export default SummaryNumberService => {
  'use strict';

  describe('SummaryNumberService', function () {
    beforeEach(function () {
      this.service = new SummaryNumberService();
    });

    it('should exist', function () {
      expect(SummaryNumberService).to.exist;
    });

    it('should initialize with default config', function () {
      expect(this.service._config.grouping).to.equal(3);
    });

    it('should output a summary number', function () {
      expect(this.service.summaryNumber(1234)).to.equal('1.23K');
      expect(this.service.summaryNumber(-1234)).to.equal('-1.23K');
      expect(this.service.summaryNumber('0.301')).to.equal('0.301');
      expect(this.service.summaryNumber('-0.300')).to.equal('-0.3');
      expect(this.service.summaryNumber('1234')).to.equal('1.23K');
      expect(this.service.summaryNumber('-1234')).to.equal('-1.23K');
      expect(this.service.summaryNumber('0')).to.equal('0');
      expect(this.service.summaryNumber('0.00')).to.equal('0');
      expect(this.service.summaryNumber('-0.00')).to.equal('0');
      expect(this.service.summaryNumber(-0.00)).to.equal('0');
      expect(this.service.summaryNumber('0.90')).to.equal('0.9');
    });

    it('should output a summary number with specified number of decimal places', function () {
      expect(this.service.summaryNumber(1234, 3)).to.equal('1.234K');
      expect(this.service.summaryNumber(1234, 1)).to.equal('1.2K');
      expect(this.service.summaryNumber(2, 4)).to.equal('2.0000');
    });
  });
};