module.exports = class LazyLoad {
  constructor() {
    this.value = {};
    this.loaded = false;
    this.loadQueue = [];
  }

  load() {
    if(this.loaded) {
      return this;
    }

    this.loadQueue.forEach(l => {
      l.fn(this.value);
    });

    delete this.loadQueue;
    this.loaded = true;

    return this;
  }

  get(fn, namespace) {
    if (!this.loaded) {
      if (namespace) {
        this.loadQueue = this.loadQueue.filter(d => d.namespace !== namespace);
      }
      this.loadQueue.push({
        fn,
        namespace
      });
    }
    else {
      fn(this.value);
    }

    return this;
  }
};