module.exports = class ValueNode {
  constructor() {
    this.value = 0;
    this.numChildren = 0;
    this.max = -Infinity;
    this.min = Infinity;
    this.children;
  }

  add(value, child, ...restOfPath) {
    if (child) {
      if (!this.children) {
        this.children = {};
      }

      if (!this.children[child]) {
        this.children[child] = new ValueNode();
      }

      this.children[child].add(value, ...restOfPath);
    }

    this.numChildren += 1;
    this.value += value;
    this.max = Math.max(this.max, value);
    this.min = Math.min(this.min, value);
  }

  done() {
    this.value /= this.numChildren;
    for (let a in this.children) {
      this.children[a].done();
    }
  }

  getDescendent(child, ...restOfPath) {
    if (!child) {
      return this;
    }

    if (!this.children || !this.children[child]) {
      return false;
    }

    return this.children[child].getDescendent(...restOfPath);
  }
};