/*! Copyright 2016 Domo Inc. */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("d3"), require("@domoinc/base-widget"), require("@domoinc/summary-number"), require("@domoinc/da-theme2"), require("@domoinc/domo-tooltip"), require("topojson"));
	else if(typeof define === 'function' && define.amd)
		define(["d3", "base-widget", "summary-number", "theme2", "domo-tooltip", "topojson"], factory);
	else if(typeof exports === 'object')
		exports["CanadaFsaMap"] = factory(require("d3"), require("@domoinc/base-widget"), require("@domoinc/summary-number"), require("@domoinc/da-theme2"), require("@domoinc/domo-tooltip"), require("topojson"));
	else
		root["CanadaFsaMap"] = factory(root["d3"], root["BaseWidget"], root["SummaryNumber"], root["da"]["theme2"], root["DomoTooltip"], root["topojson"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__, __WEBPACK_EXTERNAL_MODULE_2__, __WEBPACK_EXTERNAL_MODULE_3__, __WEBPACK_EXTERNAL_MODULE_4__, __WEBPACK_EXTERNAL_MODULE_5__, __WEBPACK_EXTERNAL_MODULE_8__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/dist/";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	/*----------------------------------------------------------------------------------
	----------------------------------------------------------------------------------
	// CanadaFsaMap:

	 © 2011 - 2015 DOMO, INC.
	----------------------------------------------------------------------------------
	----------------------------------------------------------------------------------*/
	var d3 = __webpack_require__(1);
	var BaseWidget = __webpack_require__(2);
	var SummaryNumber = __webpack_require__(3);
	var service = new SummaryNumber();
	var daTheme = __webpack_require__(4);
	var DomoTooltip = __webpack_require__(5);

	var ValueNode = __webpack_require__(6);
	var GeometryNode = __webpack_require__(7);
	var LazyLoad = __webpack_require__(9);
	var fsaToProvince = __webpack_require__(10);
	var button = __webpack_require__(11);

	var plusSvg = __webpack_require__(16);
	var minusSvg = __webpack_require__(17);

	module.exports = BaseWidget.extend('CanadaFsaMap', {
	  //**********************************************************************************
	  // Initialization
	  //**********************************************************************************
	  initialize: function initialize() {
	    'use strict';

	    var _Chart = this;
	    var colorChoices = [{ name: 'Orange', value: ["#FCCF84", "#FBAD56", "#FB8D34", "#E45621", "#A43724"] }, { name: 'Blue', value: ["#B7DAF5", "#90c4e4", "#73B0D7", "#4E8CBA", "#31689B"] }, { name: 'Green', value: ["#BBE491", "#A0D771", "#80C25D", "#559E38", "#387B26"] }, { name: 'Pink', value: ['#FBB6DD', '#F395CD', '#EE76BF', '#CF51AC', '#A62A92'] }, { name: 'Average', value: ["#336088", "#71A7C7", "#B7D7E6", "#D8EBF3", "#FFFFFF", "#F7DAD7", "#EFB7B1", "#E37872", "#B53230"] }];
	    //----------------------------------------------------------------------------------
	    // Config
	    //----------------------------------------------------------------------------------
	    _Chart._newConfig = {
	      //App builder configurable configs
	      width: {
	        name: 'Widget Width',
	        description: 'Width of the widget',
	        value: 700,
	        type: 'number',
	        units: 'px'
	      },
	      height: {
	        name: 'Widget Height',
	        description: 'Height of the widget',
	        value: 400,
	        type: 'number',
	        units: 'px'
	      },
	      colorTheme: {
	        name: 'Color Theme',
	        description: 'The color theme used by the elements',
	        value: colorChoices[1],
	        type: 'select',
	        options: colorChoices
	      },
	      noDataColor: daTheme.themeElements.noDataColor(),
	      districtStrokeColor: {
	        name: 'Province Border Color',
	        description: 'Color for the province border',
	        value: '#333333',
	        type: 'color'
	      },
	      districtStrokeWidth: {
	        name: 'Province Border Width',
	        description: 'Width of the province border',
	        type: 'number',
	        value: 1,
	        units: 'px'
	      },
	      digitStrokeColor: {
	        name: 'City Border Color',
	        description: 'Color for the border around groups of FSAs',
	        value: '#585858',
	        type: 'color'
	      },
	      digitStrokeWidth: {
	        name: 'City Border Width',
	        description: 'Width of the border around groups of FSAs',
	        type: 'number',
	        value: 1,
	        units: 'px'
	      },
	      regionStrokeColor: {
	        name: 'FSA Border Color',
	        description: 'Color for the border around individual FSAs',
	        value: '#585858',
	        type: 'color'
	      },
	      regionStrokeWidth: {
	        name: 'FSA Border Width',
	        description: 'Width of the border around indivisual FSAs',
	        type: 'number',
	        value: 0.5,
	        units: 'px'
	      },
	      highlightStrokeColor: {
	        name: 'Highlight Border Color',
	        description: 'Color for the border around hovered regions',
	        value: '#FDECAD',
	        type: 'color'
	      },
	      highlightStrokeWidth: {
	        name: 'Highlight Border Width',
	        description: 'Width of the border around hovered regions',
	        type: 'number',
	        value: 2,
	        units: 'px'
	      },
	      showFsaLabels: {
	        name: 'Show FSA Labels',
	        description: 'Show or hide the labels on the FSAs',
	        type: 'select',
	        value: { name: 'Show', value: true },
	        options: [{ name: 'Show', value: true }, { name: 'Hide', value: false }]
	      },
	      fsaLabelFontFamily: {
	        name: 'FSA Label Font',
	        description: 'Font type for the FSA labels',
	        category: 'Text',
	        value: 'Open Sans',
	        type: 'font'
	      },
	      fsaLabelFontSize: {
	        name: 'FSA Label Font Size',
	        description: 'Font size for the FSA labels',
	        value: 13,
	        type: 'number',
	        units: 'px'
	      },
	      fsaLabelFontColor: {
	        name: 'FSA Label Font Color',
	        description: 'Font color for the FSA labels',
	        value: '#333333',
	        type: 'color'
	      },
	      tooltipBackground: daTheme.themeElements.tooltipBackground(),
	      tooltipFontFamily: daTheme.themeElements.tooltipFontFamily(),
	      tooltipFontSize: daTheme.themeElements.tooltipFontSize(),
	      tooltipFontColor: daTheme.themeElements.tooltipFontColor(),
	      //Default configs not seen in the app builder
	      chartName: {
	        description: 'Name of chart for reporting',
	        type: 'string',
	        value: 'templateChart'
	      },
	      animationDuration: {
	        type: 'number',
	        value: 250,
	        units: 'ms'
	      }
	    };
	    _Chart.mergeConfig(_Chart._newConfig);

	    //----------------------------------------------------------------------------------
	    // Data Definition
	    //----------------------------------------------------------------------------------
	    _Chart._newDataDefinition = {
	      'FSA': {
	        type: 'string',
	        validate: function validate(d) {
	          return this.accessor(d);
	        },
	        accessor: function accessor(line) {
	          return line[0];
	        }
	      },
	      'Value': {
	        type: 'number',
	        validate: function validate(d) {
	          return this.accessor(d) || this.accessor(d) === 0;
	        },
	        accessor: function accessor(line) {
	          return parseFloat(line[1]);
	        }
	      }
	    };
	    _Chart.mergeDataDefinition(_Chart._newDataDefinition);

	    //----------------------------------------------------------------------------------
	    // Public properties
	    //----------------------------------------------------------------------------------
	    _Chart.defaultTranslate;
	    _Chart.defaultScale;
	    _Chart.zoom;
	    _Chart.resetZoom;

	    //----------------------------------------------------------------------------------
	    // Local variables
	    //----------------------------------------------------------------------------------
	    var firstDraw = true;

	    var svg = _Chart._layerGroup.append('svg').attr({
	      width: '100%',
	      height: '100%'
	    }).classed('map', true).style({
	      'overflow': 'hidden'
	    });

	    var map = initMap(svg);

	    var zoom = _Chart.zoom = d3.behavior.zoom();
	    addZoomScaleEvent(zoom);
	    svg.call(zoom);

	    setupMapScale(map, zoom);
	    setupHighlight(map, zoom);
	    setupDrill(map, zoom, svg);
	    initZoomButtons(_Chart._layerGroup, zoom, svg);

	    var tooltip = new DomoTooltip(svg.append('g')).c('container', _Chart._layerGroup);

	    var tooltipElems = addTooltipElems(tooltip);
	    tooltipMapEvents(tooltip, tooltipElems, map);

	    //----------------------------------------------------------------------------------
	    // Triggers and event listeners
	    //----------------------------------------------------------------------------------

	    //**********************************************************************************
	    // d3.Chart Transform
	    //**********************************************************************************
	    var superTransform = _Chart.transform;
	    _Chart.transform = function (data) {
	      var validData = superTransform(data);

	      updateZoomBehavior(map, zoom);
	      updateMapStyles(map);
	      updateTooltipStyles(tooltip);

	      var valueTree = createValueTree(map, data);
	      mapData(map, valueTree);
	      mapColor(map, valueTree);

	      if (firstDraw) {
	        _Chart.resetZoom();
	      } else {
	        zoom.event(svg);
	      }

	      firstDraw = false;
	      return validData;
	    };

	    _Chart.resetZoom = function (animate) {
	      zoom.event(svg);

	      zoom.translate(_Chart.defaultTranslate).scale(_Chart.defaultScale).event(animate ? svg.transition().duration(750) : svg);
	    };

	    function createFsaTree() {
	      var topology = __webpack_require__(18);
	      var geometries = topology.objects.good.geometries;
	      var tree = new GeometryNode(topology);

	      geometries.forEach(function (d) {
	        var fsa = d.properties.fsa;
	        var province = fsaToProvince(fsa);
	        var digit = fsa[1];
	        var region = fsa[2];

	        tree.add(d, province, digit, region);
	      });

	      return tree;
	    }

	    function initMap(container) {

	      var background = container.append('rect').classed('background', true).attr({
	        width: '100%',
	        height: '100%'
	      }).style('opacity', 0);
	      var features = container.append('g').classed('features', true);

	      var districtsG = features.append('g').classed('districts', true);
	      var regionsG = features.append('g').classed('regions', true);
	      var districtStrokeG = features.append('g').classed('district-stroke', true);
	      var regionExtrasG = features.append('g').classed('region-extras', true);

	      var scale = 9000;

	      var projection = d3.geo.conicConformal().rotate([96, -62]).parallels([-77, -49]).translate([0, 0]).scale(scale);

	      var path = d3.geo.path().projection(projection);

	      var fsaTree = createFsaTree();

	      var districts = initDistricts(districtsG, districtStrokeG, fsaTree, path);
	      var regions = initRegions(regionsG, regionExtrasG, fsaTree, path);

	      var fsaList = {};
	      for (var i = 0; i < fsaTree.geometries.length; i++) {
	        fsaList[fsaTree.geometries[i].properties.fsa] = true;
	      }

	      return {
	        background: background,
	        features: features,
	        districts: districts,
	        regions: regions,
	        bounds: path.bounds(fsaTree.merge()),
	        scale: scale,
	        path: path,
	        fsaList: fsaList
	      };
	    }

	    function initDistricts(featureContainer, strokeContainer, fsaTree, path) {
	      return {
	        feature: featureContainer.selectAll('path').data(fsaTree.mergeToArray()).enter().append('path').attr('d', path).attr('shape-rendering', 'crispEdges').style({
	          'cursor': 'pointer'
	        }),
	        stroke: strokeContainer.append('path').attr('d', path(fsaTree.mesh(true))).style({
	          'fill': 'none',
	          'pointer-events': 'none'
	        }),
	        strokeContainer: strokeContainer.node()
	      };
	    }

	    function processRegionData(data, path) {
	      var polygons = [];
	      var points = [];

	      data.forEach(function (d) {
	        var length = Math.sqrt(path.area(d));

	        d.path = {
	          length: length,
	          centroid: path.centroid(d)
	        };

	        var category = length === 0 ? points : polygons;
	        category.push(d);
	      });

	      return {
	        polygons: polygons,
	        points: points
	      };
	    }

	    function initRegions(regionContainer, regionExtrasContainer, fsaTree, path) {
	      var regions = {};

	      var _loop = function _loop(a) {
	        regions[a] = new LazyLoad().get(function (region) {
	          var data = processRegionData(fsaTree.children[a].mergeAllToArray(), path);

	          var geometries = regionContainer.append('g').call(hide);

	          region.feature = geometries.append('g').classed('feature', true).selectAll('path').data(data.polygons).enter().append('path').attr('d', path).attr('shape-rendering', 'crispEdges');

	          region.stroke = geometries.append('path').classed('stroke', true).attr('d', path(fsaTree.children[a].meshAll(true))).style({
	            'fill': 'none',
	            'pointer-events': 'none'
	          });

	          region.digits = geometries.append('path').classed('digits', true).attr('d', path(fsaTree.children[a].mesh(true))).style({
	            'fill': 'none',
	            'pointer-events': 'none'
	          });

	          var extras = regionExtrasContainer.append('g').call(hide);

	          region.point = extras.append('g').classed('point', true).selectAll('circle').data(data.points).enter().append('circle').attr({
	            cx: function cx(d) {
	              return d.path.centroid[0];
	            },
	            cy: function cy(d) {
	              return d.path.centroid[1];
	            }
	          });

	          region.text = extras.append('g').classed('text', true).selectAll('text').data(data.polygons).enter().append('text').attr({
	            x: function x(d) {
	              return d.path.centroid[0];
	            },
	            y: function y(d) {
	              return d.path.centroid[1];
	            }
	          }).style({
	            'pointer-events': 'none',
	            'text-anchor': 'middle'
	          }).text(function (d) {
	            return d.properties.fsa;
	          });

	          region.geometries = geometries.node();
	          region.extras = extras.node();
	          region.all = d3.selectAll([geometries.node(), extras.node()]);
	        });
	      };

	      for (var a in fsaTree.children) {
	        _loop(a);
	      }

	      return regions;
	    }

	    function updateZoomBehavior(map, zoom) {
	      var maxZoom = 6e5;

	      var bounds = map.bounds;
	      var mapWidth = bounds[1][0] - bounds[0][0];
	      var mapHeight = bounds[1][1] - bounds[0][1];

	      var zoomedOut = Math.min(_Chart.c('height') / mapHeight, _Chart.c('width') / mapWidth);
	      var zoomedIn = maxZoom / map.scale;

	      var hw = _Chart.c('width') / 2;
	      var hh = _Chart.c('height') / 2;

	      zoom.on('zoom.bounds', function () {

	        var t = zoom.translate();
	        var s = zoom.scale();
	        zoom.translate([clamp(t[0], -bounds[1][0] * s + hw, -bounds[0][0] * s + hw), clamp(t[1], -bounds[1][1] * s + hh, -bounds[0][1] * s + hh)]);

	        map.features.attr({
	          'transform': 'translate(' + zoom.translate() + ')scale(' + zoom.scale() + ')'
	        });
	      });

	      zoom.scaleExtent([zoomedOut, zoomedIn]);

	      _Chart.defaultTranslate = [(-bounds[0][0] - mapWidth * 0.5) * zoomedOut + hw, (-bounds[0][1] - mapHeight * 0.5) * zoomedOut + hh];

	      _Chart.defaultScale = zoomedOut;
	    }

	    function updateMapStyles(map) {
	      map.districts.stroke.style({
	        'stroke': _Chart.c('districtStrokeColor')
	      });

	      for (var a in map.regions) {
	        map.regions[a].get(function (region) {
	          region.stroke.style({
	            'stroke': _Chart.c('regionStrokeColor')
	          });
	          region.point.style({
	            'stroke': _Chart.c('regionStrokeColor')
	          });
	          region.digits.style({
	            'stroke': _Chart.c('digitStrokeColor')
	          });
	          region.text.style({
	            'font-family': _Chart.c('fsaLabelFontFamily'),
	            'fill': _Chart.c('fsaLabelFontColor')
	          });
	          if (!_Chart.c('showFsaLabels').value) {
	            region.text.style('display', 'none');
	          }
	        }, 'styles');
	      }
	    }

	    function createValueTree(map, data) {
	      var valueTree = new ValueNode();

	      data.forEach(function (d) {
	        var fsa = _Chart.a('FSA')(d).toUpperCase();
	        var value = _Chart.a('Value')(d);

	        var province = fsaToProvince(fsa);
	        var region = fsa[1] + fsa[2];

	        if (map.fsaList[fsa] && !valueTree.getDescendent(province, region)) {
	          valueTree.add(value, province, region);
	        }
	      });

	      valueTree.done();

	      return valueTree;
	    }

	    function mapData(map, valueTree) {
	      map.districts.feature.each(function (d) {
	        d.properties.value = valueTree.getDescendent(d.properties.label).value;
	      });

	      var _loop2 = function _loop2(a) {
	        map.regions[a].get(function (region) {
	          var setValue = function setValue(d) {
	            var fsa = d.properties.fsa;
	            d.properties.value = valueTree.getDescendent(a, fsa[1] + fsa[2]).value;
	          };

	          region.feature.each(setValue);
	          region.point.each(setValue);
	        }, 'data');
	      };

	      for (var a in map.regions) {
	        _loop2(a);
	      }
	    }

	    function mapColor(map, valueTree) {
	      var colorScale = d3.scale.quantile().domain([valueTree.min, valueTree.max]).range(_Chart.c('colorTheme').value);

	      map.districts.feature.style('fill', function (d) {
	        return d.properties.value ? colorScale(d.properties.value) : _Chart.c('noDataColor');
	      });

	      for (var a in map.regions) {
	        map.regions[a].get(function (region) {

	          var fill = function fill(d) {
	            return d.properties.value ? colorScale(d.properties.value) : _Chart.c('noDataColor');
	          };

	          region.feature.style('fill', fill);
	          region.point.style('fill', fill);
	        }, 'colors');
	      }
	    }

	    function fsaLabelSize(zoom) {
	      var preferedSize = _Chart.c('fsaLabelFontSize');
	      var minSize = 2 / 3 * preferedSize;
	      var percentOfRegion = 0.15;
	      var scale = zoom.scale();

	      return function (d) {
	        var actualSize = percentOfRegion * d.path.length;
	        if (actualSize * scale < minSize) {
	          this.style.display = 'none';
	        } else {
	          this.style.display = '';
	          this.style.fontSize = Math.min(preferedSize / zoom.scale(), actualSize) + 'px';
	        }
	      };
	    }

	    function fsaPointSize(map, zoom) {
	      var maxPointSize = 1e-4;
	      var preferredPointSize = 18;

	      return Math.min(maxPointSize * map.scale, preferredPointSize / zoom.scale());
	    }

	    function setupMapScale(map, zoom) {
	      zoom.onScale('zoom.mapStroke', function () {
	        map.districts.stroke.style('stroke-width', _Chart.c('districtStrokeWidth') / zoom.scale() + 'px');
	        for (var a in map.regions) {
	          map.regions[a].get(function (region) {
	            region.stroke.style('stroke-width', _Chart.c('regionStrokeWidth') / zoom.scale() + 'px');
	            region.point.style('stroke-width', _Chart.c('regionStrokeWidth') / zoom.scale() + 'px');
	            region.digits.style('stroke-width', _Chart.c('digitStrokeWidth') / zoom.scale() + 'px');
	            region.point.attr('r', fsaPointSize(map, zoom));
	          }, 'scaleStroke');
	        }
	      });
	      zoom.onScale('zoom.mapLabels', function () {
	        if (_Chart.c('showFsaLabels').value) {
	          for (var a in map.regions) {
	            map.regions[a].get(function (region) {
	              region.text.each(fsaLabelSize(zoom));
	            }, 'scaleLabels');
	          }
	        }
	      });
	    }

	    function setupHighlight(map, zoom) {
	      var highlight = void 0;

	      var addHighlight = function addHighlight(appendTo, minStrokeWidth) {
	        d3.select(highlight).remove();

	        if (_Chart.c('highlightStrokeWidth') === 0) {
	          return;
	        }

	        highlight = this.cloneNode();

	        var strokeWidth = Math.max(minStrokeWidth(), _Chart.c('highlightStrokeWidth'));

	        d3.select(highlight).style({
	          'fill': 'none',
	          'stroke': _Chart.c('highlightStrokeColor'),
	          'stroke-width': strokeWidth / zoom.scale() + 'px',
	          'shape-rendering': 'geometricPrecision'
	        });

	        appendTo.appendChild(highlight);
	      };

	      var highlightable = function highlightable(selection, appendTo, minStrokeWidth) {
	        selection.on('mouseover', function () {
	          var _this = this;

	          addHighlight.call(this, appendTo, minStrokeWidth);
	          zoom.onScale('zoom.highlight', function () {
	            addHighlight.call(_this, appendTo, minStrokeWidth);
	          });
	        });

	        selection.on('mouseleave', function () {
	          d3.select(highlight).remove();
	          zoom.onScale('zoom.highlight', null);
	          highlight = null;
	        });
	      };

	      highlightable(map.districts.feature, map.districts.strokeContainer, function () {
	        return _Chart.c('districtStrokeWidth');
	      });
	      for (var a in map.regions) {
	        map.regions[a].get(function (region) {
	          highlightable(region.feature, map.districts.strokeContainer, function () {
	            return _Chart.c('regionStrokeWidth');
	          });
	          highlightable(region.point, region.extras, function () {
	            return _Chart.c('regionStrokeWidth');
	          });
	        });
	      }
	    }

	    function setupDrill(map, zoom, zoomContainer) {
	      var lastDistrict = void 0;

	      var clearLastDistrict = function clearLastDistrict(currentDistrict) {
	        if (lastDistrict) {

	          map.regions[lastDistrict].get(function (region) {
	            region.all.call(hide);
	          }, 'visibility');
	        }

	        lastDistrict = currentDistrict;
	      };

	      clickWithoutMoving(map.background, function () {
	        clearLastDistrict();
	        _Chart.resetZoom(true);
	      });

	      clickWithoutMoving(map.districts.feature, function (d) {
	        clearLastDistrict(d.properties.label);

	        map.regions[d.properties.label].load().get(function (region) {
	          region.all.call(show);
	        }, 'visibility');

	        zoomToBounds(zoom, zoomContainer, map.path.bounds(d));
	      });
	    }

	    function addTooltipElems(tooltip) {
	      tooltip.c({
	        format: 'textRectText'
	      }).draw();

	      var value = tooltip._appends.append('text');
	      var rect = tooltip._appends.append('rect');
	      var label = tooltip._appends.append('text');

	      return {
	        value: value, rect: rect, label: label
	      };
	    }

	    function updateTooltipStyles(tooltip) {
	      tooltip.c({
	        tooltipBackgroundColor: _Chart.c('tooltipBackground')
	      });

	      tooltip._appends.selectAll('text').style({
	        'font-family': _Chart.c('tooltipFontFamily'),
	        'font-size': _Chart.c('tooltipFontSize') + 'px',
	        'fill': _Chart.c('tooltipFontColor')
	      });

	      tooltip._appends.selectAll('rect').style('fill', _Chart.c('tooltipFontColor'));
	    }

	    function tooltipMapEvents(tooltip, tooltipElems, map) {

	      var tooltipHover = function tooltipHover(sel, mouseoverCallback) {
	        sel.on('mouseover.tooltip', function (d) {
	          mouseoverCallback.call(this, d);
	          tooltip.trigger('draw');
	        });
	        sel.on('mousemove.tooltip', function () {
	          var m = d3.mouse(_Chart._layerGroup.node());
	          tooltip.trigger('moveTo', { x: m[0], y: m[1] });
	        });
	        sel.on('mouseleave.tooltip', function () {
	          tooltip.trigger('remove');
	        });
	      };

	      tooltipHover(map.districts.feature, function (d) {
	        var label = d.properties.label;
	        var value = d.properties.value;

	        tooltipElems.label.text(label);
	        tooltipElems.value.text(value ? service.summaryNumber(value) : 'No Data');
	      });

	      for (var a in map.regions) {
	        map.regions[a].get(function (region) {
	          var hover = function hover(d) {
	            var fsa = d.properties.fsa;
	            var value = d.properties.value;

	            tooltipElems.label.text(fsa);
	            tooltipElems.value.text(value ? service.summaryNumber(value) : 'No Data');
	          };

	          tooltipHover(region.feature, hover);
	          tooltipHover(region.point, hover);
	        }, 'tooltip');
	      }
	    }

	    function initZoomButtons(buttonContainer, zoom, zoomContainer) {
	      var zoomButtonAmount = 1.8;

	      var buttonDiv = buttonContainer.append('div').style({
	        'position': 'absolute',
	        'bottom': '10px',
	        'right': '10px'
	      });

	      var buttons = {
	        zoomIn: button.create(buttonDiv, plusSvg).call(button.top),
	        zoomOut: button.create(buttonDiv, minusSvg).call(button.bottom)
	      };

	      var zoomEvent = function zoomEvent(amount) {

	        return function () {
	          var x = _Chart.c('width') / 2;
	          var y = _Chart.c('height') / 2;
	          var t = zoom.translate();
	          var k = zoom.scale();
	          var e = zoom.scaleExtent();
	          var newScale = clamp(zoom.scale() * amount, e[0], e[1]);

	          /*
	            Translate so that the x and y positions on the screen correspond
	            to the same points on the map before and after the zoom.
	          */
	          var newTranslate = [x + (t[0] - x) * newScale / k, y + (t[1] - y) * newScale / k];

	          zoom.event(zoomContainer);

	          zoom.scale(newScale).translate(newTranslate).size([2 * x, 2 * y]);

	          zoom.event(zoomContainer.transition());
	        };
	      };

	      buttons.zoomIn.on('click', zoomEvent(zoomButtonAmount));
	      buttons.zoomOut.on('click', zoomEvent(1 / zoomButtonAmount));
	    }

	    function zoomToBounds(zoom, zoomContainer, bounds) {
	      var dx = bounds[1][0] - bounds[0][0];
	      var dy = bounds[1][1] - bounds[0][1];
	      var x = (bounds[0][0] + bounds[1][0]) / 2;
	      var y = (bounds[0][1] + bounds[1][1]) / 2;
	      var e = zoom.scaleExtent();

	      var scale = clamp(0.95 * Math.min(_Chart.c('width') / dx, _Chart.c('height') / dy), e[0], e[1]);
	      var translate = [_Chart.c('width') / 2 - scale * x, _Chart.c('height') / 2 - scale * y];

	      zoom.event(zoomContainer);

	      zoom.translate(translate).scale(scale).event(zoomContainer.transition().duration(750));
	    }

	    function hide(sel) {
	      return sel.style('pointer-events', 'none').transition('hide').duration(_Chart.c('animationDuration')).style('opacity', 0).each('end', function () {
	        sel.style('display', 'none');
	      });
	    }

	    function show(sel) {
	      return sel.style({
	        'pointer-events': '',
	        'display': ''
	      }).transition('hide').duration(_Chart.c('animationDuration')).style('opacity', 1);
	    }

	    function clickWithoutMoving(selection, fn) {
	      var lastEvent = void 0;
	      selection.on('mousedown', function () {
	        lastEvent = d3.event;
	      });

	      selection.on('mouseup', function () {
	        if (lastEvent.pageX === d3.event.pageX && lastEvent.pageY === d3.event.pageY) {
	          fn.apply(this, arguments);
	        }
	      });
	    }

	    function addZoomScaleEvent(zoom) {
	      var dispatch = d3.dispatch('zoom');

	      var lastScale = void 0;
	      var timeout = void 0;

	      var onZoom = function onZoom() {
	        var s = zoom.scale();

	        clearTimeout(timeout);

	        if (lastScale !== s) {
	          dispatch.zoom();
	        } else {
	          timeout = setTimeout(dispatch.zoom, 150);
	        }

	        lastScale = s;
	      };

	      zoom.on('zoom.scaleEvent', onZoom);
	      zoom.onScale = dispatch.on.bind(dispatch);
	    }

	    function clamp(n, min, max) {
	      return Math.max(Math.min(n, max), min);
	    }
	  }
	});

/***/ },
/* 1 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_1__;

/***/ },
/* 2 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ },
/* 3 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_3__;

/***/ },
/* 4 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_4__;

/***/ },
/* 5 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_5__;

/***/ },
/* 6 */
/***/ function(module, exports) {

	"use strict";

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	module.exports = function () {
	  function ValueNode() {
	    _classCallCheck(this, ValueNode);

	    this.value = 0;
	    this.numChildren = 0;
	    this.max = -Infinity;
	    this.min = Infinity;
	    this.children;
	  }

	  _createClass(ValueNode, [{
	    key: "add",
	    value: function add(value, child) {
	      if (child) {
	        var _children$child;

	        if (!this.children) {
	          this.children = {};
	        }

	        if (!this.children[child]) {
	          this.children[child] = new ValueNode();
	        }

	        for (var _len = arguments.length, restOfPath = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
	          restOfPath[_key - 2] = arguments[_key];
	        }

	        (_children$child = this.children[child]).add.apply(_children$child, [value].concat(restOfPath));
	      }

	      this.numChildren += 1;
	      this.value += value;
	      this.max = Math.max(this.max, value);
	      this.min = Math.min(this.min, value);
	    }
	  }, {
	    key: "done",
	    value: function done() {
	      this.value /= this.numChildren;
	      for (var a in this.children) {
	        this.children[a].done();
	      }
	    }
	  }, {
	    key: "getDescendent",
	    value: function getDescendent(child) {
	      var _children$child2;

	      if (!child) {
	        return this;
	      }

	      if (!this.children || !this.children[child]) {
	        return false;
	      }

	      for (var _len2 = arguments.length, restOfPath = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
	        restOfPath[_key2 - 1] = arguments[_key2];
	      }

	      return (_children$child2 = this.children[child]).getDescendent.apply(_children$child2, restOfPath);
	    }
	  }]);

	  return ValueNode;
	}();

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	var topojson = __webpack_require__(8);

	module.exports = function () {
	  function GeometryTree(topology, label) {
	    _classCallCheck(this, GeometryTree);

	    this.topology = topology;
	    this.geometries = [];
	    this.merged;
	    this.children;
	    this.label = label;
	  }

	  _createClass(GeometryTree, [{
	    key: 'add',
	    value: function add(geometry, child) {

	      if (child) {
	        var _children$child;

	        if (!this.children) {
	          this.children = {};
	        }

	        if (!this.children[child]) {
	          this.children[child] = new GeometryTree(this.topology, child);
	        }

	        for (var _len = arguments.length, restOfPath = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
	          restOfPath[_key - 2] = arguments[_key];
	        }

	        (_children$child = this.children[child]).add.apply(_children$child, [geometry].concat(restOfPath));
	      }

	      this.geometries.push(geometry);
	    }
	  }, {
	    key: 'childGeometriesMerged',
	    value: function childGeometriesMerged() {
	      var geometries = [];
	      for (var a in this.children) {
	        geometries.push(this.children[a].mergeArcs());
	      }
	      return geometries;
	    }
	  }, {
	    key: 'mergeArcs',
	    value: function mergeArcs() {
	      if (!this.merged) {
	        if (this.children) {
	          this.merged = topojson.mergeArcs(this.topology, this.childGeometriesMerged());
	        } else {
	          this.merged = topojson.mergeArcs(this.topology, this.geometries);
	        }
	      }

	      return this.merged;
	    }
	  }, {
	    key: 'merge',
	    value: function merge() {
	      var feature = topojson.feature(this.topology, this.mergeArcs());

	      feature.properties = {
	        label: this.label
	      };

	      return feature;
	    }
	  }, {
	    key: 'mergeToArray',
	    value: function mergeToArray() {

	      var arr = [];

	      for (var a in this.children) {
	        arr.push(this.children[a].merge());
	      }

	      return arr;
	    }
	  }, {
	    key: 'mergeAllToArray',
	    value: function mergeAllToArray() {
	      var geometryCollection = {
	        type: 'GeometryCollection',
	        geometries: this.geometries
	      };

	      return topojson.feature(this.topology, geometryCollection).features;
	    }
	  }, {
	    key: 'mesh',
	    value: function mesh(border) {
	      var geometryCollection = {
	        type: 'GeometryCollection',
	        geometries: this.childGeometriesMerged()
	      };

	      if (border) {
	        return topojson.mesh(this.topology, geometryCollection);
	      } else {
	        return topojson.mesh(this.topology, geometryCollection, function (a, b) {
	          return a !== b;
	        });
	      }
	    }
	  }, {
	    key: 'meshAll',
	    value: function meshAll(border) {
	      var geometryCollection = {
	        type: 'GeometryCollection',
	        geometries: this.geometries
	      };

	      if (border) {
	        return topojson.mesh(this.topology, geometryCollection);
	      } else {
	        return topojson.mesh(this.topology, geometryCollection, function (a, b) {
	          return a !== b;
	        });
	      }
	    }
	  }, {
	    key: 'getDescendent',
	    value: function getDescendent(child) {
	      var _children$child2;

	      if (!child) {
	        return this;
	      }

	      if (!this.children || !this.children[child]) {
	        return false;
	      }

	      for (var _len2 = arguments.length, restOfPath = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
	        restOfPath[_key2 - 1] = arguments[_key2];
	      }

	      return (_children$child2 = this.children[child]).getDescendent.apply(_children$child2, restOfPath);
	    }
	  }]);

	  return GeometryTree;
	}();

/***/ },
/* 8 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_8__;

/***/ },
/* 9 */
/***/ function(module, exports) {

	"use strict";

	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

	module.exports = function () {
	  function LazyLoad() {
	    _classCallCheck(this, LazyLoad);

	    this.value = {};
	    this.loaded = false;
	    this.loadQueue = [];
	  }

	  _createClass(LazyLoad, [{
	    key: "load",
	    value: function load() {
	      var _this = this;

	      if (this.loaded) {
	        return this;
	      }

	      this.loadQueue.forEach(function (l) {
	        l.fn(_this.value);
	      });

	      delete this.loadQueue;
	      this.loaded = true;

	      return this;
	    }
	  }, {
	    key: "get",
	    value: function get(fn, namespace) {
	      if (!this.loaded) {
	        if (namespace) {
	          this.loadQueue = this.loadQueue.filter(function (d) {
	            return d.namespace !== namespace;
	          });
	        }
	        this.loadQueue.push({
	          fn: fn,
	          namespace: namespace
	        });
	      } else {
	        fn(this.value);
	      }

	      return this;
	    }
	  }]);

	  return LazyLoad;
	}();

/***/ },
/* 10 */
/***/ function(module, exports) {

	'use strict';

	module.exports = function (fsa) {
	  var district = fsa[0];
	  var digitRegion = fsa[1] + fsa[2];

	  switch (district) {
	    case 'A':
	      return 'Newfoundland and Labrador';
	    case 'B':
	      return 'Nova Scotia';
	    case 'C':
	      return 'Prince Edward Island';
	    case 'E':
	      return 'New Brunswick';
	    case 'G':
	    case 'H':
	    case 'J':
	      return 'Quebec';
	    case 'K':
	    case 'L':
	    case 'M':
	    case 'N':
	    case 'P':
	      return 'Ontario';
	    case 'R':
	      return 'Manitoba';
	    case 'S':
	      return 'Saskatchewan';
	    case 'T':
	      return 'Alberta';
	    case 'V':
	      return 'British Columbia';
	    case 'X':
	      switch (digitRegion) {
	        case '0E':
	        case '0G':
	        case '1A':
	          return 'Northwest Territories';
	        case '0A':
	        case '0B':
	        case '0C':
	          return 'Nunavut';
	        default:
	          return district;
	      }
	      break;
	    case 'Y':
	      return 'Yukon';
	    default:
	      return district;
	  }
	};

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var d3 = __webpack_require__(1);

	__webpack_require__(12);

	function create(container, html) {
	  var size = 14;

	  var button = container.append('button');
	  button.html(html);

	  button.selectAll('svg').attr({
	    width: size + 'px',
	    height: size + 'px'
	  });

	  return button;
	}

	function top(button) {
	  return button.classed('top', true);
	}

	function bottom(button) {
	  return button.classed('bottom', true);
	}

	module.exports = {
	  create: create,
	  top: top,
	  bottom: bottom
	};

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	// style-loader: Adds some css to the DOM by adding a <style> tag

	// load the styles
	var content = __webpack_require__(13);
	if(typeof content === 'string') content = [[module.id, content, '']];
	// add the styles to the DOM
	var update = __webpack_require__(15)(content, {});
	if(content.locals) module.exports = content.locals;
	// Hot Module Replacement
	if(false) {
		// When the styles change, update the <style> tags
		if(!content.locals) {
			module.hot.accept("!!./../../node_modules/css-loader/index.js!./button.css", function() {
				var newContent = require("!!./../../node_modules/css-loader/index.js!./button.css");
				if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
				update(newContent);
			});
		}
		// When the module is disposed, remove the <style> tags
		module.hot.dispose(function() { update(); });
	}

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	exports = module.exports = __webpack_require__(14)();
	// imports


	// module
	exports.push([module.id, "button {\n  display: block;\n  position: relative;\n  cursor: pointer;\n  padding: 6px;\n  margin: 0;\n  outline: 0;\n  border: 1px solid #CCCCCC;\n  border-radius: 3px;\n  background-color: #fff;\n  overflow: hidden;\n  transition: background-color .3s;\n}\n\nbutton::-moz-focus-inner {\n    padding: 0;\n    border: 0;\n}\n\nbutton:focus, button:hover {\n  background-color: #f8f8f8;\n}\n\nbutton:active {\n  transform: translateY(1px);\n  background-color: #e6e6e6;\n}\n\nbutton:before {\n  content: \"\";\n  transform: scale(0);\n  transform-origin: center center;\n  background: #000;\n  border-radius: 50%;\n  opacity: .1;\n  position: absolute;\n  height: 100px;\n  width: 100px;\n  top: 50%;\n  left: 50%;\n  margin-left: -50px;\n  margin-top: -50px;\n}\n\nbutton:focus:before {\n  transform: scale(1);\n  opacity: 0;\n  transition: transform .3s ease-out,opacity .6s ease-out;\n}\n\nbutton.top {\n  border-bottom-left-radius : 0;\n  border-bottom-right-radius: 0;\n}\n\nbutton.bottom {\n  border-top: 0;\n  border-top-left-radius : 0;\n  border-top-right-radius: 0;\n}", ""]);

	// exports


/***/ },
/* 14 */
/***/ function(module, exports) {

	/*
		MIT License http://www.opensource.org/licenses/mit-license.php
		Author Tobias Koppers @sokra
	*/
	// css base code, injected by the css-loader
	module.exports = function() {
		var list = [];

		// return the list of modules as css string
		list.toString = function toString() {
			var result = [];
			for(var i = 0; i < this.length; i++) {
				var item = this[i];
				if(item[2]) {
					result.push("@media " + item[2] + "{" + item[1] + "}");
				} else {
					result.push(item[1]);
				}
			}
			return result.join("");
		};

		// import a list of modules into the list
		list.i = function(modules, mediaQuery) {
			if(typeof modules === "string")
				modules = [[null, modules, ""]];
			var alreadyImportedModules = {};
			for(var i = 0; i < this.length; i++) {
				var id = this[i][0];
				if(typeof id === "number")
					alreadyImportedModules[id] = true;
			}
			for(i = 0; i < modules.length; i++) {
				var item = modules[i];
				// skip already imported module
				// this implementation is not 100% perfect for weird media query combinations
				//  when a module is imported multiple times with different media queries.
				//  I hope this will never occur (Hey this way we have smaller bundles)
				if(typeof item[0] !== "number" || !alreadyImportedModules[item[0]]) {
					if(mediaQuery && !item[2]) {
						item[2] = mediaQuery;
					} else if(mediaQuery) {
						item[2] = "(" + item[2] + ") and (" + mediaQuery + ")";
					}
					list.push(item);
				}
			}
		};
		return list;
	};


/***/ },
/* 15 */
/***/ function(module, exports, __webpack_require__) {

	/*
		MIT License http://www.opensource.org/licenses/mit-license.php
		Author Tobias Koppers @sokra
	*/
	var stylesInDom = {},
		memoize = function(fn) {
			var memo;
			return function () {
				if (typeof memo === "undefined") memo = fn.apply(this, arguments);
				return memo;
			};
		},
		isOldIE = memoize(function() {
			return /msie [6-9]\b/.test(window.navigator.userAgent.toLowerCase());
		}),
		getHeadElement = memoize(function () {
			return document.head || document.getElementsByTagName("head")[0];
		}),
		singletonElement = null,
		singletonCounter = 0,
		styleElementsInsertedAtTop = [];

	module.exports = function(list, options) {
		if(false) {
			if(typeof document !== "object") throw new Error("The style-loader cannot be used in a non-browser environment");
		}

		options = options || {};
		// Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
		// tags it will allow on a page
		if (typeof options.singleton === "undefined") options.singleton = isOldIE();

		// By default, add <style> tags to the bottom of <head>.
		if (typeof options.insertAt === "undefined") options.insertAt = "bottom";

		var styles = listToStyles(list);
		addStylesToDom(styles, options);

		return function update(newList) {
			var mayRemove = [];
			for(var i = 0; i < styles.length; i++) {
				var item = styles[i];
				var domStyle = stylesInDom[item.id];
				domStyle.refs--;
				mayRemove.push(domStyle);
			}
			if(newList) {
				var newStyles = listToStyles(newList);
				addStylesToDom(newStyles, options);
			}
			for(var i = 0; i < mayRemove.length; i++) {
				var domStyle = mayRemove[i];
				if(domStyle.refs === 0) {
					for(var j = 0; j < domStyle.parts.length; j++)
						domStyle.parts[j]();
					delete stylesInDom[domStyle.id];
				}
			}
		};
	}

	function addStylesToDom(styles, options) {
		for(var i = 0; i < styles.length; i++) {
			var item = styles[i];
			var domStyle = stylesInDom[item.id];
			if(domStyle) {
				domStyle.refs++;
				for(var j = 0; j < domStyle.parts.length; j++) {
					domStyle.parts[j](item.parts[j]);
				}
				for(; j < item.parts.length; j++) {
					domStyle.parts.push(addStyle(item.parts[j], options));
				}
			} else {
				var parts = [];
				for(var j = 0; j < item.parts.length; j++) {
					parts.push(addStyle(item.parts[j], options));
				}
				stylesInDom[item.id] = {id: item.id, refs: 1, parts: parts};
			}
		}
	}

	function listToStyles(list) {
		var styles = [];
		var newStyles = {};
		for(var i = 0; i < list.length; i++) {
			var item = list[i];
			var id = item[0];
			var css = item[1];
			var media = item[2];
			var sourceMap = item[3];
			var part = {css: css, media: media, sourceMap: sourceMap};
			if(!newStyles[id])
				styles.push(newStyles[id] = {id: id, parts: [part]});
			else
				newStyles[id].parts.push(part);
		}
		return styles;
	}

	function insertStyleElement(options, styleElement) {
		var head = getHeadElement();
		var lastStyleElementInsertedAtTop = styleElementsInsertedAtTop[styleElementsInsertedAtTop.length - 1];
		if (options.insertAt === "top") {
			if(!lastStyleElementInsertedAtTop) {
				head.insertBefore(styleElement, head.firstChild);
			} else if(lastStyleElementInsertedAtTop.nextSibling) {
				head.insertBefore(styleElement, lastStyleElementInsertedAtTop.nextSibling);
			} else {
				head.appendChild(styleElement);
			}
			styleElementsInsertedAtTop.push(styleElement);
		} else if (options.insertAt === "bottom") {
			head.appendChild(styleElement);
		} else {
			throw new Error("Invalid value for parameter 'insertAt'. Must be 'top' or 'bottom'.");
		}
	}

	function removeStyleElement(styleElement) {
		styleElement.parentNode.removeChild(styleElement);
		var idx = styleElementsInsertedAtTop.indexOf(styleElement);
		if(idx >= 0) {
			styleElementsInsertedAtTop.splice(idx, 1);
		}
	}

	function createStyleElement(options) {
		var styleElement = document.createElement("style");
		styleElement.type = "text/css";
		insertStyleElement(options, styleElement);
		return styleElement;
	}

	function createLinkElement(options) {
		var linkElement = document.createElement("link");
		linkElement.rel = "stylesheet";
		insertStyleElement(options, linkElement);
		return linkElement;
	}

	function addStyle(obj, options) {
		var styleElement, update, remove;

		if (options.singleton) {
			var styleIndex = singletonCounter++;
			styleElement = singletonElement || (singletonElement = createStyleElement(options));
			update = applyToSingletonTag.bind(null, styleElement, styleIndex, false);
			remove = applyToSingletonTag.bind(null, styleElement, styleIndex, true);
		} else if(obj.sourceMap &&
			typeof URL === "function" &&
			typeof URL.createObjectURL === "function" &&
			typeof URL.revokeObjectURL === "function" &&
			typeof Blob === "function" &&
			typeof btoa === "function") {
			styleElement = createLinkElement(options);
			update = updateLink.bind(null, styleElement);
			remove = function() {
				removeStyleElement(styleElement);
				if(styleElement.href)
					URL.revokeObjectURL(styleElement.href);
			};
		} else {
			styleElement = createStyleElement(options);
			update = applyToTag.bind(null, styleElement);
			remove = function() {
				removeStyleElement(styleElement);
			};
		}

		update(obj);

		return function updateStyle(newObj) {
			if(newObj) {
				if(newObj.css === obj.css && newObj.media === obj.media && newObj.sourceMap === obj.sourceMap)
					return;
				update(obj = newObj);
			} else {
				remove();
			}
		};
	}

	var replaceText = (function () {
		var textStore = [];

		return function (index, replacement) {
			textStore[index] = replacement;
			return textStore.filter(Boolean).join('\n');
		};
	})();

	function applyToSingletonTag(styleElement, index, remove, obj) {
		var css = remove ? "" : obj.css;

		if (styleElement.styleSheet) {
			styleElement.styleSheet.cssText = replaceText(index, css);
		} else {
			var cssNode = document.createTextNode(css);
			var childNodes = styleElement.childNodes;
			if (childNodes[index]) styleElement.removeChild(childNodes[index]);
			if (childNodes.length) {
				styleElement.insertBefore(cssNode, childNodes[index]);
			} else {
				styleElement.appendChild(cssNode);
			}
		}
	}

	function applyToTag(styleElement, obj) {
		var css = obj.css;
		var media = obj.media;

		if(media) {
			styleElement.setAttribute("media", media)
		}

		if(styleElement.styleSheet) {
			styleElement.styleSheet.cssText = css;
		} else {
			while(styleElement.firstChild) {
				styleElement.removeChild(styleElement.firstChild);
			}
			styleElement.appendChild(document.createTextNode(css));
		}
	}

	function updateLink(linkElement, obj) {
		var css = obj.css;
		var sourceMap = obj.sourceMap;

		if(sourceMap) {
			// http://stackoverflow.com/a/26603875
			css += "\n/*# sourceMappingURL=data:application/json;base64," + btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))) + " */";
		}

		var blob = new Blob([css], { type: "text/css" });

		var oldSrc = linkElement.href;

		linkElement.href = URL.createObjectURL(blob);

		if(oldSrc)
			URL.revokeObjectURL(oldSrc);
	}


/***/ },
/* 16 */
/***/ function(module, exports) {

	module.exports = "<svg viewBox=\"0 0 16 16\">\n  <path fill=\"#636363\" d=\"M7,7 L7,1 L9,1 L9,7 L15,7 L15,9 L9,9 L9,15 L7,15 L7,9 L1,9 L1,7 L7,7 Z\"></path>\n</svg>"

/***/ },
/* 17 */
/***/ function(module, exports) {

	module.exports = "<svg viewBox=\"0 0 16 16\">\n  <rect fill=\"#636363\" x=\"1\" y=\"7\" width=\"14\" height=\"2\"></rect>\n</svg>"

/***/ },
/* 18 */
/***/ function(module, exports) {

	module.exports = {
		"type": "Topology",
		"objects": {
			"good": {
				"type": "GeometryCollection",
				"geometries": [
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R0G"
						},
						"arcs": [
							[
								0,
								1,
								2,
								3,
								4,
								5,
								6,
								7,
								8,
								9,
								10,
								11,
								12,
								13,
								14,
								15,
								16,
								17,
								18,
								19
							],
							[
								20
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R0H"
						},
						"arcs": [
							[
								[
									21
								]
							],
							[
								[
									22,
									23,
									24,
									25,
									26,
									-19,
									27,
									-17,
									28,
									29,
									30,
									31
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R0J"
						},
						"arcs": [
							[
								32,
								33,
								-30,
								34,
								35,
								36,
								37
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R0K"
						},
						"arcs": [
							[
								-29,
								-16,
								38,
								39,
								-35
							],
							[
								40
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R0L"
						},
						"arcs": [
							[
								41,
								42,
								43,
								44,
								-31,
								-34,
								45,
								-38,
								46,
								47,
								48
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R0M"
						},
						"arcs": [
							[
								-40,
								49,
								50,
								51,
								52,
								-36
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R1B"
						},
						"arcs": [
							[
								53,
								54
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R1N"
						},
						"arcs": [
							[
								-18,
								-28
							],
							[
								-22
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R2C"
						},
						"arcs": [
							[
								55,
								56,
								57,
								58,
								59,
								60,
								61,
								62,
								63,
								64
							],
							[
								65
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R2E"
						},
						"arcs": [
							[
								66,
								-64,
								67,
								68,
								69,
								70
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R2G"
						},
						"arcs": [
							[
								-63,
								71,
								72,
								73,
								-68
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R2H"
						},
						"arcs": [
							[
								74,
								75,
								76,
								77,
								78,
								79
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R2J"
						},
						"arcs": [
							[
								[
									-66
								]
							],
							[
								[
									-59,
									80,
									81,
									-75,
									82
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R2K"
						},
						"arcs": [
							[
								[
									83,
									84,
									-61
								]
							],
							[
								[
									85,
									86,
									87,
									88,
									-73
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R2L"
						},
						"arcs": [
							[
								89,
								-84,
								-60,
								-83,
								-80,
								90,
								91,
								-87
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R2M"
						},
						"arcs": [
							[
								92,
								93,
								94,
								95,
								-76,
								-82
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R2N"
						},
						"arcs": [
							[
								96,
								97,
								98,
								-94,
								99
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R2P"
						},
						"arcs": [
							[
								100,
								101,
								102,
								103,
								104
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R2R"
						},
						"arcs": [
							[
								105,
								106,
								107,
								108,
								109,
								-103
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R2V"
						},
						"arcs": [
							[
								-69,
								-74,
								-89,
								110,
								111,
								-101,
								112
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R2W"
						},
						"arcs": [
							[
								-88,
								-92,
								113,
								114,
								115,
								116,
								-111
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R2X"
						},
						"arcs": [
							[
								-112,
								-117,
								117,
								-106,
								-102
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R2Y"
						},
						"arcs": [
							[
								[
									118
								]
							],
							[
								[
									119
								]
							],
							[
								[
									120,
									121,
									122,
									-24,
									123
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3A"
						},
						"arcs": [
							[
								124,
								125,
								-115
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3B"
						},
						"arcs": [
							[
								-91,
								-79,
								126,
								127,
								128,
								-125,
								-114
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R3C"
						},
						"arcs": [
							[
								[
									-78,
									129,
									130,
									131,
									-127
								]
							],
							[
								[
									132,
									-104,
									-110,
									133,
									-124,
									-23,
									134
								]
							],
							[
								[
									-71,
									135,
									-54,
									136
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3E"
						},
						"arcs": [
							[
								-116,
								-126,
								-129,
								137,
								138,
								-107,
								-118
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R3G"
						},
						"arcs": [
							[
								[
									139,
									140,
									-138,
									-128,
									-132,
									141,
									142,
									143
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3H"
						},
						"arcs": [
							[
								-139,
								-141,
								144,
								-108
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3J"
						},
						"arcs": [
							[
								-145,
								-140,
								145,
								-144,
								146,
								147,
								148,
								149,
								-121,
								-134,
								-109
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3K"
						},
						"arcs": [
							[
								-150,
								150,
								151,
								-122
							],
							[
								-120
							],
							[
								-119
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3L"
						},
						"arcs": [
							[
								-77,
								-96,
								152,
								153,
								-130
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R3M"
						},
						"arcs": [
							[
								[
									154
								]
							],
							[
								[
									-154,
									155,
									156,
									157,
									-142,
									-131
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3N"
						},
						"arcs": [
							[
								-158,
								158,
								-147,
								-143
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3P"
						},
						"arcs": [
							[
								-159,
								-157,
								159,
								160,
								161,
								162,
								-148
							],
							[
								-155
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3R"
						},
						"arcs": [
							[
								-163,
								163,
								164,
								-151,
								-149
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3S"
						},
						"arcs": [
							[
								165,
								-3,
								166,
								-164,
								-162
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3T"
						},
						"arcs": [
							[
								-95,
								-99,
								167,
								168,
								-160,
								-156,
								-153
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3V"
						},
						"arcs": [
							[
								169,
								-5,
								170,
								-168,
								-98
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3W"
						},
						"arcs": [
							[
								-62,
								-85,
								-90,
								-86,
								-72
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3X"
						},
						"arcs": [
							[
								171,
								172,
								-100,
								-93,
								-81,
								-58
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R3Y"
						},
						"arcs": [
							[
								-171,
								-4,
								-166,
								-161,
								-169
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R4A"
						},
						"arcs": [
							[
								173,
								-70,
								-113,
								-105,
								-133,
								174
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R4H"
						},
						"arcs": [
							[
								-123,
								-152,
								-165,
								-167,
								-2,
								175,
								176,
								-25
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R4J"
						},
						"arcs": [
							[
								-1,
								177,
								178,
								-176
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R4K"
						},
						"arcs": [
							[
								-178,
								-20,
								-27,
								179
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R4L"
						},
						"arcs": [
							[
								-177,
								-179,
								-180,
								-26
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R5A"
						},
						"arcs": [
							[
								180,
								-6,
								-170,
								-97,
								-173
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R6M"
						},
						"arcs": [
							[
								[
									181,
									-14,
									182,
									-12,
									183
								]
							],
							[
								[
									-21
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R6W"
						},
						"arcs": [
							[
								[
									-13,
									-183
								]
							],
							[
								[
									184,
									-184,
									-11
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R7A"
						},
						"arcs": [
							[
								[
									185
								]
							],
							[
								[
									-41
								],
								[
									186,
									187
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R7B"
						},
						"arcs": [
							[
								188,
								-187
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R7C"
						},
						"arcs": [
							[
								-189,
								-188
							],
							[
								-186
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R7N"
						},
						"arcs": [
							[
								-33,
								-46
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R8A"
						},
						"arcs": [
							[
								189,
								190,
								191,
								192
							],
							[
								193
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R8N"
						},
						"arcs": [
							[
								194
							],
							[
								195
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R9A"
						},
						"arcs": [
							[
								196,
								197,
								198,
								199
							],
							[
								200
							],
							[
								201
							],
							[
								202
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S0A"
						},
						"arcs": [
							[
								[
									203
								]
							],
							[
								[
									204
								]
							],
							[
								[
									205
								]
							],
							[
								[
									206,
									207
								]
							],
							[
								[
									-47,
									-37,
									-53,
									208,
									209,
									210
								],
								[
									211
								],
								[
									212
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S0C"
						},
						"arcs": [
							[
								[
									213
								]
							],
							[
								[
									214,
									215,
									216,
									217,
									218,
									219,
									-51,
									220,
									221
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S0E"
						},
						"arcs": [
							[
								[
									-212
								]
							],
							[
								[
									222
								]
							],
							[
								[
									223
								]
							],
							[
								[
									224,
									225,
									226,
									227,
									228,
									229,
									-197,
									230,
									-48,
									-211,
									231,
									232,
									233
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S0G"
						},
						"arcs": [
							[
								-208,
								234,
								-209,
								-52,
								-220,
								235,
								-218,
								236,
								237,
								238
							],
							[
								239
							],
							[
								240
							],
							[
								-206
							],
							[
								241,
								242,
								243,
								244
							],
							[
								245
							],
							[
								246
							],
							[
								-204
							],
							[
								-205
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S0H"
						},
						"arcs": [
							[
								-237,
								-217,
								247,
								248,
								249,
								250,
								251,
								252,
								253,
								254
							],
							[
								255
							],
							[
								256,
								257,
								258,
								259,
								260
							],
							[
								261
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S0J"
						},
						"arcs": [
							[
								[
									-234
								]
							],
							[
								[
									262,
									263
								]
							],
							[
								[
									264,
									265
								]
							],
							[
								[
									-233,
									266,
									267,
									268,
									269,
									270,
									271,
									272,
									273,
									274,
									275,
									276,
									277,
									-227,
									278,
									-225
								],
								[
									279
								],
								[
									-224
								],
								[
									280
								],
								[
									281
								],
								[
									282
								],
								[
									283
								],
								[
									-223
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S0K"
						},
						"arcs": [
							[
								[
									-240
								]
							],
							[
								[
									284
								]
							],
							[
								[
									-267,
									-232,
									-210,
									-235,
									-207,
									-239,
									285,
									286,
									287,
									288,
									289,
									290,
									-269,
									291
								],
								[
									292
								],
								[
									293
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S0L"
						},
						"arcs": [
							[
								-286,
								-238,
								-255,
								294,
								295,
								296,
								297,
								298,
								299,
								-290,
								300
							],
							[
								-285
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S0M"
						},
						"arcs": [
							[
								[
									-280
								]
							],
							[
								[
									-282
								]
							],
							[
								[
									-283
								]
							],
							[
								[
									301,
									-270,
									-291,
									-300,
									302,
									303,
									304,
									305,
									306,
									307,
									308,
									309,
									310,
									-272
								],
								[
									311
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S0N"
						},
						"arcs": [
							[
								[
									312
								]
							],
							[
								[
									313,
									-253,
									314,
									-251,
									315,
									-249,
									316,
									317,
									318,
									-296
								],
								[
									319
								],
								[
									320
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S0P"
						},
						"arcs": [
							[
								[
									321
								]
							],
							[
								[
									322,
									-192,
									323,
									-190,
									324,
									-229,
									325,
									-263,
									-266,
									326,
									-277
								]
							],
							[
								[
									-284
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S2V"
						},
						"arcs": [
							[
								[
									327,
									-242
								]
							],
							[
								[
									-241
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S3N"
						},
						"arcs": [
							[
								-213
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S4A"
						},
						"arcs": [
							[
								328,
								-215,
								329,
								-222
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S4H"
						},
						"arcs": [
							[
								-219,
								-236
							],
							[
								-214
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S4L"
						},
						"arcs": [
							[
								-247
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S4N"
						},
						"arcs": [
							[
								[
									-244,
									330,
									331,
									332
								]
							],
							[
								[
									333,
									334,
									335,
									336,
									337,
									338
								],
								[
									339
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S4P"
						},
						"arcs": [
							[
								[
									340,
									341,
									342,
									-337
								]
							],
							[
								[
									-333,
									343,
									344,
									345,
									346,
									347,
									348,
									349,
									350,
									351,
									-331,
									-243,
									-328,
									-245
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S4R"
						},
						"arcs": [
							[
								352,
								-338,
								-343,
								353,
								354,
								-345
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S4S"
						},
						"arcs": [
							[
								-341,
								-336,
								355,
								-350,
								356,
								357
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S4T"
						},
						"arcs": [
							[
								-342,
								-358,
								358,
								-348,
								359,
								360,
								-354
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S4V"
						},
						"arcs": [
							[
								-356,
								-335,
								361,
								362,
								-351
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S4W"
						},
						"arcs": [
							[
								-349,
								-359,
								-357
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S4X"
						},
						"arcs": [
							[
								[
									-355,
									-361,
									363,
									-346
								]
							],
							[
								[
									-332,
									-352,
									-363,
									364,
									-339,
									-353,
									-344
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S4Y"
						},
						"arcs": [
							[
								-364,
								-360,
								-347
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S4Z"
						},
						"arcs": [
							[
								[
									-340
								]
							],
							[
								[
									-365,
									-362,
									-334
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S6H"
						},
						"arcs": [
							[
								[
									-262
								]
							],
							[
								[
									-257,
									365
								]
							],
							[
								[
									-259,
									366,
									367
								],
								[
									368
								]
							],
							[
								[
									-256
								]
							],
							[
								[
									-246
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S6J"
						},
						"arcs": [
							[
								[
									-369
								]
							],
							[
								[
									-368,
									369,
									-260
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S6K"
						},
						"arcs": [
							[
								-370,
								-367,
								-258,
								-366,
								-261
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S6V"
						},
						"arcs": [
							[
								[
									-292,
									-268
								],
								[
									370
								],
								[
									371
								],
								[
									372
								]
							],
							[
								[
									-279,
									-226
								]
							],
							[
								[
									-281
								]
							],
							[
								[
									-265,
									-264,
									-326,
									-228,
									-278,
									-327
								],
								[
									-322
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S6W"
						},
						"arcs": [
							[
								-372
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S6X"
						},
						"arcs": [
							[
								[
									-373
								]
							],
							[
								[
									-371
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S7H"
						},
						"arcs": [
							[
								373,
								374,
								375,
								376,
								377
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S7J"
						},
						"arcs": [
							[
								378,
								379,
								380,
								381,
								-375
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S7K"
						},
						"arcs": [
							[
								[
									-289,
									382,
									-287,
									-301
								],
								[
									-380,
									383,
									-378,
									384,
									385,
									386,
									387,
									388,
									389,
									390,
									391,
									392
								]
							],
							[
								[
									-294
								]
							],
							[
								[
									-293
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S7L"
						},
						"arcs": [
							[
								393,
								-391,
								394,
								-389
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S7M"
						},
						"arcs": [
							[
								-388,
								395,
								-376,
								-382,
								396,
								-392,
								-394
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S7N"
						},
						"arcs": [
							[
								397,
								398,
								399,
								-377,
								-396,
								-387
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S7P"
						},
						"arcs": [
							[
								-383,
								-288
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S7R"
						},
						"arcs": [
							[
								-390,
								-395
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S7S"
						},
						"arcs": [
							[
								[
									400,
									-399
								]
							],
							[
								[
									-398,
									-386,
									401
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S7T"
						},
						"arcs": [
							[
								-381,
								-393,
								-397
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S7V"
						},
						"arcs": [
							[
								-384,
								-379,
								-374
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S7W"
						},
						"arcs": [
							[
								-400,
								-401,
								-402,
								-385
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S9A"
						},
						"arcs": [
							[
								-312
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "S9H"
						},
						"arcs": [
							[
								[
									-321
								]
							],
							[
								[
									-320
								]
							],
							[
								[
									-316,
									-250
								]
							],
							[
								[
									-252,
									-315
								]
							],
							[
								[
									-314,
									-295,
									-254
								],
								[
									-313
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S9V"
						},
						"arcs": [
							[
								402,
								403,
								404,
								-304
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "S9X"
						},
						"arcs": [
							[
								-271,
								-302
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T0A"
						},
						"arcs": [
							[
								[
									405,
									406,
									407,
									408
								]
							],
							[
								[
									409,
									410
								]
							],
							[
								[
									411
								]
							],
							[
								[
									412,
									413,
									414
								]
							],
							[
								[
									415,
									416,
									-306,
									417,
									418,
									419,
									420,
									421,
									422,
									423,
									424,
									425,
									426,
									427,
									428,
									429,
									430,
									431,
									-308,
									432,
									433
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T0B"
						},
						"arcs": [
							[
								[
									434
								]
							],
							[
								[
									-421,
									435,
									-419,
									436,
									437,
									438,
									-404,
									439,
									440,
									441,
									-303,
									-299,
									442,
									443,
									444,
									445,
									446,
									447,
									448,
									449,
									450,
									451,
									452,
									453,
									454,
									455,
									456,
									-422,
									457
								],
								[
									458,
									459
								],
								[
									460,
									461
								],
								[
									462
								],
								[
									463
								],
								[
									464
								],
								[
									465
								],
								[
									466
								],
								[
									467
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T0C"
						},
						"arcs": [
							[
								[
									-443,
									-298,
									468,
									469,
									470,
									471
								]
							],
							[
								[
									472,
									473
								]
							],
							[
								[
									474,
									-445,
									475
								]
							],
							[
								[
									476,
									477,
									478,
									479,
									480,
									481,
									482
								]
							],
							[
								[
									483,
									484,
									485,
									-449,
									486,
									-447,
									487,
									488,
									489,
									490,
									491,
									492,
									493,
									494,
									495,
									496,
									497
								],
								[
									498
								],
								[
									499
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T0E"
						},
						"arcs": [
							[
								[
									500,
									501
								]
							],
							[
								[
									-478,
									502
								]
							],
							[
								[
									503
								]
							],
							[
								[
									504
								]
							],
							[
								[
									505
								]
							],
							[
								[
									506,
									507
								]
							],
							[
								[
									508
								]
							],
							[
								[
									509,
									510,
									511,
									512,
									513,
									-497,
									514,
									-483,
									515,
									516,
									517,
									518,
									519
								],
								[
									520
								]
							],
							[
								[
									521,
									522
								]
							],
							[
								[
									523,
									524,
									525,
									526,
									527,
									528,
									529,
									530,
									531
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T0G"
						},
						"arcs": [
							[
								[
									-521
								]
							],
							[
								[
									532,
									533,
									534,
									-513,
									535
								]
							],
							[
								[
									536
								]
							],
							[
								[
									537
								]
							],
							[
								[
									538,
									539
								]
							],
							[
								[
									540,
									-430,
									541,
									-428,
									542,
									-511,
									543,
									544,
									545,
									-518,
									546,
									-523,
									547,
									548,
									549
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T0H"
						},
						"arcs": [
							[
								[
									550,
									551
								]
							],
							[
								[
									552,
									553,
									-532,
									554,
									555,
									556,
									557,
									558,
									559,
									560,
									-549,
									561
								],
								[
									562
								],
								[
									563
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T0J"
						},
						"arcs": [
							[
								[
									564,
									565,
									566
								]
							],
							[
								[
									567,
									568,
									569,
									570,
									571,
									572,
									573,
									574,
									-469,
									-297,
									-319,
									575,
									576,
									577,
									578,
									579,
									580,
									581,
									582,
									583,
									584,
									585,
									586
								],
								[
									587,
									588
								],
								[
									589
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T0K"
						},
						"arcs": [
							[
								[
									590
								]
							],
							[
								[
									591,
									592,
									593
								]
							],
							[
								[
									594,
									-576,
									-318,
									595,
									596,
									597,
									598,
									599,
									600,
									601,
									602,
									603,
									604,
									605,
									-584,
									606,
									607,
									608
								],
								[
									609
								],
								[
									610,
									611
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T0L"
						},
						"arcs": [
							[
								[
									-612
								]
							],
							[
								[
									-611
								]
							],
							[
								[
									612,
									613,
									614,
									615
								]
							],
							[
								[
									616,
									617,
									618
								]
							],
							[
								[
									619,
									620,
									621,
									622,
									623,
									624,
									625,
									626,
									627,
									628,
									629,
									630,
									631,
									632,
									633,
									634,
									-569,
									635,
									-585,
									-606,
									636,
									637,
									638,
									639,
									640,
									641,
									-598,
									642,
									643,
									-527
								],
								[
									644
								],
								[
									645
								],
								[
									646,
									647
								],
								[
									-591
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T0M"
						},
						"arcs": [
							[
								[
									648,
									649
								]
							],
							[
								[
									650,
									651,
									652,
									653,
									654,
									655,
									-491,
									656,
									657
								]
							],
							[
								[
									658
								]
							],
							[
								[
									659,
									660,
									661,
									662,
									663,
									664,
									-617,
									665,
									666,
									-620,
									-526,
									667,
									-494,
									668,
									669,
									670,
									671,
									672,
									673,
									674,
									675,
									676,
									677,
									678,
									679,
									-470,
									-575,
									680,
									-573,
									681,
									-566,
									682,
									683,
									684,
									685,
									686
								],
								[
									687
								],
								[
									688
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T0P"
						},
						"arcs": [
							[
								[
									-309,
									-432,
									689
								]
							],
							[
								[
									690
								]
							],
							[
								[
									-273,
									-311,
									691,
									-550,
									-561,
									692
								],
								[
									693
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T0V"
						},
						"arcs": [
							[
								-694
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T1A"
						},
						"arcs": [
							[
								[
									694,
									695,
									-607,
									-583
								]
							],
							[
								[
									-590
								]
							],
							[
								[
									696,
									697,
									698,
									-581
								]
							],
							[
								[
									699,
									-579
								]
							],
							[
								[
									-588,
									700
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T1B"
						},
						"arcs": [
							[
								[
									-609
								]
							],
							[
								[
									-577,
									-595,
									-608,
									-696,
									701,
									-698
								]
							],
							[
								[
									-697,
									-580,
									-700,
									-578
								]
							],
							[
								[
									-701,
									-589
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T1C"
						},
						"arcs": [
							[
								-699,
								-702,
								-695,
								-582
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T1G"
						},
						"arcs": [
							[
								[
									-610
								]
							],
							[
								[
									-602,
									702,
									-592
								]
							],
							[
								[
									-594,
									703,
									-603
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T1H"
						},
						"arcs": [
							[
								-638,
								704
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T1J"
						},
						"arcs": [
							[
								[
									705
								]
							],
							[
								[
									706
								]
							],
							[
								[
									707
								]
							],
							[
								[
									708,
									-600,
									709,
									-641,
									710,
									-639,
									-705,
									-637,
									-605
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T1K"
						},
						"arcs": [
							[
								[
									-599,
									-642,
									-710
								]
							],
							[
								[
									-640,
									-711
								],
								[
									-708
								],
								[
									-707
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T1L"
						},
						"arcs": [
							[
								-645
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T1M"
						},
						"arcs": [
							[
								-704,
								-593,
								-703,
								-601,
								-709,
								-604
							],
							[
								-706
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T1P"
						},
						"arcs": [
							[
								[
									-572,
									711,
									-567,
									-682
								]
							],
							[
								[
									-681,
									-574
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T1R"
						},
						"arcs": [
							[
								[
									-587
								]
							],
							[
								[
									-586,
									-636,
									-568
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T1S"
						},
						"arcs": [
							[
								[
									-648
								]
							],
							[
								[
									-647
								]
							],
							[
								[
									712,
									-616,
									713
								]
							],
							[
								[
									714,
									-614,
									715,
									-628,
									716,
									-630,
									717
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T1V"
						},
						"arcs": [
							[
								[
									-714,
									-615,
									-715
								]
							],
							[
								[
									-718,
									-629,
									-716,
									-613,
									-713
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T1W"
						},
						"arcs": [
							[
								[
									-646
								]
							],
							[
								[
									-665,
									718,
									-618
								]
							],
							[
								[
									719,
									-650,
									720,
									-621,
									-667
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T1X"
						},
						"arcs": [
							[
								721,
								-570,
								-635,
								722,
								723,
								724,
								725
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T1Y"
						},
						"arcs": [
							[
								726,
								727,
								728,
								729
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T2A"
						},
						"arcs": [
							[
								[
									730
								]
							],
							[
								[
									731,
									-728,
									-725,
									732,
									733,
									734,
									735
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2B"
						},
						"arcs": [
							[
								736,
								737,
								-734
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2C"
						},
						"arcs": [
							[
								-724,
								738,
								739,
								740,
								741,
								742,
								-737,
								-733
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2E"
						},
						"arcs": [
							[
								743,
								744,
								-729,
								-732,
								-731,
								-736,
								745,
								746,
								747,
								748,
								749
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2G"
						},
						"arcs": [
							[
								-735,
								-738,
								-743,
								750,
								751,
								752,
								753,
								-746
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2H"
						},
						"arcs": [
							[
								-742,
								754,
								755,
								-751
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T2J"
						},
						"arcs": [
							[
								[
									756,
									-631,
									-717,
									-627,
									757,
									758
								]
							],
							[
								[
									-741,
									759,
									760,
									761,
									762,
									-755
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2K"
						},
						"arcs": [
							[
								763,
								764,
								765,
								-749
							],
							[
								766
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2L"
						},
						"arcs": [
							[
								-765,
								767,
								768,
								769,
								770
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T2M"
						},
						"arcs": [
							[
								[
									-764,
									-748,
									771,
									-768
								]
							],
							[
								[
									772,
									-726,
									-727,
									773,
									774,
									-684
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2N"
						},
						"arcs": [
							[
								775,
								776,
								-769,
								-772,
								-747,
								777,
								778,
								779,
								780
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T2P"
						},
						"arcs": [
							[
								[
									781,
									782,
									-778,
									-754
								]
							],
							[
								[
									-712,
									-571,
									-722,
									-773,
									-683,
									-565
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2R"
						},
						"arcs": [
							[
								-753,
								783,
								784,
								785,
								-782
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2S"
						},
						"arcs": [
							[
								786,
								787,
								-784,
								-752
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2T"
						},
						"arcs": [
							[
								-785,
								-788,
								788,
								789,
								790
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2V"
						},
						"arcs": [
							[
								-787,
								-756,
								-763,
								791,
								792,
								-789
							],
							[
								793
							],
							[
								794
							],
							[
								795
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T2W"
						},
						"arcs": [
							[
								[
									-795
								]
							],
							[
								[
									-796
								]
							],
							[
								[
									-794
								]
							],
							[
								[
									796,
									797,
									-792,
									-762,
									798,
									-758,
									-626,
									799,
									-624
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2X"
						},
						"arcs": [
							[
								800,
								801,
								-632,
								-757,
								802,
								-761
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2Y"
						},
						"arcs": [
							[
								-803,
								-759,
								-799
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T2Z"
						},
						"arcs": [
							[
								803,
								804,
								-801,
								-760,
								-740
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T3A"
						},
						"arcs": [
							[
								-770,
								-777,
								805,
								-781,
								806,
								807,
								808,
								809,
								810
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T3B"
						},
						"arcs": [
							[
								[
									-776,
									-806
								]
							],
							[
								[
									-780,
									811,
									812,
									813,
									814,
									815,
									-807
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T3C"
						},
						"arcs": [
							[
								-779,
								-783,
								-786,
								-791,
								816,
								817,
								-812
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T3E"
						},
						"arcs": [
							[
								-790,
								-793,
								-798,
								818,
								819,
								-817
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T3G"
						},
						"arcs": [
							[
								-808,
								-816,
								820,
								821
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T3H"
						},
						"arcs": [
							[
								-818,
								-820,
								822,
								-813
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T3J"
						},
						"arcs": [
							[
								-774,
								-730,
								-745,
								823
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T3K"
						},
						"arcs": [
							[
								[
									-767
								]
							],
							[
								[
									824,
									-750,
									-766,
									-771,
									-811,
									825,
									-686
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T3L"
						},
						"arcs": [
							[
								826,
								-821,
								-815,
								827,
								828
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T3M"
						},
						"arcs": [
							[
								-633,
								-802,
								-805,
								829
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T3N"
						},
						"arcs": [
							[
								-775,
								-824,
								-744,
								-825,
								-685
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T3P"
						},
						"arcs": [
							[
								830,
								-687,
								-826,
								-810,
								831,
								832,
								833,
								-660
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T3R"
						},
						"arcs": [
							[
								[
									834,
									-832,
									-809,
									-822,
									-827,
									835
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T3S"
						},
						"arcs": [
							[
								-634,
								-830,
								-804,
								-739,
								-723
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T3Z"
						},
						"arcs": [
							[
								[
									-800,
									-625
								]
							],
							[
								[
									-828,
									-814,
									-823,
									-819,
									-797,
									-623,
									836
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T4A"
						},
						"arcs": [
							[
								-662,
								837
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T4B"
						},
						"arcs": [
							[
								-838,
								-661,
								-834,
								838,
								-833,
								-835,
								839,
								-663
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T4C"
						},
						"arcs": [
							[
								-619,
								-719,
								-664,
								-840,
								-836,
								-829,
								-837,
								-622,
								-721,
								-649,
								-720,
								-666
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T4E"
						},
						"arcs": [
							[
								[
									840,
									-679
								]
							],
							[
								[
									841
								]
							],
							[
								[
									842,
									843
								]
							],
							[
								[
									844
								]
							],
							[
								[
									845
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T4G"
						},
						"arcs": [
							[
								[
									-689
								]
							],
							[
								[
									-673,
									846
								]
							],
							[
								[
									847,
									-677,
									848,
									-675
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T4H"
						},
						"arcs": [
							[
								[
									-688
								]
							],
							[
								[
									-849,
									-676
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T4J"
						},
						"arcs": [
							[
								849,
								-473,
								-476,
								-444,
								-472,
								850,
								-489
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T4L"
						},
						"arcs": [
							[
								[
									-658
								]
							],
							[
								[
									-657,
									-490,
									-851,
									-471,
									851,
									-651
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T4N"
						},
						"arcs": [
							[
								-852,
								-680,
								-841,
								-678,
								-848,
								-674,
								-847,
								-672,
								852,
								-670,
								853,
								-654,
								854,
								-652
							],
							[
								-846
							],
							[
								855,
								856,
								-843,
								857
							],
							[
								-842
							],
							[
								858
							],
							[
								859
							],
							[
								860
							],
							[
								861
							],
							[
								862
							],
							[
								863
							],
							[
								864
							],
							[
								865
							],
							[
								866
							],
							[
								867
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T4P"
						},
						"arcs": [
							[
								[
									-862
								]
							],
							[
								[
									-866
								]
							],
							[
								[
									868,
									-856
								],
								[
									-845
								]
							],
							[
								[
									-865
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T4R"
						},
						"arcs": [
							[
								[
									-861
								]
							],
							[
								[
									-858,
									-844,
									-857,
									-869
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T4S"
						},
						"arcs": [
							[
								[
									-853,
									-671
								]
							],
							[
								[
									-860
								]
							],
							[
								[
									-859
								]
							],
							[
								[
									-863
								]
							],
							[
								[
									-864
								]
							],
							[
								[
									-867
								]
							],
							[
								[
									-868
								]
							],
							[
								[
									-855,
									-653
								]
							],
							[
								[
									-492,
									-656
								]
							],
							[
								[
									-655,
									-854,
									-669,
									-493
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T4T"
						},
						"arcs": [
							[
								869,
								-495,
								-668,
								-525,
								870,
								-480
							],
							[
								-659
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T4V"
						},
						"arcs": [
							[
								-487,
								-448
							],
							[
								-435
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T4X"
						},
						"arcs": [
							[
								871,
								872
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5A"
						},
						"arcs": [
							[
								873,
								874,
								875,
								876
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T5B"
						},
						"arcs": [
							[
								[
									877,
									878,
									879,
									880,
									881,
									882
								]
							],
							[
								[
									883,
									-424,
									884,
									885,
									886
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5C"
						},
						"arcs": [
							[
								-883,
								887,
								888,
								-876
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T5E"
						},
						"arcs": [
							[
								[
									-882,
									889,
									890,
									891,
									892,
									-888
								]
							],
							[
								[
									-425,
									-884
								]
							],
							[
								[
									-887,
									893,
									894,
									-409,
									895,
									-411,
									896,
									897,
									-426
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5G"
						},
						"arcs": [
							[
								-881,
								898,
								899,
								900,
								-890
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5H"
						},
						"arcs": [
							[
								901,
								902,
								903,
								904,
								905,
								906,
								-899,
								-880
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5J"
						},
						"arcs": [
							[
								907,
								-904
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5K"
						},
						"arcs": [
							[
								-903,
								908,
								909,
								910,
								911,
								-905,
								-908
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5L"
						},
						"arcs": [
							[
								-891,
								-901,
								912,
								913,
								914,
								915
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5M"
						},
						"arcs": [
							[
								-900,
								-907,
								916,
								917,
								918,
								919,
								-913
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5N"
						},
						"arcs": [
							[
								-906,
								-912,
								920,
								921,
								922,
								-917
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5P"
						},
						"arcs": [
							[
								-923,
								923,
								924,
								925,
								-918
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5R"
						},
						"arcs": [
							[
								-922,
								926,
								927,
								928,
								929,
								-924
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5S"
						},
						"arcs": [
							[
								-919,
								-926,
								930,
								931,
								932,
								933,
								934,
								935
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5T"
						},
						"arcs": [
							[
								-930,
								936,
								937,
								-931,
								-925
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5V"
						},
						"arcs": [
							[
								938,
								-914,
								-920,
								-936,
								939
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5W"
						},
						"arcs": [
							[
								940,
								941,
								942,
								943,
								-878,
								-875
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5X"
						},
						"arcs": [
							[
								944,
								-892,
								-916,
								945,
								946,
								947,
								-407
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5Y"
						},
						"arcs": [
							[
								-886,
								948,
								949,
								950,
								-877,
								951,
								-894
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T5Z"
						},
						"arcs": [
							[
								-952,
								-889,
								-893,
								-945,
								-406,
								-895
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6A"
						},
						"arcs": [
							[
								952,
								953,
								954,
								-909,
								-902,
								-879,
								-944
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6B"
						},
						"arcs": [
							[
								-943,
								955,
								956,
								957,
								958,
								959,
								-953
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6C"
						},
						"arcs": [
							[
								-960,
								960,
								-954
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6E"
						},
						"arcs": [
							[
								-961,
								-959,
								961,
								962,
								963,
								964,
								965,
								-910,
								-955
							],
							[
								966
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6G"
						},
						"arcs": [
							[
								-966,
								967,
								-927,
								-921,
								-911
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T6H"
						},
						"arcs": [
							[
								[
									968,
									969,
									970,
									-451,
									971,
									-873,
									972,
									973
								]
							],
							[
								[
									974,
									975,
									976,
									-928,
									-968,
									-965
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6J"
						},
						"arcs": [
							[
								-964,
								977,
								978,
								979,
								-975
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6K"
						},
						"arcs": [
							[
								980,
								981,
								-962,
								-958
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6L"
						},
						"arcs": [
							[
								982,
								983,
								-981,
								-957,
								984
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6M"
						},
						"arcs": [
							[
								-929,
								-977,
								985,
								986,
								987,
								988,
								-937
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6N"
						},
						"arcs": [
							[
								-967
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6P"
						},
						"arcs": [
							[
								989,
								990,
								991,
								-985,
								-956,
								-942
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6R"
						},
						"arcs": [
							[
								-976,
								-980,
								992,
								-986
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6S"
						},
						"arcs": [
							[
								993,
								994,
								995,
								-941,
								-874,
								-951
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6T"
						},
						"arcs": [
							[
								996,
								997,
								-983,
								-992
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6V"
						},
						"arcs": [
							[
								-915,
								-939,
								998,
								-946
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6W"
						},
						"arcs": [
							[
								-979,
								999,
								-974,
								1000,
								-987,
								-993
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T6X"
						},
						"arcs": [
							[
								-969,
								-1000,
								-978,
								-963,
								-982,
								-984,
								-998,
								1001
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T7A"
						},
						"arcs": [
							[
								-496,
								-870,
								-479,
								-503,
								-477,
								-515
							],
							[
								-504
							],
							[
								-505
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T7E"
						},
						"arcs": [
							[
								[
									-501,
									1002
								]
							],
							[
								[
									-552,
									1003,
									-516,
									-482,
									1004,
									-507,
									1005,
									-553
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T7N"
						},
						"arcs": [
							[
								[
									-520
								]
							],
							[
								[
									-519,
									-546,
									1006,
									-539,
									1007,
									-544,
									-510
								],
								[
									-537
								],
								[
									-538
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T7P"
						},
						"arcs": [
							[
								-1008,
								-540,
								-1007,
								-545
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T7S"
						},
						"arcs": [
							[
								-522,
								-547,
								-517,
								-1004,
								-551,
								-562,
								-548
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T7V"
						},
						"arcs": [
							[
								-508,
								-1005,
								-481,
								-871,
								-524,
								-554,
								-1006
							],
							[
								-509
							],
							[
								-506
							],
							[
								-1003,
								-502
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T7X"
						},
						"arcs": [
							[
								[
									-934,
									1008,
									1009,
									1010
								]
							],
							[
								[
									1011,
									1012,
									-932,
									-938,
									-989,
									1013,
									1014,
									-534
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T7Y"
						},
						"arcs": [
							[
								[
									-988,
									1015,
									1016,
									-484,
									1017,
									-1014
								]
							],
							[
								[
									-933,
									-1013,
									1018,
									-1009
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T7Z"
						},
						"arcs": [
							[
								-535,
								-1015,
								-1018,
								-498,
								-514
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T8A"
						},
						"arcs": [
							[
								[
									-452,
									-971,
									1019
								]
							],
							[
								[
									-466
								]
							],
							[
								[
									-467
								]
							],
							[
								[
									-468
								]
							],
							[
								[
									1020,
									1021,
									1022,
									-990,
									-996,
									1023,
									-994,
									-950,
									1024
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T8B"
						},
						"arcs": [
							[
								1025,
								-453,
								-1020,
								-970,
								-1002,
								-997,
								-991,
								-1023
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T8C"
						},
						"arcs": [
							[
								1026,
								-454,
								-1026,
								-1022
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T8E"
						},
						"arcs": [
							[
								1027,
								-455,
								-1027,
								-1021,
								1028
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T8G"
						},
						"arcs": [
							[
								-456,
								-1028,
								1029
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T8H"
						},
						"arcs": [
							[
								-1024,
								-995
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T8L"
						},
						"arcs": [
							[
								-1030,
								-1029,
								-1025,
								-949,
								-885,
								-423,
								-457
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T8N"
						},
						"arcs": [
							[
								-947,
								-999,
								-940,
								-935,
								-1011,
								1030
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T8R"
						},
						"arcs": [
							[
								-427,
								-898,
								1031,
								-536,
								-512,
								-543
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T8S"
						},
						"arcs": [
							[
								-564
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T8T"
						},
						"arcs": [
							[
								-410,
								-896,
								-408,
								-948,
								-1031,
								-1010,
								-1019,
								-1012,
								-533,
								-1032,
								-897
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T8V"
						},
						"arcs": [
							[
								-563
							],
							[
								1032
							],
							[
								1033,
								1034
							],
							[
								1035
							],
							[
								1036
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T8W"
						},
						"arcs": [
							[
								[
									1037,
									-1034
								]
							],
							[
								[
									-1037
								]
							],
							[
								[
									-1036
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T8X"
						},
						"arcs": [
							[
								[
									-1038,
									-1035
								]
							],
							[
								[
									-1033
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T9A"
						},
						"arcs": [
							[
								[
									-500
								]
							],
							[
								[
									-446,
									-475,
									-474,
									-850,
									-488
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T9C"
						},
						"arcs": [
							[
								[
									-464
								]
							],
							[
								[
									-465
								]
							],
							[
								[
									-460
								]
							],
							[
								[
									-459
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T9E"
						},
						"arcs": [
							[
								[
									-499
								]
							],
							[
								[
									-973,
									-872,
									-972,
									-450,
									-486,
									1038,
									-1016,
									-1001
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T9G"
						},
						"arcs": [
							[
								-1039,
								-485,
								-1017
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T9H"
						},
						"arcs": [
							[
								-310,
								-690,
								-431,
								-541,
								-692
							],
							[
								-691
							],
							[
								1039
							],
							[
								1040
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T9J"
						},
						"arcs": [
							[
								-1041
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T9K"
						},
						"arcs": [
							[
								-1040
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T9M"
						},
						"arcs": [
							[
								-417,
								1041,
								-414,
								1042,
								-433,
								-307
							],
							[
								-412
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T9N"
						},
						"arcs": [
							[
								[
									-415,
									-1042,
									-416
								]
							],
							[
								[
									-434,
									-1043,
									-413
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T9S"
						},
						"arcs": [
							[
								-429,
								-542
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T9V"
						},
						"arcs": [
							[
								[
									-440,
									-403,
									-442
								]
							],
							[
								[
									-441
								]
							],
							[
								[
									-463
								]
							],
							[
								[
									-438
								]
							],
							[
								[
									-437,
									-418,
									-305,
									-405,
									-439
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "T9W"
						},
						"arcs": [
							[
								-461,
								1043
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "T9X"
						},
						"arcs": [
							[
								[
									-1044,
									-462
								]
							],
							[
								[
									-436,
									-420
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V0A"
						},
						"arcs": [
							[
								-644,
								1044,
								1045,
								1046,
								1047,
								1048,
								-528
							],
							[
								1049
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V0B"
						},
						"arcs": [
							[
								[
									-1050
								]
							],
							[
								[
									-1046
								]
							],
							[
								[
									-1045,
									-643,
									-597,
									1050,
									1051,
									1052,
									1053,
									1054,
									1055,
									1056,
									1057,
									-1047
								],
								[
									1058
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V0C"
						},
						"arcs": [
							[
								[
									1059
								]
							],
							[
								[
									-557,
									1060
								]
							],
							[
								[
									-559,
									1061,
									-555,
									-531,
									1062,
									1063,
									1064,
									1065,
									1066,
									1067
								],
								[
									1068
								],
								[
									1069
								],
								[
									1070
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V0E"
						},
						"arcs": [
							[
								-1049,
								1071,
								1072,
								1073,
								1074,
								1075,
								1076,
								1077,
								1078,
								1079,
								1080,
								1081,
								1082,
								1083,
								1084,
								1085,
								1086,
								1087,
								1088,
								1089,
								1090,
								-529
							],
							[
								1091
							],
							[
								1092
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V0G"
						},
						"arcs": [
							[
								[
									1093
								]
							],
							[
								[
									1094
								]
							],
							[
								[
									1095,
									1096,
									1097,
									1098,
									1099,
									1100,
									-1052
								],
								[
									1101
								]
							],
							[
								[
									1102
								]
							],
							[
								[
									-1058,
									1103,
									-1054,
									1104,
									1105,
									1106,
									-1072,
									-1048
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V0H"
						},
						"arcs": [
							[
								[
									1107
								]
							],
							[
								[
									1108,
									1109,
									1110,
									1111,
									1112,
									-1073,
									-1107,
									1113,
									-1099,
									1114,
									1115,
									1116,
									1117,
									-1077
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V0J"
						},
						"arcs": [
							[
								[
									1118,
									1119
								]
							],
							[
								[
									1120
								]
							],
							[
								[
									1121
								]
							],
							[
								[
									-530,
									-1091,
									1122,
									1123,
									1124,
									1125,
									1126,
									1127,
									1128,
									1129,
									1130,
									1131,
									1132,
									1133,
									1134,
									-1063
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V0K"
						},
						"arcs": [
							[
								[
									1135
								]
							],
							[
								[
									1136
								],
								[
									1137
								]
							],
							[
								[
									1138
								]
							],
							[
								[
									1139,
									-1081
								]
							],
							[
								[
									-1089,
									1140,
									1141,
									1142,
									1143,
									1144,
									1145,
									1146,
									1147,
									1148,
									1149,
									1150,
									1151
								],
								[
									1152
								],
								[
									1153
								],
								[
									1154
								]
							],
							[
								[
									1155,
									1156,
									1157,
									-1124
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V0L"
						},
						"arcs": [
							[
								[
									-1150,
									1158
								]
							],
							[
								[
									-1090,
									-1152,
									1159,
									1160,
									-1156,
									-1123
								]
							],
							[
								[
									1161,
									-1119,
									1162,
									1163,
									-1148,
									1164,
									1165,
									1166,
									-1129
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V0M"
						},
						"arcs": [
							[
								1167,
								1168,
								1169,
								1170,
								1171,
								1172,
								-1145
							],
							[
								1173
							],
							[
								1174
							],
							[
								1175
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V0N"
						},
						"arcs": [
							[
								[
									1176
								]
							],
							[
								[
									1177
								]
							],
							[
								[
									1178
								]
							],
							[
								[
									1179
								]
							],
							[
								[
									1180
								]
							],
							[
								[
									1181
								]
							],
							[
								[
									1182
								]
							],
							[
								[
									-1174
								]
							],
							[
								[
									1183
								]
							],
							[
								[
									1184
								]
							],
							[
								[
									-1175
								]
							],
							[
								[
									1185,
									1186
								]
							],
							[
								[
									-1176
								]
							],
							[
								[
									1187,
									1188,
									1189,
									1190
								]
							],
							[
								[
									1191
								]
							],
							[
								[
									1192
								]
							],
							[
								[
									1193
								]
							],
							[
								[
									1194
								]
							],
							[
								[
									-1154
								]
							],
							[
								[
									-1153
								]
							],
							[
								[
									1195,
									1196
								]
							],
							[
								[
									1197
								]
							],
							[
								[
									-1146,
									-1173,
									1198,
									1199,
									1200,
									1201,
									1202,
									1203,
									1204,
									1205,
									1206,
									1207
								],
								[
									1208
								],
								[
									1209
								]
							],
							[
								[
									1210,
									1211
								],
								[
									1212
								]
							],
							[
								[
									1213
								]
							],
							[
								[
									1214
								]
							],
							[
								[
									1215
								]
							],
							[
								[
									1216
								]
							],
							[
								[
									-1166,
									1217,
									1218,
									1219
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V0P"
						},
						"arcs": [
							[
								[
									1220,
									1221
								]
							],
							[
								[
									1222,
									1223
								]
							],
							[
								[
									1224,
									1225
								]
							],
							[
								[
									1226
								]
							],
							[
								[
									1227
								]
							],
							[
								[
									-1186,
									1228
								]
							],
							[
								[
									1229
								]
							],
							[
								[
									1230
								]
							],
							[
								[
									1231
								]
							],
							[
								[
									1232
								]
							],
							[
								[
									1233
								]
							],
							[
								[
									1234
								]
							],
							[
								[
									1235
								]
							],
							[
								[
									1236
								]
							],
							[
								[
									1237
								]
							],
							[
								[
									1238,
									1239,
									1240,
									1241,
									1242,
									1243,
									1244,
									-1211,
									1245
								]
							],
							[
								[
									1246
								]
							],
							[
								[
									1247
								]
							],
							[
								[
									1248,
									-1196
								]
							],
							[
								[
									-1147,
									-1208,
									1249,
									-1218,
									-1165
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V0R"
						},
						"arcs": [
							[
								[
									1250
								]
							],
							[
								[
									1251,
									1252
								]
							],
							[
								[
									1253
								]
							],
							[
								[
									1254,
									1255
								]
							],
							[
								[
									1256,
									1257
								]
							],
							[
								[
									1258,
									1259,
									1260,
									1261,
									1262,
									1263,
									1264,
									1265,
									1266,
									1267,
									1268,
									1269,
									1270,
									1271,
									1272
								],
								[
									1273
								]
							],
							[
								[
									1274
								]
							],
							[
								[
									1275
								]
							],
							[
								[
									1276
								]
							],
							[
								[
									1277,
									1278,
									1279,
									1280
								]
							],
							[
								[
									-1225,
									1281,
									-1221,
									1282,
									-1223,
									1283
								]
							],
							[
								[
									1284,
									1285,
									1286,
									1287
								]
							],
							[
								[
									1288,
									1289,
									-1242,
									1290
								]
							],
							[
								[
									1291
								]
							],
							[
								[
									1292,
									-1244
								]
							],
							[
								[
									1293
								]
							],
							[
								[
									1294,
									1295,
									1296,
									1297,
									1298,
									1299,
									1300
								]
							],
							[
								[
									1301
								]
							],
							[
								[
									1302,
									1303
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V0S"
						},
						"arcs": [
							[
								[
									1304,
									-1269
								]
							],
							[
								[
									1305,
									-1267
								]
							],
							[
								[
									1306,
									1307,
									-1271
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V0T"
						},
						"arcs": [
							[
								[
									1308
								]
							],
							[
								[
									1309
								]
							],
							[
								[
									1310
								]
							],
							[
								[
									1311
								]
							],
							[
								[
									1312
								]
							],
							[
								[
									1313
								]
							],
							[
								[
									1314
								]
							],
							[
								[
									1315
								]
							],
							[
								[
									1316
								]
							],
							[
								[
									1317
								]
							],
							[
								[
									1318
								]
							],
							[
								[
									1319
								]
							],
							[
								[
									1320
								]
							],
							[
								[
									1321
								]
							],
							[
								[
									1322
								]
							],
							[
								[
									1323
								]
							],
							[
								[
									1324
								]
							],
							[
								[
									1325
								]
							],
							[
								[
									1326,
									1327
								]
							],
							[
								[
									1328
								]
							],
							[
								[
									1329
								]
							],
							[
								[
									1330
								]
							],
							[
								[
									1331
								]
							],
							[
								[
									1332
								]
							],
							[
								[
									1333
								]
							],
							[
								[
									1334
								]
							],
							[
								[
									-1167,
									-1220,
									1335,
									1336,
									-1130
								],
								[
									-1217
								]
							],
							[
								[
									1337
								]
							],
							[
								[
									1338,
									1339
								]
							],
							[
								[
									1340
								]
							],
							[
								[
									1341
								]
							],
							[
								[
									1342,
									-1134
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V0V"
						},
						"arcs": [
							[
								[
									1343
								]
							],
							[
								[
									1344
								]
							],
							[
								[
									1345
								]
							],
							[
								[
									1346
								]
							],
							[
								[
									1347
								]
							],
							[
								[
									1348
								]
							],
							[
								[
									1349
								]
							],
							[
								[
									1350
								]
							],
							[
								[
									1351
								]
							],
							[
								[
									1352
								]
							],
							[
								[
									1353,
									1354
								]
							],
							[
								[
									1355,
									1356
								]
							],
							[
								[
									1357,
									1358
								]
							],
							[
								[
									1359,
									1360,
									1361,
									1362,
									1363
								]
							],
							[
								[
									1364,
									1365,
									1366,
									1367,
									1368,
									1369
								]
							],
							[
								[
									1370,
									1371
								]
							],
							[
								[
									1372,
									1373,
									1374,
									-1132
								]
							],
							[
								[
									1375
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V0W"
						},
						"arcs": [
							[
								-1069
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V0X"
						},
						"arcs": [
							[
								1376,
								-1116,
								1377,
								1378,
								1379,
								1380,
								1381,
								-1168,
								-1144,
								1382,
								-1078,
								-1118
							],
							[
								-1136
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1A"
						},
						"arcs": [
							[
								-1057,
								1383,
								-1055,
								-1104
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V1B"
						},
						"arcs": [
							[
								[
									1384
								]
							],
							[
								[
									1385,
									1386
								]
							],
							[
								[
									-1113,
									1387,
									1388,
									1389,
									1390,
									1391,
									-1074
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V1C"
						},
						"arcs": [
							[
								[
									-1059
								]
							],
							[
								[
									-1056,
									-1384
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1E"
						},
						"arcs": [
							[
								-1092
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1G"
						},
						"arcs": [
							[
								-1061,
								-556,
								-1062,
								-558
							],
							[
								-1060
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1H"
						},
						"arcs": [
							[
								-1392,
								1392,
								-1386,
								1393,
								-1390,
								1394,
								1395,
								1396,
								-1075
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V1J"
						},
						"arcs": [
							[
								[
									-1071
								]
							],
							[
								[
									-1070
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V1K"
						},
						"arcs": [
							[
								[
									-1138
								]
							],
							[
								[
									-1093
								]
							],
							[
								[
									-1155
								]
							],
							[
								[
									1397,
									-1079,
									-1383,
									-1143
								],
								[
									-1139
								],
								[
									-1137
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1L"
						},
						"arcs": [
							[
								-1053,
								-1101,
								1398,
								-1105
							],
							[
								-1103
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1M"
						},
						"arcs": [
							[
								1399,
								1400,
								1401,
								1402,
								1403,
								1404
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1N"
						},
						"arcs": [
							[
								-1399,
								-1100,
								-1114,
								-1106
							],
							[
								-1095
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1P"
						},
						"arcs": [
							[
								-1388,
								-1112,
								1405,
								1406,
								1407,
								1408
							],
							[
								1409
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V1R"
						},
						"arcs": [
							[
								[
									-1102
								]
							],
							[
								[
									1410,
									-1097
								],
								[
									-1094
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1S"
						},
						"arcs": [
							[
								1411,
								1412,
								1413,
								1414,
								-1082,
								-1140,
								-1080,
								-1398,
								-1142
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1T"
						},
						"arcs": [
							[
								-1394,
								-1387,
								-1393,
								-1391
							],
							[
								-1385
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1V"
						},
						"arcs": [
							[
								1415,
								1416,
								1417,
								1418
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1W"
						},
						"arcs": [
							[
								-1406,
								-1111,
								1419,
								1420,
								1421,
								1422
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V1X"
						},
						"arcs": [
							[
								[
									-1410
								]
							],
							[
								[
									-1423,
									1423,
									-1416,
									1424,
									-1407
								]
							],
							[
								[
									-1409,
									1425,
									-1395,
									-1389
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1Y"
						},
						"arcs": [
							[
								-1424,
								-1422,
								1426,
								-1417
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V1Z"
						},
						"arcs": [
							[
								1427,
								-1418,
								-1427,
								-1421,
								1428,
								-1109,
								-1076,
								-1397
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2A"
						},
						"arcs": [
							[
								-1377,
								-1117
							],
							[
								-1108
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2B"
						},
						"arcs": [
							[
								1429,
								1430,
								1431,
								-1412,
								-1141,
								-1088
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2C"
						},
						"arcs": [
							[
								1432,
								-1086,
								1433,
								-1084,
								1434,
								-1414,
								1435,
								-1431
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V2E"
						},
						"arcs": [
							[
								[
									-1083,
									-1415,
									-1435
								]
							],
							[
								[
									-1085,
									-1434
								]
							],
							[
								[
									-1436,
									-1413,
									-1432
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2G"
						},
						"arcs": [
							[
								-1160,
								-1151,
								-1159,
								-1149,
								-1164,
								1436
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2H"
						},
						"arcs": [
							[
								-1433,
								-1430,
								-1087
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2J"
						},
						"arcs": [
							[
								1437,
								-1157,
								-1161,
								-1437,
								-1163,
								-1120,
								-1162,
								-1128
							],
							[
								-1122
							],
							[
								-1121
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2K"
						},
						"arcs": [
							[
								1438,
								1439,
								1440,
								1441,
								-1126
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2L"
						},
						"arcs": [
							[
								1442,
								1443,
								-1440
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2M"
						},
						"arcs": [
							[
								-1444,
								1444,
								-1441
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2N"
						},
						"arcs": [
							[
								-1445,
								-1443,
								-1439,
								-1125,
								-1158,
								-1438,
								-1127,
								-1442
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V2P"
						},
						"arcs": [
							[
								[
									1445
								]
							],
							[
								[
									-1382,
									1446,
									-1380,
									1447,
									1448,
									1449,
									1450,
									-1169
								],
								[
									1451
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V2R"
						},
						"arcs": [
							[
								[
									1452
								]
							],
							[
								[
									1453,
									-1449,
									1454,
									1455,
									1456,
									-1170,
									-1451
								],
								[
									-1446
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2S"
						},
						"arcs": [
							[
								1457,
								1458,
								1459,
								1460
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2T"
						},
						"arcs": [
							[
								-1459,
								1461,
								1462
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2V"
						},
						"arcs": [
							[
								-1172,
								1463,
								1464,
								1465,
								1466,
								1467,
								1468,
								-1199
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2W"
						},
						"arcs": [
							[
								1469,
								-1400,
								1470,
								1471,
								1472
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2X"
						},
						"arcs": [
							[
								-1471,
								-1405,
								1473,
								1474
							],
							[
								1475
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2Y"
						},
						"arcs": [
							[
								1476,
								1477,
								1478,
								1479,
								1480,
								-1403
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V2Z"
						},
						"arcs": [
							[
								1481,
								1482,
								1483,
								1484,
								-1478
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3A"
						},
						"arcs": [
							[
								-1485,
								1485,
								-1479
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3B"
						},
						"arcs": [
							[
								1486,
								1487,
								1488,
								1489,
								1490,
								1491
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V3C"
						},
						"arcs": [
							[
								[
									1492,
									1493,
									1494,
									1495,
									1496,
									1497,
									1498,
									-1490
								]
							],
							[
								[
									-1487,
									1499
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3E"
						},
						"arcs": [
							[
								1500,
								-1488,
								-1500,
								-1492,
								1501,
								1502
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3G"
						},
						"arcs": [
							[
								-1171,
								-1457,
								1503,
								-1461,
								1504,
								-1464
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V3H"
						},
						"arcs": [
							[
								[
									-1491,
									-1499,
									1505,
									1506,
									1507,
									1508,
									-1502
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3J"
						},
						"arcs": [
							[
								-1506,
								-1498,
								1509,
								1510,
								1511
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3K"
						},
						"arcs": [
							[
								-1497,
								1512,
								1513,
								1514,
								-1510
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3L"
						},
						"arcs": [
							[
								-1514,
								1515,
								1516,
								1517
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3M"
						},
						"arcs": [
							[
								1518,
								1519,
								1520,
								1521,
								1522,
								1523,
								1524,
								-1517
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V3N"
						},
						"arcs": [
							[
								[
									-1524,
									1525,
									1526
								]
							],
							[
								[
									1527,
									1528,
									-1511,
									-1515,
									-1518,
									-1525
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3R"
						},
						"arcs": [
							[
								1529,
								1530,
								1531,
								1532,
								1533,
								-1495
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V3S"
						},
						"arcs": [
							[
								[
									1534,
									-1480,
									-1486,
									-1484,
									1535,
									1536,
									1537,
									1538,
									1539,
									1540,
									1541,
									1542,
									-1531
								]
							],
							[
								[
									1543
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3T"
						},
						"arcs": [
							[
								1544,
								-1533
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3V"
						},
						"arcs": [
							[
								-1496,
								-1534,
								-1545,
								-1532,
								1545,
								1546,
								-1519,
								-1516,
								-1513
							],
							[
								-1544
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3W"
						},
						"arcs": [
							[
								-1543,
								1547,
								1548,
								1549,
								-1546
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3X"
						},
						"arcs": [
							[
								-1542,
								1550,
								-1548
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V3Y"
						},
						"arcs": [
							[
								1551,
								-1474,
								1552,
								-1493,
								-1489,
								-1501,
								1553,
								-1468
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V4A"
						},
						"arcs": [
							[
								1554,
								-1538,
								1555,
								1556
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V4B"
						},
						"arcs": [
							[
								-1537,
								1557,
								-1556
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V4C"
						},
						"arcs": [
							[
								-1550,
								1558,
								1559,
								1560,
								-1520,
								-1547
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V4E"
						},
						"arcs": [
							[
								-1549,
								-1551,
								1561,
								-1559
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V4G"
						},
						"arcs": [
							[
								[
									1562
								]
							],
							[
								[
									-1561,
									1563,
									1564,
									1565,
									-1521
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V4K"
						},
						"arcs": [
							[
								[
									-1560,
									-1562,
									-1541,
									1566,
									1567,
									1568,
									1569,
									1570,
									1571,
									1572,
									-1564
								],
								[
									-1563
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V4L"
						},
						"arcs": [
							[
								1573,
								1574,
								-1568
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V4M"
						},
						"arcs": [
							[
								-1575,
								1575,
								-1569
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V4N"
						},
						"arcs": [
							[
								-1404,
								-1481,
								-1535,
								-1530,
								-1494,
								-1553
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V4P"
						},
						"arcs": [
							[
								-1555,
								-1539
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V4R"
						},
						"arcs": [
							[
								[
									-1476
								]
							],
							[
								[
									-1472,
									-1475,
									-1552,
									-1467,
									1576
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V4S"
						},
						"arcs": [
							[
								1577,
								-1473,
								-1577,
								-1466
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V4T"
						},
						"arcs": [
							[
								-1420,
								-1110,
								-1429
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V4V"
						},
						"arcs": [
							[
								-1426,
								-1408,
								-1425,
								-1419,
								-1428,
								-1396
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V4W"
						},
						"arcs": [
							[
								1578,
								1579,
								-1482,
								-1477,
								-1402
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V4X"
						},
						"arcs": [
							[
								-1578,
								-1465,
								-1505,
								-1460,
								-1463,
								1580,
								-1579,
								-1401,
								-1470
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V4Z"
						},
						"arcs": [
							[
								[
									-1450,
									-1454
								]
							],
							[
								[
									-1381,
									-1447
								]
							],
							[
								[
									-1452
								]
							],
							[
								[
									1581,
									-1455,
									-1448,
									-1379
								],
								[
									-1453
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5A"
						},
						"arcs": [
							[
								-1507,
								-1512,
								-1529,
								1582,
								1583,
								1584,
								1585
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5B"
						},
						"arcs": [
							[
								-1585,
								1586,
								1587,
								1588
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5C"
						},
						"arcs": [
							[
								-1588,
								1589,
								1590,
								1591,
								1592
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5E"
						},
						"arcs": [
							[
								-1583,
								-1528,
								-1527,
								1593,
								1594,
								1595
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5G"
						},
						"arcs": [
							[
								-1584,
								-1596,
								1596,
								1597,
								1598,
								-1590,
								-1587
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5H"
						},
						"arcs": [
							[
								-1595,
								1599,
								1600,
								1601,
								-1597
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5J"
						},
						"arcs": [
							[
								-1594,
								-1526,
								-1523,
								1602,
								1603,
								-1600
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5K"
						},
						"arcs": [
							[
								-1592,
								1604,
								1605,
								1606
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5L"
						},
						"arcs": [
							[
								1607,
								1608,
								1609,
								-1606
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5M"
						},
						"arcs": [
							[
								-1591,
								-1599,
								1610,
								1611,
								-1605
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5N"
						},
						"arcs": [
							[
								-1612,
								1612,
								1613,
								1614,
								1615,
								1616,
								-1608
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5P"
						},
						"arcs": [
							[
								1617,
								1618,
								1619,
								1620,
								1621,
								1622,
								-1614
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5R"
						},
						"arcs": [
							[
								-1598,
								-1602,
								1623,
								-1618,
								-1613,
								-1611
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5S"
						},
						"arcs": [
							[
								-1604,
								1624,
								-1619,
								-1624,
								-1601
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5T"
						},
						"arcs": [
							[
								-1616,
								1625,
								1626,
								1627
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5V"
						},
						"arcs": [
							[
								-1615,
								-1623,
								1628,
								1629,
								-1626
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5W"
						},
						"arcs": [
							[
								-1622,
								1630,
								1631,
								-1629
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5X"
						},
						"arcs": [
							[
								-1631,
								-1621,
								1632,
								1633,
								1634
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5Y"
						},
						"arcs": [
							[
								-1627,
								-1630,
								-1632,
								-1635,
								1635,
								1636,
								1637,
								1638
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V5Z"
						},
						"arcs": [
							[
								1639,
								1640,
								1641,
								1642,
								-1637
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6A"
						},
						"arcs": [
							[
								-1609,
								-1617,
								-1628,
								1643,
								1644,
								1645
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6B"
						},
						"arcs": [
							[
								-1644,
								-1639,
								1646,
								1647,
								1648,
								1649
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6C"
						},
						"arcs": [
							[
								-1645,
								-1650,
								1650,
								1651,
								1652,
								1653,
								1654
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V6E"
						},
						"arcs": [
							[
								[
									1655,
									1656,
									1657
								]
							],
							[
								[
									-1653,
									1658,
									1659,
									1660
								]
							],
							[
								[
									1661,
									1662
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6G"
						},
						"arcs": [
							[
								-1654,
								-1661,
								1663,
								1664,
								-1658,
								1665,
								-1663,
								1666
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6H"
						},
						"arcs": [
							[
								1667,
								-1642,
								1668,
								1669
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V6J"
						},
						"arcs": [
							[
								[
									1670
								]
							],
							[
								[
									-1670,
									1671,
									1672,
									1673,
									1674
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6K"
						},
						"arcs": [
							[
								-1674,
								1675,
								1676,
								1677
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6L"
						},
						"arcs": [
							[
								-1676,
								-1673,
								1678,
								1679,
								1680,
								1681
							],
							[
								-1671
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6M"
						},
						"arcs": [
							[
								-1641,
								1682,
								1683,
								-1679,
								-1672,
								-1669
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6N"
						},
						"arcs": [
							[
								-1684,
								1684,
								1685,
								1686,
								1687,
								-1680
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6P"
						},
						"arcs": [
							[
								-1683,
								-1640,
								-1636,
								-1634,
								1688,
								1689,
								1690,
								-1685
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6R"
						},
						"arcs": [
							[
								-1677,
								-1682,
								1691,
								1692,
								1693
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6S"
						},
						"arcs": [
							[
								-1692,
								-1681,
								-1688,
								1694
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V6T"
						},
						"arcs": [
							[
								[
									1695,
									1696
								]
							],
							[
								[
									-1693,
									-1695,
									-1687,
									1697,
									1698
								]
							],
							[
								[
									-1554,
									-1503,
									-1509,
									1699,
									1700,
									1701,
									1702,
									1703,
									1704,
									1705,
									-1200,
									-1469
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6V"
						},
						"arcs": [
							[
								-1625,
								-1603,
								-1522,
								-1566,
								1706,
								1707,
								1708,
								-1689,
								-1633,
								-1620
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6W"
						},
						"arcs": [
							[
								-1565,
								-1573,
								1709,
								1710,
								-1707
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6X"
						},
						"arcs": [
							[
								1711,
								1712,
								1713,
								-1690,
								-1709
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6Y"
						},
						"arcs": [
							[
								1714,
								1715,
								1716,
								-1712,
								-1708,
								-1711
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V6Z"
						},
						"arcs": [
							[
								1717,
								-1648,
								1718,
								-1659,
								-1652
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7A"
						},
						"arcs": [
							[
								-1710,
								-1572,
								1719,
								-1715
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7B"
						},
						"arcs": [
							[
								1720,
								-1698,
								-1686,
								-1691,
								-1714,
								1721,
								1722,
								-1696
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7C"
						},
						"arcs": [
							[
								-1717,
								1723,
								1724,
								-1722,
								-1713
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7E"
						},
						"arcs": [
							[
								-1716,
								-1720,
								-1571,
								1725,
								-1724
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V7G"
						},
						"arcs": [
							[
								[
									1726,
									1727,
									-1701
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7H"
						},
						"arcs": [
							[
								1728,
								1729,
								-1702,
								-1728
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7J"
						},
						"arcs": [
							[
								1730,
								1731,
								1732,
								1733,
								-1703,
								-1730
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7K"
						},
						"arcs": [
							[
								1734,
								1735,
								-1704,
								-1734
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7L"
						},
						"arcs": [
							[
								-1732,
								1736,
								1737,
								1738
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7M"
						},
						"arcs": [
							[
								-1738,
								1739,
								1740,
								1741
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7N"
						},
						"arcs": [
							[
								-1735,
								-1733,
								-1739,
								-1742,
								1742,
								1743
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7P"
						},
						"arcs": [
							[
								-1743,
								-1741,
								1744,
								1745,
								1746,
								1747,
								1748
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7R"
						},
						"arcs": [
							[
								-1744,
								-1749,
								1749,
								-1705,
								-1736
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7S"
						},
						"arcs": [
							[
								-1706,
								-1750,
								1750,
								1751,
								1752,
								-1201
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V7T"
						},
						"arcs": [
							[
								[
									1753,
									-1746
								]
							],
							[
								[
									-1748,
									1754,
									1755,
									-1751
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7V"
						},
						"arcs": [
							[
								-1756,
								1756,
								1757,
								-1752
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V7W"
						},
						"arcs": [
							[
								[
									-1753,
									-1758,
									1758,
									-1202
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V7Y"
						},
						"arcs": [
							[
								-1649,
								-1718,
								-1651
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V8A"
						},
						"arcs": [
							[
								[
									-1191
								]
							],
							[
								[
									-1190,
									1759,
									-1206,
									1760,
									-1188
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V8B"
						},
						"arcs": [
							[
								[
									-1210
								]
							],
							[
								[
									1761,
									-1204
								],
								[
									-1183
								]
							],
							[
								[
									-1209
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V8C"
						},
						"arcs": [
							[
								[
									1762,
									1763
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V8G"
						},
						"arcs": [
							[
								[
									1764
								]
							],
							[
								[
									1765
								]
							],
							[
								[
									-1327,
									1766
								]
							],
							[
								[
									1767
								]
							],
							[
								[
									1768
								]
							],
							[
								[
									1769
								]
							],
							[
								[
									1770
								]
							],
							[
								[
									1771
								]
							],
							[
								[
									1772
								]
							],
							[
								[
									1773
								]
							],
							[
								[
									1774
								]
							],
							[
								[
									1775
								]
							],
							[
								[
									1776
								]
							],
							[
								[
									1777
								]
							],
							[
								[
									1778
								]
							],
							[
								[
									-1337,
									1779,
									-1340,
									1780,
									-1764,
									1781,
									-1364,
									1782,
									-1373,
									-1131
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V8J"
						},
						"arcs": [
							[
								[
									-1361,
									1783
								]
							],
							[
								[
									1784
								]
							],
							[
								[
									-1354,
									1785
								]
							],
							[
								[
									1786
								]
							],
							[
								[
									1787,
									-1366
								]
							],
							[
								[
									1788,
									-1368
								]
							],
							[
								[
									1789
								]
							],
							[
								[
									-1371,
									1790
								]
							],
							[
								[
									-1783,
									-1363,
									1791,
									-1357,
									1792,
									-1358,
									1793,
									-1370,
									1794,
									-1374
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V8K"
						},
						"arcs": [
							[
								[
									1795
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V8L"
						},
						"arcs": [
							[
								[
									1796,
									1797
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V8M"
						},
						"arcs": [
							[
								1798,
								1799,
								1800,
								1801,
								1802,
								-1797
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V8N"
						},
						"arcs": [
							[
								1803,
								1804,
								1805,
								1806,
								1807
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V8P"
						},
						"arcs": [
							[
								-1805,
								1808,
								1809,
								1810
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V8R"
						},
						"arcs": [
							[
								1811,
								1812,
								1813,
								1814,
								-1809,
								-1804
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V8S"
						},
						"arcs": [
							[
								[
									1815,
									1816,
									-1813
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V8T"
						},
						"arcs": [
							[
								-1815,
								1817,
								1818,
								1819,
								1820,
								1821,
								1822,
								-1810
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V8V"
						},
						"arcs": [
							[
								-1814,
								-1817,
								1823,
								1824,
								-1818
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V8W"
						},
						"arcs": [
							[
								-1819,
								-1825,
								1825
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V8X"
						},
						"arcs": [
							[
								-1806,
								-1811,
								-1823,
								1826,
								1827
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V8Y"
						},
						"arcs": [
							[
								1828,
								-1807,
								-1828,
								1829,
								-1800
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V8Z"
						},
						"arcs": [
							[
								-1830,
								-1827,
								-1822,
								1830,
								1831,
								1832,
								1833,
								-1801
							],
							[
								-1251
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9A"
						},
						"arcs": [
							[
								[
									1834,
									1835
								]
							],
							[
								[
									-1821,
									1836,
									-1831
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V9B"
						},
						"arcs": [
							[
								-1833,
								1837,
								-1836,
								1838,
								1839,
								1840,
								-1266,
								1841,
								-1253,
								1842,
								1843
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9C"
						},
						"arcs": [
							[
								[
									1844,
									-1840,
									1845
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V9E"
						},
						"arcs": [
							[
								-1802,
								-1834,
								-1844,
								1846
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9G"
						},
						"arcs": [
							[
								[
									-1848
								]
							],
							[
								[
									1848,
									-1260,
									1849
								]
							],
							[
								[
									-1255,
									1850,
									-1257,
									1851
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9H"
						},
						"arcs": [
							[
								[
									1852
								]
							],
							[
								[
									1853,
									1854,
									1855,
									1856,
									-1291,
									-1241,
									1857,
									-1239,
									1858
								],
								[
									1859
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V9J"
						},
						"arcs": [
							[
								1860,
								-1303,
								1861,
								1862,
								1863,
								1864,
								1865,
								-1300,
								1866,
								-1856
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9K"
						},
						"arcs": [
							[
								[
									1867,
									1868,
									-1285
								]
							],
							[
								[
									1869,
									1870,
									-1287,
									1871,
									1872,
									-1298
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9L"
						},
						"arcs": [
							[
								[
									1873,
									-1264
								]
							],
							[
								[
									1874,
									-1262
								],
								[
									-1254
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "V9M"
						},
						"arcs": [
							[
								1875,
								-1863,
								1876
							],
							[
								-1302
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9N"
						},
						"arcs": [
							[
								[
									-1296,
									1877
								]
							],
							[
								[
									1878,
									-1301,
									-1866,
									1864,
									-1864,
									-1876
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9P"
						},
						"arcs": [
							[
								[
									-1280,
									1879,
									1880,
									1881,
									-1868,
									-1288,
									-1871,
									1882
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9R"
						},
						"arcs": [
							[
								[
									1883,
									1884
								]
							],
							[
								[
									1885,
									1886,
									1887,
									-1881,
									1888
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9S"
						},
						"arcs": [
							[
								[
									-1884,
									1889,
									-1886,
									1890,
									1891
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9T"
						},
						"arcs": [
							[
								[
									1892,
									1893
								]
							],
							[
								[
									1894,
									1895,
									-1891,
									-1889,
									-1880,
									-1279
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9V"
						},
						"arcs": [
							[
								[
									-1894,
									1896
								]
							],
							[
								[
									-1895,
									-1278,
									1897
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9W"
						},
						"arcs": [
							[
								[
									-1860
								]
							],
							[
								[
									-1854,
									1898
								],
								[
									-1853
								]
							],
							[
								[
									-1240,
									-1858
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9X"
						},
						"arcs": [
							[
								[
									-1286,
									-1869,
									-1882,
									-1888,
									1899,
									-1850,
									-1259,
									1900,
									-1872
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9Y"
						},
						"arcs": [
							[
								[
									-1274
								]
							],
							[
								[
									-1299,
									-1873,
									-1901,
									-1273,
									1901,
									-1289,
									-1857,
									-1867
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "V9Z"
						},
						"arcs": [
							[
								[
									-1305,
									-1268,
									-1306,
									-1841,
									-1845,
									1902,
									-1307,
									-1270
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "X0G"
						},
						"arcs": [
							[
								1903
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "X1A"
						},
						"arcs": [
							[
								[
									1904
								]
							],
							[
								[
									-275,
									1905,
									1906
								],
								[
									1907
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "Y0A"
						},
						"arcs": [
							[
								-1067,
								1908,
								1909,
								1910,
								1911,
								1912
							],
							[
								1913
							],
							[
								1914
							],
							[
								1915
							],
							[
								1916
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "Y1A"
						},
						"arcs": [
							[
								1917,
								-1909,
								-1066,
								1918,
								-1911
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A0A"
						},
						"arcs": [
							[
								[
									1919,
									-1920,
									1920
								]
							],
							[
								[
									1921,
									1922
								]
							],
							[
								[
									1923
								],
								[
									1924
								]
							],
							[
								[
									1925,
									1926,
									1927,
									1928,
									1929,
									1930,
									1931
								]
							],
							[
								[
									1932
								]
							],
							[
								[
									1933,
									1934,
									1935,
									1936,
									1937,
									1938
								]
							],
							[
								[
									1939,
									1940
								]
							],
							[
								[
									1941,
									1942,
									1943,
									1944,
									1945
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A0B"
						},
						"arcs": [
							[
								[
									-1925
								]
							],
							[
								[
									-1945,
									1946,
									-1937,
									1947,
									1948,
									1949
								],
								[
									-1924
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A0C"
						},
						"arcs": [
							[
								[
									1950,
									1951,
									1952,
									1953,
									1954,
									1955
								],
								[
									1956
								]
							],
							[
								[
									1957,
									1958,
									1959,
									1960,
									1961,
									1962,
									1963
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A0E"
						},
						"arcs": [
							[
								[
									1964
								]
							],
							[
								[
									1965
								]
							],
							[
								[
									1966
								]
							],
							[
								[
									1967,
									1968,
									-1949,
									1969,
									1970,
									-1962
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A0G"
						},
						"arcs": [
							[
								[
									1971
								]
							],
							[
								[
									1972
								]
							],
							[
								[
									1973
								]
							],
							[
								[
									-1964,
									1974,
									1975,
									1976,
									1977
								],
								[
									1978
								]
							],
							[
								[
									1979
								]
							],
							[
								[
									1980
								]
							],
							[
								[
									1981
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A0H"
						},
						"arcs": [
							[
								[
									1982
								]
							],
							[
								[
									1983
								]
							],
							[
								[
									1984
								]
							],
							[
								[
									-1977,
									1985,
									1986,
									1987,
									-1975,
									-1963,
									-1971,
									1988,
									1989,
									1990,
									1991,
									1992,
									1993,
									1994,
									1995
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A0J"
						},
						"arcs": [
							[
								[
									1996
								]
							],
							[
								[
									1997
								]
							],
							[
								[
									1998
								]
							],
							[
								[
									1999
								]
							],
							[
								[
									2000,
									-1995,
									2001
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A0K"
						},
						"arcs": [
							[
								[
									2002
								]
							],
							[
								[
									2003,
									2004
								]
							],
							[
								[
									2005,
									2006
								]
							],
							[
								[
									2007
								]
							],
							[
								[
									2008
								]
							],
							[
								[
									-2002,
									-1994,
									2009,
									2010
								]
							],
							[
								[
									2011
								]
							],
							[
								[
									2012
								]
							],
							[
								[
									2013
								]
							],
							[
								[
									2014
								]
							],
							[
								[
									2015
								]
							],
							[
								[
									2016
								]
							],
							[
								[
									2017
								]
							],
							[
								[
									2018
								]
							],
							[
								[
									2019,
									2020,
									2021
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A0L"
						},
						"arcs": [
							[
								[
									2022,
									2023
								]
							],
							[
								[
									2024,
									2025,
									2026
								]
							],
							[
								[
									2027,
									2028
								]
							],
							[
								[
									2029,
									2030,
									2031
								]
							],
							[
								[
									2032,
									2033,
									2034,
									2035,
									2036
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A0M"
						},
						"arcs": [
							[
								[
									2037
								]
							],
							[
								[
									-1991,
									2038,
									2039,
									2040,
									2041,
									2042
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A0N"
						},
						"arcs": [
							[
								[
									-2041,
									2043
								]
							],
							[
								[
									2044,
									-2039,
									-1990
								]
							],
							[
								[
									2045,
									-2026,
									2046,
									-2023,
									2047,
									2048,
									-1992,
									-2043,
									2049,
									2050,
									2051
								],
								[
									-2038
								],
								[
									2052
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A0P"
						},
						"arcs": [
							[
								[
									2053
								]
							],
							[
								[
									2054
								]
							],
							[
								[
									2055
								]
							],
							[
								[
									2056
								]
							],
							[
								[
									2057
								]
							],
							[
								[
									2058
								]
							],
							[
								[
									2059
								]
							],
							[
								[
									2060
								]
							],
							[
								[
									2061
								]
							],
							[
								[
									2062
								]
							],
							[
								[
									2063
								]
							],
							[
								[
									2064
								]
							],
							[
								[
									2065
								]
							],
							[
								[
									2066
								]
							],
							[
								[
									2067
								]
							],
							[
								[
									2068
								]
							],
							[
								[
									2069
								]
							],
							[
								[
									2070
								]
							],
							[
								[
									2071
								]
							],
							[
								[
									2072
								]
							],
							[
								[
									2073
								]
							],
							[
								[
									2074
								]
							],
							[
								[
									2075
								]
							],
							[
								[
									2076
								]
							],
							[
								[
									2077
								]
							],
							[
								[
									2078
								]
							],
							[
								[
									2079,
									-2021,
									2080,
									2081,
									2082,
									2083,
									2084
								]
							],
							[
								[
									2085,
									2086
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A0R"
						},
						"arcs": [
							[
								-2082,
								2087
							],
							[
								2088
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A1A"
						},
						"arcs": [
							[
								[
									2089,
									2090,
									2091
								]
							],
							[
								[
									2092,
									2093,
									2094,
									2095,
									2096
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A1B"
						},
						"arcs": [
							[
								2097,
								2098,
								2099,
								2100,
								-2090,
								2101,
								-2095
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A1C"
						},
						"arcs": [
							[
								[
									-1926,
									2102
								]
							],
							[
								[
									2103,
									-1931,
									2104,
									-2098,
									-2094
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A1E"
						},
						"arcs": [
							[
								-2105,
								-1930,
								2105,
								2106,
								2107,
								2108,
								-2099
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A1G"
						},
						"arcs": [
							[
								2109,
								2110,
								-2106,
								-1929
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A1H"
						},
						"arcs": [
							[
								[
									-2111,
									2111,
									2112,
									2113
								]
							],
							[
								[
									2114,
									-2108
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A1K"
						},
						"arcs": [
							[
								[
									2115,
									-2097,
									2116,
									2117,
									-1940
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A1L"
						},
						"arcs": [
							[
								-2091,
								-2101,
								2118,
								-2113,
								2119,
								2120,
								2121,
								2122,
								2123
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A1M"
						},
						"arcs": [
							[
								-2096,
								-2102,
								-2092,
								-2124,
								2124,
								-2117
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A1N"
						},
						"arcs": [
							[
								-2115,
								-2107,
								-2114,
								-2119,
								-2100,
								-2109
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A1S"
						},
						"arcs": [
							[
								[
									-1920,
									2125,
									-1922,
									2126
								]
							],
							[
								[
									2127,
									-1935,
									2128,
									-2120,
									-2112,
									-2110,
									-1928
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A1V"
						},
						"arcs": [
							[
								-1979
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A1W"
						},
						"arcs": [
							[
								2129,
								2130,
								-2122
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A1X"
						},
						"arcs": [
							[
								-2121,
								-2129,
								-1934,
								2131,
								-2130
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A1Y"
						},
						"arcs": [
							[
								[
									2132,
									-1938,
									-1947,
									-1944
								]
							],
							[
								[
									-1942,
									2133
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A2A"
						},
						"arcs": [
							[
								2134,
								-1987
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A2B"
						},
						"arcs": [
							[
								-2135,
								-1986,
								-1976,
								-1988
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A2H"
						},
						"arcs": [
							[
								-2028,
								2135,
								-2048,
								-2024,
								-2047,
								-2025,
								2136,
								-2035,
								2137,
								2138,
								2139,
								2140,
								2141,
								2142,
								2143
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A2N"
						},
						"arcs": [
							[
								[
									2144,
									-2051
								]
							],
							[
								[
									-2053
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "A2V"
						},
						"arcs": [
							[
								-2089
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A5A"
						},
						"arcs": [
							[
								[
									-1957
								]
							],
							[
								[
									-1955,
									2145
								]
							],
							[
								[
									2146,
									-1953
								]
							],
							[
								[
									-1951,
									2147
								]
							],
							[
								[
									2148,
									-1959
								]
							],
							[
								[
									2149,
									-1968,
									-1961
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "A8A"
						},
						"arcs": [
							[
								[
									2150,
									-2139
								]
							],
							[
								[
									2151,
									-2141
								]
							],
							[
								[
									-2137,
									-2027,
									-2046,
									2152,
									-2036
								]
							],
							[
								[
									-2143,
									2153,
									-2031
								]
							],
							[
								[
									-2033,
									2154
								]
							],
							[
								[
									-2030,
									2155,
									-2005,
									2156,
									-2007,
									2157,
									-2010,
									-1993,
									-2049,
									-2136,
									-2029,
									-2144
								],
								[
									-2003
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B0C"
						},
						"arcs": [
							[
								[
									2158,
									2159,
									2160
								]
							],
							[
								[
									2161,
									2162,
									2163,
									2164
								],
								[
									2165
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B0E"
						},
						"arcs": [
							[
								[
									2166
								]
							],
							[
								[
									2167,
									2168
								]
							],
							[
								[
									2169,
									2170
								]
							],
							[
								[
									-2162,
									2171
								]
							],
							[
								[
									-2166
								]
							],
							[
								[
									-2164,
									2172,
									-2159,
									2173,
									2174,
									2175,
									2176,
									2177,
									2178,
									2179,
									2180,
									2181,
									2182
								],
								[
									2183
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B0H"
						},
						"arcs": [
							[
								[
									-2169,
									2184,
									2185,
									2186,
									2187,
									2188,
									2189,
									2190,
									2191,
									2192,
									2193
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B0J"
						},
						"arcs": [
							[
								[
									2194,
									2195,
									2196
								]
							],
							[
								[
									2197,
									2198,
									2199,
									2200,
									2201
								]
							],
							[
								[
									2202,
									2203,
									2204,
									2205
								]
							],
							[
								[
									2206,
									2207,
									2208,
									2209,
									2210,
									2211,
									2212,
									2213,
									2214
								]
							],
							[
								[
									2215,
									2216,
									2217,
									2218,
									-2188
								]
							],
							[
								[
									2219,
									-2186
								]
							],
							[
								[
									2220,
									2221,
									-2190
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B0K"
						},
						"arcs": [
							[
								[
									2222,
									2223
								]
							],
							[
								[
									2224,
									2225,
									2226
								]
							],
							[
								[
									2227,
									-2191,
									-2222,
									2228,
									2229,
									2230,
									2231,
									2232
								],
								[
									2233
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B0L"
						},
						"arcs": [
							[
								[
									2234,
									2235
								]
							],
							[
								[
									2236,
									2237,
									2238
								]
							],
							[
								[
									2239,
									2240
								],
								[
									2241
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B0M"
						},
						"arcs": [
							[
								[
									2242,
									2243,
									-2236,
									2244,
									-2238,
									2245,
									-2231
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B0N"
						},
						"arcs": [
							[
								-2221,
								-2189,
								-2219,
								2246,
								2247,
								2248,
								2249,
								2250,
								2251,
								2252,
								-2207,
								2253,
								2254,
								2255,
								2256,
								2257,
								-2229
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B0P"
						},
						"arcs": [
							[
								[
									2258
								]
							],
							[
								[
									-2254,
									-2215,
									2259,
									2260,
									2261
								]
							],
							[
								[
									2262,
									2263
								]
							],
							[
								[
									2264,
									2265,
									2266,
									2267,
									-2213,
									2268,
									2269,
									2270
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B0R"
						},
						"arcs": [
							[
								[
									-2210,
									2271,
									-2195,
									2272
								]
							],
							[
								[
									2273
								]
							],
							[
								[
									-2212,
									2274,
									2275,
									2276,
									-2269
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B0S"
						},
						"arcs": [
							[
								-2277,
								2277,
								2278,
								2279,
								2280,
								-2270
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B0T"
						},
						"arcs": [
							[
								[
									-2276,
									2281,
									-2201,
									2282,
									2283,
									2284,
									2285,
									-2278
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B0V"
						},
						"arcs": [
							[
								[
									2286
								]
							],
							[
								[
									-2280,
									2287,
									2288
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B0W"
						},
						"arcs": [
							[
								[
									2289
								]
							],
							[
								[
									2290,
									-2284
								]
							],
							[
								[
									2291,
									2292
								]
							],
							[
								[
									2293,
									2294
								]
							],
							[
								[
									-2279,
									-2286,
									2295,
									2296,
									2297,
									2298,
									2299,
									2300,
									2301,
									-2288
								],
								[
									2302
								],
								[
									2303
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B1A"
						},
						"arcs": [
							[
								[
									2304,
									2305
								]
							],
							[
								[
									2306,
									2307,
									2308,
									2309,
									2310
								],
								[
									2311
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B1B"
						},
						"arcs": [
							[
								[
									2312,
									-2305,
									2313,
									2314,
									2315,
									-2307
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B1C"
						},
						"arcs": [
							[
								[
									2316,
									2317
								]
							],
							[
								[
									2318
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B1E"
						},
						"arcs": [
							[
								-2309,
								2319,
								2320,
								2321
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B1G"
						},
						"arcs": [
							[
								[
									-2312
								]
							],
							[
								[
									-2310,
									-2322,
									2322,
									2323
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B1H"
						},
						"arcs": [
							[
								-2323,
								-2321,
								2324,
								2325,
								2326
							],
							[
								2327
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B1J"
						},
						"arcs": [
							[
								[
									2328,
									2329,
									2330,
									-2178,
									2331,
									2332,
									2333,
									2334,
									2335
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B1K"
						},
						"arcs": [
							[
								[
									2336,
									-2317,
									2337,
									2338,
									-2330,
									2339,
									2340,
									2341,
									2342,
									2343,
									-2315
								],
								[
									2344
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B1L"
						},
						"arcs": [
							[
								[
									2345,
									2346,
									-2342,
									2347,
									-2340,
									-2329,
									2348,
									2349
								]
							],
							[
								[
									2350,
									2351
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B1M"
						},
						"arcs": [
							[
								[
									-2345
								]
							],
							[
								[
									-2348,
									-2341
								]
							],
							[
								[
									-2320,
									-2308,
									-2316,
									-2344,
									2352,
									2353,
									-2325
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B1N"
						},
						"arcs": [
							[
								-2354,
								2354,
								2355,
								-2326
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B1P"
						},
						"arcs": [
							[
								[
									2356,
									2357
								]
							],
							[
								[
									2358,
									2359,
									-2333
								]
							],
							[
								[
									-2353,
									-2343,
									-2347,
									2360,
									2361,
									2362,
									-2355
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B1R"
						},
						"arcs": [
							[
								2363,
								-2362,
								2364,
								-2350,
								2365,
								-2352,
								2366
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B1S"
						},
						"arcs": [
							[
								-2346,
								-2365,
								-2361
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B1T"
						},
						"arcs": [
							[
								[
									-2335,
									2367,
									2368,
									2369,
									2370
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B1V"
						},
						"arcs": [
							[
								[
									-2328
								]
							],
							[
								[
									2371,
									2372,
									2373
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B1W"
						},
						"arcs": [
							[
								-2334,
								-2360,
								2374,
								-2357,
								2375,
								-2368
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B1X"
						},
						"arcs": [
							[
								[
									2376,
									2377
								],
								[
									2378
								]
							],
							[
								[
									-2174,
									-2161,
									2379
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B1Y"
						},
						"arcs": [
							[
								[
									2380,
									-2370,
									2381
								]
							],
							[
								[
									-2379
								]
							],
							[
								[
									-2373,
									2382,
									2383
								]
							],
							[
								[
									-2377,
									2384
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B2A"
						},
						"arcs": [
							[
								2385,
								-2367,
								-2351,
								-2366,
								-2349,
								-2336,
								-2371,
								-2381,
								2386,
								-2383,
								-2372
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B2C"
						},
						"arcs": [
							[
								-2176,
								2387,
								-2170,
								2388
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B2E"
						},
						"arcs": [
							[
								2389,
								-2179,
								-2331
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B2G"
						},
						"arcs": [
							[
								[
									-2193,
									2390,
									-2227,
									2391
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B2H"
						},
						"arcs": [
							[
								[
									-2225,
									-2391,
									-2192,
									-2228,
									2392,
									-2223,
									2393
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B2J"
						},
						"arcs": [
							[
								[
									2394,
									-2180,
									-2390,
									-2339
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B2N"
						},
						"arcs": [
							[
								[
									2395,
									-2257,
									2396,
									2397
								]
							],
							[
								[
									-2234
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B2R"
						},
						"arcs": [
							[
								2398,
								2399,
								2400,
								2401,
								2402,
								2403
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B2S"
						},
						"arcs": [
							[
								2404,
								-2248
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B2T"
						},
						"arcs": [
							[
								-2247,
								2405,
								2406,
								-2404,
								2407,
								2408,
								2409,
								2410,
								-2249,
								-2405
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B2V"
						},
						"arcs": [
							[
								2411,
								2412,
								2413,
								-2206,
								2414
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B2W"
						},
						"arcs": [
							[
								-2415,
								-2205,
								2415,
								2416,
								2417,
								-2400,
								2418
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B2X"
						},
						"arcs": [
							[
								-2418,
								2419,
								2420,
								2421,
								-2401
							],
							[
								2422
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B2Y"
						},
						"arcs": [
							[
								[
									2423
								]
							],
							[
								[
									2424,
									2425,
									-2420,
									-2417
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B2Z"
						},
						"arcs": [
							[
								2426,
								-2217,
								2427,
								-2412,
								-2419,
								-2399,
								-2407
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B3A"
						},
						"arcs": [
							[
								[
									2428,
									2429
								]
							],
							[
								[
									2430,
									2431
								]
							],
							[
								[
									2432,
									2433
								]
							],
							[
								[
									-2421,
									-2426,
									2434,
									2435
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B3B"
						},
						"arcs": [
							[
								[
									-2431,
									2436
								]
							],
							[
								[
									-2433,
									2437
								]
							],
							[
								[
									-2402,
									-2422,
									-2436,
									2438,
									2439,
									2440,
									2441
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B3E"
						},
						"arcs": [
							[
								-2427,
								-2406,
								-2218
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B3G"
						},
						"arcs": [
							[
								[
									-2203,
									-2414,
									2442
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B3H"
						},
						"arcs": [
							[
								[
									2443,
									2444,
									2445,
									2446,
									2447
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B3J"
						},
						"arcs": [
							[
								-2448,
								2448,
								2449
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B3K"
						},
						"arcs": [
							[
								[
									2450,
									-2429
								]
							],
							[
								[
									-2449,
									-2447,
									2451,
									2452,
									2453
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B3L"
						},
						"arcs": [
							[
								-2446,
								2454,
								2455,
								-2452
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B3M"
						},
						"arcs": [
							[
								[
									-2453,
									-2456,
									2456,
									2457,
									2458,
									2459,
									2460,
									2461
								]
							],
							[
								[
									-2440,
									2462,
									2463
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B3N"
						},
						"arcs": [
							[
								-2455,
								-2445,
								2464,
								2465,
								2466,
								2467,
								2468,
								-2457
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B3P"
						},
						"arcs": [
							[
								2469,
								2470,
								2471,
								-2466
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B3R"
						},
						"arcs": [
							[
								2472,
								2473,
								-2467,
								-2472
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B3S"
						},
						"arcs": [
							[
								-2469,
								2474,
								-2458
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B3T"
						},
						"arcs": [
							[
								[
									2475,
									2476
								]
							],
							[
								[
									-2475,
									-2468,
									-2474,
									2477,
									2478,
									2479,
									2480,
									-2459
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B3V"
						},
						"arcs": [
							[
								[
									-2476,
									2481
								]
							],
							[
								[
									2482,
									-2478,
									-2473,
									-2471
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B3Z"
						},
						"arcs": [
							[
								[
									2483,
									-2480,
									2484,
									-2208,
									-2253
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B4A"
						},
						"arcs": [
							[
								-2441,
								-2464,
								2485,
								-2461,
								2486,
								2487
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B4B"
						},
						"arcs": [
							[
								[
									-2423
								]
							],
							[
								[
									2488,
									-2487,
									-2460,
									-2481,
									-2484,
									-2252,
									2489
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B4C"
						},
						"arcs": [
							[
								2490,
								-2408,
								-2403,
								-2442,
								-2488,
								-2489,
								2491
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B4E"
						},
						"arcs": [
							[
								-2410,
								2492,
								-2492,
								-2490,
								-2251,
								2493
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B4G"
						},
						"arcs": [
							[
								[
									-2491,
									-2493,
									-2409
								]
							],
							[
								[
									-2494,
									-2250,
									-2411
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B4H"
						},
						"arcs": [
							[
								[
									-2242
								]
							],
							[
								[
									-2241,
									2494,
									-2232,
									-2246,
									-2237,
									2495,
									2496,
									2497,
									2498
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B4N"
						},
						"arcs": [
							[
								2499,
								-2260,
								-2214,
								-2268,
								2500,
								-2266
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B4P"
						},
						"arcs": [
							[
								2501,
								-2261,
								-2500,
								-2265,
								2502,
								-2263
							],
							[
								-2259
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "B4R"
						},
						"arcs": [
							[
								-2267,
								-2501
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B4V"
						},
						"arcs": [
							[
								[
									-2199,
									2503
								]
							],
							[
								[
									-2211,
									-2273,
									-2197,
									2504,
									-2202,
									-2282,
									-2275
								],
								[
									-2274
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B5A"
						},
						"arcs": [
							[
								[
									-2304
								]
							],
							[
								[
									2505,
									-2292,
									2506,
									-2295,
									2507,
									-2297
								]
							],
							[
								[
									2508,
									-2299
								]
							],
							[
								[
									-2303
								]
							],
							[
								[
									-2301,
									2509
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B6L"
						},
						"arcs": [
							[
								[
									-2398
								]
							],
							[
								[
									-2397,
									-2256,
									2510,
									-2243,
									-2230,
									-2258,
									-2396
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "B9A"
						},
						"arcs": [
							[
								[
									-2184
								]
							],
							[
								[
									2511,
									-2182
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "C0A"
						},
						"arcs": [
							[
								[
									2512,
									2513,
									2514
								]
							],
							[
								[
									2515,
									2516
								]
							],
							[
								[
									2517,
									2518
								]
							],
							[
								[
									2519,
									2520
								]
							],
							[
								[
									2521,
									2522,
									2523,
									2524
								]
							],
							[
								[
									2525,
									2526,
									2527,
									2528,
									2529,
									2530
								]
							],
							[
								[
									2531,
									2532,
									2533,
									2534,
									2535
								],
								[
									2536
								],
								[
									2537
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "C0B"
						},
						"arcs": [
							[
								[
									2538
								]
							],
							[
								[
									-2538
								]
							],
							[
								[
									-2537
								]
							],
							[
								[
									-2535,
									2539,
									2540,
									2541
								],
								[
									2542
								]
							],
							[
								[
									2543,
									2544
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "C1A"
						},
						"arcs": [
							[
								[
									-2531,
									2545,
									-2513
								]
							],
							[
								[
									2546
								]
							],
							[
								[
									-2515,
									2547,
									2548,
									2549,
									-2526
								]
							],
							[
								[
									2550,
									2551,
									2552,
									-2533,
									2553,
									-2528
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "C1B"
						},
						"arcs": [
							[
								2554,
								-2552,
								2555,
								-2549
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "C1C"
						},
						"arcs": [
							[
								-2527,
								-2550,
								-2556,
								-2551
							],
							[
								-2547
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "C1E"
						},
						"arcs": [
							[
								[
									-2520,
									2556,
									-2518,
									2557,
									-2529,
									-2554,
									-2532,
									2558,
									-2517,
									2559,
									-2524,
									2560
								]
							],
							[
								[
									-2522,
									2561
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "C1N"
						},
						"arcs": [
							[
								[
									-2543
								]
							],
							[
								[
									-2541,
									2562,
									-2544,
									2563
								],
								[
									-2539
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E1A"
						},
						"arcs": [
							[
								2564,
								2565,
								2566,
								2567,
								2568,
								2569
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E1B"
						},
						"arcs": [
							[
								-2567,
								2570,
								2571,
								2572
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E1C"
						},
						"arcs": [
							[
								-2573,
								2573,
								2574,
								-2568
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E1E"
						},
						"arcs": [
							[
								-2572,
								2575,
								2576,
								-2574
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E1G"
						},
						"arcs": [
							[
								[
									-2569,
									-2575,
									-2577,
									2577,
									2578,
									2579,
									2580,
									2581
								]
							],
							[
								[
									2582,
									2583,
									2584
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E1H"
						},
						"arcs": [
							[
								2585,
								2586,
								-2570,
								-2582,
								2587,
								2588
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E1J"
						},
						"arcs": [
							[
								2589,
								2590,
								2591,
								-2578,
								-2576,
								-2571,
								-2566
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E1N"
						},
						"arcs": [
							[
								[
									2592
								]
							],
							[
								[
									2593
								]
							],
							[
								[
									2594,
									2595
								]
							],
							[
								[
									2596,
									2597,
									2598,
									2599,
									2600,
									2601,
									2602,
									2603,
									2604,
									2605,
									2606,
									2607,
									2608
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E1V"
						},
						"arcs": [
							[
								[
									2609,
									2610,
									-2603,
									2611,
									2612,
									2613,
									2614
								],
								[
									-2594
								],
								[
									-2593
								]
							],
							[
								[
									2615,
									2616,
									2617
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E1W"
						},
						"arcs": [
							[
								[
									2618,
									2619
								]
							],
							[
								[
									2620,
									2621,
									2622,
									2623,
									2624,
									2625,
									2626,
									2627
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E1X"
						},
						"arcs": [
							[
								[
									2628,
									2629,
									2630,
									2631,
									2632,
									2633
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E2A"
						},
						"arcs": [
							[
								[
									2634,
									2635,
									2636,
									-2613,
									2637,
									-2618,
									2638,
									2639,
									2640
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E2E"
						},
						"arcs": [
							[
								2641,
								2642,
								2643,
								2644
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E2G"
						},
						"arcs": [
							[
								2645,
								-2645,
								2646,
								2647
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E2H"
						},
						"arcs": [
							[
								2648,
								2649,
								2650,
								2651,
								2652,
								-2643
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E2J"
						},
						"arcs": [
							[
								[
									2653,
									2654,
									2655,
									2656
								]
							],
							[
								[
									2657,
									2658,
									2659,
									2660,
									2661,
									-2651,
									2662
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E2K"
						},
						"arcs": [
							[
								[
									-2662,
									2663,
									2664,
									2665,
									-2652
								]
							],
							[
								[
									2666,
									2667
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E2L"
						},
						"arcs": [
							[
								2668,
								2669,
								2670,
								-2664,
								-2661
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E2M"
						},
						"arcs": [
							[
								[
									2671,
									-2669,
									-2660
								]
							],
							[
								[
									-2671,
									2672,
									2673,
									2674,
									2675,
									-2665
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E2N"
						},
						"arcs": [
							[
								-2667,
								2676,
								-2654,
								-2663,
								-2650,
								2677
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E2P"
						},
						"arcs": [
							[
								-2657,
								2678,
								-2658
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E2S"
						},
						"arcs": [
							[
								[
									2679,
									2680
								]
							],
							[
								[
									2681,
									2682,
									-2655,
									-2677,
									-2668,
									-2678,
									-2649,
									-2642,
									-2646,
									2683
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E2V"
						},
						"arcs": [
							[
								2684,
								2685,
								2686,
								2687,
								2688
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E3A"
						},
						"arcs": [
							[
								[
									2689,
									2690
								]
							],
							[
								[
									2691,
									-2689,
									2692,
									2693,
									2694,
									2695,
									2696,
									2697
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E3B"
						},
						"arcs": [
							[
								-2688,
								2698,
								2699,
								2700,
								2701,
								2702,
								2703,
								-2693
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E3C"
						},
						"arcs": [
							[
								[
									2704,
									-2702
								]
							],
							[
								[
									-2694,
									-2704,
									2705,
									2706
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E3E"
						},
						"arcs": [
							[
								-2706,
								-2703,
								-2705,
								-2701,
								2707,
								2708,
								2709
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E3G"
						},
						"arcs": [
							[
								2710,
								-2690,
								2711,
								-2695,
								-2707,
								-2710,
								2712,
								2713
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E3L"
						},
						"arcs": [
							[
								[
									2714,
									2715,
									2716,
									2717,
									2718
								],
								[
									2719
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E3N"
						},
						"arcs": [
							[
								2720,
								2721,
								2722,
								2723,
								2724,
								2725,
								2726,
								2727,
								2728
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E3V"
						},
						"arcs": [
							[
								2729,
								2730,
								2731,
								2732
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E3Y"
						},
						"arcs": [
							[
								2733,
								2734,
								2735,
								2736,
								2737
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E3Z"
						},
						"arcs": [
							[
								2738,
								2739,
								2740,
								-2735
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E4A"
						},
						"arcs": [
							[
								2741,
								2742,
								2743,
								2744,
								2745
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E4B"
						},
						"arcs": [
							[
								-2745,
								2746,
								2747,
								-2698,
								2748
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E4C"
						},
						"arcs": [
							[
								2749,
								2750,
								2751,
								2752,
								-2747,
								-2744,
								2753
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E4E"
						},
						"arcs": [
							[
								[
									2754,
									2755,
									2756,
									2757,
									2758,
									2759,
									2760,
									2761
								]
							],
							[
								[
									2762,
									2763
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E4G"
						},
						"arcs": [
							[
								-2763,
								2764,
								-2761,
								2765,
								-2750,
								2766
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E4H"
						},
						"arcs": [
							[
								[
									2767,
									2768,
									-2755,
									2769,
									-2591,
									2770
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E4J"
						},
						"arcs": [
							[
								-2579,
								-2592,
								2771,
								2772
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E4K"
						},
						"arcs": [
							[
								2773,
								2774,
								-2771,
								-2590,
								-2565,
								-2587,
								2775
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E4L"
						},
						"arcs": [
							[
								2776,
								2777,
								-2497,
								2778,
								-2774,
								2779
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E4M"
						},
						"arcs": [
							[
								[
									-2498,
									-2778,
									2780,
									2781
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E4N"
						},
						"arcs": [
							[
								-2781,
								-2777,
								2782,
								2783
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E4P"
						},
						"arcs": [
							[
								[
									-2783,
									-2780,
									-2776,
									-2586,
									2784,
									2785
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E4R"
						},
						"arcs": [
							[
								[
									2786,
									-2785,
									-2589,
									2787,
									2788
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E4S"
						},
						"arcs": [
							[
								2789,
								-2789,
								2790,
								-2584,
								2791,
								2792
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E4T"
						},
						"arcs": [
							[
								2793,
								-2792,
								-2583,
								2794,
								-2580,
								-2773,
								2795,
								-2742,
								2796,
								2797,
								2798
							],
							[
								2799
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E4V"
						},
						"arcs": [
							[
								-2788,
								-2588,
								-2581,
								-2795,
								-2585,
								-2791
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E4W"
						},
						"arcs": [
							[
								[
									-2800
								]
							],
							[
								[
									2800,
									-2793,
									-2794,
									2801,
									2802
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E4X"
						},
						"arcs": [
							[
								[
									2803,
									-2803,
									2804,
									-2600,
									2805
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E4Y"
						},
						"arcs": [
							[
								-2805,
								-2802,
								-2799,
								2806,
								2807,
								-2601
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E4Z"
						},
						"arcs": [
							[
								-2772,
								-2770,
								-2762,
								-2765,
								-2764,
								-2767,
								-2754,
								-2743,
								-2796
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E5A"
						},
						"arcs": [
							[
								[
									-2720
								]
							],
							[
								[
									2808,
									2809,
									2810,
									2811,
									-2719,
									2812
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E5B"
						},
						"arcs": [
							[
								[
									2813,
									-2717
								]
							],
							[
								[
									2814,
									2815,
									-2715,
									-2812
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E5C"
						},
						"arcs": [
							[
								[
									2816,
									2817,
									2818,
									2819,
									2820,
									-2815,
									-2811,
									2821
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E5E"
						},
						"arcs": [
							[
								[
									2822
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E5G"
						},
						"arcs": [
							[
								[
									2823
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E5H"
						},
						"arcs": [
							[
								[
									2824,
									2825,
									2826,
									2827,
									-2820,
									2828,
									-2818
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E5J"
						},
						"arcs": [
							[
								[
									-2827,
									2829
								]
							],
							[
								[
									2830,
									-2674,
									2831,
									-2825,
									-2817,
									2832
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E5K"
						},
						"arcs": [
							[
								2833,
								2834,
								-2675,
								-2831,
								2835,
								-2686
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E5L"
						},
						"arcs": [
							[
								-2687,
								-2836,
								-2833,
								-2822,
								2836,
								-2699
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E5M"
						},
						"arcs": [
							[
								-2753,
								2837,
								2838,
								2839,
								-2834,
								-2685,
								-2692,
								-2748
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E5N"
						},
						"arcs": [
							[
								2840,
								-2757,
								2841,
								-2684,
								-2648,
								2842,
								-2839,
								2843
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E5P"
						},
						"arcs": [
							[
								-2760,
								2844,
								-2751,
								-2766
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E5R"
						},
						"arcs": [
							[
								2845,
								-2681,
								2846,
								-2682,
								-2842,
								-2756,
								-2769
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E5S"
						},
						"arcs": [
							[
								-2647,
								-2644,
								-2653,
								-2666,
								-2676,
								-2835,
								-2840,
								-2843
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E5T"
						},
						"arcs": [
							[
								[
									-2758,
									-2841
								]
							],
							[
								[
									-2844,
									-2838,
									-2752,
									-2845,
									-2759
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E5V"
						},
						"arcs": [
							[
								[
									2847
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E6A"
						},
						"arcs": [
							[
								[
									2848,
									2849
								]
							],
							[
								[
									2850,
									2851,
									2852,
									2853,
									2854,
									2855,
									2856,
									2857
								],
								[
									2858
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E6B"
						},
						"arcs": [
							[
								2859,
								-2852,
								2860,
								-2714,
								2861,
								2862,
								2863,
								2864,
								-2854
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E6C"
						},
						"arcs": [
							[
								[
									2865,
									-2696,
									-2712,
									-2691,
									-2711,
									-2861,
									-2851,
									-2850
								]
							],
							[
								[
									-2860,
									-2853
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E6E"
						},
						"arcs": [
							[
								2866,
								2867,
								2868,
								2869,
								-2863
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E6G"
						},
						"arcs": [
							[
								2870,
								2871,
								2872,
								2873,
								2874,
								2875,
								-2868
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E6H"
						},
						"arcs": [
							[
								2876,
								-2874,
								2877,
								2878,
								2879
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E6J"
						},
						"arcs": [
							[
								2880,
								-2809,
								2881,
								-2878,
								-2873
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E6K"
						},
						"arcs": [
							[
								-2708,
								-2700,
								-2837,
								-2810,
								-2881,
								-2872,
								2882
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E6L"
						},
						"arcs": [
							[
								-2713,
								-2709,
								-2883,
								-2871,
								-2867,
								-2862
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E7A"
						},
						"arcs": [
							[
								-2732,
								2883,
								2884,
								2885
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E7B"
						},
						"arcs": [
							[
								-2733,
								-2886,
								2886,
								2887
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E7C"
						},
						"arcs": [
							[
								2888,
								2889,
								2890,
								-2730,
								-2888,
								2891,
								2892
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E7E"
						},
						"arcs": [
							[
								-2737,
								2893,
								-2890,
								2894
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E7G"
						},
						"arcs": [
							[
								2895,
								-2856,
								2896,
								2897,
								-2739,
								-2734,
								2898
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E7H"
						},
						"arcs": [
							[
								2899,
								2900,
								2901,
								2902,
								2903,
								-2740,
								-2898
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E7J"
						},
						"arcs": [
							[
								-2901,
								2904
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E7K"
						},
						"arcs": [
							[
								2905,
								2906,
								2907,
								2908,
								-2903
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E7L"
						},
						"arcs": [
							[
								-2865,
								2909,
								-2906,
								-2902,
								-2905,
								-2900,
								-2897,
								-2855
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E7M"
						},
						"arcs": [
							[
								2910,
								-2875,
								-2877,
								2911,
								2912,
								-2908,
								2913
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E7N"
						},
						"arcs": [
							[
								[
									-2880,
									2914,
									-2912
								]
							],
							[
								[
									-2869,
									-2876,
									-2911,
									2915
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E7P"
						},
						"arcs": [
							[
								-2864,
								-2870,
								-2916,
								-2914,
								-2907,
								-2910
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E8A"
						},
						"arcs": [
							[
								2916,
								2917,
								-2723,
								2918,
								-2899,
								-2738,
								-2895,
								-2889,
								2919
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E8B"
						},
						"arcs": [
							[
								-2918,
								2920,
								-2724
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E8C"
						},
						"arcs": [
							[
								2921,
								2922,
								2923,
								2924,
								-2729,
								2925
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E8E"
						},
						"arcs": [
							[
								[
									2926,
									-2727
								]
							],
							[
								[
									2927,
									-2923
								]
							],
							[
								[
									2928,
									2929,
									2930,
									-2639,
									-2617,
									2931,
									-2721,
									-2925
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E8G"
						},
						"arcs": [
							[
								[
									2932,
									2933,
									-2930,
									2934
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E8J"
						},
						"arcs": [
							[
								2935,
								-2933,
								2936
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E8K"
						},
						"arcs": [
							[
								2937,
								-2640,
								-2931,
								-2934,
								-2936
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E8L"
						},
						"arcs": [
							[
								2938,
								2939,
								-2631,
								2940,
								2941,
								-2614,
								-2637
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E8M"
						},
						"arcs": [
							[
								-2940,
								2942,
								-2632
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E8N"
						},
						"arcs": [
							[
								[
									-2627,
									2943,
									-2635,
									2944
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E8P"
						},
						"arcs": [
							[
								[
									-2623,
									2945
								]
							],
							[
								[
									2946,
									2947,
									-2634,
									2948,
									-2625,
									2949,
									-2619,
									2950
								]
							],
							[
								[
									2951,
									-2621
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E8R"
						},
						"arcs": [
							[
								-2949,
								-2633,
								-2943,
								-2939,
								-2636,
								-2944,
								-2626
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E8S"
						},
						"arcs": [
							[
								[
									-2947,
									2952
								]
							],
							[
								[
									2953,
									2954
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E8T"
						},
						"arcs": [
							[
								[
									-2955,
									2955
								]
							],
							[
								[
									2956
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E9A"
						},
						"arcs": [
							[
								[
									2957,
									-2608
								]
							],
							[
								[
									2958,
									-2606
								]
							],
							[
								[
									2959,
									-2597
								]
							],
							[
								[
									-2806,
									-2599,
									2960,
									-2595,
									2961
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E9B"
						},
						"arcs": [
							[
								-2807,
								-2798,
								2962,
								2963
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E9C"
						},
						"arcs": [
							[
								[
									-2859
								]
							],
							[
								[
									-2797,
									-2746,
									-2749,
									-2697,
									-2866,
									-2849,
									-2858,
									2964,
									-2963
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "E9E"
						},
						"arcs": [
							[
								-2616,
								-2638,
								-2612,
								-2602,
								-2808,
								-2964,
								-2965,
								-2857,
								-2896,
								-2919,
								-2722,
								-2932
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E9G"
						},
						"arcs": [
							[
								[
									-2604,
									-2611,
									2965
								]
							],
							[
								[
									2966,
									2967,
									2968,
									-2615,
									-2942,
									2969
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "E9H"
						},
						"arcs": [
							[
								[
									-2968,
									2970
								]
							],
							[
								[
									2971,
									-2970,
									-2941,
									-2630
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G0A"
						},
						"arcs": [
							[
								[
									2972,
									2973
								]
							],
							[
								[
									2974,
									2975,
									2976,
									2977
								]
							],
							[
								[
									2978,
									2979
								]
							],
							[
								[
									2980
								]
							],
							[
								[
									2981,
									2982,
									2983,
									2984,
									2985,
									2986
								]
							],
							[
								[
									2987,
									2988,
									2989,
									2990,
									2991,
									2992
								]
							],
							[
								[
									2993
								]
							],
							[
								[
									2994,
									2995,
									2996,
									2997,
									2998,
									2999,
									3000,
									3001,
									3002,
									3003,
									3004,
									3005,
									3006,
									3007,
									3008,
									3009
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G0C"
						},
						"arcs": [
							[
								[
									-2926,
									-2728,
									-2927,
									-2726,
									3010,
									3011,
									3012,
									3013
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G0E"
						},
						"arcs": [
							[
								3014,
								-3012,
								3015,
								3016,
								3017
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G0G"
						},
						"arcs": [
							[
								[
									3018
								]
							],
							[
								[
									3019,
									3020,
									3021,
									3022,
									3023,
									3024
								]
							],
							[
								[
									3025
								]
							],
							[
								[
									3026
								]
							],
							[
								[
									3027
								]
							],
							[
								[
									3028,
									3029,
									3030,
									3031,
									3032,
									-2083,
									-2088,
									-2081,
									-2020,
									3033
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G0H"
						},
						"arcs": [
							[
								[
									3034,
									3035,
									3036
								]
							],
							[
								[
									3037,
									3038,
									3039
								]
							],
							[
								[
									3040,
									3041
								]
							],
							[
								[
									3042,
									3043,
									3044,
									3045
								]
							],
							[
								[
									3046,
									3047
								]
							],
							[
								[
									3048,
									-3023,
									3049
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G0J"
						},
						"arcs": [
							[
								[
									3050,
									-3016,
									-3011,
									-2725,
									-2921,
									-2917,
									3051,
									3052,
									3053,
									3054,
									3055,
									3056
								],
								[
									3057
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G0K"
						},
						"arcs": [
							[
								3058,
								-3052,
								-2920,
								-2893,
								3059,
								3060,
								3061,
								3062,
								3063,
								3064,
								-3054
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G0L"
						},
						"arcs": [
							[
								[
									3065,
									3066,
									3067,
									3068,
									3069,
									3070,
									-3061,
									3071,
									-2885,
									3072,
									3073
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G0M"
						},
						"arcs": [
							[
								3074,
								3075,
								3076,
								3077,
								3078,
								3079,
								3080,
								3081,
								3082,
								3083
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G0N"
						},
						"arcs": [
							[
								[
									3084,
									3085
								]
							],
							[
								[
									3086,
									-3077,
									3087,
									3088,
									3089,
									3090,
									3091,
									3092,
									3093,
									3094,
									3095,
									3096,
									3097
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G0P"
						},
						"arcs": [
							[
								[
									3098,
									3099,
									3100
								]
							],
							[
								[
									-3089,
									3101,
									3102,
									3103,
									3104,
									3105,
									3106,
									3107,
									3108,
									3109
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G0R"
						},
						"arcs": [
							[
								[
									3110,
									-3001
								]
							],
							[
								[
									-3074,
									3111,
									-3084,
									3112,
									3113,
									3114,
									3115,
									3116,
									3117,
									3118,
									-3066,
									3119
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G0S"
						},
						"arcs": [
							[
								-3113,
								-3083,
								3120,
								-3098,
								3121,
								-3096,
								3122,
								-3090,
								-3110,
								3123,
								3124,
								3125,
								3126,
								-2973,
								3127,
								3128,
								3129,
								3130
							],
							[
								3131
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G0T"
						},
						"arcs": [
							[
								[
									3132,
									-2997,
									3133
								]
							],
							[
								[
									3134,
									3135,
									-2995,
									3136
								]
							],
							[
								[
									3137,
									-3039,
									3138,
									3139,
									3140,
									3141
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G0V"
						},
						"arcs": [
							[
								[
									3142,
									3143
								]
							],
							[
								[
									3144,
									3145,
									3146
								]
							],
							[
								[
									-3141,
									3147,
									3148,
									-3137,
									-3010,
									3149,
									3150,
									3151,
									3152,
									3153,
									3154,
									3155,
									3156,
									3157
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G0W"
						},
						"arcs": [
							[
								[
									3158,
									-3008,
									3159,
									3160
								]
							],
							[
								[
									3161
								]
							],
							[
								[
									3162
								]
							],
							[
								[
									3163
								]
							],
							[
								[
									3164,
									3165
								]
							],
							[
								[
									3166,
									3167
								]
							],
							[
								[
									3168,
									-3146,
									3169,
									3170,
									3171,
									3172,
									3173,
									3174,
									3175,
									3176,
									3177,
									3178,
									3179,
									3180,
									3181,
									3182,
									3183,
									3184,
									3185,
									-3156
								],
								[
									3186,
									3187
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G0X"
						},
						"arcs": [
							[
								[
									3188
								]
							],
							[
								[
									3189,
									3190,
									3191,
									-3126
								]
							],
							[
								[
									-2985,
									3192,
									3193,
									3194,
									3195,
									3196,
									3197,
									3198,
									3199,
									3200,
									3201
								],
								[
									3202,
									3203,
									3204,
									3205,
									3206
								]
							],
							[
								[
									3207
								]
							],
							[
								[
									3208,
									-3178,
									3209,
									3210,
									3211,
									3212,
									3213,
									3214
								],
								[
									-3162
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G0Y"
						},
						"arcs": [
							[
								-3076,
								3215,
								3216,
								3217,
								3218,
								-3102,
								-3088
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G0Z"
						},
						"arcs": [
							[
								3219,
								3220,
								-3101,
								3221,
								3222,
								3223,
								-3190,
								-3125
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1B"
						},
						"arcs": [
							[
								3224,
								3225,
								3226,
								3227,
								-3004
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1C"
						},
						"arcs": [
							[
								3228,
								3229,
								3230,
								3231,
								-3225,
								-3003
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G1E"
						},
						"arcs": [
							[
								[
									3232,
									3233,
									3234
								]
							],
							[
								[
									3235,
									3236,
									-3230
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1G"
						},
						"arcs": [
							[
								3237,
								3238,
								3239,
								3240,
								3241
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1H"
						},
						"arcs": [
							[
								-3231,
								3242,
								3243,
								3244,
								3245,
								-3239,
								3246
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1J"
						},
						"arcs": [
							[
								3247,
								-3234,
								3248,
								3249,
								-3243,
								-3237
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1K"
						},
						"arcs": [
							[
								-3233,
								3250,
								3251,
								3252,
								3253,
								3254,
								3255,
								3256,
								3257,
								-3249
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1L"
						},
						"arcs": [
							[
								-3258,
								3258,
								3259,
								-3244,
								-3250
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1M"
						},
						"arcs": [
							[
								-3257,
								3260,
								3261,
								3262,
								3263,
								-3259
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1N"
						},
						"arcs": [
							[
								-3256,
								3264,
								3265,
								3266,
								3267,
								-3261
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1P"
						},
						"arcs": [
							[
								-3262,
								-3268,
								3268,
								3269,
								3270,
								3271,
								3272
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G1R"
						},
						"arcs": [
							[
								[
									3273
								]
							],
							[
								[
									3274,
									-3265,
									-3255
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1S"
						},
						"arcs": [
							[
								-3254,
								3275,
								3276,
								-3266,
								-3275
							],
							[
								-3274
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1T"
						},
						"arcs": [
							[
								3277,
								3278,
								-3276,
								-3253
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1V"
						},
						"arcs": [
							[
								-3279,
								3279,
								3280,
								-3269,
								-3267,
								-3277
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1W"
						},
						"arcs": [
							[
								-3252,
								3281,
								3282,
								3283,
								-3280,
								-3278
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1X"
						},
						"arcs": [
							[
								-3270,
								-3281,
								-3284,
								3284,
								3285,
								3286,
								3287
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G1Y"
						},
						"arcs": [
							[
								-3283,
								3288,
								3289,
								-3285
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G2A"
						},
						"arcs": [
							[
								3290,
								3291,
								3292,
								3293,
								3294,
								3295,
								-2989
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G2B"
						},
						"arcs": [
							[
								[
									3296,
									3297,
									3298,
									3299,
									-3294
								]
							],
							[
								[
									3300
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G2C"
						},
						"arcs": [
							[
								-3272,
								3301,
								-3298,
								3302
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G2E"
						},
						"arcs": [
							[
								-3302,
								-3271,
								-3288,
								3303,
								3304,
								-3299
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G2G"
						},
						"arcs": [
							[
								-3304,
								-3287,
								3305,
								3306,
								3307,
								3308,
								3309
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G2J"
						},
						"arcs": [
							[
								-3245,
								-3260,
								-3264,
								3310
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G2K"
						},
						"arcs": [
							[
								-3240,
								-3246,
								-3311,
								-3263,
								-3273,
								-3303,
								-3297,
								-3293,
								3311,
								3312
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G2L"
						},
						"arcs": [
							[
								-3232,
								-3247,
								-3238,
								3313,
								-3226
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G2M"
						},
						"arcs": [
							[
								-3227,
								-3314,
								-3242,
								3314,
								3315,
								3316
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G2N"
						},
						"arcs": [
							[
								-3241,
								-3313,
								3317,
								3318,
								3319,
								-3315
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G3A"
						},
						"arcs": [
							[
								[
									-3307
								]
							],
							[
								[
									-3306,
									-3286,
									-3290,
									3320,
									-2978,
									3321,
									3322,
									-3308
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G3B"
						},
						"arcs": [
							[
								-3228,
								-3317,
								3323,
								-3005
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G3C"
						},
						"arcs": [
							[
								-3006,
								-3324,
								-3316,
								-3320,
								3324,
								-2993,
								3325,
								3326
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G3E"
						},
						"arcs": [
							[
								-3312,
								-3292,
								3327,
								-3318
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G3G"
						},
						"arcs": [
							[
								-3319,
								-3328,
								-3291,
								-2988,
								-3325
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G3H"
						},
						"arcs": [
							[
								-3322,
								-2977,
								3328,
								-2982,
								3329,
								3330
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G3J"
						},
						"arcs": [
							[
								3331,
								3332,
								-2990,
								-3296
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G3K"
						},
						"arcs": [
							[
								-3300,
								-3305,
								-3310,
								3333,
								-3332,
								-3295
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G3L"
						},
						"arcs": [
							[
								-3326,
								-2992,
								3334,
								-2979,
								3335,
								-3330,
								-2987,
								3336,
								-3211,
								3337
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G3M"
						},
						"arcs": [
							[
								3338,
								-2983,
								-3329,
								-2976
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G3N"
						},
						"arcs": [
							[
								-3333,
								-3334,
								-3309,
								-3323,
								-3331,
								-3336,
								-2980,
								-3335,
								-2991
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G3Z"
						},
						"arcs": [
							[
								[
									3339,
									-2999
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G4A"
						},
						"arcs": [
							[
								-3135,
								-3149,
								3340
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G4R"
						},
						"arcs": [
							[
								[
									-3021,
									3341
								]
							],
							[
								[
									3342,
									3343,
									3344,
									3345,
									3346,
									3347,
									3348,
									3349,
									3350,
									-3025,
									3351,
									-3045,
									3352,
									-3030
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G4S"
						},
						"arcs": [
							[
								[
									3353,
									-3344
								]
							],
							[
								[
									3354,
									-3346
								]
							],
							[
								[
									-3350,
									3355
								]
							],
							[
								[
									3356,
									-3348
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G4T"
						},
						"arcs": [
							[
								[
									3357
								]
							],
							[
								[
									3358
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G4V"
						},
						"arcs": [
							[
								-3051,
								3359,
								-3017
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G4W"
						},
						"arcs": [
							[
								3360,
								-3056
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G4X"
						},
						"arcs": [
							[
								-3013,
								-3015,
								3361
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G4Z"
						},
						"arcs": [
							[
								[
									3362
								]
							],
							[
								[
									-3353,
									-3044,
									3363,
									-3042,
									3364,
									-3037,
									3365,
									-3142,
									-3158,
									-3031
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G5A"
						},
						"arcs": [
							[
								3366,
								-3134,
								-2996,
								-3136,
								-3341,
								-3148,
								-3140
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G5B"
						},
						"arcs": [
							[
								[
									-3024,
									-3049,
									3367,
									-3048,
									3368,
									-3046,
									-3352
								],
								[
									-3301
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G5C"
						},
						"arcs": [
							[
								-3036,
								3369,
								-3040,
								-3138,
								-3366
							],
							[
								-3363
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G5H"
						},
						"arcs": [
							[
								-3059,
								-3053
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G5J"
						},
						"arcs": [
							[
								-3058
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G5L"
						},
						"arcs": [
							[
								[
									-3063,
									3370,
									3371,
									3372,
									-3070,
									3373,
									3374
								],
								[
									3375
								],
								[
									3376
								],
								[
									3377
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G5M"
						},
						"arcs": [
							[
								[
									3378,
									-3372
								]
							],
							[
								[
									-3375,
									3379,
									-3064
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G5N"
						},
						"arcs": [
							[
								[
									-3378
								]
							],
							[
								[
									-3377
								]
							],
							[
								[
									-3376
								]
							],
							[
								[
									-3071,
									-3373,
									-3379,
									-3371,
									-3062
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G5R"
						},
						"arcs": [
							[
								3380,
								-3068
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G5T"
						},
						"arcs": [
							[
								-2892,
								-2887,
								-3072,
								-3060
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G5V"
						},
						"arcs": [
							[
								3381,
								-3118
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G5X"
						},
						"arcs": [
							[
								-3082,
								3382,
								-3078,
								-3087,
								-3121
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G5Y"
						},
						"arcs": [
							[
								[
									3383
								]
							],
							[
								[
									3384
								]
							],
							[
								[
									3385,
									-3080
								],
								[
									3386,
									3387
								],
								[
									3388
								],
								[
									3389
								],
								[
									3390
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G5Z"
						},
						"arcs": [
							[
								[
									-3391
								],
								[
									-3385
								],
								[
									-3384
								]
							],
							[
								[
									-3079,
									-3383,
									-3081,
									-3386
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G6A"
						},
						"arcs": [
							[
								[
									-3390
								]
							],
							[
								[
									-3389
								]
							],
							[
								[
									-3388
								]
							],
							[
								[
									-3387
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G6B"
						},
						"arcs": [
							[
								3391,
								-3217
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G6C"
						},
						"arcs": [
							[
								3392,
								3393,
								-3115
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G6E"
						},
						"arcs": [
							[
								-3097,
								-3122
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G6G"
						},
						"arcs": [
							[
								-3095,
								3394,
								-3093,
								3395,
								-3086,
								3396,
								-3091,
								-3123
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G6H"
						},
						"arcs": [
							[
								[
									-3396,
									-3092,
									-3397,
									-3085
								]
							],
							[
								[
									-3395,
									-3094
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G6J"
						},
						"arcs": [
							[
								-3130,
								3397,
								3398,
								3399
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G6K"
						},
						"arcs": [
							[
								3400,
								3401,
								-3399,
								3402
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G6L"
						},
						"arcs": [
							[
								-3109,
								3403,
								-3220,
								-3124
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G6P"
						},
						"arcs": [
							[
								[
									3404,
									3405,
									3406,
									3407
								]
							],
							[
								[
									3408,
									3409,
									-3107,
									3410
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G6R"
						},
						"arcs": [
							[
								3411,
								-3105,
								3412,
								3413,
								-3406
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G6S"
						},
						"arcs": [
							[
								[
									-3411,
									-3106,
									-3412,
									-3405
								]
							],
							[
								[
									-3408,
									3414,
									-3409
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G6T"
						},
						"arcs": [
							[
								-3108,
								-3410,
								-3415,
								-3407,
								-3414,
								3415,
								-3099,
								-3221,
								-3404
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G6V"
						},
						"arcs": [
							[
								-3116,
								-3394,
								3416,
								3417,
								3418
							],
							[
								3419
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G6W"
						},
						"arcs": [
							[
								[
									-3132
								]
							],
							[
								[
									-3420
								]
							],
							[
								[
									3420,
									3421,
									3422,
									3423,
									-3418
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G6X"
						},
						"arcs": [
							[
								-3401,
								3424,
								-3422,
								3425
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G6Z"
						},
						"arcs": [
							[
								-3393,
								-3114,
								-3131,
								-3400,
								-3402,
								-3426,
								-3421,
								-3417
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G7A"
						},
						"arcs": [
							[
								-3423,
								-3425,
								-3403,
								-3398,
								-3129,
								3426
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G7B"
						},
						"arcs": [
							[
								3427,
								-3144,
								3428,
								3429,
								-3151
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G7G"
						},
						"arcs": [
							[
								[
									3430
								]
							],
							[
								[
									3431,
									3432,
									-3153,
									3433
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G7H"
						},
						"arcs": [
							[
								[
									3434,
									3435,
									3436,
									3437,
									3438
								]
							],
							[
								[
									3439,
									3440,
									-3434,
									-3152,
									-3430,
									3441,
									3442
								]
							],
							[
								[
									-3433,
									3443,
									3444,
									-3154
								],
								[
									-3431
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G7J"
						},
						"arcs": [
							[
								-3441,
								3445,
								3446,
								3447,
								-3432
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G7K"
						},
						"arcs": [
							[
								[
									-3443,
									3448,
									-3435
								]
							],
							[
								[
									-3439,
									-3446,
									-3440
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G7N"
						},
						"arcs": [
							[
								-3436,
								-3449,
								-3442,
								-3429,
								-3143,
								-3428,
								-3150,
								-3009,
								-3159,
								3449,
								3450,
								3451
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G7P"
						},
						"arcs": [
							[
								-3445,
								3452,
								3453,
								3454,
								3455,
								-3147,
								-3169,
								-3155
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G7S"
						},
						"arcs": [
							[
								-3444,
								-3448,
								3456,
								3457,
								-3453
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G7T"
						},
						"arcs": [
							[
								[
									-3457,
									-3447,
									-3438,
									3458
								]
							],
							[
								[
									3459
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G7X"
						},
						"arcs": [
							[
								-3456,
								3460,
								3461,
								3462,
								-3454,
								-3458,
								-3459,
								-3437,
								-3452,
								3463,
								3464,
								3465,
								-3450,
								-3161,
								3466,
								-3176,
								3467,
								-3172,
								3468,
								-3170,
								-3145
							],
							[
								-3460
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G7Y"
						},
						"arcs": [
							[
								-3451,
								-3466,
								3469,
								-3464
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G7Z"
						},
						"arcs": [
							[
								-3463,
								3470,
								-3461,
								-3455
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G8A"
						},
						"arcs": [
							[
								[
									-3465,
									-3470
								]
							],
							[
								[
									-3471,
									-3462
								]
							],
							[
								[
									-3171,
									-3469
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G8B"
						},
						"arcs": [
							[
								-3188,
								3471
							],
							[
								3472
							],
							[
								3473
							],
							[
								3474
							],
							[
								3475
							],
							[
								3476
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G8C"
						},
						"arcs": [
							[
								[
									-3477
								]
							],
							[
								[
									-3476
								]
							],
							[
								[
									-3475
								]
							],
							[
								[
									-3474
								]
							],
							[
								[
									-3473
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G8E"
						},
						"arcs": [
							[
								-3472,
								-3187
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G8G"
						},
						"arcs": [
							[
								[
									-3007,
									-3327,
									-3338,
									-3210,
									-3177,
									-3467,
									-3160
								]
							],
							[
								[
									3477,
									-3174
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G8H"
						},
						"arcs": [
							[
								3478,
								-3180
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G8J"
						},
						"arcs": [
							[
								3479,
								3480,
								-3181,
								-3479,
								-3179,
								-3209,
								3481,
								3482,
								3483,
								-3185
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G8K"
						},
						"arcs": [
							[
								3484,
								-3182,
								-3481,
								3485
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G8L"
						},
						"arcs": [
							[
								-3485,
								3486,
								-3183
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G8M"
						},
						"arcs": [
							[
								-3487,
								-3486,
								-3480,
								-3184
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G8N"
						},
						"arcs": [
							[
								-3468,
								-3175,
								-3478,
								-3173
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G8P"
						},
						"arcs": [
							[
								-3168,
								3487,
								-3483,
								3488,
								-3165
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G8T"
						},
						"arcs": [
							[
								[
									3489,
									3490,
									3491,
									3492,
									3493,
									3494,
									3495
								],
								[
									3496
								],
								[
									3497
								]
							],
							[
								[
									3498
								]
							],
							[
								[
									3499
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G8V"
						},
						"arcs": [
							[
								[
									-3496
								]
							],
							[
								[
									-3495,
									3500,
									-3194,
									3501,
									-3490
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G8W"
						},
						"arcs": [
							[
								[
									-3497
								]
							],
							[
								[
									-3498
								]
							],
							[
								[
									-3501,
									-3494,
									3502,
									3503,
									3504,
									-3195
								],
								[
									-3500
								],
								[
									-3499
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G8Y"
						},
						"arcs": [
							[
								3505,
								3506,
								3507,
								3508,
								3509,
								-3504
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G8Z"
						},
						"arcs": [
							[
								-3493,
								3510,
								3511,
								3512,
								3513,
								-3506,
								-3503
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G9A"
						},
						"arcs": [
							[
								[
									3514,
									3515
								]
							],
							[
								[
									3516,
									-3513
								]
							],
							[
								[
									3517,
									3518,
									-3511,
									-3492
								]
							],
							[
								[
									3519,
									-3509,
									3520,
									3521,
									-3197
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G9B"
						},
						"arcs": [
							[
								[
									-3515,
									3522
								]
							],
							[
								[
									3523,
									-3507,
									-3514,
									-3517,
									-3512,
									-3519,
									3524,
									-3198,
									-3522
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G9C"
						},
						"arcs": [
							[
								[
									-3524,
									-3521,
									-3508
								]
							],
							[
								[
									-3505,
									-3510,
									-3520,
									-3196
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G9H"
						},
						"arcs": [
							[
								-3224,
								3525,
								3526,
								3527,
								3528,
								-3191
							],
							[
								-3189
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G9N"
						},
						"arcs": [
							[
								-3206,
								3529,
								-3204,
								3530,
								3531
							],
							[
								3532
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G9P"
						},
						"arcs": [
							[
								-3205,
								-3530
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "G9R"
						},
						"arcs": [
							[
								[
									-3533
								]
							],
							[
								[
									3533,
									-3531,
									-3203
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G9T"
						},
						"arcs": [
							[
								-3532,
								-3534,
								-3207
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "G9X"
						},
						"arcs": [
							[
								-3337,
								-2986,
								-3202,
								3534,
								-3212
							],
							[
								-3208
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H1A"
						},
						"arcs": [
							[
								[
									3535,
									3536,
									3537
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1B"
						},
						"arcs": [
							[
								3538,
								3539,
								3540,
								3541,
								3542,
								-3536
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1C"
						},
						"arcs": [
							[
								-3537,
								-3543,
								3543,
								3544
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H1E"
						},
						"arcs": [
							[
								[
									-3542,
									3545,
									3546,
									3547,
									3548,
									-3544
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1G"
						},
						"arcs": [
							[
								3549,
								3550,
								3551,
								3552,
								3553,
								-3548
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H1H"
						},
						"arcs": [
							[
								[
									3554,
									3555,
									3556,
									3557,
									-3553
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1J"
						},
						"arcs": [
							[
								3558,
								3559,
								3560,
								3561,
								-3550,
								-3547
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1K"
						},
						"arcs": [
							[
								-3541,
								3562,
								3563,
								3564,
								-3559,
								-3546
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1L"
						},
						"arcs": [
							[
								3565,
								3566,
								-3563,
								-3540
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1M"
						},
						"arcs": [
							[
								3567,
								3568,
								3569,
								-3560,
								-3565
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H1N"
						},
						"arcs": [
							[
								[
									3570,
									3571,
									3572,
									3573
								]
							],
							[
								[
									3574,
									3575,
									-3568,
									-3564,
									-3567
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1P"
						},
						"arcs": [
							[
								3576,
								3577,
								-3551,
								-3562
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1R"
						},
						"arcs": [
							[
								-3578,
								3578,
								3579,
								-3555,
								-3552
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1S"
						},
						"arcs": [
							[
								-3570,
								3580,
								3581,
								3582,
								-3579,
								-3577,
								-3561
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1T"
						},
						"arcs": [
							[
								3583,
								3584,
								3585,
								-3581,
								-3569
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1V"
						},
						"arcs": [
							[
								3586,
								3587,
								3588,
								-3584,
								-3576
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1W"
						},
						"arcs": [
							[
								3589,
								3590,
								3591,
								3592,
								-3588
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1X"
						},
						"arcs": [
							[
								-3589,
								-3593,
								3593,
								3594,
								-3585
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1Y"
						},
						"arcs": [
							[
								-3592,
								3595,
								3596,
								3597,
								-3594
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H1Z"
						},
						"arcs": [
							[
								-3583,
								3598,
								3599,
								3600,
								3601,
								-3556,
								-3580
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2A"
						},
						"arcs": [
							[
								-3586,
								-3595,
								-3598,
								3602,
								-3599,
								-3582
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2B"
						},
						"arcs": [
							[
								-3602,
								3603,
								3604,
								-3557
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2C"
						},
						"arcs": [
							[
								3605,
								3606,
								3607,
								-3604
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2E"
						},
						"arcs": [
							[
								-3603,
								3608,
								3609,
								3610,
								3611,
								3612,
								-3600
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2G"
						},
						"arcs": [
							[
								3613,
								3614,
								3615,
								-3609,
								-3597
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H2H"
						},
						"arcs": [
							[
								[
									3616,
									-3614,
									-3596,
									3617,
									3618
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2J"
						},
						"arcs": [
							[
								-3617,
								3619,
								-3619,
								3620,
								3621,
								3622,
								3623,
								3624,
								-3615
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2K"
						},
						"arcs": [
							[
								3625,
								3626,
								-3621,
								-3618,
								-3591
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H2L"
						},
						"arcs": [
							[
								[
									3627
								]
							],
							[
								[
									3628,
									3629,
									3630
								]
							],
							[
								[
									3631,
									3632,
									3633,
									3634,
									3635,
									-3622,
									-3627
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2M"
						},
						"arcs": [
							[
								-3613,
								3636,
								3637,
								3638,
								-3606,
								-3601
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2N"
						},
						"arcs": [
							[
								3639,
								3640,
								3641,
								3642,
								-3638
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2P"
						},
						"arcs": [
							[
								3643,
								3644,
								-3640,
								-3637,
								-3612
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2R"
						},
						"arcs": [
							[
								3645,
								3646,
								-3644,
								-3611
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2S"
						},
						"arcs": [
							[
								-3616,
								-3625,
								3647,
								3648,
								3649,
								-3646,
								-3610
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2T"
						},
						"arcs": [
							[
								-3624,
								3650,
								3651,
								-3648
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2V"
						},
						"arcs": [
							[
								-3652,
								3652,
								3653,
								3654,
								3655,
								3656,
								3657,
								3658,
								-3649
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2W"
						},
						"arcs": [
							[
								-3636,
								3659,
								3660,
								-3653,
								-3651,
								-3623
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2X"
						},
						"arcs": [
							[
								3661,
								3662,
								3663,
								3664,
								3665,
								-3660,
								-3635
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2Y"
						},
						"arcs": [
							[
								3666,
								3667,
								3668,
								-3662,
								-3634
							],
							[
								-3628
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H2Z"
						},
						"arcs": [
							[
								3669,
								-3668,
								3670,
								3671,
								3672,
								-3663
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3A"
						},
						"arcs": [
							[
								3673,
								3674,
								3675,
								-3665
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3B"
						},
						"arcs": [
							[
								-3673,
								3676,
								3677,
								3678,
								-3674,
								-3664
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H3C"
						},
						"arcs": [
							[
								[
									3679,
									3680
								]
							],
							[
								[
									3681,
									3682,
									3683,
									3684,
									3685,
									3686,
									3687,
									-3678,
									3688,
									-3671,
									-3667,
									-3633,
									3689
								]
							],
							[
								[
									-3691,
									-3692,
									3628
								]
							],
							[
								[
									3692,
									3693,
									3694,
									3695
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H3E"
						},
						"arcs": [
							[
								[
									3696,
									3697,
									3698
								]
							],
							[
								[
									3699,
									3700
								]
							],
							[
								[
									3701,
									3702
								]
							],
							[
								[
									3703,
									3704,
									3705
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3G"
						},
						"arcs": [
							[
								-3679,
								-3688,
								3706,
								-3675
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3H"
						},
						"arcs": [
							[
								-3666,
								-3676,
								-3707,
								-3687,
								3707,
								3708,
								3709,
								3710,
								-3654,
								-3661
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3J"
						},
						"arcs": [
							[
								3711,
								3712,
								3713,
								3714,
								3715,
								3716,
								-3708,
								-3686
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H3K"
						},
						"arcs": [
							[
								[
									-3714,
									3717
								]
							],
							[
								[
									3718,
									3719,
									-3706,
									3720,
									3721,
									3722,
									-3683
								]
							],
							[
								[
									-3712,
									-3685,
									3723
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3L"
						},
						"arcs": [
							[
								-3639,
								-3643,
								3724,
								3725,
								3726,
								-3607
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3M"
						},
						"arcs": [
							[
								-3726,
								3727,
								3728,
								3729,
								3730
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3N"
						},
						"arcs": [
							[
								-3647,
								-3650,
								-3659,
								3731,
								3732,
								-3641,
								-3645
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3P"
						},
						"arcs": [
							[
								-3658,
								3733,
								3734,
								3735,
								-3732
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3R"
						},
						"arcs": [
							[
								3736,
								3737,
								3738,
								3739,
								-3735
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3S"
						},
						"arcs": [
							[
								-3657,
								3740,
								3741,
								-3737,
								-3734
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3T"
						},
						"arcs": [
							[
								3742,
								3743,
								-3741,
								-3656
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3V"
						},
						"arcs": [
							[
								-3711,
								3744,
								3745,
								-3743,
								-3655
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3W"
						},
						"arcs": [
							[
								-3744,
								-3746,
								3746,
								3747,
								3748,
								3749,
								-3738,
								-3742
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3X"
						},
						"arcs": [
							[
								-3749,
								3750,
								3751,
								3752,
								3753,
								3754
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3Y"
						},
						"arcs": [
							[
								3755,
								3756,
								-3747,
								-3745,
								-3710
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H3Z"
						},
						"arcs": [
							[
								-3717,
								3757,
								3758,
								-3756,
								-3709
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4A"
						},
						"arcs": [
							[
								-3757,
								-3759,
								3759,
								3760,
								3761,
								-3751,
								-3748
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4B"
						},
						"arcs": [
							[
								3762,
								3763,
								3764,
								3765,
								-3752,
								-3762
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H4C"
						},
						"arcs": [
							[
								[
									3766,
									3767,
									-3722,
									3768
								]
							],
							[
								[
									3769,
									3770,
									3771,
									3772,
									-3760,
									-3758,
									-3716
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H4E"
						},
						"arcs": [
							[
								[
									3773,
									3774
								]
							],
							[
								[
									3775,
									3776,
									3777
								]
							],
							[
								[
									3778,
									3779
								]
							],
							[
								[
									-3771,
									3780
								]
							],
							[
								[
									3781,
									-3763,
									-3761,
									-3773,
									3782
								]
							],
							[
								[
									3783,
									3784,
									3785,
									3786,
									3787,
									3788,
									3789,
									3790,
									3791,
									3792,
									-3767
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H4G"
						},
						"arcs": [
							[
								[
									-3786,
									3793
								]
							],
							[
								[
									-3705,
									3794,
									-3703,
									3795,
									3796,
									-3777,
									3797,
									-3780,
									3798,
									-3784,
									-3769,
									-3721
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H4H"
						},
						"arcs": [
							[
								[
									3799,
									3800,
									-3790,
									3801
								]
							],
							[
								[
									-3788,
									3802
								]
							],
							[
								[
									3803,
									-3700,
									3804,
									-3698,
									3805,
									3806,
									-3775,
									3807,
									-3778,
									-3797
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4J"
						},
						"arcs": [
							[
								3808,
								3809,
								3810,
								-3730
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H4K"
						},
						"arcs": [
							[
								[
									3811,
									3812,
									3813,
									3814,
									3815,
									-3810
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4L"
						},
						"arcs": [
							[
								3816,
								3817,
								3818,
								-3812,
								-3809,
								-3729,
								3819
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4M"
						},
						"arcs": [
							[
								3820,
								3821,
								3822,
								3823,
								-3818
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4N"
						},
						"arcs": [
							[
								-3642,
								-3733,
								-3736,
								-3740,
								3824,
								-3820,
								-3728,
								-3725
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4P"
						},
						"arcs": [
							[
								-3750,
								-3755,
								3825,
								3826,
								-3821,
								-3817,
								-3825,
								-3739
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4R"
						},
						"arcs": [
							[
								-3824,
								3827,
								-3813,
								-3819
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4S"
						},
						"arcs": [
							[
								-3823,
								3828,
								3829,
								3830,
								3831,
								-3814,
								-3828
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4T"
						},
						"arcs": [
							[
								-3827,
								3832,
								3833,
								-3829,
								-3822
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4V"
						},
						"arcs": [
							[
								-3766,
								3834,
								3835,
								-3753
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4W"
						},
						"arcs": [
							[
								-3754,
								-3836,
								3836,
								3837,
								3838,
								3839,
								3840,
								-3833,
								-3826
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4X"
						},
						"arcs": [
							[
								-3835,
								-3765,
								3841,
								-3837
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H4Z"
						},
						"arcs": [
							[
								-3670,
								-3669
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H5A"
						},
						"arcs": [
							[
								-3689,
								-3677,
								-3672
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H7A"
						},
						"arcs": [
							[
								[
									3842,
									3843,
									3844,
									3845,
									3846
								],
								[
									3847
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H7B"
						},
						"arcs": [
							[
								[
									-3848
								]
							],
							[
								[
									3848,
									3849,
									3850,
									-3844
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H7C"
						},
						"arcs": [
							[
								3851,
								3852,
								-3843
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H7E"
						},
						"arcs": [
							[
								-3853,
								3853,
								3854,
								3855,
								3856,
								-3849
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H7G"
						},
						"arcs": [
							[
								-3855,
								3857,
								3858,
								3859
							],
							[
								3860
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H7H"
						},
						"arcs": [
							[
								3861,
								3862,
								3863,
								3864
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H7J"
						},
						"arcs": [
							[
								[
									-3857,
									3865,
									-3865,
									3866,
									-3850
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H7K"
						},
						"arcs": [
							[
								3867,
								3868,
								-3862,
								-3866
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H7L"
						},
						"arcs": [
							[
								[
									-3869,
									3869,
									3870,
									3871,
									3872,
									-3863
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H7M"
						},
						"arcs": [
							[
								-3860,
								3873,
								3874,
								-3870,
								-3868,
								-3856
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H7N"
						},
						"arcs": [
							[
								[
									-3859,
									3875,
									3876,
									3877,
									-3874
								]
							],
							[
								[
									-3861
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H7P"
						},
						"arcs": [
							[
								[
									3878,
									3879
								]
							],
							[
								[
									3880,
									3881,
									3882,
									-3872
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H7R"
						},
						"arcs": [
							[
								[
									3883,
									3884,
									3885,
									-3882
								]
							],
							[
								[
									-3879,
									3886
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H7S"
						},
						"arcs": [
							[
								-3878,
								3887,
								3888,
								-3871,
								-3875
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H7T"
						},
						"arcs": [
							[
								3889,
								3890,
								3891,
								-3881,
								-3889
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H7V"
						},
						"arcs": [
							[
								-3877,
								3892,
								3893,
								-3890,
								-3888
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H7W"
						},
						"arcs": [
							[
								[
									3894,
									3895,
									-3891,
									-3894
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H7X"
						},
						"arcs": [
							[
								-3896,
								3896,
								3897,
								-3884,
								-3892
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H7Y"
						},
						"arcs": [
							[
								[
									-3898,
									3898,
									-3885
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H8N"
						},
						"arcs": [
							[
								[
									3899,
									3900
								]
							],
							[
								[
									-3801,
									3901,
									3902,
									3903,
									-3791
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H8P"
						},
						"arcs": [
							[
								[
									3904,
									3905,
									3906,
									3907
								]
							],
							[
								[
									3908,
									3909,
									3910,
									3911
								]
							],
							[
								[
									3912,
									3913,
									3914
								]
							],
							[
								[
									3915,
									3916
								]
							],
							[
								[
									-3697,
									3917,
									-3901,
									3918,
									-3806
								]
							],
							[
								[
									-3902,
									-3800,
									3919
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H8R"
						},
						"arcs": [
							[
								[
									-3907,
									3920,
									3921,
									3922
								]
							],
							[
								[
									-3911,
									3923,
									3924,
									3925
								]
							],
							[
								[
									3926,
									3927
								]
							],
							[
								[
									3928,
									-3917,
									3929,
									-3914,
									3930,
									3931,
									3932,
									-3792,
									-3904
								]
							],
							[
								[
									-3764,
									-3782,
									3933,
									3934,
									-3838,
									-3842
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H8S"
						},
						"arcs": [
							[
								[
									3935,
									-3932
								]
							],
							[
								[
									3936,
									-3927
								]
							],
							[
								[
									3937,
									3938
								]
							],
							[
								[
									3939,
									3940,
									-3839,
									-3935
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H8T"
						},
						"arcs": [
							[
								-3941,
								3941,
								-3938,
								3942,
								3943,
								-3840
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H8Y"
						},
						"arcs": [
							[
								-3815,
								-3832,
								3944,
								3945,
								3946,
								3947
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H8Z"
						},
						"arcs": [
							[
								[
									-3947,
									3948,
									3949,
									3950
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H9A"
						},
						"arcs": [
							[
								3951,
								3952,
								3953,
								-3949,
								-3946
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H9B"
						},
						"arcs": [
							[
								-3831,
								3954,
								3955,
								3956,
								-3952,
								-3945
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H9C"
						},
						"arcs": [
							[
								3957,
								3958
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H9E"
						},
						"arcs": [
							[
								[
									3959,
									-3958
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H9G"
						},
						"arcs": [
							[
								3960,
								3961,
								-3953,
								-3957
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H9H"
						},
						"arcs": [
							[
								-3954,
								-3962,
								3962,
								3963,
								3964,
								3965,
								-3950
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H9J"
						},
						"arcs": [
							[
								3966,
								3967,
								3968,
								3969,
								-3965
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H9K"
						},
						"arcs": [
							[
								-3969,
								3970,
								3971
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H9P"
						},
						"arcs": [
							[
								-3834,
								-3841,
								3972,
								3973,
								-3955,
								-3830
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H9R"
						},
						"arcs": [
							[
								3974,
								3975,
								-3963,
								-3961,
								-3956,
								-3974
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "H9S"
						},
						"arcs": [
							[
								[
									-3944,
									3976,
									3977,
									-3975,
									-3973
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H9W"
						},
						"arcs": [
							[
								-3978,
								3978,
								3979,
								-3967,
								-3964,
								-3976
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "H9X"
						},
						"arcs": [
							[
								-3968,
								-3980,
								3980,
								-3971
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J0A"
						},
						"arcs": [
							[
								-3100,
								-3416,
								-3413,
								-3104,
								3981,
								3982,
								3983,
								3984,
								-3222
							],
							[
								3985
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0B"
						},
						"arcs": [
							[
								[
									-3219,
									3986,
									3987,
									3988,
									3989,
									3990,
									3991,
									3992,
									3993,
									3994,
									3995,
									3996,
									3997,
									-3982,
									-3103
								]
							],
							[
								[
									3998,
									3999,
									4000,
									4001,
									4002,
									4003,
									4004,
									4005,
									-3984
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0C"
						},
						"arcs": [
							[
								[
									4006,
									4007,
									4008,
									4009,
									4010
								]
							],
							[
								[
									-3223,
									-3985,
									-4006,
									4011,
									4012,
									4013,
									4014,
									4015,
									-3526
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0E"
						},
						"arcs": [
							[
								[
									4016
								]
							],
							[
								[
									-4004,
									4017,
									-3990,
									4018,
									4019,
									4020,
									4021,
									4022,
									4023,
									4024,
									4025,
									4026,
									4027,
									4028,
									4029
								],
								[
									4030
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0G"
						},
						"arcs": [
							[
								[
									4031,
									4032
								]
							],
							[
								[
									-4034,
									-4035,
									-4036,
									-4037
								]
							],
							[
								[
									4037,
									4038
								]
							],
							[
								[
									4039,
									4040
								]
							],
							[
								[
									4041,
									-4011,
									4042,
									4043,
									4044,
									4045,
									4046,
									4047,
									4048,
									-3527,
									-4016
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J0H"
						},
						"arcs": [
							[
								-4010,
								4049,
								-4012,
								-4005,
								-4030,
								4050,
								4051,
								4052,
								4053,
								-4043
							],
							[
								4054,
								4055,
								4056
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J0J"
						},
						"arcs": [
							[
								4057,
								4058,
								4059,
								-4020,
								4060,
								4061,
								4062,
								4063,
								4064,
								4065,
								4066
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0K"
						},
						"arcs": [
							[
								[
									4067
								]
							],
							[
								[
									-3535,
									-3201,
									4068,
									4069,
									4070,
									4071,
									4072,
									4073,
									4074,
									4075,
									4076,
									4077,
									4078,
									4079,
									-3213
								],
								[
									4080
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0L"
						},
						"arcs": [
							[
								[
									4081,
									-4062,
									4082,
									4083,
									4084,
									4085,
									4086,
									4087
								]
							],
							[
								[
									-4051,
									-4029,
									4088,
									-4058,
									4089,
									4090,
									4091
								]
							],
							[
								[
									-4054,
									4092,
									4093,
									4094,
									4095,
									4096,
									-4044
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0M"
						},
						"arcs": [
							[
								[
									4097,
									4098,
									4099,
									4100
								]
							],
							[
								[
									4101,
									4102
								]
							],
							[
								[
									4103,
									4104
								]
							],
							[
								[
									4105,
									4106
								]
							],
							[
								[
									4107,
									4108
								]
							],
							[
								[
									4109,
									4110
								]
							],
							[
								[
									4111,
									4112
								]
							],
							[
								[
									4113
								]
							],
							[
								[
									4114,
									4115
								]
							],
							[
								[
									4116
								]
							],
							[
								[
									4117
								]
							],
							[
								[
									4118,
									4119
								]
							],
							[
								[
									4120,
									4121
								]
							],
							[
								[
									4122,
									4123
								]
							],
							[
								[
									4124,
									4125
								]
							],
							[
								[
									-2084,
									-3033,
									4126,
									4127
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0N"
						},
						"arcs": [
							[
								[
									4128,
									4129,
									4130,
									4131
								]
							],
							[
								[
									4132,
									4133,
									4134,
									4135,
									4136,
									4137
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0P"
						},
						"arcs": [
							[
								[
									4138,
									4139
								]
							],
							[
								[
									4140,
									4141,
									4142
								]
							],
							[
								[
									4143
								]
							],
							[
								[
									4144,
									4145,
									4146,
									4147,
									4148,
									4149,
									4150,
									4151,
									4152,
									4153,
									4154,
									4155,
									4156
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J0R"
						},
						"arcs": [
							[
								4157,
								4158,
								4159,
								4160,
								4161,
								4162,
								4163,
								4164,
								4165
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0S"
						},
						"arcs": [
							[
								[
									4166,
									4167,
									4168
								]
							],
							[
								[
									-4084,
									4169,
									4170,
									4171,
									4172,
									4173,
									4174,
									4175
								]
							],
							[
								[
									4176,
									4177
								]
							],
							[
								[
									4178,
									4179
								]
							],
							[
								[
									4180,
									4181
								]
							],
							[
								[
									4182,
									4183
								]
							],
							[
								[
									4184,
									4185,
									4186,
									4187
								]
							],
							[
								[
									4188,
									4189,
									4190
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J0T"
						},
						"arcs": [
							[
								4191,
								-4166,
								4192,
								4193,
								4194,
								4195,
								4196,
								4197,
								4198,
								-4079
							],
							[
								4199
							],
							[
								4200,
								4201
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0V"
						},
						"arcs": [
							[
								[
									4202,
									-4130,
									4203,
									-4156,
									4204,
									4205,
									4206
								]
							],
							[
								[
									4207,
									-4164,
									4208
								]
							],
							[
								[
									4209,
									-4195,
									4210,
									4211,
									4212,
									4213,
									4214,
									4215,
									4216,
									-4197
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J0W"
						},
						"arcs": [
							[
								-3214,
								-4080,
								-4199,
								4217,
								4218,
								4219,
								4220,
								4221,
								4222,
								4223
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0X"
						},
						"arcs": [
							[
								[
									4224,
									4225,
									4226,
									4227,
									4228,
									-4215
								]
							],
							[
								[
									-4222,
									4229,
									-4218,
									-4198,
									-4217,
									4230,
									4231,
									4232,
									4233,
									4234,
									4235,
									4236,
									4237,
									4238,
									4239,
									4240,
									4241,
									4242,
									4243,
									4244,
									4245
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0Y"
						},
						"arcs": [
							[
								[
									4246
								]
							],
							[
								[
									4247,
									-4099
								]
							],
							[
								[
									-3032,
									-3157,
									-3186,
									-3484,
									-3488,
									-3167,
									-3166,
									-3489,
									-3482,
									-3215,
									-4224,
									4248,
									4249,
									4250,
									4251,
									4252,
									4253,
									4254,
									-4101,
									4255,
									-4103,
									4256,
									-4105,
									4257,
									-4107,
									4258,
									-4109,
									4259,
									-4127
								],
								[
									-3164
								],
								[
									-3163
								],
								[
									4260
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J0Z"
						},
						"arcs": [
							[
								[
									4261,
									4262,
									4263,
									4264,
									4265,
									4266,
									-4250,
									4267,
									-4245,
									4268,
									4269,
									4270,
									4271,
									4272,
									4273,
									4274
								]
							],
							[
								[
									4275,
									4276,
									-4252
								],
								[
									4277
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J1A"
						},
						"arcs": [
							[
								4278,
								-3988
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J1C"
						},
						"arcs": [
							[
								4279,
								4280,
								4281,
								4282,
								-4000,
								4283,
								-3997
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J1E"
						},
						"arcs": [
							[
								[
									4284,
									4285,
									4286,
									4287,
									4288
								]
							],
							[
								[
									4289
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J1G"
						},
						"arcs": [
							[
								4290,
								4291,
								-4285,
								4292,
								-3995
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J1H"
						},
						"arcs": [
							[
								[
									-4292,
									4293,
									-3993,
									4294,
									4295,
									4296,
									-4286
								]
							],
							[
								[
									-4288,
									4297,
									-4281
								]
							],
							[
								[
									4298,
									4299,
									4300,
									-4001,
									-4283
								]
							],
							[
								[
									-4280,
									-3996,
									-4293,
									-4289
								],
								[
									-4290
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J1J"
						},
						"arcs": [
							[
								-4287,
								-4297,
								4301,
								4302,
								4303,
								-4299,
								-4282,
								-4298
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J1K"
						},
						"arcs": [
							[
								-4296,
								4304,
								4305,
								4306,
								-4302
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J1L"
						},
						"arcs": [
							[
								-4304,
								4307,
								4308,
								-4300
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J1M"
						},
						"arcs": [
							[
								-4294,
								-4291,
								-3994
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J1N"
						},
						"arcs": [
							[
								-4303,
								-4307,
								-4305,
								-4295,
								-3992,
								4309,
								4310,
								-4308
							],
							[
								4311
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J1R"
						},
						"arcs": [
							[
								[
									-4312
								]
							],
							[
								[
									-4301,
									-4309,
									-4311,
									4312,
									-4002
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J1S"
						},
						"arcs": [
							[
								-3998,
								-4284,
								-3999,
								-3983
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J1T"
						},
						"arcs": [
							[
								-3986
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J1X"
						},
						"arcs": [
							[
								-4003,
								-4313,
								-4310,
								-3991,
								-4018
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J1Z"
						},
						"arcs": [
							[
								-4015,
								4313,
								4314,
								4315,
								4316,
								-4007,
								-4042
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J2A"
						},
						"arcs": [
							[
								-4013,
								-4050,
								-4009,
								4317
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J2B"
						},
						"arcs": [
							[
								[
									4318
								]
							],
							[
								[
									4319,
									4320,
									4321,
									4322,
									-4314,
									-4014,
									-4318,
									-4008,
									-4317
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J2C"
						},
						"arcs": [
							[
								-4323,
								4323,
								-4321,
								4324,
								-4315
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J2E"
						},
						"arcs": [
							[
								[
									-4324,
									-4322
								]
							],
							[
								[
									-4325,
									-4320,
									-4316
								],
								[
									-4319
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J2G"
						},
						"arcs": [
							[
								4325,
								4326,
								4327,
								4328
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J2H"
						},
						"arcs": [
							[
								[
									4329,
									4330,
									4331,
									-4327
								]
							],
							[
								[
									-4024,
									-4329,
									4332
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J2J"
						},
						"arcs": [
							[
								[
									-4328,
									-4332,
									4333,
									-4025,
									-4333
								]
							],
							[
								[
									-4031
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J2K"
						},
						"arcs": [
							[
								4334,
								-4021,
								-4060,
								4335,
								-4027
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J2L"
						},
						"arcs": [
							[
								-4334,
								-4331,
								4336,
								-4022,
								-4335,
								-4026
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J2M"
						},
						"arcs": [
							[
								-4337,
								-4330,
								-4326,
								-4023
							],
							[
								-4017
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J2N"
						},
						"arcs": [
							[
								-4028,
								-4336,
								-4059,
								-4089
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J2R"
						},
						"arcs": [
							[
								4337,
								4338,
								-4057
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J2S"
						},
						"arcs": [
							[
								-4055,
								-4339,
								4339
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J2T"
						},
						"arcs": [
							[
								-4056,
								-4340,
								-4338
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J2W"
						},
						"arcs": [
							[
								4340,
								4341,
								4342,
								4343,
								4344,
								4345
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J2X"
						},
						"arcs": [
							[
								-4065,
								4346,
								4347,
								-4341,
								4348
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J2Y"
						},
						"arcs": [
							[
								4349,
								-4063,
								-4082,
								4350,
								-4344
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J3A"
						},
						"arcs": [
							[
								-4348,
								4351,
								-4342
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J3B"
						},
						"arcs": [
							[
								-4352,
								-4347,
								-4064,
								-4350,
								-4343
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J3E"
						},
						"arcs": [
							[
								4352,
								4353,
								4354,
								4355,
								4356,
								-4094
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J3G"
						},
						"arcs": [
							[
								[
									4357
								]
							],
							[
								[
									-4053,
									4358,
									4359,
									-4353,
									-4093
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J3H"
						},
						"arcs": [
							[
								-4052,
								-4092,
								4360,
								-4359
							],
							[
								-4358
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J3L"
						},
						"arcs": [
							[
								[
									4361
								]
							],
							[
								[
									-4066,
									-4349,
									-4346,
									4362,
									4363,
									4364,
									4365,
									4366,
									4367,
									-4361,
									-4091,
									4368
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J3M"
						},
						"arcs": [
							[
								-4067,
								-4369,
								-4090
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J3N"
						},
						"arcs": [
							[
								-4368,
								4369,
								-4354,
								-4360
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J3P"
						},
						"arcs": [
							[
								[
									-4045,
									-4097,
									4370,
									4371
								]
							],
							[
								[
									4372,
									4373,
									-4047
								]
							],
							[
								[
									-4032,
									4374
								]
							],
							[
								[
									-4040,
									4375
								]
							],
							[
								[
									-4035,
									4376
								]
							],
							[
								[
									4377,
									-4037,
									4378,
									-4038
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J3R"
						},
						"arcs": [
							[
								-4373,
								-4046,
								-4372,
								4379
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J3T"
						},
						"arcs": [
							[
								-4049,
								4380,
								-3528
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J3V"
						},
						"arcs": [
							[
								-4370,
								-4367,
								4381,
								4382,
								-4355
							],
							[
								-4362
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J3X"
						},
						"arcs": [
							[
								[
									-4357,
									4383,
									4384,
									-4095
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J3Y"
						},
						"arcs": [
							[
								-4382,
								-4366,
								4385,
								-4364,
								4386,
								4387,
								4388,
								4389,
								4390,
								4391,
								4392,
								4393
							],
							[
								4394
							],
							[
								4395
							],
							[
								4396
							],
							[
								4397
							],
							[
								4398
							],
							[
								4399
							],
							[
								4400
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J3Z"
						},
						"arcs": [
							[
								[
									-4401
								]
							],
							[
								[
									4401,
									-4388
								]
							],
							[
								[
									-4365,
									-4386
								]
							],
							[
								[
									-4400
								]
							],
							[
								[
									-4399
								]
							],
							[
								[
									-4398
								]
							],
							[
								[
									-4397
								]
							],
							[
								[
									-4396
								]
							],
							[
								[
									-4395
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J4B"
						},
						"arcs": [
							[
								[
									-3572,
									4402
								]
							],
							[
								[
									4403,
									4404
								]
							],
							[
								[
									4405,
									4406
								]
							],
							[
								[
									-4356,
									-4383,
									-4394,
									4407,
									4408,
									4409,
									4410,
									-4384
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J4G"
						},
						"arcs": [
							[
								[
									4411,
									4412,
									4413,
									4414,
									-4410
								]
							],
							[
								[
									-3574,
									4415,
									-4405,
									4416,
									-4406,
									4417
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J4H"
						},
						"arcs": [
							[
								4418,
								4419,
								4420,
								4421,
								-4414
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J4J"
						},
						"arcs": [
							[
								[
									4422,
									-4420
								]
							],
							[
								[
									-4419,
									-4413,
									4423,
									4424,
									4425
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J4K"
						},
						"arcs": [
							[
								[
									-3695,
									4426
								]
							],
							[
								[
									-3692,
									-3631,
									4427
								]
							],
							[
								[
									-4423,
									-4426,
									4428,
									4429,
									4430,
									4431,
									-4421
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J4L"
						},
						"arcs": [
							[
								4432,
								-4392,
								4433,
								-4429,
								-4425,
								4434
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J4M"
						},
						"arcs": [
							[
								-4393,
								-4433,
								4435,
								-4408
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J4N"
						},
						"arcs": [
							[
								-4436,
								-4435,
								-4424,
								-4412,
								-4409
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J4P"
						},
						"arcs": [
							[
								[
									4436,
									-3681,
									4437,
									-3693,
									4438,
									4439
								]
							],
							[
								[
									4440,
									4441
								]
							],
							[
								[
									4442,
									4443,
									-4431
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J4R"
						},
						"arcs": [
							[
								[
									-3719,
									-3682,
									4444
								]
							],
							[
								[
									4445,
									4446
								]
							],
							[
								[
									4447,
									4448,
									-4440,
									4449
								]
							],
							[
								[
									-4441,
									4450
								]
							],
							[
								[
									4451,
									4452,
									4453,
									-4443,
									4454
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J4S"
						},
						"arcs": [
							[
								[
									4455,
									4456
								]
							],
							[
								[
									4457,
									4458,
									-4448,
									4459
								]
							],
							[
								[
									-4447,
									4460
								]
							],
							[
								[
									4461,
									4462,
									4463,
									-4453
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J4T"
						},
						"arcs": [
							[
								-4391,
								4464,
								-4455,
								-4430,
								-4434
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J4V"
						},
						"arcs": [
							[
								-4390,
								4465,
								4466,
								-4462,
								-4452,
								-4465
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J4W"
						},
						"arcs": [
							[
								[
									4467,
									-4456
								]
							],
							[
								[
									4468,
									4469,
									-4458,
									4470
								]
							],
							[
								[
									4471,
									4472,
									4473,
									-4463,
									-4467,
									4474
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J4X"
						},
						"arcs": [
							[
								[
									4475,
									4476
								]
							],
							[
								[
									4477,
									4478,
									-4469,
									4479
								]
							],
							[
								[
									4480,
									4481,
									4482,
									-4473
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J4Y"
						},
						"arcs": [
							[
								4483,
								-4481,
								-4472,
								4484
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J4Z"
						},
						"arcs": [
							[
								-4389,
								-4402,
								-4387,
								-4363,
								4485,
								-4485,
								-4475,
								-4466
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J5A"
						},
						"arcs": [
							[
								-3906,
								4486,
								4487,
								4488,
								-4087,
								4489,
								-3921
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J5B"
						},
						"arcs": [
							[
								4490,
								-4488,
								4491,
								4492
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J5C"
						},
						"arcs": [
							[
								[
									-4492,
									-4487,
									-3905,
									4493
								]
							],
							[
								[
									4494,
									4495
								]
							],
							[
								[
									4496,
									4497,
									-3909,
									4498
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J5J"
						},
						"arcs": [
							[
								4499,
								4500,
								-4136,
								4501,
								4502,
								4503,
								-4160,
								4504
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J5K"
						},
						"arcs": [
							[
								4505,
								4506,
								4507,
								-4209,
								-4163
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J5L"
						},
						"arcs": [
							[
								4508,
								4509,
								-4506,
								-4162,
								4510
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J5M"
						},
						"arcs": [
							[
								4511,
								-4500,
								4512,
								-4076
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J5R"
						},
						"arcs": [
							[
								[
									-4495,
									4513
								]
							],
							[
								[
									-4484,
									-4486,
									-4345,
									-4351,
									-4088,
									-4489,
									-4491,
									4514,
									-4482
								]
							],
							[
								[
									-4476,
									4515
								]
							],
							[
								[
									-4497,
									4516,
									-4478,
									4517
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J5T"
						},
						"arcs": [
							[
								[
									4518,
									4519,
									-4071
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J5V"
						},
						"arcs": [
							[
								-3200,
								4520,
								-4069
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J5W"
						},
						"arcs": [
							[
								[
									-4520,
									4521,
									4522,
									4523,
									4524,
									4525,
									-4072
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J5X"
						},
						"arcs": [
							[
								-4526,
								4526,
								4527,
								-4073
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J5Y"
						},
						"arcs": [
							[
								4528,
								4529,
								-4523
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J5Z"
						},
						"arcs": [
							[
								-4525,
								4530,
								4531,
								4532,
								4533,
								-4527
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J6A"
						},
						"arcs": [
							[
								[
									-4531,
									-4524,
									-4530,
									4534
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J6E"
						},
						"arcs": [
							[
								-4081
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J6J"
						},
						"arcs": [
							[
								[
									-4490,
									-4086,
									4535,
									4536,
									4537,
									-4175,
									4538,
									4539,
									-3922
								],
								[
									4540
								]
							],
							[
								[
									-3925,
									4541
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J6K"
						},
						"arcs": [
							[
								[
									-4541
								]
							],
							[
								[
									4542,
									-4537
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J6N"
						},
						"arcs": [
							[
								[
									-4187,
									4543
								]
							],
							[
								[
									4544,
									-4189,
									4545
								]
							],
							[
								[
									-4181,
									4546
								]
							],
							[
								[
									-4179,
									4547
								]
							],
							[
								[
									-4185,
									4548
								]
							],
							[
								[
									-4183,
									4549
								]
							],
							[
								[
									-4539,
									-4174,
									4550,
									4551,
									-4178,
									4552
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J6R"
						},
						"arcs": [
							[
								-4536,
								-4085,
								-4176,
								-4538,
								-4543
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J6S"
						},
						"arcs": [
							[
								[
									-4173,
									4553,
									-4551
								]
							],
							[
								[
									-4545,
									4554,
									-4168,
									4555,
									4556,
									-4190
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J6T"
						},
						"arcs": [
							[
								[
									-4171,
									4557
								]
							],
							[
								[
									-4167,
									4558,
									-4556
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J6V"
						},
						"arcs": [
							[
								[
									4559,
									-3846
								]
							],
							[
								[
									4560,
									4561,
									4562,
									-4533
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J6W"
						},
						"arcs": [
							[
								[
									-4562,
									4563,
									4564,
									4565,
									4566,
									4567,
									4568,
									4569
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J6X"
						},
						"arcs": [
							[
								[
									4570
								]
							],
							[
								[
									4571
								]
							],
							[
								[
									-4568,
									4572,
									-4566,
									4573,
									-4138,
									4574,
									4575,
									4576
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J6Y"
						},
						"arcs": [
							[
								[
									-4573,
									-4567
								]
							],
							[
								[
									-4574,
									-4565,
									4577,
									4578,
									4579,
									4580,
									-4133
								],
								[
									-4572
								],
								[
									-4571
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J6Z"
						},
						"arcs": [
							[
								[
									4581,
									4582,
									4583,
									4584,
									-4579
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J7A"
						},
						"arcs": [
							[
								[
									4585,
									4586,
									4587,
									4588,
									-4583
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J7B"
						},
						"arcs": [
							[
								-4584,
								-4589,
								4589,
								4590,
								4591
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J7C"
						},
						"arcs": [
							[
								-4134,
								-4581,
								4592,
								-4591,
								4593,
								4594
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J7E"
						},
						"arcs": [
							[
								[
									4595
								]
							],
							[
								[
									-4590,
									-4588,
									4596,
									4597,
									4598,
									4599,
									-4594
								]
							],
							[
								[
									-4592,
									-4593,
									-4580,
									-4585
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J7G"
						},
						"arcs": [
							[
								[
									4600,
									4601
								]
							],
							[
								[
									4602,
									4603,
									-4597,
									-4587,
									4604
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J7H"
						},
						"arcs": [
							[
								-4604,
								4605,
								4606,
								4607,
								-4598
							],
							[
								-4596
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J7J"
						},
						"arcs": [
							[
								-4135,
								-4595,
								-4600,
								4608,
								-4509,
								4609,
								4610,
								-4502
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J7K"
						},
						"arcs": [
							[
								[
									4611
								]
							],
							[
								[
									-4534,
									-4563,
									-4570,
									4612,
									-4576,
									4613,
									-4074,
									-4528
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J7L"
						},
						"arcs": [
							[
								-4569,
								-4577,
								-4613
							],
							[
								-4612
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J7M"
						},
						"arcs": [
							[
								-4075,
								-4614,
								-4575,
								-4137,
								-4501,
								-4512
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J7N"
						},
						"arcs": [
							[
								-4609,
								-4599,
								-4608,
								4614,
								-4131,
								-4203,
								4615,
								-4507,
								-4510
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J7P"
						},
						"arcs": [
							[
								[
									-4601,
									4616
								]
							],
							[
								[
									4617,
									-4606,
									-4603,
									4618
								],
								[
									4619
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J7R"
						},
						"arcs": [
							[
								[
									-4620
								]
							],
							[
								[
									-4607,
									-4618,
									4620,
									-4132,
									-4615
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J7T"
						},
						"arcs": [
							[
								[
									-4141,
									4621,
									-4140,
									4622,
									-4148,
									4623,
									-4146,
									4624
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J7V"
						},
						"arcs": [
							[
								[
									4625
								],
								[
									4626
								],
								[
									4627
								]
							],
							[
								[
									4628,
									-4142,
									-4625,
									-4145
								],
								[
									-4144
								]
							],
							[
								[
									-4147,
									-4624
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J7W"
						},
						"arcs": [
							[
								[
									-4628
								]
							],
							[
								[
									-4627
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J7X"
						},
						"arcs": [
							[
								[
									-4150,
									4629
								]
							],
							[
								[
									4630,
									-4152
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J7Y"
						},
						"arcs": [
							[
								-4504,
								4631,
								-4610,
								-4511,
								-4161
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J7Z"
						},
						"arcs": [
							[
								-4611,
								-4632,
								-4503
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J8A"
						},
						"arcs": [
							[
								-4513,
								-4505,
								-4159,
								4632,
								-4077
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J8B"
						},
						"arcs": [
							[
								-4633,
								-4158,
								-4192,
								-4078
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J8C"
						},
						"arcs": [
							[
								[
									4633,
									-4202
								]
							],
							[
								[
									-4200
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J8E"
						},
						"arcs": [
							[
								-4634,
								-4201
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J8G"
						},
						"arcs": [
							[
								[
									4634,
									-4206,
									4635,
									4636,
									-4211,
									-4194
								]
							],
							[
								[
									-4210,
									-4196
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J8H"
						},
						"arcs": [
							[
								-4165,
								-4208,
								-4508,
								-4616,
								-4207,
								-4635,
								-4193
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J8L"
						},
						"arcs": [
							[
								-4229,
								4637,
								4638,
								4639,
								-4231,
								-4216
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J8M"
						},
						"arcs": [
							[
								-4228,
								4640,
								4641,
								4642,
								-4638
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J8N"
						},
						"arcs": [
							[
								-4640,
								4643,
								4644,
								-4232
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J8P"
						},
						"arcs": [
							[
								4645,
								4646,
								4647,
								4648,
								4649,
								4650
							],
							[
								4651
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J8R"
						},
						"arcs": [
							[
								[
									-4652
								]
							],
							[
								[
									4652
								]
							],
							[
								[
									-4643,
									4653,
									4654,
									-4651,
									4655,
									4656,
									4657,
									4658,
									-4644,
									-4639
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J8T"
						},
						"arcs": [
							[
								4659,
								-4656,
								-4650,
								4660,
								4661,
								4662,
								4663,
								4664,
								4665,
								-4658
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J8V"
						},
						"arcs": [
							[
								[
									-4657,
									-4660
								]
							],
							[
								[
									-4659,
									-4666,
									4666,
									-4233,
									-4645
								],
								[
									-4653
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J8X"
						},
						"arcs": [
							[
								4667,
								4668,
								4669,
								4670,
								4671,
								-4662
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J8Y"
						},
						"arcs": [
							[
								-4663,
								-4672,
								4672,
								4673,
								4674,
								4675
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J8Z"
						},
						"arcs": [
							[
								-4664,
								-4676,
								4676
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J9A"
						},
						"arcs": [
							[
								4677,
								4678,
								4679,
								4680,
								4681,
								4682,
								4683,
								-4674
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J9B"
						},
						"arcs": [
							[
								-4665,
								-4677,
								-4675,
								4684,
								-4234,
								-4667
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J9E"
						},
						"arcs": [
							[
								4685,
								-4219,
								-4230,
								-4221
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J9H"
						},
						"arcs": [
							[
								4686,
								4687,
								4688,
								4689,
								-4683
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J9J"
						},
						"arcs": [
							[
								-4684,
								-4690,
								4690,
								-4235,
								-4685
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J9L"
						},
						"arcs": [
							[
								-4686,
								-4220
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J9P"
						},
						"arcs": [
							[
								-4223,
								-4246,
								-4268,
								-4249
							],
							[
								-4247
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J9T"
						},
						"arcs": [
							[
								-4261
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J9V"
						},
						"arcs": [
							[
								4691,
								-4272
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J9X"
						},
						"arcs": [
							[
								[
									4692,
									-4263,
									4693
								]
							],
							[
								[
									4694,
									-4275,
									4695,
									-4276,
									-4251,
									-4267,
									4696,
									-4265,
									4697
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "J9Y"
						},
						"arcs": [
							[
								[
									-4266,
									-4697
								]
							],
							[
								[
									4692,
									4263,
									4697
								]
							],
							[
								[
									-4694,
									-4262,
									-4695
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "J9Z"
						},
						"arcs": [
							[
								-4278
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K0A"
						},
						"arcs": [
							[
								[
									4698,
									4699
								]
							],
							[
								[
									4700,
									4701,
									-4239
								]
							],
							[
								[
									4702,
									4703,
									4704,
									-4237,
									4705,
									4706,
									4707,
									4708,
									4709,
									4710,
									4711,
									4712,
									4713,
									4714,
									4715,
									4716,
									4717
								]
							],
							[
								[
									4718,
									4719,
									4720,
									4721,
									4722,
									4723,
									4724,
									4725,
									4726,
									4727,
									4728,
									4729,
									4730,
									4731,
									-4225,
									-4214
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K0B"
						},
						"arcs": [
							[
								4732,
								-4636,
								-4205,
								-4155,
								4733,
								-4719,
								-4213
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K0C"
						},
						"arcs": [
							[
								[
									4734,
									4735
								]
							],
							[
								[
									4736
								]
							],
							[
								[
									4737
								]
							],
							[
								[
									-4154,
									4738,
									4739,
									4740,
									4741,
									4742,
									4743,
									4744,
									-4722,
									4745,
									-4720,
									-4734
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K0E"
						},
						"arcs": [
							[
								[
									4746,
									4747
								]
							],
							[
								[
									4748
								]
							],
							[
								[
									4749,
									4750,
									4751,
									4752,
									4753,
									4754,
									4755
								],
								[
									4756
								],
								[
									4757
								],
								[
									4758
								]
							],
							[
								[
									4759,
									4760,
									4761,
									-4723,
									-4745
								],
								[
									-4737
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K0G"
						},
						"arcs": [
							[
								[
									4762
								]
							],
							[
								[
									-4754,
									4763,
									4764,
									4765
								],
								[
									-4749
								]
							],
							[
								[
									-4762,
									4766,
									-4747,
									-4756,
									4767,
									-4716,
									4768,
									-4724
								]
							],
							[
								[
									-4700,
									4769,
									4770,
									4771,
									4772,
									-4703
								],
								[
									4773
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K0H"
						},
						"arcs": [
							[
								[
									4774
								]
							],
							[
								[
									4775
								]
							],
							[
								[
									-4759
								]
							],
							[
								[
									-4774
								]
							],
							[
								[
									-4772,
									4776,
									-4764,
									-4753,
									4777,
									4778,
									4779,
									4780,
									4781,
									4782,
									4783,
									4784,
									4785,
									4786,
									4787,
									4788,
									4789,
									4790,
									4791,
									4792
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K0J"
						},
						"arcs": [
							[
								-4244,
								4793,
								4794,
								-4241,
								4795,
								4796,
								-4704,
								-4773,
								-4793,
								4797,
								4798,
								4799,
								4800,
								-4269
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K0K"
						},
						"arcs": [
							[
								[
									4801,
									4802
								]
							],
							[
								[
									4803,
									4804
								]
							],
							[
								[
									4805
								]
							],
							[
								[
									-4791,
									4806,
									4807,
									4808,
									4809,
									4810,
									4811,
									4812,
									4813,
									4814
								],
								[
									4815
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K0L"
						},
						"arcs": [
							[
								-4792,
								-4815,
								4816,
								4817,
								4818,
								4819,
								4820,
								4821,
								4822,
								4823,
								4824,
								-4798
							],
							[
								4825
							],
							[
								4826
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K0M"
						},
						"arcs": [
							[
								-4825,
								4827,
								-4823,
								4828,
								4829,
								4830,
								4831,
								4832,
								4833,
								4834,
								4835,
								4836,
								-4799
							],
							[
								4837
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1B"
						},
						"arcs": [
							[
								4838,
								4839,
								4840,
								4841,
								4842
							],
							[
								4843
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K1C"
						},
						"arcs": [
							[
								[
									-4728,
									4844,
									-4840,
									4845
								]
							],
							[
								[
									-4844
								]
							],
							[
								[
									4846,
									-4843,
									4847,
									-4646,
									-4655,
									4848,
									4849
								]
							],
							[
								[
									4850,
									4851,
									4852,
									4853
								],
								[
									4854
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1E"
						},
						"arcs": [
							[
								-4852,
								4855,
								-4850,
								4856
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K1G"
						},
						"arcs": [
							[
								[
									4857,
									4858,
									4859
								]
							],
							[
								[
									4860,
									4861,
									4862,
									4863,
									4864,
									4865,
									4866,
									4867,
									-4841,
									-4845,
									-4727,
									4868,
									4869
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1H"
						},
						"arcs": [
							[
								4870,
								4871,
								-4864
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1J"
						},
						"arcs": [
							[
								-4842,
								-4868,
								4872,
								-4647,
								-4848
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1K"
						},
						"arcs": [
							[
								-4867,
								4873,
								4874,
								4875,
								4876,
								4877,
								-4648,
								-4873
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K1L"
						},
						"arcs": [
							[
								[
									4878,
									4879,
									-4875
								]
							],
							[
								[
									4880,
									-4877
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1M"
						},
						"arcs": [
							[
								-4881,
								-4876,
								-4880,
								4881,
								-4668,
								-4661,
								-4649,
								-4878
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1N"
						},
						"arcs": [
							[
								-4879,
								-4874,
								-4866,
								4882,
								4883,
								4884,
								-4669,
								-4882
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1P"
						},
						"arcs": [
							[
								4885,
								4886,
								-4670,
								-4885
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1R"
						},
						"arcs": [
							[
								4887,
								4888,
								4889,
								-4678,
								-4673,
								-4671,
								-4887
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K1S"
						},
						"arcs": [
							[
								[
									-4883,
									-4865,
									-4872,
									4890,
									4891,
									4892,
									-4889,
									4893
								]
							],
							[
								[
									-4855
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1T"
						},
						"arcs": [
							[
								4894,
								-4859,
								4895,
								4896,
								-4862
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1V"
						},
						"arcs": [
							[
								-4863,
								-4897,
								4897,
								4898,
								4899,
								4900,
								4901,
								-4891,
								-4871
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1W"
						},
						"arcs": [
							[
								4902,
								-4729,
								-4846,
								-4839,
								-4847,
								4903
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K1X"
						},
						"arcs": [
							[
								[
									-4870,
									4904,
									4905,
									-4898,
									-4896,
									-4858
								]
							],
							[
								[
									-4860,
									-4895,
									-4861
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1Y"
						},
						"arcs": [
							[
								-4890,
								-4893,
								4906,
								4907,
								-4679
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K1Z"
						},
						"arcs": [
							[
								4908,
								4909,
								-4680,
								-4908
							],
							[
								4910
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K2A"
						},
						"arcs": [
							[
								[
									4911,
									4912,
									-4681,
									-4910
								]
							],
							[
								[
									-4911
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K2B"
						},
						"arcs": [
							[
								4913,
								4914,
								-4687,
								-4682,
								-4913
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K2C"
						},
						"arcs": [
							[
								[
									-4900,
									4915,
									4916,
									4917,
									4918,
									4919,
									4920
								]
							],
							[
								[
									-4902,
									4921,
									4922,
									4923,
									-4914,
									-4912,
									-4909,
									-4907,
									-4892
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K2E"
						},
						"arcs": [
							[
								-4901,
								-4921,
								4924,
								-4922
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K2G"
						},
						"arcs": [
							[
								[
									4925,
									-4918
								]
							],
							[
								[
									-4920,
									4926,
									4927,
									4928,
									-4923,
									-4925
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K2H"
						},
						"arcs": [
							[
								-4915,
								-4924,
								-4929,
								4929,
								4930,
								4931,
								-4688
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K2J"
						},
						"arcs": [
							[
								-4919,
								-4926,
								-4917,
								-4714,
								4932,
								-4927
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K2K"
						},
						"arcs": [
							[
								[
									4933,
									4934,
									-4710,
									4935,
									-4706,
									-4236,
									-4691,
									-4689,
									-4932
								],
								[
									4936
								]
							],
							[
								[
									-4708,
									4937
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K2L"
						},
						"arcs": [
							[
								4938,
								4939,
								4940,
								4941,
								4942,
								4943,
								-4934,
								-4931
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K2M"
						},
						"arcs": [
							[
								4944,
								-4940,
								4945
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K2P"
						},
						"arcs": [
							[
								-4894,
								-4888,
								-4886,
								-4884
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K2R"
						},
						"arcs": [
							[
								-4928,
								-4933,
								-4713,
								4946,
								-4946,
								-4939,
								-4930
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K2S"
						},
						"arcs": [
							[
								4947,
								-4941,
								-4945,
								-4947,
								-4712,
								4948,
								-4943
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K2T"
						},
						"arcs": [
							[
								-4944,
								-4949,
								-4711,
								-4935
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K2V"
						},
						"arcs": [
							[
								-4948,
								-4942
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K2W"
						},
						"arcs": [
							[
								[
									-4937
								]
							],
							[
								[
									-4938,
									-4707,
									-4936,
									-4709
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K4A"
						},
						"arcs": [
							[
								[
									4949,
									-4904,
									-4856,
									-4851,
									4950
								]
							],
							[
								[
									-4853,
									-4857,
									-4849,
									-4654,
									-4642,
									4951
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K4B"
						},
						"arcs": [
							[
								-4730,
								-4903,
								-4950,
								4952
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K4C"
						},
						"arcs": [
							[
								-4731,
								-4953,
								-4951,
								-4854,
								-4952,
								-4641,
								-4227,
								4953
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K4K"
						},
						"arcs": [
							[
								-4732,
								-4954,
								-4226
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K4M"
						},
						"arcs": [
							[
								4954,
								-4725,
								-4769,
								-4715,
								-4916,
								-4899,
								-4906
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K4P"
						},
						"arcs": [
							[
								-4955,
								-4905,
								-4869,
								-4726
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K4R"
						},
						"arcs": [
							[
								-4746,
								-4721
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K6A"
						},
						"arcs": [
							[
								-4637,
								-4733,
								-4212
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K6H"
						},
						"arcs": [
							[
								[
									4955,
									4956
								]
							],
							[
								[
									-4742,
									4957,
									4958
								]
							],
							[
								[
									4959,
									4960,
									4961,
									-4740
								],
								[
									-4738
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K6J"
						},
						"arcs": [
							[
								[
									-4956,
									4962
								]
							],
							[
								[
									-4735,
									4963
								]
							],
							[
								[
									-4961,
									4964,
									-4743,
									-4959,
									4965
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K6K"
						},
						"arcs": [
							[
								-4962,
								-4966,
								-4958,
								-4741
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K6T"
						},
						"arcs": [
							[
								[
									-4758
								]
							],
							[
								[
									-4757
								]
							],
							[
								[
									4966
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K6V"
						},
						"arcs": [
							[
								[
									4967,
									-4750,
									-4748,
									-4767,
									-4761
								],
								[
									-4967
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K7A"
						},
						"arcs": [
							[
								-4768,
								-4755,
								-4766,
								4968,
								4969,
								-4717
							],
							[
								-4763
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K7C"
						},
						"arcs": [
							[
								-4970,
								4970,
								-4770,
								-4699,
								-4718
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K7G"
						},
						"arcs": [
							[
								[
									4971
								]
							],
							[
								[
									-4752,
									4972,
									4973,
									-4778
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K7H"
						},
						"arcs": [
							[
								-4969,
								-4765,
								-4777,
								-4771,
								-4971
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K7K"
						},
						"arcs": [
							[
								[
									4974,
									4975,
									4976,
									4977,
									4978,
									4979,
									4980,
									4981
								],
								[
									4982
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K7L"
						},
						"arcs": [
							[
								[
									-4978,
									4983
								]
							],
							[
								[
									-4976,
									4984
								]
							],
							[
								[
									4985,
									4986,
									-4980
								]
							],
							[
								[
									-4983
								]
							],
							[
								[
									4987,
									4988,
									-4782
								]
							],
							[
								[
									-4781,
									4989
								]
							],
							[
								[
									-4974,
									4990,
									-4982,
									4991,
									4992,
									-4779
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K7M"
						},
						"arcs": [
							[
								-4981,
								-4987,
								4993,
								4994,
								-4783,
								-4989,
								4995,
								-4992
							],
							[
								4996
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K7N"
						},
						"arcs": [
							[
								4997,
								-4784,
								-4995
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K7P"
						},
						"arcs": [
							[
								[
									-4997
								]
							],
							[
								[
									-4996,
									-4988,
									-4990,
									-4780,
									-4993
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K7R"
						},
						"arcs": [
							[
								[
									-4786,
									4998
								]
							],
							[
								[
									4999,
									-4788
								]
							],
							[
								[
									-4790,
									5000,
									-4807
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K7S"
						},
						"arcs": [
							[
								-4238,
								-4705,
								-4797,
								5001,
								-4701
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K7V"
						},
						"arcs": [
							[
								-4702,
								-5002,
								-4796,
								-4240
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K8A"
						},
						"arcs": [
							[
								-4795,
								5002,
								-4242
							],
							[
								5003
							],
							[
								5004
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K8B"
						},
						"arcs": [
							[
								[
									-5004
								]
							],
							[
								[
									-5005
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K8H"
						},
						"arcs": [
							[
								-5003,
								-4794,
								-4243
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K8N"
						},
						"arcs": [
							[
								[
									5005,
									5006
								]
							],
							[
								[
									-4804,
									5007
								]
							],
							[
								[
									5008,
									5009,
									5010,
									5011,
									5012,
									-4811
								],
								[
									-4806
								]
							],
							[
								[
									5013,
									5014,
									-4809
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K8P"
						},
						"arcs": [
							[
								[
									5015,
									-5006
								]
							],
							[
								[
									5016,
									-5009,
									-4810,
									-5015
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K8R"
						},
						"arcs": [
							[
								5017,
								-5012
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K8V"
						},
						"arcs": [
							[
								[
									-4816
								]
							],
							[
								[
									-5013,
									-5018,
									-5011,
									5018,
									-4803,
									5019,
									-4812
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K9A"
						},
						"arcs": [
							[
								5020,
								5021,
								-4814
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "K9H"
						},
						"arcs": [
							[
								5022,
								5023,
								5024,
								5025,
								5026,
								5027,
								5028,
								5029
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K9J"
						},
						"arcs": [
							[
								[
									-4827
								]
							],
							[
								[
									5030,
									-4819
								],
								[
									-5029,
									5031,
									-5027,
									5032,
									-5025,
									5033,
									-5023,
									5034
								],
								[
									5035,
									5036
								]
							],
							[
								[
									-4826
								]
							],
							[
								[
									-4828,
									-4824
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K9K"
						},
						"arcs": [
							[
								[
									-5037
								]
							],
							[
								[
									-5036
								]
							],
							[
								[
									-5032,
									-5028
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K9L"
						},
						"arcs": [
							[
								[
									-5026,
									-5033
								]
							],
							[
								[
									-5024,
									-5034
								]
							],
							[
								[
									-5030,
									-5035
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "K9V"
						},
						"arcs": [
							[
								[
									-4838
								]
							],
							[
								[
									-4822,
									5037,
									-4829
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L0A"
						},
						"arcs": [
							[
								-4818,
								5038,
								5039,
								5040,
								5041,
								5042,
								-4820,
								-5031
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L0B"
						},
						"arcs": [
							[
								[
									5043,
									5044,
									5045,
									5046,
									5047
								]
							],
							[
								[
									5048,
									5049,
									-5041
								]
							],
							[
								[
									-5043,
									5050,
									5051,
									5052,
									5053,
									5054,
									5055,
									-4830,
									-5038,
									-4821
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L0C"
						},
						"arcs": [
							[
								[
									5056,
									5057,
									5058
								]
							],
							[
								[
									5059,
									5060,
									5061
								]
							],
							[
								[
									-4832,
									5062,
									5063,
									5064
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L0E"
						},
						"arcs": [
							[
								[
									5065,
									5066
								]
							],
							[
								[
									5067
								]
							],
							[
								[
									5068
								]
							],
							[
								[
									-4833,
									-5065,
									5069,
									-5061,
									5070,
									5071,
									5072,
									5073,
									5074
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L0G"
						},
						"arcs": [
							[
								[
									5075,
									5076,
									5077,
									5078,
									5079,
									5080,
									5081,
									5082,
									5083,
									5084,
									5085,
									5086
								]
							],
							[
								[
									-5060,
									5087,
									5088,
									5089,
									5090,
									5091,
									-5071
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L0H"
						},
						"arcs": [
							[
								[
									5092,
									5093,
									5094,
									5095,
									5096,
									5097,
									5098
								]
							],
							[
								[
									5099,
									5100,
									5101,
									5102,
									5103
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L0J"
						},
						"arcs": [
							[
								5104,
								5105,
								5106,
								5107,
								5108,
								5109,
								5110,
								-5080,
								5111
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L0K"
						},
						"arcs": [
							[
								[
									5112,
									5113,
									5114
								]
							],
							[
								[
									5115
								]
							],
							[
								[
									5116
								]
							],
							[
								[
									5117,
									5118
								]
							],
							[
								[
									5119,
									5120,
									5121
								]
							],
							[
								[
									5122
								]
							],
							[
								[
									5123,
									5124,
									-4834,
									-5075,
									5125,
									5126,
									5127
								]
							],
							[
								[
									5128,
									5129
								]
							],
							[
								[
									5130,
									5131,
									5132
								]
							],
							[
								[
									5133,
									5134,
									5135,
									5136,
									5137,
									5138,
									5139,
									5140,
									5141,
									5142
								]
							],
							[
								[
									5143
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L0L"
						},
						"arcs": [
							[
								[
									5144
								]
							],
							[
								[
									5145,
									5146,
									-5066,
									5147,
									5148,
									-5087,
									5149,
									5150,
									5151,
									5152
								]
							],
							[
								[
									5153,
									-5073,
									5154,
									5155,
									5156,
									-5138
								],
								[
									5157
								]
							],
							[
								[
									-5115,
									5158,
									-5140,
									5159,
									5160,
									5161,
									5162,
									5163,
									5164,
									5165,
									5166,
									5167,
									5168,
									5169,
									-5113,
									5170
								],
								[
									-5117
								],
								[
									5171
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L0M"
						},
						"arcs": [
							[
								[
									5172
								]
							],
							[
								[
									-5165,
									5173
								]
							],
							[
								[
									5174,
									-5151,
									5175,
									5176,
									5177,
									5178,
									5179,
									5180,
									-5166
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L0N"
						},
						"arcs": [
							[
								[
									5181,
									5182,
									5183
								]
							],
							[
								[
									5184
								]
							],
							[
								[
									5185,
									-5082
								]
							],
							[
								[
									5186,
									5187,
									5188,
									-5085
								]
							],
							[
								[
									5189,
									5190,
									5191,
									5192,
									5193,
									5194,
									5195,
									-5177
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L0P"
						},
						"arcs": [
							[
								[
									5196,
									5197,
									5198,
									5199,
									5200,
									5201,
									5202,
									5203,
									5204
								]
							],
							[
								[
									5205,
									5206,
									5207,
									5208,
									5209,
									5210,
									5211,
									5212
								]
							],
							[
								[
									5213,
									5214,
									5215,
									5216
								]
							],
							[
								[
									5217,
									5218
								]
							],
							[
								[
									5219,
									5220,
									5221
								]
							],
							[
								[
									5222,
									5223,
									5224
								]
							],
							[
								[
									5225,
									5226,
									5227
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L0R"
						},
						"arcs": [
							[
								[
									5228,
									5229,
									5230,
									5231,
									5232,
									5233,
									5234,
									5235,
									5236,
									5237,
									5238,
									5239
								],
								[
									5240
								]
							],
							[
								[
									5241,
									5242
								]
							],
							[
								[
									-5199,
									5243,
									5244,
									5245,
									5246,
									5247,
									5248,
									5249,
									5250,
									5251,
									5252,
									5253,
									5254,
									5255,
									5256,
									5257,
									5258,
									5259,
									5260,
									5261,
									5262,
									-5202,
									5263,
									5264,
									5265,
									-5200,
									5266
								],
								[
									5267
								],
								[
									5268
								],
								[
									5269
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L0S"
						},
						"arcs": [
							[
								[
									5270,
									5271,
									5272,
									5273
								]
							],
							[
								[
									5274,
									5275,
									5276,
									5277,
									5278,
									5279
								],
								[
									5280
								]
							],
							[
								[
									5281,
									5282,
									5283,
									-5234,
									5284,
									5285,
									5286,
									5287,
									5288,
									5289,
									5290
								]
							],
							[
								[
									5291,
									5292,
									5293,
									5294,
									5295,
									5296,
									5297,
									5298,
									5299,
									5300,
									5301,
									5302
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1A"
						},
						"arcs": [
							[
								5303,
								5304,
								-5039,
								-4817,
								-5022
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1B"
						},
						"arcs": [
							[
								-5305,
								5305,
								5306,
								-5049,
								-5040
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1C"
						},
						"arcs": [
							[
								-5050,
								-5307,
								5307,
								5308,
								-5051,
								-5042
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1E"
						},
						"arcs": [
							[
								5309,
								5310,
								5311,
								-5052,
								-5309
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1G"
						},
						"arcs": [
							[
								5312,
								5313,
								5314,
								5315,
								5316
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L1H"
						},
						"arcs": [
							[
								[
									5317,
									5318,
									-5313,
									5319,
									-5311
								]
							],
							[
								[
									-5054,
									5320
								]
							],
							[
								[
									5321,
									5322,
									-5315,
									5323,
									5324,
									5325,
									5326,
									-5044,
									5327,
									-5055
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1J"
						},
						"arcs": [
							[
								-5319,
								5328,
								5329,
								5330,
								-5324,
								-5314
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1K"
						},
						"arcs": [
							[
								-5053,
								-5312,
								-5320,
								-5317,
								-5322,
								-5321
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L1L"
						},
						"arcs": [
							[
								[
									5331,
									-5326
								]
							],
							[
								[
									-5323,
									-5316
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1M"
						},
						"arcs": [
							[
								-5332,
								5332,
								5333,
								5334,
								5335,
								5336,
								-5045,
								-5327
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1N"
						},
						"arcs": [
							[
								5337,
								5338,
								5339,
								5340,
								-5330
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1P"
						},
						"arcs": [
							[
								5341,
								-5340,
								5342,
								-5334
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1R"
						},
						"arcs": [
							[
								-5325,
								-5331,
								-5341,
								-5342,
								-5333
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1S"
						},
						"arcs": [
							[
								5343,
								5344,
								5345,
								5346,
								5347
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1T"
						},
						"arcs": [
							[
								-5347,
								5348,
								-5094,
								5349
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L1V"
						},
						"arcs": [
							[
								[
									5350
								]
							],
							[
								[
									5351,
									5352,
									5353,
									-5097
								]
							],
							[
								[
									-5349,
									-5346,
									5354,
									5355,
									5356,
									-5095
								],
								[
									5357
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1W"
						},
						"arcs": [
							[
								5358,
								5359,
								-5355,
								-5345
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L1X"
						},
						"arcs": [
							[
								[
									-5358
								]
							],
							[
								[
									5360,
									-5352,
									-5096,
									-5357
								],
								[
									-5351
								]
							],
							[
								[
									-5093,
									5361,
									-5336,
									5362
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1Y"
						},
						"arcs": [
							[
								-5337,
								-5362,
								-5099,
								5363,
								5364,
								-5057,
								5365,
								-5046
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L1Z"
						},
						"arcs": [
							[
								-5343,
								-5339,
								5366,
								-5348,
								-5350,
								-5363,
								-5335
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L2A"
						},
						"arcs": [
							[
								5367,
								-5275
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L2E"
						},
						"arcs": [
							[
								[
									5368
								]
							],
							[
								[
									5369,
									5370,
									5371,
									5372,
									-5292
								],
								[
									5373
								]
							],
							[
								[
									5374,
									5375,
									5376,
									5377,
									-5279,
									5378,
									-5288,
									5379,
									-5297,
									5380,
									5381,
									-5294
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L2G"
						},
						"arcs": [
							[
								[
									5382,
									-5377,
									5383,
									-5371
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L2H"
						},
						"arcs": [
							[
								[
									5384,
									-5372,
									-5384,
									-5376
								],
								[
									-5369
								]
							],
							[
								[
									-5296,
									5385,
									-5381
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L2J"
						},
						"arcs": [
							[
								[
									-5374
								]
							],
							[
								[
									-5373,
									-5385,
									-5375,
									-5293
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L2M"
						},
						"arcs": [
							[
								-5302,
								5386,
								-5300,
								5387,
								5388,
								5389,
								5390
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L2N"
						},
						"arcs": [
							[
								5391,
								5392,
								5393,
								5394,
								5395,
								-5390
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L2P"
						},
						"arcs": [
							[
								-5299,
								5396,
								5397,
								5398,
								-5388
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L2R"
						},
						"arcs": [
							[
								[
									-5389,
									-5399,
									5399,
									5400,
									-5392
								]
							],
							[
								[
									5401,
									5402,
									-5285,
									-5233,
									5403,
									-5395
								]
							],
							[
								[
									-5301,
									-5387
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L2S"
						},
						"arcs": [
							[
								5404,
								-5403,
								5405,
								-5393,
								-5401
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L2T"
						},
						"arcs": [
							[
								-5398,
								5406,
								-5286,
								-5405,
								-5400
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L2V"
						},
						"arcs": [
							[
								[
									-5380,
									-5287,
									-5407,
									-5397,
									-5298
								]
							],
							[
								[
									5294,
									5385,
									5381
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L2W"
						},
						"arcs": [
							[
								-5406,
								-5402,
								-5394
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L3B"
						},
						"arcs": [
							[
								[
									5407,
									-5271,
									-5291
								]
							],
							[
								[
									-5379,
									-5278,
									5408,
									-5273,
									5409,
									-5289
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L3C"
						},
						"arcs": [
							[
								-5272,
								-5408,
								-5290,
								-5410
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L3K"
						},
						"arcs": [
							[
								[
									-5281
								]
							],
							[
								[
									-5277,
									5410,
									-5282,
									-5274,
									-5409
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L3M"
						},
						"arcs": [
							[
								-5231,
								5411,
								5412,
								5413
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L3P"
						},
						"arcs": [
							[
								[
									5414,
									5415,
									5416,
									5417,
									5418,
									5419,
									5420
								]
							],
							[
								[
									5421,
									5422,
									5423,
									5424
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L3R"
						},
						"arcs": [
							[
								[
									-5421
								]
							],
							[
								[
									-5420,
									5425,
									5426,
									5427,
									5428,
									5429,
									5430,
									5431,
									5432,
									5433,
									-5415
								],
								[
									5434
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L3S"
						},
						"arcs": [
							[
								5435,
								5436,
								-5428,
								5437,
								-5426,
								-5419,
								5438
							],
							[
								5439
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L3T"
						},
						"arcs": [
							[
								5440,
								5441,
								5442,
								5443,
								5444,
								-5432
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L3V"
						},
						"arcs": [
							[
								-5126,
								-5074,
								-5154,
								-5137,
								5445
							],
							[
								-5116
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L3X"
						},
						"arcs": [
							[
								5446,
								5447,
								5448,
								5449,
								5450
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L3Y"
						},
						"arcs": [
							[
								[
									5451,
									-5104,
									5452,
									-5451,
									5453,
									-5090
								]
							],
							[
								[
									-5449,
									5454,
									-5077,
									5455,
									5456
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L3Z"
						},
						"arcs": [
							[
								5457,
								-5456,
								-5076,
								-5149,
								5458
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4A"
						},
						"arcs": [
							[
								-5365,
								5459,
								-5424,
								5460,
								-5100,
								-5452,
								-5089,
								5461,
								-5058
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4B"
						},
						"arcs": [
							[
								-5433,
								-5445,
								5462,
								5463,
								5464
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4C"
						},
						"arcs": [
							[
								-5463,
								-5444,
								5465,
								5466,
								5467
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4E"
						},
						"arcs": [
							[
								5468,
								5469,
								5470,
								5471,
								5472,
								-5102
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4G"
						},
						"arcs": [
							[
								-5103,
								-5473,
								5473,
								-5447,
								-5453
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L4H"
						},
						"arcs": [
							[
								[
									-5108,
									5474
								]
							],
							[
								[
									5475,
									-5106,
									5476,
									5477
								],
								[
									5478
								]
							],
							[
								[
									-5112,
									-5079,
									5479,
									5480,
									5481
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4J"
						},
						"arcs": [
							[
								-5443,
								5482,
								5483,
								5484,
								5485,
								5486,
								5487,
								-5466
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4K"
						},
						"arcs": [
							[
								5488,
								5489,
								5490,
								5491,
								5492,
								-5487
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L4L"
						},
						"arcs": [
							[
								[
									-5492,
									5493,
									5494,
									5495,
									5496,
									5497,
									-5109,
									-5475,
									-5107,
									-5476
								]
							],
							[
								[
									-5479
								]
							],
							[
								[
									-5482,
									5498,
									-5477,
									-5105
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L4M"
						},
						"arcs": [
							[
								[
									5499,
									5500,
									5501
								]
							],
							[
								[
									5502
								]
							],
							[
								[
									5503,
									-5152,
									-5175,
									-5174,
									-5164,
									5504,
									-5162
								],
								[
									-5173
								],
								[
									-5145
								]
							],
							[
								[
									-5172
								]
							],
							[
								[
									5505,
									-5161
								]
							],
							[
								[
									-5158
								]
							],
							[
								[
									-5160,
									-5139,
									-5157,
									5506,
									5507
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L4N"
						},
						"arcs": [
							[
								[
									-5163,
									-5505
								]
							],
							[
								[
									5508,
									-5500,
									5509,
									5510,
									5511,
									5512,
									-5153,
									-5504,
									-5506,
									-5508
								],
								[
									-5503
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4P"
						},
						"arcs": [
							[
								-5092,
								5513,
								-5459,
								-5148,
								-5067,
								-5147,
								5514,
								-5155,
								-5072
							],
							[
								-5068
							],
							[
								-5069
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4R"
						},
						"arcs": [
							[
								-5141,
								-5159,
								-5114,
								-5170,
								5515,
								5516
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4S"
						},
						"arcs": [
							[
								-5464,
								-5468,
								5517,
								-5470,
								5518
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4T"
						},
						"arcs": [
							[
								5519,
								5520,
								5521
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4V"
						},
						"arcs": [
							[
								5522,
								5523
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4W"
						},
						"arcs": [
							[
								5524,
								5525,
								5526,
								5527,
								5528,
								5529
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4X"
						},
						"arcs": [
							[
								5530,
								5531,
								-5527,
								5532
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4Y"
						},
						"arcs": [
							[
								5533,
								5534,
								-5528,
								-5532
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L4Z"
						},
						"arcs": [
							[
								5535,
								5536,
								5537,
								5538,
								5539,
								-5529
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L5A"
						},
						"arcs": [
							[
								5540,
								5541,
								-5536,
								-5535
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L5B"
						},
						"arcs": [
							[
								-5542,
								5542,
								5543,
								5544,
								-5537
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L5C"
						},
						"arcs": [
							[
								5545,
								5546,
								5547,
								5548,
								-5544
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L5E"
						},
						"arcs": [
							[
								[
									5549,
									-5534,
									-5531,
									5550,
									5551,
									5552
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L5G"
						},
						"arcs": [
							[
								[
									5553,
									5554
								]
							],
							[
								[
									-5553,
									5555,
									-5546,
									-5543,
									-5541,
									-5550,
									5556
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L5H"
						},
						"arcs": [
							[
								-5554,
								5557,
								5558,
								5559,
								5560,
								5561
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L5J"
						},
						"arcs": [
							[
								5562,
								5563,
								5564,
								5565,
								-5559
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L5K"
						},
						"arcs": [
							[
								-5566,
								5566,
								5567,
								-5560
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L5L"
						},
						"arcs": [
							[
								-5561,
								-5568,
								5568,
								5569,
								5570
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L5M"
						},
						"arcs": [
							[
								[
									-5548,
									5571,
									5572,
									5573
								]
							],
							[
								[
									5574,
									-5570,
									5575,
									-5209,
									5576
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L5N"
						},
						"arcs": [
							[
								[
									5577,
									-5573,
									5578
								]
							],
							[
								[
									5579,
									5580,
									-5577,
									-5208,
									5581,
									5582
								]
							],
							[
								[
									5583,
									5584,
									5585
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L5R"
						},
						"arcs": [
							[
								-5538,
								-5545,
								5586,
								5587
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L5S"
						},
						"arcs": [
							[
								5588,
								5589
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L5T"
						},
						"arcs": [
							[
								5590,
								-5523,
								5591,
								-5530,
								-5540,
								5592,
								5593,
								5594,
								-5589,
								5595,
								-5520
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L5V"
						},
						"arcs": [
							[
								-5587,
								-5549,
								-5574,
								-5578,
								5596,
								5597
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L5W"
						},
						"arcs": [
							[
								[
									-5580,
									5598
								]
							],
							[
								[
									-5539,
									-5588,
									-5598,
									5599,
									-5584,
									5600,
									-5593
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6A"
						},
						"arcs": [
							[
								-5518,
								-5467,
								-5488,
								-5493,
								-5478,
								-5499,
								-5481,
								5601,
								-5471
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L6B"
						},
						"arcs": [
							[
								[
									-5440
								]
							],
							[
								[
									-5354,
									5602,
									5603,
									5604,
									-5439,
									-5418,
									5605,
									-5425,
									-5460,
									-5364,
									-5098
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6C"
						},
						"arcs": [
							[
								5606,
								-5416,
								-5434,
								-5465,
								-5519,
								-5469,
								-5101,
								-5461,
								-5423
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6E"
						},
						"arcs": [
							[
								-5606,
								-5417,
								-5607,
								-5422
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L6G"
						},
						"arcs": [
							[
								[
									-5438,
									-5427
								]
							],
							[
								[
									-5435
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6H"
						},
						"arcs": [
							[
								-5567,
								-5565,
								5607,
								5608,
								5609,
								-5210,
								-5576,
								-5569
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6J"
						},
						"arcs": [
							[
								5610,
								5611,
								-5608,
								-5564
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6K"
						},
						"arcs": [
							[
								5612,
								5613,
								5614,
								-5609,
								-5612
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6L"
						},
						"arcs": [
							[
								5615,
								5616,
								5617,
								-5614
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6M"
						},
						"arcs": [
							[
								-5615,
								-5618,
								5618,
								5619,
								5620,
								5621,
								-5610
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6P"
						},
						"arcs": [
							[
								-5498,
								5622,
								5623,
								5624,
								5625,
								5626,
								-5110
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6R"
						},
						"arcs": [
							[
								5627,
								5628,
								5629,
								5630,
								-5625
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6S"
						},
						"arcs": [
							[
								5631,
								5632,
								5633,
								-5628,
								-5624
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6T"
						},
						"arcs": [
							[
								5634,
								-5521,
								-5596,
								-5590,
								-5595,
								5635,
								-5632,
								-5623,
								-5497
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6V"
						},
						"arcs": [
							[
								-5634,
								5636,
								5637,
								5638,
								-5629
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6W"
						},
						"arcs": [
							[
								-5594,
								5639,
								-5637,
								-5633,
								-5636
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L6X"
						},
						"arcs": [
							[
								[
									5640,
									-5206,
									5641
								]
							],
							[
								[
									5642,
									-5214,
									5643,
									-5638,
									5644
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L6Y"
						},
						"arcs": [
							[
								[
									-5582,
									-5207,
									-5641,
									5645
								]
							],
							[
								[
									-5586,
									5646,
									-5645,
									-5640,
									-5601
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L6Z"
						},
						"arcs": [
							[
								-5639,
								5647,
								5648,
								-5630
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L7A"
						},
						"arcs": [
							[
								-5644,
								-5217,
								5649,
								5650,
								-5648
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L7B"
						},
						"arcs": [
							[
								-5474,
								-5472,
								-5602,
								-5480,
								-5078,
								-5455,
								-5448
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L7C"
						},
						"arcs": [
							[
								-5626,
								-5631,
								-5649,
								-5651,
								5651,
								-5222,
								5652,
								-5225,
								5653,
								-5227,
								5654,
								5655,
								5656
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L7E"
						},
						"arcs": [
							[
								-5111,
								-5627,
								-5657,
								5657,
								-5083,
								-5186,
								-5081
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L7G"
						},
						"arcs": [
							[
								[
									-5650,
									-5216,
									5658,
									-5220,
									-5652
								]
							],
							[
								[
									-5654,
									-5224,
									5659,
									-5212,
									5660,
									5661,
									-5219,
									5662,
									-5228
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L7J"
						},
						"arcs": [
							[
								-5218,
								-5662,
								5663,
								5664,
								-5193,
								5665,
								5666
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L7K"
						},
						"arcs": [
							[
								-5656,
								5667,
								-5183,
								5668,
								-5187,
								-5084,
								-5658
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L7L"
						},
						"arcs": [
							[
								-5619,
								-5617,
								5669,
								5670,
								5671,
								5672
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L7M"
						},
						"arcs": [
							[
								[
									5673,
									-5672,
									5674,
									5675,
									5676
								]
							],
							[
								[
									5677,
									5678,
									-5621,
									5679
								]
							],
							[
								[
									5680,
									5681,
									5682
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L7N"
						},
						"arcs": [
							[
								5683,
								5684,
								-5675,
								-5671
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L7P"
						},
						"arcs": [
							[
								[
									5685,
									5686
								]
							],
							[
								[
									5687,
									5688,
									-5248,
									5689
								]
							],
							[
								[
									5690,
									5691,
									5692,
									-5246,
									5693,
									-5676
								]
							],
							[
								[
									5694,
									-5244,
									-5198,
									-5682
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L7R"
						},
						"arcs": [
							[
								[
									-5693,
									5695,
									-5686,
									-5690,
									-5247
								]
							],
							[
								[
									5696,
									5697,
									5698,
									-5691,
									-5685
								]
							],
							[
								[
									-5680,
									-5620,
									-5673,
									-5674
								]
							],
							[
								[
									-5677,
									-5694,
									-5245,
									-5695,
									-5681,
									5699,
									-5678
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L7S"
						},
						"arcs": [
							[
								5700,
								5701,
								5702,
								-5698
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L7T"
						},
						"arcs": [
							[
								-5703,
								5703,
								5704,
								5705,
								5706,
								5707,
								-5688,
								-5687,
								-5696,
								-5692,
								-5699
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L8E"
						},
						"arcs": [
							[
								-5413,
								5708,
								5709,
								5710,
								5711,
								5712
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L8G"
						},
						"arcs": [
							[
								5713,
								5714,
								-5710
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L8H"
						},
						"arcs": [
							[
								5715,
								-5712,
								5716,
								5717,
								-5704,
								-5702
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L8J"
						},
						"arcs": [
							[
								-5709,
								-5412,
								-5230,
								5718,
								5719,
								-5714
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L8K"
						},
						"arcs": [
							[
								-5711,
								-5715,
								-5720,
								5720,
								5721,
								5722,
								-5717
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L8L"
						},
						"arcs": [
							[
								-5718,
								5723,
								5724,
								5725,
								-5705
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L8M"
						},
						"arcs": [
							[
								-5723,
								5726,
								5727,
								5728,
								-5724
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L8N"
						},
						"arcs": [
							[
								[
									-5725,
									-5729,
									5729,
									5730,
									5731,
									5732
								]
							],
							[
								[
									-5267
								]
							],
							[
								[
									-5265
								]
							],
							[
								[
									-5264,
									-5201,
									-5266
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L8P"
						},
						"arcs": [
							[
								[
									-5732,
									5733,
									5734,
									5735
								]
							],
							[
								[
									5736
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L8R"
						},
						"arcs": [
							[
								-5726,
								-5733,
								-5736,
								5737,
								-5706
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L8S"
						},
						"arcs": [
							[
								-5738,
								-5735,
								5738,
								5739,
								5740,
								-5707
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L8T"
						},
						"arcs": [
							[
								-5727,
								-5722,
								5741,
								5742
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L8V"
						},
						"arcs": [
							[
								-5743,
								5743,
								5744,
								-5728
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L8W"
						},
						"arcs": [
							[
								-5742,
								-5721,
								-5719,
								-5229,
								5745,
								5746,
								-5744
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L9A"
						},
						"arcs": [
							[
								-5745,
								-5747,
								5747,
								5748,
								-5730
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L9B"
						},
						"arcs": [
							[
								[
									-5241
								]
							],
							[
								[
									-5748,
									-5746,
									-5240,
									5749,
									5750,
									5751
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L9C"
						},
						"arcs": [
							[
								-5731,
								-5749,
								-5752,
								5752,
								-5734
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L9G"
						},
						"arcs": [
							[
								-5740,
								5753,
								-5750,
								-5239,
								5754,
								-5254,
								-5253,
								-5252,
								-5251,
								-5250,
								5755
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L9H"
						},
						"arcs": [
							[
								[
									-5689,
									-5708,
									-5741,
									-5756,
									-5249
								],
								[
									-5737
								]
							],
							[
								[
									5756,
									-5260
								]
							],
							[
								[
									-5270
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L9J"
						},
						"arcs": [
							[
								[
									-5512,
									5757
								]
							],
							[
								[
									-5759,
									5501,
									5509
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L9K"
						},
						"arcs": [
							[
								-5751,
								-5754,
								-5739,
								-5753
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L9L"
						},
						"arcs": [
							[
								-5056,
								-5328,
								-5048,
								5759,
								-5063,
								-4831
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L9M"
						},
						"arcs": [
							[
								[
									-5516,
									-5169,
									5760,
									-5119,
									5761
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L9N"
						},
						"arcs": [
							[
								-5454,
								-5450,
								-5457,
								-5458,
								-5514,
								-5091
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L9P"
						},
						"arcs": [
							[
								-5760,
								-5047,
								-5366,
								-5059,
								-5462,
								-5088,
								-5062,
								-5070,
								-5064
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L9R"
						},
						"arcs": [
							[
								-5150,
								-5086,
								-5189,
								5762,
								-5190,
								-5176
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L9S"
						},
						"arcs": [
							[
								-5146,
								-5513,
								-5758,
								-5511,
								-5759,
								-5501,
								-5509,
								-5507,
								-5156,
								-5515
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L9T"
						},
						"arcs": [
							[
								-5211,
								-5622,
								-5679,
								-5700,
								-5683,
								-5197,
								5763,
								-5664,
								-5661
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L9V"
						},
						"arcs": [
							[
								5764
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L9W"
						},
						"arcs": [
							[
								-5763,
								-5188,
								-5669,
								-5182,
								5765,
								-5191
							],
							[
								-5185
							],
							[
								-5765
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "L9Y"
						},
						"arcs": [
							[
								[
									5766,
									5767,
									-5180,
									5768
								],
								[
									5769
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "L9Z"
						},
						"arcs": [
							[
								-5181,
								-5768,
								5770,
								-5167
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M1B"
						},
						"arcs": [
							[
								-5356,
								5771,
								5772,
								5773,
								5774,
								5775,
								5776,
								-5604,
								5777
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M1C"
						},
						"arcs": [
							[
								[
									5778,
									-5772,
									-5360,
									5779,
									5780,
									5781,
									5782
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M1E"
						},
						"arcs": [
							[
								[
									5783,
									5784,
									5785,
									5786,
									-5781
								]
							],
							[
								[
									-5783,
									5787,
									-5773,
									-5779,
									5788
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M1G"
						},
						"arcs": [
							[
								-5782,
								-5787,
								5789,
								5790,
								-5774,
								-5788
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M1H"
						},
						"arcs": [
							[
								5791,
								5792,
								5793,
								-5775,
								-5791
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M1J"
						},
						"arcs": [
							[
								-5786,
								5794,
								5795,
								5796,
								-5792,
								-5790
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M1K"
						},
						"arcs": [
							[
								5797,
								5798,
								5799,
								5800,
								5801,
								-5796
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M1L"
						},
						"arcs": [
							[
								[
									5802
								]
							],
							[
								[
									5803,
									5804,
									5805,
									5806,
									5807,
									-5800
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M1M"
						},
						"arcs": [
							[
								5808,
								5809,
								-5798,
								-5795,
								-5785
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M1N"
						},
						"arcs": [
							[
								-5810,
								5810,
								5811,
								-5804,
								-5799
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M1P"
						},
						"arcs": [
							[
								-5793,
								-5797,
								-5802,
								5812,
								5813,
								5814
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M1R"
						},
						"arcs": [
							[
								-5801,
								-5808,
								5815,
								5816,
								5817,
								-5813
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M1S"
						},
						"arcs": [
							[
								-5776,
								-5794,
								-5815,
								5818,
								5819,
								5820
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M1T"
						},
						"arcs": [
							[
								-5814,
								-5818,
								5821,
								5822,
								5823,
								5824,
								-5819
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M1V"
						},
						"arcs": [
							[
								-5820,
								-5825,
								5825,
								-5429,
								-5437,
								5826
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M1W"
						},
						"arcs": [
							[
								-5824,
								5827,
								5828,
								-5430,
								-5826
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M1X"
						},
						"arcs": [
							[
								[
									-5821,
									-5827,
									-5436,
									-5605,
									-5777
								]
							],
							[
								[
									-5353,
									-5361,
									-5778,
									-5603
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M2H"
						},
						"arcs": [
							[
								5829,
								5830,
								5831,
								-5441,
								-5431,
								-5829
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M2J"
						},
						"arcs": [
							[
								-5828,
								-5823,
								5832,
								5833,
								5834,
								-5830
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M2K"
						},
						"arcs": [
							[
								-5831,
								-5835,
								5835,
								5836,
								5837
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M2L"
						},
						"arcs": [
							[
								5838,
								5839,
								5840,
								5841,
								5842,
								-5836,
								-5834
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M2M"
						},
						"arcs": [
							[
								-5838,
								5843,
								5844,
								-5483,
								-5442,
								-5832
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M2N"
						},
						"arcs": [
							[
								[
									5845
								]
							],
							[
								[
									-5843,
									5846,
									5847,
									5848,
									5849,
									-5844,
									-5837
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M2P"
						},
						"arcs": [
							[
								5850,
								5851,
								-5847,
								-5842
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M2R"
						},
						"arcs": [
							[
								-5850,
								5852,
								-5484,
								-5845
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M3A"
						},
						"arcs": [
							[
								-5817,
								5853,
								5854,
								5855,
								-5839,
								-5833,
								-5822
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M3B"
						},
						"arcs": [
							[
								-5856,
								5856,
								5857,
								5858,
								-5840
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M3C"
						},
						"arcs": [
							[
								5859,
								5860,
								5861,
								5862,
								-5857,
								-5855,
								5863
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M3H"
						},
						"arcs": [
							[
								-5849,
								5864,
								5865,
								5866,
								5867,
								-5485,
								-5853
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M3J"
						},
						"arcs": [
							[
								-5486,
								-5868,
								5868,
								5869,
								5870,
								5871,
								-5489
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M3K"
						},
						"arcs": [
							[
								-5867,
								5872,
								5873,
								-5869
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M3L"
						},
						"arcs": [
							[
								5874,
								5875,
								5876,
								5877,
								-5871
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M3M"
						},
						"arcs": [
							[
								-5874,
								5878,
								-5875,
								-5870
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M3N"
						},
						"arcs": [
							[
								-5878,
								5879,
								5880,
								-5490,
								-5872
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4A"
						},
						"arcs": [
							[
								-5807,
								5881,
								-5864,
								-5854,
								-5816
							],
							[
								-5803
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4B"
						},
						"arcs": [
							[
								-5806,
								5882,
								5883,
								-5860,
								-5882
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4C"
						},
						"arcs": [
							[
								-5805,
								5884,
								5885,
								5886,
								-5883
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4E"
						},
						"arcs": [
							[
								5887,
								5888,
								-5885,
								-5812
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4G"
						},
						"arcs": [
							[
								5889,
								5890,
								5891,
								5892,
								5893,
								5894,
								-5858,
								-5863
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4H"
						},
						"arcs": [
							[
								-5862,
								5895,
								5896,
								-5890
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4J"
						},
						"arcs": [
							[
								-5887,
								5897,
								5898,
								5899,
								-5896,
								-5861,
								-5884
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4K"
						},
						"arcs": [
							[
								5900,
								5901,
								5902,
								5903,
								-5900
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4L"
						},
						"arcs": [
							[
								5904,
								5905,
								5906,
								-5898,
								-5886,
								-5889
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4M"
						},
						"arcs": [
							[
								5907,
								5908,
								5909,
								5910,
								-5901,
								-5899,
								-5907
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M4N"
						},
						"arcs": [
							[
								[
									5911
								]
							],
							[
								[
									-5841,
									-5859,
									-5895,
									5912,
									5913,
									5914,
									-5851
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4P"
						},
						"arcs": [
							[
								5915,
								5916,
								-5913,
								-5894
							],
							[
								-5912
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4R"
						},
						"arcs": [
							[
								-5917,
								5917,
								5918,
								5919,
								-5914
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4S"
						},
						"arcs": [
							[
								-5893,
								5920,
								5921,
								-5916
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4T"
						},
						"arcs": [
							[
								-5892,
								5922,
								5923,
								-5921
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4V"
						},
						"arcs": [
							[
								-5924,
								5924,
								5925,
								5926
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M4W"
						},
						"arcs": [
							[
								[
									5927
								]
							],
							[
								[
									-5904,
									5928,
									5929,
									5930,
									-5925,
									-5923,
									-5891,
									-5897
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M4X"
						},
						"arcs": [
							[
								-5903,
								5931,
								5932,
								-5929
							],
							[
								-5928
							],
							[
								5933
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M4Y"
						},
						"arcs": [
							[
								[
									5934,
									5935
								]
							],
							[
								[
									5936,
									5937,
									5938,
									5939,
									-5930,
									-5933
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M5A"
						},
						"arcs": [
							[
								-5911,
								5940,
								5941,
								5942,
								5943,
								5944,
								-5937,
								-5932,
								-5902
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M5B"
						},
						"arcs": [
							[
								-5945,
								5945,
								5946,
								5947,
								-5938
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M5C"
						},
						"arcs": [
							[
								5948,
								5949,
								-5946,
								-5944
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M5E"
						},
						"arcs": [
							[
								[
									5950,
									5951,
									5952,
									-5949,
									-5943
								]
							],
							[
								[
									5953
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M5G"
						},
						"arcs": [
							[
								5954,
								5955,
								5956,
								5957,
								-5939,
								-5948
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M5H"
						},
						"arcs": [
							[
								[
									5958,
									-5955,
									-5947,
									-5950,
									-5953,
									5959,
									5960
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M5J"
						},
						"arcs": [
							[
								[
									5961,
									5962
								]
							],
							[
								[
									-5941,
									-5910,
									5963
								]
							],
							[
								[
									-5952,
									5964,
									5965,
									-5960
								]
							],
							[
								[
									-5908,
									-5906,
									5966
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M5M"
						},
						"arcs": [
							[
								-5915,
								-5920,
								5967,
								5968,
								-5865,
								-5848,
								-5852
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M5N"
						},
						"arcs": [
							[
								5969,
								5970,
								5971,
								-5968,
								-5919
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M5P"
						},
						"arcs": [
							[
								-5927,
								5972,
								5973,
								-5970,
								-5918,
								-5922
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M5R"
						},
						"arcs": [
							[
								-5931,
								5974,
								5975,
								5976,
								-5973,
								-5926
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M5S"
						},
						"arcs": [
							[
								-5958,
								5977,
								5978,
								5979,
								-5975,
								-5940
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M5T"
						},
						"arcs": [
							[
								-5957,
								5980,
								5981,
								-5978
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M5V"
						},
						"arcs": [
							[
								-5959,
								5982,
								-5961,
								-5966,
								5983,
								-5962,
								5984,
								5985,
								5986,
								-5981,
								-5956
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M6A"
						},
						"arcs": [
							[
								5987,
								5988,
								-5873,
								-5866,
								-5969
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M6B"
						},
						"arcs": [
							[
								5989,
								5990,
								5991,
								5992,
								-5988,
								-5972
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M6C"
						},
						"arcs": [
							[
								-5974,
								-5977,
								5993,
								5994,
								5995,
								-5990,
								-5971
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M6E"
						},
						"arcs": [
							[
								-5996,
								5996,
								5997,
								5998,
								-5991
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M6G"
						},
						"arcs": [
							[
								-5980,
								5999,
								6000,
								-5994,
								-5976
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M6H"
						},
						"arcs": [
							[
								6001,
								6002,
								6003,
								6004,
								-5997,
								-5995,
								-6001
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M6J"
						},
						"arcs": [
							[
								-5987,
								6005,
								-6002,
								-6000,
								-5979,
								-5982
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M6K"
						},
						"arcs": [
							[
								-5986,
								6006,
								6007,
								6008,
								6009,
								-6003,
								-6006
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M6L"
						},
						"arcs": [
							[
								[
									6010,
									6011
								]
							],
							[
								[
									6012,
									6013,
									-5879,
									-5989,
									-5993
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M6M"
						},
						"arcs": [
							[
								-5992,
								-5999,
								6014,
								6015,
								6016,
								6017,
								-6011,
								6018,
								-6013
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M6N"
						},
						"arcs": [
							[
								-5998,
								-6005,
								6019,
								6020,
								6021,
								-6015
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M6P"
						},
						"arcs": [
							[
								-6004,
								6022,
								6023,
								-6020
							],
							[
								-5846
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M6R"
						},
						"arcs": [
							[
								-6010,
								6024,
								-6023
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M6S"
						},
						"arcs": [
							[
								-6024,
								-6025,
								-6009,
								6025,
								6026,
								6027,
								6028,
								-6021
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M8V"
						},
						"arcs": [
							[
								[
									6029
								]
							],
							[
								[
									6030,
									6031,
									6032,
									-5936,
									6033,
									-6026,
									-6008,
									6034
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M8W"
						},
						"arcs": [
							[
								-6031,
								6035,
								-5551,
								6036,
								6037
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M8X"
						},
						"arcs": [
							[
								[
									6038,
									6039
								]
							],
							[
								[
									6040,
									-6028,
									6041,
									6042
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M8Y"
						},
						"arcs": [
							[
								-6027,
								-6034,
								-5935,
								-6033,
								6043,
								-6042
							],
							[
								-6030
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M8Z"
						},
						"arcs": [
							[
								-6032,
								-6038,
								6044,
								6045,
								6046,
								-6039,
								-6043,
								-6044
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M9A"
						},
						"arcs": [
							[
								-6016,
								-6022,
								-6029,
								-6041,
								-6040,
								-6047,
								6047,
								6048,
								6049
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M9B"
						},
						"arcs": [
							[
								-6046,
								6050,
								6051,
								-6048
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M9C"
						},
						"arcs": [
							[
								-6051,
								-6045,
								-6037,
								-5533,
								-5526,
								6052,
								6053
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M9L"
						},
						"arcs": [
							[
								6054,
								6055,
								-5494,
								-5491,
								-5881
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M9M"
						},
						"arcs": [
							[
								-5880,
								-5877,
								6056,
								6057,
								6058,
								-6055
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M9N"
						},
						"arcs": [
							[
								-6019,
								-6012,
								-6018,
								6059,
								-6057,
								-5876,
								-6014
							],
							[
								-5954
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "M9P"
						},
						"arcs": [
							[
								[
									-5934
								]
							],
							[
								[
									-6017,
									-6050,
									6060,
									6061,
									-6060
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M9R"
						},
						"arcs": [
							[
								-6061,
								-6049,
								-6052,
								-6054,
								6062
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M9V"
						},
						"arcs": [
							[
								-6059,
								6063,
								-5495,
								-6056
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "M9W"
						},
						"arcs": [
							[
								-6064,
								-6058,
								-6062,
								-6063,
								-6053,
								-5525,
								-5592,
								-5524,
								-5591,
								-5522,
								-5635,
								-5496
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N0A"
						},
						"arcs": [
							[
								[
									-5284,
									6064,
									6065,
									-5235
								]
							],
							[
								[
									-5237,
									6066,
									6067,
									6068,
									6069,
									6070,
									6071
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N0B"
						},
						"arcs": [
							[
								[
									6072,
									6073,
									6074,
									-5256
								]
							],
							[
								[
									-5757,
									-5259,
									6075,
									6076,
									6077,
									6078,
									-5242,
									6079,
									-5261
								]
							],
							[
								[
									-5269
								]
							],
							[
								[
									-5268
								]
							],
							[
								[
									6080,
									6081,
									6082,
									6083,
									6084,
									6085,
									6086
								]
							],
							[
								[
									-5263,
									6087,
									6088,
									6089,
									6090,
									6091,
									6092,
									-5203
								]
							],
							[
								[
									6093,
									6094,
									6095,
									6096,
									6097,
									6098,
									6099,
									6100,
									6101,
									6102,
									6103,
									6104,
									6105,
									6106,
									6107,
									6108,
									6109,
									6110
								]
							],
							[
								[
									-5668,
									-5655,
									-5226,
									-5663,
									-5667,
									6111,
									-5192,
									-5766,
									-5184
								]
							],
							[
								[
									6112,
									6113,
									6114,
									6115,
									6116,
									-5194,
									-5665,
									-5764,
									-5205,
									6117,
									6118,
									6119,
									6120,
									6121,
									6122
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N0C"
						},
						"arcs": [
							[
								6123,
								6124,
								-5178,
								-5196,
								6125,
								6126,
								6127
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N0E"
						},
						"arcs": [
							[
								[
									6128,
									6129,
									6130,
									6131,
									6132,
									6133
								]
							],
							[
								[
									6134,
									-6070,
									6135,
									6136,
									6137,
									6138,
									6139,
									6140,
									6141
								]
							],
							[
								[
									-5257,
									-6075,
									6142,
									-6104,
									6143,
									-6102,
									6144,
									6145
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N0G"
						},
						"arcs": [
							[
								-6126,
								-5195,
								-6117,
								6146,
								-6114,
								6147,
								-6110,
								6148,
								6149,
								6150,
								6151,
								6152,
								6153,
								6154,
								6155,
								6156,
								6157
							],
							[
								6158
							],
							[
								6159
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N0H"
						},
						"arcs": [
							[
								[
									-5770
								]
							],
							[
								[
									-5769,
									-5179,
									-6125,
									6160,
									6161,
									6162
								]
							],
							[
								[
									6163,
									6164,
									6165
								]
							],
							[
								[
									6166,
									6167,
									-6127,
									-6158,
									6168
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N0J"
						},
						"arcs": [
							[
								[
									-6130,
									6169,
									6170,
									6171
								]
							],
							[
								[
									-6132,
									6172,
									6173
								]
							],
							[
								[
									6174,
									6175,
									6176,
									6177,
									6178,
									6179,
									6180,
									-6139
								]
							],
							[
								[
									-6083,
									6181
								]
							],
							[
								[
									6182,
									6183,
									6184,
									6185,
									6186,
									6187,
									-6085
								]
							],
							[
								[
									6188,
									-6141,
									6189,
									-6081,
									6190,
									-6106
								],
								[
									6191
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N0K"
						},
						"arcs": [
							[
								[
									6192,
									6193
								]
							],
							[
								[
									6194,
									6195,
									-6187,
									6196,
									6197,
									-6150,
									6198,
									-6108,
									6199,
									6200
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N0L"
						},
						"arcs": [
							[
								[
									6201,
									6202,
									6203,
									6204
								]
							],
							[
								[
									6205,
									6206,
									6207,
									6208,
									6209,
									6210,
									6211,
									6212,
									6213,
									6214
								]
							],
							[
								[
									-6179,
									6215,
									-6177,
									6216,
									6217,
									6218,
									6219,
									6220,
									6221,
									6222,
									6223
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N0M"
						},
						"arcs": [
							[
								-6198,
								6224,
								-6185,
								6225,
								-6223,
								6226,
								6227,
								6228,
								6229,
								-6214,
								6230,
								6231,
								6232,
								6233,
								-6151
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N0N"
						},
						"arcs": [
							[
								6234,
								-6212,
								6235,
								6236,
								6237,
								6238,
								-6232
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N0P"
						},
						"arcs": [
							[
								[
									6239,
									6240
								]
							],
							[
								[
									6241,
									6242,
									6243
								]
							],
							[
								[
									-6211,
									6244,
									6245,
									6246,
									6247,
									6248,
									6249,
									6250,
									-6236
								],
								[
									6251
								],
								[
									6252
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N0R"
						},
						"arcs": [
							[
								[
									6253
								]
							],
							[
								[
									-6247,
									6254,
									-6244,
									6255,
									6256,
									6257,
									6258,
									6259,
									6260,
									6261,
									6262,
									6263,
									6264,
									6265,
									6266
								]
							],
							[
								[
									6267,
									-6250,
									6268
								]
							],
							[
								[
									-6252
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N1A"
						},
						"arcs": [
							[
								-6066,
								6269,
								-6067,
								-5236
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N1C"
						},
						"arcs": [
							[
								6270,
								6271,
								6272,
								6273
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N1E"
						},
						"arcs": [
							[
								6274,
								6275,
								6276
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N1G"
						},
						"arcs": [
							[
								[
									6277
								]
							],
							[
								[
									6278,
									6279,
									-6274,
									6280,
									6281,
									6282,
									-6276,
									6283
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N1H"
						},
						"arcs": [
							[
								[
									6284,
									6285,
									-6091
								]
							],
							[
								[
									-5204,
									-6093,
									6286,
									-6279,
									6287,
									-6277,
									-6283,
									6288,
									-6281,
									-6273,
									6289,
									-6118
								],
								[
									6290
								]
							],
							[
								[
									-6112,
									-5666
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N1K"
						},
						"arcs": [
							[
								[
									-6291
								]
							],
							[
								[
									-6289,
									-6282
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N1L"
						},
						"arcs": [
							[
								[
									-6092,
									-6286,
									6291,
									-6271,
									-6280,
									-6287
								],
								[
									-6278
								]
							],
							[
								[
									-6288,
									-6284,
									-6275
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N1M"
						},
						"arcs": [
							[
								6292,
								-6115,
								-6147,
								-6116
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N1P"
						},
						"arcs": [
							[
								-6078,
								6293,
								6294,
								6295
							],
							[
								6296
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N1R"
						},
						"arcs": [
							[
								[
									-6297
								]
							],
							[
								[
									-6294,
									-6077,
									6297,
									-6145,
									-6101,
									6298,
									6299,
									6300
								]
							],
							[
								[
									-6088,
									-5262,
									-6080,
									-5243,
									-6079,
									-6296,
									6301,
									6302,
									6303,
									6304
								],
								[
									6305
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N1S"
						},
						"arcs": [
							[
								-6302,
								-6295,
								-6301,
								6306
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N1T"
						},
						"arcs": [
							[
								[
									-6306
								]
							],
							[
								[
									6307,
									-6089,
									-6305
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N2A"
						},
						"arcs": [
							[
								6308,
								6309,
								6310,
								6311,
								6312,
								6313,
								-6121
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N2B"
						},
						"arcs": [
							[
								-6122,
								-6314,
								6314,
								6315,
								6316
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N2C"
						},
						"arcs": [
							[
								6317,
								6318,
								6319,
								6320,
								6321,
								-6311
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N2E"
						},
						"arcs": [
							[
								-6320,
								6322,
								-6098,
								6323,
								6324
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N2G"
						},
						"arcs": [
							[
								-6312,
								-6322,
								6325,
								6326,
								6327,
								6328,
								6329,
								6330
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N2H"
						},
						"arcs": [
							[
								[
									-6329,
									6331
								]
							],
							[
								[
									-6313,
									-6331,
									6332,
									6333,
									-6315
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N2J"
						},
						"arcs": [
							[
								[
									6334,
									6335,
									6336
								]
							],
							[
								[
									-6317,
									6337,
									-6333,
									-6330,
									-6332,
									-6328,
									6338,
									6339,
									-6094,
									-6123
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N2K"
						},
						"arcs": [
							[
								6337,
								6333,
								6315
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N2L"
						},
						"arcs": [
							[
								-6327,
								6340,
								6341,
								6342,
								-6336,
								6343,
								-6339
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N2M"
						},
						"arcs": [
							[
								-6326,
								-6321,
								-6325,
								6344,
								-6341
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N2N"
						},
						"arcs": [
							[
								-6345,
								-6324,
								-6097,
								6345,
								-6342
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N2P"
						},
						"arcs": [
							[
								6346,
								-6299,
								-6100,
								6347,
								-6318,
								-6310
							],
							[
								6348
							],
							[
								6349
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N2R"
						},
						"arcs": [
							[
								[
									-6350
								]
							],
							[
								[
									-6349
								]
							],
							[
								[
									-6348,
									-6099,
									-6323,
									-6319
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N2T"
						},
						"arcs": [
							[
								-6346,
								-6096,
								6350,
								-6337,
								-6343
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N2V"
						},
						"arcs": [
							[
								-6344,
								-6335,
								-6351,
								-6095,
								-6340
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N2Z"
						},
						"arcs": [
							[
								[
									6351,
									-6153
								]
							],
							[
								[
									-6160
								]
							],
							[
								[
									6352,
									-6156
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N3A"
						},
						"arcs": [
							[
								-6191,
								-6087,
								6353,
								-6200,
								-6107
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N3B"
						},
						"arcs": [
							[
								-6111,
								-6148,
								-6113
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N3C"
						},
						"arcs": [
							[
								-6272,
								-6292,
								-6285,
								-6090,
								-6308,
								-6304,
								6354,
								6355,
								6356,
								-6119,
								-6290
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N3E"
						},
						"arcs": [
							[
								6357,
								-6356
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N3H"
						},
						"arcs": [
							[
								-6357,
								-6358,
								-6355,
								-6303,
								-6307,
								-6300,
								-6347,
								-6309,
								-6120
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N3L"
						},
						"arcs": [
							[
								[
									-6192
								]
							],
							[
								[
									-6143,
									-6074,
									6358,
									-6142,
									-6189,
									-6105
								]
							],
							[
								[
									-6103,
									-6144
								]
							],
							[
								[
									-5258,
									-6146,
									-6298,
									-6076
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N3P"
						},
						"arcs": [
							[
								6359,
								6360
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N3R"
						},
						"arcs": [
							[
								6361,
								6362,
								6363,
								6364,
								6365,
								-6360
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N3S"
						},
						"arcs": [
							[
								-6363,
								6366
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N3T"
						},
						"arcs": [
							[
								6367,
								-6071,
								-6135,
								-6359,
								-6073,
								-5255
							],
							[
								-6361,
								-6366,
								6368,
								-6364,
								-6367,
								-6362
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N3V"
						},
						"arcs": [
							[
								-6369,
								-6365
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N3W"
						},
						"arcs": [
							[
								-5238,
								-6072,
								-6368,
								-5755
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N3Y"
						},
						"arcs": [
							[
								6369,
								-6134,
								6370,
								6371,
								-6136,
								-6069
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N4B"
						},
						"arcs": [
							[
								[
									-6371,
									-6133,
									-6174,
									6372,
									-6175,
									-6138
								]
							],
							[
								[
									-6137,
									-6372
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N4G"
						},
						"arcs": [
							[
								-6373,
								-6173,
								-6131,
								-6172,
								6373,
								-6217,
								-6176
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N4K"
						},
						"arcs": [
							[
								6374,
								-6165,
								6375,
								-6167
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N4L"
						},
						"arcs": [
							[
								[
									-6161,
									-6124
								]
							],
							[
								[
									-6128,
									-6168,
									-6376,
									-6164,
									6376,
									-6162
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N4N"
						},
						"arcs": [
							[
								-6159
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N4S"
						},
						"arcs": [
							[
								-6190,
								-6140,
								-6181,
								6377,
								-6183,
								-6084,
								-6182,
								-6082
							],
							[
								6378,
								6379
							],
							[
								6380
							],
							[
								6381
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N4T"
						},
						"arcs": [
							[
								[
									-6381
								]
							],
							[
								[
									6382,
									-6380
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N4V"
						},
						"arcs": [
							[
								[
									-6382
								]
							],
							[
								[
									-6383,
									-6379
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N4W"
						},
						"arcs": [
							[
								-6109,
								-6199,
								-6149
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N4X"
						},
						"arcs": [
							[
								-6186,
								-6225,
								-6197
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N4Z"
						},
						"arcs": [
							[
								[
									6383
								]
							],
							[
								[
									6384
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N5A"
						},
						"arcs": [
							[
								[
									-6194,
									-6201,
									-6354,
									-6086,
									-6188,
									-6196
								],
								[
									-6385
								],
								[
									-6384
								]
							],
							[
								[
									-6193,
									-6195
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N5C"
						},
						"arcs": [
							[
								[
									-6216,
									-6178
								]
							],
							[
								[
									-6378,
									-6180,
									-6224,
									-6226,
									-6184
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N5H"
						},
						"arcs": [
							[
								-6374,
								-6171,
								6385,
								-6205,
								6386,
								-6218
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N5L"
						},
						"arcs": [
							[
								-6203,
								6387,
								-6209,
								6388
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N5P"
						},
						"arcs": [
							[
								-6387,
								-6204,
								-6389,
								-6208,
								6389,
								6390,
								6391,
								-6219
							],
							[
								6392
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N5R"
						},
						"arcs": [
							[
								-6393
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N5V"
						},
						"arcs": [
							[
								-6222,
								6393,
								6394,
								6395,
								6396,
								-6227
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N5W"
						},
						"arcs": [
							[
								6397,
								6398,
								6399,
								6400,
								-6395
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N5X"
						},
						"arcs": [
							[
								[
									6401
								]
							],
							[
								[
									6402,
									6403,
									-6228,
									-6397
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N5Y"
						},
						"arcs": [
							[
								-6401,
								6404,
								6405,
								6406,
								-6403,
								-6396
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N5Z"
						},
						"arcs": [
							[
								6407,
								6408,
								6409,
								6410,
								6411,
								-6399
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N6A"
						},
						"arcs": [
							[
								6412,
								6413,
								6414,
								6415,
								-6406
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N6B"
						},
						"arcs": [
							[
								-6400,
								-6412,
								6416,
								-6413,
								-6405
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N6C"
						},
						"arcs": [
							[
								-6414,
								-6417,
								-6411,
								6417,
								6418,
								6419,
								6420
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N6E"
						},
						"arcs": [
							[
								-6410,
								6421,
								6422,
								6423,
								-6418
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N6G"
						},
						"arcs": [
							[
								-6407,
								-6416,
								6424,
								-6229,
								-6404
							],
							[
								-6402
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N6H"
						},
						"arcs": [
							[
								-6415,
								-6421,
								6425,
								6426,
								-6215,
								-6230,
								-6425
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N6J"
						},
						"arcs": [
							[
								6427,
								6428,
								6429,
								-6426,
								-6420
							],
							[
								6430
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N6K"
						},
						"arcs": [
							[
								-6430,
								6431,
								-6206,
								-6427
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N6L"
						},
						"arcs": [
							[
								[
									-6423,
									6432,
									-6391,
									6433
								]
							],
							[
								[
									-6431
								]
							],
							[
								[
									6434,
									-6428,
									-6419,
									-6424
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N6M"
						},
						"arcs": [
							[
								6435,
								-6408,
								-6398,
								-6394,
								-6221
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N6N"
						},
						"arcs": [
							[
								-6392,
								-6433,
								-6422,
								-6409,
								-6436,
								-6220
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N6P"
						},
						"arcs": [
							[
								-6429,
								-6435,
								-6434,
								-6390,
								-6207,
								-6432
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N7A"
						},
						"arcs": [
							[
								-6234,
								6436,
								-6154,
								-6352,
								-6152
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N7G"
						},
						"arcs": [
							[
								-6213,
								-6235,
								-6231
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N7L"
						},
						"arcs": [
							[
								6437
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N7M"
						},
						"arcs": [
							[
								-6253
							],
							[
								-6438
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N7S"
						},
						"arcs": [
							[
								6438,
								6439,
								6440,
								6441,
								6442,
								6443
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N7T"
						},
						"arcs": [
							[
								6444,
								6445,
								-6442,
								6446,
								-6440,
								6447,
								6448,
								-6238
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N7V"
						},
						"arcs": [
							[
								-6446,
								6449,
								-6443
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N7W"
						},
						"arcs": [
							[
								-6441,
								-6447
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N7X"
						},
						"arcs": [
							[
								-6448,
								-6439,
								6450
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N8A"
						},
						"arcs": [
							[
								[
									6451,
									-6269,
									-6249
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N8H"
						},
						"arcs": [
							[
								6452,
								6453,
								-6241,
								6454,
								-6242,
								-6255,
								-6246
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N8M"
						},
						"arcs": [
							[
								-6265,
								6455
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N8N"
						},
						"arcs": [
							[
								-6266,
								-6456,
								-6264,
								6456,
								-6263,
								6457,
								6458,
								6459,
								6460,
								6461,
								6462
							],
							[
								6463
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N8P"
						},
						"arcs": [
							[
								[
									-6462,
									6464,
									6465,
									6466
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N8R"
						},
						"arcs": [
							[
								-6465,
								-6461,
								6467,
								6468
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N8S"
						},
						"arcs": [
							[
								-6466,
								-6469,
								6469,
								6470,
								6471
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N8T"
						},
						"arcs": [
							[
								-6470,
								-6468,
								-6460,
								6472,
								6473
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N8V"
						},
						"arcs": [
							[
								-6262,
								6474,
								-6458
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N8W"
						},
						"arcs": [
							[
								-6459,
								-6475,
								6475,
								6476,
								6477,
								6478,
								6479,
								-6473
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N8X"
						},
						"arcs": [
							[
								-6479,
								6480,
								6481,
								6482,
								6483
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N8Y"
						},
						"arcs": [
							[
								-6474,
								-6480,
								-6484,
								6484,
								6485,
								-6471
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N9A"
						},
						"arcs": [
							[
								[
									-6259,
									6486,
									6487,
									6488
								]
							],
							[
								[
									6489,
									6490,
									-6476,
									-6261
								]
							],
							[
								[
									-6483,
									6491,
									6492,
									-6485
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N9B"
						},
						"arcs": [
							[
								-6482,
								6493,
								6494,
								6495,
								-6492
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N9C"
						},
						"arcs": [
							[
								6496,
								6497,
								6498,
								-6495
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N9E"
						},
						"arcs": [
							[
								-6478,
								6499,
								6500,
								6501,
								-6497,
								-6494,
								-6481
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N9G"
						},
						"arcs": [
							[
								-6491,
								6502,
								-6500,
								-6477
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N9H"
						},
						"arcs": [
							[
								-6503,
								-6490,
								-6260,
								-6489,
								6503,
								-6501
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N9J"
						},
						"arcs": [
							[
								[
									-6504,
									-6488,
									6504,
									6505,
									-6498,
									-6502
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N9K"
						},
						"arcs": [
							[
								[
									-6457
								]
							],
							[
								[
									-6464
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "N9V"
						},
						"arcs": [
							[
								[
									-6487,
									-6258,
									6506,
									-6505
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "N9Y"
						},
						"arcs": [
							[
								-6243,
								-6455,
								-6240,
								-6454,
								6507,
								-6256
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0A"
						},
						"arcs": [
							[
								[
									-4837,
									6508,
									6509,
									6510,
									6511,
									-4800
								]
							],
							[
								[
									6512,
									6513,
									6514,
									6515,
									6516,
									6517,
									6518,
									6519
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0B"
						},
						"arcs": [
							[
								[
									6520,
									6521
								]
							],
							[
								[
									6522
								]
							],
							[
								[
									-6510,
									6523,
									6524,
									6525,
									6526,
									6527,
									-6514,
									6528
								],
								[
									6529
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0C"
						},
						"arcs": [
							[
								[
									6530,
									6531
								]
							],
							[
								[
									6532,
									6533
								]
							],
							[
								[
									6534,
									-6526,
									6535,
									6536,
									-5135,
									6537,
									-5133,
									6538,
									-5129,
									6539,
									6540,
									6541
								],
								[
									-5144
								]
							],
							[
								[
									6542
								]
							],
							[
								[
									6543,
									-6515,
									-6528
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0E"
						},
						"arcs": [
							[
								[
									-5128
								]
							],
							[
								[
									-5143,
									6544,
									-5120
								]
							],
							[
								[
									-5127,
									-5446,
									-5136,
									-6537,
									6545,
									-5124
								],
								[
									6546
								]
							],
							[
								[
									-5122,
									6547,
									-5131,
									-6538,
									-5134
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0G"
						},
						"arcs": [
							[
								[
									-6531,
									6548,
									-6541,
									6549
								]
							],
							[
								[
									-6533,
									6550
								]
							],
							[
								[
									-6517,
									6551
								]
							],
							[
								[
									6552,
									-6519,
									6553,
									6554,
									6555
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0H"
						},
						"arcs": [
							[
								[
									6556
								]
							],
							[
								[
									6557,
									-4270,
									-4801,
									-6512,
									6558,
									-6520,
									-6553,
									6559,
									6560,
									6561,
									6562,
									6563,
									6564
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P0J"
						},
						"arcs": [
							[
								-4273,
								-4692,
								-4271,
								-6558,
								6565,
								6566
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P0K"
						},
						"arcs": [
							[
								-4253,
								-4277,
								-4696,
								-4274,
								-6567,
								6567,
								6568,
								6569,
								6570,
								6571,
								6572,
								6573
							],
							[
								6574
							],
							[
								6575
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0L"
						},
						"arcs": [
							[
								[
									6576,
									-6569,
									6577
								]
							],
							[
								[
									-4254,
									-6574,
									6578,
									6579,
									6580,
									6581,
									6582,
									6583,
									6584,
									6585
								],
								[
									6586
								],
								[
									6587
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0M"
						},
						"arcs": [
							[
								[
									6588
								]
							],
							[
								[
									6589,
									6590
								]
							],
							[
								[
									6591
								]
							],
							[
								[
									6592
								]
							],
							[
								[
									6593
								]
							],
							[
								[
									6594
								]
							],
							[
								[
									6595
								]
							],
							[
								[
									6596,
									6597,
									-6560,
									-6556,
									6598,
									6599,
									6600,
									6601,
									6602,
									6603,
									6604,
									6605,
									-6581,
									6606,
									-6578,
									-6568,
									-6566,
									-6565
								],
								[
									6607,
									6608,
									6609,
									6610,
									6611,
									6612,
									6613,
									6614,
									6615,
									6616
								],
								[
									6617
								]
							],
							[
								[
									6618
								]
							],
							[
								[
									6619,
									6620,
									-6583
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0N"
						},
						"arcs": [
							[
								[
									-6572
								]
							],
							[
								[
									-6571,
									6621,
									-6579,
									-6573
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0P"
						},
						"arcs": [
							[
								[
									6622
								]
							],
							[
								[
									6623
								]
							],
							[
								[
									6624
								]
							],
							[
								[
									6625
								]
							],
							[
								[
									6626
								]
							],
							[
								[
									6627
								]
							],
							[
								[
									6628
								]
							],
							[
								[
									-6600,
									6629
								]
							],
							[
								[
									6630,
									6631
								]
							],
							[
								[
									6632
								]
							],
							[
								[
									6633,
									6634
								]
							],
							[
								[
									-6603,
									6635
								]
							],
							[
								[
									6636,
									6637,
									6638,
									6639,
									6640,
									-6604
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0R"
						},
						"arcs": [
							[
								[
									-6634,
									6641
								]
							],
							[
								[
									6642,
									6643
								]
							],
							[
								[
									-6641,
									6644,
									-6639,
									6645,
									6646,
									6647,
									6648,
									6649,
									6650,
									-6605
								],
								[
									6651
								],
								[
									6652
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0S"
						},
						"arcs": [
							[
								[
									-6653
								]
							],
							[
								[
									6653,
									-6643,
									6654,
									6655,
									-6647
								]
							],
							[
								[
									-6652
								]
							],
							[
								[
									6656
								]
							],
							[
								[
									-6606,
									-6651,
									6657,
									-6649,
									6658,
									6659,
									6660,
									6661,
									6662,
									-6620,
									-6582
								],
								[
									-6619
								],
								[
									-6593
								],
								[
									-6592
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0T"
						},
						"arcs": [
							[
								[
									6663
								]
							],
							[
								[
									6664
								]
							],
							[
								[
									6665,
									6666
								]
							],
							[
								[
									6667
								]
							],
							[
								[
									6668
								]
							],
							[
								[
									6669
								]
							],
							[
								[
									6670
								]
							],
							[
								[
									6671
								]
							],
							[
								[
									6672,
									6673
								]
							],
							[
								[
									-6621,
									-6663,
									6674,
									6675,
									6676,
									6677,
									6678,
									6679,
									6680,
									6681,
									6682,
									6683,
									6684,
									6685,
									6686,
									6687,
									6688,
									6689,
									-6584
								],
								[
									6690
								],
								[
									6691
								],
								[
									6692
								],
								[
									6693
								],
								[
									6694
								],
								[
									-6596
								],
								[
									-6595
								],
								[
									-6594
								]
							],
							[
								[
									6695,
									6696
								]
							],
							[
								[
									-6587
								]
							],
							[
								[
									6697
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0V"
						},
						"arcs": [
							[
								[
									6698,
									6699
								]
							],
							[
								[
									6700
								]
							],
							[
								[
									6701
								]
							],
							[
								[
									-6585,
									-6690,
									6702,
									6703,
									-6696,
									6704,
									6705,
									6706,
									6707,
									-6688,
									6708,
									-6686,
									6709,
									6710,
									6711,
									6712,
									6713,
									6714,
									6715,
									6716,
									6717,
									6718,
									6719,
									6720
								],
								[
									-6698
								],
								[
									6721
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0W"
						},
						"arcs": [
							[
								[
									-6694
								]
							],
							[
								[
									-6692
								]
							],
							[
								[
									-6691
								]
							],
							[
								[
									6722
								]
							],
							[
								[
									6723,
									6724,
									6725,
									6726
								]
							],
							[
								[
									6727,
									6728
								]
							],
							[
								[
									-6685,
									6729,
									-6683,
									6730,
									6731,
									6732,
									6733,
									-6710
								],
								[
									6734
								],
								[
									6735
								]
							],
							[
								[
									6736,
									6737
								]
							],
							[
								[
									6738,
									6739
								]
							],
							[
								[
									6740,
									6741
								]
							],
							[
								[
									6742,
									6743,
									6744,
									6745
								]
							],
							[
								[
									6746
								]
							],
							[
								[
									6747,
									6748,
									6749
								]
							],
							[
								[
									6750,
									6751
								]
							],
							[
								[
									6752,
									6753
								]
							],
							[
								[
									6754,
									6755
								]
							],
							[
								[
									6756,
									6757
								]
							],
							[
								[
									6758,
									6759
								]
							],
							[
								[
									6760,
									6761
								]
							],
							[
								[
									6762,
									6763
								]
							],
							[
								[
									6764,
									6765
								]
							],
							[
								[
									6766,
									6767
								]
							],
							[
								[
									6768,
									6769
								]
							],
							[
								[
									6770,
									6771
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P0X"
						},
						"arcs": [
							[
								[
									-6726,
									6772
								]
							],
							[
								[
									-6724,
									6773
								]
							],
							[
								[
									-6737,
									6774
								]
							],
							[
								[
									-6739,
									6775
								]
							],
							[
								[
									-6741,
									6776
								]
							],
							[
								[
									-6744,
									6777,
									-6748,
									6778,
									6779
								]
							],
							[
								[
									6780,
									6781
								]
							],
							[
								[
									6782,
									6783
								]
							],
							[
								[
									6784,
									6785
								]
							],
							[
								[
									6786,
									6787,
									6788,
									6789
								]
							],
							[
								[
									6790,
									6791
								]
							],
							[
								[
									6792,
									6793
								]
							],
							[
								[
									6794,
									6795
								]
							],
							[
								[
									6796,
									6797
								]
							],
							[
								[
									6798,
									6799
								]
							],
							[
								[
									6800,
									6801
								]
							],
							[
								[
									6802,
									6803
								]
							],
							[
								[
									6804,
									6805
								]
							],
							[
								[
									6806,
									6807
								]
							],
							[
								[
									6808,
									6809,
									6810,
									6811,
									6812,
									6813,
									6814,
									6815,
									6816,
									6817,
									6818
								]
							],
							[
								[
									6819,
									6820
								]
							],
							[
								[
									6821,
									6822
								]
							],
							[
								[
									6823,
									-6699,
									6824,
									-6711,
									-6734,
									6825,
									-6728,
									6826,
									-6746,
									6827,
									6828,
									6829,
									6830,
									6831,
									6832,
									6833,
									6834,
									6835,
									6836,
									6837,
									6838,
									-6713
								]
							],
							[
								[
									6839,
									6840
								]
							],
							[
								[
									6841,
									6842
								]
							],
							[
								[
									6843
								]
							],
							[
								[
									6844
								]
							],
							[
								[
									-6717,
									6845
								]
							],
							[
								[
									6846,
									-6715
								]
							],
							[
								[
									6847,
									-6706
								],
								[
									-6702
								],
								[
									-6701
								]
							],
							[
								[
									6848,
									6849,
									6850,
									6851,
									6852,
									6853,
									6854,
									6855,
									6856,
									6857,
									-6719
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P0Y"
						},
						"arcs": [
							[
								6858,
								6859,
								-6856
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P1A"
						},
						"arcs": [
							[
								-6562,
								6860,
								6861,
								6862
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P1B"
						},
						"arcs": [
							[
								-6863,
								6863,
								-6861,
								-6561,
								-6598,
								6864,
								-6563
							],
							[
								-6557
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P1C"
						},
						"arcs": [
							[
								-6862,
								-6864
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P1H"
						},
						"arcs": [
							[
								[
									-6530
								]
							],
							[
								[
									-6511,
									-6529,
									-6513,
									-6559
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P1L"
						},
						"arcs": [
							[
								-6509,
								-4836,
								6865,
								-6522,
								6866,
								-6524
							],
							[
								-6523
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P1P"
						},
						"arcs": [
							[
								[
									-6547
								]
							],
							[
								[
									-6521,
									-6866,
									-4835,
									-5125,
									-6546,
									-6536,
									-6525,
									-6867
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P2A"
						},
						"arcs": [
							[
								-6544,
								-6527,
								-6535,
								6867,
								-6554,
								-6518,
								-6552,
								-6516
							],
							[
								-6543
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P2B"
						},
						"arcs": [
							[
								-6865,
								-6597,
								-6564
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P2N"
						},
						"arcs": [
							[
								[
									-6576
								]
							],
							[
								[
									-6575
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P3A"
						},
						"arcs": [
							[
								-6608,
								6868,
								6869,
								6870,
								6871
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P3B"
						},
						"arcs": [
							[
								-6617,
								6872,
								6873,
								6874,
								-6869
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P3C"
						},
						"arcs": [
							[
								-6870,
								-6875,
								6875,
								-6612,
								6876
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P3E"
						},
						"arcs": [
							[
								[
									-6618
								]
							],
							[
								[
									6877,
									6878,
									-6615
								],
								[
									6879
								]
							],
							[
								[
									-6874,
									6880,
									6881,
									-6613,
									-6876
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P3G"
						},
						"arcs": [
							[
								[
									-6880
								]
							],
							[
								[
									-6879,
									6882,
									-6881,
									-6873,
									-6616
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P3L"
						},
						"arcs": [
							[
								-6872,
								6883,
								6884,
								-6609
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P3N"
						},
						"arcs": [
							[
								-6884,
								-6871,
								-6877,
								-6611,
								6885
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P3P"
						},
						"arcs": [
							[
								-6885,
								-6886,
								-6610
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P3Y"
						},
						"arcs": [
							[
								-6882,
								-6883,
								-6878,
								-6614
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P4N"
						},
						"arcs": [
							[
								[
									6886
								]
							],
							[
								[
									6887
								]
							],
							[
								[
									-6622,
									-6570,
									-6577,
									-6607,
									-6580
								],
								[
									6888
								],
								[
									6889
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P4P"
						},
						"arcs": [
							[
								-6889
							],
							[
								-6888
							],
							[
								-6887
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P4R"
						},
						"arcs": [
							[
								-6890
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P5A"
						},
						"arcs": [
							[
								-6640,
								-6645
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P5E"
						},
						"arcs": [
							[
								[
									-6636,
									-6602,
									6890,
									-6590,
									6891,
									-6632,
									6892,
									-6637
								],
								[
									-6633
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P5N"
						},
						"arcs": [
							[
								-6588
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P6A"
						},
						"arcs": [
							[
								[
									6893,
									-6661
								]
							],
							[
								[
									-6648,
									-6656,
									6894,
									6895,
									6896,
									6897,
									6898,
									-6659
								],
								[
									6899
								]
							],
							[
								[
									-6650,
									-6658
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P6B"
						},
						"arcs": [
							[
								6900,
								-6897
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P6C"
						},
						"arcs": [
							[
								[
									-6900
								]
							],
							[
								[
									-6901,
									-6896,
									6901,
									-6898
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P7A"
						},
						"arcs": [
							[
								[
									6902,
									6903
								]
							],
							[
								[
									6904,
									6905,
									6906,
									6907
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P7B"
						},
						"arcs": [
							[
								[
									-6906,
									6908,
									-6903,
									6909,
									6910,
									6911
								]
							],
							[
								[
									6912,
									-6678
								]
							],
							[
								[
									6913,
									-6667,
									6914,
									-6908,
									6915,
									-6676
								],
								[
									-6672
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P7C"
						},
						"arcs": [
							[
								[
									6916
								]
							],
							[
								[
									6917,
									6918,
									6919,
									6920,
									-6680
								]
							],
							[
								[
									6921,
									6922,
									6923,
									6924,
									6925,
									-6911
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P7E"
						},
						"arcs": [
							[
								[
									6926
								]
							],
							[
								[
									6927
								]
							],
							[
								[
									6928,
									6929,
									-6924
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P7G"
						},
						"arcs": [
							[
								-6907,
								-6912,
								-6926,
								6930,
								-6918,
								-6679,
								-6913,
								-6677,
								-6916
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P7J"
						},
						"arcs": [
							[
								[
									6931,
									-6920,
									6932,
									-6929,
									-6923,
									6933
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P7K"
						},
						"arcs": [
							[
								-6930,
								-6933,
								-6919,
								-6931,
								-6925
							],
							[
								-6917
							],
							[
								-6928
							],
							[
								-6927
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P7L"
						},
						"arcs": [
							[
								[
									6934
								]
							],
							[
								[
									-6932,
									6935,
									-6681,
									-6921
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P8N"
						},
						"arcs": [
							[
								[
									-6687,
									-6709
								]
							],
							[
								[
									-6722
								]
							],
							[
								[
									-6689,
									-6708,
									6936,
									-6674,
									6937,
									-6703
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "P8T"
						},
						"arcs": [
							[
								-6697,
								-6704,
								-6938,
								-6673,
								-6937,
								-6707,
								-6848,
								-6705
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P9A"
						},
						"arcs": [
							[
								[
									-6695
								]
							],
							[
								[
									-6693
								]
							],
							[
								[
									-6736
								]
							],
							[
								[
									6938,
									-6732
								]
							],
							[
								[
									-6735
								]
							],
							[
								[
									-6730,
									-6684
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "P9N"
						},
						"arcs": [
							[
								[
									-6759,
									6939
								]
							],
							[
								[
									-6757,
									6940
								]
							],
							[
								[
									-6787,
									6941
								]
							],
							[
								[
									6942
								]
							],
							[
								[
									-6944,
									6792,
									-6945,
									6794
								]
							],
							[
								[
									-6797,
									6945
								]
							],
							[
								[
									-6791,
									6946,
									-6785,
									6947,
									-6783,
									6948,
									-6781,
									6949,
									-6779,
									-6750,
									6950,
									-6751,
									6951,
									-6753,
									6952,
									-6755,
									6953,
									-6761,
									6954,
									-6772,
									6955,
									-6769,
									6956,
									-6767,
									6957,
									-6765,
									6958,
									-6763,
									6959
								]
							],
							[
								[
									-6961,
									6798,
									-6962,
									6828
								]
							],
							[
								[
									-6815,
									6962
								]
							],
							[
								[
									-6789,
									6963,
									6964,
									-6817,
									6965
								]
							],
							[
								[
									-6831,
									6966
								]
							],
							[
								[
									6967,
									-6813
								]
							],
							[
								[
									-6833,
									6968
								]
							],
							[
								[
									-6811,
									6969
								]
							],
							[
								[
									-6809,
									6970
								]
							],
							[
								[
									6971,
									-6835
								]
							],
							[
								[
									-6837,
									6972
								]
							],
							[
								[
									-6853,
									6973
								]
							],
							[
								[
									-6851,
									6974,
									-6822,
									6975
								]
							],
							[
								[
									-6842,
									6976
								]
							],
							[
								[
									-6847,
									-6714,
									-6839,
									6977,
									-6820,
									6978,
									-6841,
									6979,
									-6849,
									-6718,
									-6846,
									-6716
								],
								[
									-6845
								],
								[
									-6844
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R5H"
						},
						"arcs": [
							[
								6980,
								6981,
								6982,
								6983,
								6984,
								6985
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R0A"
						},
						"arcs": [
							[
								[
									6986,
									-9
								]
							],
							[
								[
									-6805,
									6987
								]
							],
							[
								[
									-6807,
									6988
								]
							],
							[
								[
									6989,
									-6981,
									6990,
									-6859,
									-6855,
									6991,
									-6803,
									6992,
									-6801,
									6993,
									-6818,
									-6965,
									6994,
									-7,
									-181,
									-172,
									-57,
									6995,
									-6985,
									6996,
									-6983,
									6997,
									6998
								],
								[
									6999
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R0B"
						},
						"arcs": [
							[
								[
									7000,
									-42
								]
							],
							[
								[
									7001
								],
								[
									7002
								]
							],
							[
								[
									-201
								]
							],
							[
								[
									-202
								]
							],
							[
								[
									-199
								]
							],
							[
								[
									-203
								]
							],
							[
								[
									-324,
									-191
								]
							],
							[
								[
									-194
								]
							],
							[
								[
									-196
								]
							],
							[
								[
									-49,
									-231,
									-200,
									-198,
									-230,
									-325,
									-193,
									-323,
									-276,
									7003,
									7004,
									-6720,
									-6858,
									7005,
									7006,
									-44,
									7007
								],
								[
									-195
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R0C"
						},
						"arcs": [
							[
								[
									7008,
									7009,
									-175,
									-135,
									-32,
									-45,
									-7007
								]
							],
							[
								[
									-7003
								]
							],
							[
								[
									-43,
									-7001,
									-7008
								],
								[
									-7002
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R0E"
						},
						"arcs": [
							[
								[
									-7000
								]
							],
							[
								[
									-6857,
									-6860,
									-6991,
									-6986,
									-6996,
									-56,
									7010,
									-7009,
									-7006
								]
							]
						]
					},
					{
						"type": "Polygon",
						"properties": {
							"fsa": "R1A"
						},
						"arcs": [
							[
								-65,
								-67,
								-137,
								-55,
								-136,
								-174,
								-7010,
								-7011
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "R5G"
						},
						"arcs": [
							[
								[
									-6999
								]
							],
							[
								[
									-6998,
									-6982,
									-6990
								]
							],
							[
								[
									-6997,
									-6984
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "X0B"
						},
						"arcs": [
							[
								[
									7011
								]
							],
							[
								[
									7012
								]
							],
							[
								[
									7013
								]
							],
							[
								[
									7014
								]
							],
							[
								[
									7015
								]
							],
							[
								[
									7016
								]
							],
							[
								[
									7017
								]
							],
							[
								[
									7018
								]
							],
							[
								[
									7019
								]
							],
							[
								[
									7020
								]
							],
							[
								[
									7021
								]
							],
							[
								[
									7022
								]
							],
							[
								[
									7023
								]
							],
							[
								[
									7024
								]
							],
							[
								[
									7025
								]
							],
							[
								[
									7026
								]
							],
							[
								[
									7027
								]
							],
							[
								[
									7028
								]
							],
							[
								[
									7029
								]
							],
							[
								[
									7030
								]
							],
							[
								[
									7031
								]
							],
							[
								[
									7032
								]
							],
							[
								[
									7033
								]
							],
							[
								[
									7034
								]
							],
							[
								[
									7035
								]
							],
							[
								[
									7036
								]
							],
							[
								[
									7037
								]
							],
							[
								[
									7038
								]
							],
							[
								[
									7039
								]
							],
							[
								[
									7040
								]
							],
							[
								[
									7041
								]
							],
							[
								[
									7042
								]
							],
							[
								[
									7043
								]
							],
							[
								[
									7044
								]
							],
							[
								[
									7045
								]
							],
							[
								[
									7046
								]
							],
							[
								[
									7047
								]
							],
							[
								[
									7048
								]
							],
							[
								[
									7049
								]
							],
							[
								[
									7050
								]
							],
							[
								[
									7051
								]
							],
							[
								[
									7052
								]
							],
							[
								[
									7053
								]
							],
							[
								[
									7054
								]
							],
							[
								[
									7055
								]
							],
							[
								[
									7056
								]
							],
							[
								[
									7057
								]
							],
							[
								[
									7058
								]
							],
							[
								[
									7059
								]
							],
							[
								[
									7060
								]
							],
							[
								[
									7061
								]
							],
							[
								[
									7062
								]
							],
							[
								[
									7063
								]
							],
							[
								[
									7064,
									7065,
									7066,
									7067,
									7068,
									7069
								]
							],
							[
								[
									7070,
									7071
								]
							],
							[
								[
									7072,
									7073
								]
							],
							[
								[
									7074,
									7075
								]
							],
							[
								[
									7076,
									7077
								]
							],
							[
								[
									7078,
									7079,
									7080,
									7081,
									7082,
									7083,
									7084,
									7085,
									7086,
									7087
								]
							],
							[
								[
									7088,
									7089
								]
							],
							[
								[
									7090,
									7091,
									7092,
									7093,
									7094,
									7095,
									7096,
									7097,
									7098,
									7099,
									7100,
									7101
								]
							],
							[
								[
									7102
								]
							],
							[
								[
									7103,
									7104,
									7105,
									7106,
									7107,
									7108
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "X0C"
						},
						"arcs": [
							[
								[
									7109
								]
							],
							[
								[
									7110
								]
							],
							[
								[
									7111
								]
							],
							[
								[
									7112
								]
							],
							[
								[
									7113
								]
							],
							[
								[
									7114
								]
							],
							[
								[
									7115
								]
							],
							[
								[
									7116
								]
							],
							[
								[
									7117
								]
							],
							[
								[
									7118
								]
							],
							[
								[
									7119,
									7120
								]
							],
							[
								[
									7121,
									7122
								]
							],
							[
								[
									7123,
									7124
								]
							],
							[
								[
									7125,
									7126,
									7127,
									7128,
									7129,
									7130,
									7131,
									7132,
									7133,
									7134,
									-7004,
									-1907,
									7135,
									-7068
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "X0E"
						},
						"arcs": [
							[
								[
									-1908
								]
							],
							[
								[
									7136
								]
							],
							[
								[
									7137
								]
							],
							[
								[
									7138
								]
							],
							[
								[
									7139
								]
							],
							[
								[
									7140
								]
							],
							[
								[
									7141
								]
							],
							[
								[
									7142
								]
							],
							[
								[
									-7069,
									-7136,
									-1906,
									-274,
									-693,
									-560,
									-1068,
									-1913,
									7143,
									7144,
									7145,
									7146,
									7147,
									7148,
									7149,
									7150
								],
								[
									-1905
								],
								[
									-1904
								]
							],
							[
								[
									7151
								]
							],
							[
								[
									7152
								]
							],
							[
								[
									7153
								]
							],
							[
								[
									-7093,
									7154
								]
							],
							[
								[
									-7097,
									7155
								]
							],
							[
								[
									-7099,
									7156
								]
							],
							[
								[
									-7073,
									7157
								]
							],
							[
								[
									-7095,
									7158
								]
							],
							[
								[
									-7101,
									7159
								]
							],
							[
								[
									-7091,
									7160
								]
							],
							[
								[
									7161
								]
							],
							[
								[
									7162
								]
							],
							[
								[
									7163
								]
							],
							[
								[
									7164,
									7165
								]
							],
							[
								[
									7166
								]
							],
							[
								[
									7167
								]
							],
							[
								[
									7168
								]
							],
							[
								[
									7169,
									7170
								]
							],
							[
								[
									7171,
									7172
								]
							],
							[
								[
									7173
								]
							],
							[
								[
									7174
								]
							],
							[
								[
									7175
								]
							],
							[
								[
									7176
								]
							],
							[
								[
									7177
								]
							],
							[
								[
									7178,
									7179
								]
							],
							[
								[
									7180,
									7181
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "Y0B"
						},
						"arcs": [
							[
								[
									-1914
								]
							],
							[
								[
									-1918,
									-1910
								]
							],
							[
								[
									-1915
								]
							],
							[
								[
									-1916
								]
							],
							[
								[
									-1917
								]
							],
							[
								[
									-7183,
									7147,
									-7184,
									7149
								]
							],
							[
								[
									-7146,
									7184
								]
							],
							[
								[
									7185
								]
							],
							[
								[
									-7144,
									-1912,
									-1919,
									-1065,
									7186
								]
							]
						]
					},
					{
						"type": "MultiPolygon",
						"properties": {
							"fsa": "X0A"
						},
						"arcs": [
							[
								[
									7187
								]
							],
							[
								[
									7188
								]
							],
							[
								[
									7189
								]
							],
							[
								[
									7190
								]
							],
							[
								[
									7191
								]
							],
							[
								[
									7192
								]
							],
							[
								[
									7193
								]
							],
							[
								[
									7194
								]
							],
							[
								[
									7195
								]
							],
							[
								[
									7196
								]
							],
							[
								[
									7197
								]
							],
							[
								[
									7198
								]
							],
							[
								[
									7199
								]
							],
							[
								[
									7200
								]
							],
							[
								[
									7201
								]
							],
							[
								[
									7202
								]
							],
							[
								[
									7203
								]
							],
							[
								[
									7204
								]
							],
							[
								[
									7205
								]
							],
							[
								[
									7206
								]
							],
							[
								[
									7207
								]
							],
							[
								[
									7208
								]
							],
							[
								[
									7209
								]
							],
							[
								[
									7210
								]
							],
							[
								[
									7211
								]
							],
							[
								[
									7212
								]
							],
							[
								[
									-4110,
									7213
								]
							],
							[
								[
									7214
								]
							],
							[
								[
									-4112,
									7215
								]
							],
							[
								[
									-4115,
									7216
								]
							],
							[
								[
									7217
								]
							],
							[
								[
									7218
								]
							],
							[
								[
									-2086,
									7219
								]
							],
							[
								[
									7220
								]
							],
							[
								[
									7221
								]
							],
							[
								[
									7222
								]
							],
							[
								[
									-4121,
									7223
								]
							],
							[
								[
									-4119,
									7224
								]
							],
							[
								[
									-4123,
									7225
								]
							],
							[
								[
									7226
								]
							],
							[
								[
									7227
								]
							],
							[
								[
									7228
								]
							],
							[
								[
									7229
								]
							],
							[
								[
									7230
								]
							],
							[
								[
									7231
								]
							],
							[
								[
									-4125,
									7232
								]
							],
							[
								[
									7233
								]
							],
							[
								[
									7234
								]
							],
							[
								[
									7235
								]
							],
							[
								[
									7236
								]
							],
							[
								[
									7237
								]
							],
							[
								[
									7238
								]
							],
							[
								[
									7239
								]
							],
							[
								[
									7240
								]
							],
							[
								[
									7241
								]
							],
							[
								[
									7242
								]
							],
							[
								[
									7243
								]
							],
							[
								[
									7244
								]
							],
							[
								[
									7245
								]
							],
							[
								[
									7246
								]
							],
							[
								[
									7247
								]
							],
							[
								[
									7248
								]
							],
							[
								[
									7249
								]
							],
							[
								[
									7250
								]
							],
							[
								[
									7251
								]
							],
							[
								[
									7252
								]
							],
							[
								[
									7253
								]
							],
							[
								[
									7254
								]
							],
							[
								[
									7255
								]
							],
							[
								[
									7256
								]
							],
							[
								[
									7257
								]
							],
							[
								[
									7258
								]
							],
							[
								[
									7259
								]
							],
							[
								[
									7260
								]
							],
							[
								[
									7261
								]
							],
							[
								[
									7262
								]
							],
							[
								[
									7263
								]
							],
							[
								[
									7264
								]
							],
							[
								[
									7265
								]
							],
							[
								[
									7266
								]
							],
							[
								[
									7267
								]
							],
							[
								[
									7268
								]
							],
							[
								[
									7269
								]
							],
							[
								[
									7270
								]
							],
							[
								[
									7271
								]
							],
							[
								[
									7272
								]
							],
							[
								[
									7273
								]
							],
							[
								[
									7274
								]
							],
							[
								[
									7275
								]
							],
							[
								[
									7276
								]
							],
							[
								[
									7277
								]
							],
							[
								[
									7278
								]
							],
							[
								[
									7279
								]
							],
							[
								[
									7280
								]
							],
							[
								[
									7281
								]
							],
							[
								[
									7282
								]
							],
							[
								[
									7283
								]
							],
							[
								[
									7284
								]
							],
							[
								[
									7285
								]
							],
							[
								[
									7286
								]
							],
							[
								[
									7287
								]
							],
							[
								[
									-7134,
									7288
								]
							],
							[
								[
									7289
								]
							],
							[
								[
									-7132,
									7290,
									-7130,
									7291
								]
							],
							[
								[
									7292
								]
							],
							[
								[
									7293
								]
							],
							[
								[
									7294
								]
							],
							[
								[
									7295
								]
							],
							[
								[
									-7124,
									7296
								]
							],
							[
								[
									-7128,
									7297,
									-7121,
									7298,
									-7122,
									7299
								]
							],
							[
								[
									7300
								]
							],
							[
								[
									7301
								]
							],
							[
								[
									7302
								]
							],
							[
								[
									7303
								]
							],
							[
								[
									7304
								]
							],
							[
								[
									7305
								]
							],
							[
								[
									7306
								]
							],
							[
								[
									7307
								]
							],
							[
								[
									7308
								]
							],
							[
								[
									7309
								]
							],
							[
								[
									7310
								]
							],
							[
								[
									7311
								]
							],
							[
								[
									7312
								]
							],
							[
								[
									7313
								]
							],
							[
								[
									7314
								]
							],
							[
								[
									7315
								]
							],
							[
								[
									7316
								]
							],
							[
								[
									7317
								]
							],
							[
								[
									7318
								]
							],
							[
								[
									7319
								]
							],
							[
								[
									7320
								]
							],
							[
								[
									7321
								]
							],
							[
								[
									7322
								]
							],
							[
								[
									7323
								]
							],
							[
								[
									7324
								]
							],
							[
								[
									7325
								]
							],
							[
								[
									7326
								]
							],
							[
								[
									7327
								]
							],
							[
								[
									7328
								]
							],
							[
								[
									-7065,
									7329
								]
							],
							[
								[
									7330
								]
							],
							[
								[
									7331
								]
							],
							[
								[
									7332
								]
							],
							[
								[
									7333
								]
							],
							[
								[
									7334
								]
							],
							[
								[
									7335
								]
							],
							[
								[
									7336
								]
							],
							[
								[
									7337
								]
							],
							[
								[
									7338
								]
							],
							[
								[
									7339
								]
							],
							[
								[
									7340
								]
							],
							[
								[
									7341
								]
							],
							[
								[
									-7126,
									-7067,
									7342
								]
							],
							[
								[
									7343
								]
							],
							[
								[
									7344
								]
							],
							[
								[
									7345
								]
							],
							[
								[
									7346
								]
							],
							[
								[
									7347
								]
							],
							[
								[
									7348
								]
							],
							[
								[
									7349
								]
							],
							[
								[
									7350
								]
							],
							[
								[
									7351
								]
							],
							[
								[
									7352
								]
							],
							[
								[
									7353
								]
							],
							[
								[
									7354
								]
							],
							[
								[
									-7087,
									7355
								]
							],
							[
								[
									-7077,
									7356
								]
							],
							[
								[
									-7085,
									7357
								]
							],
							[
								[
									-7083,
									7358
								]
							],
							[
								[
									-7075,
									7359
								]
							],
							[
								[
									7360
								]
							],
							[
								[
									-7081,
									7361
								]
							],
							[
								[
									7362
								]
							],
							[
								[
									7363
								]
							],
							[
								[
									7364
								]
							],
							[
								[
									-7108,
									7365
								]
							],
							[
								[
									-7106,
									7366
								]
							],
							[
								[
									7367
								]
							],
							[
								[
									-7104,
									7368
								]
							],
							[
								[
									7369
								]
							],
							[
								[
									-7079,
									7370,
									-7090,
									7371
								]
							],
							[
								[
									7372
								]
							],
							[
								[
									7373
								]
							],
							[
								[
									-7071,
									7374
								]
							],
							[
								[
									7375
								]
							],
							[
								[
									7376
								]
							],
							[
								[
									7377
								]
							],
							[
								[
									7378
								]
							],
							[
								[
									7379
								]
							],
							[
								[
									7380
								]
							],
							[
								[
									7381
								]
							],
							[
								[
									7382
								]
							],
							[
								[
									7383
								]
							],
							[
								[
									7384
								]
							],
							[
								[
									7385
								]
							],
							[
								[
									7386
								]
							],
							[
								[
									7387
								]
							],
							[
								[
									7388
								]
							],
							[
								[
									7389
								]
							],
							[
								[
									7390
								]
							],
							[
								[
									7391
								]
							],
							[
								[
									7392
								]
							],
							[
								[
									7393
								]
							],
							[
								[
									7394
								]
							],
							[
								[
									7395
								]
							],
							[
								[
									7396
								]
							],
							[
								[
									7397
								]
							],
							[
								[
									7398
								]
							],
							[
								[
									-7172,
									7399,
									-7165,
									7400,
									-7170,
									7401
								]
							],
							[
								[
									7402
								]
							],
							[
								[
									7403
								]
							],
							[
								[
									7404
								]
							],
							[
								[
									7405
								]
							],
							[
								[
									7406
								]
							],
							[
								[
									7407
								]
							],
							[
								[
									7408
								]
							],
							[
								[
									7409
								]
							],
							[
								[
									7410
								]
							],
							[
								[
									7411
								]
							],
							[
								[
									7412
								]
							],
							[
								[
									7413
								]
							],
							[
								[
									7414
								]
							],
							[
								[
									-7179,
									7415
								]
							],
							[
								[
									7416
								]
							],
							[
								[
									7417
								]
							],
							[
								[
									7418
								]
							],
							[
								[
									7419
								]
							],
							[
								[
									-7181,
									7420
								]
							],
							[
								[
									7421
								]
							],
							[
								[
									7422
								]
							],
							[
								[
									7423
								]
							],
							[
								[
									7424
								]
							],
							[
								[
									7425
								]
							],
							[
								[
									7426
								]
							],
							[
								[
									7427
								]
							],
							[
								[
									7428
								]
							],
							[
								[
									7429
								]
							],
							[
								[
									7430
								]
							],
							[
								[
									7431
								]
							]
						]
					}
				]
			}
		},
		"arcs": [
			[
				[
					4926857,
					1967655
				],
				[
					4160,
					-7835
				]
			],
			[
				[
					4931017,
					1959820
				],
				[
					8984,
					832
				]
			],
			[
				[
					4940001,
					1960652
				],
				[
					10693,
					793
				]
			],
			[
				[
					4950694,
					1961445
				],
				[
					3991,
					-17331
				]
			],
			[
				[
					4954685,
					1944114
				],
				[
					-45,
					-6489
				]
			],
			[
				[
					4954640,
					1937625
				],
				[
					11669,
					-9580
				],
				[
					-221,
					-12888
				]
			],
			[
				[
					4966088,
					1915157
				],
				[
					200,
					-21360
				],
				[
					-10105,
					-32
				],
				[
					2137,
					-10686
				],
				[
					29,
					-53370
				],
				[
					-10199,
					-3510
				],
				[
					4997,
					-14350
				],
				[
					-5221,
					-10
				],
				[
					8941,
					-35591
				],
				[
					-9321,
					55
				],
				[
					2773,
					-10837
				]
			],
			[
				[
					4950319,
					1765466
				],
				[
					-7629,
					14
				]
			],
			[
				[
					4942690,
					1765480
				],
				[
					18,
					18201
				],
				[
					-7606,
					3276
				],
				[
					2588,
					-21474
				]
			],
			[
				[
					4937690,
					1765483
				],
				[
					-55855,
					127
				]
			],
			[
				[
					4881835,
					1765610
				],
				[
					7593,
					3656
				],
				[
					-41,
					28383
				],
				[
					-5082,
					13
				],
				[
					-221,
					14246
				],
				[
					5071,
					10668
				],
				[
					-5088,
					7031
				],
				[
					-23052,
					43
				],
				[
					-2560,
					-3577
				]
			],
			[
				[
					4858455,
					1826073
				],
				[
					-2469,
					-7095
				]
			],
			[
				[
					4855986,
					1818978
				],
				[
					-2560,
					-10
				]
			],
			[
				[
					4853426,
					1818968
				],
				[
					-14841,
					-14240
				],
				[
					2582,
					-28464
				],
				[
					-5109,
					-10730
				]
			],
			[
				[
					4836058,
					1765534
				],
				[
					-65987,
					-52
				]
			],
			[
				[
					4770071,
					1765482
				],
				[
					10131,
					3609
				],
				[
					5069,
					14278
				],
				[
					-7617,
					14047
				],
				[
					-7718,
					221
				],
				[
					-2552,
					10689
				],
				[
					-22423,
					3568
				],
				[
					-6915,
					14260
				],
				[
					2822,
					21341
				],
				[
					15147,
					-14572
				],
				[
					2507,
					28882
				],
				[
					5087,
					7241
				],
				[
					-7625,
					3467
				],
				[
					2517,
					10747
				],
				[
					-3373,
					24760
				],
				[
					-12939,
					-57
				],
				[
					20,
					50091
				]
			],
			[
				[
					4742209,
					1958054
				],
				[
					12832,
					-97
				],
				[
					2701,
					-14309
				],
				[
					17866,
					55
				],
				[
					2607,
					7169
				],
				[
					34792,
					7071
				]
			],
			[
				[
					4813007,
					1957943
				],
				[
					37325,
					66
				]
			],
			[
				[
					4850332,
					1958009
				],
				[
					30890,
					-69
				],
				[
					5124,
					7132
				],
				[
					10314,
					-3550
				],
				[
					5144,
					7158
				]
			],
			[
				[
					4901804,
					1968680
				],
				[
					12836,
					3615
				],
				[
					8043,
					-10254
				],
				[
					4174,
					5614
				]
			],
			[
				[
					4845689,
					1825786
				],
				[
					0,
					0
				]
			],
			[
				[
					4835443,
					1986884
				],
				[
					0,
					0
				]
			],
			[
				[
					4935393,
					2011488
				],
				[
					5188,
					-3595
				],
				[
					2692,
					-18393
				]
			],
			[
				[
					4943273,
					1989500
				],
				[
					2,
					-344
				]
			],
			[
				[
					4943275,
					1989156
				],
				[
					-15695,
					-1005
				]
			],
			[
				[
					4927580,
					1988151
				],
				[
					-8098,
					1813
				],
				[
					-25955,
					19651
				]
			],
			[
				[
					4893527,
					2009615
				],
				[
					5186,
					-4003
				],
				[
					3091,
					-36932
				]
			],
			[
				[
					4850332,
					1958009
				],
				[
					5110,
					17793
				],
				[
					-553,
					14325
				],
				[
					-7746,
					13691
				],
				[
					-48,
					36127
				],
				[
					15499,
					38
				],
				[
					-5,
					24768
				],
				[
					-11251,
					54
				],
				[
					-20771,
					-12591
				],
				[
					-20336,
					3591
				],
				[
					-7249,
					7908
				],
				[
					1301,
					-13048
				],
				[
					9135,
					-65
				],
				[
					7720,
					-14276
				],
				[
					7,
					-17513
				],
				[
					-18246,
					-7259
				],
				[
					80,
					-25216
				],
				[
					15570,
					3642
				],
				[
					-5542,
					-32035
				]
			],
			[
				[
					4742209,
					1958054
				],
				[
					-13,
					21272
				],
				[
					-3906,
					3730
				],
				[
					1504,
					31992
				],
				[
					-22408,
					-126
				],
				[
					-22,
					7170
				]
			],
			[
				[
					4717364,
					2022092
				],
				[
					23428,
					68
				],
				[
					7802,
					7069
				],
				[
					18096,
					-7027
				],
				[
					2602,
					10605
				],
				[
					7718,
					-40
				],
				[
					-7741,
					10680
				],
				[
					3728,
					21560
				],
				[
					-4879,
					-83
				],
				[
					-107,
					64001
				],
				[
					2573,
					14214
				],
				[
					-15586,
					-17
				],
				[
					-1397,
					17809
				],
				[
					-7741,
					-45
				],
				[
					-25,
					10876
				],
				[
					-15970,
					-59
				],
				[
					108,
					21410
				],
				[
					-7864,
					19353
				]
			],
			[
				[
					4722109,
					2212466
				],
				[
					-1634,
					44362
				],
				[
					-7931,
					3728
				],
				[
					21167,
					-84
				],
				[
					13438,
					-9343
				],
				[
					11824,
					2399
				],
				[
					1599,
					-14714
				],
				[
					11005,
					-2064
				],
				[
					-1910,
					25393
				],
				[
					7459,
					6326
				]
			],
			[
				[
					4777126,
					2268469
				],
				[
					-950,
					-13193
				],
				[
					4204,
					-28346
				],
				[
					5863,
					-6276
				],
				[
					23695,
					-1950
				],
				[
					22834,
					-27952
				],
				[
					3594,
					-12951
				],
				[
					13404,
					-20657
				],
				[
					3918,
					-24135
				],
				[
					5741,
					1386
				],
				[
					11165,
					-24050
				],
				[
					754,
					-20775
				],
				[
					-6619,
					-8826
				],
				[
					36,
					-15989
				],
				[
					15978,
					75
				],
				[
					23,
					-10751
				],
				[
					7777,
					3624
				],
				[
					7825,
					-7126
				],
				[
					18,
					-14225
				],
				[
					18150,
					-17806
				],
				[
					20857,
					-7058
				]
			],
			[
				[
					4609189,
					2235530
				],
				[
					47639,
					-39
				]
			],
			[
				[
					4656828,
					2235491
				],
				[
					2050,
					-21230
				],
				[
					18504,
					120
				],
				[
					-19,
					7224
				],
				[
					15678,
					-143
				],
				[
					5298,
					14137
				],
				[
					-22,
					-14198
				],
				[
					23792,
					-8935
				]
			],
			[
				[
					4717364,
					2022092
				],
				[
					-15688,
					56
				],
				[
					63,
					10504
				],
				[
					-28248,
					3600
				],
				[
					29,
					-14352
				],
				[
					-20820,
					243
				],
				[
					22,
					14219
				],
				[
					-5160,
					-32
				],
				[
					-23,
					17823
				],
				[
					-15521,
					-303
				],
				[
					-2587,
					10699
				],
				[
					-15334,
					16
				],
				[
					73,
					21418
				],
				[
					-34085,
					-140
				]
			],
			[
				[
					4580085,
					2085843
				],
				[
					-28740,
					11
				],
				[
					22,
					36345
				],
				[
					-10448,
					6579
				],
				[
					17,
					-14332
				],
				[
					-10492,
					17875
				],
				[
					-15526,
					-3665
				],
				[
					5023,
					-10769
				],
				[
					-15393,
					-7034
				],
				[
					-2686,
					17830
				],
				[
					-10413,
					-7203
				],
				[
					-5157,
					28510
				],
				[
					-13060,
					47
				]
			],
			[
				[
					4473232,
					2150037
				],
				[
					-3843,
					-227
				],
				[
					82,
					85621
				],
				[
					-3339,
					-15
				],
				[
					-144,
					42941
				]
			],
			[
				[
					4465988,
					2278357
				],
				[
					42316,
					-89
				],
				[
					-1283,
					-17143
				],
				[
					22456,
					3028
				],
				[
					257,
					-28784
				],
				[
					79455,
					161
				]
			],
			[
				[
					4770071,
					1765482
				],
				[
					-73386,
					-19
				],
				[
					-89168,
					11
				]
			],
			[
				[
					4607517,
					1765474
				],
				[
					-127,
					35540
				],
				[
					7756,
					7441
				],
				[
					-9964,
					3701
				],
				[
					21,
					81881
				],
				[
					-17460,
					-174
				],
				[
					-162,
					14344
				],
				[
					-12779,
					19
				],
				[
					8,
					17970
				],
				[
					12904,
					-101
				],
				[
					2514,
					17814
				],
				[
					7873,
					-65
				],
				[
					-2576,
					21286
				],
				[
					-7701,
					3944
				],
				[
					2618,
					42226
				],
				[
					-5175,
					-8
				],
				[
					80,
					70999
				],
				[
					-5262,
					3552
				]
			],
			[
				[
					4642311,
					2000690
				],
				[
					87,
					7042
				],
				[
					-15586,
					-10
				],
				[
					-5242,
					-28394
				],
				[
					-6742,
					22
				],
				[
					3694,
					-35493
				],
				[
					-7639,
					-7158
				],
				[
					23115,
					-41
				],
				[
					-37,
					-10650
				],
				[
					20734,
					-7231
				],
				[
					-5066,
					17857
				],
				[
					30915,
					-63
				],
				[
					-81,
					19739
				],
				[
					-7746,
					1682
				],
				[
					2587,
					14212
				],
				[
					-10260,
					79
				],
				[
					5772,
					14163
				],
				[
					-7781,
					11
				],
				[
					-2584,
					10667
				],
				[
					-18140,
					3566
				]
			],
			[
				[
					4637499,
					2733290
				],
				[
					10589,
					-9571
				]
			],
			[
				[
					4648088,
					2723719
				],
				[
					18843,
					-2813
				],
				[
					1045,
					-13000
				],
				[
					32551,
					-858
				],
				[
					8716,
					6699
				],
				[
					15689,
					-5865
				],
				[
					7737,
					2556
				]
			],
			[
				[
					4732669,
					2710438
				],
				[
					8027,
					-12333
				],
				[
					8608,
					835
				],
				[
					16783,
					-68879
				],
				[
					582,
					-26973
				],
				[
					-3629,
					-13617
				],
				[
					2671,
					-17273
				],
				[
					-4269,
					-19238
				],
				[
					3318,
					-8038
				]
			],
			[
				[
					4764760,
					2544922
				],
				[
					-15646,
					43
				],
				[
					453,
					-62877
				],
				[
					1664,
					-41571
				],
				[
					-8034,
					7
				],
				[
					-123,
					-13932
				],
				[
					24014,
					-58
				],
				[
					-11,
					-12609
				],
				[
					-10017,
					5194
				],
				[
					-6528,
					-12311
				],
				[
					8482,
					-20139
				],
				[
					4941,
					4394
				],
				[
					-1136,
					-25248
				],
				[
					3367,
					-22174
				],
				[
					-712,
					-18662
				],
				[
					-8249,
					19431
				],
				[
					-4916,
					32856
				],
				[
					-14873,
					-310
				],
				[
					7521,
					-62955
				],
				[
					9072,
					-16010
				],
				[
					15298,
					16521
				],
				[
					1068,
					-19792
				],
				[
					-3478,
					-6954
				],
				[
					1874,
					-22660
				],
				[
					8335,
					3363
				]
			],
			[
				[
					4656828,
					2235491
				],
				[
					-462,
					117198
				],
				[
					-15526,
					3576
				],
				[
					5220,
					-31494
				],
				[
					-13246,
					-3774
				],
				[
					181,
					-14476
				],
				[
					-10564,
					-3561
				],
				[
					-2702,
					7266
				],
				[
					-10546,
					-21
				],
				[
					2497,
					-21538
				],
				[
					-2518,
					-17638
				],
				[
					8011,
					-24942
				],
				[
					-7982,
					-18
				],
				[
					-2,
					-10539
				]
			],
			[
				[
					4465988,
					2278357
				],
				[
					19,
					42352
				],
				[
					-3541,
					40
				],
				[
					-802,
					160817
				],
				[
					-3616,
					-26
				],
				[
					177,
					84394
				],
				[
					-3378,
					1
				]
			],
			[
				[
					4454847,
					2565935
				],
				[
					118,
					84171
				],
				[
					-3835,
					-46
				],
				[
					-145,
					83065
				]
			],
			[
				[
					4450985,
					2733125
				],
				[
					121578,
					-111
				],
				[
					64936,
					276
				]
			],
			[
				[
					4607517,
					1765474
				],
				[
					-121523,
					9
				]
			],
			[
				[
					4485994,
					1765483
				],
				[
					-13,
					42981
				],
				[
					-3412,
					28
				],
				[
					-6,
					85416
				],
				[
					-2923,
					58
				],
				[
					8,
					42657
				]
			],
			[
				[
					4479648,
					1936623
				],
				[
					-77,
					42839
				],
				[
					-3268,
					28
				],
				[
					241,
					85177
				],
				[
					-3554,
					-21
				]
			],
			[
				[
					4472990,
					2064646
				],
				[
					242,
					85391
				]
			],
			[
				[
					4987220,
					2027224
				],
				[
					-705,
					-1215
				]
			],
			[
				[
					4986515,
					2026009
				],
				[
					705,
					1215
				]
			],
			[
				[
					4986178,
					2011556
				],
				[
					11136,
					-11053
				],
				[
					-13678,
					-33813
				]
			],
			[
				[
					4983636,
					1966690
				],
				[
					-1993,
					-2856
				]
			],
			[
				[
					4981643,
					1963834
				],
				[
					-5174,
					4205
				]
			],
			[
				[
					4976469,
					1968039
				],
				[
					-5142,
					14274
				]
			],
			[
				[
					4971327,
					1982313
				],
				[
					883,
					-339
				]
			],
			[
				[
					4972210,
					1981974
				],
				[
					1547,
					696
				]
			],
			[
				[
					4973757,
					1982670
				],
				[
					2927,
					7297
				]
			],
			[
				[
					4976684,
					1989967
				],
				[
					3064,
					-56
				]
			],
			[
				[
					4979748,
					1989911
				],
				[
					3368,
					16678
				]
			],
			[
				[
					4983116,
					2006589
				],
				[
					3062,
					4967
				]
			],
			[
				[
					4981630,
					1971059
				],
				[
					0,
					0
				]
			],
			[
				[
					4982160,
					2007526
				],
				[
					956,
					-937
				]
			],
			[
				[
					4979748,
					1989911
				],
				[
					-8193,
					7812
				]
			],
			[
				[
					4971555,
					1997723
				],
				[
					537,
					1348
				]
			],
			[
				[
					4972092,
					1999071
				],
				[
					3755,
					14535
				]
			],
			[
				[
					4975847,
					2013606
				],
				[
					6313,
					-6080
				]
			],
			[
				[
					4976684,
					1989967
				],
				[
					-2641,
					-1988
				]
			],
			[
				[
					4974043,
					1987979
				],
				[
					-5924,
					4240
				]
			],
			[
				[
					4968119,
					1992219
				],
				[
					3436,
					5504
				]
			],
			[
				[
					4967490,
					1983186
				],
				[
					282,
					-6659
				]
			],
			[
				[
					4967772,
					1976527
				],
				[
					-1414,
					-1101
				]
			],
			[
				[
					4966358,
					1975426
				],
				[
					-1903,
					3697
				]
			],
			[
				[
					4964455,
					1979123
				],
				[
					647,
					1342
				]
			],
			[
				[
					4965102,
					1980465
				],
				[
					2110,
					2751
				]
			],
			[
				[
					4967212,
					1983216
				],
				[
					278,
					-30
				]
			],
			[
				[
					4976469,
					1968039
				],
				[
					-6990,
					-94
				]
			],
			[
				[
					4969479,
					1967945
				],
				[
					-1707,
					8582
				]
			],
			[
				[
					4967490,
					1983186
				],
				[
					3837,
					-873
				]
			],
			[
				[
					4972210,
					1981974
				],
				[
					-211,
					1201
				]
			],
			[
				[
					4971999,
					1983175
				],
				[
					1758,
					-505
				]
			],
			[
				[
					4974043,
					1987979
				],
				[
					-2332,
					-4607
				]
			],
			[
				[
					4971711,
					1983372
				],
				[
					-5621,
					4030
				]
			],
			[
				[
					4966090,
					1987402
				],
				[
					947,
					1443
				]
			],
			[
				[
					4967037,
					1988845
				],
				[
					1082,
					3374
				]
			],
			[
				[
					4971711,
					1983372
				],
				[
					288,
					-197
				]
			],
			[
				[
					4967212,
					1983216
				],
				[
					-725,
					91
				]
			],
			[
				[
					4966487,
					1983307
				],
				[
					-397,
					4095
				]
			],
			[
				[
					4969479,
					1967945
				],
				[
					301,
					-2135
				]
			],
			[
				[
					4969780,
					1965810
				],
				[
					-3387,
					-3810
				]
			],
			[
				[
					4966393,
					1962000
				],
				[
					-2961,
					9504
				]
			],
			[
				[
					4963432,
					1971504
				],
				[
					2926,
					3922
				]
			],
			[
				[
					4973967,
					1956651
				],
				[
					-8956,
					-11304
				]
			],
			[
				[
					4965011,
					1945347
				],
				[
					-773,
					9383
				]
			],
			[
				[
					4964238,
					1954730
				],
				[
					2155,
					7270
				]
			],
			[
				[
					4969780,
					1965810
				],
				[
					4187,
					-9159
				]
			],
			[
				[
					4967433,
					2003499
				],
				[
					-5657,
					-10565
				]
			],
			[
				[
					4961776,
					1992934
				],
				[
					-4333,
					2085
				]
			],
			[
				[
					4957443,
					1995019
				],
				[
					-1324,
					2196
				]
			],
			[
				[
					4956119,
					1997215
				],
				[
					2592,
					7157
				]
			],
			[
				[
					4958711,
					2004372
				],
				[
					8722,
					-873
				]
			],
			[
				[
					4957443,
					1995019
				],
				[
					-6,
					-6705
				]
			],
			[
				[
					4957437,
					1988314
				],
				[
					-428,
					-1778
				]
			],
			[
				[
					4957009,
					1986536
				],
				[
					-1870,
					-1
				]
			],
			[
				[
					4955139,
					1986535
				],
				[
					-3780,
					3555
				]
			],
			[
				[
					4951359,
					1990090
				],
				[
					4760,
					7125
				]
			],
			[
				[
					4967037,
					1988845
				],
				[
					-3832,
					2267
				]
			],
			[
				[
					4963205,
					1991112
				],
				[
					-1429,
					1822
				]
			],
			[
				[
					4967433,
					2003499
				],
				[
					4659,
					-4428
				]
			],
			[
				[
					4966487,
					1983307
				],
				[
					-2753,
					945
				]
			],
			[
				[
					4963734,
					1984252
				],
				[
					-1298,
					868
				]
			],
			[
				[
					4962436,
					1985120
				],
				[
					-1109,
					759
				]
			],
			[
				[
					4961327,
					1985879
				],
				[
					1878,
					5233
				]
			],
			[
				[
					4961327,
					1985879
				],
				[
					-3890,
					2435
				]
			],
			[
				[
					4945320,
					1979037
				],
				[
					0,
					0
				]
			],
			[
				[
					4944946,
					1978714
				],
				[
					0,
					0
				]
			],
			[
				[
					4949664,
					1986479
				],
				[
					-1724,
					-8866
				]
			],
			[
				[
					4947940,
					1977613
				],
				[
					-5245,
					260
				]
			],
			[
				[
					4942695,
					1977873
				],
				[
					580,
					11283
				]
			],
			[
				[
					4943273,
					1989500
				],
				[
					6391,
					-3021
				]
			],
			[
				[
					4963734,
					1984252
				],
				[
					-2100,
					-1430
				]
			],
			[
				[
					4961634,
					1982822
				],
				[
					802,
					2298
				]
			],
			[
				[
					4965102,
					1980465
				],
				[
					-3752,
					-789
				]
			],
			[
				[
					4961350,
					1979676
				],
				[
					68,
					2062
				]
			],
			[
				[
					4961418,
					1981738
				],
				[
					216,
					1084
				]
			],
			[
				[
					4964455,
					1979123
				],
				[
					-2248,
					-2107
				]
			],
			[
				[
					4962207,
					1977016
				],
				[
					-1013,
					319
				]
			],
			[
				[
					4961194,
					1977335
				],
				[
					156,
					2341
				]
			],
			[
				[
					4958698,
					2022069
				],
				[
					13,
					-17697
				]
			],
			[
				[
					4951359,
					1990090
				],
				[
					-1695,
					-3611
				]
			],
			[
				[
					4935393,
					2011488
				],
				[
					12930,
					10613
				],
				[
					10375,
					-32
				]
			],
			[
				[
					4975847,
					2013606
				],
				[
					10668,
					12403
				]
			],
			[
				[
					4987220,
					2027224
				],
				[
					-5060,
					-19698
				]
			],
			[
				[
					4961418,
					1981738
				],
				[
					-4575,
					301
				]
			],
			[
				[
					4956843,
					1982039
				],
				[
					166,
					4497
				]
			],
			[
				[
					4956686,
					1977797
				],
				[
					-188,
					2488
				]
			],
			[
				[
					4956498,
					1980285
				],
				[
					345,
					1754
				]
			],
			[
				[
					4961194,
					1977335
				],
				[
					-1548,
					-442
				]
			],
			[
				[
					4959646,
					1976893
				],
				[
					-2959,
					124
				]
			],
			[
				[
					4956687,
					1977017
				],
				[
					-1,
					780
				]
			],
			[
				[
					4956498,
					1980285
				],
				[
					-1359,
					6250
				]
			],
			[
				[
					4956686,
					1977797
				],
				[
					0,
					0
				]
			],
			[
				[
					4956687,
					1977017
				],
				[
					-727,
					-888
				]
			],
			[
				[
					4955960,
					1976129
				],
				[
					-4711,
					-1273
				]
			],
			[
				[
					4951249,
					1974856
				],
				[
					-3328,
					370
				]
			],
			[
				[
					4947921,
					1975226
				],
				[
					19,
					2387
				]
			],
			[
				[
					4947921,
					1975226
				],
				[
					-5264,
					-140
				]
			],
			[
				[
					4942657,
					1975086
				],
				[
					38,
					2787
				]
			],
			[
				[
					4963432,
					1971504
				],
				[
					-1118,
					-476
				]
			],
			[
				[
					4962314,
					1971028
				],
				[
					-107,
					5988
				]
			],
			[
				[
					4957485,
					1969771
				],
				[
					0,
					0
				]
			],
			[
				[
					4962314,
					1971028
				],
				[
					-3078,
					-1285
				]
			],
			[
				[
					4959236,
					1969743
				],
				[
					-580,
					939
				]
			],
			[
				[
					4958656,
					1970682
				],
				[
					990,
					6211
				]
			],
			[
				[
					4958656,
					1970682
				],
				[
					-2696,
					5447
				]
			],
			[
				[
					4959236,
					1969743
				],
				[
					-107,
					-4072
				]
			],
			[
				[
					4959129,
					1965671
				],
				[
					-6789,
					-3734
				]
			],
			[
				[
					4952340,
					1961937
				],
				[
					-1278,
					6934
				]
			],
			[
				[
					4951062,
					1968871
				],
				[
					187,
					5985
				]
			],
			[
				[
					4951062,
					1968871
				],
				[
					-8256,
					-1040
				]
			],
			[
				[
					4942806,
					1967831
				],
				[
					-149,
					7255
				]
			],
			[
				[
					4952340,
					1961937
				],
				[
					-1646,
					-492
				]
			],
			[
				[
					4940001,
					1960652
				],
				[
					2805,
					7179
				]
			],
			[
				[
					4964238,
					1954730
				],
				[
					-4389,
					-3278
				]
			],
			[
				[
					4959849,
					1951452
				],
				[
					-720,
					14219
				]
			],
			[
				[
					4965011,
					1945347
				],
				[
					-10371,
					-7722
				]
			],
			[
				[
					4954685,
					1944114
				],
				[
					5164,
					7338
				]
			],
			[
				[
					4981643,
					1963834
				],
				[
					-3973,
					-5994
				]
			],
			[
				[
					4977670,
					1957840
				],
				[
					-3703,
					-1189
				]
			],
			[
				[
					4966492,
					2022036
				],
				[
					9355,
					-8430
				]
			],
			[
				[
					4958698,
					2022069
				],
				[
					7794,
					-33
				]
			],
			[
				[
					4931017,
					1959820
				],
				[
					2201,
					17084
				],
				[
					-4462,
					902
				]
			],
			[
				[
					4928756,
					1977806
				],
				[
					-1176,
					10345
				]
			],
			[
				[
					4926857,
					1967655
				],
				[
					1807,
					7857
				]
			],
			[
				[
					4928664,
					1975512
				],
				[
					92,
					2294
				]
			],
			[
				[
					4893527,
					2009615
				],
				[
					35137,
					-34103
				]
			],
			[
				[
					4977670,
					1957840
				],
				[
					3966,
					-10612
				],
				[
					-9644,
					-5985
				],
				[
					4538,
					-4749
				],
				[
					-3861,
					-21369
				],
				[
					-6581,
					32
				]
			],
			[
				[
					4866635,
					1765570
				],
				[
					-30577,
					-36
				]
			],
			[
				[
					4853426,
					1818968
				],
				[
					2560,
					10
				]
			],
			[
				[
					4858455,
					1826073
				],
				[
					3016,
					-24871
				],
				[
					45,
					-24925
				],
				[
					10137,
					-7009
				],
				[
					-5018,
					-3698
				]
			],
			[
				[
					4881835,
					1765610
				],
				[
					-15200,
					-40
				]
			],
			[
				[
					4646789,
					1976570
				],
				[
					0,
					0
				]
			],
			[
				[
					4641861,
					1973822
				],
				[
					2578,
					3
				]
			],
			[
				[
					4644439,
					1973825
				],
				[
					-2578,
					-3
				]
			],
			[
				[
					4641861,
					1973822
				],
				[
					2578,
					3
				]
			],
			[
				[
					4431101,
					3099521
				],
				[
					436,
					52156
				]
			],
			[
				[
					4431537,
					3151677
				],
				[
					-262,
					3350
				]
			],
			[
				[
					4431275,
					3155027
				],
				[
					-4232,
					410
				],
				[
					434,
					83735
				],
				[
					-4570,
					625
				],
				[
					641,
					84480
				],
				[
					-4623,
					325
				],
				[
					94,
					38810
				]
			],
			[
				[
					4419019,
					3363412
				],
				[
					106117,
					257
				],
				[
					87005,
					-236
				],
				[
					261,
					-39401
				],
				[
					4646,
					-248
				],
				[
					824,
					-110924
				],
				[
					5980,
					5
				],
				[
					-3520,
					-32309
				],
				[
					-13838,
					-15124
				],
				[
					-969,
					-15608
				],
				[
					7186,
					-15375
				],
				[
					-1090,
					-13203
				],
				[
					-11968,
					-12652
				],
				[
					-32428,
					1459
				],
				[
					-4921,
					3718
				],
				[
					-28146,
					-2935
				],
				[
					-14,
					-18590
				],
				[
					-48987,
					4
				],
				[
					-1898,
					28343
				],
				[
					-5533,
					-16587
				],
				[
					-12501,
					-8934
				],
				[
					-2800,
					5032
				],
				[
					-16920,
					-16521
				],
				[
					-14404,
					15938
				]
			],
			[
				[
					4521226,
					3244515
				],
				[
					0,
					0
				]
			],
			[
				[
					4947264,
					3443958
				],
				[
					-18727,
					-10007
				],
				[
					-406,
					-89912
				],
				[
					8772,
					109
				],
				[
					56,
					-30806
				],
				[
					-9302,
					33
				],
				[
					311,
					-31726
				],
				[
					-70242,
					85
				],
				[
					-114,
					-22449
				],
				[
					-18315,
					-757
				],
				[
					-85,
					-20463
				],
				[
					-51141,
					415
				],
				[
					307,
					41441
				],
				[
					17324,
					190
				],
				[
					177,
					40830
				],
				[
					33144,
					751
				],
				[
					239,
					41254
				],
				[
					14627,
					328
				],
				[
					2862,
					7352
				],
				[
					-576,
					56350
				],
				[
					10173,
					8378
				],
				[
					11815,
					1421
				],
				[
					11470,
					13651
				],
				[
					64721,
					-501
				],
				[
					-7090,
					-5967
				]
			],
			[
				[
					4900967,
					3291087
				],
				[
					0,
					0
				]
			],
			[
				[
					4443699,
					2829749
				],
				[
					-514,
					71989
				],
				[
					-3334,
					6098
				]
			],
			[
				[
					4439851,
					2907836
				],
				[
					6334,
					-1316
				],
				[
					10553,
					13437
				],
				[
					11159,
					-6442
				],
				[
					11168,
					17234
				],
				[
					21834,
					-652
				]
			],
			[
				[
					4500899,
					2930097
				],
				[
					0,
					0
				]
			],
			[
				[
					4500899,
					2930097
				],
				[
					8926,
					5562
				],
				[
					-2776,
					9277
				],
				[
					-13189,
					-120
				],
				[
					4008,
					16868
				],
				[
					5888,
					1003
				],
				[
					-1018,
					45879
				],
				[
					34181,
					-332
				],
				[
					2917,
					-20811
				],
				[
					878,
					-86222
				],
				[
					-30075,
					152
				],
				[
					-10,
					-82784
				],
				[
					3581,
					-4956
				],
				[
					-24790,
					11337
				],
				[
					-14311,
					-21618
				],
				[
					-26785,
					26445
				],
				[
					-4625,
					-28
				]
			],
			[
				[
					4498997,
					2925489
				],
				[
					0,
					0
				]
			],
			[
				[
					4490988,
					2927169
				],
				[
					0,
					0
				]
			],
			[
				[
					4502493,
					2932266
				],
				[
					0,
					0
				]
			],
			[
				[
					4446602,
					2022040
				],
				[
					0,
					0
				]
			],
			[
				[
					4339594,
					2146223
				],
				[
					0,
					0
				]
			],
			[
				[
					4227209,
					2180097
				],
				[
					0,
					0
				]
			],
			[
				[
					4079015,
					2397528
				],
				[
					8007,
					71
				]
			],
			[
				[
					4087022,
					2397599
				],
				[
					-8007,
					-71
				]
			],
			[
				[
					4472990,
					2064646
				],
				[
					-12834,
					5
				],
				[
					-5236,
					21436
				],
				[
					-13071,
					-8376
				],
				[
					24,
					8078
				],
				[
					-28644,
					-656
				],
				[
					-13063,
					-3750
				],
				[
					5156,
					14162
				],
				[
					-5187,
					20937
				],
				[
					-15518,
					-7032
				],
				[
					-3762,
					26140
				],
				[
					-19495,
					-814
				],
				[
					-29728,
					18818
				],
				[
					-1,
					6589
				],
				[
					-23106,
					-264
				],
				[
					-10119,
					-11202
				],
				[
					-8080,
					691
				],
				[
					-878,
					-14471
				],
				[
					-21647,
					1501
				],
				[
					-28388,
					21681
				],
				[
					2786,
					23438
				],
				[
					10648,
					10869
				],
				[
					5320,
					13050
				],
				[
					12977,
					-6076
				],
				[
					-2518,
					35503
				],
				[
					1601,
					17449
				],
				[
					-24852,
					135
				],
				[
					-4233,
					-15339
				],
				[
					-196,
					18728
				],
				[
					-7949,
					-6942
				],
				[
					-10421,
					1006
				],
				[
					50,
					20882
				],
				[
					-33272,
					151
				],
				[
					22,
					13966
				],
				[
					-13216,
					96
				],
				[
					-5039,
					38606
				],
				[
					-2163,
					-24504
				],
				[
					-20939,
					-16
				],
				[
					-437,
					10707
				],
				[
					-8070,
					3560
				],
				[
					-76,
					-14296
				],
				[
					-42223,
					140
				],
				[
					-2355,
					35181
				],
				[
					-15812,
					-58
				],
				[
					-45,
					35127
				],
				[
					7945,
					46
				],
				[
					-27,
					-14106
				],
				[
					5350,
					-74
				],
				[
					-27,
					14241
				],
				[
					13221,
					-31
				],
				[
					-10573,
					6840
				],
				[
					199,
					21182
				]
			],
			[
				[
					4095089,
					2397580
				],
				[
					29529,
					-57
				],
				[
					13,
					28265
				],
				[
					5719,
					55668
				],
				[
					-2742,
					14312
				],
				[
					16190,
					6982
				],
				[
					2654,
					42254
				],
				[
					13477,
					11
				],
				[
					767,
					28028
				]
			],
			[
				[
					4160696,
					2573043
				],
				[
					7329,
					-14040
				],
				[
					10820,
					101
				],
				[
					8099,
					-14069
				],
				[
					-6,
					-21119
				],
				[
					8164,
					15
				],
				[
					-9,
					-14087
				],
				[
					-16266,
					137
				],
				[
					3,
					-7184
				],
				[
					40481,
					39
				],
				[
					2677,
					56181
				],
				[
					-4310,
					7015
				],
				[
					9,
					28030
				],
				[
					13580,
					73
				],
				[
					-39,
					13879
				],
				[
					19036,
					-80
				],
				[
					69,
					-21050
				],
				[
					16104,
					100
				],
				[
					26,
					-20915
				],
				[
					16374,
					-48
				],
				[
					-6,
					20923
				],
				[
					48830,
					38
				],
				[
					6017,
					7060
				],
				[
					5528,
					-28105
				],
				[
					111641,
					-2
				]
			],
			[
				[
					4233238,
					2457058
				],
				[
					0,
					0
				]
			],
			[
				[
					4341776,
					2341285
				],
				[
					2046,
					-21315
				],
				[
					-7340,
					-31
				],
				[
					-42,
					-14315
				],
				[
					-7977,
					97
				],
				[
					5393,
					-10745
				],
				[
					-8033,
					-3434
				],
				[
					2599,
					-14275
				],
				[
					10594,
					7122
				],
				[
					59,
					-7116
				],
				[
					26433,
					35
				],
				[
					-26,
					-42659
				],
				[
					5204,
					43
				],
				[
					2764,
					21309
				],
				[
					10603,
					-7
				],
				[
					-9,
					14048
				],
				[
					-5747,
					7288
				],
				[
					5744,
					10654
				],
				[
					13259,
					-10662
				],
				[
					10590,
					10684
				],
				[
					5284,
					-10693
				],
				[
					2373,
					21577
				],
				[
					-5019,
					6844
				],
				[
					-15885,
					4
				],
				[
					35,
					10628
				],
				[
					-8023,
					42
				],
				[
					-2775,
					10575
				],
				[
					-10636,
					7175
				],
				[
					-16015,
					-48
				],
				[
					-17,
					7154
				],
				[
					-15436,
					21
				]
			],
			[
				[
					4210039,
					1931938
				],
				[
					0,
					0
				]
			],
			[
				[
					4299034,
					1821326
				],
				[
					-4927,
					7147
				],
				[
					-10263,
					-49
				],
				[
					569,
					-7051
				],
				[
					-13280,
					-43
				],
				[
					102,
					7002
				],
				[
					-17790,
					139
				],
				[
					1042,
					-35007
				],
				[
					5078,
					-14027
				],
				[
					-10105,
					-59
				],
				[
					44,
					-13903
				]
			],
			[
				[
					4249504,
					1765475
				],
				[
					-61876,
					-12
				],
				[
					-91750,
					15
				]
			],
			[
				[
					4095878,
					1765478
				],
				[
					0,
					41891
				],
				[
					-2273,
					20967
				],
				[
					-76024,
					107
				],
				[
					7,
					21059
				],
				[
					15182,
					-93
				],
				[
					15274,
					9126
				],
				[
					-40,
					32988
				],
				[
					-2759,
					7189
				],
				[
					0,
					35117
				],
				[
					17942,
					88
				],
				[
					-86,
					6978
				],
				[
					12874,
					47
				],
				[
					22,
					6865
				],
				[
					12752,
					-14
				],
				[
					7665,
					-6964
				],
				[
					-2558,
					13913
				],
				[
					17846,
					-45
				],
				[
					-2490,
					-13950
				],
				[
					10168,
					-23
				],
				[
					-6,
					13995
				]
			],
			[
				[
					4119374,
					1954719
				],
				[
					30654,
					60
				],
				[
					-43,
					-7016
				],
				[
					33243,
					-2443
				],
				[
					-2,
					-11599
				]
			],
			[
				[
					4183226,
					1933721
				],
				[
					45,
					-31579
				],
				[
					2552,
					-10647
				],
				[
					43400,
					20
				],
				[
					-7941,
					14050
				],
				[
					5390,
					7023
				],
				[
					-12772,
					88
				],
				[
					-8,
					14022
				],
				[
					12778,
					-7097
				],
				[
					2553,
					14082
				],
				[
					-12770,
					6969
				],
				[
					125,
					14221
				]
			],
			[
				[
					4216578,
					1954873
				],
				[
					68847,
					106
				],
				[
					-2497,
					-21296
				],
				[
					-7736,
					28
				],
				[
					2675,
					-29701
				],
				[
					5010,
					-5270
				],
				[
					15294,
					-167
				],
				[
					7632,
					-6763
				],
				[
					7776,
					17412
				],
				[
					-2624,
					10570
				],
				[
					-10183,
					-20
				],
				[
					51,
					20906
				],
				[
					-10347,
					-7001
				],
				[
					4,
					14208
				],
				[
					7584,
					7066
				],
				[
					63621,
					-272
				],
				[
					5496,
					7137
				],
				[
					2379,
					28408
				],
				[
					10217,
					-152
				],
				[
					2672,
					-24603
				],
				[
					17947,
					-3543
				],
				[
					-58,
					-7048
				],
				[
					12816,
					-155
				],
				[
					-66,
					-26132
				],
				[
					11272,
					11330
				],
				[
					13998,
					3857
				],
				[
					9,
					-7105
				],
				[
					41281,
					-50
				]
			],
			[
				[
					4485994,
					1765483
				],
				[
					-72866,
					-18
				],
				[
					-98768,
					18
				]
			],
			[
				[
					4314360,
					1765483
				],
				[
					7627,
					6886
				],
				[
					-7594,
					17814
				],
				[
					7454,
					31262
				],
				[
					-12675,
					-43
				],
				[
					-10052,
					7052
				],
				[
					-86,
					-7128
				]
			],
			[
				[
					4154840,
					2834391
				],
				[
					0,
					0
				]
			],
			[
				[
					4175986,
					2889144
				],
				[
					0,
					0
				]
			],
			[
				[
					4182624,
					2839621
				],
				[
					32531,
					24663
				],
				[
					3754,
					13900
				],
				[
					10877,
					7956
				],
				[
					22,
					16465
				],
				[
					-69434,
					256
				],
				[
					-97,
					11877
				],
				[
					-7730,
					3951
				]
			],
			[
				[
					4152547,
					2918689
				],
				[
					-9053,
					23788
				],
				[
					-25958,
					4177
				],
				[
					-6025,
					28741
				]
			],
			[
				[
					4111511,
					2975395
				],
				[
					13386,
					18787
				]
			],
			[
				[
					4124897,
					2994182
				],
				[
					10485,
					-7457
				],
				[
					154,
					-15098
				],
				[
					93234,
					8
				]
			],
			[
				[
					4228770,
					2971635
				],
				[
					128543,
					-17
				],
				[
					82571,
					5
				]
			],
			[
				[
					4439884,
					2971623
				],
				[
					-33,
					-63787
				]
			],
			[
				[
					4443699,
					2829749
				],
				[
					3863,
					-11470
				],
				[
					172,
					-85121
				],
				[
					3251,
					-33
				]
			],
			[
				[
					4160696,
					2573043
				],
				[
					8168,
					6857
				],
				[
					53,
					21039
				],
				[
					-10869,
					28083
				],
				[
					-5362,
					28
				],
				[
					-3,
					20998
				],
				[
					-13513,
					-5134
				],
				[
					-57,
					-8759
				],
				[
					-16307,
					13911
				],
				[
					-13180,
					-22
				],
				[
					-25,
					10615
				],
				[
					-10919,
					-3607
				],
				[
					-2636,
					14103
				],
				[
					-21941,
					-6941
				],
				[
					-2664,
					14025
				]
			],
			[
				[
					4071441,
					2678239
				],
				[
					8518,
					4249
				],
				[
					2750,
					16763
				],
				[
					10607,
					7027
				],
				[
					-2,
					-10539
				],
				[
					8212,
					-9
				],
				[
					-5473,
					17565
				],
				[
					3186,
					36854
				],
				[
					-3585,
					21101
				],
				[
					6910,
					11634
				],
				[
					9265,
					-908
				],
				[
					17157,
					8030
				],
				[
					3669,
					-3500
				],
				[
					16193,
					15067
				],
				[
					-15099,
					14151
				],
				[
					-1130,
					9920
				],
				[
					36142,
					3516
				],
				[
					13834,
					17567
				],
				[
					29,
					-7106
				]
			],
			[
				[
					4182624,
					2839621
				],
				[
					0,
					0
				]
			],
			[
				[
					4087022,
					2397599
				],
				[
					8067,
					-19
				]
			],
			[
				[
					4216578,
					1954873
				],
				[
					-12816,
					-36
				],
				[
					-7773,
					7123
				],
				[
					-4984,
					-7170
				],
				[
					-144,
					-21040
				],
				[
					-7635,
					-29
				]
			],
			[
				[
					4119374,
					1954719
				],
				[
					7598,
					21095
				],
				[
					-7613,
					-8799
				],
				[
					-12776,
					1779
				],
				[
					-2,
					6980
				],
				[
					-12654,
					-6936
				],
				[
					201,
					14087
				],
				[
					-5338,
					5
				],
				[
					211,
					35236
				],
				[
					-15485,
					-24
				],
				[
					-5125,
					14078
				],
				[
					-2649,
					28112
				],
				[
					5145,
					-1041
				],
				[
					191,
					15049
				],
				[
					-7776,
					7022
				],
				[
					-25944,
					3
				],
				[
					2617,
					9441
				],
				[
					-50,
					53770
				],
				[
					-8581,
					3407
				],
				[
					-14682,
					15062
				],
				[
					-11111,
					18608
				],
				[
					-66,
					12110
				],
				[
					-18217,
					7048
				],
				[
					-7833,
					14138
				],
				[
					-18576,
					3680
				],
				[
					8,
					45679
				],
				[
					-13104,
					64
				],
				[
					5,
					7109
				],
				[
					-34207,
					-157
				],
				[
					-267,
					77175
				],
				[
					-8038,
					7162
				],
				[
					-23853,
					-12
				],
				[
					0,
					6914
				]
			],
			[
				[
					3881403,
					2362563
				],
				[
					-5295,
					6899
				],
				[
					4957,
					9379
				],
				[
					-293,
					32715
				],
				[
					3928,
					7034
				]
			],
			[
				[
					3884700,
					2418590
				],
				[
					44174,
					-85
				],
				[
					-46,
					35117
				],
				[
					5350,
					-3
				],
				[
					2682,
					-21054
				],
				[
					10699,
					-7
				],
				[
					29,
					-21103
				],
				[
					10674,
					111
				],
				[
					2667,
					-14050
				],
				[
					6626,
					102
				],
				[
					5422,
					-28158
				],
				[
					8061,
					5
				],
				[
					-2921,
					28000
				],
				[
					16039,
					-6946
				],
				[
					-33,
					-14052
				],
				[
					12048,
					-135
				],
				[
					-16,
					7131
				],
				[
					22483,
					-7116
				],
				[
					2689,
					13968
				],
				[
					7920,
					-2
				],
				[
					-49,
					-13969
				],
				[
					13337,
					3450
				],
				[
					-17,
					17627
				],
				[
					16020,
					73
				],
				[
					-84,
					-14086
				],
				[
					10561,
					14120
				]
			],
			[
				[
					4063154,
					2348424
				],
				[
					-38,
					-14025
				],
				[
					7940,
					-15
				],
				[
					50,
					13996
				],
				[
					-7952,
					44
				]
			],
			[
				[
					4079301,
					2197101
				],
				[
					0,
					0
				]
			],
			[
				[
					4089193,
					2144599
				],
				[
					-2569,
					1
				]
			],
			[
				[
					4086624,
					2144600
				],
				[
					-14,
					-49186
				],
				[
					2584,
					-14057
				],
				[
					10381,
					1
				],
				[
					7312,
					-28021
				],
				[
					28437,
					-2648
				],
				[
					-2154,
					9669
				],
				[
					96,
					49107
				],
				[
					2598,
					7034
				]
			],
			[
				[
					4135864,
					2116499
				],
				[
					-2605,
					7018
				]
			],
			[
				[
					4133259,
					2123517
				],
				[
					-71,
					21073
				],
				[
					-12647,
					21100
				],
				[
					-15681,
					2
				],
				[
					-2228,
					-14063
				],
				[
					-13439,
					-7030
				]
			],
			[
				[
					4010518,
					2175692
				],
				[
					0,
					0
				]
			],
			[
				[
					4148828,
					2123540
				],
				[
					-7783,
					-8882
				],
				[
					5187,
					-19252
				],
				[
					14790,
					-7006
				],
				[
					-1827,
					14030
				],
				[
					10378,
					-7012
				],
				[
					5173,
					21069
				],
				[
					-24030,
					-23
				],
				[
					-1888,
					7076
				]
			],
			[
				[
					4095878,
					1765478
				],
				[
					-75683,
					-9
				],
				[
					-85258,
					-1
				],
				[
					-110311,
					6
				]
			],
			[
				[
					3824626,
					1765474
				],
				[
					308,
					41513
				],
				[
					-23827,
					2439
				],
				[
					-110,
					17478
				],
				[
					-22825,
					1797
				],
				[
					-155,
					63094
				],
				[
					55284,
					44
				],
				[
					7655,
					6978
				],
				[
					-2,
					28160
				],
				[
					-5144,
					6902
				],
				[
					-2522,
					21189
				],
				[
					35679,
					126
				],
				[
					-725,
					34936
				],
				[
					-5110,
					14026
				],
				[
					-5158,
					-13975
				],
				[
					-12849,
					-23
				],
				[
					-4818,
					21105
				],
				[
					9967,
					0
				],
				[
					-2760,
					13964
				],
				[
					-5126,
					-6983
				],
				[
					-23072,
					2
				]
			],
			[
				[
					3819316,
					2018246
				],
				[
					2620,
					28027
				]
			],
			[
				[
					3821936,
					2046273
				],
				[
					-3407,
					17745
				],
				[
					2380,
					17412
				],
				[
					-46699,
					52
				]
			],
			[
				[
					3774210,
					2081482
				],
				[
					3,
					28068
				]
			],
			[
				[
					3774213,
					2109550
				],
				[
					34,
					35267
				],
				[
					8980,
					3576
				]
			],
			[
				[
					3783227,
					2148393
				],
				[
					20865,
					-3542
				],
				[
					26,
					31585
				]
			],
			[
				[
					3804118,
					2176436
				],
				[
					7212,
					-1299
				],
				[
					17503,
					16800
				],
				[
					8158,
					-5927
				],
				[
					12517,
					7501
				],
				[
					4389,
					13690
				],
				[
					-1788,
					14665
				],
				[
					5893,
					9057
				],
				[
					3133,
					21067
				],
				[
					19076,
					8297
				],
				[
					9416,
					9526
				],
				[
					-19968,
					23569
				],
				[
					-6108,
					21249
				],
				[
					-13321,
					19962
				],
				[
					17924,
					-67
				],
				[
					-5353,
					21006
				],
				[
					-7871,
					6983
				],
				[
					26473,
					48
				]
			],
			[
				[
					4011039,
					2170929
				],
				[
					0,
					0
				]
			],
			[
				[
					4003659,
					2081353
				],
				[
					5184,
					-3
				]
			],
			[
				[
					4008843,
					2081350
				],
				[
					2589,
					14073
				]
			],
			[
				[
					4011432,
					2095423
				],
				[
					9060,
					5232
				],
				[
					-6343,
					8842
				]
			],
			[
				[
					4014149,
					2109497
				],
				[
					-122,
					1900
				]
			],
			[
				[
					4014027,
					2111397
				],
				[
					-2632,
					19054
				],
				[
					-7818,
					14108
				],
				[
					-10231,
					45
				],
				[
					-59,
					-49196
				],
				[
					7779,
					8
				],
				[
					2593,
					-14063
				]
			],
			[
				[
					4011764,
					2046228
				],
				[
					5110,
					14173
				],
				[
					-10228,
					-57
				],
				[
					-2626,
					-14094
				],
				[
					-7734,
					-497
				],
				[
					703,
					-12482
				],
				[
					7011,
					5899
				],
				[
					5189,
					-6986
				],
				[
					2575,
					14044
				]
			],
			[
				[
					4246303,
					3113513
				],
				[
					-6733,
					-17430
				],
				[
					-14610,
					9284
				]
			],
			[
				[
					4224960,
					3105367
				],
				[
					-54,
					8037
				],
				[
					21397,
					109
				]
			],
			[
				[
					4246303,
					3113513
				],
				[
					-1,
					9269
				],
				[
					20597,
					18282
				],
				[
					13575,
					-1606
				],
				[
					3143,
					9291
				],
				[
					10137,
					-5324
				]
			],
			[
				[
					4293754,
					3143425
				],
				[
					-123,
					-30003
				],
				[
					-47328,
					91
				]
			],
			[
				[
					4071441,
					2678239
				],
				[
					-6196,
					13997
				],
				[
					-12958,
					-74
				],
				[
					5,
					-6969
				],
				[
					-24698,
					92
				],
				[
					650,
					14057
				],
				[
					-8760,
					-187
				],
				[
					10,
					-13806
				],
				[
					-32988,
					-71
				],
				[
					78,
					7026
				],
				[
					-13688,
					6989
				],
				[
					-20907,
					-6203
				],
				[
					6639,
					13892
				],
				[
					10751,
					-1505
				],
				[
					13916,
					6967
				]
			],
			[
				[
					3983295,
					2712444
				],
				[
					4232,
					12384
				],
				[
					10454,
					11087
				],
				[
					15027,
					-3855
				],
				[
					4169,
					12525
				],
				[
					-8932,
					-1772
				],
				[
					-495,
					17746
				],
				[
					14332,
					-1041
				],
				[
					5106,
					12382
				],
				[
					15146,
					-10984
				],
				[
					6832,
					9766
				],
				[
					14618,
					4906
				],
				[
					2254,
					33294
				],
				[
					-13626,
					-7819
				],
				[
					-35,
					10623
				],
				[
					-22102,
					-107
				],
				[
					-2723,
					6976
				],
				[
					-47070,
					-1791
				],
				[
					-13797,
					1751
				],
				[
					2582,
					-13435
				],
				[
					-8445,
					-647
				],
				[
					-1942,
					-26467
				],
				[
					-8505,
					901
				],
				[
					-14436,
					-9824
				],
				[
					-5766,
					-15705
				],
				[
					-13560,
					-18884
				]
			],
			[
				[
					3916613,
					2734454
				],
				[
					-4679,
					-20453
				],
				[
					-14878,
					-17226
				],
				[
					-23457,
					-40149
				],
				[
					-6848,
					-5279
				],
				[
					-5064,
					-22206
				],
				[
					-14717,
					-18
				],
				[
					-144,
					7014
				],
				[
					-21677,
					17
				],
				[
					6,
					-6988
				],
				[
					-27048,
					28
				]
			],
			[
				[
					3798107,
					2629194
				],
				[
					1395,
					35028
				],
				[
					-2653,
					3
				],
				[
					-89,
					42085
				],
				[
					13540,
					7080
				],
				[
					-2659,
					14117
				],
				[
					22011,
					-90
				],
				[
					-841,
					49389
				],
				[
					-16554,
					-23
				],
				[
					-2696,
					-35027
				],
				[
					-13742,
					14056
				],
				[
					11,
					-11705
				],
				[
					-13894,
					4597
				],
				[
					-8453,
					10517
				],
				[
					5694,
					15889
				],
				[
					-2827,
					8702
				],
				[
					-14106,
					-7257
				],
				[
					99,
					35029
				],
				[
					-11075,
					-86
				],
				[
					-54,
					7253
				],
				[
					-15624,
					-84
				],
				[
					5638,
					24833
				],
				[
					7392,
					17142
				],
				[
					-4678,
					-36
				],
				[
					-115,
					21238
				]
			],
			[
				[
					3743827,
					2881844
				],
				[
					-1892,
					42100
				],
				[
					16811,
					-26
				],
				[
					-27,
					42128
				]
			],
			[
				[
					3758719,
					2966046
				],
				[
					50513,
					-78
				],
				[
					-958,
					28006
				],
				[
					-9112,
					14920
				],
				[
					3318,
					18973
				],
				[
					-4093,
					8634
				],
				[
					3578,
					24562
				],
				[
					4923,
					9970
				],
				[
					246,
					42088
				],
				[
					-48157,
					-92
				],
				[
					3133,
					17152
				],
				[
					-5244,
					17910
				],
				[
					286,
					38991
				],
				[
					5891,
					20031
				],
				[
					-2197,
					13246
				],
				[
					10370,
					22759
				],
				[
					17421,
					-6815
				],
				[
					-3368,
					45482
				],
				[
					-31722,
					14
				],
				[
					-4411,
					16843
				],
				[
					-21716,
					35188
				],
				[
					670,
					12349
				],
				[
					-22061,
					23413
				],
				[
					-13710,
					28175
				],
				[
					40196,
					-734
				],
				[
					301,
					48625
				],
				[
					2316,
					8421
				],
				[
					0,
					163405
				],
				[
					-108837,
					759
				],
				[
					1450,
					12111
				],
				[
					-2690,
					48151
				],
				[
					-7212,
					16798
				],
				[
					-2638,
					20529
				],
				[
					5092,
					14631
				],
				[
					-7356,
					27582
				],
				[
					-23311,
					60744
				],
				[
					-5974,
					7191
				],
				[
					-6340,
					24470
				],
				[
					-3912,
					35545
				],
				[
					8363,
					16445
				],
				[
					-9491,
					34112
				],
				[
					-63392,
					-11
				]
			],
			[
				[
					3508884,
					3936541
				],
				[
					0,
					482462
				]
			],
			[
				[
					3508884,
					4419003
				],
				[
					155457,
					14
				]
			],
			[
				[
					3664341,
					4419017
				],
				[
					99072,
					-14
				],
				[
					113124,
					0
				],
				[
					141405,
					0
				],
				[
					113124,
					0
				],
				[
					141405,
					0
				],
				[
					141404,
					0
				]
			],
			[
				[
					4413875,
					4419003
				],
				[
					0,
					-964962
				]
			],
			[
				[
					4413875,
					3454041
				],
				[
					-74673,
					54
				],
				[
					-151574,
					-40
				],
				[
					0,
					-146651
				]
			],
			[
				[
					4187628,
					3307404
				],
				[
					0,
					-94556
				],
				[
					-144232,
					-44
				],
				[
					-343,
					-14291
				],
				[
					-6727,
					-67
				],
				[
					-2508,
					-22784
				],
				[
					3370,
					-8513
				],
				[
					23269,
					12774
				],
				[
					-2180,
					-22811
				],
				[
					34871,
					-17770
				],
				[
					-14990,
					-52128
				],
				[
					6141,
					-14907
				],
				[
					2561,
					-46920
				],
				[
					7752,
					-11874
				],
				[
					22604,
					2440
				],
				[
					-1931,
					23090
				],
				[
					26884,
					-2652
				],
				[
					1853,
					-10500
				],
				[
					-6047,
					-15415
				],
				[
					-13078,
					-16294
				]
			],
			[
				[
					4111511,
					2975395
				],
				[
					-11641,
					-17717
				],
				[
					-25366,
					-12727
				],
				[
					-18,
					-21200
				],
				[
					44926,
					65
				],
				[
					904,
					-18383
				],
				[
					33866,
					-2585
				],
				[
					-1635,
					15841
				]
			],
			[
				[
					3782795,
					2860991
				],
				[
					-5521,
					8901
				],
				[
					-30,
					-15980
				],
				[
					5551,
					7079
				]
			],
			[
				[
					4026172,
					2956174
				],
				[
					2,
					9812
				],
				[
					31806,
					76
				],
				[
					8408,
					10283
				],
				[
					2028,
					18874
				],
				[
					6088,
					7165
				],
				[
					0,
					26514
				],
				[
					-65879,
					-1595
				],
				[
					-12537,
					-26715
				],
				[
					813,
					-12499
				],
				[
					20942,
					-692
				],
				[
					8329,
					-31223
				]
			],
			[
				[
					3746824,
					3320409
				],
				[
					0,
					0
				]
			],
			[
				[
					3770252,
					3426433
				],
				[
					0,
					0
				]
			],
			[
				[
					4412990,
					3713904
				],
				[
					0,
					0
				]
			],
			[
				[
					3551476,
					2607976
				],
				[
					2748,
					-20695
				],
				[
					-8071,
					-300
				],
				[
					-86,
					20939
				],
				[
					5409,
					56
				]
			],
			[
				[
					3884700,
					2418590
				],
				[
					-16298,
					-82
				],
				[
					9754,
					25603
				],
				[
					-2137,
					16480
				]
			],
			[
				[
					3876019,
					2460591
				],
				[
					4747,
					-14011
				],
				[
					21347,
					10643
				],
				[
					1,
					17496
				],
				[
					10338,
					7001
				],
				[
					-2693,
					14319
				],
				[
					8051,
					-337
				],
				[
					2670,
					14091
				],
				[
					5324,
					-7050
				],
				[
					13490,
					48
				],
				[
					-23,
					7051
				],
				[
					16225,
					-82
				],
				[
					13,
					7051
				],
				[
					-13447,
					7033
				],
				[
					2693,
					10556
				],
				[
					-10748,
					104
				],
				[
					-20,
					-10654
				],
				[
					-18846,
					14022
				],
				[
					-5607,
					28111
				]
			],
			[
				[
					3909534,
					2565983
				],
				[
					-10438,
					-14040
				]
			],
			[
				[
					3899096,
					2551943
				],
				[
					-21603,
					25
				],
				[
					-3,
					7023
				],
				[
					-26923,
					-21066
				],
				[
					-10,
					-14048
				],
				[
					8075,
					-7026
				],
				[
					2690,
					-14066
				]
			],
			[
				[
					3861322,
					2502785
				],
				[
					-16149,
					-7021
				],
				[
					-24195,
					-15
				],
				[
					-5354,
					-7042
				],
				[
					1003,
					-28093
				],
				[
					-37390,
					139
				],
				[
					-9377,
					8739
				],
				[
					-1380,
					-8914
				],
				[
					-50856,
					-33
				],
				[
					2684,
					-21096
				],
				[
					-29436,
					148
				],
				[
					16,
					6992
				],
				[
					-15981,
					-37
				],
				[
					-2537,
					13976
				],
				[
					-24111,
					76
				],
				[
					-1777,
					28837
				],
				[
					-5512,
					15368
				],
				[
					1995,
					18701
				],
				[
					-45395,
					-25
				],
				[
					-2729,
					21179
				],
				[
					-13504,
					21
				],
				[
					-5339,
					-7109
				],
				[
					-2733,
					21003
				],
				[
					-16274,
					7225
				],
				[
					-2760,
					21218
				],
				[
					16126,
					-87
				],
				[
					-5253,
					20361
				],
				[
					-5410,
					5815
				],
				[
					5419,
					29967
				],
				[
					5278,
					7152
				]
			],
			[
				[
					3570391,
					2650230
				],
				[
					35202,
					23
				],
				[
					-2640,
					-14009
				],
				[
					62243,
					-184
				],
				[
					2725,
					-14063
				],
				[
					-4690,
					-7041
				],
				[
					15557,
					177
				],
				[
					-2847,
					-14120
				],
				[
					20374,
					305
				],
				[
					281,
					27849
				],
				[
					20201,
					-5278
				],
				[
					38,
					-8603
				],
				[
					16158,
					-7193
				],
				[
					22,
					11143
				],
				[
					8100,
					-893
				],
				[
					2737,
					-17602
				],
				[
					21672,
					416
				],
				[
					2648,
					13992
				],
				[
					29875,
					44
				],
				[
					60,
					14001
				]
			],
			[
				[
					3916613,
					2734454
				],
				[
					11405,
					264
				],
				[
					4248,
					9552
				],
				[
					10209,
					-4295
				],
				[
					-771,
					10881
				],
				[
					9389,
					-4372
				],
				[
					15072,
					6973
				],
				[
					4945,
					-7059
				],
				[
					-6884,
					-7241
				],
				[
					8204,
					-17675
				],
				[
					2795,
					14262
				],
				[
					2624,
					-17809
				],
				[
					5446,
					-5491
				]
			],
			[
				[
					3890353,
					2601075
				],
				[
					0,
					0
				]
			],
			[
				[
					3884934,
					2592432
				],
				[
					0,
					0
				]
			],
			[
				[
					3804118,
					2176436
				],
				[
					-10739,
					-13012
				],
				[
					-29526,
					2944
				]
			],
			[
				[
					3763853,
					2166368
				],
				[
					-19344,
					5819
				],
				[
					-9996,
					-7834
				],
				[
					-9671,
					6391
				],
				[
					-15772,
					-4242
				],
				[
					-10751,
					9058
				],
				[
					-12248,
					21984
				],
				[
					-7692,
					30682
				],
				[
					-16651,
					2861
				],
				[
					-10937,
					7556
				],
				[
					-8971,
					-1661
				],
				[
					-16734,
					17241
				],
				[
					-25010,
					-3910
				],
				[
					-11931,
					1800
				],
				[
					-20901,
					-14137
				],
				[
					-22439,
					5787
				],
				[
					-5615,
					-11737
				],
				[
					-13412,
					4326
				],
				[
					-6871,
					-8579
				],
				[
					-10553,
					12366
				]
			],
			[
				[
					3508354,
					2240139
				],
				[
					-42,
					192175
				]
			],
			[
				[
					3508312,
					2432314
				],
				[
					-9,
					70260
				]
			],
			[
				[
					3508303,
					2502574
				],
				[
					-30,
					147518
				]
			],
			[
				[
					3508273,
					2650092
				],
				[
					62118,
					138
				]
			],
			[
				[
					3861322,
					2502785
				],
				[
					-1941,
					-35119
				],
				[
					-5341,
					-7043
				],
				[
					815,
					-13368
				],
				[
					-6150,
					-7708
				],
				[
					-31,
					-20925
				],
				[
					13432,
					-126
				],
				[
					5322,
					6987
				],
				[
					-11,
					21060
				],
				[
					5352,
					-2
				],
				[
					-23,
					24617
				],
				[
					3273,
					-10567
				]
			],
			[
				[
					3758719,
					2966046
				],
				[
					-106,
					20868
				],
				[
					-33466,
					60
				],
				[
					-1568,
					7512
				],
				[
					16903,
					-740
				],
				[
					25,
					56512
				],
				[
					-76127,
					-105
				],
				[
					3902,
					-14046
				],
				[
					-4200,
					-14034
				],
				[
					-17010,
					7011
				],
				[
					-3291,
					-21050
				],
				[
					6173,
					5
				],
				[
					-8927,
					-22693
				],
				[
					16820,
					1702
				],
				[
					15,
					-84112
				],
				[
					19330,
					-10
				],
				[
					-14,
					-21080
				],
				[
					66649,
					-2
				]
			],
			[
				[
					3508273,
					2650092
				],
				[
					-71,
					98102
				]
			],
			[
				[
					3508202,
					2748194
				],
				[
					14237,
					4
				],
				[
					-189,
					42102
				],
				[
					5556,
					7140
				],
				[
					24812,
					-15
				],
				[
					13946,
					-3560
				],
				[
					-86,
					23636
				],
				[
					-8745,
					19921
				],
				[
					2723,
					10775
				],
				[
					-8031,
					7463
				],
				[
					-2775,
					16375
				],
				[
					-10485,
					3725
				],
				[
					-10459,
					-12512
				],
				[
					-20465,
					11417
				]
			],
			[
				[
					3508241,
					2874665
				],
				[
					-3,
					2723
				]
			],
			[
				[
					3508238,
					2877388
				],
				[
					6,
					109656
				]
			],
			[
				[
					3508244,
					2987044
				],
				[
					96,
					186729
				]
			],
			[
				[
					3508340,
					3173773
				],
				[
					532,
					118979
				]
			],
			[
				[
					3508872,
					3292752
				],
				[
					12,
					136596
				]
			],
			[
				[
					3508884,
					3429348
				],
				[
					0,
					357923
				]
			],
			[
				[
					3508884,
					3787271
				],
				[
					0,
					149270
				]
			],
			[
				[
					3715922,
					2734404
				],
				[
					-9462,
					-7025
				],
				[
					-6,
					-14024
				],
				[
					-21891,
					3
				],
				[
					18,
					-8059
				],
				[
					10648,
					-11909
				],
				[
					-1872,
					-12826
				],
				[
					16717,
					-23968
				],
				[
					7728,
					-6377
				],
				[
					29708,
					-12
				],
				[
					-28,
					63143
				],
				[
					-19126,
					-2
				],
				[
					-10947,
					10503
				],
				[
					-1487,
					10553
				]
			],
			[
				[
					3773567,
					2166513
				],
				[
					0,
					0
				]
			],
			[
				[
					3763853,
					2166368
				],
				[
					2514,
					-14528
				],
				[
					16860,
					-3447
				]
			],
			[
				[
					3774213,
					2109550
				],
				[
					-5191,
					-7008
				],
				[
					-44064,
					2
				],
				[
					2586,
					-7020
				],
				[
					1711,
					-49213
				],
				[
					5088,
					-14031
				],
				[
					12796,
					10
				],
				[
					5122,
					26418
				],
				[
					10174,
					1676
				],
				[
					111,
					-13950
				],
				[
					11809,
					-55
				],
				[
					-145,
					35103
				]
			],
			[
				[
					3821936,
					2046273
				],
				[
					-18024,
					-16624
				],
				[
					-9,
					-11334
				],
				[
					15413,
					-69
				]
			],
			[
				[
					3824626,
					1765474
				],
				[
					-89772,
					-10
				],
				[
					-141133,
					-1
				],
				[
					-85405,
					14
				]
			],
			[
				[
					3508316,
					1765477
				],
				[
					22,
					46688
				]
			],
			[
				[
					3508338,
					1812165
				],
				[
					16,
					427974
				]
			],
			[
				[
					3790857,
					2022807
				],
				[
					0,
					0
				]
			],
			[
				[
					3785907,
					1997043
				],
				[
					0,
					0
				]
			],
			[
				[
					4259232,
					3192116
				],
				[
					0,
					0
				]
			],
			[
				[
					4413875,
					3454041
				],
				[
					0,
					-45120
				],
				[
					5558,
					298
				],
				[
					-414,
					-45807
				]
			],
			[
				[
					4431275,
					3155027
				],
				[
					262,
					-3350
				]
			],
			[
				[
					4431101,
					3099521
				],
				[
					-292,
					-27795
				],
				[
					4430,
					-225
				],
				[
					-8,
					-84390
				],
				[
					4653,
					-15488
				]
			],
			[
				[
					4228770,
					2971635
				],
				[
					-2054,
					15549
				],
				[
					199,
					84127
				],
				[
					-1955,
					34056
				]
			],
			[
				[
					4293754,
					3143425
				],
				[
					-1233,
					53925
				],
				[
					8231,
					432
				],
				[
					0,
					153552
				],
				[
					-10848,
					-6816
				],
				[
					-5805,
					4223
				],
				[
					-18813,
					-8967
				],
				[
					-5373,
					-12996
				],
				[
					-17974,
					-9131
				],
				[
					-1925,
					-8527
				],
				[
					-35987,
					-9494
				],
				[
					-6387,
					8775
				],
				[
					-10012,
					-997
				]
			],
			[
				[
					4089193,
					2144599
				],
				[
					-2569,
					1
				]
			],
			[
				[
					4314360,
					1765483
				],
				[
					-64856,
					-8
				]
			],
			[
				[
					4299034,
					1821326
				],
				[
					0,
					0
				]
			],
			[
				[
					4135864,
					2116499
				],
				[
					-5181,
					-28
				]
			],
			[
				[
					4130683,
					2116471
				],
				[
					-2,
					7055
				]
			],
			[
				[
					4130681,
					2123526
				],
				[
					2578,
					-9
				]
			],
			[
				[
					4128092,
					2116487
				],
				[
					-1615,
					-2152
				]
			],
			[
				[
					4126477,
					2114335
				],
				[
					-3753,
					-4902
				]
			],
			[
				[
					4122724,
					2109433
				],
				[
					-2561,
					1970
				]
			],
			[
				[
					4120163,
					2111403
				],
				[
					142,
					5221
				]
			],
			[
				[
					4120305,
					2116624
				],
				[
					2656,
					10463
				]
			],
			[
				[
					4122961,
					2127087
				],
				[
					5131,
					-10600
				]
			],
			[
				[
					4127312,
					2116381
				],
				[
					0,
					0
				]
			],
			[
				[
					4120163,
					2111403
				],
				[
					-2455,
					452
				]
			],
			[
				[
					4117708,
					2111855
				],
				[
					2,
					3794
				]
			],
			[
				[
					4117710,
					2115649
				],
				[
					2595,
					975
				]
			],
			[
				[
					4130681,
					2123526
				],
				[
					36,
					13597
				],
				[
					-7792,
					-6576
				]
			],
			[
				[
					4122925,
					2130547
				],
				[
					-2599,
					35
				]
			],
			[
				[
					4120326,
					2130582
				],
				[
					-10370,
					6997
				],
				[
					-1371,
					-14068
				]
			],
			[
				[
					4108585,
					2123511
				],
				[
					-1245,
					-3568
				]
			],
			[
				[
					4107340,
					2119943
				],
				[
					5190,
					-12244
				]
			],
			[
				[
					4112530,
					2107699
				],
				[
					2303,
					-4892
				]
			],
			[
				[
					4114833,
					2102807
				],
				[
					8068,
					-366
				]
			],
			[
				[
					4122901,
					2102441
				],
				[
					7775,
					2744
				],
				[
					3,
					9516
				]
			],
			[
				[
					4130679,
					2114701
				],
				[
					4,
					1770
				]
			],
			[
				[
					4122925,
					2130547
				],
				[
					36,
					-3460
				]
			],
			[
				[
					4117710,
					2115649
				],
				[
					-5196,
					7864
				]
			],
			[
				[
					4112514,
					2123513
				],
				[
					7812,
					7069
				]
			],
			[
				[
					4122724,
					2109433
				],
				[
					177,
					-6992
				]
			],
			[
				[
					4114833,
					2102807
				],
				[
					36,
					4893
				]
			],
			[
				[
					4114869,
					2107700
				],
				[
					2839,
					4155
				]
			],
			[
				[
					4114869,
					2107700
				],
				[
					-2339,
					-1
				]
			],
			[
				[
					4107340,
					2119943
				],
				[
					2528,
					7
				]
			],
			[
				[
					4109868,
					2119950
				],
				[
					2646,
					3563
				]
			],
			[
				[
					4126477,
					2114335
				],
				[
					1616,
					330
				]
			],
			[
				[
					4128093,
					2114665
				],
				[
					2586,
					36
				]
			],
			[
				[
					4109868,
					2119950
				],
				[
					-1283,
					3561
				]
			],
			[
				[
					4128093,
					2114665
				],
				[
					-1,
					1822
				]
			],
			[
				[
					4003659,
					2081353
				],
				[
					5184,
					-3
				]
			],
			[
				[
					4011432,
					2095423
				],
				[
					-2116,
					14053
				]
			],
			[
				[
					4009316,
					2109476
				],
				[
					4833,
					21
				]
			],
			[
				[
					4017172,
					2106003
				],
				[
					0,
					0
				]
			],
			[
				[
					4009316,
					2109476
				],
				[
					4711,
					1921
				]
			],
			[
				[
					3994492,
					2777668
				],
				[
					0,
					0
				]
			],
			[
				[
					3985914,
					2772983
				],
				[
					0,
					0
				]
			],
			[
				[
					3994091,
					2774303
				],
				[
					0,
					0
				]
			],
			[
				[
					3897852,
					2516819
				],
				[
					-1240,
					-2960
				]
			],
			[
				[
					3896612,
					2513859
				],
				[
					-11081,
					1203
				]
			],
			[
				[
					3885531,
					2515062
				],
				[
					-163,
					1796
				]
			],
			[
				[
					3885368,
					2516858
				],
				[
					13626,
					5381
				]
			],
			[
				[
					3898994,
					2522239
				],
				[
					-1142,
					-5420
				]
			],
			[
				[
					3896612,
					2513859
				],
				[
					-287,
					-4061
				]
			],
			[
				[
					3896325,
					2509798
				],
				[
					-2692,
					-2
				]
			],
			[
				[
					3893633,
					2509796
				],
				[
					-8092,
					1879
				]
			],
			[
				[
					3885541,
					2511675
				],
				[
					-10,
					3387
				]
			],
			[
				[
					3899096,
					2551943
				],
				[
					3342,
					-5574
				],
				[
					7096,
					19614
				]
			],
			[
				[
					3896325,
					2509798
				],
				[
					1527,
					7021
				]
			],
			[
				[
					3898994,
					2522239
				],
				[
					-2677,
					8651
				]
			],
			[
				[
					3896317,
					2530890
				],
				[
					-2689,
					16
				]
			],
			[
				[
					3893628,
					2530906
				],
				[
					-7913,
					-12442
				]
			],
			[
				[
					3885715,
					2518464
				],
				[
					-161,
					1872
				]
			],
			[
				[
					3885554,
					2520336
				],
				[
					-5390,
					10543
				]
			],
			[
				[
					3880164,
					2530879
				],
				[
					2,
					-3438
				]
			],
			[
				[
					3880166,
					2527441
				],
				[
					-5380,
					-7106
				]
			],
			[
				[
					3874786,
					2520335
				],
				[
					7376,
					-8679
				]
			],
			[
				[
					3882162,
					2511656
				],
				[
					-3756,
					-5483
				],
				[
					9779,
					-17490
				],
				[
					8143,
					29
				],
				[
					-2695,
					21084
				]
			],
			[
				[
					3885554,
					2520336
				],
				[
					-10768,
					-1
				]
			],
			[
				[
					3880166,
					2527441
				],
				[
					-2,
					3438
				]
			],
			[
				[
					3885715,
					2518464
				],
				[
					-347,
					-1606
				]
			],
			[
				[
					3885541,
					2511675
				],
				[
					-3379,
					-19
				]
			],
			[
				[
					3893628,
					2530906
				],
				[
					2691,
					-5664
				]
			],
			[
				[
					3896319,
					2525242
				],
				[
					-1,
					-582
				]
			],
			[
				[
					3896318,
					2524660
				],
				[
					2676,
					-2421
				]
			],
			[
				[
					3896319,
					2525242
				],
				[
					-1,
					-582
				]
			],
			[
				[
					3896317,
					2530890
				],
				[
					2,
					-5648
				]
			],
			[
				[
					3508202,
					2748194
				],
				[
					17,
					55397
				]
			],
			[
				[
					3508219,
					2803591
				],
				[
					20,
					50226
				]
			],
			[
				[
					3508239,
					2853817
				],
				[
					2,
					20848
				]
			],
			[
				[
					3116885,
					2889042
				],
				[
					-3012,
					10
				]
			],
			[
				[
					3113873,
					2889052
				],
				[
					-1407,
					11
				]
			],
			[
				[
					3112466,
					2889063
				],
				[
					5,
					3598
				]
			],
			[
				[
					3112471,
					2892661
				],
				[
					4414,
					-3619
				]
			],
			[
				[
					3112479,
					2896091
				],
				[
					-1386,
					7035
				]
			],
			[
				[
					3111093,
					2903126
				],
				[
					1386,
					-7035
				]
			],
			[
				[
					3499908,
					3057350
				],
				[
					7115,
					-14232
				],
				[
					-7130,
					742
				],
				[
					15,
					13490
				]
			],
			[
				[
					3436928,
					3074771
				],
				[
					2870,
					3
				]
			],
			[
				[
					3439798,
					3074774
				],
				[
					14492,
					6948
				],
				[
					472,
					-10526
				],
				[
					14174,
					-86
				],
				[
					-2940,
					-35673
				]
			],
			[
				[
					3465996,
					3035437
				],
				[
					-14295,
					848
				],
				[
					11,
					6951
				],
				[
					-14125,
					-3520
				],
				[
					2843,
					17586
				],
				[
					-3502,
					17469
				]
			],
			[
				[
					3436928,
					3074771
				],
				[
					-31312,
					3527
				],
				[
					-1963,
					-7002
				],
				[
					-14086,
					-139
				],
				[
					-857,
					13935
				],
				[
					-15632,
					-1060
				],
				[
					2678,
					-26883
				],
				[
					8292,
					-101
				],
				[
					2904,
					-13895
				],
				[
					8414,
					-6613
				],
				[
					-64,
					-28463
				],
				[
					28336,
					-4725
				],
				[
					-551,
					-16241
				],
				[
					34767,
					-28
				],
				[
					4090,
					-6400
				],
				[
					3397,
					20669
				],
				[
					7692,
					13608
				],
				[
					-9677,
					6
				],
				[
					8446,
					13892
				]
			],
			[
				[
					3471802,
					3028858
				],
				[
					2764,
					-6911
				],
				[
					16887,
					-62
				],
				[
					16,
					-13749
				],
				[
					-17140,
					-3513
				],
				[
					7079,
					-17546
				],
				[
					26836,
					-33
				]
			],
			[
				[
					3508238,
					2877388
				],
				[
					-10338,
					5799
				]
			],
			[
				[
					3497900,
					2883187
				],
				[
					-9059,
					19551
				],
				[
					-26629,
					118
				],
				[
					-15502,
					13939
				],
				[
					-19638,
					47
				],
				[
					-2775,
					-7049
				]
			],
			[
				[
					3424297,
					2909793
				],
				[
					-2813,
					-3379
				]
			],
			[
				[
					3421484,
					2906414
				],
				[
					-19626,
					3299
				],
				[
					-11090,
					14234
				],
				[
					-12034,
					-12558
				],
				[
					-26346,
					-210
				],
				[
					-12001,
					11622
				],
				[
					-3007,
					11575
				],
				[
					-11120,
					-3578
				]
			],
			[
				[
					3326260,
					2930798
				],
				[
					-6739,
					30462
				],
				[
					-15294,
					-921
				],
				[
					-5956,
					5660
				],
				[
					41,
					-14947
				],
				[
					-12502,
					-1783
				],
				[
					-18748,
					15530
				],
				[
					6051,
					8235
				],
				[
					-18867,
					15835
				],
				[
					-19338,
					-19278
				],
				[
					-21939,
					3180
				],
				[
					-20571,
					13826
				],
				[
					-5363,
					-8529
				],
				[
					-1826,
					-20457
				],
				[
					-10177,
					-11610
				]
			],
			[
				[
					3175032,
					2946001
				],
				[
					-13137,
					-7686
				],
				[
					-11423,
					-23011
				],
				[
					-677,
					8952
				],
				[
					-8394,
					-6992
				]
			],
			[
				[
					3141401,
					2917264
				],
				[
					-11169,
					7025
				]
			],
			[
				[
					3130232,
					2924289
				],
				[
					-2787,
					7
				]
			],
			[
				[
					3127445,
					2924296
				],
				[
					-14053,
					7
				],
				[
					-2779,
					6964
				]
			],
			[
				[
					3110613,
					2931267
				],
				[
					-2856,
					14019
				]
			],
			[
				[
					3107757,
					2945286
				],
				[
					14003,
					7051
				],
				[
					8345,
					34963
				],
				[
					8423,
					-6890
				],
				[
					-153,
					13912
				],
				[
					-11324,
					1812
				],
				[
					1,
					40239
				],
				[
					8457,
					-2
				],
				[
					2830,
					28083
				],
				[
					10647,
					6873
				],
				[
					0,
					13290
				],
				[
					8556,
					1998
				],
				[
					2849,
					26692
				],
				[
					-2870,
					7014
				]
			],
			[
				[
					3157521,
					3120321
				],
				[
					11422,
					7007
				],
				[
					8546,
					21064
				],
				[
					2911,
					21103
				],
				[
					5749,
					3535
				],
				[
					-11504,
					14032
				],
				[
					5750,
					18736
				]
			],
			[
				[
					3180395,
					3205798
				],
				[
					21157,
					3444
				],
				[
					-4719,
					13085
				],
				[
					-14808,
					9147
				],
				[
					7929,
					23293
				],
				[
					729,
					13216
				],
				[
					14548,
					20154
				],
				[
					-13048,
					49741
				],
				[
					4792,
					4896
				],
				[
					-3819,
					24807
				],
				[
					7755,
					12525
				],
				[
					14167,
					8126
				],
				[
					-4040,
					32940
				],
				[
					-5028,
					10405
				],
				[
					6623,
					8798
				],
				[
					-1986,
					10105
				]
			],
			[
				[
					3210647,
					3450480
				],
				[
					67517,
					517
				],
				[
					78,
					-10586
				],
				[
					17059,
					30534
				]
			],
			[
				[
					3295301,
					3470945
				],
				[
					371,
					-19695
				],
				[
					53398,
					-924
				],
				[
					1574,
					-42038
				],
				[
					-388,
					-84302
				],
				[
					28858,
					-11580
				],
				[
					9888,
					-14105
				],
				[
					19061,
					-130
				],
				[
					4616,
					-5064
				],
				[
					96193,
					-355
				]
			],
			[
				[
					3508340,
					3173773
				],
				[
					-8663,
					-18271
				],
				[
					-94004,
					-70
				],
				[
					-45,
					-64827
				],
				[
					28490,
					1632
				],
				[
					4257,
					-5219
				]
			],
			[
				[
					3438375,
					3087018
				],
				[
					-1447,
					-12247
				]
			],
			[
				[
					3191455,
					2741757
				],
				[
					5482,
					-7
				],
				[
					2309,
					-14595
				],
				[
					-7791,
					14602
				]
			],
			[
				[
					3421484,
					2906414
				],
				[
					2813,
					3379
				]
			],
			[
				[
					3497900,
					2883187
				],
				[
					7583,
					-29423
				]
			],
			[
				[
					3505483,
					2853764
				],
				[
					0,
					0
				]
			],
			[
				[
					3505483,
					2853764
				],
				[
					2756,
					53
				]
			],
			[
				[
					3508219,
					2803591
				],
				[
					-5509,
					926
				]
			],
			[
				[
					3502710,
					2804517
				],
				[
					0,
					0
				]
			],
			[
				[
					3502710,
					2804517
				],
				[
					-10949,
					-7073
				],
				[
					-2838,
					-21253
				],
				[
					-8257,
					-6972
				],
				[
					11048,
					-7035
				],
				[
					13756,
					58
				],
				[
					2732,
					-14048
				]
			],
			[
				[
					3508303,
					2502574
				],
				[
					-24245,
					-24
				],
				[
					-4,
					14060
				],
				[
					-24946,
					-1556
				],
				[
					8876,
					6805
				],
				[
					2737,
					15853
				],
				[
					-5387,
					7065
				],
				[
					-70037,
					-25
				],
				[
					-5376,
					13981
				],
				[
					-14394,
					7062
				],
				[
					2682,
					14004
				],
				[
					-5411,
					7033
				],
				[
					-11188,
					7
				],
				[
					-100,
					14080
				],
				[
					-8578,
					-11576
				],
				[
					-17709,
					-7077
				],
				[
					-8222,
					-15052
				],
				[
					-11393,
					8178
				],
				[
					-5170,
					11010
				],
				[
					-7973,
					-1562
				],
				[
					-215,
					-11999
				],
				[
					-10858,
					-65
				],
				[
					-5394,
					21019
				],
				[
					-8367,
					-7034
				],
				[
					2657,
					13856
				],
				[
					-27084,
					11740
				],
				[
					-2,
					-11507
				],
				[
					-8142,
					7017
				],
				[
					-19001,
					5
				],
				[
					2714,
					-14040
				],
				[
					-10855,
					-4
				],
				[
					2,
					14042
				],
				[
					-13568,
					7023
				],
				[
					5,
					-14037
				],
				[
					-10076,
					7011
				],
				[
					-16836,
					11
				],
				[
					-7409,
					-14167
				],
				[
					-22636,
					146
				],
				[
					-35,
					28022
				],
				[
					-8135,
					17
				],
				[
					5420,
					14017
				],
				[
					-5422,
					7039
				]
			],
			[
				[
					3139228,
					2642952
				],
				[
					13559,
					-29
				],
				[
					2658,
					21554
				],
				[
					-24624,
					19
				],
				[
					110,
					3336
				]
			],
			[
				[
					3130931,
					2667832
				],
				[
					10369,
					4351
				]
			],
			[
				[
					3141300,
					2672183
				],
				[
					8689,
					-755
				],
				[
					8201,
					14129
				],
				[
					-5322,
					28076
				]
			],
			[
				[
					3152868,
					2713633
				],
				[
					12726,
					6165
				]
			],
			[
				[
					3165594,
					2719798
				],
				[
					7575,
					-3053
				],
				[
					1443,
					10974
				],
				[
					8209,
					-8858
				],
				[
					10905,
					1841
				],
				[
					5515,
					-21067
				],
				[
					2723,
					28055
				],
				[
					10923,
					2
				],
				[
					630,
					28044
				],
				[
					-2767,
					14070
				],
				[
					-8282,
					-5257
				],
				[
					-8238,
					5260
				],
				[
					5,
					10540
				],
				[
					-8296,
					-3556
				],
				[
					-2979,
					10562
				],
				[
					-2565,
					-29439
				],
				[
					-5513,
					-9180
				]
			],
			[
				[
					3174882,
					2748736
				],
				[
					-24792,
					10484
				],
				[
					-1402,
					17587
				],
				[
					-6866,
					-21
				],
				[
					-2732,
					21071
				],
				[
					-11018,
					-17
				]
			],
			[
				[
					3128072,
					2797840
				],
				[
					11,
					7015
				]
			],
			[
				[
					3128083,
					2804855
				],
				[
					8233,
					-4
				]
			],
			[
				[
					3136316,
					2804851
				],
				[
					5691,
					-8
				],
				[
					-3274,
					14027
				]
			],
			[
				[
					3138733,
					2818870
				],
				[
					2921,
					-4
				]
			],
			[
				[
					3141654,
					2818866
				],
				[
					13891,
					24
				]
			],
			[
				[
					3155545,
					2818890
				],
				[
					8301,
					30
				]
			],
			[
				[
					3163846,
					2818920
				],
				[
					23681,
					-2
				],
				[
					318,
					32698
				],
				[
					-7209,
					3028
				],
				[
					5292,
					23265
				]
			],
			[
				[
					3185928,
					2877909
				],
				[
					4993,
					18596
				],
				[
					-13059,
					6592
				],
				[
					-5601,
					14168
				],
				[
					-1667,
					21502
				],
				[
					4438,
					7234
				]
			],
			[
				[
					3326260,
					2930798
				],
				[
					0,
					0
				]
			],
			[
				[
					3264004,
					2889091
				],
				[
					0,
					0
				]
			],
			[
				[
					3264004,
					2889091
				],
				[
					-2777,
					-27997
				],
				[
					-8321,
					-7066
				],
				[
					-38,
					-28094
				],
				[
					11163,
					-7006
				],
				[
					12865,
					-24
				],
				[
					1,
					-13968
				],
				[
					13555,
					-320
				],
				[
					-4,
					14061
				],
				[
					6858,
					-31
				],
				[
					-2533,
					35373
				],
				[
					8169,
					1797
				],
				[
					-11085,
					12244
				],
				[
					-2804,
					21002
				],
				[
					-25049,
					29
				]
			],
			[
				[
					3397891,
					2744828
				],
				[
					-6999,
					-17201
				],
				[
					-800,
					-37980
				],
				[
					-7185,
					-8445
				],
				[
					-33,
					-11185
				],
				[
					7171,
					1149
				],
				[
					17167,
					-23453
				],
				[
					15430,
					-2632
				],
				[
					4092,
					9957
				],
				[
					19266,
					-15449
				],
				[
					5411,
					6825
				],
				[
					2298,
					18153
				],
				[
					-9712,
					6946
				],
				[
					-1203,
					21120
				],
				[
					8211,
					21077
				],
				[
					-8322,
					20792
				],
				[
					4929,
					5631
				]
			],
			[
				[
					3447612,
					2740133
				],
				[
					-19,
					15129
				],
				[
					8165,
					3526
				],
				[
					71,
					10512
				],
				[
					-13791,
					6986
				],
				[
					11122,
					21157
				],
				[
					-11193,
					-209
				],
				[
					51,
					15887
				],
				[
					-11011,
					-52
				],
				[
					5206,
					12571
				],
				[
					-8730,
					-1609
				],
				[
					2822,
					22758
				],
				[
					-2672,
					14010
				],
				[
					-11251,
					7005
				],
				[
					-13911,
					-10519
				],
				[
					-13866,
					42
				],
				[
					3830,
					-38868
				],
				[
					-8,
					-49206
				],
				[
					-2738,
					-7037
				],
				[
					8202,
					-17388
				]
			],
			[
				[
					3499174,
					2837285
				],
				[
					0,
					0
				]
			],
			[
				[
					3315186,
					2811273
				],
				[
					14,
					7403
				],
				[
					-11030,
					-37
				],
				[
					11016,
					-7366
				]
			],
			[
				[
					3314382,
					2839335
				],
				[
					-5902,
					25148
				],
				[
					-39,
					-30457
				],
				[
					5941,
					5309
				]
			],
			[
				[
					3207159,
					2820643
				],
				[
					0,
					0
				]
			],
			[
				[
					3207288,
					2820714
				],
				[
					0,
					0
				]
			],
			[
				[
					3207804,
					2820727
				],
				[
					0,
					0
				]
			],
			[
				[
					3508312,
					2432314
				],
				[
					-5465,
					-6325
				],
				[
					-17833,
					-535
				],
				[
					-3175,
					-6993
				],
				[
					-29657,
					-37
				],
				[
					-60,
					28066
				],
				[
					-18536,
					-56
				],
				[
					-5381,
					-21147
				],
				[
					-29338,
					741
				],
				[
					61,
					-21699
				],
				[
					-13427,
					14
				],
				[
					-18,
					14127
				],
				[
					-21364,
					-35
				],
				[
					-7899,
					6908
				],
				[
					-74,
					-13923
				],
				[
					-13346,
					-78
				],
				[
					-49,
					20994
				],
				[
					13149,
					-147
				],
				[
					177,
					21153
				],
				[
					-13430,
					-24
				],
				[
					-2539,
					27946
				],
				[
					-58042,
					452
				],
				[
					-8810,
					27861
				],
				[
					-28900,
					-6
				],
				[
					-2,
					7025
				],
				[
					-21549,
					3
				],
				[
					2695,
					-14044
				],
				[
					-8082,
					-2
				],
				[
					-5390,
					14047
				],
				[
					-8,
					-25481
				],
				[
					-8088,
					5215
				],
				[
					5394,
					6217
				],
				[
					-18848,
					-1
				],
				[
					-2691,
					14050
				],
				[
					-12284,
					-21235
				]
			],
			[
				[
					3175503,
					2495365
				],
				[
					-9232,
					24029
				],
				[
					-4783,
					42210
				],
				[
					-4717,
					5275
				],
				[
					-14306,
					-4794
				],
				[
					-4324,
					-12614
				],
				[
					-17660,
					-2147
				]
			],
			[
				[
					3120481,
					2547324
				],
				[
					-2633,
					11372
				],
				[
					-8061,
					25
				],
				[
					5074,
					49164
				],
				[
					-2734,
					14064
				]
			],
			[
				[
					3112127,
					2621949
				],
				[
					8110,
					14028
				],
				[
					16280,
					-39
				],
				[
					2711,
					7014
				]
			],
			[
				[
					3097996,
					2692567
				],
				[
					-8200,
					9
				]
			],
			[
				[
					3089796,
					2692576
				],
				[
					8200,
					-9
				]
			],
			[
				[
					3097996,
					2692567
				],
				[
					88,
					17566
				],
				[
					15133,
					-3474
				],
				[
					-70,
					6974
				],
				[
					11847,
					5
				],
				[
					343,
					-21073
				],
				[
					10974,
					15
				],
				[
					-1790,
					-14106
				],
				[
					6779,
					-6291
				]
			],
			[
				[
					3130931,
					2667832
				],
				[
					-16503,
					-10350
				],
				[
					-2753,
					28076
				],
				[
					-13679,
					7009
				]
			],
			[
				[
					2891719,
					2782548
				],
				[
					56,
					-9040
				],
				[
					15608,
					-3921
				]
			],
			[
				[
					2907383,
					2769587
				],
				[
					-5199,
					-13984
				]
			],
			[
				[
					2902184,
					2755603
				],
				[
					-758,
					-8175
				],
				[
					-14670,
					-8140
				],
				[
					-9204,
					-17100
				]
			],
			[
				[
					2877552,
					2722188
				],
				[
					-1877,
					-396
				]
			],
			[
				[
					2875675,
					2721792
				],
				[
					-1525,
					19186
				]
			],
			[
				[
					2874150,
					2740978
				],
				[
					17,
					36051
				],
				[
					-6916,
					6541
				]
			],
			[
				[
					2867251,
					2783570
				],
				[
					24468,
					-1022
				]
			],
			[
				[
					3061854,
					2812203
				],
				[
					22118,
					5232
				]
			],
			[
				[
					3083972,
					2817435
				],
				[
					-16,
					-2042
				]
			],
			[
				[
					3083956,
					2815393
				],
				[
					5507,
					-24559
				],
				[
					-39,
					-28070
				],
				[
					5516,
					-7045
				],
				[
					11024,
					14038
				],
				[
					27607,
					26
				],
				[
					-5499,
					28057
				]
			],
			[
				[
					3174882,
					2748736
				],
				[
					-3010,
					-26215
				],
				[
					-6278,
					-2723
				]
			],
			[
				[
					3152868,
					2713633
				],
				[
					-8324,
					7038
				],
				[
					-5414,
					24404
				],
				[
					-22141,
					-3328
				],
				[
					35,
					-7037
				],
				[
					-38188,
					-37
				],
				[
					-2704,
					-42093
				]
			],
			[
				[
					3076132,
					2692580
				],
				[
					-2729,
					-7016
				],
				[
					-19748,
					-3347
				],
				[
					11504,
					-32031
				]
			],
			[
				[
					3065159,
					2650186
				],
				[
					-7261,
					-6856
				],
				[
					-1696,
					-35107
				],
				[
					9813,
					-233
				],
				[
					-5478,
					-13870
				]
			],
			[
				[
					3060537,
					2594120
				],
				[
					-2690,
					-6917
				],
				[
					-15230,
					66
				],
				[
					2715,
					-13809
				]
			],
			[
				[
					3045332,
					2573460
				],
				[
					-208,
					-241
				]
			],
			[
				[
					3045124,
					2573219
				],
				[
					-18765,
					14030
				]
			],
			[
				[
					3026359,
					2587249
				],
				[
					-5428,
					7025
				],
				[
					3,
					21114
				],
				[
					-5409,
					7043
				],
				[
					-29699,
					-3517
				],
				[
					-2633,
					-10374
				]
			],
			[
				[
					2983193,
					2608540
				],
				[
					-5441,
					5
				],
				[
					2640,
					35822
				],
				[
					-12499,
					11726
				],
				[
					-9928,
					-4
				],
				[
					6198,
					-14921
				],
				[
					-23358,
					-1888
				],
				[
					-1842,
					-6709
				],
				[
					-5590,
					37046
				],
				[
					-7741,
					6137
				],
				[
					1557,
					16800
				]
			],
			[
				[
					2927189,
					2692554
				],
				[
					-9088,
					16646
				],
				[
					2730,
					34406
				],
				[
					25160,
					1922
				],
				[
					13963,
					24422
				],
				[
					13761,
					-2045
				],
				[
					2734,
					15622
				],
				[
					-5521,
					7323
				],
				[
					-30,
					14923
				]
			],
			[
				[
					2970898,
					2805773
				],
				[
					27719,
					-718
				],
				[
					21813,
					26937
				]
			],
			[
				[
					3020430,
					2831992
				],
				[
					4609,
					-12093
				],
				[
					26139,
					-10947
				],
				[
					10676,
					3251
				]
			],
			[
				[
					3041234,
					2749634
				],
				[
					0,
					0
				]
			],
			[
				[
					3067898,
					2734709
				],
				[
					0,
					0
				]
			],
			[
				[
					2680039,
					2739366
				],
				[
					-63,
					-2455
				]
			],
			[
				[
					2679976,
					2736911
				],
				[
					63,
					2455
				]
			],
			[
				[
					2907383,
					2769587
				],
				[
					13725,
					395
				],
				[
					-7186,
					-15007
				],
				[
					-11738,
					628
				]
			],
			[
				[
					2918418,
					2794591
				],
				[
					0,
					0
				]
			],
			[
				[
					2948504,
					2798178
				],
				[
					0,
					0
				]
			],
			[
				[
					2617796,
					2800124
				],
				[
					0,
					0
				]
			],
			[
				[
					2718439,
					2787547
				],
				[
					4195,
					10305
				],
				[
					13635,
					0
				],
				[
					9367,
					-6228
				],
				[
					221,
					-10820
				],
				[
					12507,
					-3781
				],
				[
					-1209,
					-14328
				],
				[
					4973,
					-16103
				],
				[
					-8253,
					-11478
				],
				[
					-14707,
					16764
				],
				[
					-1475,
					-4753
				]
			],
			[
				[
					2737693,
					2747125
				],
				[
					-21452,
					24451
				],
				[
					-9726,
					-3168
				],
				[
					-6337,
					-14386
				],
				[
					-15640,
					-6825
				],
				[
					-3579,
					8353
				],
				[
					5540,
					12325
				],
				[
					-13530,
					21349
				],
				[
					9223,
					7250
				],
				[
					-491,
					8283
				],
				[
					36738,
					-17210
				]
			],
			[
				[
					2618537,
					2805204
				],
				[
					0,
					0
				]
			],
			[
				[
					2954524,
					2994251
				],
				[
					8312,
					-3801
				],
				[
					8821,
					-17291
				],
				[
					17354,
					-70
				],
				[
					2949,
					-14061
				],
				[
					15864,
					7151
				],
				[
					11813,
					34
				],
				[
					2820,
					-7004
				]
			],
			[
				[
					3022457,
					2959209
				],
				[
					16927,
					-14037
				],
				[
					-8,
					-7006
				],
				[
					13662,
					-3321
				]
			],
			[
				[
					3053038,
					2934845
				],
				[
					24,
					-12409
				]
			],
			[
				[
					3053062,
					2922436
				],
				[
					311,
					-33431
				]
			],
			[
				[
					3053373,
					2889005
				],
				[
					-13874,
					-14061
				],
				[
					-131,
					-21047
				],
				[
					-5425,
					-1573
				],
				[
					-2751,
					-19470
				],
				[
					-10762,
					-862
				]
			],
			[
				[
					2970898,
					2805773
				],
				[
					-3275,
					4169
				],
				[
					-18713,
					-19146
				],
				[
					7,
					21109
				],
				[
					10974,
					-7077
				],
				[
					25,
					14118
				],
				[
					-11850,
					7046
				],
				[
					4,
					14127
				],
				[
					-11905,
					-215
				],
				[
					-5205,
					-20993
				],
				[
					-14010,
					-48
				],
				[
					-7696,
					7021
				],
				[
					-14127,
					-10307
				],
				[
					-4,
					-12819
				],
				[
					7819,
					-1879
				],
				[
					-11223,
					-18331
				]
			],
			[
				[
					2867251,
					2783570
				],
				[
					-9511,
					35215
				],
				[
					-12399,
					19517
				],
				[
					-159,
					22594
				],
				[
					-11116,
					7128
				],
				[
					-2513,
					14085
				],
				[
					-10287,
					-45
				],
				[
					-9597,
					9213
				],
				[
					3552,
					30508
				],
				[
					-11224,
					2193
				],
				[
					-30,
					42072
				]
			],
			[
				[
					2803967,
					2966050
				],
				[
					41073,
					198
				],
				[
					928,
					-21004
				],
				[
					39449,
					23
				],
				[
					11229,
					6892
				],
				[
					-15,
					14050
				],
				[
					8399,
					-13
				],
				[
					-86,
					10444
				],
				[
					-8318,
					-7
				],
				[
					8513,
					10413
				],
				[
					-12884,
					1707
				],
				[
					5711,
					5538
				],
				[
					-9298,
					14074
				],
				[
					10126,
					5
				]
			],
			[
				[
					2898794,
					3008370
				],
				[
					21640,
					-49
				]
			],
			[
				[
					2920434,
					3008321
				],
				[
					22629,
					3
				],
				[
					-28,
					-7091
				],
				[
					11489,
					-6982
				]
			],
			[
				[
					2954524,
					2994251
				],
				[
					0,
					0
				]
			],
			[
				[
					3050581,
					2905013
				],
				[
					0,
					0
				]
			],
			[
				[
					2898198,
					3010975
				],
				[
					-5314,
					22581
				],
				[
					-16409,
					30351
				],
				[
					4721,
					7388
				],
				[
					-8428,
					20394
				],
				[
					11578,
					-9322
				],
				[
					933,
					9898
				]
			],
			[
				[
					2885279,
					3092265
				],
				[
					31562,
					36
				],
				[
					2604,
					-14096
				],
				[
					9391,
					-17241
				],
				[
					-3793,
					-12210
				],
				[
					-10395,
					-1871
				],
				[
					-1048,
					-14181
				],
				[
					-15274,
					-12783
				],
				[
					-128,
					-8944
				]
			],
			[
				[
					2609647,
					2954631
				],
				[
					5530,
					-13997
				],
				[
					-10651,
					-16002
				],
				[
					6011,
					-18570
				],
				[
					-2542,
					-9434
				],
				[
					-17538,
					-13629
				],
				[
					13101,
					-16579
				],
				[
					20507,
					-4550
				],
				[
					-82,
					-33371
				],
				[
					-6067,
					-9761
				],
				[
					-8181,
					51
				],
				[
					-113,
					-11702
				],
				[
					9382,
					-21196
				],
				[
					18936,
					-11307
				],
				[
					11735,
					-27984
				],
				[
					11967,
					-6899
				],
				[
					-6357,
					-16480
				],
				[
					35725,
					-36151
				],
				[
					16914,
					-25061
				],
				[
					11195,
					-356
				],
				[
					9204,
					-15146
				],
				[
					9810,
					16723
				]
			],
			[
				[
					2738133,
					2663230
				],
				[
					2037,
					-11791
				],
				[
					-10296,
					-25192
				]
			],
			[
				[
					2729874,
					2626247
				],
				[
					1738,
					-14012
				],
				[
					-15631,
					-34494
				],
				[
					-8495,
					-28489
				],
				[
					6785,
					-9013
				]
			],
			[
				[
					2714271,
					2540239
				],
				[
					-19793,
					12499
				],
				[
					7223,
					-9811
				],
				[
					-16897,
					-14370
				],
				[
					-3681,
					7408
				]
			],
			[
				[
					2681123,
					2535965
				],
				[
					-7235,
					-13586
				],
				[
					-16047,
					4951
				],
				[
					-9972,
					-3374
				],
				[
					-5913,
					12938
				],
				[
					-17510,
					6866
				],
				[
					-2405,
					11524
				],
				[
					15134,
					22004
				],
				[
					-6867,
					12628
				],
				[
					-13624,
					2026
				],
				[
					-11414,
					17833
				],
				[
					-6373,
					-24498
				],
				[
					-10620,
					2180
				],
				[
					-9951,
					-6564
				]
			],
			[
				[
					2578326,
					2580893
				],
				[
					-3317,
					16705
				],
				[
					7012,
					6823
				],
				[
					-15749,
					24690
				],
				[
					-2480,
					12909
				],
				[
					7280,
					10616
				],
				[
					-5960,
					14682
				],
				[
					-9003,
					8982
				],
				[
					4008,
					17208
				],
				[
					-17733,
					14777
				],
				[
					-7286,
					-6954
				],
				[
					-597,
					13620
				],
				[
					-6375,
					11435
				],
				[
					1631,
					12395
				],
				[
					-12950,
					9575
				],
				[
					4559,
					9886
				],
				[
					-24653,
					29782
				],
				[
					-8641,
					-1685
				],
				[
					2711,
					-20112
				],
				[
					-5443,
					-5248
				],
				[
					-11090,
					15525
				],
				[
					-11930,
					1878
				],
				[
					-13882,
					36673
				]
			],
			[
				[
					2448438,
					2815055
				],
				[
					-33337,
					4063
				],
				[
					-6394,
					5048
				],
				[
					-20054,
					55822
				],
				[
					17418,
					-6463
				],
				[
					3995,
					5117
				],
				[
					-9499,
					22481
				],
				[
					-12512,
					683
				],
				[
					2234,
					16616
				],
				[
					-12643,
					6450
				]
			],
			[
				[
					2377646,
					2924872
				],
				[
					0,
					31647
				]
			],
			[
				[
					2377646,
					2956519
				],
				[
					9137,
					1411
				],
				[
					16177,
					-11871
				],
				[
					11103,
					8603
				],
				[
					13820,
					21713
				],
				[
					8123,
					1245
				],
				[
					-104,
					-43020
				],
				[
					35266,
					-383
				],
				[
					4116,
					34492
				],
				[
					15520,
					20939
				],
				[
					16598,
					5164
				],
				[
					8477,
					16981
				],
				[
					8763,
					4179
				],
				[
					15365,
					18197
				],
				[
					3623,
					33304
				],
				[
					6741,
					10962
				],
				[
					-6425,
					14446
				],
				[
					-2703,
					20605
				],
				[
					39379,
					347
				],
				[
					-6215,
					-16304
				],
				[
					9567,
					-1087
				],
				[
					-11396,
					-9945
				],
				[
					-17653,
					-66905
				],
				[
					-4223,
					-3194
				],
				[
					-11281,
					-31790
				],
				[
					-5851,
					-8415
				],
				[
					-5708,
					-22764
				],
				[
					18647,
					-12035
				],
				[
					4799,
					-16371
				],
				[
					38759,
					-66
				],
				[
					-55,
					12297
				],
				[
					8420,
					15614
				],
				[
					11215,
					1763
				]
			],
			[
				[
					3076956,
					2910139
				],
				[
					-5629,
					-29
				],
				[
					-1956,
					-21053
				]
			],
			[
				[
					3069371,
					2889057
				],
				[
					-13199,
					-80
				]
			],
			[
				[
					3056172,
					2888977
				],
				[
					-2799,
					28
				]
			],
			[
				[
					3053062,
					2922436
				],
				[
					15531,
					-5067
				],
				[
					8395,
					13874
				],
				[
					-32,
					-21104
				]
			],
			[
				[
					2976721,
					2998207
				],
				[
					0,
					0
				]
			],
			[
				[
					3022346,
					3001360
				],
				[
					0,
					0
				]
			],
			[
				[
					3035196,
					3022359
				],
				[
					-4398,
					6900
				]
			],
			[
				[
					3030798,
					3029259
				],
				[
					4398,
					-6900
				]
			],
			[
				[
					3201647,
					3582977
				],
				[
					-36096,
					-1168
				],
				[
					3962,
					-26417
				],
				[
					37723,
					-2235
				],
				[
					16988,
					-51332
				],
				[
					-13133,
					-29178
				],
				[
					-444,
					-22167
				]
			],
			[
				[
					3180395,
					3205798
				],
				[
					-10,
					12866
				],
				[
					-51745,
					-60
				],
				[
					26,
					-20893
				],
				[
					-34449,
					-126
				],
				[
					128,
					-42120
				],
				[
					-3065,
					-58
				],
				[
					572,
					-48899
				],
				[
					8661,
					-7287
				],
				[
					-2,
					-14049
				],
				[
					14259,
					1
				],
				[
					2850,
					21082
				],
				[
					14258,
					4
				],
				[
					2,
					9414
				],
				[
					14184,
					12006
				],
				[
					11457,
					-7358
				]
			],
			[
				[
					3107757,
					2945286
				],
				[
					-27980,
					7034
				],
				[
					-1438,
					-14055
				],
				[
					-21043,
					6891
				],
				[
					-4258,
					-10311
				]
			],
			[
				[
					3022457,
					2959209
				],
				[
					2975,
					28109
				],
				[
					13801,
					-86
				],
				[
					-1,
					14077
				]
			],
			[
				[
					3039232,
					3001309
				],
				[
					8498,
					-14028
				],
				[
					34052,
					69
				],
				[
					8505,
					6889
				],
				[
					2771,
					13675
				],
				[
					28,
					30228
				],
				[
					11315,
					12267
				],
				[
					-36759,
					-3
				],
				[
					-28367,
					3557
				],
				[
					5300,
					14050
				],
				[
					-11021,
					-3524
				],
				[
					-2779,
					-21153
				]
			],
			[
				[
					3030775,
					3043336
				],
				[
					-14109,
					-7042
				],
				[
					-28,
					-7045
				],
				[
					-14149,
					-116
				],
				[
					-15549,
					-13664
				],
				[
					-26796,
					-7147
				],
				[
					-11298,
					7011
				],
				[
					2177,
					19089
				],
				[
					17601,
					11273
				],
				[
					-8433,
					4468
				],
				[
					-14620,
					-11909
				],
				[
					-5266,
					-11081
				],
				[
					-19871,
					-18852
				]
			],
			[
				[
					2898794,
					3008370
				],
				[
					-596,
					2605
				]
			],
			[
				[
					2885279,
					3092265
				],
				[
					-50895,
					-23
				]
			],
			[
				[
					2834384,
					3092242
				],
				[
					-587,
					63343
				],
				[
					-1888,
					20974
				],
				[
					-86093,
					175
				],
				[
					251,
					50869
				],
				[
					11735,
					4002
				],
				[
					-14884,
					26623
				],
				[
					-2814,
					16750
				],
				[
					-14405,
					-6969
				],
				[
					-690,
					35014
				],
				[
					-16717,
					85
				],
				[
					-10352,
					19064
				],
				[
					4377,
					8923
				],
				[
					14577,
					-7124
				],
				[
					-5791,
					14141
				],
				[
					11804,
					148
				],
				[
					36,
					-7114
				],
				[
					14536,
					-177
				],
				[
					7484,
					7322
				],
				[
					-5212,
					13796
				],
				[
					619,
					14351
				],
				[
					17678,
					-215
				],
				[
					-321,
					21080
				],
				[
					17799,
					134
				],
				[
					-2803,
					20717
				],
				[
					47,
					42172
				],
				[
					53543,
					152
				],
				[
					-229,
					40125
				],
				[
					6526,
					4116
				],
				[
					6768,
					17364
				],
				[
					15538,
					3540
				],
				[
					12304,
					-3346
				],
				[
					16096,
					4750
				],
				[
					749,
					6772
				],
				[
					18820,
					-514
				],
				[
					-811,
					13167
				],
				[
					5106,
					34947
				],
				[
					-13505,
					3308
				],
				[
					294,
					43933
				],
				[
					54017,
					-36
				],
				[
					-1161,
					97898
				],
				[
					14011,
					10292
				],
				[
					15723,
					-2009
				],
				[
					10766,
					-8861
				],
				[
					218,
					-26201
				],
				[
					10040,
					-12196
				],
				[
					12801,
					9021
				],
				[
					-12986,
					8605
				],
				[
					-6671,
					18964
				],
				[
					1547,
					14339
				],
				[
					-9482,
					17698
				],
				[
					-606,
					24740
				],
				[
					-9886,
					16366
				],
				[
					84089,
					32
				]
			],
			[
				[
					3056389,
					3787292
				],
				[
					102422,
					253
				],
				[
					95,
					-21101
				],
				[
					37177,
					-123
				],
				[
					2936,
					-21220
				],
				[
					-478,
					-84461
				],
				[
					2619,
					-76
				],
				[
					487,
					-77587
				]
			],
			[
				[
					2762904,
					3008337
				],
				[
					-4651,
					-17740
				]
			],
			[
				[
					2758253,
					2990597
				],
				[
					-7254,
					-2979
				],
				[
					71,
					13356
				],
				[
					11834,
					7363
				]
			],
			[
				[
					2762904,
					3008337
				],
				[
					-15275,
					5012
				],
				[
					-1783,
					-8166
				],
				[
					-28441,
					-8343
				],
				[
					-6264,
					-7600
				],
				[
					-24775,
					-760
				],
				[
					-10964,
					4008
				],
				[
					-6970,
					-12467
				]
			],
			[
				[
					2668432,
					2980021
				],
				[
					-11797,
					4301
				],
				[
					-16624,
					-6632
				],
				[
					-11576,
					-16229
				],
				[
					-8119,
					1725
				],
				[
					-10669,
					-8555
				]
			],
			[
				[
					2377646,
					2956519
				],
				[
					0,
					430726
				]
			],
			[
				[
					2377646,
					3387245
				],
				[
					0,
					33441
				]
			],
			[
				[
					2377646,
					3420686
				],
				[
					0,
					15804
				]
			],
			[
				[
					2377646,
					3436490
				],
				[
					0,
					52697
				]
			],
			[
				[
					2377646,
					3489187
				],
				[
					0,
					929816
				]
			],
			[
				[
					2377646,
					4419003
				],
				[
					84843,
					0
				],
				[
					141405,
					0
				],
				[
					141404,
					0
				],
				[
					113124,
					0
				],
				[
					113124,
					0
				],
				[
					113124,
					0
				],
				[
					85379,
					1
				]
			],
			[
				[
					3170049,
					4419004
				],
				[
					-628,
					-240037
				],
				[
					12492,
					25738
				],
				[
					22611,
					20130
				],
				[
					18611,
					-4111
				],
				[
					9154,
					-9307
				],
				[
					15366,
					993
				],
				[
					12663,
					-7559
				],
				[
					17793,
					5404
				],
				[
					16959,
					-7691
				],
				[
					4010,
					-19291
				],
				[
					18173,
					-15813
				],
				[
					12353,
					36875
				],
				[
					2424,
					50089
				],
				[
					7972,
					23574
				],
				[
					3353,
					23055
				],
				[
					389,
					31484
				],
				[
					3947,
					-9150
				],
				[
					-6819,
					-39481
				],
				[
					7825,
					-35424
				],
				[
					-8909,
					-4402
				],
				[
					-2829,
					-12779
				],
				[
					13544,
					-4300
				],
				[
					-6785,
					-20357
				],
				[
					3854,
					-29686
				],
				[
					26294,
					-18094
				],
				[
					-12236,
					-30434
				],
				[
					6232,
					-17274
				],
				[
					16784,
					-28088
				],
				[
					817,
					-9980
				],
				[
					-32378,
					-15314
				],
				[
					-17754,
					-11899
				],
				[
					-2286,
					-23064
				],
				[
					12049,
					-36287
				],
				[
					8415,
					-8285
				],
				[
					-2254,
					-21245
				],
				[
					-147821,
					-1837
				],
				[
					-94362,
					403
				],
				[
					-52683,
					602
				],
				[
					0,
					-168870
				]
			],
			[
				[
					2834384,
					3092242
				],
				[
					-847,
					-21070
				],
				[
					-14875,
					446
				],
				[
					-6588,
					-6697
				],
				[
					519,
					-14571
				],
				[
					-10883,
					12
				],
				[
					103,
					-16965
				],
				[
					-17734,
					-8105
				],
				[
					-21175,
					-16955
				]
			],
			[
				[
					2486765,
					3225587
				],
				[
					7360,
					6598
				],
				[
					7049,
					-6176
				],
				[
					13980,
					4925
				],
				[
					14597,
					-3246
				],
				[
					21941,
					12156
				],
				[
					71,
					21350
				],
				[
					5791,
					6983
				],
				[
					-5785,
					13984
				],
				[
					-26091,
					-55
				],
				[
					-2993,
					-14097
				],
				[
					-20295,
					-14
				],
				[
					-5721,
					14061
				],
				[
					-14530,
					7071
				],
				[
					5699,
					-21098
				],
				[
					-5699,
					-13804
				],
				[
					4626,
					-28638
				]
			],
			[
				[
					2683527,
					3502358
				],
				[
					4213,
					29858
				],
				[
					10819,
					10910
				],
				[
					5579,
					18460
				],
				[
					4520,
					31043
				],
				[
					-8092,
					5013
				],
				[
					3517,
					10356
				],
				[
					-15290,
					10806
				],
				[
					7985,
					-18698
				],
				[
					-17399,
					-57899
				],
				[
					-24788,
					623
				],
				[
					-7628,
					-8028
				],
				[
					15881,
					-31
				],
				[
					-1462,
					-39690
				],
				[
					-8478,
					-727
				],
				[
					9570,
					-12185
				],
				[
					21053,
					20189
				]
			],
			[
				[
					3103268,
					2271169
				],
				[
					-2650,
					21031
				]
			],
			[
				[
					3100618,
					2292200
				],
				[
					2632,
					15
				]
			],
			[
				[
					3103250,
					2292215
				],
				[
					18,
					-21046
				]
			],
			[
				[
					3267267,
					2116647
				],
				[
					-17835,
					126
				],
				[
					-5422,
					14007
				],
				[
					-2071,
					25280
				],
				[
					-10393,
					9775
				],
				[
					45,
					14133
				],
				[
					-11418,
					7341
				],
				[
					3712,
					-10953
				]
			],
			[
				[
					3223885,
					2176356
				],
				[
					-36730,
					64
				],
				[
					-22184,
					11768
				],
				[
					-19184,
					5700
				],
				[
					-3856,
					12139
				],
				[
					-12532,
					-2210
				],
				[
					2917,
					-9729
				],
				[
					-18206,
					-52
				],
				[
					-5230,
					8190
				],
				[
					-7931,
					-3726
				]
			],
			[
				[
					3100949,
					2198500
				],
				[
					-2554,
					9504
				],
				[
					-10516,
					7056
				],
				[
					-513,
					28166
				]
			],
			[
				[
					3087366,
					2243226
				],
				[
					15904,
					6867
				]
			],
			[
				[
					3103270,
					2250093
				],
				[
					326,
					-24579
				],
				[
					33908,
					-3318
				],
				[
					2601,
					10455
				],
				[
					10369,
					-3685
				],
				[
					5231,
					14222
				],
				[
					7882,
					-40
				],
				[
					-2518,
					20957
				],
				[
					-10505,
					-53
				],
				[
					2603,
					14063
				],
				[
					-13100,
					14
				],
				[
					-5272,
					21029
				],
				[
					-13152,
					17
				],
				[
					2,
					7128
				]
			],
			[
				[
					3121645,
					2306303
				],
				[
					5250,
					6867
				]
			],
			[
				[
					3126895,
					2313170
				],
				[
					-407,
					7075
				]
			],
			[
				[
					3126488,
					2320245
				],
				[
					38,
					21042
				],
				[
					42375,
					420
				],
				[
					-7959,
					6658
				],
				[
					2678,
					21021
				],
				[
					-2700,
					30009
				],
				[
					10624,
					-1813
				],
				[
					11186,
					-11391
				],
				[
					-8821,
					50484
				],
				[
					-8598,
					19932
				],
				[
					14306,
					22823
				],
				[
					-4114,
					15935
				]
			],
			[
				[
					3508338,
					1812165
				],
				[
					-27842,
					7726
				],
				[
					12,
					22288
				],
				[
					-4582,
					16093
				],
				[
					5276,
					11965
				],
				[
					-2019,
					17738
				],
				[
					-11559,
					11228
				]
			],
			[
				[
					3467624,
					1899203
				],
				[
					-12189,
					27379
				],
				[
					-7620,
					6264
				],
				[
					-750,
					15222
				],
				[
					7841,
					199
				],
				[
					7631,
					-14987
				],
				[
					-452,
					43018
				],
				[
					6722,
					7972
				],
				[
					-1446,
					14449
				],
				[
					-15613,
					2304
				],
				[
					20,
					10232
				]
			],
			[
				[
					3451768,
					2011255
				],
				[
					15506,
					-124
				],
				[
					-2541,
					13789
				]
			],
			[
				[
					3464733,
					2024920
				],
				[
					12863,
					170
				],
				[
					6146,
					20386
				],
				[
					4625,
					1910
				],
				[
					1877,
					33861
				],
				[
					-8155,
					-7014
				],
				[
					-7377,
					6410
				],
				[
					1439,
					-27385
				],
				[
					-6411,
					-11
				]
			],
			[
				[
					3469740,
					2053247
				],
				[
					-5386,
					7087
				]
			],
			[
				[
					3464354,
					2060334
				],
				[
					-34,
					14055
				],
				[
					-10393,
					44
				],
				[
					36,
					-14060
				],
				[
					-11118,
					-3454
				],
				[
					-254,
					-17983
				],
				[
					-7835,
					2921
				],
				[
					-4076,
					-7864
				]
			],
			[
				[
					3430680,
					2033993
				],
				[
					-5930,
					-12500
				]
			],
			[
				[
					3424750,
					2021493
				],
				[
					-10392,
					3673
				],
				[
					-17887,
					-14033
				]
			],
			[
				[
					3396471,
					2011133
				],
				[
					-15729,
					12076
				],
				[
					-17448,
					-5619
				],
				[
					-10638,
					-19581
				],
				[
					-3401,
					3809
				],
				[
					-3848,
					-18273
				],
				[
					-6861,
					8293
				],
				[
					2497,
					40578
				],
				[
					-7988,
					6606
				],
				[
					-24007,
					-1751
				],
				[
					-8633,
					4129
				],
				[
					-5631,
					15006
				],
				[
					-21592,
					-1411
				],
				[
					-911,
					19224
				],
				[
					-12774,
					7469
				]
			],
			[
				[
					3259507,
					2081688
				],
				[
					-2673,
					28642
				]
			],
			[
				[
					3256834,
					2110330
				],
				[
					10429,
					-7670
				],
				[
					4,
					13987
				]
			],
			[
				[
					3267267,
					2116647
				],
				[
					12644,
					7215
				],
				[
					771,
					-21162
				],
				[
					28065,
					-110
				],
				[
					900,
					30497
				],
				[
					6937,
					4648
				],
				[
					5018,
					21035
				],
				[
					-11646,
					-25
				],
				[
					-5242,
					21107
				],
				[
					-5190,
					-7055
				],
				[
					-12412,
					11
				],
				[
					-3359,
					-12395
				],
				[
					-15551,
					7641
				],
				[
					-4241,
					-3404
				],
				[
					6976,
					-12654
				],
				[
					-8100,
					2470
				],
				[
					1878,
					-16485
				],
				[
					-7735,
					-7185
				],
				[
					10292,
					-92
				],
				[
					-5,
					-14057
				]
			],
			[
				[
					3479855,
					2088329
				],
				[
					5159,
					110
				]
			],
			[
				[
					3485014,
					2088439
				],
				[
					-5159,
					-110
				]
			],
			[
				[
					3376659,
					2064325
				],
				[
					0,
					0
				]
			],
			[
				[
					3154875,
					1859152
				],
				[
					-6260,
					-2335
				],
				[
					-55,
					13835
				],
				[
					10100,
					-47
				],
				[
					-3785,
					-11453
				]
			],
			[
				[
					3263384,
					1961699
				],
				[
					-5908,
					-3496
				],
				[
					-2068,
					-31296
				],
				[
					-12684,
					6987
				]
			],
			[
				[
					3242724,
					1933894
				],
				[
					-7667,
					7056
				]
			],
			[
				[
					3235057,
					1940950
				],
				[
					77,
					21034
				],
				[
					12528,
					7029
				],
				[
					5942,
					-8903
				],
				[
					9780,
					1589
				]
			],
			[
				[
					3429189,
					1937814
				],
				[
					2680,
					-3511
				],
				[
					-40,
					-27966
				],
				[
					12644,
					6585
				],
				[
					2853,
					-29946
				],
				[
					20298,
					16227
				]
			],
			[
				[
					3508316,
					1765477
				],
				[
					-140836,
					-14
				],
				[
					-110992,
					6
				],
				[
					-115256,
					-6
				],
				[
					-92681,
					16
				]
			],
			[
				[
					3048551,
					1765479
				],
				[
					-1363,
					14414
				],
				[
					-8145,
					9591
				],
				[
					482,
					10636
				],
				[
					-8198,
					10950
				],
				[
					-7439,
					-2662
				],
				[
					-12989,
					8504
				],
				[
					-9672,
					32336
				],
				[
					-12535,
					15738
				],
				[
					1152,
					36867
				],
				[
					-12165,
					-4545
				],
				[
					-6490,
					15208
				],
				[
					9667,
					6775
				],
				[
					104,
					7682
				]
			],
			[
				[
					2980960,
					1926973
				],
				[
					20919,
					-3366
				],
				[
					-77,
					31782
				],
				[
					9134,
					15656
				],
				[
					9053,
					5187
				],
				[
					11064,
					-7382
				],
				[
					14734,
					-104
				],
				[
					10505,
					13670
				],
				[
					-60,
					-48435
				],
				[
					20668,
					172
				],
				[
					9682,
					7385
				],
				[
					5852,
					-7491
				],
				[
					17737,
					-99
				],
				[
					-39,
					-52705
				],
				[
					2875,
					-14009
				],
				[
					17887,
					3460
				],
				[
					-4716,
					-13964
				],
				[
					17168,
					-103
				],
				[
					-7397,
					-6928
				],
				[
					29498,
					3721
				],
				[
					4130,
					30064
				],
				[
					19713,
					13946
				],
				[
					-846,
					4500
				]
			],
			[
				[
					3188444,
					1901930
				],
				[
					6012,
					-1841
				]
			],
			[
				[
					3194456,
					1900089
				],
				[
					5058,
					-4887
				],
				[
					17685,
					97
				],
				[
					2546,
					6942
				]
			],
			[
				[
					3219745,
					1902241
				],
				[
					12738,
					148
				],
				[
					12,
					10445
				],
				[
					25508,
					32
				]
			],
			[
				[
					3258003,
					1912866
				],
				[
					16626,
					-7048
				],
				[
					22316,
					-3513
				],
				[
					-5667,
					10676
				],
				[
					25,
					34571
				],
				[
					-5113,
					14372
				],
				[
					3402,
					21234
				],
				[
					-8777,
					-3842
				],
				[
					-5738,
					15280
				],
				[
					-6904,
					4043
				],
				[
					-5201,
					-8490
				],
				[
					412,
					-28450
				]
			],
			[
				[
					3263384,
					1961699
				],
				[
					-4474,
					14315
				],
				[
					2364,
					28203
				],
				[
					-10333,
					7023
				],
				[
					-10198,
					-7016
				],
				[
					-1,
					-21138
				],
				[
					-10243,
					-4581
				]
			],
			[
				[
					3230499,
					1978505
				],
				[
					-16570,
					-4900
				],
				[
					-17823,
					-11675
				]
			],
			[
				[
					3196106,
					1961930
				],
				[
					-9068,
					-9741
				]
			],
			[
				[
					3187038,
					1952189
				],
				[
					-7728,
					2839
				],
				[
					-2969,
					35044
				],
				[
					4980,
					21252
				],
				[
					-7635,
					-21
				],
				[
					5147,
					14029
				],
				[
					12885,
					73
				],
				[
					28,
					14122
				],
				[
					18063,
					-124
				],
				[
					17,
					13980
				],
				[
					12812,
					3520
				],
				[
					633,
					14055
				],
				[
					10478,
					-2
				],
				[
					-4,
					10700
				],
				[
					25762,
					32
				]
			],
			[
				[
					3396471,
					2011133
				],
				[
					1217,
					-13931
				],
				[
					12865,
					11
				],
				[
					5168,
					-14057
				],
				[
					7709,
					-10
				],
				[
					3210,
					-13988
				]
			],
			[
				[
					3426640,
					1969158
				],
				[
					5234,
					-31379
				],
				[
					-2685,
					35
				]
			],
			[
				[
					3429189,
					1937814
				],
				[
					0,
					0
				]
			],
			[
				[
					3296448,
					1948101
				],
				[
					0,
					0
				]
			],
			[
				[
					3115606,
					1844041
				],
				[
					13273,
					-4904
				],
				[
					4591,
					10563
				],
				[
					-17012,
					137
				],
				[
					-852,
					-5796
				]
			],
			[
				[
					3115606,
					1844041
				],
				[
					-10113,
					2067
				],
				[
					-60,
					-17670
				],
				[
					8539,
					160
				],
				[
					1634,
					15443
				]
			],
			[
				[
					3074622,
					2165806
				],
				[
					-4888,
					-15246
				],
				[
					-7,
					15244
				],
				[
					-7858,
					-7038
				]
			],
			[
				[
					3061869,
					2158766
				],
				[
					7841,
					14293
				]
			],
			[
				[
					3069710,
					2173059
				],
				[
					2295,
					-5109
				]
			],
			[
				[
					3072005,
					2167950
				],
				[
					2617,
					-2144
				]
			],
			[
				[
					2976813,
					2390651
				],
				[
					-38,
					-14190
				],
				[
					-12111,
					12543
				]
			],
			[
				[
					2964664,
					2389004
				],
				[
					-146,
					3528
				]
			],
			[
				[
					2964518,
					2392532
				],
				[
					12295,
					-1881
				]
			],
			[
				[
					2714271,
					2540239
				],
				[
					5993,
					-15027
				],
				[
					28439,
					-21060
				],
				[
					13083,
					-22501
				],
				[
					-202,
					-20816
				],
				[
					10973,
					-16395
				],
				[
					11187,
					4735
				],
				[
					9669,
					-11442
				],
				[
					14471,
					11318
				],
				[
					12570,
					20908
				],
				[
					11303,
					-18298
				],
				[
					5614,
					2325
				],
				[
					-148,
					-19516
				],
				[
					6758,
					-7282
				],
				[
					7205,
					4517
				],
				[
					16429,
					-16283
				],
				[
					10706,
					-18149
				]
			],
			[
				[
					2878321,
					2397273
				],
				[
					8779,
					-12873
				],
				[
					-4333,
					-7761
				],
				[
					6709,
					-35834
				],
				[
					-2559,
					-10184
				],
				[
					19557,
					-18220
				],
				[
					12177,
					6529
				],
				[
					8967,
					-1423
				]
			],
			[
				[
					2927618,
					2317507
				],
				[
					12347,
					-4865
				],
				[
					10776,
					2539
				],
				[
					4075,
					-13034
				],
				[
					11025,
					-10752
				],
				[
					11341,
					7728
				],
				[
					15983,
					67
				],
				[
					5185,
					-7087
				],
				[
					-9914,
					-3447
				]
			],
			[
				[
					2988436,
					2288656
				],
				[
					-7436,
					-741
				],
				[
					-20189,
					-13430
				],
				[
					5873,
					-9747
				],
				[
					18479,
					-5926
				],
				[
					2646,
					13267
				],
				[
					15695,
					-7971
				],
				[
					-787,
					-13965
				]
			],
			[
				[
					3002717,
					2250143
				],
				[
					-617,
					1
				]
			],
			[
				[
					3002100,
					2250144
				],
				[
					-8918,
					-200
				],
				[
					26,
					-13451
				]
			],
			[
				[
					2993208,
					2236493
				],
				[
					-129,
					-7534
				],
				[
					31747,
					-96
				]
			],
			[
				[
					3024826,
					2228863
				],
				[
					-2642,
					-21012
				],
				[
					-5213,
					-10555
				],
				[
					13124,
					-10462
				]
			],
			[
				[
					3030095,
					2186834
				],
				[
					5202,
					-35114
				]
			],
			[
				[
					3035297,
					2151720
				],
				[
					7888,
					-7115
				],
				[
					62,
					-10467
				],
				[
					-12398,
					-21
				],
				[
					-589,
					-10655
				],
				[
					7657,
					147
				],
				[
					538,
					-12447
				],
				[
					10037,
					12465
				],
				[
					35213,
					134
				],
				[
					10365,
					6932
				],
				[
					-1433,
					17508
				],
				[
					-7288,
					-469
				],
				[
					2619,
					25124
				],
				[
					5223,
					130
				],
				[
					0,
					21009
				],
				[
					-10523,
					-4
				],
				[
					-9835,
					-7094
				]
			],
			[
				[
					3072833,
					2186897
				],
				[
					-3110,
					-4711
				],
				[
					-10874,
					18801
				],
				[
					-13118,
					-114
				]
			],
			[
				[
					3045731,
					2200873
				],
				[
					-2594,
					13986
				],
				[
					7949,
					28
				]
			],
			[
				[
					3051086,
					2214887
				],
				[
					8678,
					-2069
				]
			],
			[
				[
					3059764,
					2212818
				],
				[
					7291,
					328
				]
			],
			[
				[
					3067055,
					2213146
				],
				[
					5147,
					-120
				]
			],
			[
				[
					3072202,
					2213026
				],
				[
					6074,
					-7409
				],
				[
					22673,
					-7117
				]
			],
			[
				[
					3223885,
					2176356
				],
				[
					3593,
					-16319
				],
				[
					13804,
					-9418
				],
				[
					-305,
					-24951
				],
				[
					6639,
					-14442
				],
				[
					9218,
					-896
				]
			],
			[
				[
					3187038,
					1952189
				],
				[
					-626,
					-4224
				]
			],
			[
				[
					3186412,
					1947965
				],
				[
					-517,
					-6935
				]
			],
			[
				[
					3185895,
					1941030
				],
				[
					-11744,
					-77
				],
				[
					-4278,
					14010
				],
				[
					-6069,
					-77
				],
				[
					9105,
					-13744
				],
				[
					-2406,
					-12068
				],
				[
					6662,
					-8390
				]
			],
			[
				[
					3177165,
					1920684
				],
				[
					5092,
					-3904
				]
			],
			[
				[
					3182257,
					1916780
				],
				[
					4221,
					-11447
				]
			],
			[
				[
					3186478,
					1905333
				],
				[
					1966,
					-3403
				]
			],
			[
				[
					2980960,
					1926973
				],
				[
					3808,
					15573
				],
				[
					-771,
					22589
				],
				[
					-5866,
					16540
				],
				[
					3886,
					17396
				],
				[
					-874,
					22997
				],
				[
					-7728,
					13891
				],
				[
					996,
					16612
				],
				[
					-5153,
					14430
				],
				[
					454,
					24303
				],
				[
					-10865,
					10552
				],
				[
					-17131,
					42547
				],
				[
					-8097,
					4557
				],
				[
					-9987,
					-5346
				],
				[
					-3912,
					-9593
				],
				[
					-12103,
					47765
				],
				[
					-11165,
					-3514
				],
				[
					-9183,
					16587
				]
			],
			[
				[
					2887269,
					2194859
				],
				[
					-17413,
					22707
				],
				[
					9824,
					4849
				],
				[
					-14736,
					32401
				],
				[
					-9056,
					9271
				],
				[
					-17103,
					3882
				],
				[
					-12809,
					20968
				],
				[
					3308,
					12535
				],
				[
					-20467,
					19176
				],
				[
					-8995,
					2524
				],
				[
					-1814,
					34875
				],
				[
					-8664,
					3468
				],
				[
					-3425,
					18024
				],
				[
					-23088,
					28040
				],
				[
					1085,
					12284
				],
				[
					-10651,
					24191
				],
				[
					-7314,
					-1550
				],
				[
					-8413,
					-17138
				],
				[
					-8753,
					-7921
				],
				[
					-9093,
					13860
				],
				[
					-4877,
					31644
				],
				[
					-14594,
					19799
				],
				[
					-5514,
					1616
				],
				[
					-12200,
					22719
				],
				[
					-1384,
					28882
				]
			],
			[
				[
					2869055,
					2288847
				],
				[
					11451,
					-1794
				],
				[
					262,
					7932
				],
				[
					-11713,
					-6138
				]
			],
			[
				[
					2898444,
					2280871
				],
				[
					2508,
					-10688
				],
				[
					-5094,
					-10828
				],
				[
					3332,
					-9220
				],
				[
					14966,
					-128
				],
				[
					5304,
					7110
				],
				[
					10857,
					-153
				],
				[
					-41,
					7748
				],
				[
					-18259,
					-7346
				],
				[
					-3270,
					13857
				],
				[
					-10303,
					9648
				]
			],
			[
				[
					3030073,
					2158772
				],
				[
					0,
					0
				]
			],
			[
				[
					3030073,
					2158772
				],
				[
					0,
					0
				]
			],
			[
				[
					2923853,
					2389049
				],
				[
					-2819,
					-7740
				]
			],
			[
				[
					2921034,
					2381309
				],
				[
					2819,
					7740
				]
			],
			[
				[
					3082165,
					2586814
				],
				[
					8286,
					23
				],
				[
					2684,
					-21076
				],
				[
					9429,
					-11847
				]
			],
			[
				[
					3102564,
					2553914
				],
				[
					-10065,
					6935
				],
				[
					-938,
					10175
				],
				[
					-12061,
					4190
				]
			],
			[
				[
					3079500,
					2575214
				],
				[
					-4389,
					313
				]
			],
			[
				[
					3075111,
					2575527
				],
				[
					-24361,
					-2310
				]
			],
			[
				[
					3050750,
					2573217
				],
				[
					-5626,
					2
				]
			],
			[
				[
					3045124,
					2573219
				],
				[
					208,
					241
				]
			],
			[
				[
					3060537,
					2594120
				],
				[
					16344,
					-275
				],
				[
					5284,
					-7031
				]
			],
			[
				[
					3082165,
					2586814
				],
				[
					0,
					0
				]
			],
			[
				[
					2822156,
					2602532
				],
				[
					0,
					0
				]
			],
			[
				[
					3043000,
					2292292
				],
				[
					-4,
					14023
				]
			],
			[
				[
					3042996,
					2306315
				],
				[
					13305,
					3429
				]
			],
			[
				[
					3056301,
					2309744
				],
				[
					3481,
					3516
				]
			],
			[
				[
					3059782,
					2313260
				],
				[
					1281,
					-7075
				],
				[
					23726,
					48
				],
				[
					-6119,
					28042
				],
				[
					-15892,
					27
				],
				[
					-37,
					-7079
				],
				[
					-11858,
					3563
				],
				[
					-2645,
					10582
				],
				[
					-29139,
					45
				],
				[
					7,
					-12320
				]
			],
			[
				[
					3019106,
					2329093
				],
				[
					-7951,
					1801
				],
				[
					25,
					17486
				],
				[
					-7988,
					7077
				],
				[
					-26429,
					-80
				],
				[
					8,
					10685
				],
				[
					-15219,
					-6884
				],
				[
					-6582,
					2363
				],
				[
					-8860,
					24987
				],
				[
					4535,
					1532
				]
			],
			[
				[
					2950645,
					2388060
				],
				[
					14019,
					944
				]
			],
			[
				[
					2976813,
					2390651
				],
				[
					-8778,
					13980
				],
				[
					59,
					13996
				],
				[
					-20425,
					-4133
				],
				[
					-3632,
					-16801
				],
				[
					-20986,
					-2999
				]
			],
			[
				[
					2923051,
					2394694
				],
				[
					-4865,
					2761
				],
				[
					-39865,
					-182
				]
			],
			[
				[
					2729874,
					2626247
				],
				[
					67052,
					1864
				],
				[
					-6080,
					17121
				],
				[
					-10398,
					11390
				],
				[
					13936,
					5023
				],
				[
					3944,
					-15011
				],
				[
					5914,
					-531
				],
				[
					12817,
					-17591
				],
				[
					19157,
					319
				],
				[
					-981,
					-13523
				],
				[
					5418,
					-4679
				],
				[
					-22781,
					-6886
				],
				[
					3602,
					-19101
				],
				[
					21822,
					89
				],
				[
					12909,
					14663
				],
				[
					16276,
					-4904
				],
				[
					9994,
					3523
				],
				[
					7613,
					-16008
				],
				[
					19584,
					1968
				],
				[
					1736,
					-33437
				],
				[
					-7430,
					-9541
				],
				[
					-362,
					-18803
				],
				[
					10586,
					-7073
				],
				[
					7894,
					-15163
				],
				[
					9535,
					9697
				],
				[
					3346,
					-8259
				],
				[
					8288,
					8756
				],
				[
					0,
					15647
				],
				[
					25671,
					-1679
				],
				[
					6739,
					10578
				],
				[
					-8094,
					10399
				],
				[
					8060,
					-59
				],
				[
					-657,
					49464
				],
				[
					8208,
					4
				],
				[
					1,
					14036
				]
			],
			[
				[
					3026359,
					2587249
				],
				[
					5585,
					-35163
				]
			],
			[
				[
					3031944,
					2552086
				],
				[
					11,
					-6955
				]
			],
			[
				[
					3031955,
					2545131
				],
				[
					8240,
					-13863
				]
			],
			[
				[
					3040195,
					2531268
				],
				[
					39,
					-7012
				]
			],
			[
				[
					3040234,
					2524256
				],
				[
					5354,
					-17563
				],
				[
					10867,
					-266
				],
				[
					-80,
					17559
				]
			],
			[
				[
					3056375,
					2523986
				],
				[
					3675,
					-68
				]
			],
			[
				[
					3060050,
					2523918
				],
				[
					-1432,
					-22770
				],
				[
					-22370,
					6810
				],
				[
					-16249,
					-18321
				],
				[
					-6690,
					9925
				],
				[
					17947,
					3559
				],
				[
					3565,
					13859
				],
				[
					-10760,
					-6819
				],
				[
					-10711,
					6988
				],
				[
					-13524,
					-5646
				],
				[
					-162,
					-29666
				],
				[
					11158,
					-38
				],
				[
					5050,
					7058
				],
				[
					16295,
					-14066
				],
				[
					2,
					14044
				],
				[
					7866,
					-7041
				],
				[
					21215,
					95
				],
				[
					847,
					-7201
				],
				[
					10695,
					-27
				],
				[
					8152,
					-10515
				]
			],
			[
				[
					3080944,
					2464146
				],
				[
					-13498,
					-3487
				],
				[
					357,
					-7126
				],
				[
					-11054,
					220
				],
				[
					15,
					6942
				],
				[
					-24594,
					83
				],
				[
					-13386,
					-14045
				],
				[
					-10665,
					7039
				],
				[
					232,
					-13952
				],
				[
					10433,
					-7148
				],
				[
					201,
					-13949
				],
				[
					18719,
					13
				],
				[
					-198,
					13984
				],
				[
					10715,
					-6992
				],
				[
					13939,
					-20
				],
				[
					10635,
					-6971
				],
				[
					6,
					-10531
				],
				[
					10624,
					6893
				],
				[
					16,
					10575
				],
				[
					8048,
					32
				],
				[
					-2708,
					38411
				]
			],
			[
				[
					3088781,
					2464117
				],
				[
					5402,
					18
				],
				[
					7736,
					17534
				],
				[
					13119,
					44
				],
				[
					61,
					20842
				],
				[
					-5352,
					7037
				],
				[
					-16149,
					21
				],
				[
					-10766,
					-7029
				],
				[
					-6165,
					14035
				],
				[
					-7123,
					-12172
				],
				[
					-122,
					12219
				],
				[
					-8123,
					7222
				]
			],
			[
				[
					3061299,
					2523888
				],
				[
					3718,
					6906
				],
				[
					15100,
					-115
				]
			],
			[
				[
					3080117,
					2530679
				],
				[
					2701,
					-16
				]
			],
			[
				[
					3082818,
					2530663
				],
				[
					2695,
					-6997
				],
				[
					26901,
					-4945
				],
				[
					33,
					19016
				],
				[
					8033,
					-69
				],
				[
					1,
					9656
				]
			],
			[
				[
					3126488,
					2320245
				],
				[
					407,
					-7075
				]
			],
			[
				[
					3121645,
					2306303
				],
				[
					-7990,
					55
				],
				[
					-2522,
					-14063
				],
				[
					-7883,
					-80
				]
			],
			[
				[
					3100618,
					2292200
				],
				[
					-13160,
					-7023
				],
				[
					-278,
					-14035
				],
				[
					-5570,
					-2
				]
			],
			[
				[
					3081610,
					2271140
				],
				[
					544,
					28097
				],
				[
					-13164,
					-69
				],
				[
					-2646,
					-7034
				]
			],
			[
				[
					3066344,
					2292134
				],
				[
					-10188,
					5
				]
			],
			[
				[
					3056156,
					2292139
				],
				[
					-10540,
					154
				]
			],
			[
				[
					3045616,
					2292293
				],
				[
					-2616,
					-1
				]
			],
			[
				[
					3008261,
					2418696
				],
				[
					2537,
					20803
				],
				[
					-8013,
					-1532
				],
				[
					-2554,
					-19268
				],
				[
					8030,
					-3
				]
			],
			[
				[
					2994642,
					2488926
				],
				[
					0,
					0
				]
			],
			[
				[
					3295301,
					3470945
				],
				[
					18404,
					23540
				],
				[
					1915,
					10656
				],
				[
					13740,
					15426
				],
				[
					2331,
					17383
				],
				[
					23145,
					18356
				],
				[
					22598,
					2817
				],
				[
					-3093,
					-10651
				],
				[
					8883,
					133
				],
				[
					6460,
					12876
				],
				[
					2292,
					-20251
				],
				[
					17889,
					-17570
				],
				[
					-2088,
					-13287
				],
				[
					4336,
					-13802
				],
				[
					-6400,
					-15809
				],
				[
					2798,
					-24688
				],
				[
					4402,
					-3383
				],
				[
					3326,
					-22929
				],
				[
					6809,
					-11
				],
				[
					-522,
					13731
				],
				[
					7681,
					3842
				],
				[
					-919,
					-17591
				],
				[
					79596,
					-385
				]
			],
			[
				[
					3326338,
					3735950
				],
				[
					0,
					0
				]
			],
			[
				[
					3508884,
					3787271
				],
				[
					-167534,
					478
				],
				[
					4042,
					-9457
				],
				[
					-27941,
					9160
				],
				[
					-12122,
					-18780
				],
				[
					-17808,
					155
				],
				[
					2420,
					-24014
				],
				[
					368,
					-83839
				],
				[
					1466,
					-38289
				],
				[
					-2175,
					-5748
				],
				[
					-57102,
					-446
				],
				[
					-8258,
					-19385
				],
				[
					-17243,
					-1063
				],
				[
					-5350,
					-13066
				]
			],
			[
				[
					3170049,
					4419004
				],
				[
					140869,
					-1
				],
				[
					113124,
					0
				],
				[
					84842,
					0
				]
			],
			[
				[
					3326950,
					4385945
				],
				[
					0,
					0
				]
			],
			[
				[
					3424750,
					2021493
				],
				[
					12066,
					-5020
				]
			],
			[
				[
					3436816,
					2016473
				],
				[
					-9488,
					-12226
				],
				[
					8983,
					-86
				],
				[
					2516,
					-28005
				],
				[
					-12187,
					-6998
				]
			],
			[
				[
					3464354,
					2060334
				],
				[
					-10016,
					38
				],
				[
					47,
					-35169
				],
				[
					-2617,
					-13948
				]
			],
			[
				[
					3451768,
					2011255
				],
				[
					-10315,
					-12577
				],
				[
					-4944,
					19606
				]
			],
			[
				[
					3436509,
					2018284
				],
				[
					-5829,
					15709
				]
			],
			[
				[
					3464733,
					2024920
				],
				[
					-9763,
					279
				],
				[
					14770,
					28048
				]
			],
			[
				[
					3479855,
					2088329
				],
				[
					5159,
					110
				]
			],
			[
				[
					3436816,
					2016473
				],
				[
					-307,
					1811
				]
			],
			[
				[
					3258003,
					1912866
				],
				[
					-15279,
					21028
				]
			],
			[
				[
					3235057,
					1940950
				],
				[
					-2521,
					-1914
				],
				[
					-2037,
					39469
				]
			],
			[
				[
					3186412,
					1947965
				],
				[
					8157,
					121
				],
				[
					-2015,
					-14197
				],
				[
					-6659,
					7141
				]
			],
			[
				[
					3226075,
					1912910
				],
				[
					0,
					0
				]
			],
			[
				[
					3183980,
					1922201
				],
				[
					0,
					0
				]
			],
			[
				[
					3183974,
					1922752
				],
				[
					0,
					0
				]
			],
			[
				[
					3196106,
					1961930
				],
				[
					8518,
					-24
				],
				[
					73,
					-26241
				],
				[
					4968,
					-15803
				],
				[
					7526,
					7104
				],
				[
					2554,
					-24725
				]
			],
			[
				[
					3194456,
					1900089
				],
				[
					-7978,
					5244
				]
			],
			[
				[
					3182257,
					1916780
				],
				[
					14781,
					3051
				],
				[
					-600,
					12362
				],
				[
					-16040,
					-54
				],
				[
					-3233,
					-11455
				]
			],
			[
				[
					3103270,
					2250093
				],
				[
					-5300,
					7044
				],
				[
					5298,
					14032
				]
			],
			[
				[
					3071816,
					2174881
				],
				[
					2806,
					-9075
				]
			],
			[
				[
					3072005,
					2167950
				],
				[
					-189,
					6931
				]
			],
			[
				[
					3071816,
					2174881
				],
				[
					-2106,
					-1822
				]
			],
			[
				[
					3061869,
					2158766
				],
				[
					-2613,
					-7080
				],
				[
					-23959,
					34
				]
			],
			[
				[
					3030095,
					2186834
				],
				[
					7832,
					30
				],
				[
					-33,
					16015
				],
				[
					7837,
					-2006
				]
			],
			[
				[
					3072833,
					2186897
				],
				[
					-1017,
					-12016
				]
			],
			[
				[
					2950645,
					2388060
				],
				[
					13873,
					4472
				]
			],
			[
				[
					2923051,
					2394694
				],
				[
					802,
					-5645
				]
			],
			[
				[
					2921034,
					2381309
				],
				[
					6350,
					-18486
				],
				[
					7463,
					2218
				],
				[
					5643,
					-19916
				],
				[
					-8045,
					-3718
				],
				[
					1606,
					-17663
				],
				[
					-6433,
					-6237
				]
			],
			[
				[
					3077605,
					2260607
				],
				[
					1821,
					-17373
				],
				[
					7940,
					-8
				]
			],
			[
				[
					3072202,
					2213026
				],
				[
					-653,
					30210
				],
				[
					-5289,
					-5
				]
			],
			[
				[
					3066260,
					2243231
				],
				[
					103,
					13834
				]
			],
			[
				[
					3066363,
					2257065
				],
				[
					7,
					6988
				]
			],
			[
				[
					3066370,
					2264053
				],
				[
					11235,
					-3446
				]
			],
			[
				[
					3066344,
					2271117
				],
				[
					26,
					-7064
				]
			],
			[
				[
					3066370,
					2264053
				],
				[
					-10183,
					-23
				]
			],
			[
				[
					3056187,
					2264030
				],
				[
					2317,
					9326
				]
			],
			[
				[
					3058504,
					2273356
				],
				[
					7840,
					-2239
				]
			],
			[
				[
					3056250,
					2261961
				],
				[
					0,
					0
				]
			],
			[
				[
					3056250,
					2261961
				],
				[
					-63,
					2069
				]
			],
			[
				[
					3066363,
					2257065
				],
				[
					-5281,
					-3465
				]
			],
			[
				[
					3061082,
					2253600
				],
				[
					-5319,
					3254
				]
			],
			[
				[
					3055763,
					2256854
				],
				[
					-1551,
					2591
				]
			],
			[
				[
					3054212,
					2259445
				],
				[
					2038,
					2516
				]
			],
			[
				[
					3061082,
					2253600
				],
				[
					-6183,
					-2488
				]
			],
			[
				[
					3054899,
					2251112
				],
				[
					864,
					5742
				]
			],
			[
				[
					3066260,
					2243231
				],
				[
					-2594,
					-7096
				]
			],
			[
				[
					3063666,
					2236135
				],
				[
					-10036,
					2209
				]
			],
			[
				[
					3053630,
					2238344
				],
				[
					-231,
					2312
				]
			],
			[
				[
					3053399,
					2240656
				],
				[
					-54,
					9164
				]
			],
			[
				[
					3053345,
					2249820
				],
				[
					1554,
					1292
				]
			],
			[
				[
					3056277,
					2285261
				],
				[
					2179,
					-3546
				]
			],
			[
				[
					3058456,
					2281715
				],
				[
					48,
					-8359
				]
			],
			[
				[
					3054212,
					2259445
				],
				[
					-4937,
					1194
				]
			],
			[
				[
					3049275,
					2260639
				],
				[
					-6,
					414
				]
			],
			[
				[
					3049269,
					2261053
				],
				[
					-134,
					6546
				]
			],
			[
				[
					3049135,
					2267599
				],
				[
					5613,
					14148
				]
			],
			[
				[
					3054748,
					2281747
				],
				[
					1529,
					3514
				]
			],
			[
				[
					3053345,
					2249820
				],
				[
					-4635,
					248
				]
			],
			[
				[
					3048710,
					2250068
				],
				[
					459,
					7018
				]
			],
			[
				[
					3049169,
					2257086
				],
				[
					323,
					1396
				]
			],
			[
				[
					3049492,
					2258482
				],
				[
					-217,
					2157
				]
			],
			[
				[
					3053399,
					2240656
				],
				[
					-4773,
					559
				]
			],
			[
				[
					3048626,
					2241215
				],
				[
					84,
					8853
				]
			],
			[
				[
					3045772,
					2221055
				],
				[
					5314,
					-6168
				]
			],
			[
				[
					3024826,
					2228863
				],
				[
					15643,
					101
				]
			],
			[
				[
					3040469,
					2228964
				],
				[
					5303,
					-7909
				]
			],
			[
				[
					3053630,
					2238344
				],
				[
					1083,
					-12826
				]
			],
			[
				[
					3054713,
					2225518
				],
				[
					-6267,
					5332
				]
			],
			[
				[
					3048446,
					2230850
				],
				[
					-485,
					8593
				]
			],
			[
				[
					3047961,
					2239443
				],
				[
					665,
					1772
				]
			],
			[
				[
					3049135,
					2267599
				],
				[
					-3467,
					-1453
				]
			],
			[
				[
					3045668,
					2266146
				],
				[
					-270,
					11950
				]
			],
			[
				[
					3045398,
					2278096
				],
				[
					9350,
					3651
				]
			],
			[
				[
					3050607,
					2278331
				],
				[
					0,
					0
				]
			],
			[
				[
					3045668,
					2266146
				],
				[
					-4074,
					1440
				]
			],
			[
				[
					3041594,
					2267586
				],
				[
					-401,
					-8
				]
			],
			[
				[
					3041193,
					2267578
				],
				[
					1055,
					12268
				]
			],
			[
				[
					3042248,
					2279846
				],
				[
					3150,
					-1750
				]
			],
			[
				[
					3049269,
					2261053
				],
				[
					-7675,
					6533
				]
			],
			[
				[
					3081610,
					2271140
				],
				[
					-4005,
					-10533
				]
			],
			[
				[
					3066344,
					2271117
				],
				[
					-2,
					10128
				]
			],
			[
				[
					3066342,
					2281245
				],
				[
					2,
					10889
				]
			],
			[
				[
					3039958,
					2267584
				],
				[
					869,
					-4
				]
			],
			[
				[
					3040827,
					2267580
				],
				[
					366,
					-2
				]
			],
			[
				[
					3049275,
					2260639
				],
				[
					-3600,
					-1385
				]
			],
			[
				[
					3045675,
					2259254
				],
				[
					-5229,
					2311
				]
			],
			[
				[
					3040446,
					2261565
				],
				[
					-1260,
					6051
				]
			],
			[
				[
					3039186,
					2267616
				],
				[
					772,
					-32
				]
			],
			[
				[
					3049492,
					2258482
				],
				[
					-3155,
					168
				]
			],
			[
				[
					3046337,
					2258650
				],
				[
					-662,
					604
				]
			],
			[
				[
					3049169,
					2257086
				],
				[
					-1642,
					-7
				]
			],
			[
				[
					3047527,
					2257079
				],
				[
					-1244,
					-3
				]
			],
			[
				[
					3046283,
					2257076
				],
				[
					54,
					1574
				]
			],
			[
				[
					3048710,
					2250068
				],
				[
					-2035,
					-2
				]
			],
			[
				[
					3046675,
					2250066
				],
				[
					852,
					7013
				]
			],
			[
				[
					3046675,
					2250066
				],
				[
					-2330,
					-248
				]
			],
			[
				[
					3044345,
					2249818
				],
				[
					-749,
					7233
				]
			],
			[
				[
					3043596,
					2257051
				],
				[
					2687,
					25
				]
			],
			[
				[
					3047961,
					2239443
				],
				[
					-7469,
					-318
				]
			],
			[
				[
					3040492,
					2239125
				],
				[
					3853,
					10693
				]
			],
			[
				[
					3046233,
					2238929
				],
				[
					0,
					0
				]
			],
			[
				[
					3045896,
					2238787
				],
				[
					0,
					0
				]
			],
			[
				[
					3046507,
					2239043
				],
				[
					0,
					0
				]
			],
			[
				[
					3002717,
					2250143
				],
				[
					11162,
					-3613
				],
				[
					5572,
					-8577
				],
				[
					10253,
					-1229
				]
			],
			[
				[
					3029704,
					2236724
				],
				[
					10788,
					2401
				]
			],
			[
				[
					3048446,
					2230850
				],
				[
					-7977,
					-1886
				]
			],
			[
				[
					2993208,
					2236493
				],
				[
					8892,
					13651
				]
			],
			[
				[
					3054713,
					2225518
				],
				[
					442,
					-3141
				]
			],
			[
				[
					3055155,
					2222377
				],
				[
					4609,
					-9559
				]
			],
			[
				[
					3045772,
					2221055
				],
				[
					2674,
					9795
				]
			],
			[
				[
					3063666,
					2236135
				],
				[
					3309,
					-10431
				]
			],
			[
				[
					3066975,
					2225704
				],
				[
					-11820,
					-3327
				]
			],
			[
				[
					3040827,
					2267580
				],
				[
					-869,
					4
				]
			],
			[
				[
					3039186,
					2267616
				],
				[
					-3003,
					7037
				]
			],
			[
				[
					3036183,
					2274653
				],
				[
					1710,
					9984
				]
			],
			[
				[
					3037893,
					2284637
				],
				[
					5227,
					631
				]
			],
			[
				[
					3043120,
					2285268
				],
				[
					905,
					1952
				]
			],
			[
				[
					3044025,
					2287220
				],
				[
					-1777,
					-7374
				]
			],
			[
				[
					3040446,
					2261565
				],
				[
					-5276,
					4733
				]
			],
			[
				[
					3035170,
					2266298
				],
				[
					-5267,
					1339
				]
			],
			[
				[
					3029903,
					2267637
				],
				[
					-4214,
					4696
				]
			],
			[
				[
					3025689,
					2272333
				],
				[
					7800,
					4714
				]
			],
			[
				[
					3033489,
					2277047
				],
				[
					2694,
					-2394
				]
			],
			[
				[
					3043596,
					2257051
				],
				[
					-5780,
					491
				]
			],
			[
				[
					3037816,
					2257542
				],
				[
					-2646,
					8756
				]
			],
			[
				[
					3029704,
					2236724
				],
				[
					8068,
					9976
				]
			],
			[
				[
					3037772,
					2246700
				],
				[
					44,
					10842
				]
			],
			[
				[
					3033489,
					2277047
				],
				[
					-6229,
					5752
				]
			],
			[
				[
					3027260,
					2282799
				],
				[
					10633,
					1838
				]
			],
			[
				[
					3037772,
					2246700
				],
				[
					-7895,
					3380
				],
				[
					26,
					17557
				]
			],
			[
				[
					3058456,
					2281715
				],
				[
					7886,
					-470
				]
			],
			[
				[
					3056156,
					2292139
				],
				[
					121,
					-6878
				]
			],
			[
				[
					3044025,
					2287220
				],
				[
					1591,
					5073
				]
			],
			[
				[
					3019377,
					2289514
				],
				[
					7883,
					-6715
				]
			],
			[
				[
					3025689,
					2272333
				],
				[
					-6675,
					12152
				],
				[
					-10227,
					1414
				]
			],
			[
				[
					3008787,
					2285899
				],
				[
					80,
					9915
				],
				[
					10510,
					-6300
				]
			],
			[
				[
					3066975,
					2225704
				],
				[
					80,
					-12558
				]
			],
			[
				[
					3043000,
					2292292
				],
				[
					0,
					0
				]
			],
			[
				[
					3043120,
					2285268
				],
				[
					-5375,
					10865
				]
			],
			[
				[
					3037745,
					2296133
				],
				[
					10,
					10171
				]
			],
			[
				[
					3037755,
					2306304
				],
				[
					5241,
					11
				]
			],
			[
				[
					3024645,
					2313256
				],
				[
					5192,
					-15728
				],
				[
					7908,
					-1395
				]
			],
			[
				[
					3019377,
					2289514
				],
				[
					4,
					23760
				],
				[
					5264,
					-18
				]
			],
			[
				[
					2988436,
					2288656
				],
				[
					1999,
					-10602
				],
				[
					18369,
					224
				],
				[
					-17,
					7621
				]
			],
			[
				[
					3056301,
					2309744
				],
				[
					3481,
					3516
				]
			],
			[
				[
					3037755,
					2306304
				],
				[
					0,
					0
				]
			],
			[
				[
					3024645,
					2313256
				],
				[
					2378,
					14119
				],
				[
					-7917,
					1718
				]
			],
			[
				[
					3080117,
					2530679
				],
				[
					2701,
					-16
				]
			],
			[
				[
					3093589,
					2544737
				],
				[
					0,
					0
				]
			],
			[
				[
					3080146,
					2541238
				],
				[
					-2686,
					1691
				]
			],
			[
				[
					3077460,
					2542929
				],
				[
					2686,
					-1691
				]
			],
			[
				[
					3082981,
					2556058
				],
				[
					0,
					0
				]
			],
			[
				[
					3089995,
					2559846
				],
				[
					0,
					0
				]
			],
			[
				[
					3040234,
					2524256
				],
				[
					8045,
					-7021
				],
				[
					8096,
					6751
				]
			],
			[
				[
					3060050,
					2523918
				],
				[
					1249,
					-30
				]
			],
			[
				[
					3088781,
					2464117
				],
				[
					-7837,
					29
				]
			],
			[
				[
					3076132,
					2692580
				],
				[
					13664,
					-4
				]
			],
			[
				[
					3112127,
					2621949
				],
				[
					-14682,
					6995
				],
				[
					-15155,
					-8
				],
				[
					-5422,
					14017
				],
				[
					-11709,
					7233
				]
			],
			[
				[
					3120481,
					2547324
				],
				[
					-17917,
					6590
				]
			],
			[
				[
					3040195,
					2531268
				],
				[
					20,
					13879
				],
				[
					-8260,
					-16
				]
			],
			[
				[
					3031944,
					2552086
				],
				[
					13478,
					10
				],
				[
					5328,
					21121
				]
			],
			[
				[
					3075111,
					2575527
				],
				[
					4389,
					-313
				]
			],
			[
				[
					3085547,
					2553490
				],
				[
					-4057,
					17
				]
			],
			[
				[
					3081490,
					2553507
				],
				[
					-4030,
					-10578
				]
			],
			[
				[
					3080146,
					2541238
				],
				[
					5401,
					12252
				]
			],
			[
				[
					3061296,
					2551903
				],
				[
					0,
					0
				]
			],
			[
				[
					3072084,
					2549479
				],
				[
					0,
					0
				]
			],
			[
				[
					3074815,
					2549639
				],
				[
					0,
					0
				]
			],
			[
				[
					3080779,
					2552797
				],
				[
					0,
					0
				]
			],
			[
				[
					3071677,
					2555402
				],
				[
					0,
					0
				]
			],
			[
				[
					3064005,
					2561235
				],
				[
					0,
					0
				]
			],
			[
				[
					3072834,
					2565740
				],
				[
					0,
					0
				]
			],
			[
				[
					3072751,
					2557090
				],
				[
					0,
					0
				]
			],
			[
				[
					3071442,
					2566910
				],
				[
					0,
					0
				]
			],
			[
				[
					3076019,
					2569330
				],
				[
					0,
					0
				]
			],
			[
				[
					3085547,
					2553490
				],
				[
					-4057,
					17
				]
			],
			[
				[
					2877552,
					2722188
				],
				[
					-660,
					-11016
				],
				[
					9589,
					-14978
				],
				[
					24980,
					155
				],
				[
					15728,
					-3795
				]
			],
			[
				[
					2738133,
					2663230
				],
				[
					-1702,
					8466
				],
				[
					24429,
					-245
				],
				[
					-4743,
					14640
				],
				[
					9608,
					15961
				],
				[
					12533,
					-9484
				],
				[
					93512,
					17
				],
				[
					3866,
					5563
				],
				[
					39,
					23644
				]
			],
			[
				[
					3122561,
					2811835
				],
				[
					-2731,
					-10
				]
			],
			[
				[
					3119830,
					2811825
				],
				[
					2731,
					10
				]
			],
			[
				[
					3127716,
					2875167
				],
				[
					-278,
					-7196
				]
			],
			[
				[
					3127438,
					2867971
				],
				[
					-8022,
					3209
				]
			],
			[
				[
					3119416,
					2871180
				],
				[
					25,
					7796
				]
			],
			[
				[
					3119441,
					2878976
				],
				[
					8275,
					-3809
				]
			],
			[
				[
					3119416,
					2871180
				],
				[
					553,
					-6886
				]
			],
			[
				[
					3119969,
					2864294
				],
				[
					-3123,
					-276
				]
			],
			[
				[
					3116846,
					2864018
				],
				[
					-1731,
					1739
				]
			],
			[
				[
					3115115,
					2865757
				],
				[
					180,
					5027
				]
			],
			[
				[
					3115295,
					2870784
				],
				[
					1368,
					403
				]
			],
			[
				[
					3116663,
					2871187
				],
				[
					2753,
					-7
				]
			],
			[
				[
					3127445,
					2924296
				],
				[
					2787,
					-7
				]
			],
			[
				[
					3141401,
					2917264
				],
				[
					-5250,
					-14188
				]
			],
			[
				[
					3136151,
					2903076
				],
				[
					-11525,
					26
				]
			],
			[
				[
					3124626,
					2903102
				],
				[
					2819,
					21194
				]
			],
			[
				[
					3116663,
					2871187
				],
				[
					5,
					7772
				]
			],
			[
				[
					3116668,
					2878959
				],
				[
					2773,
					17
				]
			],
			[
				[
					3115295,
					2870784
				],
				[
					-5206,
					-230
				]
			],
			[
				[
					3110089,
					2870554
				],
				[
					-1093,
					4528
				]
			],
			[
				[
					3108996,
					2875082
				],
				[
					4901,
					3386
				]
			],
			[
				[
					3113897,
					2878468
				],
				[
					2771,
					491
				]
			],
			[
				[
					3124626,
					2903102
				],
				[
					-5192,
					-14046
				]
			],
			[
				[
					3119434,
					2889056
				],
				[
					-2549,
					-14
				]
			],
			[
				[
					3112471,
					2892661
				],
				[
					8,
					3430
				]
			],
			[
				[
					3111093,
					2903126
				],
				[
					-479,
					8925
				]
			],
			[
				[
					3110614,
					2912051
				],
				[
					-1,
					19216
				]
			],
			[
				[
					3115115,
					2865757
				],
				[
					-5418,
					-1298
				]
			],
			[
				[
					3109697,
					2864459
				],
				[
					-67,
					3380
				]
			],
			[
				[
					3109630,
					2867839
				],
				[
					459,
					2715
				]
			],
			[
				[
					3116846,
					2864018
				],
				[
					-2049,
					-3655
				]
			],
			[
				[
					3114797,
					2860363
				],
				[
					-126,
					563
				]
			],
			[
				[
					3114671,
					2860926
				],
				[
					-2669,
					1383
				]
			],
			[
				[
					3112002,
					2862309
				],
				[
					-1459,
					-60
				]
			],
			[
				[
					3110543,
					2862249
				],
				[
					-1092,
					1060
				]
			],
			[
				[
					3109451,
					2863309
				],
				[
					246,
					1150
				]
			],
			[
				[
					3114671,
					2860926
				],
				[
					-2669,
					1383
				]
			],
			[
				[
					3114797,
					2860363
				],
				[
					-128,
					-352
				]
			],
			[
				[
					3114669,
					2860011
				],
				[
					-3010,
					-1833
				]
			],
			[
				[
					3111659,
					2858178
				],
				[
					-3018,
					2020
				]
			],
			[
				[
					3108641,
					2860198
				],
				[
					1902,
					2051
				]
			],
			[
				[
					3109630,
					2867839
				],
				[
					-5478,
					964
				]
			],
			[
				[
					3104152,
					2868803
				],
				[
					-181,
					6226
				]
			],
			[
				[
					3103971,
					2875029
				],
				[
					4318,
					614
				]
			],
			[
				[
					3108289,
					2875643
				],
				[
					707,
					-561
				]
			],
			[
				[
					3109451,
					2863309
				],
				[
					-4689,
					1938
				]
			],
			[
				[
					3104762,
					2865247
				],
				[
					-4796,
					-270
				]
			],
			[
				[
					3099966,
					2864977
				],
				[
					-1,
					3039
				]
			],
			[
				[
					3099965,
					2868016
				],
				[
					4187,
					787
				]
			],
			[
				[
					3108641,
					2860198
				],
				[
					-1976,
					-2139
				]
			],
			[
				[
					3106665,
					2858059
				],
				[
					-2529,
					572
				]
			],
			[
				[
					3104136,
					2858631
				],
				[
					626,
					6616
				]
			],
			[
				[
					3104136,
					2858631
				],
				[
					-4192,
					34
				]
			],
			[
				[
					3099944,
					2858665
				],
				[
					-356,
					2354
				]
			],
			[
				[
					3099588,
					2861019
				],
				[
					378,
					3958
				]
			],
			[
				[
					3106665,
					2858059
				],
				[
					-595,
					-6217
				]
			],
			[
				[
					3106070,
					2851842
				],
				[
					-2927,
					-524
				]
			],
			[
				[
					3103143,
					2851318
				],
				[
					-395,
					-10
				]
			],
			[
				[
					3102748,
					2851308
				],
				[
					-2804,
					7357
				]
			],
			[
				[
					3099588,
					2861019
				],
				[
					-10782,
					-17
				]
			],
			[
				[
					3088806,
					2861002
				],
				[
					-22,
					6966
				]
			],
			[
				[
					3088784,
					2867968
				],
				[
					1,
					5333
				]
			],
			[
				[
					3088785,
					2873301
				],
				[
					4681,
					1555
				]
			],
			[
				[
					3093466,
					2874856
				],
				[
					920,
					125
				]
			],
			[
				[
					3094386,
					2874981
				],
				[
					5579,
					-6965
				]
			],
			[
				[
					3102748,
					2851308
				],
				[
					-11165,
					929
				]
			],
			[
				[
					3091583,
					2852237
				],
				[
					-2777,
					8765
				]
			],
			[
				[
					3099958,
					2875002
				],
				[
					4013,
					27
				]
			],
			[
				[
					3094386,
					2874981
				],
				[
					5572,
					21
				]
			],
			[
				[
					3127438,
					2867971
				],
				[
					343,
					-7025
				]
			],
			[
				[
					3127781,
					2860946
				],
				[
					-2816,
					10
				]
			],
			[
				[
					3124965,
					2860956
				],
				[
					-798,
					11
				]
			],
			[
				[
					3124167,
					2860967
				],
				[
					-4198,
					3327
				]
			],
			[
				[
					3113873,
					2889052
				],
				[
					24,
					-10584
				]
			],
			[
				[
					3108289,
					2875643
				],
				[
					-2776,
					6402
				]
			],
			[
				[
					3105513,
					2882045
				],
				[
					-12,
					5249
				]
			],
			[
				[
					3105501,
					2887294
				],
				[
					6965,
					1769
				]
			],
			[
				[
					3136151,
					2903076
				],
				[
					2669,
					-11317
				],
				[
					-5617,
					-9750
				]
			],
			[
				[
					3133203,
					2882009
				],
				[
					2932,
					-3838
				]
			],
			[
				[
					3136135,
					2878171
				],
				[
					-8419,
					-3004
				]
			],
			[
				[
					3119441,
					2878976
				],
				[
					-7,
					10080
				]
			],
			[
				[
					3124167,
					2860967
				],
				[
					-4686,
					-864
				]
			],
			[
				[
					3119481,
					2860103
				],
				[
					-4105,
					-38
				]
			],
			[
				[
					3115376,
					2860065
				],
				[
					-707,
					-54
				]
			],
			[
				[
					3124965,
					2860956
				],
				[
					-4,
					-11582
				]
			],
			[
				[
					3124961,
					2849374
				],
				[
					-5555,
					-1899
				]
			],
			[
				[
					3119406,
					2847475
				],
				[
					-1533,
					565
				]
			],
			[
				[
					3117873,
					2848040
				],
				[
					1579,
					4199
				]
			],
			[
				[
					3119452,
					2852239
				],
				[
					29,
					7864
				]
			],
			[
				[
					3119452,
					2852239
				],
				[
					-4076,
					7826
				]
			],
			[
				[
					3117873,
					2848040
				],
				[
					-1167,
					-12112
				]
			],
			[
				[
					3116706,
					2835928
				],
				[
					-1908,
					42
				]
			],
			[
				[
					3114798,
					2835970
				],
				[
					-932,
					10057
				]
			],
			[
				[
					3113866,
					2846027
				],
				[
					-2277,
					6830
				]
			],
			[
				[
					3111589,
					2852857
				],
				[
					70,
					5321
				]
			],
			[
				[
					3115762,
					2842069
				],
				[
					0,
					0
				]
			],
			[
				[
					3111589,
					2852857
				],
				[
					-5519,
					-1015
				]
			],
			[
				[
					3112055,
					2825924
				],
				[
					18497,
					-59
				]
			],
			[
				[
					3130552,
					2825865
				],
				[
					5744,
					-6995
				]
			],
			[
				[
					3136296,
					2818870
				],
				[
					20,
					-14019
				]
			],
			[
				[
					3128083,
					2804855
				],
				[
					-5522,
					6980
				]
			],
			[
				[
					3119830,
					2811825
				],
				[
					-22626,
					14024
				]
			],
			[
				[
					3097204,
					2825849
				],
				[
					14851,
					75
				]
			],
			[
				[
					3113866,
					2846027
				],
				[
					-7053,
					876
				]
			],
			[
				[
					3106813,
					2846903
				],
				[
					-4261,
					-551
				]
			],
			[
				[
					3102552,
					2846352
				],
				[
					591,
					4966
				]
			],
			[
				[
					3114798,
					2835970
				],
				[
					356,
					-1421
				]
			],
			[
				[
					3115154,
					2834549
				],
				[
					-9935,
					-1649
				]
			],
			[
				[
					3105219,
					2832900
				],
				[
					1594,
					14003
				]
			],
			[
				[
					3119406,
					2847475
				],
				[
					22,
					-11976
				]
			],
			[
				[
					3119428,
					2835499
				],
				[
					-2722,
					429
				]
			],
			[
				[
					3124961,
					2847945
				],
				[
					29,
					-12448
				]
			],
			[
				[
					3124990,
					2835497
				],
				[
					-5562,
					2
				]
			],
			[
				[
					3124961,
					2849374
				],
				[
					0,
					-1429
				]
			],
			[
				[
					3102552,
					2846352
				],
				[
					-2541,
					-5188
				]
			],
			[
				[
					3100011,
					2841164
				],
				[
					-3331,
					-15333
				]
			],
			[
				[
					3096680,
					2825831
				],
				[
					-5115,
					14083
				]
			],
			[
				[
					3091565,
					2839914
				],
				[
					18,
					12323
				]
			],
			[
				[
					3127781,
					2860946
				],
				[
					2732,
					-6813
				]
			],
			[
				[
					3130513,
					2854133
				],
				[
					46,
					-7259
				]
			],
			[
				[
					3130559,
					2846874
				],
				[
					-5598,
					1071
				]
			],
			[
				[
					3105219,
					2832900
				],
				[
					-5208,
					8264
				]
			],
			[
				[
					3136135,
					2878171
				],
				[
					3,
					-10189
				]
			],
			[
				[
					3136138,
					2867982
				],
				[
					-5419,
					-7102
				]
			],
			[
				[
					3130719,
					2860880
				],
				[
					-2938,
					66
				]
			],
			[
				[
					3130559,
					2846874
				],
				[
					-45,
					-6988
				]
			],
			[
				[
					3130514,
					2839886
				],
				[
					-5524,
					-4389
				]
			],
			[
				[
					3099958,
					2875002
				],
				[
					5555,
					7043
				]
			],
			[
				[
					3115154,
					2834549
				],
				[
					-3099,
					-8625
				]
			],
			[
				[
					3097204,
					2825849
				],
				[
					-524,
					-18
				]
			],
			[
				[
					3130514,
					2839886
				],
				[
					38,
					-14021
				]
			],
			[
				[
					2680039,
					2739366
				],
				[
					-63,
					-2455
				]
			],
			[
				[
					2758253,
					2990597
				],
				[
					12155,
					-3209
				],
				[
					62,
					-12095
				],
				[
					8681,
					630
				],
				[
					2204,
					-9752
				],
				[
					22612,
					-121
				]
			],
			[
				[
					2874150,
					2740978
				],
				[
					-7544,
					6343
				],
				[
					-11356,
					-14085
				],
				[
					-10494,
					-4998
				],
				[
					-10398,
					6638
				],
				[
					-10942,
					-12106
				],
				[
					-30038,
					-9744
				],
				[
					-27595,
					694
				],
				[
					-7531,
					13328
				],
				[
					-16730,
					12046
				],
				[
					-3829,
					8031
				]
			],
			[
				[
					2718439,
					2787547
				],
				[
					6673,
					16592
				],
				[
					-12307,
					12604
				],
				[
					-6569,
					15240
				],
				[
					-1848,
					27889
				],
				[
					-13295,
					6941
				],
				[
					-1196,
					9128
				],
				[
					8866,
					9297
				],
				[
					384,
					34087
				],
				[
					-3879,
					3686
				],
				[
					13497,
					27163
				],
				[
					21994,
					17396
				],
				[
					-8939,
					8239
				],
				[
					-11547,
					-9640
				],
				[
					-41841,
					13852
				]
			],
			[
				[
					3030775,
					3043336
				],
				[
					23,
					-14077
				]
			],
			[
				[
					3035196,
					3022359
				],
				[
					4036,
					-21050
				]
			],
			[
				[
					3088785,
					2873301
				],
				[
					-11127,
					1757
				]
			],
			[
				[
					3077658,
					2875058
				],
				[
					13061,
					5842
				]
			],
			[
				[
					3090719,
					2880900
				],
				[
					2747,
					-6044
				]
			],
			[
				[
					3069371,
					2889057
				],
				[
					8156,
					-15188
				]
			],
			[
				[
					3077527,
					2873869
				],
				[
					11257,
					-5901
				]
			],
			[
				[
					3091565,
					2839914
				],
				[
					-27706,
					-64
				]
			],
			[
				[
					3063859,
					2839850
				],
				[
					-1557,
					21170
				],
				[
					-4016,
					3510
				],
				[
					-2114,
					24447
				]
			],
			[
				[
					3096680,
					2825831
				],
				[
					-6989,
					-8637
				]
			],
			[
				[
					3089691,
					2817194
				],
				[
					-5719,
					241
				]
			],
			[
				[
					3061854,
					2812203
				],
				[
					2005,
					27647
				]
			],
			[
				[
					3077527,
					2873869
				],
				[
					131,
					1189
				]
			],
			[
				[
					3136296,
					2818870
				],
				[
					2437,
					0
				]
			],
			[
				[
					3147260,
					2882004
				],
				[
					-21,
					-21008
				],
				[
					5583,
					-7016
				]
			],
			[
				[
					3152822,
					2853980
				],
				[
					-10428,
					-29
				]
			],
			[
				[
					3142394,
					2853951
				],
				[
					-11881,
					182
				]
			],
			[
				[
					3130719,
					2860880
				],
				[
					5419,
					7102
				]
			],
			[
				[
					3133203,
					2882009
				],
				[
					14057,
					-5
				]
			],
			[
				[
					3142394,
					2853951
				],
				[
					-740,
					-35085
				]
			],
			[
				[
					3152822,
					2853980
				],
				[
					2723,
					-35090
				]
			],
			[
				[
					3163907,
					2889010
				],
				[
					-34,
					-42112
				],
				[
					5684,
					-13077
				],
				[
					-5711,
					-14901
				]
			],
			[
				[
					3147260,
					2882004
				],
				[
					-14,
					7009
				],
				[
					16661,
					-3
				]
			],
			[
				[
					3163907,
					2889010
				],
				[
					12530,
					11
				],
				[
					9491,
					-11112
				]
			],
			[
				[
					3090719,
					2880900
				],
				[
					933,
					9825
				],
				[
					13849,
					-3431
				]
			],
			[
				[
					3110614,
					2912051
				],
				[
					-33658,
					-1912
				]
			],
			[
				[
					2512272,
					3267049
				],
				[
					0,
					0
				]
			],
			[
				[
					2517369,
					3247003
				],
				[
					916,
					5
				]
			],
			[
				[
					2518285,
					3247008
				],
				[
					7288,
					13989
				],
				[
					-8751,
					1739
				],
				[
					547,
					-15733
				]
			],
			[
				[
					2509407,
					3251700
				],
				[
					0,
					0
				]
			],
			[
				[
					2512666,
					3249881
				],
				[
					0,
					0
				]
			],
			[
				[
					2517369,
					3247003
				],
				[
					916,
					5
				]
			],
			[
				[
					3083956,
					2815393
				],
				[
					5735,
					1801
				]
			],
			[
				[
					3350209,
					3642238
				],
				[
					-8572,
					-509
				],
				[
					3760,
					-12730
				],
				[
					8705,
					1813
				],
				[
					-3893,
					11426
				]
			],
			[
				[
					3353669,
					3626562
				],
				[
					0,
					0
				]
			],
			[
				[
					3471802,
					3028858
				],
				[
					-5806,
					6579
				]
			],
			[
				[
					3439798,
					3074774
				],
				[
					5688,
					14014
				],
				[
					-7111,
					-1770
				]
			],
			[
				[
					3397891,
					2744828
				],
				[
					32474,
					-25
				],
				[
					8793,
					6750
				],
				[
					8454,
					-11420
				]
			],
			[
				[
					2887269,
					2194859
				],
				[
					-10999,
					-16138
				],
				[
					-8518,
					6495
				],
				[
					-13926,
					-15829
				],
				[
					-2324,
					-15831
				],
				[
					18200,
					-45285
				],
				[
					2352,
					-17494
				],
				[
					-6117,
					-6341
				],
				[
					-2254,
					-25259
				],
				[
					-11177,
					-13603
				],
				[
					-4490,
					6889
				],
				[
					-574,
					38128
				],
				[
					-5631,
					25258
				],
				[
					-11785,
					9668
				]
			],
			[
				[
					2830026,
					2125517
				],
				[
					0,
					0
				]
			],
			[
				[
					2830026,
					2125517
				],
				[
					14430,
					-34663
				],
				[
					-2217,
					-20526
				],
				[
					-34807,
					4510
				],
				[
					-9428,
					5848
				],
				[
					-12519,
					-6190
				],
				[
					-9795,
					-27342
				]
			],
			[
				[
					2775690,
					2047154
				],
				[
					-8537,
					10893
				],
				[
					1812,
					25600
				],
				[
					-8755,
					-359
				],
				[
					-3890,
					24837
				],
				[
					-7903,
					9899
				],
				[
					7726,
					33072
				],
				[
					8430,
					11741
				],
				[
					-8603,
					8428
				],
				[
					-14110,
					4052
				],
				[
					-6405,
					15063
				],
				[
					-24142,
					16509
				],
				[
					-3754,
					8606
				],
				[
					5713,
					22321
				],
				[
					-12487,
					3530
				],
				[
					1415,
					11999
				],
				[
					-10562,
					8875
				],
				[
					-13931,
					-4916
				]
			],
			[
				[
					2677707,
					2257304
				],
				[
					-6432,
					17412
				],
				[
					-8338,
					-12976
				],
				[
					-7625,
					7967
				],
				[
					-18433,
					-3808
				],
				[
					4225,
					22349
				],
				[
					-4146,
					3420
				],
				[
					-2584,
					32208
				],
				[
					-12346,
					13689
				],
				[
					-16843,
					30946
				],
				[
					5559,
					7494
				],
				[
					-5732,
					11847
				],
				[
					9256,
					34665
				],
				[
					-11922,
					5047
				],
				[
					-9163,
					-9721
				],
				[
					-4036,
					17994
				],
				[
					-6729,
					3014
				],
				[
					7443,
					23548
				],
				[
					-10702,
					20771
				],
				[
					-15648,
					4039
				],
				[
					16873,
					16219
				],
				[
					-6568,
					31286
				],
				[
					-7695,
					5790
				],
				[
					-16218,
					-625
				],
				[
					-7156,
					15132
				],
				[
					5362,
					9529
				],
				[
					19912,
					13335
				],
				[
					3094,
					-6954
				],
				[
					7211,
					9972
				]
			],
			[
				[
					2841160,
					2081323
				],
				[
					0,
					0
				]
			],
			[
				[
					3048551,
					1765479
				],
				[
					-102641,
					-9
				],
				[
					-57439,
					-2
				],
				[
					-151753,
					18
				]
			],
			[
				[
					2736718,
					1765486
				],
				[
					-9328,
					13626
				],
				[
					12186,
					18919
				],
				[
					-14168,
					12196
				],
				[
					-12783,
					-7114
				],
				[
					3289,
					23658
				],
				[
					-6955,
					8229
				],
				[
					1950,
					18396
				],
				[
					-7428,
					17677
				]
			],
			[
				[
					2703481,
					1871073
				],
				[
					3788,
					8171
				]
			],
			[
				[
					2707269,
					1879244
				],
				[
					31735,
					794
				],
				[
					-3477,
					27258
				],
				[
					-8126,
					11882
				],
				[
					2488,
					19049
				],
				[
					103,
					36945
				],
				[
					21726,
					177
				]
			],
			[
				[
					2751718,
					1975349
				],
				[
					11615,
					-41175
				],
				[
					-7551,
					-7613
				],
				[
					-3607,
					-22934
				],
				[
					7245,
					-8178
				],
				[
					-4772,
					-16073
				],
				[
					9929,
					-4105
				],
				[
					17655,
					18928
				],
				[
					12564,
					-2186
				],
				[
					11532,
					-26811
				]
			],
			[
				[
					2806328,
					1865202
				],
				[
					5110,
					-14757
				],
				[
					-2672,
					-7321
				],
				[
					12995,
					-19002
				],
				[
					13391,
					11309
				],
				[
					15873,
					22878
				],
				[
					2457,
					15108
				],
				[
					17865,
					-6139
				],
				[
					-5015,
					8835
				],
				[
					12757,
					16530
				],
				[
					-9710,
					10553
				],
				[
					1367,
					10523
				],
				[
					-6694,
					14836
				],
				[
					-6326,
					64
				]
			],
			[
				[
					2857726,
					1928619
				],
				[
					-15260,
					4877
				],
				[
					-8773,
					24918
				],
				[
					-10747,
					7276
				],
				[
					-11032,
					-15304
				],
				[
					-14553,
					36771
				],
				[
					-12304,
					4246
				],
				[
					-5043,
					10295
				]
			],
			[
				[
					2780014,
					2001698
				],
				[
					-6238,
					18549
				],
				[
					4422,
					14861
				],
				[
					-2508,
					12046
				]
			],
			[
				[
					2847955,
					1854145
				],
				[
					0,
					0
				]
			],
			[
				[
					2316444,
					3397833
				],
				[
					0,
					0
				]
			],
			[
				[
					2377646,
					3420686
				],
				[
					-15880,
					-7014
				],
				[
					-8870,
					7021
				],
				[
					2932,
					22748
				],
				[
					8870,
					7080
				],
				[
					2953,
					-10528
				],
				[
					9995,
					-3503
				]
			],
			[
				[
					2377646,
					3489187
				],
				[
					-11868,
					-10700
				],
				[
					-27511,
					-642
				],
				[
					51,
					-27329
				],
				[
					-9035,
					-21160
				],
				[
					4,
					-13907
				],
				[
					-14760,
					5
				],
				[
					-8862,
					7005
				],
				[
					107,
					-35164
				],
				[
					9893,
					-252
				],
				[
					-1478,
					-20797
				],
				[
					-9591,
					-161
				],
				[
					332,
					-17085
				],
				[
					-15218,
					-12061
				],
				[
					-5674,
					-14190
				],
				[
					3178,
					-20272
				],
				[
					-11925,
					-8765
				],
				[
					6930,
					-17901
				],
				[
					2770,
					-19480
				],
				[
					-4018,
					-45384
				],
				[
					3648,
					-8200
				],
				[
					21712,
					-18416
				],
				[
					-1329,
					-10806
				],
				[
					10679,
					386
				],
				[
					15453,
					16825
				],
				[
					18897,
					8929
				],
				[
					4695,
					32656
				],
				[
					-3404,
					14272
				],
				[
					3107,
					21478
				],
				[
					11057,
					31486
				],
				[
					-230,
					17561
				],
				[
					-19833,
					-15658
				],
				[
					-3277,
					-7563
				],
				[
					286,
					72474
				],
				[
					18606,
					-126
				],
				[
					-2925,
					24559
				],
				[
					19533,
					-3559
				]
			],
			[
				[
					2377646,
					2924872
				],
				[
					-5633,
					5497
				],
				[
					-2794,
					35892
				],
				[
					-9166,
					-9560
				],
				[
					-11820,
					9278
				],
				[
					3436,
					15661
				],
				[
					8433,
					3130
				],
				[
					-1381,
					16162
				],
				[
					-18293,
					-4139
				],
				[
					-22942,
					7636
				],
				[
					-5618,
					9123
				],
				[
					-1932,
					26504
				],
				[
					-14566,
					4021
				],
				[
					7656,
					13183
				],
				[
					-8210,
					12927
				],
				[
					-4950,
					-2768
				],
				[
					-5556,
					23297
				],
				[
					-12342,
					-10069
				],
				[
					-15836,
					-188
				],
				[
					-5885,
					7883
				],
				[
					188,
					15702
				],
				[
					-13987,
					-577
				],
				[
					-2704,
					-7076
				],
				[
					-14172,
					3964
				],
				[
					-3,
					8514
				],
				[
					-14268,
					20027
				],
				[
					3917,
					24207
				],
				[
					-7346,
					16414
				],
				[
					-19353,
					15944
				],
				[
					-7577,
					-11375
				],
				[
					-8283,
					7195
				],
				[
					2291,
					15483
				],
				[
					-35781,
					48444
				],
				[
					-10203,
					2246
				],
				[
					1451,
					19144
				],
				[
					-16681,
					27137
				],
				[
					-11176,
					3244
				],
				[
					-11900,
					15858
				],
				[
					-7352,
					-17384
				],
				[
					-25209,
					15384
				],
				[
					-10944,
					-1958
				],
				[
					-3528,
					11577
				],
				[
					8816,
					4094
				],
				[
					-2291,
					28434
				],
				[
					-7420,
					-5108
				],
				[
					-7300,
					15862
				],
				[
					-7327,
					3604
				],
				[
					-95,
					22012
				],
				[
					-13242,
					-8342
				],
				[
					-9114,
					8239
				],
				[
					2652,
					16640
				],
				[
					-14072,
					19837
				],
				[
					-9198,
					-4657
				],
				[
					-25778,
					17062
				],
				[
					-8554,
					14356
				],
				[
					3769,
					9283
				],
				[
					15445,
					5016
				],
				[
					17733,
					-5304
				],
				[
					3041,
					12820
				],
				[
					-9462,
					38329
				],
				[
					1150,
					20801
				],
				[
					-7967,
					6632
				],
				[
					7025,
					14805
				],
				[
					-3525,
					17536
				],
				[
					-12448,
					6603
				],
				[
					-4706,
					12633
				],
				[
					7607,
					4765
				],
				[
					888,
					15765
				],
				[
					-7899,
					1613
				],
				[
					-7702,
					26488
				],
				[
					3615,
					9437
				],
				[
					-11999,
					30509
				],
				[
					-1712,
					15489
				],
				[
					-10649,
					8016
				],
				[
					6324,
					17174
				],
				[
					-9536,
					6747
				],
				[
					1331,
					15220
				],
				[
					-10187,
					1719
				],
				[
					-10522,
					14690
				],
				[
					12081,
					12544
				],
				[
					-1302,
					18478
				],
				[
					-10522,
					15478
				],
				[
					794,
					11544
				],
				[
					-13542,
					-2345
				],
				[
					-12457,
					14592
				],
				[
					-4841,
					22134
				],
				[
					-24864,
					6495
				],
				[
					-2867,
					9728
				],
				[
					-13984,
					4840
				],
				[
					-7213,
					20840
				],
				[
					-10506,
					16930
				],
				[
					5637,
					22331
				],
				[
					-31772,
					9070
				],
				[
					-27956,
					-12253
				],
				[
					-16154,
					-13825
				],
				[
					-2957,
					5499
				],
				[
					-14411,
					-17248
				],
				[
					-5656,
					24243
				],
				[
					-13466,
					3531
				],
				[
					-14445,
					-3316
				],
				[
					-3830,
					-12850
				],
				[
					-17059,
					4842
				],
				[
					-4521,
					-18825
				],
				[
					-13184,
					17004
				],
				[
					-13788,
					3757
				],
				[
					-16948,
					27877
				],
				[
					-55008,
					77442
				],
				[
					-20101,
					30757
				],
				[
					-54560,
					74180
				],
				[
					-29433,
					45163
				],
				[
					-99526,
					404
				],
				[
					-6680,
					-242074
				],
				[
					-140513,
					402
				],
				[
					-85670,
					30
				],
				[
					-918,
					241604
				],
				[
					-71750,
					-363
				],
				[
					-97193,
					180
				],
				[
					-84859,
					170
				],
				[
					-129710,
					-479
				]
			],
			[
				[
					748664,
					4177786
				],
				[
					1652,
					9972
				],
				[
					-11245,
					22191
				],
				[
					-9617,
					28
				],
				[
					-12234,
					14305
				],
				[
					-2416,
					13409
				],
				[
					-29371,
					7887
				],
				[
					-8062,
					16227
				],
				[
					4633,
					9534
				],
				[
					-12249,
					9439
				],
				[
					7867,
					11893
				],
				[
					31,
					21135
				],
				[
					-21958,
					24178
				],
				[
					-1458,
					7672
				],
				[
					-27636,
					24766
				],
				[
					-52793,
					-32564
				],
				[
					-28232,
					-5985
				],
				[
					-18152,
					-9200
				],
				[
					12931,
					-10028
				],
				[
					-6791,
					-22499
				],
				[
					-19775,
					-397
				],
				[
					990,
					-43332
				],
				[
					-12952,
					-28712
				],
				[
					-27453,
					-1384
				],
				[
					-19793,
					-16509
				],
				[
					-32667,
					-22165
				],
				[
					-17891,
					-21909
				],
				[
					-9069,
					-498
				],
				[
					3102,
					18464
				],
				[
					-11624,
					62138
				],
				[
					-31220,
					33945
				],
				[
					-82284,
					90763
				],
				[
					-11353,
					35835
				],
				[
					-39188,
					22627
				]
			],
			[
				[
					222387,
					4419012
				],
				[
					119029,
					-9
				],
				[
					113124,
					0
				],
				[
					158597,
					14
				]
			],
			[
				[
					613137,
					4419017
				],
				[
					69209,
					-11
				]
			],
			[
				[
					682346,
					4419006
				],
				[
					139847,
					-3
				],
				[
					170044,
					0
				],
				[
					141046,
					0
				],
				[
					113124,
					0
				],
				[
					141405,
					0
				],
				[
					113124,
					0
				],
				[
					141405,
					0
				],
				[
					141404,
					0
				],
				[
					165238,
					7
				]
			],
			[
				[
					1948983,
					4419010
				],
				[
					89291,
					-7
				],
				[
					113124,
					0
				],
				[
					84843,
					0
				],
				[
					141405,
					0
				]
			],
			[
				[
					815916,
					4374982
				],
				[
					10316,
					-72624
				],
				[
					13768,
					-34767
				],
				[
					14826,
					-11497
				],
				[
					8543,
					16538
				],
				[
					13863,
					94795
				],
				[
					-64712,
					29394
				],
				[
					3396,
					-21839
				]
			],
			[
				[
					2172831,
					3820459
				],
				[
					-9339,
					-5087
				],
				[
					-5890,
					-16302
				],
				[
					-10337,
					-8760
				],
				[
					-14767,
					-598
				],
				[
					-28779,
					-16760
				],
				[
					-12973,
					-28273
				],
				[
					-13038,
					3097
				],
				[
					11475,
					-27403
				],
				[
					22281,
					-18209
				],
				[
					26304,
					-5658
				],
				[
					13732,
					-16245
				],
				[
					20997,
					-37743
				],
				[
					19854,
					-19140
				],
				[
					13778,
					-6732
				],
				[
					18551,
					828
				],
				[
					6516,
					20240
				],
				[
					-12162,
					31282
				],
				[
					-1757,
					14464
				],
				[
					-10402,
					24433
				],
				[
					-2064,
					16461
				],
				[
					5454,
					13975
				],
				[
					-478,
					20825
				],
				[
					5935,
					7832
				],
				[
					916,
					29265
				],
				[
					-10725,
					13515
				],
				[
					-33082,
					10693
				]
			],
			[
				[
					2281781,
					3556911
				],
				[
					-8949,
					-677
				],
				[
					4404,
					-21662
				],
				[
					-10358,
					14029
				],
				[
					-11920,
					7016
				],
				[
					-1362,
					-16692
				],
				[
					-7514,
					8181
				],
				[
					268,
					-19099
				],
				[
					17550,
					-117
				],
				[
					3266,
					6539
				],
				[
					5673,
					-20892
				],
				[
					20834,
					-21003
				],
				[
					5872,
					20976
				],
				[
					18161,
					-35
				],
				[
					-22914,
					7913
				],
				[
					8190,
					34225
				],
				[
					-9280,
					7024
				],
				[
					-11921,
					-5726
				]
			],
			[
				[
					2677707,
					2257304
				],
				[
					-5726,
					-16283
				],
				[
					-12906,
					-7671
				],
				[
					-2310,
					-11631
				],
				[
					-17809,
					-24163
				],
				[
					-36680,
					-20420
				],
				[
					-21445,
					-2593
				],
				[
					4658,
					-20344
				],
				[
					-5952,
					-17706
				],
				[
					4439,
					-10844
				],
				[
					-6848,
					-14216
				],
				[
					4221,
					-14792
				],
				[
					15403,
					-4611
				],
				[
					2436,
					-18296
				],
				[
					8320,
					-15004
				],
				[
					-444,
					-21258
				],
				[
					-12714,
					-8826
				],
				[
					-14542,
					28554
				],
				[
					-5748,
					-6741
				],
				[
					-3371,
					-20169
				],
				[
					-11852,
					-4596
				],
				[
					-166,
					-10937
				],
				[
					-10871,
					44
				],
				[
					13402,
					-28940
				],
				[
					337,
					-21483
				],
				[
					7038,
					-2962
				]
			],
			[
				[
					2568577,
					1961416
				],
				[
					-40689,
					98
				]
			],
			[
				[
					2527888,
					1961514
				],
				[
					155,
					88622
				],
				[
					-39620,
					54
				],
				[
					-5456,
					8859
				],
				[
					7941,
					12018
				],
				[
					-162,
					25545
				],
				[
					-7307,
					2505
				],
				[
					-7734,
					-12646
				],
				[
					-15088,
					4737
				]
			],
			[
				[
					2460617,
					2091208
				],
				[
					-5805,
					15874
				],
				[
					-29843,
					3536
				],
				[
					-15655,
					-27609
				],
				[
					4341,
					-12866
				],
				[
					-7938,
					-837
				],
				[
					-6719,
					-20702
				]
			],
			[
				[
					2398998,
					2048604
				],
				[
					7083,
					-11759
				],
				[
					-2316,
					-19741
				],
				[
					-8929,
					-16275
				]
			],
			[
				[
					2394836,
					2000829
				],
				[
					-19905,
					-1918
				],
				[
					-7618,
					-14576
				]
			],
			[
				[
					2367313,
					1984335
				],
				[
					-13794,
					-5778
				],
				[
					-13211,
					6912
				],
				[
					-16801,
					-32075
				],
				[
					-9989,
					8585
				]
			],
			[
				[
					2313518,
					1961979
				],
				[
					780,
					24040
				],
				[
					6415,
					-2136
				],
				[
					-8477,
					16754
				],
				[
					-30,
					37902
				],
				[
					9689,
					9241
				],
				[
					2538,
					15409
				],
				[
					7668,
					11037
				],
				[
					-396,
					17791
				],
				[
					7374,
					7758
				]
			],
			[
				[
					2339079,
					2099775
				],
				[
					-1855,
					52911
				]
			],
			[
				[
					2337224,
					2152686
				],
				[
					-67,
					3154
				]
			],
			[
				[
					2337157,
					2155840
				],
				[
					1265,
					4345
				]
			],
			[
				[
					2338422,
					2160185
				],
				[
					1779,
					4943
				]
			],
			[
				[
					2340201,
					2165128
				],
				[
					3468,
					1002
				]
			],
			[
				[
					2343669,
					2166130
				],
				[
					10568,
					-10141
				]
			],
			[
				[
					2354237,
					2155989
				],
				[
					-12553,
					-1068
				],
				[
					7598,
					-22318
				],
				[
					9394,
					-9168
				],
				[
					4287,
					-30387
				],
				[
					19090,
					181
				],
				[
					-8430,
					17300
				],
				[
					-352,
					22922
				],
				[
					22757,
					1534
				],
				[
					72,
					12262
				],
				[
					-18367,
					15824
				]
			],
			[
				[
					2377733,
					2163071
				],
				[
					13961,
					6407
				],
				[
					-13627,
					12137
				],
				[
					-20538,
					7659
				],
				[
					-3874,
					20057
				],
				[
					-5919,
					6257
				]
			],
			[
				[
					2347736,
					2215588
				],
				[
					4214,
					33790
				],
				[
					-769,
					21233
				],
				[
					-12561,
					-499
				],
				[
					3885,
					-25317
				]
			],
			[
				[
					2342505,
					2244795
				],
				[
					-18610,
					-6908
				],
				[
					964,
					13206
				],
				[
					-10518,
					3730
				],
				[
					-93,
					152618
				],
				[
					6425,
					8540
				],
				[
					14420,
					4326
				],
				[
					-8438,
					16228
				],
				[
					12176,
					11703
				],
				[
					10763,
					19770
				],
				[
					-3399,
					15772
				],
				[
					-7612,
					-539
				],
				[
					5841,
					25845
				],
				[
					-1634,
					13922
				],
				[
					-8985,
					-696
				]
			],
			[
				[
					2333805,
					2522312
				],
				[
					67,
					9915
				],
				[
					-16731,
					36391
				],
				[
					8556,
					22154
				],
				[
					-9381,
					10826
				],
				[
					15212,
					16492
				],
				[
					5052,
					-1530
				],
				[
					14450,
					25708
				],
				[
					-11812,
					37034
				],
				[
					3029,
					17002
				],
				[
					19273,
					4349
				]
			],
			[
				[
					2361520,
					2700653
				],
				[
					9177,
					-12652
				],
				[
					4149,
					-16094
				],
				[
					29008,
					-23468
				],
				[
					5900,
					18769
				],
				[
					-5228,
					11041
				],
				[
					9797,
					17671
				],
				[
					10968,
					10083
				],
				[
					23147,
					109052
				]
			],
			[
				[
					2452295,
					2193011
				],
				[
					-20910,
					-16437
				],
				[
					-24,
					-10628
				],
				[
					14072,
					-28918
				],
				[
					3100,
					-20018
				],
				[
					8566,
					4445
				],
				[
					-1224,
					12755
				],
				[
					7695,
					-106
				],
				[
					1448,
					23771
				],
				[
					16305,
					5730
				],
				[
					-6069,
					3181
				],
				[
					6771,
					20840
				],
				[
					-11652,
					15
				],
				[
					-4025,
					-13872
				],
				[
					-3882,
					16874
				],
				[
					-10171,
					2368
				]
			],
			[
				[
					2346311,
					2065243
				],
				[
					-6412,
					-7637
				],
				[
					-316,
					-18003
				],
				[
					10790,
					5063
				],
				[
					-395,
					20584
				],
				[
					-3667,
					-7
				]
			],
			[
				[
					2626212,
					1780901
				],
				[
					0,
					0
				]
			],
			[
				[
					2639189,
					1846885
				],
				[
					0,
					0
				]
			],
			[
				[
					2736718,
					1765486
				],
				[
					-91418,
					175
				]
			],
			[
				[
					2645300,
					1765661
				],
				[
					1747,
					22045
				],
				[
					-10438,
					4488
				],
				[
					-2678,
					8623
				],
				[
					-4875,
					-19182
				],
				[
					-6538,
					1409
				],
				[
					972,
					-17440
				]
			],
			[
				[
					2623490,
					1765604
				],
				[
					-26629,
					-70
				]
			],
			[
				[
					2596861,
					1765534
				],
				[
					1826,
					36612
				],
				[
					-7345,
					8381
				],
				[
					8784,
					18503
				]
			],
			[
				[
					2600126,
					1829030
				],
				[
					37355,
					442
				],
				[
					6020,
					-11252
				],
				[
					9273,
					5983
				],
				[
					8431,
					-4070
				],
				[
					244,
					26734
				]
			],
			[
				[
					2661449,
					1846867
				],
				[
					8185,
					15045
				],
				[
					16957,
					4833
				],
				[
					8550,
					-3060
				],
				[
					8340,
					7388
				]
			],
			[
				[
					2649990,
					1782005
				],
				[
					0,
					0
				]
			],
			[
				[
					2721748,
					1914410
				],
				[
					0,
					0
				]
			],
			[
				[
					2780014,
					2001698
				],
				[
					-7582,
					1377
				],
				[
					-20714,
					-27726
				]
			],
			[
				[
					2707269,
					1879244
				],
				[
					772,
					8419
				],
				[
					-9978,
					21927
				],
				[
					21076,
					-1963
				],
				[
					-1574,
					8666
				],
				[
					9482,
					15823
				],
				[
					-17078,
					-156
				],
				[
					-14613,
					15429
				],
				[
					93,
					-13543
				],
				[
					-14270,
					-4717
				],
				[
					1698,
					-20622
				],
				[
					-2775,
					-24541
				],
				[
					-7476,
					2316
				],
				[
					-14089,
					-15660
				]
			],
			[
				[
					2658537,
					1870622
				],
				[
					-19755,
					-4290
				],
				[
					-6818,
					19240
				],
				[
					-10770,
					9971
				],
				[
					-9963,
					-1504
				],
				[
					-9078,
					9062
				],
				[
					1353,
					29322
				],
				[
					-17191,
					8272
				],
				[
					-12930,
					1502
				],
				[
					1353,
					-18286
				]
			],
			[
				[
					2574738,
					1923911
				],
				[
					-6161,
					37505
				]
			],
			[
				[
					2389552,
					1862630
				],
				[
					0,
					0
				]
			],
			[
				[
					2394836,
					2000829
				],
				[
					-9695,
					-9445
				]
			],
			[
				[
					2385141,
					1991384
				],
				[
					-3357,
					-7957
				],
				[
					26810,
					-16028
				],
				[
					8425,
					-12056
				]
			],
			[
				[
					2417019,
					1955343
				],
				[
					-5107,
					-6366
				],
				[
					19916,
					-1873
				]
			],
			[
				[
					2431828,
					1947104
				],
				[
					16766,
					-23864
				],
				[
					8590,
					2701
				],
				[
					3841,
					19187
				],
				[
					15468,
					3010
				],
				[
					5437,
					10003
				],
				[
					11031,
					3268
				]
			],
			[
				[
					2492961,
					1961409
				],
				[
					34927,
					105
				]
			],
			[
				[
					2574738,
					1923911
				],
				[
					1454,
					-22980
				],
				[
					-4806,
					-16081
				],
				[
					1543,
					-18165
				],
				[
					10962,
					-41077
				],
				[
					16235,
					3422
				]
			],
			[
				[
					2596861,
					1765534
				],
				[
					-107051,
					-68
				],
				[
					-69870,
					17
				]
			],
			[
				[
					2419940,
					1765483
				],
				[
					-49,
					17704
				],
				[
					-4984,
					6230
				],
				[
					19,
					48286
				],
				[
					-15818,
					2497
				]
			],
			[
				[
					2399108,
					1840200
				],
				[
					-1882,
					23117
				],
				[
					11282,
					6253
				],
				[
					5361,
					-12263
				],
				[
					8354,
					2980
				],
				[
					8301,
					22948
				],
				[
					5413,
					-6082
				],
				[
					15594,
					1986
				],
				[
					-3398,
					-16472
				],
				[
					8654,
					-2774
				],
				[
					-252,
					27394
				],
				[
					-25771,
					-218
				],
				[
					-1931,
					12423
				],
				[
					-25853,
					2468
				],
				[
					4197,
					-22763
				],
				[
					-18234,
					56
				]
			],
			[
				[
					2388943,
					1879253
				],
				[
					-5598,
					13794
				],
				[
					-9464,
					-1778
				],
				[
					189,
					17688
				],
				[
					-7649,
					12376
				],
				[
					5346,
					7697
				],
				[
					8285,
					-2684
				],
				[
					73,
					32558
				],
				[
					-12812,
					25431
				]
			],
			[
				[
					1925516,
					2649877
				],
				[
					-13219,
					5619
				],
				[
					-4252,
					9660
				],
				[
					-12000,
					3947
				],
				[
					-12805,
					-5267
				],
				[
					-18255,
					8761
				],
				[
					-13374,
					20448
				],
				[
					6149,
					26710
				],
				[
					6114,
					10609
				]
			],
			[
				[
					1863874,
					2730364
				],
				[
					61196,
					179
				],
				[
					446,
					-80666
				]
			],
			[
				[
					1869804,
					2751094
				],
				[
					0,
					0
				]
			],
			[
				[
					1888076,
					2760046
				],
				[
					0,
					0
				]
			],
			[
				[
					2361520,
					2700653
				],
				[
					-1875,
					10759
				],
				[
					-20285,
					1459
				],
				[
					-12974,
					15889
				]
			],
			[
				[
					2326386,
					2728760
				],
				[
					-3992,
					14787
				],
				[
					8072,
					11021
				],
				[
					-5617,
					11785
				],
				[
					-28088,
					27845
				],
				[
					-8198,
					-1901
				],
				[
					-15309,
					12164
				],
				[
					-5571,
					-6824
				],
				[
					-5219,
					12299
				],
				[
					946,
					45698
				],
				[
					-11030,
					-828
				],
				[
					-11860,
					12531
				],
				[
					3607,
					11210
				],
				[
					-12458,
					7032
				],
				[
					-16449,
					-6795
				],
				[
					-1612,
					-8995
				],
				[
					-11424,
					-6853
				],
				[
					-5447,
					7551
				],
				[
					-4594,
					-16277
				],
				[
					-12982,
					7223
				],
				[
					-25830,
					6259
				],
				[
					-7116,
					14442
				],
				[
					3520,
					16691
				],
				[
					-12271,
					17133
				],
				[
					-21177,
					-9363
				],
				[
					-6161,
					3617
				]
			],
			[
				[
					2110126,
					2910212
				],
				[
					-5266,
					2289
				],
				[
					-5761,
					33069
				],
				[
					-5306,
					12663
				]
			],
			[
				[
					2093793,
					2958233
				],
				[
					10712,
					-1706
				],
				[
					17217,
					-14798
				],
				[
					31315,
					5272
				],
				[
					-17782,
					11172
				],
				[
					-4256,
					21052
				],
				[
					-48346,
					-6160
				],
				[
					-737,
					9698
				],
				[
					11758,
					9618
				],
				[
					-7386,
					18178
				],
				[
					-40261,
					-1052
				],
				[
					2431,
					18419
				],
				[
					-16984,
					-41
				],
				[
					-2262,
					17584
				],
				[
					-11829,
					2724
				],
				[
					-3171,
					-11693
				],
				[
					4626,
					-16992
				],
				[
					-5026,
					-6708
				],
				[
					-34030,
					131
				],
				[
					-5572,
					-15560
				],
				[
					9319,
					-5504
				],
				[
					-15140,
					-9495
				],
				[
					9386,
					-13826
				],
				[
					12716,
					-3057
				]
			],
			[
				[
					1990491,
					2965489
				],
				[
					-323,
					-43895
				],
				[
					-5569,
					-14582
				],
				[
					30086,
					218
				],
				[
					-7615,
					-24010
				],
				[
					-13267,
					-10099
				],
				[
					8650,
					-16997
				],
				[
					-11515,
					-4789
				],
				[
					2631,
					-7557
				]
			],
			[
				[
					1993569,
					2843778
				],
				[
					-2793,
					3246
				],
				[
					-63660,
					176
				],
				[
					-1690,
					-9708
				],
				[
					-15731,
					-8645
				],
				[
					-16187,
					12741
				],
				[
					-11455,
					-1485
				],
				[
					-37,
					11349
				],
				[
					-16600,
					7055
				],
				[
					467,
					-34458
				],
				[
					-2780,
					-12321
				],
				[
					-8888,
					1319
				],
				[
					-33167,
					-17329
				],
				[
					-9537,
					-8652
				],
				[
					478,
					-56611
				]
			],
			[
				[
					1811989,
					2730455
				],
				[
					-84897,
					27
				],
				[
					-97094,
					-28
				]
			],
			[
				[
					1629998,
					2730454
				],
				[
					-4596,
					7734
				],
				[
					-8394,
					-9595
				],
				[
					-7462,
					1904
				],
				[
					-1174,
					17823
				],
				[
					-24548,
					1055
				],
				[
					1532,
					19313
				],
				[
					-5315,
					11542
				],
				[
					7764,
					17330
				],
				[
					-3783,
					7375
				],
				[
					-11932,
					-16731
				],
				[
					-3384,
					10024
				],
				[
					-8366,
					-7465
				],
				[
					-4750,
					6572
				]
			],
			[
				[
					1555590,
					2797335
				],
				[
					-19017,
					51471
				],
				[
					-7270,
					-7630
				],
				[
					-7481,
					8123
				],
				[
					-5549,
					18156
				],
				[
					-3944,
					-8351
				],
				[
					-12425,
					4651
				],
				[
					1997,
					6758
				],
				[
					-8897,
					35407
				],
				[
					-9158,
					4203
				],
				[
					-4028,
					19570
				],
				[
					-6953,
					7273
				],
				[
					-237,
					33446
				],
				[
					12183,
					6535
				],
				[
					9931,
					21442
				],
				[
					9398,
					3146
				],
				[
					-4098,
					11806
				],
				[
					11622,
					17590
				],
				[
					13528,
					34053
				],
				[
					-246,
					11615
				],
				[
					-27355,
					7760
				],
				[
					2528,
					16987
				],
				[
					7904,
					9800
				],
				[
					-12703,
					13042
				],
				[
					-159,
					88532
				],
				[
					-127404,
					182
				],
				[
					-6768,
					-15301
				],
				[
					-21177,
					-12041
				],
				[
					-13934,
					-985
				],
				[
					-8647,
					5945
				],
				[
					-12475,
					-17523
				]
			],
			[
				[
					1304756,
					3172997
				],
				[
					-10116,
					2836
				],
				[
					-1583,
					30387
				],
				[
					-47130,
					4534
				]
			],
			[
				[
					1245927,
					3210754
				],
				[
					6189,
					27216
				],
				[
					10534,
					18541
				],
				[
					5619,
					21160
				],
				[
					7057,
					4351
				],
				[
					9046,
					35046
				],
				[
					-5325,
					-4267
				],
				[
					-11518,
					52756
				],
				[
					5203,
					-38594
				],
				[
					-8167,
					-18992
				],
				[
					7252,
					-6421
				],
				[
					-14207,
					-48535
				],
				[
					-12084,
					-20202
				],
				[
					-9720,
					-23605
				],
				[
					-8162,
					22866
				],
				[
					10220,
					29371
				],
				[
					14914,
					20851
				],
				[
					-6714,
					11634
				],
				[
					-2386,
					30148
				],
				[
					-9725,
					24651
				],
				[
					2692,
					29845
				],
				[
					-5333,
					18927
				],
				[
					12267,
					24811
				]
			],
			[
				[
					1243579,
					3422312
				],
				[
					5073,
					254
				],
				[
					11531,
					33817
				],
				[
					-7952,
					7250
				],
				[
					-12869,
					55970
				],
				[
					-45570,
					-7273
				]
			],
			[
				[
					1193792,
					3512330
				],
				[
					-21621,
					10113
				],
				[
					-14158,
					20424
				],
				[
					-34595,
					9237
				],
				[
					-8705,
					9874
				],
				[
					-34302,
					25037
				],
				[
					-12938,
					14787
				],
				[
					-28493,
					-3280
				],
				[
					-2696,
					24847
				],
				[
					-5020,
					12685
				],
				[
					3516,
					12518
				],
				[
					-28325,
					14630
				],
				[
					8509,
					42733
				],
				[
					-36582,
					11429
				],
				[
					14105,
					29090
				],
				[
					-14136,
					33630
				],
				[
					-21946,
					37488
				],
				[
					-22157,
					48415
				],
				[
					-12288,
					33064
				],
				[
					-22792,
					37503
				],
				[
					-11635,
					36567
				],
				[
					-20551,
					31785
				],
				[
					-12128,
					25684
				],
				[
					8991,
					10296
				],
				[
					-35936,
					42592
				],
				[
					-16048,
					29197
				],
				[
					-46958,
					31101
				],
				[
					-9157,
					14778
				],
				[
					2839,
					9904
				],
				[
					-9921,
					9328
				]
			],
			[
				[
					2216199,
					1901721
				],
				[
					0,
					0
				]
			],
			[
				[
					2281905,
					2064626
				],
				[
					0,
					0
				]
			],
			[
				[
					2279277,
					2048138
				],
				[
					0,
					0
				]
			],
			[
				[
					2286158,
					2115229
				],
				[
					0,
					0
				]
			],
			[
				[
					2337224,
					2152686
				],
				[
					-8776,
					-11074
				],
				[
					-924,
					14140
				],
				[
					9633,
					88
				]
			],
			[
				[
					2342505,
					2244795
				],
				[
					298,
					-28220
				],
				[
					-3071,
					-11374
				],
				[
					-12440,
					-247
				],
				[
					3946,
					-19202
				],
				[
					-12761,
					-2114
				],
				[
					-5298,
					26296
				],
				[
					-12295,
					5518
				],
				[
					-6127,
					12091
				],
				[
					-8258,
					-13727
				],
				[
					4202,
					-9723
				],
				[
					-14960,
					-7060
				],
				[
					1917,
					-7542
				],
				[
					16189,
					5894
				],
				[
					6344,
					-7607
				]
			],
			[
				[
					2300191,
					2187778
				],
				[
					-9579,
					3505
				],
				[
					3708,
					-33527
				],
				[
					21695,
					1809
				],
				[
					-13869,
					-27156
				],
				[
					723,
					-10038
				],
				[
					-13957,
					4362
				],
				[
					-2889,
					-9233
				]
			],
			[
				[
					2286023,
					2117500
				],
				[
					-8855,
					67
				],
				[
					1062,
					-19192
				],
				[
					-9870,
					-25837
				],
				[
					-453,
					-10877
				],
				[
					-19258,
					-155
				],
				[
					-12202,
					-19742
				],
				[
					-8275,
					-4465
				],
				[
					-791,
					-21486
				],
				[
					6692,
					-18224
				],
				[
					-6233,
					-15157
				],
				[
					23714,
					-4748
				],
				[
					-1099,
					-13051
				],
				[
					-9896,
					-11186
				],
				[
					10530,
					-24490
				],
				[
					-5887,
					-7088
				],
				[
					5740,
					-9169
				],
				[
					6608,
					4456
				]
			],
			[
				[
					2257550,
					1917156
				],
				[
					-10927,
					-7725
				],
				[
					-5887,
					-24642
				],
				[
					-8375,
					2492
				],
				[
					-8923,
					35586
				],
				[
					-22555,
					12107
				],
				[
					-15711,
					-266
				]
			],
			[
				[
					2185172,
					1934708
				],
				[
					-1247,
					29128
				],
				[
					-6829,
					11733
				],
				[
					-2319,
					-7248
				],
				[
					-7322,
					9519
				],
				[
					-20498,
					-15278
				],
				[
					-14071,
					22275
				],
				[
					-12178,
					12956
				],
				[
					-1984,
					21331
				],
				[
					7646,
					16310
				],
				[
					-4208,
					1039
				]
			],
			[
				[
					2122162,
					2036473
				],
				[
					-6540,
					15360
				],
				[
					1492,
					15017
				],
				[
					7744,
					6214
				],
				[
					-827,
					11368
				],
				[
					10633,
					10088
				],
				[
					-11474,
					14808
				],
				[
					-11483,
					-9457
				],
				[
					-19985,
					1020
				],
				[
					4762,
					12780
				],
				[
					8052,
					-10845
				],
				[
					12422,
					7820
				],
				[
					-1157,
					18516
				],
				[
					-15906,
					12952
				],
				[
					-17487,
					9269
				],
				[
					-2192,
					12788
				],
				[
					-23031,
					-1593
				],
				[
					-10759,
					-10861
				],
				[
					-3261,
					-12653
				],
				[
					-7019,
					12637
				],
				[
					-2917,
					-5741
				],
				[
					-13474,
					13844
				],
				[
					-8156,
					21291
				],
				[
					-9675,
					2025
				],
				[
					-4998,
					16709
				],
				[
					-27969,
					-5866
				],
				[
					-10611,
					3876
				],
				[
					-2597,
					12179
				]
			],
			[
				[
					1955749,
					2210018
				],
				[
					-3247,
					9795
				]
			],
			[
				[
					1952502,
					2219813
				],
				[
					10863,
					-744
				],
				[
					23806,
					24225
				],
				[
					23564,
					4726
				],
				[
					-1357,
					16381
				],
				[
					-11017,
					8571
				],
				[
					27974,
					19301
				],
				[
					-1332,
					-11273
				],
				[
					7094,
					759
				],
				[
					-2876,
					17376
				],
				[
					20528,
					-7217
				],
				[
					5530,
					2652
				],
				[
					15795,
					-7493
				],
				[
					291,
					-8987
				],
				[
					9222,
					-10879
				],
				[
					-1764,
					11635
				],
				[
					12589,
					19541
				],
				[
					-4646,
					9264
				],
				[
					-11713,
					6461
				],
				[
					6953,
					23685
				],
				[
					-2751,
					8253
				],
				[
					8864,
					6921
				],
				[
					1217,
					11938
				]
			],
			[
				[
					2089336,
					2364909
				],
				[
					29836,
					10276
				]
			],
			[
				[
					2119172,
					2375185
				],
				[
					11964,
					4077
				],
				[
					8,
					-6835
				],
				[
					33181,
					419
				],
				[
					-19,
					11648
				],
				[
					11101,
					1425
				],
				[
					-17383,
					17152
				],
				[
					-4225,
					21478
				],
				[
					58,
					32609
				]
			],
			[
				[
					2153857,
					2457158
				],
				[
					16119,
					2042
				],
				[
					-361,
					26470
				],
				[
					-13200,
					19600
				],
				[
					183,
					12361
				],
				[
					-13126,
					23306
				],
				[
					6137,
					11612
				],
				[
					1658,
					20834
				]
			],
			[
				[
					2151267,
					2573383
				],
				[
					2490,
					-5285
				],
				[
					17306,
					3485
				],
				[
					6540,
					12866
				],
				[
					26255,
					-17305
				],
				[
					-6261,
					-8636
				],
				[
					14270,
					234
				],
				[
					-3959,
					-24998
				],
				[
					-10990,
					-4628
				],
				[
					317,
					-8803
				],
				[
					-11843,
					-23
				],
				[
					-265,
					-12003
				],
				[
					33124,
					-918
				],
				[
					10332,
					10826
				],
				[
					-5838,
					7698
				],
				[
					18054,
					-7010
				],
				[
					23740,
					372
				],
				[
					4,
					22454
				],
				[
					13721,
					9292
				],
				[
					16564,
					-1017
				],
				[
					-3765,
					-20779
				],
				[
					6521,
					-7073
				],
				[
					36221,
					180
				]
			],
			[
				[
					2124540,
					2184029
				],
				[
					0,
					0
				]
			],
			[
				[
					2122832,
					2181166
				],
				[
					0,
					0
				]
			],
			[
				[
					2240705,
					2073382
				],
				[
					8199,
					2617
				],
				[
					-11905,
					6797
				],
				[
					3706,
					-9414
				]
			],
			[
				[
					2326386,
					2728760
				],
				[
					-15774,
					-11326
				],
				[
					-28404,
					-10707
				],
				[
					-8135,
					-7860
				]
			],
			[
				[
					2274073,
					2698867
				],
				[
					-11997,
					23862
				],
				[
					-19412,
					2948
				],
				[
					-15158,
					-2633
				],
				[
					-22979,
					30249
				],
				[
					-9424,
					-14925
				],
				[
					-18172,
					13335
				],
				[
					7399,
					16318
				],
				[
					29270,
					7140
				],
				[
					5008,
					18227
				],
				[
					-4322,
					3078
				],
				[
					-11131,
					37979
				],
				[
					6294,
					-28654
				],
				[
					-4402,
					-8090
				],
				[
					-17236,
					3818
				],
				[
					2161,
					9417
				],
				[
					-18993,
					13044
				],
				[
					-13104,
					16642
				],
				[
					-13637,
					-12338
				],
				[
					-2244,
					-23646
				],
				[
					8928,
					-17592
				],
				[
					-15965,
					-9464
				],
				[
					-10149,
					-21794
				],
				[
					-10855,
					553
				],
				[
					343,
					25031
				],
				[
					-13185,
					2358
				],
				[
					-18707,
					-25105
				],
				[
					-9740,
					4595
				],
				[
					-11057,
					30574
				],
				[
					-8961,
					11800
				]
			],
			[
				[
					2052646,
					2805594
				],
				[
					4083,
					14934
				],
				[
					22790,
					5587
				],
				[
					-5387,
					14556
				],
				[
					-2455,
					33126
				],
				[
					34795,
					-741
				],
				[
					8489,
					16052
				],
				[
					-4835,
					21104
				]
			],
			[
				[
					2119172,
					2375185
				],
				[
					5682,
					23449
				],
				[
					-10125,
					23283
				],
				[
					1999,
					9516
				],
				[
					15843,
					15853
				],
				[
					9297,
					-71
				],
				[
					-4380,
					15269
				],
				[
					16369,
					-5326
				]
			],
			[
				[
					2151267,
					2573383
				],
				[
					-3858,
					14023
				],
				[
					-11687,
					3382
				],
				[
					1242,
					-15984
				],
				[
					-17161,
					-5006
				],
				[
					-9763,
					7107
				]
			],
			[
				[
					2110040,
					2576905
				],
				[
					-6412,
					28449
				],
				[
					2480,
					13795
				],
				[
					18843,
					678
				],
				[
					3184,
					6394
				],
				[
					-4805,
					28973
				],
				[
					12331,
					6397
				],
				[
					22445,
					-76
				],
				[
					286,
					6909
				],
				[
					20279,
					-266
				],
				[
					7347,
					-5358
				],
				[
					12664,
					4723
				],
				[
					-3899,
					11041
				],
				[
					1351,
					18176
				],
				[
					14249,
					-3340
				],
				[
					15245,
					5903
				],
				[
					11519,
					13270
				],
				[
					12458,
					-90
				],
				[
					1295,
					-13516
				],
				[
					23173,
					-100
				]
			],
			[
				[
					1811989,
					2730455
				],
				[
					51885,
					-91
				]
			],
			[
				[
					1925516,
					2649877
				],
				[
					-75,
					-39789
				],
				[
					78186,
					-70
				]
			],
			[
				[
					2003627,
					2610018
				],
				[
					-6783,
					-10875
				],
				[
					4749,
					-15148
				],
				[
					-10407,
					-27138
				],
				[
					-7407,
					-5384
				],
				[
					30207,
					-12318
				],
				[
					9312,
					3537
				],
				[
					3001,
					-8472
				],
				[
					21463,
					-22789
				],
				[
					7541,
					-21310
				],
				[
					8275,
					5194
				],
				[
					13145,
					-13359
				],
				[
					9577,
					5380
				],
				[
					2672,
					32530
				],
				[
					11327,
					-26227
				],
				[
					11498,
					-13634
				],
				[
					-14099,
					-1689
				],
				[
					2793,
					-13428
				],
				[
					-7833,
					258
				],
				[
					-599,
					-12288
				],
				[
					-11155,
					-11513
				],
				[
					-4680,
					-12609
				],
				[
					27782,
					-23017
				],
				[
					1893,
					-19250
				],
				[
					-3433,
					-9598
				],
				[
					-18092,
					2112
				],
				[
					4962,
					-14074
				]
			],
			[
				[
					1952502,
					2219813
				],
				[
					-13195,
					16220
				],
				[
					-12201,
					2883
				],
				[
					-6726,
					-4832
				],
				[
					-5088,
					16181
				],
				[
					-9731,
					12492
				],
				[
					-1376,
					17805
				],
				[
					-21566,
					1780
				],
				[
					1082,
					12872
				],
				[
					-7622,
					-11490
				],
				[
					-37133,
					21668
				],
				[
					-4268,
					16211
				],
				[
					-31215,
					11363
				],
				[
					-11472,
					11109
				],
				[
					-10131,
					-5240
				]
			],
			[
				[
					1781860,
					2338835
				],
				[
					-8133,
					7767
				],
				[
					11388,
					39324
				],
				[
					-6577,
					4179
				],
				[
					7144,
					12325
				],
				[
					-2470,
					30056
				],
				[
					-14111,
					5849
				],
				[
					-3035,
					11775
				],
				[
					-12143,
					7252
				],
				[
					2958,
					11487
				],
				[
					-9934,
					-593
				]
			],
			[
				[
					1746947,
					2468256
				],
				[
					-4641,
					17971
				],
				[
					4154,
					16335
				],
				[
					-8993,
					1204
				],
				[
					3337,
					21372
				],
				[
					16614,
					6849
				],
				[
					3549,
					6513
				],
				[
					-6740,
					10210
				],
				[
					10185,
					8106
				],
				[
					8732,
					15550
				],
				[
					-3180,
					10805
				],
				[
					-10700,
					2182
				],
				[
					1176,
					17553
				],
				[
					-18602,
					9555
				],
				[
					-12978,
					-7553
				],
				[
					-7260,
					10950
				],
				[
					4967,
					4453
				],
				[
					-10760,
					7974
				],
				[
					-2313,
					13722
				],
				[
					-13233,
					-3456
				],
				[
					-6651,
					-9102
				],
				[
					-10095,
					-1124
				],
				[
					-6986,
					-18561
				],
				[
					-8216,
					9949
				],
				[
					-10004,
					-1487
				],
				[
					-9823,
					28735
				],
				[
					11272,
					11560
				],
				[
					1174,
					30744
				],
				[
					-22017,
					-13119
				],
				[
					-12321,
					17093
				],
				[
					5865,
					8051
				],
				[
					-6642,
					15087
				],
				[
					4181,
					14077
				]
			],
			[
				[
					2185172,
					1934708
				],
				[
					3398,
					-20634
				],
				[
					13678,
					-3380
				],
				[
					-2455,
					-27872
				],
				[
					-5265,
					3678
				],
				[
					-11266,
					-26598
				],
				[
					12932,
					-8313
				],
				[
					-7979,
					-10669
				],
				[
					-4182,
					-19511
				],
				[
					-12387,
					-3943
				]
			],
			[
				[
					2171646,
					1817466
				],
				[
					-12833,
					2184
				],
				[
					-8021,
					-9576
				]
			],
			[
				[
					2150792,
					1810074
				],
				[
					-13511,
					-9591
				]
			],
			[
				[
					2137281,
					1800483
				],
				[
					-14130,
					-478
				]
			],
			[
				[
					2123151,
					1800005
				],
				[
					5347,
					13361
				],
				[
					5531,
					-30
				],
				[
					12291,
					33518
				],
				[
					-14717,
					17056
				],
				[
					4972,
					25218
				],
				[
					5719,
					7136
				],
				[
					-1529,
					15820
				],
				[
					-16155,
					-5137
				],
				[
					-23638,
					11937
				],
				[
					-2570,
					12385
				],
				[
					8022,
					-279
				],
				[
					2507,
					35100
				],
				[
					-8861,
					33
				],
				[
					1512,
					15776
				],
				[
					-5256,
					-92
				],
				[
					54,
					15767
				],
				[
					-10016,
					65
				],
				[
					157,
					38849
				]
			],
			[
				[
					2086521,
					2036488
				],
				[
					35641,
					-15
				]
			],
			[
				[
					2135163,
					1950296
				],
				[
					0,
					0
				]
			],
			[
				[
					2105808,
					1991281
				],
				[
					0,
					0
				]
			],
			[
				[
					2090081,
					2019988
				],
				[
					0,
					0
				]
			],
			[
				[
					2019279,
					1719028
				],
				[
					12308,
					-6767
				],
				[
					-11806,
					-3585
				],
				[
					-502,
					10352
				]
			],
			[
				[
					2003389,
					1722506
				],
				[
					6083,
					-7429
				],
				[
					-1915,
					-10057
				],
				[
					-4168,
					17486
				]
			],
			[
				[
					2005607,
					1735046
				],
				[
					6774,
					-14416
				],
				[
					-7952,
					3038
				],
				[
					1178,
					11378
				]
			],
			[
				[
					1973461,
					1768048
				],
				[
					7455,
					-12588
				],
				[
					18227,
					-12885
				],
				[
					3669,
					-10381
				],
				[
					-23460,
					20057
				],
				[
					-5891,
					15797
				]
			],
			[
				[
					2002767,
					1866246
				],
				[
					-5280,
					-19820
				],
				[
					-7400,
					8930
				],
				[
					12680,
					10890
				]
			],
			[
				[
					1995558,
					1894109
				],
				[
					6905,
					-15028
				],
				[
					-5074,
					-9594
				],
				[
					-11076,
					9772
				],
				[
					9245,
					14850
				]
			],
			[
				[
					2022593,
					1942766
				],
				[
					0,
					0
				]
			],
			[
				[
					1923430,
					1954359
				],
				[
					-5118,
					-10135
				],
				[
					-3818,
					-23019
				],
				[
					-12576,
					6449
				],
				[
					7309,
					21146
				],
				[
					14203,
					5559
				]
			],
			[
				[
					1856679,
					1959192
				],
				[
					11945,
					-16343
				],
				[
					16203,
					-6581
				],
				[
					11172,
					-23940
				],
				[
					12398,
					-17290
				],
				[
					768,
					-11706
				],
				[
					-7866,
					9761
				],
				[
					-25482,
					21981
				],
				[
					-4632,
					14049
				],
				[
					-16205,
					10459
				],
				[
					1699,
					19610
				]
			],
			[
				[
					1829983,
					2012267
				],
				[
					-30,
					391
				]
			],
			[
				[
					1829953,
					2012658
				],
				[
					30,
					-391
				]
			],
			[
				[
					1842785,
					2007494
				],
				[
					-1371,
					-10009
				]
			],
			[
				[
					1841414,
					1997485
				],
				[
					-9200,
					16086
				],
				[
					1436,
					8571
				],
				[
					9811,
					-15381
				]
			],
			[
				[
					1843461,
					2006761
				],
				[
					-676,
					733
				]
			],
			[
				[
					1842785,
					2007494
				],
				[
					0,
					0
				]
			],
			[
				[
					1633245,
					2150701
				],
				[
					5666,
					-9435
				],
				[
					-11755,
					-1391
				],
				[
					-2641,
					7852
				],
				[
					8730,
					2974
				]
			],
			[
				[
					1666743,
					2152649
				],
				[
					8683,
					-6733
				],
				[
					-7570,
					-10191
				],
				[
					-16614,
					-5013
				],
				[
					-21316,
					2386
				],
				[
					-7607,
					6406
				],
				[
					23184,
					998
				],
				[
					21240,
					12147
				]
			],
			[
				[
					1657470,
					2158766
				],
				[
					-8685,
					-11475
				],
				[
					-13094,
					2945
				],
				[
					10941,
					8397
				],
				[
					10838,
					133
				]
			],
			[
				[
					1574962,
					2167968
				],
				[
					27034,
					-6754
				],
				[
					-3476,
					-4980
				],
				[
					-31176,
					4696
				],
				[
					7618,
					7038
				]
			],
			[
				[
					1631668,
					2173334
				],
				[
					-777,
					1667
				]
			],
			[
				[
					1630891,
					2175001
				],
				[
					13081,
					17007
				],
				[
					16748,
					15429
				],
				[
					12286,
					-2379
				],
				[
					1807,
					-12562
				],
				[
					6429,
					-3380
				],
				[
					-19110,
					-26840
				],
				[
					-15382,
					6778
				],
				[
					-3499,
					-8548
				],
				[
					-14296,
					7846
				],
				[
					2713,
					4982
				]
			],
			[
				[
					1619639,
					2214284
				],
				[
					9425,
					-2807
				],
				[
					9716,
					-13541
				],
				[
					-18432,
					-781
				],
				[
					-9938,
					-5517
				],
				[
					-13733,
					16912
				],
				[
					22856,
					1200
				],
				[
					106,
					4534
				]
			],
			[
				[
					2086521,
					2036488
				],
				[
					-18152,
					6704
				],
				[
					-6145,
					-4863
				],
				[
					-402,
					-21719
				],
				[
					12714,
					-4453
				],
				[
					-97,
					-9990
				],
				[
					-13603,
					-14626
				],
				[
					-10861,
					-6220
				],
				[
					-4516,
					5450
				],
				[
					-7465,
					-14788
				],
				[
					14737,
					-8238
				],
				[
					-2003,
					-4826
				],
				[
					8564,
					-21882
				],
				[
					-4324,
					-9585
				],
				[
					4111,
					-23919
				]
			],
			[
				[
					2059079,
					1903533
				],
				[
					-14588,
					-437
				],
				[
					2356,
					-5334
				],
				[
					-20146,
					-156
				],
				[
					-588,
					-27007
				],
				[
					-3938,
					-7077
				]
			],
			[
				[
					2022175,
					1863522
				],
				[
					-11218,
					390
				]
			],
			[
				[
					2010957,
					1863912
				],
				[
					287,
					9815
				]
			],
			[
				[
					2011244,
					1873727
				],
				[
					-2700,
					17045
				],
				[
					5096,
					28777
				]
			],
			[
				[
					2013640,
					1919549
				],
				[
					10161,
					13732
				],
				[
					12618,
					7667
				],
				[
					-16875,
					5054
				],
				[
					-3460,
					-15565
				],
				[
					-7119,
					-7511
				]
			],
			[
				[
					2008965,
					1922926
				],
				[
					1117,
					-9956
				],
				[
					-12279,
					-13849
				],
				[
					-13585,
					-6196
				],
				[
					1140,
					-19060
				],
				[
					-3680,
					-13460
				],
				[
					-25214,
					10825
				],
				[
					-2236,
					7462
				],
				[
					-17936,
					2580
				],
				[
					-11335,
					18156
				],
				[
					-1929,
					17191
				],
				[
					-6120,
					2704
				],
				[
					6398,
					27706
				],
				[
					11937,
					-1164
				],
				[
					11818,
					-43241
				],
				[
					9928,
					16456
				],
				[
					-11128,
					-1416
				],
				[
					-2650,
					6864
				],
				[
					11126,
					14875
				],
				[
					-11225,
					-8354
				],
				[
					-11950,
					21696
				],
				[
					5803,
					8882
				],
				[
					3359,
					25072
				],
				[
					-12515,
					10671
				],
				[
					2275,
					8765
				],
				[
					18859,
					11728
				],
				[
					5287,
					9822
				],
				[
					-12133,
					18562
				],
				[
					-14626,
					6771
				],
				[
					19984,
					-24092
				],
				[
					-5055,
					-8558
				],
				[
					-18847,
					-14890
				],
				[
					5984,
					-21664
				],
				[
					6511,
					-6339
				],
				[
					-7411,
					-17902
				],
				[
					-7249,
					16927
				],
				[
					-760,
					13063
				]
			],
			[
				[
					1920628,
					1989563
				],
				[
					-3121,
					17280
				],
				[
					-9414,
					14572
				],
				[
					1571,
					17973
				],
				[
					7638,
					3624
				],
				[
					-919,
					14251
				],
				[
					-11048,
					3075
				],
				[
					2260,
					25106
				],
				[
					-11019,
					2925
				],
				[
					-16884,
					-14059
				],
				[
					-13400,
					-44522
				],
				[
					-6565,
					-10429
				],
				[
					956,
					-20901
				],
				[
					-11908,
					-442
				]
			],
			[
				[
					1848775,
					1998016
				],
				[
					-6255,
					20596
				],
				[
					-6922,
					4189
				],
				[
					10254,
					7704
				],
				[
					-3169,
					5381
				],
				[
					11026,
					9651
				],
				[
					2895,
					9830
				],
				[
					-3035,
					22111
				],
				[
					-11675,
					7717
				],
				[
					11309,
					18067
				],
				[
					12919,
					-507
				],
				[
					11773,
					9642
				],
				[
					6130,
					11347
				],
				[
					-23928,
					-15825
				]
			],
			[
				[
					1860097,
					2107919
				],
				[
					6980,
					19077
				],
				[
					-7254,
					16863
				],
				[
					-1566,
					22450
				],
				[
					23112,
					14277
				],
				[
					7186,
					32024
				],
				[
					24234,
					-15956
				],
				[
					4526,
					12787
				],
				[
					10747,
					-8802
				],
				[
					12441,
					-22485
				],
				[
					7137,
					20845
				],
				[
					-2524,
					10282
				],
				[
					10633,
					737
				]
			],
			[
				[
					2024523,
					1960684
				],
				[
					0,
					0
				]
			],
			[
				[
					2024918,
					1945383
				],
				[
					0,
					0
				]
			],
			[
				[
					1686462,
					2116166
				],
				[
					-125,
					-13560
				],
				[
					6229,
					1696
				],
				[
					6918,
					-15496
				],
				[
					-7745,
					-5977
				],
				[
					-19222,
					25450
				],
				[
					3790,
					-16576
				],
				[
					-12928,
					-15204
				],
				[
					-13896,
					-2277
				],
				[
					61,
					-8700
				],
				[
					11505,
					39
				],
				[
					13703,
					-6558
				],
				[
					2068,
					-16843
				],
				[
					-6677,
					-18822
				],
				[
					3161,
					-12729
				],
				[
					-18387,
					-26408
				],
				[
					-9997,
					3124
				],
				[
					-1899,
					10658
				],
				[
					-8777,
					6358
				],
				[
					1451,
					9462
				],
				[
					-12817,
					-2778
				],
				[
					-1243,
					21569
				],
				[
					-7249,
					-945
				],
				[
					-8464,
					15993
				],
				[
					-2001,
					-7475
				],
				[
					-7245,
					12398
				],
				[
					-9825,
					-2053
				],
				[
					1578,
					15076
				],
				[
					-13371,
					23196
				],
				[
					-9497,
					-18692
				],
				[
					-13371,
					3376
				],
				[
					134,
					-10305
				],
				[
					-27869,
					13986
				],
				[
					-13549,
					-12615
				],
				[
					-8412,
					-18327
				],
				[
					-20692,
					-8531
				]
			],
			[
				[
					1481802,
					2037676
				],
				[
					7238,
					7468
				],
				[
					9144,
					20671
				],
				[
					-8454,
					6993
				],
				[
					-2873,
					16922
				],
				[
					-8726,
					-5402
				],
				[
					-4332,
					6712
				],
				[
					7804,
					19394
				],
				[
					-1741,
					8356
				],
				[
					15266,
					-1414
				],
				[
					13108,
					7667
				],
				[
					13470,
					-3105
				],
				[
					9488,
					-22710
				],
				[
					-2178,
					14985
				],
				[
					-12813,
					21034
				],
				[
					-20812,
					-9537
				],
				[
					-23832,
					-5687
				],
				[
					-4234,
					-6342
				],
				[
					-19426,
					22595
				],
				[
					-997,
					10910
				],
				[
					-11363,
					13666
				],
				[
					6205,
					8396
				],
				[
					-9860,
					-584
				],
				[
					-4655,
					23921
				],
				[
					8301,
					8483
				],
				[
					8953,
					-576
				],
				[
					22351,
					17591
				],
				[
					16438,
					-361
				],
				[
					47298,
					-25999
				],
				[
					591,
					-12274
				],
				[
					6502,
					361
				],
				[
					9989,
					-11168
				],
				[
					23592,
					-14028
				],
				[
					791,
					-5794
				],
				[
					16004,
					-2103
				],
				[
					44322,
					-24057
				],
				[
					25848,
					643
				],
				[
					28253,
					-7137
				]
			],
			[
				[
					1471405,
					2163099
				],
				[
					29949,
					-14484
				],
				[
					14755,
					-1869
				],
				[
					-9626,
					7138
				],
				[
					-10246,
					-1238
				],
				[
					-24832,
					10453
				]
			],
			[
				[
					1608310,
					2221239
				],
				[
					6096,
					-9061
				],
				[
					-20321,
					-1529
				],
				[
					14225,
					10590
				]
			],
			[
				[
					1502534,
					2227692
				],
				[
					9286,
					-19679
				],
				[
					-20992,
					10101
				],
				[
					11706,
					9578
				]
			],
			[
				[
					1484147,
					2233958
				],
				[
					6885,
					-2186
				],
				[
					-5018,
					-10418
				],
				[
					-12933,
					6189
				],
				[
					11066,
					6415
				]
			],
			[
				[
					1565928,
					2412691
				],
				[
					0,
					0
				]
			],
			[
				[
					1781860,
					2338835
				],
				[
					7127,
					-12948
				],
				[
					-14138,
					-17739
				],
				[
					-325,
					-12039
				],
				[
					7826,
					-8452
				],
				[
					-3886,
					-14772
				],
				[
					6085,
					-9468
				],
				[
					-9297,
					-4411
				],
				[
					7955,
					-20739
				],
				[
					-17738,
					-3893
				],
				[
					-9671,
					-10409
				],
				[
					-699,
					-25679
				],
				[
					-11537,
					-44595
				],
				[
					-15297,
					-1022
				],
				[
					-9886,
					-7583
				],
				[
					-3604,
					16268
				],
				[
					-9204,
					-2042
				]
			],
			[
				[
					1705571,
					2159312
				],
				[
					-3781,
					2342
				],
				[
					-24325,
					-14996
				],
				[
					-12194,
					10944
				],
				[
					25758,
					7791
				],
				[
					20812,
					1477
				],
				[
					21508,
					6671
				],
				[
					3621,
					14514
				],
				[
					8208,
					10666
				],
				[
					-6343,
					13509
				],
				[
					12382,
					6274
				],
				[
					4117,
					15592
				],
				[
					-4730,
					27509
				],
				[
					-10990,
					8049
				],
				[
					5573,
					-12972
				],
				[
					-76,
					-17021
				],
				[
					5286,
					-6855
				],
				[
					-15854,
					-15031
				],
				[
					-167,
					-22624
				],
				[
					-5093,
					-17811
				],
				[
					-25631,
					-5347
				],
				[
					-6318,
					4319
				],
				[
					-19071,
					-8404
				],
				[
					-1201,
					10820
				],
				[
					17770,
					19283
				],
				[
					-17130,
					-2682
				],
				[
					-2860,
					12524
				],
				[
					-13010,
					4051
				],
				[
					-17784,
					-8899
				],
				[
					-9227,
					4786
				],
				[
					7679,
					21687
				],
				[
					9230,
					-3154
				],
				[
					21626,
					3474
				],
				[
					-26613,
					4614
				],
				[
					-6178,
					22649
				],
				[
					-3864,
					-8477
				],
				[
					4331,
					-14797
				],
				[
					-17262,
					-18398
				],
				[
					-19981,
					11654
				],
				[
					14286,
					4332
				],
				[
					-17192,
					7879
				],
				[
					-5240,
					-14088
				],
				[
					-26281,
					1237
				],
				[
					26916,
					-8916
				],
				[
					-14650,
					-13280
				],
				[
					-26850,
					23410
				],
				[
					-7067,
					-2486
				],
				[
					-21316,
					26117
				],
				[
					2985,
					20450
				],
				[
					10244,
					-12045
				],
				[
					30042,
					-2549
				],
				[
					14194,
					5263
				],
				[
					27309,
					1743
				],
				[
					11442,
					21074
				],
				[
					-13357,
					-17519
				],
				[
					-25168,
					495
				],
				[
					-15935,
					-7399
				],
				[
					-21507,
					391
				],
				[
					-17923,
					12789
				],
				[
					-17292,
					-5034
				],
				[
					-10383,
					17306
				]
			],
			[
				[
					1501046,
					2286213
				],
				[
					1220,
					7238
				],
				[
					31835,
					3766
				],
				[
					7446,
					5831
				],
				[
					20696,
					-7554
				],
				[
					23845,
					10505
				],
				[
					17718,
					19846
				],
				[
					8664,
					-5238
				],
				[
					7351,
					26157
				],
				[
					428,
					16681
				],
				[
					12428,
					-17508
				],
				[
					11727,
					8727
				],
				[
					5345,
					10683
				],
				[
					8084,
					-8002
				],
				[
					29007,
					2074
				],
				[
					-1284,
					13541
				],
				[
					10164,
					19690
				],
				[
					5242,
					-4646
				],
				[
					8085,
					8117
				],
				[
					-9839,
					27506
				],
				[
					7946,
					21572
				],
				[
					5231,
					35127
				],
				[
					18099,
					10880
				],
				[
					4780,
					-15759
				],
				[
					11683,
					-7191
				]
			],
			[
				[
					1691274,
					1834876
				],
				[
					15,
					-1895
				]
			],
			[
				[
					1691289,
					1832981
				],
				[
					-15,
					1895
				]
			],
			[
				[
					1692409,
					1835210
				],
				[
					-973,
					-248
				]
			],
			[
				[
					1691436,
					1834962
				],
				[
					973,
					248
				]
			],
			[
				[
					1691855,
					1831423
				],
				[
					1455,
					48
				]
			],
			[
				[
					1693310,
					1831471
				],
				[
					-3864,
					-6249
				],
				[
					-16638,
					8626
				],
				[
					245,
					26684
				],
				[
					11313,
					982
				],
				[
					5305,
					-7795
				],
				[
					2184,
					-22296
				]
			],
			[
				[
					1640309,
					1930920
				],
				[
					4287,
					-5548
				],
				[
					-9795,
					-5948
				],
				[
					5508,
					11496
				]
			],
			[
				[
					1608629,
					1979305
				],
				[
					8506,
					-10280
				],
				[
					5831,
					2918
				],
				[
					4358,
					-26020
				],
				[
					2159,
					-36282
				],
				[
					-6151,
					-4121
				],
				[
					-17946,
					9117
				],
				[
					-8423,
					14333
				],
				[
					-2431,
					19910
				],
				[
					5342,
					4567
				],
				[
					-10154,
					13148
				],
				[
					18909,
					12710
				]
			],
			[
				[
					1829983,
					2012267
				],
				[
					-30,
					391
				]
			],
			[
				[
					1812027,
					2064353
				],
				[
					11812,
					-23667
				],
				[
					1170,
					-16609
				],
				[
					-11418,
					-14514
				],
				[
					403,
					14533
				],
				[
					-9988,
					9811
				],
				[
					9818,
					14795
				],
				[
					-1797,
					15651
				]
			],
			[
				[
					1804386,
					2072176
				],
				[
					3897,
					-15313
				],
				[
					-10935,
					-19483
				],
				[
					675,
					22287
				],
				[
					6363,
					12509
				]
			],
			[
				[
					1822295,
					2080206
				],
				[
					13871,
					-4487
				],
				[
					-3527,
					-17477
				],
				[
					6944,
					-13821
				],
				[
					-6041,
					-10270
				],
				[
					-19003,
					30992
				],
				[
					7756,
					15063
				]
			],
			[
				[
					1783778,
					2080883
				],
				[
					12199,
					-24297
				],
				[
					-5985,
					-17632
				],
				[
					5342,
					-29770
				],
				[
					-4392,
					-3730
				],
				[
					-6194,
					22101
				],
				[
					-10725,
					12260
				],
				[
					1225,
					9750
				],
				[
					-6606,
					23891
				],
				[
					15136,
					7427
				]
			],
			[
				[
					1842606,
					2080513
				],
				[
					9851,
					-17345
				],
				[
					-7596,
					-17388
				],
				[
					-11560,
					19039
				],
				[
					9305,
					15694
				]
			],
			[
				[
					1798009,
					2085227
				],
				[
					3656,
					-7974
				],
				[
					-6746,
					-14867
				],
				[
					-6602,
					16398
				],
				[
					9692,
					6443
				]
			],
			[
				[
					1798188,
					2107980
				],
				[
					4294,
					-9377
				],
				[
					-6952,
					-3275
				],
				[
					2658,
					12652
				]
			],
			[
				[
					1780364,
					2113744
				],
				[
					11205,
					-13298
				],
				[
					5453,
					-14079
				],
				[
					-9996,
					-7612
				],
				[
					-6417,
					4787
				],
				[
					-13330,
					-5810
				],
				[
					1717,
					14429
				],
				[
					8896,
					-5004
				],
				[
					-3782,
					12570
				],
				[
					6254,
					14017
				]
			],
			[
				[
					1753503,
					2113649
				],
				[
					2037,
					-8722
				],
				[
					-27622,
					-7367
				],
				[
					-5079,
					5354
				],
				[
					30664,
					10735
				]
			],
			[
				[
					1716529,
					2098866
				],
				[
					1680,
					-27088
				],
				[
					11895,
					-3415
				]
			],
			[
				[
					1730104,
					2068363
				],
				[
					-4132,
					-11773
				],
				[
					18975,
					-30620
				],
				[
					-12765,
					5529
				],
				[
					-1273,
					-8976
				],
				[
					-13026,
					-6086
				],
				[
					-8638,
					-9852
				]
			],
			[
				[
					1709245,
					2006585
				],
				[
					-690,
					-23620
				],
				[
					3791,
					-7243
				],
				[
					-3772,
					-23034
				],
				[
					25787,
					-40708
				],
				[
					-7005,
					-8376
				],
				[
					831,
					-12102
				]
			],
			[
				[
					1728187,
					1891502
				],
				[
					-17779,
					-25115
				]
			],
			[
				[
					1710408,
					1866387
				],
				[
					-12067,
					-23891
				],
				[
					-8778,
					18953
				],
				[
					4333,
					11152
				],
				[
					-16420,
					-11095
				],
				[
					-7815,
					10401
				],
				[
					-4318,
					17658
				]
			],
			[
				[
					1665343,
					1889565
				],
				[
					-1566,
					19132
				],
				[
					-8222,
					-7969
				],
				[
					-5797,
					4182
				],
				[
					-14082,
					-8824
				]
			],
			[
				[
					1635676,
					1896086
				],
				[
					-1022,
					9167
				],
				[
					9626,
					10794
				],
				[
					24291,
					6385
				],
				[
					-19590,
					541
				],
				[
					-6254,
					14165
				],
				[
					-10085,
					-4216
				],
				[
					-9579,
					40315
				],
				[
					-14750,
					10998
				],
				[
					-12329,
					-9237
				],
				[
					-3891,
					29032
				],
				[
					22,
					-31200
				],
				[
					-25545,
					2873
				],
				[
					-7999,
					22236
				],
				[
					10698,
					14443
				],
				[
					-15710,
					-12111
				],
				[
					-1331,
					15610
				],
				[
					23926,
					17574
				],
				[
					-12981,
					-4595
				],
				[
					-7381,
					6395
				],
				[
					-695,
					-15522
				],
				[
					-9898,
					-7431
				],
				[
					-9509,
					7238
				],
				[
					-8252,
					19134
				],
				[
					-12413,
					-3656
				],
				[
					1298,
					16630
				],
				[
					-8064,
					-13378
				],
				[
					-13941,
					-12343
				],
				[
					-12516,
					11749
				]
			],
			[
				[
					1686462,
					2116166
				],
				[
					18645,
					-15216
				],
				[
					11422,
					-2084
				]
			],
			[
				[
					1769669,
					2118562
				],
				[
					5474,
					-4329
				],
				[
					-6483,
					-18993
				],
				[
					-7770,
					-4554
				],
				[
					-10928,
					6583
				],
				[
					19707,
					21293
				]
			],
			[
				[
					1722009,
					2121598
				],
				[
					6745,
					-10571
				],
				[
					-4711,
					-4981
				],
				[
					-16917,
					556
				],
				[
					-5358,
					5848
				],
				[
					20241,
					9148
				]
			],
			[
				[
					1631668,
					2173334
				],
				[
					-777,
					1667
				]
			],
			[
				[
					1860097,
					2107919
				],
				[
					-9833,
					4226
				],
				[
					-5665,
					-15374
				],
				[
					-10260,
					-14026
				],
				[
					-15290,
					2602
				],
				[
					-84,
					13102
				],
				[
					-6306,
					-7980
				],
				[
					-6925,
					5276
				],
				[
					614,
					26956
				],
				[
					9107,
					4729
				],
				[
					2691,
					11998
				],
				[
					6763,
					2569
				],
				[
					2539,
					30903
				],
				[
					3561,
					10573
				],
				[
					-9588,
					16382
				],
				[
					14420,
					22978
				],
				[
					-3993,
					8550
				],
				[
					-9879,
					-22879
				],
				[
					-7880,
					-9466
				],
				[
					10426,
					-15816
				],
				[
					-4475,
					-14537
				],
				[
					3424,
					-7573
				],
				[
					-10655,
					-25006
				],
				[
					-12987,
					-8709
				],
				[
					-670,
					-16843
				],
				[
					-7814,
					-5509
				],
				[
					-19697,
					21117
				],
				[
					-14234,
					-12984
				],
				[
					-15217,
					2172
				],
				[
					-9762,
					-6828
				],
				[
					-12856,
					16368
				],
				[
					4412,
					10612
				],
				[
					-15491,
					-14499
				],
				[
					-15205,
					216
				],
				[
					-25033,
					7946
				],
				[
					9109,
					14811
				],
				[
					28207,
					15336
				]
			],
			[
				[
					1994193,
					1634714
				],
				[
					0,
					0
				]
			],
			[
				[
					1981131,
					1658423
				],
				[
					-45,
					73
				]
			],
			[
				[
					1981086,
					1658496
				],
				[
					45,
					-73
				]
			],
			[
				[
					1960859,
					1708641
				],
				[
					0,
					0
				]
			],
			[
				[
					1960321,
					1787902
				],
				[
					2074,
					325
				]
			],
			[
				[
					1962395,
					1788227
				],
				[
					-2074,
					-325
				]
			],
			[
				[
					1962076,
					1792152
				],
				[
					-3804,
					-50
				]
			],
			[
				[
					1958272,
					1792102
				],
				[
					3804,
					50
				]
			],
			[
				[
					1870646,
					1782769
				],
				[
					12637,
					3993
				],
				[
					546,
					-21372
				],
				[
					21671,
					2224
				],
				[
					9877,
					-10173
				],
				[
					-1369,
					12582
				],
				[
					9970,
					-4659
				]
			],
			[
				[
					1923978,
					1765364
				],
				[
					18939,
					-14508
				],
				[
					6769,
					-9495
				],
				[
					3632,
					13126
				]
			],
			[
				[
					1953318,
					1754487
				],
				[
					18751,
					-30780
				]
			],
			[
				[
					1972069,
					1723707
				],
				[
					-8960,
					-1586
				],
				[
					-6627,
					15476
				],
				[
					-7850,
					1219
				],
				[
					-10382,
					-23915
				],
				[
					-1014,
					-18314
				],
				[
					13278,
					-10803
				],
				[
					8843,
					-393
				],
				[
					8884,
					7877
				],
				[
					-2871,
					14149
				]
			],
			[
				[
					1965370,
					1707417
				],
				[
					878,
					45
				]
			],
			[
				[
					1966248,
					1707462
				],
				[
					386,
					15
				]
			],
			[
				[
					1966634,
					1707477
				],
				[
					11129,
					-15852
				],
				[
					1852,
					-19060
				],
				[
					-3327,
					-25735
				]
			],
			[
				[
					1976288,
					1646830
				],
				[
					-11791,
					-1808
				]
			],
			[
				[
					1964497,
					1645022
				],
				[
					1383,
					18069
				],
				[
					-8646,
					-5954
				],
				[
					1844,
					-12203
				]
			],
			[
				[
					1959078,
					1644934
				],
				[
					-5555,
					114
				]
			],
			[
				[
					1953523,
					1645048
				],
				[
					-8164,
					1193
				]
			],
			[
				[
					1945359,
					1646241
				],
				[
					-12447,
					-238
				],
				[
					-2014,
					33687
				],
				[
					-18605,
					1298
				],
				[
					-12033,
					5278
				],
				[
					-3710,
					-8588
				]
			],
			[
				[
					1896550,
					1677678
				],
				[
					-1529,
					8280
				],
				[
					-16670,
					-1141
				],
				[
					-865,
					-9503
				],
				[
					-7787,
					1893
				],
				[
					-1180,
					-21757
				]
			],
			[
				[
					1868519,
					1655450
				],
				[
					-24223,
					11947
				],
				[
					-11803,
					16817
				],
				[
					-33713,
					16562
				],
				[
					-1809,
					10020
				],
				[
					-8998,
					2740
				],
				[
					15744,
					24168
				],
				[
					4631,
					11702
				],
				[
					19770,
					17528
				],
				[
					7244,
					32452
				]
			],
			[
				[
					1835362,
					1799386
				],
				[
					6744,
					-18718
				],
				[
					5027,
					-1639
				],
				[
					18121,
					-31432
				],
				[
					-3167,
					16146
				],
				[
					1356,
					15804
				],
				[
					7203,
					3222
				]
			],
			[
				[
					1849624,
					1720377
				],
				[
					0,
					0
				]
			],
			[
				[
					1945519,
					1814333
				],
				[
					12211,
					-10358
				],
				[
					-2231,
					-7825
				],
				[
					-14760,
					7454
				],
				[
					4780,
					10729
				]
			],
			[
				[
					1697501,
					1817720
				],
				[
					9123,
					-7314
				],
				[
					-8516,
					-6048
				],
				[
					-607,
					13362
				]
			],
			[
				[
					1714417,
					1823939
				],
				[
					6688,
					-5677
				],
				[
					848,
					-23652
				],
				[
					-6430,
					3217
				],
				[
					-4327,
					18787
				],
				[
					3221,
					7325
				]
			],
			[
				[
					1918685,
					1825576
				],
				[
					203,
					-2858
				]
			],
			[
				[
					1918888,
					1822718
				],
				[
					-3009,
					-9200
				]
			],
			[
				[
					1915879,
					1813518
				],
				[
					-6030,
					237
				],
				[
					-901,
					12520
				]
			],
			[
				[
					1908948,
					1826275
				],
				[
					9737,
					-699
				]
			],
			[
				[
					1691855,
					1831423
				],
				[
					-566,
					1558
				]
			],
			[
				[
					1691274,
					1834876
				],
				[
					162,
					86
				]
			],
			[
				[
					1692409,
					1835210
				],
				[
					901,
					-3739
				]
			],
			[
				[
					1892512,
					1820065
				],
				[
					-3187,
					5326
				],
				[
					-13120,
					-9872
				]
			],
			[
				[
					1876205,
					1815519
				],
				[
					-12493,
					11945
				]
			],
			[
				[
					1863712,
					1827464
				],
				[
					12057,
					5148
				],
				[
					-551,
					11150
				],
				[
					6610,
					-1843
				]
			],
			[
				[
					1881828,
					1841919
				],
				[
					8536,
					-6328
				],
				[
					2148,
					-15526
				]
			],
			[
				[
					1747881,
					1885657
				],
				[
					1239,
					-14215
				],
				[
					-4915,
					-5048
				],
				[
					4747,
					-20484
				],
				[
					19340,
					-7923
				],
				[
					10297,
					-14459
				],
				[
					2206,
					-10313
				],
				[
					12603,
					-539
				],
				[
					13944,
					-12801
				],
				[
					23021,
					-7482
				],
				[
					2906,
					8341
				]
			],
			[
				[
					1833269,
					1800734
				],
				[
					-6999,
					-32638
				],
				[
					-4228,
					-6268
				],
				[
					-15302,
					3355
				],
				[
					-7439,
					-6007
				],
				[
					-5418,
					7026
				],
				[
					-9355,
					-14159
				],
				[
					-11927,
					23273
				],
				[
					-2307,
					-10314
				],
				[
					-12475,
					-18393
				],
				[
					-11186,
					13740
				],
				[
					979,
					-9791
				],
				[
					-20370,
					31438
				],
				[
					-7908,
					-1267
				],
				[
					-7267,
					14949
				],
				[
					14352,
					-3812
				],
				[
					13180,
					13191
				],
				[
					-3864,
					10857
				],
				[
					-5045,
					-14502
				],
				[
					-3139,
					7432
				],
				[
					2300,
					19180
				],
				[
					-9733,
					-1766
				],
				[
					-12153,
					6070
				],
				[
					-6058,
					-12137
				],
				[
					-6675,
					13916
				],
				[
					8786,
					5930
				],
				[
					6390,
					26350
				]
			],
			[
				[
					1728187,
					1891502
				],
				[
					19694,
					-5845
				]
			],
			[
				[
					1884561,
					1892267
				],
				[
					12029,
					-4377
				],
				[
					8943,
					-16591
				],
				[
					-21986,
					9874
				],
				[
					1014,
					11094
				]
			],
			[
				[
					1665343,
					1889565
				],
				[
					5012,
					-21066
				],
				[
					-298,
					-18250
				],
				[
					-17315,
					14975
				],
				[
					-1782,
					15231
				],
				[
					-7328,
					-11002
				],
				[
					1543,
					-12850
				],
				[
					-11601,
					9184
				],
				[
					2102,
					30299
				]
			],
			[
				[
					1830534,
					1911968
				],
				[
					11958,
					-25323
				],
				[
					-2926,
					-3128
				],
				[
					-9897,
					16240
				],
				[
					865,
					12211
				]
			],
			[
				[
					1817984,
					1922106
				],
				[
					1492,
					-905
				]
			],
			[
				[
					1819476,
					1921201
				],
				[
					4958,
					-10924
				]
			],
			[
				[
					1824434,
					1910277
				],
				[
					11459,
					-33835
				],
				[
					7229,
					1556
				],
				[
					9591,
					-11153
				]
			],
			[
				[
					1852713,
					1866845
				],
				[
					-13735,
					-8989
				],
				[
					-11040,
					12081
				],
				[
					-12307,
					73
				]
			],
			[
				[
					1815631,
					1870010
				],
				[
					-6151,
					14230
				],
				[
					-7683,
					-6828
				],
				[
					-9592,
					6641
				]
			],
			[
				[
					1792205,
					1884053
				],
				[
					-250,
					13891
				],
				[
					-8270,
					-5107
				],
				[
					8278,
					24295
				],
				[
					9472,
					4749
				]
			],
			[
				[
					1801435,
					1921881
				],
				[
					13062,
					-12873
				],
				[
					8063,
					1946
				],
				[
					-4576,
					11152
				]
			],
			[
				[
					1824672,
					1939489
				],
				[
					0,
					0
				]
			],
			[
				[
					1811255,
					1957010
				],
				[
					-7537,
					-6161
				],
				[
					961,
					17226
				]
			],
			[
				[
					1804679,
					1968075
				],
				[
					6576,
					-11065
				]
			],
			[
				[
					1953523,
					1645048
				],
				[
					480,
					-19755
				],
				[
					-12769,
					-7441
				],
				[
					4125,
					28389
				]
			],
			[
				[
					1964497,
					1645022
				],
				[
					-5419,
					-88
				]
			],
			[
				[
					1896550,
					1677678
				],
				[
					707,
					-10235
				],
				[
					-16446,
					-2806
				],
				[
					3078,
					-11548
				],
				[
					11259,
					-11958
				],
				[
					23761,
					-15126
				]
			],
			[
				[
					1918909,
					1626005
				],
				[
					-50390,
					29445
				]
			],
			[
				[
					1526073,
					2322826
				],
				[
					16836,
					-3911
				],
				[
					-23395,
					-6687
				],
				[
					6559,
					10598
				]
			],
			[
				[
					1520211,
					2386396
				],
				[
					1789,
					-9749
				],
				[
					-5842,
					-12072
				],
				[
					-7644,
					2405
				],
				[
					11697,
					19416
				]
			],
			[
				[
					1462108,
					2414010
				],
				[
					-547,
					-7783
				],
				[
					16101,
					-2278
				],
				[
					6983,
					-20025
				],
				[
					-2085,
					-9192
				],
				[
					4076,
					-18390
				],
				[
					-23867,
					7491
				],
				[
					-7613,
					43897
				],
				[
					6952,
					6280
				]
			],
			[
				[
					1471546,
					2423870
				],
				[
					5462,
					-17618
				],
				[
					-14072,
					421
				],
				[
					8610,
					17197
				]
			],
			[
				[
					1424996,
					2490246
				],
				[
					-759,
					-15519
				],
				[
					-5579,
					3486
				],
				[
					6338,
					12033
				]
			],
			[
				[
					1473310,
					2507540
				],
				[
					4897,
					-2930
				],
				[
					-487,
					-23420
				],
				[
					-12627,
					-42672
				],
				[
					-6814,
					16412
				],
				[
					5848,
					21900
				],
				[
					-6191,
					1764
				],
				[
					1335,
					-19360
				],
				[
					-12978,
					-3022
				],
				[
					8663,
					42509
				],
				[
					18354,
					8819
				]
			],
			[
				[
					1122353,
					2525775
				],
				[
					17726,
					-17962
				],
				[
					-14982,
					-3550
				],
				[
					7213,
					-20923
				],
				[
					-4704,
					-5546
				],
				[
					-9277,
					35454
				],
				[
					4024,
					12527
				]
			],
			[
				[
					1485666,
					2533945
				],
				[
					-6347,
					-26352
				],
				[
					-19925,
					6653
				],
				[
					-2038,
					10601
				],
				[
					15420,
					5082
				],
				[
					9786,
					-4327
				],
				[
					3104,
					8343
				]
			],
			[
				[
					1452983,
					2540571
				],
				[
					3476,
					-6492
				],
				[
					1006,
					-24182
				],
				[
					-11777,
					-16406
				],
				[
					-4820,
					21075
				],
				[
					3944,
					17540
				],
				[
					8171,
					8465
				]
			],
			[
				[
					1445030,
					2543444
				],
				[
					-7234,
					-23373
				],
				[
					-193,
					15792
				],
				[
					7427,
					7581
				]
			],
			[
				[
					1441395,
					2546501
				],
				[
					-11708,
					-20265
				],
				[
					833,
					19903
				],
				[
					10875,
					362
				]
			],
			[
				[
					1424723,
					2546714
				],
				[
					5250,
					-354
				],
				[
					-718,
					-15599
				],
				[
					-11283,
					-5849
				],
				[
					6751,
					21802
				]
			],
			[
				[
					1476355,
					2562635
				],
				[
					5800,
					-13085
				],
				[
					121,
					-20750
				],
				[
					-20211,
					8847
				],
				[
					14290,
					24988
				]
			],
			[
				[
					1467592,
					2563701
				],
				[
					4903,
					-5547
				],
				[
					-8908,
					-13247
				],
				[
					-10060,
					2989
				],
				[
					14065,
					15805
				]
			],
			[
				[
					1460889,
					2595060
				],
				[
					6499,
					-28579
				],
				[
					-12927,
					-11485
				],
				[
					-5081,
					3055
				],
				[
					11509,
					37009
				]
			],
			[
				[
					1555519,
					2593717
				],
				[
					8049,
					-19171
				],
				[
					-13594,
					-22130
				],
				[
					-13731,
					-4968
				],
				[
					-15189,
					-21249
				],
				[
					-7690,
					-3279
				],
				[
					-8350,
					-42323
				],
				[
					-20917,
					-7137
				],
				[
					1680,
					38147
				],
				[
					12798,
					35954
				],
				[
					17499,
					6645
				],
				[
					18745,
					15328
				],
				[
					967,
					10672
				],
				[
					19733,
					13511
				]
			],
			[
				[
					1101565,
					2597261
				],
				[
					5047,
					-1996
				],
				[
					-10351,
					-20927
				],
				[
					-4919,
					15887
				],
				[
					10223,
					7036
				]
			],
			[
				[
					1440332,
					2604647
				],
				[
					-46,
					-14363
				],
				[
					-10402,
					-12922
				],
				[
					-11379,
					7324
				],
				[
					8692,
					14829
				],
				[
					13135,
					5132
				]
			],
			[
				[
					1414283,
					2628739
				],
				[
					-780,
					5439
				]
			],
			[
				[
					1413503,
					2634178
				],
				[
					780,
					-5439
				]
			],
			[
				[
					1078060,
					2667300
				],
				[
					4906,
					-6532
				],
				[
					-2098,
					-20694
				],
				[
					-17308,
					3317
				],
				[
					7923,
					-9816
				],
				[
					-6793,
					-3665
				],
				[
					-3848,
					15288
				],
				[
					-10102,
					14573
				],
				[
					20249,
					-5275
				],
				[
					7071,
					12804
				]
			],
			[
				[
					1060291,
					2676929
				],
				[
					4031,
					-6397
				],
				[
					-11476,
					-1489
				],
				[
					-3991,
					6416
				],
				[
					11436,
					1470
				]
			],
			[
				[
					1048348,
					2696754
				],
				[
					11496,
					-5206
				],
				[
					-10239,
					-7683
				],
				[
					-12386,
					7981
				],
				[
					11129,
					4908
				]
			],
			[
				[
					982748,
					2732385
				],
				[
					15070,
					-7567
				],
				[
					-14395,
					-3314
				],
				[
					-675,
					10881
				]
			],
			[
				[
					1039108,
					2739741
				],
				[
					19312,
					-9608
				],
				[
					6247,
					-8253
				],
				[
					-10016,
					-21989
				],
				[
					-13887,
					-1630
				],
				[
					-8551,
					16075
				],
				[
					-4460,
					19520
				],
				[
					11355,
					5885
				]
			],
			[
				[
					953921,
					2767140
				],
				[
					21761,
					-10662
				],
				[
					-16923,
					-740
				],
				[
					-4838,
					11402
				]
			],
			[
				[
					1041896,
					2787849
				],
				[
					851,
					-18541
				],
				[
					17548,
					-12655
				],
				[
					3703,
					-19167
				],
				[
					-21853,
					9308
				],
				[
					-12615,
					-4708
				],
				[
					-12769,
					1880
				],
				[
					14522,
					-24985
				],
				[
					-4435,
					-6998
				],
				[
					10750,
					-15000
				],
				[
					4156,
					-15954
				],
				[
					5717,
					-1810
				],
				[
					-8334,
					-16537
				],
				[
					11275,
					-8457
				],
				[
					5627,
					-23100
				],
				[
					20238,
					-17226
				],
				[
					8739,
					-11980
				],
				[
					-1082,
					-18996
				],
				[
					8307,
					-2994
				],
				[
					1996,
					-16343
				],
				[
					11166,
					-15318
				],
				[
					-2501,
					10627
				],
				[
					10736,
					8940
				],
				[
					1815,
					-11308
				],
				[
					7535,
					2150
				],
				[
					-3658,
					-18024
				],
				[
					13150,
					313
				],
				[
					-4303,
					-12420
				],
				[
					-10999,
					-435
				],
				[
					-4106,
					-10478
				],
				[
					-6076,
					9029
				],
				[
					-3333,
					-8689
				],
				[
					-9937,
					21073
				],
				[
					-23835,
					28707
				],
				[
					-4432,
					13823
				],
				[
					9299,
					7885
				],
				[
					-12448,
					3539
				],
				[
					-4262,
					11565
				],
				[
					-8604,
					3885
				],
				[
					-16937,
					20161
				],
				[
					-6190,
					21091
				],
				[
					-3051,
					-4694
				],
				[
					-15366,
					21639
				],
				[
					5877,
					6590
				],
				[
					7819,
					-5214
				],
				[
					1867,
					12752
				],
				[
					-7823,
					2678
				],
				[
					-8130,
					-15404
				],
				[
					-16793,
					21541
				],
				[
					-11039,
					27928
				],
				[
					22728,
					7604
				],
				[
					-11466,
					9716
				],
				[
					-26801,
					2174
				],
				[
					-8989,
					16527
				],
				[
					17931,
					789
				],
				[
					7577,
					11798
				],
				[
					30346,
					45
				],
				[
					18029,
					22207
				],
				[
					12863,
					-529
				]
			],
			[
				[
					1501046,
					2286213
				],
				[
					-4349,
					1169
				],
				[
					1950,
					20088
				],
				[
					15640,
					8344
				],
				[
					5668,
					-4700
				],
				[
					17618,
					1889
				],
				[
					15204,
					8435
				],
				[
					-27735,
					3830
				],
				[
					2099,
					5629
				],
				[
					-28945,
					-5662
				],
				[
					-2075,
					8144
				],
				[
					14279,
					11744
				],
				[
					16430,
					26663
				],
				[
					1844,
					26484
				],
				[
					27050,
					10475
				],
				[
					-7883,
					6278
				],
				[
					-11265,
					-8505
				],
				[
					-1594,
					23024
				],
				[
					6254,
					3328
				],
				[
					4803,
					24500
				],
				[
					-8643,
					-24046
				],
				[
					-4510,
					-26090
				],
				[
					-9107,
					-5369
				],
				[
					-3713,
					-14417
				],
				[
					-10317,
					-15595
				],
				[
					-14123,
					3739
				],
				[
					125,
					16023
				],
				[
					13617,
					1626
				],
				[
					-1756,
					6567
				],
				[
					-11434,
					-1560
				],
				[
					-9584,
					11158
				],
				[
					-1274,
					52299
				],
				[
					8831,
					11483
				],
				[
					11933,
					1642
				],
				[
					7814,
					17396
				],
				[
					3199,
					26285
				],
				[
					13127,
					8583
				],
				[
					2703,
					-19378
				],
				[
					3934,
					7359
				],
				[
					-2864,
					20310
				],
				[
					18796,
					9555
				],
				[
					12970,
					19999
				],
				[
					16342,
					-865
				],
				[
					8465,
					-11538
				],
				[
					3452,
					-17885
				],
				[
					10059,
					-9552
				],
				[
					17135,
					-31366
				],
				[
					1256,
					7026
				],
				[
					-15808,
					27255
				],
				[
					-9641,
					8613
				],
				[
					-7326,
					27826
				],
				[
					4236,
					8986
				],
				[
					16627,
					6254
				],
				[
					-1794,
					5967
				],
				[
					-21413,
					-16415
				],
				[
					-20108,
					2723
				],
				[
					-8163,
					45005
				],
				[
					15412,
					18286
				],
				[
					13037,
					6134
				],
				[
					7777,
					21971
				],
				[
					-5738,
					28286
				],
				[
					-12289,
					6132
				],
				[
					9021,
					-12774
				],
				[
					2994,
					-22881
				],
				[
					-7805,
					-17956
				],
				[
					-8451,
					-5045
				],
				[
					-16173,
					-19025
				],
				[
					-1876,
					-19329
				],
				[
					-8318,
					-10908
				],
				[
					-7134,
					55
				],
				[
					-23550,
					38220
				],
				[
					20675,
					-39282
				],
				[
					-6160,
					-18115
				],
				[
					-13558,
					-11361
				],
				[
					-19970,
					-5623
				],
				[
					-8551,
					-15699
				],
				[
					-7326,
					18738
				],
				[
					51,
					16787
				],
				[
					7938,
					9386
				],
				[
					-10319,
					13706
				],
				[
					7124,
					-17690
				],
				[
					-6977,
					-11851
				],
				[
					-10233,
					1156
				],
				[
					-4477,
					31690
				],
				[
					7830,
					12744
				],
				[
					-7351,
					-234
				],
				[
					-4262,
					21588
				],
				[
					516,
					-30373
				],
				[
					-21642,
					-52826
				],
				[
					-8529,
					9030
				],
				[
					6653,
					25513
				],
				[
					6639,
					2193
				],
				[
					6347,
					18223
				]
			],
			[
				[
					1450407,
					2605839
				],
				[
					2472,
					22140
				],
				[
					7514,
					17805
				],
				[
					-4944,
					5459
				],
				[
					15884,
					11474
				],
				[
					9410,
					-580
				],
				[
					1809,
					-9915
				],
				[
					14908,
					425
				],
				[
					11483,
					27404
				],
				[
					9277,
					-2899
				],
				[
					-2169,
					-11235
				],
				[
					6073,
					-10078
				],
				[
					8173,
					386
				],
				[
					13758,
					15219
				],
				[
					1811,
					12687
				],
				[
					14771,
					3403
				],
				[
					-8531,
					20578
				],
				[
					6875,
					13054
				],
				[
					-753,
					13182
				],
				[
					-8898,
					12337
				],
				[
					-12662,
					5056
				],
				[
					-4809,
					12236
				],
				[
					13125,
					9158
				],
				[
					10606,
					24200
				]
			],
			[
				[
					1004799,
					2924441
				],
				[
					-5006,
					-22279
				],
				[
					-4001,
					14314
				],
				[
					9007,
					7965
				]
			],
			[
				[
					1398754,
					2962103
				],
				[
					137,
					4609
				]
			],
			[
				[
					1398891,
					2966712
				],
				[
					-137,
					-4609
				]
			],
			[
				[
					1056780,
					2989012
				],
				[
					-3593,
					-22873
				],
				[
					-17487,
					-41094
				],
				[
					-1337,
					-23683
				],
				[
					-6683,
					-21701
				],
				[
					-2534,
					-25584
				],
				[
					4962,
					-19488
				],
				[
					-9441,
					-44459
				],
				[
					-14453,
					1180
				],
				[
					-13898,
					-8358
				],
				[
					12968,
					-9525
				],
				[
					-11521,
					-7963
				],
				[
					-8454,
					3114
				],
				[
					-21596,
					-3587
				],
				[
					-10817,
					14879
				],
				[
					3535,
					6404
				],
				[
					-17249,
					5390
				],
				[
					9905,
					8968
				],
				[
					-521,
					8171
				],
				[
					-15375,
					-43
				],
				[
					5428,
					12539
				],
				[
					20355,
					-2688
				],
				[
					6514,
					-10486
				],
				[
					7103,
					4382
				],
				[
					-11513,
					9160
				],
				[
					-1143,
					8859
				],
				[
					-27500,
					11283
				],
				[
					-13347,
					1813
				],
				[
					5590,
					12490
				],
				[
					-11443,
					224
				],
				[
					-6743,
					16697
				],
				[
					19222,
					1168
				],
				[
					-10485,
					4733
				],
				[
					-871,
					17430
				],
				[
					-20743,
					21372
				],
				[
					4173,
					11053
				],
				[
					-8205,
					22016
				],
				[
					4016,
					20931
				],
				[
					6988,
					7125
				],
				[
					-4871,
					22384
				],
				[
					8387,
					14812
				],
				[
					23826,
					-13798
				],
				[
					17428,
					6369
				],
				[
					8704,
					-7769
				],
				[
					2018,
					-16530
				],
				[
					-9975,
					-12240
				],
				[
					-1943,
					-13899
				],
				[
					13189,
					14715
				],
				[
					-1521,
					8618
				],
				[
					28761,
					16848
				],
				[
					8956,
					-20151
				],
				[
					6616,
					-2744
				],
				[
					7904,
					-30802
				],
				[
					-2377,
					-10756
				],
				[
					-14901,
					-19068
				],
				[
					-16883,
					-4593
				],
				[
					-3577,
					-6863
				],
				[
					-20468,
					-6988
				],
				[
					9331,
					-9844
				],
				[
					20953,
					6688
				],
				[
					-11914,
					-13710
				],
				[
					16026,
					-1263
				],
				[
					-2843,
					14020
				],
				[
					19107,
					3491
				],
				[
					9370,
					47295
				],
				[
					-5980,
					30141
				],
				[
					-6004,
					8765
				],
				[
					22838,
					-3505
				],
				[
					22845,
					10587
				],
				[
					15359,
					23697
				],
				[
					-2168,
					-23756
				]
			],
			[
				[
					903136,
					3033820
				],
				[
					3582,
					-10721
				],
				[
					-8627,
					2218
				],
				[
					5045,
					8503
				]
			],
			[
				[
					1243579,
					3422312
				],
				[
					2586,
					33362
				],
				[
					-11489,
					27841
				],
				[
					-15559,
					-6324
				],
				[
					-20191,
					10390
				],
				[
					-5134,
					24749
				]
			],
			[
				[
					1312776,
					2829500
				],
				[
					8896,
					-11615
				],
				[
					-365,
					-14819
				],
				[
					-5946,
					1891
				],
				[
					-7535,
					16392
				],
				[
					4950,
					8151
				]
			],
			[
				[
					1253015,
					2862459
				],
				[
					5473,
					-1786
				],
				[
					-3900,
					-17035
				],
				[
					-11177,
					9639
				],
				[
					9604,
					9182
				]
			],
			[
				[
					1193260,
					2884250
				],
				[
					40256,
					-29241
				],
				[
					23576,
					-30103
				],
				[
					11598,
					-24203
				],
				[
					5661,
					-18832
				],
				[
					-3376,
					-11538
				],
				[
					-5859,
					5469
				],
				[
					-14383,
					-4360
				],
				[
					-15611,
					24466
				],
				[
					-176,
					8853
				],
				[
					-9260,
					11898
				],
				[
					-12189,
					5306
				],
				[
					-13271,
					18687
				],
				[
					5013,
					15857
				],
				[
					-8473,
					-4763
				],
				[
					-12363,
					11649
				],
				[
					798,
					18370
				],
				[
					8059,
					2485
				]
			],
			[
				[
					1215014,
					2923341
				],
				[
					5255,
					-17930
				],
				[
					12334,
					-7882
				],
				[
					5238,
					-31142
				],
				[
					-8912,
					1046
				],
				[
					-20219,
					11931
				],
				[
					-8539,
					13518
				],
				[
					13683,
					18721
				],
				[
					1160,
					11738
				]
			],
			[
				[
					1182834,
					2935110
				],
				[
					6969,
					-7005
				],
				[
					-10112,
					-7575
				],
				[
					-5990,
					5368
				],
				[
					9133,
					9212
				]
			],
			[
				[
					1223064,
					2950220
				],
				[
					8917,
					-5288
				],
				[
					34247,
					-43308
				],
				[
					13419,
					-26565
				],
				[
					32496,
					-44881
				],
				[
					-7108,
					-16849
				],
				[
					-689,
					-27580
				],
				[
					-11287,
					-4253
				],
				[
					-12664,
					26236
				],
				[
					-15061,
					16125
				],
				[
					-1084,
					16368
				],
				[
					-7990,
					2653
				],
				[
					2511,
					28080
				],
				[
					-13363,
					-4327
				],
				[
					-6006,
					8028
				],
				[
					-4671,
					24276
				],
				[
					-11612,
					5471
				],
				[
					-1225,
					21558
				],
				[
					-8298,
					3096
				],
				[
					305,
					10905
				],
				[
					9163,
					10255
				]
			],
			[
				[
					1224789,
					2990997
				],
				[
					6961,
					-14449
				],
				[
					-8681,
					-4141
				],
				[
					1720,
					18590
				]
			],
			[
				[
					1199481,
					2996237
				],
				[
					10000,
					-10068
				],
				[
					10387,
					-19927
				],
				[
					-12082,
					-36080
				],
				[
					-16171,
					4455
				],
				[
					1351,
					10995
				],
				[
					-9512,
					922
				],
				[
					-10040,
					15370
				],
				[
					-6073,
					-16238
				],
				[
					9929,
					-8037
				],
				[
					-10425,
					-3278
				],
				[
					-3258,
					15564
				],
				[
					14897,
					29880
				],
				[
					20997,
					16442
				]
			],
			[
				[
					1217453,
					3018397
				],
				[
					11437,
					-10463
				],
				[
					-10267,
					-8132
				],
				[
					-4955,
					8444
				],
				[
					3785,
					10151
				]
			],
			[
				[
					1157494,
					3023810
				],
				[
					16518,
					-18891
				],
				[
					-4744,
					-7037
				],
				[
					-15848,
					16216
				],
				[
					4074,
					9712
				]
			],
			[
				[
					1208834,
					3028986
				],
				[
					1504,
					383
				]
			],
			[
				[
					1210338,
					3029369
				],
				[
					-1504,
					-383
				]
			],
			[
				[
					1225065,
					3031587
				],
				[
					-672,
					1148
				]
			],
			[
				[
					1224393,
					3032735
				],
				[
					672,
					-1148
				]
			],
			[
				[
					1224373,
					3033396
				],
				[
					13,
					-429
				]
			],
			[
				[
					1224386,
					3032967
				],
				[
					-13,
					429
				]
			],
			[
				[
					1333384,
					2882633
				],
				[
					-2325,
					-12732
				],
				[
					1596,
					-37139
				],
				[
					-11477,
					-10114
				],
				[
					-39469,
					51900
				],
				[
					-2305,
					14506
				],
				[
					-21184,
					26520
				],
				[
					-20021,
					30026
				],
				[
					-4147,
					13606
				],
				[
					3007,
					40033
				],
				[
					-24153,
					28281
				]
			],
			[
				[
					1212906,
					3027520
				],
				[
					1157,
					119
				]
			],
			[
				[
					1214063,
					3027639
				],
				[
					11012,
					3941
				]
			],
			[
				[
					1225075,
					3031580
				],
				[
					26056,
					3091
				],
				[
					-1568,
					-14353
				],
				[
					12168,
					8242
				],
				[
					27431,
					-11800
				],
				[
					5918,
					8875
				],
				[
					14647,
					6916
				],
				[
					7778,
					12909
				]
			],
			[
				[
					1317505,
					3045460
				],
				[
					-224,
					-122923
				],
				[
					16103,
					-39904
				]
			],
			[
				[
					1192331,
					3071648
				],
				[
					-986,
					3151
				]
			],
			[
				[
					1191345,
					3074799
				],
				[
					710,
					3349
				]
			],
			[
				[
					1192055,
					3078148
				],
				[
					8970,
					6362
				]
			],
			[
				[
					1201025,
					3084510
				],
				[
					-310,
					245
				]
			],
			[
				[
					1200715,
					3084755
				],
				[
					-4575,
					5088
				],
				[
					1601,
					16773
				]
			],
			[
				[
					1197741,
					3106616
				],
				[
					10918,
					-2215
				],
				[
					571,
					-32825
				],
				[
					-16899,
					72
				]
			],
			[
				[
					1203770,
					3138936
				],
				[
					-316,
					-101
				]
			],
			[
				[
					1203454,
					3138835
				],
				[
					1002,
					6188
				],
				[
					17636,
					19881
				],
				[
					-1890,
					-19020
				],
				[
					-16432,
					-6948
				]
			],
			[
				[
					1304756,
					3172997
				],
				[
					11254,
					-10484
				],
				[
					-8962,
					-31614
				]
			],
			[
				[
					1307048,
					3130899
				],
				[
					-24932,
					8473
				],
				[
					-1901,
					9896
				],
				[
					-10658,
					2257
				],
				[
					-19258,
					-11305
				],
				[
					-19716,
					7671
				],
				[
					-8771,
					-1113
				]
			],
			[
				[
					1221812,
					3146778
				],
				[
					8814,
					28904
				],
				[
					-2448,
					4970
				],
				[
					17749,
					30102
				]
			],
			[
				[
					1223868,
					3224487
				],
				[
					5172,
					-22090
				],
				[
					-13859,
					-29689
				],
				[
					-18579,
					-18347
				],
				[
					-4388,
					-12803
				],
				[
					-15939,
					2026
				],
				[
					-4424,
					12322
				],
				[
					10309,
					6834
				],
				[
					25025,
					30488
				],
				[
					16683,
					31259
				]
			],
			[
				[
					2388943,
					1879253
				],
				[
					1016,
					-37957
				],
				[
					9149,
					-1096
				]
			],
			[
				[
					2419940,
					1765483
				],
				[
					-84146,
					0
				],
				[
					-102146,
					-13
				]
			],
			[
				[
					2233648,
					1765470
				],
				[
					-8223,
					23540
				],
				[
					-5034,
					-5289
				],
				[
					-4675,
					19540
				],
				[
					-5722,
					-4616
				],
				[
					-7765,
					15888
				],
				[
					-4453,
					-11053
				],
				[
					-10559,
					6795
				],
				[
					-12098,
					-18170
				],
				[
					-4503,
					10584
				]
			],
			[
				[
					2170616,
					1802689
				],
				[
					-2250,
					5507
				]
			],
			[
				[
					2168366,
					1808196
				],
				[
					309,
					3
				]
			],
			[
				[
					2168675,
					1808199
				],
				[
					2971,
					9267
				]
			],
			[
				[
					2257550,
					1917156
				],
				[
					11224,
					10771
				],
				[
					1579,
					21012
				],
				[
					19828,
					675
				],
				[
					19100,
					-3329
				],
				[
					6942,
					5559
				],
				[
					-2705,
					10135
				]
			],
			[
				[
					2857726,
					1928619
				],
				[
					-11964,
					55
				],
				[
					-2057,
					-17707
				],
				[
					-21653,
					-3162
				],
				[
					-3056,
					-13760
				],
				[
					-12668,
					-28843
				]
			],
			[
				[
					2459989,
					2064622
				],
				[
					0,
					0
				]
			],
			[
				[
					2459384,
					2074724
				],
				[
					20,
					169
				]
			],
			[
				[
					2459404,
					2074893
				],
				[
					-20,
					-169
				]
			],
			[
				[
					2492961,
					1961409
				],
				[
					-8490,
					12
				],
				[
					13668,
					24929
				],
				[
					14346,
					9637
				],
				[
					-209,
					15975
				],
				[
					-6676,
					7467
				],
				[
					-22105,
					-3797
				],
				[
					-1524,
					12469
				],
				[
					-8411,
					3785
				]
			],
			[
				[
					2473560,
					2031886
				],
				[
					681,
					11294
				],
				[
					-20693,
					-36
				]
			],
			[
				[
					2453548,
					2043144
				],
				[
					7535,
					9556
				],
				[
					-1948,
					12988
				]
			],
			[
				[
					2459135,
					2065688
				],
				[
					1084,
					10763
				]
			],
			[
				[
					2460219,
					2076451
				],
				[
					398,
					14757
				]
			],
			[
				[
					2460219,
					2076451
				],
				[
					-815,
					-1558
				]
			],
			[
				[
					2459384,
					2074724
				],
				[
					-249,
					-9036
				]
			],
			[
				[
					2453548,
					2043144
				],
				[
					-141,
					-1
				]
			],
			[
				[
					2453407,
					2043143
				],
				[
					-16294,
					-275
				]
			],
			[
				[
					2437113,
					2042868
				],
				[
					182,
					7379
				],
				[
					-38297,
					-1643
				]
			],
			[
				[
					2286023,
					2117500
				],
				[
					19871,
					-6997
				],
				[
					7694,
					-6958
				],
				[
					25491,
					-3770
				]
			],
			[
				[
					2661449,
					1846867
				],
				[
					-7208,
					2715
				],
				[
					4296,
					21040
				]
			],
			[
				[
					2084716,
					1813577
				],
				[
					14478,
					-6784
				]
			],
			[
				[
					2099194,
					1806793
				],
				[
					50,
					-5850
				]
			],
			[
				[
					2099244,
					1800943
				],
				[
					-8597,
					-6731
				]
			],
			[
				[
					2090647,
					1794212
				],
				[
					-15951,
					11489
				]
			],
			[
				[
					2074696,
					1805701
				],
				[
					1144,
					7098
				]
			],
			[
				[
					2075840,
					1812799
				],
				[
					8876,
					778
				]
			],
			[
				[
					2431828,
					1947104
				],
				[
					20229,
					23293
				],
				[
					-5451,
					3658
				]
			],
			[
				[
					2446606,
					1974055
				],
				[
					2964,
					13372
				],
				[
					8632,
					6840
				],
				[
					-7189,
					6980
				]
			],
			[
				[
					2451013,
					2001247
				],
				[
					5566,
					11942
				]
			],
			[
				[
					2456579,
					2013189
				],
				[
					16981,
					18697
				]
			],
			[
				[
					2449503,
					1977553
				],
				[
					0,
					0
				]
			],
			[
				[
					2645300,
					1765661
				],
				[
					-21810,
					-57
				]
			],
			[
				[
					2300191,
					2187778
				],
				[
					18728,
					-9606
				],
				[
					5105,
					-6686
				]
			],
			[
				[
					2324024,
					2171486
				],
				[
					11745,
					-6194
				]
			],
			[
				[
					2335769,
					2165292
				],
				[
					179,
					-857
				]
			],
			[
				[
					2335948,
					2164435
				],
				[
					2474,
					-4250
				]
			],
			[
				[
					2447131,
					1999539
				],
				[
					-5858,
					-19816
				]
			],
			[
				[
					2441273,
					1979723
				],
				[
					-4907,
					15708
				]
			],
			[
				[
					2436366,
					1995431
				],
				[
					2039,
					12315
				]
			],
			[
				[
					2438405,
					2007746
				],
				[
					8726,
					-8207
				]
			],
			[
				[
					2417019,
					1955343
				],
				[
					9681,
					5329
				]
			],
			[
				[
					2426700,
					1960672
				],
				[
					5803,
					10698
				]
			],
			[
				[
					2432503,
					1971370
				],
				[
					8806,
					6226
				]
			],
			[
				[
					2441309,
					1977596
				],
				[
					5297,
					-3541
				]
			],
			[
				[
					2441309,
					1977596
				],
				[
					-36,
					2127
				]
			],
			[
				[
					2447131,
					1999539
				],
				[
					3882,
					1708
				]
			],
			[
				[
					2456579,
					2013189
				],
				[
					-4179,
					9594
				],
				[
					1007,
					20360
				]
			],
			[
				[
					2432503,
					1971370
				],
				[
					3863,
					24061
				]
			],
			[
				[
					2437113,
					2042868
				],
				[
					1292,
					-35122
				]
			],
			[
				[
					2426700,
					1960672
				],
				[
					54,
					8960
				],
				[
					-10843,
					14929
				],
				[
					-10226,
					-1019
				],
				[
					-20544,
					7842
				]
			],
			[
				[
					2347736,
					2215588
				],
				[
					-10338,
					-31161
				],
				[
					1586,
					-13601
				]
			],
			[
				[
					2338984,
					2170826
				],
				[
					-3092,
					539
				]
			],
			[
				[
					2335892,
					2171365
				],
				[
					-11868,
					121
				]
			],
			[
				[
					2338984,
					2170826
				],
				[
					21164,
					-2070
				],
				[
					17585,
					-5685
				]
			],
			[
				[
					2354237,
					2155989
				],
				[
					2425,
					8040
				],
				[
					-12993,
					2101
				]
			],
			[
				[
					2340201,
					2165128
				],
				[
					-4253,
					-693
				]
			],
			[
				[
					2335769,
					2165292
				],
				[
					123,
					6073
				]
			],
			[
				[
					2003627,
					2610018
				],
				[
					70537,
					1535
				],
				[
					27936,
					-1034
				],
				[
					7940,
					-33614
				]
			],
			[
				[
					1993569,
					2843778
				],
				[
					-518,
					-16125
				],
				[
					11143,
					-7537
				],
				[
					-425,
					-21111
				],
				[
					29153,
					3556
				],
				[
					4881,
					-5769
				],
				[
					14843,
					8802
				]
			],
			[
				[
					2093793,
					2958233
				],
				[
					-24251,
					-8208
				]
			],
			[
				[
					2069542,
					2950025
				],
				[
					-4858,
					3746
				]
			],
			[
				[
					2064684,
					2953771
				],
				[
					-12469,
					12545
				],
				[
					-6449,
					-2557
				],
				[
					-5208,
					-19277
				]
			],
			[
				[
					2040558,
					2944482
				],
				[
					-9912,
					-8724
				],
				[
					-6497,
					12432
				],
				[
					-12460,
					1849
				],
				[
					-4351,
					18509
				],
				[
					-16847,
					-3059
				]
			],
			[
				[
					2069542,
					2950025
				],
				[
					-4939,
					-989
				]
			],
			[
				[
					2064603,
					2949036
				],
				[
					81,
					4735
				]
			],
			[
				[
					2064603,
					2949036
				],
				[
					-9213,
					-15211
				],
				[
					-4806,
					9754
				],
				[
					-10026,
					903
				]
			],
			[
				[
					2150712,
					1804710
				],
				[
					0,
					0
				]
			],
			[
				[
					2168675,
					1808199
				],
				[
					-309,
					-3
				]
			],
			[
				[
					2170616,
					1802689
				],
				[
					-7527,
					-1676
				]
			],
			[
				[
					2163089,
					1801013
				],
				[
					-2451,
					12
				]
			],
			[
				[
					2160638,
					1801025
				],
				[
					-3061,
					13
				]
			],
			[
				[
					2157577,
					1801038
				],
				[
					-6785,
					9036
				]
			],
			[
				[
					2163377,
					1812967
				],
				[
					0,
					0
				]
			],
			[
				[
					2162339,
					1785302
				],
				[
					0,
					0
				]
			],
			[
				[
					2157577,
					1801038
				],
				[
					3061,
					-13
				]
			],
			[
				[
					2163089,
					1801013
				],
				[
					5045,
					-35531
				]
			],
			[
				[
					2168134,
					1765482
				],
				[
					-29946,
					520
				]
			],
			[
				[
					2138188,
					1766002
				],
				[
					5002,
					10434
				],
				[
					-5909,
					24047
				]
			],
			[
				[
					2122322,
					1766026
				],
				[
					-6642,
					20
				]
			],
			[
				[
					2115680,
					1766046
				],
				[
					-50,
					17415
				]
			],
			[
				[
					2115630,
					1783461
				],
				[
					3309,
					3520
				]
			],
			[
				[
					2118939,
					1786981
				],
				[
					3383,
					-20955
				]
			],
			[
				[
					2115680,
					1766046
				],
				[
					-12573,
					-28
				]
			],
			[
				[
					2103107,
					1766018
				],
				[
					5066,
					24
				],
				[
					108,
					17487
				],
				[
					7349,
					-68
				]
			],
			[
				[
					2123151,
					1800005
				],
				[
					-6300,
					-4778
				]
			],
			[
				[
					2116851,
					1795227
				],
				[
					-9410,
					4120
				]
			],
			[
				[
					2107441,
					1799347
				],
				[
					8214,
					6920
				],
				[
					4845,
					27492
				],
				[
					-3151,
					17540
				],
				[
					-12328,
					-693
				]
			],
			[
				[
					2105021,
					1850606
				],
				[
					-18714,
					-125
				]
			],
			[
				[
					2086307,
					1850481
				],
				[
					-3156,
					167
				]
			],
			[
				[
					2083151,
					1850648
				],
				[
					8505,
					25267
				],
				[
					-9054,
					20224
				],
				[
					-10401,
					7683
				],
				[
					-13122,
					-289
				]
			],
			[
				[
					2103229,
					1806191
				],
				[
					-4035,
					602
				]
			],
			[
				[
					2084716,
					1813577
				],
				[
					1329,
					1666
				]
			],
			[
				[
					2086045,
					1815243
				],
				[
					7390,
					1479
				],
				[
					9966,
					12445
				]
			],
			[
				[
					2103401,
					1829167
				],
				[
					-172,
					-22976
				]
			],
			[
				[
					2075840,
					1812799
				],
				[
					1267,
					8722
				]
			],
			[
				[
					2077107,
					1821521
				],
				[
					9478,
					2164
				],
				[
					-540,
					-8442
				]
			],
			[
				[
					2087132,
					1822060
				],
				[
					0,
					0
				]
			],
			[
				[
					2090647,
					1794212
				],
				[
					-10,
					-2560
				]
			],
			[
				[
					2090637,
					1791652
				],
				[
					-7508,
					-4440
				]
			],
			[
				[
					2083129,
					1787212
				],
				[
					-8619,
					5735
				]
			],
			[
				[
					2074510,
					1792947
				],
				[
					-30,
					1240
				]
			],
			[
				[
					2074480,
					1794187
				],
				[
					216,
					11514
				]
			],
			[
				[
					2090637,
					1791652
				],
				[
					32,
					-25636
				]
			],
			[
				[
					2090669,
					1766016
				],
				[
					-16379,
					-20
				]
			],
			[
				[
					2074290,
					1765996
				],
				[
					122,
					13971
				]
			],
			[
				[
					2074412,
					1779967
				],
				[
					8717,
					7245
				]
			],
			[
				[
					2074412,
					1779967
				],
				[
					98,
					12980
				]
			],
			[
				[
					2067908,
					1834396
				],
				[
					81,
					0
				]
			],
			[
				[
					2067989,
					1834396
				],
				[
					945,
					-9047
				]
			],
			[
				[
					2068934,
					1825349
				],
				[
					-568,
					-757
				]
			],
			[
				[
					2068366,
					1824592
				],
				[
					-8413,
					7593
				]
			],
			[
				[
					2059953,
					1832185
				],
				[
					5,
					316
				]
			],
			[
				[
					2059958,
					1832501
				],
				[
					7950,
					1895
				]
			],
			[
				[
					2068366,
					1824592
				],
				[
					-1968,
					-7078
				]
			],
			[
				[
					2066398,
					1817514
				],
				[
					-3704,
					-259
				]
			],
			[
				[
					2062694,
					1817255
				],
				[
					-3673,
					1243
				]
			],
			[
				[
					2059021,
					1818498
				],
				[
					-92,
					12
				]
			],
			[
				[
					2058929,
					1818510
				],
				[
					68,
					7366
				]
			],
			[
				[
					2058997,
					1825876
				],
				[
					57,
					6151
				]
			],
			[
				[
					2059054,
					1832027
				],
				[
					899,
					158
				]
			],
			[
				[
					2067908,
					1834396
				],
				[
					81,
					0
				]
			],
			[
				[
					2081467,
					1850201
				],
				[
					-12533,
					-24852
				]
			],
			[
				[
					2059958,
					1832501
				],
				[
					-1584,
					17785
				]
			],
			[
				[
					2058374,
					1850286
				],
				[
					23093,
					-85
				]
			],
			[
				[
					2138188,
					1766002
				],
				[
					-15866,
					24
				]
			],
			[
				[
					2118939,
					1786981
				],
				[
					-2088,
					8246
				]
			],
			[
				[
					2059054,
					1832027
				],
				[
					-8826,
					3302
				]
			],
			[
				[
					2050228,
					1835329
				],
				[
					131,
					561
				]
			],
			[
				[
					2050359,
					1835890
				],
				[
					-3121,
					5310
				],
				[
					6522,
					17040
				]
			],
			[
				[
					2053760,
					1858240
				],
				[
					4614,
					-7954
				]
			],
			[
				[
					2058997,
					1825876
				],
				[
					-9145,
					-460
				]
			],
			[
				[
					2049852,
					1825416
				],
				[
					-1691,
					953
				]
			],
			[
				[
					2048161,
					1826369
				],
				[
					2067,
					8960
				]
			],
			[
				[
					2058929,
					1818510
				],
				[
					-6621,
					74
				]
			],
			[
				[
					2052308,
					1818584
				],
				[
					-1874,
					4300
				]
			],
			[
				[
					2050434,
					1822884
				],
				[
					-582,
					2532
				]
			],
			[
				[
					2052308,
					1818584
				],
				[
					-3461,
					-5293
				]
			],
			[
				[
					2048847,
					1813291
				],
				[
					-2388,
					4999
				]
			],
			[
				[
					2046459,
					1818290
				],
				[
					3975,
					4594
				]
			],
			[
				[
					2048847,
					1813291
				],
				[
					-1899,
					-5079
				]
			],
			[
				[
					2046948,
					1808212
				],
				[
					-2187,
					-4209
				]
			],
			[
				[
					2044761,
					1804003
				],
				[
					-4021,
					1178
				]
			],
			[
				[
					2040740,
					1805181
				],
				[
					2350,
					6145
				]
			],
			[
				[
					2043090,
					1811326
				],
				[
					367,
					1634
				]
			],
			[
				[
					2043457,
					1812960
				],
				[
					-378,
					3216
				]
			],
			[
				[
					2043079,
					1816176
				],
				[
					3380,
					2114
				]
			],
			[
				[
					2043457,
					1812960
				],
				[
					-2138,
					2878
				]
			],
			[
				[
					2041319,
					1815838
				],
				[
					1760,
					338
				]
			],
			[
				[
					2043079,
					1816176
				],
				[
					1052,
					6709
				]
			],
			[
				[
					2044131,
					1822885
				],
				[
					4030,
					3484
				]
			],
			[
				[
					2062694,
					1817255
				],
				[
					-683,
					-12519
				]
			],
			[
				[
					2062011,
					1804736
				],
				[
					-3762,
					27
				]
			],
			[
				[
					2058249,
					1804763
				],
				[
					-571,
					3287
				]
			],
			[
				[
					2057678,
					1808050
				],
				[
					-4061,
					7845
				]
			],
			[
				[
					2053617,
					1815895
				],
				[
					5404,
					2603
				]
			],
			[
				[
					2062011,
					1804736
				],
				[
					1264,
					-6997
				],
				[
					11205,
					-3552
				]
			],
			[
				[
					2074290,
					1765996
				],
				[
					-12120,
					3280
				]
			],
			[
				[
					2062170,
					1769276
				],
				[
					1074,
					183
				]
			],
			[
				[
					2063244,
					1769459
				],
				[
					-1237,
					7874
				]
			],
			[
				[
					2062007,
					1777333
				],
				[
					-8995,
					2173
				]
			],
			[
				[
					2053012,
					1779506
				],
				[
					-2339,
					8016
				]
			],
			[
				[
					2050673,
					1787522
				],
				[
					-16,
					158
				]
			],
			[
				[
					2050657,
					1787680
				],
				[
					7609,
					6530
				]
			],
			[
				[
					2058266,
					1794210
				],
				[
					-17,
					10553
				]
			],
			[
				[
					2052885,
					1816779
				],
				[
					0,
					0
				]
			],
			[
				[
					2057678,
					1808050
				],
				[
					-4061,
					7845
				]
			],
			[
				[
					2058249,
					1804763
				],
				[
					-7561,
					71
				]
			],
			[
				[
					2050688,
					1804834
				],
				[
					-3740,
					3378
				]
			],
			[
				[
					2058266,
					1794210
				],
				[
					-7587,
					52
				]
			],
			[
				[
					2050679,
					1794262
				],
				[
					5,
					3544
				]
			],
			[
				[
					2050684,
					1797806
				],
				[
					4,
					7028
				]
			],
			[
				[
					2050657,
					1787680
				],
				[
					22,
					6582
				]
			],
			[
				[
					2086307,
					1850481
				],
				[
					-2850,
					-22994
				],
				[
					-6350,
					-5966
				]
			],
			[
				[
					2075840,
					1812799
				],
				[
					-9442,
					4715
				]
			],
			[
				[
					2081467,
					1850201
				],
				[
					1684,
					447
				]
			],
			[
				[
					2053012,
					1779506
				],
				[
					8995,
					-2173
				]
			],
			[
				[
					2063244,
					1769459
				],
				[
					-7495,
					1925
				]
			],
			[
				[
					2055749,
					1771384
				],
				[
					-2737,
					8122
				]
			],
			[
				[
					2062170,
					1769276
				],
				[
					-6421,
					2108
				]
			],
			[
				[
					2050684,
					1797806
				],
				[
					-4371,
					-11
				]
			],
			[
				[
					2046313,
					1797795
				],
				[
					-902,
					2714
				]
			],
			[
				[
					2045411,
					1800509
				],
				[
					-650,
					3494
				]
			],
			[
				[
					2050657,
					1787680
				],
				[
					-4344,
					10115
				]
			],
			[
				[
					2045644,
					1787400
				],
				[
					0,
					0
				]
			],
			[
				[
					2045411,
					1800509
				],
				[
					-13511,
					-3192
				]
			],
			[
				[
					2031900,
					1797317
				],
				[
					8434,
					7638
				]
			],
			[
				[
					2040334,
					1804955
				],
				[
					406,
					226
				]
			],
			[
				[
					2050673,
					1787522
				],
				[
					-12500,
					-6703
				]
			],
			[
				[
					2038173,
					1780819
				],
				[
					-8706,
					-980
				]
			],
			[
				[
					2029467,
					1779839
				],
				[
					-4979,
					-2341
				]
			],
			[
				[
					2024488,
					1777498
				],
				[
					-7820,
					16641
				]
			],
			[
				[
					2016668,
					1794139
				],
				[
					2017,
					-997
				]
			],
			[
				[
					2018685,
					1793142
				],
				[
					8656,
					-5935
				],
				[
					2394,
					7639
				]
			],
			[
				[
					2029735,
					1794846
				],
				[
					2165,
					2471
				]
			],
			[
				[
					2038173,
					1780819
				],
				[
					-7660,
					-14858
				]
			],
			[
				[
					2030513,
					1765961
				],
				[
					-1046,
					13878
				]
			],
			[
				[
					2030513,
					1765961
				],
				[
					-6025,
					11537
				]
			],
			[
				[
					2105021,
					1850606
				],
				[
					-1620,
					-21439
				]
			],
			[
				[
					2107441,
					1799347
				],
				[
					-4212,
					6844
				]
			],
			[
				[
					2099244,
					1800943
				],
				[
					213,
					-34935
				]
			],
			[
				[
					2099457,
					1766008
				],
				[
					-8788,
					8
				]
			],
			[
				[
					2103107,
					1766018
				],
				[
					-3650,
					-10
				]
			],
			[
				[
					2233648,
					1765470
				],
				[
					-65514,
					12
				]
			],
			[
				[
					2044131,
					1822885
				],
				[
					-1868,
					1055
				]
			],
			[
				[
					2042263,
					1823940
				],
				[
					-195,
					2665
				]
			],
			[
				[
					2042068,
					1826605
				],
				[
					2153,
					8959
				]
			],
			[
				[
					2044221,
					1835564
				],
				[
					6138,
					326
				]
			],
			[
				[
					2042068,
					1826605
				],
				[
					-2165,
					2023
				]
			],
			[
				[
					2039903,
					1828628
				],
				[
					-1914,
					7017
				]
			],
			[
				[
					2037989,
					1835645
				],
				[
					6232,
					-81
				]
			],
			[
				[
					2039903,
					1828628
				],
				[
					-4292,
					-179
				]
			],
			[
				[
					2035611,
					1828449
				],
				[
					9,
					2033
				]
			],
			[
				[
					2035620,
					1830482
				],
				[
					43,
					5782
				]
			],
			[
				[
					2035663,
					1836264
				],
				[
					2326,
					-619
				]
			],
			[
				[
					2041319,
					1815838
				],
				[
					127,
					3178
				]
			],
			[
				[
					2041446,
					1819016
				],
				[
					36,
					2879
				]
			],
			[
				[
					2041482,
					1821895
				],
				[
					781,
					2045
				]
			],
			[
				[
					2041482,
					1821895
				],
				[
					-5858,
					737
				]
			],
			[
				[
					2035624,
					1822632
				],
				[
					-10,
					3298
				]
			],
			[
				[
					2035614,
					1825930
				],
				[
					-3,
					2519
				]
			],
			[
				[
					2041446,
					1819016
				],
				[
					-4598,
					-10
				]
			],
			[
				[
					2036848,
					1819006
				],
				[
					-1230,
					2494
				]
			],
			[
				[
					2035618,
					1821500
				],
				[
					6,
					1132
				]
			],
			[
				[
					2043090,
					1811326
				],
				[
					-7433,
					2322
				]
			],
			[
				[
					2035657,
					1813648
				],
				[
					1191,
					5358
				]
			],
			[
				[
					2035620,
					1830482
				],
				[
					-3749,
					6
				]
			],
			[
				[
					2031871,
					1830488
				],
				[
					552,
					5760
				]
			],
			[
				[
					2032423,
					1836248
				],
				[
					3240,
					16
				]
			],
			[
				[
					2031871,
					1830488
				],
				[
					-2513,
					27
				]
			],
			[
				[
					2029358,
					1830515
				],
				[
					166,
					4281
				]
			],
			[
				[
					2029524,
					1834796
				],
				[
					2899,
					1452
				]
			],
			[
				[
					2035614,
					1825930
				],
				[
					-3745,
					-231
				]
			],
			[
				[
					2031869,
					1825699
				],
				[
					2,
					4789
				]
			],
			[
				[
					2031869,
					1825699
				],
				[
					-236,
					-2391
				]
			],
			[
				[
					2031633,
					1823308
				],
				[
					-1998,
					102
				]
			],
			[
				[
					2029635,
					1823410
				],
				[
					-166,
					3868
				]
			],
			[
				[
					2029469,
					1827278
				],
				[
					48,
					2424
				]
			],
			[
				[
					2029517,
					1829702
				],
				[
					-159,
					813
				]
			],
			[
				[
					2031633,
					1823308
				],
				[
					-42,
					-2505
				]
			],
			[
				[
					2031591,
					1820803
				],
				[
					298,
					-5969
				]
			],
			[
				[
					2031889,
					1814834
				],
				[
					-3938,
					154
				]
			],
			[
				[
					2027951,
					1814988
				],
				[
					1576,
					4820
				]
			],
			[
				[
					2029527,
					1819808
				],
				[
					92,
					3396
				]
			],
			[
				[
					2029619,
					1823204
				],
				[
					16,
					206
				]
			],
			[
				[
					2035618,
					1821500
				],
				[
					-4027,
					-697
				]
			],
			[
				[
					2035657,
					1813648
				],
				[
					-3768,
					1186
				]
			],
			[
				[
					2029469,
					1827278
				],
				[
					-3067,
					94
				]
			],
			[
				[
					2026402,
					1827372
				],
				[
					376,
					3930
				]
			],
			[
				[
					2026778,
					1831302
				],
				[
					2739,
					-1600
				]
			],
			[
				[
					2029619,
					1823204
				],
				[
					-3264,
					294
				]
			],
			[
				[
					2026355,
					1823498
				],
				[
					47,
					3874
				]
			],
			[
				[
					2029527,
					1819808
				],
				[
					-3233,
					112
				]
			],
			[
				[
					2026294,
					1819920
				],
				[
					61,
					3578
				]
			],
			[
				[
					2027951,
					1814988
				],
				[
					-2915,
					-344
				]
			],
			[
				[
					2025036,
					1814644
				],
				[
					66,
					4998
				]
			],
			[
				[
					2025102,
					1819642
				],
				[
					1192,
					278
				]
			],
			[
				[
					2025102,
					1819642
				],
				[
					7,
					357
				]
			],
			[
				[
					2025109,
					1819999
				],
				[
					181,
					10873
				]
			],
			[
				[
					2025290,
					1830872
				],
				[
					1339,
					434
				]
			],
			[
				[
					2026629,
					1831306
				],
				[
					149,
					-4
				]
			],
			[
				[
					2025109,
					1819999
				],
				[
					-1162,
					100
				]
			],
			[
				[
					2023947,
					1820099
				],
				[
					-133,
					3607
				]
			],
			[
				[
					2023814,
					1823706
				],
				[
					777,
					6374
				]
			],
			[
				[
					2024591,
					1830080
				],
				[
					699,
					792
				]
			],
			[
				[
					2026778,
					1831302
				],
				[
					-820,
					3164
				]
			],
			[
				[
					2025958,
					1834466
				],
				[
					20,
					66
				]
			],
			[
				[
					2025978,
					1834532
				],
				[
					3546,
					264
				]
			],
			[
				[
					2026629,
					1831306
				],
				[
					-1334,
					-87
				]
			],
			[
				[
					2025295,
					1831219
				],
				[
					-575,
					2119
				]
			],
			[
				[
					2024720,
					1833338
				],
				[
					303,
					110
				]
			],
			[
				[
					2025023,
					1833448
				],
				[
					935,
					1018
				]
			],
			[
				[
					2025023,
					1833448
				],
				[
					-419,
					47
				]
			],
			[
				[
					2024604,
					1833495
				],
				[
					-222,
					305
				]
			],
			[
				[
					2024382,
					1833800
				],
				[
					-236,
					1486
				]
			],
			[
				[
					2024146,
					1835286
				],
				[
					-198,
					343
				]
			],
			[
				[
					2023948,
					1835629
				],
				[
					2030,
					-1097
				]
			],
			[
				[
					2022014,
					1834152
				],
				[
					-31,
					-69
				]
			],
			[
				[
					2021983,
					1834083
				],
				[
					46,
					612
				]
			],
			[
				[
					2022029,
					1834695
				],
				[
					-15,
					-543
				]
			],
			[
				[
					2024382,
					1833800
				],
				[
					-1514,
					-1817
				]
			],
			[
				[
					2022868,
					1831983
				],
				[
					-528,
					1244
				]
			],
			[
				[
					2022340,
					1833227
				],
				[
					1806,
					2059
				]
			],
			[
				[
					2021639,
					1835382
				],
				[
					-31,
					5
				]
			],
			[
				[
					2021608,
					1835387
				],
				[
					31,
					-5
				]
			],
			[
				[
					2022340,
					1833227
				],
				[
					-357,
					856
				]
			],
			[
				[
					2021983,
					1834083
				],
				[
					31,
					69
				]
			],
			[
				[
					2022029,
					1834695
				],
				[
					-390,
					687
				]
			],
			[
				[
					2021608,
					1835387
				],
				[
					2340,
					242
				]
			],
			[
				[
					2023147,
					1831136
				],
				[
					1444,
					-1056
				]
			],
			[
				[
					2023814,
					1823706
				],
				[
					-1291,
					334
				]
			],
			[
				[
					2022523,
					1824040
				],
				[
					624,
					7096
				]
			],
			[
				[
					2020947,
					1825881
				],
				[
					0,
					0
				]
			],
			[
				[
					2022523,
					1824040
				],
				[
					-1611,
					-171
				]
			],
			[
				[
					2020912,
					1823869
				],
				[
					61,
					3401
				]
			],
			[
				[
					2020973,
					1827270
				],
				[
					-491,
					4260
				]
			],
			[
				[
					2020482,
					1831530
				],
				[
					2665,
					-394
				]
			],
			[
				[
					2020973,
					1827270
				],
				[
					-2845,
					368
				]
			],
			[
				[
					2018128,
					1827638
				],
				[
					1577,
					3931
				]
			],
			[
				[
					2019705,
					1831569
				],
				[
					777,
					-39
				]
			],
			[
				[
					2020912,
					1823869
				],
				[
					-1020,
					33
				]
			],
			[
				[
					2019892,
					1823902
				],
				[
					-1827,
					26
				]
			],
			[
				[
					2018065,
					1823928
				],
				[
					-161,
					3646
				]
			],
			[
				[
					2017904,
					1827574
				],
				[
					224,
					64
				]
			],
			[
				[
					2023947,
					1820099
				],
				[
					-4276,
					192
				]
			],
			[
				[
					2019671,
					1820291
				],
				[
					221,
					3611
				]
			],
			[
				[
					2019671,
					1820291
				],
				[
					-428,
					-3093
				]
			],
			[
				[
					2019243,
					1817198
				],
				[
					-6528,
					3476
				]
			],
			[
				[
					2012715,
					1820674
				],
				[
					2333,
					2043
				]
			],
			[
				[
					2015048,
					1822717
				],
				[
					3017,
					1211
				]
			],
			[
				[
					2025036,
					1814644
				],
				[
					-996,
					-904
				]
			],
			[
				[
					2024040,
					1813740
				],
				[
					-746,
					-384
				]
			],
			[
				[
					2023294,
					1813356
				],
				[
					-4051,
					3842
				]
			],
			[
				[
					2017904,
					1827574
				],
				[
					-3996,
					204
				]
			],
			[
				[
					2013908,
					1827778
				],
				[
					-951,
					4703
				]
			],
			[
				[
					2012957,
					1832481
				],
				[
					6748,
					-912
				]
			],
			[
				[
					2015048,
					1822717
				],
				[
					-1140,
					5061
				]
			],
			[
				[
					2008915,
					1824831
				],
				[
					-200,
					151
				]
			],
			[
				[
					2008715,
					1824982
				],
				[
					200,
					-151
				]
			],
			[
				[
					2012715,
					1820674
				],
				[
					-2313,
					3036
				]
			],
			[
				[
					2010402,
					1823710
				],
				[
					2555,
					8771
				]
			],
			[
				[
					2053760,
					1858240
				],
				[
					-2167,
					7186
				]
			],
			[
				[
					2051593,
					1865426
				],
				[
					-7532,
					-1204
				]
			],
			[
				[
					2044061,
					1864222
				],
				[
					-3848,
					-136
				]
			],
			[
				[
					2040213,
					1864086
				],
				[
					-5909,
					-289
				]
			],
			[
				[
					2034304,
					1863797
				],
				[
					-900,
					-21
				]
			],
			[
				[
					2033404,
					1863776
				],
				[
					-9135,
					-325
				]
			],
			[
				[
					2024269,
					1863451
				],
				[
					-2094,
					71
				]
			],
			[
				[
					2040334,
					1804955
				],
				[
					-11890,
					1605
				]
			],
			[
				[
					2028444,
					1806560
				],
				[
					-27,
					0
				]
			],
			[
				[
					2028417,
					1806560
				],
				[
					-4377,
					7180
				]
			],
			[
				[
					2029735,
					1794846
				],
				[
					-1289,
					2815
				]
			],
			[
				[
					2028446,
					1797661
				],
				[
					-2,
					8899
				]
			],
			[
				[
					2028417,
					1806560
				],
				[
					-6852,
					-56
				]
			],
			[
				[
					2021565,
					1806504
				],
				[
					-111,
					2069
				]
			],
			[
				[
					2021454,
					1808573
				],
				[
					1840,
					4783
				]
			],
			[
				[
					2028446,
					1797661
				],
				[
					-6896,
					3198
				]
			],
			[
				[
					2021550,
					1800859
				],
				[
					1,
					378
				]
			],
			[
				[
					2021551,
					1801237
				],
				[
					14,
					5267
				]
			],
			[
				[
					2024604,
					1833495
				],
				[
					116,
					-157
				]
			],
			[
				[
					2025295,
					1831219
				],
				[
					-2427,
					764
				]
			],
			[
				[
					2018685,
					1793142
				],
				[
					2865,
					7717
				]
			],
			[
				[
					2008915,
					1824831
				],
				[
					1487,
					-1121
				]
			],
			[
				[
					2021454,
					1808573
				],
				[
					-5088,
					-568
				]
			],
			[
				[
					2016366,
					1808005
				],
				[
					-7651,
					16977
				]
			],
			[
				[
					2021551,
					1801237
				],
				[
					-5368,
					3
				]
			],
			[
				[
					2016183,
					1801240
				],
				[
					183,
					6765
				]
			],
			[
				[
					2016668,
					1794139
				],
				[
					-485,
					7101
				]
			],
			[
				[
					2051593,
					1865426
				],
				[
					-1046,
					-12766
				],
				[
					-8816,
					-14070
				]
			],
			[
				[
					2041731,
					1838590
				],
				[
					2330,
					25632
				]
			],
			[
				[
					2041731,
					1838590
				],
				[
					-6290,
					-357
				]
			],
			[
				[
					2035441,
					1838233
				],
				[
					4772,
					25853
				]
			],
			[
				[
					2035441,
					1838233
				],
				[
					-1541,
					-831
				]
			],
			[
				[
					2033900,
					1837402
				],
				[
					-1685,
					7406
				]
			],
			[
				[
					2032215,
					1844808
				],
				[
					51,
					57
				]
			],
			[
				[
					2032266,
					1844865
				],
				[
					2038,
					18932
				]
			],
			[
				[
					2032266,
					1844865
				],
				[
					1171,
					7936
				]
			],
			[
				[
					2033437,
					1852801
				],
				[
					-33,
					10975
				]
			],
			[
				[
					2033900,
					1837402
				],
				[
					-4845,
					2915
				]
			],
			[
				[
					2029055,
					1840317
				],
				[
					1067,
					4810
				]
			],
			[
				[
					2030122,
					1845127
				],
				[
					2093,
					-319
				]
			],
			[
				[
					2029055,
					1840317
				],
				[
					-1163,
					722
				]
			],
			[
				[
					2027892,
					1841039
				],
				[
					18,
					4500
				]
			],
			[
				[
					2027910,
					1845539
				],
				[
					2212,
					-412
				]
			],
			[
				[
					2027910,
					1845539
				],
				[
					2,
					52
				]
			],
			[
				[
					2027912,
					1845591
				],
				[
					5525,
					7210
				]
			],
			[
				[
					2027892,
					1841039
				],
				[
					-5140,
					887
				]
			],
			[
				[
					2022752,
					1841926
				],
				[
					-47,
					766
				]
			],
			[
				[
					2022705,
					1842692
				],
				[
					-980,
					529
				]
			],
			[
				[
					2021725,
					1843221
				],
				[
					3195,
					2478
				]
			],
			[
				[
					2024920,
					1845699
				],
				[
					2992,
					-108
				]
			],
			[
				[
					2024920,
					1845699
				],
				[
					-651,
					17752
				]
			],
			[
				[
					2024920,
					1845699
				],
				[
					-4235,
					2518
				]
			],
			[
				[
					2020685,
					1848217
				],
				[
					-9334,
					1425
				]
			],
			[
				[
					2011351,
					1849642
				],
				[
					-394,
					14270
				]
			],
			[
				[
					2022752,
					1841926
				],
				[
					-47,
					766
				]
			],
			[
				[
					2021725,
					1843221
				],
				[
					-1435,
					1029
				]
			],
			[
				[
					2020290,
					1844250
				],
				[
					395,
					3967
				]
			],
			[
				[
					2020290,
					1844250
				],
				[
					-9309,
					2991
				]
			],
			[
				[
					2010981,
					1847241
				],
				[
					370,
					2401
				]
			],
			[
				[
					2010981,
					1847241
				],
				[
					-5908,
					8153
				],
				[
					6171,
					18333
				]
			],
			[
				[
					1843461,
					2006761
				],
				[
					5314,
					-8745
				]
			],
			[
				[
					1920628,
					1989563
				],
				[
					-4386,
					-31246
				],
				[
					-24633,
					-8894
				],
				[
					-11340,
					925
				],
				[
					-14682,
					9150
				],
				[
					-3372,
					16298
				],
				[
					-20801,
					21689
				]
			],
			[
				[
					2013640,
					1919549
				],
				[
					-4675,
					3377
				]
			],
			[
				[
					1398810,
					2970337
				],
				[
					-4570,
					1735
				],
				[
					-4230,
					-19156
				],
				[
					-6740,
					-4977
				],
				[
					-13255,
					-24875
				]
			],
			[
				[
					1370015,
					2923064
				],
				[
					-73,
					32493
				],
				[
					13881,
					-16
				],
				[
					6674,
					7155
				],
				[
					111,
					34966
				],
				[
					21193,
					-115
				],
				[
					-93,
					-27282
				],
				[
					-12898,
					72
				]
			],
			[
				[
					1395199,
					2606061
				],
				[
					6619,
					-6042
				],
				[
					877,
					-31405
				],
				[
					-5333,
					-12139
				],
				[
					-7675,
					8444
				],
				[
					-4402,
					25047
				],
				[
					1125,
					13443
				],
				[
					8789,
					2652
				]
			],
			[
				[
					1423284,
					2620497
				],
				[
					17966,
					-6489
				],
				[
					93,
					-6845
				],
				[
					-16163,
					-6458
				],
				[
					-1896,
					19792
				]
			],
			[
				[
					1414283,
					2628739
				],
				[
					5624,
					-25322
				],
				[
					-6227,
					-10143
				],
				[
					-21877,
					19236
				],
				[
					755,
					-7044
				],
				[
					-12203,
					10044
				],
				[
					220,
					8338
				],
				[
					12017,
					-5968
				],
				[
					-4778,
					14952
				],
				[
					18783,
					705
				],
				[
					3950,
					19028
				],
				[
					2956,
					-18387
				]
			],
			[
				[
					1429403,
					2682688
				],
				[
					10695,
					-29823
				],
				[
					-757,
					-37611
				],
				[
					-16706,
					6020
				],
				[
					1144,
					35286
				],
				[
					-2159,
					14131
				],
				[
					7783,
					11997
				]
			],
			[
				[
					1328459,
					2688638
				],
				[
					18253,
					-20217
				],
				[
					20478,
					-31149
				],
				[
					-293,
					-22695
				],
				[
					-4158,
					-15394
				],
				[
					-5795,
					17935
				],
				[
					-7127,
					-1380
				],
				[
					-4985,
					18941
				],
				[
					-10314,
					8750
				],
				[
					-9533,
					29440
				],
				[
					3474,
					15769
				]
			],
			[
				[
					1455953,
					2683737
				],
				[
					-2884,
					-19982
				],
				[
					-8671,
					-29690
				],
				[
					-4943,
					-2033
				],
				[
					2530,
					19722
				],
				[
					-7681,
					26632
				],
				[
					21649,
					5351
				]
			],
			[
				[
					1416250,
					2698851
				],
				[
					3697,
					-6208
				],
				[
					-1096,
					-32955
				],
				[
					-3418,
					-15670
				],
				[
					-4881,
					12292
				],
				[
					5698,
					42541
				]
			],
			[
				[
					1287520,
					2735589
				],
				[
					11007,
					-12054
				],
				[
					-2822,
					-5107
				],
				[
					-8185,
					17161
				]
			],
			[
				[
					1281904,
					2762937
				],
				[
					9491,
					-12633
				],
				[
					-2550,
					-7767
				],
				[
					-12287,
					6558
				],
				[
					-2210,
					11110
				],
				[
					7556,
					2732
				]
			],
			[
				[
					1304361,
					2776301
				],
				[
					10396,
					-24296
				],
				[
					8969,
					-10145
				],
				[
					2069,
					-17888
				],
				[
					-4962,
					-2542
				],
				[
					-10166,
					13138
				],
				[
					-11717,
					29297
				],
				[
					5411,
					12436
				]
			],
			[
				[
					1356254,
					2804334
				],
				[
					13521,
					-1755
				],
				[
					4423,
					-9713
				],
				[
					20886,
					-23157
				],
				[
					5437,
					-1479
				],
				[
					11121,
					-31179
				],
				[
					-184,
					-34676
				],
				[
					-5901,
					-66427
				],
				[
					-18317,
					-1970
				],
				[
					-266,
					30380
				],
				[
					4135,
					37755
				],
				[
					-7818,
					-31430
				],
				[
					3054,
					-20209
				],
				[
					-5006,
					6140
				],
				[
					-9866,
					-9425
				],
				[
					-12248,
					10618
				],
				[
					-12517,
					23704
				],
				[
					-1450,
					24636
				],
				[
					-7883,
					12075
				],
				[
					3424,
					26819
				],
				[
					9433,
					8753
				],
				[
					-1163,
					22585
				],
				[
					6159,
					3048
				],
				[
					-6530,
					20345
				],
				[
					7556,
					4562
				]
			],
			[
				[
					1329263,
					2809321
				],
				[
					10775,
					-10338
				],
				[
					91,
					-32329
				],
				[
					3552,
					-7727
				],
				[
					-13042,
					-7293
				],
				[
					-8047,
					5822
				],
				[
					-1978,
					23249
				],
				[
					9934,
					14669
				],
				[
					-1285,
					13947
				]
			],
			[
				[
					1358435,
					2858314
				],
				[
					10104,
					-32102
				],
				[
					-853,
					-16702
				],
				[
					-22319,
					-3727
				],
				[
					-3135,
					6135
				],
				[
					11264,
					27143
				],
				[
					4939,
					19253
				]
			],
			[
				[
					1373980,
					2903307
				],
				[
					-1989,
					-37897
				],
				[
					-6909,
					5445
				],
				[
					-17207,
					-21667
				],
				[
					2547,
					-9430
				],
				[
					-11490,
					-4308
				],
				[
					118,
					44176
				],
				[
					10339,
					12931
				],
				[
					24591,
					10750
				]
			],
			[
				[
					1373897,
					2917746
				],
				[
					-7068,
					-15827
				],
				[
					-13555,
					-7438
				],
				[
					-2819,
					4678
				],
				[
					23442,
					18587
				]
			],
			[
				[
					1450407,
					2605839
				],
				[
					-5814,
					12569
				],
				[
					15273,
					54003
				],
				[
					-5296,
					24261
				],
				[
					-12791,
					-15274
				],
				[
					-18020,
					4248
				],
				[
					-7480,
					16718
				],
				[
					-1576,
					29736
				],
				[
					-7573,
					29242
				],
				[
					-30303,
					33612
				],
				[
					-4693,
					10357
				],
				[
					363,
					24255
				],
				[
					-9902,
					20547
				],
				[
					1218,
					12916
				],
				[
					10675,
					-4802
				],
				[
					5620,
					9447
				],
				[
					6846,
					-20378
				],
				[
					11352,
					-2275
				],
				[
					15656,
					-19557
				],
				[
					-7684,
					20058
				],
				[
					-11319,
					5969
				],
				[
					-15712,
					28730
				],
				[
					5085,
					21931
				],
				[
					-3105,
					13947
				],
				[
					14578,
					19916
				],
				[
					16620,
					-4680
				],
				[
					-20426,
					12348
				],
				[
					6755,
					18420
				]
			],
			[
				[
					1398891,
					2966712
				],
				[
					-81,
					3625
				]
			],
			[
				[
					1370015,
					2923064
				],
				[
					-24982,
					-21526
				],
				[
					-11649,
					-18905
				]
			],
			[
				[
					1317505,
					3045460
				],
				[
					44,
					12157
				],
				[
					-11827,
					2828
				],
				[
					-5587,
					16964
				],
				[
					-14553,
					11739
				],
				[
					-3787,
					25945
				],
				[
					13431,
					9852
				],
				[
					10618,
					-4084
				],
				[
					1204,
					10038
				]
			],
			[
				[
					1212906,
					3027520
				],
				[
					1157,
					119
				]
			],
			[
				[
					1197043,
					3050947
				],
				[
					8230,
					-17746
				],
				[
					-12420,
					12039
				],
				[
					4190,
					5707
				]
			],
			[
				[
					1208834,
					3028986
				],
				[
					-1999,
					15829
				],
				[
					7326,
					7445
				],
				[
					2872,
					-19174
				],
				[
					-6695,
					-3717
				]
			],
			[
				[
					1164288,
					3071085
				],
				[
					1631,
					-11672
				],
				[
					-9294,
					3199
				],
				[
					7663,
					8473
				]
			],
			[
				[
					1191345,
					3074799
				],
				[
					710,
					3349
				]
			],
			[
				[
					1201025,
					3084510
				],
				[
					-310,
					245
				]
			],
			[
				[
					1145152,
					3124752
				],
				[
					3540,
					-6709
				],
				[
					10097,
					4737
				],
				[
					1774,
					-13666
				],
				[
					-21365,
					-24572
				],
				[
					-2717,
					19899
				],
				[
					8671,
					20311
				]
			],
			[
				[
					1203770,
					3138936
				],
				[
					-316,
					-101
				]
			],
			[
				[
					1225075,
					3031580
				],
				[
					-10,
					7
				]
			],
			[
				[
					1224393,
					3032735
				],
				[
					-7,
					232
				]
			],
			[
				[
					1224373,
					3033396
				],
				[
					-8847,
					21193
				],
				[
					-11254,
					-5922
				],
				[
					-10068,
					3939
				],
				[
					-1873,
					19042
				]
			],
			[
				[
					1197741,
					3106616
				],
				[
					5332,
					-738
				],
				[
					-5454,
					19476
				],
				[
					10225,
					-13359
				],
				[
					8620,
					-21078
				],
				[
					16805,
					-23965
				],
				[
					-19846,
					42991
				],
				[
					-11412,
					13981
				],
				[
					2581,
					11732
				],
				[
					23776,
					7029
				],
				[
					10711,
					-16764
				],
				[
					-2051,
					12152
				],
				[
					-15216,
					8705
				]
			],
			[
				[
					1970960,
					1752176
				],
				[
					19570,
					-23119
				],
				[
					-8783,
					322
				],
				[
					15064,
					-18103
				],
				[
					-14790,
					-14641
				],
				[
					-7394,
					12614
				],
				[
					1668,
					24233
				],
				[
					-5335,
					18694
				]
			],
			[
				[
					1993198,
					1671900
				],
				[
					-9024,
					128
				]
			],
			[
				[
					1984174,
					1672028
				],
				[
					234,
					19965
				],
				[
					8327,
					-1625
				],
				[
					463,
					-18468
				]
			],
			[
				[
					1993198,
					1671900
				],
				[
					3746,
					-14907
				]
			],
			[
				[
					1996944,
					1656993
				],
				[
					-3095,
					952
				]
			],
			[
				[
					1993849,
					1657945
				],
				[
					-2006,
					-875
				]
			],
			[
				[
					1991843,
					1657070
				],
				[
					-6094,
					2037
				]
			],
			[
				[
					1985749,
					1659107
				],
				[
					-1575,
					12921
				]
			],
			[
				[
					2004483,
					1634213
				],
				[
					-202,
					177
				]
			],
			[
				[
					2004281,
					1634390
				],
				[
					-5245,
					3676
				]
			],
			[
				[
					1999036,
					1638066
				],
				[
					318,
					7377
				]
			],
			[
				[
					1999354,
					1645443
				],
				[
					31,
					210
				]
			],
			[
				[
					1999385,
					1645653
				],
				[
					5098,
					-11440
				]
			],
			[
				[
					2004281,
					1634390
				],
				[
					-3617,
					-2571
				]
			],
			[
				[
					2000664,
					1631819
				],
				[
					-1991,
					618
				]
			],
			[
				[
					1998673,
					1632437
				],
				[
					363,
					5629
				]
			],
			[
				[
					2004483,
					1634213
				],
				[
					-923,
					-7119
				]
			],
			[
				[
					2003560,
					1627094
				],
				[
					-4365,
					-230
				]
			],
			[
				[
					1999195,
					1626864
				],
				[
					12,
					335
				]
			],
			[
				[
					1999207,
					1627199
				],
				[
					1457,
					4620
				]
			],
			[
				[
					2003560,
					1627094
				],
				[
					-5049,
					-5028
				]
			],
			[
				[
					1998511,
					1622066
				],
				[
					684,
					4798
				]
			],
			[
				[
					1999207,
					1627199
				],
				[
					-1540,
					309
				]
			],
			[
				[
					1997667,
					1627508
				],
				[
					-1091,
					1453
				]
			],
			[
				[
					1996576,
					1628961
				],
				[
					-1009,
					86
				]
			],
			[
				[
					1995567,
					1629047
				],
				[
					70,
					2689
				]
			],
			[
				[
					1995637,
					1631736
				],
				[
					808,
					579
				]
			],
			[
				[
					1996445,
					1632315
				],
				[
					2228,
					122
				]
			],
			[
				[
					1998511,
					1622066
				],
				[
					-2190,
					3784
				]
			],
			[
				[
					1996321,
					1625850
				],
				[
					1346,
					1658
				]
			],
			[
				[
					1996321,
					1625850
				],
				[
					255,
					3111
				]
			],
			[
				[
					1996445,
					1632315
				],
				[
					-1722,
					12266
				]
			],
			[
				[
					1994723,
					1644581
				],
				[
					4631,
					862
				]
			],
			[
				[
					1996944,
					1656993
				],
				[
					2441,
					-11340
				]
			],
			[
				[
					1994723,
					1644581
				],
				[
					-874,
					13364
				]
			],
			[
				[
					1995637,
					1631736
				],
				[
					-3895,
					3334
				]
			],
			[
				[
					1991742,
					1635070
				],
				[
					-1818,
					252
				]
			],
			[
				[
					1989924,
					1635322
				],
				[
					-1176,
					1436
				]
			],
			[
				[
					1988748,
					1636758
				],
				[
					3095,
					20312
				]
			],
			[
				[
					1990360,
					1633224
				],
				[
					-1150,
					-453
				]
			],
			[
				[
					1989210,
					1632771
				],
				[
					1150,
					453
				]
			],
			[
				[
					1995567,
					1629047
				],
				[
					-3825,
					6023
				]
			],
			[
				[
					1989924,
					1635322
				],
				[
					436,
					-2098
				]
			],
			[
				[
					1989210,
					1632771
				],
				[
					-2868,
					1456
				]
			],
			[
				[
					1986342,
					1634227
				],
				[
					-13071,
					-6982
				]
			],
			[
				[
					1973271,
					1627245
				],
				[
					1666,
					6320
				],
				[
					-10440,
					11457
				]
			],
			[
				[
					1976288,
					1646830
				],
				[
					4843,
					11593
				]
			],
			[
				[
					1981086,
					1658496
				],
				[
					205,
					471
				]
			],
			[
				[
					1981291,
					1658967
				],
				[
					7457,
					-22209
				]
			],
			[
				[
					1971679,
					1606836
				],
				[
					-6437,
					19764
				],
				[
					8029,
					645
				]
			],
			[
				[
					1986342,
					1634227
				],
				[
					-3355,
					-14476
				],
				[
					-11308,
					-12915
				]
			],
			[
				[
					1981291,
					1658967
				],
				[
					4458,
					140
				]
			],
			[
				[
					1958039,
					1785094
				],
				[
					0,
					0
				]
			],
			[
				[
					1949560,
					1784272
				],
				[
					4137,
					-8692
				],
				[
					-11705,
					-3194
				],
				[
					11326,
					-17899
				]
			],
			[
				[
					1923978,
					1765364
				],
				[
					-2895,
					6338
				],
				[
					17042,
					-415
				],
				[
					3936,
					16754
				],
				[
					7499,
					-3769
				]
			],
			[
				[
					1960321,
					1787902
				],
				[
					-2049,
					4200
				]
			],
			[
				[
					1962076,
					1792152
				],
				[
					319,
					-3925
				]
			],
			[
				[
					1783767,
					2005918
				],
				[
					0,
					0
				]
			],
			[
				[
					1775203,
					2033487
				],
				[
					11082,
					-38437
				],
				[
					3419,
					-316
				]
			],
			[
				[
					1789704,
					1994734
				],
				[
					9196,
					-18802
				]
			],
			[
				[
					1798900,
					1975932
				],
				[
					-12412,
					5832
				],
				[
					-15735,
					-16803
				],
				[
					-13672,
					115
				],
				[
					-7620,
					-10201
				],
				[
					6989,
					-10705
				],
				[
					-2540,
					-7382
				],
				[
					9900,
					-16406
				]
			],
			[
				[
					1763810,
					1920382
				],
				[
					5278,
					-22748
				],
				[
					-5714,
					1884
				],
				[
					-7888,
					-18705
				],
				[
					-7605,
					4844
				]
			],
			[
				[
					1709245,
					2006585
				],
				[
					25091,
					-30
				],
				[
					4150,
					-8790
				],
				[
					13561,
					-1750
				],
				[
					17079,
					7305
				],
				[
					-2186,
					14255
				],
				[
					-12173,
					6471
				],
				[
					-2251,
					18305
				],
				[
					2970,
					9213
				],
				[
					-11642,
					14840
				],
				[
					-13740,
					1959
				]
			],
			[
				[
					1716529,
					2098866
				],
				[
					13955,
					-6162
				],
				[
					15963,
					2803
				],
				[
					15066,
					-8236
				],
				[
					9924,
					-49130
				],
				[
					3766,
					-4654
				]
			],
			[
				[
					1748656,
					1987239
				],
				[
					11061,
					-282
				],
				[
					-8819,
					7365
				],
				[
					-2242,
					-7083
				]
			],
			[
				[
					1798900,
					1975932
				],
				[
					5779,
					-7857
				]
			],
			[
				[
					1811255,
					1957010
				],
				[
					7347,
					-10342
				]
			],
			[
				[
					1818602,
					1946668
				],
				[
					700,
					-2469
				]
			],
			[
				[
					1819302,
					1944199
				],
				[
					-13561,
					-14734
				]
			],
			[
				[
					1805741,
					1929465
				],
				[
					0,
					0
				]
			],
			[
				[
					1805741,
					1929465
				],
				[
					-4306,
					-7584
				]
			],
			[
				[
					1792205,
					1884053
				],
				[
					-6644,
					-137
				],
				[
					-21751,
					36466
				]
			],
			[
				[
					1892512,
					1820065
				],
				[
					-4959,
					-10790
				]
			],
			[
				[
					1887553,
					1809275
				],
				[
					-11348,
					6244
				]
			],
			[
				[
					1852713,
					1866845
				],
				[
					6833,
					-9113
				],
				[
					22122,
					-6729
				]
			],
			[
				[
					1881668,
					1851003
				],
				[
					160,
					-9084
				]
			],
			[
				[
					1863712,
					1827464
				],
				[
					-13474,
					5889
				],
				[
					-1451,
					-8105
				]
			],
			[
				[
					1848787,
					1825248
				],
				[
					-8196,
					6678
				],
				[
					-24960,
					38084
				]
			],
			[
				[
					1966248,
					1707462
				],
				[
					386,
					15
				]
			],
			[
				[
					1972069,
					1723707
				],
				[
					524,
					-14149
				],
				[
					-7223,
					-2141
				]
			],
			[
				[
					1817657,
					1928061
				],
				[
					1645,
					16138
				]
			],
			[
				[
					1818602,
					1946668
				],
				[
					9289,
					-12079
				],
				[
					-10234,
					-6528
				]
			],
			[
				[
					1819476,
					1921201
				],
				[
					4958,
					-10924
				]
			],
			[
				[
					1817657,
					1928061
				],
				[
					327,
					-5955
				]
			],
			[
				[
					1915879,
					1813518
				],
				[
					46,
					-4338
				]
			],
			[
				[
					1915925,
					1809180
				],
				[
					-2,
					-2665
				]
			],
			[
				[
					1915923,
					1806515
				],
				[
					-36,
					-21217
				],
				[
					-10635,
					6070
				],
				[
					-10111,
					-1889
				],
				[
					-7588,
					19796
				]
			],
			[
				[
					1881668,
					1851003
				],
				[
					31168,
					-20363
				],
				[
					-3888,
					-4365
				]
			],
			[
				[
					1931675,
					1806889
				],
				[
					103,
					44
				]
			],
			[
				[
					1931778,
					1806933
				],
				[
					-103,
					-44
				]
			],
			[
				[
					1924876,
					1810924
				],
				[
					6617,
					-3826
				]
			],
			[
				[
					1931493,
					1807098
				],
				[
					5444,
					-8255
				]
			],
			[
				[
					1936937,
					1798843
				],
				[
					724,
					-4602
				],
				[
					-21738,
					12274
				]
			],
			[
				[
					1915925,
					1809180
				],
				[
					8951,
					1744
				]
			],
			[
				[
					1931675,
					1806889
				],
				[
					-182,
					209
				]
			],
			[
				[
					1924876,
					1810924
				],
				[
					3725,
					4242
				]
			],
			[
				[
					1928601,
					1815166
				],
				[
					3177,
					-8233
				]
			],
			[
				[
					1931793,
					1819819
				],
				[
					-8,
					30
				]
			],
			[
				[
					1931785,
					1819849
				],
				[
					8,
					-30
				]
			],
			[
				[
					1918888,
					1822718
				],
				[
					9439,
					-453
				]
			],
			[
				[
					1928327,
					1822265
				],
				[
					274,
					-7099
				]
			],
			[
				[
					1931785,
					1819849
				],
				[
					8,
					-30
				]
			],
			[
				[
					1918685,
					1825576
				],
				[
					9642,
					-3311
				]
			],
			[
				[
					1775203,
					2033487
				],
				[
					6127,
					-10078
				],
				[
					8374,
					-28675
				]
			],
			[
				[
					1936937,
					1798843
				],
				[
					8608,
					-552
				],
				[
					4015,
					-14019
				]
			],
			[
				[
					1870646,
					1782769
				],
				[
					-4748,
					1020
				],
				[
					-4151,
					19965
				],
				[
					-15646,
					3934
				],
				[
					2686,
					17560
				]
			],
			[
				[
					1835362,
					1799386
				],
				[
					-2093,
					1348
				]
			],
			[
				[
					1971679,
					1606836
				],
				[
					-5689,
					-6287
				],
				[
					-14551,
					13284
				],
				[
					-6254,
					-3459
				],
				[
					-26276,
					15631
				]
			],
			[
				[
					1993153,
					4469808
				],
				[
					-11340,
					5350
				],
				[
					17714,
					19773
				],
				[
					9079,
					-7648
				],
				[
					-15453,
					-17475
				]
			],
			[
				[
					3137062,
					5045566
				],
				[
					16835,
					-46183
				],
				[
					-119320,
					-42280
				],
				[
					-15888,
					42919
				],
				[
					-20933,
					-12
				],
				[
					43,
					21968
				],
				[
					9746,
					63
				],
				[
					-3316,
					19876
				],
				[
					118541,
					42359
				],
				[
					14292,
					-38710
				]
			],
			[
				[
					3664341,
					4419017
				],
				[
					-2202,
					5592
				],
				[
					-214557,
					240369
				],
				[
					15456,
					42835
				],
				[
					3102,
					27851
				],
				[
					10428,
					30589
				],
				[
					3732,
					26607
				],
				[
					41343,
					24974
				],
				[
					698,
					9196
				],
				[
					-325070,
					-228
				],
				[
					-234643,
					-1795
				],
				[
					29179,
					9718
				],
				[
					114089,
					60133
				],
				[
					40848,
					4824
				],
				[
					5485,
					6812
				],
				[
					17090,
					-2342
				],
				[
					21051,
					7417
				],
				[
					45316,
					9140
				],
				[
					23257,
					21582
				],
				[
					12892,
					16842
				],
				[
					30050,
					24971
				],
				[
					11393,
					5892
				],
				[
					9845,
					27741
				],
				[
					14594,
					23724
				],
				[
					5822,
					22936
				],
				[
					13566,
					6912
				],
				[
					12954,
					20391
				],
				[
					18545,
					13660
				],
				[
					47528,
					17103
				],
				[
					45119,
					2043
				],
				[
					63874,
					-7644
				],
				[
					18704,
					-12406
				],
				[
					58132,
					-11857
				],
				[
					257694,
					-6857
				],
				[
					190024,
					-18891
				],
				[
					344196,
					-29694
				]
			],
			[
				[
					4413875,
					5037157
				],
				[
					0,
					-618154
				]
			],
			[
				[
					3420756,
					4997493
				],
				[
					3994,
					-12547
				],
				[
					19287,
					5888
				],
				[
					-4844,
					15564
				],
				[
					-18437,
					-8905
				]
			],
			[
				[
					682346,
					4419006
				],
				[
					10,
					46700
				],
				[
					28331,
					10790
				]
			],
			[
				[
					710687,
					4476496
				],
				[
					-2241,
					-20531
				],
				[
					9219,
					16
				],
				[
					3333,
					13470
				],
				[
					21205,
					12783
				],
				[
					27971,
					30215
				],
				[
					36997,
					29985
				],
				[
					-36517,
					40441
				]
			],
			[
				[
					770654,
					4582875
				],
				[
					-30119,
					33827
				],
				[
					-20880,
					28799
				],
				[
					-8544,
					47954
				],
				[
					-13965,
					17329
				],
				[
					-14967,
					9522
				],
				[
					-18749,
					5065
				],
				[
					-33641,
					-6960
				]
			],
			[
				[
					629789,
					4718411
				],
				[
					-25009,
					29625
				],
				[
					-10862,
					20000
				],
				[
					-17982,
					61181
				],
				[
					-18960,
					34061
				],
				[
					-18576,
					42716
				],
				[
					-2388,
					11755
				],
				[
					14170,
					11248
				],
				[
					-15810,
					7789
				],
				[
					3437,
					10489
				],
				[
					-8985,
					20009
				],
				[
					3142,
					10907
				],
				[
					-33087,
					24254
				],
				[
					-28302,
					44316
				],
				[
					18632,
					30459
				],
				[
					20336,
					16228
				],
				[
					-3354,
					10237
				],
				[
					6202,
					39010
				],
				[
					110419,
					0
				],
				[
					164029,
					0
				],
				[
					121609,
					0
				],
				[
					111709,
					0
				],
				[
					0,
					398745
				]
			],
			[
				[
					1020159,
					5541440
				],
				[
					7003,
					-15105
				],
				[
					14899,
					-13608
				],
				[
					13772,
					-3030
				],
				[
					974,
					-8651
				],
				[
					-16835,
					-14669
				],
				[
					-3784,
					-10476
				],
				[
					20587,
					-984
				],
				[
					5974,
					-5676
				],
				[
					19512,
					9215
				],
				[
					2157,
					11111
				],
				[
					15434,
					2137
				],
				[
					16762,
					-10371
				],
				[
					13658,
					-23905
				],
				[
					9350,
					-28686
				],
				[
					8275,
					-28
				],
				[
					-9570,
					-17451
				],
				[
					9624,
					-19645
				],
				[
					16631,
					-1284
				],
				[
					-5925,
					-12137
				],
				[
					37648,
					-20531
				],
				[
					11712,
					-18783
				],
				[
					13664,
					13519
				],
				[
					12354,
					-7214
				],
				[
					921,
					-20562
				],
				[
					-26973,
					-15269
				],
				[
					8035,
					-11120
				],
				[
					22186,
					9187
				],
				[
					-1001,
					-18054
				],
				[
					13451,
					428
				],
				[
					20083,
					-39521
				],
				[
					-10113,
					2777
				],
				[
					917,
					-21810
				],
				[
					-31567,
					-18884
				],
				[
					-1414,
					-11201
				],
				[
					12329,
					2411
				],
				[
					15644,
					-14534
				],
				[
					19206,
					-31744
				],
				[
					14423,
					3024
				],
				[
					2786,
					-7449
				],
				[
					-17497,
					-49162
				],
				[
					8824,
					-5830
				],
				[
					11149,
					-32089
				],
				[
					9217,
					-4524
				],
				[
					318,
					-26860
				],
				[
					10798,
					4878
				],
				[
					7091,
					-11265
				],
				[
					18619,
					-11093
				],
				[
					-14160,
					-19033
				],
				[
					10787,
					-9207
				],
				[
					-7555,
					-8105
				],
				[
					-1514,
					-16879
				],
				[
					12030,
					-13030
				],
				[
					-8362,
					-12763
				],
				[
					12260,
					-12449
				],
				[
					20838,
					4735
				],
				[
					24243,
					-18320
				],
				[
					6937,
					15906
				],
				[
					13506,
					1730
				],
				[
					22818,
					-24464
				],
				[
					-245,
					-9969
				],
				[
					11485,
					-8800
				],
				[
					6813,
					-26201
				],
				[
					18970,
					-1177
				],
				[
					3921,
					-7710
				],
				[
					-6953,
					-15163
				],
				[
					18734,
					-14754
				],
				[
					13015,
					-17711
				],
				[
					11115,
					-2795
				],
				[
					5184,
					-12140
				],
				[
					17368,
					-11355
				],
				[
					26172,
					3624
				],
				[
					15258,
					-10139
				],
				[
					1380,
					-21726
				],
				[
					6959,
					-1648
				],
				[
					7749,
					-46636
				],
				[
					-12635,
					-24444
				],
				[
					2875,
					-11897
				],
				[
					9151,
					7909
				],
				[
					12731,
					-28570
				],
				[
					-2654,
					-20200
				],
				[
					3609,
					-17590
				],
				[
					8519,
					-6354
				],
				[
					8731,
					4920
				],
				[
					6065,
					-9226
				],
				[
					17270,
					16732
				],
				[
					22950,
					-9968
				],
				[
					9680,
					5647
				],
				[
					-1439,
					12592
				],
				[
					16663,
					4085
				],
				[
					768,
					-13539
				],
				[
					10154,
					-1448
				],
				[
					5202,
					14318
				],
				[
					10022,
					7886
				],
				[
					18392,
					-18859
				],
				[
					15368,
					2231
				],
				[
					17973,
					-11090
				],
				[
					12539,
					474
				],
				[
					13143,
					15477
				],
				[
					20406,
					4037
				],
				[
					16030,
					-2942
				],
				[
					-1316,
					15021
				],
				[
					8063,
					14172
				],
				[
					15037,
					-7542
				],
				[
					10616,
					2848
				],
				[
					4879,
					-32832
				],
				[
					5321,
					-9123
				],
				[
					-16995,
					-18531
				],
				[
					3211,
					-11205
				],
				[
					14013,
					-16550
				],
				[
					6567,
					-27585
				],
				[
					21638,
					-3026
				],
				[
					-1878,
					-19622
				],
				[
					10253,
					-38253
				],
				[
					14008,
					-23417
				],
				[
					23833,
					-26269
				]
			],
			[
				[
					766906,
					4479872
				],
				[
					-355,
					18353
				],
				[
					-11242,
					-540
				],
				[
					815,
					-24405
				],
				[
					10782,
					6592
				]
			],
			[
				[
					1005194,
					4859145
				],
				[
					-14404,
					1641
				],
				[
					368,
					-9751
				],
				[
					16937,
					-11911
				],
				[
					7487,
					16487
				],
				[
					-10388,
					3534
				]
			],
			[
				[
					972956,
					4889424
				],
				[
					0,
					0
				]
			],
			[
				[
					920573,
					4967827
				],
				[
					-20898,
					-11245
				],
				[
					-22248,
					12528
				],
				[
					-28343,
					-1464
				],
				[
					345,
					-28675
				],
				[
					35089,
					-32
				],
				[
					10,
					7798
				],
				[
					23668,
					-10922
				],
				[
					19399,
					17659
				],
				[
					-7022,
					14353
				]
			],
			[
				[
					770654,
					4582875
				],
				[
					-14505,
					-35652
				],
				[
					-14265,
					9279
				],
				[
					10777,
					11562
				],
				[
					-10304,
					9237
				],
				[
					-5950,
					-22360
				],
				[
					-6314,
					7089
				],
				[
					-7320,
					-9088
				],
				[
					14580,
					-67265
				],
				[
					-26666,
					-9181
				]
			],
			[
				[
					613137,
					4419017
				],
				[
					13042,
					86967
				],
				[
					-381,
					47153
				],
				[
					-60807,
					62383
				],
				[
					13709,
					49136
				],
				[
					19412,
					33132
				],
				[
					20392,
					18249
				],
				[
					11285,
					2374
				]
			],
			[
				[
					9986540,
					1364012
				],
				[
					9,
					-10
				]
			],
			[
				[
					9986540,
					1364012
				],
				[
					0,
					0
				]
			],
			[
				[
					9986619,
					1364303
				],
				[
					-25,
					-23
				]
			],
			[
				[
					9986594,
					1364280
				],
				[
					25,
					23
				]
			],
			[
				[
					9926082,
					1373293
				],
				[
					0,
					0
				]
			],
			[
				[
					9925153,
					1372976
				],
				[
					0,
					0
				]
			],
			[
				[
					9992065,
					1410865
				],
				[
					53,
					-14382
				]
			],
			[
				[
					9992118,
					1396483
				],
				[
					-897,
					-2721
				]
			],
			[
				[
					9991221,
					1393762
				],
				[
					-5682,
					11088
				]
			],
			[
				[
					9985539,
					1404850
				],
				[
					2176,
					8006
				]
			],
			[
				[
					9987715,
					1412856
				],
				[
					1638,
					4074
				]
			],
			[
				[
					9989353,
					1416930
				],
				[
					283,
					-146
				]
			],
			[
				[
					9989636,
					1416784
				],
				[
					2429,
					-5919
				]
			],
			[
				[
					9965931,
					1441686
				],
				[
					-7217,
					-14739
				],
				[
					-3792,
					4242
				],
				[
					11009,
					10497
				]
			],
			[
				[
					9946124,
					1393174
				],
				[
					12543,
					-6290
				]
			],
			[
				[
					9958667,
					1386884
				],
				[
					9326,
					-11988
				],
				[
					18315,
					-12099
				]
			],
			[
				[
					9986308,
					1362797
				],
				[
					-10522,
					-12519
				],
				[
					-1879,
					-31208
				],
				[
					-6130,
					-13643
				],
				[
					5833,
					-4676
				],
				[
					-14634,
					-75803
				],
				[
					-7036,
					-6406
				],
				[
					-3185,
					-17943
				],
				[
					-10002,
					-6934
				],
				[
					-7104,
					2132
				],
				[
					-7042,
					16475
				],
				[
					-13070,
					1359
				],
				[
					-13798,
					-22902
				],
				[
					-10417,
					4366
				],
				[
					-3997,
					15830
				]
			],
			[
				[
					9883325,
					1210925
				],
				[
					18245,
					18281
				],
				[
					5821,
					14271
				],
				[
					12099,
					14682
				],
				[
					2331,
					20583
				],
				[
					11711,
					20666
				],
				[
					-1814,
					19349
				],
				[
					4081,
					4369
				],
				[
					-21350,
					19091
				],
				[
					-11376,
					-8055
				],
				[
					22700,
					27569
				],
				[
					1670,
					-8805
				],
				[
					6095,
					13664
				],
				[
					-12590,
					15188
				],
				[
					-3822,
					-8389
				],
				[
					-7604,
					13995
				],
				[
					-8351,
					-4752
				],
				[
					898,
					10073
				],
				[
					10631,
					20095
				],
				[
					492,
					26276
				]
			],
			[
				[
					9913192,
					1439076
				],
				[
					22832,
					19808
				]
			],
			[
				[
					9936024,
					1458884
				],
				[
					-8519,
					-14748
				],
				[
					10211,
					7217
				],
				[
					-11466,
					-37825
				],
				[
					8841,
					7659
				],
				[
					7491,
					-34704
				],
				[
					3542,
					6691
				]
			],
			[
				[
					9988940,
					1459507
				],
				[
					-8746,
					-11222
				],
				[
					-4089,
					10753
				]
			],
			[
				[
					9976105,
					1459038
				],
				[
					3198,
					18769
				],
				[
					9637,
					-18300
				]
			],
			[
				[
					9942612,
					1480072
				],
				[
					-2479,
					-6528
				]
			],
			[
				[
					9940133,
					1473544
				],
				[
					32,
					-2188
				]
			],
			[
				[
					9940165,
					1471356
				],
				[
					-12975,
					-11177
				],
				[
					-8013,
					948
				]
			],
			[
				[
					9919177,
					1461127
				],
				[
					2,
					6191
				],
				[
					13232,
					32192
				],
				[
					4691,
					20160
				],
				[
					6372,
					-2113
				],
				[
					9442,
					11179
				],
				[
					-5126,
					6823
				]
			],
			[
				[
					9947790,
					1535559
				],
				[
					8169,
					8372
				],
				[
					4530,
					19763
				],
				[
					8978,
					-2292
				],
				[
					4556,
					-12737
				],
				[
					-8029,
					-2039
				],
				[
					-7060,
					-12599
				],
				[
					-1105,
					-13837
				],
				[
					-7385,
					-9848
				],
				[
					249,
					-13305
				],
				[
					-8081,
					-16965
				]
			],
			[
				[
					9919177,
					1461127
				],
				[
					-5985,
					-22051
				]
			],
			[
				[
					9883325,
					1210925
				],
				[
					4573,
					13681
				],
				[
					-5642,
					14777
				],
				[
					6612,
					18250
				],
				[
					8951,
					12222
				],
				[
					-12014,
					1140
				],
				[
					-1864,
					12791
				],
				[
					10433,
					25905
				],
				[
					-1368,
					24833
				],
				[
					-5931,
					-20261
				],
				[
					-18514,
					-23159
				],
				[
					-13424,
					-33256
				],
				[
					-9910,
					-14907
				],
				[
					-13780,
					-8921
				],
				[
					-8118,
					4403
				],
				[
					-1603,
					17406
				],
				[
					3088,
					24830
				],
				[
					8239,
					19669
				],
				[
					10068,
					46567
				],
				[
					109,
					12431
				],
				[
					8593,
					-446
				],
				[
					5558,
					8749
				],
				[
					-5539,
					8007
				],
				[
					12748,
					8915
				],
				[
					-13445,
					7167
				],
				[
					4095,
					37917
				],
				[
					-3754,
					1370
				],
				[
					-5143,
					36436
				],
				[
					-5495,
					-1136
				],
				[
					2099,
					13863
				],
				[
					-8086,
					-1440
				],
				[
					17,
					16946
				]
			],
			[
				[
					9834878,
					1495674
				],
				[
					13653,
					20352
				],
				[
					10013,
					-3111
				],
				[
					6761,
					-11179
				]
			],
			[
				[
					9865305,
					1501736
				],
				[
					9425,
					-4848
				],
				[
					-8340,
					-27667
				],
				[
					-9675,
					19605
				],
				[
					3091,
					-30605
				],
				[
					9254,
					-22028
				],
				[
					11109,
					6318
				],
				[
					-4703,
					-13030
				],
				[
					5006,
					-1310
				],
				[
					1374,
					-21094
				],
				[
					4138,
					11355
				],
				[
					8021,
					-10526
				],
				[
					-607,
					27961
				],
				[
					5953,
					-4141
				],
				[
					3196,
					19509
				],
				[
					-2864,
					12563
				],
				[
					9994,
					29343
				],
				[
					3584,
					2506
				],
				[
					8734,
					29089
				],
				[
					12996,
					9304
				],
				[
					12799,
					1519
				]
			],
			[
				[
					9863663,
					1546402
				],
				[
					5969,
					7475
				],
				[
					-5747,
					11483
				]
			],
			[
				[
					9863885,
					1565360
				],
				[
					8172,
					-2798
				]
			],
			[
				[
					9872057,
					1562562
				],
				[
					2174,
					-2555
				]
			],
			[
				[
					9874231,
					1560007
				],
				[
					1899,
					-249
				]
			],
			[
				[
					9876130,
					1559758
				],
				[
					2980,
					-3
				]
			],
			[
				[
					9879110,
					1559755
				],
				[
					15176,
					13751
				],
				[
					3074,
					-15743
				],
				[
					-2444,
					-11331
				],
				[
					-7743,
					-3460
				],
				[
					-10148,
					5915
				],
				[
					-13362,
					-2485
				]
			],
			[
				[
					9875404,
					1558462
				],
				[
					0,
					0
				]
			],
			[
				[
					9844760,
					1631455
				],
				[
					-8398,
					-8088
				],
				[
					-5228,
					4176
				],
				[
					-6584,
					-9446
				],
				[
					1547,
					-13038
				],
				[
					7706,
					17047
				],
				[
					5147,
					-2241
				],
				[
					21614,
					19220
				],
				[
					3219,
					-1882
				],
				[
					-9804,
					-21102
				],
				[
					8552,
					6218
				],
				[
					5065,
					16669
				],
				[
					14595,
					15571
				],
				[
					2929,
					-10084
				],
				[
					-12518,
					-19290
				],
				[
					11087,
					8683
				],
				[
					6021,
					17597
				],
				[
					-103,
					-22554
				],
				[
					12129,
					19748
				],
				[
					4696,
					26464
				],
				[
					10158,
					-2244
				],
				[
					10761,
					-22813
				],
				[
					2617,
					11014
				],
				[
					11260,
					15145
				],
				[
					2561,
					10467
				],
				[
					9536,
					-4092
				],
				[
					3949,
					-13979
				],
				[
					-7236,
					-33605
				],
				[
					-16453,
					-26455
				],
				[
					-10755,
					5739
				],
				[
					-7492,
					-4963
				],
				[
					-16360,
					-27751
				],
				[
					-14674,
					-15296
				],
				[
					-7199,
					-2685
				],
				[
					-8236,
					7947
				]
			],
			[
				[
					9868869,
					1571552
				],
				[
					-11439,
					4109
				]
			],
			[
				[
					9857430,
					1575661
				],
				[
					-6383,
					6131
				]
			],
			[
				[
					9851047,
					1581792
				],
				[
					-6219,
					-5471
				],
				[
					-20191,
					8175
				],
				[
					-495,
					-15201
				],
				[
					8882,
					-25548
				]
			],
			[
				[
					9833024,
					1543747
				],
				[
					-10548,
					-4030
				],
				[
					-13854,
					1550
				],
				[
					-10097,
					14573
				],
				[
					-3326,
					17107
				],
				[
					-19096,
					-691
				]
			],
			[
				[
					9776103,
					1572256
				],
				[
					126,
					12303
				],
				[
					-7359,
					-1
				]
			],
			[
				[
					9768870,
					1584558
				],
				[
					19922,
					66393
				],
				[
					36536,
					47882
				],
				[
					9268,
					-19995
				],
				[
					13516,
					-1094
				],
				[
					-227,
					-12756
				],
				[
					-6332,
					-33085
				],
				[
					3207,
					-448
				]
			],
			[
				[
					9824581,
					1383796
				],
				[
					2223,
					-10818
				],
				[
					-7795,
					-967
				],
				[
					5572,
					11785
				]
			],
			[
				[
					9829658,
					1446235
				],
				[
					-4804,
					-35058
				],
				[
					-10635,
					-33639
				],
				[
					-11386,
					2971
				],
				[
					10450,
					14967
				],
				[
					11183,
					26717
				],
				[
					5192,
					24042
				]
			],
			[
				[
					9836076,
					1444028
				],
				[
					-3951,
					-39744
				],
				[
					-559,
					23816
				],
				[
					4510,
					15928
				]
			],
			[
				[
					9833024,
					1543747
				],
				[
					2099,
					9632
				],
				[
					16578,
					2112
				]
			],
			[
				[
					9851701,
					1555491
				],
				[
					-978,
					-11638
				],
				[
					9564,
					-2857
				],
				[
					18733,
					2273
				],
				[
					1602,
					-4654
				],
				[
					-15618,
					-10605
				],
				[
					-16533,
					2124
				],
				[
					16673,
					-6823
				],
				[
					20687,
					13609
				],
				[
					-811,
					-15794
				],
				[
					-7279,
					-22662
				],
				[
					-12436,
					3272
				]
			],
			[
				[
					9834878,
					1495674
				],
				[
					-1609,
					-12535
				],
				[
					-8439,
					12649
				],
				[
					-11505,
					-42446
				],
				[
					-7547,
					-8619
				],
				[
					-8386,
					-34800
				],
				[
					-12077,
					-33496
				],
				[
					-7919,
					-9221
				],
				[
					-2304,
					7885
				],
				[
					8639,
					14410
				],
				[
					13830,
					41909
				],
				[
					-15150,
					-37733
				],
				[
					-10008,
					-16800
				],
				[
					-5337,
					5005
				],
				[
					-10432,
					-11669
				],
				[
					-9270,
					5811
				],
				[
					-23860,
					-41586
				],
				[
					5286,
					-6195
				],
				[
					-8086,
					-5536
				],
				[
					918,
					-20334
				],
				[
					-12045,
					-13757
				],
				[
					-5255,
					-20174
				],
				[
					-7056,
					-9079
				],
				[
					-20702,
					-5918
				],
				[
					506,
					12893
				],
				[
					-11333,
					-2460
				],
				[
					-6689,
					-10911
				],
				[
					-22461,
					-2971
				],
				[
					-16263,
					12849
				],
				[
					204,
					19312
				],
				[
					13113,
					19103
				],
				[
					9789,
					8315
				],
				[
					10220,
					-5860
				],
				[
					17935,
					13613
				],
				[
					23916,
					30893
				],
				[
					2279,
					27943
				],
				[
					13610,
					20712
				],
				[
					24036,
					7663
				],
				[
					12640,
					12212
				],
				[
					-3151,
					11674
				],
				[
					19606,
					16888
				],
				[
					-2751,
					1811
				],
				[
					-28826,
					-20804
				],
				[
					-12046,
					-971
				]
			],
			[
				[
					9720898,
					1425349
				],
				[
					8988,
					19063
				],
				[
					11960,
					3337
				],
				[
					5324,
					13654
				],
				[
					-2578,
					29854
				],
				[
					11515,
					-43
				],
				[
					4235,
					15602
				],
				[
					-1309,
					12459
				],
				[
					6768,
					11203
				],
				[
					-8143,
					18328
				],
				[
					15689,
					15060
				],
				[
					2756,
					8390
				]
			],
			[
				[
					9882174,
					1736470
				],
				[
					3168,
					-4554
				],
				[
					-15292,
					-9998
				],
				[
					12124,
					14552
				]
			],
			[
				[
					9712156,
					1848548
				],
				[
					4604,
					-9415
				],
				[
					-9187,
					-8905
				],
				[
					4583,
					18320
				]
			],
			[
				[
					9765398,
					1884885
				],
				[
					-1301,
					-23829
				],
				[
					-8775,
					6034
				],
				[
					10076,
					17795
				]
			],
			[
				[
					9768870,
					1584558
				],
				[
					-83937,
					36
				],
				[
					-4260,
					7768
				],
				[
					-10850,
					-4292
				],
				[
					-9829,
					4037
				],
				[
					-34,
					-7547
				],
				[
					-31967,
					-1
				],
				[
					9,
					33212
				],
				[
					-6284,
					184
				],
				[
					-1127,
					11537
				],
				[
					-7529,
					11481
				]
			],
			[
				[
					9613062,
					1640973
				],
				[
					10602,
					27537
				],
				[
					12505,
					7384
				],
				[
					5309,
					21897
				],
				[
					-832,
					16752
				],
				[
					5138,
					19465
				],
				[
					9845,
					13129
				]
			],
			[
				[
					9655629,
					1747137
				],
				[
					15726,
					-3610
				],
				[
					7200,
					-15703
				],
				[
					11266,
					-3408
				],
				[
					-489,
					-10580
				],
				[
					6764,
					-5891
				],
				[
					1595,
					9976
				],
				[
					14281,
					2312
				],
				[
					-2711,
					19975
				],
				[
					9456,
					-545
				],
				[
					-3624,
					8480
				],
				[
					11245,
					-445
				],
				[
					11091,
					15047
				],
				[
					-13167,
					29503
				],
				[
					-9274,
					2798
				],
				[
					-15447,
					-22533
				],
				[
					-11438,
					6271
				],
				[
					6051,
					7130
				]
			],
			[
				[
					9694154,
					1785914
				],
				[
					4958,
					26803
				],
				[
					10745,
					15157
				],
				[
					12851,
					6662
				],
				[
					-3343,
					13462
				],
				[
					8245,
					-5995
				],
				[
					3625,
					-12952
				],
				[
					6389,
					10856
				],
				[
					5553,
					-3313
				],
				[
					-2965,
					16211
				],
				[
					6901,
					12903
				],
				[
					-75,
					-28669
				],
				[
					10452,
					4122
				],
				[
					23525,
					54646
				],
				[
					9569,
					6972
				],
				[
					-10792,
					-35229
				],
				[
					13066,
					14117
				],
				[
					-6417,
					-27468
				],
				[
					8088,
					-7700
				],
				[
					1421,
					13685
				],
				[
					11772,
					11678
				],
				[
					4308,
					-12616
				],
				[
					5027,
					7337
				],
				[
					6210,
					-8642
				],
				[
					2058,
					17994
				],
				[
					17823,
					3462
				],
				[
					-4578,
					-10036
				],
				[
					10958,
					5414
				],
				[
					8996,
					-9370
				],
				[
					21987,
					-14184
				],
				[
					12550,
					-17909
				],
				[
					6829,
					389
				],
				[
					3561,
					-12749
				],
				[
					-9217,
					-9766
				],
				[
					921,
					-9521
				],
				[
					-7547,
					-8182
				],
				[
					1280,
					-18724
				],
				[
					-18972,
					-940
				],
				[
					-177,
					-9839
				],
				[
					-10583,
					-5500
				],
				[
					5740,
					-8085
				],
				[
					-21519,
					-8143
				],
				[
					4187,
					-5948
				],
				[
					-3552,
					-13279
				],
				[
					-9757,
					1950
				],
				[
					-13982,
					-6411
				],
				[
					-1338,
					-9514
				],
				[
					25350,
					10675
				],
				[
					10679,
					8536
				],
				[
					8536,
					-8928
				],
				[
					-10296,
					-18769
				],
				[
					-13610,
					-12761
				],
				[
					9625,
					210
				],
				[
					11837,
					18677
				],
				[
					-3369,
					-13495
				],
				[
					14106,
					3941
				],
				[
					427,
					-15855
				],
				[
					10412,
					9963
				],
				[
					-4483,
					-12837
				],
				[
					-13999,
					-3140
				],
				[
					-8079,
					-15660
				],
				[
					19156,
					450
				],
				[
					-7135,
					-13770
				],
				[
					-23332,
					-14832
				]
			],
			[
				[
					9770741,
					1764978
				],
				[
					-8310,
					-8034
				],
				[
					12920,
					-6579
				],
				[
					8369,
					-12615
				],
				[
					3559,
					21956
				],
				[
					-16538,
					5272
				]
			],
			[
				[
					9781545,
					1921985
				],
				[
					-2258,
					-19579
				],
				[
					-20964,
					-9926
				],
				[
					1420,
					-5460
				],
				[
					-16913,
					-4923
				],
				[
					7416,
					6771
				],
				[
					-9224,
					13589
				],
				[
					12139,
					8183
				],
				[
					1082,
					-15825
				],
				[
					9877,
					6216
				],
				[
					5913,
					17485
				],
				[
					11512,
					3469
				]
			],
			[
				[
					9761980,
					1929010
				],
				[
					2746,
					-19592
				],
				[
					-7520,
					4663
				],
				[
					4774,
					14929
				]
			],
			[
				[
					9827314,
					1946522
				],
				[
					4748,
					-590
				],
				[
					7093,
					-19299
				],
				[
					-2127,
					-8741
				],
				[
					-29376,
					-13365
				],
				[
					97,
					23856
				],
				[
					8214,
					13412
				],
				[
					3138,
					-5713
				],
				[
					8213,
					10440
				]
			],
			[
				[
					9630437,
					1355418
				],
				[
					2009,
					-8449
				],
				[
					-11537,
					1324
				],
				[
					9528,
					7125
				]
			],
			[
				[
					9625708,
					1450095
				],
				[
					1945,
					-22672
				],
				[
					-21451,
					7416
				],
				[
					-372,
					7506
				],
				[
					19878,
					7750
				]
			],
			[
				[
					9632398,
					1465434
				],
				[
					-3274,
					-6394
				],
				[
					-15396,
					-4473
				],
				[
					6706,
					9572
				],
				[
					11964,
					1295
				]
			],
			[
				[
					9655629,
					1747137
				],
				[
					21,
					79
				]
			],
			[
				[
					9655650,
					1747216
				],
				[
					9215,
					14364
				]
			],
			[
				[
					9664865,
					1761580
				],
				[
					-1875,
					37088
				],
				[
					-10752,
					1154
				],
				[
					-9612,
					-20790
				],
				[
					-1479,
					24728
				],
				[
					-11864,
					-3951
				],
				[
					-10595,
					-15937
				],
				[
					6024,
					-3768
				],
				[
					2760,
					-26184
				],
				[
					-13820,
					6587
				],
				[
					440,
					-22673
				],
				[
					-12364,
					-33023
				],
				[
					4224,
					-19568
				],
				[
					-6674,
					-12951
				],
				[
					642,
					-20852
				],
				[
					7202,
					2959
				],
				[
					5940,
					-13426
				]
			],
			[
				[
					9720898,
					1425349
				],
				[
					-8626,
					5388
				],
				[
					3713,
					10321
				],
				[
					-10696,
					-4395
				],
				[
					-18340,
					9989
				],
				[
					3287,
					12095
				],
				[
					-10125,
					-4705
				],
				[
					2368,
					-7946
				],
				[
					-5674,
					-12376
				],
				[
					9870,
					-9185
				],
				[
					-2742,
					-25276
				],
				[
					-20042,
					-11226
				],
				[
					-6545,
					16433
				],
				[
					-14806,
					-12368
				],
				[
					-8473,
					4389
				],
				[
					2473,
					23281
				],
				[
					-32147,
					-24729
				],
				[
					-7737,
					10055
				],
				[
					25206,
					11515
				],
				[
					22301,
					18380
				],
				[
					-10878,
					-3428
				],
				[
					-7584,
					14926
				],
				[
					11180,
					13804
				],
				[
					76,
					23688
				],
				[
					8786,
					7325
				],
				[
					-8374,
					8057
				],
				[
					-1866,
					-25585
				],
				[
					-19352,
					-9275
				],
				[
					-4004,
					-12146
				],
				[
					-7596,
					-2564
				],
				[
					-2263,
					17204
				],
				[
					-2427,
					-25168
				],
				[
					-10254,
					-4877
				]
			],
			[
				[
					9589607,
					1436950
				],
				[
					-5050,
					5273
				],
				[
					11062,
					21602
				],
				[
					-973,
					9903
				],
				[
					-13471,
					12520
				],
				[
					-2080,
					26189
				],
				[
					-5345,
					11554
				],
				[
					2442,
					12292
				],
				[
					-4948,
					4457
				],
				[
					5372,
					13428
				],
				[
					-18366,
					-9217
				],
				[
					-959,
					8056
				],
				[
					-9972,
					-7817
				],
				[
					-3561,
					-18309
				],
				[
					-7454,
					6100
				],
				[
					-1533,
					17356
				],
				[
					-10409,
					22263
				],
				[
					-10668,
					-14145
				],
				[
					-9479,
					3446
				],
				[
					-11644,
					-10571
				],
				[
					1695,
					-16033
				],
				[
					-14519,
					4660
				],
				[
					-14223,
					10389
				],
				[
					1237,
					12642
				],
				[
					-9768,
					-7126
				],
				[
					-7281,
					-33775
				],
				[
					-12593,
					-8201
				],
				[
					-5321,
					6946
				]
			],
			[
				[
					9431798,
					1520832
				],
				[
					-2583,
					5328
				]
			],
			[
				[
					9429215,
					1526160
				],
				[
					-8782,
					46548
				],
				[
					3447,
					9199
				],
				[
					-23691,
					-3663
				],
				[
					-5488,
					8019
				],
				[
					14871,
					19050
				],
				[
					11410,
					-6805
				],
				[
					7581,
					4106
				],
				[
					13522,
					25053
				],
				[
					-16681,
					10361
				],
				[
					3573,
					7972
				],
				[
					29049,
					2430
				],
				[
					847,
					4064
				]
			],
			[
				[
					9458873,
					1652494
				],
				[
					-251,
					9968
				],
				[
					-11047,
					23292
				],
				[
					9424,
					11405
				],
				[
					4198,
					29337
				],
				[
					15174,
					12712
				],
				[
					11792,
					-8797
				],
				[
					9936,
					-1358
				],
				[
					7124,
					27631
				],
				[
					29038,
					10394
				],
				[
					4282,
					29176
				],
				[
					6965,
					9055
				],
				[
					-4788,
					9313
				],
				[
					-9955,
					2279
				]
			],
			[
				[
					9530765,
					1816901
				],
				[
					1103,
					10535
				],
				[
					27936,
					22265
				]
			],
			[
				[
					9559804,
					1849701
				],
				[
					43457,
					-15917
				],
				[
					29022,
					17600
				],
				[
					26697,
					-14596
				],
				[
					4640,
					15386
				]
			],
			[
				[
					9663620,
					1852174
				],
				[
					6160,
					19220
				],
				[
					8622,
					12834
				],
				[
					9970,
					-2246
				],
				[
					-9406,
					-14735
				],
				[
					14294,
					9229
				],
				[
					-15265,
					-24771
				],
				[
					11449,
					10194
				],
				[
					10069,
					-4539
				],
				[
					-2541,
					26081
				],
				[
					-4511,
					11235
				],
				[
					20176,
					961
				],
				[
					2543,
					-17319
				],
				[
					-12878,
					-31321
				],
				[
					834,
					-19653
				],
				[
					-16661,
					-22886
				],
				[
					6541,
					-3247
				],
				[
					1138,
					-15297
				]
			],
			[
				[
					9667602,
					1895951
				],
				[
					-14647,
					-13724
				],
				[
					3454,
					13217
				],
				[
					11193,
					507
				]
			],
			[
				[
					9652595,
					1900912
				],
				[
					1929,
					-10998
				],
				[
					-6559,
					-7010
				],
				[
					-1285,
					17968
				],
				[
					5915,
					40
				]
			],
			[
				[
					9641648,
					1908009
				],
				[
					2225,
					-11067
				],
				[
					-8512,
					-1935
				],
				[
					6287,
					13002
				]
			],
			[
				[
					9654387,
					1917586
				],
				[
					9240,
					-11265
				],
				[
					-15667,
					-4365
				],
				[
					6427,
					15630
				]
			],
			[
				[
					9601183,
					1933613
				],
				[
					11119,
					-2016
				],
				[
					-15101,
					-17154
				],
				[
					3694,
					-1187
				],
				[
					12423,
					16650
				],
				[
					21192,
					2469
				],
				[
					-10692,
					-20613
				],
				[
					11604,
					-8168
				],
				[
					-25305,
					-17129
				],
				[
					-8601,
					-17061
				],
				[
					6314,
					275
				],
				[
					9272,
					15794
				],
				[
					17639,
					8115
				],
				[
					18075,
					-14480
				],
				[
					-6823,
					-13633
				],
				[
					5869,
					-7943
				],
				[
					13497,
					25849
				],
				[
					4866,
					-1477
				],
				[
					-6605,
					-29730
				]
			],
			[
				[
					9559804,
					1849701
				],
				[
					6425,
					18198
				],
				[
					-3945,
					25289
				],
				[
					3906,
					19053
				],
				[
					13733,
					31317
				],
				[
					12387,
					-9669
				],
				[
					8873,
					-276
				]
			],
			[
				[
					9496874,
					1808181
				],
				[
					159,
					-9618
				],
				[
					-9815,
					-14
				],
				[
					1249,
					9572
				],
				[
					8407,
					60
				]
			],
			[
				[
					9374790,
					1880276
				],
				[
					2606,
					4486
				]
			],
			[
				[
					9377396,
					1884762
				],
				[
					-2606,
					-4486
				]
			],
			[
				[
					9400392,
					1890202
				],
				[
					853,
					-3111
				]
			],
			[
				[
					9401245,
					1887091
				],
				[
					-853,
					3111
				]
			],
			[
				[
					9675449,
					2200519
				],
				[
					1280,
					-10820
				],
				[
					-11512,
					-16035
				],
				[
					-9669,
					5516
				],
				[
					5930,
					10982
				],
				[
					13971,
					10357
				]
			],
			[
				[
					9667632,
					2244853
				],
				[
					2075,
					-7076
				],
				[
					-10892,
					-9980
				],
				[
					-410,
					12398
				],
				[
					9227,
					4658
				]
			],
			[
				[
					9530765,
					1816901
				],
				[
					-14253,
					-172
				],
				[
					-20970,
					7617
				],
				[
					-9193,
					-16490
				],
				[
					-17130,
					12612
				],
				[
					-7730,
					-510
				],
				[
					14279,
					17453
				],
				[
					-9927,
					2103
				],
				[
					9624,
					15142
				],
				[
					-10101,
					8680
				],
				[
					-6738,
					-14058
				],
				[
					-5438,
					16583
				],
				[
					-7752,
					-2110
				],
				[
					2227,
					16522
				],
				[
					-6248,
					4163
				],
				[
					-6908,
					-18613
				],
				[
					-25386,
					26900
				],
				[
					-3789,
					-3349
				]
			],
			[
				[
					9405332,
					1889374
				],
				[
					-8686,
					21144
				],
				[
					-1428,
					19830
				],
				[
					10568,
					25911
				],
				[
					962,
					12111
				],
				[
					8690,
					6294
				],
				[
					-4458,
					7281
				],
				[
					28215,
					85604
				],
				[
					4270,
					26665
				],
				[
					7289,
					27429
				],
				[
					15535,
					33978
				],
				[
					14391,
					-6017
				],
				[
					5985,
					9227
				],
				[
					-12644,
					-5529
				],
				[
					2744,
					7645
				],
				[
					-11448,
					12737
				],
				[
					-7527,
					1224
				],
				[
					27397,
					12967
				],
				[
					10706,
					10884
				],
				[
					12337,
					23882
				],
				[
					-8982,
					27109
				],
				[
					6410,
					-4779
				],
				[
					9595,
					6620
				],
				[
					-4899,
					10030
				],
				[
					17646,
					22529
				],
				[
					-1209,
					19938
				],
				[
					9027,
					22559
				],
				[
					28618,
					22542
				],
				[
					4022,
					-1344
				],
				[
					26266,
					24057
				],
				[
					14348,
					7264
				],
				[
					20471,
					20780
				],
				[
					3110,
					-7428
				],
				[
					-3932,
					-23841
				],
				[
					21490,
					394
				],
				[
					-826,
					14453
				],
				[
					8415,
					12504
				],
				[
					664,
					-12314
				],
				[
					18952,
					9045
				],
				[
					5528,
					-3909
				],
				[
					-2588,
					-18347
				],
				[
					-9797,
					-4514
				],
				[
					7052,
					-4796
				],
				[
					-3270,
					-23853
				],
				[
					-7102,
					5471
				],
				[
					-3681,
					-21762
				],
				[
					-24774,
					11078
				],
				[
					-19354,
					-2870
				],
				[
					-6499,
					9405
				],
				[
					-5997,
					-7132
				],
				[
					7288,
					-11253
				],
				[
					829,
					-14184
				],
				[
					-6880,
					-4873
				],
				[
					13101,
					-17543
				],
				[
					-1053,
					12011
				],
				[
					12485,
					7827
				],
				[
					2032,
					-6904
				],
				[
					12512,
					-902
				],
				[
					-2945,
					-8821
				],
				[
					3434,
					-17832
				],
				[
					-10029,
					-17402
				],
				[
					-7557,
					-27174
				],
				[
					-10379,
					-14830
				],
				[
					-5838,
					-18241
				],
				[
					-9357,
					-10771
				],
				[
					-4150,
					9349
				],
				[
					3696,
					36910
				],
				[
					-8122,
					-32760
				],
				[
					1928,
					-21330
				],
				[
					4761,
					-12347
				],
				[
					-10282,
					-7974
				],
				[
					-6250,
					-25136
				],
				[
					-17401,
					-31137
				],
				[
					-5333,
					-24064
				],
				[
					-16043,
					-35563
				],
				[
					-16139,
					-24404
				],
				[
					-3307,
					-24434
				],
				[
					6729,
					8845
				],
				[
					-1510,
					-20761
				],
				[
					-9992,
					-21062
				],
				[
					-8599,
					-9729
				],
				[
					9434,
					1279
				],
				[
					4715,
					-12417
				],
				[
					-7763,
					-37016
				],
				[
					26603,
					65137
				],
				[
					22248,
					25840
				],
				[
					10038,
					26788
				],
				[
					19523,
					30183
				],
				[
					8186,
					-18967
				],
				[
					-10173,
					-33047
				],
				[
					9528,
					16725
				],
				[
					18570,
					6712
				],
				[
					6501,
					-15037
				],
				[
					10753,
					-5613
				],
				[
					19121,
					3253
				],
				[
					8563,
					9242
				],
				[
					5951,
					-14172
				],
				[
					-22665,
					-25656
				],
				[
					-21446,
					-13471
				],
				[
					-18144,
					-17628
				],
				[
					-12923,
					-3563
				]
			],
			[
				[
					9699007,
					2490447
				],
				[
					-9305,
					-29425
				],
				[
					-7709,
					2816
				],
				[
					4667,
					17075
				],
				[
					12347,
					9534
				]
			],
			[
				[
					9636021,
					2624630
				],
				[
					10113,
					-12098
				],
				[
					-12783,
					5565
				],
				[
					2670,
					6533
				]
			],
			[
				[
					9627405,
					2633507
				],
				[
					8759,
					-4747
				],
				[
					-6310,
					-6203
				],
				[
					-12209,
					5488
				],
				[
					9760,
					5462
				]
			],
			[
				[
					9643459,
					2733042
				],
				[
					-1772,
					-17143
				],
				[
					-6189,
					14822
				],
				[
					7961,
					2321
				]
			],
			[
				[
					9643896,
					2750949
				],
				[
					3298,
					-6767
				],
				[
					-12125,
					-10614
				],
				[
					40,
					17054
				],
				[
					8787,
					327
				]
			],
			[
				[
					9633496,
					2846446
				],
				[
					8502,
					-22546
				],
				[
					-20631,
					11240
				],
				[
					-881,
					8506
				],
				[
					13010,
					2800
				]
			],
			[
				[
					9501779,
					2901843
				],
				[
					-8518,
					-16807
				],
				[
					-6382,
					3197
				],
				[
					5382,
					11742
				],
				[
					9518,
					1868
				]
			],
			[
				[
					9510778,
					2925560
				],
				[
					16368,
					-4114
				],
				[
					-15383,
					-11819
				],
				[
					-7125,
					9981
				],
				[
					6140,
					5952
				]
			],
			[
				[
					9492171,
					2348133
				],
				[
					190,
					102348
				]
			],
			[
				[
					9492361,
					2450481
				],
				[
					5996,
					5305
				],
				[
					-1469,
					18276
				],
				[
					4428,
					13074
				],
				[
					9789,
					652
				],
				[
					-4630,
					14123
				],
				[
					-9828,
					13156
				],
				[
					-12634,
					-12099
				],
				[
					-10207,
					8571
				],
				[
					-7885,
					-10022
				],
				[
					-7047,
					4515
				],
				[
					-1948,
					15207
				],
				[
					-7348,
					17322
				],
				[
					-15510,
					24722
				],
				[
					-6691,
					1173
				],
				[
					-1402,
					12643
				],
				[
					-8218,
					13131
				],
				[
					3932,
					15005
				],
				[
					-9875,
					287
				],
				[
					-11489,
					-16611
				],
				[
					-14315,
					16342
				],
				[
					-6744,
					22585
				],
				[
					-5254,
					432
				],
				[
					-19110,
					26559
				],
				[
					-13686,
					5339
				],
				[
					2538,
					-8605
				],
				[
					-17349,
					-5752
				],
				[
					6493,
					-16148
				],
				[
					-19609,
					-1389
				],
				[
					6235,
					-26437
				],
				[
					-24255,
					2373
				],
				[
					-15836,
					4751
				],
				[
					-8086,
					11328
				],
				[
					-12375,
					-5138
				],
				[
					-16570,
					24752
				],
				[
					-22179,
					-3350
				],
				[
					265,
					-10409
				],
				[
					-8579,
					543
				],
				[
					-754,
					15032
				],
				[
					-29722,
					15963
				],
				[
					842,
					6675
				],
				[
					-13506,
					2635
				],
				[
					3336,
					9949
				],
				[
					16088,
					13845
				],
				[
					4109,
					12745
				],
				[
					-3707,
					14197
				],
				[
					13396,
					18799
				],
				[
					9465,
					3506
				],
				[
					12714,
					27076
				],
				[
					-12871,
					-1603
				],
				[
					10741,
					36062
				],
				[
					27041,
					12100
				],
				[
					3484,
					11861
				],
				[
					11938,
					15037
				],
				[
					-1079,
					10913
				],
				[
					12496,
					17604
				],
				[
					17679,
					17177
				],
				[
					10284,
					4374
				],
				[
					22506,
					-1293
				],
				[
					23750,
					-9072
				],
				[
					-3732,
					9635
				],
				[
					13167,
					16792
				],
				[
					-9911,
					3375
				],
				[
					8806,
					14615
				],
				[
					-5164,
					6768
				],
				[
					13034,
					-554
				],
				[
					4586,
					14764
				],
				[
					20949,
					-1919
				],
				[
					187,
					14765
				],
				[
					16297,
					-241
				],
				[
					4870,
					11538
				],
				[
					22000,
					-3368
				],
				[
					23259,
					3197
				],
				[
					9875,
					15633
				]
			],
			[
				[
					9468362,
					2985269
				],
				[
					13952,
					-25582
				],
				[
					1927,
					-20878
				],
				[
					13870,
					-13175
				],
				[
					-10385,
					-6516
				],
				[
					4566,
					-10049
				],
				[
					-16770,
					-15026
				],
				[
					-21237,
					-11774
				],
				[
					655,
					-15015
				],
				[
					11569,
					9202
				],
				[
					7210,
					-17442
				],
				[
					-2124,
					-18696
				],
				[
					18575,
					18746
				],
				[
					-245,
					20964
				],
				[
					11540,
					4410
				],
				[
					-2913,
					6716
				],
				[
					11128,
					14894
				],
				[
					22246,
					-3460
				],
				[
					33057,
					14707
				],
				[
					8098,
					-13698
				],
				[
					-12766,
					-845
				],
				[
					-7821,
					-10766
				],
				[
					-8789,
					257
				],
				[
					15613,
					-11931
				],
				[
					14113,
					-2883
				],
				[
					9517,
					4011
				],
				[
					-8946,
					-20210
				],
				[
					15060,
					9156
				],
				[
					28325,
					-4372
				],
				[
					-2093,
					-9194
				],
				[
					-26302,
					7668
				],
				[
					10964,
					-14042
				],
				[
					14638,
					-7647
				],
				[
					-1529,
					-6236
				],
				[
					28468,
					-26481
				],
				[
					-13167,
					-9173
				],
				[
					19909,
					-11269
				],
				[
					-3996,
					-12665
				],
				[
					2751,
					-14066
				],
				[
					-13129,
					-10485
				],
				[
					-9710,
					-19261
				],
				[
					-11643,
					3716
				],
				[
					-5002,
					-12614
				],
				[
					9589,
					6543
				],
				[
					10632,
					-2159
				],
				[
					8708,
					-16163
				],
				[
					3822,
					-22373
				],
				[
					-13099,
					3471
				],
				[
					-10305,
					-16796
				],
				[
					-18770,
					14750
				],
				[
					7111,
					-16893
				],
				[
					11293,
					-5338
				],
				[
					6643,
					-16881
				],
				[
					16466,
					5220
				],
				[
					8342,
					-12294
				],
				[
					-5205,
					-11468
				],
				[
					-16442,
					9087
				],
				[
					-17885,
					2743
				],
				[
					13197,
					-6811
				],
				[
					-8541,
					-7767
				],
				[
					4296,
					-8814
				],
				[
					-13170,
					3987
				],
				[
					-4130,
					-10471
				],
				[
					13238,
					2861
				],
				[
					7318,
					-8485
				],
				[
					13993,
					1711
				],
				[
					12811,
					-4493
				],
				[
					-2634,
					-11529
				],
				[
					14935,
					-2339
				],
				[
					-3055,
					-21016
				],
				[
					-7626,
					8004
				],
				[
					-12542,
					586
				],
				[
					3289,
					-11572
				],
				[
					-45087,
					27273
				],
				[
					51330,
					-41508
				],
				[
					14245,
					-14109
				],
				[
					-13544,
					-9469
				],
				[
					6112,
					-21911
				],
				[
					-11190,
					-2983
				],
				[
					974,
					-12004
				],
				[
					-13962,
					-6451
				],
				[
					1432,
					-8386
				],
				[
					-28118,
					-30098
				],
				[
					-8674,
					-12700
				],
				[
					-15277,
					-1738
				],
				[
					1540,
					-7089
				],
				[
					-11532,
					-4386
				],
				[
					-19607,
					-21907
				],
				[
					-9807,
					-1832
				],
				[
					-2021,
					-14125
				],
				[
					-16789,
					-27574
				],
				[
					-7755,
					7539
				],
				[
					-2567,
					-15443
				],
				[
					-17357,
					-2532
				]
			],
			[
				[
					9372188,
					1688577
				],
				[
					-7242,
					-2405
				],
				[
					-2392,
					11145
				],
				[
					7428,
					2487
				]
			],
			[
				[
					9369982,
					1699804
				],
				[
					2206,
					-11227
				]
			],
			[
				[
					9376513,
					1728675
				],
				[
					-844,
					-17798
				]
			],
			[
				[
					9375669,
					1710877
				],
				[
					-7948,
					31
				]
			],
			[
				[
					9367721,
					1710908
				],
				[
					-1981,
					7787
				],
				[
					10773,
					9980
				]
			],
			[
				[
					9440111,
					1776851
				],
				[
					7213,
					-11841
				],
				[
					-15267,
					-2840
				],
				[
					6996,
					14096
				]
			],
			[
				[
					9439053,
					1776266
				],
				[
					1058,
					585
				]
			],
			[
				[
					9386281,
					1792748
				],
				[
					-6073,
					-4655
				]
			],
			[
				[
					9380208,
					1788093
				],
				[
					959,
					8197
				]
			],
			[
				[
					9381167,
					1796290
				],
				[
					5114,
					-3542
				]
			],
			[
				[
					9345610,
					1796904
				],
				[
					5977,
					-3966
				]
			],
			[
				[
					9351587,
					1792938
				],
				[
					-1452,
					-14426
				],
				[
					11566,
					4252
				],
				[
					11050,
					-2359
				],
				[
					2876,
					-11210
				],
				[
					12083,
					-11508
				]
			],
			[
				[
					9387710,
					1757687
				],
				[
					-3656,
					-7632
				]
			],
			[
				[
					9384054,
					1750055
				],
				[
					-5654,
					4027
				],
				[
					-17537,
					26523
				],
				[
					-12455,
					-3907
				],
				[
					-5846,
					13688
				]
			],
			[
				[
					9342562,
					1790386
				],
				[
					3048,
					6518
				]
			],
			[
				[
					9250721,
					1470207
				],
				[
					-6265,
					-21701
				],
				[
					218,
					13630
				],
				[
					6047,
					8071
				]
			],
			[
				[
					9431798,
					1520832
				],
				[
					-11092,
					-34310
				],
				[
					6520,
					-49663
				]
			],
			[
				[
					9427226,
					1436859
				],
				[
					-7648,
					-164
				]
			],
			[
				[
					9419578,
					1436695
				],
				[
					-199,
					-867
				]
			],
			[
				[
					9419379,
					1435828
				],
				[
					-29264,
					10307
				],
				[
					-2588,
					8627
				],
				[
					-23247,
					-11989
				],
				[
					-4122,
					5484
				],
				[
					-9726,
					-8113
				],
				[
					4742,
					18073
				],
				[
					-13266,
					-21062
				],
				[
					-15020,
					14306
				],
				[
					3152,
					-13790
				],
				[
					-21911,
					-9511
				],
				[
					-30009,
					-3072
				],
				[
					-19254,
					-5540
				],
				[
					-12797,
					14524
				]
			],
			[
				[
					9246069,
					1434072
				],
				[
					5175,
					5872
				],
				[
					-6454,
					6682
				],
				[
					18637,
					21163
				],
				[
					10022,
					-2549
				],
				[
					4628,
					16695
				],
				[
					11565,
					5335
				],
				[
					11109,
					-4200
				],
				[
					7225,
					15960
				],
				[
					9150,
					-6620
				],
				[
					2503,
					7300
				],
				[
					13294,
					5047
				],
				[
					17869,
					19495
				],
				[
					-2590,
					18179
				],
				[
					10081,
					9755
				],
				[
					15071,
					-4550
				],
				[
					13314,
					-13731
				],
				[
					3706,
					4842
				],
				[
					4498,
					-17753
				],
				[
					-6616,
					-7206
				],
				[
					18229,
					8409
				],
				[
					7760,
					-8923
				],
				[
					3828,
					13457
				],
				[
					4902,
					-7940
				],
				[
					6240,
					7369
				]
			],
			[
				[
					9419578,
					1436695
				],
				[
					-199,
					-867
				]
			],
			[
				[
					9589607,
					1436950
				],
				[
					-5954,
					-3562
				],
				[
					-2063,
					39793
				],
				[
					-620,
					-38862
				],
				[
					-6985,
					-5770
				],
				[
					-15927,
					3052
				],
				[
					-26414,
					-2197
				],
				[
					5086,
					-9684
				],
				[
					-8220,
					-6921
				],
				[
					-25672,
					13466
				],
				[
					-13785,
					-4651
				],
				[
					-4267,
					11077
				],
				[
					-17555,
					-8638
				],
				[
					-2170,
					14032
				],
				[
					-32928,
					-5277
				],
				[
					-4907,
					4051
				]
			],
			[
				[
					9320622,
					1711113
				],
				[
					47099,
					-205
				]
			],
			[
				[
					9375669,
					1710877
				],
				[
					-5687,
					-11073
				]
			],
			[
				[
					9372188,
					1688577
				],
				[
					24483,
					-7246
				]
			],
			[
				[
					9396671,
					1681331
				],
				[
					10204,
					-15513
				],
				[
					18597,
					-7096
				],
				[
					15257,
					-11721
				],
				[
					18144,
					5493
				]
			],
			[
				[
					9246069,
					1434072
				],
				[
					-3570,
					17022
				],
				[
					-1522,
					31493
				],
				[
					-9327,
					16915
				],
				[
					10581,
					11142
				],
				[
					5533,
					14354
				],
				[
					20602,
					23140
				],
				[
					12127,
					7494
				],
				[
					40599,
					64723
				],
				[
					16244,
					7902
				],
				[
					5369,
					12353
				],
				[
					-3218,
					8122
				]
			],
			[
				[
					9339487,
					1648732
				],
				[
					-1539,
					11632
				],
				[
					-18913,
					3234
				],
				[
					-3806,
					-4963
				]
			],
			[
				[
					9315229,
					1658635
				],
				[
					-30586,
					-11816
				],
				[
					-8548,
					4183
				],
				[
					-28291,
					-14382
				],
				[
					5638,
					19629
				],
				[
					14722,
					19296
				],
				[
					21344,
					18070
				],
				[
					-7414,
					-20731
				],
				[
					11792,
					-9633
				],
				[
					16666,
					-3689
				],
				[
					6716,
					20137
				],
				[
					-3643,
					9997
				],
				[
					6997,
					21417
				]
			],
			[
				[
					9319470,
					1684973
				],
				[
					0,
					0
				]
			],
			[
				[
					9345553,
					2997172
				],
				[
					-1467,
					-10643
				],
				[
					-12185,
					-3846
				],
				[
					4354,
					13211
				],
				[
					9298,
					1278
				]
			],
			[
				[
					9474029,
					3110139
				],
				[
					2730,
					-15061
				],
				[
					-11707,
					-3903
				],
				[
					1804,
					15615
				],
				[
					7173,
					3349
				]
			],
			[
				[
					9314156,
					3214159
				],
				[
					4151,
					-15730
				],
				[
					-11379,
					-5509
				],
				[
					7228,
					21239
				]
			],
			[
				[
					9154285,
					3295710
				],
				[
					-11616,
					-10350
				],
				[
					2652,
					12324
				],
				[
					8964,
					-1974
				]
			],
			[
				[
					9131557,
					3298340
				],
				[
					-7083,
					-20847
				],
				[
					2558,
					20141
				],
				[
					4525,
					706
				]
			],
			[
				[
					9167559,
					3308512
				],
				[
					-55,
					-10835
				],
				[
					-10909,
					-6643
				],
				[
					10964,
					17478
				]
			],
			[
				[
					9130230,
					3416735
				],
				[
					4885,
					-12187
				],
				[
					-11359,
					2982
				],
				[
					6474,
					9205
				]
			],
			[
				[
					9048554,
					3439648
				],
				[
					12692,
					-1629
				],
				[
					3495,
					-15014
				],
				[
					-17835,
					3976
				],
				[
					1648,
					12667
				]
			],
			[
				[
					9075006,
					3439895
				],
				[
					15071,
					-7536
				],
				[
					-12157,
					-11832
				],
				[
					-9854,
					14942
				],
				[
					6940,
					4426
				]
			],
			[
				[
					9068358,
					3456108
				],
				[
					-2158,
					-12584
				],
				[
					-6633,
					1726
				],
				[
					8791,
					10858
				]
			],
			[
				[
					9042378,
					3494780
				],
				[
					-1856,
					-7416
				],
				[
					15317,
					-12739
				],
				[
					-7996,
					-18973
				],
				[
					-19745,
					7687
				],
				[
					-3997,
					15757
				],
				[
					18277,
					15684
				]
			],
			[
				[
					8967697,
					3551292
				],
				[
					36751,
					-8792
				],
				[
					327,
					-12031
				],
				[
					-16662,
					-199
				],
				[
					-18189,
					8717
				],
				[
					-2227,
					12305
				]
			],
			[
				[
					8956991,
					3566459
				],
				[
					11100,
					-1464
				],
				[
					4077,
					-8352
				],
				[
					-19930,
					3149
				],
				[
					4753,
					6667
				]
			],
			[
				[
					8986285,
					3587786
				],
				[
					25999,
					-7619
				],
				[
					3817,
					-10172
				],
				[
					15605,
					-2938
				],
				[
					-4416,
					-10000
				],
				[
					-26172,
					5217
				],
				[
					-5687,
					-3932
				],
				[
					-14602,
					6478
				],
				[
					-1944,
					7887
				],
				[
					7400,
					15079
				]
			],
			[
				[
					8995392,
					3595621
				],
				[
					8530,
					-7136
				],
				[
					-15803,
					2603
				],
				[
					7273,
					4533
				]
			],
			[
				[
					9033708,
					3619442
				],
				[
					11916,
					-15059
				],
				[
					-6722,
					-4871
				],
				[
					-15462,
					3163
				],
				[
					10268,
					16767
				]
			],
			[
				[
					9041272,
					3650720
				],
				[
					-13593,
					-1098
				],
				[
					5360,
					9059
				],
				[
					8233,
					-7961
				]
			],
			[
				[
					8999207,
					3679386
				],
				[
					13917,
					-1836
				],
				[
					-8416,
					-11964
				],
				[
					162,
					-14616
				],
				[
					-6508,
					7141
				],
				[
					-5485,
					-14698
				],
				[
					16899,
					-5327
				],
				[
					-237,
					-24840
				],
				[
					-3788,
					-14686
				],
				[
					-18931,
					18009
				],
				[
					-15696,
					-1305
				],
				[
					11293,
					32378
				],
				[
					-2238,
					13361
				],
				[
					17962,
					23963
				],
				[
					1066,
					-5580
				]
			],
			[
				[
					8972931,
					3783458
				],
				[
					9976,
					-11288
				],
				[
					-6282,
					-7947
				],
				[
					-13076,
					8094
				],
				[
					9382,
					11141
				]
			],
			[
				[
					8919673,
					3816893
				],
				[
					-14866,
					-4559
				],
				[
					5300,
					8340
				],
				[
					9566,
					-3781
				]
			],
			[
				[
					8970924,
					3825140
				],
				[
					8994,
					-7531
				],
				[
					-6035,
					-13646
				],
				[
					-11545,
					1605
				],
				[
					21095,
					-12205
				],
				[
					-28177,
					147
				],
				[
					-2299,
					9223
				],
				[
					17967,
					22407
				]
			],
			[
				[
					8952432,
					3835801
				],
				[
					11168,
					-8697
				],
				[
					-10138,
					-22635
				],
				[
					-12042,
					1263
				],
				[
					-7166,
					20222
				],
				[
					5758,
					9175
				],
				[
					4572,
					-8292
				],
				[
					7848,
					8964
				]
			],
			[
				[
					8967271,
					3894869
				],
				[
					10882,
					-11437
				],
				[
					-3700,
					-18859
				],
				[
					-6663,
					164
				],
				[
					-10553,
					15482
				],
				[
					-7263,
					-4672
				],
				[
					4647,
					17220
				],
				[
					12650,
					2102
				]
			],
			[
				[
					8922051,
					3937037
				],
				[
					-5747,
					-11456
				],
				[
					-3456,
					11633
				],
				[
					9203,
					-177
				]
			],
			[
				[
					8824034,
					4066230
				],
				[
					-2743,
					-11754
				],
				[
					-6216,
					7759
				],
				[
					8959,
					3995
				]
			],
			[
				[
					8857714,
					4073909
				],
				[
					8822,
					-7300
				],
				[
					-12327,
					-279
				],
				[
					3505,
					7579
				]
			],
			[
				[
					9460974,
					3007619
				],
				[
					7388,
					-22350
				]
			],
			[
				[
					9492361,
					2450481
				],
				[
					-102,
					38312
				],
				[
					-96944,
					-494
				],
				[
					-121006,
					129
				],
				[
					-159197,
					-114
				],
				[
					-154395,
					-169
				],
				[
					-117384,
					277
				],
				[
					-109043,
					215
				],
				[
					-3624,
					16199
				],
				[
					7744,
					3942
				],
				[
					14175,
					-9393
				],
				[
					-6292,
					10906
				],
				[
					1293,
					10185
				],
				[
					-6514,
					30314
				],
				[
					-5413,
					13219
				],
				[
					-24516,
					12615
				],
				[
					-9139,
					24963
				],
				[
					6891,
					24668
				],
				[
					20547,
					13060
				],
				[
					52845,
					8900
				],
				[
					-8554,
					14168
				],
				[
					-17771,
					13530
				],
				[
					914,
					23377
				]
			],
			[
				[
					8756876,
					2699290
				],
				[
					5455,
					16898
				],
				[
					10197,
					3712
				],
				[
					390,
					-17346
				],
				[
					8258,
					313
				],
				[
					8264,
					-16314
				],
				[
					2274,
					-14129
				],
				[
					7820,
					-10818
				],
				[
					7714,
					23074
				],
				[
					22167,
					-12416
				],
				[
					6280,
					6652
				],
				[
					27157,
					-1785
				],
				[
					-1511,
					8459
				],
				[
					10552,
					-2402
				],
				[
					-12399,
					14991
				],
				[
					-2175,
					13818
				],
				[
					8382,
					2573
				],
				[
					8419,
					-8820
				],
				[
					12743,
					-1671
				],
				[
					1066,
					23238
				],
				[
					14160,
					4454
				],
				[
					2025,
					-10867
				],
				[
					26785,
					3262
				],
				[
					-4547,
					27507
				],
				[
					13947,
					3271
				],
				[
					17086,
					-4125
				],
				[
					7323,
					37834
				],
				[
					-18851,
					2627
				],
				[
					-16732,
					18218
				],
				[
					-2317,
					17244
				],
				[
					-9390,
					8938
				],
				[
					-15473,
					6212
				],
				[
					-7988,
					-3498
				],
				[
					-15807,
					4787
				],
				[
					-13261,
					9307
				],
				[
					-16489,
					-3282
				],
				[
					-1239,
					8664
				],
				[
					8578,
					4974
				],
				[
					-5984,
					6132
				],
				[
					35766,
					24137
				],
				[
					-3566,
					4253
				],
				[
					-19835,
					-3476
				],
				[
					-6956,
					14858
				],
				[
					10188,
					9057
				],
				[
					-8634,
					6775
				],
				[
					14629,
					10192
				],
				[
					4932,
					10845
				],
				[
					-17329,
					-4841
				],
				[
					-3070,
					21163
				],
				[
					-30174,
					22359
				],
				[
					-6485,
					10804
				],
				[
					3332,
					8800
				],
				[
					-12371,
					7255
				],
				[
					8755,
					20433
				],
				[
					-15197,
					18591
				],
				[
					4460,
					12288
				],
				[
					-6201,
					15228
				],
				[
					-23777,
					1600
				],
				[
					-7907,
					19450
				],
				[
					-25224,
					23628
				]
			],
			[
				[
					8745091,
					3122375
				],
				[
					-10219,
					24290
				],
				[
					-13693,
					12728
				],
				[
					12087,
					9291
				],
				[
					-3970,
					16449
				],
				[
					6849,
					17076
				],
				[
					14754,
					-13495
				],
				[
					5542,
					4821
				],
				[
					698,
					21338
				],
				[
					5626,
					6284
				],
				[
					-6219,
					13596
				],
				[
					23621,
					40276
				],
				[
					-16386,
					-7791
				],
				[
					-14940,
					9992
				],
				[
					17752,
					10368
				],
				[
					-5866,
					7173
				],
				[
					28231,
					6379
				],
				[
					573,
					11039
				],
				[
					-13023,
					-2756
				],
				[
					-4939,
					6953
				],
				[
					-21135,
					-1485
				],
				[
					-14399,
					10660
				],
				[
					11448,
					10004
				],
				[
					2600,
					34635
				],
				[
					-6486,
					20729
				],
				[
					5707,
					12973
				],
				[
					-10522,
					-482
				],
				[
					1753,
					13630
				],
				[
					-10430,
					7858
				],
				[
					-489,
					9093
				],
				[
					13064,
					2714
				],
				[
					18023,
					17378
				]
			],
			[
				[
					8760703,
					3454093
				],
				[
					9871,
					-3034
				],
				[
					4957,
					10140
				],
				[
					-21853,
					-1445
				],
				[
					-10695,
					11248
				],
				[
					-12060,
					-6057
				],
				[
					3034,
					9551
				],
				[
					-8657,
					1984
				],
				[
					3552,
					10681
				],
				[
					-18312,
					-16856
				],
				[
					-2026,
					21136
				],
				[
					19574,
					13921
				],
				[
					-5654,
					12290
				],
				[
					-19736,
					-1603
				],
				[
					-6342,
					13286
				],
				[
					4987,
					9636
				],
				[
					-6039,
					21518
				],
				[
					18069,
					-7937
				],
				[
					13586,
					9833
				],
				[
					-6529,
					4158
				],
				[
					-49,
					16295
				],
				[
					-13507,
					17511
				],
				[
					2896,
					11256
				],
				[
					-13626,
					11277
				],
				[
					7512,
					16222
				],
				[
					7483,
					2816
				],
				[
					-25,
					17168
				],
				[
					16866,
					11333
				],
				[
					-6132,
					1769
				],
				[
					3169,
					43886
				],
				[
					7911,
					-2553
				],
				[
					6252,
					15541
				],
				[
					2649,
					24326
				],
				[
					-7655,
					5161
				],
				[
					-4169,
					-13984
				],
				[
					-4229,
					17714
				],
				[
					3117,
					13673
				],
				[
					17479,
					8209
				],
				[
					-8362,
					30212
				],
				[
					3354,
					20726
				],
				[
					16612,
					20348
				],
				[
					221,
					18673
				],
				[
					-8064,
					-4175
				],
				[
					-2778,
					-17186
				],
				[
					-6902,
					16415
				],
				[
					-4100,
					-8017
				],
				[
					-10583,
					6054
				],
				[
					-2310,
					20659
				],
				[
					-10566,
					3336
				],
				[
					-3247,
					-11500
				],
				[
					-10263,
					11274
				],
				[
					-5187,
					26970
				],
				[
					-12074,
					33403
				],
				[
					-18534,
					2050
				],
				[
					1285,
					28167
				],
				[
					23073,
					14730
				],
				[
					5153,
					27534
				],
				[
					16933,
					2206
				],
				[
					4068,
					17692
				],
				[
					11930,
					-3599
				],
				[
					8288,
					14548
				],
				[
					-11257,
					20202
				],
				[
					-14335,
					-12072
				],
				[
					-8016,
					9596
				],
				[
					-338,
					18435
				],
				[
					6867,
					15193
				],
				[
					10970,
					-4193
				],
				[
					26233,
					5099
				],
				[
					23933,
					8730
				],
				[
					-4977,
					22670
				],
				[
					-18010,
					12182
				],
				[
					-11555,
					-9646
				],
				[
					-26380,
					-8857
				],
				[
					-10459,
					-15483
				],
				[
					-10398,
					9042
				],
				[
					-447,
					19411
				],
				[
					-6103,
					7873
				],
				[
					-19027,
					2766
				],
				[
					-6007,
					-4978
				],
				[
					-25087,
					15246
				],
				[
					-10186,
					-8175
				],
				[
					-5011,
					23764
				],
				[
					9703,
					14366
				],
				[
					10858,
					-63
				],
				[
					1468,
					-8704
				],
				[
					19514,
					-4628
				],
				[
					4239,
					-9147
				],
				[
					22457,
					7585
				],
				[
					-12923,
					19214
				],
				[
					-12928,
					1561
				],
				[
					1990,
					19616
				],
				[
					-5558,
					3944
				],
				[
					3761,
					14563
				],
				[
					-6214,
					12863
				],
				[
					3612,
					27149
				],
				[
					21214,
					21662
				],
				[
					-12409,
					7043
				],
				[
					-17637,
					-18283
				],
				[
					-10199,
					-4650
				],
				[
					-18077,
					25676
				],
				[
					-5642,
					26249
				],
				[
					15846,
					13288
				],
				[
					-8574,
					26142
				],
				[
					9469,
					15364
				],
				[
					6532,
					-2919
				],
				[
					6446,
					12808
				],
				[
					-13609,
					10661
				],
				[
					-10535,
					-1005
				],
				[
					-6295,
					23131
				],
				[
					17326,
					-2431
				],
				[
					-2781,
					12598
				],
				[
					19636,
					2093
				],
				[
					-990,
					12058
				],
				[
					-16676,
					5099
				],
				[
					-12903,
					9660
				],
				[
					1150,
					9942
				],
				[
					37218,
					7332
				]
			],
			[
				[
					8653218,
					4491325
				],
				[
					17067,
					-12358
				],
				[
					1016,
					-19537
				],
				[
					-13962,
					-11467
				],
				[
					5415,
					-13234
				],
				[
					7876,
					15769
				],
				[
					-2443,
					-28734
				],
				[
					-20618,
					-1729
				],
				[
					20028,
					-5174
				],
				[
					-9772,
					-22098
				],
				[
					13585,
					8667
				],
				[
					4658,
					30621
				],
				[
					5902,
					572
				],
				[
					12366,
					-19296
				],
				[
					-7927,
					-6957
				],
				[
					11958,
					-11954
				],
				[
					-5850,
					-10626
				],
				[
					603,
					-16854
				],
				[
					12111,
					21450
				],
				[
					4297,
					-21486
				],
				[
					10442,
					-6875
				],
				[
					-5795,
					-8254
				],
				[
					-19624,
					-4680
				],
				[
					-4266,
					15898
				],
				[
					-7218,
					-2800
				],
				[
					10651,
					-16723
				],
				[
					25921,
					-1396
				],
				[
					-601,
					-12386
				],
				[
					9048,
					-14717
				],
				[
					12841,
					-8529
				],
				[
					3283,
					-9659
				],
				[
					-11778,
					-22782
				],
				[
					-19850,
					3952
				],
				[
					22478,
					-13262
				],
				[
					11552,
					246
				],
				[
					-6603,
					-23657
				],
				[
					14020,
					22164
				],
				[
					14054,
					-10705
				],
				[
					-2685,
					-14644
				],
				[
					16713,
					6611
				],
				[
					-8524,
					-24566
				],
				[
					11262,
					5477
				],
				[
					-9906,
					-23918
				],
				[
					-15331,
					-10020
				],
				[
					-19133,
					-3138
				],
				[
					-15272,
					5164
				],
				[
					16922,
					-13905
				],
				[
					9757,
					6940
				],
				[
					13928,
					-3371
				],
				[
					15982,
					16821
				],
				[
					12010,
					-8336
				],
				[
					15885,
					-1205
				],
				[
					-5367,
					-7656
				],
				[
					-17717,
					-518
				],
				[
					14626,
					-4732
				],
				[
					8915,
					-19347
				],
				[
					-3057,
					-25472
				],
				[
					11664,
					21992
				],
				[
					18905,
					-30253
				],
				[
					-2927,
					-13287
				],
				[
					8493,
					-13648
				],
				[
					-16401,
					-27183
				],
				[
					-20190,
					-13651
				],
				[
					-16931,
					-3667
				],
				[
					-12250,
					-24994
				],
				[
					-19628,
					-22015
				],
				[
					21206,
					17674
				],
				[
					16558,
					23594
				],
				[
					19876,
					-358
				],
				[
					-8344,
					-17635
				],
				[
					8240,
					667
				],
				[
					2521,
					13250
				],
				[
					6751,
					-7395
				],
				[
					9873,
					14308
				],
				[
					15627,
					4100
				],
				[
					25333,
					-3173
				],
				[
					-12281,
					-17955
				],
				[
					5708,
					-6242
				],
				[
					-3658,
					-26303
				],
				[
					8011,
					-10034
				],
				[
					-9806,
					-15354
				],
				[
					-14846,
					2574
				],
				[
					-30209,
					-4080
				],
				[
					3257,
					-11628
				],
				[
					-20179,
					-12168
				],
				[
					9370,
					-15013
				],
				[
					4583,
					16981
				],
				[
					16285,
					13536
				],
				[
					13096,
					3205
				],
				[
					19345,
					-5119
				],
				[
					14188,
					15000
				],
				[
					10257,
					-2104
				],
				[
					-8851,
					-15648
				],
				[
					16912,
					236
				],
				[
					-654,
					-15568
				],
				[
					7556,
					1247
				],
				[
					-7447,
					-13212
				],
				[
					-13640,
					1275
				],
				[
					12045,
					-11949
				],
				[
					5554,
					7018
				],
				[
					2123,
					-15256
				],
				[
					10988,
					2726
				],
				[
					9518,
					13530
				],
				[
					7994,
					-21848
				],
				[
					16222,
					5816
				],
				[
					4386,
					-26314
				],
				[
					-6360,
					-6160
				],
				[
					-13109,
					13756
				],
				[
					-4344,
					-11849
				],
				[
					8853,
					975
				],
				[
					3652,
					-23399
				],
				[
					9428,
					-3263
				],
				[
					910,
					-16422
				],
				[
					-22255,
					-8352
				],
				[
					-332,
					-8525
				],
				[
					-19992,
					-3575
				],
				[
					-10428,
					-18954
				],
				[
					-21232,
					13577
				],
				[
					23250,
					-20230
				],
				[
					17181,
					10848
				],
				[
					15769,
					-1742
				],
				[
					28398,
					-20508
				],
				[
					-14051,
					-2910
				],
				[
					8093,
					-19352
				],
				[
					-17743,
					-12696
				],
				[
					12302,
					-3479
				],
				[
					13183,
					-15015
				],
				[
					14559,
					19320
				],
				[
					-6681,
					-19833
				],
				[
					27568,
					2348
				],
				[
					13074,
					-15224
				],
				[
					-2402,
					-11475
				],
				[
					4479,
					-15397
				],
				[
					-15625,
					-813
				],
				[
					-9070,
					-7811
				],
				[
					-11007,
					-19994
				],
				[
					368,
					-14184
				],
				[
					-15882,
					-5562
				],
				[
					-14475,
					3135
				],
				[
					3494,
					-10222
				],
				[
					12821,
					478
				],
				[
					9144,
					-8417
				],
				[
					-11358,
					-9579
				],
				[
					16415,
					-9183
				],
				[
					-3515,
					-7501
				],
				[
					-20859,
					3534
				],
				[
					-31640,
					17966
				],
				[
					-42482,
					14061
				],
				[
					22440,
					-13496
				],
				[
					20917,
					-6063
				],
				[
					14496,
					-14759
				],
				[
					-24812,
					-2998
				],
				[
					40174,
					-3143
				],
				[
					25215,
					-12774
				],
				[
					-1598,
					-8773
				],
				[
					-13159,
					-5054
				],
				[
					-25833,
					11979
				],
				[
					8572,
					-18427
				],
				[
					-25398,
					-230
				],
				[
					9830,
					-10264
				],
				[
					28595,
					-1869
				],
				[
					4504,
					-13812
				],
				[
					-17110,
					432
				],
				[
					15836,
					-7572
				],
				[
					15369,
					512
				],
				[
					8696,
					-9515
				],
				[
					-20540,
					3233
				],
				[
					11199,
					-6512
				],
				[
					-8540,
					-5376
				],
				[
					-6629,
					10305
				],
				[
					-16764,
					-3280
				],
				[
					-17735,
					5097
				],
				[
					10457,
					-16752
				],
				[
					10800,
					-3686
				],
				[
					37884,
					2091
				],
				[
					2775,
					-6454
				],
				[
					24366,
					9432
				],
				[
					-126,
					-13488
				],
				[
					-10872,
					-5670
				],
				[
					10848,
					-10578
				],
				[
					-17969,
					-9724
				],
				[
					8956,
					-7192
				],
				[
					12513,
					10731
				],
				[
					492,
					-13968
				],
				[
					-22668,
					1884
				],
				[
					10591,
					-16622
				],
				[
					31700,
					4353
				],
				[
					8432,
					-21625
				],
				[
					-16943,
					-2269
				],
				[
					13969,
					-10092
				],
				[
					21165,
					4822
				],
				[
					20989,
					-5973
				],
				[
					-1649,
					-11827
				],
				[
					-23599,
					-14580
				],
				[
					17686,
					4896
				],
				[
					3517,
					-5569
				],
				[
					14138,
					24931
				],
				[
					5083,
					-30796
				],
				[
					-7121,
					-7098
				],
				[
					6731,
					-11927
				],
				[
					8283,
					37829
				],
				[
					23054,
					-484
				],
				[
					-7703,
					-20371
				],
				[
					-10925,
					-6162
				],
				[
					9855,
					-13086
				],
				[
					-2657,
					-19642
				],
				[
					11607,
					11762
				],
				[
					-3802,
					-21624
				],
				[
					-13321,
					-17224
				],
				[
					5040,
					-1842
				],
				[
					10592,
					20945
				],
				[
					-375,
					-11329
				],
				[
					7820,
					14047
				],
				[
					7150,
					-10983
				],
				[
					-2347,
					-8253
				],
				[
					-15616,
					-9562
				],
				[
					-5782,
					-28243
				],
				[
					-13137,
					-2224
				],
				[
					-2954,
					-21805
				],
				[
					7867,
					14522
				],
				[
					11563,
					-2248
				],
				[
					-7671,
					-6388
				],
				[
					-7138,
					-19826
				],
				[
					-16066,
					-14158
				],
				[
					-4386,
					-15668
				],
				[
					11524,
					17215
				],
				[
					12404,
					10543
				],
				[
					3008,
					12121
				],
				[
					6229,
					-2936
				],
				[
					16648,
					31031
				],
				[
					3672,
					-7583
				],
				[
					7396,
					9526
				],
				[
					-981,
					-13038
				],
				[
					12323,
					9957
				],
				[
					-4243,
					-19305
				],
				[
					-23772,
					-31559
				],
				[
					-2154,
					-17119
				],
				[
					6567,
					13501
				],
				[
					18551,
					21260
				],
				[
					5047,
					17490
				],
				[
					15892,
					7944
				],
				[
					7403,
					17684
				],
				[
					8249,
					5624
				],
				[
					6715,
					-17752
				],
				[
					-3304,
					-14170
				],
				[
					-20001,
					-11901
				],
				[
					11324,
					-9947
				],
				[
					4663,
					8448
				],
				[
					17200,
					-1272
				],
				[
					12006,
					11336
				],
				[
					10532,
					-14909
				],
				[
					-7044,
					-3170
				],
				[
					-7969,
					-15987
				],
				[
					-33938,
					-42585
				],
				[
					5088,
					-4754
				],
				[
					-11048,
					-25216
				],
				[
					7821,
					5088
				],
				[
					7195,
					30122
				],
				[
					18787,
					14233
				],
				[
					20852,
					31708
				],
				[
					5325,
					-3474
				],
				[
					12787,
					31907
				],
				[
					15820,
					7407
				],
				[
					-3449,
					-23766
				],
				[
					-24015,
					-30308
				],
				[
					7280,
					898
				],
				[
					7875,
					16230
				],
				[
					20571,
					17441
				],
				[
					11980,
					-3853
				],
				[
					-3896,
					-35086
				],
				[
					10072,
					-12084
				],
				[
					-9499,
					-3335
				],
				[
					-4068,
					-10600
				],
				[
					14050,
					2974
				],
				[
					-6866,
					-15439
				],
				[
					10441,
					-4835
				],
				[
					15380,
					6429
				],
				[
					17451,
					-17990
				],
				[
					26168,
					7359
				],
				[
					12241,
					-2194
				],
				[
					1562,
					23677
				],
				[
					4773,
					-9292
				],
				[
					24055,
					20365
				],
				[
					-1704,
					-34347
				],
				[
					7217,
					12123
				],
				[
					8662,
					-5997
				],
				[
					-20076,
					-13849
				],
				[
					-19868,
					-2353
				],
				[
					39860,
					-1469
				],
				[
					18437,
					-26453
				],
				[
					25264,
					6948
				],
				[
					4764,
					-18119
				],
				[
					8673,
					37
				],
				[
					-10343,
					-22049
				],
				[
					-30757,
					-2023
				],
				[
					-72,
					-4403
				],
				[
					25032,
					3880
				],
				[
					-3135,
					-11924
				],
				[
					-22046,
					-14480
				],
				[
					-17616,
					6873
				],
				[
					-36429,
					-8390
				],
				[
					-12786,
					-13689
				],
				[
					20673,
					4171
				],
				[
					-18357,
					-12064
				],
				[
					4888,
					-4893
				],
				[
					-24589,
					-3548
				],
				[
					-14227,
					-7099
				],
				[
					-6323,
					-9695
				],
				[
					-19972,
					-8608
				],
				[
					-11848,
					2073
				],
				[
					-37249,
					-13490
				],
				[
					-18722,
					-13183
				],
				[
					-17889,
					1789
				],
				[
					4410,
					-10892
				],
				[
					16584,
					2180
				],
				[
					28465,
					13733
				],
				[
					14060,
					902
				],
				[
					40964,
					22167
				],
				[
					8676,
					8367
				],
				[
					19625,
					8536
				],
				[
					-7312,
					-14493
				],
				[
					-22423,
					-32171
				],
				[
					-13617,
					-1049
				],
				[
					-21790,
					4707
				],
				[
					-11333,
					-4797
				],
				[
					14104,
					-1757
				],
				[
					-9386,
					-15129
				],
				[
					-9456,
					391
				],
				[
					-25872,
					-14694
				],
				[
					-5080,
					-6654
				],
				[
					-21999,
					-10885
				],
				[
					-31943,
					6496
				],
				[
					-6041,
					-6806
				],
				[
					10722,
					-6435
				],
				[
					-20289,
					-975
				],
				[
					-12977,
					-10160
				],
				[
					4448,
					-2733
				],
				[
					-8790,
					-27264
				],
				[
					5918,
					-12847
				],
				[
					-6529,
					-7053
				],
				[
					8767,
					-10417
				],
				[
					6560,
					-23971
				],
				[
					10757,
					14436
				],
				[
					13219,
					4848
				],
				[
					-12584,
					12009
				],
				[
					8508,
					3546
				],
				[
					28613,
					-2950
				],
				[
					29064,
					33332
				],
				[
					12937,
					6367
				],
				[
					15265,
					-1412
				],
				[
					7686,
					13466
				],
				[
					-6549,
					10863
				],
				[
					23358,
					24382
				],
				[
					3975,
					15668
				],
				[
					12614,
					-16
				],
				[
					16637,
					12800
				],
				[
					20071,
					3844
				],
				[
					6237,
					7304
				],
				[
					13176,
					2283
				],
				[
					13888,
					8513
				],
				[
					16528,
					-7589
				],
				[
					15048,
					-798
				],
				[
					2888,
					6552
				],
				[
					-43881,
					9812
				],
				[
					-9215,
					-9892
				],
				[
					-17102,
					9279
				],
				[
					4567,
					16060
				],
				[
					16617,
					2568
				],
				[
					6868,
					5999
				],
				[
					21648,
					-3953
				],
				[
					40501,
					-3703
				],
				[
					1106,
					-6328
				],
				[
					16017,
					5573
				],
				[
					7690,
					-11210
				]
			],
			[
				[
					8654126,
					4493811
				],
				[
					-1950,
					7466
				],
				[
					11740,
					8841
				]
			],
			[
				[
					8663916,
					4510118
				],
				[
					-9790,
					-16307
				]
			],
			[
				[
					8756876,
					2699290
				],
				[
					-12787,
					-24311
				],
				[
					-15003,
					750
				],
				[
					-14550,
					-11574
				],
				[
					-17495,
					915
				],
				[
					-4028,
					-14154
				],
				[
					164,
					-20820
				],
				[
					-5773,
					-590
				],
				[
					8384,
					-16400
				],
				[
					4438,
					-28891
				],
				[
					-6341,
					-7477
				],
				[
					-5913,
					-25561
				],
				[
					5041,
					-34777
				],
				[
					-8851,
					7124
				],
				[
					-4597,
					-15637
				],
				[
					6552,
					-20925
				],
				[
					-11958,
					-427
				],
				[
					-1476,
					-33738
				],
				[
					8631,
					-27197
				],
				[
					-6868,
					-17185
				],
				[
					-9715,
					2606
				],
				[
					-3657,
					-12418
				],
				[
					-11202,
					-11776
				],
				[
					-7898,
					12829
				],
				[
					-1777,
					18345
				],
				[
					-7904,
					12283
				],
				[
					-24313,
					5285
				],
				[
					-683,
					-15342
				],
				[
					-13406,
					13361
				],
				[
					-3775,
					-5657
				],
				[
					-11706,
					7094
				],
				[
					-12915,
					24693
				],
				[
					-4135,
					-13205
				],
				[
					-6385,
					22116
				],
				[
					4350,
					6714
				],
				[
					-15985,
					25924
				],
				[
					676,
					12521
				],
				[
					-8381,
					-16466
				],
				[
					-6375,
					2209
				],
				[
					-3352,
					-13557
				],
				[
					-3363,
					13195
				],
				[
					1744,
					17751
				],
				[
					-32839,
					-3670
				],
				[
					-1767,
					-10464
				],
				[
					-11267,
					10247
				],
				[
					-670,
					13521
				],
				[
					-9514,
					18484
				],
				[
					-1917,
					-4429
				],
				[
					-9397,
					23153
				],
				[
					-5942,
					-5730
				],
				[
					5481,
					-29029
				],
				[
					-6725,
					-8049
				],
				[
					-9892,
					23783
				],
				[
					-6721,
					6091
				],
				[
					-2273,
					20741
				],
				[
					7991,
					9984
				],
				[
					5621,
					-7016
				],
				[
					3221,
					10438
				],
				[
					-4127,
					40413
				],
				[
					-7023,
					17287
				],
				[
					5839,
					11069
				],
				[
					8977,
					-18742
				],
				[
					3576,
					7206
				],
				[
					-6945,
					12102
				],
				[
					3444,
					10608
				],
				[
					-11941,
					28968
				],
				[
					3899,
					6946
				],
				[
					10880,
					-10636
				],
				[
					2656,
					7847
				],
				[
					-11427,
					35819
				],
				[
					-12921,
					6785
				],
				[
					-1508,
					-19801
				],
				[
					-15524,
					-1494
				],
				[
					-4315,
					-16591
				],
				[
					1458,
					-25291
				],
				[
					-7754,
					-4116
				],
				[
					-7629,
					8167
				],
				[
					4437,
					-22766
				],
				[
					-4352,
					-7241
				],
				[
					-9057,
					21946
				],
				[
					-3207,
					-21069
				],
				[
					-6200,
					20003
				],
				[
					-7530,
					-3749
				],
				[
					-5754,
					7493
				],
				[
					-820,
					24204
				],
				[
					-11443,
					-13040
				],
				[
					-10535,
					13585
				],
				[
					-5463,
					-546
				],
				[
					-1792,
					20353
				],
				[
					-6547,
					28228
				],
				[
					13194,
					24915
				],
				[
					13539,
					-7935
				],
				[
					3882,
					-9396
				],
				[
					8031,
					7544
				],
				[
					-2214,
					-14636
				],
				[
					9509,
					2179
				],
				[
					-2507,
					19462
				],
				[
					5450,
					33257
				],
				[
					-7764,
					6802
				],
				[
					13613,
					14630
				],
				[
					-4278,
					19481
				],
				[
					-13292,
					14722
				],
				[
					-13347,
					3849
				],
				[
					-4384,
					-5475
				],
				[
					-17893,
					16131
				],
				[
					-6426,
					26364
				],
				[
					-7495,
					12247
				],
				[
					-10432,
					56
				],
				[
					10476,
					16731
				],
				[
					-12388,
					10226
				],
				[
					1449,
					12652
				],
				[
					-9611,
					12113
				],
				[
					-15242,
					10338
				],
				[
					4207,
					13670
				],
				[
					-3556,
					13678
				],
				[
					5115,
					6964
				],
				[
					14072,
					1478
				],
				[
					2831,
					7871
				],
				[
					-6981,
					11078
				],
				[
					-297,
					16945
				],
				[
					-7702,
					9248
				],
				[
					-2141,
					20880
				],
				[
					20962,
					13821
				],
				[
					9192,
					-3040
				],
				[
					3087,
					9310
				],
				[
					-5789,
					13361
				],
				[
					6409,
					1996
				],
				[
					13394,
					-16107
				],
				[
					11798,
					-4091
				],
				[
					-4003,
					22135
				],
				[
					16038,
					7900
				],
				[
					7390,
					19425
				],
				[
					-15859,
					21152
				],
				[
					-21079,
					39830
				],
				[
					-7234,
					25328
				],
				[
					15935,
					6323
				],
				[
					10052,
					-9128
				],
				[
					-4390,
					-6517
				],
				[
					24466,
					-31185
				],
				[
					14646,
					-22378
				],
				[
					5812,
					3338
				],
				[
					22667,
					-25758
				],
				[
					-7024,
					25081
				],
				[
					8819,
					-10369
				],
				[
					6422,
					10442
				],
				[
					-18477,
					44992
				],
				[
					15880,
					-3894
				],
				[
					-12379,
					14517
				],
				[
					-1568,
					41407
				],
				[
					4714,
					2755
				],
				[
					-13178,
					19262
				],
				[
					564,
					11662
				],
				[
					22704,
					-18614
				],
				[
					13880,
					-17621
				],
				[
					3271,
					-10817
				],
				[
					24421,
					-39774
				],
				[
					10064,
					-1846
				],
				[
					12800,
					-16251
				],
				[
					2832,
					5208
				],
				[
					19633,
					-3557
				],
				[
					-365,
					-17191
				],
				[
					18088,
					-35649
				],
				[
					5050,
					6525
				],
				[
					21833,
					-1600
				],
				[
					-91,
					29107
				],
				[
					11369,
					-7353
				],
				[
					16540,
					7043
				],
				[
					4155,
					20661
				],
				[
					9851,
					8674
				],
				[
					19319,
					-11955
				],
				[
					5480,
					-18138
				],
				[
					13430,
					-7435
				],
				[
					-3418,
					-19425
				],
				[
					25024,
					-4778
				],
				[
					8099,
					19312
				],
				[
					9934,
					-778
				],
				[
					13789,
					-15083
				],
				[
					8945,
					450
				],
				[
					10221,
					-16754
				],
				[
					-133,
					-11385
				],
				[
					23696,
					-3011
				],
				[
					9557,
					12081
				],
				[
					11397,
					-6232
				]
			],
			[
				[
					8387048,
					2713563
				],
				[
					-5870,
					15669
				],
				[
					-4366,
					-16677
				],
				[
					10236,
					1008
				]
			],
			[
				[
					9975114,
					1418542
				],
				[
					-322,
					-4433
				]
			],
			[
				[
					9974792,
					1414109
				],
				[
					-3909,
					3790
				]
			],
			[
				[
					9970883,
					1417899
				],
				[
					4231,
					643
				]
			],
			[
				[
					9995437,
					1430406
				],
				[
					-4547,
					-10081
				]
			],
			[
				[
					9990890,
					1420325
				],
				[
					-414,
					1741
				]
			],
			[
				[
					9990476,
					1422066
				],
				[
					-7146,
					7839
				]
			],
			[
				[
					9983330,
					1429905
				],
				[
					-1112,
					4073
				]
			],
			[
				[
					9982218,
					1433978
				],
				[
					13219,
					-3572
				]
			],
			[
				[
					9990476,
					1422066
				],
				[
					-3574,
					-4157
				]
			],
			[
				[
					9986902,
					1417909
				],
				[
					-7775,
					-4647
				]
			],
			[
				[
					9979127,
					1413262
				],
				[
					-2013,
					-1048
				]
			],
			[
				[
					9977114,
					1412214
				],
				[
					-2322,
					1895
				]
			],
			[
				[
					9975114,
					1418542
				],
				[
					8216,
					11363
				]
			],
			[
				[
					9992065,
					1410865
				],
				[
					5476,
					-9994
				],
				[
					-5423,
					-4388
				]
			],
			[
				[
					9990890,
					1420325
				],
				[
					-1254,
					-3541
				]
			],
			[
				[
					9989353,
					1416930
				],
				[
					-2451,
					979
				]
			],
			[
				[
					9987715,
					1412856
				],
				[
					-6899,
					-9138
				]
			],
			[
				[
					9980816,
					1403718
				],
				[
					-590,
					2336
				]
			],
			[
				[
					9980226,
					1406054
				],
				[
					-160,
					259
				]
			],
			[
				[
					9980066,
					1406313
				],
				[
					-939,
					6949
				]
			],
			[
				[
					9985539,
					1404850
				],
				[
					-5384,
					-3692
				]
			],
			[
				[
					9980155,
					1401158
				],
				[
					661,
					2560
				]
			],
			[
				[
					9980155,
					1401158
				],
				[
					-11136,
					-6495
				]
			],
			[
				[
					9969019,
					1394663
				],
				[
					4410,
					11416
				]
			],
			[
				[
					9973429,
					1406079
				],
				[
					7387,
					-2361
				]
			],
			[
				[
					9980226,
					1406054
				],
				[
					-160,
					259
				]
			],
			[
				[
					9988940,
					1459507
				],
				[
					-1333,
					-17462
				],
				[
					6719,
					1576
				],
				[
					1111,
					-13215
				]
			],
			[
				[
					9982218,
					1433978
				],
				[
					-8328,
					16041
				]
			],
			[
				[
					9973890,
					1450019
				],
				[
					2215,
					9019
				]
			],
			[
				[
					9977114,
					1412214
				],
				[
					-3685,
					-6135
				]
			],
			[
				[
					9969019,
					1394663
				],
				[
					-2254,
					-38
				]
			],
			[
				[
					9966765,
					1394625
				],
				[
					-586,
					10279
				]
			],
			[
				[
					9966179,
					1404904
				],
				[
					393,
					11602
				]
			],
			[
				[
					9966572,
					1416506
				],
				[
					2078,
					7379
				]
			],
			[
				[
					9968650,
					1423885
				],
				[
					2233,
					-5986
				]
			],
			[
				[
					9968650,
					1423885
				],
				[
					5240,
					26134
				]
			],
			[
				[
					9986540,
					1364012
				],
				[
					54,
					268
				]
			],
			[
				[
					9986619,
					1364303
				],
				[
					-70,
					-301
				]
			],
			[
				[
					9991221,
					1393762
				],
				[
					4405,
					-5605
				],
				[
					-9318,
					-25360
				]
			],
			[
				[
					9958667,
					1386884
				],
				[
					8098,
					7741
				]
			],
			[
				[
					9966179,
					1404904
				],
				[
					-6703,
					3038
				]
			],
			[
				[
					9959476,
					1407942
				],
				[
					7096,
					8564
				]
			],
			[
				[
					9946124,
					1393174
				],
				[
					13352,
					14768
				]
			],
			[
				[
					9940165,
					1471356
				],
				[
					-4141,
					-12472
				]
			],
			[
				[
					9942612,
					1480072
				],
				[
					-2479,
					-6528
				]
			],
			[
				[
					9655650,
					1747216
				],
				[
					9215,
					14364
				]
			],
			[
				[
					9440111,
					1776851
				],
				[
					7945,
					18246
				],
				[
					12854,
					-6471
				],
				[
					9330,
					-16937
				],
				[
					-12333,
					-20374
				],
				[
					-13762,
					-7226
				],
				[
					-19087,
					-20388
				],
				[
					-19184,
					-31501
				],
				[
					-9203,
					-10869
				]
			],
			[
				[
					9376513,
					1728675
				],
				[
					7238,
					6734
				],
				[
					303,
					14646
				]
			],
			[
				[
					9387710,
					1757687
				],
				[
					14001,
					-494
				]
			],
			[
				[
					9401711,
					1757193
				],
				[
					886,
					326
				]
			],
			[
				[
					9402597,
					1757519
				],
				[
					-993,
					4567
				]
			],
			[
				[
					9401604,
					1762086
				],
				[
					-113,
					205
				]
			],
			[
				[
					9401491,
					1762291
				],
				[
					-17054,
					1332
				],
				[
					-9342,
					22253
				]
			],
			[
				[
					9375095,
					1785876
				],
				[
					5113,
					2217
				]
			],
			[
				[
					9380208,
					1788093
				],
				[
					4260,
					-17705
				],
				[
					14271,
					3611
				],
				[
					3606,
					14612
				],
				[
					13158,
					3198
				],
				[
					26003,
					-251
				],
				[
					5799,
					3936
				],
				[
					-8252,
					-19228
				]
			],
			[
				[
					9339487,
					1648732
				],
				[
					-8116,
					-3999
				],
				[
					-6185,
					10452
				],
				[
					-9957,
					3450
				]
			],
			[
				[
					9876130,
					1559758
				],
				[
					2980,
					-3
				]
			],
			[
				[
					9872057,
					1562562
				],
				[
					2174,
					-2555
				]
			],
			[
				[
					9863663,
					1546402
				],
				[
					-7951,
					4502
				],
				[
					-5861,
					23933
				],
				[
					7949,
					-11906
				],
				[
					6085,
					2429
				]
			],
			[
				[
					9868869,
					1571552
				],
				[
					-11439,
					4109
				]
			],
			[
				[
					9851047,
					1581792
				],
				[
					-4673,
					-13274
				],
				[
					5327,
					-13027
				]
			],
			[
				[
					9401711,
					1757193
				],
				[
					886,
					326
				]
			],
			[
				[
					9401604,
					1762086
				],
				[
					-113,
					205
				]
			],
			[
				[
					9320622,
					1711113
				],
				[
					9787,
					24487
				],
				[
					4355,
					31668
				],
				[
					7798,
					23118
				]
			],
			[
				[
					9375095,
					1785876
				],
				[
					6072,
					10414
				]
			],
			[
				[
					9345610,
					1796904
				],
				[
					5977,
					-3966
				]
			],
			[
				[
					9386281,
					1792748
				],
				[
					6239,
					8129
				],
				[
					-14094,
					3160
				],
				[
					10960,
					11742
				],
				[
					-21115,
					5251
				],
				[
					-5770,
					13193
				],
				[
					4104,
					32597
				],
				[
					8185,
					13456
				]
			],
			[
				[
					9377396,
					1884762
				],
				[
					16228,
					15647
				],
				[
					6768,
					-10207
				]
			],
			[
				[
					9401245,
					1887091
				],
				[
					4087,
					2283
				]
			],
			[
				[
					9104939,
					1102767
				],
				[
					-893,
					8940
				]
			],
			[
				[
					9104046,
					1111707
				],
				[
					7050,
					8939
				]
			],
			[
				[
					9111096,
					1120646
				],
				[
					-6157,
					-17879
				]
			],
			[
				[
					9103873,
					1112192
				],
				[
					-491,
					755
				]
			],
			[
				[
					9103382,
					1112947
				],
				[
					-6562,
					-6437
				]
			],
			[
				[
					9096820,
					1106510
				],
				[
					-7419,
					20155
				],
				[
					-3007,
					23057
				],
				[
					-6150,
					-9939
				],
				[
					-7281,
					3900
				],
				[
					7583,
					19954
				],
				[
					21312,
					126080
				]
			],
			[
				[
					9101858,
					1289717
				],
				[
					10337,
					-5580
				],
				[
					9256,
					3768
				],
				[
					-14434,
					-27013
				],
				[
					7093,
					-9805
				],
				[
					16075,
					-1321
				],
				[
					-5183,
					-41489
				],
				[
					310,
					-14928
				],
				[
					-6281,
					-18642
				],
				[
					-5761,
					-28923
				],
				[
					-7280,
					-13773
				],
				[
					-2117,
					-19819
				]
			],
			[
				[
					9096806,
					1125934
				],
				[
					0,
					0
				]
			],
			[
				[
					9049484,
					943727
				],
				[
					14001,
					-6826
				],
				[
					-11696,
					-12869
				],
				[
					-10232,
					751
				],
				[
					-5000,
					11821
				],
				[
					12927,
					7123
				]
			],
			[
				[
					9003880,
					955233
				],
				[
					10212,
					-22613
				],
				[
					9653,
					-6043
				],
				[
					1388,
					-9701
				],
				[
					-9483,
					-12381
				],
				[
					-11767,
					-2459
				]
			],
			[
				[
					9003883,
					902036
				],
				[
					-1446,
					13260
				],
				[
					-7449,
					15521
				],
				[
					8892,
					24416
				]
			],
			[
				[
					9067211,
					1047989
				],
				[
					-2471,
					-63
				]
			],
			[
				[
					9064740,
					1047926
				],
				[
					2471,
					63
				]
			],
			[
				[
					9103873,
					1112192
				],
				[
					-491,
					755
				]
			],
			[
				[
					9096820,
					1106510
				],
				[
					1194,
					-14237
				],
				[
					6032,
					19434
				]
			],
			[
				[
					9104939,
					1102767
				],
				[
					4295,
					-4337
				]
			],
			[
				[
					9109234,
					1098430
				],
				[
					-13668,
					-24190
				],
				[
					-11307,
					-9748
				],
				[
					-14250,
					-5629
				],
				[
					-7914,
					2905
				],
				[
					-9374,
					-22200
				],
				[
					-16568,
					-12592
				],
				[
					17181,
					3487
				],
				[
					113,
					8761
				],
				[
					9962,
					8016
				]
			],
			[
				[
					9063409,
					1047240
				],
				[
					392,
					-18458
				]
			],
			[
				[
					9063801,
					1028782
				],
				[
					-11094,
					-9266
				],
				[
					8869,
					-10151
				],
				[
					-21230,
					-17723
				],
				[
					-6359,
					-9175
				],
				[
					6475,
					-14429
				],
				[
					15969,
					17255
				],
				[
					17100,
					-7858
				],
				[
					-1231,
					-11187
				],
				[
					7242,
					4235
				],
				[
					-2712,
					10557
				],
				[
					11556,
					17647
				]
			],
			[
				[
					9088386,
					998687
				],
				[
					10054,
					-4508
				]
			],
			[
				[
					9098440,
					994179
				],
				[
					-5165,
					-6187
				],
				[
					4014,
					-12069
				]
			],
			[
				[
					9097289,
					975923
				],
				[
					-2221,
					-27323
				]
			],
			[
				[
					9095068,
					948600
				],
				[
					-14460,
					-9740
				],
				[
					-1604,
					8132
				],
				[
					-15344,
					7406
				],
				[
					-30095,
					-17451
				],
				[
					-1536,
					8770
				],
				[
					-8920,
					-2304
				],
				[
					-4246,
					-10270
				],
				[
					-6920,
					13796
				]
			],
			[
				[
					9011943,
					946939
				],
				[
					9380,
					10782
				],
				[
					-2422,
					19140
				],
				[
					-10708,
					12715
				],
				[
					-11129,
					3534
				],
				[
					2617,
					-16538
				]
			],
			[
				[
					8999681,
					976572
				],
				[
					-3871,
					17971
				],
				[
					993,
					21817
				],
				[
					-4119,
					7430
				],
				[
					-3286,
					27907
				],
				[
					8675,
					11167
				],
				[
					5542,
					23320
				],
				[
					12998,
					12297
				],
				[
					6100,
					16957
				],
				[
					16883,
					32428
				],
				[
					8414,
					39508
				],
				[
					8291,
					16882
				],
				[
					6193,
					23122
				],
				[
					12227,
					15013
				],
				[
					12365,
					21723
				],
				[
					10225,
					29226
				],
				[
					4547,
					-3623
				]
			],
			[
				[
					9011974,
					946653
				],
				[
					0,
					0
				]
			],
			[
				[
					9003883,
					902036
				],
				[
					-9113,
					-5126
				],
				[
					4557,
					-11174
				],
				[
					36212,
					986
				],
				[
					18178,
					-5321
				],
				[
					-1284,
					-9952
				],
				[
					-8991,
					-16238
				],
				[
					-9580,
					-2071
				],
				[
					-3469,
					6830
				],
				[
					-15567,
					1539
				],
				[
					-5981,
					-9987
				],
				[
					8061,
					-4913
				],
				[
					-18668,
					-9841
				],
				[
					-13790,
					-1197
				],
				[
					-10042,
					4085
				],
				[
					4478,
					-9577
				]
			],
			[
				[
					8978884,
					830079
				],
				[
					-42706,
					32027
				],
				[
					4927,
					-19615
				]
			],
			[
				[
					8941105,
					842491
				],
				[
					-11,
					97
				]
			],
			[
				[
					8941094,
					842588
				],
				[
					-9761,
					17297
				],
				[
					-9790,
					-13734
				],
				[
					-1528,
					-18162
				],
				[
					-9125,
					-4317
				],
				[
					7645,
					-25539
				],
				[
					-34406,
					39512
				],
				[
					-6450,
					-6654
				]
			],
			[
				[
					8877679,
					830991
				],
				[
					-3651,
					17943
				],
				[
					-13742,
					15911
				]
			],
			[
				[
					8860286,
					864845
				],
				[
					-1478,
					9145
				]
			],
			[
				[
					8858808,
					873990
				],
				[
					5240,
					11109
				],
				[
					10425,
					173
				],
				[
					5438,
					-8296
				],
				[
					11407,
					3765
				]
			],
			[
				[
					8891318,
					880741
				],
				[
					17368,
					5746
				],
				[
					8337,
					-13387
				],
				[
					12161,
					19812
				]
			],
			[
				[
					8929184,
					892912
				],
				[
					2442,
					-12218
				],
				[
					10255,
					11025
				],
				[
					-4409,
					18248
				],
				[
					3993,
					17879
				],
				[
					5176,
					-1808
				],
				[
					8326,
					17082
				],
				[
					5488,
					2575
				]
			],
			[
				[
					8960455,
					945695
				],
				[
					6113,
					11304
				],
				[
					14574,
					-6530
				],
				[
					6452,
					17052
				],
				[
					9139,
					148
				],
				[
					7147,
					-12436
				]
			],
			[
				[
					8663051,
					611415
				],
				[
					144,
					-4208
				]
			],
			[
				[
					8663195,
					607207
				],
				[
					-6290,
					-14145
				],
				[
					-8302,
					4232
				]
			],
			[
				[
					8648603,
					597294
				],
				[
					6708,
					22429
				],
				[
					7740,
					-8308
				]
			],
			[
				[
					8648458,
					597381
				],
				[
					24,
					-42
				]
			],
			[
				[
					8648482,
					597339
				],
				[
					93,
					-94
				]
			],
			[
				[
					8648575,
					597245
				],
				[
					2362,
					-8785
				],
				[
					-3456,
					-15189
				],
				[
					-15327,
					-3051
				]
			],
			[
				[
					8632154,
					570220
				],
				[
					-8132,
					9818
				],
				[
					-5947,
					26330
				],
				[
					9439,
					4258
				],
				[
					4937,
					15278
				]
			],
			[
				[
					8632451,
					625904
				],
				[
					10429,
					-18892
				],
				[
					-1954,
					-10537
				],
				[
					7532,
					906
				]
			],
			[
				[
					8770909,
					710697
				],
				[
					-3128,
					-811
				]
			],
			[
				[
					8767781,
					709886
				],
				[
					-1370,
					2345
				]
			],
			[
				[
					8766411,
					712231
				],
				[
					2733,
					4529
				]
			],
			[
				[
					8769144,
					716760
				],
				[
					1765,
					-6063
				]
			],
			[
				[
					8670105,
					774013
				],
				[
					3979,
					-13467
				],
				[
					11671,
					-17693
				],
				[
					31895,
					6463
				]
			],
			[
				[
					8717650,
					749316
				],
				[
					1080,
					-16526
				],
				[
					-5402,
					-15747
				]
			],
			[
				[
					8713328,
					717043
				],
				[
					-6885,
					-8171
				],
				[
					5460,
					-27074
				],
				[
					-4652,
					3249
				],
				[
					-3801,
					-12368
				],
				[
					-11010,
					28743
				],
				[
					-3937,
					-12434
				],
				[
					-11780,
					1926
				],
				[
					1858,
					-8641
				],
				[
					-5523,
					-15148
				],
				[
					2750,
					-10225
				],
				[
					12177,
					-7803
				],
				[
					-14299,
					-1927
				],
				[
					1107,
					-7279
				],
				[
					11445,
					-9681
				],
				[
					-5828,
					-9419
				],
				[
					-7338,
					8183
				]
			],
			[
				[
					8673072,
					628974
				],
				[
					74,
					1017
				]
			],
			[
				[
					8673146,
					629991
				],
				[
					82,
					17706
				],
				[
					-6838,
					11371
				],
				[
					-3233,
					-5363
				],
				[
					-16038,
					12070
				],
				[
					-895,
					22281
				]
			],
			[
				[
					8646224,
					688056
				],
				[
					-859,
					12757
				],
				[
					6829,
					3136
				],
				[
					-10771,
					28235
				],
				[
					-5152,
					4547
				],
				[
					11840,
					18420
				],
				[
					-1818,
					7551
				]
			],
			[
				[
					8646293,
					762702
				],
				[
					1307,
					7248
				]
			],
			[
				[
					8647600,
					769950
				],
				[
					6810,
					-7154
				],
				[
					10229,
					14790
				]
			],
			[
				[
					8664639,
					777586
				],
				[
					5466,
					-3573
				]
			],
			[
				[
					8941094,
					842588
				],
				[
					-1165,
					-9754
				],
				[
					12029,
					-25710
				],
				[
					-7834,
					5396
				],
				[
					-118,
					-9346
				],
				[
					-9655,
					-3956
				],
				[
					6498,
					-4245
				],
				[
					-17819,
					-2564
				],
				[
					-31550,
					-19454
				],
				[
					-6427,
					1736
				],
				[
					-6791,
					-11627
				],
				[
					-9863,
					-4085
				],
				[
					-24242,
					-20373
				],
				[
					4230,
					-5631
				],
				[
					-16021,
					1514
				],
				[
					-5232,
					-6814
				],
				[
					-2589,
					18935
				],
				[
					-7154,
					-522
				],
				[
					7477,
					-12751
				],
				[
					-4592,
					-11721
				],
				[
					-13383,
					7140
				],
				[
					-16721,
					-14161
				]
			],
			[
				[
					8790172,
					714595
				],
				[
					1109,
					5465
				]
			],
			[
				[
					8791281,
					720060
				],
				[
					158,
					14396
				],
				[
					7688,
					11245
				],
				[
					-5594,
					11388
				],
				[
					959,
					9992
				]
			],
			[
				[
					8794492,
					767081
				],
				[
					24331,
					17328
				],
				[
					35158,
					21104
				],
				[
					23698,
					25478
				]
			],
			[
				[
					8978884,
					830079
				],
				[
					-14926,
					-8173
				],
				[
					-7876,
					3736
				],
				[
					-732,
					-16325
				],
				[
					-10895,
					11680
				],
				[
					-3350,
					21494
				]
			],
			[
				[
					8860286,
					864845
				],
				[
					-6715,
					8961
				]
			],
			[
				[
					8853571,
					873806
				],
				[
					5237,
					184
				]
			],
			[
				[
					8875327,
					957118
				],
				[
					-7529,
					-11799
				],
				[
					-2615,
					5609
				]
			],
			[
				[
					8865183,
					950928
				],
				[
					-2011,
					14466
				],
				[
					13234,
					-3092
				],
				[
					-1079,
					-5184
				]
			],
			[
				[
					8923137,
					919757
				],
				[
					-7729,
					-18746
				],
				[
					-5106,
					15551
				],
				[
					-8969,
					11384
				],
				[
					-7885,
					-9027
				],
				[
					-9537,
					20836
				],
				[
					-5972,
					-14665
				],
				[
					-6460,
					12322
				],
				[
					14944,
					20585
				]
			],
			[
				[
					8886423,
					957997
				],
				[
					17865,
					9016
				],
				[
					12068,
					13205
				]
			],
			[
				[
					8916356,
					980218
				],
				[
					-2445,
					-14129
				],
				[
					2716,
					-13547
				],
				[
					-7347,
					-8225
				],
				[
					10273,
					-6604
				],
				[
					3584,
					-17956
				]
			],
			[
				[
					8855819,
					956532
				],
				[
					-2117,
					-16249
				],
				[
					11327,
					-2828
				],
				[
					-1113,
					-17887
				],
				[
					20691,
					-6994
				],
				[
					-1851,
					-14787
				],
				[
					8562,
					-17046
				]
			],
			[
				[
					8853571,
					873806
				],
				[
					-24888,
					38369
				]
			],
			[
				[
					8828683,
					912175
				],
				[
					-9204,
					26187
				],
				[
					-17025,
					-10022
				],
				[
					-4880,
					7612
				],
				[
					-10997,
					-11620
				],
				[
					-3331,
					-12254
				]
			],
			[
				[
					8783246,
					912078
				],
				[
					1357,
					7108
				],
				[
					-8486,
					6118
				],
				[
					-4709,
					40279
				],
				[
					2459,
					10238
				],
				[
					-10773,
					-13372
				],
				[
					-8838,
					5545
				],
				[
					-1104,
					11377
				],
				[
					-13653,
					-5081
				],
				[
					-2475,
					8967
				],
				[
					-7252,
					-3093
				],
				[
					8886,
					14037
				],
				[
					-3021,
					8724
				]
			],
			[
				[
					8735637,
					1002925
				],
				[
					-2440,
					12337
				]
			],
			[
				[
					8733197,
					1015262
				],
				[
					17124,
					-9677
				],
				[
					-1012,
					5745
				],
				[
					23402,
					1080
				],
				[
					-1722,
					-6638
				],
				[
					7764,
					-11879
				],
				[
					20310,
					-799
				],
				[
					-16563,
					-9595
				],
				[
					9713,
					-7519
				],
				[
					26142,
					8915
				],
				[
					-3934,
					8190
				],
				[
					12154,
					-1075
				],
				[
					24693,
					-7981
				],
				[
					15327,
					-10918
				],
				[
					-10776,
					-16579
				]
			],
			[
				[
					8805918,
					979419
				],
				[
					0,
					0
				]
			],
			[
				[
					8611595,
					904962
				],
				[
					10735,
					16926
				],
				[
					13664,
					9133
				]
			],
			[
				[
					8635994,
					931021
				],
				[
					-13458,
					-20424
				],
				[
					-10941,
					-5635
				]
			],
			[
				[
					8678493,
					986350
				],
				[
					12569,
					3880
				],
				[
					5200,
					-6537
				]
			],
			[
				[
					8696262,
					983693
				],
				[
					-619,
					-12763
				],
				[
					-8904,
					-7808
				],
				[
					-3668,
					12495
				],
				[
					-6002,
					-2595
				],
				[
					1055,
					-10788
				],
				[
					-4909,
					-16775
				],
				[
					-21939,
					-6042
				],
				[
					-3806,
					-12233
				],
				[
					-11459,
					3881
				]
			],
			[
				[
					8636011,
					931065
				],
				[
					3024,
					9776
				],
				[
					8723,
					5910
				],
				[
					15286,
					24410
				],
				[
					-1331,
					6382
				],
				[
					14950,
					21832
				],
				[
					1830,
					-13025
				]
			],
			[
				[
					8724094,
					1035490
				],
				[
					6415,
					-11476
				]
			],
			[
				[
					8730509,
					1024014
				],
				[
					-15923,
					-8509
				],
				[
					2105,
					14264
				],
				[
					7403,
					5721
				]
			],
			[
				[
					8727362,
					1029504
				],
				[
					0,
					0
				]
			],
			[
				[
					8783246,
					912078
				],
				[
					980,
					-19083
				],
				[
					-5995,
					-3812
				]
			],
			[
				[
					8778231,
					889183
				],
				[
					-21101,
					6081
				],
				[
					-19593,
					2080
				],
				[
					-12140,
					-12702
				],
				[
					-6980,
					11208
				],
				[
					-11828,
					1716
				],
				[
					-31386,
					-2474
				],
				[
					-7024,
					-6617
				],
				[
					-7229,
					7471
				],
				[
					-13840,
					2643
				],
				[
					-14060,
					-9340
				],
				[
					-796,
					-12461
				],
				[
					-15742,
					9485
				],
				[
					-10674,
					-6413
				],
				[
					5757,
					25102
				]
			],
			[
				[
					8635994,
					931021
				],
				[
					17,
					44
				]
			],
			[
				[
					8696262,
					983693
				],
				[
					14424,
					-15737
				],
				[
					4038,
					8630
				],
				[
					-5043,
					6745
				],
				[
					12618,
					4901
				],
				[
					-3247,
					5943
				],
				[
					16585,
					8750
				]
			],
			[
				[
					8794492,
					767081
				],
				[
					3633,
					17484
				],
				[
					-7256,
					3720
				],
				[
					-7755,
					-5585
				]
			],
			[
				[
					8783114,
					782700
				],
				[
					-1566,
					23924
				],
				[
					-25695,
					26893
				],
				[
					-10709,
					-3064
				],
				[
					279,
					-15903
				],
				[
					14584,
					-17950
				]
			],
			[
				[
					8760007,
					796600
				],
				[
					-2505,
					-8699
				]
			],
			[
				[
					8757502,
					787901
				],
				[
					-6813,
					-2623
				],
				[
					-13374,
					-17286
				]
			],
			[
				[
					8737315,
					767992
				],
				[
					-2304,
					-6031
				]
			],
			[
				[
					8735011,
					761961
				],
				[
					-7275,
					-10563
				]
			],
			[
				[
					8727736,
					751398
				],
				[
					-10086,
					-2082
				]
			],
			[
				[
					8670105,
					774013
				],
				[
					3295,
					6866
				],
				[
					22861,
					17387
				],
				[
					840,
					14511
				],
				[
					-9192,
					16360
				]
			],
			[
				[
					8687909,
					829137
				],
				[
					5049,
					16349
				],
				[
					31844,
					22322
				],
				[
					23393,
					8843
				],
				[
					22752,
					136
				]
			],
			[
				[
					8770947,
					876787
				],
				[
					3354,
					-15846
				],
				[
					12927,
					128
				],
				[
					4119,
					16513
				]
			],
			[
				[
					8791347,
					877582
				],
				[
					4303,
					2110
				]
			],
			[
				[
					8795650,
					879692
				],
				[
					1648,
					-4845
				],
				[
					19674,
					-2288
				],
				[
					-2309,
					12388
				],
				[
					12212,
					-7164
				],
				[
					-6049,
					25017
				],
				[
					7857,
					9375
				]
			],
			[
				[
					8677771,
					821751
				],
				[
					0,
					0
				]
			],
			[
				[
					8664639,
					777586
				],
				[
					1780,
					2503
				]
			],
			[
				[
					8666419,
					780089
				],
				[
					18574,
					27936
				],
				[
					1961,
					9920
				],
				[
					-5313,
					9457
				]
			],
			[
				[
					8681641,
					827402
				],
				[
					6268,
					1735
				]
			],
			[
				[
					8680340,
					829559
				],
				[
					-5442,
					482
				]
			],
			[
				[
					8674898,
					830041
				],
				[
					5442,
					-482
				]
			],
			[
				[
					8670094,
					825152
				],
				[
					-5388,
					-3613
				]
			],
			[
				[
					8664706,
					821539
				],
				[
					-19703,
					6515
				],
				[
					-4406,
					-9814
				]
			],
			[
				[
					8640597,
					818240
				],
				[
					6942,
					-7276
				]
			],
			[
				[
					8647539,
					810964
				],
				[
					-8225,
					-17160
				],
				[
					8286,
					-23854
				]
			],
			[
				[
					8646293,
					762702
				],
				[
					-11224,
					-12987
				],
				[
					-13329,
					1774
				],
				[
					-5115,
					19748
				],
				[
					-5502,
					-1540
				]
			],
			[
				[
					8611123,
					769697
				],
				[
					-3934,
					-3840
				],
				[
					-4354,
					13985
				],
				[
					-5129,
					-2940
				],
				[
					-5355,
					26938
				],
				[
					9219,
					-1555
				],
				[
					-4338,
					14557
				]
			],
			[
				[
					8597232,
					816842
				],
				[
					29150,
					24795
				],
				[
					34180,
					17438
				],
				[
					9052,
					18411
				],
				[
					6058,
					-10446
				],
				[
					-7230,
					-19286
				],
				[
					1652,
					-22602
				]
			],
			[
				[
					8673072,
					628974
				],
				[
					-9877,
					-21767
				]
			],
			[
				[
					8663051,
					611415
				],
				[
					892,
					13965
				],
				[
					-7402,
					13682
				],
				[
					3996,
					7381
				],
				[
					12609,
					-16452
				]
			],
			[
				[
					8628298,
					674102
				],
				[
					0,
					0
				]
			],
			[
				[
					8646224,
					688056
				],
				[
					-5260,
					3834
				],
				[
					944,
					-20956
				],
				[
					-12443,
					10387
				],
				[
					-14512,
					-19727
				]
			],
			[
				[
					8614953,
					661594
				],
				[
					964,
					8551
				],
				[
					-17033,
					25172
				],
				[
					-956,
					12155
				]
			],
			[
				[
					8597928,
					707472
				],
				[
					6554,
					14817
				],
				[
					-1451,
					8766
				],
				[
					19289,
					-742
				],
				[
					-11197,
					39384
				]
			],
			[
				[
					8597928,
					707472
				],
				[
					-3294,
					-7928
				],
				[
					-14590,
					9481
				],
				[
					2164,
					-18161
				],
				[
					8553,
					-19190
				],
				[
					-10735,
					8131
				],
				[
					1456,
					-8971
				],
				[
					-9720,
					-9165
				],
				[
					3222,
					-6985
				],
				[
					-13040,
					-20213
				]
			],
			[
				[
					8561944,
					634471
				],
				[
					-19354,
					35052
				],
				[
					-12432,
					4426
				],
				[
					-8536,
					12323
				],
				[
					-7123,
					-3795
				]
			],
			[
				[
					8514499,
					682477
				],
				[
					173,
					36691
				]
			],
			[
				[
					8514672,
					719168
				],
				[
					507,
					11294
				],
				[
					36396,
					40154
				],
				[
					21492,
					20250
				],
				[
					24165,
					25976
				]
			],
			[
				[
					8614953,
					661594
				],
				[
					17498,
					-35690
				]
			],
			[
				[
					8632154,
					570220
				],
				[
					5496,
					-6318
				],
				[
					-7914,
					-16116
				],
				[
					-10904,
					-341
				],
				[
					-2898,
					-7766
				],
				[
					8112,
					-11925
				],
				[
					-5555,
					-13177
				],
				[
					-3131,
					9928
				],
				[
					-2720,
					-12968
				],
				[
					-10303,
					-13841
				],
				[
					-4835,
					3336
				],
				[
					-1027,
					-14945
				],
				[
					-5730,
					102
				],
				[
					152,
					13251
				],
				[
					-6090,
					-22912
				],
				[
					-879,
					17473
				],
				[
					-4212,
					-8028
				],
				[
					-7180,
					25327
				],
				[
					2375,
					-24501
				],
				[
					-4507,
					-10142
				],
				[
					-8021,
					1464
				],
				[
					-7364,
					-28118
				]
			],
			[
				[
					8555019,
					450003
				],
				[
					-2540,
					4228
				]
			],
			[
				[
					8552479,
					454231
				],
				[
					-4835,
					7454
				]
			],
			[
				[
					8547644,
					461685
				],
				[
					-2058,
					8411
				],
				[
					12602,
					40797
				],
				[
					-16291,
					13106
				],
				[
					1501,
					8191
				],
				[
					-6918,
					8165
				],
				[
					17935,
					74263
				],
				[
					7529,
					19853
				]
			],
			[
				[
					8461985,
					656917
				],
				[
					63,
					-7049
				],
				[
					-12711,
					-30386
				],
				[
					-763,
					6781
				],
				[
					13411,
					30654
				]
			],
			[
				[
					8514499,
					682477
				],
				[
					-2882,
					-3354
				],
				[
					-9342,
					13688
				]
			],
			[
				[
					8502275,
					692811
				],
				[
					-414,
					8518
				],
				[
					-13415,
					-7358
				],
				[
					-17018,
					-27433
				],
				[
					-7417,
					-16210
				],
				[
					-932,
					7031
				],
				[
					9953,
					20407
				],
				[
					18718,
					28293
				],
				[
					18802,
					20257
				],
				[
					4120,
					-7148
				]
			],
			[
				[
					8530749,
					442077
				],
				[
					5574,
					-9162
				],
				[
					-6495,
					-11966
				],
				[
					-4521,
					7438
				],
				[
					5442,
					13690
				]
			],
			[
				[
					8555019,
					450003
				],
				[
					-2540,
					4228
				]
			],
			[
				[
					8484870,
					516426
				],
				[
					493,
					1391
				]
			],
			[
				[
					8485363,
					517817
				],
				[
					-493,
					-1391
				]
			],
			[
				[
					8484620,
					515721
				],
				[
					5904,
					-19816
				],
				[
					-5910,
					-13627
				],
				[
					-1529,
					12487
				],
				[
					-5728,
					-632
				],
				[
					-1774,
					11204
				]
			],
			[
				[
					8475583,
					505337
				],
				[
					3840,
					17345
				],
				[
					5197,
					-6961
				]
			],
			[
				[
					8547644,
					461685
				],
				[
					1236,
					-15922
				],
				[
					-10217,
					-5139
				],
				[
					-4255,
					14280
				],
				[
					-2075,
					-8881
				],
				[
					-15180,
					-9625
				],
				[
					-6669,
					18443
				],
				[
					2543,
					23113
				],
				[
					-1896,
					8800
				],
				[
					-3596,
					-23486
				],
				[
					-937,
					26859
				],
				[
					-12094,
					21632
				],
				[
					-7255,
					-1404
				],
				[
					1008,
					16377
				]
			],
			[
				[
					8488257,
					526732
				],
				[
					-7910,
					-174
				],
				[
					-12757,
					41913
				]
			],
			[
				[
					8467590,
					568471
				],
				[
					-388,
					3520
				]
			],
			[
				[
					8467202,
					571991
				],
				[
					-2039,
					7674
				]
			],
			[
				[
					8465163,
					579665
				],
				[
					-1212,
					1529
				]
			],
			[
				[
					8463951,
					581194
				],
				[
					-1690,
					4470
				]
			],
			[
				[
					8462261,
					585664
				],
				[
					8948,
					33672
				],
				[
					1755,
					23357
				],
				[
					16239,
					33149
				],
				[
					13072,
					16969
				]
			],
			[
				[
					8466768,
					582780
				],
				[
					0,
					0
				]
			],
			[
				[
					8475749,
					530106
				],
				[
					0,
					0
				]
			],
			[
				[
					9183193,
					1082287
				],
				[
					-12169,
					-1808
				]
			],
			[
				[
					9171024,
					1080479
				],
				[
					7616,
					7628
				],
				[
					4553,
					-5820
				]
			],
			[
				[
					9170934,
					1080594
				],
				[
					-2223,
					2787
				]
			],
			[
				[
					9168711,
					1083381
				],
				[
					-3145,
					126
				]
			],
			[
				[
					9165566,
					1083507
				],
				[
					-864,
					4830
				]
			],
			[
				[
					9164702,
					1088337
				],
				[
					603,
					5786
				]
			],
			[
				[
					9165305,
					1094123
				],
				[
					5066,
					49
				],
				[
					563,
					-13578
				]
			],
			[
				[
					9169426,
					1090595
				],
				[
					0,
					0
				]
			],
			[
				[
					9170934,
					1080594
				],
				[
					90,
					-115
				]
			],
			[
				[
					9183193,
					1082287
				],
				[
					-7230,
					-16499
				],
				[
					1629,
					-9209
				],
				[
					-8882,
					-6267
				]
			],
			[
				[
					9168710,
					1050312
				],
				[
					7641,
					6944
				],
				[
					-10718,
					11986
				]
			],
			[
				[
					9165633,
					1069242
				],
				[
					3078,
					14139
				]
			],
			[
				[
					9147856,
					1011583
				],
				[
					3787,
					19922
				],
				[
					20327,
					13245
				]
			],
			[
				[
					9171970,
					1044750
				],
				[
					11117,
					886
				],
				[
					4662,
					-14490
				],
				[
					-14287,
					-6173
				],
				[
					-6082,
					-10736
				],
				[
					-19524,
					-2654
				]
			],
			[
				[
					9201015,
					1050339
				],
				[
					-1863,
					-9973
				],
				[
					-10954,
					2174
				],
				[
					12817,
					7799
				]
			],
			[
				[
					9165566,
					1083507
				],
				[
					-3929,
					1485
				]
			],
			[
				[
					9161637,
					1084992
				],
				[
					182,
					4284
				]
			],
			[
				[
					9161819,
					1089276
				],
				[
					2883,
					-939
				]
			],
			[
				[
					9161819,
					1089276
				],
				[
					-1303,
					3974
				]
			],
			[
				[
					9160516,
					1093250
				],
				[
					4789,
					873
				]
			],
			[
				[
					9161637,
					1084992
				],
				[
					-8949,
					-1176
				]
			],
			[
				[
					9152688,
					1083816
				],
				[
					30,
					15946
				],
				[
					-5585,
					1762
				]
			],
			[
				[
					9147133,
					1101524
				],
				[
					3576,
					4762
				],
				[
					11249,
					-5998
				],
				[
					-1442,
					-7038
				]
			],
			[
				[
					9159262,
					1100676
				],
				[
					0,
					0
				]
			],
			[
				[
					9122464,
					1048474
				],
				[
					8264,
					-6412
				]
			],
			[
				[
					9130728,
					1042062
				],
				[
					-929,
					-5638
				],
				[
					-24410,
					-28415
				],
				[
					-2517,
					-15823
				]
			],
			[
				[
					9102872,
					992186
				],
				[
					-4432,
					1993
				]
			],
			[
				[
					9088386,
					998687
				],
				[
					4287,
					8960
				],
				[
					24502,
					30289
				],
				[
					-10815,
					-4618
				]
			],
			[
				[
					9106360,
					1033318
				],
				[
					-6561,
					-1490
				]
			],
			[
				[
					9099799,
					1031828
				],
				[
					654,
					7197
				]
			],
			[
				[
					9100453,
					1039025
				],
				[
					12356,
					11539
				]
			],
			[
				[
					9112809,
					1050564
				],
				[
					9655,
					-2090
				]
			],
			[
				[
					9168710,
					1050312
				],
				[
					3260,
					-5562
				]
			],
			[
				[
					9147856,
					1011583
				],
				[
					-2212,
					-4633
				],
				[
					10796,
					-8874
				],
				[
					-4384,
					-9045
				],
				[
					-9838,
					-3271
				],
				[
					-2930,
					-10572
				]
			],
			[
				[
					9139288,
					975188
				],
				[
					-36416,
					16998
				]
			],
			[
				[
					9130728,
					1042062
				],
				[
					4360,
					-1732
				],
				[
					7191,
					14721
				]
			],
			[
				[
					9142279,
					1055051
				],
				[
					-4,
					2608
				]
			],
			[
				[
					9142275,
					1057659
				],
				[
					2082,
					10135
				]
			],
			[
				[
					9144357,
					1067794
				],
				[
					2509,
					519
				]
			],
			[
				[
					9146866,
					1068313
				],
				[
					4286,
					-8671
				],
				[
					14481,
					9600
				]
			],
			[
				[
					9152635,
					1055962
				],
				[
					0,
					0
				]
			],
			[
				[
					9137534,
					1066218
				],
				[
					5999,
					1325
				]
			],
			[
				[
					9143533,
					1067543
				],
				[
					824,
					251
				]
			],
			[
				[
					9142275,
					1057659
				],
				[
					4,
					-2608
				]
			],
			[
				[
					9122464,
					1048474
				],
				[
					-1536,
					12032
				],
				[
					8491,
					11236
				]
			],
			[
				[
					9129419,
					1071742
				],
				[
					8115,
					-5524
				]
			],
			[
				[
					9135403,
					1071426
				],
				[
					3172,
					5163
				]
			],
			[
				[
					9138575,
					1076589
				],
				[
					-3172,
					-5163
				]
			],
			[
				[
					9146866,
					1068313
				],
				[
					2503,
					10967
				]
			],
			[
				[
					9149369,
					1079280
				],
				[
					3319,
					4536
				]
			],
			[
				[
					9149369,
					1079280
				],
				[
					-6735,
					1526
				]
			],
			[
				[
					9142634,
					1080806
				],
				[
					4499,
					20718
				]
			],
			[
				[
					9099446,
					1028906
				],
				[
					2,
					288
				]
			],
			[
				[
					9099448,
					1029194
				],
				[
					-2,
					-288
				]
			],
			[
				[
					9106360,
					1033318
				],
				[
					-6741,
					-1878
				]
			],
			[
				[
					9099619,
					1031440
				],
				[
					180,
					388
				]
			],
			[
				[
					9143533,
					1067543
				],
				[
					-1100,
					6295
				]
			],
			[
				[
					9142433,
					1073838
				],
				[
					-542,
					2262
				]
			],
			[
				[
					9141891,
					1076100
				],
				[
					743,
					4706
				]
			],
			[
				[
					9140439,
					1079675
				],
				[
					1452,
					-3575
				]
			],
			[
				[
					9142433,
					1073838
				],
				[
					-4899,
					-7620
				]
			],
			[
				[
					9129419,
					1071742
				],
				[
					5984,
					-316
				]
			],
			[
				[
					9138575,
					1076589
				],
				[
					1864,
					3086
				]
			],
			[
				[
					9100453,
					1039025
				],
				[
					-10504,
					-6097
				],
				[
					633,
					-12980
				]
			],
			[
				[
					9090582,
					1019948
				],
				[
					-6231,
					-2582
				],
				[
					-8226,
					8051
				],
				[
					10534,
					19390
				],
				[
					17337,
					16149
				]
			],
			[
				[
					9103996,
					1060956
				],
				[
					3900,
					4084
				]
			],
			[
				[
					9107896,
					1065040
				],
				[
					4913,
					-14476
				]
			],
			[
				[
					9138582,
					1094359
				],
				[
					-2966,
					5201
				]
			],
			[
				[
					9135616,
					1099560
				],
				[
					2328,
					5565
				]
			],
			[
				[
					9137944,
					1105125
				],
				[
					638,
					-10766
				]
			],
			[
				[
					9099619,
					1031440
				],
				[
					-171,
					-2246
				]
			],
			[
				[
					9099446,
					1028906
				],
				[
					-8864,
					-8958
				]
			],
			[
				[
					9125894,
					1119607
				],
				[
					-4240,
					-11798
				],
				[
					-13805,
					-20134
				],
				[
					2691,
					-4818
				]
			],
			[
				[
					9110540,
					1082857
				],
				[
					-13268,
					-19123
				],
				[
					-6825,
					7
				],
				[
					7466,
					10058
				],
				[
					19337,
					36351
				],
				[
					8644,
					9457
				]
			],
			[
				[
					9106099,
					1084944
				],
				[
					0,
					0
				]
			],
			[
				[
					9111096,
					1120646
				],
				[
					6329,
					-6244
				],
				[
					-8191,
					-15972
				]
			],
			[
				[
					9115616,
					1076280
				],
				[
					-7720,
					-11240
				]
			],
			[
				[
					9103996,
					1060956
				],
				[
					11620,
					15324
				]
			],
			[
				[
					9135616,
					1099560
				],
				[
					-7895,
					-19993
				],
				[
					-12086,
					-3306
				]
			],
			[
				[
					9115635,
					1076261
				],
				[
					5418,
					14202
				],
				[
					8096,
					2255
				],
				[
					5538,
					22700
				],
				[
					3257,
					-10293
				]
			],
			[
				[
					9125894,
					1119607
				],
				[
					5974,
					3114
				],
				[
					-160,
					-20060
				],
				[
					-9419,
					-2953
				],
				[
					-11749,
					-16851
				]
			],
			[
				[
					9138582,
					1094359
				],
				[
					-8723,
					-16239
				],
				[
					9367,
					8885
				],
				[
					1213,
					-7330
				]
			],
			[
				[
					9115616,
					1076280
				],
				[
					19,
					-19
				]
			],
			[
				[
					9063409,
					1047240
				],
				[
					1331,
					686
				]
			],
			[
				[
					9067211,
					1047989
				],
				[
					14497,
					10404
				],
				[
					-7739,
					-16338
				],
				[
					-776,
					-13302
				],
				[
					-9392,
					29
				]
			],
			[
				[
					9102872,
					992186
				],
				[
					-5583,
					-16263
				]
			],
			[
				[
					8929184,
					892912
				],
				[
					-6047,
					26845
				]
			],
			[
				[
					8916356,
					980218
				],
				[
					12535,
					10039
				],
				[
					13684,
					22102
				],
				[
					4800,
					-8768
				],
				[
					4005,
					-25555
				],
				[
					-4383,
					-21346
				],
				[
					5075,
					8297
				],
				[
					9331,
					-10113
				],
				[
					-948,
					-9179
				]
			],
			[
				[
					8855819,
					956532
				],
				[
					9364,
					-5604
				]
			],
			[
				[
					8875327,
					957118
				],
				[
					11096,
					879
				]
			],
			[
				[
					9139288,
					975188
				],
				[
					-9112,
					-1046
				],
				[
					-12447,
					-18084
				],
				[
					-22661,
					-7458
				]
			],
			[
				[
					8797813,
					894813
				],
				[
					-2163,
					-15121
				]
			],
			[
				[
					8791347,
					877582
				],
				[
					-1873,
					13202
				],
				[
					8339,
					4029
				]
			],
			[
				[
					8797813,
					894813
				],
				[
					0,
					0
				]
			],
			[
				[
					8761925,
					753617
				],
				[
					8190,
					-16416
				],
				[
					-1688,
					-4960
				]
			],
			[
				[
					8768427,
					732241
				],
				[
					-332,
					-2748
				]
			],
			[
				[
					8768095,
					729493
				],
				[
					-4655,
					4607
				]
			],
			[
				[
					8763440,
					734100
				],
				[
					-3950,
					3484
				]
			],
			[
				[
					8759490,
					737584
				],
				[
					-3670,
					10403
				]
			],
			[
				[
					8755820,
					747987
				],
				[
					6105,
					5630
				]
			],
			[
				[
					8783114,
					782700
				],
				[
					-12342,
					-10525
				],
				[
					-4965,
					10806
				],
				[
					4206,
					8138
				],
				[
					-4485,
					9158
				],
				[
					-5521,
					-3677
				]
			],
			[
				[
					8794492,
					767081
				],
				[
					-13896,
					-12751
				]
			],
			[
				[
					8780596,
					754330
				],
				[
					-18671,
					-713
				]
			],
			[
				[
					8755820,
					747987
				],
				[
					-7005,
					2602
				]
			],
			[
				[
					8748815,
					750589
				],
				[
					413,
					1526
				]
			],
			[
				[
					8749228,
					752115
				],
				[
					-332,
					4239
				]
			],
			[
				[
					8748896,
					756354
				],
				[
					11409,
					27884
				],
				[
					-2803,
					3663
				]
			],
			[
				[
					8773271,
					721797
				],
				[
					42,
					-5
				]
			],
			[
				[
					8773313,
					721792
				],
				[
					1454,
					-2792
				]
			],
			[
				[
					8774767,
					719000
				],
				[
					-3858,
					-8303
				]
			],
			[
				[
					8769144,
					716760
				],
				[
					4127,
					5037
				]
			],
			[
				[
					8766411,
					712231
				],
				[
					-2373,
					2717
				]
			],
			[
				[
					8764038,
					714948
				],
				[
					587,
					8020
				]
			],
			[
				[
					8764625,
					722968
				],
				[
					3470,
					6525
				]
			],
			[
				[
					8768427,
					732241
				],
				[
					4844,
					-10444
				]
			],
			[
				[
					8764625,
					722968
				],
				[
					-1190,
					1320
				]
			],
			[
				[
					8763435,
					724288
				],
				[
					-980,
					3222
				]
			],
			[
				[
					8762455,
					727510
				],
				[
					985,
					6590
				]
			],
			[
				[
					8764256,
					724918
				],
				[
					0,
					0
				]
			],
			[
				[
					9186632,
					545516
				],
				[
					-10425,
					-4918
				],
				[
					-14452,
					2133
				],
				[
					24877,
					2785
				]
			],
			[
				[
					8764038,
					714948
				],
				[
					-2978,
					4567
				]
			],
			[
				[
					8761060,
					719515
				],
				[
					2375,
					4773
				]
			],
			[
				[
					8780596,
					754330
				],
				[
					-8013,
					-10881
				],
				[
					7604,
					304
				],
				[
					998,
					-12447
				],
				[
					9832,
					2939
				],
				[
					264,
					-14185
				]
			],
			[
				[
					8790172,
					714595
				],
				[
					-16859,
					7197
				]
			],
			[
				[
					8759674,
					719541
				],
				[
					-64,
					91
				]
			],
			[
				[
					8759610,
					719632
				],
				[
					64,
					-91
				]
			],
			[
				[
					8756589,
					723060
				],
				[
					19,
					45
				]
			],
			[
				[
					8756608,
					723105
				],
				[
					-19,
					-45
				]
			],
			[
				[
					8756707,
					723346
				],
				[
					22,
					53
				]
			],
			[
				[
					8756729,
					723399
				],
				[
					-22,
					-53
				]
			],
			[
				[
					8761060,
					719515
				],
				[
					-4302,
					3954
				]
			],
			[
				[
					8756758,
					723469
				],
				[
					5697,
					4041
				]
			],
			[
				[
					8756589,
					723060
				],
				[
					19,
					45
				]
			],
			[
				[
					8756707,
					723346
				],
				[
					22,
					53
				]
			],
			[
				[
					8756758,
					723469
				],
				[
					-1475,
					5243
				]
			],
			[
				[
					8755283,
					728712
				],
				[
					331,
					1047
				]
			],
			[
				[
					8755614,
					729759
				],
				[
					1031,
					2424
				]
			],
			[
				[
					8756645,
					732183
				],
				[
					2845,
					5401
				]
			],
			[
				[
					8774767,
					719000
				],
				[
					3917,
					-7063
				],
				[
					-4099,
					-10531
				],
				[
					-6804,
					8480
				]
			],
			[
				[
					8761555,
					714375
				],
				[
					-5953,
					-393
				]
			],
			[
				[
					8755602,
					713982
				],
				[
					-40,
					23
				]
			],
			[
				[
					8755562,
					714005
				],
				[
					3352,
					1438
				]
			],
			[
				[
					8758914,
					715443
				],
				[
					617,
					563
				]
			],
			[
				[
					8759531,
					716006
				],
				[
					2024,
					-1631
				]
			],
			[
				[
					8759531,
					716006
				],
				[
					666,
					1266
				]
			],
			[
				[
					8760197,
					717272
				],
				[
					1358,
					-2897
				]
			],
			[
				[
					8759674,
					719541
				],
				[
					-64,
					91
				]
			],
			[
				[
					8758914,
					715443
				],
				[
					-3614,
					3731
				]
			],
			[
				[
					8755300,
					719174
				],
				[
					983,
					3145
				]
			],
			[
				[
					8756283,
					722319
				],
				[
					3914,
					-5047
				]
			],
			[
				[
					8755562,
					714005
				],
				[
					-958,
					5106
				]
			],
			[
				[
					8754604,
					719111
				],
				[
					696,
					63
				]
			],
			[
				[
					8754604,
					719111
				],
				[
					-2418,
					-3169
				]
			],
			[
				[
					8752186,
					715942
				],
				[
					-3289,
					7664
				]
			],
			[
				[
					8748897,
					723606
				],
				[
					-1981,
					3050
				]
			],
			[
				[
					8746916,
					726656
				],
				[
					911,
					692
				]
			],
			[
				[
					8747827,
					727348
				],
				[
					2802,
					2740
				]
			],
			[
				[
					8750629,
					730088
				],
				[
					5654,
					-7769
				]
			],
			[
				[
					8755283,
					728712
				],
				[
					-1639,
					1672
				]
			],
			[
				[
					8753644,
					730384
				],
				[
					1970,
					-625
				]
			],
			[
				[
					8755602,
					713982
				],
				[
					586,
					-1725
				]
			],
			[
				[
					8756188,
					712257
				],
				[
					-787,
					-3572
				]
			],
			[
				[
					8755401,
					708685
				],
				[
					-4245,
					-2715
				]
			],
			[
				[
					8751156,
					705970
				],
				[
					-621,
					6616
				]
			],
			[
				[
					8750535,
					712586
				],
				[
					1651,
					3356
				]
			],
			[
				[
					8756188,
					712257
				],
				[
					6238,
					-6778
				]
			],
			[
				[
					8762426,
					705479
				],
				[
					-413,
					-724
				]
			],
			[
				[
					8762013,
					704755
				],
				[
					-6612,
					3930
				]
			],
			[
				[
					8762013,
					704755
				],
				[
					-586,
					-7861
				],
				[
					-9545,
					3984
				]
			],
			[
				[
					8751882,
					700878
				],
				[
					-726,
					5092
				]
			],
			[
				[
					8750535,
					712586
				],
				[
					-1638,
					11020
				]
			],
			[
				[
					8749090,
					670684
				],
				[
					-110,
					-243
				]
			],
			[
				[
					8748980,
					670441
				],
				[
					110,
					243
				]
			],
			[
				[
					8751882,
					700878
				],
				[
					-2433,
					-28910
				]
			],
			[
				[
					8749449,
					671968
				],
				[
					-5958,
					-3738
				],
				[
					-10315,
					7526
				],
				[
					2915,
					13653
				]
			],
			[
				[
					8736091,
					689409
				],
				[
					-4831,
					17283
				],
				[
					8403,
					-2960
				],
				[
					2980,
					10990
				],
				[
					-5609,
					10875
				]
			],
			[
				[
					8737034,
					725597
				],
				[
					9882,
					1059
				]
			],
			[
				[
					8749090,
					670684
				],
				[
					-110,
					-243
				]
			],
			[
				[
					8762426,
					705479
				],
				[
					4441,
					-25423
				],
				[
					-7604,
					-10299
				],
				[
					-9814,
					2211
				]
			],
			[
				[
					8727736,
					751398
				],
				[
					2076,
					-17004
				],
				[
					6837,
					1899
				],
				[
					385,
					-10696
				]
			],
			[
				[
					8736091,
					689409
				],
				[
					-2938,
					-9935
				],
				[
					-11458,
					-1667
				],
				[
					-1982,
					26673
				],
				[
					5200,
					21684
				],
				[
					-11585,
					-9121
				]
			],
			[
				[
					8753644,
					730384
				],
				[
					-3015,
					-296
				]
			],
			[
				[
					8747827,
					727348
				],
				[
					3624,
					11628
				]
			],
			[
				[
					8751451,
					738976
				],
				[
					5194,
					-6793
				]
			],
			[
				[
					8746138,
					743805
				],
				[
					5313,
					-4829
				]
			],
			[
				[
					8735011,
					761961
				],
				[
					11127,
					-18156
				]
			],
			[
				[
					8748682,
					750637
				],
				[
					133,
					-48
				]
			],
			[
				[
					8746138,
					743805
				],
				[
					2544,
					6832
				]
			],
			[
				[
					8749228,
					752115
				],
				[
					-546,
					-1478
				]
			],
			[
				[
					8737315,
					767992
				],
				[
					11581,
					-11638
				]
			],
			[
				[
					8730509,
					1024014
				],
				[
					2688,
					-8752
				]
			],
			[
				[
					8678493,
					986350
				],
				[
					6438,
					12858
				],
				[
					-3457,
					4332
				]
			],
			[
				[
					8681474,
					1003540
				],
				[
					12812,
					30619
				]
			],
			[
				[
					8694286,
					1034159
				],
				[
					13477,
					6010
				]
			],
			[
				[
					8707763,
					1040169
				],
				[
					16331,
					-4679
				]
			],
			[
				[
					8664706,
					821539
				],
				[
					-5467,
					-8423
				],
				[
					1215,
					-24037
				],
				[
					5965,
					-8990
				]
			],
			[
				[
					8647539,
					810964
				],
				[
					1119,
					9773
				],
				[
					-8061,
					-2497
				]
			],
			[
				[
					8680340,
					829559
				],
				[
					1301,
					-2157
				]
			],
			[
				[
					8670094,
					825152
				],
				[
					4804,
					4889
				]
			],
			[
				[
					8648482,
					597339
				],
				[
					93,
					-94
				]
			],
			[
				[
					8648603,
					597294
				],
				[
					-145,
					87
				]
			],
			[
				[
					8488257,
					526732
				],
				[
					-2894,
					-8915
				]
			],
			[
				[
					8484870,
					516426
				],
				[
					-250,
					-705
				]
			],
			[
				[
					8475583,
					505337
				],
				[
					-8565,
					21052
				],
				[
					2100,
					18329
				],
				[
					-1528,
					23753
				]
			],
			[
				[
					8467202,
					571991
				],
				[
					-2039,
					7674
				]
			],
			[
				[
					8463951,
					581194
				],
				[
					-1690,
					4470
				]
			],
			[
				[
					8770947,
					876787
				],
				[
					7284,
					12396
				]
			],
			[
				[
					9011943,
					946939
				],
				[
					-6895,
					9662
				],
				[
					-5367,
					19971
				]
			],
			[
				[
					8830390,
					1091593
				],
				[
					-1328,
					-1898
				]
			],
			[
				[
					8829062,
					1089695
				],
				[
					-1189,
					-789
				]
			],
			[
				[
					8827873,
					1088906
				],
				[
					2517,
					2687
				]
			],
			[
				[
					8797143,
					1138746
				],
				[
					1648,
					949
				]
			],
			[
				[
					8798791,
					1139695
				],
				[
					-1648,
					-949
				]
			],
			[
				[
					8807650,
					1144147
				],
				[
					402,
					397
				]
			],
			[
				[
					8808052,
					1144544
				],
				[
					-402,
					-397
				]
			],
			[
				[
					8808765,
					1145307
				],
				[
					216,
					356
				]
			],
			[
				[
					8808981,
					1145663
				],
				[
					-216,
					-356
				]
			],
			[
				[
					8800175,
					1146439
				],
				[
					-61,
					-130
				]
			],
			[
				[
					8800114,
					1146309
				],
				[
					-187,
					-401
				]
			],
			[
				[
					8799927,
					1145908
				],
				[
					-156,
					-333
				]
			],
			[
				[
					8799771,
					1145575
				],
				[
					404,
					864
				]
			],
			[
				[
					8830390,
					1091593
				],
				[
					-1068,
					9306
				],
				[
					8021,
					5439
				],
				[
					-863,
					20303
				],
				[
					-21064,
					-15524
				]
			],
			[
				[
					8815416,
					1111117
				],
				[
					-231,
					-402
				]
			],
			[
				[
					8815185,
					1110715
				],
				[
					-6596,
					20484
				]
			],
			[
				[
					8808589,
					1131199
				],
				[
					-1444,
					12448
				]
			],
			[
				[
					8807145,
					1143647
				],
				[
					13736,
					-2159
				],
				[
					5752,
					-11785
				],
				[
					2365,
					11558
				],
				[
					38687,
					13305
				],
				[
					24593,
					40
				],
				[
					29964,
					3955
				],
				[
					19902,
					-7811
				],
				[
					-24037,
					-25100
				],
				[
					-15265,
					552
				],
				[
					-4465,
					-17730
				],
				[
					-7472,
					-4162
				],
				[
					1549,
					-11335
				],
				[
					-17177,
					-7802
				],
				[
					2432,
					-14715
				],
				[
					10381,
					-3583
				],
				[
					-789,
					-20613
				],
				[
					-5851,
					-10491
				],
				[
					-26989,
					-4152
				],
				[
					-8865,
					1720
				],
				[
					-16008,
					22896
				],
				[
					-7755,
					-2623
				],
				[
					16707,
					14465
				],
				[
					-8643,
					3299
				],
				[
					1918,
					15718
				]
			],
			[
				[
					8831815,
					1087094
				],
				[
					-1425,
					4499
				]
			],
			[
				[
					8797051,
					1138792
				],
				[
					-4335,
					-6862
				],
				[
					14788,
					-32386
				]
			],
			[
				[
					8807504,
					1099544
				],
				[
					1740,
					-3292
				]
			],
			[
				[
					8809244,
					1096252
				],
				[
					1904,
					-8355
				],
				[
					-13475,
					-15064
				],
				[
					-31471,
					17934
				],
				[
					-1987,
					8291
				]
			],
			[
				[
					8764215,
					1099058
				],
				[
					-1165,
					11045
				],
				[
					7351,
					3007
				],
				[
					-5934,
					17357
				],
				[
					9162,
					22920
				]
			],
			[
				[
					8773629,
					1153387
				],
				[
					4535,
					9733
				],
				[
					12203,
					-3128
				],
				[
					6684,
					-21200
				]
			],
			[
				[
					8772093,
					1151936
				],
				[
					0,
					0
				]
			],
			[
				[
					8769917,
					1148420
				],
				[
					0,
					0
				]
			],
			[
				[
					8732586,
					1148028
				],
				[
					0,
					0
				]
			],
			[
				[
					8764215,
					1099058
				],
				[
					-474,
					-7856
				],
				[
					-17379,
					11242
				],
				[
					-13040,
					19361
				],
				[
					665,
					9658
				],
				[
					9205,
					-5639
				]
			],
			[
				[
					8743192,
					1125824
				],
				[
					6994,
					2726
				],
				[
					-1298,
					21457
				],
				[
					-4363,
					-153
				]
			],
			[
				[
					8744525,
					1149854
				],
				[
					-3420,
					9504
				],
				[
					8983,
					19370
				],
				[
					18471,
					-7893
				],
				[
					5070,
					-17448
				]
			],
			[
				[
					8747544,
					1123871
				],
				[
					0,
					0
				]
			],
			[
				[
					8729177,
					1152491
				],
				[
					-951,
					-14124
				]
			],
			[
				[
					8728226,
					1138367
				],
				[
					-8583,
					4317
				],
				[
					-7371,
					-8001
				],
				[
					-14889,
					4010
				],
				[
					2616,
					29891
				],
				[
					6296,
					12235
				],
				[
					-3300,
					13617
				],
				[
					-4834,
					-10802
				],
				[
					-10098,
					10165
				],
				[
					-18651,
					-3673
				],
				[
					-3171,
					22334
				],
				[
					14178,
					24377
				],
				[
					13416,
					34100
				],
				[
					13378,
					13683
				],
				[
					5879,
					13103
				],
				[
					2438,
					-43440
				],
				[
					-11699,
					-30890
				],
				[
					6763,
					-2959
				],
				[
					15668,
					-24523
				],
				[
					5265,
					-14296
				],
				[
					-4292,
					-18517
				],
				[
					1942,
					-10607
				]
			],
			[
				[
					8831815,
					1087094
				],
				[
					-2753,
					2601
				]
			],
			[
				[
					8813319,
					1106076
				],
				[
					0,
					0
				]
			],
			[
				[
					8827873,
					1088906
				],
				[
					-8269,
					-828
				]
			],
			[
				[
					8819604,
					1088078
				],
				[
					-4066,
					14016
				]
			],
			[
				[
					8815538,
					1102094
				],
				[
					-122,
					9023
				]
			],
			[
				[
					8815185,
					1110715
				],
				[
					-1325,
					-11955
				]
			],
			[
				[
					8813860,
					1098760
				],
				[
					-2864,
					-3559
				]
			],
			[
				[
					8810996,
					1095201
				],
				[
					-1752,
					1051
				]
			],
			[
				[
					8807504,
					1099544
				],
				[
					3822,
					12849
				],
				[
					-2737,
					18806
				]
			],
			[
				[
					8819604,
					1088078
				],
				[
					-8608,
					7123
				]
			],
			[
				[
					8813860,
					1098760
				],
				[
					1678,
					3334
				]
			],
			[
				[
					8808765,
					1145307
				],
				[
					-713,
					-763
				]
			],
			[
				[
					8807650,
					1144147
				],
				[
					-505,
					-500
				]
			],
			[
				[
					8797051,
					1138792
				],
				[
					92,
					-46
				]
			],
			[
				[
					8798791,
					1139695
				],
				[
					980,
					5880
				]
			],
			[
				[
					8799927,
					1145908
				],
				[
					9054,
					-245
				]
			],
			[
				[
					8800175,
					1146439
				],
				[
					-61,
					-130
				]
			],
			[
				[
					8743192,
					1125824
				],
				[
					-1258,
					10502
				],
				[
					-13708,
					2041
				]
			],
			[
				[
					8729177,
					1152491
				],
				[
					15348,
					-2637
				]
			],
			[
				[
					8637315,
					1056663
				],
				[
					-3588,
					-8774
				]
			],
			[
				[
					8633727,
					1047889
				],
				[
					-3735,
					9058
				]
			],
			[
				[
					8629992,
					1056947
				],
				[
					-3506,
					6192
				]
			],
			[
				[
					8626486,
					1063139
				],
				[
					-7410,
					6714
				]
			],
			[
				[
					8619076,
					1069853
				],
				[
					3710,
					2621
				]
			],
			[
				[
					8622786,
					1072474
				],
				[
					11627,
					5007
				],
				[
					6013,
					-5635
				],
				[
					-3111,
					-15183
				]
			],
			[
				[
					8629992,
					1056947
				],
				[
					-10081,
					-8840
				],
				[
					-8089,
					5957
				]
			],
			[
				[
					8611822,
					1054064
				],
				[
					12149,
					5737
				]
			],
			[
				[
					8623971,
					1059801
				],
				[
					2515,
					3338
				]
			],
			[
				[
					8623971,
					1059801
				],
				[
					-6438,
					8386
				]
			],
			[
				[
					8617533,
					1068187
				],
				[
					1543,
					1666
				]
			],
			[
				[
					8611822,
					1054064
				],
				[
					-776,
					-422
				]
			],
			[
				[
					8611046,
					1053642
				],
				[
					-1693,
					7939
				],
				[
					8180,
					6606
				]
			],
			[
				[
					8611046,
					1053642
				],
				[
					-12822,
					-3336
				]
			],
			[
				[
					8598224,
					1050306
				],
				[
					-3667,
					5643
				],
				[
					-7922,
					44200
				]
			],
			[
				[
					8586635,
					1100149
				],
				[
					7473,
					5593
				],
				[
					20176,
					1258
				],
				[
					-1152,
					5696
				]
			],
			[
				[
					8613132,
					1112696
				],
				[
					7913,
					6797
				],
				[
					1257,
					-12108
				]
			],
			[
				[
					8622302,
					1107385
				],
				[
					-6918,
					-313
				],
				[
					7402,
					-34598
				]
			],
			[
				[
					8612027,
					1115438
				],
				[
					1582,
					15748
				]
			],
			[
				[
					8613609,
					1131186
				],
				[
					1463,
					-4934
				]
			],
			[
				[
					8615072,
					1126252
				],
				[
					-3045,
					-10814
				]
			],
			[
				[
					8641077,
					1099250
				],
				[
					-6444,
					-8337
				],
				[
					15442,
					-29068
				],
				[
					6450,
					2525
				]
			],
			[
				[
					8656525,
					1064370
				],
				[
					256,
					-8922
				],
				[
					-19466,
					1215
				]
			],
			[
				[
					8622302,
					1107385
				],
				[
					12896,
					855
				]
			],
			[
				[
					8635198,
					1108240
				],
				[
					5879,
					-8990
				]
			],
			[
				[
					8633727,
					1047889
				],
				[
					1566,
					-9746
				]
			],
			[
				[
					8635293,
					1038143
				],
				[
					-23154,
					-7090
				],
				[
					-504,
					-16848
				]
			],
			[
				[
					8611635,
					1014205
				],
				[
					-6195,
					13248
				],
				[
					3735,
					6675
				],
				[
					-10951,
					16178
				]
			],
			[
				[
					8531884,
					1276368
				],
				[
					0,
					0
				]
			],
			[
				[
					8530836,
					1276767
				],
				[
					0,
					0
				]
			],
			[
				[
					8599059,
					1298382
				],
				[
					-1743,
					3502
				]
			],
			[
				[
					8597316,
					1301884
				],
				[
					1743,
					-3502
				]
			],
			[
				[
					8597286,
					1301945
				],
				[
					-1036,
					-2153
				]
			],
			[
				[
					8596250,
					1299792
				],
				[
					261,
					-136
				]
			],
			[
				[
					8596511,
					1299656
				],
				[
					-2947,
					-10660
				],
				[
					6026,
					-15511
				]
			],
			[
				[
					8599590,
					1273485
				],
				[
					-23247,
					-27904
				]
			],
			[
				[
					8576343,
					1245581
				],
				[
					-6289,
					5957
				],
				[
					-9882,
					-11160
				],
				[
					-6110,
					10701
				],
				[
					-22288,
					-25091
				]
			],
			[
				[
					8531774,
					1225988
				],
				[
					3964,
					29043
				],
				[
					-7113,
					4585
				]
			],
			[
				[
					8528625,
					1259616
				],
				[
					8050,
					25806
				],
				[
					22568,
					17254
				]
			],
			[
				[
					8559243,
					1302676
				],
				[
					1524,
					57
				]
			],
			[
				[
					8560767,
					1302733
				],
				[
					4563,
					-5057
				],
				[
					10882,
					5142
				],
				[
					-562,
					-9417
				]
			],
			[
				[
					8575650,
					1293401
				],
				[
					361,
					-875
				]
			],
			[
				[
					8576011,
					1292526
				],
				[
					7252,
					833
				]
			],
			[
				[
					8583263,
					1293359
				],
				[
					225,
					9
				]
			],
			[
				[
					8583488,
					1293368
				],
				[
					13798,
					8577
				]
			],
			[
				[
					8571012,
					1314158
				],
				[
					-10460,
					-9136
				]
			],
			[
				[
					8560552,
					1305022
				],
				[
					-1309,
					-2346
				]
			],
			[
				[
					8528625,
					1259616
				],
				[
					-6033,
					-9932
				],
				[
					-8226,
					2556
				],
				[
					7935,
					8104
				],
				[
					-2509,
					14310
				],
				[
					-14104,
					4166
				],
				[
					-125,
					10794
				],
				[
					8627,
					-201
				],
				[
					-9182,
					29715
				],
				[
					2241,
					20009
				]
			],
			[
				[
					8507249,
					1339137
				],
				[
					21545,
					10506
				]
			],
			[
				[
					8528794,
					1349643
				],
				[
					17797,
					8900
				]
			],
			[
				[
					8546591,
					1358543
				],
				[
					9111,
					-46912
				],
				[
					15310,
					2527
				]
			],
			[
				[
					8505245,
					1342203
				],
				[
					-9092,
					-11689
				],
				[
					7026,
					-8046
				],
				[
					-32547,
					-8287
				],
				[
					-5067,
					2659
				],
				[
					-8017,
					-14248
				],
				[
					-18036,
					12117
				],
				[
					-10746,
					40776
				],
				[
					-5438,
					8961
				],
				[
					5119,
					14805
				]
			],
			[
				[
					8428447,
					1379251
				],
				[
					30589,
					-7140
				],
				[
					9702,
					7949
				]
			],
			[
				[
					8468738,
					1380060
				],
				[
					11801,
					-11452
				],
				[
					8186,
					1516
				],
				[
					16520,
					-27921
				]
			],
			[
				[
					8613847,
					1466009
				],
				[
					-1255,
					-584
				]
			],
			[
				[
					8612592,
					1465425
				],
				[
					1255,
					584
				]
			],
			[
				[
					8618515,
					1464790
				],
				[
					-4141,
					1468
				]
			],
			[
				[
					8614374,
					1466258
				],
				[
					-1868,
					-873
				]
			],
			[
				[
					8612506,
					1465385
				],
				[
					-281,
					-148
				]
			],
			[
				[
					8612225,
					1465237
				],
				[
					-283,
					-98
				]
			],
			[
				[
					8611942,
					1465139
				],
				[
					-13958,
					-8079
				]
			],
			[
				[
					8597984,
					1457060
				],
				[
					-14934,
					-2163
				]
			],
			[
				[
					8583050,
					1454897
				],
				[
					8074,
					17342
				]
			],
			[
				[
					8591124,
					1472239
				],
				[
					29166,
					5397
				],
				[
					-1775,
					-12846
				]
			],
			[
				[
					8620552,
					1439528
				],
				[
					-3352,
					-15236
				],
				[
					-7182,
					-8601
				],
				[
					4016,
					-17052
				],
				[
					-1753,
					-11177
				]
			],
			[
				[
					8612281,
					1387462
				],
				[
					-2704,
					2245
				],
				[
					-29060,
					-14224
				]
			],
			[
				[
					8580517,
					1375483
				],
				[
					-1607,
					15347
				]
			],
			[
				[
					8578910,
					1390830
				],
				[
					7280,
					80
				],
				[
					9504,
					11070
				],
				[
					5543,
					15110
				],
				[
					-7632,
					18505
				]
			],
			[
				[
					8593605,
					1435595
				],
				[
					2911,
					1982
				]
			],
			[
				[
					8596516,
					1437577
				],
				[
					12804,
					-3632
				],
				[
					11232,
					5583
				]
			],
			[
				[
					8574789,
					1477789
				],
				[
					3534,
					-21538
				],
				[
					3759,
					-2819
				]
			],
			[
				[
					8582082,
					1453432
				],
				[
					-9555,
					-12388
				],
				[
					-9695,
					-4778
				],
				[
					791,
					-19827
				]
			],
			[
				[
					8563623,
					1416439
				],
				[
					-9717,
					5302
				],
				[
					-13357,
					-4938
				],
				[
					-6339,
					10089
				],
				[
					-3887,
					-5772
				],
				[
					4284,
					-20317
				],
				[
					4644,
					-4818
				],
				[
					-10172,
					-8989
				],
				[
					-285,
					-37353
				]
			],
			[
				[
					8507249,
					1339137
				],
				[
					-2004,
					3066
				]
			],
			[
				[
					8468738,
					1380060
				],
				[
					-4154,
					9438
				],
				[
					8790,
					6506
				],
				[
					-11605,
					19830
				],
				[
					6348,
					3378
				]
			],
			[
				[
					8468117,
					1419212
				],
				[
					52256,
					26512
				],
				[
					4823,
					816
				]
			],
			[
				[
					8525196,
					1446540
				],
				[
					-2207,
					-7686
				],
				[
					21153,
					6916
				],
				[
					14048,
					17854
				],
				[
					16599,
					14165
				]
			],
			[
				[
					8492041,
					898065
				],
				[
					-3356,
					-6103
				]
			],
			[
				[
					8488685,
					891962
				],
				[
					-4581,
					1415
				]
			],
			[
				[
					8484104,
					893377
				],
				[
					2915,
					15479
				]
			],
			[
				[
					8487019,
					908856
				],
				[
					5022,
					-10791
				]
			],
			[
				[
					8499019,
					904482
				],
				[
					-6978,
					-6417
				]
			],
			[
				[
					8487019,
					908856
				],
				[
					1443,
					1669
				]
			],
			[
				[
					8488462,
					910525
				],
				[
					8852,
					10837
				],
				[
					1705,
					-16880
				]
			],
			[
				[
					8488685,
					891962
				],
				[
					2420,
					-3775
				]
			],
			[
				[
					8491105,
					888187
				],
				[
					-4471,
					-9793
				]
			],
			[
				[
					8486634,
					878394
				],
				[
					-4689,
					-2480
				]
			],
			[
				[
					8481945,
					875914
				],
				[
					-2097,
					6181
				]
			],
			[
				[
					8479848,
					882095
				],
				[
					4256,
					11282
				]
			],
			[
				[
					8492644,
					861738
				],
				[
					5532,
					3844
				]
			],
			[
				[
					8498176,
					865582
				],
				[
					5277,
					-12108
				]
			],
			[
				[
					8503453,
					853474
				],
				[
					-7149,
					-6207
				],
				[
					-4671,
					8690
				]
			],
			[
				[
					8491633,
					855957
				],
				[
					1011,
					5781
				]
			],
			[
				[
					8492644,
					861738
				],
				[
					-8802,
					3807
				]
			],
			[
				[
					8483842,
					865545
				],
				[
					-2265,
					-1607
				]
			],
			[
				[
					8481577,
					863938
				],
				[
					-628,
					3424
				]
			],
			[
				[
					8480949,
					867362
				],
				[
					-481,
					1707
				]
			],
			[
				[
					8480468,
					869069
				],
				[
					1477,
					6845
				]
			],
			[
				[
					8486634,
					878394
				],
				[
					6010,
					-16656
				]
			],
			[
				[
					8480468,
					869069
				],
				[
					-2652,
					-3182
				]
			],
			[
				[
					8477816,
					865887
				],
				[
					-8450,
					9728
				]
			],
			[
				[
					8469366,
					875615
				],
				[
					10482,
					6480
				]
			],
			[
				[
					8501485,
					882646
				],
				[
					-435,
					1942
				]
			],
			[
				[
					8501050,
					884588
				],
				[
					435,
					-1942
				]
			],
			[
				[
					8480949,
					867362
				],
				[
					46,
					-2661
				]
			],
			[
				[
					8480995,
					864701
				],
				[
					-1185,
					-750
				]
			],
			[
				[
					8479810,
					863951
				],
				[
					-1994,
					1936
				]
			],
			[
				[
					8481577,
					863938
				],
				[
					-582,
					763
				]
			],
			[
				[
					8479810,
					863951
				],
				[
					-10603,
					-10277
				],
				[
					665,
					-9158
				],
				[
					-10727,
					-9338
				]
			],
			[
				[
					8459145,
					835178
				],
				[
					207,
					34184
				]
			],
			[
				[
					8459352,
					869362
				],
				[
					7615,
					4753
				]
			],
			[
				[
					8466967,
					874115
				],
				[
					2399,
					1500
				]
			],
			[
				[
					8501485,
					882646
				],
				[
					-3309,
					-17064
				]
			],
			[
				[
					8491105,
					888187
				],
				[
					9945,
					-3599
				]
			],
			[
				[
					8491633,
					855957
				],
				[
					-6280,
					-3019
				],
				[
					-1511,
					12607
				]
			],
			[
				[
					8526132,
					871053
				],
				[
					-971,
					2068
				]
			],
			[
				[
					8525161,
					873121
				],
				[
					971,
					-2068
				]
			],
			[
				[
					8518441,
					892568
				],
				[
					1561,
					-18930
				],
				[
					5084,
					-406
				]
			],
			[
				[
					8525086,
					873232
				],
				[
					-8497,
					-11298
				],
				[
					-7900,
					2050
				],
				[
					-5236,
					-10510
				]
			],
			[
				[
					8499019,
					904482
				],
				[
					4818,
					-7583
				],
				[
					9229,
					5605
				],
				[
					5375,
					-9936
				]
			],
			[
				[
					8457981,
					1008474
				],
				[
					-15006,
					-37594
				],
				[
					7343,
					-5710
				],
				[
					-640,
					-11370
				]
			],
			[
				[
					8449678,
					953800
				],
				[
					-4340,
					-3695
				]
			],
			[
				[
					8445338,
					950105
				],
				[
					-8507,
					5480
				],
				[
					-7488,
					21068
				],
				[
					-5025,
					1303
				]
			],
			[
				[
					8424318,
					977956
				],
				[
					1541,
					23070
				],
				[
					3913,
					8154
				]
			],
			[
				[
					8429772,
					1009180
				],
				[
					21532,
					6149
				],
				[
					6677,
					-6855
				]
			],
			[
				[
					8417788,
					1045710
				],
				[
					-2173,
					4796
				]
			],
			[
				[
					8415615,
					1050506
				],
				[
					2173,
					-4796
				]
			],
			[
				[
					8458200,
					1008957
				],
				[
					-219,
					-483
				]
			],
			[
				[
					8429772,
					1009180
				],
				[
					-19888,
					24600
				]
			],
			[
				[
					8409884,
					1033780
				],
				[
					-3817,
					2152
				]
			],
			[
				[
					8406067,
					1035932
				],
				[
					12486,
					9275
				]
			],
			[
				[
					8418553,
					1045207
				],
				[
					237,
					15289
				],
				[
					17452,
					-587
				],
				[
					18831,
					46352
				]
			],
			[
				[
					8455073,
					1106261
				],
				[
					7214,
					-3991
				],
				[
					9649,
					-14996
				]
			],
			[
				[
					8471936,
					1087274
				],
				[
					-27751,
					-68717
				],
				[
					7556,
					6384
				],
				[
					11174,
					-4054
				],
				[
					-4715,
					-11930
				]
			],
			[
				[
					8424318,
					977956
				],
				[
					-14209,
					3720
				],
				[
					-2151,
					7409
				],
				[
					-9245,
					-22829
				]
			],
			[
				[
					8398713,
					966256
				],
				[
					-14092,
					-1123
				],
				[
					17256,
					42871
				]
			],
			[
				[
					8401877,
					1008004
				],
				[
					2065,
					5167
				]
			],
			[
				[
					8403942,
					1013171
				],
				[
					-2437,
					-10832
				],
				[
					9041,
					705
				],
				[
					1137,
					23427
				],
				[
					-7295,
					-436
				]
			],
			[
				[
					8404388,
					1026035
				],
				[
					-5414,
					7580
				]
			],
			[
				[
					8398974,
					1033615
				],
				[
					10910,
					165
				]
			],
			[
				[
					8403942,
					1013171
				],
				[
					446,
					12864
				]
			],
			[
				[
					8398974,
					1033615
				],
				[
					-880,
					1533
				]
			],
			[
				[
					8398094,
					1035148
				],
				[
					7973,
					784
				]
			],
			[
				[
					8401877,
					1008004
				],
				[
					-3879,
					4564
				],
				[
					-8625,
					-20678
				],
				[
					-8358,
					19777
				]
			],
			[
				[
					8381015,
					1011667
				],
				[
					12496,
					21534
				]
			],
			[
				[
					8393511,
					1033201
				],
				[
					4583,
					1947
				]
			],
			[
				[
					8405830,
					1074536
				],
				[
					9785,
					-24030
				]
			],
			[
				[
					8417788,
					1045710
				],
				[
					765,
					-503
				]
			],
			[
				[
					8393511,
					1033201
				],
				[
					3980,
					15919
				],
				[
					-4539,
					22111
				]
			],
			[
				[
					8392952,
					1071231
				],
				[
					-1419,
					7778
				],
				[
					14297,
					-4473
				]
			],
			[
				[
					8364060,
					848453
				],
				[
					-7398,
					2808
				]
			],
			[
				[
					8356662,
					851261
				],
				[
					-134,
					62
				]
			],
			[
				[
					8356528,
					851323
				],
				[
					-242,
					-22
				]
			],
			[
				[
					8356286,
					851301
				],
				[
					-2711,
					-10629
				],
				[
					-12729,
					6314
				],
				[
					-6194,
					-16282
				],
				[
					-13955,
					28965
				],
				[
					-2362,
					11104
				],
				[
					7417,
					20467
				]
			],
			[
				[
					8325752,
					891240
				],
				[
					4897,
					-1096
				],
				[
					6557,
					-23371
				],
				[
					5906,
					2112
				],
				[
					7058,
					-11503
				],
				[
					3425,
					12593
				],
				[
					9299,
					599
				],
				[
					1166,
					-22121
				]
			],
			[
				[
					8342221,
					866687
				],
				[
					0,
					0
				]
			],
			[
				[
					8438709,
					1532304
				],
				[
					-18183,
					-10715
				],
				[
					-98,
					-12653
				],
				[
					-8133,
					-11308
				],
				[
					10,
					-56462
				]
			],
			[
				[
					8412305,
					1441166
				],
				[
					-21797,
					-28608
				],
				[
					-3326,
					10302
				]
			],
			[
				[
					8387182,
					1422860
				],
				[
					-48,
					25476
				],
				[
					-14826,
					-1003
				],
				[
					-7336,
					9277
				],
				[
					-11061,
					-3614
				]
			],
			[
				[
					8353911,
					1452996
				],
				[
					-5180,
					3489
				],
				[
					3993,
					15935
				],
				[
					12797,
					5742
				],
				[
					3543,
					9034
				],
				[
					10633,
					2667
				],
				[
					-2477,
					19212
				]
			],
			[
				[
					8377220,
					1509075
				],
				[
					4897,
					11444
				],
				[
					19784,
					4461
				]
			],
			[
				[
					8401901,
					1524980
				],
				[
					7443,
					1888
				]
			],
			[
				[
					8409344,
					1526868
				],
				[
					2730,
					1398
				]
			],
			[
				[
					8412074,
					1528266
				],
				[
					14134,
					7368
				],
				[
					3565,
					7392
				]
			],
			[
				[
					8429773,
					1543026
				],
				[
					9672,
					-2877
				],
				[
					-736,
					-7845
				]
			],
			[
				[
					8227302,
					1378621
				],
				[
					-3370,
					-9100
				]
			],
			[
				[
					8223932,
					1369521
				],
				[
					-4925,
					-962
				],
				[
					-1667,
					-16230
				],
				[
					-10904,
					2337
				]
			],
			[
				[
					8206436,
					1354666
				],
				[
					2799,
					20109
				]
			],
			[
				[
					8209235,
					1374775
				],
				[
					13002,
					10501
				],
				[
					5065,
					-6655
				]
			],
			[
				[
					8319005,
					1344107
				],
				[
					7632,
					-30636
				],
				[
					-8209,
					-12780
				],
				[
					-3761,
					11074
				],
				[
					-18191,
					-42127
				]
			],
			[
				[
					8296476,
					1269638
				],
				[
					-7991,
					25468
				],
				[
					-4666,
					4096
				]
			],
			[
				[
					8283819,
					1299202
				],
				[
					-6236,
					5871
				]
			],
			[
				[
					8277583,
					1305073
				],
				[
					9441,
					28486
				],
				[
					8225,
					5335
				],
				[
					3,
					10265
				],
				[
					8204,
					-3102
				],
				[
					-1038,
					23867
				]
			],
			[
				[
					8302418,
					1369924
				],
				[
					12128,
					11623
				],
				[
					3745,
					-15848
				],
				[
					714,
					-21592
				]
			],
			[
				[
					8296476,
					1269638
				],
				[
					-2330,
					-3999
				]
			],
			[
				[
					8294146,
					1265639
				],
				[
					677,
					-19425
				],
				[
					-10939,
					-12733
				]
			],
			[
				[
					8283884,
					1233481
				],
				[
					-65,
					65721
				]
			],
			[
				[
					8503115,
					1122946
				],
				[
					40747,
					-16011
				]
			],
			[
				[
					8543862,
					1106935
				],
				[
					-29142,
					-52636
				]
			],
			[
				[
					8514720,
					1054299
				],
				[
					-14092,
					-25762
				],
				[
					-17412,
					6451
				]
			],
			[
				[
					8483216,
					1034988
				],
				[
					2903,
					16548
				],
				[
					9328,
					7808
				],
				[
					-14044,
					15359
				],
				[
					3024,
					21216
				],
				[
					7797,
					-246
				],
				[
					8874,
					22664
				],
				[
					-4834,
					7364
				]
			],
			[
				[
					8496264,
					1125701
				],
				[
					6851,
					-2755
				]
			],
			[
				[
					8483216,
					1034988
				],
				[
					-2735,
					-19884
				],
				[
					-12638,
					-12618
				]
			],
			[
				[
					8467843,
					1002486
				],
				[
					-9643,
					6471
				]
			],
			[
				[
					8471936,
					1087274
				],
				[
					17005,
					41266
				],
				[
					7323,
					-2839
				]
			],
			[
				[
					8521071,
					1023896
				],
				[
					1999,
					-14286
				]
			],
			[
				[
					8523070,
					1009610
				],
				[
					-19011,
					-28321
				]
			],
			[
				[
					8504059,
					981289
				],
				[
					-15527,
					7521
				],
				[
					-9769,
					-17090
				],
				[
					-7991,
					11361
				]
			],
			[
				[
					8470772,
					983081
				],
				[
					1855,
					10908
				],
				[
					-4784,
					8497
				]
			],
			[
				[
					8514720,
					1054299
				],
				[
					4340,
					-8293
				],
				[
					2011,
					-22110
				]
			],
			[
				[
					8584409,
					957192
				],
				[
					1548,
					-8273
				]
			],
			[
				[
					8585957,
					948919
				],
				[
					-48840,
					-31486
				]
			],
			[
				[
					8537117,
					917433
				],
				[
					-3751,
					20979
				],
				[
					-5330,
					3814
				]
			],
			[
				[
					8528036,
					942226
				],
				[
					-1465,
					4030
				]
			],
			[
				[
					8526571,
					946256
				],
				[
					-2349,
					11462
				]
			],
			[
				[
					8524222,
					957718
				],
				[
					14562,
					17315
				]
			],
			[
				[
					8538784,
					975033
				],
				[
					11961,
					1021
				],
				[
					11955,
					11901
				]
			],
			[
				[
					8562700,
					987955
				],
				[
					3112,
					-6764
				],
				[
					12584,
					3821
				],
				[
					6013,
					-27820
				]
			],
			[
				[
					8564857,
					993459
				],
				[
					1104,
					4644
				]
			],
			[
				[
					8565961,
					998103
				],
				[
					-1104,
					-4644
				]
			],
			[
				[
					8564857,
					993459
				],
				[
					-2157,
					-5504
				]
			],
			[
				[
					8538784,
					975033
				],
				[
					-5390,
					13602
				],
				[
					5650,
					5707
				],
				[
					-3712,
					9416
				],
				[
					-7842,
					-3455
				],
				[
					-4420,
					9307
				]
			],
			[
				[
					8521071,
					1023896
				],
				[
					17498,
					13219
				],
				[
					17782,
					-8169
				],
				[
					2116,
					-13981
				],
				[
					13164,
					-5848
				],
				[
					-5670,
					-11014
				]
			],
			[
				[
					8650765,
					1002706
				],
				[
					-13504,
					-22473
				],
				[
					-2808,
					-13761
				],
				[
					-10027,
					-22787
				],
				[
					-9806,
					9333
				],
				[
					-11483,
					-15930
				],
				[
					-13009,
					-9449
				]
			],
			[
				[
					8590128,
					927639
				],
				[
					-4171,
					21280
				]
			],
			[
				[
					8584409,
					957192
				],
				[
					35120,
					40073
				],
				[
					-7894,
					16940
				]
			],
			[
				[
					8635293,
					1038143
				],
				[
					15472,
					-35437
				]
			],
			[
				[
					8611635,
					1014205
				],
				[
					-9926,
					-5514
				],
				[
					-12847,
					6138
				],
				[
					-1658,
					33967
				],
				[
					-10175,
					2415
				],
				[
					-1167,
					13216
				],
				[
					-12344,
					3200
				],
				[
					6683,
					15163
				]
			],
			[
				[
					8570201,
					1082790
				],
				[
					4261,
					14855
				],
				[
					12173,
					2504
				]
			],
			[
				[
					8664566,
					1063476
				],
				[
					-7549,
					-15900
				],
				[
					7275,
					-12532
				],
				[
					-10091,
					-32504
				],
				[
					3548,
					-18014
				]
			],
			[
				[
					8657749,
					984526
				],
				[
					-7683,
					-8551
				],
				[
					7211,
					19062
				],
				[
					-6512,
					7669
				]
			],
			[
				[
					8656525,
					1064370
				],
				[
					8041,
					-894
				]
			],
			[
				[
					8685798,
					1072574
				],
				[
					10467,
					-10556
				]
			],
			[
				[
					8696265,
					1062018
				],
				[
					-8827,
					-19193
				],
				[
					6848,
					-8666
				]
			],
			[
				[
					8681474,
					1003540
				],
				[
					-6835,
					6256
				],
				[
					-16890,
					-25270
				]
			],
			[
				[
					8664566,
					1063476
				],
				[
					10340,
					1226
				],
				[
					2445,
					8483
				],
				[
					8447,
					-611
				]
			],
			[
				[
					8696265,
					1062018
				],
				[
					799,
					16815
				]
			],
			[
				[
					8697064,
					1078833
				],
				[
					17821,
					7025
				],
				[
					19282,
					-7145
				],
				[
					4206,
					-11644
				],
				[
					-14281,
					-11237
				],
				[
					-19705,
					-1312
				],
				[
					3376,
					-14351
				]
			],
			[
				[
					8685798,
					1072574
				],
				[
					-4669,
					17896
				],
				[
					-6012,
					6640
				]
			],
			[
				[
					8675117,
					1097110
				],
				[
					11534,
					-131
				],
				[
					10413,
					-18146
				]
			],
			[
				[
					8641077,
					1099250
				],
				[
					7226,
					3202
				]
			],
			[
				[
					8648303,
					1102452
				],
				[
					26814,
					-5342
				]
			],
			[
				[
					8640652,
					1148517
				],
				[
					2239,
					-25646
				],
				[
					6070,
					7394
				],
				[
					5975,
					-12829
				],
				[
					-6633,
					-14984
				]
			],
			[
				[
					8635198,
					1108240
				],
				[
					3292,
					8991
				],
				[
					-7304,
					8310
				],
				[
					5306,
					12131
				]
			],
			[
				[
					8636492,
					1137672
				],
				[
					4160,
					10845
				]
			],
			[
				[
					8630949,
					1185800
				],
				[
					5593,
					-25232
				],
				[
					-4106,
					-5254
				],
				[
					8216,
					-6797
				]
			],
			[
				[
					8636492,
					1137672
				],
				[
					-3744,
					11922
				],
				[
					-5610,
					-12359
				],
				[
					-12066,
					-10983
				]
			],
			[
				[
					8613609,
					1131186
				],
				[
					-5836,
					-5092
				],
				[
					-12927,
					32253
				],
				[
					4875,
					3429
				]
			],
			[
				[
					8599721,
					1161776
				],
				[
					6529,
					-4903
				],
				[
					8369,
					7334
				],
				[
					-981,
					8800
				],
				[
					8300,
					51
				],
				[
					1024,
					10019
				],
				[
					7987,
					2723
				]
			],
			[
				[
					8572023,
					1188923
				],
				[
					21696,
					162
				],
				[
					1354,
					-6067
				],
				[
					13734,
					-5053
				],
				[
					-9086,
					-16189
				]
			],
			[
				[
					8612027,
					1115438
				],
				[
					1105,
					-2742
				]
			],
			[
				[
					8570201,
					1082790
				],
				[
					-13429,
					758
				],
				[
					-4356,
					20137
				],
				[
					-8554,
					3250
				]
			],
			[
				[
					8503115,
					1122946
				],
				[
					6117,
					14721
				]
			],
			[
				[
					8509232,
					1137667
				],
				[
					23988,
					56367
				],
				[
					3642,
					4464
				]
			],
			[
				[
					8536862,
					1198498
				],
				[
					4500,
					5604
				],
				[
					21852,
					-33312
				],
				[
					-1949,
					12633
				],
				[
					10758,
					5500
				]
			],
			[
				[
					8607834,
					1184152
				],
				[
					0,
					0
				]
			],
			[
				[
					8616716,
					1210365
				],
				[
					14233,
					-1959
				],
				[
					0,
					-22606
				]
			],
			[
				[
					8572023,
					1188923
				],
				[
					11273,
					11271
				]
			],
			[
				[
					8583296,
					1200194
				],
				[
					8679,
					9554
				],
				[
					16480,
					6014
				],
				[
					8261,
					-5397
				]
			],
			[
				[
					8612014,
					1262941
				],
				[
					-7008,
					-17221
				],
				[
					4194,
					-3342
				],
				[
					2340,
					-20365
				],
				[
					8531,
					-4661
				],
				[
					-3355,
					-6987
				]
			],
			[
				[
					8583296,
					1200194
				],
				[
					-10225,
					-2766
				],
				[
					-3849,
					5811
				],
				[
					13493,
					15967
				],
				[
					-6372,
					26375
				]
			],
			[
				[
					8599590,
					1273485
				],
				[
					7581,
					9116
				],
				[
					4843,
					-19660
				]
			],
			[
				[
					8536862,
					1198498
				],
				[
					-12449,
					16712
				]
			],
			[
				[
					8524413,
					1215210
				],
				[
					7361,
					10778
				]
			],
			[
				[
					8325934,
					922773
				],
				[
					13828,
					-212
				]
			],
			[
				[
					8339762,
					922561
				],
				[
					21169,
					-423
				],
				[
					9583,
					-12326
				],
				[
					5165,
					-16220
				],
				[
					5816,
					951
				]
			],
			[
				[
					8381495,
					894543
				],
				[
					2112,
					-53279
				],
				[
					-6880,
					3931
				]
			],
			[
				[
					8376727,
					845195
				],
				[
					-5956,
					9788
				],
				[
					-6711,
					-6530
				]
			],
			[
				[
					8325752,
					891240
				],
				[
					-9112,
					27719
				],
				[
					9294,
					3814
				]
			],
			[
				[
					8356528,
					851323
				],
				[
					-242,
					-22
				]
			],
			[
				[
					8376727,
					845195
				],
				[
					-13,
					-292
				]
			],
			[
				[
					8376714,
					844903
				],
				[
					-11048,
					-13172
				],
				[
					3322,
					-14464
				],
				[
					-5053,
					1595
				],
				[
					-5586,
					15417
				],
				[
					-1687,
					16982
				]
			],
			[
				[
					8419248,
					875994
				],
				[
					99,
					-30109
				]
			],
			[
				[
					8419347,
					845885
				],
				[
					-19600,
					-15034
				]
			],
			[
				[
					8399747,
					830851
				],
				[
					-3513,
					-7534
				]
			],
			[
				[
					8396234,
					823317
				],
				[
					-1535,
					-7380
				]
			],
			[
				[
					8394699,
					815937
				],
				[
					-8494,
					-5456
				],
				[
					-4167,
					11609
				],
				[
					2959,
					9891
				],
				[
					-8283,
					12922
				]
			],
			[
				[
					8381495,
					894543
				],
				[
					9611,
					-13276
				],
				[
					4847,
					-15663
				],
				[
					2453,
					10438
				],
				[
					20842,
					-48
				]
			],
			[
				[
					8384174,
					790203
				],
				[
					-1872,
					-27526
				],
				[
					-5999,
					8050
				],
				[
					7871,
					19476
				]
			],
			[
				[
					8398232,
					752161
				],
				[
					4844,
					-8373
				],
				[
					-2607,
					-25585
				],
				[
					-8879,
					-1196
				],
				[
					-7992,
					-10298
				],
				[
					9140,
					38787
				],
				[
					5494,
					6665
				]
			],
			[
				[
					8419347,
					845885
				],
				[
					-6,
					-15578
				]
			],
			[
				[
					8419341,
					830307
				],
				[
					-18,
					-281
				]
			],
			[
				[
					8419323,
					830026
				],
				[
					-2447,
					-4198
				]
			],
			[
				[
					8416876,
					825828
				],
				[
					-4045,
					-6974
				],
				[
					-17668,
					-8540
				],
				[
					-464,
					5623
				]
			],
			[
				[
					8396234,
					823317
				],
				[
					3513,
					7534
				]
			],
			[
				[
					8419323,
					830026
				],
				[
					-2447,
					-4198
				]
			],
			[
				[
					8434327,
					875981
				],
				[
					32,
					-21888
				],
				[
					24993,
					15269
				]
			],
			[
				[
					8459145,
					835178
				],
				[
					-21545,
					-11563
				],
				[
					-3496,
					8145
				],
				[
					-14763,
					-1453
				]
			],
			[
				[
					8419248,
					875994
				],
				[
					15079,
					-13
				]
			],
			[
				[
					8449678,
					953800
				],
				[
					6909,
					-1439
				],
				[
					10588,
					-13937
				],
				[
					102,
					-12234
				],
				[
					-6780,
					-10329
				],
				[
					15300,
					1435
				]
			],
			[
				[
					8475797,
					917296
				],
				[
					-15450,
					-30426
				],
				[
					6620,
					-12755
				]
			],
			[
				[
					8434327,
					875981
				],
				[
					-3566,
					21636
				],
				[
					2463,
					26647
				],
				[
					8593,
					-1522
				],
				[
					-2076,
					14267
				],
				[
					5597,
					13096
				]
			],
			[
				[
					8381495,
					894543
				],
				[
					-959,
					27252
				],
				[
					-5885,
					9138
				],
				[
					12998,
					8276
				],
				[
					11064,
					27047
				]
			],
			[
				[
					8470772,
					983081
				],
				[
					4618,
					-11884
				],
				[
					-224,
					-14258
				],
				[
					8409,
					-14060
				],
				[
					160,
					-9178
				]
			],
			[
				[
					8483735,
					933701
				],
				[
					-3733,
					-7511
				]
			],
			[
				[
					8480002,
					926190
				],
				[
					-4205,
					-8894
				]
			],
			[
				[
					8526571,
					946256
				],
				[
					1465,
					-4030
				]
			],
			[
				[
					8537117,
					917433
				],
				[
					-8846,
					-5512
				],
				[
					-9830,
					-19353
				]
			],
			[
				[
					8488462,
					910525
				],
				[
					-2774,
					14171
				],
				[
					-5686,
					1494
				]
			],
			[
				[
					8483735,
					933701
				],
				[
					13736,
					14101
				],
				[
					2672,
					-5697
				],
				[
					14329,
					17313
				],
				[
					2458,
					-12903
				],
				[
					9641,
					-259
				]
			],
			[
				[
					8524222,
					957718
				],
				[
					-3138,
					11845
				],
				[
					-8078,
					-4794
				],
				[
					-8947,
					16520
				]
			],
			[
				[
					8590128,
					927639
				],
				[
					-29394,
					-19054
				],
				[
					-21558,
					-22099
				],
				[
					-243,
					-7913
				],
				[
					-12801,
					-7520
				]
			],
			[
				[
					8525161,
					873121
				],
				[
					-75,
					111
				]
			],
			[
				[
					8379414,
					806978
				],
				[
					-5017,
					-23043
				],
				[
					-2736,
					12319
				],
				[
					7753,
					10724
				]
			],
			[
				[
					8450952,
					1122087
				],
				[
					12648,
					5236
				],
				[
					-6524,
					-16105
				]
			],
			[
				[
					8457076,
					1111218
				],
				[
					-6124,
					10869
				]
			],
			[
				[
					8450952,
					1122087
				],
				[
					-22292,
					-9390
				],
				[
					-8392,
					5215
				]
			],
			[
				[
					8420268,
					1117912
				],
				[
					1672,
					6171
				]
			],
			[
				[
					8421940,
					1124083
				],
				[
					4810,
					15446
				],
				[
					-6216,
					6373
				],
				[
					-10709,
					-1572
				]
			],
			[
				[
					8409825,
					1144330
				],
				[
					-7635,
					7784
				],
				[
					-4673,
					-4716
				],
				[
					-9989,
					4518
				],
				[
					-10185,
					48116
				]
			],
			[
				[
					8377343,
					1200032
				],
				[
					10884,
					28468
				]
			],
			[
				[
					8388227,
					1228500
				],
				[
					8202,
					21895
				]
			],
			[
				[
					8396429,
					1250395
				],
				[
					11628,
					-3971
				],
				[
					7662,
					-27214
				],
				[
					37006,
					17387
				]
			],
			[
				[
					8452725,
					1236597
				],
				[
					13339,
					-62510
				],
				[
					-10925,
					-3427
				],
				[
					-13567,
					-15464
				],
				[
					7583,
					-11756
				],
				[
					1797,
					-21353
				]
			],
			[
				[
					8444761,
					1160334
				],
				[
					0,
					0
				]
			],
			[
				[
					8409825,
					1144330
				],
				[
					10714,
					-11354
				],
				[
					1401,
					-8893
				]
			],
			[
				[
					8420268,
					1117912
				],
				[
					-1212,
					-9365
				],
				[
					-10701,
					-5630
				],
				[
					6159,
					-19049
				],
				[
					-8684,
					-9332
				]
			],
			[
				[
					8392952,
					1071231
				],
				[
					-16990,
					14834
				],
				[
					-4518,
					-797
				]
			],
			[
				[
					8371444,
					1085268
				],
				[
					-1545,
					5462
				],
				[
					-25066,
					22410
				]
			],
			[
				[
					8344833,
					1113140
				],
				[
					12544,
					34430
				]
			],
			[
				[
					8357377,
					1147570
				],
				[
					19966,
					52462
				]
			],
			[
				[
					8457076,
					1111218
				],
				[
					-2003,
					-4957
				]
			],
			[
				[
					8371444,
					1085268
				],
				[
					-4335,
					-29725
				],
				[
					5532,
					-14865
				],
				[
					-14108,
					11343
				]
			],
			[
				[
					8358533,
					1052021
				],
				[
					-11881,
					2841
				],
				[
					-4510,
					11785
				],
				[
					-12367,
					8472
				]
			],
			[
				[
					8329775,
					1075119
				],
				[
					7228,
					17938
				]
			],
			[
				[
					8337003,
					1093057
				],
				[
					7830,
					20083
				]
			],
			[
				[
					8358533,
					1052021
				],
				[
					-3294,
					-15091
				],
				[
					10176,
					-12569
				]
			],
			[
				[
					8365415,
					1024361
				],
				[
					-20774,
					-52274
				]
			],
			[
				[
					8344641,
					972087
				],
				[
					-9179,
					41983
				]
			],
			[
				[
					8335462,
					1014070
				],
				[
					3944,
					16787
				],
				[
					-22611,
					11099
				]
			],
			[
				[
					8316795,
					1041956
				],
				[
					-16,
					503
				]
			],
			[
				[
					8316779,
					1042459
				],
				[
					12996,
					32660
				]
			],
			[
				[
					8316714,
					1041328
				],
				[
					81,
					628
				]
			],
			[
				[
					8335462,
					1014070
				],
				[
					-27145,
					-69058
				]
			],
			[
				[
					8308317,
					945012
				],
				[
					-16324,
					16587
				],
				[
					-9693,
					2411
				],
				[
					170,
					30246
				],
				[
					5295,
					4901
				],
				[
					-5496,
					14365
				],
				[
					2591,
					14608
				]
			],
			[
				[
					8284860,
					1028130
				],
				[
					6835,
					-189
				],
				[
					6438,
					-26836
				],
				[
					342,
					19487
				],
				[
					10267,
					-2046
				],
				[
					4814,
					24105
				],
				[
					3158,
					-1323
				]
			],
			[
				[
					8344641,
					972087
				],
				[
					4616,
					-26667
				],
				[
					-9495,
					-22859
				]
			],
			[
				[
					8325934,
					922773
				],
				[
					-4388,
					23551
				],
				[
					-13229,
					-1312
				]
			],
			[
				[
					8365415,
					1024361
				],
				[
					15600,
					-12694
				]
			],
			[
				[
					8206436,
					1354666
				],
				[
					-11969,
					-2400
				],
				[
					-2957,
					-9501
				],
				[
					-12345,
					-1664
				],
				[
					-21202,
					-14799
				],
				[
					-15628,
					15805
				],
				[
					-1109,
					13296
				]
			],
			[
				[
					8141226,
					1355403
				],
				[
					28404,
					11774
				],
				[
					25873,
					18725
				]
			],
			[
				[
					8195503,
					1385902
				],
				[
					3936,
					-8293
				],
				[
					9796,
					-2834
				]
			],
			[
				[
					8195503,
					1385902
				],
				[
					21202,
					30548
				],
				[
					114,
					57316
				]
			],
			[
				[
					8216819,
					1473766
				],
				[
					29484,
					-20124
				],
				[
					-5812,
					-26181
				],
				[
					5875,
					-1148
				],
				[
					-1836,
					-18754
				],
				[
					-6957,
					-2563
				],
				[
					-2202,
					-13427
				],
				[
					-8069,
					-12948
				]
			],
			[
				[
					8265291,
					1524219
				],
				[
					4664,
					-21481
				],
				[
					-2593,
					-10909
				],
				[
					4989,
					-9651
				],
				[
					-4616,
					-21785
				],
				[
					9932,
					-7930
				],
				[
					253,
					-20230
				],
				[
					8853,
					-6003
				]
			],
			[
				[
					8286773,
					1426230
				],
				[
					-4346,
					-10667
				],
				[
					8044,
					-705
				],
				[
					-5592,
					-9908
				],
				[
					-3611,
					7498
				],
				[
					-15246,
					-31529
				],
				[
					2697,
					-2653
				],
				[
					-20216,
					-27720
				]
			],
			[
				[
					8248503,
					1350546
				],
				[
					-14941,
					18166
				],
				[
					-9630,
					809
				]
			],
			[
				[
					8216819,
					1473766
				],
				[
					-16,
					21531
				]
			],
			[
				[
					8216803,
					1495297
				],
				[
					33,
					8700
				],
				[
					29360,
					49
				],
				[
					45,
					20148
				],
				[
					19050,
					25
				]
			],
			[
				[
					8277583,
					1305073
				],
				[
					-12061,
					24856
				],
				[
					-17019,
					20617
				]
			],
			[
				[
					8286773,
					1426230
				],
				[
					8548,
					-6004
				],
				[
					-67,
					-36186
				],
				[
					7164,
					-14116
				]
			],
			[
				[
					8358806,
					1376590
				],
				[
					8948,
					-6087
				],
				[
					34343,
					-105025
				],
				[
					-5668,
					-15083
				]
			],
			[
				[
					8388227,
					1228500
				],
				[
					-53124,
					-22697
				]
			],
			[
				[
					8335103,
					1205803
				],
				[
					4,
					10979
				],
				[
					-11778,
					27649
				],
				[
					-13299,
					13190
				],
				[
					-11689,
					-12156
				],
				[
					672,
					17196
				],
				[
					-4867,
					2978
				]
			],
			[
				[
					8319005,
					1344107
				],
				[
					20902,
					45200
				],
				[
					18899,
					-12717
				]
			],
			[
				[
					8335103,
					1205803
				],
				[
					-13979,
					-6052
				]
			],
			[
				[
					8321124,
					1199751
				],
				[
					-29676,
					-14447
				]
			],
			[
				[
					8291448,
					1185304
				],
				[
					-5543,
					-5494
				]
			],
			[
				[
					8285905,
					1179810
				],
				[
					-1822,
					6978
				]
			],
			[
				[
					8284083,
					1186788
				],
				[
					-199,
					46693
				]
			],
			[
				[
					8321124,
					1199751
				],
				[
					-6271,
					-16717
				],
				[
					3432,
					-8354
				],
				[
					-12453,
					-8470
				],
				[
					-12297,
					9724
				],
				[
					-2087,
					9370
				]
			],
			[
				[
					8285905,
					1179810
				],
				[
					11996,
					-17821
				],
				[
					1657,
					-14032
				]
			],
			[
				[
					8299558,
					1147957
				],
				[
					6801,
					-29460
				],
				[
					-4599,
					-7343
				]
			],
			[
				[
					8301760,
					1111154
				],
				[
					-17010,
					-7116
				]
			],
			[
				[
					8284750,
					1104038
				],
				[
					-667,
					82750
				]
			],
			[
				[
					8357377,
					1147570
				],
				[
					-26512,
					-678
				],
				[
					-1198,
					-20843
				],
				[
					-19013,
					-2210
				],
				[
					-11096,
					24118
				]
			],
			[
				[
					8313428,
					1090209
				],
				[
					-4567,
					-8531
				],
				[
					1825,
					-28230
				],
				[
					6093,
					-10989
				]
			],
			[
				[
					8316714,
					1041328
				],
				[
					-7044,
					14175
				],
				[
					-525,
					11756
				],
				[
					-22482,
					-545
				],
				[
					-1826,
					-4259
				]
			],
			[
				[
					8284837,
					1062455
				],
				[
					-87,
					41583
				]
			],
			[
				[
					8301760,
					1111154
				],
				[
					4290,
					-13578
				],
				[
					10432,
					9882
				],
				[
					-3054,
					-17249
				]
			],
			[
				[
					8284860,
					1028130
				],
				[
					-23,
					34325
				]
			],
			[
				[
					8313428,
					1090209
				],
				[
					23575,
					2848
				]
			],
			[
				[
					8305562,
					1524188
				],
				[
					-1054,
					-15458
				],
				[
					4409,
					-3458
				]
			],
			[
				[
					8308917,
					1505272
				],
				[
					-136,
					-77395
				],
				[
					37222,
					-821
				],
				[
					-2205,
					12872
				],
				[
					10113,
					13068
				]
			],
			[
				[
					8387182,
					1422860
				],
				[
					-3842,
					-12294
				],
				[
					-16035,
					-4328
				],
				[
					3658,
					-10333
				],
				[
					-12157,
					-19315
				]
			],
			[
				[
					8265291,
					1524219
				],
				[
					40271,
					-31
				]
			],
			[
				[
					8308917,
					1505272
				],
				[
					9740,
					-4546
				],
				[
					12423,
					-13811
				],
				[
					2603,
					11735
				],
				[
					15676,
					-4455
				],
				[
					16820,
					14367
				],
				[
					9767,
					-10098
				],
				[
					1274,
					10611
				]
			],
			[
				[
					8449465,
					1538890
				],
				[
					-5824,
					-8747
				]
			],
			[
				[
					8443641,
					1530143
				],
				[
					-554,
					1628
				]
			],
			[
				[
					8443087,
					1531771
				],
				[
					-3066,
					-1774
				]
			],
			[
				[
					8440021,
					1529997
				],
				[
					-1312,
					2307
				]
			],
			[
				[
					8429773,
					1543026
				],
				[
					13334,
					2474
				],
				[
					6358,
					-6610
				]
			],
			[
				[
					8409344,
					1526868
				],
				[
					2730,
					1398
				]
			],
			[
				[
					8443641,
					1530143
				],
				[
					-554,
					1628
				]
			],
			[
				[
					8440021,
					1529997
				],
				[
					18339,
					-10471
				]
			],
			[
				[
					8458360,
					1519526
				],
				[
					8524,
					-9893
				],
				[
					-14520,
					-19986
				],
				[
					-1398,
					-11936
				],
				[
					-6680,
					2960
				],
				[
					-5,
					-39224
				],
				[
					21655,
					1573
				],
				[
					1885,
					-4947
				]
			],
			[
				[
					8467821,
					1438073
				],
				[
					296,
					-18861
				]
			],
			[
				[
					8428447,
					1379251
				],
				[
					-2707,
					10538
				],
				[
					-9159,
					834
				],
				[
					-4269,
					13501
				],
				[
					-8207,
					1219
				],
				[
					192,
					12554
				],
				[
					8011,
					9570
				],
				[
					-3,
					13699
				]
			],
			[
				[
					8509642,
					1495395
				],
				[
					-2588,
					-7602
				],
				[
					-11138,
					-5172
				],
				[
					-5081,
					-14285
				]
			],
			[
				[
					8490835,
					1468336
				],
				[
					-9523,
					-27131
				],
				[
					-13491,
					-3132
				]
			],
			[
				[
					8458360,
					1519526
				],
				[
					15253,
					-5822
				],
				[
					3058,
					-7417
				],
				[
					21045,
					-1053
				],
				[
					11926,
					-9839
				]
			],
			[
				[
					8519116,
					1464751
				],
				[
					-21706,
					-4449
				],
				[
					-6575,
					8034
				]
			],
			[
				[
					8509642,
					1495395
				],
				[
					6765,
					-12166
				],
				[
					2709,
					-18478
				]
			],
			[
				[
					8519116,
					1464751
				],
				[
					6080,
					-18211
				]
			],
			[
				[
					8563623,
					1416439
				],
				[
					14349,
					3483
				]
			],
			[
				[
					8577972,
					1419922
				],
				[
					1767,
					-7333
				],
				[
					-7472,
					-10173
				],
				[
					6643,
					-11586
				]
			],
			[
				[
					8580517,
					1375483
				],
				[
					-8594,
					-4268
				]
			],
			[
				[
					8571923,
					1371215
				],
				[
					-25332,
					-12672
				]
			],
			[
				[
					8577972,
					1419922
				],
				[
					5207,
					10550
				],
				[
					10426,
					5123
				]
			],
			[
				[
					8583050,
					1454897
				],
				[
					-968,
					-1465
				]
			],
			[
				[
					8574789,
					1477789
				],
				[
					24346,
					7256
				],
				[
					-8011,
					-12806
				]
			],
			[
				[
					8612506,
					1465385
				],
				[
					-281,
					-148
				]
			],
			[
				[
					8625364,
					1450919
				],
				[
					1887,
					-815
				]
			],
			[
				[
					8627251,
					1450104
				],
				[
					-6699,
					-10576
				]
			],
			[
				[
					8596516,
					1437577
				],
				[
					1468,
					19483
				]
			],
			[
				[
					8611942,
					1465139
				],
				[
					650,
					286
				]
			],
			[
				[
					8613847,
					1466009
				],
				[
					9052,
					-5101
				],
				[
					2465,
					-9989
				]
			],
			[
				[
					8618515,
					1464790
				],
				[
					-4141,
					1468
				]
			],
			[
				[
					8625364,
					1450919
				],
				[
					135,
					14478
				],
				[
					10739,
					-6987
				],
				[
					-8987,
					-8306
				]
			],
			[
				[
					8646354,
					1467213
				],
				[
					-7422,
					-9011
				],
				[
					-5007,
					8835
				],
				[
					6388,
					4737
				]
			],
			[
				[
					8640313,
					1471774
				],
				[
					6041,
					-4561
				]
			],
			[
				[
					8640313,
					1471774
				],
				[
					-6276,
					213
				],
				[
					710,
					17893
				],
				[
					6796,
					7092
				],
				[
					13814,
					-8695
				],
				[
					-9003,
					-21064
				]
			],
			[
				[
					8652504,
					1528364
				],
				[
					7397,
					-17835
				],
				[
					-14150,
					-10981
				],
				[
					6753,
					28816
				]
			],
			[
				[
					8583263,
					1293359
				],
				[
					225,
					9
				]
			],
			[
				[
					8575650,
					1293401
				],
				[
					361,
					-875
				]
			],
			[
				[
					8597286,
					1301945
				],
				[
					-1036,
					-2153
				]
			],
			[
				[
					8596511,
					1299656
				],
				[
					805,
					2228
				]
			],
			[
				[
					8599059,
					1298382
				],
				[
					22497,
					3155
				],
				[
					-869,
					-24477
				],
				[
					-8673,
					-14119
				]
			],
			[
				[
					8509232,
					1137667
				],
				[
					-22523,
					105765
				]
			],
			[
				[
					8486709,
					1243432
				],
				[
					7022,
					-1248
				],
				[
					12280,
					-12105
				],
				[
					4721,
					9471
				],
				[
					13681,
					-24340
				]
			],
			[
				[
					8452725,
					1236597
				],
				[
					30610,
					14348
				],
				[
					3374,
					-7513
				]
			],
			[
				[
					8560552,
					1305022
				],
				[
					215,
					-2289
				]
			],
			[
				[
					8596871,
					1349102
				],
				[
					-10774,
					-13577
				]
			],
			[
				[
					8586097,
					1335525
				],
				[
					316,
					-1514
				]
			],
			[
				[
					8586413,
					1334011
				],
				[
					-15401,
					-19853
				]
			],
			[
				[
					8571923,
					1371215
				],
				[
					2969,
					-11878
				],
				[
					11303,
					1247
				],
				[
					10676,
					-11482
				]
			],
			[
				[
					8586097,
					1335525
				],
				[
					316,
					-1514
				]
			],
			[
				[
					8612281,
					1387462
				],
				[
					-9053,
					-22188
				],
				[
					-927,
					-15484
				],
				[
					-5430,
					-688
				]
			],
			[
				[
					7826511,
					1200494
				],
				[
					-2499,
					2201
				]
			],
			[
				[
					7824012,
					1202695
				],
				[
					2499,
					-2201
				]
			],
			[
				[
					7861595,
					1214392
				],
				[
					-16014,
					-9198
				]
			],
			[
				[
					7845581,
					1205194
				],
				[
					-5154,
					9362
				]
			],
			[
				[
					7840427,
					1214556
				],
				[
					13460,
					11556
				]
			],
			[
				[
					7853887,
					1226112
				],
				[
					7708,
					-11720
				]
			],
			[
				[
					7840494,
					1249163
				],
				[
					-449,
					4492
				]
			],
			[
				[
					7840045,
					1253655
				],
				[
					449,
					-4492
				]
			],
			[
				[
					7943592,
					1288762
				],
				[
					-9212,
					-23351
				],
				[
					-14348,
					-16486
				],
				[
					-15313,
					-1870
				],
				[
					22665,
					34760
				],
				[
					16208,
					6947
				]
			],
			[
				[
					7838201,
					1243711
				],
				[
					1666,
					-5342
				],
				[
					-10124,
					-9696
				],
				[
					10300,
					-15210
				]
			],
			[
				[
					7840043,
					1213463
				],
				[
					-3766,
					-10414
				]
			],
			[
				[
					7836277,
					1203049
				],
				[
					-11001,
					5682
				],
				[
					-21710,
					-24934
				],
				[
					-7529,
					-908
				]
			],
			[
				[
					7796037,
					1182889
				],
				[
					-32923,
					49962
				],
				[
					25376,
					19961
				],
				[
					-16594,
					24182
				],
				[
					3890,
					10454
				],
				[
					-7750,
					23683
				],
				[
					-7783,
					3061
				]
			],
			[
				[
					7760253,
					1314192
				],
				[
					3068,
					13747
				],
				[
					11851,
					-6470
				],
				[
					1923,
					13189
				]
			],
			[
				[
					7777095,
					1334658
				],
				[
					24209,
					-36484
				],
				[
					-3356,
					-16084
				],
				[
					6867,
					-549
				],
				[
					18130,
					-27377
				],
				[
					-596,
					-17943
				],
				[
					15852,
					7490
				]
			],
			[
				[
					7873036,
					1278645
				],
				[
					-1350,
					-17075
				]
			],
			[
				[
					7871686,
					1261570
				],
				[
					-2378,
					-2023
				]
			],
			[
				[
					7869308,
					1259547
				],
				[
					-8599,
					-11624
				]
			],
			[
				[
					7860709,
					1247923
				],
				[
					-10143,
					13287
				],
				[
					4306,
					10032
				],
				[
					-8258,
					12435
				]
			],
			[
				[
					7846614,
					1283677
				],
				[
					-16722,
					27632
				],
				[
					19381,
					17812
				],
				[
					4488,
					7924
				]
			],
			[
				[
					7853761,
					1337045
				],
				[
					3602,
					-25024
				],
				[
					15673,
					-33376
				]
			],
			[
				[
					7995570,
					1385929
				],
				[
					-6420,
					-14125
				],
				[
					-4510,
					5862
				],
				[
					10930,
					8263
				]
			],
			[
				[
					7978990,
					1463227
				],
				[
					6608,
					-14806
				],
				[
					-4629,
					-17658
				],
				[
					10985,
					7135
				]
			],
			[
				[
					7991954,
					1437898
				],
				[
					-1522,
					-7457
				],
				[
					9913,
					-4735
				]
			],
			[
				[
					8000345,
					1425706
				],
				[
					9474,
					-19978
				]
			],
			[
				[
					8009819,
					1405728
				],
				[
					-2519,
					-5138
				],
				[
					-21643,
					-12249
				]
			],
			[
				[
					7985657,
					1388341
				],
				[
					-1086,
					21444
				],
				[
					-13783,
					117
				],
				[
					-29446,
					-6277
				],
				[
					-6923,
					-16482
				],
				[
					18405,
					-40868
				],
				[
					13064,
					30175
				],
				[
					11763,
					1416
				]
			],
			[
				[
					7977651,
					1377866
				],
				[
					-13844,
					-40003
				]
			],
			[
				[
					7963807,
					1337863
				],
				[
					-5437,
					3476
				],
				[
					-12043,
					-32425
				],
				[
					2728,
					-5378
				]
			],
			[
				[
					7949055,
					1303536
				],
				[
					-6387,
					-8447
				],
				[
					-15742,
					-8499
				],
				[
					-22340,
					-31253
				]
			],
			[
				[
					7904586,
					1255337
				],
				[
					-3101,
					4132
				]
			],
			[
				[
					7901485,
					1259469
				],
				[
					-6200,
					16529
				]
			],
			[
				[
					7895285,
					1275998
				],
				[
					-1171,
					15298
				]
			],
			[
				[
					7894114,
					1291296
				],
				[
					6020,
					9140
				],
				[
					-25049,
					54610
				]
			],
			[
				[
					7875085,
					1355046
				],
				[
					-1701,
					10731
				],
				[
					8836,
					3513
				],
				[
					3234,
					19319
				],
				[
					8521,
					6907
				],
				[
					-706,
					37987
				],
				[
					4252,
					17765
				],
				[
					-910,
					16268
				],
				[
					-20540,
					42560
				],
				[
					-3854,
					14153
				]
			],
			[
				[
					7872217,
					1524249
				],
				[
					21600,
					-13
				]
			],
			[
				[
					7893817,
					1524236
				],
				[
					13816,
					50
				]
			],
			[
				[
					7907633,
					1524286
				],
				[
					66752,
					-5
				],
				[
					-444,
					-68372
				],
				[
					5049,
					7318
				]
			],
			[
				[
					8401901,
					1524980
				],
				[
					1958,
					8305
				],
				[
					-7682,
					17065
				],
				[
					-15401,
					20507
				],
				[
					4804,
					3020
				],
				[
					-9587,
					23369
				],
				[
					139017,
					76158
				]
			],
			[
				[
					8515010,
					1673404
				],
				[
					27702,
					14681
				],
				[
					47545,
					-65218
				],
				[
					16797,
					-4605
				],
				[
					-6755,
					18371
				],
				[
					1414,
					11048
				],
				[
					8762,
					13764
				],
				[
					9948,
					5495
				],
				[
					-5545,
					19062
				],
				[
					10119,
					5804
				]
			],
			[
				[
					8624997,
					1691806
				],
				[
					18562,
					-1203
				],
				[
					-1144,
					-8880
				],
				[
					11026,
					-4159
				],
				[
					8158,
					14180
				],
				[
					21867,
					529
				]
			],
			[
				[
					8683466,
					1692273
				],
				[
					9367,
					-19222
				],
				[
					-16800,
					-1565
				],
				[
					3950,
					-14031
				],
				[
					9439,
					-6635
				],
				[
					-11478,
					-12397
				],
				[
					-1178,
					-13168
				],
				[
					-8112,
					-433
				],
				[
					-39275,
					-19017
				],
				[
					-4378,
					-31978
				],
				[
					-18262,
					-6923
				],
				[
					-1658,
					-5930
				],
				[
					-24522,
					-26267
				],
				[
					-17359,
					-9480
				],
				[
					-14478,
					-62
				],
				[
					-9429,
					15026
				],
				[
					-31790,
					13621
				],
				[
					-13916,
					18613
				],
				[
					-17679,
					-25657
				],
				[
					-19116,
					3164
				],
				[
					-7327,
					-11042
				]
			],
			[
				[
					8632425,
					1797688
				],
				[
					-3931,
					-8592
				],
				[
					419,
					-20687
				],
				[
					5107,
					-4976
				],
				[
					-1024,
					-29538
				],
				[
					-9871,
					10511
				],
				[
					1779,
					-15154
				],
				[
					14062,
					-5914
				],
				[
					-85,
					-11242
				],
				[
					-13884,
					-20290
				]
			],
			[
				[
					8515010,
					1673404
				],
				[
					-12983,
					30155
				],
				[
					-1004,
					10920
				],
				[
					-18177,
					22150
				]
			],
			[
				[
					8482846,
					1736629
				],
				[
					-5330,
					20332
				],
				[
					2030,
					24889
				],
				[
					-16028,
					-7694
				],
				[
					-4025,
					20185
				],
				[
					-7859,
					14798
				]
			],
			[
				[
					8451634,
					1809139
				],
				[
					39220,
					11348
				],
				[
					17290,
					-1286
				],
				[
					28389,
					8256
				],
				[
					26173,
					-1518
				],
				[
					5297,
					-4233
				],
				[
					19337,
					-953
				],
				[
					20440,
					-5771
				],
				[
					24645,
					-17294
				]
			],
			[
				[
					8698127,
					1993326
				],
				[
					14455,
					-6217
				],
				[
					8737,
					-9118
				],
				[
					63287,
					-15153
				],
				[
					38081,
					-16728
				],
				[
					11327,
					-10848
				],
				[
					32091,
					-21403
				],
				[
					8854,
					-2387
				],
				[
					18477,
					-29807
				],
				[
					7983,
					-314
				],
				[
					8783,
					-13466
				],
				[
					16652,
					-12120
				],
				[
					7612,
					1390
				],
				[
					7787,
					-9799
				],
				[
					7959,
					1659
				],
				[
					7330,
					-9670
				],
				[
					4672,
					-16653
				],
				[
					13830,
					-25956
				],
				[
					-6357,
					-10939
				],
				[
					-24377,
					-5062
				],
				[
					-30064,
					834
				],
				[
					-4708,
					-2398
				],
				[
					-30690,
					16884
				],
				[
					-24642,
					5410
				],
				[
					-37389,
					16830
				],
				[
					-19142,
					13705
				],
				[
					-6368,
					10144
				],
				[
					-30699,
					15793
				],
				[
					-7825,
					30803
				],
				[
					-22144,
					30072
				],
				[
					-19057,
					15554
				],
				[
					-31439,
					14545
				],
				[
					-12997,
					16524
				],
				[
					693,
					-8911
				],
				[
					-15355,
					16792
				],
				[
					6823,
					12299
				],
				[
					26112,
					8165
				],
				[
					11708,
					-454
				]
			],
			[
				[
					8424169,
					2057791
				],
				[
					2690,
					-9782
				]
			],
			[
				[
					8426859,
					2048009
				],
				[
					2021,
					-5896
				]
			],
			[
				[
					8428880,
					2042113
				],
				[
					-18545,
					-6021
				],
				[
					-5827,
					-10993
				]
			],
			[
				[
					8404508,
					2025099
				],
				[
					-6074,
					-6218
				]
			],
			[
				[
					8398434,
					2018881
				],
				[
					-13845,
					-4662
				],
				[
					-9550,
					10369
				]
			],
			[
				[
					8375039,
					2024588
				],
				[
					29419,
					33293
				],
				[
					12038,
					6039
				],
				[
					7673,
					-6129
				]
			],
			[
				[
					8729435,
					2052411
				],
				[
					-6289,
					-1055
				],
				[
					20,
					13026
				],
				[
					6269,
					-11971
				]
			],
			[
				[
					9239724,
					2160728
				],
				[
					6532,
					-22200
				],
				[
					-6789,
					-7398
				],
				[
					257,
					29598
				]
			],
			[
				[
					9345033,
					2311344
				],
				[
					-4119,
					-12225
				],
				[
					-14497,
					2464
				],
				[
					6524,
					8856
				],
				[
					12092,
					905
				]
			],
			[
				[
					9318926,
					2296164
				],
				[
					2286,
					-15169
				],
				[
					-19319,
					-15826
				],
				[
					-11287,
					-23941
				],
				[
					20,
					18799
				],
				[
					-6963,
					-13521
				],
				[
					-3267,
					-28655
				],
				[
					4218,
					-13596
				],
				[
					-13641,
					-16814
				],
				[
					-2156,
					16745
				],
				[
					-12823,
					-23974
				],
				[
					-13077,
					-5860
				],
				[
					-2080,
					-11490
				],
				[
					-13633,
					-8421
				],
				[
					-13624,
					-35185
				],
				[
					-21867,
					-11897
				],
				[
					-5216,
					1077
				],
				[
					-8480,
					-13189
				],
				[
					5225,
					-12644
				],
				[
					-11238,
					-12193
				],
				[
					-2566,
					14061
				],
				[
					-2842,
					-20275
				],
				[
					-12817,
					562
				],
				[
					-4344,
					-10474
				],
				[
					-6325,
					1810
				],
				[
					-588,
					17029
				],
				[
					-9971,
					-13916
				],
				[
					-681,
					15319
				],
				[
					4945,
					9386
				],
				[
					-6066,
					3893
				],
				[
					737,
					-21217
				],
				[
					-8128,
					-4942
				],
				[
					-18296,
					317
				],
				[
					-1625,
					-5414
				],
				[
					-21715,
					768
				],
				[
					-9836,
					-4371
				],
				[
					-803,
					10185
				],
				[
					10310,
					12811
				],
				[
					-10602,
					-1240
				],
				[
					4290,
					-7273
				],
				[
					-14137,
					-10951
				],
				[
					-14861,
					-250
				],
				[
					-13091,
					-7196
				],
				[
					-13882,
					2789
				],
				[
					-22498,
					-9149
				],
				[
					-28854,
					-16430
				],
				[
					-5907,
					4665
				],
				[
					-4806,
					26084
				],
				[
					-12889,
					4027
				],
				[
					-4328,
					-5445
				],
				[
					-24673,
					4470
				],
				[
					-23600,
					14453
				],
				[
					-3312,
					-8307
				],
				[
					-30641,
					4024
				],
				[
					-6108,
					9402
				],
				[
					-6071,
					-8251
				],
				[
					-18228,
					2234
				],
				[
					-3571,
					7417
				],
				[
					-5696,
					-9363
				],
				[
					-13899,
					420
				],
				[
					3988,
					-7492
				],
				[
					-27507,
					-11029
				],
				[
					-8138,
					11625
				],
				[
					-14188,
					-2740
				],
				[
					-12076,
					11331
				],
				[
					-27357,
					4426
				],
				[
					-17186,
					-1987
				],
				[
					-7281,
					-7926
				],
				[
					-20447,
					6883
				],
				[
					-8912,
					8003
				],
				[
					-14187,
					-8012
				],
				[
					-46871,
					-4816
				],
				[
					-7242,
					4134
				],
				[
					-19556,
					772
				],
				[
					-17254,
					4478
				],
				[
					-21496,
					-7437
				],
				[
					-34309,
					-4558
				],
				[
					-11738,
					9052
				],
				[
					-17674,
					-25283
				],
				[
					-7162,
					2231
				]
			],
			[
				[
					8467436,
					2053727
				],
				[
					-8986,
					15110
				],
				[
					-215,
					19818
				],
				[
					-7322,
					275
				],
				[
					16,
					36821
				],
				[
					24325,
					373
				],
				[
					-10871,
					29770
				],
				[
					-1160,
					19071
				],
				[
					-21012,
					19817
				],
				[
					49,
					11705
				],
				[
					-8785,
					11934
				],
				[
					4225,
					11821
				],
				[
					9054,
					7458
				],
				[
					-506,
					18337
				],
				[
					10256,
					23810
				],
				[
					929,
					21683
				],
				[
					-7402,
					28920
				],
				[
					4528,
					28845
				],
				[
					-7689,
					12179
				],
				[
					-4287,
					23521
				],
				[
					3211,
					15254
				],
				[
					-8794,
					9887
				],
				[
					-10762,
					32939
				],
				[
					-51648,
					125
				],
				[
					-97,
					-68446
				],
				[
					-52290,
					-177
				]
			],
			[
				[
					8322203,
					2384577
				],
				[
					-4294,
					26644
				],
				[
					-4260,
					7772
				],
				[
					35413,
					306
				],
				[
					263,
					173950
				],
				[
					-133160,
					-473
				],
				[
					1001,
					-174007
				],
				[
					-24912,
					-763
				],
				[
					-80,
					71167
				],
				[
					-93895,
					-2
				],
				[
					-5526,
					9516
				],
				[
					-6687,
					30604
				],
				[
					-18007,
					24540
				],
				[
					-27,
					30502
				],
				[
					-10469,
					31126
				],
				[
					-21448,
					41033
				],
				[
					-4981,
					647
				]
			],
			[
				[
					8031134,
					2657139
				],
				[
					-96,
					53667
				],
				[
					2801,
					-107
				],
				[
					0,
					502149
				]
			],
			[
				[
					8033839,
					3212848
				],
				[
					0,
					241231
				],
				[
					141405,
					0
				],
				[
					141405,
					0
				],
				[
					113124,
					0
				],
				[
					84843,
					0
				],
				[
					84843,
					0
				],
				[
					161244,
					14
				]
			],
			[
				[
					9492171,
					2348133
				],
				[
					-7468,
					-2155
				],
				[
					-8221,
					12226
				],
				[
					1086,
					11235
				],
				[
					-19093,
					-6383
				],
				[
					-7787,
					-10214
				],
				[
					-1979,
					7399
				],
				[
					-22444,
					-11016
				],
				[
					-6294,
					9221
				],
				[
					-3036,
					-14699
				],
				[
					-14030,
					-4449
				],
				[
					-13009,
					-19525
				],
				[
					-23338,
					-10181
				],
				[
					-2361,
					14749
				],
				[
					-5392,
					788
				],
				[
					-909,
					-15906
				],
				[
					-14136,
					12197
				],
				[
					-24834,
					-25256
				]
			],
			[
				[
					8238211,
					1813791
				],
				[
					-5075,
					-3333
				]
			],
			[
				[
					8233136,
					1810458
				],
				[
					-1552,
					5223
				]
			],
			[
				[
					8231584,
					1815681
				],
				[
					6627,
					-1890
				]
			],
			[
				[
					8223726,
					1809400
				],
				[
					14289,
					-5015
				],
				[
					692,
					-14853
				],
				[
					-13157,
					-1388
				],
				[
					-10401,
					-11535
				],
				[
					-9231,
					5877
				],
				[
					-13593,
					-6070
				],
				[
					-4345,
					-10935
				],
				[
					1347,
					-20545
				],
				[
					-17485,
					-6733
				],
				[
					-11191,
					-16388
				],
				[
					-12826,
					-9008
				]
			],
			[
				[
					8147825,
					1712807
				],
				[
					-15210,
					21500
				],
				[
					28560,
					39794
				]
			],
			[
				[
					8161175,
					1774101
				],
				[
					41120,
					46120
				],
				[
					1289,
					-7722
				],
				[
					15777,
					-9407
				],
				[
					4365,
					6308
				]
			],
			[
				[
					8254870,
					1833978
				],
				[
					-9850,
					-9280
				]
			],
			[
				[
					8245020,
					1824698
				],
				[
					9850,
					9280
				]
			],
			[
				[
					8375358,
					1989275
				],
				[
					-2355,
					-15758
				],
				[
					-6434,
					-11105
				],
				[
					-3539,
					7560
				],
				[
					-8378,
					-16687
				],
				[
					-230,
					-23620
				],
				[
					-7691,
					-20861
				],
				[
					-533,
					-32747
				],
				[
					-16212,
					-34100
				],
				[
					-12671,
					1897
				],
				[
					-24621,
					-3520
				],
				[
					-12125,
					-10014
				],
				[
					-8630,
					5531
				],
				[
					-17584,
					726
				]
			],
			[
				[
					8254355,
					1836577
				],
				[
					-22,
					25162
				],
				[
					13185,
					21357
				],
				[
					-5746,
					5644
				],
				[
					-453,
					18625
				],
				[
					45857,
					366
				]
			],
			[
				[
					8307176,
					1907731
				],
				[
					11863,
					29
				],
				[
					3466,
					24816
				],
				[
					8029,
					323
				],
				[
					44,
					35001
				],
				[
					23012,
					31544
				]
			],
			[
				[
					8353590,
					1999444
				],
				[
					16325,
					-14982
				],
				[
					5443,
					4813
				]
			],
			[
				[
					8394573,
					2013929
				],
				[
					-3645,
					-203
				]
			],
			[
				[
					8390928,
					2013726
				],
				[
					3645,
					203
				]
			],
			[
				[
					8395105,
					2013979
				],
				[
					3329,
					4902
				]
			],
			[
				[
					8404508,
					2025099
				],
				[
					-9403,
					-11120
				]
			],
			[
				[
					8417613,
					1792479
				],
				[
					6814,
					-16633
				],
				[
					-11207,
					-3614
				],
				[
					55117,
					-77096
				],
				[
					8390,
					28239
				],
				[
					-2048,
					9385
				],
				[
					8167,
					3869
				]
			],
			[
				[
					8305562,
					1524188
				],
				[
					4197,
					-8484
				],
				[
					14241,
					9607
				],
				[
					1466,
					14929
				],
				[
					-15320,
					19416
				],
				[
					-5022,
					-2867
				],
				[
					-38614,
					54763
				],
				[
					-23329,
					29974
				],
				[
					-2769,
					6818
				]
			],
			[
				[
					8240412,
					1648344
				],
				[
					6368,
					14068
				],
				[
					-3127,
					8207
				],
				[
					-12085,
					-11485
				]
			],
			[
				[
					8231568,
					1659134
				],
				[
					-4820,
					5960
				]
			],
			[
				[
					8226748,
					1665094
				],
				[
					26175,
					21556
				],
				[
					12030,
					3180
				],
				[
					13995,
					15509
				],
				[
					23787,
					15291
				]
			],
			[
				[
					8302735,
					1720630
				],
				[
					12568,
					-23217
				],
				[
					6780,
					1571
				],
				[
					10266,
					15983
				],
				[
					2122,
					10838
				],
				[
					-7660,
					10605
				]
			],
			[
				[
					8326811,
					1736410
				],
				[
					28073,
					15202
				],
				[
					47570,
					35496
				],
				[
					15159,
					5371
				]
			],
			[
				[
					8319608,
					1665630
				],
				[
					369,
					-13311
				],
				[
					-7296,
					-13818
				],
				[
					8729,
					-15567
				],
				[
					10379,
					7867
				],
				[
					3161,
					11986
				],
				[
					-15342,
					22843
				]
			],
			[
				[
					8231568,
					1659134
				],
				[
					8844,
					-10790
				]
			],
			[
				[
					8216803,
					1495297
				],
				[
					-9249,
					-8080
				]
			],
			[
				[
					8207554,
					1487217
				],
				[
					-12110,
					17133
				],
				[
					-6428,
					-9433
				],
				[
					-14134,
					20089
				],
				[
					-12181,
					11784
				],
				[
					2127,
					13516
				],
				[
					11936,
					12239
				],
				[
					12606,
					29160
				],
				[
					3106,
					-4153
				],
				[
					10521,
					16518
				]
			],
			[
				[
					8202997,
					1594070
				],
				[
					10333,
					5680
				],
				[
					9226,
					13921
				],
				[
					-15274,
					20450
				]
			],
			[
				[
					8207282,
					1634121
				],
				[
					-207,
					3891
				]
			],
			[
				[
					8207075,
					1638012
				],
				[
					4815,
					13775
				]
			],
			[
				[
					8211890,
					1651787
				],
				[
					14858,
					13307
				]
			],
			[
				[
					8034830,
					1377838
				],
				[
					-4298,
					3589
				],
				[
					-5582,
					-12166
				]
			],
			[
				[
					8024950,
					1369261
				],
				[
					6440,
					31190
				],
				[
					11456,
					8039
				],
				[
					16079,
					24406
				],
				[
					21710,
					45474
				]
			],
			[
				[
					8080635,
					1478370
				],
				[
					-1762,
					-12177
				],
				[
					9950,
					1030
				],
				[
					9210,
					17569
				],
				[
					-11590,
					13274
				]
			],
			[
				[
					8086443,
					1498066
				],
				[
					11498,
					25348
				],
				[
					9912,
					4117
				],
				[
					16238,
					26668
				],
				[
					28176,
					40209
				],
				[
					35016,
					27978
				]
			],
			[
				[
					8187283,
					1622386
				],
				[
					11483,
					-14918
				]
			],
			[
				[
					8198766,
					1607468
				],
				[
					4231,
					-13398
				]
			],
			[
				[
					8207554,
					1487217
				],
				[
					-2616,
					-20428
				],
				[
					8592,
					-12498
				],
				[
					-12320,
					-17906
				],
				[
					-8054,
					9329
				],
				[
					-20507,
					-35670
				],
				[
					22854,
					-24142
				]
			],
			[
				[
					8141226,
					1355403
				],
				[
					1281,
					29467
				],
				[
					-20875,
					8989
				],
				[
					-39250,
					-81784
				]
			],
			[
				[
					8082382,
					1312075
				],
				[
					-47552,
					65763
				]
			],
			[
				[
					8003543,
					1095103
				],
				[
					-2814,
					-7143
				],
				[
					6377,
					-11165
				],
				[
					-9194,
					-30278
				],
				[
					261,
					-13288
				],
				[
					6442,
					-1277
				],
				[
					-105,
					-16829
				],
				[
					-17852,
					-22770
				],
				[
					3746,
					-14662
				],
				[
					-9312,
					-6836
				],
				[
					-15058,
					-18830
				]
			],
			[
				[
					7966034,
					952025
				],
				[
					-16548,
					18728
				],
				[
					-9546,
					-537
				],
				[
					8104,
					17359
				],
				[
					-15179,
					1142
				],
				[
					-421,
					15125
				],
				[
					-6208,
					-9196
				],
				[
					-5661,
					5981
				],
				[
					-5005,
					-9976
				],
				[
					-11673,
					12623
				],
				[
					-5133,
					-3938
				]
			],
			[
				[
					7898764,
					999336
				],
				[
					3600,
					24306
				],
				[
					13094,
					19663
				],
				[
					6551,
					4253
				],
				[
					-4156,
					8203
				],
				[
					6250,
					13957
				],
				[
					-4990,
					12435
				],
				[
					6350,
					8665
				],
				[
					9199,
					766
				]
			],
			[
				[
					7934662,
					1091584
				],
				[
					13354,
					-14933
				],
				[
					-1809,
					-6013
				]
			],
			[
				[
					7946207,
					1070638
				],
				[
					5224,
					-10842
				],
				[
					-4817,
					-20824
				],
				[
					9751,
					-183
				],
				[
					2308,
					14409
				]
			],
			[
				[
					7958673,
					1053198
				],
				[
					10242,
					12291
				],
				[
					-4525,
					9498
				],
				[
					5242,
					7881
				],
				[
					-2798,
					9656
				],
				[
					-8829,
					-13068
				],
				[
					-5168,
					864
				]
			],
			[
				[
					7952837,
					1080320
				],
				[
					-2233,
					-3294
				]
			],
			[
				[
					7950604,
					1077026
				],
				[
					-1430,
					8399
				],
				[
					9419,
					23498
				]
			],
			[
				[
					7958593,
					1108923
				],
				[
					12175,
					17219
				]
			],
			[
				[
					7970768,
					1126142
				],
				[
					1916,
					-11789
				],
				[
					19046,
					-21303
				],
				[
					11813,
					2053
				]
			],
			[
				[
					7878667,
					1064273
				],
				[
					-2498,
					-5019
				],
				[
					-13708,
					14425
				]
			],
			[
				[
					7862461,
					1073679
				],
				[
					4305,
					3232
				],
				[
					11901,
					-12638
				]
			],
			[
				[
					7934403,
					1098243
				],
				[
					259,
					-6659
				]
			],
			[
				[
					7898764,
					999336
				],
				[
					-9013,
					1317
				],
				[
					-16445,
					16517
				],
				[
					-4072,
					-6113
				]
			],
			[
				[
					7869234,
					1011057
				],
				[
					-9238,
					9011
				],
				[
					1110,
					9769
				],
				[
					8247,
					-8082
				],
				[
					2285,
					9610
				],
				[
					-11675,
					4422
				],
				[
					-19900,
					27071
				],
				[
					12655,
					23266
				],
				[
					5205,
					-1880
				]
			],
			[
				[
					7857923,
					1084244
				],
				[
					2974,
					-3191
				]
			],
			[
				[
					7860897,
					1081053
				],
				[
					1136,
					-8234
				]
			],
			[
				[
					7862033,
					1072819
				],
				[
					-7269,
					-14971
				],
				[
					12929,
					-7207
				],
				[
					16534,
					-3871
				],
				[
					954,
					5526
				]
			],
			[
				[
					7885181,
					1052296
				],
				[
					8676,
					-5623
				],
				[
					4569,
					5600
				],
				[
					-6862,
					12528
				]
			],
			[
				[
					7891564,
					1064801
				],
				[
					12380,
					17802
				],
				[
					-9196,
					9548
				],
				[
					-9846,
					-9929
				]
			],
			[
				[
					7884902,
					1082222
				],
				[
					-3521,
					-5077
				],
				[
					-8463,
					11396
				],
				[
					1260,
					8893
				]
			],
			[
				[
					7874178,
					1097434
				],
				[
					-299,
					14296
				],
				[
					10413,
					14276
				],
				[
					7830,
					-11688
				],
				[
					17215,
					2125
				],
				[
					-5159,
					7809
				],
				[
					18480,
					7606
				]
			],
			[
				[
					7922658,
					1131858
				],
				[
					599,
					-926
				]
			],
			[
				[
					7923257,
					1130932
				],
				[
					6481,
					-15141
				],
				[
					-1823,
					-9469
				],
				[
					6488,
					-8079
				]
			],
			[
				[
					7807070,
					1068117
				],
				[
					-4388,
					-16818
				]
			],
			[
				[
					7802682,
					1051299
				],
				[
					-11530,
					-1236
				]
			],
			[
				[
					7791152,
					1050063
				],
				[
					-3212,
					17197
				],
				[
					13438,
					5604
				],
				[
					5692,
					-4747
				]
			],
			[
				[
					7869234,
					1011057
				],
				[
					-1022,
					-13493
				]
			],
			[
				[
					7868212,
					997564
				],
				[
					-8802,
					-7094
				],
				[
					-11652,
					7583
				]
			],
			[
				[
					7847758,
					998053
				],
				[
					-14135,
					16105
				],
				[
					1800,
					3547
				],
				[
					-13938,
					15821
				]
			],
			[
				[
					7821485,
					1033526
				],
				[
					1085,
					2389
				]
			],
			[
				[
					7822570,
					1035915
				],
				[
					6661,
					13838
				],
				[
					-12179,
					9586
				]
			],
			[
				[
					7817052,
					1059339
				],
				[
					1279,
					2727
				]
			],
			[
				[
					7818331,
					1062066
				],
				[
					-240,
					4396
				]
			],
			[
				[
					7818091,
					1066462
				],
				[
					19625,
					17322
				],
				[
					6852,
					18134
				]
			],
			[
				[
					7844568,
					1101918
				],
				[
					8182,
					3991
				],
				[
					8789,
					-9311
				],
				[
					-3616,
					-12354
				]
			],
			[
				[
					7963807,
					1337863
				],
				[
					-14752,
					-34327
				]
			],
			[
				[
					8082382,
					1312075
				],
				[
					-48213,
					-102448
				],
				[
					-6809,
					-67745
				],
				[
					-17165,
					-20629
				],
				[
					-6652,
					-26150
				]
			],
			[
				[
					7970768,
					1126142
				],
				[
					-11955,
					17864
				],
				[
					-7841,
					-10935
				],
				[
					-7568,
					374
				],
				[
					-11146,
					22497
				],
				[
					6926,
					9685
				],
				[
					-14065,
					19414
				],
				[
					-9141,
					-614
				],
				[
					-5789,
					13932
				],
				[
					-6561,
					856
				]
			],
			[
				[
					7903628,
					1199215
				],
				[
					3052,
					16038
				]
			],
			[
				[
					7906680,
					1215253
				],
				[
					13531,
					16472
				],
				[
					-4072,
					6060
				]
			],
			[
				[
					7916139,
					1237785
				],
				[
					-3084,
					4541
				]
			],
			[
				[
					7913055,
					1242326
				],
				[
					9038,
					788
				],
				[
					13142,
					14273
				],
				[
					11533,
					2918
				],
				[
					11376,
					12510
				]
			],
			[
				[
					7958144,
					1272815
				],
				[
					17009,
					-19322
				],
				[
					10474,
					14681
				],
				[
					-10493,
					15226
				]
			],
			[
				[
					7975134,
					1283400
				],
				[
					31450,
					57059
				],
				[
					5389,
					17275
				],
				[
					12977,
					11527
				]
			],
			[
				[
					8034830,
					1377838
				],
				[
					0,
					0
				]
			],
			[
				[
					7958593,
					1108923
				],
				[
					-8464,
					13629
				],
				[
					-15726,
					-24309
				]
			],
			[
				[
					7923257,
					1130932
				],
				[
					6559,
					13537
				],
				[
					-11615,
					21135
				],
				[
					-7695,
					-12291
				],
				[
					12152,
					-21455
				]
			],
			[
				[
					7874178,
					1097434
				],
				[
					-6258,
					97
				],
				[
					-7023,
					-16478
				]
			],
			[
				[
					7844568,
					1101918
				],
				[
					-8472,
					16514
				],
				[
					-14986,
					-16772
				],
				[
					-253,
					12262
				]
			],
			[
				[
					7820857,
					1113922
				],
				[
					-1012,
					6649
				]
			],
			[
				[
					7819845,
					1120571
				],
				[
					-31861,
					48860
				]
			],
			[
				[
					7787984,
					1169431
				],
				[
					7940,
					7604
				],
				[
					10150,
					663
				],
				[
					17938,
					24997
				]
			],
			[
				[
					7826511,
					1200494
				],
				[
					6254,
					-6739
				],
				[
					15290,
					1847
				],
				[
					15960,
					11953
				]
			],
			[
				[
					7864015,
					1207555
				],
				[
					11693,
					-13662
				]
			],
			[
				[
					7875708,
					1193893
				],
				[
					7535,
					-14096
				],
				[
					10366,
					17087
				],
				[
					-553,
					11571
				]
			],
			[
				[
					7893056,
					1208455
				],
				[
					5914,
					484
				],
				[
					-2396,
					-20320
				],
				[
					7054,
					10596
				]
			],
			[
				[
					7895235,
					1205136
				],
				[
					0,
					0
				]
			],
			[
				[
					8013487,
					1425843
				],
				[
					-3668,
					-20115
				]
			],
			[
				[
					8000345,
					1425706
				],
				[
					5642,
					7576
				],
				[
					7500,
					-7439
				]
			],
			[
				[
					8001762,
					1462455
				],
				[
					4368,
					-15655
				]
			],
			[
				[
					8006130,
					1446800
				],
				[
					-13082,
					-3278
				],
				[
					-1094,
					-5624
				]
			],
			[
				[
					7978990,
					1463227
				],
				[
					12668,
					2604
				],
				[
					3523,
					-9540
				],
				[
					6581,
					6164
				]
			],
			[
				[
					8089116,
					2006698
				],
				[
					-2414,
					-10849
				],
				[
					10463,
					-11520
				],
				[
					-3670,
					-6343
				],
				[
					9267,
					-28978
				],
				[
					3389,
					4505
				],
				[
					11525,
					-6288
				],
				[
					-943,
					-21112
				],
				[
					12682,
					-10406
				],
				[
					1233,
					-12055
				],
				[
					-215,
					-118192
				],
				[
					30984,
					-403
				],
				[
					-242,
					-10956
				]
			],
			[
				[
					8147825,
					1712807
				],
				[
					-9395,
					-14919
				],
				[
					-1226,
					-19094
				],
				[
					-6154,
					-17948
				],
				[
					-10637,
					617
				],
				[
					-9951,
					-37790
				],
				[
					-18108,
					-33455
				],
				[
					-27747,
					-39879
				],
				[
					-8806,
					-47779
				],
				[
					-6122,
					-10159
				],
				[
					-4706,
					-20143
				]
			],
			[
				[
					8044973,
					1472258
				],
				[
					-18690,
					24456
				]
			],
			[
				[
					8026283,
					1496714
				],
				[
					22169,
					71329
				],
				[
					-2626,
					10826
				],
				[
					-20901,
					7148
				],
				[
					7953,
					24566
				],
				[
					-170,
					154883
				],
				[
					-965,
					3
				],
				[
					-145,
					192340
				],
				[
					-1593,
					-51
				],
				[
					934,
					48943
				]
			],
			[
				[
					8030939,
					2006701
				],
				[
					58177,
					-3
				]
			],
			[
				[
					7919699,
					1603911
				],
				[
					391,
					976
				]
			],
			[
				[
					7920090,
					1604887
				],
				[
					-391,
					-976
				]
			],
			[
				[
					7879482,
					1640375
				],
				[
					-11164,
					6116
				]
			],
			[
				[
					7868318,
					1646491
				],
				[
					191,
					14166
				]
			],
			[
				[
					7868509,
					1660657
				],
				[
					10642,
					-2154
				],
				[
					331,
					-18128
				]
			],
			[
				[
					8026283,
					1496714
				],
				[
					-7211,
					-17479
				],
				[
					-13431,
					-13193
				]
			],
			[
				[
					8005641,
					1466042
				],
				[
					-3879,
					-3587
				]
			],
			[
				[
					7907633,
					1524286
				],
				[
					-228,
					19627
				],
				[
					9327,
					12768
				],
				[
					5774,
					26469
				],
				[
					-1207,
					11050
				]
			],
			[
				[
					7921299,
					1594200
				],
				[
					16614,
					-12815
				],
				[
					18528,
					30679
				],
				[
					-9945,
					12059
				],
				[
					-14725,
					3880
				]
			],
			[
				[
					7931771,
					1628003
				],
				[
					-16843,
					13303
				]
			],
			[
				[
					7914928,
					1641306
				],
				[
					-2648,
					-4221
				]
			],
			[
				[
					7912280,
					1637085
				],
				[
					-12187,
					5088
				]
			],
			[
				[
					7900093,
					1642173
				],
				[
					886,
					9473
				],
				[
					-9958,
					3698
				],
				[
					1700,
					16508
				],
				[
					-20572,
					7264
				]
			],
			[
				[
					7872149,
					1679116
				],
				[
					6381,
					33430
				],
				[
					12071,
					-4430
				],
				[
					1720,
					19274
				],
				[
					-11388,
					31190
				],
				[
					1329,
					15313
				],
				[
					6199,
					15372
				],
				[
					3052,
					52446
				],
				[
					8826,
					42030
				],
				[
					-4525,
					14405
				],
				[
					2293,
					12837
				],
				[
					-314,
					31519
				],
				[
					3683,
					21998
				],
				[
					-11476,
					16577
				],
				[
					7838,
					31657
				],
				[
					-9681,
					32997
				],
				[
					2786,
					9252
				],
				[
					-2712,
					18114
				],
				[
					-7895,
					13531
				],
				[
					-1137,
					21175
				],
				[
					8449,
					19462
				],
				[
					-516,
					16291
				],
				[
					4675,
					9884
				],
				[
					-7437,
					40109
				],
				[
					2974,
					15256
				],
				[
					-6517,
					24692
				],
				[
					1083,
					22016
				],
				[
					-19341,
					48865
				],
				[
					6926,
					14979
				],
				[
					-2758,
					23318
				],
				[
					4468,
					28657
				],
				[
					-180,
					24551
				],
				[
					10043,
					17042
				],
				[
					6053,
					34381
				],
				[
					17957,
					48582
				],
				[
					4046,
					21823
				],
				[
					13662,
					14415
				],
				[
					13998,
					21852
				]
			],
			[
				[
					7936784,
					2553978
				],
				[
					5654,
					-8551
				],
				[
					27825,
					20092
				],
				[
					8632,
					-2978
				],
				[
					21931,
					10689
				],
				[
					6801,
					16647
				],
				[
					-5858,
					903
				],
				[
					14197,
					33043
				],
				[
					-1956,
					8725
				],
				[
					17124,
					24591
				]
			],
			[
				[
					8031134,
					2657139
				],
				[
					-195,
					-650438
				]
			],
			[
				[
					7891692,
					1571598
				],
				[
					2346,
					-8528
				],
				[
					-2741,
					-24164
				],
				[
					2520,
					-14670
				]
			],
			[
				[
					7872217,
					1524249
				],
				[
					-19655,
					37757
				]
			],
			[
				[
					7852562,
					1562006
				],
				[
					10129,
					15022
				],
				[
					14037,
					-12624
				],
				[
					3570,
					9371
				],
				[
					11394,
					-2177
				]
			],
			[
				[
					7473931,
					1688237
				],
				[
					0,
					0
				]
			],
			[
				[
					7476526,
					1959954
				],
				[
					21038,
					-5
				],
				[
					-15,
					-10401
				],
				[
					-20923,
					-307
				],
				[
					-100,
					10713
				]
			],
			[
				[
					7490955,
					1989908
				],
				[
					0,
					0
				]
			],
			[
				[
					7595323,
					2108457
				],
				[
					-6064,
					560
				]
			],
			[
				[
					7589259,
					2109017
				],
				[
					-520,
					31405
				],
				[
					5976,
					17942
				],
				[
					9767,
					13494
				],
				[
					-9958,
					-52827
				],
				[
					799,
					-10574
				]
			],
			[
				[
					7595323,
					2108457
				],
				[
					5852,
					15685
				],
				[
					-786,
					15478
				],
				[
					20028,
					60926
				],
				[
					36924,
					-22637
				],
				[
					-11517,
					-16929
				],
				[
					-7986,
					-21638
				],
				[
					-23935,
					-46315
				]
			],
			[
				[
					7613903,
					2093027
				],
				[
					-8830,
					-3656
				],
				[
					-9750,
					19086
				]
			],
			[
				[
					7872149,
					1679116
				],
				[
					-3640,
					-18459
				]
			],
			[
				[
					7868318,
					1646491
				],
				[
					-2597,
					-13056
				],
				[
					12298,
					-4983
				]
			],
			[
				[
					7878019,
					1628452
				],
				[
					-613,
					-3214
				]
			],
			[
				[
					7877406,
					1625238
				],
				[
					-10596,
					3953
				],
				[
					-8747,
					-11651
				]
			],
			[
				[
					7858063,
					1617540
				],
				[
					-1927,
					4521
				],
				[
					-22799,
					11711
				]
			],
			[
				[
					7833337,
					1633772
				],
				[
					-2612,
					7783
				],
				[
					-12068,
					1533
				],
				[
					-5320,
					-28039
				],
				[
					5325,
					-2178
				],
				[
					-2858,
					-15222
				],
				[
					13710,
					-4563
				]
			],
			[
				[
					7829514,
					1593086
				],
				[
					22039,
					-8526
				]
			],
			[
				[
					7851553,
					1584560
				],
				[
					-3222,
					-15143
				]
			],
			[
				[
					7848331,
					1569417
				],
				[
					-9746,
					-45823
				],
				[
					-44931,
					465
				]
			],
			[
				[
					7793654,
					1524059
				],
				[
					-21872,
					142
				],
				[
					-12105,
					13034
				]
			],
			[
				[
					7759677,
					1537235
				],
				[
					720,
					16702
				],
				[
					-4075,
					13282
				],
				[
					1518,
					17214
				],
				[
					-22107,
					38382
				],
				[
					20707,
					22067
				],
				[
					5485,
					13475
				],
				[
					7033,
					-7371
				]
			],
			[
				[
					7768958,
					1650986
				],
				[
					-471,
					-8091
				],
				[
					10998,
					-24112
				],
				[
					8674,
					-3887
				],
				[
					3244,
					26793
				],
				[
					-7806,
					17420
				],
				[
					-6752,
					429
				]
			],
			[
				[
					7776845,
					1659538
				],
				[
					-2693,
					12033
				]
			],
			[
				[
					7774152,
					1671571
				],
				[
					-2738,
					16287
				]
			],
			[
				[
					7771414,
					1687858
				],
				[
					24618,
					12663
				],
				[
					-9106,
					24975
				],
				[
					8183,
					13059
				],
				[
					-2935,
					5555
				],
				[
					9260,
					9885
				],
				[
					-6472,
					14436
				],
				[
					1322,
					28490
				],
				[
					-11360,
					-1697
				],
				[
					-9836,
					-17041
				],
				[
					8440,
					-21079
				],
				[
					-10454,
					-11379
				]
			],
			[
				[
					7773074,
					1745725
				],
				[
					-2708,
					17100
				],
				[
					-7176,
					2448
				],
				[
					-15417,
					-15700
				],
				[
					4313,
					-7968
				],
				[
					-5787,
					-7270
				],
				[
					-4528,
					8889
				],
				[
					-16318,
					-16518
				]
			],
			[
				[
					7725453,
					1726706
				],
				[
					-14733,
					7273
				],
				[
					-22954,
					21710
				],
				[
					-5303,
					12280
				],
				[
					-4055,
					34185
				],
				[
					-10374,
					9731
				],
				[
					-15015,
					4140
				],
				[
					2395,
					22666
				],
				[
					-5795,
					9515
				],
				[
					2725,
					33874
				],
				[
					3923,
					11512
				],
				[
					-3827,
					10714
				],
				[
					-11819,
					-6746
				],
				[
					2068,
					20870
				],
				[
					-1939,
					17628
				],
				[
					-11543,
					9520
				],
				[
					1207,
					41295
				],
				[
					-10775,
					-1210
				],
				[
					-3163,
					9230
				],
				[
					2906,
					17889
				],
				[
					-17147,
					197
				]
			],
			[
				[
					7602235,
					2012979
				],
				[
					3366,
					11630
				],
				[
					1528,
					34274
				],
				[
					9789,
					-1148
				],
				[
					9402,
					32365
				],
				[
					11320,
					9300
				],
				[
					12978,
					24137
				],
				[
					5663,
					22285
				],
				[
					13181,
					31330
				],
				[
					9433,
					10995
				],
				[
					10411,
					-11910
				],
				[
					-999,
					-11684
				],
				[
					11322,
					14788
				],
				[
					9010,
					21852
				],
				[
					14251,
					3457
				],
				[
					2000,
					-13678
				],
				[
					11675,
					2189
				],
				[
					7857,
					28254
				],
				[
					2010,
					-19895
				],
				[
					-2859,
					-15843
				],
				[
					14494,
					9713
				],
				[
					7244,
					25003
				],
				[
					12150,
					15447
				],
				[
					5084,
					18356
				],
				[
					7208,
					-11421
				],
				[
					-93,
					10596
				],
				[
					9531,
					30604
				],
				[
					8809,
					6925
				],
				[
					801,
					12398
				],
				[
					13099,
					11721
				],
				[
					1045,
					17134
				],
				[
					13033,
					315
				],
				[
					7082,
					13828
				],
				[
					2378,
					16750
				],
				[
					8378,
					4337
				],
				[
					1162,
					22108
				],
				[
					-3628,
					17425
				],
				[
					4758,
					37330
				],
				[
					19387,
					6647
				],
				[
					9573,
					30270
				],
				[
					12417,
					17554
				],
				[
					-7177,
					112
				],
				[
					14526,
					31332
				],
				[
					31950,
					23817
				]
			],
			[
				[
					7850777,
					1669983
				],
				[
					2683,
					13110
				],
				[
					-19190,
					7142
				],
				[
					-3437,
					-17957
				]
			],
			[
				[
					7830833,
					1672278
				],
				[
					-1660,
					-8101
				],
				[
					9739,
					-3810
				],
				[
					-1888,
					-9719
				],
				[
					20845,
					-8382
				],
				[
					2468,
					10429
				],
				[
					-9384,
					2680
				],
				[
					-176,
					14608
				]
			],
			[
				[
					7758974,
					1122505
				],
				[
					0,
					0
				]
			],
			[
				[
					7819845,
					1120571
				],
				[
					-6010,
					-8130
				],
				[
					-6844,
					6281
				],
				[
					-8671,
					-16593
				],
				[
					-11432,
					8623
				]
			],
			[
				[
					7786888,
					1110752
				],
				[
					-7195,
					13229
				],
				[
					9072,
					12978
				],
				[
					-7338,
					11480
				]
			],
			[
				[
					7781427,
					1148439
				],
				[
					6557,
					20992
				]
			],
			[
				[
					7796037,
					1182889
				],
				[
					-13016,
					-9524
				],
				[
					-4995,
					-20900
				],
				[
					-18289,
					-12573
				]
			],
			[
				[
					7759737,
					1139892
				],
				[
					-5911,
					8664
				],
				[
					-6329,
					-5624
				]
			],
			[
				[
					7747497,
					1142932
				],
				[
					-7573,
					11800
				],
				[
					-9155,
					-13761
				]
			],
			[
				[
					7730769,
					1140971
				],
				[
					-4675,
					553
				]
			],
			[
				[
					7726094,
					1141524
				],
				[
					2033,
					-13982
				]
			],
			[
				[
					7728127,
					1127542
				],
				[
					-8533,
					-9463
				],
				[
					4587,
					-7376
				]
			],
			[
				[
					7724181,
					1110703
				],
				[
					-14065,
					-8328
				]
			],
			[
				[
					7710116,
					1102375
				],
				[
					-3864,
					5587
				]
			],
			[
				[
					7706252,
					1107962
				],
				[
					-1200,
					11895
				],
				[
					-9189,
					31739
				],
				[
					-12158,
					19526
				],
				[
					9003,
					16231
				],
				[
					-11276,
					12007
				],
				[
					6577,
					9864
				],
				[
					2689,
					-9782
				],
				[
					5104,
					7056
				],
				[
					-1667,
					14046
				],
				[
					-14764,
					22064
				],
				[
					-1283,
					-14879
				],
				[
					-7771,
					-3472
				],
				[
					-11874,
					9324
				],
				[
					3695,
					11337
				],
				[
					-2266,
					24889
				],
				[
					-15017,
					24270
				],
				[
					3946,
					8007
				],
				[
					-15972,
					18365
				],
				[
					14922,
					10551
				],
				[
					-2488,
					22554
				]
			],
			[
				[
					7645263,
					1353554
				],
				[
					18047,
					-26855
				],
				[
					18187,
					-3013
				],
				[
					10878,
					-6620
				],
				[
					3247,
					10613
				],
				[
					9919,
					7390
				],
				[
					1138,
					-6564
				],
				[
					20646,
					-30605
				],
				[
					19506,
					29418
				],
				[
					2485,
					-9421
				],
				[
					10937,
					-3705
				]
			],
			[
				[
					7710672,
					1202341
				],
				[
					-1366,
					-10597
				],
				[
					9667,
					-15313
				]
			],
			[
				[
					7718973,
					1176431
				],
				[
					1254,
					-5094
				]
			],
			[
				[
					7720227,
					1171337
				],
				[
					1449,
					-18479
				],
				[
					5043,
					8088
				]
			],
			[
				[
					7726719,
					1160946
				],
				[
					6600,
					9416
				],
				[
					-5594,
					8189
				],
				[
					3610,
					9478
				]
			],
			[
				[
					7731335,
					1188029
				],
				[
					6956,
					8610
				],
				[
					-13023,
					9001
				],
				[
					-6552,
					-6682
				],
				[
					-8044,
					3383
				]
			],
			[
				[
					7610298,
					1510237
				],
				[
					148,
					-11237
				],
				[
					-11694,
					11229
				],
				[
					11546,
					8
				]
			],
			[
				[
					7529597,
					1755172
				],
				[
					1555,
					-6792
				],
				[
					126405,
					-174495
				],
				[
					5698,
					-11364
				],
				[
					-4484,
					-10365
				],
				[
					7608,
					-2693
				],
				[
					13739,
					-25567
				],
				[
					72897,
					307
				],
				[
					6662,
					13032
				]
			],
			[
				[
					7793654,
					1524059
				],
				[
					42848,
					-89638
				]
			],
			[
				[
					7836502,
					1434421
				],
				[
					-40187,
					-58752
				],
				[
					-9771,
					-4357
				]
			],
			[
				[
					7786544,
					1371312
				],
				[
					-17703,
					22635
				],
				[
					-35020,
					50830
				],
				[
					-11419,
					-40062
				],
				[
					-8104,
					4592
				],
				[
					-15156,
					21975
				],
				[
					-31640,
					-45942
				],
				[
					-17225,
					25039
				],
				[
					53813,
					77032
				],
				[
					-29085,
					39737
				],
				[
					-5986,
					-5472
				],
				[
					-11448,
					-30769
				],
				[
					-5432,
					16493
				],
				[
					-5555,
					2659
				],
				[
					-8268,
					18013
				],
				[
					-12443,
					3362
				],
				[
					-8515,
					11553
				],
				[
					-14668,
					-6257
				],
				[
					2432,
					-7828
				],
				[
					-7135,
					-9824
				],
				[
					5502,
					-28622
				],
				[
					-7027,
					-25808
				],
				[
					3219,
					-9022
				],
				[
					-617,
					-21215
				],
				[
					-12143,
					-17264
				]
			],
			[
				[
					7586921,
					1417147
				],
				[
					-9433,
					10883
				],
				[
					764,
					14455
				],
				[
					-6366,
					2694
				],
				[
					-10324,
					-20398
				],
				[
					-5716,
					9764
				],
				[
					-5551,
					-6474
				],
				[
					-26909,
					38624
				],
				[
					-10985,
					52
				],
				[
					-4712,
					-11987
				],
				[
					12821,
					-11448
				],
				[
					-9913,
					-21309
				],
				[
					-10727,
					-9876
				],
				[
					3257,
					-13634
				],
				[
					-9737,
					-12323
				],
				[
					-4246,
					-13033
				]
			],
			[
				[
					7489144,
					1373137
				],
				[
					-65325,
					93666
				],
				[
					-5479,
					25613
				],
				[
					-8998,
					5207
				]
			],
			[
				[
					7409342,
					1497623
				],
				[
					-470,
					256618
				],
				[
					4596,
					11227
				],
				[
					91372,
					12
				],
				[
					10567,
					-8886
				],
				[
					8090,
					8873
				],
				[
					6100,
					-10295
				]
			],
			[
				[
					7966034,
					952025
				],
				[
					-8597,
					-13236
				]
			],
			[
				[
					7957437,
					938789
				],
				[
					-16583,
					15517
				],
				[
					-3958,
					12520
				],
				[
					-10015,
					-18449
				],
				[
					7288,
					-21667
				],
				[
					-14,
					-16869
				],
				[
					22637,
					-20
				]
			],
			[
				[
					7956792,
					909821
				],
				[
					6688,
					-11590
				],
				[
					-3217,
					-6656
				],
				[
					-12038,
					12357
				],
				[
					-7741,
					-6886
				],
				[
					1528,
					-23214
				],
				[
					-5227,
					-18137
				],
				[
					-4586,
					3635
				],
				[
					-2310,
					16604
				],
				[
					-5645,
					4786
				]
			],
			[
				[
					7924244,
					880720
				],
				[
					5351,
					19032
				],
				[
					-8653,
					4114
				],
				[
					248,
					7847
				],
				[
					-15437,
					-5506
				],
				[
					-2979,
					23607
				],
				[
					-6247,
					8586
				],
				[
					2395,
					14868
				],
				[
					-30710,
					44296
				]
			],
			[
				[
					7820857,
					1113922
				],
				[
					-11698,
					-12585
				],
				[
					4154,
					-17921
				],
				[
					-3017,
					-13057
				]
			],
			[
				[
					7810296,
					1070359
				],
				[
					-3226,
					-2242
				]
			],
			[
				[
					7791152,
					1050063
				],
				[
					-7609,
					-3056
				],
				[
					-8721,
					5843
				]
			],
			[
				[
					7774822,
					1052850
				],
				[
					-11761,
					27571
				],
				[
					7077,
					15231
				]
			],
			[
				[
					7770138,
					1095652
				],
				[
					16750,
					15100
				]
			],
			[
				[
					7901485,
					1259469
				],
				[
					-7171,
					-4111
				]
			],
			[
				[
					7894314,
					1255358
				],
				[
					-3226,
					7399
				]
			],
			[
				[
					7891088,
					1262757
				],
				[
					-2615,
					5921
				]
			],
			[
				[
					7888473,
					1268678
				],
				[
					6812,
					7320
				]
			],
			[
				[
					7904586,
					1255337
				],
				[
					-197,
					-933
				]
			],
			[
				[
					7904389,
					1254404
				],
				[
					-10024,
					-7355
				]
			],
			[
				[
					7894365,
					1247049
				],
				[
					-1987,
					4559
				]
			],
			[
				[
					7892378,
					1251608
				],
				[
					1936,
					3750
				]
			],
			[
				[
					7898756,
					1241990
				],
				[
					-339,
					524
				]
			],
			[
				[
					7898417,
					1242514
				],
				[
					-812,
					1259
				]
			],
			[
				[
					7897605,
					1243773
				],
				[
					1151,
					-1783
				]
			],
			[
				[
					7904389,
					1254404
				],
				[
					-6957,
					-10367
				]
			],
			[
				[
					7897432,
					1244037
				],
				[
					-3067,
					3012
				]
			],
			[
				[
					7888860,
					1257694
				],
				[
					2963,
					-5693
				]
			],
			[
				[
					7891823,
					1252001
				],
				[
					-3072,
					-4285
				]
			],
			[
				[
					7888751,
					1247716
				],
				[
					-3358,
					7994
				]
			],
			[
				[
					7885393,
					1255710
				],
				[
					1395,
					1823
				]
			],
			[
				[
					7886788,
					1257533
				],
				[
					2072,
					161
				]
			],
			[
				[
					7894365,
					1247049
				],
				[
					-1144,
					-1908
				]
			],
			[
				[
					7893221,
					1245141
				],
				[
					-2438,
					-1452
				]
			],
			[
				[
					7890783,
					1243689
				],
				[
					-1267,
					2010
				]
			],
			[
				[
					7889516,
					1245699
				],
				[
					-765,
					2017
				]
			],
			[
				[
					7891823,
					1252001
				],
				[
					555,
					-393
				]
			],
			[
				[
					7897432,
					1244037
				],
				[
					173,
					-264
				]
			],
			[
				[
					7898417,
					1242514
				],
				[
					-2405,
					-2419
				]
			],
			[
				[
					7896012,
					1240095
				],
				[
					-2791,
					5046
				]
			],
			[
				[
					7898756,
					1241990
				],
				[
					-10185,
					-19223
				]
			],
			[
				[
					7888571,
					1222767
				],
				[
					-21,
					57
				]
			],
			[
				[
					7888550,
					1222824
				],
				[
					5647,
					9373
				]
			],
			[
				[
					7894197,
					1232197
				],
				[
					1594,
					2291
				]
			],
			[
				[
					7895791,
					1234488
				],
				[
					-1504,
					1714
				]
			],
			[
				[
					7894287,
					1236202
				],
				[
					-1476,
					2179
				]
			],
			[
				[
					7892811,
					1238381
				],
				[
					819,
					1169
				]
			],
			[
				[
					7893630,
					1239550
				],
				[
					2382,
					545
				]
			],
			[
				[
					7893630,
					1239550
				],
				[
					-3964,
					2990
				]
			],
			[
				[
					7889666,
					1242540
				],
				[
					1117,
					1149
				]
			],
			[
				[
					7892811,
					1238381
				],
				[
					-4807,
					-873
				]
			],
			[
				[
					7888004,
					1237508
				],
				[
					-1071,
					3181
				]
			],
			[
				[
					7886933,
					1240689
				],
				[
					2159,
					1783
				]
			],
			[
				[
					7889092,
					1242472
				],
				[
					574,
					68
				]
			],
			[
				[
					7894287,
					1236202
				],
				[
					-65,
					-47
				]
			],
			[
				[
					7894222,
					1236155
				],
				[
					-3804,
					-2367
				]
			],
			[
				[
					7890418,
					1233788
				],
				[
					-2353,
					-434
				]
			],
			[
				[
					7888065,
					1233354
				],
				[
					-61,
					4154
				]
			],
			[
				[
					7888065,
					1233354
				],
				[
					-2824,
					-1184
				]
			],
			[
				[
					7885241,
					1232170
				],
				[
					-711,
					2012
				]
			],
			[
				[
					7884530,
					1234182
				],
				[
					-2174,
					3375
				]
			],
			[
				[
					7882356,
					1237557
				],
				[
					3219,
					4272
				]
			],
			[
				[
					7885575,
					1241829
				],
				[
					1358,
					-1140
				]
			],
			[
				[
					7894518,
					1234183
				],
				[
					0,
					0
				]
			],
			[
				[
					7895791,
					1234488
				],
				[
					-1569,
					1667
				]
			],
			[
				[
					7894197,
					1232197
				],
				[
					-2655,
					-751
				]
			],
			[
				[
					7891542,
					1231446
				],
				[
					-1124,
					2342
				]
			],
			[
				[
					7888550,
					1222824
				],
				[
					1005,
					5621
				]
			],
			[
				[
					7889555,
					1228445
				],
				[
					1987,
					3001
				]
			],
			[
				[
					7889555,
					1228445
				],
				[
					-3165,
					-503
				]
			],
			[
				[
					7886390,
					1227942
				],
				[
					-1149,
					4228
				]
			],
			[
				[
					7888571,
					1222767
				],
				[
					-5024,
					-497
				]
			],
			[
				[
					7883547,
					1222270
				],
				[
					-1087,
					2080
				]
			],
			[
				[
					7882460,
					1224350
				],
				[
					3930,
					3592
				]
			],
			[
				[
					7882460,
					1224350
				],
				[
					-3343,
					-520
				]
			],
			[
				[
					7879117,
					1223830
				],
				[
					-723,
					2611
				]
			],
			[
				[
					7878394,
					1226441
				],
				[
					2701,
					4874
				]
			],
			[
				[
					7881095,
					1231315
				],
				[
					3435,
					2867
				]
			],
			[
				[
					7883547,
					1222270
				],
				[
					-4277,
					-3183
				]
			],
			[
				[
					7879270,
					1219087
				],
				[
					-153,
					4743
				]
			],
			[
				[
					7871686,
					1261570
				],
				[
					7431,
					-6636
				]
			],
			[
				[
					7879117,
					1254934
				],
				[
					6073,
					-3559
				]
			],
			[
				[
					7885190,
					1251375
				],
				[
					-1224,
					-2789
				]
			],
			[
				[
					7883966,
					1248586
				],
				[
					-7867,
					-2986
				]
			],
			[
				[
					7876099,
					1245600
				],
				[
					-668,
					5505
				]
			],
			[
				[
					7875431,
					1251105
				],
				[
					-6123,
					8442
				]
			],
			[
				[
					7883966,
					1248586
				],
				[
					558,
					-2734
				]
			],
			[
				[
					7884524,
					1245852
				],
				[
					-4983,
					-5671
				]
			],
			[
				[
					7879541,
					1240181
				],
				[
					-1820,
					1858
				]
			],
			[
				[
					7877721,
					1242039
				],
				[
					-1622,
					3561
				]
			],
			[
				[
					8388917,
					2012879
				],
				[
					0,
					0
				]
			],
			[
				[
					7882356,
					1237557
				],
				[
					-2815,
					2624
				]
			],
			[
				[
					7884524,
					1245852
				],
				[
					1051,
					-4023
				]
			],
			[
				[
					7881095,
					1231315
				],
				[
					-5379,
					7815
				]
			],
			[
				[
					7875716,
					1239130
				],
				[
					2005,
					2909
				]
			],
			[
				[
					7878394,
					1226441
				],
				[
					-2256,
					-1561
				]
			],
			[
				[
					7876138,
					1224880
				],
				[
					0,
					0
				]
			],
			[
				[
					7876138,
					1224880
				],
				[
					-11240,
					10441
				]
			],
			[
				[
					7864898,
					1235321
				],
				[
					152,
					72
				]
			],
			[
				[
					7865050,
					1235393
				],
				[
					10666,
					3737
				]
			],
			[
				[
					7889092,
					1242472
				],
				[
					424,
					3227
				]
			],
			[
				[
					7885190,
					1251375
				],
				[
					-1690,
					3889
				]
			],
			[
				[
					7883500,
					1255264
				],
				[
					1893,
					446
				]
			],
			[
				[
					7888860,
					1257694
				],
				[
					2228,
					5063
				]
			],
			[
				[
					7886788,
					1257533
				],
				[
					-5723,
					12699
				]
			],
			[
				[
					7881065,
					1270232
				],
				[
					1643,
					2020
				]
			],
			[
				[
					7882708,
					1272252
				],
				[
					5765,
					-3574
				]
			],
			[
				[
					7883500,
					1255264
				],
				[
					-1175,
					2683
				]
			],
			[
				[
					7882325,
					1257947
				],
				[
					-3912,
					8789
				]
			],
			[
				[
					7878413,
					1266736
				],
				[
					2652,
					3496
				]
			],
			[
				[
					7879270,
					1219087
				],
				[
					-17675,
					-4695
				]
			],
			[
				[
					7853887,
					1226112
				],
				[
					4564,
					4930
				]
			],
			[
				[
					7858451,
					1231042
				],
				[
					6447,
					4279
				]
			],
			[
				[
					7882708,
					1272252
				],
				[
					-3240,
					6801
				],
				[
					14646,
					12243
				]
			],
			[
				[
					7878413,
					1266736
				],
				[
					-5377,
					11909
				]
			],
			[
				[
					7853761,
					1337045
				],
				[
					-7139,
					8007
				],
				[
					670,
					15426
				],
				[
					12350,
					9758
				],
				[
					2963,
					9260
				]
			],
			[
				[
					7862605,
					1379496
				],
				[
					12480,
					-24450
				]
			],
			[
				[
					7879117,
					1254934
				],
				[
					3208,
					3013
				]
			],
			[
				[
					7840427,
					1214556
				],
				[
					-384,
					-1093
				]
			],
			[
				[
					7838201,
					1243711
				],
				[
					3467,
					1619
				]
			],
			[
				[
					7841668,
					1245330
				],
				[
					8935,
					-14063
				],
				[
					7848,
					-225
				]
			],
			[
				[
					7875431,
					1251105
				],
				[
					-13009,
					-11684
				]
			],
			[
				[
					7862422,
					1239421
				],
				[
					-1713,
					8502
				]
			],
			[
				[
					7865050,
					1235393
				],
				[
					-2628,
					4028
				]
			],
			[
				[
					7846614,
					1283677
				],
				[
					-8689,
					-24340
				],
				[
					2120,
					-5682
				]
			],
			[
				[
					7840494,
					1249163
				],
				[
					1174,
					-3833
				]
			],
			[
				[
					7777095,
					1334658
				],
				[
					9449,
					36654
				]
			],
			[
				[
					7836502,
					1434421
				],
				[
					26103,
					-54925
				]
			],
			[
				[
					7845581,
					1205194
				],
				[
					-9304,
					-2145
				]
			],
			[
				[
					7985657,
					1388341
				],
				[
					-8006,
					-10475
				]
			],
			[
				[
					8005641,
					1466042
				],
				[
					8460,
					-8580
				],
				[
					-7971,
					-10662
				]
			],
			[
				[
					8426859,
					2048009
				],
				[
					2021,
					-5896
				]
			],
			[
				[
					8467436,
					2053727
				],
				[
					-6074,
					4008
				],
				[
					-16316,
					-6167
				],
				[
					-4490,
					9615
				]
			],
			[
				[
					8440556,
					2061183
				],
				[
					238,
					246
				]
			],
			[
				[
					8440794,
					2061429
				],
				[
					1176,
					582
				]
			],
			[
				[
					8441970,
					2062011
				],
				[
					323,
					149
				]
			],
			[
				[
					8442293,
					2062160
				],
				[
					608,
					997
				]
			],
			[
				[
					8442901,
					2063157
				],
				[
					8298,
					13324
				],
				[
					-9185,
					3286
				],
				[
					-7703,
					-7669
				]
			],
			[
				[
					8434311,
					2072098
				],
				[
					42,
					-528
				]
			],
			[
				[
					8434353,
					2071570
				],
				[
					-4725,
					-5732
				]
			],
			[
				[
					8429628,
					2065838
				],
				[
					-5459,
					-8047
				]
			],
			[
				[
					8375039,
					2024588
				],
				[
					-21449,
					-25144
				]
			],
			[
				[
					8307176,
					1907731
				],
				[
					-2572,
					29418
				],
				[
					10917,
					21252
				],
				[
					-2277,
					12041
				],
				[
					-14826,
					11489
				],
				[
					-8856,
					-5501
				],
				[
					2210,
					23605
				],
				[
					11910,
					15895
				],
				[
					-19317,
					111359
				],
				[
					-4679,
					12531
				],
				[
					8811,
					18343
				],
				[
					-2454,
					20366
				],
				[
					5309,
					6586
				],
				[
					-2786,
					23354
				],
				[
					11380,
					41873
				],
				[
					-6781,
					18948
				],
				[
					-9217,
					8448
				],
				[
					-6530,
					18082
				],
				[
					2226,
					7858
				],
				[
					-10913,
					16612
				],
				[
					7882,
					24741
				],
				[
					-7615,
					11279
				],
				[
					-399,
					27556
				],
				[
					53604,
					711
				]
			],
			[
				[
					8440556,
					2061183
				],
				[
					238,
					246
				]
			],
			[
				[
					8441970,
					2062011
				],
				[
					323,
					149
				]
			],
			[
				[
					8434353,
					2071570
				],
				[
					-4725,
					-5732
				]
			],
			[
				[
					8442901,
					2063157
				],
				[
					-8590,
					8941
				]
			],
			[
				[
					8984262,
					1417197
				],
				[
					-9727,
					-8410
				],
				[
					-9799,
					-31512
				],
				[
					-6607,
					3890
				],
				[
					20462,
					34031
				],
				[
					5671,
					2001
				]
			],
			[
				[
					9006073,
					1435370
				],
				[
					-7478,
					-13886
				],
				[
					-415,
					10870
				],
				[
					-6564,
					1400
				],
				[
					-17667,
					-20152
				],
				[
					-18181,
					-28106
				],
				[
					-3596,
					-19410
				],
				[
					-6167,
					-6033
				],
				[
					4539,
					-16890
				],
				[
					9407,
					-4888
				],
				[
					-21973,
					-3496
				],
				[
					-848,
					9108
				],
				[
					7097,
					21211
				],
				[
					-689,
					10565
				],
				[
					17341,
					18495
				],
				[
					28133,
					38668
				],
				[
					17061,
					2544
				]
			],
			[
				[
					8417613,
					1792479
				],
				[
					14792,
					4457
				],
				[
					19229,
					12203
				]
			],
			[
				[
					8302735,
					1720630
				],
				[
					24076,
					15780
				]
			],
			[
				[
					8632425,
					1797688
				],
				[
					9955,
					-4695
				],
				[
					25562,
					-25491
				],
				[
					17396,
					-26213
				],
				[
					2135,
					-18297
				],
				[
					7135,
					-17243
				],
				[
					-9486,
					12684
				],
				[
					-24221,
					13618
				],
				[
					-2813,
					-7713
				],
				[
					8468,
					-2534
				],
				[
					3513,
					-12204
				],
				[
					13397,
					-17327
				]
			],
			[
				[
					8210009,
					1849130
				],
				[
					8625,
					-6099
				],
				[
					-10005,
					-6878
				],
				[
					1380,
					12977
				]
			],
			[
				[
					8254355,
					1836577
				],
				[
					515,
					-2599
				]
			],
			[
				[
					8245020,
					1824698
				],
				[
					-6809,
					-10907
				]
			],
			[
				[
					8231584,
					1815681
				],
				[
					-14862,
					1337
				],
				[
					-2855,
					9840
				],
				[
					6932,
					16200
				],
				[
					-8965,
					32386
				],
				[
					1769,
					30257
				],
				[
					-18096,
					24074
				],
				[
					-7324,
					38807
				],
				[
					-3473,
					29237
				],
				[
					2326,
					9061
				],
				[
					-1395,
					29933
				],
				[
					12429,
					29296
				],
				[
					-662,
					26144
				],
				[
					-5372,
					13718
				],
				[
					-9164,
					7479
				],
				[
					5980,
					39452
				],
				[
					-10832,
					7983
				],
				[
					-2203,
					14717
				],
				[
					2739,
					32177
				],
				[
					4458,
					24195
				],
				[
					-9400,
					15498
				],
				[
					6768,
					24491
				],
				[
					-3538,
					8356
				],
				[
					-10785,
					-3145
				],
				[
					-21284,
					16338
				],
				[
					-14746,
					43015
				],
				[
					6023,
					48376
				],
				[
					-96469,
					-923
				],
				[
					5377,
					-32531
				],
				[
					6778,
					1808
				],
				[
					9209,
					-20388
				],
				[
					-561,
					-9681
				],
				[
					9967,
					-36545
				],
				[
					-1352,
					-7098
				],
				[
					9918,
					-11648
				],
				[
					-3119,
					-7062
				],
				[
					8457,
					-18744
				],
				[
					153,
					-11091
				],
				[
					11502,
					-21057
				],
				[
					251,
					-10661
				],
				[
					16156,
					-5976
				],
				[
					51,
					-15291
				],
				[
					4966,
					-13881
				],
				[
					-284,
					-26816
				],
				[
					4496,
					-1276
				],
				[
					-5725,
					-42061
				],
				[
					2810,
					-31460
				],
				[
					8146,
					-21896
				],
				[
					13519,
					-11520
				],
				[
					-3877,
					-22393
				],
				[
					-47305,
					-14
				]
			],
			[
				[
					8044973,
					1472258
				],
				[
					-11488,
					-19604
				],
				[
					-13973,
					-12633
				],
				[
					-6025,
					-14178
				]
			],
			[
				[
					8395105,
					2013979
				],
				[
					-532,
					-50
				]
			],
			[
				[
					8390928,
					2013726
				],
				[
					-10284,
					-7352
				],
				[
					-5286,
					-17099
				]
			],
			[
				[
					8233136,
					1810458
				],
				[
					-9410,
					-1058
				]
			],
			[
				[
					8207282,
					1634121
				],
				[
					-1890,
					-2521
				]
			],
			[
				[
					8205392,
					1631600
				],
				[
					-1457,
					-1814
				]
			],
			[
				[
					8203935,
					1629786
				],
				[
					-6482,
					-5434
				],
				[
					1313,
					-16884
				]
			],
			[
				[
					8187283,
					1622386
				],
				[
					16700,
					19120
				]
			],
			[
				[
					8203983,
					1641506
				],
				[
					3092,
					-3494
				]
			],
			[
				[
					8197134,
					1630462
				],
				[
					0,
					0
				]
			],
			[
				[
					8199974,
					1627744
				],
				[
					0,
					0
				]
			],
			[
				[
					8199551,
					1627516
				],
				[
					0,
					0
				]
			],
			[
				[
					8205392,
					1631600
				],
				[
					-1457,
					-1814
				]
			],
			[
				[
					8203983,
					1641506
				],
				[
					7907,
					10281
				]
			],
			[
				[
					8080635,
					1478370
				],
				[
					5808,
					19696
				]
			],
			[
				[
					7958144,
					1272815
				],
				[
					16990,
					10585
				]
			],
			[
				[
					7950604,
					1077026
				],
				[
					-4397,
					-6388
				]
			],
			[
				[
					7962091,
					1066316
				],
				[
					0,
					0
				]
			],
			[
				[
					7963292,
					1066946
				],
				[
					0,
					0
				]
			],
			[
				[
					7958673,
					1053198
				],
				[
					1754,
					10875
				],
				[
					-7590,
					16247
				]
			],
			[
				[
					7955241,
					1076156
				],
				[
					0,
					0
				]
			],
			[
				[
					7955241,
					1076156
				],
				[
					0,
					0
				]
			],
			[
				[
					7959474,
					1073788
				],
				[
					0,
					0
				]
			],
			[
				[
					7961133,
					1073218
				],
				[
					0,
					0
				]
			],
			[
				[
					7961966,
					1071903
				],
				[
					0,
					0
				]
			],
			[
				[
					7957437,
					938789
				],
				[
					-5438,
					-14623
				],
				[
					4793,
					-14345
				]
			],
			[
				[
					7906680,
					1215253
				],
				[
					-3240,
					5625
				]
			],
			[
				[
					7903440,
					1220878
				],
				[
					3099,
					12114
				],
				[
					9600,
					4793
				]
			],
			[
				[
					7884902,
					1082222
				],
				[
					6662,
					-17421
				]
			],
			[
				[
					7885181,
					1052296
				],
				[
					-6514,
					11977
				]
			],
			[
				[
					7862461,
					1073679
				],
				[
					-428,
					-860
				]
			],
			[
				[
					7875708,
					1193893
				],
				[
					7027,
					9078
				]
			],
			[
				[
					7882735,
					1202971
				],
				[
					6775,
					5961
				]
			],
			[
				[
					7889510,
					1208932
				],
				[
					3546,
					-477
				]
			],
			[
				[
					7889378,
					1212030
				],
				[
					824,
					-1838
				]
			],
			[
				[
					7890202,
					1210192
				],
				[
					-692,
					-1260
				]
			],
			[
				[
					7882735,
					1202971
				],
				[
					6643,
					9059
				]
			],
			[
				[
					7818091,
					1066462
				],
				[
					-7795,
					3897
				]
			],
			[
				[
					7815578,
					1056906
				],
				[
					1307,
					-7825
				]
			],
			[
				[
					7816885,
					1049081
				],
				[
					-11136,
					2878
				]
			],
			[
				[
					7805749,
					1051959
				],
				[
					9057,
					6776
				]
			],
			[
				[
					7814806,
					1058735
				],
				[
					772,
					-1829
				]
			],
			[
				[
					7815578,
					1056906
				],
				[
					-213,
					2806
				]
			],
			[
				[
					7815365,
					1059712
				],
				[
					2966,
					2354
				]
			],
			[
				[
					7817052,
					1059339
				],
				[
					-1474,
					-2433
				]
			],
			[
				[
					7816885,
					1049081
				],
				[
					5685,
					-13166
				]
			],
			[
				[
					7821485,
					1033526
				],
				[
					-17285,
					15378
				]
			],
			[
				[
					7804200,
					1048904
				],
				[
					1549,
					3055
				]
			],
			[
				[
					7814806,
					1058735
				],
				[
					559,
					977
				]
			],
			[
				[
					7804200,
					1048904
				],
				[
					-1518,
					2395
				]
			],
			[
				[
					7903440,
					1220878
				],
				[
					-6686,
					88
				]
			],
			[
				[
					7896754,
					1220966
				],
				[
					-2205,
					5000
				]
			],
			[
				[
					7894549,
					1225966
				],
				[
					7085,
					15835
				],
				[
					11421,
					525
				]
			],
			[
				[
					7900963,
					1223085
				],
				[
					0,
					0
				]
			],
			[
				[
					7896754,
					1220966
				],
				[
					-4832,
					-3241
				]
			],
			[
				[
					7891922,
					1217725
				],
				[
					-3034,
					-1252
				]
			],
			[
				[
					7888888,
					1216473
				],
				[
					413,
					4452
				]
			],
			[
				[
					7889301,
					1220925
				],
				[
					5248,
					5041
				]
			],
			[
				[
					7889378,
					1212030
				],
				[
					-490,
					4443
				]
			],
			[
				[
					7891922,
					1217725
				],
				[
					-1720,
					-7533
				]
			],
			[
				[
					7864015,
					1207555
				],
				[
					25286,
					13370
				]
			],
			[
				[
					7921299,
					1594200
				],
				[
					-1600,
					9711
				]
			],
			[
				[
					7920090,
					1604887
				],
				[
					-2066,
					4015
				]
			],
			[
				[
					7918024,
					1608902
				],
				[
					13747,
					19101
				]
			],
			[
				[
					7907414,
					1634714
				],
				[
					0,
					0
				]
			],
			[
				[
					7912844,
					1628935
				],
				[
					-5960,
					1938
				]
			],
			[
				[
					7906884,
					1630873
				],
				[
					5396,
					6212
				]
			],
			[
				[
					7914928,
					1641306
				],
				[
					-2084,
					-12371
				]
			],
			[
				[
					7907627,
					1617702
				],
				[
					-3641,
					-7194
				]
			],
			[
				[
					7903986,
					1610508
				],
				[
					-2784,
					2653
				]
			],
			[
				[
					7901202,
					1613161
				],
				[
					3297,
					6597
				]
			],
			[
				[
					7904499,
					1619758
				],
				[
					198,
					113
				]
			],
			[
				[
					7904697,
					1619871
				],
				[
					2930,
					-2169
				]
			],
			[
				[
					7907627,
					1617702
				],
				[
					658,
					1308
				]
			],
			[
				[
					7908285,
					1619010
				],
				[
					4559,
					9925
				]
			],
			[
				[
					7918024,
					1608902
				],
				[
					-9965,
					-2296
				]
			],
			[
				[
					7908059,
					1606606
				],
				[
					-432,
					11096
				]
			],
			[
				[
					7906884,
					1630873
				],
				[
					-8262,
					3757
				]
			],
			[
				[
					7898622,
					1634630
				],
				[
					1471,
					7543
				]
			],
			[
				[
					7908285,
					1619010
				],
				[
					-3588,
					861
				]
			],
			[
				[
					7904697,
					1619871
				],
				[
					-117,
					159
				]
			],
			[
				[
					7904580,
					1620030
				],
				[
					2304,
					10843
				]
			],
			[
				[
					7908059,
					1606606
				],
				[
					-4073,
					3902
				]
			],
			[
				[
					7891692,
					1571598
				],
				[
					-5821,
					16993
				],
				[
					9718,
					20756
				]
			],
			[
				[
					7895589,
					1609347
				],
				[
					4404,
					4982
				]
			],
			[
				[
					7899993,
					1614329
				],
				[
					1209,
					-1168
				]
			],
			[
				[
					7898622,
					1634630
				],
				[
					-4832,
					-3348
				]
			],
			[
				[
					7893790,
					1631282
				],
				[
					-261,
					-490
				]
			],
			[
				[
					7893529,
					1630792
				],
				[
					-3035,
					4472
				]
			],
			[
				[
					7890494,
					1635264
				],
				[
					-11012,
					5111
				]
			],
			[
				[
					7904580,
					1620030
				],
				[
					-2115,
					-383
				]
			],
			[
				[
					7902465,
					1619647
				],
				[
					-8675,
					11635
				]
			],
			[
				[
					7904499,
					1619758
				],
				[
					-2034,
					-111
				]
			],
			[
				[
					7898609,
					1622653
				],
				[
					0,
					0
				]
			],
			[
				[
					7890494,
					1635264
				],
				[
					-1911,
					-9663
				]
			],
			[
				[
					7888583,
					1625601
				],
				[
					3612,
					866
				]
			],
			[
				[
					7892195,
					1626467
				],
				[
					1334,
					4325
				]
			],
			[
				[
					7899993,
					1614329
				],
				[
					-11344,
					-572
				]
			],
			[
				[
					7888649,
					1613757
				],
				[
					2183,
					-3458
				]
			],
			[
				[
					7890832,
					1610299
				],
				[
					4757,
					-952
				]
			],
			[
				[
					7852562,
					1562006
				],
				[
					-4231,
					7411
				]
			],
			[
				[
					7851553,
					1584560
				],
				[
					6510,
					32980
				]
			],
			[
				[
					7877406,
					1625238
				],
				[
					613,
					3214
				]
			],
			[
				[
					7890832,
					1610299
				],
				[
					-2183,
					3458
				]
			],
			[
				[
					7892195,
					1626467
				],
				[
					-3612,
					-866
				]
			],
			[
				[
					7830833,
					1672278
				],
				[
					19944,
					-2295
				]
			],
			[
				[
					7844019,
					1659537
				],
				[
					0,
					0
				]
			],
			[
				[
					7844675,
					1658400
				],
				[
					0,
					0
				]
			],
			[
				[
					7845571,
					1656519
				],
				[
					0,
					0
				]
			],
			[
				[
					7846279,
					1653042
				],
				[
					0,
					0
				]
			],
			[
				[
					7851593,
					1652592
				],
				[
					0,
					0
				]
			],
			[
				[
					7833337,
					1633772
				],
				[
					3188,
					-5264
				],
				[
					-7011,
					-35422
				]
			],
			[
				[
					7768958,
					1650986
				],
				[
					7887,
					8552
				]
			],
			[
				[
					7725453,
					1726706
				],
				[
					-5515,
					-6424
				],
				[
					23955,
					-18486
				]
			],
			[
				[
					7743893,
					1701796
				],
				[
					-5419,
					-5769
				],
				[
					5668,
					-10546
				],
				[
					-6380,
					-5793
				],
				[
					13420,
					-16474
				],
				[
					13733,
					19643
				],
				[
					9237,
					-11286
				]
			],
			[
				[
					7529597,
					1755172
				],
				[
					17984,
					11251
				],
				[
					6724,
					51839
				],
				[
					-191,
					15581
				],
				[
					-7576,
					-5479
				],
				[
					-13866,
					15640
				],
				[
					2088,
					23150
				],
				[
					6998,
					19415
				],
				[
					9546,
					1757
				]
			],
			[
				[
					7551304,
					1888326
				],
				[
					2154,
					15214
				],
				[
					9800,
					-5612
				],
				[
					5979,
					33451
				],
				[
					10110,
					10301
				],
				[
					175,
					17207
				]
			],
			[
				[
					7579522,
					1958887
				],
				[
					11690,
					22732
				],
				[
					6554,
					28181
				],
				[
					4469,
					3179
				]
			],
			[
				[
					7773869,
					1724355
				],
				[
					2991,
					-5602
				],
				[
					-7567,
					-11088
				],
				[
					2121,
					-19807
				]
			],
			[
				[
					7743893,
					1701796
				],
				[
					22036,
					23019
				],
				[
					7940,
					-460
				]
			],
			[
				[
					7773869,
					1724355
				],
				[
					-795,
					21370
				]
			],
			[
				[
					7613903,
					2093027
				],
				[
					-6118,
					-13905
				],
				[
					-3701,
					-21221
				],
				[
					-15919,
					-17615
				],
				[
					-15578,
					-24819
				],
				[
					6618,
					-2837
				],
				[
					317,
					-53743
				]
			],
			[
				[
					7551304,
					1888326
				],
				[
					-4435,
					11867
				],
				[
					454,
					15418
				],
				[
					-9689,
					26998
				],
				[
					-9273,
					-48
				],
				[
					42,
					70458
				],
				[
					28099,
					-171
				],
				[
					13202,
					24342
				],
				[
					-2793,
					14231
				],
				[
					8399,
					10242
				],
				[
					21912,
					-2563
				],
				[
					-4012,
					12309
				],
				[
					-3951,
					37608
				]
			],
			[
				[
					7749312,
					1133780
				],
				[
					6334,
					2933
				]
			],
			[
				[
					7755646,
					1136713
				],
				[
					-5771,
					-8597
				]
			],
			[
				[
					7749875,
					1128116
				],
				[
					-5148,
					2107
				]
			],
			[
				[
					7744727,
					1130223
				],
				[
					-207,
					54
				]
			],
			[
				[
					7744520,
					1130277
				],
				[
					-896,
					7560
				]
			],
			[
				[
					7743624,
					1137837
				],
				[
					5688,
					-4057
				]
			],
			[
				[
					7749312,
					1133780
				],
				[
					0,
					0
				]
			],
			[
				[
					7743875,
					1134562
				],
				[
					0,
					0
				]
			],
			[
				[
					7743859,
					1134774
				],
				[
					0,
					0
				]
			],
			[
				[
					7742252,
					1137911
				],
				[
					0,
					0
				]
			],
			[
				[
					7741796,
					1145784
				],
				[
					0,
					0
				]
			],
			[
				[
					7743624,
					1137837
				],
				[
					3873,
					5095
				]
			],
			[
				[
					7759737,
					1139892
				],
				[
					-4091,
					-3179
				]
			],
			[
				[
					7744520,
					1130277
				],
				[
					-1758,
					397
				]
			],
			[
				[
					7742762,
					1130674
				],
				[
					-8373,
					6095
				]
			],
			[
				[
					7734389,
					1136769
				],
				[
					-3620,
					4202
				]
			],
			[
				[
					7742762,
					1130674
				],
				[
					-2741,
					-9709
				]
			],
			[
				[
					7740021,
					1120965
				],
				[
					-3594,
					4837
				]
			],
			[
				[
					7736427,
					1125802
				],
				[
					-3554,
					4842
				]
			],
			[
				[
					7732873,
					1130644
				],
				[
					-1273,
					2663
				]
			],
			[
				[
					7731600,
					1133307
				],
				[
					2789,
					3462
				]
			],
			[
				[
					7744727,
					1130223
				],
				[
					-3932,
					-10229
				]
			],
			[
				[
					7740795,
					1119994
				],
				[
					-509,
					-487
				]
			],
			[
				[
					7740286,
					1119507
				],
				[
					-453,
					998
				]
			],
			[
				[
					7739833,
					1120505
				],
				[
					188,
					460
				]
			],
			[
				[
					7743412,
					1116748
				],
				[
					-33,
					41
				]
			],
			[
				[
					7743379,
					1116789
				],
				[
					33,
					-41
				]
			],
			[
				[
					7740286,
					1119507
				],
				[
					-453,
					998
				]
			],
			[
				[
					7749875,
					1128116
				],
				[
					-6575,
					-11228
				]
			],
			[
				[
					7743300,
					1116888
				],
				[
					-2505,
					3106
				]
			],
			[
				[
					7726094,
					1141524
				],
				[
					5506,
					-8217
				]
			],
			[
				[
					7732873,
					1130644
				],
				[
					3248,
					-5312
				]
			],
			[
				[
					7736121,
					1125332
				],
				[
					-7994,
					2210
				]
			],
			[
				[
					7743412,
					1116748
				],
				[
					-33,
					41
				]
			],
			[
				[
					7736121,
					1125332
				],
				[
					306,
					470
				]
			],
			[
				[
					7743300,
					1116888
				],
				[
					-11544,
					-8093
				],
				[
					-7575,
					1908
				]
			],
			[
				[
					7770138,
					1095652
				],
				[
					-8804,
					8685
				],
				[
					-8883,
					-15861
				]
			],
			[
				[
					7752451,
					1088476
				],
				[
					-2843,
					4323
				]
			],
			[
				[
					7749608,
					1092799
				],
				[
					-10078,
					15702
				]
			],
			[
				[
					7739530,
					1108501
				],
				[
					17327,
					23969
				],
				[
					22503,
					9898
				],
				[
					2067,
					6071
				]
			],
			[
				[
					7726719,
					1160946
				],
				[
					-6492,
					10391
				]
			],
			[
				[
					7718973,
					1176431
				],
				[
					-66,
					8148
				]
			],
			[
				[
					7718907,
					1184579
				],
				[
					12428,
					3450
				]
			],
			[
				[
					7721040,
					1182767
				],
				[
					0,
					0
				]
			],
			[
				[
					7710672,
					1202341
				],
				[
					8235,
					-17762
				]
			],
			[
				[
					7645263,
					1353554
				],
				[
					-34076,
					49322
				],
				[
					-22119,
					-6597
				],
				[
					8411,
					19208
				],
				[
					-10558,
					1660
				]
			],
			[
				[
					7639344,
					957097
				],
				[
					-4633,
					-187
				]
			],
			[
				[
					7634711,
					956910
				],
				[
					2191,
					12302
				]
			],
			[
				[
					7636902,
					969212
				],
				[
					2442,
					-12115
				]
			],
			[
				[
					7639344,
					957097
				],
				[
					-2042,
					-8489
				]
			],
			[
				[
					7637302,
					948608
				],
				[
					-2238,
					-20
				]
			],
			[
				[
					7635064,
					948588
				],
				[
					-2695,
					2735
				]
			],
			[
				[
					7632369,
					951323
				],
				[
					-570,
					4469
				]
			],
			[
				[
					7631799,
					955792
				],
				[
					2912,
					1118
				]
			],
			[
				[
					7631799,
					955792
				],
				[
					-1969,
					4171
				]
			],
			[
				[
					7629830,
					959963
				],
				[
					7072,
					9249
				]
			],
			[
				[
					7632369,
					951323
				],
				[
					-2146,
					-1394
				]
			],
			[
				[
					7630223,
					949929
				],
				[
					-3874,
					-1593
				]
			],
			[
				[
					7626349,
					948336
				],
				[
					-2096,
					4159
				]
			],
			[
				[
					7624253,
					952495
				],
				[
					5577,
					7468
				]
			],
			[
				[
					7626349,
					948336
				],
				[
					157,
					-933
				]
			],
			[
				[
					7626506,
					947403
				],
				[
					-1261,
					-2323
				]
			],
			[
				[
					7625245,
					945080
				],
				[
					-1194,
					-1648
				]
			],
			[
				[
					7624051,
					943432
				],
				[
					-2024,
					3844
				]
			],
			[
				[
					7622027,
					947276
				],
				[
					2226,
					5219
				]
			],
			[
				[
					7624051,
					943432
				],
				[
					-398,
					-1498
				]
			],
			[
				[
					7623653,
					941934
				],
				[
					-1159,
					-2475
				]
			],
			[
				[
					7622494,
					939459
				],
				[
					-2033,
					1806
				]
			],
			[
				[
					7620461,
					941265
				],
				[
					1566,
					6011
				]
			],
			[
				[
					7630223,
					949929
				],
				[
					-214,
					-4486
				]
			],
			[
				[
					7630009,
					945443
				],
				[
					-92,
					-853
				]
			],
			[
				[
					7629917,
					944590
				],
				[
					-251,
					81
				]
			],
			[
				[
					7629666,
					944671
				],
				[
					-3160,
					2732
				]
			],
			[
				[
					7635064,
					948588
				],
				[
					-1348,
					-4968
				]
			],
			[
				[
					7633716,
					943620
				],
				[
					-212,
					-770
				]
			],
			[
				[
					7633504,
					942850
				],
				[
					-3495,
					2593
				]
			],
			[
				[
					7637302,
					948608
				],
				[
					-17,
					-6979
				]
			],
			[
				[
					7637285,
					941629
				],
				[
					-3569,
					1991
				]
			],
			[
				[
					7633504,
					942850
				],
				[
					-1362,
					-4685
				]
			],
			[
				[
					7632142,
					938165
				],
				[
					-1886,
					4786
				]
			],
			[
				[
					7630256,
					942951
				],
				[
					-339,
					1639
				]
			],
			[
				[
					7638456,
					940857
				],
				[
					-69,
					267
				]
			],
			[
				[
					7638387,
					941124
				],
				[
					107,
					-48
				]
			],
			[
				[
					7638494,
					941076
				],
				[
					2,
					-151
				]
			],
			[
				[
					7638496,
					940925
				],
				[
					-40,
					-68
				]
			],
			[
				[
					7637285,
					941629
				],
				[
					-2099,
					-6251
				]
			],
			[
				[
					7635186,
					935378
				],
				[
					-3044,
					2787
				]
			],
			[
				[
					7629666,
					944671
				],
				[
					-1840,
					-3625
				]
			],
			[
				[
					7627826,
					941046
				],
				[
					-2581,
					4034
				]
			],
			[
				[
					7627826,
					941046
				],
				[
					-1067,
					-2583
				]
			],
			[
				[
					7626759,
					938463
				],
				[
					-3106,
					3471
				]
			],
			[
				[
					7630256,
					942951
				],
				[
					-2557,
					-5431
				]
			],
			[
				[
					7627699,
					937520
				],
				[
					-928,
					876
				]
			],
			[
				[
					7626771,
					938396
				],
				[
					-12,
					67
				]
			],
			[
				[
					7632142,
					938165
				],
				[
					-386,
					-1238
				]
			],
			[
				[
					7631756,
					936927
				],
				[
					-3726,
					-98
				]
			],
			[
				[
					7628030,
					936829
				],
				[
					-331,
					691
				]
			],
			[
				[
					7635186,
					935378
				],
				[
					-546,
					-3060
				]
			],
			[
				[
					7634640,
					932318
				],
				[
					-2899,
					2012
				]
			],
			[
				[
					7631741,
					934330
				],
				[
					15,
					2597
				]
			],
			[
				[
					7634640,
					932318
				],
				[
					-1396,
					-3244
				]
			],
			[
				[
					7633244,
					929074
				],
				[
					-2293,
					1786
				]
			],
			[
				[
					7630951,
					930860
				],
				[
					211,
					1648
				]
			],
			[
				[
					7631162,
					932508
				],
				[
					579,
					1822
				]
			],
			[
				[
					7631162,
					932508
				],
				[
					-3883,
					2488
				]
			],
			[
				[
					7627279,
					934996
				],
				[
					751,
					1833
				]
			],
			[
				[
					7630951,
					930860
				],
				[
					-1357,
					281
				]
			],
			[
				[
					7629594,
					931141
				],
				[
					-2820,
					2609
				]
			],
			[
				[
					7626774,
					933750
				],
				[
					505,
					1246
				]
			],
			[
				[
					7626771,
					938396
				],
				[
					-1603,
					-3160
				]
			],
			[
				[
					7625168,
					935236
				],
				[
					-1196,
					-769
				]
			],
			[
				[
					7623972,
					934467
				],
				[
					-2506,
					2304
				]
			],
			[
				[
					7621466,
					936771
				],
				[
					1028,
					2688
				]
			],
			[
				[
					7626774,
					933750
				],
				[
					-1606,
					1486
				]
			],
			[
				[
					7621466,
					936771
				],
				[
					-2271,
					2438
				]
			],
			[
				[
					7619195,
					939209
				],
				[
					1266,
					2056
				]
			],
			[
				[
					7621466,
					936771
				],
				[
					-918,
					-3320
				]
			],
			[
				[
					7620548,
					933451
				],
				[
					-2310,
					1415
				]
			],
			[
				[
					7618238,
					934866
				],
				[
					957,
					4343
				]
			],
			[
				[
					7626774,
					933750
				],
				[
					-918,
					-2202
				]
			],
			[
				[
					7625856,
					931548
				],
				[
					-476,
					210
				]
			],
			[
				[
					7625380,
					931758
				],
				[
					-1283,
					1429
				]
			],
			[
				[
					7624097,
					933187
				],
				[
					-865,
					223
				]
			],
			[
				[
					7623232,
					933410
				],
				[
					740,
					1057
				]
			],
			[
				[
					7629594,
					931141
				],
				[
					-1455,
					-722
				]
			],
			[
				[
					7628139,
					930419
				],
				[
					-572,
					-527
				]
			],
			[
				[
					7627567,
					929892
				],
				[
					-1711,
					1656
				]
			],
			[
				[
					7629046,
					929266
				],
				[
					-907,
					1153
				]
			],
			[
				[
					7630951,
					930860
				],
				[
					-903,
					-2334
				]
			],
			[
				[
					7630048,
					928526
				],
				[
					-1002,
					740
				]
			],
			[
				[
					7629046,
					929266
				],
				[
					0,
					0
				]
			],
			[
				[
					7630048,
					928526
				],
				[
					-288,
					-651
				]
			],
			[
				[
					7629760,
					927875
				],
				[
					-691,
					-1458
				]
			],
			[
				[
					7629069,
					926417
				],
				[
					-601,
					379
				]
			],
			[
				[
					7628468,
					926796
				],
				[
					-1462,
					1618
				]
			],
			[
				[
					7627006,
					928414
				],
				[
					561,
					1478
				]
			],
			[
				[
					7633244,
					929074
				],
				[
					-437,
					-3286
				]
			],
			[
				[
					7632807,
					925788
				],
				[
					-3047,
					2087
				]
			],
			[
				[
					7632334,
					924270
				],
				[
					0,
					0
				]
			],
			[
				[
					7634385,
					925783
				],
				[
					-481,
					-2827
				]
			],
			[
				[
					7633904,
					922956
				],
				[
					-413,
					3341
				]
			],
			[
				[
					7633491,
					926297
				],
				[
					894,
					-514
				]
			],
			[
				[
					7632807,
					925788
				],
				[
					-427,
					-2046
				]
			],
			[
				[
					7632380,
					923742
				],
				[
					-72,
					32
				]
			],
			[
				[
					7632308,
					923774
				],
				[
					-733,
					138
				]
			],
			[
				[
					7631575,
					923912
				],
				[
					-1785,
					1808
				]
			],
			[
				[
					7629790,
					925720
				],
				[
					-721,
					697
				]
			],
			[
				[
					7623232,
					933410
				],
				[
					-1341,
					-2192
				]
			],
			[
				[
					7621891,
					931218
				],
				[
					-1670,
					1026
				]
			],
			[
				[
					7620221,
					932244
				],
				[
					327,
					1207
				]
			],
			[
				[
					7621891,
					931218
				],
				[
					-320,
					-1217
				]
			],
			[
				[
					7621571,
					930001
				],
				[
					-347,
					-903
				]
			],
			[
				[
					7621224,
					929098
				],
				[
					-1545,
					1155
				]
			],
			[
				[
					7619679,
					930253
				],
				[
					542,
					1991
				]
			],
			[
				[
					7624097,
					933187
				],
				[
					-1242,
					-3357
				]
			],
			[
				[
					7622855,
					929830
				],
				[
					-1284,
					171
				]
			],
			[
				[
					7625380,
					931758
				],
				[
					-1146,
					-2902
				]
			],
			[
				[
					7624234,
					928856
				],
				[
					-1379,
					974
				]
			],
			[
				[
					7627006,
					928414
				],
				[
					-1176,
					-430
				]
			],
			[
				[
					7625830,
					927984
				],
				[
					-1420,
					598
				]
			],
			[
				[
					7624410,
					928582
				],
				[
					-176,
					274
				]
			],
			[
				[
					7628468,
					926796
				],
				[
					-587,
					-1400
				]
			],
			[
				[
					7627881,
					925396
				],
				[
					-2051,
					2588
				]
			],
			[
				[
					7627881,
					925396
				],
				[
					-81,
					-176
				]
			],
			[
				[
					7627800,
					925220
				],
				[
					-739,
					-3460
				]
			],
			[
				[
					7627061,
					921760
				],
				[
					-1236,
					1215
				]
			],
			[
				[
					7625825,
					922975
				],
				[
					-1066,
					852
				]
			],
			[
				[
					7624759,
					923827
				],
				[
					-940,
					2063
				]
			],
			[
				[
					7623819,
					925890
				],
				[
					433,
					987
				]
			],
			[
				[
					7624252,
					926877
				],
				[
					158,
					1705
				]
			],
			[
				[
					7629790,
					925720
				],
				[
					-860,
					-1639
				]
			],
			[
				[
					7628930,
					924081
				],
				[
					-1130,
					1139
				]
			],
			[
				[
					7631575,
					923912
				],
				[
					-151,
					-1082
				]
			],
			[
				[
					7631424,
					922830
				],
				[
					-747,
					-184
				]
			],
			[
				[
					7630677,
					922646
				],
				[
					-253,
					239
				]
			],
			[
				[
					7630424,
					922885
				],
				[
					-1579,
					255
				]
			],
			[
				[
					7628845,
					923140
				],
				[
					85,
					941
				]
			],
			[
				[
					7632308,
					923774
				],
				[
					-1504,
					-2163
				]
			],
			[
				[
					7630804,
					921611
				],
				[
					517,
					937
				]
			],
			[
				[
					7631321,
					922548
				],
				[
					103,
					282
				]
			],
			[
				[
					7631424,
					922830
				],
				[
					-103,
					-282
				]
			],
			[
				[
					7630804,
					921611
				],
				[
					-180,
					-385
				]
			],
			[
				[
					7630624,
					921226
				],
				[
					-97,
					121
				]
			],
			[
				[
					7630527,
					921347
				],
				[
					150,
					1299
				]
			],
			[
				[
					7630424,
					922885
				],
				[
					-917,
					-2047
				]
			],
			[
				[
					7629507,
					920838
				],
				[
					-871,
					1411
				]
			],
			[
				[
					7628636,
					922249
				],
				[
					209,
					891
				]
			],
			[
				[
					7630527,
					921347
				],
				[
					144,
					-761
				]
			],
			[
				[
					7630671,
					920586
				],
				[
					-945,
					-246
				]
			],
			[
				[
					7629726,
					920340
				],
				[
					-219,
					498
				]
			],
			[
				[
					7635701,
					920108
				],
				[
					-32,
					5
				]
			],
			[
				[
					7635669,
					920113
				],
				[
					32,
					-5
				]
			],
			[
				[
					7633485,
					918342
				],
				[
					-91,
					-62
				]
			],
			[
				[
					7633394,
					918280
				],
				[
					-1951,
					487
				]
			],
			[
				[
					7631443,
					918767
				],
				[
					-21,
					126
				]
			],
			[
				[
					7631422,
					918893
				],
				[
					-888,
					-349
				]
			],
			[
				[
					7630534,
					918544
				],
				[
					-866,
					885
				]
			],
			[
				[
					7629668,
					919429
				],
				[
					-64,
					69
				]
			],
			[
				[
					7629604,
					919498
				],
				[
					122,
					842
				]
			],
			[
				[
					7630671,
					920586
				],
				[
					-47,
					640
				]
			],
			[
				[
					7632380,
					923742
				],
				[
					1105,
					-5400
				]
			],
			[
				[
					7634356,
					926215
				],
				[
					-452,
					-3259
				]
			],
			[
				[
					7634385,
					925783
				],
				[
					-29,
					432
				]
			],
			[
				[
					7635815,
					920431
				],
				[
					-156,
					-315
				]
			],
			[
				[
					7635659,
					920116
				],
				[
					-1039,
					6147
				]
			],
			[
				[
					7634620,
					926263
				],
				[
					337,
					6
				]
			],
			[
				[
					7634957,
					926269
				],
				[
					858,
					-5838
				]
			],
			[
				[
					7628423,
					905488
				],
				[
					-235,
					73
				]
			],
			[
				[
					7628188,
					905561
				],
				[
					1352,
					1930
				]
			],
			[
				[
					7629540,
					907491
				],
				[
					-1117,
					-2003
				]
			],
			[
				[
					7629614,
					907606
				],
				[
					467,
					819
				]
			],
			[
				[
					7630081,
					908425
				],
				[
					-467,
					-819
				]
			],
			[
				[
					7631158,
					912992
				],
				[
					-11,
					-306
				]
			],
			[
				[
					7631147,
					912686
				],
				[
					11,
					306
				]
			],
			[
				[
					7632004,
					914206
				],
				[
					-557,
					-467
				]
			],
			[
				[
					7631447,
					913739
				],
				[
					-291,
					612
				]
			],
			[
				[
					7631156,
					914351
				],
				[
					848,
					-145
				]
			],
			[
				[
					7629604,
					919498
				],
				[
					-968,
					2751
				]
			],
			[
				[
					7629668,
					919429
				],
				[
					-952,
					-1569
				]
			],
			[
				[
					7628716,
					917860
				],
				[
					-830,
					1299
				]
			],
			[
				[
					7627886,
					919159
				],
				[
					-1851,
					763
				]
			],
			[
				[
					7626035,
					919922
				],
				[
					1026,
					1838
				]
			],
			[
				[
					7630534,
					918544
				],
				[
					-127,
					-562
				]
			],
			[
				[
					7630407,
					917982
				],
				[
					-23,
					-29
				]
			],
			[
				[
					7630384,
					917953
				],
				[
					23,
					-322
				]
			],
			[
				[
					7630407,
					917631
				],
				[
					-970,
					-1618
				]
			],
			[
				[
					7629437,
					916013
				],
				[
					-658,
					1659
				]
			],
			[
				[
					7628779,
					917672
				],
				[
					-63,
					188
				]
			],
			[
				[
					7630384,
					917953
				],
				[
					23,
					-322
				]
			],
			[
				[
					7633394,
					918280
				],
				[
					-63,
					-2635
				]
			],
			[
				[
					7633331,
					915645
				],
				[
					-1327,
					-1439
				]
			],
			[
				[
					7631156,
					914351
				],
				[
					-1506,
					726
				]
			],
			[
				[
					7629650,
					915077
				],
				[
					-285,
					607
				]
			],
			[
				[
					7629365,
					915684
				],
				[
					2078,
					3083
				]
			],
			[
				[
					7631422,
					918893
				],
				[
					-1015,
					-911
				]
			],
			[
				[
					7619679,
					930253
				],
				[
					-1816,
					611
				]
			],
			[
				[
					7617863,
					930864
				],
				[
					-2523,
					1535
				]
			],
			[
				[
					7615340,
					932399
				],
				[
					2898,
					2467
				]
			],
			[
				[
					7617863,
					930864
				],
				[
					-830,
					-2589
				]
			],
			[
				[
					7617033,
					928275
				],
				[
					-934,
					-194
				]
			],
			[
				[
					7616099,
					928081
				],
				[
					-2047,
					2608
				]
			],
			[
				[
					7614052,
					930689
				],
				[
					1288,
					1710
				]
			],
			[
				[
					7624252,
					926877
				],
				[
					-3411,
					860
				]
			],
			[
				[
					7620841,
					927737
				],
				[
					383,
					1361
				]
			],
			[
				[
					7623819,
					925890
				],
				[
					-834,
					-1435
				]
			],
			[
				[
					7622985,
					924455
				],
				[
					-2601,
					1496
				]
			],
			[
				[
					7620384,
					925951
				],
				[
					457,
					1786
				]
			],
			[
				[
					7622985,
					924455
				],
				[
					-1298,
					-3344
				]
			],
			[
				[
					7621687,
					921111
				],
				[
					-518,
					-193
				]
			],
			[
				[
					7621169,
					920918
				],
				[
					-1647,
					2119
				]
			],
			[
				[
					7619522,
					923037
				],
				[
					862,
					2914
				]
			],
			[
				[
					7624759,
					923827
				],
				[
					-1703,
					-4023
				]
			],
			[
				[
					7623056,
					919804
				],
				[
					-1369,
					1307
				]
			],
			[
				[
					7625825,
					922975
				],
				[
					-1389,
					-3040
				]
			],
			[
				[
					7624436,
					919935
				],
				[
					-1380,
					-131
				]
			],
			[
				[
					7626035,
					919922
				],
				[
					-1469,
					-1308
				]
			],
			[
				[
					7624566,
					918614
				],
				[
					-130,
					1321
				]
			],
			[
				[
					7624566,
					918614
				],
				[
					608,
					-2330
				]
			],
			[
				[
					7625174,
					916284
				],
				[
					-798,
					-153
				]
			],
			[
				[
					7624376,
					916131
				],
				[
					-3645,
					3612
				]
			],
			[
				[
					7620731,
					919743
				],
				[
					438,
					1175
				]
			],
			[
				[
					7624376,
					916131
				],
				[
					-1630,
					-1620
				]
			],
			[
				[
					7622746,
					914511
				],
				[
					-281,
					-651
				]
			],
			[
				[
					7622465,
					913860
				],
				[
					-2218,
					2270
				]
			],
			[
				[
					7620247,
					916130
				],
				[
					-24,
					3224
				]
			],
			[
				[
					7620223,
					919354
				],
				[
					508,
					389
				]
			],
			[
				[
					7627886,
					919159
				],
				[
					-1961,
					-3587
				]
			],
			[
				[
					7625925,
					915572
				],
				[
					-751,
					712
				]
			],
			[
				[
					7628779,
					917672
				],
				[
					-1877,
					-2788
				]
			],
			[
				[
					7626902,
					914884
				],
				[
					-977,
					688
				]
			],
			[
				[
					7626902,
					914884
				],
				[
					-1228,
					-2841
				]
			],
			[
				[
					7625674,
					912043
				],
				[
					-161,
					-186
				]
			],
			[
				[
					7625513,
					911857
				],
				[
					-2767,
					2654
				]
			],
			[
				[
					7625513,
					911857
				],
				[
					-1839,
					-2116
				]
			],
			[
				[
					7623674,
					909741
				],
				[
					-749,
					-734
				]
			],
			[
				[
					7622925,
					909007
				],
				[
					-1154,
					966
				]
			],
			[
				[
					7621771,
					909973
				],
				[
					694,
					3887
				]
			],
			[
				[
					7628782,
					913027
				],
				[
					-733,
					394
				]
			],
			[
				[
					7628049,
					913421
				],
				[
					1316,
					2263
				]
			],
			[
				[
					7629650,
					915077
				],
				[
					-868,
					-2050
				]
			],
			[
				[
					7629437,
					916013
				],
				[
					-2312,
					-3248
				]
			],
			[
				[
					7627125,
					912765
				],
				[
					-50,
					-45
				]
			],
			[
				[
					7627075,
					912720
				],
				[
					-262,
					-323
				]
			],
			[
				[
					7626813,
					912397
				],
				[
					-1139,
					-354
				]
			],
			[
				[
					7627341,
					907528
				],
				[
					638,
					1373
				]
			],
			[
				[
					7627979,
					908901
				],
				[
					-638,
					-1373
				]
			],
			[
				[
					7628515,
					909858
				],
				[
					194,
					472
				]
			],
			[
				[
					7628709,
					910330
				],
				[
					62,
					-60
				]
			],
			[
				[
					7628771,
					910270
				],
				[
					-256,
					-412
				]
			],
			[
				[
					7628820,
					910783
				],
				[
					-17,
					1539
				]
			],
			[
				[
					7628803,
					912322
				],
				[
					17,
					-1539
				]
			],
			[
				[
					7627125,
					912765
				],
				[
					-50,
					-45
				]
			],
			[
				[
					7623755,
					909622
				],
				[
					-81,
					119
				]
			],
			[
				[
					7626813,
					912397
				],
				[
					-3058,
					-2775
				]
			],
			[
				[
					7628782,
					913027
				],
				[
					-32,
					-699
				]
			],
			[
				[
					7628750,
					912328
				],
				[
					8,
					-1544
				]
			],
			[
				[
					7628758,
					910784
				],
				[
					-116,
					-447
				]
			],
			[
				[
					7628642,
					910337
				],
				[
					-172,
					-455
				]
			],
			[
				[
					7628470,
					909882
				],
				[
					-551,
					-981
				]
			],
			[
				[
					7627919,
					908901
				],
				[
					-620,
					-1331
				]
			],
			[
				[
					7627299,
					907570
				],
				[
					-268,
					-542
				]
			],
			[
				[
					7627031,
					907028
				],
				[
					-3181,
					2465
				]
			],
			[
				[
					7623850,
					909493
				],
				[
					-36,
					48
				]
			],
			[
				[
					7623814,
					909541
				],
				[
					4235,
					3880
				]
			],
			[
				[
					7628758,
					910784
				],
				[
					-116,
					-447
				]
			],
			[
				[
					7631447,
					913739
				],
				[
					-289,
					-747
				]
			],
			[
				[
					7631147,
					912686
				],
				[
					-423,
					-2533
				]
			],
			[
				[
					7630724,
					910153
				],
				[
					-1953,
					117
				]
			],
			[
				[
					7628709,
					910330
				],
				[
					111,
					453
				]
			],
			[
				[
					7628803,
					912322
				],
				[
					-53,
					6
				]
			],
			[
				[
					7626668,
					906057
				],
				[
					-32,
					2
				]
			],
			[
				[
					7626636,
					906059
				],
				[
					395,
					969
				]
			],
			[
				[
					7627299,
					907570
				],
				[
					-631,
					-1513
				]
			],
			[
				[
					7628470,
					909882
				],
				[
					-551,
					-981
				]
			],
			[
				[
					7630724,
					910153
				],
				[
					-643,
					-1728
				]
			],
			[
				[
					7629614,
					907606
				],
				[
					-74,
					-115
				]
			],
			[
				[
					7628188,
					905561
				],
				[
					-1418,
					472
				]
			],
			[
				[
					7626770,
					906033
				],
				[
					571,
					1495
				]
			],
			[
				[
					7627979,
					908901
				],
				[
					536,
					957
				]
			],
			[
				[
					7616099,
					928081
				],
				[
					-1848,
					-1323
				]
			],
			[
				[
					7614251,
					926758
				],
				[
					-2047,
					2155
				]
			],
			[
				[
					7612204,
					928913
				],
				[
					1848,
					1776
				]
			],
			[
				[
					7614251,
					926758
				],
				[
					183,
					-250
				]
			],
			[
				[
					7614434,
					926508
				],
				[
					-2982,
					-1909
				]
			],
			[
				[
					7611452,
					924599
				],
				[
					-2409,
					-2829
				]
			],
			[
				[
					7609043,
					921770
				],
				[
					-900,
					1807
				]
			],
			[
				[
					7608143,
					923577
				],
				[
					4061,
					5336
				]
			],
			[
				[
					7619111,
					922144
				],
				[
					-862,
					-1655
				]
			],
			[
				[
					7618249,
					920489
				],
				[
					-1606,
					3095
				]
			],
			[
				[
					7616643,
					923584
				],
				[
					-2209,
					2924
				]
			],
			[
				[
					7617033,
					928275
				],
				[
					2078,
					-6131
				]
			],
			[
				[
					7618249,
					920489
				],
				[
					-1667,
					-2222
				]
			],
			[
				[
					7616582,
					918267
				],
				[
					-2099,
					282
				]
			],
			[
				[
					7614483,
					918549
				],
				[
					94,
					212
				]
			],
			[
				[
					7614577,
					918761
				],
				[
					2066,
					4823
				]
			],
			[
				[
					7619522,
					923037
				],
				[
					-411,
					-893
				]
			],
			[
				[
					7620223,
					919354
				],
				[
					-2375,
					-2087
				]
			],
			[
				[
					7617848,
					917267
				],
				[
					-1266,
					1000
				]
			],
			[
				[
					7614577,
					918761
				],
				[
					-3125,
					5838
				]
			],
			[
				[
					7614483,
					918549
				],
				[
					-648,
					-3222
				]
			],
			[
				[
					7613835,
					915327
				],
				[
					-6124,
					2789
				]
			],
			[
				[
					7607711,
					918116
				],
				[
					-678,
					2492
				]
			],
			[
				[
					7607033,
					920608
				],
				[
					2010,
					1162
				]
			],
			[
				[
					7617848,
					917267
				],
				[
					-4861,
					-3941
				]
			],
			[
				[
					7612987,
					913326
				],
				[
					848,
					2001
				]
			],
			[
				[
					7621771,
					909973
				],
				[
					-1747,
					1408
				]
			],
			[
				[
					7620024,
					911381
				],
				[
					223,
					4749
				]
			],
			[
				[
					7620024,
					911381
				],
				[
					-1177,
					-767
				]
			],
			[
				[
					7618847,
					910614
				],
				[
					-240,
					-960
				]
			],
			[
				[
					7618607,
					909654
				],
				[
					-2543,
					-1069
				]
			],
			[
				[
					7616064,
					908585
				],
				[
					-3130,
					240
				]
			],
			[
				[
					7612934,
					908825
				],
				[
					53,
					4501
				]
			],
			[
				[
					7622925,
					909007
				],
				[
					-4078,
					1607
				]
			],
			[
				[
					7622034,
					951175
				],
				[
					-510,
					6887
				]
			],
			[
				[
					7621524,
					958062
				],
				[
					2647,
					9438
				]
			],
			[
				[
					7624171,
					967500
				],
				[
					4196,
					-28
				]
			],
			[
				[
					7628367,
					967472
				],
				[
					3224,
					1786
				]
			],
			[
				[
					7631591,
					969258
				],
				[
					-9557,
					-18083
				]
			],
			[
				[
					7623969,
					965885
				],
				[
					0,
					0
				]
			],
			[
				[
					7621524,
					958062
				],
				[
					-568,
					3323
				]
			],
			[
				[
					7620956,
					961385
				],
				[
					-40,
					5048
				]
			],
			[
				[
					7620916,
					966433
				],
				[
					3255,
					1067
				]
			],
			[
				[
					7622034,
					951175
				],
				[
					-916,
					-5854
				]
			],
			[
				[
					7621118,
					945321
				],
				[
					406,
					12741
				]
			],
			[
				[
					7621118,
					945321
				],
				[
					-2260,
					-5453
				]
			],
			[
				[
					7618858,
					939868
				],
				[
					-2495,
					4133
				]
			],
			[
				[
					7616363,
					944001
				],
				[
					-2857,
					6830
				]
			],
			[
				[
					7613506,
					950831
				],
				[
					7450,
					10554
				]
			],
			[
				[
					7618858,
					939868
				],
				[
					-1014,
					-4757
				]
			],
			[
				[
					7617844,
					935111
				],
				[
					-3641,
					4695
				]
			],
			[
				[
					7614203,
					939806
				],
				[
					2160,
					4195
				]
			],
			[
				[
					7615434,
					940335
				],
				[
					0,
					0
				]
			],
			[
				[
					7612101,
					953636
				],
				[
					-4326,
					-2035
				]
			],
			[
				[
					7607775,
					951601
				],
				[
					-978,
					2612
				]
			],
			[
				[
					7606797,
					954213
				],
				[
					2565,
					5642
				]
			],
			[
				[
					7609362,
					959855
				],
				[
					2739,
					-6219
				]
			],
			[
				[
					7613506,
					950831
				],
				[
					-1405,
					2805
				]
			],
			[
				[
					7609362,
					959855
				],
				[
					11554,
					6578
				]
			],
			[
				[
					7613506,
					950831
				],
				[
					-2882,
					-5011
				]
			],
			[
				[
					7610624,
					945820
				],
				[
					-2849,
					5781
				]
			],
			[
				[
					7610624,
					945820
				],
				[
					1529,
					-4208
				]
			],
			[
				[
					7612153,
					941612
				],
				[
					-2642,
					-2147
				]
			],
			[
				[
					7609511,
					939465
				],
				[
					-6676,
					7824
				]
			],
			[
				[
					7602835,
					947289
				],
				[
					3962,
					6924
				]
			],
			[
				[
					7614203,
					939806
				],
				[
					-811,
					-850
				]
			],
			[
				[
					7613392,
					938956
				],
				[
					-1239,
					2656
				]
			],
			[
				[
					7617844,
					935111
				],
				[
					-4079,
					-4030
				]
			],
			[
				[
					7613765,
					931081
				],
				[
					-1598,
					4758
				]
			],
			[
				[
					7612167,
					935839
				],
				[
					1225,
					3117
				]
			],
			[
				[
					7599815,
					940456
				],
				[
					-67,
					133
				]
			],
			[
				[
					7599748,
					940589
				],
				[
					67,
					-133
				]
			],
			[
				[
					7609511,
					939465
				],
				[
					-6554,
					-5153
				]
			],
			[
				[
					7602957,
					934312
				],
				[
					-2976,
					5822
				]
			],
			[
				[
					7599981,
					940134
				],
				[
					2854,
					7155
				]
			],
			[
				[
					7602957,
					934312
				],
				[
					-4519,
					-2962
				]
			],
			[
				[
					7598438,
					931350
				],
				[
					-1590,
					-5109
				]
			],
			[
				[
					7596848,
					926241
				],
				[
					3133,
					13893
				]
			],
			[
				[
					7599815,
					940456
				],
				[
					-67,
					133
				]
			],
			[
				[
					7612167,
					935839
				],
				[
					-1091,
					494
				]
			],
			[
				[
					7611076,
					936333
				],
				[
					-1565,
					3132
				]
			],
			[
				[
					7611076,
					936333
				],
				[
					-2562,
					-2691
				]
			],
			[
				[
					7608514,
					933642
				],
				[
					-3715,
					-2990
				]
			],
			[
				[
					7604799,
					930652
				],
				[
					-1842,
					3660
				]
			],
			[
				[
					7613765,
					931081
				],
				[
					-2882,
					-2124
				]
			],
			[
				[
					7610883,
					928957
				],
				[
					-2369,
					4685
				]
			],
			[
				[
					7610883,
					928957
				],
				[
					-3113,
					-4595
				]
			],
			[
				[
					7607770,
					924362
				],
				[
					-2971,
					6290
				]
			],
			[
				[
					7607770,
					924362
				],
				[
					-5718,
					1139
				]
			],
			[
				[
					7602052,
					925501
				],
				[
					-3614,
					5849
				]
			],
			[
				[
					7602052,
					925501
				],
				[
					-5204,
					740
				]
			],
			[
				[
					7625124,
					903551
				],
				[
					468,
					620
				]
			],
			[
				[
					7625592,
					904171
				],
				[
					-468,
					-620
				]
			],
			[
				[
					7626636,
					906059
				],
				[
					-1112,
					-1799
				]
			],
			[
				[
					7625524,
					904260
				],
				[
					-1423,
					-1658
				]
			],
			[
				[
					7624101,
					902602
				],
				[
					-251,
					6891
				]
			],
			[
				[
					7626358,
					898419
				],
				[
					-562,
					-2483
				]
			],
			[
				[
					7625796,
					895936
				],
				[
					-2899,
					929
				]
			],
			[
				[
					7622897,
					896865
				],
				[
					-2975,
					2436
				]
			],
			[
				[
					7619922,
					899301
				],
				[
					6436,
					-882
				]
			],
			[
				[
					7626561,
					899286
				],
				[
					-159,
					-678
				]
			],
			[
				[
					7626402,
					898608
				],
				[
					-6442,
					850
				]
			],
			[
				[
					7619960,
					899458
				],
				[
					229,
					955
				]
			],
			[
				[
					7620189,
					900413
				],
				[
					6372,
					-1127
				]
			],
			[
				[
					7622950,
					900612
				],
				[
					-127,
					27
				]
			],
			[
				[
					7622823,
					900639
				],
				[
					176,
					249
				]
			],
			[
				[
					7622999,
					900888
				],
				[
					-49,
					-276
				]
			],
			[
				[
					7623295,
					901967
				],
				[
					-294,
					-1071
				]
			],
			[
				[
					7623001,
					900896
				],
				[
					294,
					1071
				]
			],
			[
				[
					7628423,
					905488
				],
				[
					-3299,
					-1937
				]
			],
			[
				[
					7625592,
					904171
				],
				[
					1178,
					1862
				]
			],
			[
				[
					7626668,
					906057
				],
				[
					-1144,
					-1797
				]
			],
			[
				[
					7622897,
					896865
				],
				[
					-3053,
					-4183
				]
			],
			[
				[
					7619844,
					892682
				],
				[
					-2955,
					8314
				]
			],
			[
				[
					7616889,
					900996
				],
				[
					3033,
					-1695
				]
			],
			[
				[
					7619960,
					899458
				],
				[
					-3057,
					1789
				]
			],
			[
				[
					7616903,
					901247
				],
				[
					3,
					66
				]
			],
			[
				[
					7616906,
					901313
				],
				[
					3283,
					-900
				]
			],
			[
				[
					7619132,
					904584
				],
				[
					-10,
					84
				]
			],
			[
				[
					7619122,
					904668
				],
				[
					10,
					-84
				]
			],
			[
				[
					7624101,
					902602
				],
				[
					-806,
					-635
				]
			],
			[
				[
					7623001,
					900896
				],
				[
					-2,
					-8
				]
			],
			[
				[
					7622823,
					900639
				],
				[
					-3652,
					3215
				]
			],
			[
				[
					7619171,
					903854
				],
				[
					-37,
					686
				]
			],
			[
				[
					7619134,
					904540
				],
				[
					4680,
					5001
				]
			],
			[
				[
					7623755,
					909622
				],
				[
					-4674,
					-4857
				]
			],
			[
				[
					7619081,
					904765
				],
				[
					-474,
					4889
				]
			],
			[
				[
					7619171,
					903854
				],
				[
					-37,
					686
				]
			],
			[
				[
					7619132,
					904584
				],
				[
					-10,
					84
				]
			],
			[
				[
					7616241,
					904817
				],
				[
					4,
					42
				]
			],
			[
				[
					7616245,
					904859
				],
				[
					-4,
					-42
				]
			],
			[
				[
					7619081,
					904765
				],
				[
					-2827,
					194
				]
			],
			[
				[
					7616254,
					904959
				],
				[
					-190,
					3626
				]
			],
			[
				[
					7616254,
					904959
				],
				[
					-9,
					-100
				]
			],
			[
				[
					7616241,
					904817
				],
				[
					-3207,
					1474
				]
			],
			[
				[
					7613034,
					906291
				],
				[
					-100,
					2534
				]
			],
			[
				[
					7607033,
					920608
				],
				[
					-4225,
					-681
				]
			],
			[
				[
					7602808,
					919927
				],
				[
					-1091,
					2858
				]
			],
			[
				[
					7601717,
					922785
				],
				[
					-167,
					1500
				]
			],
			[
				[
					7601550,
					924285
				],
				[
					6593,
					-708
				]
			],
			[
				[
					7601717,
					922785
				],
				[
					-3619,
					-3573
				]
			],
			[
				[
					7598098,
					919212
				],
				[
					-221,
					733
				]
			],
			[
				[
					7597877,
					919945
				],
				[
					3673,
					4340
				]
			],
			[
				[
					7602808,
					919927
				],
				[
					-2255,
					-1890
				]
			],
			[
				[
					7600553,
					918037
				],
				[
					-1196,
					-1115
				]
			],
			[
				[
					7599357,
					916922
				],
				[
					-1259,
					2290
				]
			],
			[
				[
					7607711,
					918116
				],
				[
					-2977,
					-1702
				]
			],
			[
				[
					7604734,
					916414
				],
				[
					-2529,
					-456
				]
			],
			[
				[
					7602205,
					915958
				],
				[
					-1652,
					2079
				]
			],
			[
				[
					7595210,
					917680
				],
				[
					-2881,
					6274
				]
			],
			[
				[
					7592329,
					923954
				],
				[
					2881,
					-6274
				]
			],
			[
				[
					7595210,
					917680
				],
				[
					-2881,
					6274
				]
			],
			[
				[
					7602205,
					915958
				],
				[
					-3451,
					-3774
				]
			],
			[
				[
					7598754,
					912184
				],
				[
					603,
					4738
				]
			],
			[
				[
					7598754,
					912184
				],
				[
					863,
					-4156
				]
			],
			[
				[
					7599617,
					908028
				],
				[
					-1518,
					-51
				]
			],
			[
				[
					7598099,
					907977
				],
				[
					-3142,
					6535
				]
			],
			[
				[
					7594957,
					914512
				],
				[
					2920,
					5433
				]
			],
			[
				[
					7598099,
					907977
				],
				[
					-5553,
					-2401
				]
			],
			[
				[
					7592546,
					905576
				],
				[
					-407,
					2727
				]
			],
			[
				[
					7592139,
					908303
				],
				[
					1088,
					4764
				]
			],
			[
				[
					7593227,
					913067
				],
				[
					1730,
					1445
				]
			],
			[
				[
					7592139,
					908303
				],
				[
					-3671,
					1046
				]
			],
			[
				[
					7588468,
					909349
				],
				[
					4759,
					3718
				]
			],
			[
				[
					7612934,
					908825
				],
				[
					-6703,
					248
				]
			],
			[
				[
					7606231,
					909073
				],
				[
					-1497,
					7341
				]
			],
			[
				[
					7606231,
					909073
				],
				[
					-6285,
					-2817
				]
			],
			[
				[
					7599946,
					906256
				],
				[
					-329,
					1772
				]
			],
			[
				[
					7613034,
					906291
				],
				[
					-12588,
					-2380
				]
			],
			[
				[
					7600446,
					903911
				],
				[
					-500,
					2345
				]
			],
			[
				[
					7600446,
					903911
				],
				[
					-7261,
					-3441
				]
			],
			[
				[
					7593185,
					900470
				],
				[
					-639,
					5106
				]
			],
			[
				[
					7593185,
					900470
				],
				[
					-6382,
					-2802
				],
				[
					1665,
					11681
				]
			],
			[
				[
					7847758,
					998053
				],
				[
					-7033,
					-13821
				],
				[
					10478,
					-11909
				],
				[
					-11478,
					-22890
				],
				[
					-13913,
					-2785
				]
			],
			[
				[
					7825812,
					946648
				],
				[
					-15617,
					12832
				],
				[
					-4071,
					9495
				]
			],
			[
				[
					7806124,
					968975
				],
				[
					-13550,
					15266
				],
				[
					4471,
					8583
				],
				[
					-10566,
					17847
				]
			],
			[
				[
					7786479,
					1010671
				],
				[
					-8437,
					4468
				],
				[
					-7465,
					19066
				],
				[
					4245,
					18645
				]
			],
			[
				[
					7821513,
					993810
				],
				[
					-11735,
					-6193
				],
				[
					2130,
					-16614
				],
				[
					9605,
					22807
				]
			],
			[
				[
					7924244,
					880720
				],
				[
					-14565,
					-7369
				],
				[
					-4036,
					-13832
				],
				[
					-10694,
					1244
				],
				[
					-6297,
					12599
				],
				[
					-9044,
					-8719
				],
				[
					-7095,
					-32966
				],
				[
					-8091,
					-14097
				],
				[
					-338,
					-13639
				],
				[
					-33728,
					-863
				]
			],
			[
				[
					7830356,
					803078
				],
				[
					221,
					20743
				],
				[
					9130,
					-1958
				],
				[
					4806,
					17112
				],
				[
					-25579,
					129
				],
				[
					-8095,
					-21563
				],
				[
					4667,
					-7167
				],
				[
					-8638,
					-8110
				]
			],
			[
				[
					7806868,
					802264
				],
				[
					-26170,
					-573
				]
			],
			[
				[
					7780698,
					801691
				],
				[
					-4458,
					14753
				],
				[
					1706,
					20058
				],
				[
					-5237,
					1114
				],
				[
					150,
					18068
				],
				[
					6078,
					18708
				]
			],
			[
				[
					7778937,
					874392
				],
				[
					2551,
					-107
				],
				[
					-2047,
					-34697
				],
				[
					5490,
					-16310
				],
				[
					11038,
					16095
				],
				[
					-38,
					27151
				],
				[
					6877,
					6557
				]
			],
			[
				[
					7802808,
					873081
				],
				[
					10593,
					1646
				],
				[
					1882,
					12020
				]
			],
			[
				[
					7815283,
					886747
				],
				[
					4193,
					706
				]
			],
			[
				[
					7819476,
					887453
				],
				[
					8914,
					-10262
				],
				[
					1121,
					19834
				]
			],
			[
				[
					7829511,
					897025
				],
				[
					-1666,
					6844
				]
			],
			[
				[
					7827845,
					903869
				],
				[
					-5402,
					5940
				]
			],
			[
				[
					7822443,
					909809
				],
				[
					-5830,
					17210
				]
			],
			[
				[
					7816613,
					927019
				],
				[
					3874,
					7417
				],
				[
					-6928,
					7820
				],
				[
					12253,
					4392
				]
			],
			[
				[
					7806124,
					968975
				],
				[
					-6346,
					-22259
				],
				[
					9239,
					-20917
				]
			],
			[
				[
					7809017,
					925799
				],
				[
					-5503,
					-11772
				],
				[
					6818,
					-5832
				]
			],
			[
				[
					7810332,
					908195
				],
				[
					3,
					-817
				]
			],
			[
				[
					7810335,
					907378
				],
				[
					-10490,
					-737
				],
				[
					-4167,
					-13172
				]
			],
			[
				[
					7795678,
					893469
				],
				[
					-4645,
					10396
				]
			],
			[
				[
					7791033,
					903865
				],
				[
					1715,
					19440
				],
				[
					-18963,
					19397
				]
			],
			[
				[
					7773785,
					942702
				],
				[
					7060,
					13886
				],
				[
					-8417,
					10007
				]
			],
			[
				[
					7772428,
					966595
				],
				[
					9743,
					16976
				],
				[
					-5622,
					9244
				],
				[
					9930,
					17856
				]
			],
			[
				[
					7733433,
					1043540
				],
				[
					8083,
					-6815
				]
			],
			[
				[
					7741516,
					1036725
				],
				[
					-8148,
					-15354
				],
				[
					16620,
					-20001
				]
			],
			[
				[
					7749988,
					1001370
				],
				[
					11315,
					-15794
				]
			],
			[
				[
					7761303,
					985576
				],
				[
					-9147,
					-15975
				],
				[
					-12652,
					22080
				],
				[
					-11602,
					-8020
				],
				[
					-16964,
					28680
				]
			],
			[
				[
					7710938,
					1012341
				],
				[
					6877,
					6955
				],
				[
					13630,
					25508
				],
				[
					1988,
					-1264
				]
			],
			[
				[
					7772428,
					966595
				],
				[
					-6361,
					3408
				],
				[
					-2118,
					12133
				]
			],
			[
				[
					7763949,
					982136
				],
				[
					10151,
					17851
				],
				[
					-7283,
					4434
				]
			],
			[
				[
					7766817,
					1004421
				],
				[
					866,
					1527
				]
			],
			[
				[
					7767683,
					1005948
				],
				[
					-2780,
					7555
				],
				[
					5873,
					10693
				],
				[
					-12567,
					15122
				],
				[
					-7982,
					-634
				],
				[
					-3784,
					9934
				]
			],
			[
				[
					7746443,
					1048618
				],
				[
					-2722,
					8047
				],
				[
					6600,
					16656
				],
				[
					10119,
					2902
				],
				[
					-7989,
					12253
				]
			],
			[
				[
					7749779,
					886765
				],
				[
					0,
					0
				]
			],
			[
				[
					7791033,
					903865
				],
				[
					-10322,
					5155
				],
				[
					-1774,
					-34628
				]
			],
			[
				[
					7780698,
					801691
				],
				[
					-51726,
					2610
				]
			],
			[
				[
					7728972,
					804301
				],
				[
					60,
					14553
				],
				[
					-20718,
					119
				],
				[
					-60,
					36063
				]
			],
			[
				[
					7708254,
					855036
				],
				[
					6777,
					-10195
				],
				[
					14706,
					3479
				],
				[
					7527,
					6340
				],
				[
					-233,
					11363
				]
			],
			[
				[
					7737031,
					866023
				],
				[
					4032,
					8640
				]
			],
			[
				[
					7741063,
					874663
				],
				[
					14186,
					90
				],
				[
					67,
					18327
				],
				[
					-7093,
					-3405
				],
				[
					-15711,
					12317
				]
			],
			[
				[
					7732512,
					901992
				],
				[
					-5864,
					8886
				]
			],
			[
				[
					7726648,
					910878
				],
				[
					-12363,
					-7095
				],
				[
					-2378,
					-14366
				],
				[
					10121,
					-6606
				]
			],
			[
				[
					7722028,
					882811
				],
				[
					-4717,
					-11163
				]
			],
			[
				[
					7717311,
					871648
				],
				[
					-9538,
					-7290
				]
			],
			[
				[
					7707773,
					864358
				],
				[
					-10826,
					16612
				]
			],
			[
				[
					7696947,
					880970
				],
				[
					6648,
					20034
				],
				[
					-5293,
					9800
				]
			],
			[
				[
					7698302,
					910804
				],
				[
					16845,
					3779
				],
				[
					1970,
					15682
				],
				[
					12323,
					-3357
				],
				[
					9484,
					3324
				],
				[
					2335,
					-9444
				],
				[
					20511,
					-4223
				],
				[
					309,
					11409
				],
				[
					6644,
					16928
				],
				[
					5062,
					-2200
				]
			],
			[
				[
					7722037,
					916822
				],
				[
					0,
					0
				]
			],
			[
				[
					7699384,
					1062729
				],
				[
					-247,
					376
				]
			],
			[
				[
					7699137,
					1063105
				],
				[
					247,
					-376
				]
			],
			[
				[
					7697752,
					1065114
				],
				[
					1122,
					-1610
				]
			],
			[
				[
					7698137,
					1064563
				],
				[
					-385,
					551
				]
			],
			[
				[
					7698802,
					1063611
				],
				[
					-665,
					952
				]
			],
			[
				[
					7698874,
					1063504
				],
				[
					-72,
					107
				]
			],
			[
				[
					7697560,
					1065388
				],
				[
					-99,
					142
				]
			],
			[
				[
					7697461,
					1065530
				],
				[
					99,
					-142
				]
			],
			[
				[
					7699091,
					1063175
				],
				[
					-152,
					230
				]
			],
			[
				[
					7698939,
					1063405
				],
				[
					152,
					-230
				]
			],
			[
				[
					7746443,
					1048618
				],
				[
					-13010,
					-5078
				]
			],
			[
				[
					7710938,
					1012341
				],
				[
					-5070,
					7069
				],
				[
					-5570,
					-14097
				],
				[
					736,
					-12240
				],
				[
					-14076,
					23271
				],
				[
					-2015,
					-12217
				],
				[
					-6335,
					-3365
				]
			],
			[
				[
					7678608,
					1000762
				],
				[
					-723,
					30226
				]
			],
			[
				[
					7677885,
					1030988
				],
				[
					49,
					7662
				]
			],
			[
				[
					7677934,
					1038650
				],
				[
					37,
					1753
				]
			],
			[
				[
					7677971,
					1040403
				],
				[
					11801,
					-1365
				],
				[
					3186,
					14491
				],
				[
					6903,
					8967
				]
			],
			[
				[
					7699861,
					1062496
				],
				[
					3104,
					7361
				],
				[
					13872,
					5422
				],
				[
					14294,
					13369
				]
			],
			[
				[
					7731131,
					1088648
				],
				[
					8712,
					-11897
				],
				[
					9765,
					16048
				]
			],
			[
				[
					7761303,
					985576
				],
				[
					2646,
					-3440
				]
			],
			[
				[
					7698302,
					910804
				],
				[
					-10903,
					19623
				],
				[
					-8632,
					8593
				]
			],
			[
				[
					7678767,
					939020
				],
				[
					107,
					925
				]
			],
			[
				[
					7678874,
					939945
				],
				[
					-5420,
					12479
				]
			],
			[
				[
					7673454,
					952424
				],
				[
					-573,
					27886
				],
				[
					5727,
					20452
				]
			],
			[
				[
					7689309,
					951447
				],
				[
					7033,
					-13206
				]
			],
			[
				[
					7696342,
					938241
				],
				[
					11172,
					4152
				]
			],
			[
				[
					7707514,
					942393
				],
				[
					6848,
					16083
				],
				[
					-9707,
					14348
				],
				[
					-5105,
					-6561
				],
				[
					-4653,
					7384
				],
				[
					-5588,
					-22200
				]
			],
			[
				[
					7676403,
					891644
				],
				[
					8128,
					-5299
				],
				[
					4608,
					7444
				],
				[
					4345,
					-9495
				]
			],
			[
				[
					7693484,
					884294
				],
				[
					-991,
					-22706
				],
				[
					15286,
					-6573
				]
			],
			[
				[
					7707779,
					855015
				],
				[
					475,
					21
				]
			],
			[
				[
					7728972,
					804301
				],
				[
					-44779,
					-64
				],
				[
					1529,
					10538
				],
				[
					-10384,
					-717
				],
				[
					-2662,
					-10283
				],
				[
					-39112,
					-1760
				]
			],
			[
				[
					7633564,
					802015
				],
				[
					9560,
					43711
				],
				[
					-2530,
					22592
				],
				[
					7511,
					11640
				]
			],
			[
				[
					7648105,
					879958
				],
				[
					4448,
					-4118
				],
				[
					-4630,
					-13816
				],
				[
					10387,
					-218
				]
			],
			[
				[
					7658310,
					861806
				],
				[
					8483,
					1327
				]
			],
			[
				[
					7666793,
					863133
				],
				[
					5950,
					-1565
				],
				[
					2564,
					11310
				],
				[
					-3963,
					12472
				]
			],
			[
				[
					7671344,
					885350
				],
				[
					561,
					6297
				]
			],
			[
				[
					7671905,
					891647
				],
				[
					4498,
					-3
				]
			],
			[
				[
					7689701,
					1076336
				],
				[
					-13003,
					-19522
				],
				[
					5249,
					16255
				],
				[
					7754,
					3267
				]
			],
			[
				[
					7706252,
					1107962
				],
				[
					-3255,
					4872
				],
				[
					-12281,
					-7490
				],
				[
					9421,
					-13097
				]
			],
			[
				[
					7700137,
					1092247
				],
				[
					-14936,
					-15147
				],
				[
					-10568,
					-16153
				],
				[
					-2257,
					-23835
				],
				[
					-7105,
					-18402
				]
			],
			[
				[
					7665271,
					1018710
				],
				[
					-10345,
					15221
				],
				[
					-4808,
					-15020
				]
			],
			[
				[
					7650118,
					1018911
				],
				[
					-7277,
					9293
				],
				[
					-2886,
					-11392
				]
			],
			[
				[
					7639955,
					1016812
				],
				[
					-10937,
					-18153
				]
			],
			[
				[
					7629018,
					998659
				],
				[
					-12303,
					-6397
				]
			],
			[
				[
					7616715,
					992262
				],
				[
					-1268,
					2357
				]
			],
			[
				[
					7615447,
					994619
				],
				[
					2447,
					7347
				],
				[
					-11213,
					18569
				],
				[
					-12145,
					-5414
				]
			],
			[
				[
					7594536,
					1015121
				],
				[
					-13433,
					26111
				]
			],
			[
				[
					7581103,
					1041232
				],
				[
					-369,
					8620
				]
			],
			[
				[
					7580734,
					1049852
				],
				[
					5270,
					7964
				],
				[
					-2363,
					27212
				],
				[
					10875,
					16051
				],
				[
					-21747,
					30550
				],
				[
					-10962,
					26982
				],
				[
					-6152,
					-3238
				],
				[
					-46021,
					67524
				],
				[
					-18166,
					24213
				]
			],
			[
				[
					7491468,
					1247110
				],
				[
					24725,
					35375
				],
				[
					-21352,
					31465
				],
				[
					-592,
					10978
				],
				[
					9750,
					5256
				],
				[
					3881,
					15651
				],
				[
					-18736,
					27302
				]
			],
			[
				[
					7638155,
					1041543
				],
				[
					10381,
					2002
				],
				[
					1638,
					14449
				],
				[
					-13686,
					182
				],
				[
					1667,
					-16633
				]
			],
			[
				[
					7650328,
					886233
				],
				[
					-2223,
					-6275
				]
			],
			[
				[
					7633564,
					802015
				],
				[
					-17710,
					-804
				]
			],
			[
				[
					7615854,
					801211
				],
				[
					1290,
					22121
				],
				[
					-8117,
					17787
				],
				[
					9819,
					9242
				],
				[
					-7437,
					11910
				]
			],
			[
				[
					7611409,
					862271
				],
				[
					5241,
					19454
				]
			],
			[
				[
					7616650,
					881725
				],
				[
					4515,
					4005
				]
			],
			[
				[
					7621165,
					885730
				],
				[
					8886,
					-13739
				],
				[
					5871,
					10383
				]
			],
			[
				[
					7635922,
					882374
				],
				[
					5323,
					12406
				],
				[
					9083,
					-8547
				]
			],
			[
				[
					7696947,
					880970
				],
				[
					-3463,
					3324
				]
			],
			[
				[
					7676403,
					891644
				],
				[
					7095,
					15182
				],
				[
					-8202,
					11474
				]
			],
			[
				[
					7675296,
					918300
				],
				[
					-3043,
					5432
				]
			],
			[
				[
					7672253,
					923732
				],
				[
					6514,
					15288
				]
			],
			[
				[
					7673454,
					952424
				],
				[
					-11044,
					-2622
				]
			],
			[
				[
					7662410,
					949802
				],
				[
					-7260,
					8253
				]
			],
			[
				[
					7655150,
					958055
				],
				[
					2702,
					9113
				],
				[
					-7952,
					14037
				]
			],
			[
				[
					7649900,
					981205
				],
				[
					18495,
					28031
				],
				[
					5594,
					27923
				]
			],
			[
				[
					7673989,
					1037159
				],
				[
					3896,
					-6171
				]
			],
			[
				[
					7030203,
					2330615
				],
				[
					3,
					450
				]
			],
			[
				[
					7030206,
					2331065
				],
				[
					-1049,
					3597
				]
			],
			[
				[
					7029157,
					2334662
				],
				[
					-1134,
					8998
				],
				[
					14673,
					21442
				]
			],
			[
				[
					7042696,
					2365102
				],
				[
					5678,
					723
				],
				[
					19606,
					-13830
				],
				[
					4306,
					-11740
				],
				[
					882,
					-20250
				],
				[
					-21865,
					957
				],
				[
					262,
					-52844
				],
				[
					-7070,
					2250
				],
				[
					-12569,
					16357
				],
				[
					-7838,
					21239
				],
				[
					6115,
					22651
				]
			],
			[
				[
					7042545,
					2367302
				],
				[
					-7018,
					2874
				],
				[
					97,
					14015
				]
			],
			[
				[
					7035624,
					2384191
				],
				[
					11767,
					-252
				],
				[
					-4846,
					-16637
				]
			],
			[
				[
					7067005,
					2527321
				],
				[
					-1516,
					17897
				]
			],
			[
				[
					7065489,
					2545218
				],
				[
					40173,
					-1532
				],
				[
					14386,
					4552
				],
				[
					15164,
					-11464
				],
				[
					164,
					-26401
				],
				[
					-25542,
					528
				],
				[
					-328,
					19424
				],
				[
					-37220,
					-250
				],
				[
					-5281,
					-2754
				]
			],
			[
				[
					7049273,
					2701322
				],
				[
					-13142,
					-5781
				],
				[
					-9795,
					14448
				],
				[
					14732,
					12302
				],
				[
					-17128,
					4673
				],
				[
					-7269,
					7651
				],
				[
					7051,
					5362
				],
				[
					-3034,
					16171
				]
			],
			[
				[
					7020688,
					2756148
				],
				[
					50188,
					-9
				],
				[
					-771,
					-32577
				],
				[
					-12146,
					-11687
				],
				[
					-9838,
					2277
				],
				[
					1152,
					-12830
				]
			],
			[
				[
					7028406,
					2864321
				],
				[
					-12643,
					11658
				],
				[
					-282,
					20865
				],
				[
					-8940,
					2729
				],
				[
					5130,
					20924
				],
				[
					-2401,
					9046
				]
			],
			[
				[
					7009270,
					2929543
				],
				[
					13289,
					-1097
				],
				[
					9743,
					-13915
				],
				[
					40023,
					-9148
				],
				[
					7833,
					2795
				],
				[
					31521,
					-1114
				],
				[
					-502,
					-31387
				],
				[
					-11164,
					536
				],
				[
					-54,
					-15037
				],
				[
					-17895,
					916
				],
				[
					-27920,
					-5054
				],
				[
					-5389,
					4636
				],
				[
					-20349,
					2647
				]
			],
			[
				[
					7217528,
					3938965
				],
				[
					-272,
					2050
				]
			],
			[
				[
					7217256,
					3941015
				],
				[
					272,
					-2050
				]
			],
			[
				[
					8311936,
					4028185
				],
				[
					3656,
					-4696
				]
			],
			[
				[
					8315592,
					4023489
				],
				[
					-3656,
					4696
				]
			],
			[
				[
					8305760,
					4030654
				],
				[
					9178,
					-16336
				],
				[
					-6170,
					-6869
				],
				[
					-11620,
					1851
				],
				[
					8612,
					21354
				]
			],
			[
				[
					7103136,
					4042701
				],
				[
					-649,
					4011
				]
			],
			[
				[
					7102487,
					4046712
				],
				[
					649,
					-4011
				]
			],
			[
				[
					8144700,
					4181870
				],
				[
					4113,
					-8795
				],
				[
					-13345,
					-5049
				],
				[
					9232,
					13844
				]
			],
			[
				[
					8122455,
					4214613
				],
				[
					14589,
					-22407
				],
				[
					-6783,
					-4179
				],
				[
					-9531,
					-22104
				],
				[
					-4953,
					6860
				],
				[
					-8323,
					-7593
				],
				[
					8653,
					30998
				],
				[
					-8230,
					12766
				],
				[
					14578,
					5659
				]
			],
			[
				[
					8034818,
					4649510
				],
				[
					3375,
					-1088
				]
			],
			[
				[
					8038193,
					4648422
				],
				[
					-3375,
					1088
				]
			],
			[
				[
					8025165,
					4652597
				],
				[
					808,
					-258
				]
			],
			[
				[
					8025973,
					4652339
				],
				[
					-808,
					258
				]
			],
			[
				[
					7849948,
					4735878
				],
				[
					128,
					-2452
				]
			],
			[
				[
					7850076,
					4733426
				],
				[
					-128,
					2452
				]
			],
			[
				[
					7678790,
					4966125
				],
				[
					654,
					-3099
				]
			],
			[
				[
					7679444,
					4963026
				],
				[
					-654,
					3099
				]
			],
			[
				[
					8033839,
					3212848
				],
				[
					-113124,
					0
				],
				[
					-84843,
					0
				],
				[
					-84842,
					0
				],
				[
					-113124,
					0
				],
				[
					-113124,
					0
				],
				[
					-84843,
					0
				],
				[
					-113124,
					0
				],
				[
					-113124,
					0
				],
				[
					-141668,
					0
				]
			],
			[
				[
					7072023,
					3212848
				],
				[
					21722,
					11106
				],
				[
					20440,
					24904
				],
				[
					39179,
					29512
				],
				[
					18036,
					27018
				],
				[
					5322,
					209
				],
				[
					18089,
					25990
				],
				[
					33734,
					41890
				],
				[
					-1320,
					10638
				],
				[
					15429,
					26989
				],
				[
					18531,
					26035
				],
				[
					3524,
					17233
				],
				[
					8801,
					4857
				],
				[
					8116,
					24914
				],
				[
					2594,
					27075
				],
				[
					8872,
					15477
				],
				[
					3364,
					36409
				],
				[
					-3693,
					5592
				],
				[
					1758,
					30027
				],
				[
					-104,
					56558
				],
				[
					-3899,
					26129
				],
				[
					1832,
					31583
				],
				[
					-5042,
					36797
				],
				[
					-11415,
					51055
				],
				[
					-4471,
					4866
				],
				[
					-13202,
					37929
				],
				[
					1602,
					11569
				],
				[
					-30991,
					70657
				],
				[
					-15479,
					22629
				],
				[
					-12268,
					9273
				],
				[
					-17865,
					33547
				],
				[
					-28291,
					14376
				],
				[
					-32687,
					21405
				],
				[
					1501,
					10964
				],
				[
					-17575,
					11977
				],
				[
					-5257,
					11968
				],
				[
					-12642,
					11489
				],
				[
					-1101,
					10076
				],
				[
					-9820,
					5916
				],
				[
					3527,
					-22506
				],
				[
					-11643,
					23425
				],
				[
					-6422,
					1283
				],
				[
					8984,
					30674
				],
				[
					-8500,
					35407
				],
				[
					8403,
					-4736
				],
				[
					15543,
					2277
				],
				[
					9470,
					17066
				],
				[
					-3751,
					17416
				],
				[
					10755,
					-661
				],
				[
					11236,
					11293
				],
				[
					-8047,
					13319
				],
				[
					8430,
					18
				],
				[
					-1131,
					15723
				],
				[
					26859,
					11179
				],
				[
					12078,
					10857
				],
				[
					-5303,
					14355
				],
				[
					20211,
					2355
				],
				[
					-9639,
					9645
				],
				[
					-12720,
					578
				],
				[
					-8972,
					-7096
				],
				[
					4740,
					28704
				],
				[
					15649,
					5295
				],
				[
					2648,
					19029
				],
				[
					-6524,
					3966
				],
				[
					-2876,
					20079
				],
				[
					17755,
					57
				],
				[
					12975,
					-5297
				],
				[
					-3608,
					17105
				],
				[
					30022,
					7052
				],
				[
					-8884,
					18310
				],
				[
					-2529,
					19529
				],
				[
					15922,
					10890
				],
				[
					-12527,
					15215
				],
				[
					-21966,
					-2736
				],
				[
					-5038,
					15443
				],
				[
					14771,
					5968
				],
				[
					-10330,
					17538
				],
				[
					9985,
					138
				],
				[
					-14165,
					22432
				],
				[
					-4639,
					17383
				],
				[
					-13965,
					4635
				],
				[
					12358,
					23069
				],
				[
					8247,
					4176
				],
				[
					102,
					15267
				],
				[
					-9388,
					-4749
				],
				[
					-14417,
					12782
				],
				[
					-2951,
					15538
				],
				[
					13553,
					7442
				],
				[
					10153,
					19196
				],
				[
					-15778,
					-5473
				],
				[
					27459,
					20097
				],
				[
					-40042,
					-16495
				],
				[
					-22865,
					12861
				],
				[
					-16698,
					-8916
				],
				[
					3072,
					19297
				],
				[
					22895,
					31801
				],
				[
					18741,
					15436
				],
				[
					668,
					22934
				],
				[
					13042,
					9357
				],
				[
					-8036,
					32155
				],
				[
					1703,
					13037
				],
				[
					-5584,
					21055
				],
				[
					10416,
					-7707
				],
				[
					2255,
					7797
				],
				[
					15699,
					4099
				],
				[
					-16983,
					9595
				],
				[
					11586,
					17636
				],
				[
					-13901,
					87
				],
				[
					-6549,
					23088
				],
				[
					-17672,
					-2301
				],
				[
					-9167,
					12415
				],
				[
					-8099,
					37087
				],
				[
					-9809,
					63836
				],
				[
					2848,
					35891
				],
				[
					7884,
					15050
				],
				[
					16723,
					13310
				],
				[
					24971,
					11850
				],
				[
					16215,
					14364
				],
				[
					7948,
					14013
				],
				[
					50171,
					-13550
				],
				[
					28344,
					-710
				],
				[
					27058,
					-16829
				],
				[
					53367,
					-18720
				],
				[
					-1948,
					-10038
				],
				[
					11269,
					4806
				],
				[
					16360,
					-8152
				],
				[
					40960,
					-12128
				],
				[
					18514,
					10992
				],
				[
					49238,
					-15520
				],
				[
					31402,
					-32286
				],
				[
					-9122,
					19560
				],
				[
					973,
					13351
				],
				[
					31893,
					-3218
				],
				[
					14366,
					7404
				],
				[
					3191,
					10560
				],
				[
					34259,
					13005
				],
				[
					13647,
					22622
				],
				[
					21311,
					2580
				],
				[
					13624,
					-23295
				],
				[
					17159,
					-872
				],
				[
					7878,
					-10675
				],
				[
					13627,
					-3304
				],
				[
					487,
					-10990
				],
				[
					14959,
					-20909
				],
				[
					16975,
					-5812
				],
				[
					4770,
					-11833
				],
				[
					13233,
					8628
				],
				[
					15972,
					-7905
				],
				[
					3459,
					-39054
				],
				[
					17736,
					-11309
				],
				[
					24201,
					-7391
				],
				[
					10969,
					-18502
				],
				[
					-11617,
					-2968
				],
				[
					31144,
					-18620
				],
				[
					35052,
					-13297
				],
				[
					11915,
					-18223
				],
				[
					-32842,
					-8307
				],
				[
					11385,
					-18367
				],
				[
					-17928,
					-7768
				],
				[
					23280,
					-7907
				],
				[
					218,
					-19727
				],
				[
					-11843,
					-7212
				],
				[
					14990,
					-4135
				],
				[
					10046,
					-11799
				],
				[
					-620,
					-15981
				],
				[
					7161,
					15725
				],
				[
					6405,
					83
				],
				[
					6901,
					-25728
				],
				[
					3165,
					9867
				],
				[
					46436,
					-9943
				],
				[
					17639,
					-14294
				],
				[
					1752,
					6452
				],
				[
					26772,
					-17538
				],
				[
					3361,
					14336
				],
				[
					10023,
					-15187
				],
				[
					-615,
					19377
				],
				[
					27572,
					817
				],
				[
					6782,
					-4897
				],
				[
					-5752,
					-17415
				],
				[
					8259,
					-9068
				],
				[
					4681,
					-28351
				],
				[
					15334,
					-9975
				],
				[
					10317,
					22405
				],
				[
					19111,
					-5008
				],
				[
					-4168,
					19151
				],
				[
					8428,
					30190
				],
				[
					12362,
					-2811
				],
				[
					16150,
					-60691
				],
				[
					-38021,
					-27407
				],
				[
					7826,
					-27444
				],
				[
					-21109,
					-17567
				],
				[
					11264,
					-13670
				],
				[
					-6412,
					-10235
				],
				[
					12159,
					-14564
				],
				[
					-12027,
					-11312
				],
				[
					20784,
					-20452
				],
				[
					-2654,
					-27333
				],
				[
					-14600,
					-13539
				],
				[
					-10137,
					6206
				],
				[
					-1123,
					-14961
				],
				[
					13477,
					-12458
				],
				[
					5807,
					-21666
				],
				[
					14022,
					-2988
				],
				[
					-7188,
					-17139
				],
				[
					6026,
					-11870
				],
				[
					-9123,
					-8439
				],
				[
					14747,
					-8230
				],
				[
					-1535,
					-14002
				],
				[
					-14875,
					-8594
				],
				[
					-11093,
					-22467
				],
				[
					8179,
					-2667
				],
				[
					5549,
					-27723
				],
				[
					-14440,
					-11790
				],
				[
					17219,
					893
				],
				[
					19308,
					11248
				],
				[
					8559,
					-13786
				],
				[
					12649,
					6672
				],
				[
					-92,
					-26969
				],
				[
					-11947,
					5342
				],
				[
					-663,
					-11221
				],
				[
					-8030,
					7330
				],
				[
					-11940,
					-20213
				],
				[
					21290,
					-12146
				],
				[
					-10400,
					-17534
				],
				[
					-5020,
					9356
				],
				[
					4364,
					-37380
				],
				[
					-7938,
					-463
				],
				[
					-4846,
					-23025
				],
				[
					-11468,
					-3884
				],
				[
					-3953,
					7342
				],
				[
					3249,
					30062
				],
				[
					-11252,
					2877
				],
				[
					-7875,
					22292
				],
				[
					-7239,
					-23139
				],
				[
					9763,
					410
				],
				[
					2274,
					-31084
				],
				[
					-12455,
					12046
				],
				[
					1530,
					-10615
				],
				[
					-16454,
					-1422
				],
				[
					-5557,
					-10138
				],
				[
					5714,
					-12662
				],
				[
					13557,
					12239
				],
				[
					-2077,
					-23192
				],
				[
					11510,
					7342
				],
				[
					-4382,
					-18255
				],
				[
					5950,
					-13402
				],
				[
					15295,
					31091
				],
				[
					31002,
					27824
				],
				[
					1722,
					9938
				],
				[
					27747,
					7461
				],
				[
					14822,
					-7131
				],
				[
					16528,
					2641
				],
				[
					11778,
					8296
				],
				[
					3074,
					-7686
				],
				[
					14776,
					3015
				],
				[
					14986,
					-19197
				],
				[
					13967,
					-9323
				],
				[
					-3893,
					-14713
				],
				[
					5744,
					-9159
				],
				[
					-1338,
					-20260
				],
				[
					10418,
					-18282
				],
				[
					5990,
					8017
				],
				[
					14366,
					-13479
				],
				[
					11628,
					16002
				],
				[
					-881,
					-10364
				],
				[
					32339,
					-23090
				],
				[
					-5803,
					-24271
				],
				[
					1413,
					-15180
				],
				[
					22811,
					-2710
				],
				[
					7695,
					8566
				],
				[
					8977,
					-3964
				],
				[
					5969,
					12063
				],
				[
					9782,
					1150
				],
				[
					7017,
					10505
				],
				[
					14300,
					3569
				],
				[
					10264,
					26702
				],
				[
					6756,
					142
				],
				[
					5397,
					-16334
				],
				[
					13353,
					19293
				],
				[
					12950,
					-8048
				],
				[
					-4534,
					17265
				],
				[
					6304,
					-61
				],
				[
					-505,
					17970
				],
				[
					5460,
					1971
				],
				[
					3638,
					18206
				],
				[
					9328,
					1402
				],
				[
					-467,
					28865
				],
				[
					8440,
					5235
				],
				[
					14047,
					-11836
				],
				[
					17103,
					-21060
				],
				[
					9064,
					495
				],
				[
					-9230,
					13276
				],
				[
					3661,
					14252
				],
				[
					10824,
					6385
				],
				[
					16138,
					-13091
				],
				[
					3559,
					12658
				],
				[
					6095,
					-12282
				],
				[
					15475,
					-8804
				],
				[
					1544,
					-7828
				],
				[
					16139,
					-11725
				],
				[
					-24253,
					30119
				],
				[
					-7682,
					672
				],
				[
					-4840,
					12514
				],
				[
					-16120,
					1066
				],
				[
					-6489,
					11172
				],
				[
					23487,
					15604
				],
				[
					12342,
					-11831
				],
				[
					195,
					9578
				],
				[
					-13602,
					10892
				],
				[
					21990,
					6978
				],
				[
					-15017,
					26035
				],
				[
					-3570,
					19224
				],
				[
					4704,
					9743
				],
				[
					10490,
					-9391
				],
				[
					12478,
					12726
				],
				[
					-7658,
					19933
				],
				[
					9748,
					-2122
				],
				[
					20545,
					-30022
				],
				[
					-14760,
					39498
				],
				[
					7485,
					1441
				],
				[
					-17022,
					16896
				],
				[
					14509,
					-1288
				],
				[
					-9566,
					47289
				],
				[
					-6266,
					7376
				],
				[
					8276,
					11949
				],
				[
					-2151,
					9003
				],
				[
					11947,
					-221
				],
				[
					-2317,
					8420
				],
				[
					18581,
					3226
				],
				[
					-504,
					21477
				],
				[
					8518,
					1574
				],
				[
					2272,
					26835
				],
				[
					15137,
					19928
				],
				[
					5299,
					32457
				],
				[
					17983,
					14850
				],
				[
					-3140,
					11733
				],
				[
					10516,
					-911
				],
				[
					23500,
					-15845
				]
			],
			[
				[
					7591615,
					928590
				],
				[
					-16382,
					-17479
				],
				[
					-13026,
					11085
				]
			],
			[
				[
					7562207,
					922196
				],
				[
					3682,
					5260
				]
			],
			[
				[
					7565889,
					927456
				],
				[
					12751,
					10220
				]
			],
			[
				[
					7578640,
					937676
				],
				[
					12975,
					-9086
				]
			],
			[
				[
					7608376,
					972825
				],
				[
					-9664,
					1826
				]
			],
			[
				[
					7598712,
					974651
				],
				[
					-401,
					557
				]
			],
			[
				[
					7598311,
					975208
				],
				[
					-7015,
					10127
				]
			],
			[
				[
					7591296,
					985335
				],
				[
					9955,
					12270
				]
			],
			[
				[
					7601251,
					997605
				],
				[
					10448,
					-15149
				]
			],
			[
				[
					7611699,
					982456
				],
				[
					-3323,
					-9631
				]
			],
			[
				[
					7566468,
					874686
				],
				[
					-86,
					216
				]
			],
			[
				[
					7566382,
					874902
				],
				[
					86,
					-216
				]
			],
			[
				[
					7583144,
					878496
				],
				[
					-1048,
					2739
				]
			],
			[
				[
					7582096,
					881235
				],
				[
					2537,
					189
				]
			],
			[
				[
					7584633,
					881424
				],
				[
					-1489,
					-2928
				]
			],
			[
				[
					7574943,
					893283
				],
				[
					0,
					0
				]
			],
			[
				[
					7573157,
					907252
				],
				[
					-9910,
					347
				]
			],
			[
				[
					7563247,
					907599
				],
				[
					-2453,
					1589
				]
			],
			[
				[
					7560794,
					909188
				],
				[
					-5442,
					-4474
				]
			],
			[
				[
					7555352,
					904714
				],
				[
					10926,
					-29550
				]
			],
			[
				[
					7566278,
					875164
				],
				[
					-7497,
					-12577
				]
			],
			[
				[
					7558781,
					862587
				],
				[
					-38,
					48
				]
			],
			[
				[
					7558743,
					862635
				],
				[
					136,
					843
				]
			],
			[
				[
					7558879,
					863478
				],
				[
					-1754,
					-1225
				]
			],
			[
				[
					7557125,
					862253
				],
				[
					-14699,
					-12224
				]
			],
			[
				[
					7542426,
					850029
				],
				[
					-14500,
					23523
				],
				[
					2241,
					12849
				]
			],
			[
				[
					7530167,
					886401
				],
				[
					8046,
					50703
				]
			],
			[
				[
					7538213,
					937104
				],
				[
					4368,
					-11466
				]
			],
			[
				[
					7542581,
					925638
				],
				[
					30576,
					-18386
				]
			],
			[
				[
					7553491,
					1029445
				],
				[
					6159,
					-9076
				],
				[
					11283,
					6430
				]
			],
			[
				[
					7570933,
					1026799
				],
				[
					6672,
					-21692
				]
			],
			[
				[
					7577605,
					1005107
				],
				[
					1064,
					-1732
				]
			],
			[
				[
					7578669,
					1003375
				],
				[
					-5707,
					1929
				]
			],
			[
				[
					7572962,
					1005304
				],
				[
					-7569,
					-7013
				],
				[
					2368,
					-9400
				]
			],
			[
				[
					7567761,
					988891
				],
				[
					-7212,
					2450
				]
			],
			[
				[
					7560549,
					991341
				],
				[
					-13975,
					8148
				]
			],
			[
				[
					7546574,
					999489
				],
				[
					-182,
					2255
				]
			],
			[
				[
					7546392,
					1001744
				],
				[
					3978,
					32173
				],
				[
					3121,
					-4472
				]
			],
			[
				[
					7574035,
					854631
				],
				[
					21,
					17
				]
			],
			[
				[
					7574056,
					854648
				],
				[
					9615,
					6014
				]
			],
			[
				[
					7583671,
					860662
				],
				[
					-9636,
					-6031
				]
			],
			[
				[
					7615854,
					801211
				],
				[
					-51583,
					-2807
				],
				[
					-55048,
					1972
				],
				[
					17691,
					9466
				],
				[
					8686,
					21605
				],
				[
					12396,
					10827
				],
				[
					8194,
					642
				],
				[
					7281,
					11884
				]
			],
			[
				[
					7563471,
					854800
				],
				[
					7937,
					-2419
				]
			],
			[
				[
					7571408,
					852381
				],
				[
					15168,
					10055
				]
			],
			[
				[
					7586576,
					862436
				],
				[
					242,
					145
				]
			],
			[
				[
					7586818,
					862581
				],
				[
					12142,
					-3792
				],
				[
					3731,
					17434
				]
			],
			[
				[
					7602691,
					876223
				],
				[
					1484,
					-2270
				]
			],
			[
				[
					7604175,
					873953
				],
				[
					7234,
					-11682
				]
			],
			[
				[
					7591018,
					872305
				],
				[
					1223,
					4261
				]
			],
			[
				[
					7592241,
					876566
				],
				[
					-1223,
					-4261
				]
			],
			[
				[
					7591851,
					876750
				],
				[
					159,
					-78
				]
			],
			[
				[
					7592010,
					876672
				],
				[
					-159,
					78
				]
			],
			[
				[
					7591631,
					876846
				],
				[
					34,
					-14
				]
			],
			[
				[
					7591665,
					876832
				],
				[
					-34,
					14
				]
			],
			[
				[
					7591460,
					876913
				],
				[
					136,
					-51
				]
			],
			[
				[
					7591596,
					876862
				],
				[
					-136,
					51
				]
			],
			[
				[
					7591301,
					877124
				],
				[
					-33,
					-176
				]
			],
			[
				[
					7591268,
					876948
				],
				[
					-1575,
					-3544
				]
			],
			[
				[
					7589693,
					873404
				],
				[
					-157,
					135
				]
			],
			[
				[
					7589536,
					873539
				],
				[
					1765,
					3585
				]
			],
			[
				[
					7589501,
					873569
				],
				[
					-3322,
					-5948
				]
			],
			[
				[
					7586179,
					867621
				],
				[
					-1641,
					8401
				]
			],
			[
				[
					7584538,
					876022
				],
				[
					4963,
					-2453
				]
			],
			[
				[
					7580734,
					1049852
				],
				[
					-7127,
					-10854
				],
				[
					-6203,
					8721
				],
				[
					-13913,
					-18274
				]
			],
			[
				[
					7546392,
					1001744
				],
				[
					-11720,
					3114
				],
				[
					-2829,
					-22801
				]
			],
			[
				[
					7531843,
					982057
				],
				[
					-8960,
					1744
				]
			],
			[
				[
					7522883,
					983801
				],
				[
					-2054,
					2293
				]
			],
			[
				[
					7520829,
					986094
				],
				[
					3768,
					34347
				],
				[
					-23445,
					4329
				]
			],
			[
				[
					7501152,
					1024770
				],
				[
					-9148,
					-3451
				],
				[
					-1991,
					14009
				],
				[
					-24596,
					207
				],
				[
					-419,
					31024
				],
				[
					-6878,
					31
				],
				[
					1294,
					22826
				],
				[
					-9284,
					-16315
				],
				[
					-6223,
					6523
				]
			],
			[
				[
					7443907,
					1079624
				],
				[
					-24,
					14021
				],
				[
					-6063,
					3752
				]
			],
			[
				[
					7437820,
					1097397
				],
				[
					13616,
					8528
				],
				[
					-2932,
					10839
				],
				[
					26148,
					673
				],
				[
					-89,
					39085
				],
				[
					-14444,
					-769
				],
				[
					-2502,
					4900
				],
				[
					-159,
					34141
				],
				[
					2730,
					-15
				],
				[
					2628,
					26711
				],
				[
					10562,
					-17019
				],
				[
					1614,
					-15488
				],
				[
					11033,
					15751
				],
				[
					-11759,
					17412
				],
				[
					17202,
					24964
				]
			],
			[
				[
					7549495,
					1071804
				],
				[
					-827,
					-7035
				],
				[
					-11236,
					2134
				],
				[
					-2187,
					-20341
				],
				[
					16266,
					-4454
				],
				[
					7088,
					16260
				],
				[
					-9104,
					13436
				]
			],
			[
				[
					7518584,
					1050973
				],
				[
					4201,
					35954
				],
				[
					-18222,
					24148
				],
				[
					1653,
					-45211
				],
				[
					3030,
					-11277
				],
				[
					9315,
					-3779
				]
			],
			[
				[
					7518561,
					1050808
				],
				[
					14631,
					-13945
				],
				[
					1664,
					9683
				],
				[
					-16272,
					4427
				]
			],
			[
				[
					7555382,
					945405
				],
				[
					10507,
					-17949
				]
			],
			[
				[
					7562207,
					922196
				],
				[
					-1859,
					5921
				],
				[
					-17767,
					-2479
				]
			],
			[
				[
					7538213,
					937104
				],
				[
					-1823,
					1069
				]
			],
			[
				[
					7536390,
					938173
				],
				[
					2941,
					13077
				]
			],
			[
				[
					7539331,
					951250
				],
				[
					16051,
					-5845
				]
			],
			[
				[
					7558281,
					970624
				],
				[
					-12559,
					6978
				],
				[
					852,
					21887
				]
			],
			[
				[
					7560549,
					991341
				],
				[
					-2268,
					-20717
				]
			],
			[
				[
					7501152,
					1024770
				],
				[
					-5072,
					-30923
				],
				[
					24749,
					-7753
				]
			],
			[
				[
					7522883,
					983801
				],
				[
					-4405,
					-37760
				]
			],
			[
				[
					7518478,
					946041
				],
				[
					-7897,
					7578
				]
			],
			[
				[
					7510581,
					953619
				],
				[
					-11744,
					-1507
				],
				[
					-24170,
					3637
				],
				[
					-18359,
					-15088
				]
			],
			[
				[
					7456308,
					940661
				],
				[
					-5455,
					-593
				]
			],
			[
				[
					7450853,
					940068
				],
				[
					4710,
					33138
				],
				[
					-11887,
					4379
				]
			],
			[
				[
					7443676,
					977585
				],
				[
					-3993,
					32521
				],
				[
					-15841,
					-3924
				]
			],
			[
				[
					7423842,
					1006182
				],
				[
					-1726,
					49111
				],
				[
					9644,
					-24
				],
				[
					3848,
					10073
				],
				[
					8718,
					70
				],
				[
					-419,
					14212
				]
			],
			[
				[
					7437820,
					1097397
				],
				[
					-3885,
					-7284
				],
				[
					-11679,
					-1728
				],
				[
					55,
					9030
				],
				[
					-29790,
					47
				],
				[
					-913,
					-13126
				],
				[
					-12865,
					-415
				],
				[
					-2406,
					11878
				],
				[
					4250,
					20363
				]
			],
			[
				[
					7380587,
					1116162
				],
				[
					7700,
					475
				],
				[
					88,
					30869
				]
			],
			[
				[
					7388375,
					1147506
				],
				[
					29816,
					386
				],
				[
					-6140,
					14670
				],
				[
					10186,
					91
				],
				[
					-109,
					30002
				],
				[
					-4711,
					4609
				],
				[
					-16650,
					-684
				],
				[
					-125,
					16083
				],
				[
					-17213,
					137
				],
				[
					422,
					-59516
				]
			],
			[
				[
					7383851,
					1153284
				],
				[
					-2058,
					-7356
				],
				[
					-21529,
					-439
				],
				[
					5532,
					16954
				],
				[
					-3167,
					18613
				],
				[
					-7876,
					-167
				],
				[
					-264,
					-26553
				],
				[
					-8490,
					-1570
				],
				[
					-8586,
					-13486
				]
			],
			[
				[
					7337413,
					1139280
				],
				[
					-15125,
					17035
				],
				[
					-23903,
					15217
				],
				[
					-9028,
					155
				],
				[
					-10532,
					17201
				],
				[
					6138,
					13249
				],
				[
					-13545,
					13140
				],
				[
					-6353,
					-5731
				],
				[
					-103,
					73468
				],
				[
					-22975,
					-12
				],
				[
					-435,
					35089
				]
			],
			[
				[
					7241552,
					1318091
				],
				[
					87,
					34672
				],
				[
					48387,
					-284
				],
				[
					199,
					75461
				],
				[
					-18371,
					26753
				],
				[
					3795,
					8579
				]
			],
			[
				[
					7275649,
					1463272
				],
				[
					16024,
					27238
				],
				[
					8213,
					6853
				],
				[
					11611,
					-5833
				],
				[
					2997,
					-25970
				],
				[
					4872,
					-6592
				],
				[
					2191,
					17795
				],
				[
					11358,
					-4586
				],
				[
					18551,
					16261
				],
				[
					18853,
					-1352
				],
				[
					57,
					13282
				],
				[
					11369,
					5813
				],
				[
					9496,
					-15228
				],
				[
					9786,
					-939
				],
				[
					8315,
					7609
				]
			],
			[
				[
					7450853,
					940068
				],
				[
					-1108,
					-140
				]
			],
			[
				[
					7449745,
					939928
				],
				[
					-8971,
					1855
				],
				[
					-11301,
					-11706
				]
			],
			[
				[
					7429473,
					930077
				],
				[
					-311,
					-43
				]
			],
			[
				[
					7429162,
					930034
				],
				[
					-1133,
					14554
				]
			],
			[
				[
					7428029,
					944588
				],
				[
					-407,
					8357
				],
				[
					11054,
					1665
				],
				[
					-1616,
					21596
				],
				[
					6616,
					1379
				]
			],
			[
				[
					7337413,
					1139280
				],
				[
					-5321,
					-17639
				],
				[
					5468,
					-6348
				],
				[
					43027,
					869
				]
			],
			[
				[
					7423842,
					1006182
				],
				[
					-13146,
					-4193
				],
				[
					2167,
					-30983
				],
				[
					-4505,
					-569
				]
			],
			[
				[
					7408358,
					970437
				],
				[
					-12630,
					31116
				],
				[
					-10804,
					-2147
				],
				[
					-175,
					18914
				],
				[
					-19746,
					-260
				],
				[
					-785,
					-31880
				],
				[
					9881,
					1852
				],
				[
					1882,
					-37372
				]
			],
			[
				[
					7375981,
					950660
				],
				[
					-9228,
					-1535
				]
			],
			[
				[
					7366753,
					949125
				],
				[
					-3679,
					-600
				],
				[
					2343,
					-32070
				]
			],
			[
				[
					7365417,
					916455
				],
				[
					1536,
					-19028
				]
			],
			[
				[
					7366953,
					897427
				],
				[
					-1172,
					2071
				]
			],
			[
				[
					7365781,
					899498
				],
				[
					-9233,
					16747
				],
				[
					-11619,
					8252
				],
				[
					-12572,
					1213
				],
				[
					-6873,
					-12246
				]
			],
			[
				[
					7325484,
					913464
				],
				[
					-3897,
					-865
				]
			],
			[
				[
					7321587,
					912599
				],
				[
					-7413,
					-1794
				],
				[
					-15381,
					14289
				]
			],
			[
				[
					7298793,
					925094
				],
				[
					-12474,
					3739
				],
				[
					-7404,
					14444
				]
			],
			[
				[
					7278915,
					943277
				],
				[
					-4357,
					17798
				],
				[
					892,
					13345
				],
				[
					-7215,
					3056
				],
				[
					-1231,
					33261
				],
				[
					-13136,
					6464
				],
				[
					-2202,
					-19833
				]
			],
			[
				[
					7251666,
					997368
				],
				[
					-7995,
					-7202
				],
				[
					-24563,
					21505
				]
			],
			[
				[
					7219108,
					1011671
				],
				[
					-9534,
					26053
				]
			],
			[
				[
					7209574,
					1037724
				],
				[
					1138,
					6107
				],
				[
					-32777,
					36349
				],
				[
					-32137,
					11760
				]
			],
			[
				[
					7145798,
					1091940
				],
				[
					-410,
					16792
				],
				[
					5177,
					19358
				],
				[
					7496,
					12001
				],
				[
					-3805,
					11048
				],
				[
					1584,
					14335
				],
				[
					-2976,
					22176
				],
				[
					-7767,
					8780
				],
				[
					4408,
					15647
				],
				[
					-1366,
					26489
				],
				[
					-7053,
					6753
				],
				[
					5379,
					20048
				],
				[
					-67,
					47931
				]
			],
			[
				[
					7146398,
					1313298
				],
				[
					-1483,
					26630
				],
				[
					-8331,
					8137
				],
				[
					32185,
					-52
				],
				[
					78,
					4757
				],
				[
					24290,
					-21
				],
				[
					-222,
					-34773
				],
				[
					48637,
					115
				]
			],
			[
				[
					7203287,
					1538317
				],
				[
					0,
					0
				]
			],
			[
				[
					7030206,
					2331065
				],
				[
					-1049,
					3597
				]
			],
			[
				[
					7275649,
					1463272
				],
				[
					-9483,
					11069
				],
				[
					5410,
					6843
				],
				[
					3881,
					19611
				],
				[
					8789,
					7010
				],
				[
					-10373,
					15141
				],
				[
					-11345,
					-11728
				],
				[
					-5809,
					-20030
				],
				[
					-7361,
					-2868
				],
				[
					112,
					35427
				],
				[
					-23921,
					-355
				],
				[
					-192,
					36047
				],
				[
					-24966,
					140
				],
				[
					-3539,
					-11476
				],
				[
					-16576,
					-1158
				],
				[
					6611,
					21169
				],
				[
					-8380,
					1882
				],
				[
					52,
					23704
				],
				[
					-58135,
					-138
				],
				[
					-4442,
					-13989
				],
				[
					8539,
					7
				],
				[
					3668,
					-14071
				],
				[
					-70,
					-42489
				],
				[
					-18876,
					-2037
				],
				[
					-5344,
					-7585
				],
				[
					-90,
					-60733
				],
				[
					48432,
					-36
				],
				[
					-2276,
					-23916
				],
				[
					-40361,
					-15574
				],
				[
					-8729,
					9873
				],
				[
					-10169,
					-8846
				],
				[
					-6517,
					1689
				]
			],
			[
				[
					7084189,
					1415855
				],
				[
					2031,
					9283
				],
				[
					-5750,
					9452
				],
				[
					3401,
					17775
				],
				[
					-29114,
					53
				],
				[
					128,
					29484
				],
				[
					6043,
					-918
				],
				[
					3846,
					42300
				],
				[
					-9936,
					71
				]
			],
			[
				[
					7054838,
					1523355
				],
				[
					525,
					52754
				],
				[
					9869,
					17335
				]
			],
			[
				[
					7065232,
					1593444
				],
				[
					2315,
					2
				],
				[
					310,
					34630
				],
				[
					-12071,
					97
				],
				[
					235,
					137353
				],
				[
					-24690,
					-59
				],
				[
					36,
					33073
				],
				[
					10778,
					13838
				],
				[
					695,
					27276
				],
				[
					21443,
					4076
				],
				[
					-7767,
					8054
				],
				[
					12401,
					4274
				],
				[
					12219,
					15341
				],
				[
					14863,
					5193
				],
				[
					52,
					50669
				],
				[
					-9192,
					16339
				],
				[
					-14697,
					9012
				],
				[
					-12394,
					19993
				],
				[
					-11671,
					-10485
				],
				[
					-22471,
					-2502
				],
				[
					-3439,
					5923
				],
				[
					-19697,
					-10320
				],
				[
					-16550,
					-1996
				],
				[
					-6661,
					-23362
				],
				[
					2888,
					-11916
				],
				[
					-3065,
					-38157
				],
				[
					5350,
					-11849
				],
				[
					3683,
					-58228
				],
				[
					-9286,
					-7082
				],
				[
					-21714,
					-1217
				]
			],
			[
				[
					6957135,
					1801414
				],
				[
					7,
					37398
				]
			],
			[
				[
					6957142,
					1838812
				],
				[
					-6,
					411437
				],
				[
					256,
					108841
				]
			],
			[
				[
					6957392,
					2359090
				],
				[
					-2487,
					22485
				],
				[
					6820,
					3215
				],
				[
					18798,
					23219
				],
				[
					9682,
					-4855
				],
				[
					-2709,
					-25951
				],
				[
					16575,
					-773
				],
				[
					13799,
					-17862
				],
				[
					3634,
					-30411
				],
				[
					8699,
					2458
				]
			],
			[
				[
					7042696,
					2365102
				],
				[
					-151,
					2200
				]
			],
			[
				[
					7035624,
					2384191
				],
				[
					-6482,
					17814
				],
				[
					-12652,
					15800
				],
				[
					-5153,
					14212
				],
				[
					15880,
					8821
				],
				[
					6947,
					9437
				],
				[
					-4217,
					15583
				],
				[
					3152,
					9592
				],
				[
					14281,
					7451
				],
				[
					2109,
					17864
				],
				[
					12603,
					11667
				],
				[
					4913,
					14889
				]
			],
			[
				[
					7065489,
					2545218
				],
				[
					-524,
					13533
				],
				[
					6276,
					7318
				],
				[
					777,
					30443
				],
				[
					-9049,
					20590
				],
				[
					-20839,
					6450
				],
				[
					9366,
					8463
				],
				[
					-13415,
					10883
				],
				[
					8008,
					12551
				],
				[
					-15881,
					12721
				],
				[
					18933,
					9675
				],
				[
					-10040,
					7773
				],
				[
					10172,
					15704
				]
			],
			[
				[
					7020688,
					2756148
				],
				[
					5845,
					37597
				],
				[
					-7277,
					3827
				],
				[
					3973,
					18819
				],
				[
					-6371,
					21761
				],
				[
					-11702,
					2021
				],
				[
					-3250,
					10819
				],
				[
					7140,
					7139
				],
				[
					19360,
					6190
				]
			],
			[
				[
					7009270,
					2929543
				],
				[
					-4119,
					15100
				],
				[
					16003,
					2838
				],
				[
					-22401,
					12655
				],
				[
					11661,
					333
				],
				[
					-1928,
					10454
				],
				[
					11278,
					2838
				],
				[
					-15390,
					5353
				],
				[
					5080,
					13034
				],
				[
					695,
					19796
				],
				[
					-22344,
					4347
				],
				[
					-14333,
					-2002
				],
				[
					10360,
					10588
				],
				[
					-22904,
					20350
				],
				[
					3265,
					5918
				],
				[
					-5367,
					18073
				],
				[
					-1098,
					39467
				],
				[
					-7455,
					8773
				],
				[
					-17267,
					7438
				],
				[
					19923,
					21581
				],
				[
					24260,
					8036
				],
				[
					37461,
					19369
				],
				[
					16018,
					15090
				],
				[
					11437,
					1823
				],
				[
					21010,
					12420
				],
				[
					8908,
					9633
				]
			],
			[
				[
					7124711,
					1695834
				],
				[
					-2797,
					-19050
				],
				[
					-16401,
					-199
				],
				[
					459,
					-27763
				],
				[
					23273,
					-79
				],
				[
					1121,
					17508
				],
				[
					21033,
					-195
				],
				[
					68,
					24783
				],
				[
					-11913,
					6949
				],
				[
					-14843,
					-1954
				]
			],
			[
				[
					7006910,
					1599674
				],
				[
					1520,
					-1545
				]
			],
			[
				[
					7008430,
					1598129
				],
				[
					728,
					-1865
				]
			],
			[
				[
					7009158,
					1596264
				],
				[
					-2959,
					-2757
				]
			],
			[
				[
					7006199,
					1593507
				],
				[
					13,
					-17658
				]
			],
			[
				[
					7006212,
					1575849
				],
				[
					-15083,
					-10403
				],
				[
					-2157,
					-17414
				],
				[
					16995,
					-10690
				],
				[
					3166,
					21235
				],
				[
					21436,
					3
				]
			],
			[
				[
					7030569,
					1558580
				],
				[
					5638,
					-11607
				],
				[
					18631,
					-23618
				]
			],
			[
				[
					7084189,
					1415855
				],
				[
					-17026,
					1714
				],
				[
					-70,
					-58159
				],
				[
					7228,
					-9405
				],
				[
					24387,
					-16395
				],
				[
					-3061,
					-20121
				],
				[
					50751,
					-191
				]
			],
			[
				[
					7145798,
					1091940
				],
				[
					-31650,
					16050
				],
				[
					-14767,
					-135
				],
				[
					-5869,
					-5204
				],
				[
					-10318,
					9738
				]
			],
			[
				[
					7083194,
					1112389
				],
				[
					-11209,
					446
				],
				[
					-25517,
					11520
				],
				[
					127,
					9777
				],
				[
					-18735,
					19067
				],
				[
					-10990,
					20973
				],
				[
					-2871,
					18815
				],
				[
					-8945,
					14822
				],
				[
					-8653,
					33033
				],
				[
					-4868,
					1949
				],
				[
					-22211,
					54647
				]
			],
			[
				[
					6969322,
					1297438
				],
				[
					-3711,
					9927
				],
				[
					1827,
					35961
				],
				[
					-2631,
					6548
				]
			],
			[
				[
					6964807,
					1349874
				],
				[
					8813,
					-476
				],
				[
					-2329,
					33708
				],
				[
					-19685,
					-3884
				]
			],
			[
				[
					6951606,
					1379222
				],
				[
					-2226,
					11282
				],
				[
					7850,
					21113
				],
				[
					-72,
					131213
				]
			],
			[
				[
					6957158,
					1542830
				],
				[
					23,
					68180
				]
			],
			[
				[
					6957181,
					1611010
				],
				[
					24612,
					-130
				],
				[
					16461,
					-3282
				],
				[
					48,
					-10526
				],
				[
					8608,
					2602
				]
			],
			[
				[
					7065232,
					1593444
				],
				[
					-41519,
					77
				],
				[
					-4876,
					5266
				],
				[
					19,
					22771
				],
				[
					12186,
					6464
				],
				[
					13,
					34913
				],
				[
					-18329,
					-39
				],
				[
					-854,
					-17325
				],
				[
					-5476,
					-538
				],
				[
					-2,
					-17152
				],
				[
					-49197,
					465
				]
			],
			[
				[
					6957197,
					1628346
				],
				[
					-62,
					173068
				]
			],
			[
				[
					6981885,
					1715371
				],
				[
					2288,
					-7059
				],
				[
					13828,
					1
				],
				[
					8620,
					7103
				],
				[
					-9806,
					20799
				],
				[
					-14891,
					-81
				],
				[
					-39,
					-20763
				]
			],
			[
				[
					7830356,
					803078
				],
				[
					-23488,
					-814
				]
			],
			[
				[
					7822443,
					909809
				],
				[
					-3469,
					-2726
				]
			],
			[
				[
					7818974,
					907083
				],
				[
					-2612,
					184
				]
			],
			[
				[
					7816362,
					907267
				],
				[
					-155,
					-57
				]
			],
			[
				[
					7816207,
					907210
				],
				[
					-5875,
					985
				]
			],
			[
				[
					7809017,
					925799
				],
				[
					7596,
					1220
				]
			],
			[
				[
					7827361,
					903483
				],
				[
					-6973,
					-5695
				]
			],
			[
				[
					7820388,
					897788
				],
				[
					-2196,
					4198
				]
			],
			[
				[
					7818192,
					901986
				],
				[
					-123,
					304
				]
			],
			[
				[
					7818069,
					902290
				],
				[
					905,
					4793
				]
			],
			[
				[
					7818974,
					907083
				],
				[
					8387,
					-3600
				]
			],
			[
				[
					7822945,
					908197
				],
				[
					0,
					0
				]
			],
			[
				[
					7829511,
					897025
				],
				[
					-8252,
					-3411
				]
			],
			[
				[
					7821259,
					893614
				],
				[
					-871,
					4174
				]
			],
			[
				[
					7827361,
					903483
				],
				[
					484,
					386
				]
			],
			[
				[
					7821259,
					893614
				],
				[
					-1783,
					-6161
				]
			],
			[
				[
					7815283,
					886747
				],
				[
					-103,
					3844
				]
			],
			[
				[
					7815180,
					890591
				],
				[
					1619,
					4535
				]
			],
			[
				[
					7816799,
					895126
				],
				[
					1393,
					6860
				]
			],
			[
				[
					7818069,
					902290
				],
				[
					-1707,
					4977
				]
			],
			[
				[
					7816207,
					907210
				],
				[
					-1552,
					-5315
				]
			],
			[
				[
					7814655,
					901895
				],
				[
					-3340,
					1441
				]
			],
			[
				[
					7811315,
					903336
				],
				[
					-980,
					4042
				]
			],
			[
				[
					7816799,
					895126
				],
				[
					-4191,
					-1299
				]
			],
			[
				[
					7812608,
					893827
				],
				[
					-217,
					1126
				]
			],
			[
				[
					7812391,
					894953
				],
				[
					2264,
					6942
				]
			],
			[
				[
					7815180,
					890591
				],
				[
					-2107,
					567
				]
			],
			[
				[
					7813073,
					891158
				],
				[
					0,
					0
				]
			],
			[
				[
					7813073,
					891158
				],
				[
					-465,
					2669
				]
			],
			[
				[
					7812391,
					894953
				],
				[
					-3106,
					983
				]
			],
			[
				[
					7809285,
					895936
				],
				[
					2030,
					7400
				]
			],
			[
				[
					7802808,
					873081
				],
				[
					-7257,
					7727
				]
			],
			[
				[
					7795551,
					880808
				],
				[
					13734,
					15128
				]
			],
			[
				[
					7808040,
					895016
				],
				[
					0,
					0
				]
			],
			[
				[
					7795551,
					880808
				],
				[
					127,
					12661
				]
			],
			[
				[
					7767683,
					1005948
				],
				[
					-12903,
					11042
				]
			],
			[
				[
					7754780,
					1016990
				],
				[
					-783,
					5862
				]
			],
			[
				[
					7753997,
					1022852
				],
				[
					-1388,
					285
				]
			],
			[
				[
					7752609,
					1023137
				],
				[
					-11093,
					13588
				]
			],
			[
				[
					7749988,
					1001370
				],
				[
					9687,
					6846
				],
				[
					7142,
					-3795
				]
			],
			[
				[
					7753191,
					1023263
				],
				[
					0,
					0
				]
			],
			[
				[
					7752609,
					1023137
				],
				[
					73,
					-2696
				]
			],
			[
				[
					7752682,
					1020441
				],
				[
					-2893,
					-71
				]
			],
			[
				[
					7749789,
					1020370
				],
				[
					-3500,
					-5614
				]
			],
			[
				[
					7746289,
					1014756
				],
				[
					2729,
					-7899
				],
				[
					5762,
					10133
				]
			],
			[
				[
					7746289,
					1014756
				],
				[
					3500,
					5614
				]
			],
			[
				[
					7752682,
					1020441
				],
				[
					1315,
					2411
				]
			],
			[
				[
					7732512,
					901992
				],
				[
					-88,
					-3427
				]
			],
			[
				[
					7732424,
					898565
				],
				[
					-8208,
					-5697
				]
			],
			[
				[
					7724216,
					892868
				],
				[
					-97,
					9374
				]
			],
			[
				[
					7724119,
					902242
				],
				[
					8393,
					-250
				]
			],
			[
				[
					7732424,
					898565
				],
				[
					-331,
					-16518
				]
			],
			[
				[
					7732093,
					882047
				],
				[
					-8971,
					707
				]
			],
			[
				[
					7723122,
					882754
				],
				[
					1094,
					10114
				]
			],
			[
				[
					7724119,
					902242
				],
				[
					2529,
					8636
				]
			],
			[
				[
					7723122,
					882754
				],
				[
					-1094,
					57
				]
			],
			[
				[
					7717311,
					871648
				],
				[
					7534,
					-9588
				],
				[
					12186,
					3963
				]
			],
			[
				[
					7707779,
					855015
				],
				[
					-6,
					9343
				]
			],
			[
				[
					7732093,
					882047
				],
				[
					8970,
					-7384
				]
			],
			[
				[
					7707514,
					942393
				],
				[
					-5732,
					15419
				]
			],
			[
				[
					7701782,
					957812
				],
				[
					-12473,
					-6365
				]
			],
			[
				[
					7701782,
					957812
				],
				[
					-5440,
					-19571
				]
			],
			[
				[
					7666244,
					892325
				],
				[
					-1468,
					-9596
				]
			],
			[
				[
					7664776,
					882729
				],
				[
					-2829,
					-2298
				]
			],
			[
				[
					7661947,
					880431
				],
				[
					-2582,
					1790
				]
			],
			[
				[
					7659365,
					882221
				],
				[
					-8755,
					10961
				]
			],
			[
				[
					7650610,
					893182
				],
				[
					111,
					7011
				]
			],
			[
				[
					7650721,
					900193
				],
				[
					15523,
					-7868
				]
			],
			[
				[
					7666793,
					863133
				],
				[
					-2624,
					16244
				]
			],
			[
				[
					7664169,
					879377
				],
				[
					607,
					3352
				]
			],
			[
				[
					7666244,
					892325
				],
				[
					5100,
					-6975
				]
			],
			[
				[
					7659365,
					882221
				],
				[
					-1055,
					-20415
				]
			],
			[
				[
					7650328,
					886233
				],
				[
					282,
					6949
				]
			],
			[
				[
					7664169,
					879377
				],
				[
					-2222,
					1054
				]
			],
			[
				[
					7662410,
					949802
				],
				[
					-626,
					-10510
				]
			],
			[
				[
					7661784,
					939292
				],
				[
					-306,
					-5143
				]
			],
			[
				[
					7661478,
					934149
				],
				[
					-9064,
					3682
				]
			],
			[
				[
					7652414,
					937831
				],
				[
					-1397,
					9721
				]
			],
			[
				[
					7651017,
					947552
				],
				[
					4133,
					10503
				]
			],
			[
				[
					7676700,
					930086
				],
				[
					0,
					0
				]
			],
			[
				[
					7678874,
					939945
				],
				[
					-5758,
					4000
				],
				[
					-4868,
					-14339
				]
			],
			[
				[
					7668248,
					929606
				],
				[
					-6464,
					9686
				]
			],
			[
				[
					7672253,
					923732
				],
				[
					-4005,
					5874
				]
			],
			[
				[
					7657372,
					924433
				],
				[
					0,
					0
				]
			],
			[
				[
					7650721,
					900193
				],
				[
					765,
					4796
				]
			],
			[
				[
					7651486,
					904989
				],
				[
					3551,
					7809
				]
			],
			[
				[
					7655037,
					912798
				],
				[
					182,
					508
				]
			],
			[
				[
					7655219,
					913306
				],
				[
					919,
					3496
				]
			],
			[
				[
					7656138,
					916802
				],
				[
					1829,
					7497
				]
			],
			[
				[
					7657967,
					924299
				],
				[
					6230,
					-7045
				],
				[
					4051,
					12352
				]
			],
			[
				[
					7675296,
					918300
				],
				[
					-3917,
					-8141
				],
				[
					526,
					-18512
				]
			],
			[
				[
					7657967,
					924299
				],
				[
					3511,
					9850
				]
			],
			[
				[
					7673989,
					1037159
				],
				[
					1640,
					6569
				]
			],
			[
				[
					7675629,
					1043728
				],
				[
					2305,
					-5078
				]
			],
			[
				[
					7677971,
					1040403
				],
				[
					2892,
					12824
				]
			],
			[
				[
					7680863,
					1053227
				],
				[
					18998,
					9269
				]
			],
			[
				[
					7699384,
					1062729
				],
				[
					-247,
					376
				]
			],
			[
				[
					7699091,
					1063175
				],
				[
					-152,
					230
				]
			],
			[
				[
					7698137,
					1064563
				],
				[
					-385,
					551
				]
			],
			[
				[
					7697560,
					1065388
				],
				[
					1242,
					-1777
				]
			],
			[
				[
					7698874,
					1063504
				],
				[
					-1413,
					2026
				]
			],
			[
				[
					7675629,
					1043728
				],
				[
					5234,
					9499
				]
			],
			[
				[
					7731131,
					1088648
				],
				[
					677,
					9749
				],
				[
					7722,
					10104
				]
			],
			[
				[
					7656138,
					916802
				],
				[
					-5805,
					13367
				]
			],
			[
				[
					7650333,
					930169
				],
				[
					2081,
					7662
				]
			],
			[
				[
					7651017,
					947552
				],
				[
					-6864,
					11509
				]
			],
			[
				[
					7644153,
					959061
				],
				[
					5747,
					22144
				]
			],
			[
				[
					7655219,
					913306
				],
				[
					-182,
					-508
				]
			],
			[
				[
					7651486,
					904989
				],
				[
					-4483,
					6283
				]
			],
			[
				[
					7647003,
					911272
				],
				[
					-333,
					469
				]
			],
			[
				[
					7646670,
					911741
				],
				[
					-3409,
					4837
				]
			],
			[
				[
					7643261,
					916578
				],
				[
					755,
					3817
				]
			],
			[
				[
					7644016,
					920395
				],
				[
					-1755,
					2118
				]
			],
			[
				[
					7642261,
					922513
				],
				[
					3131,
					4119
				]
			],
			[
				[
					7645392,
					926632
				],
				[
					2619,
					7232
				]
			],
			[
				[
					7648011,
					933864
				],
				[
					2322,
					-3695
				]
			],
			[
				[
					7649855,
					922549
				],
				[
					0,
					0
				]
			],
			[
				[
					7649765,
					922128
				],
				[
					0,
					0
				]
			],
			[
				[
					7650073,
					922144
				],
				[
					0,
					0
				]
			],
			[
				[
					7649789,
					921809
				],
				[
					0,
					0
				]
			],
			[
				[
					7650086,
					921805
				],
				[
					0,
					0
				]
			],
			[
				[
					7649942,
					920300
				],
				[
					0,
					0
				]
			],
			[
				[
					7654596,
					911738
				],
				[
					0,
					0
				]
			],
			[
				[
					7647003,
					911272
				],
				[
					-333,
					469
				]
			],
			[
				[
					7638387,
					941124
				],
				[
					107,
					-48
				]
			],
			[
				[
					7638755,
					941388
				],
				[
					31,
					50
				]
			],
			[
				[
					7638786,
					941438
				],
				[
					-31,
					-50
				]
			],
			[
				[
					7640531,
					942473
				],
				[
					-1406,
					-745
				]
			],
			[
				[
					7639125,
					941728
				],
				[
					1406,
					745
				]
			],
			[
				[
					7648011,
					933864
				],
				[
					-2469,
					593
				]
			],
			[
				[
					7645542,
					934457
				],
				[
					-1964,
					3281
				]
			],
			[
				[
					7643578,
					937738
				],
				[
					-2371,
					3902
				]
			],
			[
				[
					7641207,
					941640
				],
				[
					2946,
					17421
				]
			],
			[
				[
					7643578,
					937738
				],
				[
					-2141,
					-2850
				]
			],
			[
				[
					7641437,
					934888
				],
				[
					-3003,
					-2132
				]
			],
			[
				[
					7638434,
					932756
				],
				[
					-805,
					675
				]
			],
			[
				[
					7637629,
					933431
				],
				[
					3578,
					8209
				]
			],
			[
				[
					7638496,
					940925
				],
				[
					259,
					463
				]
			],
			[
				[
					7638786,
					941438
				],
				[
					339,
					290
				]
			],
			[
				[
					7640531,
					942473
				],
				[
					-2075,
					-1616
				]
			],
			[
				[
					7638434,
					932756
				],
				[
					-1051,
					-4935
				]
			],
			[
				[
					7637383,
					927821
				],
				[
					-197,
					-37
				]
			],
			[
				[
					7637186,
					927784
				],
				[
					-2330,
					1452
				]
			],
			[
				[
					7634856,
					929236
				],
				[
					2773,
					4195
				]
			],
			[
				[
					7637383,
					927821
				],
				[
					-197,
					-37
				]
			],
			[
				[
					7641437,
					934888
				],
				[
					142,
					-4908
				]
			],
			[
				[
					7641579,
					929980
				],
				[
					-1261,
					-4664
				]
			],
			[
				[
					7640318,
					925316
				],
				[
					-2935,
					2505
				]
			],
			[
				[
					7634620,
					926263
				],
				[
					337,
					6
				]
			],
			[
				[
					7633491,
					926297
				],
				[
					865,
					-82
				]
			],
			[
				[
					7640318,
					925316
				],
				[
					-365,
					-2993
				]
			],
			[
				[
					7639953,
					922323
				],
				[
					-783,
					-160
				]
			],
			[
				[
					7639170,
					922163
				],
				[
					-3982,
					3407
				]
			],
			[
				[
					7635188,
					925570
				],
				[
					-332,
					3666
				]
			],
			[
				[
					7641761,
					929691
				],
				[
					3631,
					-3059
				]
			],
			[
				[
					7642261,
					922513
				],
				[
					-2308,
					-190
				]
			],
			[
				[
					7641579,
					929980
				],
				[
					182,
					-289
				]
			],
			[
				[
					7641761,
					929691
				],
				[
					3781,
					4766
				]
			],
			[
				[
					7635731,
					919974
				],
				[
					-30,
					134
				]
			],
			[
				[
					7635669,
					920113
				],
				[
					-10,
					3
				]
			],
			[
				[
					7635815,
					920431
				],
				[
					66,
					-336
				]
			],
			[
				[
					7635881,
					920095
				],
				[
					-150,
					-121
				]
			],
			[
				[
					7636117,
					920302
				],
				[
					-188,
					-174
				]
			],
			[
				[
					7635929,
					920128
				],
				[
					188,
					174
				]
			],
			[
				[
					7639170,
					922163
				],
				[
					-3004,
					-1824
				]
			],
			[
				[
					7636166,
					920339
				],
				[
					-978,
					5231
				]
			],
			[
				[
					7633485,
					918342
				],
				[
					-154,
					-2697
				]
			],
			[
				[
					7636409,
					917935
				],
				[
					103,
					8
				]
			],
			[
				[
					7636512,
					917943
				],
				[
					-103,
					-8
				]
			],
			[
				[
					7636188,
					917916
				],
				[
					-134,
					-12
				]
			],
			[
				[
					7636054,
					917904
				],
				[
					-323,
					2070
				]
			],
			[
				[
					7635881,
					920095
				],
				[
					307,
					-2179
				]
			],
			[
				[
					7636117,
					920302
				],
				[
					-188,
					-174
				]
			],
			[
				[
					7639319,
					921388
				],
				[
					579,
					-4481
				]
			],
			[
				[
					7639898,
					916907
				],
				[
					-3087,
					1062
				]
			],
			[
				[
					7636811,
					917969
				],
				[
					-645,
					2370
				]
			],
			[
				[
					7639170,
					922163
				],
				[
					149,
					-775
				]
			],
			[
				[
					7636996,
					915779
				],
				[
					-86,
					3
				]
			],
			[
				[
					7636910,
					915782
				],
				[
					86,
					-3
				]
			],
			[
				[
					7636743,
					915784
				],
				[
					-117,
					5
				]
			],
			[
				[
					7636626,
					915789
				],
				[
					-572,
					2115
				]
			],
			[
				[
					7636188,
					917916
				],
				[
					555,
					-2132
				]
			],
			[
				[
					7636512,
					917943
				],
				[
					-103,
					-8
				]
			],
			[
				[
					7639898,
					916907
				],
				[
					890,
					-1366
				]
			],
			[
				[
					7640788,
					915541
				],
				[
					-3400,
					225
				]
			],
			[
				[
					7637388,
					915766
				],
				[
					-577,
					2203
				]
			],
			[
				[
					7644016,
					920395
				],
				[
					-4697,
					993
				]
			],
			[
				[
					7643261,
					916578
				],
				[
					-1368,
					201
				]
			],
			[
				[
					7641893,
					916779
				],
				[
					-1105,
					-1238
				]
			],
			[
				[
					7636996,
					915779
				],
				[
					-86,
					3
				]
			],
			[
				[
					7637574,
					911332
				],
				[
					-71,
					-1
				]
			],
			[
				[
					7637503,
					911331
				],
				[
					-877,
					4458
				]
			],
			[
				[
					7636743,
					915784
				],
				[
					831,
					-4452
				]
			],
			[
				[
					7641713,
					912827
				],
				[
					118,
					-2485
				]
			],
			[
				[
					7641831,
					910342
				],
				[
					-3563,
					1002
				]
			],
			[
				[
					7638268,
					911344
				],
				[
					-880,
					4422
				]
			],
			[
				[
					7641893,
					916779
				],
				[
					-180,
					-3952
				]
			],
			[
				[
					7638103,
					904922
				],
				[
					-254,
					179
				]
			],
			[
				[
					7637849,
					905101
				],
				[
					254,
					-179
				]
			],
			[
				[
					7637728,
					905184
				],
				[
					-67,
					28
				]
			],
			[
				[
					7637661,
					905212
				],
				[
					-158,
					6119
				]
			],
			[
				[
					7637574,
					911332
				],
				[
					154,
					-6148
				]
			],
			[
				[
					7641831,
					910342
				],
				[
					-1590,
					-5953
				]
			],
			[
				[
					7640241,
					904389
				],
				[
					-1399,
					247
				]
			],
			[
				[
					7638842,
					904636
				],
				[
					-574,
					6708
				]
			],
			[
				[
					7643614,
					902389
				],
				[
					-3373,
					2000
				]
			],
			[
				[
					7641713,
					912827
				],
				[
					1901,
					-10438
				]
			],
			[
				[
					7650721,
					900193
				],
				[
					-7107,
					2196
				]
			],
			[
				[
					7625796,
					895936
				],
				[
					6012,
					-2110
				]
			],
			[
				[
					7631808,
					893826
				],
				[
					3853,
					-5392
				]
			],
			[
				[
					7635661,
					888434
				],
				[
					261,
					-6060
				]
			],
			[
				[
					7621165,
					885730
				],
				[
					-1321,
					6952
				]
			],
			[
				[
					7633834,
					897258
				],
				[
					1827,
					-8824
				]
			],
			[
				[
					7631808,
					893826
				],
				[
					1597,
					3832
				]
			],
			[
				[
					7633405,
					897658
				],
				[
					429,
					-400
				]
			],
			[
				[
					7626358,
					898419
				],
				[
					7047,
					-761
				]
			],
			[
				[
					7634145,
					898945
				],
				[
					-27,
					-149
				]
			],
			[
				[
					7634118,
					898796
				],
				[
					27,
					149
				]
			],
			[
				[
					7634218,
					899350
				],
				[
					-25,
					-136
				]
			],
			[
				[
					7634193,
					899214
				],
				[
					-7791,
					-606
				]
			],
			[
				[
					7626561,
					899286
				],
				[
					7657,
					64
				]
			],
			[
				[
					7592475,
					1014126
				],
				[
					10753,
					-15556
				]
			],
			[
				[
					7603228,
					998570
				],
				[
					-1977,
					-965
				]
			],
			[
				[
					7591296,
					985335
				],
				[
					-3903,
					5807
				]
			],
			[
				[
					7587393,
					991142
				],
				[
					-2968,
					4163
				]
			],
			[
				[
					7584425,
					995305
				],
				[
					-5756,
					8070
				]
			],
			[
				[
					7577605,
					1005107
				],
				[
					14870,
					9019
				]
			],
			[
				[
					7567761,
					988891
				],
				[
					7836,
					-5297
				]
			],
			[
				[
					7575597,
					983594
				],
				[
					-7089,
					-14198
				],
				[
					-10311,
					493
				]
			],
			[
				[
					7558197,
					969889
				],
				[
					84,
					735
				]
			],
			[
				[
					7579490,
					984299
				],
				[
					74,
					-2104
				]
			],
			[
				[
					7579564,
					982195
				],
				[
					-3967,
					1399
				]
			],
			[
				[
					7572962,
					1005304
				],
				[
					6528,
					-21005
				]
			],
			[
				[
					7615447,
					994619
				],
				[
					-12219,
					3951
				]
			],
			[
				[
					7592475,
					1014126
				],
				[
					2061,
					995
				]
			],
			[
				[
					7634145,
					898945
				],
				[
					-27,
					-149
				]
			],
			[
				[
					7633834,
					897258
				],
				[
					5008,
					7378
				]
			],
			[
				[
					7638103,
					904922
				],
				[
					-254,
					179
				]
			],
			[
				[
					7634218,
					899350
				],
				[
					3443,
					5862
				]
			],
			[
				[
					7637728,
					905184
				],
				[
					-3535,
					-5970
				]
			],
			[
				[
					7665271,
					1018710
				],
				[
					-6044,
					-13579
				]
			],
			[
				[
					7659227,
					1005131
				],
				[
					-9109,
					13780
				]
			],
			[
				[
					7710116,
					1102375
				],
				[
					-9979,
					-10128
				]
			],
			[
				[
					7659227,
					1005131
				],
				[
					-9876,
					-15301
				]
			],
			[
				[
					7649351,
					989830
				],
				[
					-4541,
					527
				]
			],
			[
				[
					7644810,
					990357
				],
				[
					-1227,
					-2929
				]
			],
			[
				[
					7643583,
					987428
				],
				[
					-5396,
					9263
				]
			],
			[
				[
					7638187,
					996691
				],
				[
					5664,
					14390
				],
				[
					-3896,
					5731
				]
			],
			[
				[
					7638187,
					996691
				],
				[
					-3236,
					-4674
				]
			],
			[
				[
					7634951,
					992017
				],
				[
					-5933,
					6642
				]
			],
			[
				[
					7649351,
					989830
				],
				[
					-3126,
					-7212
				]
			],
			[
				[
					7646225,
					982618
				],
				[
					-1415,
					7739
				]
			],
			[
				[
					7643583,
					987428
				],
				[
					-3568,
					-14600
				]
			],
			[
				[
					7640015,
					972828
				],
				[
					-701,
					-62
				]
			],
			[
				[
					7639314,
					972766
				],
				[
					-7815,
					3534
				]
			],
			[
				[
					7631499,
					976300
				],
				[
					3452,
					15717
				]
			],
			[
				[
					7646225,
					982618
				],
				[
					-6210,
					-9790
				]
			],
			[
				[
					7616650,
					881725
				],
				[
					-1511,
					930
				]
			],
			[
				[
					7615139,
					882655
				],
				[
					-5566,
					1391
				]
			],
			[
				[
					7609573,
					884046
				],
				[
					-5398,
					-10093
				]
			],
			[
				[
					7602691,
					876223
				],
				[
					4399,
					13594
				]
			],
			[
				[
					7607090,
					889817
				],
				[
					9799,
					11179
				]
			],
			[
				[
					7608883,
					883361
				],
				[
					0,
					0
				]
			],
			[
				[
					7616903,
					901247
				],
				[
					3,
					66
				]
			],
			[
				[
					7615139,
					882655
				],
				[
					-5566,
					1391
				]
			],
			[
				[
					7589693,
					873404
				],
				[
					-157,
					135
				]
			],
			[
				[
					7586481,
					865256
				],
				[
					-302,
					2365
				]
			],
			[
				[
					7589501,
					873569
				],
				[
					-3020,
					-8313
				]
			],
			[
				[
					7591631,
					876846
				],
				[
					34,
					-14
				]
			],
			[
				[
					7591851,
					876750
				],
				[
					159,
					-78
				]
			],
			[
				[
					7591301,
					877124
				],
				[
					-33,
					-176
				]
			],
			[
				[
					7591460,
					876913
				],
				[
					136,
					-51
				]
			],
			[
				[
					7586818,
					862581
				],
				[
					-40,
					287
				]
			],
			[
				[
					7586778,
					862868
				],
				[
					4240,
					9437
				]
			],
			[
				[
					7592241,
					876566
				],
				[
					14849,
					13251
				]
			],
			[
				[
					7586576,
					862436
				],
				[
					202,
					432
				]
			],
			[
				[
					7586481,
					865256
				],
				[
					-2810,
					-4594
				]
			],
			[
				[
					7574056,
					854648
				],
				[
					-8688,
					7649
				]
			],
			[
				[
					7565368,
					862297
				],
				[
					19170,
					13725
				]
			],
			[
				[
					7563471,
					854800
				],
				[
					7937,
					-2419
				]
			],
			[
				[
					7574035,
					854631
				],
				[
					-8667,
					7666
				]
			],
			[
				[
					7628367,
					967472
				],
				[
					3224,
					1786
				]
			],
			[
				[
					7639314,
					972766
				],
				[
					-10322,
					-4225
				]
			],
			[
				[
					7628992,
					968541
				],
				[
					283,
					5755
				]
			],
			[
				[
					7629275,
					974296
				],
				[
					2224,
					2004
				]
			],
			[
				[
					7628992,
					968541
				],
				[
					-8477,
					-291
				]
			],
			[
				[
					7620515,
					968250
				],
				[
					-1673,
					-308
				]
			],
			[
				[
					7618842,
					967942
				],
				[
					29,
					246
				]
			],
			[
				[
					7618871,
					968188
				],
				[
					-8,
					681
				]
			],
			[
				[
					7618863,
					968869
				],
				[
					1239,
					6729
				]
			],
			[
				[
					7620102,
					975598
				],
				[
					1841,
					-562
				]
			],
			[
				[
					7621943,
					975036
				],
				[
					7332,
					-740
				]
			],
			[
				[
					7617424,
					971694
				],
				[
					0,
					0
				]
			],
			[
				[
					7617120,
					972020
				],
				[
					0,
					0
				]
			],
			[
				[
					7618863,
					968869
				],
				[
					8,
					-681
				]
			],
			[
				[
					7618842,
					967942
				],
				[
					-10466,
					4883
				]
			],
			[
				[
					7611699,
					982456
				],
				[
					3643,
					-1702
				]
			],
			[
				[
					7615342,
					980754
				],
				[
					1529,
					-2174
				]
			],
			[
				[
					7616871,
					978580
				],
				[
					3231,
					-2982
				]
			],
			[
				[
					7620515,
					968250
				],
				[
					-10481,
					-6092
				]
			],
			[
				[
					7610034,
					962158
				],
				[
					-4814,
					3390
				]
			],
			[
				[
					7605220,
					965548
				],
				[
					-2254,
					3184
				]
			],
			[
				[
					7602966,
					968732
				],
				[
					-4254,
					5919
				]
			],
			[
				[
					7610034,
					962158
				],
				[
					-2727,
					-4730
				]
			],
			[
				[
					7607307,
					957428
				],
				[
					-2032,
					2529
				]
			],
			[
				[
					7605275,
					959957
				],
				[
					-2141,
					2170
				]
			],
			[
				[
					7603134,
					962127
				],
				[
					2086,
					3421
				]
			],
			[
				[
					7607307,
					957428
				],
				[
					-4505,
					-7696
				]
			],
			[
				[
					7602802,
					949732
				],
				[
					-1611,
					2203
				]
			],
			[
				[
					7601191,
					951935
				],
				[
					1286,
					3680
				]
			],
			[
				[
					7602477,
					955615
				],
				[
					2798,
					4342
				]
			],
			[
				[
					7602477,
					955615
				],
				[
					-3053,
					4420
				]
			],
			[
				[
					7599424,
					960035
				],
				[
					101,
					154
				]
			],
			[
				[
					7599525,
					960189
				],
				[
					3609,
					1938
				]
			],
			[
				[
					7602966,
					968732
				],
				[
					-3441,
					-8543
				]
			],
			[
				[
					7599424,
					960035
				],
				[
					-4597,
					-1453
				]
			],
			[
				[
					7594827,
					958582
				],
				[
					-5075,
					7224
				],
				[
					8559,
					9402
				]
			],
			[
				[
					7596421,
					947616
				],
				[
					0,
					0
				]
			],
			[
				[
					7601191,
					951935
				],
				[
					-1778,
					-88
				]
			],
			[
				[
					7599413,
					951847
				],
				[
					-7776,
					-485
				]
			],
			[
				[
					7591637,
					951362
				],
				[
					-1646,
					2565
				]
			],
			[
				[
					7589991,
					953927
				],
				[
					4836,
					4655
				]
			],
			[
				[
					7599663,
					940757
				],
				[
					-135,
					263
				]
			],
			[
				[
					7599528,
					941020
				],
				[
					135,
					-263
				]
			],
			[
				[
					7599413,
					941245
				],
				[
					-2574,
					3842
				]
			],
			[
				[
					7596839,
					945087
				],
				[
					2574,
					6760
				]
			],
			[
				[
					7602802,
					949732
				],
				[
					-3389,
					-8487
				]
			],
			[
				[
					7596839,
					945087
				],
				[
					-233,
					-601
				]
			],
			[
				[
					7596606,
					944486
				],
				[
					-3600,
					4992
				]
			],
			[
				[
					7593006,
					949478
				],
				[
					-1369,
					1884
				]
			],
			[
				[
					7589991,
					953927
				],
				[
					-13527,
					10679
				],
				[
					7542,
					12088
				],
				[
					-4442,
					5501
				]
			],
			[
				[
					7579490,
					984299
				],
				[
					743,
					254
				]
			],
			[
				[
					7580233,
					984553
				],
				[
					7160,
					6589
				]
			],
			[
				[
					7624256,
					981603
				],
				[
					0,
					0
				]
			],
			[
				[
					7621943,
					975036
				],
				[
					-5072,
					3544
				]
			],
			[
				[
					7615342,
					980754
				],
				[
					1373,
					11508
				]
			],
			[
				[
					7593006,
					949478
				],
				[
					-14366,
					-11802
				]
			],
			[
				[
					7555382,
					945405
				],
				[
					-4414,
					20824
				],
				[
					7229,
					3660
				]
			],
			[
				[
					7599663,
					940757
				],
				[
					-135,
					263
				]
			],
			[
				[
					7594193,
					935563
				],
				[
					2413,
					8923
				]
			],
			[
				[
					7599413,
					941245
				],
				[
					-5220,
					-5682
				]
			],
			[
				[
					7595997,
					938804
				],
				[
					0,
					0
				]
			],
			[
				[
					7594193,
					935563
				],
				[
					-2578,
					-6973
				]
			],
			[
				[
					7583144,
					878496
				],
				[
					-16676,
					-3810
				]
			],
			[
				[
					7566382,
					874902
				],
				[
					-104,
					262
				]
			],
			[
				[
					7555352,
					904714
				],
				[
					5442,
					4474
				]
			],
			[
				[
					7563247,
					907599
				],
				[
					18849,
					-26364
				]
			],
			[
				[
					7586824,
					897092
				],
				[
					10700,
					-8700
				],
				[
					-15536,
					-631
				],
				[
					4836,
					9331
				]
			],
			[
				[
					7584054,
					892538
				],
				[
					0,
					0
				]
			],
			[
				[
					7584901,
					892294
				],
				[
					0,
					0
				]
			],
			[
				[
					7573157,
					907252
				],
				[
					11476,
					-25828
				]
			],
			[
				[
					7558781,
					862587
				],
				[
					-38,
					48
				]
			],
			[
				[
					7558879,
					863478
				],
				[
					-1754,
					-1225
				]
			],
			[
				[
					7584425,
					995305
				],
				[
					-4192,
					-10752
				]
			],
			[
				[
					7570933,
					1026799
				],
				[
					10170,
					14433
				]
			],
			[
				[
					7518561,
					1050808
				],
				[
					23,
					165
				]
			],
			[
				[
					7531843,
					982057
				],
				[
					12440,
					-3057
				],
				[
					-4952,
					-27750
				]
			],
			[
				[
					7536390,
					938173
				],
				[
					-11447,
					5562
				]
			],
			[
				[
					7524943,
					943735
				],
				[
					-6465,
					2306
				]
			],
			[
				[
					7428029,
					944588
				],
				[
					-4585,
					-8496
				],
				[
					-15434,
					-5251
				]
			],
			[
				[
					7408010,
					930841
				],
				[
					-1094,
					5390
				]
			],
			[
				[
					7406916,
					936231
				],
				[
					-1787,
					33380
				],
				[
					3229,
					826
				]
			],
			[
				[
					7429162,
					930034
				],
				[
					-15443,
					-5919
				]
			],
			[
				[
					7413719,
					924115
				],
				[
					-4953,
					-3736
				]
			],
			[
				[
					7408766,
					920379
				],
				[
					-756,
					10462
				]
			],
			[
				[
					7406916,
					936231
				],
				[
					-16061,
					-2901
				]
			],
			[
				[
					7390855,
					933330
				],
				[
					-1202,
					21451
				],
				[
					-13672,
					-4121
				]
			],
			[
				[
					7406857,
					918638
				],
				[
					-3146,
					-3105
				]
			],
			[
				[
					7403711,
					915533
				],
				[
					-6431,
					-1899
				]
			],
			[
				[
					7397280,
					913634
				],
				[
					-4271,
					-1315
				]
			],
			[
				[
					7393009,
					912319
				],
				[
					-1438,
					-608
				]
			],
			[
				[
					7391571,
					911711
				],
				[
					-566,
					7049
				]
			],
			[
				[
					7391005,
					918760
				],
				[
					13672,
					4559
				],
				[
					2180,
					-4681
				]
			],
			[
				[
					7403211,
					921973
				],
				[
					0,
					0
				]
			],
			[
				[
					7387387,
					925440
				],
				[
					0,
					0
				]
			],
			[
				[
					7408766,
					920379
				],
				[
					-213,
					-177
				]
			],
			[
				[
					7408553,
					920202
				],
				[
					-1696,
					-1564
				]
			],
			[
				[
					7391005,
					918760
				],
				[
					-721,
					509
				]
			],
			[
				[
					7390284,
					919269
				],
				[
					-94,
					3017
				]
			],
			[
				[
					7390190,
					922286
				],
				[
					1355,
					662
				]
			],
			[
				[
					7391545,
					922948
				],
				[
					-690,
					10382
				]
			],
			[
				[
					7390190,
					922286
				],
				[
					94,
					-3017
				]
			],
			[
				[
					7391571,
					911711
				],
				[
					-1683,
					-1901
				]
			],
			[
				[
					7389888,
					909810
				],
				[
					-2682,
					1134
				]
			],
			[
				[
					7387206,
					910944
				],
				[
					-1006,
					1349
				]
			],
			[
				[
					7386200,
					912293
				],
				[
					-2086,
					3373
				]
			],
			[
				[
					7384114,
					915666
				],
				[
					-605,
					2376
				]
			],
			[
				[
					7383509,
					918042
				],
				[
					8036,
					4906
				]
			],
			[
				[
					7383509,
					918042
				],
				[
					-16756,
					31083
				]
			],
			[
				[
					7389888,
					909810
				],
				[
					-808,
					-2101
				]
			],
			[
				[
					7389080,
					907709
				],
				[
					-474,
					-3477
				]
			],
			[
				[
					7388606,
					904232
				],
				[
					-1104,
					-1822
				]
			],
			[
				[
					7387502,
					902410
				],
				[
					-547,
					-238
				]
			],
			[
				[
					7386955,
					902172
				],
				[
					251,
					8772
				]
			],
			[
				[
					7386955,
					902172
				],
				[
					-422,
					-1116
				]
			],
			[
				[
					7386533,
					901056
				],
				[
					-7803,
					10251
				]
			],
			[
				[
					7378730,
					911307
				],
				[
					1125,
					161
				]
			],
			[
				[
					7379855,
					911468
				],
				[
					6345,
					825
				]
			],
			[
				[
					7379855,
					911468
				],
				[
					4259,
					4198
				]
			],
			[
				[
					7386533,
					901056
				],
				[
					-749,
					56
				]
			],
			[
				[
					7385784,
					901112
				],
				[
					-3497,
					-1700
				]
			],
			[
				[
					7382287,
					899412
				],
				[
					-1457,
					-3373
				]
			],
			[
				[
					7380830,
					896039
				],
				[
					-727,
					-1345
				]
			],
			[
				[
					7380103,
					894694
				],
				[
					-2045,
					-2890
				]
			],
			[
				[
					7378058,
					891804
				],
				[
					3822,
					9094
				]
			],
			[
				[
					7381880,
					900898
				],
				[
					-3150,
					10409
				]
			],
			[
				[
					7378730,
					911307
				],
				[
					-13313,
					5148
				]
			],
			[
				[
					7383851,
					1153284
				],
				[
					4524,
					-5778
				]
			],
			[
				[
					7378058,
					891804
				],
				[
					-2354,
					-1357
				]
			],
			[
				[
					7375704,
					890447
				],
				[
					-4447,
					2410
				]
			],
			[
				[
					7371257,
					892857
				],
				[
					-2217,
					2164
				]
			],
			[
				[
					7369040,
					895021
				],
				[
					12840,
					5877
				]
			],
			[
				[
					7369040,
					895021
				],
				[
					-2087,
					2406
				]
			],
			[
				[
					6964807,
					1349874
				],
				[
					-13201,
					29348
				]
			],
			[
				[
					7010450,
					1598733
				],
				[
					-1292,
					-2469
				]
			],
			[
				[
					7008430,
					1598129
				],
				[
					2020,
					604
				]
			],
			[
				[
					7010450,
					1598733
				],
				[
					-3540,
					941
				]
			],
			[
				[
					6957181,
					1611010
				],
				[
					16,
					17336
				]
			],
			[
				[
					7030569,
					1558580
				],
				[
					171,
					10267
				],
				[
					-7760,
					6172
				],
				[
					-16768,
					830
				]
			],
			[
				[
					7006199,
					1593507
				],
				[
					4251,
					5226
				]
			],
			[
				[
					7321861,
					830508
				],
				[
					518,
					-9690
				]
			],
			[
				[
					7322379,
					820818
				],
				[
					-518,
					9690
				]
			],
			[
				[
					7321587,
					912599
				],
				[
					-2060,
					-6851
				],
				[
					-8711,
					6021
				],
				[
					-8733,
					-3278
				],
				[
					-7515,
					7665
				]
			],
			[
				[
					7294568,
					916156
				],
				[
					4225,
					8938
				]
			],
			[
				[
					7321861,
					830508
				],
				[
					-10128,
					-4494
				],
				[
					-3890,
					11053
				],
				[
					-16604,
					5941
				],
				[
					-6569,
					14858
				]
			],
			[
				[
					7284670,
					857866
				],
				[
					13234,
					17458
				],
				[
					-8033,
					18230
				]
			],
			[
				[
					7289871,
					893554
				],
				[
					9378,
					5172
				],
				[
					4700,
					-15569
				],
				[
					12705,
					18561
				],
				[
					6588,
					-11687
				],
				[
					6015,
					7928
				],
				[
					-3773,
					15505
				]
			],
			[
				[
					7365781,
					899498
				],
				[
					-5076,
					-7059
				]
			],
			[
				[
					7360705,
					892439
				],
				[
					-1361,
					1750
				]
			],
			[
				[
					7359344,
					894189
				],
				[
					-2760,
					1625
				]
			],
			[
				[
					7356584,
					895814
				],
				[
					-8297,
					284
				],
				[
					8563,
					-13480
				],
				[
					4320,
					1458
				]
			],
			[
				[
					7361170,
					884076
				],
				[
					1564,
					-3046
				]
			],
			[
				[
					7362734,
					881030
				],
				[
					121,
					-8680
				]
			],
			[
				[
					7362855,
					872350
				],
				[
					-6776,
					-15805
				],
				[
					6094,
					-15960
				],
				[
					10095,
					20612
				]
			],
			[
				[
					7372268,
					861197
				],
				[
					5127,
					4369
				]
			],
			[
				[
					7377395,
					865566
				],
				[
					2323,
					-8464
				],
				[
					7933,
					1583
				]
			],
			[
				[
					7387651,
					858685
				],
				[
					7877,
					-10866
				],
				[
					1582,
					-16998
				]
			],
			[
				[
					7397110,
					830821
				],
				[
					-1031,
					-10306
				],
				[
					-6749,
					1402
				],
				[
					-13100,
					-22719
				],
				[
					-8047,
					9591
				]
			],
			[
				[
					7368183,
					808789
				],
				[
					-13910,
					11549
				],
				[
					-9340,
					-3924
				]
			],
			[
				[
					7344933,
					816414
				],
				[
					-1561,
					5900
				],
				[
					8154,
					14892
				],
				[
					-6789,
					-458
				],
				[
					-9830,
					12002
				],
				[
					-13046,
					-18242
				]
			],
			[
				[
					7456308,
					940661
				],
				[
					3734,
					-10184
				],
				[
					-6985,
					-3976
				],
				[
					5335,
					-23184
				],
				[
					13947,
					-3773
				]
			],
			[
				[
					7472339,
					899544
				],
				[
					482,
					-18833
				],
				[
					-6506,
					-3999
				],
				[
					2641,
					-9356
				],
				[
					-9366,
					-5576
				],
				[
					2668,
					-6457
				],
				[
					-6509,
					-12511
				],
				[
					-9672,
					-7734
				],
				[
					-3975,
					9494
				],
				[
					-10826,
					-5006
				]
			],
			[
				[
					7431276,
					839566
				],
				[
					3150,
					20933
				],
				[
					-3312,
					12365
				],
				[
					-11079,
					3052
				],
				[
					4817,
					-19486
				],
				[
					-1950,
					-6849
				]
			],
			[
				[
					7422902,
					849581
				],
				[
					-5086,
					-4715
				],
				[
					1846,
					-15186
				]
			],
			[
				[
					7419662,
					829680
				],
				[
					-11026,
					-11830
				],
				[
					-3047,
					4515
				]
			],
			[
				[
					7405589,
					822365
				],
				[
					-7343,
					5437
				]
			],
			[
				[
					7398246,
					827802
				],
				[
					2719,
					22354
				]
			],
			[
				[
					7400965,
					850156
				],
				[
					8710,
					2793
				],
				[
					-1827,
					18797
				]
			],
			[
				[
					7407848,
					871746
				],
				[
					3226,
					2857
				],
				[
					-4679,
					18293
				]
			],
			[
				[
					7406395,
					892896
				],
				[
					1899,
					10014
				]
			],
			[
				[
					7408294,
					902910
				],
				[
					5194,
					-1129
				]
			],
			[
				[
					7413488,
					901781
				],
				[
					11797,
					-11567
				],
				[
					15035,
					-1744
				],
				[
					-4020,
					15776
				],
				[
					-7913,
					-1852
				],
				[
					-2498,
					9832
				]
			],
			[
				[
					7425889,
					912226
				],
				[
					7308,
					4512
				]
			],
			[
				[
					7433197,
					916738
				],
				[
					1112,
					7902
				],
				[
					16790,
					9781
				],
				[
					-1354,
					5507
				]
			],
			[
				[
					7510581,
					953619
				],
				[
					-3724,
					-13102
				],
				[
					15641,
					-6321
				],
				[
					2445,
					9539
				]
			],
			[
				[
					7530167,
					886401
				],
				[
					-6813,
					-11388
				],
				[
					-15666,
					25072
				],
				[
					-6168,
					-5698
				],
				[
					-5050,
					12553
				],
				[
					-8248,
					-8145
				],
				[
					-8570,
					5241
				],
				[
					-7313,
					-4492
				]
			],
			[
				[
					7491875,
					802720
				],
				[
					41,
					-101
				]
			],
			[
				[
					7491916,
					802619
				],
				[
					-41,
					101
				]
			],
			[
				[
					7421353,
					811238
				],
				[
					0,
					0
				]
			],
			[
				[
					7509489,
					813380
				],
				[
					0,
					0
				]
			],
			[
				[
					7542426,
					850029
				],
				[
					-12555,
					-12030
				],
				[
					-12442,
					-23737
				]
			],
			[
				[
					7517429,
					814262
				],
				[
					-2893,
					7707
				],
				[
					-11362,
					-6106
				],
				[
					6,
					14818
				],
				[
					-7286,
					-13999
				]
			],
			[
				[
					7495894,
					816682
				],
				[
					-3635,
					-3298
				]
			],
			[
				[
					7492259,
					813384
				],
				[
					-254,
					-5080
				]
			],
			[
				[
					7492005,
					808304
				],
				[
					-230,
					-4220
				]
			],
			[
				[
					7491775,
					804084
				],
				[
					-11049,
					3044
				],
				[
					-11724,
					-8878
				],
				[
					-27930,
					-28245
				]
			],
			[
				[
					7441072,
					770005
				],
				[
					-12236,
					32754
				],
				[
					2151,
					12471
				],
				[
					-7002,
					-5566
				],
				[
					866,
					14203
				],
				[
					-5189,
					5813
				]
			],
			[
				[
					7422902,
					849581
				],
				[
					8374,
					-10015
				]
			],
			[
				[
					7377507,
					720510
				],
				[
					1972,
					2674
				]
			],
			[
				[
					7379479,
					723184
				],
				[
					-1972,
					-2674
				]
			],
			[
				[
					7334387,
					753345
				],
				[
					0,
					0
				]
			],
			[
				[
					7377507,
					720510
				],
				[
					-4846,
					-7443
				],
				[
					12641,
					-6550
				],
				[
					-5934,
					-23228
				]
			],
			[
				[
					7379368,
					683289
				],
				[
					-17246,
					-33406
				],
				[
					-17816,
					-6681
				]
			],
			[
				[
					7344306,
					643202
				],
				[
					-1750,
					11836
				]
			],
			[
				[
					7342556,
					655038
				],
				[
					3859,
					1037
				],
				[
					-1817,
					26146
				],
				[
					-11227,
					-8816
				],
				[
					-5657,
					8154
				]
			],
			[
				[
					7327714,
					681559
				],
				[
					12000,
					22119
				],
				[
					3509,
					32251
				],
				[
					8988,
					11582
				]
			],
			[
				[
					7352211,
					747511
				],
				[
					3590,
					4851
				]
			],
			[
				[
					7355801,
					752362
				],
				[
					7744,
					-9056
				],
				[
					2031,
					6342
				],
				[
					11931,
					-29138
				]
			],
			[
				[
					7379102,
					699525
				],
				[
					0,
					0
				]
			],
			[
				[
					7379573,
					699572
				],
				[
					0,
					0
				]
			],
			[
				[
					7333467,
					673746
				],
				[
					0,
					0
				]
			],
			[
				[
					7441072,
					770005
				],
				[
					-21260,
					-23617
				],
				[
					-21628,
					-34882
				]
			],
			[
				[
					7398184,
					711506
				],
				[
					-6237,
					37325
				]
			],
			[
				[
					7391947,
					748831
				],
				[
					5357,
					16539
				],
				[
					-2294,
					5769
				],
				[
					15231,
					16651
				],
				[
					-473,
					11484
				],
				[
					-8169,
					19963
				],
				[
					3990,
					3128
				]
			],
			[
				[
					7348627,
					760170
				],
				[
					0,
					0
				]
			],
			[
				[
					7327714,
					681559
				],
				[
					-2337,
					-3908
				],
				[
					-29746,
					55633
				],
				[
					8033,
					11763
				]
			],
			[
				[
					7303664,
					745047
				],
				[
					5932,
					5921
				],
				[
					12559,
					-21804
				],
				[
					8002,
					12137
				],
				[
					8685,
					26606
				],
				[
					4597,
					597
				]
			],
			[
				[
					7343439,
					768504
				],
				[
					8772,
					-20993
				]
			],
			[
				[
					7391947,
					748831
				],
				[
					-12468,
					-25647
				]
			],
			[
				[
					7355801,
					752362
				],
				[
					-1729,
					7302
				],
				[
					14109,
					26279
				],
				[
					2,
					22846
				]
			],
			[
				[
					7397110,
					830821
				],
				[
					1136,
					-3019
				]
			],
			[
				[
					7322379,
					820818
				],
				[
					5784,
					-14720
				]
			],
			[
				[
					7328163,
					806098
				],
				[
					-7246,
					-17219
				],
				[
					-16009,
					-20682
				]
			],
			[
				[
					7304908,
					768197
				],
				[
					-8009,
					-2363
				],
				[
					-12402,
					6973
				],
				[
					-16484,
					62057
				]
			],
			[
				[
					7268013,
					834864
				],
				[
					16657,
					23002
				]
			],
			[
				[
					7299676,
					770448
				],
				[
					0,
					0
				]
			],
			[
				[
					7282540,
					605543
				],
				[
					-6355,
					-20579
				],
				[
					-12293,
					7727
				],
				[
					18648,
					12852
				]
			],
			[
				[
					7334317,
					616729
				],
				[
					-17184,
					-13341
				],
				[
					-11286,
					-19437
				],
				[
					-8816,
					13774
				],
				[
					9927,
					13545
				],
				[
					10323,
					5259
				],
				[
					4956,
					-5454
				],
				[
					12080,
					5654
				]
			],
			[
				[
					7304908,
					768197
				],
				[
					-9427,
					-7244
				],
				[
					3019,
					-14015
				],
				[
					5164,
					-1891
				]
			],
			[
				[
					7342556,
					655038
				],
				[
					-10068,
					-5566
				],
				[
					537,
					21326
				],
				[
					-6034,
					-1541
				],
				[
					1475,
					-30012
				],
				[
					-10821,
					-2001
				]
			],
			[
				[
					7317645,
					637244
				],
				[
					-1711,
					12007
				],
				[
					-13859,
					-21805
				],
				[
					-12152,
					8609
				],
				[
					-896,
					-4818
				]
			],
			[
				[
					7289027,
					631237
				],
				[
					-9431,
					-3193
				]
			],
			[
				[
					7279596,
					628044
				],
				[
					1164,
					-3632
				]
			],
			[
				[
					7280760,
					624412
				],
				[
					689,
					-2188
				]
			],
			[
				[
					7281449,
					622224
				],
				[
					-1505,
					-7965
				]
			],
			[
				[
					7279944,
					614259
				],
				[
					-106,
					-3321
				]
			],
			[
				[
					7279838,
					610938
				],
				[
					-12288,
					-7467
				],
				[
					-18422,
					-20541
				],
				[
					-9420,
					-5496
				]
			],
			[
				[
					7239708,
					577434
				],
				[
					11582,
					8708
				],
				[
					3693,
					10397
				]
			],
			[
				[
					7254983,
					596539
				],
				[
					19,
					10
				]
			],
			[
				[
					7255002,
					596549
				],
				[
					-1990,
					4336
				]
			],
			[
				[
					7253012,
					600885
				],
				[
					-3233,
					1629
				]
			],
			[
				[
					7249779,
					602514
				],
				[
					14894,
					9363
				],
				[
					-8867,
					13724
				],
				[
					10420,
					1107
				],
				[
					-4552,
					11440
				]
			],
			[
				[
					7261674,
					638148
				],
				[
					10990,
					11404
				],
				[
					-22168,
					63778
				],
				[
					-31998,
					-17239
				],
				[
					-9145,
					39855
				],
				[
					-2883,
					-1580
				],
				[
					-7615,
					30114
				],
				[
					-4919,
					-1711
				]
			],
			[
				[
					7193936,
					762769
				],
				[
					-9921,
					6508
				],
				[
					11844,
					7019
				],
				[
					14925,
					18112
				],
				[
					-1477,
					26325
				],
				[
					-6343,
					-7036
				],
				[
					-16604,
					4253
				],
				[
					-5637,
					17387
				],
				[
					6201,
					3772
				]
			],
			[
				[
					7186924,
					839109
				],
				[
					30635,
					18612
				],
				[
					8861,
					-33237
				],
				[
					18862,
					11110
				],
				[
					-1313,
					8863
				],
				[
					18962,
					9491
				],
				[
					5082,
					-19084
				]
			],
			[
				[
					7209574,
					1037724
				],
				[
					-21082,
					-15152
				],
				[
					205,
					-9699
				],
				[
					-6969,
					-2474
				],
				[
					-5655,
					11764
				],
				[
					9068,
					-35563
				]
			],
			[
				[
					7185141,
					986600
				],
				[
					4114,
					-16780
				],
				[
					10720,
					6391
				],
				[
					-2456,
					-19175
				],
				[
					19159,
					4887
				],
				[
					5042,
					-12733
				],
				[
					11258,
					5626
				],
				[
					7328,
					10566
				],
				[
					-3885,
					6950
				],
				[
					17958,
					20173
				],
				[
					-2713,
					4863
				]
			],
			[
				[
					7278915,
					943277
				],
				[
					-16232,
					-24182
				],
				[
					-10750,
					1936
				],
				[
					6176,
					-13152
				],
				[
					-6275,
					-8722
				],
				[
					3907,
					-9889
				],
				[
					-2447,
					-25849
				],
				[
					3164,
					-6309
				],
				[
					13045,
					13961
				],
				[
					-5103,
					13494
				],
				[
					20097,
					4077
				],
				[
					-2147,
					13038
				],
				[
					7246,
					-7600
				]
			],
			[
				[
					7289596,
					894080
				],
				[
					275,
					-526
				]
			],
			[
				[
					7186924,
					839109
				],
				[
					-6741,
					-2956
				],
				[
					-10158,
					39766
				],
				[
					-18289,
					-10070
				],
				[
					-1793,
					3493
				],
				[
					12064,
					16387
				],
				[
					-7572,
					15018
				],
				[
					-45757,
					-25454
				]
			],
			[
				[
					7108678,
					875293
				],
				[
					-7886,
					31479
				]
			],
			[
				[
					7100792,
					906772
				],
				[
					-7530,
					29018
				]
			],
			[
				[
					7093262,
					935790
				],
				[
					7411,
					4644
				],
				[
					-2301,
					28275
				],
				[
					13692,
					18568
				],
				[
					-1685,
					19783
				],
				[
					7428,
					1289
				],
				[
					13839,
					26534
				],
				[
					14838,
					-668
				],
				[
					10026,
					30797
				],
				[
					-15265,
					-8720
				],
				[
					-3293,
					12621
				],
				[
					-18927,
					-10989
				],
				[
					-8934,
					-14504
				],
				[
					-8245,
					203
				],
				[
					-17461,
					-23908
				],
				[
					-14715,
					14558
				],
				[
					-13358,
					-8203
				],
				[
					-4458,
					17356
				],
				[
					19998,
					11591
				],
				[
					-1034,
					4046
				],
				[
					20636,
					13055
				],
				[
					-9268,
					35585
				],
				[
					1008,
					4686
				]
			],
			[
				[
					7182903,
					585342
				],
				[
					-2691,
					-944
				]
			],
			[
				[
					7180212,
					584398
				],
				[
					2691,
					944
				]
			],
			[
				[
					7190870,
					587173
				],
				[
					3123,
					-8269
				],
				[
					8888,
					1189
				]
			],
			[
				[
					7202881,
					580093
				],
				[
					6453,
					7153
				],
				[
					24436,
					14132
				],
				[
					-4356,
					-31898
				],
				[
					9827,
					-2097
				],
				[
					19720,
					19230
				],
				[
					-5672,
					-19065
				],
				[
					-7384,
					-4065
				],
				[
					-8747,
					-16302
				],
				[
					11813,
					-4810
				],
				[
					-24578,
					-21954
				],
				[
					-1513,
					6293
				],
				[
					-12500,
					8073
				],
				[
					3190,
					14680
				],
				[
					-27572,
					-7958
				],
				[
					-8985,
					14966
				],
				[
					6033,
					3576
				],
				[
					-9293,
					8449
				],
				[
					17117,
					18677
				]
			],
			[
				[
					7194854,
					614635
				],
				[
					0,
					0
				]
			],
			[
				[
					7261674,
					638148
				],
				[
					-9214,
					1779
				],
				[
					-16251,
					-12663
				],
				[
					2295,
					-19518
				]
			],
			[
				[
					7238504,
					607746
				],
				[
					-20649,
					-10944
				],
				[
					-4288,
					5129
				]
			],
			[
				[
					7213567,
					601931
				],
				[
					-4362,
					20078
				],
				[
					-11351,
					-15836
				]
			],
			[
				[
					7197854,
					606173
				],
				[
					-927,
					-472
				]
			],
			[
				[
					7196927,
					605701
				],
				[
					-4353,
					11554
				],
				[
					-7589,
					-17236
				]
			],
			[
				[
					7184985,
					600019
				],
				[
					-4186,
					5125
				],
				[
					-16817,
					-5104
				],
				[
					-1048,
					-11785
				],
				[
					4624,
					-19758
				],
				[
					6255,
					6656
				]
			],
			[
				[
					7173813,
					575153
				],
				[
					-15301,
					-12510
				],
				[
					-22348,
					-10523
				],
				[
					-12822,
					-382
				]
			],
			[
				[
					7123342,
					551738
				],
				[
					-4268,
					16019
				],
				[
					-6576,
					-9999
				],
				[
					-6746,
					22513
				],
				[
					-7187,
					-1087
				]
			],
			[
				[
					7098565,
					579184
				],
				[
					5359,
					14550
				],
				[
					15670,
					26959
				],
				[
					13357,
					-8639
				],
				[
					6070,
					15919
				],
				[
					6665,
					-5841
				],
				[
					1859,
					-11974
				],
				[
					17124,
					12584
				],
				[
					4902,
					-3387
				],
				[
					-5200,
					25943
				],
				[
					2735,
					10879
				],
				[
					-9516,
					-6162
				],
				[
					2099,
					14585
				],
				[
					-14955,
					65036
				],
				[
					19789,
					9777
				],
				[
					9312,
					-13467
				],
				[
					3730,
					7976
				],
				[
					3500,
					-12242
				],
				[
					7094,
					2875
				],
				[
					-10407,
					40864
				],
				[
					16184,
					-2650
				]
			],
			[
				[
					7174532,
					573874
				],
				[
					0,
					0
				]
			],
			[
				[
					7098565,
					579184
				],
				[
					-6547,
					-1504
				]
			],
			[
				[
					7092018,
					577680
				],
				[
					-5127,
					22174
				],
				[
					-19438,
					-15
				],
				[
					16993,
					11919
				]
			],
			[
				[
					7084446,
					611758
				],
				[
					6629,
					-8130
				],
				[
					18251,
					18928
				],
				[
					-7272,
					32057
				],
				[
					-14594,
					8351
				],
				[
					-1772,
					-18626
				],
				[
					-7569,
					-2740
				],
				[
					2590,
					-12216
				]
			],
			[
				[
					7080709,
					629382
				],
				[
					-17792,
					-9041
				]
			],
			[
				[
					7062917,
					620341
				],
				[
					-10101,
					-11
				]
			],
			[
				[
					7052816,
					620330
				],
				[
					-138,
					21148
				],
				[
					18093,
					5779
				],
				[
					2667,
					16014
				]
			],
			[
				[
					7073438,
					663271
				],
				[
					153,
					8807
				]
			],
			[
				[
					7073591,
					672078
				],
				[
					11853,
					-1569
				],
				[
					-6993,
					24711
				]
			],
			[
				[
					7078451,
					695220
				],
				[
					6817,
					11973
				],
				[
					-10256,
					-5350
				],
				[
					9287,
					29302
				],
				[
					6989,
					7389
				],
				[
					-5455,
					17242
				],
				[
					667,
					11010
				],
				[
					17221,
					11724
				],
				[
					-2811,
					12562
				],
				[
					-11936,
					14334
				],
				[
					13231,
					8451
				],
				[
					-4279,
					17515
				],
				[
					17802,
					16406
				],
				[
					-7050,
					27515
				]
			],
			[
				[
					7109669,
					664800
				],
				[
					0,
					0
				]
			],
			[
				[
					7102232,
					612509
				],
				[
					0,
					0
				]
			],
			[
				[
					7078451,
					695220
				],
				[
					-8652,
					-5890
				],
				[
					3792,
					-17252
				]
			],
			[
				[
					7073438,
					663271
				],
				[
					-4693,
					2408
				],
				[
					-17729,
					-5667
				],
				[
					-2708,
					10917
				],
				[
					-9132,
					-15336
				],
				[
					-5741,
					8855
				],
				[
					4289,
					-30146
				],
				[
					8514,
					4054
				],
				[
					-856,
					-21549
				]
			],
			[
				[
					7045382,
					616807
				],
				[
					-11808,
					-16684
				]
			],
			[
				[
					7033574,
					600123
				],
				[
					-1039,
					10229
				],
				[
					-6408,
					-3375
				]
			],
			[
				[
					7026127,
					606977
				],
				[
					-4597,
					3622
				],
				[
					-5765,
					28755
				]
			],
			[
				[
					7015765,
					639354
				],
				[
					-7143,
					12850
				]
			],
			[
				[
					7008622,
					652204
				],
				[
					3352,
					4890
				],
				[
					-7699,
					37048
				],
				[
					11604,
					12490
				],
				[
					-4228,
					18835
				],
				[
					5388,
					2799
				],
				[
					-11518,
					46520
				]
			],
			[
				[
					7005521,
					774786
				],
				[
					-3236,
					13710
				]
			],
			[
				[
					7002285,
					788496
				],
				[
					20861,
					8581
				],
				[
					-7538,
					28864
				]
			],
			[
				[
					7015608,
					825941
				],
				[
					17927,
					9590
				],
				[
					-1314,
					8404
				],
				[
					12697,
					13516
				],
				[
					6087,
					-5970
				],
				[
					-5931,
					24041
				],
				[
					55718,
					31250
				]
			],
			[
				[
					7043983,
					616461
				],
				[
					0,
					0
				]
			],
			[
				[
					7406971,
					906668
				],
				[
					-260,
					-1157
				]
			],
			[
				[
					7406711,
					905511
				],
				[
					-5528,
					-8901
				]
			],
			[
				[
					7401183,
					896610
				],
				[
					-4793,
					5295
				]
			],
			[
				[
					7396390,
					901905
				],
				[
					6794,
					8048
				]
			],
			[
				[
					7403184,
					909953
				],
				[
					3787,
					-3285
				]
			],
			[
				[
					7403910,
					909904
				],
				[
					0,
					0
				]
			],
			[
				[
					7406395,
					892896
				],
				[
					-5212,
					3714
				]
			],
			[
				[
					7406711,
					905511
				],
				[
					1583,
					-2601
				]
			],
			[
				[
					7411117,
					910469
				],
				[
					-4146,
					-3801
				]
			],
			[
				[
					7403184,
					909953
				],
				[
					527,
					5580
				]
			],
			[
				[
					7408553,
					920202
				],
				[
					489,
					-1645
				]
			],
			[
				[
					7409042,
					918557
				],
				[
					2075,
					-8088
				]
			],
			[
				[
					7414966,
					919411
				],
				[
					-3438,
					-2139
				]
			],
			[
				[
					7411528,
					917272
				],
				[
					-139,
					446
				]
			],
			[
				[
					7411389,
					917718
				],
				[
					3194,
					4524
				]
			],
			[
				[
					7414583,
					922242
				],
				[
					383,
					-2831
				]
			],
			[
				[
					7412385,
					918056
				],
				[
					0,
					0
				]
			],
			[
				[
					7411528,
					917272
				],
				[
					-411,
					-6803
				]
			],
			[
				[
					7409042,
					918557
				],
				[
					2347,
					-839
				]
			],
			[
				[
					7402606,
					872149
				],
				[
					-532,
					-492
				]
			],
			[
				[
					7402074,
					871657
				],
				[
					383,
					1035
				]
			],
			[
				[
					7402457,
					872692
				],
				[
					149,
					-543
				]
			],
			[
				[
					7402606,
					872149
				],
				[
					1375,
					6228
				]
			],
			[
				[
					7403981,
					878377
				],
				[
					-6559,
					12869
				]
			],
			[
				[
					7397422,
					891246
				],
				[
					-290,
					1199
				]
			],
			[
				[
					7397132,
					892445
				],
				[
					-4642,
					4411
				]
			],
			[
				[
					7392490,
					896856
				],
				[
					75,
					3658
				]
			],
			[
				[
					7392565,
					900514
				],
				[
					596,
					617
				]
			],
			[
				[
					7393161,
					901131
				],
				[
					3220,
					815
				]
			],
			[
				[
					7396381,
					901946
				],
				[
					9,
					-41
				]
			],
			[
				[
					7407848,
					871746
				],
				[
					-4294,
					-3885
				]
			],
			[
				[
					7403554,
					867861
				],
				[
					-948,
					4288
				]
			],
			[
				[
					7397132,
					892445
				],
				[
					-6734,
					289
				]
			],
			[
				[
					7390398,
					892734
				],
				[
					2092,
					4122
				]
			],
			[
				[
					7396381,
					901946
				],
				[
					899,
					11688
				]
			],
			[
				[
					7393161,
					901131
				],
				[
					-912,
					3933
				]
			],
			[
				[
					7392249,
					905064
				],
				[
					210,
					2936
				]
			],
			[
				[
					7392459,
					908000
				],
				[
					148,
					493
				]
			],
			[
				[
					7392607,
					908493
				],
				[
					422,
					2585
				]
			],
			[
				[
					7393029,
					911078
				],
				[
					-20,
					1241
				]
			],
			[
				[
					7392249,
					905064
				],
				[
					-796,
					992
				]
			],
			[
				[
					7391453,
					906056
				],
				[
					1006,
					1944
				]
			],
			[
				[
					7392607,
					908493
				],
				[
					422,
					2585
				]
			],
			[
				[
					7391453,
					906056
				],
				[
					-2373,
					1653
				]
			],
			[
				[
					7392565,
					900514
				],
				[
					-1260,
					982
				]
			],
			[
				[
					7391305,
					901496
				],
				[
					-1694,
					1491
				]
			],
			[
				[
					7389611,
					902987
				],
				[
					-1005,
					1245
				]
			],
			[
				[
					7389611,
					902987
				],
				[
					-656,
					-1847
				]
			],
			[
				[
					7388955,
					901140
				],
				[
					-1453,
					1270
				]
			],
			[
				[
					7388955,
					901140
				],
				[
					833,
					-2131
				]
			],
			[
				[
					7389788,
					899009
				],
				[
					-2210,
					-1356
				]
			],
			[
				[
					7387578,
					897653
				],
				[
					-1794,
					3459
				]
			],
			[
				[
					7390398,
					892734
				],
				[
					-414,
					-1258
				]
			],
			[
				[
					7389984,
					891476
				],
				[
					-2235,
					3267
				]
			],
			[
				[
					7387749,
					894743
				],
				[
					-171,
					2910
				]
			],
			[
				[
					7389788,
					899009
				],
				[
					1517,
					2487
				]
			],
			[
				[
					7403981,
					878377
				],
				[
					-1524,
					-5685
				]
			],
			[
				[
					7402074,
					871657
				],
				[
					-5821,
					-240
				]
			],
			[
				[
					7396253,
					871417
				],
				[
					1169,
					19829
				]
			],
			[
				[
					7396253,
					871417
				],
				[
					-6031,
					-5218
				]
			],
			[
				[
					7390222,
					866199
				],
				[
					-1769,
					-1554
				]
			],
			[
				[
					7388453,
					864645
				],
				[
					1015,
					13360
				]
			],
			[
				[
					7389468,
					878005
				],
				[
					-583,
					7325
				]
			],
			[
				[
					7388885,
					885330
				],
				[
					1099,
					6146
				]
			],
			[
				[
					7412257,
					906469
				],
				[
					1231,
					-4688
				]
			],
			[
				[
					7411117,
					910469
				],
				[
					1140,
					-4000
				]
			],
			[
				[
					7403554,
					867861
				],
				[
					-5990,
					-5561
				]
			],
			[
				[
					7397564,
					862300
				],
				[
					-7342,
					3899
				]
			],
			[
				[
					7387749,
					894743
				],
				[
					-172,
					-597
				]
			],
			[
				[
					7387577,
					894146
				],
				[
					-5290,
					5266
				]
			],
			[
				[
					7387577,
					894146
				],
				[
					-4009,
					-2890
				]
			],
			[
				[
					7383568,
					891256
				],
				[
					-2738,
					4783
				]
			],
			[
				[
					7382386,
					896595
				],
				[
					0,
					0
				]
			],
			[
				[
					7383568,
					891256
				],
				[
					-2273,
					-3578
				]
			],
			[
				[
					7381295,
					887678
				],
				[
					-1192,
					7016
				]
			],
			[
				[
					7381295,
					887678
				],
				[
					-2306,
					-3306
				]
			],
			[
				[
					7378989,
					884372
				],
				[
					-3285,
					6075
				]
			],
			[
				[
					7388453,
					864645
				],
				[
					-802,
					-5960
				]
			],
			[
				[
					7387651,
					858685
				],
				[
					221,
					5196
				]
			],
			[
				[
					7387872,
					863881
				],
				[
					-2361,
					8684
				]
			],
			[
				[
					7385511,
					872565
				],
				[
					-311,
					1075
				]
			],
			[
				[
					7385200,
					873640
				],
				[
					2255,
					3367
				]
			],
			[
				[
					7387455,
					877007
				],
				[
					2013,
					998
				]
			],
			[
				[
					7388885,
					885330
				],
				[
					-4319,
					2289
				]
			],
			[
				[
					7384566,
					887619
				],
				[
					-5470,
					-4928
				]
			],
			[
				[
					7379096,
					882691
				],
				[
					-107,
					1681
				]
			],
			[
				[
					7387455,
					877007
				],
				[
					-2889,
					10612
				]
			],
			[
				[
					7387872,
					863881
				],
				[
					-2361,
					8684
				]
			],
			[
				[
					7385200,
					873640
				],
				[
					-4637,
					3776
				]
			],
			[
				[
					7380563,
					877416
				],
				[
					-108,
					376
				]
			],
			[
				[
					7380455,
					877792
				],
				[
					-1359,
					4899
				]
			],
			[
				[
					7380455,
					877792
				],
				[
					-7895,
					-792
				]
			],
			[
				[
					7372560,
					877000
				],
				[
					486,
					5136
				]
			],
			[
				[
					7373046,
					882136
				],
				[
					-1789,
					10721
				]
			],
			[
				[
					7377395,
					865566
				],
				[
					3168,
					11850
				]
			],
			[
				[
					7373046,
					882136
				],
				[
					-7237,
					-6239
				]
			],
			[
				[
					7365809,
					875897
				],
				[
					-3075,
					5133
				]
			],
			[
				[
					7361170,
					884076
				],
				[
					-465,
					8363
				]
			],
			[
				[
					7361093,
					889355
				],
				[
					0,
					0
				]
			],
			[
				[
					7359344,
					894189
				],
				[
					-2760,
					1625
				]
			],
			[
				[
					7372560,
					877000
				],
				[
					-3085,
					-4762
				]
			],
			[
				[
					7369475,
					872238
				],
				[
					-7,
					-5036
				]
			],
			[
				[
					7369468,
					867202
				],
				[
					-1084,
					1468
				]
			],
			[
				[
					7368384,
					868670
				],
				[
					-2315,
					1528
				]
			],
			[
				[
					7366069,
					870198
				],
				[
					-3171,
					2077
				]
			],
			[
				[
					7362898,
					872275
				],
				[
					2911,
					3622
				]
			],
			[
				[
					7371242,
					865345
				],
				[
					-1774,
					1857
				]
			],
			[
				[
					7369475,
					872238
				],
				[
					1767,
					-6893
				]
			],
			[
				[
					7372268,
					861197
				],
				[
					-1026,
					4148
				]
			],
			[
				[
					7366069,
					870198
				],
				[
					2315,
					-1528
				]
			],
			[
				[
					7362855,
					872350
				],
				[
					43,
					-75
				]
			],
			[
				[
					7419716,
					911308
				],
				[
					-7459,
					-4839
				]
			],
			[
				[
					7414966,
					919411
				],
				[
					4750,
					-8103
				]
			],
			[
				[
					7413719,
					924115
				],
				[
					864,
					-1873
				]
			],
			[
				[
					7419716,
					911308
				],
				[
					6173,
					918
				]
			],
			[
				[
					7429473,
					930077
				],
				[
					3724,
					-13339
				]
			],
			[
				[
					7397564,
					862300
				],
				[
					3401,
					-12144
				]
			],
			[
				[
					7497661,
					798598
				],
				[
					-43,
					3623
				]
			],
			[
				[
					7497618,
					802221
				],
				[
					43,
					-3623
				]
			],
			[
				[
					7492259,
					813384
				],
				[
					1626,
					-219
				]
			],
			[
				[
					7493885,
					813165
				],
				[
					-1880,
					-4861
				]
			],
			[
				[
					7517429,
					814262
				],
				[
					-19145,
					-11129
				]
			],
			[
				[
					7498284,
					803133
				],
				[
					-2404,
					9942
				]
			],
			[
				[
					7495880,
					813075
				],
				[
					14,
					3607
				]
			],
			[
				[
					7497661,
					798598
				],
				[
					-43,
					3623
				]
			],
			[
				[
					7491875,
					802720
				],
				[
					41,
					-101
				]
			],
			[
				[
					7498284,
					803133
				],
				[
					-6509,
					951
				]
			],
			[
				[
					7493885,
					813165
				],
				[
					1995,
					-90
				]
			],
			[
				[
					7385398,
					712479
				],
				[
					0,
					0
				]
			],
			[
				[
					7398184,
					711506
				],
				[
					-18816,
					-28217
				]
			],
			[
				[
					7343439,
					768504
				],
				[
					-8920,
					14683
				],
				[
					10242,
					7866
				],
				[
					-7596,
					18368
				]
			],
			[
				[
					7337165,
					809421
				],
				[
					7768,
					6993
				]
			],
			[
				[
					7337165,
					809421
				],
				[
					-9002,
					-3323
				]
			],
			[
				[
					7331808,
					632916
				],
				[
					-11403,
					-14236
				],
				[
					-3956,
					4378
				],
				[
					15359,
					9858
				]
			],
			[
				[
					7344306,
					643202
				],
				[
					-11210,
					-9979
				],
				[
					-11642,
					-1839
				]
			],
			[
				[
					7321454,
					631384
				],
				[
					-3809,
					5860
				]
			],
			[
				[
					7307258,
					617033
				],
				[
					-5470,
					-1021
				]
			],
			[
				[
					7301788,
					616012
				],
				[
					-328,
					-73
				]
			],
			[
				[
					7301460,
					615939
				],
				[
					-23,
					-4
				]
			],
			[
				[
					7301437,
					615935
				],
				[
					-264,
					-61
				]
			],
			[
				[
					7301173,
					615874
				],
				[
					-107,
					-877
				]
			],
			[
				[
					7301066,
					614997
				],
				[
					-4695,
					3324
				]
			],
			[
				[
					7296371,
					618321
				],
				[
					-565,
					6951
				]
			],
			[
				[
					7295806,
					625272
				],
				[
					11949,
					4194
				],
				[
					-497,
					-12433
				]
			],
			[
				[
					7303135,
					622060
				],
				[
					0,
					0
				]
			],
			[
				[
					7301437,
					615935
				],
				[
					-264,
					-61
				]
			],
			[
				[
					7301788,
					616012
				],
				[
					-328,
					-73
				]
			],
			[
				[
					7301066,
					614997
				],
				[
					-4298,
					-2528
				]
			],
			[
				[
					7296768,
					612469
				],
				[
					-397,
					5852
				]
			],
			[
				[
					7280760,
					624412
				],
				[
					1514,
					-409
				]
			],
			[
				[
					7282274,
					624003
				],
				[
					-825,
					-1779
				]
			],
			[
				[
					7279596,
					628044
				],
				[
					1164,
					-3632
				]
			],
			[
				[
					7321454,
					631384
				],
				[
					-14196,
					-14351
				]
			],
			[
				[
					7295806,
					625272
				],
				[
					-5193,
					2877
				]
			],
			[
				[
					7290613,
					628149
				],
				[
					-1586,
					3088
				]
			],
			[
				[
					7296768,
					612469
				],
				[
					-12495,
					192
				]
			],
			[
				[
					7284273,
					612661
				],
				[
					-4329,
					1598
				]
			],
			[
				[
					7282274,
					624003
				],
				[
					8527,
					-4210
				],
				[
					-188,
					8356
				]
			],
			[
				[
					7293539,
					624349
				],
				[
					0,
					0
				]
			],
			[
				[
					7284273,
					612661
				],
				[
					-4435,
					-1723
				]
			],
			[
				[
					7239708,
					577434
				],
				[
					-6526,
					57
				],
				[
					8069,
					14069
				],
				[
					13732,
					4979
				]
			],
			[
				[
					7255002,
					596549
				],
				[
					-1990,
					4336
				]
			],
			[
				[
					7249779,
					602514
				],
				[
					-15482,
					-17836
				],
				[
					4207,
					23068
				]
			],
			[
				[
					7289596,
					894080
				],
				[
					4972,
					22076
				]
			],
			[
				[
					7185141,
					986600
				],
				[
					25783,
					14022
				],
				[
					-2106,
					8239
				],
				[
					10290,
					2810
				]
			],
			[
				[
					7232017,
					994621
				],
				[
					0,
					0
				]
			],
			[
				[
					7233818,
					996077
				],
				[
					0,
					0
				]
			],
			[
				[
					7198183,
					594788
				],
				[
					31,
					17
				]
			],
			[
				[
					7198214,
					594805
				],
				[
					-31,
					-17
				]
			],
			[
				[
					7190870,
					587173
				],
				[
					15821,
					8008
				],
				[
					-3810,
					-15088
				]
			],
			[
				[
					7196927,
					605701
				],
				[
					-3179,
					-13269
				]
			],
			[
				[
					7193748,
					592432
				],
				[
					-7664,
					-4217
				]
			],
			[
				[
					7186084,
					588215
				],
				[
					1075,
					3544
				]
			],
			[
				[
					7187159,
					591759
				],
				[
					-938,
					3109
				]
			],
			[
				[
					7186221,
					594868
				],
				[
					-1236,
					5151
				]
			],
			[
				[
					7213567,
					601931
				],
				[
					-15120,
					-3908
				]
			],
			[
				[
					7198447,
					598023
				],
				[
					-593,
					8150
				]
			],
			[
				[
					7198183,
					594788
				],
				[
					31,
					17
				]
			],
			[
				[
					7198447,
					598023
				],
				[
					-4699,
					-5591
				]
			],
			[
				[
					7187159,
					591759
				],
				[
					-938,
					3109
				]
			],
			[
				[
					7186084,
					588215
				],
				[
					-3181,
					-2873
				]
			],
			[
				[
					7180212,
					584398
				],
				[
					-6399,
					-9245
				]
			],
			[
				[
					7123342,
					551738
				],
				[
					-24344,
					-4173
				]
			],
			[
				[
					7098998,
					547565
				],
				[
					-433,
					31619
				]
			],
			[
				[
					7095971,
					643824
				],
				[
					568,
					-2192
				]
			],
			[
				[
					7096539,
					641632
				],
				[
					-2068,
					-5176
				]
			],
			[
				[
					7094471,
					636456
				],
				[
					225,
					-3966
				]
			],
			[
				[
					7094696,
					632490
				],
				[
					-45,
					-578
				]
			],
			[
				[
					7094651,
					631912
				],
				[
					-4826,
					3277
				]
			],
			[
				[
					7089825,
					635189
				],
				[
					48,
					2694
				]
			],
			[
				[
					7089873,
					637883
				],
				[
					879,
					3932
				]
			],
			[
				[
					7090752,
					641815
				],
				[
					5219,
					2009
				]
			],
			[
				[
					7084446,
					611758
				],
				[
					-3737,
					17624
				]
			],
			[
				[
					7089873,
					637883
				],
				[
					-48,
					-2694
				]
			],
			[
				[
					7094651,
					631912
				],
				[
					45,
					578
				]
			],
			[
				[
					7094471,
					636456
				],
				[
					2068,
					5176
				]
			],
			[
				[
					7095971,
					643824
				],
				[
					-5219,
					-2009
				]
			],
			[
				[
					7087899,
					625539
				],
				[
					0,
					0
				]
			],
			[
				[
					7087899,
					625539
				],
				[
					0,
					0
				]
			],
			[
				[
					7052816,
					620330
				],
				[
					-7434,
					-3523
				]
			],
			[
				[
					7092018,
					577680
				],
				[
					-11101,
					-10693
				],
				[
					-4996,
					-11875
				],
				[
					2091,
					-10291
				]
			],
			[
				[
					7078012,
					544821
				],
				[
					-8895,
					7214
				]
			],
			[
				[
					7069117,
					552035
				],
				[
					-7162,
					11606
				],
				[
					10003,
					12049
				],
				[
					-1515,
					7447
				],
				[
					-19697,
					-10896
				]
			],
			[
				[
					7050746,
					572241
				],
				[
					-1450,
					6471
				]
			],
			[
				[
					7049296,
					578712
				],
				[
					-2679,
					12417
				],
				[
					4818,
					2414
				],
				[
					-3912,
					14206
				],
				[
					12667,
					3230
				],
				[
					2727,
					9362
				]
			],
			[
				[
					7019854,
					566014
				],
				[
					844,
					-4060
				]
			],
			[
				[
					7020698,
					561954
				],
				[
					-8574,
					-8956
				]
			],
			[
				[
					7012124,
					552998
				],
				[
					-4234,
					7706
				]
			],
			[
				[
					7007890,
					560704
				],
				[
					2404,
					1200
				]
			],
			[
				[
					7010294,
					561904
				],
				[
					9560,
					4110
				]
			],
			[
				[
					7069117,
					552035
				],
				[
					-12779,
					-6167
				]
			],
			[
				[
					7056338,
					545868
				],
				[
					-5592,
					26373
				]
			],
			[
				[
					7049296,
					578712
				],
				[
					-9284,
					-4624
				],
				[
					4299,
					-23644
				],
				[
					-2404,
					-5913
				]
			],
			[
				[
					7041907,
					544531
				],
				[
					-6051,
					-2968
				]
			],
			[
				[
					7035856,
					541563
				],
				[
					-871,
					4251
				]
			],
			[
				[
					7034985,
					545814
				],
				[
					-880,
					4164
				]
			],
			[
				[
					7034105,
					549978
				],
				[
					-4251,
					20756
				]
			],
			[
				[
					7029854,
					570734
				],
				[
					-6461,
					13348
				],
				[
					11449,
					3630
				],
				[
					-1268,
					12411
				]
			],
			[
				[
					6998893,
					556241
				],
				[
					-2735,
					-1355
				]
			],
			[
				[
					6996158,
					554886
				],
				[
					-4421,
					7182
				],
				[
					-584,
					18367
				]
			],
			[
				[
					6991153,
					580435
				],
				[
					2696,
					1276
				],
				[
					5044,
					-25470
				]
			],
			[
				[
					6990013,
					586352
				],
				[
					-1681,
					8585
				]
			],
			[
				[
					6988332,
					594937
				],
				[
					2654,
					1274
				]
			],
			[
				[
					6990986,
					596211
				],
				[
					-973,
					-9859
				]
			],
			[
				[
					7026127,
					606977
				],
				[
					-1589,
					-10582
				],
				[
					-9919,
					-3362
				]
			],
			[
				[
					7014619,
					593033
				],
				[
					-1866,
					9034
				],
				[
					-9491,
					-1184
				],
				[
					-2368,
					-9347
				],
				[
					-8144,
					28606
				]
			],
			[
				[
					6992750,
					620142
				],
				[
					3744,
					10195
				],
				[
					19271,
					9017
				]
			],
			[
				[
					6957860,
					622817
				],
				[
					-28,
					6259
				]
			],
			[
				[
					6957832,
					629076
				],
				[
					28,
					-6259
				]
			],
			[
				[
					6962032,
					636288
				],
				[
					0,
					0
				]
			],
			[
				[
					6960811,
					639939
				],
				[
					0,
					0
				]
			],
			[
				[
					6992750,
					620142
				],
				[
					-4390,
					-11124
				],
				[
					2626,
					-12807
				]
			],
			[
				[
					6988332,
					594937
				],
				[
					-5533,
					-2643
				],
				[
					-5188,
					20403
				],
				[
					-8762,
					-4126
				]
			],
			[
				[
					6968849,
					608571
				],
				[
					2246,
					5674
				],
				[
					-4839,
					49472
				]
			],
			[
				[
					6966256,
					663717
				],
				[
					8921,
					2681
				]
			],
			[
				[
					6975177,
					666398
				],
				[
					10403,
					3052
				]
			],
			[
				[
					6985580,
					669450
				],
				[
					2718,
					773
				],
				[
					5164,
					-25230
				],
				[
					15160,
					7211
				]
			],
			[
				[
					6938201,
					589766
				],
				[
					2103,
					-17709
				],
				[
					6880,
					-892
				]
			],
			[
				[
					6947184,
					571165
				],
				[
					8978,
					-5675
				]
			],
			[
				[
					6956162,
					565490
				],
				[
					-7810,
					-8369
				],
				[
					-1630,
					-22866
				]
			],
			[
				[
					6946722,
					534255
				],
				[
					-4451,
					-2044
				]
			],
			[
				[
					6942271,
					532211
				],
				[
					-7037,
					-2866
				]
			],
			[
				[
					6935234,
					529345
				],
				[
					-4117,
					24365
				],
				[
					-12027,
					-1027
				]
			],
			[
				[
					6919090,
					552683
				],
				[
					-3655,
					-1696
				]
			],
			[
				[
					6915435,
					550987
				],
				[
					-3479,
					-1613
				]
			],
			[
				[
					6911956,
					549374
				],
				[
					-177,
					-81
				]
			],
			[
				[
					6911779,
					549293
				],
				[
					-3032,
					26031
				]
			],
			[
				[
					6908747,
					575324
				],
				[
					312,
					13877
				],
				[
					5276,
					2665
				],
				[
					3871,
					-11397
				],
				[
					7844,
					6820
				]
			],
			[
				[
					6926050,
					587289
				],
				[
					12151,
					2477
				]
			],
			[
				[
					6990013,
					586352
				],
				[
					-1550,
					-7192
				]
			],
			[
				[
					6988463,
					579160
				],
				[
					-10055,
					-3066
				]
			],
			[
				[
					6978408,
					576094
				],
				[
					-12067,
					3485
				]
			],
			[
				[
					6966341,
					579579
				],
				[
					-2709,
					-1346
				],
				[
					-5865,
					25166
				]
			],
			[
				[
					6957767,
					603399
				],
				[
					11082,
					5172
				]
			],
			[
				[
					7010475,
					543198
				],
				[
					938,
					-4209
				]
			],
			[
				[
					7011413,
					538989
				],
				[
					-5702,
					-2789
				]
			],
			[
				[
					7005711,
					536200
				],
				[
					-2351,
					-5927
				]
			],
			[
				[
					7003360,
					530273
				],
				[
					-4158,
					-3745
				]
			],
			[
				[
					6999202,
					526528
				],
				[
					-4079,
					4542
				]
			],
			[
				[
					6995123,
					531070
				],
				[
					-1844,
					8404
				]
			],
			[
				[
					6993279,
					539474
				],
				[
					17196,
					3724
				]
			],
			[
				[
					6972114,
					563696
				],
				[
					6380,
					-19238
				]
			],
			[
				[
					6978494,
					544458
				],
				[
					-6866,
					-3549
				]
			],
			[
				[
					6971628,
					540909
				],
				[
					-344,
					13026
				]
			],
			[
				[
					6971284,
					553935
				],
				[
					-2003,
					13054
				]
			],
			[
				[
					6969281,
					566989
				],
				[
					2833,
					-3293
				]
			],
			[
				[
					6948442,
					529498
				],
				[
					483,
					-4541
				]
			],
			[
				[
					6948925,
					524957
				],
				[
					473,
					-4323
				]
			],
			[
				[
					6949398,
					520634
				],
				[
					-2717,
					-1351
				]
			],
			[
				[
					6946681,
					519283
				],
				[
					-2371,
					-2281
				]
			],
			[
				[
					6944310,
					517002
				],
				[
					-5359,
					-1282
				]
			],
			[
				[
					6938951,
					515720
				],
				[
					-2100,
					6767
				]
			],
			[
				[
					6936851,
					522487
				],
				[
					-1617,
					6858
				]
			],
			[
				[
					6942271,
					532211
				],
				[
					6171,
					-2713
				]
			],
			[
				[
					6921091,
					717802
				],
				[
					-7228,
					4967
				]
			],
			[
				[
					6913863,
					722769
				],
				[
					8075,
					6516
				],
				[
					4616,
					-11473
				]
			],
			[
				[
					6926554,
					717812
				],
				[
					-5463,
					-10
				]
			],
			[
				[
					6972041,
					729248
				],
				[
					0,
					0
				]
			],
			[
				[
					6898246,
					734740
				],
				[
					0,
					0
				]
			],
			[
				[
					6888296,
					750351
				],
				[
					991,
					4842
				]
			],
			[
				[
					6889287,
					755193
				],
				[
					-991,
					-4842
				]
			],
			[
				[
					6928611,
					761291
				],
				[
					-64,
					-12
				]
			],
			[
				[
					6928547,
					761279
				],
				[
					-1859,
					1309
				]
			],
			[
				[
					6926688,
					762588
				],
				[
					1923,
					-1297
				]
			],
			[
				[
					6875956,
					772122
				],
				[
					9460,
					-12877
				],
				[
					-10549,
					1142
				],
				[
					1089,
					11735
				]
			],
			[
				[
					6977718,
					746522
				],
				[
					901,
					8946
				],
				[
					12775,
					3257
				]
			],
			[
				[
					6991394,
					758725
				],
				[
					10296,
					5223
				],
				[
					3831,
					10838
				]
			],
			[
				[
					6985580,
					669450
				],
				[
					-8688,
					21883
				],
				[
					10609,
					17952
				],
				[
					12382,
					5905
				],
				[
					-4615,
					21759
				],
				[
					-11227,
					-6215
				],
				[
					2034,
					-9806
				],
				[
					-15281,
					-8464
				],
				[
					4466,
					17225
				],
				[
					-4659,
					17527
				]
			],
			[
				[
					6970601,
					747216
				],
				[
					7117,
					-694
				]
			],
			[
				[
					6977718,
					746522
				],
				[
					0,
					0
				]
			],
			[
				[
					6910860,
					787168
				],
				[
					166,
					288
				]
			],
			[
				[
					6911026,
					787456
				],
				[
					-166,
					-288
				]
			],
			[
				[
					6917928,
					792325
				],
				[
					-679,
					-1965
				]
			],
			[
				[
					6917249,
					790360
				],
				[
					-5473,
					99
				]
			],
			[
				[
					6911776,
					790459
				],
				[
					6152,
					1866
				]
			],
			[
				[
					6928611,
					761291
				],
				[
					2527,
					7870
				],
				[
					-3182,
					26001
				]
			],
			[
				[
					6927956,
					795162
				],
				[
					10724,
					4958
				],
				[
					6068,
					-24771
				],
				[
					9668,
					-9080
				]
			],
			[
				[
					6954416,
					766269
				],
				[
					806,
					-22009
				]
			],
			[
				[
					6955222,
					744260
				],
				[
					2471,
					-12034
				],
				[
					-5116,
					-4387
				],
				[
					5139,
					-23795
				]
			],
			[
				[
					6957716,
					704044
				],
				[
					-16387,
					-9969
				]
			],
			[
				[
					6941329,
					694075
				],
				[
					-1055,
					12826
				]
			],
			[
				[
					6940274,
					706901
				],
				[
					-4643,
					6070
				]
			],
			[
				[
					6935631,
					712971
				],
				[
					-15988,
					27953
				]
			],
			[
				[
					6919643,
					740924
				],
				[
					14631,
					11229
				],
				[
					-6313,
					8447
				]
			],
			[
				[
					6927961,
					760600
				],
				[
					650,
					691
				]
			],
			[
				[
					6920629,
					805812
				],
				[
					0,
					0
				]
			],
			[
				[
					6928361,
					636075
				],
				[
					0,
					0
				]
			],
			[
				[
					6933205,
					631570
				],
				[
					1764,
					-14641
				],
				[
					22914,
					14166
				]
			],
			[
				[
					6957883,
					631095
				],
				[
					-51,
					-2019
				]
			],
			[
				[
					6957860,
					622817
				],
				[
					-129,
					-12822
				]
			],
			[
				[
					6957731,
					609995
				],
				[
					-20245,
					-14311
				],
				[
					715,
					-5918
				]
			],
			[
				[
					6926050,
					587289
				],
				[
					-1490,
					19294
				],
				[
					-4278,
					4902
				]
			],
			[
				[
					6920282,
					611485
				],
				[
					6711,
					9968
				],
				[
					290,
					13909
				]
			],
			[
				[
					6927283,
					635362
				],
				[
					5187,
					2250
				]
			],
			[
				[
					6932470,
					637612
				],
				[
					735,
					-6042
				]
			],
			[
				[
					6957716,
					704044
				],
				[
					4772,
					-6358
				],
				[
					12689,
					-31288
				]
			],
			[
				[
					6966256,
					663717
				],
				[
					-8109,
					-2522
				]
			],
			[
				[
					6958147,
					661195
				],
				[
					-14219,
					-8081
				]
			],
			[
				[
					6943928,
					653114
				],
				[
					1188,
					18001
				],
				[
					-11494,
					15964
				],
				[
					7707,
					6996
				]
			],
			[
				[
					6935419,
					684630
				],
				[
					0,
					0
				]
			],
			[
				[
					6926554,
					717812
				],
				[
					2650,
					-10889
				],
				[
					6427,
					6048
				]
			],
			[
				[
					6940274,
					706901
				],
				[
					-8786,
					-20262
				],
				[
					9929,
					-22910
				],
				[
					-6551,
					-3665
				]
			],
			[
				[
					6934866,
					660064
				],
				[
					-2947,
					-4296
				]
			],
			[
				[
					6931919,
					655768
				],
				[
					-2479,
					-3853
				]
			],
			[
				[
					6929440,
					651915
				],
				[
					-493,
					-223
				]
			],
			[
				[
					6928947,
					651692
				],
				[
					-3722,
					3090
				]
			],
			[
				[
					6925225,
					654782
				],
				[
					-785,
					-9187
				]
			],
			[
				[
					6924440,
					645595
				],
				[
					-5158,
					-4636
				],
				[
					-13760,
					33522
				]
			],
			[
				[
					6905522,
					674481
				],
				[
					-2480,
					20993
				]
			],
			[
				[
					6903042,
					695474
				],
				[
					1911,
					24894
				],
				[
					-8710,
					14785
				]
			],
			[
				[
					6896243,
					735153
				],
				[
					11954,
					5679
				]
			],
			[
				[
					6908197,
					740832
				],
				[
					5666,
					-18063
				]
			],
			[
				[
					6921091,
					717802
				],
				[
					0,
					0
				]
			],
			[
				[
					6934252,
					662245
				],
				[
					0,
					0
				]
			],
			[
				[
					6925450,
					644042
				],
				[
					0,
					0
				]
			],
			[
				[
					6925225,
					654782
				],
				[
					-785,
					-9187
				]
			],
			[
				[
					6924440,
					645595
				],
				[
					2843,
					-10233
				]
			],
			[
				[
					6920282,
					611485
				],
				[
					-1548,
					13024
				],
				[
					-4886,
					-4012
				],
				[
					-3045,
					-27875
				],
				[
					-5465,
					-2543
				]
			],
			[
				[
					6905338,
					590079
				],
				[
					-4785,
					24742
				],
				[
					-6671,
					-9776
				],
				[
					-5879,
					4149
				],
				[
					-3894,
					14588
				],
				[
					-10253,
					-4677
				]
			],
			[
				[
					6873856,
					619105
				],
				[
					3814,
					9986
				],
				[
					-634,
					24526
				],
				[
					-8273,
					4293
				]
			],
			[
				[
					6868763,
					657910
				],
				[
					2857,
					9643
				]
			],
			[
				[
					6871620,
					667553
				],
				[
					14949,
					6755
				]
			],
			[
				[
					6886569,
					674308
				],
				[
					10217,
					-5701
				],
				[
					8736,
					5874
				]
			],
			[
				[
					6885149,
					522744
				],
				[
					1628,
					3164
				]
			],
			[
				[
					6886777,
					525908
				],
				[
					3001,
					-4725
				]
			],
			[
				[
					6889778,
					521183
				],
				[
					-4629,
					1561
				]
			],
			[
				[
					6880394,
					541626
				],
				[
					0,
					0
				]
			],
			[
				[
					6919090,
					552683
				],
				[
					-3655,
					-1696
				]
			],
			[
				[
					6911779,
					549293
				],
				[
					-1913,
					-898
				]
			],
			[
				[
					6909866,
					548395
				],
				[
					-4798,
					25240
				]
			],
			[
				[
					6905068,
					573635
				],
				[
					3679,
					1689
				]
			],
			[
				[
					6905338,
					590079
				],
				[
					-1026,
					-9954
				]
			],
			[
				[
					6904312,
					580125
				],
				[
					-10936,
					-5438
				],
				[
					1542,
					-7259
				],
				[
					-17444,
					-6427
				],
				[
					-4621,
					4952
				],
				[
					3399,
					-33025
				],
				[
					7631,
					-12623
				]
			],
			[
				[
					6883883,
					520305
				],
				[
					-4105,
					-18460
				],
				[
					5153,
					-11217
				]
			],
			[
				[
					6884931,
					490628
				],
				[
					-2599,
					-4994
				]
			],
			[
				[
					6882332,
					485634
				],
				[
					-9317,
					13883
				],
				[
					505,
					11555
				],
				[
					-10628,
					15924
				],
				[
					-5380,
					-2413
				]
			],
			[
				[
					6857512,
					524583
				],
				[
					-4502,
					40992
				]
			],
			[
				[
					6853010,
					565575
				],
				[
					18149,
					9069
				],
				[
					-3565,
					21958
				],
				[
					6262,
					22503
				]
			],
			[
				[
					6907165,
					440247
				],
				[
					3781,
					-14220
				]
			],
			[
				[
					6910946,
					426027
				],
				[
					-1331,
					-10935
				]
			],
			[
				[
					6909615,
					415092
				],
				[
					-1903,
					-2685
				]
			],
			[
				[
					6907712,
					412407
				],
				[
					-3413,
					10733
				]
			],
			[
				[
					6904299,
					423140
				],
				[
					-4739,
					-2888
				]
			],
			[
				[
					6899560,
					420252
				],
				[
					-3325,
					-2233
				]
			],
			[
				[
					6896235,
					418019
				],
				[
					2484,
					13688
				],
				[
					-12847,
					19554
				]
			],
			[
				[
					6885872,
					451261
				],
				[
					1462,
					6126
				]
			],
			[
				[
					6887334,
					457387
				],
				[
					6322,
					-946
				],
				[
					13509,
					-16194
				]
			],
			[
				[
					6919575,
					473854
				],
				[
					2865,
					-4449
				]
			],
			[
				[
					6922440,
					469405
				],
				[
					3876,
					-6050
				]
			],
			[
				[
					6926316,
					463355
				],
				[
					3135,
					-12033
				]
			],
			[
				[
					6929451,
					451322
				],
				[
					3772,
					-6511
				]
			],
			[
				[
					6933223,
					444811
				],
				[
					-3165,
					-6121
				]
			],
			[
				[
					6930058,
					438690
				],
				[
					-10624,
					12493
				]
			],
			[
				[
					6919434,
					451183
				],
				[
					3572,
					8751
				],
				[
					-5002,
					14526
				]
			],
			[
				[
					6918004,
					474460
				],
				[
					1571,
					-606
				]
			],
			[
				[
					6919279,
					474353
				],
				[
					268,
					-453
				]
			],
			[
				[
					6919547,
					473900
				],
				[
					-908,
					949
				]
			],
			[
				[
					6918639,
					474849
				],
				[
					-162,
					799
				]
			],
			[
				[
					6918477,
					475648
				],
				[
					802,
					-1295
				]
			],
			[
				[
					6906599,
					464539
				],
				[
					-6552,
					19083
				]
			],
			[
				[
					6900047,
					483622
				],
				[
					6552,
					-19083
				]
			],
			[
				[
					6912148,
					485666
				],
				[
					-1275,
					-2186
				]
			],
			[
				[
					6910873,
					483480
				],
				[
					-1085,
					5934
				]
			],
			[
				[
					6909788,
					489414
				],
				[
					2360,
					-3748
				]
			],
			[
				[
					6909763,
					489453
				],
				[
					1086,
					-5935
				]
			],
			[
				[
					6910849,
					483518
				],
				[
					-1811,
					7076
				]
			],
			[
				[
					6909038,
					490594
				],
				[
					725,
					-1141
				]
			],
			[
				[
					6901898,
					497760
				],
				[
					1187,
					2300
				]
			],
			[
				[
					6903085,
					500060
				],
				[
					3018,
					-4809
				]
			],
			[
				[
					6906103,
					495251
				],
				[
					-4205,
					2509
				]
			],
			[
				[
					6918185,
					363590
				],
				[
					4815,
					-1304
				]
			],
			[
				[
					6923000,
					362286
				],
				[
					18217,
					-9475
				],
				[
					1168,
					4550
				]
			],
			[
				[
					6942385,
					357361
				],
				[
					11422,
					-5360
				],
				[
					3894,
					13194
				]
			],
			[
				[
					6957701,
					365195
				],
				[
					22101,
					-2810
				]
			],
			[
				[
					6979802,
					362385
				],
				[
					-3388,
					-16528
				]
			],
			[
				[
					6976414,
					345857
				],
				[
					-7521,
					-11678
				],
				[
					469,
					-25178
				],
				[
					-8101,
					-332
				]
			],
			[
				[
					6961261,
					308669
				],
				[
					-3473,
					979
				]
			],
			[
				[
					6957788,
					309648
				],
				[
					-15887,
					11925
				]
			],
			[
				[
					6941901,
					321573
				],
				[
					-15583,
					11706
				]
			],
			[
				[
					6926318,
					333279
				],
				[
					-19751,
					14984
				]
			],
			[
				[
					6906567,
					348263
				],
				[
					4582,
					18798
				]
			],
			[
				[
					6911149,
					367061
				],
				[
					7036,
					-3471
				]
			],
			[
				[
					6912160,
					365150
				],
				[
					0,
					0
				]
			],
			[
				[
					6880147,
					396018
				],
				[
					-4302,
					737
				]
			],
			[
				[
					6875845,
					396755
				],
				[
					4302,
					-737
				]
			],
			[
				[
					6909615,
					415092
				],
				[
					6176,
					-9226
				]
			],
			[
				[
					6915791,
					405866
				],
				[
					1734,
					-2682
				]
			],
			[
				[
					6917525,
					403184
				],
				[
					276,
					-3585
				]
			],
			[
				[
					6917801,
					399599
				],
				[
					-2688,
					-3038
				]
			],
			[
				[
					6915113,
					396561
				],
				[
					-2568,
					-3964
				]
			],
			[
				[
					6912545,
					392597
				],
				[
					-2226,
					3285
				],
				[
					-16031,
					-5682
				],
				[
					6308,
					-20329
				]
			],
			[
				[
					6900596,
					369871
				],
				[
					488,
					-3158
				]
			],
			[
				[
					6901084,
					366713
				],
				[
					3,
					-2
				]
			],
			[
				[
					6901087,
					366711
				],
				[
					0,
					0
				]
			],
			[
				[
					6901087,
					366711
				],
				[
					-3,
					2
				]
			],
			[
				[
					6901084,
					366713
				],
				[
					-5559,
					-9932
				]
			],
			[
				[
					6895525,
					356781
				],
				[
					-15959,
					13963
				]
			],
			[
				[
					6879566,
					370744
				],
				[
					-1075,
					5568
				]
			],
			[
				[
					6878491,
					376312
				],
				[
					-989,
					5526
				]
			],
			[
				[
					6877502,
					381838
				],
				[
					-625,
					3376
				]
			],
			[
				[
					6876877,
					385214
				],
				[
					9605,
					6694
				]
			],
			[
				[
					6886482,
					391908
				],
				[
					487,
					129
				]
			],
			[
				[
					6886969,
					392037
				],
				[
					1837,
					9410
				]
			],
			[
				[
					6888806,
					401447
				],
				[
					-571,
					4080
				]
			],
			[
				[
					6888235,
					405527
				],
				[
					10689,
					3802
				],
				[
					-2689,
					8690
				]
			],
			[
				[
					6899560,
					420252
				],
				[
					1612,
					-1834
				]
			],
			[
				[
					6901172,
					418418
				],
				[
					0,
					0
				]
			],
			[
				[
					6901172,
					418418
				],
				[
					3127,
					4722
				]
			],
			[
				[
					6907712,
					412407
				],
				[
					0,
					0
				]
			],
			[
				[
					6892720,
					406573
				],
				[
					0,
					0
				]
			],
			[
				[
					6892616,
					406164
				],
				[
					0,
					0
				]
			],
			[
				[
					6913828,
					397394
				],
				[
					0,
					0
				]
			],
			[
				[
					6981590,
					304995
				],
				[
					2291,
					4016
				]
			],
			[
				[
					6983881,
					309011
				],
				[
					2225,
					-37
				]
			],
			[
				[
					6986106,
					308974
				],
				[
					-428,
					-4064
				]
			],
			[
				[
					6985678,
					304910
				],
				[
					-4088,
					85
				]
			],
			[
				[
					7021967,
					305853
				],
				[
					-3969,
					-16823
				]
			],
			[
				[
					7017998,
					289030
				],
				[
					-13600,
					-8310
				],
				[
					-6674,
					7551
				]
			],
			[
				[
					6997724,
					288271
				],
				[
					725,
					17097
				]
			],
			[
				[
					6998449,
					305368
				],
				[
					5356,
					4818
				]
			],
			[
				[
					7003805,
					310186
				],
				[
					9178,
					3671
				]
			],
			[
				[
					7012983,
					313857
				],
				[
					8984,
					-8004
				]
			],
			[
				[
					6999999,
					285859
				],
				[
					0,
					0
				]
			],
			[
				[
					6981590,
					304995
				],
				[
					-6016,
					-20080
				]
			],
			[
				[
					6975574,
					284915
				],
				[
					-9357,
					3218
				]
			],
			[
				[
					6966217,
					288133
				],
				[
					-4956,
					20536
				]
			],
			[
				[
					6976414,
					345857
				],
				[
					6894,
					-7940
				],
				[
					2619,
					8961
				]
			],
			[
				[
					6985927,
					346878
				],
				[
					2281,
					-548
				]
			],
			[
				[
					6988208,
					346330
				],
				[
					4990,
					-8933
				]
			],
			[
				[
					6993198,
					337397
				],
				[
					62,
					-9249
				],
				[
					8556,
					179
				],
				[
					3007,
					-8386
				]
			],
			[
				[
					7004823,
					319941
				],
				[
					-12610,
					1189
				],
				[
					-2791,
					13356
				],
				[
					-4240,
					-9934
				]
			],
			[
				[
					6985182,
					324552
				],
				[
					-2331,
					-4864
				]
			],
			[
				[
					6982851,
					319688
				],
				[
					-7893,
					-9437
				],
				[
					6632,
					-5256
				]
			],
			[
				[
					7010794,
					353838
				],
				[
					-6493,
					-445
				]
			],
			[
				[
					7004301,
					353393
				],
				[
					-1371,
					100
				]
			],
			[
				[
					7002930,
					353493
				],
				[
					-3509,
					-245
				]
			],
			[
				[
					6999421,
					353248
				],
				[
					-2640,
					-910
				]
			],
			[
				[
					6996781,
					352338
				],
				[
					396,
					-2285
				]
			],
			[
				[
					6997177,
					350053
				],
				[
					-1322,
					-4358
				]
			],
			[
				[
					6995855,
					345695
				],
				[
					-578,
					6056
				]
			],
			[
				[
					6995277,
					351751
				],
				[
					-1786,
					6684
				]
			],
			[
				[
					6993491,
					358435
				],
				[
					-431,
					5989
				]
			],
			[
				[
					6993060,
					364424
				],
				[
					-216,
					7686
				]
			],
			[
				[
					6992844,
					372110
				],
				[
					-13,
					750
				]
			],
			[
				[
					6992831,
					372860
				],
				[
					7220,
					7147
				],
				[
					9231,
					-1146
				],
				[
					1512,
					-25023
				]
			],
			[
				[
					7098998,
					547565
				],
				[
					-19583,
					-9483
				]
			],
			[
				[
					7079415,
					538082
				],
				[
					-1403,
					6739
				]
			],
			[
				[
					7079415,
					538082
				],
				[
					-5063,
					-3719
				],
				[
					-19099,
					-1044
				]
			],
			[
				[
					7055253,
					533319
				],
				[
					1085,
					12549
				]
			],
			[
				[
					7055253,
					533319
				],
				[
					-3566,
					-3066
				]
			],
			[
				[
					7051687,
					530253
				],
				[
					-9217,
					-178
				],
				[
					-563,
					14456
				]
			],
			[
				[
					7051687,
					530253
				],
				[
					-12906,
					-3025
				]
			],
			[
				[
					7038781,
					527228
				],
				[
					-2245,
					11024
				]
			],
			[
				[
					7036536,
					538252
				],
				[
					-680,
					3311
				]
			],
			[
				[
					7036062,
					538050
				],
				[
					-5523,
					-3499
				]
			],
			[
				[
					7030539,
					534551
				],
				[
					-3316,
					7539
				]
			],
			[
				[
					7027223,
					542090
				],
				[
					258,
					4677
				]
			],
			[
				[
					7027481,
					546767
				],
				[
					2195,
					1041
				]
			],
			[
				[
					7029676,
					547808
				],
				[
					6386,
					-9758
				]
			],
			[
				[
					7038781,
					527228
				],
				[
					-2537,
					352
				]
			],
			[
				[
					7036244,
					527580
				],
				[
					-5705,
					6971
				]
			],
			[
				[
					7036062,
					538050
				],
				[
					474,
					202
				]
			],
			[
				[
					7034985,
					545814
				],
				[
					-880,
					4164
				]
			],
			[
				[
					7034105,
					549978
				],
				[
					-4429,
					-2170
				]
			],
			[
				[
					7029676,
					547808
				],
				[
					-2195,
					-1041
				]
			],
			[
				[
					7027223,
					542090
				],
				[
					-1120,
					-545
				]
			],
			[
				[
					7026103,
					541545
				],
				[
					-1484,
					3898
				]
			],
			[
				[
					7024619,
					545443
				],
				[
					-912,
					4378
				]
			],
			[
				[
					7023707,
					549821
				],
				[
					-3009,
					12133
				]
			],
			[
				[
					7019854,
					566014
				],
				[
					10000,
					4720
				]
			],
			[
				[
					7036244,
					527580
				],
				[
					-7191,
					-3836
				]
			],
			[
				[
					7029053,
					523744
				],
				[
					-2694,
					13282
				]
			],
			[
				[
					7026359,
					537026
				],
				[
					-256,
					4519
				]
			],
			[
				[
					7024619,
					545443
				],
				[
					-912,
					4378
				]
			],
			[
				[
					7024619,
					545443
				],
				[
					-5174,
					-7101
				]
			],
			[
				[
					7019445,
					538342
				],
				[
					-3857,
					-1945
				]
			],
			[
				[
					7015588,
					536397
				],
				[
					-827,
					4222
				]
			],
			[
				[
					7014761,
					540619
				],
				[
					-951,
					4287
				]
			],
			[
				[
					7013810,
					544906
				],
				[
					-1686,
					8092
				]
			],
			[
				[
					7029053,
					523744
				],
				[
					-9992,
					-4601
				]
			],
			[
				[
					7019061,
					519143
				],
				[
					-943,
					4647
				]
			],
			[
				[
					7018118,
					523790
				],
				[
					2169,
					10296
				]
			],
			[
				[
					7020287,
					534086
				],
				[
					6072,
					2940
				]
			],
			[
				[
					7019445,
					538342
				],
				[
					842,
					-4256
				]
			],
			[
				[
					7018118,
					523790
				],
				[
					-2530,
					12607
				]
			],
			[
				[
					7015782,
					517213
				],
				[
					-4434,
					-2278
				]
			],
			[
				[
					7011348,
					514935
				],
				[
					-2552,
					6561
				]
			],
			[
				[
					7008796,
					521496
				],
				[
					-474,
					2145
				]
			],
			[
				[
					7008322,
					523641
				],
				[
					4428,
					2547
				]
			],
			[
				[
					7012750,
					526188
				],
				[
					3032,
					-8975
				]
			],
			[
				[
					7008322,
					523641
				],
				[
					-2611,
					12559
				]
			],
			[
				[
					7011413,
					538989
				],
				[
					1337,
					-12801
				]
			],
			[
				[
					7001219,
					522675
				],
				[
					0,
					0
				]
			],
			[
				[
					6999202,
					526528
				],
				[
					-1683,
					-7060
				]
			],
			[
				[
					6997519,
					519468
				],
				[
					-1055,
					4958
				]
			],
			[
				[
					6996464,
					524426
				],
				[
					-1341,
					6644
				]
			],
			[
				[
					7008796,
					521496
				],
				[
					-8256,
					-9298
				]
			],
			[
				[
					7000540,
					512198
				],
				[
					-2864,
					6517
				]
			],
			[
				[
					6997676,
					518715
				],
				[
					9536,
					4400
				],
				[
					-3852,
					7158
				]
			],
			[
				[
					7006524,
					527043
				],
				[
					0,
					0
				]
			],
			[
				[
					7011348,
					514935
				],
				[
					-8686,
					-5189
				]
			],
			[
				[
					7002662,
					509746
				],
				[
					-2122,
					2452
				]
			],
			[
				[
					6997676,
					518715
				],
				[
					-157,
					753
				]
			],
			[
				[
					7010475,
					543198
				],
				[
					3335,
					1708
				]
			],
			[
				[
					7014761,
					540619
				],
				[
					-3348,
					-1630
				]
			],
			[
				[
					6993279,
					539474
				],
				[
					-1792,
					8500
				]
			],
			[
				[
					6991487,
					547974
				],
				[
					4671,
					6912
				]
			],
			[
				[
					6998893,
					556241
				],
				[
					8997,
					4463
				]
			],
			[
				[
					7019061,
					519143
				],
				[
					-3279,
					-1930
				]
			],
			[
				[
					7021967,
					305853
				],
				[
					4137,
					-8719
				],
				[
					-8106,
					-8104
				]
			],
			[
				[
					7001680,
					346991
				],
				[
					0,
					0
				]
			],
			[
				[
					7010794,
					353838
				],
				[
					-2832,
					-13818
				]
			],
			[
				[
					7007962,
					340020
				],
				[
					-5598,
					1898
				]
			],
			[
				[
					7002364,
					341918
				],
				[
					-244,
					3831
				]
			],
			[
				[
					7002120,
					345749
				],
				[
					2181,
					7644
				]
			],
			[
				[
					7006133,
					351558
				],
				[
					0,
					0
				]
			],
			[
				[
					7002930,
					353493
				],
				[
					-1310,
					-4518
				]
			],
			[
				[
					7001620,
					348975
				],
				[
					685,
					-11809
				]
			],
			[
				[
					7002305,
					337166
				],
				[
					4133,
					-9312
				],
				[
					5422,
					4821
				]
			],
			[
				[
					7011860,
					332675
				],
				[
					1123,
					-18818
				]
			],
			[
				[
					7003805,
					310186
				],
				[
					1018,
					9755
				]
			],
			[
				[
					6993198,
					337397
				],
				[
					2657,
					8298
				]
			],
			[
				[
					6997177,
					350053
				],
				[
					1389,
					3113
				]
			],
			[
				[
					6998566,
					353166
				],
				[
					855,
					82
				]
			],
			[
				[
					7007962,
					340020
				],
				[
					3898,
					-7345
				]
			],
			[
				[
					7002305,
					337166
				],
				[
					59,
					4752
				]
			],
			[
				[
					7001620,
					348975
				],
				[
					500,
					-3226
				]
			],
			[
				[
					6996781,
					352338
				],
				[
					1785,
					828
				]
			],
			[
				[
					6992844,
					372110
				],
				[
					216,
					-7686
				]
			],
			[
				[
					6993491,
					358435
				],
				[
					-2440,
					754
				]
			],
			[
				[
					6991051,
					359189
				],
				[
					-1487,
					739
				]
			],
			[
				[
					6989564,
					359928
				],
				[
					-479,
					10491
				]
			],
			[
				[
					6989085,
					370419
				],
				[
					3746,
					2441
				]
			],
			[
				[
					6989564,
					359928
				],
				[
					-4643,
					1233
				]
			],
			[
				[
					6984921,
					361161
				],
				[
					-364,
					-554
				]
			],
			[
				[
					6984557,
					360607
				],
				[
					-529,
					68
				]
			],
			[
				[
					6984028,
					360675
				],
				[
					-946,
					4835
				]
			],
			[
				[
					6983082,
					365510
				],
				[
					6003,
					4909
				]
			],
			[
				[
					6995277,
					351751
				],
				[
					-1405,
					-1059
				]
			],
			[
				[
					6993872,
					350692
				],
				[
					-3251,
					1709
				]
			],
			[
				[
					6990621,
					352401
				],
				[
					430,
					6788
				]
			],
			[
				[
					6990621,
					352401
				],
				[
					-2598,
					861
				]
			],
			[
				[
					6988023,
					353262
				],
				[
					-3102,
					7899
				]
			],
			[
				[
					6984028,
					360675
				],
				[
					445,
					-4717
				]
			],
			[
				[
					6984473,
					355958
				],
				[
					1454,
					-9080
				]
			],
			[
				[
					6979802,
					362385
				],
				[
					3280,
					3125
				]
			],
			[
				[
					6988023,
					353262
				],
				[
					-2096,
					-6384
				]
			],
			[
				[
					6984473,
					355958
				],
				[
					84,
					4649
				]
			],
			[
				[
					6993872,
					350692
				],
				[
					-5664,
					-4362
				]
			],
			[
				[
					6982851,
					319688
				],
				[
					1030,
					-10677
				]
			],
			[
				[
					6998449,
					305368
				],
				[
					-12771,
					-458
				]
			],
			[
				[
					6986106,
					308974
				],
				[
					-924,
					15578
				]
			],
			[
				[
					6997724,
					288271
				],
				[
					-22150,
					-3356
				]
			],
			[
				[
					6942385,
					357361
				],
				[
					1417,
					7724
				]
			],
			[
				[
					6943802,
					365085
				],
				[
					1533,
					7483
				]
			],
			[
				[
					6945335,
					372568
				],
				[
					12366,
					-7373
				]
			],
			[
				[
					6981430,
					528067
				],
				[
					426,
					2979
				]
			],
			[
				[
					6981856,
					531046
				],
				[
					1187,
					576
				]
			],
			[
				[
					6983043,
					531622
				],
				[
					5576,
					3018
				]
			],
			[
				[
					6988619,
					534640
				],
				[
					695,
					-6595
				]
			],
			[
				[
					6989314,
					528045
				],
				[
					-5426,
					-3396
				]
			],
			[
				[
					6983888,
					524649
				],
				[
					-2458,
					3418
				]
			],
			[
				[
					6981430,
					528067
				],
				[
					0,
					0
				]
			],
			[
				[
					6988326,
					537119
				],
				[
					-5771,
					-1066
				]
			],
			[
				[
					6982555,
					536053
				],
				[
					-1093,
					9757
				]
			],
			[
				[
					6981462,
					545810
				],
				[
					5588,
					2633
				]
			],
			[
				[
					6987050,
					548443
				],
				[
					1276,
					-11324
				]
			],
			[
				[
					6983888,
					524649
				],
				[
					-2735,
					-2459
				]
			],
			[
				[
					6981153,
					522190
				],
				[
					78,
					-641
				]
			],
			[
				[
					6981231,
					521549
				],
				[
					2006,
					-3662
				]
			],
			[
				[
					6983237,
					517887
				],
				[
					-3363,
					-1665
				]
			],
			[
				[
					6979874,
					516222
				],
				[
					-2759,
					-1385
				]
			],
			[
				[
					6977115,
					514837
				],
				[
					-1228,
					-579
				]
			],
			[
				[
					6975887,
					514258
				],
				[
					-2123,
					8146
				]
			],
			[
				[
					6973764,
					522404
				],
				[
					-501,
					4392
				]
			],
			[
				[
					6973263,
					526796
				],
				[
					8593,
					4250
				]
			],
			[
				[
					6980107,
					525583
				],
				[
					0,
					0
				]
			],
			[
				[
					6990175,
					521316
				],
				[
					-2848,
					-1417
				]
			],
			[
				[
					6987327,
					519899
				],
				[
					-4090,
					-2012
				]
			],
			[
				[
					6981231,
					521549
				],
				[
					-78,
					641
				]
			],
			[
				[
					6989314,
					528045
				],
				[
					861,
					-6729
				]
			],
			[
				[
					6989609,
					523611
				],
				[
					0,
					0
				]
			],
			[
				[
					6975887,
					514258
				],
				[
					-3532,
					-1727
				]
			],
			[
				[
					6972355,
					512531
				],
				[
					-4151,
					-1952
				]
			],
			[
				[
					6968204,
					510579
				],
				[
					-1075,
					8581
				]
			],
			[
				[
					6967129,
					519160
				],
				[
					496,
					915
				]
			],
			[
				[
					6967625,
					520075
				],
				[
					6139,
					2329
				]
			],
			[
				[
					6955222,
					744260
				],
				[
					13886,
					11822
				],
				[
					1493,
					-8866
				]
			],
			[
				[
					6969155,
					567869
				],
				[
					-9945,
					-4521
				]
			],
			[
				[
					6959210,
					563348
				],
				[
					-309,
					3564
				]
			],
			[
				[
					6958901,
					566912
				],
				[
					-804,
					7755
				]
			],
			[
				[
					6958097,
					574667
				],
				[
					2874,
					1461
				]
			],
			[
				[
					6960971,
					576128
				],
				[
					8184,
					-8259
				]
			],
			[
				[
					6978408,
					576094
				],
				[
					1041,
					-8918
				],
				[
					-7335,
					-3480
				]
			],
			[
				[
					6969281,
					566989
				],
				[
					-126,
					880
				]
			],
			[
				[
					6960971,
					576128
				],
				[
					5370,
					3451
				]
			],
			[
				[
					6958901,
					566912
				],
				[
					-2739,
					-1422
				]
			],
			[
				[
					6947184,
					571165
				],
				[
					6788,
					15475
				]
			],
			[
				[
					6953972,
					586640
				],
				[
					4125,
					-11973
				]
			],
			[
				[
					6957143,
					603111
				],
				[
					-3171,
					-16471
				]
			],
			[
				[
					6957731,
					609995
				],
				[
					-588,
					-6884
				]
			],
			[
				[
					6991487,
					547974
				],
				[
					-4437,
					469
				]
			],
			[
				[
					6981462,
					545810
				],
				[
					-2968,
					-1352
				]
			],
			[
				[
					6988463,
					579160
				],
				[
					2690,
					1275
				]
			],
			[
				[
					6967625,
					520075
				],
				[
					1102,
					9330
				]
			],
			[
				[
					6968727,
					529405
				],
				[
					4039,
					1743
				]
			],
			[
				[
					6972766,
					531148
				],
				[
					497,
					-4352
				]
			],
			[
				[
					6967129,
					519160
				],
				[
					-3289,
					3398
				]
			],
			[
				[
					6963840,
					522558
				],
				[
					-1253,
					11225
				]
			],
			[
				[
					6962587,
					533783
				],
				[
					6140,
					-4378
				]
			],
			[
				[
					6971628,
					540909
				],
				[
					131,
					-1052
				]
			],
			[
				[
					6971759,
					539857
				],
				[
					-9408,
					-4082
				]
			],
			[
				[
					6962351,
					535775
				],
				[
					-670,
					5267
				]
			],
			[
				[
					6961681,
					541042
				],
				[
					-884,
					8010
				]
			],
			[
				[
					6960797,
					549052
				],
				[
					10487,
					4883
				]
			],
			[
				[
					6960797,
					549052
				],
				[
					-1587,
					14296
				]
			],
			[
				[
					6946681,
					519283
				],
				[
					-2371,
					-2281
				]
			],
			[
				[
					6953922,
					517859
				],
				[
					-4524,
					2775
				]
			],
			[
				[
					6948925,
					524957
				],
				[
					4245,
					1843
				]
			],
			[
				[
					6953170,
					526800
				],
				[
					752,
					-8941
				]
			],
			[
				[
					6949674,
					521010
				],
				[
					0,
					0
				]
			],
			[
				[
					6946722,
					534255
				],
				[
					5341,
					2436
				]
			],
			[
				[
					6952063,
					536691
				],
				[
					108,
					-932
				]
			],
			[
				[
					6952171,
					535759
				],
				[
					-3729,
					-6261
				]
			],
			[
				[
					6968204,
					510579
				],
				[
					-1864,
					-865
				]
			],
			[
				[
					6966340,
					509714
				],
				[
					-3426,
					-1566
				]
			],
			[
				[
					6962914,
					508148
				],
				[
					-367,
					-154
				]
			],
			[
				[
					6962547,
					507994
				],
				[
					-1,
					-1
				]
			],
			[
				[
					6962546,
					507993
				],
				[
					-1468,
					13355
				]
			],
			[
				[
					6961078,
					521348
				],
				[
					2762,
					1210
				]
			],
			[
				[
					6962546,
					507993
				],
				[
					-5839,
					-2832
				]
			],
			[
				[
					6956707,
					505161
				],
				[
					-1497,
					-691
				]
			],
			[
				[
					6955210,
					504470
				],
				[
					-52,
					-25
				]
			],
			[
				[
					6955158,
					504445
				],
				[
					-1236,
					13414
				]
			],
			[
				[
					6953922,
					517859
				],
				[
					7156,
					3489
				]
			],
			[
				[
					6955158,
					504445
				],
				[
					-5107,
					-2304
				]
			],
			[
				[
					6950051,
					502141
				],
				[
					-5687,
					-2730
				]
			],
			[
				[
					6944364,
					499411
				],
				[
					-1068,
					-212
				]
			],
			[
				[
					6943296,
					499199
				],
				[
					-938,
					3942
				]
			],
			[
				[
					6942358,
					503141
				],
				[
					-3407,
					12579
				]
			],
			[
				[
					6952171,
					535759
				],
				[
					999,
					-8959
				]
			],
			[
				[
					6946035,
					643981
				],
				[
					877,
					3602
				]
			],
			[
				[
					6946912,
					647583
				],
				[
					307,
					143
				]
			],
			[
				[
					6947219,
					647726
				],
				[
					-1184,
					-3745
				]
			],
			[
				[
					6944244,
					647682
				],
				[
					0,
					0
				]
			],
			[
				[
					6931919,
					655768
				],
				[
					551,
					-18156
				]
			],
			[
				[
					6928947,
					651692
				],
				[
					493,
					223
				]
			],
			[
				[
					6934866,
					660064
				],
				[
					-2947,
					-4296
				]
			],
			[
				[
					6943928,
					653114
				],
				[
					-1934,
					-528
				]
			],
			[
				[
					6941994,
					652586
				],
				[
					-7128,
					7478
				]
			],
			[
				[
					6941994,
					652586
				],
				[
					4918,
					-5003
				]
			],
			[
				[
					6946035,
					643981
				],
				[
					-180,
					-85
				]
			],
			[
				[
					6945855,
					643896
				],
				[
					-4711,
					-5316
				]
			],
			[
				[
					6941144,
					638580
				],
				[
					-3778,
					-5022
				]
			],
			[
				[
					6937366,
					633558
				],
				[
					-4161,
					-1988
				]
			],
			[
				[
					6957767,
					603399
				],
				[
					-624,
					-288
				]
			],
			[
				[
					6957883,
					631095
				],
				[
					264,
					30100
				]
			],
			[
				[
					6908197,
					740832
				],
				[
					9432,
					9574
				]
			],
			[
				[
					6917629,
					750406
				],
				[
					2014,
					-9482
				]
			],
			[
				[
					6962587,
					533783
				],
				[
					-236,
					1992
				]
			],
			[
				[
					6971759,
					539857
				],
				[
					1007,
					-8709
				]
			],
			[
				[
					6946618,
					487305
				],
				[
					-4741,
					-1732
				]
			],
			[
				[
					6941877,
					485573
				],
				[
					1519,
					10373
				]
			],
			[
				[
					6943396,
					495946
				],
				[
					3222,
					-8641
				]
			],
			[
				[
					6947755,
					483667
				],
				[
					-688,
					2568
				]
			],
			[
				[
					6947067,
					486235
				],
				[
					688,
					-2568
				]
			],
			[
				[
					6948835,
					479442
				],
				[
					478,
					320
				]
			],
			[
				[
					6949313,
					479762
				],
				[
					143,
					-7826
				]
			],
			[
				[
					6949456,
					471936
				],
				[
					-1895,
					-3679
				]
			],
			[
				[
					6947561,
					468257
				],
				[
					-1821,
					-3536
				]
			],
			[
				[
					6945740,
					464721
				],
				[
					-7016,
					8936
				]
			],
			[
				[
					6938724,
					473657
				],
				[
					10111,
					5785
				]
			],
			[
				[
					6952402,
					464037
				],
				[
					-1030,
					-2052
				]
			],
			[
				[
					6951372,
					461985
				],
				[
					-3811,
					6272
				]
			],
			[
				[
					6949456,
					471936
				],
				[
					2946,
					-7899
				]
			],
			[
				[
					6951372,
					461985
				],
				[
					-1603,
					-3142
				]
			],
			[
				[
					6949769,
					458843
				],
				[
					-4029,
					5878
				]
			],
			[
				[
					6945740,
					464721
				],
				[
					-1852,
					-3410
				]
			],
			[
				[
					6943888,
					461311
				],
				[
					-1007,
					873
				]
			],
			[
				[
					6942881,
					462184
				],
				[
					-4391,
					6291
				]
			],
			[
				[
					6938490,
					468475
				],
				[
					-709,
					2415
				]
			],
			[
				[
					6937781,
					470890
				],
				[
					943,
					2767
				]
			],
			[
				[
					6949769,
					458843
				],
				[
					-1900,
					-3718
				]
			],
			[
				[
					6947869,
					455125
				],
				[
					-3981,
					6186
				]
			],
			[
				[
					6947869,
					455125
				],
				[
					-1000,
					-2386
				]
			],
			[
				[
					6946869,
					452739
				],
				[
					-5819,
					6646
				]
			],
			[
				[
					6941050,
					459385
				],
				[
					1831,
					2799
				]
			],
			[
				[
					6946869,
					452739
				],
				[
					-106,
					-306
				]
			],
			[
				[
					6946763,
					452433
				],
				[
					-8412,
					1217
				]
			],
			[
				[
					6938351,
					453650
				],
				[
					1094,
					2288
				]
			],
			[
				[
					6939445,
					455938
				],
				[
					1605,
					3447
				]
			],
			[
				[
					6951973,
					455166
				],
				[
					-2204,
					3677
				]
			],
			[
				[
					6952402,
					464037
				],
				[
					1840,
					-5787
				]
			],
			[
				[
					6954242,
					458250
				],
				[
					-2149,
					-3584
				]
			],
			[
				[
					6952093,
					454666
				],
				[
					-120,
					500
				]
			],
			[
				[
					6949348,
					450897
				],
				[
					-611,
					215
				]
			],
			[
				[
					6948737,
					451112
				],
				[
					611,
					-215
				]
			],
			[
				[
					6952093,
					454666
				],
				[
					-5330,
					-2233
				]
			],
			[
				[
					6951973,
					455166
				],
				[
					0,
					0
				]
			],
			[
				[
					6949348,
					450897
				],
				[
					-1762,
					-6900
				]
			],
			[
				[
					6947586,
					443997
				],
				[
					-4091,
					2723
				]
			],
			[
				[
					6943495,
					446720
				],
				[
					-2356,
					2233
				]
			],
			[
				[
					6941139,
					448953
				],
				[
					133,
					155
				]
			],
			[
				[
					6941272,
					449108
				],
				[
					7465,
					2004
				]
			],
			[
				[
					6947586,
					443997
				],
				[
					-2577,
					-9851
				]
			],
			[
				[
					6945009,
					434146
				],
				[
					-4944,
					7769
				]
			],
			[
				[
					6940065,
					441915
				],
				[
					-376,
					595
				]
			],
			[
				[
					6939689,
					442510
				],
				[
					3806,
					4210
				]
			],
			[
				[
					6939689,
					442510
				],
				[
					-1367,
					1094
				]
			],
			[
				[
					6938322,
					443604
				],
				[
					2817,
					5349
				]
			],
			[
				[
					6938322,
					443604
				],
				[
					-4857,
					1528
				]
			],
			[
				[
					6933465,
					445132
				],
				[
					4786,
					8743
				]
			],
			[
				[
					6938251,
					453875
				],
				[
					3021,
					-4767
				]
			],
			[
				[
					6938351,
					453650
				],
				[
					-3775,
					7432
				]
			],
			[
				[
					6934576,
					461082
				],
				[
					595,
					1168
				]
			],
			[
				[
					6935171,
					462250
				],
				[
					4274,
					-6312
				]
			],
			[
				[
					6934527,
					460989
				],
				[
					3724,
					-7114
				]
			],
			[
				[
					6933465,
					445132
				],
				[
					-242,
					-321
				]
			],
			[
				[
					6929451,
					451322
				],
				[
					5076,
					9667
				]
			],
			[
				[
					6934515,
					463277
				],
				[
					656,
					-1027
				]
			],
			[
				[
					6934576,
					461082
				],
				[
					-61,
					2195
				]
			],
			[
				[
					6932759,
					468125
				],
				[
					460,
					-2336
				]
			],
			[
				[
					6933219,
					465789
				],
				[
					1308,
					-4800
				]
			],
			[
				[
					6926316,
					463355
				],
				[
					4851,
					7033
				]
			],
			[
				[
					6931167,
					470388
				],
				[
					1592,
					-2263
				]
			],
			[
				[
					6931925,
					471660
				],
				[
					-564,
					-1873
				]
			],
			[
				[
					6931361,
					469787
				],
				[
					-162,
					680
				]
			],
			[
				[
					6931199,
					470467
				],
				[
					726,
					1193
				]
			],
			[
				[
					6941050,
					459385
				],
				[
					-4431,
					8049
				]
			],
			[
				[
					6936619,
					467434
				],
				[
					1871,
					1041
				]
			],
			[
				[
					6940672,
					483258
				],
				[
					-3029,
					-3648
				]
			],
			[
				[
					6937643,
					479610
				],
				[
					3029,
					3648
				]
			],
			[
				[
					6946618,
					487305
				],
				[
					449,
					-1070
				]
			],
			[
				[
					6947755,
					483667
				],
				[
					1080,
					-4225
				]
			],
			[
				[
					6937781,
					470890
				],
				[
					-2814,
					4417
				]
			],
			[
				[
					6934967,
					475307
				],
				[
					1554,
					4193
				]
			],
			[
				[
					6936521,
					479500
				],
				[
					1122,
					110
				]
			],
			[
				[
					6940672,
					483258
				],
				[
					1205,
					2315
				]
			],
			[
				[
					6934515,
					463277
				],
				[
					-1235,
					2563
				]
			],
			[
				[
					6933280,
					465840
				],
				[
					3339,
					1594
				]
			],
			[
				[
					6932759,
					468125
				],
				[
					460,
					-2336
				]
			],
			[
				[
					6933280,
					465840
				],
				[
					-1919,
					3947
				]
			],
			[
				[
					6931925,
					471660
				],
				[
					3042,
					3647
				]
			],
			[
				[
					6952063,
					536691
				],
				[
					9618,
					4351
				]
			],
			[
				[
					6996464,
					524426
				],
				[
					-3427,
					-1739
				]
			],
			[
				[
					6993037,
					522687
				],
				[
					-987,
					-480
				]
			],
			[
				[
					6992050,
					522207
				],
				[
					-1875,
					-891
				]
			],
			[
				[
					6988619,
					534640
				],
				[
					-293,
					2479
				]
			],
			[
				[
					6982555,
					536053
				],
				[
					488,
					-4431
				]
			],
			[
				[
					6940065,
					441915
				],
				[
					-2841,
					-14719
				]
			],
			[
				[
					6937224,
					427196
				],
				[
					-17,
					13
				]
			],
			[
				[
					6937207,
					427209
				],
				[
					-7149,
					11481
				]
			],
			[
				[
					6945009,
					434146
				],
				[
					-4543,
					-9257
				]
			],
			[
				[
					6940466,
					424889
				],
				[
					-3242,
					2307
				]
			],
			[
				[
					6940466,
					424889
				],
				[
					-2142,
					-4620
				]
			],
			[
				[
					6938324,
					420269
				],
				[
					-2058,
					2449
				]
			],
			[
				[
					6936266,
					422718
				],
				[
					941,
					4491
				]
			],
			[
				[
					6938324,
					420269
				],
				[
					-4552,
					-12526
				]
			],
			[
				[
					6933772,
					407743
				],
				[
					-3627,
					5721
				]
			],
			[
				[
					6930145,
					413464
				],
				[
					6121,
					9254
				]
			],
			[
				[
					6930145,
					413464
				],
				[
					-2206,
					3374
				]
			],
			[
				[
					6927939,
					416838
				],
				[
					-3145,
					4872
				]
			],
			[
				[
					6924794,
					421710
				],
				[
					-808,
					1247
				]
			],
			[
				[
					6923986,
					422957
				],
				[
					6072,
					15733
				]
			],
			[
				[
					6942358,
					503141
				],
				[
					-4066,
					-3385
				]
			],
			[
				[
					6938292,
					499756
				],
				[
					-4263,
					2450
				]
			],
			[
				[
					6934029,
					502206
				],
				[
					-4301,
					6742
				]
			],
			[
				[
					6929728,
					508948
				],
				[
					3715,
					6844
				]
			],
			[
				[
					6933443,
					515792
				],
				[
					3408,
					6695
				]
			],
			[
				[
					6934029,
					502206
				],
				[
					-4838,
					-9088
				]
			],
			[
				[
					6929191,
					493118
				],
				[
					-11,
					24
				]
			],
			[
				[
					6929180,
					493142
				],
				[
					-3099,
					8870
				]
			],
			[
				[
					6926081,
					502012
				],
				[
					3647,
					6936
				]
			],
			[
				[
					6938292,
					499756
				],
				[
					-5643,
					-10643
				]
			],
			[
				[
					6932649,
					489113
				],
				[
					-423,
					-816
				]
			],
			[
				[
					6932226,
					488297
				],
				[
					-3035,
					4821
				]
			],
			[
				[
					6943296,
					499199
				],
				[
					100,
					-3253
				]
			],
			[
				[
					6936521,
					479500
				],
				[
					-3872,
					9613
				]
			],
			[
				[
					6932226,
					488297
				],
				[
					-2473,
					-4759
				]
			],
			[
				[
					6929753,
					483538
				],
				[
					-3022,
					4811
				]
			],
			[
				[
					6926731,
					488349
				],
				[
					2449,
					4793
				]
			],
			[
				[
					6934967,
					475307
				],
				[
					-5214,
					8231
				]
			],
			[
				[
					6925230,
					473701
				],
				[
					-2790,
					-4296
				]
			],
			[
				[
					6919575,
					473854
				],
				[
					5655,
					-153
				]
			],
			[
				[
					6925183,
					473779
				],
				[
					-5636,
					121
				]
			],
			[
				[
					6919279,
					474353
				],
				[
					7452,
					13996
				]
			],
			[
				[
					6929753,
					483538
				],
				[
					-4570,
					-9759
				]
			],
			[
				[
					6925230,
					473701
				],
				[
					5937,
					-3313
				]
			],
			[
				[
					6931199,
					470467
				],
				[
					-6016,
					3312
				]
			],
			[
				[
					6926731,
					488349
				],
				[
					-4999,
					7812
				]
			],
			[
				[
					6921732,
					496161
				],
				[
					4349,
					5851
				]
			],
			[
				[
					6918477,
					475648
				],
				[
					-3305,
					5235
				]
			],
			[
				[
					6915172,
					480883
				],
				[
					6560,
					15278
				]
			],
			[
				[
					6915172,
					480883
				],
				[
					-3024,
					4783
				]
			],
			[
				[
					6909788,
					489414
				],
				[
					-25,
					39
				]
			],
			[
				[
					6909038,
					490594
				],
				[
					-2935,
					4657
				]
			],
			[
				[
					6903085,
					500060
				],
				[
					-1206,
					1947
				]
			],
			[
				[
					6901879,
					502007
				],
				[
					7243,
					14038
				],
				[
					-2973,
					4856
				],
				[
					12041,
					18704
				]
			],
			[
				[
					6918190,
					539605
				],
				[
					15253,
					-23813
				]
			],
			[
				[
					6918190,
					539605
				],
				[
					-6234,
					9769
				]
			],
			[
				[
					6918639,
					474849
				],
				[
					-7766,
					8631
				]
			],
			[
				[
					6910849,
					483518
				],
				[
					7155,
					-9058
				]
			],
			[
				[
					6919434,
					451183
				],
				[
					-11559,
					11351
				]
			],
			[
				[
					6907875,
					462534
				],
				[
					-1276,
					2005
				]
			],
			[
				[
					6900047,
					483622
				],
				[
					1851,
					14138
				]
			],
			[
				[
					6907875,
					462534
				],
				[
					-5591,
					-10763
				]
			],
			[
				[
					6902284,
					451771
				],
				[
					-11737,
					13493
				],
				[
					2371,
					4543
				],
				[
					-10586,
					15827
				]
			],
			[
				[
					6884931,
					490628
				],
				[
					3746,
					-1779
				]
			],
			[
				[
					6888677,
					488849
				],
				[
					5240,
					8819
				],
				[
					6130,
					-14046
				]
			],
			[
				[
					6901879,
					502007
				],
				[
					-12101,
					19176
				]
			],
			[
				[
					6886777,
					525908
				],
				[
					6465,
					14451
				],
				[
					16624,
					8036
				]
			],
			[
				[
					6933772,
					407743
				],
				[
					-4022,
					-6261
				]
			],
			[
				[
					6929750,
					401482
				],
				[
					-4041,
					6297
				]
			],
			[
				[
					6925709,
					407779
				],
				[
					-1391,
					8385
				]
			],
			[
				[
					6924318,
					416164
				],
				[
					3621,
					674
				]
			],
			[
				[
					6922946,
					418288
				],
				[
					1372,
					-2124
				]
			],
			[
				[
					6925709,
					407779
				],
				[
					-927,
					-4743
				]
			],
			[
				[
					6924782,
					403036
				],
				[
					-4056,
					6169
				]
			],
			[
				[
					6920726,
					409205
				],
				[
					2220,
					9083
				]
			],
			[
				[
					6922946,
					418288
				],
				[
					83,
					2779
				]
			],
			[
				[
					6923029,
					421067
				],
				[
					957,
					1890
				]
			],
			[
				[
					6924794,
					421710
				],
				[
					-1848,
					-3422
				]
			],
			[
				[
					6921927,
					422436
				],
				[
					-5300,
					-6699
				]
			],
			[
				[
					6916627,
					415737
				],
				[
					-5681,
					10290
				]
			],
			[
				[
					6910946,
					426027
				],
				[
					3564,
					7008
				],
				[
					7417,
					-10599
				]
			],
			[
				[
					6929750,
					401482
				],
				[
					-1960,
					-3171
				]
			],
			[
				[
					6927790,
					398311
				],
				[
					-3008,
					4725
				]
			],
			[
				[
					6915133,
					392720
				],
				[
					2341,
					-886
				]
			],
			[
				[
					6917474,
					391834
				],
				[
					-2341,
					886
				]
			],
			[
				[
					6915133,
					392720
				],
				[
					-1654,
					-1714
				]
			],
			[
				[
					6913479,
					391006
				],
				[
					-934,
					1591
				]
			],
			[
				[
					6915113,
					396561
				],
				[
					20,
					-3841
				]
			],
			[
				[
					6924782,
					403036
				],
				[
					-3123,
					-4008
				]
			],
			[
				[
					6921659,
					399028
				],
				[
					-3273,
					-5577
				]
			],
			[
				[
					6918386,
					393451
				],
				[
					-585,
					6148
				]
			],
			[
				[
					6917525,
					403184
				],
				[
					3201,
					6021
				]
			],
			[
				[
					6916627,
					415737
				],
				[
					-836,
					-9871
				]
			],
			[
				[
					6918386,
					393451
				],
				[
					-912,
					-1617
				]
			],
			[
				[
					6927790,
					398311
				],
				[
					-1940,
					-2233
				]
			],
			[
				[
					6925850,
					396078
				],
				[
					-3298,
					1186
				]
			],
			[
				[
					6922552,
					397264
				],
				[
					-893,
					1764
				]
			],
			[
				[
					6921927,
					422436
				],
				[
					1102,
					-1369
				]
			],
			[
				[
					6925850,
					396078
				],
				[
					87,
					-5458
				]
			],
			[
				[
					6925937,
					390620
				],
				[
					-617,
					376
				]
			],
			[
				[
					6925320,
					390996
				],
				[
					-2768,
					6268
				]
			],
			[
				[
					6925320,
					390996
				],
				[
					129,
					-951
				]
			],
			[
				[
					6925449,
					390045
				],
				[
					-7791,
					-2500
				]
			],
			[
				[
					6917658,
					387545
				],
				[
					-2912,
					-658
				]
			],
			[
				[
					6914746,
					386887
				],
				[
					-380,
					-93
				]
			],
			[
				[
					6914366,
					386794
				],
				[
					-887,
					4212
				]
			],
			[
				[
					6943802,
					365085
				],
				[
					-6769,
					2387
				]
			],
			[
				[
					6937033,
					367472
				],
				[
					-8853,
					6091
				]
			],
			[
				[
					6928180,
					373563
				],
				[
					82,
					442
				]
			],
			[
				[
					6928262,
					374005
				],
				[
					294,
					7951
				]
			],
			[
				[
					6928556,
					381956
				],
				[
					16779,
					-9388
				]
			],
			[
				[
					6937033,
					367472
				],
				[
					-8348,
					1739
				]
			],
			[
				[
					6928685,
					369211
				],
				[
					-505,
					4352
				]
			],
			[
				[
					6925937,
					390620
				],
				[
					2619,
					-8664
				]
			],
			[
				[
					6928262,
					374005
				],
				[
					-5269,
					2585
				]
			],
			[
				[
					6922993,
					376590
				],
				[
					2456,
					13455
				]
			],
			[
				[
					6923000,
					362286
				],
				[
					-74,
					4114
				]
			],
			[
				[
					6922926,
					366400
				],
				[
					5759,
					2811
				]
			],
			[
				[
					6922926,
					366400
				],
				[
					67,
					874
				]
			],
			[
				[
					6922993,
					367274
				],
				[
					-394,
					7203
				]
			],
			[
				[
					6922599,
					374477
				],
				[
					394,
					2113
				]
			],
			[
				[
					6922993,
					376590
				],
				[
					-3307,
					2301
				]
			],
			[
				[
					6919686,
					378891
				],
				[
					-1166,
					349
				]
			],
			[
				[
					6918520,
					379240
				],
				[
					-862,
					8305
				]
			],
			[
				[
					6922599,
					374477
				],
				[
					-1116,
					918
				]
			],
			[
				[
					6921483,
					375395
				],
				[
					-2235,
					1517
				]
			],
			[
				[
					6919248,
					376912
				],
				[
					438,
					1979
				]
			],
			[
				[
					6919248,
					376912
				],
				[
					-2330,
					317
				]
			],
			[
				[
					6916918,
					377229
				],
				[
					-585,
					7
				]
			],
			[
				[
					6916333,
					377236
				],
				[
					1080,
					2763
				]
			],
			[
				[
					6917413,
					379999
				],
				[
					1107,
					-759
				]
			],
			[
				[
					6916333,
					377236
				],
				[
					-6006,
					92
				]
			],
			[
				[
					6910327,
					377328
				],
				[
					4734,
					4132
				]
			],
			[
				[
					6915061,
					381460
				],
				[
					2352,
					-1461
				]
			],
			[
				[
					6906649,
					382823
				],
				[
					0,
					0
				]
			],
			[
				[
					6915061,
					381460
				],
				[
					-315,
					5427
				]
			],
			[
				[
					6910327,
					377328
				],
				[
					-1280,
					-450
				]
			],
			[
				[
					6909047,
					376878
				],
				[
					-64,
					731
				]
			],
			[
				[
					6908983,
					377609
				],
				[
					5383,
					9185
				]
			],
			[
				[
					6922993,
					367274
				],
				[
					-3116,
					1979
				]
			],
			[
				[
					6919877,
					369253
				],
				[
					1606,
					6142
				]
			],
			[
				[
					6919877,
					369253
				],
				[
					-2035,
					730
				]
			],
			[
				[
					6917842,
					369983
				],
				[
					1406,
					6929
				]
			],
			[
				[
					6918185,
					363590
				],
				[
					-787,
					4312
				]
			],
			[
				[
					6917398,
					367902
				],
				[
					444,
					2081
				]
			],
			[
				[
					6917398,
					367902
				],
				[
					-2112,
					1852
				]
			],
			[
				[
					6915286,
					369754
				],
				[
					1632,
					7475
				]
			],
			[
				[
					6911149,
					367061
				],
				[
					-509,
					1758
				]
			],
			[
				[
					6910640,
					368819
				],
				[
					-133,
					2614
				]
			],
			[
				[
					6910507,
					371433
				],
				[
					4779,
					-1679
				]
			],
			[
				[
					6910507,
					371433
				],
				[
					-180,
					5895
				]
			],
			[
				[
					6909047,
					376878
				],
				[
					1593,
					-8059
				]
			],
			[
				[
					6906567,
					348263
				],
				[
					-11042,
					8518
				]
			],
			[
				[
					6900596,
					369871
				],
				[
					1403,
					9098
				],
				[
					6984,
					-1360
				]
			],
			[
				[
					6886482,
					391908
				],
				[
					487,
					129
				]
			],
			[
				[
					6941144,
					638580
				],
				[
					-3778,
					-5022
				]
			],
			[
				[
					6947219,
					647726
				],
				[
					-1364,
					-3830
				]
			],
			[
				[
					7010294,
					561904
				],
				[
					-4757,
					23532
				],
				[
					9082,
					7597
				]
			],
			[
				[
					6896243,
					735153
				],
				[
					-8010,
					5073
				],
				[
					63,
					10125
				]
			],
			[
				[
					6889287,
					755193
				],
				[
					8094,
					-899
				],
				[
					1515,
					10540
				],
				[
					9244,
					3609
				],
				[
					5285,
					-6516
				],
				[
					-4949,
					-7615
				],
				[
					9153,
					-3906
				]
			],
			[
				[
					6905068,
					573635
				],
				[
					-756,
					6490
				]
			],
			[
				[
					6907165,
					440247
				],
				[
					-4881,
					11524
				]
			],
			[
				[
					6891892,
					553701
				],
				[
					0,
					0
				]
			],
			[
				[
					6885149,
					522744
				],
				[
					-1266,
					-2439
				]
			],
			[
				[
					6863262,
					689053
				],
				[
					23166,
					-13955
				]
			],
			[
				[
					6886428,
					675098
				],
				[
					141,
					-790
				]
			],
			[
				[
					6871620,
					667553
				],
				[
					-7905,
					502
				],
				[
					-453,
					20998
				]
			],
			[
				[
					6865664,
					683565
				],
				[
					0,
					0
				]
			],
			[
				[
					6886428,
					675098
				],
				[
					7412,
					-64
				],
				[
					9202,
					20440
				]
			],
			[
				[
					7000540,
					512198
				],
				[
					-7183,
					-1613
				]
			],
			[
				[
					6993357,
					510585
				],
				[
					-3138,
					-2112
				]
			],
			[
				[
					6990219,
					508473
				],
				[
					-810,
					-693
				]
			],
			[
				[
					6989409,
					507780
				],
				[
					-300,
					-191
				]
			],
			[
				[
					6989109,
					507589
				],
				[
					-869,
					6621
				]
			],
			[
				[
					6988240,
					514210
				],
				[
					3810,
					7997
				]
			],
			[
				[
					6993037,
					522687
				],
				[
					4639,
					-3972
				]
			],
			[
				[
					6993739,
					508475
				],
				[
					-382,
					2110
				]
			],
			[
				[
					7002662,
					509746
				],
				[
					-3312,
					-6716
				]
			],
			[
				[
					6999350,
					503030
				],
				[
					-5191,
					2947
				]
			],
			[
				[
					6994159,
					505977
				],
				[
					-305,
					1549
				]
			],
			[
				[
					6993854,
					507526
				],
				[
					-115,
					949
				]
			],
			[
				[
					6999350,
					503030
				],
				[
					-6810,
					-7513
				]
			],
			[
				[
					6992540,
					495517
				],
				[
					-502,
					2545
				]
			],
			[
				[
					6992038,
					498062
				],
				[
					671,
					1899
				]
			],
			[
				[
					6992709,
					499961
				],
				[
					1450,
					6016
				]
			],
			[
				[
					6993854,
					507526
				],
				[
					-3635,
					947
				]
			],
			[
				[
					6993739,
					508475
				],
				[
					0,
					0
				]
			],
			[
				[
					6992709,
					499961
				],
				[
					-2329,
					409
				]
			],
			[
				[
					6990380,
					500370
				],
				[
					-971,
					7410
				]
			],
			[
				[
					6990380,
					500370
				],
				[
					-2417,
					-32
				]
			],
			[
				[
					6987963,
					500338
				],
				[
					-1126,
					5550
				]
			],
			[
				[
					6986837,
					505888
				],
				[
					2272,
					1701
				]
			],
			[
				[
					6992038,
					498062
				],
				[
					-4080,
					-3759
				]
			],
			[
				[
					6987958,
					494303
				],
				[
					-1120,
					5548
				]
			],
			[
				[
					6986838,
					499851
				],
				[
					1125,
					487
				]
			],
			[
				[
					6987958,
					494303
				],
				[
					-642,
					-2940
				]
			],
			[
				[
					6987316,
					491363
				],
				[
					-1640,
					-4182
				]
			],
			[
				[
					6985676,
					487181
				],
				[
					-2427,
					8583
				]
			],
			[
				[
					6983249,
					495764
				],
				[
					630,
					659
				]
			],
			[
				[
					6983879,
					496423
				],
				[
					2959,
					3428
				]
			],
			[
				[
					6981475,
					492917
				],
				[
					0,
					0
				]
			],
			[
				[
					6985676,
					487181
				],
				[
					-2482,
					-2817
				]
			],
			[
				[
					6983194,
					484364
				],
				[
					-382,
					2008
				]
			],
			[
				[
					6982812,
					486372
				],
				[
					-929,
					4517
				]
			],
			[
				[
					6981883,
					490889
				],
				[
					-542,
					2764
				]
			],
			[
				[
					6981341,
					493653
				],
				[
					1908,
					2111
				]
			],
			[
				[
					6992540,
					495517
				],
				[
					-4430,
					-8311
				]
			],
			[
				[
					6988110,
					487206
				],
				[
					-794,
					4157
				]
			],
			[
				[
					6988110,
					487206
				],
				[
					-3952,
					-7094
				]
			],
			[
				[
					6984158,
					480112
				],
				[
					-964,
					4252
				]
			],
			[
				[
					6983879,
					496423
				],
				[
					-1459,
					8059
				]
			],
			[
				[
					6982420,
					504482
				],
				[
					1118,
					555
				]
			],
			[
				[
					6983538,
					505037
				],
				[
					3299,
					851
				]
			],
			[
				[
					6981341,
					493653
				],
				[
					-1163,
					3296
				]
			],
			[
				[
					6980178,
					496949
				],
				[
					-508,
					5934
				]
			],
			[
				[
					6979670,
					502883
				],
				[
					2750,
					1599
				]
			],
			[
				[
					6983538,
					505037
				],
				[
					-1365,
					6330
				]
			],
			[
				[
					6982173,
					511367
				],
				[
					5703,
					4576
				]
			],
			[
				[
					6987876,
					515943
				],
				[
					364,
					-1733
				]
			],
			[
				[
					6979670,
					502883
				],
				[
					-106,
					547
				]
			],
			[
				[
					6979564,
					503430
				],
				[
					-648,
					2891
				]
			],
			[
				[
					6978916,
					506321
				],
				[
					2912,
					4864
				]
			],
			[
				[
					6981828,
					511185
				],
				[
					345,
					182
				]
			],
			[
				[
					6981828,
					511185
				],
				[
					-1954,
					5037
				]
			],
			[
				[
					6987327,
					519899
				],
				[
					549,
					-3956
				]
			],
			[
				[
					6978916,
					506321
				],
				[
					-681,
					3077
				]
			],
			[
				[
					6978235,
					509398
				],
				[
					-1120,
					5439
				]
			],
			[
				[
					6978235,
					509398
				],
				[
					-5033,
					-1090
				]
			],
			[
				[
					6973202,
					508308
				],
				[
					-698,
					2021
				]
			],
			[
				[
					6972504,
					510329
				],
				[
					-149,
					2202
				]
			],
			[
				[
					6979564,
					503430
				],
				[
					-4523,
					-556
				]
			],
			[
				[
					6975041,
					502874
				],
				[
					-360,
					69
				]
			],
			[
				[
					6974681,
					502943
				],
				[
					-1479,
					5365
				]
			],
			[
				[
					6974681,
					502943
				],
				[
					-2741,
					-729
				]
			],
			[
				[
					6971940,
					502214
				],
				[
					-576,
					5230
				]
			],
			[
				[
					6971364,
					507444
				],
				[
					1140,
					2885
				]
			],
			[
				[
					6975041,
					502874
				],
				[
					1109,
					-1119
				]
			],
			[
				[
					6976150,
					501755
				],
				[
					-3620,
					-6124
				]
			],
			[
				[
					6972530,
					495631
				],
				[
					-1410,
					1424
				]
			],
			[
				[
					6971120,
					497055
				],
				[
					-410,
					4385
				]
			],
			[
				[
					6970710,
					501440
				],
				[
					1230,
					774
				]
			],
			[
				[
					6971364,
					507444
				],
				[
					-4311,
					-2053
				]
			],
			[
				[
					6967053,
					505391
				],
				[
					-713,
					4323
				]
			],
			[
				[
					6964194,
					477623
				],
				[
					0,
					0
				]
			],
			[
				[
					6970710,
					501440
				],
				[
					-1183,
					-1569
				]
			],
			[
				[
					6969527,
					499871
				],
				[
					-342,
					-465
				]
			],
			[
				[
					6969185,
					499406
				],
				[
					-3232,
					2378
				]
			],
			[
				[
					6965953,
					501784
				],
				[
					1100,
					3607
				]
			],
			[
				[
					6971120,
					497055
				],
				[
					-1405,
					534
				]
			],
			[
				[
					6969715,
					497589
				],
				[
					-188,
					2282
				]
			],
			[
				[
					6965953,
					501784
				],
				[
					-3039,
					6364
				]
			],
			[
				[
					6980178,
					496949
				],
				[
					-1845,
					-412
				]
			],
			[
				[
					6978333,
					496537
				],
				[
					-174,
					-71
				]
			],
			[
				[
					6978159,
					496466
				],
				[
					-2009,
					5289
				]
			],
			[
				[
					6978159,
					496466
				],
				[
					-5497,
					-2371
				]
			],
			[
				[
					6972662,
					494095
				],
				[
					-88,
					134
				]
			],
			[
				[
					6972574,
					494229
				],
				[
					-44,
					1402
				]
			],
			[
				[
					6979588,
					490721
				],
				[
					-1457,
					-2998
				]
			],
			[
				[
					6978131,
					487723
				],
				[
					-266,
					-31
				]
			],
			[
				[
					6977865,
					487692
				],
				[
					-102,
					2251
				]
			],
			[
				[
					6977763,
					489943
				],
				[
					-5101,
					4152
				]
			],
			[
				[
					6978333,
					496537
				],
				[
					1255,
					-5816
				]
			],
			[
				[
					6969185,
					499406
				],
				[
					-2522,
					-3748
				]
			],
			[
				[
					6966663,
					495658
				],
				[
					-1672,
					-1459
				]
			],
			[
				[
					6964991,
					494199
				],
				[
					-1684,
					4844
				]
			],
			[
				[
					6963307,
					499043
				],
				[
					-760,
					8951
				]
			],
			[
				[
					6963307,
					499043
				],
				[
					-2190,
					642
				]
			],
			[
				[
					6961117,
					499685
				],
				[
					-1716,
					-2089
				]
			],
			[
				[
					6959401,
					497596
				],
				[
					-765,
					1202
				]
			],
			[
				[
					6958636,
					498798
				],
				[
					-1929,
					6363
				]
			],
			[
				[
					6964991,
					494199
				],
				[
					-2720,
					-1259
				]
			],
			[
				[
					6962271,
					492940
				],
				[
					-1154,
					6745
				]
			],
			[
				[
					6959401,
					497596
				],
				[
					-1123,
					-6374
				]
			],
			[
				[
					6958278,
					491222
				],
				[
					-1187,
					-282
				]
			],
			[
				[
					6957091,
					490940
				],
				[
					-897,
					4756
				]
			],
			[
				[
					6956194,
					495696
				],
				[
					2442,
					3102
				]
			],
			[
				[
					6962271,
					492940
				],
				[
					-3993,
					-1718
				]
			],
			[
				[
					6956194,
					495696
				],
				[
					-1129,
					4080
				]
			],
			[
				[
					6955065,
					499776
				],
				[
					145,
					4694
				]
			],
			[
				[
					6981883,
					490889
				],
				[
					-2295,
					-168
				]
			],
			[
				[
					6982812,
					486372
				],
				[
					-4084,
					877
				]
			],
			[
				[
					6978728,
					487249
				],
				[
					-597,
					474
				]
			],
			[
				[
					6983194,
					484364
				],
				[
					-2687,
					-1723
				]
			],
			[
				[
					6980507,
					482641
				],
				[
					-1148,
					-960
				]
			],
			[
				[
					6979359,
					481681
				],
				[
					-631,
					5568
				]
			],
			[
				[
					6984158,
					480112
				],
				[
					-1327,
					-863
				]
			],
			[
				[
					6982831,
					479249
				],
				[
					-2324,
					3392
				]
			],
			[
				[
					6977763,
					489943
				],
				[
					-2640,
					-2499
				]
			],
			[
				[
					6975123,
					487444
				],
				[
					-1349,
					-2751
				]
			],
			[
				[
					6973774,
					484693
				],
				[
					-1126,
					969
				]
			],
			[
				[
					6972648,
					485662
				],
				[
					377,
					3321
				]
			],
			[
				[
					6973025,
					488983
				],
				[
					-166,
					3016
				]
			],
			[
				[
					6972859,
					491999
				],
				[
					-285,
					2230
				]
			],
			[
				[
					6977865,
					487692
				],
				[
					-1798,
					-892
				]
			],
			[
				[
					6976067,
					486800
				],
				[
					-944,
					644
				]
			],
			[
				[
					6979359,
					481681
				],
				[
					-927,
					-787
				]
			],
			[
				[
					6978432,
					480894
				],
				[
					-804,
					-712
				]
			],
			[
				[
					6977628,
					480182
				],
				[
					-1561,
					6618
				]
			],
			[
				[
					6977628,
					480182
				],
				[
					-2170,
					-1781
				]
			],
			[
				[
					6975458,
					478401
				],
				[
					-300,
					1055
				]
			],
			[
				[
					6975158,
					479456
				],
				[
					-292,
					482
				]
			],
			[
				[
					6974866,
					479938
				],
				[
					1201,
					6862
				]
			],
			[
				[
					6982831,
					479249
				],
				[
					-2771,
					-1502
				]
			],
			[
				[
					6980060,
					477747
				],
				[
					-1473,
					-703
				]
			],
			[
				[
					6978587,
					477044
				],
				[
					-155,
					3850
				]
			],
			[
				[
					6978587,
					477044
				],
				[
					-49,
					-2624
				]
			],
			[
				[
					6978538,
					474420
				],
				[
					-41,
					-37
				]
			],
			[
				[
					6978497,
					474383
				],
				[
					-2856,
					-74
				]
			],
			[
				[
					6975641,
					474309
				],
				[
					-183,
					4092
				]
			],
			[
				[
					6972678,
					491404
				],
				[
					0,
					0
				]
			],
			[
				[
					6972859,
					491999
				],
				[
					-2433,
					-1111
				]
			],
			[
				[
					6970426,
					490888
				],
				[
					-551,
					1738
				]
			],
			[
				[
					6969875,
					492626
				],
				[
					-160,
					4963
				]
			],
			[
				[
					6973025,
					488983
				],
				[
					-2364,
					-420
				]
			],
			[
				[
					6970661,
					488563
				],
				[
					-235,
					2325
				]
			],
			[
				[
					6970661,
					488563
				],
				[
					-1148,
					-515
				]
			],
			[
				[
					6969513,
					488048
				],
				[
					-644,
					4335
				]
			],
			[
				[
					6968869,
					492383
				],
				[
					1006,
					243
				]
			],
			[
				[
					6972648,
					485662
				],
				[
					-1732,
					230
				]
			],
			[
				[
					6970916,
					485892
				],
				[
					-255,
					2671
				]
			],
			[
				[
					6973774,
					484693
				],
				[
					-2302,
					-2318
				]
			],
			[
				[
					6971472,
					482375
				],
				[
					-556,
					3517
				]
			],
			[
				[
					6971472,
					482375
				],
				[
					-766,
					-722
				]
			],
			[
				[
					6970706,
					481653
				],
				[
					-1493,
					1577
				]
			],
			[
				[
					6969213,
					483230
				],
				[
					1703,
					2662
				]
			],
			[
				[
					6973448,
					480021
				],
				[
					0,
					0
				]
			],
			[
				[
					6974866,
					479938
				],
				[
					-1772,
					333
				]
			],
			[
				[
					6973094,
					480271
				],
				[
					-1431,
					-650
				]
			],
			[
				[
					6971663,
					479621
				],
				[
					-957,
					2032
				]
			],
			[
				[
					6975158,
					479456
				],
				[
					-1634,
					-1398
				]
			],
			[
				[
					6973524,
					478058
				],
				[
					-430,
					2213
				]
			],
			[
				[
					6973885,
					478963
				],
				[
					0,
					0
				]
			],
			[
				[
					6960329,
					467158
				],
				[
					100,
					167
				]
			],
			[
				[
					6960429,
					467325
				],
				[
					-100,
					-167
				]
			],
			[
				[
					6973524,
					478058
				],
				[
					-414,
					-185
				]
			],
			[
				[
					6973110,
					477873
				],
				[
					-722,
					-252
				]
			],
			[
				[
					6972388,
					477621
				],
				[
					-312,
					-135
				]
			],
			[
				[
					6972076,
					477486
				],
				[
					-413,
					2135
				]
			],
			[
				[
					6975641,
					474309
				],
				[
					-549,
					-501
				]
			],
			[
				[
					6975092,
					473808
				],
				[
					-1056,
					-427
				]
			],
			[
				[
					6974036,
					473381
				],
				[
					-383,
					1608
				]
			],
			[
				[
					6973653,
					474989
				],
				[
					-151,
					787
				]
			],
			[
				[
					6973502,
					475776
				],
				[
					-392,
					2097
				]
			],
			[
				[
					6973502,
					475776
				],
				[
					-680,
					-310
				]
			],
			[
				[
					6972822,
					475466
				],
				[
					-381,
					127
				]
			],
			[
				[
					6972441,
					475593
				],
				[
					-53,
					2028
				]
			],
			[
				[
					6973653,
					474989
				],
				[
					-648,
					-469
				]
			],
			[
				[
					6973005,
					474520
				],
				[
					-183,
					946
				]
			],
			[
				[
					6974036,
					473381
				],
				[
					-680,
					-480
				]
			],
			[
				[
					6973356,
					472901
				],
				[
					-586,
					1333
				]
			],
			[
				[
					6972770,
					474234
				],
				[
					235,
					286
				]
			],
			[
				[
					6957033,
					487693
				],
				[
					0,
					0
				]
			],
			[
				[
					6972441,
					475593
				],
				[
					-553,
					-553
				]
			],
			[
				[
					6971888,
					475040
				],
				[
					-73,
					357
				]
			],
			[
				[
					6971815,
					475397
				],
				[
					-339,
					2039
				]
			],
			[
				[
					6971476,
					477436
				],
				[
					600,
					50
				]
			],
			[
				[
					6971729,
					474591
				],
				[
					159,
					449
				]
			],
			[
				[
					6972770,
					474234
				],
				[
					-751,
					162
				]
			],
			[
				[
					6972019,
					474396
				],
				[
					-290,
					195
				]
			],
			[
				[
					6971652,
					471783
				],
				[
					47,
					234
				]
			],
			[
				[
					6971699,
					472017
				],
				[
					-47,
					-234
				]
			],
			[
				[
					6978497,
					474383
				],
				[
					-3405,
					-575
				]
			],
			[
				[
					6973356,
					472901
				],
				[
					-1463,
					-763
				]
			],
			[
				[
					6971893,
					472138
				],
				[
					126,
					2258
				]
			],
			[
				[
					6980060,
					477747
				],
				[
					-1522,
					-3327
				]
			],
			[
				[
					6968869,
					492383
				],
				[
					-1766,
					-799
				]
			],
			[
				[
					6967103,
					491584
				],
				[
					-440,
					4074
				]
			],
			[
				[
					6969513,
					488048
				],
				[
					-1928,
					-870
				]
			],
			[
				[
					6967585,
					487178
				],
				[
					-100,
					1077
				]
			],
			[
				[
					6967485,
					488255
				],
				[
					-382,
					3329
				]
			],
			[
				[
					6969213,
					483230
				],
				[
					-252,
					-112
				]
			],
			[
				[
					6968961,
					483118
				],
				[
					-1376,
					4060
				]
			],
			[
				[
					6971663,
					479621
				],
				[
					-2455,
					-1097
				]
			],
			[
				[
					6969208,
					478524
				],
				[
					-799,
					4335
				]
			],
			[
				[
					6968409,
					482859
				],
				[
					552,
					259
				]
			],
			[
				[
					6971476,
					477436
				],
				[
					-1942,
					-1041
				]
			],
			[
				[
					6969534,
					476395
				],
				[
					-39,
					-2
				]
			],
			[
				[
					6969495,
					476393
				],
				[
					-287,
					2131
				]
			],
			[
				[
					6971815,
					475397
				],
				[
					-1829,
					-997
				]
			],
			[
				[
					6969986,
					474400
				],
				[
					-452,
					1995
				]
			],
			[
				[
					6971729,
					474591
				],
				[
					0,
					0
				]
			],
			[
				[
					6971893,
					472138
				],
				[
					-194,
					-121
				]
			],
			[
				[
					6971652,
					471783
				],
				[
					-4227,
					-1832
				]
			],
			[
				[
					6967425,
					469951
				],
				[
					1698,
					3006
				]
			],
			[
				[
					6969123,
					472957
				],
				[
					863,
					1443
				]
			],
			[
				[
					6967103,
					491584
				],
				[
					-4524,
					-2025
				]
			],
			[
				[
					6962579,
					489559
				],
				[
					-308,
					3381
				]
			],
			[
				[
					6967485,
					488255
				],
				[
					-1252,
					-840
				]
			],
			[
				[
					6966233,
					487415
				],
				[
					-2991,
					-392
				]
			],
			[
				[
					6963242,
					487023
				],
				[
					-756,
					1142
				]
			],
			[
				[
					6962486,
					488165
				],
				[
					93,
					1394
				]
			],
			[
				[
					6968409,
					482859
				],
				[
					-1610,
					-679
				]
			],
			[
				[
					6966799,
					482180
				],
				[
					-385,
					-175
				]
			],
			[
				[
					6966414,
					482005
				],
				[
					-181,
					5410
				]
			],
			[
				[
					6966414,
					482005
				],
				[
					-2134,
					-1012
				]
			],
			[
				[
					6964280,
					480993
				],
				[
					-738,
					1901
				]
			],
			[
				[
					6963542,
					482894
				],
				[
					-300,
					4129
				]
			],
			[
				[
					6969495,
					476393
				],
				[
					-1587,
					-455
				]
			],
			[
				[
					6967908,
					475938
				],
				[
					-1109,
					6242
				]
			],
			[
				[
					6967908,
					475938
				],
				[
					-947,
					-374
				]
			],
			[
				[
					6966961,
					475564
				],
				[
					-1126,
					-618
				]
			],
			[
				[
					6965835,
					474946
				],
				[
					-908,
					4107
				]
			],
			[
				[
					6964927,
					479053
				],
				[
					-647,
					1940
				]
			],
			[
				[
					6969123,
					472957
				],
				[
					-2162,
					2607
				]
			],
			[
				[
					6967425,
					469951
				],
				[
					-4879,
					508
				]
			],
			[
				[
					6962546,
					470459
				],
				[
					-359,
					293
				]
			],
			[
				[
					6962187,
					470752
				],
				[
					2252,
					1217
				]
			],
			[
				[
					6964439,
					471969
				],
				[
					1396,
					2977
				]
			],
			[
				[
					6959158,
					487810
				],
				[
					-300,
					-139
				]
			],
			[
				[
					6958858,
					487671
				],
				[
					300,
					139
				]
			],
			[
				[
					6962486,
					488165
				],
				[
					-2667,
					-38
				]
			],
			[
				[
					6959819,
					488127
				],
				[
					-1541,
					3095
				]
			],
			[
				[
					6963542,
					482894
				],
				[
					-5531,
					207
				]
			],
			[
				[
					6958011,
					483101
				],
				[
					-1,
					32
				]
			],
			[
				[
					6958010,
					483133
				],
				[
					-266,
					2314
				]
			],
			[
				[
					6957744,
					485447
				],
				[
					1114,
					2224
				]
			],
			[
				[
					6959158,
					487810
				],
				[
					661,
					317
				]
			],
			[
				[
					6964927,
					479053
				],
				[
					-3796,
					-126
				]
			],
			[
				[
					6961131,
					478927
				],
				[
					-3349,
					-1006
				]
			],
			[
				[
					6957782,
					477921
				],
				[
					229,
					5180
				]
			],
			[
				[
					6965835,
					474946
				],
				[
					-2745,
					785
				]
			],
			[
				[
					6963090,
					475731
				],
				[
					-1959,
					3196
				]
			],
			[
				[
					6964439,
					471969
				],
				[
					-1349,
					3762
				]
			],
			[
				[
					6962187,
					470752
				],
				[
					-116,
					127
				]
			],
			[
				[
					6962071,
					470879
				],
				[
					-1996,
					2862
				]
			],
			[
				[
					6960075,
					473741
				],
				[
					-1541,
					4220
				]
			],
			[
				[
					6958534,
					477961
				],
				[
					-752,
					-40
				]
			],
			[
				[
					6960443,
					467752
				],
				[
					0,
					0
				]
			],
			[
				[
					6957017,
					460570
				],
				[
					-840,
					2591
				]
			],
			[
				[
					6956177,
					463161
				],
				[
					2907,
					3365
				]
			],
			[
				[
					6959084,
					466526
				],
				[
					1245,
					632
				]
			],
			[
				[
					6960429,
					467325
				],
				[
					1642,
					3554
				]
			],
			[
				[
					6962546,
					470459
				],
				[
					-5529,
					-9889
				]
			],
			[
				[
					6957017,
					460570
				],
				[
					-2775,
					-2320
				]
			],
			[
				[
					6952402,
					464037
				],
				[
					804,
					3537
				]
			],
			[
				[
					6953206,
					467574
				],
				[
					2971,
					-4413
				]
			],
			[
				[
					6956521,
					473590
				],
				[
					-133,
					-62
				]
			],
			[
				[
					6956388,
					473528
				],
				[
					133,
					62
				]
			],
			[
				[
					6956521,
					473590
				],
				[
					2013,
					4371
				]
			],
			[
				[
					6960075,
					473741
				],
				[
					-2194,
					486
				]
			],
			[
				[
					6957881,
					474227
				],
				[
					-1360,
					-637
				]
			],
			[
				[
					6959084,
					466526
				],
				[
					-1203,
					7701
				]
			],
			[
				[
					6953206,
					467574
				],
				[
					-413,
					2188
				]
			],
			[
				[
					6952793,
					469762
				],
				[
					2489,
					2847
				]
			],
			[
				[
					6955282,
					472609
				],
				[
					1106,
					919
				]
			],
			[
				[
					6955282,
					472609
				],
				[
					-1875,
					8824
				]
			],
			[
				[
					6953407,
					481433
				],
				[
					1343,
					641
				]
			],
			[
				[
					6954750,
					482074
				],
				[
					3260,
					1059
				]
			],
			[
				[
					6952793,
					469762
				],
				[
					-1897,
					10269
				]
			],
			[
				[
					6950896,
					480031
				],
				[
					2511,
					1402
				]
			],
			[
				[
					6949313,
					479762
				],
				[
					1071,
					1712
				]
			],
			[
				[
					6950384,
					481474
				],
				[
					512,
					-1443
				]
			],
			[
				[
					6955065,
					499776
				],
				[
					-3664,
					-1681
				]
			],
			[
				[
					6951401,
					498095
				],
				[
					-1350,
					4046
				]
			],
			[
				[
					6957091,
					490940
				],
				[
					-2208,
					-868
				]
			],
			[
				[
					6954883,
					490072
				],
				[
					-1247,
					4789
				]
			],
			[
				[
					6953636,
					494861
				],
				[
					-2235,
					3234
				]
			],
			[
				[
					6957744,
					485447
				],
				[
					-2861,
					4625
				]
			],
			[
				[
					6954750,
					482074
				],
				[
					-1502,
					7155
				]
			],
			[
				[
					6953248,
					489229
				],
				[
					1635,
					843
				]
			],
			[
				[
					6950384,
					481474
				],
				[
					2864,
					7755
				]
			],
			[
				[
					6953636,
					494861
				],
				[
					-9272,
					4550
				]
			],
			[
				[
					6966217,
					288133
				],
				[
					-5247,
					-8430
				],
				[
					-10464,
					3709
				]
			],
			[
				[
					6950506,
					283412
				],
				[
					7374,
					6855
				],
				[
					-3516,
					8021
				],
				[
					3424,
					11360
				]
			],
			[
				[
					6941901,
					321573
				],
				[
					-8782,
					-13025
				],
				[
					2658,
					-10147
				],
				[
					-7420,
					-1567
				],
				[
					-2527,
					-17131
				]
			],
			[
				[
					6925830,
					279703
				],
				[
					-21612,
					-11872
				],
				[
					-28089,
					-4171
				]
			],
			[
				[
					6876129,
					263660
				],
				[
					-2355,
					13068
				],
				[
					13553,
					4493
				],
				[
					-4624,
					13669
				]
			],
			[
				[
					6882703,
					294890
				],
				[
					3260,
					1057
				],
				[
					-4301,
					24821
				],
				[
					-6562,
					5014
				],
				[
					2500,
					8052
				]
			],
			[
				[
					6877600,
					333834
				],
				[
					12330,
					13144
				]
			],
			[
				[
					6889930,
					346978
				],
				[
					15524,
					-9547
				],
				[
					-5251,
					-16360
				],
				[
					11765,
					-9176
				],
				[
					2087,
					15338
				],
				[
					12263,
					6046
				]
			],
			[
				[
					6879566,
					370744
				],
				[
					-4119,
					-1547
				]
			],
			[
				[
					6875447,
					369197
				],
				[
					-819,
					4403
				]
			],
			[
				[
					6874628,
					373600
				],
				[
					3863,
					2712
				]
			],
			[
				[
					6876877,
					385214
				],
				[
					-9138,
					3962
				]
			],
			[
				[
					6867739,
					389176
				],
				[
					2160,
					10396
				]
			],
			[
				[
					6869899,
					399572
				],
				[
					2176,
					116
				]
			],
			[
				[
					6872075,
					399688
				],
				[
					3770,
					-2933
				]
			],
			[
				[
					6880147,
					396018
				],
				[
					8659,
					5429
				]
			],
			[
				[
					6819461,
					393104
				],
				[
					-5124,
					-8362
				]
			],
			[
				[
					6814337,
					384742
				],
				[
					-5309,
					-3450
				]
			],
			[
				[
					6809028,
					381292
				],
				[
					1517,
					-6319
				]
			],
			[
				[
					6810545,
					374973
				],
				[
					-2055,
					-8676
				]
			],
			[
				[
					6808490,
					366297
				],
				[
					-7816,
					24402
				],
				[
					-2370,
					-1526
				]
			],
			[
				[
					6798304,
					389173
				],
				[
					-1791,
					13954
				],
				[
					8380,
					-4765
				],
				[
					2992,
					13295
				]
			],
			[
				[
					6807885,
					411657
				],
				[
					11362,
					-137
				],
				[
					214,
					-18416
				]
			],
			[
				[
					6888235,
					405527
				],
				[
					-1285,
					11055
				],
				[
					-14638,
					-5100
				]
			],
			[
				[
					6872312,
					411482
				],
				[
					-920,
					3820
				]
			],
			[
				[
					6871392,
					415302
				],
				[
					13825,
					11432
				]
			],
			[
				[
					6885217,
					426734
				],
				[
					-20,
					12005
				]
			],
			[
				[
					6885197,
					438739
				],
				[
					-3418,
					5513
				]
			],
			[
				[
					6881779,
					444252
				],
				[
					4093,
					7009
				]
			],
			[
				[
					6841674,
					449249
				],
				[
					-9156,
					-5878
				],
				[
					1445,
					-13765
				]
			],
			[
				[
					6833963,
					429606
				],
				[
					2553,
					-4937
				]
			],
			[
				[
					6836516,
					424669
				],
				[
					1140,
					-2220
				]
			],
			[
				[
					6837656,
					422449
				],
				[
					2913,
					-5638
				]
			],
			[
				[
					6840569,
					416811
				],
				[
					1536,
					-2996
				]
			],
			[
				[
					6842105,
					413815
				],
				[
					6032,
					-9369
				]
			],
			[
				[
					6848137,
					404446
				],
				[
					6690,
					2490
				]
			],
			[
				[
					6854827,
					406936
				],
				[
					3614,
					-17652
				],
				[
					8548,
					-374
				]
			],
			[
				[
					6866989,
					388910
				],
				[
					-3234,
					-4235
				]
			],
			[
				[
					6863755,
					384675
				],
				[
					96,
					-564
				]
			],
			[
				[
					6863851,
					384111
				],
				[
					-728,
					-12392
				]
			],
			[
				[
					6863123,
					371719
				],
				[
					-5257,
					10212
				],
				[
					-7966,
					-2939
				]
			],
			[
				[
					6849900,
					378992
				],
				[
					-3714,
					20083
				],
				[
					-9359,
					1638
				]
			],
			[
				[
					6836827,
					400713
				],
				[
					-6530,
					12963
				],
				[
					-184,
					11848
				],
				[
					-16690,
					-572
				]
			],
			[
				[
					6813423,
					424952
				],
				[
					-6882,
					11297
				],
				[
					1249,
					12501
				],
				[
					9024,
					-7855
				],
				[
					3772,
					10379
				],
				[
					-8712,
					651
				],
				[
					1729,
					12806
				]
			],
			[
				[
					6813603,
					464731
				],
				[
					5532,
					14912
				]
			],
			[
				[
					6819135,
					479643
				],
				[
					4126,
					3175
				],
				[
					11227,
					-9766
				],
				[
					1958,
					6555
				]
			],
			[
				[
					6836446,
					479607
				],
				[
					-3173,
					-26195
				],
				[
					8401,
					-4163
				]
			],
			[
				[
					6888677,
					488849
				],
				[
					-3746,
					1779
				]
			],
			[
				[
					6841674,
					449249
				],
				[
					6611,
					21692
				],
				[
					-9621,
					12137
				]
			],
			[
				[
					6838664,
					483078
				],
				[
					-11021,
					16290
				],
				[
					2961,
					11504
				],
				[
					17205,
					-13499
				]
			],
			[
				[
					6847809,
					497373
				],
				[
					11498,
					-17376
				],
				[
					11208,
					14799
				],
				[
					-6122,
					4968
				]
			],
			[
				[
					6864393,
					499764
				],
				[
					-8712,
					9077
				]
			],
			[
				[
					6855681,
					508841
				],
				[
					-6192,
					9304
				],
				[
					8023,
					6438
				]
			],
			[
				[
					6887334,
					457387
				],
				[
					-1580,
					-1871
				],
				[
					-18489,
					24282
				],
				[
					-6135,
					-9387
				],
				[
					5082,
					-14877
				],
				[
					-4042,
					-6280
				],
				[
					4480,
					-14649
				]
			],
			[
				[
					6866650,
					434605
				],
				[
					-1898,
					-1314
				]
			],
			[
				[
					6864752,
					433291
				],
				[
					-6534,
					-6575
				]
			],
			[
				[
					6858218,
					426716
				],
				[
					-3075,
					2519
				]
			],
			[
				[
					6855143,
					429235
				],
				[
					-319,
					4548
				]
			],
			[
				[
					6854824,
					433783
				],
				[
					-5296,
					11409
				],
				[
					-7854,
					4057
				]
			],
			[
				[
					6839932,
					669531
				],
				[
					2890,
					1326
				]
			],
			[
				[
					6842822,
					670857
				],
				[
					5092,
					-1776
				],
				[
					-1534,
					-21618
				],
				[
					22383,
					10447
				]
			],
			[
				[
					6853010,
					565575
				],
				[
					-8694,
					14411
				],
				[
					-11569,
					4583
				],
				[
					-1656,
					15784
				],
				[
					-14347,
					-3416
				],
				[
					-7241,
					38582
				]
			],
			[
				[
					6809503,
					635519
				],
				[
					8769,
					1883
				],
				[
					6227,
					10783
				],
				[
					-4317,
					22088
				],
				[
					3339,
					4606
				]
			],
			[
				[
					6823521,
					674879
				],
				[
					16411,
					-5348
				]
			],
			[
				[
					6872172,
					256387
				],
				[
					-21003,
					-31373
				],
				[
					22266,
					-13845
				],
				[
					23525,
					-2380
				],
				[
					-12926,
					-1701
				],
				[
					-24857,
					9180
				],
				[
					-25626,
					365
				]
			],
			[
				[
					6833551,
					216633
				],
				[
					-12477,
					13387
				],
				[
					322,
					24360
				]
			],
			[
				[
					6821396,
					254380
				],
				[
					4119,
					2651
				]
			],
			[
				[
					6825515,
					257031
				],
				[
					9883,
					3903
				]
			],
			[
				[
					6835398,
					260934
				],
				[
					11940,
					547
				]
			],
			[
				[
					6847338,
					261481
				],
				[
					3522,
					-10732
				],
				[
					17618,
					15510
				],
				[
					3694,
					-9872
				]
			],
			[
				[
					6855444,
					349615
				],
				[
					1972,
					-10263
				],
				[
					20184,
					-5518
				]
			],
			[
				[
					6882703,
					294890
				],
				[
					-26645,
					-6146
				]
			],
			[
				[
					6856058,
					288744
				],
				[
					-6804,
					-2230
				]
			],
			[
				[
					6849254,
					286514
				],
				[
					-3833,
					3595
				]
			],
			[
				[
					6845421,
					290109
				],
				[
					-3637,
					12699
				],
				[
					5518,
					6031
				],
				[
					-2246,
					12730
				],
				[
					-4879,
					-1780
				],
				[
					-3325,
					17483
				]
			],
			[
				[
					6836852,
					337272
				],
				[
					-1572,
					8876
				]
			],
			[
				[
					6835280,
					346148
				],
				[
					19202,
					8644
				]
			],
			[
				[
					6854482,
					354792
				],
				[
					962,
					-5177
				]
			],
			[
				[
					6874628,
					373600
				],
				[
					-11505,
					-1881
				]
			],
			[
				[
					6863851,
					384111
				],
				[
					-96,
					564
				]
			],
			[
				[
					6866989,
					388910
				],
				[
					359,
					136
				]
			],
			[
				[
					6867348,
					389046
				],
				[
					10154,
					-7208
				]
			],
			[
				[
					6855681,
					508841
				],
				[
					-7872,
					-11468
				]
			],
			[
				[
					6838664,
					483078
				],
				[
					-2218,
					-3471
				]
			],
			[
				[
					6819135,
					479643
				],
				[
					-33697,
					29786
				],
				[
					-15871,
					1945
				],
				[
					9988,
					-8646
				],
				[
					-2854,
					-7766
				],
				[
					10006,
					-8601
				],
				[
					2802,
					7730
				],
				[
					8807,
					-22747
				]
			],
			[
				[
					6798316,
					471344
				],
				[
					-4134,
					-11852
				],
				[
					-20621,
					17833
				],
				[
					-2837,
					-7704
				],
				[
					-13534,
					16976
				]
			],
			[
				[
					6757190,
					486597
				],
				[
					1413,
					3846
				],
				[
					-25723,
					24045
				],
				[
					1491,
					12324
				],
				[
					-6357,
					-1305
				],
				[
					-15772,
					13585
				]
			],
			[
				[
					6712242,
					539092
				],
				[
					1020,
					19558
				],
				[
					-7418,
					13121
				]
			],
			[
				[
					6705844,
					571771
				],
				[
					-365,
					310
				]
			],
			[
				[
					6705479,
					572081
				],
				[
					-349,
					286
				]
			],
			[
				[
					6705130,
					572367
				],
				[
					4979,
					16070
				]
			],
			[
				[
					6710109,
					588437
				],
				[
					7730,
					7283
				],
				[
					15134,
					-12811
				],
				[
					19725,
					11701
				],
				[
					-1239,
					8741
				],
				[
					-19874,
					12313
				],
				[
					-11270,
					-402
				]
			],
			[
				[
					6720315,
					615262
				],
				[
					334,
					20174
				],
				[
					8719,
					12708
				]
			],
			[
				[
					6729368,
					648144
				],
				[
					6771,
					-10938
				],
				[
					10543,
					21616
				],
				[
					15963,
					-17896
				],
				[
					24126,
					13551
				],
				[
					6243,
					-22737
				],
				[
					16489,
					3779
				]
			],
			[
				[
					6782369,
					603890
				],
				[
					4486,
					-14690
				],
				[
					-7353,
					-9330
				],
				[
					16700,
					4519
				],
				[
					9901,
					18037
				],
				[
					-4959,
					12283
				],
				[
					-18775,
					-10819
				]
			],
			[
				[
					6741857,
					582367
				],
				[
					0,
					0
				]
			],
			[
				[
					6842822,
					670857
				],
				[
					-2890,
					-1326
				]
			],
			[
				[
					6839932,
					669531
				],
				[
					3423,
					5752
				],
				[
					981,
					27379
				]
			],
			[
				[
					6844336,
					702662
				],
				[
					13912,
					-13646
				],
				[
					5014,
					37
				]
			],
			[
				[
					6831800,
					722133
				],
				[
					-8281,
					-7900
				]
			],
			[
				[
					6823519,
					714233
				],
				[
					-7130,
					-8252
				],
				[
					-12944,
					4244
				]
			],
			[
				[
					6803445,
					710225
				],
				[
					6093,
					15417
				],
				[
					8701,
					8645
				],
				[
					12433,
					-2317
				],
				[
					1128,
					-9837
				]
			],
			[
				[
					6798094,
					719031
				],
				[
					-9348,
					1154
				],
				[
					2385,
					-18564
				],
				[
					-16269,
					-2790
				],
				[
					318,
					-8856
				],
				[
					7760,
					1997
				],
				[
					6439,
					-24785
				],
				[
					14459,
					7495
				],
				[
					6451,
					13648
				],
				[
					10002,
					-1480
				]
			],
			[
				[
					6820291,
					686850
				],
				[
					3230,
					-11971
				]
			],
			[
				[
					6729368,
					648144
				],
				[
					3677,
					9841
				],
				[
					8293,
					3790
				],
				[
					8775,
					26665
				],
				[
					7559,
					15350
				],
				[
					-483,
					50022
				],
				[
					-9905,
					24107
				],
				[
					2161,
					14488
				],
				[
					-8025,
					2018
				],
				[
					-4475,
					18036
				],
				[
					-5780,
					6657
				],
				[
					-6908,
					27901
				],
				[
					-9879,
					-1711
				],
				[
					-7295,
					8233
				],
				[
					4628,
					8995
				],
				[
					25333,
					-6483
				],
				[
					18327,
					4291
				],
				[
					-3772,
					-26063
				],
				[
					6136,
					-5391
				],
				[
					368,
					-22795
				],
				[
					7168,
					-14942
				],
				[
					10360,
					48
				],
				[
					-4148,
					-12556
				],
				[
					10880,
					-2985
				],
				[
					4873,
					17604
				],
				[
					6456,
					-2670
				],
				[
					-7691,
					-15357
				],
				[
					-407,
					-14213
				],
				[
					-11025,
					-14780
				],
				[
					15951,
					8447
				],
				[
					9497,
					-3438
				],
				[
					2117,
					-14101
				],
				[
					-4040,
					-18121
				]
			],
			[
				[
					6833551,
					216633
				],
				[
					-20820,
					15493
				],
				[
					-13118,
					3942
				]
			],
			[
				[
					6799613,
					236068
				],
				[
					41,
					7923
				],
				[
					11363,
					5687
				],
				[
					-2541,
					18583
				],
				[
					4478,
					5618
				]
			],
			[
				[
					6812954,
					273879
				],
				[
					6489,
					-1593
				],
				[
					1953,
					-17906
				]
			],
			[
				[
					6825515,
					257031
				],
				[
					351,
					15976
				],
				[
					5491,
					11826
				]
			],
			[
				[
					6831357,
					284833
				],
				[
					4041,
					-23899
				]
			],
			[
				[
					6845421,
					290109
				],
				[
					-6961,
					-2218
				]
			],
			[
				[
					6838460,
					287891
				],
				[
					-6279,
					8543
				],
				[
					-10159,
					-3198
				],
				[
					-1242,
					10071
				],
				[
					-19816,
					-6295
				]
			],
			[
				[
					6800964,
					297012
				],
				[
					-465,
					3453
				]
			],
			[
				[
					6800499,
					300465
				],
				[
					-460,
					3551
				]
			],
			[
				[
					6800039,
					304016
				],
				[
					-1305,
					10155
				]
			],
			[
				[
					6798734,
					314171
				],
				[
					4508,
					5417
				],
				[
					17495,
					5084
				],
				[
					-715,
					4120
				]
			],
			[
				[
					6820022,
					328792
				],
				[
					16830,
					8480
				]
			],
			[
				[
					6809028,
					381292
				],
				[
					1517,
					-6319
				]
			],
			[
				[
					6808490,
					366297
				],
				[
					-3881,
					-9840
				],
				[
					4170,
					-16513
				],
				[
					8013,
					-9667
				]
			],
			[
				[
					6816792,
					330277
				],
				[
					-5050,
					-3415
				],
				[
					-6128,
					15734
				],
				[
					-8713,
					-5598
				]
			],
			[
				[
					6796901,
					336998
				],
				[
					-8903,
					37809
				]
			],
			[
				[
					6787998,
					374807
				],
				[
					-2645,
					11001
				]
			],
			[
				[
					6785353,
					385808
				],
				[
					11262,
					2280
				]
			],
			[
				[
					6796615,
					388088
				],
				[
					1689,
					1085
				]
			],
			[
				[
					6849900,
					378992
				],
				[
					4582,
					-24200
				]
			],
			[
				[
					6835280,
					346148
				],
				[
					-4429,
					19860
				],
				[
					-8349,
					-5757
				],
				[
					-8165,
					24491
				]
			],
			[
				[
					6819461,
					393104
				],
				[
					17366,
					7609
				]
			],
			[
				[
					6846915,
					367146
				],
				[
					0,
					0
				]
			],
			[
				[
					6777776,
					415642
				],
				[
					5447,
					5204
				]
			],
			[
				[
					6783223,
					420846
				],
				[
					-5447,
					-5204
				]
			],
			[
				[
					6783223,
					420846
				],
				[
					-7311,
					7008
				],
				[
					1864,
					-12212
				]
			],
			[
				[
					6777776,
					415642
				],
				[
					6699,
					-16988
				],
				[
					12140,
					-10566
				]
			],
			[
				[
					6785353,
					385808
				],
				[
					-22404,
					22932
				],
				[
					-4426,
					-981
				],
				[
					-7505,
					-19161
				]
			],
			[
				[
					6751018,
					388598
				],
				[
					-6063,
					1158
				],
				[
					-5597,
					30623
				],
				[
					6039,
					15222
				],
				[
					-12031,
					14349
				],
				[
					10270,
					23693
				],
				[
					7814,
					11199
				],
				[
					-6739,
					12608
				],
				[
					12479,
					-10853
				]
			],
			[
				[
					6798316,
					471344
				],
				[
					15287,
					-6613
				]
			],
			[
				[
					6813423,
					424952
				],
				[
					-2845,
					52
				]
			],
			[
				[
					6810578,
					425004
				],
				[
					-8494,
					140
				],
				[
					-7673,
					-9740
				],
				[
					-11188,
					5442
				]
			],
			[
				[
					6785415,
					235685
				],
				[
					-18036,
					1651
				]
			],
			[
				[
					6767379,
					237336
				],
				[
					-1824,
					13042
				]
			],
			[
				[
					6765555,
					250378
				],
				[
					9965,
					-7492
				],
				[
					5049,
					7961
				]
			],
			[
				[
					6780569,
					250847
				],
				[
					5013,
					713
				],
				[
					-167,
					-15875
				]
			],
			[
				[
					6746453,
					310785
				],
				[
					-1195,
					-3947
				]
			],
			[
				[
					6745258,
					306838
				],
				[
					8160,
					-32189
				]
			],
			[
				[
					6753418,
					274649
				],
				[
					4520,
					-25344
				]
			],
			[
				[
					6757938,
					249305
				],
				[
					-6969,
					-7946
				],
				[
					1101,
					-8144
				]
			],
			[
				[
					6752070,
					233215
				],
				[
					-27340,
					-26160
				],
				[
					-22029,
					-30051
				]
			],
			[
				[
					6702701,
					177004
				],
				[
					-782,
					24212
				],
				[
					-4973,
					11082
				],
				[
					-3233,
					47248
				]
			],
			[
				[
					6693713,
					259546
				],
				[
					6146,
					11991
				],
				[
					282,
					11740
				]
			],
			[
				[
					6700141,
					283277
				],
				[
					10356,
					-5911
				],
				[
					8525,
					9136
				],
				[
					11679,
					26492
				]
			],
			[
				[
					6730701,
					312994
				],
				[
					12930,
					9521
				]
			],
			[
				[
					6743631,
					322515
				],
				[
					2822,
					-11730
				]
			],
			[
				[
					6800039,
					304016
				],
				[
					460,
					-3551
				]
			],
			[
				[
					6800964,
					297012
				],
				[
					775,
					-6667
				],
				[
					9975,
					3174
				],
				[
					-373,
					-19113
				]
			],
			[
				[
					6811341,
					274406
				],
				[
					-2942,
					4144
				],
				[
					-27207,
					-3548
				]
			],
			[
				[
					6781192,
					275002
				],
				[
					-9543,
					9313
				]
			],
			[
				[
					6771649,
					284315
				],
				[
					4847,
					2566
				],
				[
					1208,
					18650
				]
			],
			[
				[
					6777704,
					305531
				],
				[
					-1896,
					14233
				]
			],
			[
				[
					6775808,
					319764
				],
				[
					2333,
					1530
				]
			],
			[
				[
					6778141,
					321294
				],
				[
					9339,
					6293
				]
			],
			[
				[
					6787480,
					327587
				],
				[
					2719,
					-11315
				],
				[
					8535,
					-2101
				]
			],
			[
				[
					6751018,
					388598
				],
				[
					18175,
					-18195
				],
				[
					3173,
					-13100
				],
				[
					11925,
					-6842
				],
				[
					-6133,
					25860
				],
				[
					9840,
					-1514
				]
			],
			[
				[
					6796901,
					336998
				],
				[
					-9421,
					-9411
				]
			],
			[
				[
					6778141,
					321294
				],
				[
					-9320,
					12065
				]
			],
			[
				[
					6768821,
					333359
				],
				[
					-12364,
					-4530
				]
			],
			[
				[
					6756457,
					328829
				],
				[
					-6332,
					-3976
				]
			],
			[
				[
					6750125,
					324853
				],
				[
					-6494,
					-2338
				]
			],
			[
				[
					6730701,
					312994
				],
				[
					-12229,
					19130
				],
				[
					-7993,
					-1782
				],
				[
					417,
					-22951
				],
				[
					4345,
					-5904
				],
				[
					-4957,
					-11826
				],
				[
					-10098,
					62
				]
			],
			[
				[
					6700186,
					289723
				],
				[
					-14245,
					-670
				],
				[
					-10224,
					5759
				],
				[
					250,
					24289
				],
				[
					3760,
					8904
				],
				[
					7687,
					-2977
				],
				[
					2581,
					12758
				],
				[
					-6216,
					9956
				],
				[
					859,
					25037
				]
			],
			[
				[
					6684638,
					372779
				],
				[
					13992,
					14440
				],
				[
					10544,
					27227
				],
				[
					-1011,
					58797
				]
			],
			[
				[
					6708163,
					473243
				],
				[
					10811,
					-102
				],
				[
					-2560,
					13945
				],
				[
					12301,
					17948
				],
				[
					-10462,
					4871
				],
				[
					1527,
					9159
				],
				[
					-6713,
					5830
				],
				[
					-825,
					14198
				]
			],
			[
				[
					6700186,
					289723
				],
				[
					-45,
					-6446
				]
			],
			[
				[
					6693713,
					259546
				],
				[
					-7589,
					-72
				],
				[
					-5783,
					-11330
				],
				[
					-4570,
					6160
				],
				[
					-26691,
					1461
				],
				[
					-11364,
					5406
				],
				[
					-14263,
					575
				]
			],
			[
				[
					6623453,
					261746
				],
				[
					-1631,
					10055
				],
				[
					2475,
					25040
				]
			],
			[
				[
					6624297,
					296841
				],
				[
					25567,
					2166
				],
				[
					292,
					17502
				],
				[
					-4923,
					8859
				]
			],
			[
				[
					6645233,
					325368
				],
				[
					8287,
					3853
				],
				[
					20407,
					30330
				],
				[
					-172,
					9720
				],
				[
					10883,
					3508
				]
			],
			[
				[
					6603385,
					86237
				],
				[
					190,
					5305
				]
			],
			[
				[
					6603575,
					91542
				],
				[
					-190,
					-5305
				]
			],
			[
				[
					6604050,
					106697
				],
				[
					-379,
					-12099
				]
			],
			[
				[
					6603671,
					94598
				],
				[
					-8082,
					2080
				]
			],
			[
				[
					6595589,
					96678
				],
				[
					-668,
					10703
				],
				[
					9129,
					-684
				]
			],
			[
				[
					6702701,
					177004
				],
				[
					-9084,
					-22341
				],
				[
					-10229,
					-14161
				],
				[
					-17664,
					-4010
				],
				[
					-30881,
					-27457
				],
				[
					-12642,
					-21697
				]
			],
			[
				[
					6622201,
					87338
				],
				[
					-8336,
					12615
				],
				[
					366,
					12025
				],
				[
					-9972,
					741
				]
			],
			[
				[
					6604259,
					112719
				],
				[
					4101,
					5241
				],
				[
					605,
					20924
				],
				[
					10088,
					654
				],
				[
					2440,
					11360
				]
			],
			[
				[
					6621493,
					150898
				],
				[
					7581,
					13078
				],
				[
					247,
					29389
				]
			],
			[
				[
					6629321,
					193365
				],
				[
					19221,
					31683
				],
				[
					299,
					17886
				],
				[
					-15886,
					3643
				],
				[
					-114,
					-20796
				],
				[
					-12393,
					1290
				],
				[
					-4762,
					-10533
				]
			],
			[
				[
					6615686,
					216538
				],
				[
					-2788,
					-72
				]
			],
			[
				[
					6612898,
					216466
				],
				[
					4245,
					6906
				],
				[
					6310,
					38374
				]
			],
			[
				[
					6655462,
					218552
				],
				[
					0,
					0
				]
			],
			[
				[
					6662739,
					206276
				],
				[
					-25141,
					-25207
				],
				[
					-3728,
					-17492
				],
				[
					10685,
					19222
				],
				[
					-3578,
					-31505
				],
				[
					10292,
					5568
				],
				[
					3839,
					-6702
				],
				[
					10761,
					18883
				],
				[
					8910,
					9104
				],
				[
					-13341,
					22182
				],
				[
					1301,
					5947
				]
			],
			[
				[
					6604159,
					36091
				],
				[
					2003,
					-19383
				],
				[
					-5945,
					-5804
				],
				[
					-1064,
					21556
				],
				[
					5006,
					3631
				]
			],
			[
				[
					6604259,
					112719
				],
				[
					-209,
					-6022
				]
			],
			[
				[
					6595589,
					96678
				],
				[
					-11882,
					2537
				],
				[
					-797,
					-23068
				]
			],
			[
				[
					6582910,
					76147
				],
				[
					-11181,
					-3900
				],
				[
					-15696,
					13164
				]
			],
			[
				[
					6556033,
					85411
				],
				[
					-1311,
					6900
				],
				[
					11326,
					-1444
				],
				[
					-3431,
					11924
				],
				[
					553,
					18432
				]
			],
			[
				[
					6563170,
					121223
				],
				[
					272,
					8485
				]
			],
			[
				[
					6563442,
					129708
				],
				[
					1496,
					3268
				]
			],
			[
				[
					6564938,
					132976
				],
				[
					4502,
					8385
				]
			],
			[
				[
					6569440,
					141361
				],
				[
					1895,
					712
				]
			],
			[
				[
					6571335,
					142073
				],
				[
					6478,
					2293
				]
			],
			[
				[
					6577813,
					144366
				],
				[
					5914,
					-369
				]
			],
			[
				[
					6583727,
					143997
				],
				[
					-3494,
					-24123
				],
				[
					-9105,
					-3730
				],
				[
					-2268,
					-15895
				],
				[
					19950,
					1519
				],
				[
					-1477,
					17697
				],
				[
					2051,
					24167
				],
				[
					-3856,
					250
				]
			],
			[
				[
					6585528,
					143882
				],
				[
					-1752,
					8734
				]
			],
			[
				[
					6583776,
					152616
				],
				[
					10404,
					-4207
				],
				[
					19356,
					4556
				],
				[
					7957,
					-2067
				]
			],
			[
				[
					6627098,
					194797
				],
				[
					-9581,
					-794
				],
				[
					-11890,
					12215
				],
				[
					7271,
					10248
				]
			],
			[
				[
					6615686,
					216538
				],
				[
					-1113,
					-15552
				],
				[
					12525,
					-6189
				]
			],
			[
				[
					6950506,
					283412
				],
				[
					-7057,
					-4981
				],
				[
					-6742,
					5989
				],
				[
					-10877,
					-4717
				]
			],
			[
				[
					6879192,
					435534
				],
				[
					607,
					-941
				]
			],
			[
				[
					6879799,
					434593
				],
				[
					-46,
					-116
				]
			],
			[
				[
					6879753,
					434477
				],
				[
					-5879,
					4787
				]
			],
			[
				[
					6873874,
					439264
				],
				[
					5318,
					-3730
				]
			],
			[
				[
					6880092,
					454346
				],
				[
					-2416,
					-3736
				]
			],
			[
				[
					6877676,
					450610
				],
				[
					-2275,
					-2459
				]
			],
			[
				[
					6875401,
					448151
				],
				[
					-3063,
					13278
				],
				[
					7754,
					-7083
				]
			],
			[
				[
					6879407,
					445910
				],
				[
					0,
					0
				]
			],
			[
				[
					6879594,
					447654
				],
				[
					540,
					-852
				]
			],
			[
				[
					6880134,
					446802
				],
				[
					-942,
					-11268
				]
			],
			[
				[
					6873874,
					439264
				],
				[
					-1647,
					4399
				]
			],
			[
				[
					6872227,
					443663
				],
				[
					462,
					1564
				]
			],
			[
				[
					6872689,
					445227
				],
				[
					2712,
					2924
				]
			],
			[
				[
					6877676,
					450610
				],
				[
					1918,
					-2956
				]
			],
			[
				[
					6885217,
					426734
				],
				[
					-4010,
					5650
				]
			],
			[
				[
					6881207,
					432384
				],
				[
					3990,
					6355
				]
			],
			[
				[
					6881779,
					444252
				],
				[
					-1645,
					2550
				]
			],
			[
				[
					6879594,
					447654
				],
				[
					498,
					6692
				]
			],
			[
				[
					6872689,
					445227
				],
				[
					-462,
					-1564
				]
			],
			[
				[
					6879753,
					434477
				],
				[
					2411,
					-6078
				],
				[
					-13019,
					-1431
				],
				[
					-2495,
					7637
				]
			],
			[
				[
					6867139,
					444858
				],
				[
					0,
					0
				]
			],
			[
				[
					6881207,
					432384
				],
				[
					-1408,
					2209
				]
			],
			[
				[
					6864393,
					499764
				],
				[
					0,
					0
				]
			],
			[
				[
					6869899,
					399572
				],
				[
					-3266,
					-1125
				]
			],
			[
				[
					6866633,
					398447
				],
				[
					270,
					4890
				]
			],
			[
				[
					6866903,
					403337
				],
				[
					5172,
					-3649
				]
			],
			[
				[
					6871787,
					400724
				],
				[
					0,
					0
				]
			],
			[
				[
					6867739,
					389176
				],
				[
					-391,
					-130
				]
			],
			[
				[
					6854827,
					406936
				],
				[
					951,
					356
				]
			],
			[
				[
					6855778,
					407292
				],
				[
					4967,
					3168
				]
			],
			[
				[
					6860745,
					410460
				],
				[
					5888,
					-12013
				]
			],
			[
				[
					6866903,
					403337
				],
				[
					-2952,
					7161
				]
			],
			[
				[
					6863951,
					410498
				],
				[
					1567,
					7489
				]
			],
			[
				[
					6865518,
					417987
				],
				[
					2064,
					153
				]
			],
			[
				[
					6867582,
					418140
				],
				[
					4730,
					-6658
				]
			],
			[
				[
					6871779,
					401738
				],
				[
					0,
					0
				]
			],
			[
				[
					6860745,
					410460
				],
				[
					3206,
					38
				]
			],
			[
				[
					6867582,
					418140
				],
				[
					3810,
					-2838
				]
			],
			[
				[
					6858218,
					426716
				],
				[
					-1964,
					-6893
				]
			],
			[
				[
					6856254,
					419823
				],
				[
					-851,
					-255
				]
			],
			[
				[
					6855403,
					419568
				],
				[
					-4570,
					3219
				]
			],
			[
				[
					6850833,
					422787
				],
				[
					-90,
					993
				]
			],
			[
				[
					6850743,
					423780
				],
				[
					-238,
					2033
				]
			],
			[
				[
					6850505,
					425813
				],
				[
					4638,
					3422
				]
			],
			[
				[
					6850505,
					425813
				],
				[
					-2314,
					6995
				]
			],
			[
				[
					6848191,
					432808
				],
				[
					2913,
					413
				]
			],
			[
				[
					6851104,
					433221
				],
				[
					3720,
					562
				]
			],
			[
				[
					6855403,
					419568
				],
				[
					-3373,
					-5212
				]
			],
			[
				[
					6852030,
					414356
				],
				[
					-1592,
					2653
				]
			],
			[
				[
					6850438,
					417009
				],
				[
					-1662,
					3274
				]
			],
			[
				[
					6848776,
					420283
				],
				[
					644,
					1669
				]
			],
			[
				[
					6849420,
					421952
				],
				[
					1413,
					835
				]
			],
			[
				[
					6850438,
					417009
				],
				[
					-8333,
					-3194
				]
			],
			[
				[
					6840569,
					416811
				],
				[
					3872,
					2394
				]
			],
			[
				[
					6844441,
					419205
				],
				[
					4335,
					1078
				]
			],
			[
				[
					6849420,
					421952
				],
				[
					-5517,
					6301
				]
			],
			[
				[
					6843903,
					428253
				],
				[
					334,
					248
				]
			],
			[
				[
					6844237,
					428501
				],
				[
					290,
					243
				]
			],
			[
				[
					6844527,
					428744
				],
				[
					186,
					46
				]
			],
			[
				[
					6844713,
					428790
				],
				[
					426,
					360
				]
			],
			[
				[
					6845139,
					429150
				],
				[
					5604,
					-5370
				]
			],
			[
				[
					6844527,
					428744
				],
				[
					186,
					46
				]
			],
			[
				[
					6845139,
					429150
				],
				[
					1634,
					3292
				]
			],
			[
				[
					6846773,
					432442
				],
				[
					1418,
					366
				]
			],
			[
				[
					6837000,
					432012
				],
				[
					1519,
					4214
				]
			],
			[
				[
					6838519,
					436226
				],
				[
					-649,
					-3584
				]
			],
			[
				[
					6837870,
					432642
				],
				[
					-870,
					-630
				]
			],
			[
				[
					6851104,
					433221
				],
				[
					-4331,
					-779
				]
			],
			[
				[
					6844237,
					428501
				],
				[
					-3413,
					9495
				]
			],
			[
				[
					6840824,
					437996
				],
				[
					-6861,
					-8390
				]
			],
			[
				[
					6843903,
					428253
				],
				[
					-2602,
					-3280
				]
			],
			[
				[
					6841301,
					424973
				],
				[
					-371,
					228
				]
			],
			[
				[
					6840930,
					425201
				],
				[
					-3060,
					7441
				]
			],
			[
				[
					6838519,
					436226
				],
				[
					2305,
					1770
				]
			],
			[
				[
					6844441,
					419205
				],
				[
					-3140,
					5768
				]
			],
			[
				[
					6837656,
					422449
				],
				[
					3274,
					2752
				]
			],
			[
				[
					6856254,
					419823
				],
				[
					-476,
					-12531
				]
			],
			[
				[
					6848137,
					404446
				],
				[
					3893,
					9910
				]
			],
			[
				[
					6851305,
					413761
				],
				[
					0,
					0
				]
			],
			[
				[
					6852705,
					410886
				],
				[
					0,
					0
				]
			],
			[
				[
					6836516,
					424669
				],
				[
					484,
					7343
				]
			],
			[
				[
					6705844,
					571771
				],
				[
					-365,
					310
				]
			],
			[
				[
					6710109,
					588437
				],
				[
					10206,
					26825
				]
			],
			[
				[
					6807885,
					411657
				],
				[
					2693,
					13347
				]
			],
			[
				[
					6865518,
					417987
				],
				[
					-1837,
					-94
				]
			],
			[
				[
					6863681,
					417893
				],
				[
					-1264,
					3664
				]
			],
			[
				[
					6862417,
					421557
				],
				[
					2335,
					11734
				]
			],
			[
				[
					6863681,
					417893
				],
				[
					-1264,
					3664
				]
			],
			[
				[
					6875447,
					369197
				],
				[
					-8961,
					-3228
				],
				[
					-11042,
					-16354
				]
			],
			[
				[
					6875041,
					359844
				],
				[
					-799,
					4299
				]
			],
			[
				[
					6874242,
					364143
				],
				[
					799,
					-4299
				]
			],
			[
				[
					6875041,
					359844
				],
				[
					8,
					-1922
				]
			],
			[
				[
					6875049,
					357922
				],
				[
					-1108,
					-4069
				]
			],
			[
				[
					6873941,
					353853
				],
				[
					-5695,
					5810
				]
			],
			[
				[
					6868246,
					359663
				],
				[
					879,
					1423
				]
			],
			[
				[
					6869125,
					361086
				],
				[
					5117,
					3057
				]
			],
			[
				[
					6875049,
					357922
				],
				[
					5581,
					-3991
				],
				[
					-8030,
					-10018
				],
				[
					1341,
					9940
				]
			],
			[
				[
					6895525,
					356781
				],
				[
					-5595,
					-9803
				]
			],
			[
				[
					6869125,
					361086
				],
				[
					-879,
					-1423
				]
			],
			[
				[
					6876129,
					263660
				],
				[
					-3957,
					-7273
				]
			],
			[
				[
					6847338,
					261481
				],
				[
					4290,
					10830
				],
				[
					-2374,
					14203
				]
			],
			[
				[
					6849254,
					286514
				],
				[
					6804,
					2230
				]
			],
			[
				[
					6831357,
					284833
				],
				[
					7103,
					3058
				]
			],
			[
				[
					6812954,
					273879
				],
				[
					-1613,
					527
				]
			],
			[
				[
					6798094,
					719031
				],
				[
					-1377,
					-19859
				],
				[
					6728,
					11053
				]
			],
			[
				[
					6823519,
					714233
				],
				[
					-3228,
					-27383
				]
			],
			[
				[
					6831800,
					722133
				],
				[
					8,
					-8002
				],
				[
					12528,
					-11469
				]
			],
			[
				[
					6820022,
					328792
				],
				[
					-3230,
					1485
				]
			],
			[
				[
					6820175,
					350453
				],
				[
					827,
					250
				]
			],
			[
				[
					6821002,
					350703
				],
				[
					-827,
					-250
				]
			],
			[
				[
					6815895,
					354601
				],
				[
					0,
					0
				]
			],
			[
				[
					6818651,
					346434
				],
				[
					0,
					0
				]
			],
			[
				[
					6821002,
					350703
				],
				[
					-827,
					-250
				]
			],
			[
				[
					6788638,
					406294
				],
				[
					0,
					0
				]
			],
			[
				[
					6795651,
					408786
				],
				[
					0,
					0
				]
			],
			[
				[
					6799613,
					236068
				],
				[
					-14198,
					-383
				]
			],
			[
				[
					6780569,
					250847
				],
				[
					5030,
					2592
				],
				[
					180,
					13880
				],
				[
					-4587,
					7683
				]
			],
			[
				[
					6767379,
					237336
				],
				[
					-15309,
					-4121
				]
			],
			[
				[
					6757938,
					249305
				],
				[
					7617,
					1073
				]
			],
			[
				[
					6753418,
					274649
				],
				[
					1997,
					1098
				]
			],
			[
				[
					6755415,
					275747
				],
				[
					10335,
					5438
				]
			],
			[
				[
					6765750,
					281185
				],
				[
					5899,
					3130
				]
			],
			[
				[
					6771657,
					264785
				],
				[
					-6279,
					-207
				],
				[
					5209,
					-10494
				],
				[
					1070,
					10701
				]
			],
			[
				[
					6775808,
					319764
				],
				[
					-2104,
					-4666
				]
			],
			[
				[
					6773704,
					315098
				],
				[
					-7277,
					2220
				]
			],
			[
				[
					6766427,
					317318
				],
				[
					-2234,
					9474
				]
			],
			[
				[
					6764193,
					326792
				],
				[
					4628,
					6567
				]
			],
			[
				[
					6773704,
					315098
				],
				[
					-5934,
					-3686
				]
			],
			[
				[
					6767770,
					311412
				],
				[
					-4364,
					3181
				]
			],
			[
				[
					6763406,
					314593
				],
				[
					-469,
					2281
				]
			],
			[
				[
					6762937,
					316874
				],
				[
					3490,
					444
				]
			],
			[
				[
					6758902,
					322789
				],
				[
					0,
					0
				]
			],
			[
				[
					6764193,
					326792
				],
				[
					-4266,
					-5394
				]
			],
			[
				[
					6759927,
					321398
				],
				[
					-3470,
					7431
				]
			],
			[
				[
					6762937,
					316874
				],
				[
					-1043,
					-107
				]
			],
			[
				[
					6761894,
					316767
				],
				[
					-2768,
					4825
				]
			],
			[
				[
					6759126,
					321592
				],
				[
					801,
					-194
				]
			],
			[
				[
					6767770,
					311412
				],
				[
					1425,
					-8648
				]
			],
			[
				[
					6769195,
					302764
				],
				[
					-1429,
					-703
				]
			],
			[
				[
					6767766,
					302061
				],
				[
					-461,
					3004
				]
			],
			[
				[
					6767305,
					305065
				],
				[
					-3820,
					6909
				]
			],
			[
				[
					6763485,
					311974
				],
				[
					-79,
					2619
				]
			],
			[
				[
					6761894,
					316767
				],
				[
					-1378,
					-3678
				]
			],
			[
				[
					6760516,
					313089
				],
				[
					-149,
					506
				]
			],
			[
				[
					6760367,
					313595
				],
				[
					-378,
					2851
				]
			],
			[
				[
					6759989,
					316446
				],
				[
					-863,
					5146
				]
			],
			[
				[
					6763485,
					311974
				],
				[
					-2969,
					1115
				]
			],
			[
				[
					6767305,
					305065
				],
				[
					-6344,
					-1152
				]
			],
			[
				[
					6760961,
					303913
				],
				[
					-524,
					-95
				]
			],
			[
				[
					6760437,
					303818
				],
				[
					-658,
					9621
				]
			],
			[
				[
					6759779,
					313439
				],
				[
					588,
					156
				]
			],
			[
				[
					6767766,
					302061
				],
				[
					-1204,
					-10578
				]
			],
			[
				[
					6766562,
					291483
				],
				[
					-5448,
					-1418
				]
			],
			[
				[
					6761114,
					290065
				],
				[
					-153,
					13848
				]
			],
			[
				[
					6759989,
					316446
				],
				[
					-7689,
					-367
				],
				[
					-2175,
					8774
				]
			],
			[
				[
					6759779,
					313439
				],
				[
					-2260,
					-1061
				]
			],
			[
				[
					6757519,
					312378
				],
				[
					-11066,
					-1593
				]
			],
			[
				[
					6760437,
					303818
				],
				[
					-2381,
					-4245
				]
			],
			[
				[
					6758056,
					299573
				],
				[
					-414,
					3793
				]
			],
			[
				[
					6757642,
					303366
				],
				[
					-123,
					9012
				]
			],
			[
				[
					6758759,
					302084
				],
				[
					0,
					0
				]
			],
			[
				[
					6757642,
					303366
				],
				[
					-10239,
					-4065
				],
				[
					-2145,
					7537
				]
			],
			[
				[
					6766562,
					291483
				],
				[
					-812,
					-10298
				]
			],
			[
				[
					6755415,
					275747
				],
				[
					5699,
					14318
				]
			],
			[
				[
					6761114,
					290065
				],
				[
					-3058,
					9508
				]
			],
			[
				[
					6777704,
					305531
				],
				[
					-8509,
					-2767
				]
			],
			[
				[
					6708163,
					473243
				],
				[
					-353,
					70274
				],
				[
					-2680,
					28850
				]
			],
			[
				[
					6655030,
					179630
				],
				[
					0,
					0
				]
			],
			[
				[
					6637637,
					323171
				],
				[
					-62,
					-2094
				]
			],
			[
				[
					6637575,
					321077
				],
				[
					-147,
					-6620
				]
			],
			[
				[
					6637428,
					314457
				],
				[
					-139,
					-6045
				]
			],
			[
				[
					6637289,
					308412
				],
				[
					-3427,
					6561
				]
			],
			[
				[
					6633862,
					314973
				],
				[
					1219,
					7370
				]
			],
			[
				[
					6635081,
					322343
				],
				[
					2556,
					828
				]
			],
			[
				[
					6624297,
					296841
				],
				[
					4252,
					21208
				]
			],
			[
				[
					6628549,
					318049
				],
				[
					5313,
					-3076
				]
			],
			[
				[
					6637289,
					308412
				],
				[
					139,
					6045
				]
			],
			[
				[
					6637575,
					321077
				],
				[
					6016,
					3781
				]
			],
			[
				[
					6643591,
					324858
				],
				[
					1642,
					510
				]
			],
			[
				[
					6628549,
					318049
				],
				[
					6532,
					4294
				]
			],
			[
				[
					6637637,
					323171
				],
				[
					5954,
					1687
				]
			],
			[
				[
					6629321,
					193365
				],
				[
					-2223,
					1432
				]
			],
			[
				[
					6622201,
					87338
				],
				[
					-3358,
					-32138
				],
				[
					-9712,
					27884
				],
				[
					-5775,
					2376
				]
			],
			[
				[
					6603356,
					85460
				],
				[
					29,
					777
				]
			],
			[
				[
					6603575,
					91542
				],
				[
					96,
					3056
				]
			],
			[
				[
					6583727,
					143997
				],
				[
					1801,
					-115
				]
			],
			[
				[
					6577813,
					144366
				],
				[
					0,
					0
				]
			],
			[
				[
					6571335,
					142073
				],
				[
					-1083,
					4313
				]
			],
			[
				[
					6570252,
					146386
				],
				[
					-82,
					299
				]
			],
			[
				[
					6570170,
					146685
				],
				[
					2554,
					-93
				]
			],
			[
				[
					6572724,
					146592
				],
				[
					1670,
					6015
				]
			],
			[
				[
					6574394,
					152607
				],
				[
					1106,
					4739
				]
			],
			[
				[
					6575500,
					157346
				],
				[
					8276,
					-4730
				]
			],
			[
				[
					6578263,
					150421
				],
				[
					0,
					0
				]
			],
			[
				[
					6574394,
					152607
				],
				[
					-2347,
					1253
				]
			],
			[
				[
					6572047,
					153860
				],
				[
					-860,
					4768
				]
			],
			[
				[
					6571187,
					158628
				],
				[
					4313,
					-1282
				]
			],
			[
				[
					6572724,
					146592
				],
				[
					-1783,
					6052
				]
			],
			[
				[
					6570941,
					152644
				],
				[
					1106,
					1216
				]
			],
			[
				[
					6570941,
					152644
				],
				[
					-4758,
					1742
				]
			],
			[
				[
					6566183,
					154386
				],
				[
					-256,
					2306
				]
			],
			[
				[
					6565927,
					156692
				],
				[
					5260,
					1936
				]
			],
			[
				[
					6570170,
					146685
				],
				[
					-3816,
					5501
				]
			],
			[
				[
					6566354,
					152186
				],
				[
					-171,
					2200
				]
			],
			[
				[
					6569440,
					141361
				],
				[
					812,
					5025
				]
			],
			[
				[
					6569440,
					141361
				],
				[
					-2016,
					-4163
				]
			],
			[
				[
					6567424,
					137198
				],
				[
					-2191,
					2559
				]
			],
			[
				[
					6565233,
					139757
				],
				[
					-1685,
					2985
				]
			],
			[
				[
					6563548,
					142742
				],
				[
					-805,
					7364
				]
			],
			[
				[
					6562743,
					150106
				],
				[
					3611,
					2080
				]
			],
			[
				[
					6563548,
					142742
				],
				[
					-4478,
					3874
				]
			],
			[
				[
					6559070,
					146616
				],
				[
					-753,
					1980
				]
			],
			[
				[
					6558317,
					148596
				],
				[
					3619,
					3714
				]
			],
			[
				[
					6561936,
					152310
				],
				[
					807,
					-2204
				]
			],
			[
				[
					6561936,
					152310
				],
				[
					-560,
					3182
				]
			],
			[
				[
					6561376,
					155492
				],
				[
					4551,
					1200
				]
			],
			[
				[
					6563170,
					121223
				],
				[
					-4830,
					342
				]
			],
			[
				[
					6558340,
					121565
				],
				[
					1222,
					4608
				]
			],
			[
				[
					6559562,
					126173
				],
				[
					3880,
					3535
				]
			],
			[
				[
					6564938,
					132976
				],
				[
					-368,
					241
				]
			],
			[
				[
					6564570,
					133217
				],
				[
					2854,
					3981
				]
			],
			[
				[
					6558317,
					148596
				],
				[
					-1369,
					4654
				]
			],
			[
				[
					6556948,
					153250
				],
				[
					4428,
					2242
				]
			],
			[
				[
					6559070,
					146616
				],
				[
					-1311,
					-3642
				]
			],
			[
				[
					6557759,
					142974
				],
				[
					-2718,
					8522
				]
			],
			[
				[
					6555041,
					151496
				],
				[
					1907,
					1754
				]
			],
			[
				[
					6557759,
					142974
				],
				[
					-3149,
					-5182
				]
			],
			[
				[
					6554610,
					137792
				],
				[
					-3400,
					273
				]
			],
			[
				[
					6551210,
					138065
				],
				[
					3831,
					13431
				]
			],
			[
				[
					6565233,
					139757
				],
				[
					-5841,
					-2190
				]
			],
			[
				[
					6559392,
					137567
				],
				[
					-3007,
					377
				]
			],
			[
				[
					6556385,
					137944
				],
				[
					-1775,
					-152
				]
			],
			[
				[
					6564570,
					133217
				],
				[
					-5178,
					4350
				]
			],
			[
				[
					6559562,
					126173
				],
				[
					-3177,
					11771
				]
			],
			[
				[
					6558340,
					121565
				],
				[
					-6724,
					431
				]
			],
			[
				[
					6551616,
					121996
				],
				[
					-406,
					16069
				]
			],
			[
				[
					6556033,
					85411
				],
				[
					-5951,
					4740
				],
				[
					1534,
					31845
				]
			],
			[
				[
					6603356,
					85460
				],
				[
					-20446,
					-9313
				]
			],
			[
				[
					7015608,
					825941
				],
				[
					-1570,
					6504
				]
			],
			[
				[
					7014038,
					832445
				],
				[
					4395,
					1693
				],
				[
					-6354,
					17483
				],
				[
					5866,
					9233
				]
			],
			[
				[
					7017945,
					860854
				],
				[
					-9551,
					549
				],
				[
					-288,
					25377
				],
				[
					23520,
					13747
				]
			],
			[
				[
					7031626,
					900527
				],
				[
					61636,
					35263
				]
			],
			[
				[
					7023850,
					929047
				],
				[
					-59449,
					-33461
				]
			],
			[
				[
					6964401,
					895586
				],
				[
					-5349,
					-3299
				]
			],
			[
				[
					6959052,
					892287
				],
				[
					-10962,
					-6259
				]
			],
			[
				[
					6948090,
					886028
				],
				[
					-8972,
					34957
				],
				[
					-8157,
					-2297
				],
				[
					-5789,
					20000
				],
				[
					-8259,
					-4708
				]
			],
			[
				[
					6916913,
					933980
				],
				[
					-10872,
					-6436
				]
			],
			[
				[
					6906041,
					927544
				],
				[
					-2143,
					8462
				],
				[
					-19098,
					-11132
				]
			],
			[
				[
					6884800,
					924874
				],
				[
					-3394,
					-1911
				],
				[
					-12538,
					49853
				],
				[
					22206,
					12595
				]
			],
			[
				[
					6891074,
					985411
				],
				[
					34518,
					20270
				],
				[
					6161,
					-5122
				],
				[
					5678,
					-21999
				],
				[
					6669,
					3894
				],
				[
					1826,
					21889
				],
				[
					8139,
					-4515
				],
				[
					-3687,
					14555
				],
				[
					4542,
					7702
				],
				[
					19782,
					11285
				],
				[
					12785,
					3421
				],
				[
					14646,
					-27135
				],
				[
					-6680,
					-6212
				],
				[
					5525,
					-21643
				],
				[
					8594,
					3032
				],
				[
					14278,
					-55786
				]
			],
			[
				[
					6965570,
					807421
				],
				[
					-3472,
					4698
				]
			],
			[
				[
					6962098,
					812119
				],
				[
					3472,
					-4698
				]
			],
			[
				[
					6987583,
					841095
				],
				[
					0,
					0
				]
			],
			[
				[
					7014038,
					832445
				],
				[
					-18050,
					-9022
				],
				[
					-5094,
					20494
				],
				[
					-17349,
					-9393
				],
				[
					-11855,
					2599
				],
				[
					-592,
					-23627
				]
			],
			[
				[
					6961098,
					813496
				],
				[
					-10537,
					-1931
				]
			],
			[
				[
					6950561,
					811565
				],
				[
					-12545,
					1828
				],
				[
					-8705,
					28648
				]
			],
			[
				[
					6929311,
					842041
				],
				[
					3077,
					1598
				]
			],
			[
				[
					6932388,
					843639
				],
				[
					18673,
					13150
				],
				[
					-6701,
					5876
				],
				[
					12997,
					6795
				],
				[
					8015,
					-2207
				],
				[
					-6320,
					25034
				]
			],
			[
				[
					6964401,
					895586
				],
				[
					5145,
					-20846
				],
				[
					14957,
					-4181
				],
				[
					5411,
					5790
				],
				[
					-286,
					-23591
				],
				[
					8299,
					4467
				],
				[
					2460,
					-7975
				],
				[
					17558,
					11604
				]
			],
			[
				[
					7000912,
					847824
				],
				[
					0,
					0
				]
			],
			[
				[
					6887145,
					860021
				],
				[
					816,
					1620
				]
			],
			[
				[
					6887961,
					861641
				],
				[
					-816,
					-1620
				]
			],
			[
				[
					6872381,
					868589
				],
				[
					362,
					671
				]
			],
			[
				[
					6872743,
					869260
				],
				[
					-362,
					-671
				]
			],
			[
				[
					6897784,
					873716
				],
				[
					4430,
					-18755
				],
				[
					14474,
					8222
				],
				[
					4974,
					-18780
				],
				[
					7649,
					-2362
				]
			],
			[
				[
					6950561,
					811565
				],
				[
					843,
					-11546
				],
				[
					9010,
					-217
				],
				[
					-2126,
					-13987
				]
			],
			[
				[
					6958288,
					785815
				],
				[
					-3872,
					-19546
				]
			],
			[
				[
					6927956,
					795162
				],
				[
					-10028,
					-2837
				]
			],
			[
				[
					6911776,
					790459
				],
				[
					-750,
					-3003
				]
			],
			[
				[
					6910860,
					787168
				],
				[
					480,
					13440
				],
				[
					-9937,
					6726
				],
				[
					2143,
					7319
				],
				[
					-12205,
					6471
				],
				[
					12859,
					10689
				],
				[
					-4246,
					16089
				],
				[
					-12539,
					911
				],
				[
					-1234,
					9398
				]
			],
			[
				[
					6886181,
					858211
				],
				[
					903,
					1690
				]
			],
			[
				[
					6887084,
					859901
				],
				[
					10700,
					13815
				]
			],
			[
				[
					6929614,
					879187
				],
				[
					0,
					0
				]
			],
			[
				[
					6932388,
					843639
				],
				[
					-3363,
					31638
				],
				[
					11060,
					-5971
				],
				[
					-438,
					11901
				],
				[
					8443,
					4821
				]
			],
			[
				[
					6927961,
					760600
				],
				[
					586,
					679
				]
			],
			[
				[
					6958288,
					785815
				],
				[
					7920,
					-15677
				],
				[
					10167,
					8935
				],
				[
					9625,
					-3387
				],
				[
					5394,
					-16961
				]
			],
			[
				[
					6978530,
					770540
				],
				[
					0,
					0
				]
			],
			[
				[
					6926688,
					762588
				],
				[
					-9439,
					27772
				]
			],
			[
				[
					6887145,
					860021
				],
				[
					-61,
					-120
				]
			],
			[
				[
					6886181,
					858211
				],
				[
					1780,
					3430
				]
			],
			[
				[
					6872381,
					868589
				],
				[
					362,
					671
				]
			],
			[
				[
					6916913,
					933980
				],
				[
					-8137,
					-17177
				],
				[
					-2735,
					10741
				]
			],
			[
				[
					6853786,
					1050647
				],
				[
					771,
					-15468
				],
				[
					-4090,
					-12872
				],
				[
					-10654,
					-9821
				],
				[
					5293,
					-20444
				],
				[
					38398,
					22066
				],
				[
					7570,
					-28697
				]
			],
			[
				[
					6884800,
					924874
				],
				[
					5709,
					-22068
				],
				[
					1511,
					-25586
				],
				[
					-9098,
					2043
				]
			],
			[
				[
					6882922,
					879263
				],
				[
					-14050,
					6961
				],
				[
					-434,
					16076
				],
				[
					-10643,
					9271
				],
				[
					191,
					31732
				],
				[
					-11157,
					-8002
				],
				[
					-9093,
					18335
				],
				[
					-1877,
					13866
				],
				[
					-6318,
					8682
				],
				[
					3248,
					9525
				],
				[
					-12257,
					15324
				],
				[
					-1213,
					9768
				]
			],
			[
				[
					6819319,
					1010801
				],
				[
					18410,
					4504
				],
				[
					-1053,
					30945
				],
				[
					17110,
					4397
				]
			],
			[
				[
					6969773,
					1128524
				],
				[
					0,
					0
				]
			],
			[
				[
					6872037,
					1339649
				],
				[
					54341,
					-115
				],
				[
					6325,
					-14603
				],
				[
					11500,
					14171
				],
				[
					165,
					-41773
				],
				[
					24954,
					109
				]
			],
			[
				[
					7031626,
					900527
				],
				[
					-7776,
					28520
				]
			],
			[
				[
					6853786,
					1050647
				],
				[
					26507,
					2560
				],
				[
					17963,
					-5218
				],
				[
					18043,
					10304
				],
				[
					-6784,
					25175
				],
				[
					18676,
					8538
				]
			],
			[
				[
					6928191,
					1092006
				],
				[
					39643,
					4525
				],
				[
					9380,
					5147
				],
				[
					-3327,
					11919
				]
			],
			[
				[
					6973887,
					1113597
				],
				[
					-1456,
					4958
				]
			],
			[
				[
					6972431,
					1118555
				],
				[
					14338,
					-1248
				],
				[
					-199,
					32501
				],
				[
					-56742,
					-189
				],
				[
					58,
					-6967
				]
			],
			[
				[
					6929886,
					1142652
				],
				[
					-8919,
					10558
				],
				[
					-10724,
					-2740
				],
				[
					-7756,
					-29841
				],
				[
					-6134,
					91
				],
				[
					1824,
					-14082
				]
			],
			[
				[
					6898177,
					1106638
				],
				[
					-30201,
					862
				],
				[
					1558,
					40079
				],
				[
					-6960,
					-14734
				],
				[
					-7100,
					62
				],
				[
					16,
					18551
				],
				[
					11909,
					-3071
				],
				[
					-4936,
					19432
				],
				[
					-7060,
					-138
				],
				[
					-97,
					10560
				],
				[
					14248,
					35
				],
				[
					331,
					118245
				],
				[
					1702,
					85
				],
				[
					450,
					43043
				]
			],
			[
				[
					6872037,
					1339649
				],
				[
					-214,
					20598
				],
				[
					-90654,
					373
				],
				[
					1,
					87272
				]
			],
			[
				[
					6781170,
					1447892
				],
				[
					-31,
					38249
				],
				[
					70747,
					-626
				],
				[
					-4813,
					10030
				],
				[
					11042,
					879
				],
				[
					8071,
					14038
				],
				[
					19910,
					-4030
				],
				[
					122,
					4891
				],
				[
					29029,
					-1885
				],
				[
					466,
					-12184
				],
				[
					9129,
					523
				],
				[
					4753,
					9098
				],
				[
					14607,
					-305
				],
				[
					518,
					42229
				],
				[
					12438,
					-5969
				]
			],
			[
				[
					6781170,
					1447892
				],
				[
					-6840,
					46450
				],
				[
					-7039,
					31951
				],
				[
					-9817,
					2806
				],
				[
					4994,
					19884
				],
				[
					-69927,
					314
				],
				[
					60,
					32244
				]
			],
			[
				[
					6692601,
					1581541
				],
				[
					6704,
					9617
				],
				[
					7952,
					-131
				]
			],
			[
				[
					6707257,
					1591027
				],
				[
					75995,
					201
				]
			],
			[
				[
					6783252,
					1591228
				],
				[
					23327,
					-87
				],
				[
					14174,
					9357
				],
				[
					-10141,
					29335
				],
				[
					-158,
					55823
				]
			],
			[
				[
					6810454,
					1685656
				],
				[
					0,
					0
				]
			],
			[
				[
					6810454,
					1685656
				],
				[
					-11355,
					-10620
				],
				[
					-2684,
					10322
				],
				[
					-580,
					31509
				],
				[
					14956,
					-243
				]
			],
			[
				[
					6810791,
					1716624
				],
				[
					15521,
					-9
				],
				[
					10109,
					57733
				],
				[
					-4998,
					42273
				],
				[
					-4866,
					7008
				],
				[
					17065,
					17553
				],
				[
					113520,
					-2370
				]
			],
			[
				[
					6903073,
					1591812
				],
				[
					-6706,
					-957
				],
				[
					4955,
					-21050
				],
				[
					13912,
					65
				],
				[
					-2206,
					20826
				],
				[
					-9955,
					1116
				]
			],
			[
				[
					6900641,
					1562569
				],
				[
					-7733,
					-9324
				],
				[
					7687,
					-4408
				],
				[
					46,
					13732
				]
			],
			[
				[
					6691848,
					1653318
				],
				[
					15332,
					-18848
				],
				[
					77,
					-43443
				]
			],
			[
				[
					6692601,
					1581541
				],
				[
					-25,
					51218
				],
				[
					-20499,
					31
				],
				[
					-1963,
					12955
				],
				[
					11477,
					-2
				],
				[
					-91,
					10884
				],
				[
					10348,
					-3309
				]
			],
			[
				[
					6810791,
					1716624
				],
				[
					-5406,
					17076
				],
				[
					-12423,
					11740
				],
				[
					-6825,
					13249
				],
				[
					-20279,
					-16
				],
				[
					433,
					-60444
				]
			],
			[
				[
					6766291,
					1698229
				],
				[
					-12274,
					6327
				],
				[
					28,
					-8729
				],
				[
					-46854,
					-172
				]
			],
			[
				[
					6707191,
					1695655
				],
				[
					-102997,
					186
				]
			],
			[
				[
					6604194,
					1695841
				],
				[
					-28,
					21295
				],
				[
					-7138,
					4887
				],
				[
					7123,
					5609
				],
				[
					-114,
					83755
				],
				[
					-8395,
					-11749
				],
				[
					-13074,
					-2518
				],
				[
					-6128,
					-8183
				],
				[
					-16950,
					-2510
				],
				[
					-9875,
					12590
				],
				[
					-9028,
					343
				],
				[
					-3158,
					-20111
				],
				[
					-12178,
					-8287
				],
				[
					-3081,
					29577
				],
				[
					-5566,
					10471
				],
				[
					-26036,
					159
				],
				[
					-149,
					46746
				],
				[
					-21461,
					15918
				],
				[
					-8839,
					-158
				],
				[
					-10462,
					-23107
				],
				[
					-11630,
					-2187
				]
			],
			[
				[
					6438027,
					1848381
				],
				[
					2044,
					11191
				],
				[
					-11391,
					-1167
				],
				[
					-7797,
					-10845
				],
				[
					-15440,
					26206
				],
				[
					-10244,
					74
				],
				[
					13,
					62552
				],
				[
					-95740,
					312
				]
			],
			[
				[
					6299472,
					1936704
				],
				[
					-151,
					62644
				],
				[
					73009,
					-428
				],
				[
					-174,
					62010
				],
				[
					-81157,
					-305
				],
				[
					-129201,
					1772
				],
				[
					14,
					49150
				]
			],
			[
				[
					6161812,
					2111547
				],
				[
					60,
					261560
				],
				[
					-1317,
					235690
				],
				[
					811,
					121602
				],
				[
					-12,
					234070
				],
				[
					851,
					443434
				]
			],
			[
				[
					6162205,
					3407903
				],
				[
					19566,
					-10597
				],
				[
					12674,
					-13865
				],
				[
					23545,
					-9317
				],
				[
					16861,
					-3165
				],
				[
					14695,
					-14246
				],
				[
					13618,
					-6301
				],
				[
					28312,
					-39382
				],
				[
					20097,
					-8262
				],
				[
					11147,
					-9452
				],
				[
					1923,
					-17645
				],
				[
					14511,
					4537
				],
				[
					21857,
					-10335
				],
				[
					31459,
					439
				],
				[
					22937,
					9609
				],
				[
					15315,
					98
				],
				[
					11069,
					-6189
				],
				[
					21512,
					10072
				],
				[
					28818,
					-19894
				],
				[
					-2564,
					12717
				],
				[
					24240,
					-13405
				],
				[
					25825,
					1036
				],
				[
					7505,
					-3782
				],
				[
					19255,
					6284
				],
				[
					9704,
					-18234
				],
				[
					20127,
					-1899
				],
				[
					4601,
					7598
				],
				[
					16780,
					-18697
				],
				[
					7007,
					5223
				],
				[
					4545,
					-9757
				],
				[
					12356,
					-5138
				],
				[
					-2616,
					9342
				],
				[
					8827,
					3961
				],
				[
					-2335,
					-15379
				],
				[
					1402,
					-37852
				],
				[
					5936,
					-3351
				],
				[
					993,
					-19498
				],
				[
					-10170,
					-34480
				],
				[
					-3448,
					-36194
				],
				[
					-11755,
					-43235
				],
				[
					612,
					-30621
				],
				[
					20901,
					-40001
				],
				[
					12214,
					-50494
				],
				[
					-10194,
					-55795
				],
				[
					8343,
					-46716
				],
				[
					3415,
					-29170
				],
				[
					-14625,
					-20152
				],
				[
					-5168,
					-31163
				],
				[
					4311,
					-32732
				],
				[
					15593,
					-10649
				],
				[
					17386,
					-25862
				],
				[
					9042,
					-27369
				],
				[
					12796,
					-13127
				],
				[
					8487,
					-17909
				],
				[
					16602,
					-25307
				],
				[
					-2263,
					-8364
				],
				[
					4871,
					-16055
				],
				[
					-4591,
					-9569
				],
				[
					9104,
					-7049
				],
				[
					6496,
					-26971
				],
				[
					6839,
					-10269
				],
				[
					22853,
					-14803
				],
				[
					19351,
					-7207
				],
				[
					8730,
					-22013
				],
				[
					6960,
					-3501
				],
				[
					22064,
					-27473
				],
				[
					10236,
					-22216
				],
				[
					-601,
					-8257
				],
				[
					9654,
					-36792
				],
				[
					6435,
					-14744
				],
				[
					-473,
					-19227
				],
				[
					12596,
					-12948
				],
				[
					23455,
					-6646
				],
				[
					13942,
					-11345
				],
				[
					11591,
					-18355
				],
				[
					10122,
					-2465
				],
				[
					5781,
					7599
				],
				[
					6831,
					22568
				],
				[
					-6537,
					11319
				],
				[
					3453,
					12681
				],
				[
					4382,
					-9323
				],
				[
					11653,
					29629
				],
				[
					6407,
					-1315
				]
			],
			[
				[
					6234477,
					2397685
				],
				[
					6338,
					1622
				],
				[
					223,
					18892
				],
				[
					-15794,
					540
				],
				[
					-275,
					-15218
				],
				[
					9508,
					-5836
				]
			],
			[
				[
					6622417,
					1873841
				],
				[
					1019,
					-23105
				],
				[
					13061,
					234
				],
				[
					8652,
					-8246
				],
				[
					-88,
					31485
				],
				[
					-7439,
					-24
				],
				[
					1236,
					16299
				],
				[
					-7713,
					-16356
				],
				[
					-8728,
					-287
				]
			],
			[
				[
					6769841,
					1041986
				],
				[
					-2826,
					-11044
				],
				[
					-7253,
					-1356
				],
				[
					-15896,
					7913
				],
				[
					25975,
					4487
				]
			],
			[
				[
					6719318,
					1066340
				],
				[
					2058,
					92
				]
			],
			[
				[
					6721376,
					1066432
				],
				[
					-2058,
					-92
				]
			],
			[
				[
					6440309,
					1598556
				],
				[
					0,
					0
				]
			],
			[
				[
					6340734,
					1610313
				],
				[
					5141,
					-10942
				],
				[
					29120,
					7694
				],
				[
					-4018,
					-38658
				],
				[
					-3769,
					10147
				],
				[
					-15401,
					1718
				],
				[
					-2625,
					13712
				],
				[
					-11626,
					3497
				],
				[
					3178,
					12832
				]
			],
			[
				[
					6264118,
					1690290
				],
				[
					0,
					0
				]
			],
			[
				[
					6264396,
					1690405
				],
				[
					0,
					0
				]
			],
			[
				[
					6267420,
					1693564
				],
				[
					0,
					0
				]
			],
			[
				[
					6898177,
					1106638
				],
				[
					3193,
					291
				]
			],
			[
				[
					6901370,
					1106929
				],
				[
					13260,
					-3062
				],
				[
					13561,
					-11861
				]
			],
			[
				[
					6819319,
					1010801
				],
				[
					167,
					9504
				],
				[
					-8101,
					11062
				],
				[
					-4636,
					-9071
				],
				[
					-17477,
					6822
				],
				[
					-21941,
					-3785
				],
				[
					4716,
					16770
				],
				[
					-24631,
					-1552
				],
				[
					-16783,
					-5448
				],
				[
					2938,
					8834
				],
				[
					-18798,
					-1453
				],
				[
					12578,
					11067
				],
				[
					-450,
					6461
				]
			],
			[
				[
					6726901,
					1060012
				],
				[
					136,
					286
				]
			],
			[
				[
					6727037,
					1060298
				],
				[
					-5571,
					6138
				]
			],
			[
				[
					6721466,
					1066436
				],
				[
					3904,
					126
				]
			],
			[
				[
					6725370,
					1066562
				],
				[
					14956,
					1211
				],
				[
					-211,
					41474
				],
				[
					-28766,
					-322
				]
			],
			[
				[
					6711349,
					1108925
				],
				[
					-116,
					21000
				],
				[
					-14063,
					-61
				],
				[
					-226,
					62773
				],
				[
					-19280,
					-54
				]
			],
			[
				[
					6677664,
					1192583
				],
				[
					-8987,
					44735
				],
				[
					-6627,
					13449
				],
				[
					-10307,
					8936
				],
				[
					-2850,
					17866
				],
				[
					-38003,
					-80
				],
				[
					164,
					62356
				],
				[
					-28335,
					63
				],
				[
					-19,
					-83252
				],
				[
					-14451,
					-101
				],
				[
					30,
					-17977
				],
				[
					-9347,
					5198
				],
				[
					-9778,
					-1962
				],
				[
					-22972,
					3928
				],
				[
					2068,
					6723
				]
			],
			[
				[
					6528250,
					1252465
				],
				[
					14767,
					17657
				],
				[
					1397,
					23236
				],
				[
					-7816,
					10355
				],
				[
					-6727,
					36131
				],
				[
					-76930,
					127
				],
				[
					134,
					168365
				],
				[
					-4823,
					0
				],
				[
					167,
					50633
				],
				[
					-9082,
					-59
				],
				[
					-7578,
					9748
				],
				[
					9855,
					13578
				],
				[
					-1132,
					13018
				],
				[
					7956,
					11698
				],
				[
					17,
					25744
				],
				[
					62549,
					-32
				],
				[
					-3596,
					-7898
				],
				[
					14837,
					-13559
				],
				[
					227,
					10419
				],
				[
					7464,
					11210
				],
				[
					73861,
					98
				],
				[
					397,
					62907
				]
			],
			[
				[
					6707191,
					1695655
				],
				[
					-99,
					-21020
				],
				[
					-14893,
					-62
				],
				[
					-351,
					-21255
				]
			],
			[
				[
					6802429,
					1161264
				],
				[
					488,
					5
				]
			],
			[
				[
					6802917,
					1161269
				],
				[
					7156,
					-852
				],
				[
					-12,
					16605
				],
				[
					5847,
					12603
				],
				[
					-1947,
					24188
				],
				[
					-3955,
					1839
				]
			],
			[
				[
					6810006,
					1215652
				],
				[
					-5331,
					13325
				],
				[
					-7419,
					-3358
				],
				[
					-10443,
					22838
				],
				[
					-15646,
					-3518
				],
				[
					-2590,
					-10151
				],
				[
					237,
					-41780
				],
				[
					14961,
					-918
				]
			],
			[
				[
					6783775,
					1192090
				],
				[
					-2318,
					-20651
				]
			],
			[
				[
					6781457,
					1171439
				],
				[
					3719,
					-15884
				]
			],
			[
				[
					6785176,
					1155555
				],
				[
					-4478,
					-2823
				]
			],
			[
				[
					6780698,
					1152732
				],
				[
					711,
					12036
				],
				[
					-12471,
					197
				],
				[
					-160,
					-25643
				],
				[
					5857,
					-13482
				]
			],
			[
				[
					6774635,
					1125840
				],
				[
					-11747,
					-27580
				],
				[
					-8127,
					-8296
				],
				[
					40306,
					-2308
				],
				[
					-112,
					-21001
				],
				[
					26219,
					367
				],
				[
					2799,
					5287
				],
				[
					152,
					36099
				],
				[
					14268,
					20787
				],
				[
					-25466,
					-70
				],
				[
					-9781,
					21131
				]
			],
			[
				[
					6803146,
					1150256
				],
				[
					-812,
					3437
				]
			],
			[
				[
					6802334,
					1153693
				],
				[
					95,
					7571
				]
			],
			[
				[
					6815073,
					1147953
				],
				[
					0,
					0
				]
			],
			[
				[
					6437149,
					1779219
				],
				[
					-11187,
					286
				],
				[
					156,
					15388
				],
				[
					13469,
					256
				],
				[
					-2438,
					-15930
				]
			],
			[
				[
					6438027,
					1848381
				],
				[
					-4097,
					-8466
				],
				[
					-11605,
					-5376
				],
				[
					-1993,
					-26261
				],
				[
					-6421,
					-921
				],
				[
					-21520,
					20901
				],
				[
					-17995,
					-13411
				],
				[
					-2584,
					-11233
				],
				[
					-9212,
					-515
				],
				[
					2463,
					-18837
				],
				[
					-476,
					-27454
				],
				[
					-5636,
					-13817
				],
				[
					-150,
					-14317
				],
				[
					-12835,
					-30873
				],
				[
					65,
					-11957
				],
				[
					-8800,
					-11246
				],
				[
					-21695,
					-4282
				],
				[
					33,
					-15767
				],
				[
					-16327,
					-373
				]
			],
			[
				[
					6299242,
					1654176
				],
				[
					111,
					19704
				],
				[
					-11928,
					5457
				],
				[
					-13819,
					17303
				],
				[
					7671,
					13539
				],
				[
					7666,
					2926
				],
				[
					14626,
					19559
				],
				[
					3973,
					17450
				],
				[
					-8227,
					2647
				],
				[
					157,
					183943
				]
			],
			[
				[
					6783252,
					1591228
				],
				[
					-6794,
					6994
				],
				[
					-876,
					24625
				],
				[
					-9142,
					9894
				],
				[
					-9890,
					96
				],
				[
					7410,
					19032
				],
				[
					7406,
					2472
				],
				[
					-5960,
					18341
				],
				[
					8519,
					9320
				],
				[
					-7634,
					16227
				]
			],
			[
				[
					6710437,
					928929
				],
				[
					-4137,
					-14360
				],
				[
					-9445,
					-6603
				],
				[
					224,
					13678
				],
				[
					13358,
					7285
				]
			],
			[
				[
					6607856,
					1032208
				],
				[
					1625,
					-14456
				],
				[
					-6378,
					-3232
				],
				[
					-10361,
					7736
				],
				[
					5762,
					9749
				],
				[
					9352,
					203
				]
			],
			[
				[
					6692931,
					1035195
				],
				[
					2442,
					-8980
				],
				[
					-5754,
					-6927
				],
				[
					3312,
					15907
				]
			],
			[
				[
					6523551,
					1039441
				],
				[
					10094,
					-8917
				],
				[
					-8,
					-10416
				],
				[
					-10924,
					-14547
				],
				[
					-15186,
					10670
				],
				[
					9181,
					22165
				],
				[
					6843,
					1045
				]
			],
			[
				[
					6586101,
					1038122
				],
				[
					-4719,
					-18533
				],
				[
					10084,
					-18483
				],
				[
					9388,
					7986
				],
				[
					8795,
					-3780
				],
				[
					5057,
					-16050
				],
				[
					5459,
					13087
				],
				[
					-11135,
					11191
				],
				[
					8926,
					5540
				],
				[
					2636,
					9534
				],
				[
					23704,
					10169
				],
				[
					-752,
					-13629
				],
				[
					6721,
					3017
				],
				[
					8798,
					-27865
				],
				[
					9684,
					30782
				],
				[
					9874,
					7495
				],
				[
					8729,
					-2598
				],
				[
					-877,
					-22328
				],
				[
					10793,
					-4247
				],
				[
					-3266,
					-16352
				],
				[
					5248,
					-18015
				],
				[
					2523,
					16572
				],
				[
					11934,
					27631
				],
				[
					1229,
					-16779
				],
				[
					-5253,
					-11944
				],
				[
					14094,
					4145
				],
				[
					-7367,
					-28285
				],
				[
					-22409,
					-41621
				],
				[
					-16095,
					12022
				],
				[
					12203,
					9243
				],
				[
					14726,
					16844
				],
				[
					-11169,
					2520
				],
				[
					-9573,
					-17736
				],
				[
					-16130,
					-13125
				],
				[
					-27601,
					31223
				],
				[
					-18667,
					5759
				],
				[
					-6121,
					10725
				],
				[
					-26440,
					6898
				],
				[
					-7247,
					7742
				],
				[
					-3563,
					-7162
				],
				[
					-10408,
					12699
				],
				[
					-10567,
					-137
				],
				[
					-6353,
					8378
				],
				[
					-12648,
					1082
				],
				[
					4328,
					20177
				],
				[
					10841,
					-10891
				],
				[
					3289,
					10758
				],
				[
					6567,
					-8439
				],
				[
					9684,
					9994
				],
				[
					13046,
					4786
				]
			],
			[
				[
					6650314,
					1055171
				],
				[
					3125,
					-17403
				],
				[
					-5976,
					4818
				],
				[
					2851,
					12585
				]
			],
			[
				[
					6694864,
					1056888
				],
				[
					7395,
					-17600
				],
				[
					-21673,
					4754
				],
				[
					1390,
					9572
				],
				[
					12888,
					3274
				]
			],
			[
				[
					6726901,
					1060012
				],
				[
					136,
					286
				]
			],
			[
				[
					6713703,
					1064056
				],
				[
					-6975,
					-7475
				],
				[
					-3482,
					-14124
				],
				[
					-3454,
					14184
				],
				[
					9087,
					9167
				]
			],
			[
				[
					6708879,
					1065808
				],
				[
					4824,
					-1752
				]
			],
			[
				[
					6707969,
					1073289
				],
				[
					0,
					0
				]
			],
			[
				[
					6620878,
					1075368
				],
				[
					-24,
					593
				]
			],
			[
				[
					6620854,
					1075961
				],
				[
					24,
					-593
				]
			],
			[
				[
					6725370,
					1066562
				],
				[
					44,
					21400
				],
				[
					-14032,
					11328
				],
				[
					-33,
					9635
				]
			],
			[
				[
					6711349,
					1108925
				],
				[
					-20102,
					-3527
				],
				[
					-544,
					-14028
				],
				[
					18317,
					-3353
				],
				[
					-3971,
					-11597
				],
				[
					3920,
					-10164
				]
			],
			[
				[
					6708969,
					1066256
				],
				[
					-29382,
					-2520
				],
				[
					-24082,
					6225
				],
				[
					-18903,
					9381
				],
				[
					1300,
					7512
				],
				[
					-14355,
					3317
				],
				[
					-6241,
					-7497
				],
				[
					-19391,
					-2012
				],
				[
					8245,
					10723
				]
			],
			[
				[
					6606160,
					1091385
				],
				[
					5840,
					2489
				],
				[
					200,
					14501
				]
			],
			[
				[
					6612200,
					1108375
				],
				[
					14756,
					292
				]
			],
			[
				[
					6626956,
					1108667
				],
				[
					27628,
					113
				],
				[
					-486,
					33340
				],
				[
					9466,
					28950
				],
				[
					17857,
					-17975
				],
				[
					-3757,
					39488
				]
			],
			[
				[
					6620878,
					1075368
				],
				[
					-24,
					593
				]
			],
			[
				[
					6438172,
					1119495
				],
				[
					1679,
					1707
				]
			],
			[
				[
					6439851,
					1121202
				],
				[
					4589,
					-9866
				],
				[
					8275,
					5279
				],
				[
					23071,
					-23342
				],
				[
					-9636,
					-14302
				],
				[
					-3775,
					-17080
				],
				[
					-7278,
					-6303
				],
				[
					-4392,
					22741
				],
				[
					-12853,
					21618
				],
				[
					320,
					19548
				]
			],
			[
				[
					6626956,
					1108667
				],
				[
					-778,
					62441
				],
				[
					-43400,
					-301
				],
				[
					1551,
					-63422
				],
				[
					27871,
					990
				]
			],
			[
				[
					6606160,
					1091385
				],
				[
					-46859,
					-9140
				],
				[
					-57840,
					21641
				],
				[
					-7493,
					6837
				],
				[
					-8365,
					-3729
				],
				[
					-7134,
					6334
				],
				[
					-14294,
					1674
				],
				[
					-757,
					6695
				],
				[
					-18681,
					-3883
				],
				[
					-3408,
					5276
				]
			],
			[
				[
					6441329,
					1123090
				],
				[
					16327,
					24525
				],
				[
					10710,
					-1960
				],
				[
					-212,
					23817
				],
				[
					-21124,
					-151
				]
			],
			[
				[
					6447030,
					1169321
				],
				[
					281,
					19155
				],
				[
					-23043,
					-2721
				],
				[
					682,
					24739
				]
			],
			[
				[
					6424950,
					1210494
				],
				[
					28242,
					-417
				],
				[
					41,
					11760
				],
				[
					12148,
					3244
				]
			],
			[
				[
					6465381,
					1225081
				],
				[
					4368,
					-2586
				],
				[
					11804,
					9086
				],
				[
					-164,
					7399
				]
			],
			[
				[
					6481389,
					1238980
				],
				[
					24935,
					22996
				],
				[
					9621,
					-2685
				],
				[
					5292,
					-9748
				],
				[
					7013,
					2922
				]
			],
			[
				[
					6456786,
					1177912
				],
				[
					0,
					0
				]
			],
			[
				[
					6472356,
					1147509
				],
				[
					0,
					0
				]
			],
			[
				[
					6441329,
					1123090
				],
				[
					-1478,
					-1888
				]
			],
			[
				[
					6438172,
					1119495
				],
				[
					-4661,
					23204
				],
				[
					1936,
					27048
				]
			],
			[
				[
					6435447,
					1169747
				],
				[
					11583,
					-426
				]
			],
			[
				[
					6392021,
					1262604
				],
				[
					4726,
					-6886
				],
				[
					-8188,
					-3912
				],
				[
					3462,
					10798
				]
			],
			[
				[
					6481389,
					1238980
				],
				[
					-810,
					7503
				],
				[
					-11710,
					-4584
				],
				[
					-8714,
					-10130
				],
				[
					5226,
					-6688
				]
			],
			[
				[
					6424950,
					1210494
				],
				[
					-19564,
					-144
				],
				[
					-10453,
					-8730
				]
			],
			[
				[
					6394933,
					1201620
				],
				[
					7336,
					7328
				]
			],
			[
				[
					6402269,
					1208948
				],
				[
					-838,
					1267
				]
			],
			[
				[
					6401431,
					1210215
				],
				[
					-1380,
					12313
				],
				[
					-7325,
					-702
				],
				[
					-5502,
					-15148
				],
				[
					-2468,
					12652
				],
				[
					4789,
					23120
				],
				[
					10355,
					3100
				],
				[
					3351,
					-7071
				],
				[
					5517,
					18693
				],
				[
					-12850,
					11192
				],
				[
					-11069,
					1599
				],
				[
					-4335,
					-13758
				],
				[
					-4812,
					15934
				],
				[
					-13750,
					4718
				],
				[
					-432,
					16011
				],
				[
					8057,
					14725
				],
				[
					-142,
					20165
				],
				[
					13983,
					23665
				],
				[
					-3900,
					14175
				],
				[
					-9326,
					7226
				],
				[
					-1497,
					11760
				],
				[
					-27274,
					28145
				],
				[
					-8869,
					16725
				],
				[
					6328,
					13908
				],
				[
					-3320,
					10070
				],
				[
					13066,
					18863
				],
				[
					-4760,
					14499
				],
				[
					11394,
					18335
				],
				[
					-1744,
					8214
				],
				[
					-11004,
					1966
				],
				[
					-42810,
					-3347
				]
			],
			[
				[
					6299702,
					1511962
				],
				[
					-460,
					142214
				]
			],
			[
				[
					6254740,
					1473716
				],
				[
					14783,
					-9334
				],
				[
					-10703,
					-10151
				],
				[
					-29277,
					1812
				],
				[
					-64,
					6664
				],
				[
					11093,
					11013
				],
				[
					14168,
					-4
				]
			],
			[
				[
					5931152,
					1625878
				],
				[
					-6666,
					-16000
				],
				[
					75,
					11610
				],
				[
					6591,
					4390
				]
			],
			[
				[
					5869976,
					1641211
				],
				[
					-281,
					-116
				]
			],
			[
				[
					5869695,
					1641095
				],
				[
					281,
					116
				]
			],
			[
				[
					6112788,
					1686941
				],
				[
					2436,
					-10025
				],
				[
					-10727,
					5311
				],
				[
					8291,
					4714
				]
			],
			[
				[
					6031370,
					1727843
				],
				[
					12047,
					-22398
				],
				[
					-12181,
					-3228
				],
				[
					-4905,
					23428
				],
				[
					5039,
					2198
				]
			],
			[
				[
					6008123,
					1730653
				],
				[
					17342,
					-5285
				],
				[
					22,
					-12311
				],
				[
					-7383,
					-10602
				],
				[
					-9064,
					5646
				],
				[
					-8505,
					-2634
				],
				[
					-7794,
					-15387
				],
				[
					-4662,
					11271
				],
				[
					-493,
					16505
				],
				[
					12018,
					12902
				],
				[
					8519,
					-105
				]
			],
			[
				[
					5991271,
					1752849
				],
				[
					5150,
					-11447
				],
				[
					-9931,
					7784
				],
				[
					4781,
					3663
				]
			],
			[
				[
					5860029,
					1790436
				],
				[
					-6583,
					-14011
				],
				[
					595,
					13040
				],
				[
					5988,
					971
				]
			],
			[
				[
					5576464,
					2020453
				],
				[
					-22,
					1371
				]
			],
			[
				[
					5576442,
					2021824
				],
				[
					12543,
					407
				],
				[
					-14,
					-25890
				],
				[
					-7419,
					8266
				],
				[
					-5088,
					15846
				]
			],
			[
				[
					6299702,
					1511962
				],
				[
					-6068,
					-6192
				],
				[
					-28854,
					-777
				],
				[
					-18839,
					7347
				],
				[
					-9923,
					10391
				],
				[
					-21748,
					39936
				],
				[
					-11749,
					44387
				],
				[
					-9637,
					56640
				],
				[
					-7487,
					8395
				],
				[
					-7643,
					26124
				],
				[
					-8528,
					11867
				],
				[
					-6258,
					-10284
				],
				[
					-11164,
					493
				],
				[
					2413,
					11980
				],
				[
					-9927,
					6102
				],
				[
					-18035,
					-14303
				],
				[
					-15901,
					16382
				],
				[
					-7653,
					-9792
				],
				[
					-17937,
					-4147
				],
				[
					-6781,
					8967
				],
				[
					-11431,
					3266
				],
				[
					-3083,
					7188
				],
				[
					-14848,
					-2626
				],
				[
					117,
					12826
				],
				[
					-11248,
					-5328
				],
				[
					-2859,
					9828
				],
				[
					-12756,
					7028
				],
				[
					-5269,
					-4217
				],
				[
					-20030,
					13760
				],
				[
					-2619,
					12155
				],
				[
					-15078,
					-12888
				],
				[
					-7900,
					-872
				],
				[
					995,
					-28925
				],
				[
					14981,
					-12805
				],
				[
					17,
					-17971
				],
				[
					-16361,
					-32455
				],
				[
					-11585,
					16249
				],
				[
					1111,
					-13527
				],
				[
					-7650,
					-15546
				],
				[
					-4099,
					8884
				],
				[
					-7157,
					-15024
				],
				[
					1854,
					-8125
				],
				[
					-8902,
					-13147
				],
				[
					-1065,
					18580
				],
				[
					3366,
					11517
				],
				[
					22814,
					33409
				],
				[
					4249,
					19942
				],
				[
					-4668,
					15383
				],
				[
					-15539,
					6168
				],
				[
					-8108,
					-25298
				],
				[
					4318,
					-9845
				],
				[
					-2419,
					-13257
				],
				[
					-9172,
					-5628
				],
				[
					-2242,
					-27187
				],
				[
					-13581,
					-39494
				],
				[
					-20423,
					-8851
				],
				[
					8201,
					13214
				],
				[
					4020,
					26788
				],
				[
					7751,
					21937
				]
			],
			[
				[
					5911685,
					1660584
				],
				[
					-2401,
					9255
				],
				[
					-24798,
					346
				],
				[
					516,
					122710
				],
				[
					-8530,
					5825
				],
				[
					-10310,
					-3019
				],
				[
					-9860,
					4666
				],
				[
					-8173,
					-4432
				],
				[
					-11415,
					22144
				],
				[
					5571,
					25716
				],
				[
					-1902,
					8992
				],
				[
					-24232,
					15837
				],
				[
					-17505,
					-9469
				],
				[
					-5726,
					-13893
				],
				[
					6311,
					-5761
				],
				[
					-17109,
					-23125
				],
				[
					5478,
					16252
				],
				[
					-12385,
					-10951
				],
				[
					1191,
					15737
				],
				[
					-5054,
					12551
				],
				[
					-29,
					-41916
				],
				[
					9873,
					-7163
				],
				[
					4575,
					-16070
				],
				[
					5678,
					3557
				],
				[
					-2721,
					-20829
				],
				[
					-5407,
					-8630
				],
				[
					8570,
					-13678
				],
				[
					10803,
					3200
				],
				[
					10352,
					-5953
				],
				[
					1092,
					-16770
				],
				[
					7777,
					-20007
				],
				[
					-10638,
					-7176
				],
				[
					90,
					-11319
				],
				[
					21748,
					973
				],
				[
					7934,
					-15197
				],
				[
					1258,
					-24527
				]
			],
			[
				[
					5842307,
					1648460
				],
				[
					-6196,
					-136
				]
			],
			[
				[
					5836111,
					1648324
				],
				[
					35,
					-6862
				]
			],
			[
				[
					5836146,
					1641462
				],
				[
					67,
					-20953
				]
			],
			[
				[
					5836213,
					1620509
				],
				[
					-19964,
					-4
				],
				[
					2588,
					-13231
				],
				[
					-5908,
					-4559
				]
			],
			[
				[
					5812929,
					1602715
				],
				[
					-458,
					-24391
				],
				[
					-14291,
					230
				],
				[
					-323,
					-16022
				],
				[
					7244,
					-39
				],
				[
					-864,
					-35751
				]
			],
			[
				[
					5804237,
					1526742
				],
				[
					-12589,
					1160
				],
				[
					-8809,
					-6555
				],
				[
					-10802,
					9679
				],
				[
					-3305,
					13623
				],
				[
					-13622,
					6833
				],
				[
					-22761,
					-4448
				],
				[
					-13748,
					3616
				],
				[
					-9764,
					-3141
				],
				[
					-3309,
					6670
				],
				[
					-19079,
					-7838
				],
				[
					-15327,
					37378
				],
				[
					-22176,
					-15683
				],
				[
					-19123,
					-23646
				],
				[
					-20487,
					-8218
				],
				[
					-6429,
					4730
				],
				[
					-8912,
					-6063
				],
				[
					912,
					15776
				],
				[
					-17276,
					1358
				],
				[
					-268,
					20469
				],
				[
					-16921,
					1860
				],
				[
					-3300,
					7536
				],
				[
					-12685,
					6218
				],
				[
					605,
					13656
				],
				[
					-6188,
					9135
				],
				[
					-23417,
					-1080
				],
				[
					-4942,
					-9197
				],
				[
					4110,
					-16599
				],
				[
					-11376,
					-6380
				],
				[
					-12060,
					35999
				],
				[
					-3493,
					18715
				],
				[
					-16687,
					-2866
				],
				[
					-6503,
					6441
				],
				[
					9277,
					9141
				],
				[
					-549,
					10106
				],
				[
					-10682,
					-858
				],
				[
					-24199,
					16567
				]
			],
			[
				[
					5438353,
					1670836
				],
				[
					-228,
					23651
				]
			],
			[
				[
					5438125,
					1694487
				],
				[
					5199,
					-168
				],
				[
					-3803,
					17107
				]
			],
			[
				[
					5439521,
					1711426
				],
				[
					-404,
					58707
				]
			],
			[
				[
					5439117,
					1770133
				],
				[
					93381,
					549
				],
				[
					-15131,
					31190
				],
				[
					339,
					22211
				],
				[
					-16226,
					-6491
				],
				[
					-10216,
					34284
				],
				[
					3782,
					22305
				],
				[
					-5248,
					21223
				]
			],
			[
				[
					5489798,
					1895404
				],
				[
					7230,
					-1335
				],
				[
					2981,
					-11277
				],
				[
					7673,
					-4438
				],
				[
					-2333,
					17462
				]
			],
			[
				[
					5505349,
					1895816
				],
				[
					8615,
					-19
				],
				[
					-16,
					11764
				],
				[
					6234,
					-5210
				],
				[
					7870,
					10290
				],
				[
					-1198,
					11285
				],
				[
					7905,
					13481
				]
			],
			[
				[
					5534759,
					1937407
				],
				[
					54179,
					-217
				],
				[
					25,
					45999
				],
				[
					13726,
					912
				],
				[
					13675,
					-13453
				],
				[
					5618,
					19403
				],
				[
					19816,
					-405
				],
				[
					20329,
					27502
				]
			],
			[
				[
					5662127,
					2017148
				],
				[
					6074,
					4782
				],
				[
					113265,
					-107
				],
				[
					88534,
					419
				],
				[
					2055,
					19373
				],
				[
					-2994,
					13267
				],
				[
					-211,
					41183
				],
				[
					15636,
					144
				],
				[
					0,
					9529
				],
				[
					155465,
					73
				],
				[
					118506,
					-56
				],
				[
					3355,
					5792
				]
			],
			[
				[
					5474576,
					1708846
				],
				[
					0,
					0
				]
			],
			[
				[
					5490777,
					1699389
				],
				[
					0,
					0
				]
			],
			[
				[
					5455835,
					1687234
				],
				[
					0,
					0
				]
			],
			[
				[
					5528497,
					1686451
				],
				[
					-9543,
					-12116
				],
				[
					-12602,
					-1820
				],
				[
					195,
					-14615
				],
				[
					21526,
					8114
				],
				[
					6458,
					6949
				],
				[
					-6034,
					13488
				]
			],
			[
				[
					5522771,
					1611235
				],
				[
					15654,
					5402
				],
				[
					11767,
					-614
				],
				[
					-1,
					6255
				],
				[
					-27461,
					-88
				],
				[
					41,
					-10955
				]
			],
			[
				[
					5593056,
					2144324
				],
				[
					185,
					-7958
				]
			],
			[
				[
					5593241,
					2136366
				],
				[
					-11442,
					-356
				],
				[
					-4830,
					7723
				],
				[
					16087,
					591
				]
			],
			[
				[
					6082186,
					2730387
				],
				[
					2009,
					-28846
				],
				[
					7623,
					-112
				],
				[
					-4798,
					-16917
				],
				[
					-34499,
					1042
				],
				[
					1383,
					37268
				],
				[
					3605,
					7543
				],
				[
					24677,
					22
				]
			],
			[
				[
					5323591,
					1868398
				],
				[
					-1,
					813
				]
			],
			[
				[
					5323590,
					1869211
				],
				[
					1,
					-813
				]
			],
			[
				[
					5594980,
					2286960
				],
				[
					0,
					0
				]
			],
			[
				[
					5569456,
					2428069
				],
				[
					0,
					0
				]
			],
			[
				[
					5662127,
					2017148
				],
				[
					2,
					63887
				],
				[
					-13000,
					3145
				],
				[
					-24438,
					-321
				],
				[
					-15599,
					-16514
				],
				[
					-6567,
					3370
				],
				[
					-14057,
					-5897
				]
			],
			[
				[
					5588468,
					2064818
				],
				[
					-9318,
					23564
				],
				[
					11033,
					13061
				],
				[
					8520,
					24960
				],
				[
					-5462,
					9963
				]
			],
			[
				[
					5593056,
					2144324
				],
				[
					2279,
					14431
				],
				[
					15835,
					27945
				],
				[
					-2141,
					8003
				]
			],
			[
				[
					5609029,
					2194703
				],
				[
					-3445,
					18692
				],
				[
					14817,
					22628
				],
				[
					30837,
					6683
				],
				[
					11016,
					-4848
				],
				[
					177,
					201764
				],
				[
					-223094,
					1621
				],
				[
					-150,
					-188171
				],
				[
					-62189,
					-539
				],
				[
					81,
					-21215
				],
				[
					-31994,
					365
				],
				[
					4412,
					-8833
				],
				[
					16556,
					-1053
				],
				[
					18821,
					-15524
				],
				[
					15251,
					4011
				],
				[
					-368,
					-34490
				],
				[
					12395,
					309
				],
				[
					4383,
					-20371
				],
				[
					15596,
					-11529
				],
				[
					10772,
					-16555
				],
				[
					3291,
					-13298
				],
				[
					14773,
					-6512
				],
				[
					-257,
					-13931
				],
				[
					8166,
					-12027
				],
				[
					22635,
					2449
				],
				[
					14413,
					-4534
				],
				[
					16272,
					8135
				]
			],
			[
				[
					5522196,
					2087930
				],
				[
					9022,
					-229
				],
				[
					444,
					-65570
				],
				[
					-6383,
					-21922
				]
			],
			[
				[
					5525279,
					2000209
				],
				[
					-101056,
					108
				],
				[
					-280,
					-31280
				],
				[
					10154,
					1
				],
				[
					595,
					-19331
				],
				[
					-3496,
					-11954
				],
				[
					23198,
					13
				],
				[
					-12,
					12652
				],
				[
					12778,
					905
				],
				[
					6219,
					7264
				],
				[
					10635,
					166
				],
				[
					-155,
					-21343
				],
				[
					50900,
					-3
				]
			],
			[
				[
					5505349,
					1895816
				],
				[
					3152,
					10452
				],
				[
					-13519,
					6570
				],
				[
					-5184,
					-17434
				]
			],
			[
				[
					5439117,
					1770133
				],
				[
					590,
					30546
				],
				[
					-3419,
					-9664
				],
				[
					-86606,
					205
				]
			],
			[
				[
					5349682,
					1791220
				],
				[
					159,
					36683
				],
				[
					-26104,
					175
				],
				[
					2992,
					34510
				],
				[
					11858,
					-1609
				],
				[
					-406,
					6600
				]
			],
			[
				[
					5338181,
					1867579
				],
				[
					-14592,
					2386
				]
			],
			[
				[
					5323589,
					1869965
				],
				[
					-52,
					86508
				],
				[
					-5653,
					4671
				]
			],
			[
				[
					5317884,
					1961144
				],
				[
					-151,
					18493
				],
				[
					5161,
					9620
				],
				[
					19602,
					13573
				],
				[
					2365,
					8535
				]
			],
			[
				[
					5344861,
					2011365
				],
				[
					7186,
					25839
				],
				[
					-6393,
					17389
				],
				[
					-9049,
					-2325
				],
				[
					-6528,
					15885
				]
			],
			[
				[
					5330077,
					2068153
				],
				[
					-13280,
					3007
				],
				[
					-8647,
					-11798
				]
			],
			[
				[
					5308150,
					2059362
				],
				[
					881,
					-10243
				]
			],
			[
				[
					5309031,
					2049119
				],
				[
					-19470,
					1583
				],
				[
					-8695,
					-4177
				]
			],
			[
				[
					5280866,
					2046525
				],
				[
					-6877,
					8286
				],
				[
					-9664,
					32811
				],
				[
					-7928,
					13233
				],
				[
					-2367,
					31334
				],
				[
					14921,
					-2383
				],
				[
					28977,
					6189
				],
				[
					32649,
					133
				],
				[
					-735,
					95562
				],
				[
					-7032,
					-237
				],
				[
					135,
					17694
				],
				[
					7416,
					8313
				],
				[
					-1835,
					183758
				],
				[
					-9658,
					731
				],
				[
					-130439,
					-848
				]
			],
			[
				[
					5188429,
					2441101
				],
				[
					-12,
					250827
				],
				[
					100735,
					130470
				],
				[
					34815,
					42081
				],
				[
					36768,
					46848
				],
				[
					52019,
					81880
				],
				[
					132360,
					196970
				],
				[
					39843,
					60903
				],
				[
					95651,
					135550
				],
				[
					205406,
					271783
				]
			],
			[
				[
					5886014,
					3658413
				],
				[
					12570,
					2508
				],
				[
					5053,
					-14151
				],
				[
					19260,
					-24131
				],
				[
					19543,
					-12565
				],
				[
					13816,
					-17764
				],
				[
					16478,
					-12343
				],
				[
					28746,
					-15651
				],
				[
					1977,
					-10624
				],
				[
					24706,
					-42712
				],
				[
					11172,
					-33406
				],
				[
					13811,
					-10277
				],
				[
					3531,
					-9255
				],
				[
					30456,
					-19684
				],
				[
					34698,
					-4950
				],
				[
					24397,
					-17500
				],
				[
					15977,
					-8005
				]
			],
			[
				[
					5486696,
					1916933
				],
				[
					-7695,
					-13031
				],
				[
					6010,
					-478
				],
				[
					9360,
					13278
				],
				[
					-7675,
					231
				]
			],
			[
				[
					5253281,
					1792446
				],
				[
					7941,
					-12674
				],
				[
					-5748,
					-11422
				],
				[
					-9517,
					9037
				],
				[
					7324,
					15059
				]
			],
			[
				[
					5308269,
					1794279
				],
				[
					-24,
					-525
				]
			],
			[
				[
					5308245,
					1793754
				],
				[
					-4,
					-87
				]
			],
			[
				[
					5308241,
					1793667
				],
				[
					-12,
					-247
				]
			],
			[
				[
					5308229,
					1793420
				],
				[
					40,
					859
				]
			],
			[
				[
					5308326,
					1799068
				],
				[
					-47,
					-3955
				]
			],
			[
				[
					5308279,
					1795113
				],
				[
					47,
					3955
				]
			],
			[
				[
					5439521,
					1711426
				],
				[
					-1396,
					-16939
				]
			],
			[
				[
					5438353,
					1670836
				],
				[
					-4445,
					3892
				],
				[
					-36914,
					2240
				]
			],
			[
				[
					5396994,
					1676968
				],
				[
					-11577,
					9499
				],
				[
					-1253,
					16320
				],
				[
					-6880,
					-202
				],
				[
					88,
					-18732
				],
				[
					-11458,
					-3144
				],
				[
					-19,
					-29021
				]
			],
			[
				[
					5365895,
					1651688
				],
				[
					-23743,
					-2934
				],
				[
					-4537,
					26432
				],
				[
					-19363,
					4275
				],
				[
					-26989,
					2154
				],
				[
					-2148,
					10534
				],
				[
					-30885,
					2038
				],
				[
					-11822,
					9375
				],
				[
					-6593,
					19967
				],
				[
					11747,
					28255
				],
				[
					10310,
					2581
				],
				[
					20065,
					29591
				],
				[
					2166,
					14633
				],
				[
					12842,
					-12660
				],
				[
					11191,
					5624
				]
			],
			[
				[
					5308136,
					1791553
				],
				[
					-100,
					-26071
				],
				[
					41575,
					-12
				],
				[
					71,
					25750
				]
			],
			[
				[
					5409279,
					1703125
				],
				[
					-6720,
					-14299
				],
				[
					21783,
					8702
				],
				[
					-149,
					9577
				],
				[
					-14914,
					-3980
				]
			],
			[
				[
					5392783,
					1687740
				],
				[
					2446,
					9484
				],
				[
					-8229,
					2782
				],
				[
					5783,
					-12266
				]
			],
			[
				[
					5308375,
					1800681
				],
				[
					-26,
					-738
				]
			],
			[
				[
					5308349,
					1799943
				],
				[
					26,
					738
				]
			],
			[
				[
					5308441,
					1802560
				],
				[
					-24,
					-688
				]
			],
			[
				[
					5308417,
					1801872
				],
				[
					24,
					688
				]
			],
			[
				[
					5308530,
					1805091
				],
				[
					-41,
					-1153
				]
			],
			[
				[
					5308489,
					1803938
				],
				[
					41,
					1153
				]
			],
			[
				[
					5308679,
					1809447
				],
				[
					-13920,
					-1710
				],
				[
					1856,
					6046
				]
			],
			[
				[
					5296615,
					1813783
				],
				[
					7054,
					101
				]
			],
			[
				[
					5303669,
					1813884
				],
				[
					2753,
					39
				]
			],
			[
				[
					5306422,
					1813923
				],
				[
					2257,
					-4476
				]
			],
			[
				[
					5245442,
					1814920
				],
				[
					1908,
					-6027
				],
				[
					10556,
					5824
				],
				[
					1121,
					-6551
				],
				[
					-8594,
					-14152
				],
				[
					-13459,
					-2213
				],
				[
					-2872,
					14098
				],
				[
					11340,
					9021
				]
			],
			[
				[
					5295810,
					1831158
				],
				[
					90,
					-16311
				]
			],
			[
				[
					5295900,
					1814847
				],
				[
					-6498,
					-1304
				],
				[
					-5160,
					20205
				]
			],
			[
				[
					5284242,
					1833748
				],
				[
					11568,
					-2590
				]
			],
			[
				[
					5282560,
					1833759
				],
				[
					1284,
					-8
				]
			],
			[
				[
					5283844,
					1833751
				],
				[
					-1284,
					8
				]
			],
			[
				[
					5277917,
					1833788
				],
				[
					1914,
					-12
				]
			],
			[
				[
					5279831,
					1833776
				],
				[
					-1914,
					12
				]
			],
			[
				[
					5256010,
					1833907
				],
				[
					21807,
					-119
				]
			],
			[
				[
					5277817,
					1833788
				],
				[
					-11080,
					-12918
				],
				[
					-10727,
					13037
				]
			],
			[
				[
					5235846,
					1834544
				],
				[
					585,
					-21
				]
			],
			[
				[
					5236431,
					1834523
				],
				[
					-585,
					21
				]
			],
			[
				[
					5239016,
					1834431
				],
				[
					942,
					1040
				]
			],
			[
				[
					5239958,
					1835471
				],
				[
					-942,
					-1040
				]
			],
			[
				[
					5255385,
					1849688
				],
				[
					160,
					-12854
				]
			],
			[
				[
					5255545,
					1836834
				],
				[
					-8886,
					9010
				],
				[
					8726,
					3844
				]
			],
			[
				[
					5239837,
					1853070
				],
				[
					1776,
					726
				]
			],
			[
				[
					5241613,
					1853796
				],
				[
					-1776,
					-726
				]
			],
			[
				[
					5242404,
					1853803
				],
				[
					1638,
					12
				]
			],
			[
				[
					5244042,
					1853815
				],
				[
					-1638,
					-12
				]
			],
			[
				[
					5245682,
					1853827
				],
				[
					6441,
					44
				]
			],
			[
				[
					5252123,
					1853871
				],
				[
					-6441,
					-44
				]
			],
			[
				[
					5252377,
					1853873
				],
				[
					1220,
					7
				]
			],
			[
				[
					5253597,
					1853880
				],
				[
					-1220,
					-7
				]
			],
			[
				[
					5255380,
					1850052
				],
				[
					-1436,
					3830
				]
			],
			[
				[
					5253944,
					1853882
				],
				[
					1436,
					-3830
				]
			],
			[
				[
					5308241,
					1793667
				],
				[
					-12,
					-247
				]
			],
			[
				[
					5308269,
					1794279
				],
				[
					-24,
					-525
				]
			],
			[
				[
					5308375,
					1800681
				],
				[
					-26,
					-738
				]
			],
			[
				[
					5308441,
					1802560
				],
				[
					-24,
					-688
				]
			],
			[
				[
					5308530,
					1805091
				],
				[
					-41,
					-1153
				]
			],
			[
				[
					5296615,
					1813783
				],
				[
					-715,
					1064
				]
			],
			[
				[
					5295810,
					1831158
				],
				[
					-1161,
					10480
				]
			],
			[
				[
					5294649,
					1841638
				],
				[
					15788,
					-8583
				],
				[
					944,
					-7967
				],
				[
					-7712,
					-11204
				]
			],
			[
				[
					5294478,
					1843177
				],
				[
					-85,
					763
				]
			],
			[
				[
					5294393,
					1843940
				],
				[
					85,
					-763
				]
			],
			[
				[
					5293809,
					1849213
				],
				[
					-412,
					3716
				]
			],
			[
				[
					5293397,
					1852929
				],
				[
					412,
					-3716
				]
			],
			[
				[
					5293357,
					1853296
				],
				[
					-76,
					4960
				]
			],
			[
				[
					5293281,
					1858256
				],
				[
					76,
					-4960
				]
			],
			[
				[
					5200984,
					1854281
				],
				[
					-647,
					288
				]
			],
			[
				[
					5200337,
					1854569
				],
				[
					-877,
					468
				]
			],
			[
				[
					5199460,
					1855037
				],
				[
					11404,
					5508
				]
			],
			[
				[
					5210864,
					1860545
				],
				[
					-9880,
					-6264
				]
			],
			[
				[
					5293281,
					1858619
				],
				[
					-5,
					8612
				]
			],
			[
				[
					5293276,
					1867231
				],
				[
					5,
					-8612
				]
			],
			[
				[
					5293275,
					1869077
				],
				[
					0,
					729
				]
			],
			[
				[
					5293275,
					1869806
				],
				[
					0,
					-729
				]
			],
			[
				[
					5293274,
					1870765
				],
				[
					0,
					902
				]
			],
			[
				[
					5293274,
					1871667
				],
				[
					0,
					-902
				]
			],
			[
				[
					5293266,
					1878039
				],
				[
					-3,
					1647
				]
			],
			[
				[
					5293263,
					1879686
				],
				[
					3,
					-1647
				]
			],
			[
				[
					5293260,
					1881534
				],
				[
					-1,
					253
				]
			],
			[
				[
					5293259,
					1881787
				],
				[
					1,
					-253
				]
			],
			[
				[
					5188498,
					1878831
				],
				[
					-164,
					28591
				]
			],
			[
				[
					5188334,
					1907422
				],
				[
					6650,
					-13069
				],
				[
					-6486,
					-15522
				]
			],
			[
				[
					5188450,
					1910889
				],
				[
					-37,
					3234
				]
			],
			[
				[
					5188413,
					1914123
				],
				[
					37,
					-3234
				]
			],
			[
				[
					5188403,
					1916614
				],
				[
					-1,
					377
				]
			],
			[
				[
					5188402,
					1916991
				],
				[
					1,
					-377
				]
			],
			[
				[
					5188395,
					1918640
				],
				[
					-3,
					722
				]
			],
			[
				[
					5188392,
					1919362
				],
				[
					3,
					-722
				]
			],
			[
				[
					5243497,
					1900643
				],
				[
					-2305,
					-1410
				]
			],
			[
				[
					5241192,
					1899233
				],
				[
					-381,
					-624
				]
			],
			[
				[
					5240811,
					1898609
				],
				[
					-2038,
					-3021
				]
			],
			[
				[
					5238773,
					1895588
				],
				[
					-7086,
					-4166
				]
			],
			[
				[
					5231687,
					1891422
				],
				[
					-13268,
					-1777
				]
			],
			[
				[
					5218419,
					1889645
				],
				[
					-155,
					-300
				]
			],
			[
				[
					5218264,
					1889345
				],
				[
					-140,
					-272
				]
			],
			[
				[
					5218124,
					1889073
				],
				[
					-432,
					-837
				]
			],
			[
				[
					5217692,
					1888236
				],
				[
					-9334,
					-9999
				],
				[
					-15374,
					-7110
				],
				[
					-4516,
					2811
				]
			],
			[
				[
					5188468,
					1873938
				],
				[
					2,
					404
				]
			],
			[
				[
					5188470,
					1874342
				],
				[
					4744,
					-2303
				],
				[
					16992,
					11034
				],
				[
					2081,
					8894
				],
				[
					11580,
					1430
				],
				[
					-3227,
					10011
				],
				[
					29813,
					17643
				],
				[
					-6956,
					-20408
				]
			],
			[
				[
					5260955,
					1941354
				],
				[
					1394,
					-2924
				]
			],
			[
				[
					5262349,
					1938430
				],
				[
					-1394,
					2924
				]
			],
			[
				[
					5257040,
					1954220
				],
				[
					17,
					-426
				]
			],
			[
				[
					5257057,
					1953794
				],
				[
					-17,
					426
				]
			],
			[
				[
					5323589,
					1869965
				],
				[
					1,
					-754
				]
			],
			[
				[
					5323591,
					1868398
				],
				[
					-15651,
					-2980
				],
				[
					13775,
					-4756
				],
				[
					16466,
					6917
				]
			],
			[
				[
					5308136,
					1791553
				],
				[
					143,
					3560
				]
			],
			[
				[
					5308326,
					1799068
				],
				[
					14150,
					4811
				],
				[
					-632,
					8128
				],
				[
					-13165,
					-2560
				]
			],
			[
				[
					5306422,
					1813923
				],
				[
					8419,
					14980
				],
				[
					3587,
					26658
				],
				[
					-7487,
					-104
				],
				[
					-13493,
					15039
				],
				[
					-4189,
					11443
				]
			],
			[
				[
					5293259,
					1881939
				],
				[
					-7,
					3895
				]
			],
			[
				[
					5293252,
					1885834
				],
				[
					-1,
					738
				]
			],
			[
				[
					5293251,
					1886572
				],
				[
					-6,
					3544
				]
			],
			[
				[
					5293245,
					1890116
				],
				[
					-2,
					1065
				]
			],
			[
				[
					5293243,
					1891181
				],
				[
					-11146,
					4549
				]
			],
			[
				[
					5282097,
					1895730
				],
				[
					-3538,
					14331
				],
				[
					15050,
					-1929
				]
			],
			[
				[
					5293609,
					1908132
				],
				[
					-3261,
					949
				]
			],
			[
				[
					5290348,
					1909081
				],
				[
					-5872,
					6032
				]
			],
			[
				[
					5284476,
					1915113
				],
				[
					-839,
					4724
				]
			],
			[
				[
					5283637,
					1919837
				],
				[
					1641,
					7420
				],
				[
					-8898,
					13129
				]
			],
			[
				[
					5276380,
					1940386
				],
				[
					14384,
					46
				],
				[
					4863,
					17836
				],
				[
					22257,
					2876
				]
			],
			[
				[
					5253758,
					1970588
				],
				[
					-16,
					80
				]
			],
			[
				[
					5253742,
					1970668
				],
				[
					16,
					-80
				]
			],
			[
				[
					5253239,
					1989639
				],
				[
					-24,
					-460
				]
			],
			[
				[
					5253215,
					1989179
				],
				[
					-4296,
					-10064
				],
				[
					-7593,
					11612
				],
				[
					7545,
					7867
				],
				[
					4368,
					-8955
				]
			],
			[
				[
					5274459,
					2000676
				],
				[
					0,
					0
				]
			],
			[
				[
					5321515,
					2056033
				],
				[
					-843,
					-14157
				],
				[
					-8732,
					-2001
				],
				[
					2898,
					16024
				],
				[
					6677,
					134
				]
			],
			[
				[
					5308150,
					2059362
				],
				[
					881,
					-10243
				]
			],
			[
				[
					5344861,
					2011365
				],
				[
					-25822,
					-4014
				],
				[
					5555,
					18980
				],
				[
					-2194,
					21697
				],
				[
					7677,
					20125
				]
			],
			[
				[
					5609029,
					2194703
				],
				[
					-10176,
					-24909
				],
				[
					-7838,
					8805
				],
				[
					-9616,
					-10968
				],
				[
					-8415,
					44
				],
				[
					-5544,
					-16627
				],
				[
					-15826,
					-13578
				],
				[
					8627,
					-23164
				],
				[
					-7833,
					-39
				],
				[
					-5309,
					-12697
				],
				[
					-23060,
					-6102
				],
				[
					-1843,
					-7538
				]
			],
			[
				[
					5280866,
					2046525
				],
				[
					135,
					-38614
				],
				[
					-16463,
					-45
				],
				[
					1332,
					-19775
				],
				[
					-8800,
					-2008
				]
			],
			[
				[
					5257070,
					1986083
				],
				[
					-12800,
					18371
				],
				[
					-5187,
					-11849
				],
				[
					7294,
					-6083
				],
				[
					1044,
					-12198
				],
				[
					9639,
					-20599
				]
			],
			[
				[
					5257060,
					1953725
				],
				[
					55,
					-1341
				]
			],
			[
				[
					5257115,
					1952384
				],
				[
					50,
					-1237
				]
			],
			[
				[
					5257165,
					1951147
				],
				[
					7,
					-1178
				]
			],
			[
				[
					5257172,
					1949969
				],
				[
					-4035,
					-7240
				],
				[
					3389,
					-13377
				],
				[
					-14270,
					-5854
				],
				[
					8153,
					11999
				],
				[
					-24362,
					829
				],
				[
					-8098,
					-15174
				],
				[
					9522,
					758
				],
				[
					-7830,
					-19281
				],
				[
					-13934,
					3656
				],
				[
					5789,
					9211
				],
				[
					-10939,
					3491
				],
				[
					-5973,
					-5823
				],
				[
					-6199,
					7977
				]
			],
			[
				[
					5188385,
					1921141
				],
				[
					17,
					6227
				]
			],
			[
				[
					5188402,
					1927368
				],
				[
					11133,
					-40
				],
				[
					-4603,
					22926
				],
				[
					8131,
					456
				],
				[
					-113,
					15705
				],
				[
					-14501,
					51
				]
			],
			[
				[
					5188449,
					1966466
				],
				[
					-17,
					412252
				]
			],
			[
				[
					5188432,
					2378718
				],
				[
					-3,
					62383
				]
			],
			[
				[
					5188402,
					1927368
				],
				[
					13,
					9236
				]
			],
			[
				[
					5188415,
					1936604
				],
				[
					34,
					29862
				]
			],
			[
				[
					6973887,
					1113597
				],
				[
					-7166,
					2020
				],
				[
					1252,
					-15656
				],
				[
					-8863,
					568
				],
				[
					-114,
					16744
				],
				[
					10366,
					3978
				]
			],
			[
				[
					6969362,
					1121251
				],
				[
					680,
					833
				]
			],
			[
				[
					6970042,
					1122084
				],
				[
					2389,
					-3529
				]
			],
			[
				[
					6970042,
					1122084
				],
				[
					-680,
					-833
				]
			],
			[
				[
					6901370,
					1106929
				],
				[
					14436,
					2965
				],
				[
					-88,
					20046
				],
				[
					14304,
					858
				],
				[
					-136,
					11854
				]
			],
			[
				[
					7002285,
					788496
				],
				[
					-7113,
					8330
				],
				[
					-11434,
					-5982
				],
				[
					-4245,
					9417
				],
				[
					-12575,
					-4190
				],
				[
					-1348,
					11350
				]
			],
			[
				[
					6962098,
					812119
				],
				[
					-1000,
					1377
				]
			],
			[
				[
					6897784,
					873716
				],
				[
					-12009,
					-6222
				],
				[
					-3721,
					-12910
				],
				[
					-4956,
					15398
				],
				[
					5824,
					9281
				]
			],
			[
				[
					6802429,
					1161264
				],
				[
					-11363,
					3257
				]
			],
			[
				[
					6791066,
					1164521
				],
				[
					-2,
					6794
				]
			],
			[
				[
					6791064,
					1171315
				],
				[
					4779,
					70
				]
			],
			[
				[
					6795843,
					1171385
				],
				[
					7222,
					-89
				],
				[
					-148,
					-10027
				]
			],
			[
				[
					6802334,
					1153693
				],
				[
					-5974,
					-105
				]
			],
			[
				[
					6796360,
					1153588
				],
				[
					-5815,
					7034
				]
			],
			[
				[
					6790545,
					1160622
				],
				[
					521,
					3899
				]
			],
			[
				[
					6790545,
					1160622
				],
				[
					-5369,
					-5067
				]
			],
			[
				[
					6781457,
					1171439
				],
				[
					9607,
					-124
				]
			],
			[
				[
					6774635,
					1125840
				],
				[
					4956,
					3657
				]
			],
			[
				[
					6779591,
					1129497
				],
				[
					23400,
					-214
				],
				[
					155,
					20973
				]
			],
			[
				[
					6778408,
					1128428
				],
				[
					0,
					0
				]
			],
			[
				[
					6796360,
					1153588
				],
				[
					-6570,
					-8404
				],
				[
					-8642,
					5053
				]
			],
			[
				[
					6781148,
					1150237
				],
				[
					-450,
					2495
				]
			],
			[
				[
					6779591,
					1129497
				],
				[
					1557,
					20740
				]
			],
			[
				[
					6795843,
					1171385
				],
				[
					2328,
					20757
				]
			],
			[
				[
					6798171,
					1192142
				],
				[
					11739,
					-215
				],
				[
					96,
					23725
				]
			],
			[
				[
					6783775,
					1192090
				],
				[
					14396,
					52
				]
			],
			[
				[
					6751209,
					1642938
				],
				[
					0,
					0
				]
			],
			[
				[
					6751528,
					1643197
				],
				[
					0,
					0
				]
			],
			[
				[
					6749158,
					1643859
				],
				[
					0,
					0
				]
			],
			[
				[
					6746660,
					1642184
				],
				[
					0,
					0
				]
			],
			[
				[
					6721466,
					1066436
				],
				[
					-90,
					-4
				]
			],
			[
				[
					6719318,
					1066340
				],
				[
					-5615,
					-2284
				]
			],
			[
				[
					6708879,
					1065808
				],
				[
					90,
					448
				]
			],
			[
				[
					6402269,
					1208948
				],
				[
					-838,
					1267
				]
			],
			[
				[
					6435447,
					1169747
				],
				[
					-10950,
					919
				],
				[
					-4285,
					-9598
				],
				[
					-12482,
					3488
				]
			],
			[
				[
					6407730,
					1164556
				],
				[
					4005,
					3087
				]
			],
			[
				[
					6411735,
					1167643
				],
				[
					2289,
					4856
				]
			],
			[
				[
					6414024,
					1172499
				],
				[
					-9514,
					2208
				],
				[
					-4,
					-12512
				]
			],
			[
				[
					6404506,
					1162195
				],
				[
					-8291,
					-11110
				],
				[
					-9074,
					1868
				],
				[
					-9175,
					16452
				],
				[
					16967,
					32215
				]
			],
			[
				[
					6405645,
					1177907
				],
				[
					0,
					0
				]
			],
			[
				[
					6411735,
					1167643
				],
				[
					2289,
					4856
				]
			],
			[
				[
					6407730,
					1164556
				],
				[
					-3224,
					-2361
				]
			],
			[
				[
					5860096,
					1628895
				],
				[
					-24,
					1
				]
			],
			[
				[
					5860072,
					1628896
				],
				[
					24,
					-1
				]
			],
			[
				[
					5867372,
					1639043
				],
				[
					-7317,
					-10145
				]
			],
			[
				[
					5860055,
					1628898
				],
				[
					-4955,
					4788
				]
			],
			[
				[
					5855100,
					1633686
				],
				[
					8763,
					7175
				]
			],
			[
				[
					5863863,
					1640861
				],
				[
					3509,
					-1818
				]
			],
			[
				[
					5860055,
					1628898
				],
				[
					17,
					-2
				]
			],
			[
				[
					5860096,
					1628895
				],
				[
					-860,
					-2147
				]
			],
			[
				[
					5859236,
					1626748
				],
				[
					-7270,
					-4693
				]
			],
			[
				[
					5851966,
					1622055
				],
				[
					3134,
					11631
				]
			],
			[
				[
					5836111,
					1648324
				],
				[
					35,
					-6862
				]
			],
			[
				[
					5911685,
					1660584
				],
				[
					-16489,
					-5326
				],
				[
					-7418,
					-8125
				],
				[
					-17802,
					-5922
				]
			],
			[
				[
					5869695,
					1641095
				],
				[
					-2323,
					-2052
				]
			],
			[
				[
					5863863,
					1640861
				],
				[
					-33,
					7552
				],
				[
					-21523,
					47
				]
			],
			[
				[
					5850285,
					1618086
				],
				[
					0,
					0
				]
			],
			[
				[
					5836213,
					1620509
				],
				[
					4318,
					-31
				]
			],
			[
				[
					5840531,
					1620478
				],
				[
					-33,
					-12929
				]
			],
			[
				[
					5840498,
					1607549
				],
				[
					-1877,
					-13414
				]
			],
			[
				[
					5838621,
					1594135
				],
				[
					-13585,
					-106
				],
				[
					38,
					8846
				],
				[
					-12145,
					-160
				]
			],
			[
				[
					5859236,
					1626748
				],
				[
					720,
					-7746
				]
			],
			[
				[
					5859956,
					1619002
				],
				[
					-2873,
					-2744
				]
			],
			[
				[
					5857083,
					1616258
				],
				[
					-6619,
					581
				]
			],
			[
				[
					5850464,
					1616839
				],
				[
					740,
					3643
				]
			],
			[
				[
					5851204,
					1620482
				],
				[
					762,
					1573
				]
			],
			[
				[
					5849364,
					1616123
				],
				[
					0,
					0
				]
			],
			[
				[
					5850289,
					1616281
				],
				[
					0,
					0
				]
			],
			[
				[
					5857083,
					1616258
				],
				[
					-8412,
					-8422
				]
			],
			[
				[
					5848671,
					1607836
				],
				[
					1793,
					9003
				]
			],
			[
				[
					5851204,
					1620482
				],
				[
					-10673,
					-4
				]
			],
			[
				[
					5853667,
					1581652
				],
				[
					-11122,
					-2968
				],
				[
					-3924,
					15451
				]
			],
			[
				[
					5840498,
					1607549
				],
				[
					8173,
					287
				]
			],
			[
				[
					5859956,
					1619002
				],
				[
					1691,
					-14836
				],
				[
					-7980,
					-22514
				]
			],
			[
				[
					5876657,
					1590212
				],
				[
					4686,
					-6292
				],
				[
					-10675,
					-9647
				],
				[
					-5897,
					6387
				],
				[
					11886,
					9552
				]
			],
			[
				[
					5853667,
					1581652
				],
				[
					-8233,
					-34654
				],
				[
					-13951,
					-6870
				],
				[
					555,
					-6267
				],
				[
					-13143,
					-7588
				],
				[
					-14658,
					469
				]
			],
			[
				[
					5525279,
					2000209
				],
				[
					18120,
					-267
				],
				[
					-533,
					15300
				],
				[
					13275,
					39
				],
				[
					8241,
					-6036
				],
				[
					12114,
					2579
				],
				[
					-32,
					8629
				]
			],
			[
				[
					5576442,
					2021824
				],
				[
					-197,
					17475
				],
				[
					-10890,
					66
				],
				[
					3842,
					13957
				],
				[
					19271,
					11496
				]
			],
			[
				[
					5396994,
					1676968
				],
				[
					-17608,
					-9893
				],
				[
					-179,
					-10974
				],
				[
					-13312,
					-4413
				]
			],
			[
				[
					5239016,
					1834431
				],
				[
					942,
					1040
				]
			],
			[
				[
					5235846,
					1834544
				],
				[
					585,
					-21
				]
			],
			[
				[
					5200984,
					1854281
				],
				[
					-647,
					288
				]
			],
			[
				[
					5236860,
					1867726
				],
				[
					727,
					-19579
				],
				[
					-9048,
					1937
				],
				[
					8321,
					17642
				]
			],
			[
				[
					5293275,
					1869077
				],
				[
					-1,
					2590
				]
			],
			[
				[
					5293274,
					1870765
				],
				[
					1,
					-959
				]
			],
			[
				[
					5293266,
					1878039
				],
				[
					-3,
					1647
				]
			],
			[
				[
					5293281,
					1858619
				],
				[
					0,
					-363
				]
			],
			[
				[
					5293357,
					1853296
				],
				[
					40,
					-367
				]
			],
			[
				[
					5293809,
					1849213
				],
				[
					584,
					-5273
				]
			],
			[
				[
					5294478,
					1843177
				],
				[
					171,
					-1539
				]
			],
			[
				[
					5284242,
					1833748
				],
				[
					-398,
					3
				]
			],
			[
				[
					5282560,
					1833759
				],
				[
					-2729,
					17
				]
			],
			[
				[
					5277917,
					1833788
				],
				[
					-100,
					0
				]
			],
			[
				[
					5256010,
					1833907
				],
				[
					-465,
					2927
				]
			],
			[
				[
					5255385,
					1849688
				],
				[
					-5,
					364
				]
			],
			[
				[
					5253944,
					1853882
				],
				[
					-347,
					-2
				]
			],
			[
				[
					5252377,
					1853873
				],
				[
					-254,
					-2
				]
			],
			[
				[
					5245682,
					1853827
				],
				[
					-1640,
					-12
				]
			],
			[
				[
					5242404,
					1853803
				],
				[
					-791,
					-7
				]
			],
			[
				[
					5239837,
					1853070
				],
				[
					1813,
					16087
				],
				[
					-7092,
					4582
				],
				[
					5329,
					11536
				],
				[
					10090,
					-10302
				],
				[
					31744,
					7411
				],
				[
					6208,
					-16021
				],
				[
					5347,
					868
				]
			],
			[
				[
					5293260,
					1881534
				],
				[
					-8,
					4300
				]
			],
			[
				[
					5293259,
					1881939
				],
				[
					0,
					-152
				]
			],
			[
				[
					5218264,
					1889345
				],
				[
					-140,
					-272
				]
			],
			[
				[
					5199460,
					1855037
				],
				[
					-11077,
					6594
				]
			],
			[
				[
					5188383,
					1861631
				],
				[
					85,
					12307
				]
			],
			[
				[
					5217692,
					1888236
				],
				[
					7664,
					-1721
				],
				[
					-14492,
					-25970
				]
			],
			[
				[
					5293251,
					1886572
				],
				[
					-6,
					3544
				]
			],
			[
				[
					5231687,
					1891422
				],
				[
					-13268,
					-1777
				]
			],
			[
				[
					5293243,
					1891181
				],
				[
					-11146,
					4549
				]
			],
			[
				[
					5240811,
					1898609
				],
				[
					-2038,
					-3021
				]
			],
			[
				[
					5243497,
					1900643
				],
				[
					-2305,
					-1410
				]
			],
			[
				[
					5293609,
					1908132
				],
				[
					-3261,
					949
				]
			],
			[
				[
					5284476,
					1915113
				],
				[
					-839,
					4724
				]
			],
			[
				[
					5257165,
					1951147
				],
				[
					7,
					-1178
				]
			],
			[
				[
					5257060,
					1953725
				],
				[
					-3,
					69
				]
			],
			[
				[
					5257040,
					1954220
				],
				[
					75,
					-1836
				]
			],
			[
				[
					5253239,
					1989639
				],
				[
					-24,
					-460
				]
			],
			[
				[
					5276380,
					1940386
				],
				[
					-14031,
					-1956
				]
			],
			[
				[
					5260955,
					1941354
				],
				[
					4299,
					5344
				],
				[
					-11496,
					23890
				]
			],
			[
				[
					5253742,
					1970668
				],
				[
					3328,
					15415
				]
			],
			[
				[
					5040971,
					1907583
				],
				[
					-7775,
					-3534
				],
				[
					-2607,
					10646
				],
				[
					-7709,
					-3534
				]
			],
			[
				[
					5022880,
					1911161
				],
				[
					-2843,
					22
				]
			],
			[
				[
					5020037,
					1911183
				],
				[
					21,
					3517
				]
			],
			[
				[
					5020058,
					1914700
				],
				[
					-5082,
					3621
				]
			],
			[
				[
					5014976,
					1918321
				],
				[
					-12658,
					-3425
				],
				[
					2517,
					17963
				],
				[
					13284,
					-2592
				],
				[
					4917,
					27348
				]
			],
			[
				[
					5023036,
					1957615
				],
				[
					17867,
					-7167
				],
				[
					10335,
					9
				],
				[
					-155,
					-14378
				],
				[
					-17902,
					34
				],
				[
					-11,
					-10604
				],
				[
					7793,
					-3698
				],
				[
					8,
					-14228
				]
			],
			[
				[
					4942690,
					1765480
				],
				[
					-5000,
					3
				]
			],
			[
				[
					5188403,
					1916614
				],
				[
					-1,
					377
				]
			],
			[
				[
					5188395,
					1918640
				],
				[
					-3,
					722
				]
			],
			[
				[
					5017063,
					1854797
				],
				[
					2489,
					3504
				],
				[
					-8,
					35560
				],
				[
					8498,
					3028
				],
				[
					-5162,
					14272
				]
			],
			[
				[
					5040971,
					1907583
				],
				[
					10235,
					592
				],
				[
					-1180,
					-42889
				],
				[
					76798,
					30
				],
				[
					0,
					-32154
				],
				[
					20954,
					493
				],
				[
					9817,
					-11730
				],
				[
					-209,
					-12256
				],
				[
					9473,
					5904
				],
				[
					7402,
					12220
				],
				[
					-7325,
					17085
				],
				[
					1054,
					11977
				],
				[
					-8971,
					17600
				],
				[
					-11266,
					-60
				],
				[
					-5787,
					19508
				],
				[
					17668,
					-67
				],
				[
					3,
					30267
				],
				[
					28778,
					12501
				]
			],
			[
				[
					5188385,
					1921141
				],
				[
					28,
					-7018
				]
			],
			[
				[
					5188450,
					1910889
				],
				[
					-116,
					-3467
				]
			],
			[
				[
					5188498,
					1878831
				],
				[
					-28,
					-4489
				]
			],
			[
				[
					5188383,
					1861631
				],
				[
					44,
					-54029
				],
				[
					-13980,
					-8340
				],
				[
					36,
					-20047
				],
				[
					5046,
					-13746
				],
				[
					-143106,
					-5
				],
				[
					-86104,
					2
				]
			],
			[
				[
					4983636,
					1966690
				],
				[
					10945,
					-8927
				],
				[
					28455,
					-148
				]
			],
			[
				[
					5014976,
					1918321
				],
				[
					5082,
					-3621
				]
			],
			[
				[
					5020037,
					1911183
				],
				[
					-17701,
					-6908
				],
				[
					-507,
					-35254
				],
				[
					10213,
					-84
				],
				[
					5021,
					-14140
				]
			],
			[
				[
					5017063,
					1854797
				],
				[
					0,
					0
				]
			],
			[
				[
					5166810,
					1930486
				],
				[
					0,
					0
				]
			],
			[
				[
					4637499,
					2733290
				],
				[
					33250,
					3
				],
				[
					-987,
					-10905
				],
				[
					-21674,
					1331
				]
			],
			[
				[
					4664145,
					2758344
				],
				[
					0,
					0
				]
			],
			[
				[
					4660699,
					2754697
				],
				[
					0,
					0
				]
			],
			[
				[
					4413875,
					4419003
				],
				[
					169686,
					0
				],
				[
					141405,
					0
				],
				[
					113124,
					0
				],
				[
					84843,
					0
				],
				[
					141405,
					0
				],
				[
					161442,
					0
				]
			],
			[
				[
					5225780,
					4419003
				],
				[
					-1176,
					-28340
				],
				[
					6412,
					-24883
				],
				[
					-6442,
					-16333
				],
				[
					59,
					-26757
				],
				[
					11260,
					-38596
				],
				[
					-6,
					-31572
				],
				[
					-8141,
					-16858
				],
				[
					3382,
					-7695
				],
				[
					-3761,
					-21382
				],
				[
					2594,
					-23720
				],
				[
					21147,
					-18770
				],
				[
					-471,
					-16211
				],
				[
					14790,
					-20409
				],
				[
					5835,
					-21125
				],
				[
					11134,
					4131
				],
				[
					6486,
					16712
				],
				[
					42192,
					-8027
				],
				[
					7865,
					5745
				],
				[
					33470,
					-2669
				],
				[
					9843,
					-16640
				],
				[
					11710,
					14614
				],
				[
					14448,
					941
				],
				[
					7625,
					-21561
				],
				[
					881,
					-35211
				],
				[
					11624,
					-43756
				],
				[
					6111,
					-7620
				],
				[
					6560,
					-28096
				],
				[
					5889,
					-6480
				],
				[
					8134,
					-31694
				],
				[
					-678,
					-16099
				],
				[
					8154,
					-42428
				],
				[
					21316,
					-60988
				],
				[
					8974,
					-20107
				],
				[
					3908,
					-24076
				],
				[
					-1529,
					-25792
				],
				[
					-11965,
					-37918
				],
				[
					-15550,
					-24023
				],
				[
					-5944,
					-18047
				],
				[
					14035,
					15225
				],
				[
					19022,
					14226
				],
				[
					25582,
					6145
				],
				[
					10629,
					-5596
				],
				[
					17405,
					1326
				],
				[
					91174,
					46432
				],
				[
					31085,
					4535
				],
				[
					20687,
					-9078
				],
				[
					7874,
					2488
				],
				[
					65083,
					-45801
				],
				[
					11020,
					-10007
				],
				[
					52394,
					-18713
				],
				[
					10632,
					177
				],
				[
					24075,
					-13685
				],
				[
					23397,
					-6524
				]
			],
			[
				[
					5188432,
					2378718
				],
				[
					-95813,
					-1189
				],
				[
					0,
					-1444
				],
				[
					-61432,
					218
				]
			],
			[
				[
					5031187,
					2376303
				],
				[
					-21309,
					35888
				],
				[
					-8376,
					19502
				],
				[
					16547,
					744
				],
				[
					41,
					7058
				],
				[
					-13002,
					15880
				],
				[
					-12775,
					3578
				],
				[
					7882,
					13330
				],
				[
					-7893,
					19774
				],
				[
					-8947,
					9579
				],
				[
					-583,
					10226
				],
				[
					-17012,
					37620
				],
				[
					-119465,
					2
				],
				[
					3320,
					-4635
				],
				[
					-84855,
					73
				]
			],
			[
				[
					4732669,
					2710438
				],
				[
					2206,
					19957
				],
				[
					-7545,
					7374
				],
				[
					-4156,
					17554
				],
				[
					4840,
					16361
				],
				[
					-5593,
					7311
				],
				[
					4041,
					15569
				],
				[
					-29777,
					208
				],
				[
					0,
					-21108
				],
				[
					-66788,
					-248
				],
				[
					-182,
					-30795
				],
				[
					7784,
					-9331
				]
			],
			[
				[
					5031187,
					2376303
				],
				[
					-6512,
					-8938
				],
				[
					8160,
					-12177
				],
				[
					7408,
					-24366
				],
				[
					10459,
					-5582
				],
				[
					12400,
					-30132
				],
				[
					-11392,
					-2299
				],
				[
					-15677,
					-12615
				],
				[
					-34057,
					-41968
				],
				[
					-18006,
					18774
				],
				[
					3651,
					-11906
				],
				[
					-7206,
					-27370
				],
				[
					1943,
					-18096
				],
				[
					-1620,
					-56332
				],
				[
					5941,
					-34699
				],
				[
					9562,
					-9397
				],
				[
					3171,
					-15188
				],
				[
					-2523,
					-14815
				]
			],
			[
				[
					4996889,
					2069197
				],
				[
					-7218,
					-4500
				],
				[
					20,
					-10657
				],
				[
					-15600,
					3615
				],
				[
					-7735,
					7107
				],
				[
					136,
					-42726
				]
			],
			[
				[
					4986178,
					2011556
				],
				[
					6183,
					10268
				],
				[
					12840,
					7119
				],
				[
					-9848,
					7278
				],
				[
					3292,
					19697
				],
				[
					-1756,
					13279
				]
			],
			[
				[
					3755748,
					6111385
				],
				[
					-126,
					-29802
				],
				[
					-5579,
					5
				],
				[
					5705,
					29797
				]
			],
			[
				[
					3731455,
					6105694
				],
				[
					8519,
					-13324
				],
				[
					-5939,
					-11688
				],
				[
					-7767,
					15561
				],
				[
					5187,
					9451
				]
			],
			[
				[
					3781257,
					6161008
				],
				[
					32833,
					-30989
				],
				[
					-18431,
					-3121
				],
				[
					-10396,
					8906
				],
				[
					-8792,
					19193
				],
				[
					4786,
					6011
				]
			],
			[
				[
					5165231,
					6173254
				],
				[
					8767,
					-1955
				],
				[
					-8857,
					-16770
				],
				[
					-19999,
					10180
				],
				[
					20089,
					8545
				]
			],
			[
				[
					3746287,
					6227424
				],
				[
					3754,
					-20607
				],
				[
					-10601,
					-11730
				],
				[
					-8851,
					11562
				],
				[
					15698,
					20775
				]
			],
			[
				[
					3716258,
					6244701
				],
				[
					5962,
					-28359
				],
				[
					-17761,
					9342
				],
				[
					12746,
					3404
				],
				[
					-947,
					15613
				]
			],
			[
				[
					3702078,
					6243691
				],
				[
					882,
					-19265
				],
				[
					-8228,
					-5429
				],
				[
					-13953,
					15490
				],
				[
					2392,
					11894
				],
				[
					11059,
					-9259
				],
				[
					7848,
					6569
				]
			],
			[
				[
					3729803,
					6269359
				],
				[
					13467,
					-12947
				],
				[
					3017,
					-16270
				],
				[
					-14914,
					-4007
				],
				[
					-7052,
					-13307
				],
				[
					-806,
					45859
				],
				[
					6288,
					672
				]
			],
			[
				[
					3618325,
					6300081
				],
				[
					-6732,
					-9456
				],
				[
					-6480,
					9525
				],
				[
					13212,
					-69
				]
			],
			[
				[
					5091873,
					6311974
				],
				[
					3595,
					-6656
				],
				[
					-22094,
					-5167
				],
				[
					18499,
					11823
				]
			],
			[
				[
					3420736,
					6339020
				],
				[
					-10546,
					-15931
				],
				[
					-23582,
					-6796
				],
				[
					34128,
					22727
				]
			],
			[
				[
					3727513,
					6343430
				],
				[
					1302,
					-21480
				],
				[
					-9360,
					-3066
				],
				[
					-9431,
					11853
				],
				[
					17489,
					12693
				]
			],
			[
				[
					3603528,
					6346141
				],
				[
					33777,
					-6138
				],
				[
					-4713,
					-22728
				],
				[
					-26923,
					18858
				],
				[
					-2141,
					10008
				]
			],
			[
				[
					4759834,
					6370245
				],
				[
					1051,
					-25989
				],
				[
					-11802,
					18391
				],
				[
					10751,
					7598
				]
			],
			[
				[
					3569250,
					6373874
				],
				[
					22898,
					-12421
				],
				[
					-2875,
					-18192
				],
				[
					-22537,
					15883
				],
				[
					2514,
					14730
				]
			],
			[
				[
					3508215,
					6373324
				],
				[
					-9195,
					-9945
				],
				[
					-11494,
					1944
				],
				[
					20689,
					8001
				]
			],
			[
				[
					3756075,
					6374969
				],
				[
					16877,
					-9208
				],
				[
					-13959,
					-1875
				],
				[
					4941,
					-22384
				],
				[
					-14964,
					4941
				],
				[
					-842,
					19102
				],
				[
					7947,
					9424
				]
			],
			[
				[
					3524801,
					6386735
				],
				[
					-3966,
					-14809
				],
				[
					-8838,
					4030
				],
				[
					12804,
					10779
				]
			],
			[
				[
					4145844,
					6398906
				],
				[
					3514,
					-3414
				],
				[
					-16390,
					-26175
				],
				[
					-2698,
					20254
				],
				[
					15574,
					9335
				]
			],
			[
				[
					3562594,
					6410645
				],
				[
					-13519,
					-16107
				],
				[
					-20136,
					-4764
				],
				[
					33655,
					20871
				]
			],
			[
				[
					5058183,
					6410690
				],
				[
					-1312,
					-10251
				],
				[
					-12841,
					1518
				],
				[
					14153,
					8733
				]
			],
			[
				[
					3340661,
					6427717
				],
				[
					-12881,
					-19567
				],
				[
					-10791,
					-5274
				],
				[
					-8019,
					12247
				],
				[
					31691,
					12594
				]
			],
			[
				[
					4088926,
					6435583
				],
				[
					9043,
					-10359
				],
				[
					-16555,
					-15660
				],
				[
					-10650,
					15600
				],
				[
					16001,
					364
				],
				[
					2161,
					10055
				]
			],
			[
				[
					3850382,
					6436350
				],
				[
					13460,
					-17425
				],
				[
					-5602,
					-6873
				],
				[
					-7858,
					24298
				]
			],
			[
				[
					4633145,
					6439009
				],
				[
					-2708,
					-22063
				],
				[
					-9921,
					11135
				],
				[
					12629,
					10928
				]
			],
			[
				[
					3420121,
					6484105
				],
				[
					12507,
					-16724
				],
				[
					-30151,
					-5657
				],
				[
					-9014,
					12151
				],
				[
					26658,
					10230
				]
			],
			[
				[
					3442100,
					6490128
				],
				[
					-4812,
					-10339
				],
				[
					-11918,
					8294
				],
				[
					16730,
					2045
				]
			],
			[
				[
					4084602,
					6492119
				],
				[
					35378,
					-5989
				],
				[
					20900,
					-17377
				],
				[
					-1833,
					-17516
				],
				[
					-14836,
					-6679
				],
				[
					-19645,
					4948
				],
				[
					-29692,
					19968
				],
				[
					-8501,
					14085
				],
				[
					18229,
					8560
				]
			],
			[
				[
					4426954,
					6547676
				],
				[
					23173,
					-17456
				],
				[
					-2405,
					-28027
				],
				[
					-9887,
					6803
				],
				[
					-2578,
					-24424
				],
				[
					-15739,
					15368
				],
				[
					-13276,
					-3443
				],
				[
					-17044,
					7873
				],
				[
					-13384,
					13896
				],
				[
					33958,
					16689
				],
				[
					4209,
					13379
				],
				[
					12973,
					-658
				]
			],
			[
				[
					5780560,
					6555272
				],
				[
					68,
					-10266
				],
				[
					15273,
					-13587
				],
				[
					-15107,
					-18022
				],
				[
					-13274,
					19558
				],
				[
					13040,
					22317
				]
			],
			[
				[
					5782609,
					6587487
				],
				[
					674,
					-14229
				],
				[
					-15603,
					5487
				],
				[
					14929,
					8742
				]
			],
			[
				[
					4589442,
					6600674
				],
				[
					15163,
					-2996
				],
				[
					2300,
					-12630
				],
				[
					18605,
					-26331
				],
				[
					-576,
					-17939
				],
				[
					-11679,
					-2736
				],
				[
					-17215,
					-17258
				],
				[
					-12958,
					20426
				],
				[
					-11881,
					-2496
				],
				[
					6934,
					38845
				],
				[
					-7744,
					11972
				],
				[
					19051,
					11143
				]
			],
			[
				[
					5744370,
					6625366
				],
				[
					10232,
					-172
				],
				[
					4557,
					-20152
				],
				[
					-15449,
					3001
				],
				[
					660,
					17323
				]
			],
			[
				[
					4627383,
					6626630
				],
				[
					14563,
					-28682
				],
				[
					2253,
					-16970
				],
				[
					-19522,
					200
				],
				[
					-11190,
					20427
				],
				[
					13896,
					25025
				]
			],
			[
				[
					4465561,
					6645481
				],
				[
					9027,
					-15446
				],
				[
					-10153,
					-14341
				],
				[
					-14952,
					-672
				],
				[
					10872,
					9915
				],
				[
					-12796,
					9940
				],
				[
					18002,
					10604
				]
			],
			[
				[
					5752820,
					6646774
				],
				[
					7560,
					-16128
				],
				[
					-13537,
					8008
				],
				[
					5977,
					8120
				]
			],
			[
				[
					5699689,
					6681100
				],
				[
					11250,
					-9221
				],
				[
					10209,
					-27265
				],
				[
					-12805,
					-6363
				],
				[
					-14398,
					7392
				],
				[
					2876,
					29922
				],
				[
					-11887,
					-15324
				],
				[
					-3684,
					6839
				],
				[
					18439,
					14020
				]
			],
			[
				[
					5739527,
					6695682
				],
				[
					10160,
					780
				],
				[
					5118,
					-21333
				],
				[
					-16050,
					-20635
				],
				[
					-25463,
					19013
				],
				[
					3958,
					9800
				],
				[
					22277,
					12375
				]
			],
			[
				[
					5018816,
					6732981
				],
				[
					4366,
					-7700
				],
				[
					26536,
					4840
				],
				[
					9881,
					-12447
				],
				[
					14652,
					14734
				],
				[
					9374,
					-11290
				],
				[
					2362,
					-20208
				],
				[
					-6223,
					-25797
				],
				[
					-48899,
					32223
				],
				[
					-12049,
					25645
				]
			],
			[
				[
					4501671,
					6731107
				],
				[
					2679,
					-9043
				],
				[
					16411,
					-1602
				],
				[
					11970,
					-14177
				],
				[
					-9402,
					-2627
				],
				[
					-5128,
					-17442
				],
				[
					-17286,
					7575
				],
				[
					-15134,
					27122
				],
				[
					5254,
					11904
				],
				[
					10636,
					-1710
				]
			],
			[
				[
					5655502,
					6738787
				],
				[
					2753,
					-9882
				],
				[
					-12220,
					-7624
				],
				[
					-3984,
					8609
				],
				[
					13451,
					8897
				]
			],
			[
				[
					5118578,
					6743446
				],
				[
					21865,
					-5907
				],
				[
					28543,
					-22973
				],
				[
					-4981,
					-26669
				],
				[
					-21006,
					-20091
				],
				[
					-18824,
					12373
				],
				[
					12201,
					8885
				],
				[
					-4351,
					35004
				],
				[
					-16545,
					7401
				],
				[
					9349,
					-27157
				],
				[
					-15975,
					-26453
				],
				[
					-12098,
					33693
				],
				[
					21822,
					31894
				]
			],
			[
				[
					4399594,
					6767892
				],
				[
					3543,
					-16306
				],
				[
					-13738,
					2480
				],
				[
					-1736,
					11841
				],
				[
					11931,
					1985
				]
			],
			[
				[
					5605964,
					6775971
				],
				[
					-6710,
					-10911
				],
				[
					-15374,
					7805
				],
				[
					22084,
					3106
				]
			],
			[
				[
					5600178,
					6787073
				],
				[
					6886,
					-9041
				],
				[
					-24108,
					-2746
				],
				[
					-8108,
					5147
				],
				[
					20538,
					11054
				],
				[
					4792,
					-4414
				]
			],
			[
				[
					5573533,
					6801423
				],
				[
					14235,
					-5663
				],
				[
					-22487,
					-8966
				],
				[
					8252,
					14629
				]
			],
			[
				[
					4871054,
					6807449
				],
				[
					13471,
					-3123
				],
				[
					36706,
					-27980
				],
				[
					8390,
					1802
				],
				[
					7968,
					-16112
				],
				[
					-8055,
					-10144
				],
				[
					8436,
					-21002
				],
				[
					7227,
					22774
				],
				[
					8875,
					4669
				],
				[
					13005,
					-10415
				],
				[
					4277,
					-16564
				],
				[
					27151,
					-20573
				],
				[
					7945,
					-33159
				],
				[
					4535,
					4522
				],
				[
					-12066,
					28498
				],
				[
					30640,
					-12195
				],
				[
					19959,
					-18515
				],
				[
					10526,
					-2958
				],
				[
					16598,
					-18580
				],
				[
					-2628,
					-32381
				],
				[
					4179,
					-25720
				],
				[
					5620,
					20933
				],
				[
					-2014,
					16760
				],
				[
					21581,
					-12034
				],
				[
					-5144,
					-22682
				],
				[
					13458,
					-15696
				],
				[
					422,
					-26091
				],
				[
					19678,
					-2074
				],
				[
					511,
					-8667
				],
				[
					16324,
					1983
				],
				[
					23958,
					15523
				],
				[
					14338,
					-11414
				],
				[
					-8081,
					-12978
				],
				[
					-16060,
					-8337
				],
				[
					-16450,
					-24210
				],
				[
					348,
					21109
				],
				[
					-25376,
					-112
				],
				[
					-9880,
					-37512
				],
				[
					-13570,
					8377
				],
				[
					-35648,
					-38881
				],
				[
					-29937,
					-5676
				],
				[
					-48648,
					20797
				],
				[
					-13874,
					15862
				],
				[
					4168,
					-15355
				],
				[
					-7970,
					-6429
				],
				[
					-52483,
					16742
				],
				[
					-18100,
					14190
				],
				[
					-26743,
					11649
				],
				[
					-9211,
					-2915
				],
				[
					-24369,
					22343
				],
				[
					5799,
					15517
				],
				[
					-20064,
					1047
				],
				[
					2350,
					-20081
				],
				[
					-10117,
					-2211
				],
				[
					-16757,
					13899
				],
				[
					-5520,
					-4240
				],
				[
					-17666,
					12725
				],
				[
					5188,
					18122
				],
				[
					-25927,
					9391
				],
				[
					-2854,
					-23636
				],
				[
					-14341,
					-422
				],
				[
					-28514,
					10750
				],
				[
					-1862,
					14327
				],
				[
					-13058,
					12835
				],
				[
					4036,
					18496
				],
				[
					11035,
					14813
				],
				[
					12566,
					-6863
				],
				[
					4897,
					8975
				],
				[
					24637,
					-5683
				],
				[
					15605,
					11358
				],
				[
					10774,
					-2817
				],
				[
					15902,
					9911
				],
				[
					4087,
					23429
				],
				[
					13053,
					-7749
				],
				[
					3417,
					9692
				],
				[
					14766,
					-3416
				],
				[
					-8825,
					20608
				],
				[
					-17576,
					13949
				],
				[
					5945,
					35161
				],
				[
					20481,
					-4554
				],
				[
					33042,
					-34183
				],
				[
					10402,
					1880
				],
				[
					-19011,
					15216
				],
				[
					-10977,
					21300
				],
				[
					-12371,
					5338
				],
				[
					5612,
					26444
				],
				[
					10540,
					17408
				],
				[
					14639,
					5585
				],
				[
					12680,
					19630
				]
			],
			[
				[
					4931187,
					6822702
				],
				[
					14102,
					-6591
				],
				[
					-8095,
					-9175
				],
				[
					-6007,
					15766
				]
			],
			[
				[
					4545738,
					6912001
				],
				[
					12597,
					-1673
				],
				[
					-7604,
					-15541
				],
				[
					-4993,
					17214
				]
			],
			[
				[
					4567969,
					7001626
				],
				[
					17942,
					-6322
				],
				[
					37593,
					-24884
				],
				[
					-25086,
					4795
				],
				[
					12887,
					-13118
				],
				[
					-11904,
					-12428
				],
				[
					-33053,
					18273
				],
				[
					1621,
					33684
				]
			],
			[
				[
					5027131,
					7143593
				],
				[
					15071,
					-20391
				],
				[
					-20924,
					6434
				],
				[
					5853,
					13957
				]
			],
			[
				[
					4996099,
					7256760
				],
				[
					-16521,
					-13253
				],
				[
					1671,
					10490
				],
				[
					14850,
					2763
				]
			],
			[
				[
					5168653,
					7278456
				],
				[
					8384,
					-2928
				],
				[
					-2584,
					-23965
				],
				[
					-18150,
					-935
				],
				[
					-95,
					19234
				],
				[
					12445,
					8594
				]
			],
			[
				[
					5883121,
					6650804
				],
				[
					-890,
					-115238
				],
				[
					376,
					-118222
				]
			],
			[
				[
					5882607,
					6417344
				],
				[
					-14313,
					-3479
				],
				[
					-2207,
					-11313
				],
				[
					16520,
					14546
				]
			],
			[
				[
					5882607,
					6417098
				],
				[
					3565,
					-309480
				]
			],
			[
				[
					5886172,
					6107618
				],
				[
					-186927,
					0
				],
				[
					-193724,
					0
				],
				[
					-117366,
					0
				],
				[
					-178327,
					0
				],
				[
					-162459,
					0
				],
				[
					-110296,
					0
				],
				[
					-111710,
					0
				],
				[
					-94741,
					0
				],
				[
					-147061,
					0
				],
				[
					-158373,
					0
				],
				[
					-192311,
					0
				],
				[
					-157455,
					0
				],
				[
					-17,
					-239488
				],
				[
					338470,
					-93263
				],
				[
					0,
					-345336
				]
			],
			[
				[
					4413875,
					5429531
				],
				[
					-325231,
					66804
				],
				[
					-193229,
					30612
				],
				[
					-255069,
					33591
				],
				[
					-21153,
					23959
				],
				[
					-47272,
					40567
				],
				[
					-123944,
					107638
				],
				[
					-231336,
					301
				],
				[
					-132625,
					94350
				],
				[
					-325266,
					231398
				],
				[
					-49137,
					31783
				],
				[
					-172937,
					65057
				],
				[
					-83623,
					51243
				],
				[
					-146764,
					88934
				],
				[
					4532,
					113173
				],
				[
					-1676,
					90282
				],
				[
					-13504,
					229547
				]
			],
			[
				[
					2295641,
					6728770
				],
				[
					38896,
					-33306
				],
				[
					49128,
					-22166
				],
				[
					15403,
					558
				],
				[
					27098,
					-7944
				],
				[
					33573,
					-2272
				],
				[
					42029,
					-9504
				],
				[
					28927,
					-10210
				],
				[
					31065,
					-28381
				],
				[
					7395,
					-243
				],
				[
					32190,
					-19150
				],
				[
					34295,
					-11061
				],
				[
					37942,
					-3590
				],
				[
					24152,
					-15162
				],
				[
					23906,
					1971
				],
				[
					5006,
					6363
				],
				[
					32216,
					-15173
				],
				[
					24136,
					-1563
				],
				[
					2874,
					5932
				],
				[
					29423,
					-17021
				],
				[
					22253,
					1206
				],
				[
					-17367,
					7172
				],
				[
					2632,
					7330
				],
				[
					-29916,
					16508
				],
				[
					14335,
					9200
				],
				[
					35364,
					-13903
				],
				[
					14237,
					5205
				],
				[
					-17885,
					12588
				],
				[
					36563,
					-6421
				],
				[
					57595,
					-31025
				],
				[
					1924,
					6432
				],
				[
					34267,
					-21511
				],
				[
					1061,
					-10440
				],
				[
					22101,
					-2986
				],
				[
					11983,
					-11080
				],
				[
					4127,
					-15603
				],
				[
					27944,
					-13887
				],
				[
					8169,
					-9385
				],
				[
					6623,
					-24188
				],
				[
					17407,
					-7623
				],
				[
					-17438,
					-24165
				],
				[
					5486,
					-13271
				],
				[
					-38728,
					-2681
				],
				[
					-11865,
					8049
				],
				[
					-19595,
					-5876
				],
				[
					-34519,
					10532
				],
				[
					19295,
					-18304
				],
				[
					-11484,
					-1221
				],
				[
					-5673,
					-12431
				],
				[
					-39110,
					9632
				],
				[
					11868,
					-11928
				],
				[
					-8826,
					-12142
				],
				[
					-260,
					-14805
				],
				[
					11487,
					-7972
				],
				[
					-42534,
					-15859
				],
				[
					6256,
					-10382
				],
				[
					18407,
					-2621
				],
				[
					14011,
					-12515
				],
				[
					20059,
					-7633
				],
				[
					30717,
					6895
				],
				[
					8820,
					-9842
				],
				[
					19842,
					531
				],
				[
					9071,
					-8980
				],
				[
					48070,
					-4612
				],
				[
					28840,
					-9456
				],
				[
					45883,
					2755
				],
				[
					21539,
					-5043
				],
				[
					56872,
					-1442
				],
				[
					34124,
					7539
				],
				[
					-5063,
					8457
				],
				[
					19017,
					-2829
				],
				[
					40457,
					8785
				],
				[
					20251,
					-7369
				],
				[
					14324,
					7840
				],
				[
					10958,
					-9276
				],
				[
					7009,
					14983
				],
				[
					16336,
					11873
				],
				[
					-2175,
					-11132
				],
				[
					20616,
					-666
				],
				[
					-2065,
					-6746
				],
				[
					27502,
					10905
				],
				[
					17469,
					17439
				],
				[
					41716,
					22054
				],
				[
					12445,
					-3661
				],
				[
					4752,
					14735
				],
				[
					11815,
					-1005
				],
				[
					10977,
					-28468
				],
				[
					17525,
					-6284
				],
				[
					15083,
					-15712
				],
				[
					-5464,
					-18313
				],
				[
					23025,
					-8073
				],
				[
					3666,
					14253
				],
				[
					23429,
					-6746
				],
				[
					23314,
					1777
				],
				[
					9374,
					-16311
				],
				[
					4494,
					-28782
				],
				[
					-5717,
					-23137
				],
				[
					21476,
					-22823
				],
				[
					8360,
					24896
				],
				[
					2159,
					39264
				],
				[
					14019,
					-2022
				],
				[
					8373,
					-28309
				],
				[
					-2233,
					-7838
				],
				[
					7795,
					-27701
				],
				[
					8276,
					24875
				],
				[
					8063,
					-4836
				],
				[
					-4062,
					-27115
				],
				[
					11409,
					-1668
				],
				[
					-5158,
					12563
				],
				[
					11041,
					-1262
				],
				[
					24445,
					-18365
				],
				[
					4868,
					-11193
				],
				[
					8516,
					-46122
				],
				[
					-16485,
					11317
				],
				[
					-13886,
					-1970
				],
				[
					-4338,
					-18722
				],
				[
					-14263,
					6049
				],
				[
					-35910,
					28671
				],
				[
					12190,
					-29536
				],
				[
					3773,
					10449
				],
				[
					14692,
					-19142
				],
				[
					20019,
					-4271
				],
				[
					8206,
					-13460
				],
				[
					-2956,
					-18242
				],
				[
					10552,
					1269
				],
				[
					10934,
					-12131
				],
				[
					-2825,
					-14715
				],
				[
					9027,
					-12487
				],
				[
					4600,
					10014
				],
				[
					11090,
					-22956
				],
				[
					18956,
					-24137
				],
				[
					6046,
					4065
				],
				[
					33365,
					-48228
				],
				[
					5750,
					5976
				],
				[
					-15399,
					22074
				],
				[
					-25905,
					26641
				],
				[
					-764,
					12893
				],
				[
					-11195,
					18542
				],
				[
					-11833,
					6706
				],
				[
					6712,
					20806
				],
				[
					-9409,
					35379
				],
				[
					2053,
					13135
				],
				[
					14203,
					-14073
				],
				[
					-4667,
					27010
				],
				[
					18596,
					-19539
				],
				[
					-8820,
					-17601
				],
				[
					-12123,
					11327
				],
				[
					5686,
					-15504
				],
				[
					9074,
					-315
				],
				[
					-1123,
					-14181
				],
				[
					18483,
					-1568
				],
				[
					-11625,
					10762
				],
				[
					14263,
					7716
				],
				[
					-1534,
					15667
				],
				[
					30164,
					-21941
				],
				[
					-7053,
					18307
				],
				[
					-28398,
					24404
				],
				[
					36548,
					18627
				],
				[
					-28332,
					-1032
				],
				[
					-25064,
					30931
				],
				[
					-14598,
					34225
				],
				[
					10306,
					-1201
				],
				[
					5607,
					24741
				],
				[
					-9986,
					15137
				],
				[
					-29144,
					26691
				],
				[
					-12998,
					17087
				],
				[
					10305,
					28248
				],
				[
					6152,
					-3652
				],
				[
					27623,
					20035
				],
				[
					-11430,
					9228
				],
				[
					586,
					12986
				],
				[
					20203,
					10324
				],
				[
					20563,
					-5589
				],
				[
					13300,
					4690
				],
				[
					11357,
					16285
				],
				[
					2711,
					-10385
				],
				[
					12854,
					6617
				],
				[
					34819,
					7401
				],
				[
					-6748,
					15086
				],
				[
					19137,
					-6849
				],
				[
					786,
					18834
				],
				[
					20745,
					-22254
				],
				[
					9986,
					5661
				],
				[
					-19142,
					13736
				],
				[
					4932,
					11098
				],
				[
					-12964,
					1016
				],
				[
					-6030,
					11921
				],
				[
					-19706,
					16871
				],
				[
					1358,
					-10798
				],
				[
					-25952,
					804
				],
				[
					-13347,
					-24382
				],
				[
					-10766,
					-2493
				],
				[
					-7813,
					17193
				],
				[
					-19013,
					-2701
				],
				[
					-6980,
					8094
				],
				[
					-37950,
					-6759
				],
				[
					-4198,
					-13154
				],
				[
					35581,
					-24434
				],
				[
					-19662,
					2788
				],
				[
					-15809,
					-9258
				],
				[
					-8861,
					6384
				],
				[
					-27163,
					-2365
				],
				[
					-12973,
					-6617
				],
				[
					5259,
					17538
				],
				[
					-12156,
					3856
				],
				[
					-5447,
					22047
				],
				[
					-14445,
					-14770
				],
				[
					-19930,
					-4599
				],
				[
					-7798,
					6637
				],
				[
					10910,
					10764
				],
				[
					1899,
					14057
				],
				[
					10843,
					7186
				],
				[
					28228,
					50793
				],
				[
					10062,
					6501
				],
				[
					62843,
					5498
				],
				[
					47354,
					11325
				],
				[
					55075,
					28083
				],
				[
					66370,
					24384
				],
				[
					1855,
					6361
				],
				[
					23957,
					-12671
				],
				[
					23956,
					-2369
				],
				[
					38214,
					-35299
				],
				[
					-7405,
					-12763
				],
				[
					16325,
					-46725
				],
				[
					-16124,
					-7256
				],
				[
					33506,
					-34053
				],
				[
					28076,
					-18692
				],
				[
					20183,
					-1929
				],
				[
					23090,
					4847
				],
				[
					-9015,
					-25837
				],
				[
					8912,
					-4828
				],
				[
					9197,
					-23809
				],
				[
					21126,
					4987
				],
				[
					17179,
					-7927
				],
				[
					19040,
					8261
				],
				[
					12711,
					-6830
				],
				[
					42609,
					12622
				],
				[
					1157,
					18070
				],
				[
					10583,
					2865
				],
				[
					4798,
					-37485
				],
				[
					16799,
					-11917
				],
				[
					10610,
					1614
				],
				[
					4712,
					-18007
				],
				[
					14621,
					9705
				],
				[
					10760,
					-21573
				],
				[
					24395,
					-10330
				],
				[
					22742,
					-1951
				],
				[
					24070,
					-25297
				],
				[
					9821,
					19956
				],
				[
					7933,
					-6470
				],
				[
					16673,
					11310
				],
				[
					96,
					-10415
				],
				[
					23488,
					-12006
				],
				[
					33161,
					-2716
				],
				[
					-1650,
					12068
				],
				[
					19005,
					-11399
				],
				[
					3956,
					24148
				],
				[
					18939,
					-9377
				],
				[
					20607,
					4756
				],
				[
					24708,
					20992
				],
				[
					8686,
					-9142
				],
				[
					-4484,
					-15259
				],
				[
					20378,
					23196
				],
				[
					26423,
					471
				],
				[
					8740,
					-6129
				],
				[
					34457,
					-5759
				],
				[
					6845,
					9562
				],
				[
					17432,
					-13193
				],
				[
					13824,
					5172
				],
				[
					19075,
					-7675
				],
				[
					13960,
					-16014
				],
				[
					11620,
					10086
				],
				[
					20947,
					-12399
				],
				[
					5890,
					16394
				],
				[
					5994,
					-6406
				],
				[
					12822,
					10556
				],
				[
					40515,
					-511
				],
				[
					-10851,
					22160
				],
				[
					-12201,
					-619
				],
				[
					-19062,
					18190
				],
				[
					-4068,
					24311
				],
				[
					18699,
					14357
				],
				[
					7042,
					-15272
				],
				[
					34484,
					-30993
				],
				[
					11088,
					-33248
				],
				[
					6585,
					12112
				],
				[
					-34502,
					44121
				],
				[
					-16528,
					32431
				],
				[
					4523,
					11646
				],
				[
					12181,
					-26749
				],
				[
					8644,
					9088
				],
				[
					-2252,
					15222
				],
				[
					-21113,
					5276
				],
				[
					2683,
					9379
				],
				[
					-25712,
					31280
				],
				[
					12850,
					1879
				],
				[
					10464,
					-11565
				],
				[
					-1183,
					22385
				],
				[
					11403,
					-14168
				],
				[
					30372,
					-14880
				],
				[
					-1540,
					11041
				],
				[
					14537,
					5214
				],
				[
					10530,
					-12046
				],
				[
					11365,
					3733
				],
				[
					-4403,
					15434
				],
				[
					17041,
					-10517
				],
				[
					-34031,
					39445
				],
				[
					8827,
					9207
				],
				[
					29574,
					-7988
				],
				[
					9051,
					-18599
				],
				[
					7296,
					15833
				],
				[
					22652,
					-1830
				],
				[
					12375,
					-10806
				],
				[
					18725,
					-35381
				],
				[
					15355,
					-16581
				],
				[
					28570,
					8506
				],
				[
					4183,
					-12444
				],
				[
					18080,
					13128
				],
				[
					1347,
					-9209
				],
				[
					-15494,
					-28592
				],
				[
					-20031,
					-10487
				],
				[
					9483,
					-18319
				],
				[
					15057,
					15632
				],
				[
					5342,
					-8919
				],
				[
					7507,
					29049
				],
				[
					55263,
					24228
				],
				[
					-12394,
					-17979
				],
				[
					5429,
					-14060
				],
				[
					-5632,
					-24190
				],
				[
					-9986,
					-18136
				],
				[
					-7336,
					-27170
				],
				[
					8194,
					-33897
				],
				[
					-2550,
					-19393
				],
				[
					-9248,
					3739
				],
				[
					-9699,
					17567
				],
				[
					3447,
					-19555
				],
				[
					-12761,
					-18099
				],
				[
					4057,
					-23641
				],
				[
					17694,
					-6047
				],
				[
					14996,
					14143
				],
				[
					2191,
					-8469
				],
				[
					-19864,
					-46976
				],
				[
					12994,
					4096
				],
				[
					1857,
					-11958
				],
				[
					23599,
					15148
				],
				[
					18847,
					17470
				],
				[
					8121,
					-6058
				],
				[
					8882,
					13053
				],
				[
					5544,
					-13602
				],
				[
					-29512,
					-36856
				],
				[
					18043,
					12233
				],
				[
					-5908,
					-11660
				],
				[
					16683,
					11118
				],
				[
					7388,
					-19847
				],
				[
					14509,
					2671
				],
				[
					22704,
					31129
				],
				[
					-17576,
					13901
				],
				[
					-6367,
					28137
				],
				[
					3422,
					25406
				],
				[
					-16794,
					20953
				],
				[
					-24023,
					13166
				],
				[
					-1241,
					10524
				],
				[
					17202,
					14681
				],
				[
					4293,
					29360
				],
				[
					12028,
					20834
				],
				[
					-6197,
					10286
				],
				[
					26978,
					5274
				],
				[
					366,
					-10599
				],
				[
					14410,
					13519
				],
				[
					7762,
					-11680
				],
				[
					20856,
					-2249
				],
				[
					14501,
					4528
				],
				[
					12472,
					22349
				],
				[
					11636,
					3820
				],
				[
					15691,
					15989
				],
				[
					18225,
					8807
				],
				[
					-1199,
					25148
				],
				[
					26422,
					24225
				],
				[
					12396,
					1829
				],
				[
					32828,
					20242
				],
				[
					20696,
					-4128
				],
				[
					-448,
					-18280
				],
				[
					17087,
					-13547
				],
				[
					54256,
					6252
				],
				[
					44613,
					-1450
				],
				[
					15020,
					2841
				],
				[
					17380,
					-38044
				],
				[
					-14809,
					-20571
				],
				[
					-35132,
					-12331
				],
				[
					-6298,
					-14165
				],
				[
					22366,
					17144
				],
				[
					20163,
					3686
				],
				[
					14304,
					26217
				],
				[
					-8108,
					11252
				],
				[
					-8605,
					31350
				],
				[
					-14850,
					-5336
				],
				[
					-56189,
					-350
				],
				[
					-17583,
					-4906
				],
				[
					-36576,
					1268
				],
				[
					-6653,
					11377
				],
				[
					919,
					22476
				],
				[
					-30905,
					16431
				],
				[
					-9698,
					-3600
				],
				[
					8998,
					26055
				],
				[
					-5269,
					5717
				],
				[
					14881,
					25351
				],
				[
					-6266,
					5542
				],
				[
					-3697,
					24890
				],
				[
					-18834,
					-4264
				],
				[
					-6944,
					7657
				],
				[
					9705,
					18996
				],
				[
					-12020,
					-9755
				],
				[
					-5719,
					-23522
				],
				[
					-12842,
					-11294
				],
				[
					5490,
					-12716
				],
				[
					13787,
					11168
				],
				[
					-411,
					-10219
				],
				[
					-20995,
					-19586
				],
				[
					-18379,
					584
				],
				[
					-16295,
					-9078
				],
				[
					-25441,
					7214
				],
				[
					11097,
					34004
				],
				[
					-7697,
					15144
				],
				[
					6416,
					5993
				],
				[
					14034,
					-8250
				],
				[
					11137,
					21576
				],
				[
					20000,
					4706
				],
				[
					258,
					14492
				],
				[
					-19826,
					11563
				],
				[
					7339,
					28471
				],
				[
					-2992,
					9410
				],
				[
					21734,
					7188
				],
				[
					34690,
					2369
				],
				[
					11262,
					13797
				],
				[
					15787,
					2651
				],
				[
					-37624,
					-40266
				],
				[
					7255,
					-9707
				],
				[
					-3303,
					-14358
				],
				[
					44944,
					40401
				],
				[
					9503,
					12466
				],
				[
					12478,
					1898
				],
				[
					-3919,
					-27010
				],
				[
					5696,
					-3672
				],
				[
					-8909,
					-19957
				],
				[
					18813,
					-5452
				],
				[
					-9906,
					-17320
				],
				[
					15427,
					2399
				],
				[
					2028,
					15340
				],
				[
					16537,
					38932
				],
				[
					16056,
					17739
				],
				[
					-56779,
					9078
				],
				[
					7388,
					-5393
				],
				[
					-31560,
					-13972
				],
				[
					-5863,
					8389
				],
				[
					9808,
					15136
				],
				[
					-11120,
					20534
				],
				[
					-27845,
					-9429
				],
				[
					-10132,
					-13719
				],
				[
					-43683,
					114
				],
				[
					-38706,
					49702
				],
				[
					4270,
					10067
				],
				[
					-17326,
					-3068
				],
				[
					2779,
					-16282
				],
				[
					-15327,
					-10762
				],
				[
					-44332,
					21043
				],
				[
					-39537,
					24369
				],
				[
					-10582,
					12449
				],
				[
					-13415,
					-11042
				],
				[
					-29031,
					19424
				],
				[
					-4253,
					28451
				],
				[
					-18623,
					3735
				],
				[
					-25261,
					29968
				],
				[
					-7809,
					35985
				],
				[
					1958,
					20927
				],
				[
					15743,
					21873
				],
				[
					7115,
					-2540
				],
				[
					12135,
					38237
				],
				[
					10572,
					-8348
				],
				[
					9298,
					19428
				],
				[
					20020,
					23312
				],
				[
					-25728,
					-11966
				],
				[
					-6957,
					-11077
				],
				[
					-23641,
					15913
				],
				[
					-6712,
					14534
				],
				[
					-17027,
					9894
				],
				[
					-1722,
					15477
				],
				[
					8140,
					13383
				],
				[
					12424,
					40787
				],
				[
					-14485,
					14611
				],
				[
					13250,
					7617
				],
				[
					-2079,
					29558
				],
				[
					17974,
					406
				],
				[
					11528,
					25273
				],
				[
					16384,
					6938
				],
				[
					15052,
					-4333
				],
				[
					14048,
					-18401
				],
				[
					30343,
					-8347
				],
				[
					7611,
					23015
				],
				[
					-11951,
					8383
				],
				[
					25869,
					24430
				],
				[
					-25519,
					-7814
				],
				[
					-30025,
					3953
				],
				[
					-12414,
					10026
				],
				[
					9983,
					19017
				],
				[
					16334,
					1160
				],
				[
					23562,
					23670
				],
				[
					27301,
					965
				],
				[
					-5623,
					6312
				],
				[
					12950,
					46904
				],
				[
					69059,
					10964
				],
				[
					21180,
					-15683
				],
				[
					-9592,
					-20873
				],
				[
					-19853,
					-6335
				],
				[
					10412,
					-18384
				],
				[
					8178,
					18338
				],
				[
					9072,
					-2556
				],
				[
					2328,
					-27923
				],
				[
					21549,
					25683
				],
				[
					7837,
					-10353
				],
				[
					48207,
					1451
				],
				[
					1582,
					-10578
				],
				[
					-13279,
					-18035
				],
				[
					14850,
					-13300
				],
				[
					53270,
					-32498
				],
				[
					6883,
					-18567
				],
				[
					18667,
					-6705
				],
				[
					6043,
					-32389
				],
				[
					7342,
					-13090
				],
				[
					-4359,
					-21631
				],
				[
					-1633,
					-44519
				],
				[
					7953,
					-6254
				],
				[
					-14142,
					-8034
				],
				[
					30827,
					-12208
				],
				[
					6764,
					-22240
				],
				[
					8912,
					-414
				],
				[
					44113,
					-21323
				],
				[
					-12369,
					-3943
				],
				[
					405,
					-19848
				],
				[
					28399,
					-26811
				],
				[
					1714,
					-26143
				],
				[
					15924,
					8333
				],
				[
					-4165,
					13311
				],
				[
					21509,
					-3408
				],
				[
					72,
					-38227
				],
				[
					4376,
					10100
				],
				[
					15897,
					-12304
				],
				[
					25,
					-9442
				],
				[
					-52988,
					-6535
				],
				[
					-31908,
					19955
				],
				[
					-16742,
					-6490
				],
				[
					-3507,
					-22930
				],
				[
					32929,
					3416
				],
				[
					20034,
					-9185
				],
				[
					4444,
					-9027
				],
				[
					-25701,
					-18987
				],
				[
					-7561,
					-11767
				],
				[
					-37821,
					-21805
				],
				[
					-3561,
					-11259
				],
				[
					-29649,
					-14961
				],
				[
					36440,
					4762
				],
				[
					22328,
					-11917
				],
				[
					25565,
					-23100
				],
				[
					36533,
					-18007
				],
				[
					24439,
					18294
				],
				[
					384,
					12483
				],
				[
					12048,
					9309
				],
				[
					21379,
					-1423
				],
				[
					4560,
					-14025
				],
				[
					-12532,
					-12564
				],
				[
					-31868,
					-6439
				],
				[
					10051,
					-2922
				],
				[
					40093,
					12024
				],
				[
					14032,
					-14421
				],
				[
					24858,
					1908
				],
				[
					-849,
					-8962
				],
				[
					17611,
					19125
				],
				[
					26522,
					-10499
				],
				[
					11076,
					-13320
				],
				[
					-27392,
					-6159
				],
				[
					-26305,
					-21455
				],
				[
					1803,
					-18832
				],
				[
					-17256,
					1193
				],
				[
					1938,
					24476
				],
				[
					-22974,
					-17075
				],
				[
					-29943,
					15901
				],
				[
					76159,
					-60254
				],
				[
					11037,
					-5820
				],
				[
					-5215,
					-16264
				],
				[
					29865,
					-32574
				],
				[
					-18697,
					-18373
				],
				[
					17293,
					4664
				],
				[
					-8638,
					-21654
				],
				[
					5548,
					-14046
				],
				[
					-8492,
					-10800
				],
				[
					8795,
					-24808
				],
				[
					-14154,
					-19905
				],
				[
					7362,
					-7351
				],
				[
					26916,
					-9413
				],
				[
					-3873,
					-13998
				],
				[
					10309,
					-21008
				],
				[
					16650,
					8921
				],
				[
					-5501,
					9195
				],
				[
					18552,
					18918
				],
				[
					-1073,
					14797
				],
				[
					12209,
					3402
				],
				[
					4513,
					18581
				],
				[
					21297,
					6565
				],
				[
					7673,
					-19452
				],
				[
					198,
					-19454
				],
				[
					11702,
					-2916
				],
				[
					-15884,
					20182
				],
				[
					1955,
					18506
				],
				[
					-6646,
					3985
				],
				[
					-21698,
					-7085
				],
				[
					-10600,
					20110
				],
				[
					16655,
					20861
				],
				[
					5497,
					-9535
				],
				[
					7185,
					23735
				],
				[
					-8046,
					48557
				],
				[
					13220,
					22052
				],
				[
					18820,
					16019
				],
				[
					9719,
					23793
				],
				[
					12664,
					9204
				],
				[
					28941,
					-2882
				]
			],
			[
				[
					5192616,
					7425906
				],
				[
					140793,
					-50038
				]
			],
			[
				[
					5333409,
					7375868
				],
				[
					-16774,
					-24649
				],
				[
					-942,
					-15348
				],
				[
					-24748,
					-14297
				],
				[
					19456,
					-1903
				],
				[
					3318,
					-8378
				],
				[
					-45066,
					9222
				],
				[
					-27041,
					-2111
				],
				[
					-39019,
					-9744
				],
				[
					-17716,
					-145
				],
				[
					-864,
					85616
				],
				[
					-5353,
					27101
				],
				[
					13956,
					4674
				]
			],
			[
				[
					3526730,
					7486122
				],
				[
					1,
					490
				]
			],
			[
				[
					3526731,
					7486612
				],
				[
					-1,
					-490
				]
			],
			[
				[
					4983734,
					7495922
				],
				[
					9941,
					-3203
				]
			],
			[
				[
					4993675,
					7492719
				],
				[
					-9941,
					3203
				]
			],
			[
				[
					4979348,
					7497333
				],
				[
					2261,
					-727
				]
			],
			[
				[
					4981609,
					7496606
				],
				[
					-2261,
					727
				]
			],
			[
				[
					4586921,
					7612608
				],
				[
					230445,
					-64934
				]
			],
			[
				[
					4817366,
					7547674
				],
				[
					927,
					-26893
				],
				[
					-47109,
					-34221
				],
				[
					-13841,
					-14913
				],
				[
					28789,
					-11378
				],
				[
					10056,
					5392
				],
				[
					31836,
					-1300
				],
				[
					4369,
					-25201
				],
				[
					16599,
					5880
				],
				[
					-11224,
					16707
				],
				[
					-20596,
					15353
				],
				[
					-15578,
					-9494
				],
				[
					-21281,
					1782
				],
				[
					-8157,
					21070
				],
				[
					45758,
					28191
				],
				[
					14617,
					24459
				]
			],
			[
				[
					4832531,
					7543108
				],
				[
					125563,
					-38970
				]
			],
			[
				[
					4958094,
					7504138
				],
				[
					974,
					-311
				]
			],
			[
				[
					4959068,
					7503827
				],
				[
					6747,
					-2152
				]
			],
			[
				[
					4965815,
					7501675
				],
				[
					545,
					-174
				]
			],
			[
				[
					4966360,
					7501501
				],
				[
					9190,
					-2946
				]
			],
			[
				[
					4975550,
					7498555
				],
				[
					-12147,
					-18917
				],
				[
					-2894,
					-20990
				],
				[
					31312,
					20547
				],
				[
					22285,
					6792
				]
			],
			[
				[
					5014106,
					7485987
				],
				[
					13327,
					-4392
				]
			],
			[
				[
					5027433,
					7481595
				],
				[
					16018,
					-12943
				],
				[
					4471,
					-23881
				],
				[
					8274,
					-6405
				],
				[
					5899,
					-24611
				],
				[
					-43572,
					-25472
				],
				[
					14200,
					-6665
				],
				[
					8195,
					-40646
				],
				[
					-3594,
					-8466
				],
				[
					-41922,
					-9249
				],
				[
					28448,
					-3930
				],
				[
					16385,
					5381
				],
				[
					-1291,
					-19158
				],
				[
					-14375,
					-1835
				],
				[
					-12450,
					-12565
				],
				[
					27784,
					8261
				],
				[
					-6524,
					-25003
				],
				[
					-23444,
					-9177
				],
				[
					-20282,
					4315
				],
				[
					-19108,
					-27459
				],
				[
					-35363,
					-18382
				],
				[
					-32845,
					302
				],
				[
					-32923,
					10499
				],
				[
					-22368,
					-6189
				],
				[
					-21668,
					24870
				],
				[
					26789,
					61316
				],
				[
					20392,
					10798
				],
				[
					5018,
					22627
				],
				[
					-4533,
					24267
				],
				[
					-10912,
					7021
				],
				[
					291,
					-23537
				],
				[
					8240,
					-9585
				],
				[
					-552,
					-19041
				],
				[
					-33090,
					-30662
				],
				[
					-777,
					-14894
				],
				[
					-14025,
					-7568
				],
				[
					-12079,
					-24220
				],
				[
					13184,
					-4423
				],
				[
					885,
					-15263
				],
				[
					30725,
					-24608
				],
				[
					1415,
					-15391
				],
				[
					-52641,
					-46610
				],
				[
					-29530,
					2240
				],
				[
					-14404,
					20883
				],
				[
					-31006,
					-8772
				],
				[
					-14483,
					34103
				],
				[
					-296,
					20206
				],
				[
					-21765,
					8849
				],
				[
					-15161,
					36373
				],
				[
					-18616,
					21140
				],
				[
					-25491,
					5069
				],
				[
					-21500,
					19966
				],
				[
					-8583,
					17578
				],
				[
					-14241,
					7954
				],
				[
					-16137,
					28538
				],
				[
					-9221,
					5578
				],
				[
					-37225,
					-1688
				],
				[
					-23385,
					36323
				],
				[
					-17789,
					-11359
				],
				[
					-2632,
					-12393
				],
				[
					-29097,
					14049
				],
				[
					-13364,
					-1527
				],
				[
					-14726,
					15903
				],
				[
					146,
					27509
				],
				[
					-78892,
					41979
				],
				[
					-17346,
					26573
				],
				[
					15354,
					27485
				],
				[
					11974,
					36065
				],
				[
					44597,
					14512
				],
				[
					25952,
					-6867
				],
				[
					752,
					-15757
				],
				[
					16412,
					-15593
				],
				[
					27877,
					-12651
				],
				[
					27666,
					-40177
				],
				[
					42429,
					-4677
				],
				[
					1259,
					11986
				],
				[
					19335,
					5902
				],
				[
					11313,
					-11374
				],
				[
					18471,
					5100
				],
				[
					13408,
					16716
				],
				[
					-20327,
					35131
				],
				[
					5157,
					18177
				],
				[
					8241,
					-18367
				],
				[
					14999,
					-6534
				],
				[
					-12735,
					-9520
				],
				[
					30799,
					3418
				],
				[
					6030,
					9896
				],
				[
					-17082,
					38076
				],
				[
					-25816,
					4980
				],
				[
					-12960,
					-9363
				],
				[
					-9263,
					15080
				],
				[
					14115,
					22476
				]
			],
			[
				[
					4551658,
					7621983
				],
				[
					-27538,
					6972
				]
			],
			[
				[
					4524120,
					7628955
				],
				[
					27538,
					-6972
				]
			],
			[
				[
					2718928,
					6755871
				],
				[
					58544,
					3746
				],
				[
					-32761,
					20178
				],
				[
					-19114,
					22542
				],
				[
					-11163,
					29035
				],
				[
					75650,
					-234
				],
				[
					209729,
					163
				],
				[
					189482,
					624
				],
				[
					767,
					-37454
				],
				[
					33967,
					77
				],
				[
					822,
					37169
				],
				[
					57915,
					-138
				],
				[
					241752,
					-738
				],
				[
					1860,
					589791
				]
			],
			[
				[
					3526378,
					7420632
				],
				[
					20,
					2974
				]
			],
			[
				[
					3526398,
					7423606
				],
				[
					48,
					7195
				]
			],
			[
				[
					3526446,
					7430801
				],
				[
					85,
					12884
				]
			],
			[
				[
					3526531,
					7443685
				],
				[
					159,
					30721
				]
			],
			[
				[
					3526690,
					7474406
				],
				[
					28,
					8250
				]
			],
			[
				[
					3526718,
					7482656
				],
				[
					2,
					690
				]
			],
			[
				[
					3526720,
					7483346
				],
				[
					4,
					1090
				]
			],
			[
				[
					3526724,
					7484436
				],
				[
					3,
					739
				]
			],
			[
				[
					3526727,
					7485175
				],
				[
					12,
					3695
				]
			],
			[
				[
					3526739,
					7488870
				],
				[
					166,
					48130
				]
			],
			[
				[
					3526905,
					7537000
				],
				[
					21891,
					2674
				],
				[
					-4286,
					-17510
				],
				[
					39059,
					-20791
				],
				[
					-2442,
					-7449
				],
				[
					23300,
					4141
				],
				[
					15155,
					-19507
				],
				[
					1097,
					-27542
				],
				[
					33341,
					5835
				],
				[
					14959,
					-10143
				],
				[
					-7323,
					-49430
				],
				[
					18891,
					-39362
				],
				[
					12996,
					-6472
				],
				[
					-3105,
					-35857
				],
				[
					22358,
					-6284
				],
				[
					-9853,
					-26022
				],
				[
					2110,
					-20367
				],
				[
					12872,
					-6593
				],
				[
					-716,
					-12904
				],
				[
					14213,
					4787
				],
				[
					6673,
					-19409
				],
				[
					20659,
					-8762
				],
				[
					9809,
					4429
				],
				[
					-12572,
					23351
				],
				[
					22001,
					-2049
				],
				[
					4793,
					11994
				],
				[
					36377,
					14426
				],
				[
					-23579,
					14840
				],
				[
					24439,
					2243
				],
				[
					-18608,
					8675
				],
				[
					1229,
					11122
				],
				[
					-21468,
					9263
				],
				[
					-4512,
					25975
				],
				[
					-14046,
					5315
				],
				[
					-2533,
					31672
				],
				[
					6289,
					12328
				],
				[
					-16061,
					25051
				],
				[
					12385,
					6360
				],
				[
					-17350,
					5921
				],
				[
					9026,
					22715
				],
				[
					-18404,
					13649
				],
				[
					2752,
					16506
				],
				[
					-14426,
					31777
				],
				[
					-4747,
					32855
				],
				[
					4841,
					19591
				],
				[
					-13612,
					7875
				],
				[
					-3460,
					21335
				],
				[
					18337,
					7934
				],
				[
					24064,
					-4307
				],
				[
					-25137,
					18436
				],
				[
					10551,
					20816
				],
				[
					42287,
					-6476
				],
				[
					25096,
					-10277
				],
				[
					25565,
					-19954
				],
				[
					28066,
					-3772
				],
				[
					-16165,
					9089
				],
				[
					660,
					14657
				],
				[
					24756,
					7513
				],
				[
					19355,
					-19199
				],
				[
					27896,
					-3257
				],
				[
					5277,
					-15010
				],
				[
					37851,
					-26989
				],
				[
					24507,
					789
				],
				[
					5642,
					-17326
				],
				[
					30981,
					-23032
				],
				[
					9813,
					2563
				],
				[
					13889,
					-19432
				],
				[
					-23037,
					19407
				],
				[
					15598,
					-20501
				],
				[
					6523,
					-19081
				],
				[
					-17266,
					10840
				],
				[
					3097,
					-15831
				],
				[
					14125,
					-16123
				],
				[
					-938,
					-14330
				],
				[
					11939,
					-15874
				],
				[
					-2322,
					-27361
				],
				[
					13383,
					-12598
				],
				[
					13013,
					-33972
				],
				[
					547,
					-17039
				],
				[
					22706,
					-40495
				],
				[
					1244,
					-27513
				],
				[
					17709,
					-10240
				],
				[
					36665,
					-54519
				],
				[
					-7250,
					-10720
				],
				[
					8826,
					-21906
				],
				[
					1091,
					-24562
				],
				[
					-11801,
					6234
				],
				[
					-11361,
					-7325
				],
				[
					8215,
					-18410
				],
				[
					-12011,
					-25852
				],
				[
					-11218,
					-8923
				],
				[
					15108,
					-23849
				],
				[
					39086,
					-17655
				],
				[
					9047,
					-9413
				],
				[
					6400,
					-35728
				],
				[
					19824,
					-3424
				],
				[
					22430,
					-17399
				],
				[
					2464,
					-9207
				],
				[
					22878,
					-12991
				],
				[
					13159,
					4453
				],
				[
					23845,
					-24459
				],
				[
					20271,
					-1730
				],
				[
					-4021,
					11919
				],
				[
					-18969,
					10496
				],
				[
					-2427,
					17878
				],
				[
					12196,
					4593
				],
				[
					23847,
					-21044
				],
				[
					-5023,
					-21017
				],
				[
					36086,
					-8769
				],
				[
					35191,
					-21868
				],
				[
					38513,
					-31605
				],
				[
					24889,
					14295
				],
				[
					13319,
					-11004
				],
				[
					-10698,
					-2566
				],
				[
					-203,
					-17282
				],
				[
					16343,
					-11400
				],
				[
					57443,
					11785
				],
				[
					-1035,
					-22564
				],
				[
					11165,
					-18965
				],
				[
					-3362,
					-12273
				],
				[
					8178,
					-20136
				],
				[
					-5874,
					-40456
				],
				[
					-17843,
					-13285
				],
				[
					-6418,
					9116
				],
				[
					-16643,
					-6671
				],
				[
					-18677,
					29566
				],
				[
					-2341,
					28382
				],
				[
					-15249,
					-45216
				],
				[
					-35153,
					3607
				],
				[
					-16701,
					27967
				],
				[
					-11453,
					721
				],
				[
					-11410,
					14828
				],
				[
					2915,
					-16241
				],
				[
					-14897,
					-21032
				],
				[
					-15372,
					5715
				],
				[
					-13577,
					-19099
				],
				[
					15040,
					-1626
				],
				[
					-2807,
					-33357
				],
				[
					-32857,
					-7571
				],
				[
					-38104,
					21030
				],
				[
					-14927,
					15156
				],
				[
					688,
					26640
				],
				[
					21748,
					-11966
				],
				[
					5911,
					8988
				],
				[
					-30655,
					30570
				],
				[
					-817,
					-8836
				],
				[
					-16244,
					1676
				],
				[
					13559,
					-14587
				],
				[
					5127,
					-18647
				],
				[
					-10638,
					-11943
				],
				[
					-24550,
					9103
				],
				[
					25457,
					-33637
				],
				[
					16547,
					668
				],
				[
					12015,
					-32554
				],
				[
					318,
					18189
				],
				[
					10855,
					-10078
				],
				[
					2666,
					-19052
				],
				[
					-6678,
					-4377
				],
				[
					2452,
					-31308
				],
				[
					-23628,
					-16586
				],
				[
					1216,
					-17258
				],
				[
					25367,
					26854
				],
				[
					16931,
					40282
				],
				[
					14571,
					-2696
				],
				[
					25542,
					8442
				],
				[
					7287,
					20144
				],
				[
					33895,
					-1119
				],
				[
					17484,
					-10031
				],
				[
					5787,
					-12552
				],
				[
					-13421,
					-14207
				],
				[
					-6258,
					-26211
				],
				[
					-8702,
					12379
				],
				[
					-5624,
					-8665
				],
				[
					14506,
					-17627
				],
				[
					12595,
					20511
				],
				[
					26675,
					-18547
				],
				[
					-6232,
					-28689
				],
				[
					2146,
					-14914
				],
				[
					-23049,
					-7587
				],
				[
					-12345,
					5379
				],
				[
					-4855,
					-10746
				],
				[
					-26800,
					-5961
				],
				[
					-9193,
					-12783
				],
				[
					-17231,
					-3297
				],
				[
					-14507,
					10783
				],
				[
					3737,
					-14752
				],
				[
					-16726,
					-2768
				],
				[
					-7889,
					-9140
				],
				[
					-22559,
					11342
				],
				[
					-43104,
					-8054
				],
				[
					-38725,
					6494
				],
				[
					-15270,
					9897
				],
				[
					-8178,
					-5667
				],
				[
					-33902,
					14288
				],
				[
					-9607,
					9708
				],
				[
					-11823,
					-22203
				],
				[
					-20366,
					-249
				],
				[
					-46669,
					8010
				],
				[
					-13102,
					15586
				],
				[
					19098,
					6901
				],
				[
					21857,
					17331
				],
				[
					-18028,
					10595
				],
				[
					874,
					-10845
				],
				[
					-39119,
					11478
				],
				[
					-15588,
					9780
				],
				[
					-37503,
					9144
				],
				[
					-24806,
					-8000
				],
				[
					-31288,
					8497
				],
				[
					-5385,
					15043
				],
				[
					16094,
					8927
				],
				[
					-6687,
					28506
				],
				[
					-16055,
					16122
				],
				[
					-20702,
					4138
				],
				[
					-11157,
					-24194
				],
				[
					-24605,
					-6887
				],
				[
					5107,
					-27084
				],
				[
					-22084,
					-19741
				],
				[
					-20138,
					-30121
				],
				[
					-24866,
					-13951
				],
				[
					-73046,
					-11609
				],
				[
					-45120,
					1899
				],
				[
					2725,
					-11946
				],
				[
					-21964,
					-18529
				],
				[
					-34168,
					-20918
				],
				[
					-41615,
					-7384
				],
				[
					-37100,
					-15209
				],
				[
					-36010,
					-3500
				],
				[
					-15291,
					5657
				],
				[
					-18509,
					-15817
				],
				[
					-28942,
					11115
				],
				[
					-9840,
					-7762
				],
				[
					-34204,
					-9851
				],
				[
					-859,
					11551
				],
				[
					38284,
					12875
				],
				[
					-2900,
					10062
				],
				[
					15836,
					6665
				],
				[
					-7862,
					6128
				],
				[
					-11122,
					-18926
				],
				[
					-20808,
					-14045
				],
				[
					-19133,
					-5202
				],
				[
					-35208,
					1309
				],
				[
					20890,
					-16949
				],
				[
					-55063,
					6898
				],
				[
					-20870,
					-6181
				],
				[
					-28947,
					1974
				],
				[
					-26632,
					-8644
				],
				[
					-30186,
					2210
				],
				[
					-16060,
					-9397
				],
				[
					-14009,
					4386
				],
				[
					-35519,
					-6905
				],
				[
					-10740,
					6485
				],
				[
					29511,
					2243
				],
				[
					-5180,
					11458
				],
				[
					-32323,
					12737
				],
				[
					-7777,
					22868
				],
				[
					-27483,
					29680
				],
				[
					-80,
					19683
				],
				[
					12203,
					12593
				],
				[
					276,
					23995
				],
				[
					-15318,
					16745
				],
				[
					12709,
					6732
				],
				[
					-7647,
					10630
				],
				[
					21235,
					-3080
				],
				[
					-82677,
					25167
				],
				[
					-77589,
					-3997
				],
				[
					-17976,
					5256
				],
				[
					-17088,
					-8725
				],
				[
					-14010,
					5473
				],
				[
					-71724,
					5820
				],
				[
					-11081,
					10772
				],
				[
					-15941,
					1230
				],
				[
					-19721,
					12290
				],
				[
					-17332,
					2511
				],
				[
					-13489,
					12524
				],
				[
					10044,
					9223
				],
				[
					-10090,
					16986
				],
				[
					-8559,
					-4942
				],
				[
					-17554,
					7112
				],
				[
					2737,
					17781
				],
				[
					-17591,
					8459
				]
			],
			[
				[
					3755663,
					7705677
				],
				[
					24569,
					-1790
				],
				[
					5584,
					-7782
				],
				[
					-36254,
					-10334
				],
				[
					-11573,
					1599
				],
				[
					-4279,
					15414
				],
				[
					21953,
					2893
				]
			],
			[
				[
					3958065,
					7731992
				],
				[
					142057,
					-21814
				]
			],
			[
				[
					4100122,
					7710178
				],
				[
					571,
					-92
				]
			],
			[
				[
					4100693,
					7710086
				],
				[
					2246,
					-363
				]
			],
			[
				[
					4102939,
					7709723
				],
				[
					7307,
					-1180
				]
			],
			[
				[
					4110246,
					7708543
				],
				[
					7081,
					-1144
				]
			],
			[
				[
					4117327,
					7707399
				],
				[
					20015,
					-20093
				],
				[
					-11875,
					-56851
				],
				[
					-43839,
					-56629
				],
				[
					-5630,
					-17306
				],
				[
					-23106,
					-16169
				],
				[
					-15885,
					4506
				],
				[
					10541,
					-25739
				],
				[
					-32167,
					32550
				],
				[
					-8401,
					2641
				],
				[
					-54153,
					49617
				],
				[
					8433,
					3727
				],
				[
					-18141,
					11834
				],
				[
					7760,
					4738
				],
				[
					-27888,
					14077
				],
				[
					-10073,
					14087
				],
				[
					-25145,
					5911
				],
				[
					-16923,
					10757
				],
				[
					-23651,
					155
				],
				[
					39834,
					50833
				],
				[
					19482,
					8563
				],
				[
					51550,
					3384
				]
			],
			[
				[
					5424677,
					4884459
				],
				[
					8927,
					-18905
				],
				[
					-7152,
					-6652
				],
				[
					-11130,
					12647
				],
				[
					-14546,
					3176
				],
				[
					23901,
					9734
				]
			],
			[
				[
					5636435,
					5071223
				],
				[
					20316,
					-6954
				],
				[
					-9006,
					-5690
				],
				[
					-18777,
					9678
				],
				[
					7467,
					2966
				]
			],
			[
				[
					6647083,
					5141311
				],
				[
					44303,
					-18812
				],
				[
					-11676,
					-27630
				],
				[
					1430,
					-21641
				],
				[
					-22261,
					-26525
				],
				[
					-16576,
					-4212
				],
				[
					-13105,
					-16351
				],
				[
					-6977,
					-16559
				],
				[
					-22861,
					-18434
				],
				[
					-17408,
					-23950
				],
				[
					-27360,
					-20823
				],
				[
					-26651,
					17546
				],
				[
					-13132,
					-2172
				],
				[
					-27951,
					-25153
				],
				[
					-6845,
					2013
				],
				[
					162,
					32751
				],
				[
					-18822,
					21390
				],
				[
					-4305,
					23709
				],
				[
					28423,
					30521
				],
				[
					11625,
					19868
				],
				[
					-2931,
					14573
				],
				[
					4394,
					19955
				],
				[
					18991,
					18912
				],
				[
					13569,
					5974
				],
				[
					12303,
					-6029
				],
				[
					3209,
					-12131
				],
				[
					13100,
					-3030
				],
				[
					34503,
					23934
				],
				[
					33278,
					-2745
				],
				[
					19571,
					15051
				]
			],
			[
				[
					5600463,
					5289505
				],
				[
					11216,
					-1478
				],
				[
					10082,
					-11886
				],
				[
					-13019,
					-2345
				],
				[
					-15132,
					15335
				],
				[
					6853,
					374
				]
			],
			[
				[
					5431552,
					5362292
				],
				[
					8535,
					-11211
				],
				[
					-16342,
					4691
				],
				[
					7807,
					6520
				]
			],
			[
				[
					6735309,
					5440317
				],
				[
					10290,
					-7100
				],
				[
					-16593,
					-4452
				],
				[
					6303,
					11552
				]
			],
			[
				[
					6524933,
					5833534
				],
				[
					10300,
					-4979
				],
				[
					-27965,
					-8858
				],
				[
					-7440,
					11435
				],
				[
					25105,
					2402
				]
			],
			[
				[
					6280594,
					5848191
				],
				[
					761,
					-24300
				],
				[
					11211,
					-6545
				],
				[
					4501,
					8646
				],
				[
					17993,
					-4039
				],
				[
					2545,
					-21555
				],
				[
					16761,
					-27120
				],
				[
					-3850,
					-9432
				],
				[
					-24175,
					-12142
				],
				[
					22478,
					-15260
				],
				[
					10565,
					-16306
				],
				[
					-620,
					-14806
				],
				[
					13975,
					-30247
				],
				[
					15212,
					12432
				],
				[
					-309,
					17588
				],
				[
					21327,
					35644
				],
				[
					15448,
					-9226
				],
				[
					-576,
					-10119
				],
				[
					23816,
					-9259
				],
				[
					5069,
					-15498
				],
				[
					-8364,
					-6124
				],
				[
					20805,
					-20058
				],
				[
					19381,
					1152
				],
				[
					-2853,
					-7606
				],
				[
					45826,
					-579
				],
				[
					11118,
					-4920
				],
				[
					10221,
					-17365
				],
				[
					54,
					-14741
				],
				[
					13908,
					-14363
				],
				[
					24193,
					-10527
				],
				[
					22375,
					-23494
				],
				[
					23078,
					-10038
				],
				[
					4452,
					-7279
				],
				[
					19953,
					7217
				],
				[
					17842,
					-19250
				],
				[
					13078,
					-697
				],
				[
					4421,
					-10954
				],
				[
					24500,
					-21186
				],
				[
					9941,
					-20402
				],
				[
					536,
					-47875
				],
				[
					16670,
					-23070
				],
				[
					-13288,
					-18714
				],
				[
					-28801,
					-7412
				],
				[
					-2056,
					-20326
				],
				[
					57911,
					12666
				],
				[
					4556,
					8280
				],
				[
					18809,
					-3501
				],
				[
					35804,
					-18930
				],
				[
					-4503,
					22095
				],
				[
					6181,
					14869
				],
				[
					20152,
					-14870
				],
				[
					5075,
					-13434
				],
				[
					18145,
					-5142
				],
				[
					-2183,
					-17817
				],
				[
					9639,
					-3959
				],
				[
					-15038,
					-8973
				],
				[
					12032,
					-541
				],
				[
					35019,
					-14370
				],
				[
					2541,
					-10136
				],
				[
					-10106,
					-6489
				],
				[
					-26373,
					-3386
				],
				[
					-9827,
					-20737
				],
				[
					-39106,
					-26359
				],
				[
					-1969,
					-15568
				],
				[
					-13474,
					-3483
				],
				[
					-36503,
					17725
				],
				[
					-20010,
					14329
				],
				[
					-14317,
					-1219
				],
				[
					-9638,
					15773
				],
				[
					-17384,
					-2095
				],
				[
					-17433,
					14856
				],
				[
					-18619,
					-1523
				],
				[
					-7490,
					-8887
				],
				[
					-19518,
					6530
				],
				[
					-7275,
					17156
				],
				[
					5179,
					13147
				],
				[
					18277,
					9960
				],
				[
					-3338,
					14711
				],
				[
					-19201,
					14699
				],
				[
					-29380,
					294
				],
				[
					-9722,
					4880
				],
				[
					-20724,
					-9253
				],
				[
					-7872,
					5918
				],
				[
					4167,
					13986
				],
				[
					18224,
					26202
				],
				[
					-7829,
					12226
				],
				[
					-12853,
					-2937
				],
				[
					-6565,
					-13904
				],
				[
					-11254,
					7090
				],
				[
					-13010,
					-10304
				],
				[
					-15603,
					913
				],
				[
					-15269,
					-26371
				],
				[
					7254,
					-16457
				],
				[
					-3898,
					-14846
				],
				[
					5925,
					-11858
				],
				[
					-5625,
					-13729
				],
				[
					-13643,
					3986
				],
				[
					-17365,
					-23699
				],
				[
					-22472,
					-20121
				],
				[
					-8506,
					7675
				],
				[
					-19849,
					-13382
				],
				[
					-9041,
					-19170
				],
				[
					-2904,
					-27999
				],
				[
					-15992,
					-18087
				],
				[
					-7355,
					-1559
				],
				[
					-34735,
					-30675
				],
				[
					-27298,
					-13000
				],
				[
					-32752,
					-305
				],
				[
					-12506,
					17198
				],
				[
					-4769,
					56964
				],
				[
					7072,
					20801
				],
				[
					-1283,
					41733
				],
				[
					-8634,
					3153
				],
				[
					-4865,
					16908
				],
				[
					7742,
					10179
				],
				[
					2752,
					18286
				],
				[
					-6800,
					-1011
				],
				[
					-8892,
					-37809
				],
				[
					-30734,
					-8078
				],
				[
					-25807,
					-11040
				],
				[
					-28867,
					6975
				],
				[
					-13076,
					-4654
				],
				[
					-13326,
					-16518
				],
				[
					-20108,
					-7567
				],
				[
					-22060,
					3848
				],
				[
					-9600,
					15028
				],
				[
					1036,
					21903
				],
				[
					24992,
					36699
				],
				[
					24751,
					21808
				],
				[
					35344,
					15427
				],
				[
					10189,
					9747
				],
				[
					20607,
					5408
				],
				[
					-883,
					21952
				],
				[
					-12518,
					12358
				],
				[
					-6741,
					35293
				],
				[
					-3625,
					51452
				],
				[
					14425,
					32382
				],
				[
					15803,
					49768
				],
				[
					-9256,
					11654
				],
				[
					9621,
					32321
				],
				[
					-3656,
					42850
				],
				[
					6948,
					15711
				],
				[
					-4966,
					5565
				],
				[
					4795,
					29737
				],
				[
					8956,
					28592
				],
				[
					2260,
					21619
				],
				[
					14696,
					21894
				],
				[
					31215,
					28199
				],
				[
					10577,
					2529
				]
			],
			[
				[
					6331648,
					5873686
				],
				[
					15209,
					-3495
				],
				[
					30638,
					-59028
				],
				[
					9422,
					-38066
				],
				[
					-8375,
					-13517
				],
				[
					-12320,
					-2352
				],
				[
					-9581,
					11099
				],
				[
					-5780,
					19647
				],
				[
					-24243,
					16004
				],
				[
					-4437,
					15820
				],
				[
					2727,
					23625
				],
				[
					-5844,
					20760
				],
				[
					12584,
					9503
				]
			],
			[
				[
					6405053,
					5900973
				],
				[
					45828,
					-25474
				],
				[
					36158,
					-25109
				],
				[
					-1227,
					-22423
				],
				[
					-11012,
					-7751
				],
				[
					35144,
					-20619
				],
				[
					33631,
					-3800
				],
				[
					-5462,
					-13773
				],
				[
					-17661,
					-7260
				],
				[
					-7426,
					7514
				],
				[
					-28472,
					-1306
				],
				[
					-11564,
					25305
				],
				[
					3617,
					9781
				],
				[
					-18825,
					-15393
				],
				[
					-20780,
					9127
				],
				[
					5874,
					10293
				],
				[
					-9644,
					39131
				],
				[
					-25804,
					7182
				],
				[
					-9253,
					15289
				],
				[
					6878,
					19286
				]
			],
			[
				[
					6347249,
					6085362
				],
				[
					-318,
					424
				]
			],
			[
				[
					6346931,
					6085786
				],
				[
					318,
					-424
				]
			],
			[
				[
					6343092,
					6090901
				],
				[
					3638,
					-4847
				]
			],
			[
				[
					6346730,
					6086054
				],
				[
					-3638,
					4847
				]
			],
			[
				[
					6341003,
					6093685
				],
				[
					995,
					-1326
				]
			],
			[
				[
					6341998,
					6092359
				],
				[
					-995,
					1326
				]
			],
			[
				[
					5886172,
					6107618
				],
				[
					177898,
					0
				],
				[
					156959,
					0
				],
				[
					109483,
					0
				],
				[
					7129,
					-9453
				]
			],
			[
				[
					6337641,
					6098165
				],
				[
					-17633,
					-10152
				],
				[
					-1895,
					-13721
				],
				[
					15768,
					-1634
				],
				[
					17089,
					7968
				]
			],
			[
				[
					6350970,
					6080626
				],
				[
					116344,
					-138860
				]
			],
			[
				[
					6467314,
					5941766
				],
				[
					891,
					-1097
				]
			],
			[
				[
					6468205,
					5940669
				],
				[
					1413,
					-1737
				]
			],
			[
				[
					6469618,
					5938932
				],
				[
					338,
					-416
				]
			],
			[
				[
					6469956,
					5938516
				],
				[
					11458,
					-14185
				]
			],
			[
				[
					6481414,
					5924331
				],
				[
					1519,
					-1896
				]
			],
			[
				[
					6482933,
					5922435
				],
				[
					5386,
					-6720
				]
			],
			[
				[
					6488319,
					5915715
				],
				[
					-14597,
					-12011
				],
				[
					1748,
					14286
				],
				[
					-16924,
					-5219
				],
				[
					-21397,
					16463
				],
				[
					-1613,
					12180
				],
				[
					-10412,
					2145
				],
				[
					-10082,
					-12398
				],
				[
					-8648,
					18254
				],
				[
					-13680,
					13032
				],
				[
					-12093,
					-14125
				],
				[
					28936,
					-29426
				],
				[
					-159,
					-13341
				],
				[
					-11007,
					-53
				],
				[
					-11218,
					13733
				],
				[
					-22024,
					-1181
				],
				[
					-8666,
					10598
				],
				[
					-13637,
					-4452
				],
				[
					-16379,
					12922
				],
				[
					-15362,
					-6609
				],
				[
					-9531,
					41820
				],
				[
					1690,
					7574
				],
				[
					-15336,
					26833
				],
				[
					-19881,
					-6055
				],
				[
					-25207,
					-13989
				],
				[
					-23262,
					-2141
				],
				[
					-33843,
					7056
				],
				[
					-27495,
					10274
				],
				[
					179,
					-12120
				],
				[
					-16659,
					3178
				],
				[
					12807,
					-20807
				],
				[
					-19791,
					2122
				],
				[
					18303,
					-30932
				],
				[
					37049,
					-9006
				],
				[
					47644,
					-22888
				],
				[
					-13493,
					-20676
				],
				[
					262,
					-19627
				],
				[
					-20827,
					-9688
				],
				[
					-5055,
					-12381
				],
				[
					-19245,
					-8810
				],
				[
					-4798,
					-27982
				],
				[
					-10604,
					-24126
				],
				[
					-16984,
					-7533
				],
				[
					-1270,
					-9009
				],
				[
					-20820,
					-11433
				],
				[
					-13498,
					-18593
				],
				[
					-9010,
					-603
				],
				[
					3068,
					-17053
				],
				[
					-29904,
					-19865
				],
				[
					-37711,
					1531
				],
				[
					-22652,
					-2703
				],
				[
					-19763,
					5400
				],
				[
					-18371,
					11473
				],
				[
					-27205,
					35772
				],
				[
					-14577,
					11613
				],
				[
					-30265,
					12531
				],
				[
					38474,
					858
				],
				[
					-49083,
					9736
				],
				[
					-59659,
					46304
				],
				[
					-7728,
					1984
				],
				[
					-34618,
					23743
				],
				[
					11837,
					-12200
				],
				[
					-28491,
					4606
				],
				[
					20884,
					-11963
				],
				[
					7605,
					-15989
				],
				[
					-43082,
					13708
				],
				[
					-11830,
					-7187
				],
				[
					-28211,
					5940
				],
				[
					46164,
					-17709
				],
				[
					46342,
					-29596
				],
				[
					6986,
					-13416
				],
				[
					15814,
					-9507
				],
				[
					9599,
					-25880
				],
				[
					18458,
					-10895
				],
				[
					16392,
					-29366
				],
				[
					12392,
					3505
				],
				[
					41826,
					-9733
				],
				[
					51826,
					-4207
				],
				[
					12762,
					-11106
				],
				[
					-2099,
					12257
				],
				[
					32932,
					-5707
				],
				[
					-3501,
					6988
				],
				[
					21074,
					844
				],
				[
					61292,
					-12910
				],
				[
					-3054,
					-7653
				],
				[
					13069,
					-16347
				],
				[
					-9189,
					-12913
				],
				[
					3870,
					-8745
				],
				[
					-11847,
					-6777
				],
				[
					2208,
					-11613
				],
				[
					-13108,
					-9060
				],
				[
					-15482,
					-35431
				],
				[
					2012,
					-8277
				],
				[
					-23178,
					-19273
				],
				[
					-6520,
					-24881
				],
				[
					-28082,
					-15107
				],
				[
					-5742,
					-11547
				],
				[
					26,
					-20033
				],
				[
					-19554,
					-23297
				],
				[
					1478,
					-14340
				],
				[
					-11519,
					-18248
				],
				[
					-8363,
					6090
				],
				[
					-15465,
					-16375
				],
				[
					-27627,
					34
				],
				[
					14650,
					-6926
				],
				[
					-35483,
					-22525
				],
				[
					-38139,
					13387
				],
				[
					-15591,
					16677
				],
				[
					15924,
					-35181
				],
				[
					-15498,
					-36
				],
				[
					-18534,
					21148
				],
				[
					-4186,
					-6475
				],
				[
					-15623,
					15653
				],
				[
					-2078,
					-13182
				],
				[
					-23818,
					15634
				],
				[
					8482,
					9486
				],
				[
					-5791,
					24052
				],
				[
					-2332,
					-23671
				],
				[
					-23961,
					5393
				],
				[
					14524,
					-23822
				],
				[
					5444,
					-33569
				],
				[
					-23081,
					13760
				],
				[
					-8771,
					-6493
				],
				[
					1091,
					-18103
				],
				[
					15097,
					-20825
				],
				[
					-14510,
					-3364
				],
				[
					2893,
					-11212
				],
				[
					-17147,
					-30068
				],
				[
					-10175,
					10221
				],
				[
					-17624,
					-11423
				],
				[
					-12830,
					22028
				],
				[
					-5049,
					-2444
				],
				[
					7817,
					-22294
				],
				[
					-39380,
					-5617
				],
				[
					18597,
					-1974
				],
				[
					11834,
					-25279
				],
				[
					-11123,
					-332
				],
				[
					-5163,
					10390
				],
				[
					-19402,
					13197
				],
				[
					926,
					6625
				],
				[
					-39604,
					19574
				],
				[
					-9769,
					-2662
				],
				[
					-2965,
					24475
				],
				[
					-3099,
					-13515
				],
				[
					-31861,
					10776
				],
				[
					-45059,
					-994
				],
				[
					-16226,
					9225
				],
				[
					-11940,
					-1022
				],
				[
					-12815,
					13586
				],
				[
					-27635,
					3418
				],
				[
					-5127,
					9783
				],
				[
					-17412,
					3138
				],
				[
					-4000,
					11950
				],
				[
					-16294,
					-4738
				],
				[
					-5208,
					8255
				],
				[
					-36179,
					12025
				],
				[
					-31739,
					38923
				],
				[
					7766,
					-19534
				],
				[
					12532,
					-11540
				],
				[
					2165,
					-14700
				],
				[
					-22109,
					-2101
				],
				[
					12905,
					-23309
				],
				[
					40523,
					-11751
				],
				[
					-15423,
					12752
				],
				[
					-5851,
					16468
				],
				[
					7656,
					6215
				],
				[
					32431,
					-23614
				],
				[
					33894,
					-9080
				],
				[
					21459,
					-17905
				],
				[
					7612,
					13050
				],
				[
					8838,
					-2923
				],
				[
					9500,
					-18550
				],
				[
					16565,
					4965
				],
				[
					13500,
					-16715
				],
				[
					-1349,
					-9511
				],
				[
					-20590,
					-6515
				],
				[
					-18531,
					-16606
				],
				[
					-38015,
					2217
				],
				[
					-8317,
					-9142
				],
				[
					-13987,
					785
				],
				[
					14419,
					-9693
				],
				[
					20141,
					-30960
				],
				[
					11804,
					-1206
				],
				[
					-19382,
					13685
				],
				[
					856,
					6868
				],
				[
					-14480,
					14670
				],
				[
					2056,
					8857
				],
				[
					13379,
					3731
				],
				[
					36818,
					1502
				],
				[
					13604,
					-16692
				],
				[
					-2081,
					-24219
				],
				[
					12564,
					-13778
				],
				[
					5244,
					4390
				],
				[
					-15959,
					18171
				],
				[
					13602,
					-4090
				],
				[
					-8995,
					20010
				],
				[
					-12973,
					14966
				],
				[
					8953,
					7773
				],
				[
					5503,
					-8031
				],
				[
					3485,
					14666
				],
				[
					20227,
					15954
				],
				[
					28882,
					13238
				],
				[
					21549,
					-19664
				],
				[
					-5079,
					-15090
				],
				[
					14889,
					-324
				],
				[
					553,
					-7626
				],
				[
					15061,
					-12573
				],
				[
					9795,
					2339
				],
				[
					34442,
					-8622
				],
				[
					24442,
					-27934
				],
				[
					2231,
					-23310
				],
				[
					6703,
					-7579
				],
				[
					-1658,
					-20741
				],
				[
					5799,
					-26853
				],
				[
					-7084,
					-1685
				],
				[
					-10369,
					-24585
				],
				[
					-11306,
					6066
				],
				[
					-14966,
					-1495
				],
				[
					-18204,
					-11082
				],
				[
					-4838,
					-11248
				],
				[
					-17481,
					-2194
				],
				[
					3190,
					-8419
				],
				[
					-32027,
					1108
				],
				[
					-51281,
					14542
				],
				[
					5041,
					-14405
				],
				[
					-34794,
					9677
				],
				[
					-6671,
					-10211
				],
				[
					9227,
					-17956
				],
				[
					20517,
					-15770
				],
				[
					32324,
					-6169
				],
				[
					1999,
					-12629
				],
				[
					-16376,
					-14142
				],
				[
					-38965,
					10833
				],
				[
					2517,
					-8358
				],
				[
					-14258,
					-1605
				],
				[
					-12127,
					10082
				],
				[
					-18087,
					25005
				],
				[
					-18483,
					16477
				],
				[
					4556,
					-13166
				],
				[
					10033,
					-3248
				],
				[
					17986,
					-22370
				],
				[
					11235,
					-21127
				],
				[
					-5852,
					-9695
				],
				[
					19186,
					-9950
				],
				[
					5098,
					3756
				],
				[
					17146,
					-9088
				],
				[
					1672,
					-7999
				],
				[
					-18511,
					1095
				],
				[
					-2869,
					6371
				],
				[
					-28498,
					3224
				],
				[
					7943,
					10244
				],
				[
					-8376,
					9128
				],
				[
					-16173,
					-4185
				],
				[
					9041,
					-17587
				],
				[
					-12396,
					-5892
				],
				[
					26599,
					-13030
				],
				[
					-2832,
					-16916
				],
				[
					5334,
					-16840
				],
				[
					-9668,
					-2900
				],
				[
					2947,
					11540
				],
				[
					-19645,
					23076
				],
				[
					-34494,
					6780
				],
				[
					-30356,
					8947
				],
				[
					-11674,
					21385
				],
				[
					-5151,
					18476
				],
				[
					-20297,
					35612
				],
				[
					1184,
					20424
				],
				[
					8994,
					7639
				],
				[
					-16362,
					16802
				],
				[
					15646,
					3957
				],
				[
					-3411,
					22907
				],
				[
					-5304,
					-8462
				],
				[
					7667,
					-12261
				],
				[
					-22279,
					-8378
				],
				[
					11716,
					-3233
				],
				[
					4932,
					-15160
				],
				[
					-6623,
					-5525
				],
				[
					3614,
					-22666
				],
				[
					13874,
					-20949
				],
				[
					11499,
					-29343
				],
				[
					8217,
					-10780
				],
				[
					-5015,
					-5829
				],
				[
					37043,
					-13444
				],
				[
					36209,
					-20392
				],
				[
					-4759,
					-15880
				],
				[
					-4730,
					6184
				],
				[
					-21716,
					-8654
				],
				[
					-27013,
					-109
				],
				[
					15359,
					-4613
				],
				[
					1687,
					-10786
				],
				[
					18480,
					-1974
				],
				[
					-12506,
					-13184
				],
				[
					-12387,
					1204
				],
				[
					8961,
					-16802
				],
				[
					-16020,
					5040
				],
				[
					-9875,
					11200
				],
				[
					880,
					-12318
				],
				[
					13655,
					-12814
				],
				[
					-17450,
					2684
				],
				[
					8317,
					-13942
				],
				[
					-6369,
					-2159
				],
				[
					-32330,
					16673
				],
				[
					10907,
					-17313
				],
				[
					-12576,
					5592
				],
				[
					-18202,
					17747
				],
				[
					-4370,
					-3572
				],
				[
					18500,
					-11295
				],
				[
					12228,
					-18304
				],
				[
					17950,
					-14336
				],
				[
					17927,
					-4335
				],
				[
					-13097,
					-7293
				],
				[
					-12975,
					6415
				],
				[
					-19495,
					-276
				],
				[
					544,
					-10597
				],
				[
					18471,
					4252
				],
				[
					20910,
					-2787
				],
				[
					-27423,
					-12128
				],
				[
					-33585,
					-29068
				],
				[
					-17348,
					-25074
				],
				[
					2156,
					-18848
				],
				[
					14782,
					308
				],
				[
					3197,
					-8362
				],
				[
					-9996,
					-10881
				],
				[
					-22402,
					516
				],
				[
					10050,
					-21791
				],
				[
					-10731,
					-11511
				],
				[
					2003,
					-11035
				],
				[
					12028,
					-5559
				],
				[
					-20824,
					-5722
				],
				[
					-6683,
					-43783
				],
				[
					-10799,
					-5362
				],
				[
					-13822,
					-29898
				],
				[
					1750,
					-9682
				],
				[
					-11052,
					-16554
				],
				[
					-3349,
					-22588
				],
				[
					-16843,
					-16753
				],
				[
					6576,
					-16712
				],
				[
					-12098,
					-51277
				],
				[
					5367,
					-18792
				],
				[
					-7127,
					-5844
				],
				[
					-6002,
					-19833
				]
			],
			[
				[
					4413875,
					5037157
				],
				[
					0,
					392374
				]
			],
			[
				[
					553894,
					6626199
				],
				[
					14295,
					-10424
				],
				[
					-18894,
					3878
				],
				[
					4599,
					6546
				]
			],
			[
				[
					813009,
					6731857
				],
				[
					-20779,
					-5082
				],
				[
					10022,
					9783
				],
				[
					10757,
					-4701
				]
			],
			[
				[
					1167649,
					6740937
				],
				[
					4018,
					-12398
				],
				[
					-10339,
					-9752
				],
				[
					-1709,
					22388
				],
				[
					8030,
					-238
				]
			],
			[
				[
					633272,
					6744204
				],
				[
					-7113,
					-16192
				],
				[
					-12725,
					1881
				],
				[
					19838,
					14311
				]
			],
			[
				[
					3155113,
					6910171
				],
				[
					24664,
					-8405
				],
				[
					-29796,
					2265
				],
				[
					5132,
					6140
				]
			],
			[
				[
					3262255,
					6918851
				],
				[
					44130,
					-14814
				],
				[
					-15331,
					-4562
				],
				[
					-43783,
					16696
				],
				[
					14984,
					2680
				]
			],
			[
				[
					2761813,
					6969396
				],
				[
					33717,
					-10009
				],
				[
					-3774,
					-3195
				],
				[
					-39119,
					5153
				],
				[
					9176,
					8051
				]
			],
			[
				[
					1020159,
					5541440
				],
				[
					-40381,
					31410
				],
				[
					-21387,
					-3117
				],
				[
					-9234,
					14338
				],
				[
					18706,
					17341
				],
				[
					-3170,
					14675
				],
				[
					8612,
					5302
				],
				[
					8833,
					18415
				],
				[
					-23376,
					7040
				],
				[
					3779,
					20169
				],
				[
					-16671,
					-7889
				],
				[
					-13124,
					10188
				],
				[
					13090,
					22938
				],
				[
					10247,
					1427
				],
				[
					3312,
					16022
				],
				[
					29613,
					25869
				],
				[
					-904,
					10338
				],
				[
					13014,
					24575
				],
				[
					-14739,
					20151
				],
				[
					-1680,
					13001
				],
				[
					-32003,
					28187
				],
				[
					7410,
					11867
				],
				[
					20446,
					11198
				],
				[
					-3141,
					8859
				],
				[
					-13196,
					-4114
				],
				[
					-8340,
					12276
				],
				[
					-9992,
					-1699
				],
				[
					-28578,
					-31792
				],
				[
					-12700,
					8388
				],
				[
					11351,
					24511
				],
				[
					-23408,
					2537
				],
				[
					-31349,
					-22213
				],
				[
					-28636,
					5023
				],
				[
					6761,
					23360
				],
				[
					-9355,
					634
				],
				[
					2647,
					15116
				],
				[
					12324,
					11623
				],
				[
					-522,
					20992
				],
				[
					-8224,
					10037
				],
				[
					-23665,
					4487
				],
				[
					11452,
					29705
				],
				[
					14068,
					-1035
				],
				[
					-9075,
					22154
				],
				[
					12182,
					8286
				],
				[
					-23869,
					21033
				],
				[
					5124,
					7121
				],
				[
					-11116,
					10574
				],
				[
					9804,
					18872
				],
				[
					-20772,
					25145
				],
				[
					-19747,
					12461
				],
				[
					32604,
					10392
				],
				[
					-153607,
					0
				],
				[
					-110512,
					0
				],
				[
					-7996,
					41623
				],
				[
					16803,
					30917
				],
				[
					-15328,
					25273
				],
				[
					5898,
					23730
				],
				[
					-13572,
					31454
				],
				[
					-17973,
					3676
				],
				[
					-1083,
					39427
				],
				[
					-1160,
					254702
				]
			],
			[
				[
					514654,
					6558420
				],
				[
					-1,
					553
				]
			],
			[
				[
					514653,
					6558973
				],
				[
					-5,
					2311
				]
			],
			[
				[
					514648,
					6561284
				],
				[
					-3,
					1590
				]
			],
			[
				[
					514645,
					6562874
				],
				[
					-1,
					448
				]
			],
			[
				[
					514644,
					6563322
				],
				[
					-2,
					957
				]
			],
			[
				[
					514642,
					6564279
				],
				[
					10,
					303
				]
			],
			[
				[
					514652,
					6564582
				],
				[
					38344,
					-4228
				],
				[
					10697,
					16865
				],
				[
					-9529,
					12973
				],
				[
					10097,
					2597
				],
				[
					10277,
					15853
				],
				[
					-4728,
					31881
				],
				[
					14422,
					21020
				],
				[
					33741,
					9858
				],
				[
					25734,
					-11634
				],
				[
					-9164,
					15154
				],
				[
					11809,
					17292
				],
				[
					28756,
					11707
				],
				[
					26595,
					2706
				],
				[
					31508,
					-12492
				],
				[
					14113,
					10920
				],
				[
					-9196,
					11649
				],
				[
					7894,
					24298
				],
				[
					-4893,
					15986
				],
				[
					12411,
					683
				],
				[
					-987,
					-11040
				],
				[
					15498,
					2243
				],
				[
					-2519,
					-19380
				],
				[
					12638,
					-14234
				],
				[
					16830,
					4719
				],
				[
					13687,
					-9967
				],
				[
					8386,
					18896
				],
				[
					1512,
					-21232
				],
				[
					-8274,
					-14522
				],
				[
					20292,
					-12800
				],
				[
					18496,
					5315
				],
				[
					44437,
					-495
				],
				[
					17955,
					12041
				],
				[
					-1822,
					30216
				],
				[
					6998,
					18135
				],
				[
					39531,
					-5937
				],
				[
					24871,
					9083
				],
				[
					-10842,
					4738
				],
				[
					-23787,
					-5277
				],
				[
					16937,
					20230
				],
				[
					22886,
					-2957
				],
				[
					19257,
					-12107
				],
				[
					-1436,
					8579
				],
				[
					16481,
					-2702
				],
				[
					6916,
					16812
				],
				[
					12843,
					148
				],
				[
					22018,
					23306
				],
				[
					22022,
					5516
				],
				[
					2224,
					14715
				],
				[
					15515,
					-4559
				],
				[
					18256,
					-14528
				],
				[
					18567,
					45518
				],
				[
					11941,
					6606
				],
				[
					11042,
					-6385
				],
				[
					11981,
					14769
				],
				[
					26651,
					-1799
				],
				[
					7269,
					-10468
				],
				[
					23553,
					871
				],
				[
					13378,
					-8028
				],
				[
					15487,
					5006
				],
				[
					4050,
					20020
				],
				[
					12676,
					23317
				],
				[
					27136,
					-23752
				],
				[
					3853,
					-14115
				],
				[
					9528,
					3651
				],
				[
					-12872,
					-22271
				],
				[
					-51328,
					-24458
				],
				[
					-15068,
					-10941
				],
				[
					-31004,
					-10513
				],
				[
					-28747,
					-21154
				],
				[
					-896,
					-11153
				],
				[
					-17720,
					-5076
				],
				[
					-19902,
					-30127
				],
				[
					-12387,
					19744
				],
				[
					-33707,
					-15009
				],
				[
					-33775,
					1196
				],
				[
					-2855,
					-11749
				],
				[
					-12119,
					9454
				],
				[
					-29775,
					-12111
				],
				[
					-7735,
					-13668
				],
				[
					3793,
					-16289
				],
				[
					-37962,
					-19212
				],
				[
					-2705,
					-18026
				],
				[
					-17633,
					11690
				],
				[
					-31744,
					-21162
				],
				[
					-7079,
					-28441
				],
				[
					-10816,
					-9472
				],
				[
					-19546,
					505
				],
				[
					-11066,
					-17096
				],
				[
					8611,
					-239
				],
				[
					-2775,
					-15542
				],
				[
					-11345,
					-9649
				],
				[
					-15358,
					6952
				],
				[
					-1068,
					-20923
				],
				[
					36246,
					-21526
				],
				[
					-12152,
					19941
				],
				[
					-13777,
					7866
				],
				[
					14002,
					7145
				],
				[
					14079,
					-9883
				],
				[
					18714,
					-920
				],
				[
					11867,
					8117
				],
				[
					7781,
					-9535
				],
				[
					10200,
					4642
				],
				[
					28625,
					-6693
				],
				[
					8133,
					11995
				],
				[
					-13548,
					12996
				],
				[
					-17228,
					-17049
				],
				[
					-10108,
					378
				],
				[
					-13315,
					52761
				],
				[
					43589,
					16994
				],
				[
					3283,
					23390
				],
				[
					10855,
					-19300
				],
				[
					2313,
					18590
				],
				[
					7856,
					-8019
				],
				[
					16233,
					11739
				],
				[
					15460,
					1614
				],
				[
					24199,
					18944
				],
				[
					2647,
					13283
				],
				[
					-19205,
					6207
				],
				[
					32478,
					2525
				],
				[
					22295,
					7358
				],
				[
					-6337,
					-13011
				],
				[
					9684,
					-6857
				],
				[
					2569,
					16457
				],
				[
					-8113,
					9785
				],
				[
					19492,
					8440
				],
				[
					9807,
					-9245
				],
				[
					3819,
					-21740
				],
				[
					4758,
					32874
				],
				[
					-6387,
					22528
				],
				[
					18562,
					-26311
				],
				[
					-1984,
					-27162
				],
				[
					7464,
					16748
				],
				[
					8726,
					-5660
				],
				[
					-3246,
					23527
				],
				[
					9546,
					-2949
				],
				[
					4032,
					-20394
				],
				[
					16136,
					8441
				],
				[
					23826,
					26306
				],
				[
					12742,
					28327
				],
				[
					28323,
					4306
				],
				[
					43530,
					17456
				],
				[
					13448,
					9455
				],
				[
					58801,
					12021
				],
				[
					17825,
					22937
				],
				[
					-4978,
					-30540
				],
				[
					-17287,
					4321
				],
				[
					-3751,
					-38980
				],
				[
					10674,
					8892
				],
				[
					28134,
					7855
				],
				[
					21392,
					27328
				],
				[
					32198,
					17204
				],
				[
					2087,
					15846
				],
				[
					-9828,
					13928
				],
				[
					4851,
					13542
				],
				[
					24522,
					11009
				],
				[
					36099,
					4265
				],
				[
					32589,
					10313
				],
				[
					-31863,
					4246
				],
				[
					-27879,
					8831
				],
				[
					-17439,
					21835
				],
				[
					5949,
					30644
				],
				[
					17555,
					17065
				],
				[
					57060,
					-38739
				],
				[
					15589,
					-14309
				],
				[
					32427,
					-43347
				],
				[
					26912,
					-60367
				],
				[
					12295,
					-38493
				],
				[
					50920,
					-57999
				],
				[
					39906,
					-30948
				],
				[
					36846,
					-5304
				],
				[
					15189,
					-13937
				],
				[
					13503,
					11059
				],
				[
					-4872,
					7288
				],
				[
					23277,
					-3373
				],
				[
					1696,
					15694
				],
				[
					-30520,
					4549
				],
				[
					-23492,
					-8380
				],
				[
					6290,
					13346
				],
				[
					14406,
					8818
				],
				[
					36586,
					-9123
				],
				[
					-17173,
					10948
				],
				[
					4305,
					16525
				],
				[
					-17905,
					219
				],
				[
					2604,
					20381
				],
				[
					19063,
					1541
				],
				[
					13691,
					14888
				],
				[
					14496,
					-3148
				],
				[
					5239,
					-19923
				],
				[
					14508,
					14671
				],
				[
					-41828,
					13810
				],
				[
					-9282,
					-2447
				],
				[
					-6382,
					13310
				],
				[
					6610,
					8003
				],
				[
					7337,
					-14113
				],
				[
					16463,
					5514
				],
				[
					13835,
					31430
				],
				[
					30236,
					8703
				],
				[
					-24541,
					339
				],
				[
					-5831,
					8603
				],
				[
					-31857,
					-12746
				],
				[
					-1085,
					13629
				],
				[
					25350,
					12661
				],
				[
					-178,
					-14052
				],
				[
					14407,
					12237
				],
				[
					26231,
					1769
				],
				[
					6348,
					-15192
				],
				[
					14102,
					16389
				],
				[
					-14874,
					-2852
				],
				[
					1826,
					10386
				],
				[
					-15777,
					-5713
				],
				[
					-5595,
					20604
				],
				[
					8972,
					6232
				],
				[
					17996,
					-3562
				],
				[
					-19618,
					-8657
				],
				[
					35241,
					-3644
				],
				[
					-1824,
					-26786
				],
				[
					-13093,
					-4231
				],
				[
					10436,
					-16113
				],
				[
					-11679,
					-49167
				],
				[
					28875,
					-6242
				],
				[
					21024,
					4361
				],
				[
					3729,
					-9681
				],
				[
					-17464,
					-10797
				],
				[
					-6655,
					-18347
				],
				[
					-22678,
					-20034
				],
				[
					2464,
					-15460
				],
				[
					-8117,
					-10202
				],
				[
					17477,
					-7469
				],
				[
					37952,
					-3047
				],
				[
					312,
					16319
				],
				[
					33189,
					-12980
				],
				[
					28391,
					10733
				],
				[
					2270,
					14728
				],
				[
					14715,
					12585
				],
				[
					17122,
					1173
				],
				[
					492,
					25028
				],
				[
					8139,
					16667
				],
				[
					-6797,
					22724
				],
				[
					21772,
					14647
				],
				[
					14107,
					-8751
				],
				[
					55481,
					7851
				],
				[
					21806,
					-7464
				],
				[
					8067,
					4924
				],
				[
					38347,
					-2782
				],
				[
					23348,
					-8653
				],
				[
					13328,
					1419
				],
				[
					15069,
					-11658
				],
				[
					39120,
					-14998
				],
				[
					23506,
					-21244
				]
			],
			[
				[
					2840350,
					6972342
				],
				[
					5370,
					-9458
				],
				[
					-22186,
					-769
				],
				[
					16816,
					10227
				]
			],
			[
				[
					2696388,
					6974198
				],
				[
					6721,
					-6787
				],
				[
					28377,
					-4227
				],
				[
					-43085,
					-735
				],
				[
					7987,
					11749
				]
			],
			[
				[
					1458923,
					6977651
				],
				[
					-1999,
					-13080
				],
				[
					-23861,
					-4150
				],
				[
					11178,
					25899
				],
				[
					14682,
					-8669
				]
			],
			[
				[
					3526398,
					7423606
				],
				[
					-44338,
					26775
				],
				[
					20466,
					-3087
				],
				[
					23920,
					-16493
				]
			],
			[
				[
					3526718,
					7482656
				],
				[
					2,
					690
				]
			],
			[
				[
					3526724,
					7484436
				],
				[
					3,
					739
				]
			],
			[
				[
					3526730,
					7486122
				],
				[
					1,
					490
				]
			],
			[
				[
					3526531,
					7443685
				],
				[
					-22089,
					26256
				],
				[
					-22169,
					-1358
				],
				[
					10618,
					8812
				],
				[
					-7704,
					8846
				],
				[
					15078,
					3949
				],
				[
					26425,
					-15784
				]
			],
			[
				[
					3526739,
					7488870
				],
				[
					-33595,
					10570
				],
				[
					-11053,
					14613
				],
				[
					-24753,
					1558
				],
				[
					-25614,
					21265
				],
				[
					-3870,
					15083
				],
				[
					36611,
					6082
				],
				[
					62050,
					-13862
				],
				[
					390,
					-7179
				]
			],
			[
				[
					2718928,
					6755871
				],
				[
					-23421,
					13800
				],
				[
					-11607,
					20946
				],
				[
					-10951,
					36879
				],
				[
					2999,
					13246
				],
				[
					43040,
					19838
				],
				[
					117913,
					26881
				],
				[
					115183,
					13099
				],
				[
					70006,
					9875
				],
				[
					45328,
					-11693
				],
				[
					31435,
					-2535
				],
				[
					42010,
					3458
				],
				[
					29623,
					-11267
				],
				[
					22936,
					-176
				],
				[
					29137,
					-8800
				],
				[
					4166,
					11302
				],
				[
					38943,
					9177
				],
				[
					31148,
					-4594
				],
				[
					24588,
					4100
				],
				[
					24189,
					11529
				],
				[
					-4321,
					5973
				],
				[
					-41595,
					2743
				],
				[
					-13859,
					4307
				],
				[
					-22247,
					31332
				],
				[
					-42017,
					3669
				],
				[
					-11007,
					8017
				],
				[
					-47616,
					9240
				],
				[
					-13480,
					13042
				],
				[
					-43438,
					-1541
				],
				[
					-18985,
					12437
				],
				[
					-26624,
					5027
				],
				[
					-24290,
					-11199
				],
				[
					-27166,
					1519
				],
				[
					-7559,
					-7800
				],
				[
					-29583,
					-6577
				],
				[
					-4760,
					4143
				],
				[
					-26271,
					-8735
				],
				[
					-78031,
					1151
				],
				[
					-34243,
					-4977
				],
				[
					-18811,
					2229
				],
				[
					8185,
					9651
				],
				[
					-47179,
					529
				],
				[
					-22851,
					-7874
				],
				[
					-49042,
					3657
				],
				[
					-28898,
					-8656
				],
				[
					-33339,
					16607
				],
				[
					5910,
					13591
				],
				[
					-44792,
					22258
				],
				[
					-16804,
					12552
				],
				[
					-24374,
					30169
				],
				[
					6018,
					12901
				],
				[
					62382,
					32641
				],
				[
					29019,
					3910
				],
				[
					111961,
					23582
				],
				[
					4674,
					-11405
				],
				[
					-28915,
					-4980
				],
				[
					26435,
					-5439
				],
				[
					16273,
					-19553
				],
				[
					12968,
					5517
				],
				[
					-26917,
					11039
				],
				[
					7512,
					4590
				],
				[
					-11923,
					20434
				],
				[
					-28227,
					-3280
				],
				[
					7112,
					7482
				],
				[
					58468,
					17078
				],
				[
					10617,
					-4291
				],
				[
					45936,
					4452
				],
				[
					3299,
					6144
				],
				[
					-55377,
					9342
				],
				[
					68716,
					18135
				],
				[
					19417,
					-12420
				],
				[
					32072,
					10321
				],
				[
					-21638,
					-1781
				],
				[
					-23569,
					6467
				],
				[
					12383,
					5339
				],
				[
					-21916,
					5130
				],
				[
					-63217,
					-15290
				],
				[
					-13528,
					1997
				],
				[
					-44130,
					-9276
				],
				[
					-14436,
					-7832
				],
				[
					-24346,
					557
				],
				[
					-41741,
					-11875
				],
				[
					116,
					18526
				],
				[
					-27200,
					2413
				],
				[
					18416,
					-9743
				],
				[
					-4673,
					-13283
				],
				[
					-27462,
					4029
				],
				[
					-26434,
					-5294
				],
				[
					-27798,
					4193
				],
				[
					-7647,
					19042
				],
				[
					29617,
					19064
				],
				[
					27496,
					-4602
				],
				[
					14808,
					7361
				],
				[
					-23685,
					13078
				],
				[
					13446,
					11820
				],
				[
					-31628,
					2740
				],
				[
					-14022,
					-17367
				],
				[
					-25128,
					-2806
				],
				[
					-885,
					9048
				],
				[
					-18969,
					8164
				],
				[
					-30786,
					258
				],
				[
					-7583,
					-17507
				],
				[
					-19390,
					17152
				],
				[
					-4530,
					44651
				],
				[
					7197,
					16630
				],
				[
					21048,
					23512
				],
				[
					15759,
					8836
				],
				[
					23419,
					33032
				],
				[
					49581,
					13620
				],
				[
					-1695,
					18897
				],
				[
					-11345,
					7584
				],
				[
					-31259,
					1196
				],
				[
					-8562,
					8977
				],
				[
					5859,
					25957
				],
				[
					37708,
					32483
				],
				[
					28311,
					11783
				],
				[
					39868,
					27699
				],
				[
					27382,
					28979
				],
				[
					56918,
					13666
				],
				[
					30420,
					18193
				],
				[
					52901,
					15853
				],
				[
					37825,
					14603
				],
				[
					36101,
					9375
				],
				[
					73235,
					28245
				],
				[
					8423,
					7997
				],
				[
					21788,
					1125
				],
				[
					34504,
					-12257
				],
				[
					30043,
					-39959
				],
				[
					-500,
					-31658
				],
				[
					-7678,
					-5337
				],
				[
					196,
					-33656
				],
				[
					8589,
					-10802
				],
				[
					-27451,
					-4031
				],
				[
					-19767,
					-15309
				],
				[
					9008,
					-11403
				],
				[
					-19443,
					-15825
				],
				[
					-16672,
					-4942
				],
				[
					27812,
					-11470
				],
				[
					33906,
					22755
				],
				[
					21895,
					-3456
				],
				[
					39032,
					11214
				],
				[
					-23492,
					-12736
				],
				[
					34117,
					10474
				],
				[
					-45,
					16426
				],
				[
					-20090,
					2208
				],
				[
					24002,
					38876
				],
				[
					16560,
					16938
				],
				[
					26573,
					5572
				],
				[
					62265,
					-16252
				],
				[
					12289,
					-8162
				],
				[
					34998,
					-4139
				],
				[
					39205,
					-18784
				],
				[
					30349,
					-9925
				],
				[
					-746,
					-8091
				],
				[
					26531,
					-3213
				],
				[
					420,
					-24266
				],
				[
					-9378,
					-16349
				],
				[
					-17898,
					-11411
				],
				[
					-6076,
					-15163
				],
				[
					-35149,
					-13314
				],
				[
					-30583,
					-22481
				],
				[
					20010,
					8620
				],
				[
					33478,
					-913
				],
				[
					-17604,
					-5426
				],
				[
					8700,
					-6490
				],
				[
					23218,
					8244
				],
				[
					-14893,
					11703
				],
				[
					41500,
					25220
				],
				[
					-5389,
					-18989
				],
				[
					22205,
					-13397
				],
				[
					16,
					14301
				],
				[
					15836,
					22472
				],
				[
					27729,
					21021
				],
				[
					32581,
					-13960
				],
				[
					3485,
					9908
				],
				[
					38836,
					-28691
				],
				[
					11253,
					8488
				],
				[
					9242,
					-7786
				]
			],
			[
				[
					1906328,
					7701426
				],
				[
					8767,
					-7708
				],
				[
					-26301,
					-2959
				],
				[
					-565,
					17101
				],
				[
					18099,
					-6434
				]
			],
			[
				[
					2208907,
					7930731
				],
				[
					43700,
					-8254
				],
				[
					23098,
					-22135
				],
				[
					88011,
					-37281
				],
				[
					51649,
					-8146
				],
				[
					4164,
					-10659
				],
				[
					-11530,
					-15413
				],
				[
					13408,
					772
				],
				[
					18461,
					22158
				],
				[
					34704,
					-2159
				],
				[
					11405,
					-24993
				],
				[
					-12022,
					-29007
				],
				[
					21809,
					2564
				],
				[
					20477,
					29253
				],
				[
					-12260,
					10304
				],
				[
					11776,
					8708
				],
				[
					71215,
					17697
				],
				[
					26775,
					-1730
				],
				[
					57043,
					-10556
				],
				[
					21559,
					-9980
				],
				[
					64252,
					-42452
				],
				[
					35609,
					-29567
				],
				[
					65002,
					-49501
				],
				[
					50433,
					-36335
				],
				[
					586,
					-14785
				],
				[
					-55365,
					-31668
				],
				[
					-75919,
					-20445
				],
				[
					-29948,
					-17618
				],
				[
					-53341,
					-23473
				],
				[
					-28032,
					-8726
				],
				[
					-63024,
					-39483
				],
				[
					-27243,
					-7963
				],
				[
					-30950,
					-23242
				],
				[
					-22824,
					-3320
				],
				[
					-48828,
					-29982
				],
				[
					834,
					-16757
				],
				[
					-9122,
					-9048
				],
				[
					-6111,
					-35337
				],
				[
					-40521,
					-19759
				],
				[
					-15150,
					-13897
				],
				[
					-38115,
					2871
				],
				[
					-10989,
					10315
				],
				[
					9985,
					-28010
				],
				[
					-4521,
					-17756
				],
				[
					-32122,
					-35376
				],
				[
					6930,
					-19541
				],
				[
					-6455,
					-30454
				],
				[
					8298,
					-10007
				],
				[
					-10891,
					-31129
				],
				[
					-19927,
					-18183
				],
				[
					-76522,
					-26385
				],
				[
					-27896,
					5921
				],
				[
					-3036,
					15928
				],
				[
					-21913,
					7618
				],
				[
					-25959,
					-46487
				],
				[
					-18735,
					-12009
				],
				[
					-31455,
					-10332
				],
				[
					-20792,
					-12827
				],
				[
					-16465,
					-19404
				],
				[
					-40229,
					-1218
				],
				[
					-32562,
					34234
				],
				[
					-21110,
					64632
				],
				[
					-21436,
					10094
				],
				[
					-18386,
					33061
				],
				[
					-24913,
					16123
				],
				[
					-46021,
					13311
				],
				[
					-62150,
					31799
				],
				[
					-16241,
					14907
				],
				[
					-56918,
					-6917
				],
				[
					11589,
					33280
				],
				[
					-10529,
					8455
				],
				[
					16851,
					13610
				],
				[
					-4380,
					12997
				],
				[
					19326,
					7396
				],
				[
					1165,
					18108
				],
				[
					19796,
					18150
				],
				[
					-1107,
					15173
				],
				[
					46333,
					20952
				],
				[
					-15241,
					11440
				],
				[
					10868,
					15409
				],
				[
					427,
					17108
				],
				[
					-9868,
					21692
				],
				[
					57323,
					17155
				],
				[
					9730,
					8149
				],
				[
					-22726,
					18593
				],
				[
					-11616,
					-366
				],
				[
					-13150,
					14756
				],
				[
					11470,
					19173
				],
				[
					25511,
					21394
				],
				[
					-1392,
					8554
				],
				[
					27587,
					48160
				],
				[
					25443,
					9505
				],
				[
					2565,
					33497
				],
				[
					25290,
					10609
				],
				[
					9841,
					14502
				],
				[
					-11034,
					17274
				],
				[
					-38464,
					8959
				],
				[
					1098,
					14560
				],
				[
					-16734,
					13530
				],
				[
					-16338,
					28423
				],
				[
					8053,
					6924
				],
				[
					-18649,
					33480
				],
				[
					-23395,
					15013
				],
				[
					18777,
					5507
				],
				[
					155734,
					20305
				],
				[
					80705,
					3532
				],
				[
					40453,
					6154
				],
				[
					47602,
					14705
				],
				[
					27852,
					1619
				]
			],
			[
				[
					2093991,
					8261757
				],
				[
					17903,
					-1266
				],
				[
					3513,
					-14601
				],
				[
					-37856,
					10417
				],
				[
					16440,
					5450
				]
			],
			[
				[
					3527780,
					8262863
				],
				[
					64,
					-16551
				]
			],
			[
				[
					3527844,
					8246312
				],
				[
					-22844,
					7747
				],
				[
					22780,
					8804
				]
			],
			[
				[
					2273166,
					8265288
				],
				[
					6575,
					-20127
				],
				[
					-21364,
					-31321
				],
				[
					-25297,
					4935
				],
				[
					27540,
					14794
				],
				[
					3914,
					30978
				],
				[
					8632,
					741
				]
			],
			[
				[
					2063471,
					8294690
				],
				[
					20239,
					-3462
				],
				[
					-37006,
					-11721
				],
				[
					-12154,
					7277
				],
				[
					28921,
					7906
				]
			],
			[
				[
					2641891,
					8309435
				],
				[
					25384,
					-7655
				],
				[
					-12012,
					-25662
				],
				[
					-19665,
					-16048
				],
				[
					-25516,
					-35036
				],
				[
					2870,
					-9694
				],
				[
					-24898,
					-16929
				],
				[
					-24261,
					-26988
				],
				[
					-25330,
					-12811
				],
				[
					-40812,
					18244
				],
				[
					-28468,
					-1316
				],
				[
					-24663,
					9515
				],
				[
					10999,
					12787
				],
				[
					41538,
					25364
				],
				[
					25325,
					28290
				],
				[
					44217,
					21855
				],
				[
					20152,
					-704
				],
				[
					5004,
					11717
				],
				[
					20122,
					5910
				],
				[
					30014,
					19161
				]
			],
			[
				[
					3527512,
					8401123
				],
				[
					95,
					-63134
				]
			],
			[
				[
					3527607,
					8337989
				],
				[
					-8540,
					-10680
				],
				[
					-17509,
					15121
				],
				[
					-32175,
					12296
				],
				[
					-4725,
					27631
				],
				[
					31564,
					4967
				],
				[
					31290,
					13799
				]
			],
			[
				[
					3527964,
					8166466
				],
				[
					87,
					-159120
				]
			],
			[
				[
					3528051,
					8007346
				],
				[
					-21643,
					-11867
				],
				[
					-28420,
					6215
				],
				[
					-14879,
					-11517
				],
				[
					-27526,
					-7327
				],
				[
					10589,
					-13800
				],
				[
					-80837,
					-35462
				],
				[
					-12200,
					650
				],
				[
					-33969,
					-17573
				],
				[
					-79826,
					-18650
				],
				[
					-59572,
					-4785
				],
				[
					-59670,
					4732
				],
				[
					-29845,
					7994
				],
				[
					-62595,
					33427
				],
				[
					-20949,
					24562
				],
				[
					40162,
					21978
				],
				[
					39075,
					10207
				],
				[
					33988,
					3253
				],
				[
					33895,
					15819
				],
				[
					2739,
					7754
				],
				[
					30611,
					10424
				],
				[
					84548,
					6411
				],
				[
					47144,
					-4171
				],
				[
					44393,
					24218
				],
				[
					3030,
					8799
				],
				[
					27782,
					12975
				],
				[
					12627,
					16267
				],
				[
					-38668,
					2183
				],
				[
					-6100,
					-14371
				],
				[
					-28862,
					-13635
				],
				[
					-18790,
					10958
				],
				[
					-19199,
					-12016
				],
				[
					-57515,
					-2471
				],
				[
					-2469,
					13540
				],
				[
					-21801,
					4850
				],
				[
					-7996,
					14160
				],
				[
					-2806,
					-29398
				],
				[
					-17814,
					-8068
				],
				[
					-116128,
					-13304
				],
				[
					-2509,
					22384
				],
				[
					29919,
					9259
				],
				[
					-29843,
					499
				],
				[
					13951,
					34616
				],
				[
					39589,
					17939
				],
				[
					2180,
					9062
				],
				[
					-49792,
					-15865
				],
				[
					-18956,
					24014
				],
				[
					-219,
					-31220
				],
				[
					-16256,
					-30444
				],
				[
					-20790,
					15893
				],
				[
					-21858,
					6510
				],
				[
					-6693,
					-7406
				],
				[
					22318,
					-3451
				],
				[
					14728,
					-26027
				],
				[
					-18844,
					-23428
				],
				[
					-65921,
					-23999
				],
				[
					-16045,
					7837
				],
				[
					-2337,
					43416
				],
				[
					-21864,
					-18504
				],
				[
					-26710,
					11807
				],
				[
					11052,
					-22665
				],
				[
					-17822,
					-20295
				],
				[
					-63443,
					22120
				],
				[
					18837,
					8763
				],
				[
					-23291,
					1290
				],
				[
					4247,
					27273
				],
				[
					-37859,
					-12563
				],
				[
					-12266,
					-11085
				],
				[
					-72571,
					14238
				],
				[
					-37779,
					18149
				],
				[
					11261,
					22515
				],
				[
					28545,
					27163
				],
				[
					17403,
					6016
				],
				[
					126675,
					854
				],
				[
					45876,
					22413
				],
				[
					38360,
					11583
				],
				[
					18127,
					18772
				],
				[
					-32778,
					-11654
				],
				[
					-111878,
					-22389
				],
				[
					-90472,
					3803
				],
				[
					6940,
					21679
				],
				[
					27334,
					28283
				],
				[
					11455,
					4061
				],
				[
					83864,
					1660
				],
				[
					46993,
					7990
				],
				[
					75853,
					4347
				],
				[
					18992,
					11672
				],
				[
					-46443,
					-5907
				],
				[
					-60850,
					2137
				],
				[
					-30342,
					-5412
				],
				[
					-43782,
					667
				],
				[
					-34643,
					6156
				],
				[
					2780,
					15775
				],
				[
					28339,
					9012
				],
				[
					-25796,
					11792
				],
				[
					20358,
					23846
				],
				[
					49648,
					13054
				],
				[
					36818,
					-3505
				],
				[
					55275,
					648
				],
				[
					31663,
					-7819
				],
				[
					-7171,
					12577
				],
				[
					-30442,
					5528
				],
				[
					-40176,
					272
				],
				[
					-23758,
					5048
				],
				[
					-1642,
					24537
				],
				[
					43114,
					23821
				],
				[
					14813,
					-1153
				],
				[
					106670,
					14397
				],
				[
					28146,
					-8620
				],
				[
					12907,
					-14754
				],
				[
					-13709,
					-17248
				],
				[
					15730,
					-29387
				],
				[
					13998,
					-7212
				],
				[
					25272,
					2471
				],
				[
					52360,
					16134
				],
				[
					44711,
					-3896
				],
				[
					10368,
					-12488
				],
				[
					38809,
					-5537
				],
				[
					-11755,
					-17467
				],
				[
					11585,
					-15028
				],
				[
					43943,
					-8899
				],
				[
					28647,
					-13402
				],
				[
					3425,
					-12113
				],
				[
					-48869,
					-11084
				],
				[
					27420,
					-11990
				],
				[
					34375,
					4300
				],
				[
					25412,
					-13204
				],
				[
					8615,
					-13218
				],
				[
					-9696,
					-23994
				],
				[
					20932,
					-23705
				],
				[
					26849,
					3079
				],
				[
					26038,
					10700
				],
				[
					34613,
					493
				],
				[
					7179,
					-7504
				],
				[
					61968,
					-2624
				]
			],
			[
				[
					2275523,
					8463114
				],
				[
					5308,
					-7933
				],
				[
					-30410,
					-1245
				],
				[
					25102,
					9178
				]
			],
			[
				[
					3055180,
					8494363
				],
				[
					30785,
					-898
				],
				[
					31397,
					-14362
				],
				[
					2398,
					-11144
				],
				[
					-17826,
					-16661
				],
				[
					-32856,
					2974
				],
				[
					-18404,
					-6381
				],
				[
					-85666,
					13844
				],
				[
					-561,
					14796
				],
				[
					17550,
					10371
				],
				[
					73183,
					7461
				]
			],
			[
				[
					3080553,
					8558488
				],
				[
					18191,
					-6356
				],
				[
					-25008,
					-6706
				],
				[
					6817,
					13062
				]
			],
			[
				[
					2786204,
					8654830
				],
				[
					41342,
					-15299
				],
				[
					-10343,
					-5089
				],
				[
					33341,
					-7833
				],
				[
					38347,
					-18674
				],
				[
					-4415,
					-22788
				],
				[
					-29517,
					-3302
				],
				[
					-49155,
					-21220
				],
				[
					-18488,
					-3320
				],
				[
					15622,
					-26464
				],
				[
					59536,
					-23741
				],
				[
					-23859,
					-11300
				],
				[
					-36944,
					11904
				],
				[
					-12686,
					-3554
				],
				[
					20559,
					-20038
				],
				[
					21907,
					-5291
				],
				[
					13281,
					-31263
				],
				[
					-19735,
					-17798
				],
				[
					-50017,
					-13747
				],
				[
					-31335,
					1160
				],
				[
					-30534,
					-7233
				],
				[
					10990,
					-47514
				],
				[
					-40946,
					-20843
				],
				[
					-56177,
					14972
				],
				[
					-28594,
					21750
				],
				[
					3276,
					17944
				],
				[
					13324,
					10895
				],
				[
					-2766,
					36651
				],
				[
					15885,
					8290
				],
				[
					6002,
					17600
				],
				[
					-10903,
					8925
				],
				[
					-18155,
					-17128
				],
				[
					-36028,
					4510
				],
				[
					-15828,
					-23984
				],
				[
					14977,
					-6571
				],
				[
					913,
					-22787
				],
				[
					-29966,
					-13257
				],
				[
					-28036,
					14952
				],
				[
					-13627,
					-18486
				],
				[
					31339,
					-7080
				],
				[
					15004,
					-29142
				],
				[
					-16577,
					-12540
				],
				[
					-29962,
					-2866
				],
				[
					9895,
					-23161
				],
				[
					-20810,
					-20270
				],
				[
					-27732,
					10367
				],
				[
					-21849,
					37110
				],
				[
					-2611,
					16486
				],
				[
					-22320,
					-19783
				],
				[
					15776,
					-17067
				],
				[
					-14996,
					-9028
				],
				[
					14911,
					-12704
				],
				[
					-28832,
					-621
				],
				[
					36143,
					-14060
				],
				[
					-27503,
					-30965
				],
				[
					1170,
					-9489
				],
				[
					-39901,
					-7257
				],
				[
					-9555,
					13490
				],
				[
					-13533,
					-23396
				],
				[
					-21470,
					5200
				],
				[
					3723,
					42236
				],
				[
					-15691,
					-6638
				],
				[
					-15549,
					12340
				],
				[
					-1320,
					22692
				],
				[
					9471,
					7587
				],
				[
					-24333,
					12533
				],
				[
					-18779,
					-15952
				],
				[
					7181,
					-36542
				],
				[
					-31196,
					-3946
				],
				[
					-6678,
					-16202
				],
				[
					-22833,
					21290
				],
				[
					-35012,
					11412
				],
				[
					-32380,
					-230
				],
				[
					-5513,
					-14571
				],
				[
					-26485,
					-13480
				],
				[
					-39218,
					11494
				],
				[
					30712,
					31309
				],
				[
					-15643,
					17711
				],
				[
					-46104,
					-22772
				],
				[
					7246,
					26211
				],
				[
					35890,
					19714
				],
				[
					-1163,
					17074
				],
				[
					35139,
					16318
				],
				[
					36334,
					8011
				],
				[
					54074,
					-1374
				],
				[
					15494,
					19296
				],
				[
					-4089,
					10057
				],
				[
					26215,
					16112
				],
				[
					-1945,
					15034
				],
				[
					14377,
					-3576
				],
				[
					32997,
					16926
				],
				[
					23782,
					1293
				],
				[
					25908,
					16197
				],
				[
					-6469,
					16791
				],
				[
					19967,
					2824
				],
				[
					13967,
					22649
				],
				[
					35162,
					18831
				],
				[
					-678,
					7481
				],
				[
					49340,
					20566
				],
				[
					16144,
					29336
				],
				[
					34153,
					2973
				],
				[
					10593,
					8101
				],
				[
					80513,
					265
				],
				[
					3598,
					5419
				],
				[
					37972,
					-2765
				],
				[
					15487,
					-8891
				],
				[
					43162,
					-9989
				],
				[
					29473,
					4359
				],
				[
					-19485,
					13939
				],
				[
					33903,
					-11237
				],
				[
					22681,
					17706
				],
				[
					-39031,
					1408
				],
				[
					-16638,
					13477
				],
				[
					29992,
					5635
				],
				[
					14120,
					13989
				],
				[
					39627,
					5316
				]
			],
			[
				[
					3017864,
					8780013
				],
				[
					10541,
					-15702
				],
				[
					25297,
					-6948
				],
				[
					4936,
					-16798
				],
				[
					21845,
					-2099
				],
				[
					26392,
					-19420
				],
				[
					-40345,
					-24456
				],
				[
					-43536,
					-3733
				],
				[
					-27422,
					13514
				],
				[
					-55318,
					36154
				],
				[
					32460,
					25468
				],
				[
					45150,
					14020
				]
			],
			[
				[
					3527984,
					8788105
				],
				[
					4,
					-41801
				]
			],
			[
				[
					3527988,
					8746304
				],
				[
					-63640,
					-11483
				],
				[
					-58029,
					-5863
				],
				[
					28087,
					-23068
				],
				[
					44892,
					4515
				],
				[
					24101,
					-4026
				],
				[
					-6844,
					-21369
				],
				[
					5637,
					-28666
				],
				[
					-26261,
					-17092
				],
				[
					-59831,
					-12045
				],
				[
					-10253,
					-9001
				],
				[
					-47191,
					5692
				],
				[
					-1253,
					-5993
				],
				[
					-78812,
					-18605
				],
				[
					-48977,
					11064
				],
				[
					-14860,
					22304
				],
				[
					-36026,
					69
				],
				[
					-4213,
					13663
				],
				[
					-27485,
					-23
				],
				[
					3077,
					21880
				],
				[
					-10447,
					13149
				],
				[
					10946,
					18126
				],
				[
					-16022,
					9206
				],
				[
					10195,
					31674
				],
				[
					20155,
					-3408
				],
				[
					44254,
					17745
				],
				[
					44165,
					5385
				],
				[
					50304,
					14478
				],
				[
					11297,
					-6740
				],
				[
					23462,
					10856
				],
				[
					54125,
					6935
				],
				[
					28341,
					-7912
				],
				[
					6240,
					9147
				],
				[
					100862,
					1207
				]
			],
			[
				[
					3527846,
					8916277
				],
				[
					133,
					-82205
				]
			],
			[
				[
					3527979,
					8834072
				],
				[
					-18170,
					6345
				],
				[
					-42326,
					-12573
				],
				[
					-53554,
					11054
				],
				[
					-33218,
					17168
				],
				[
					-18391,
					-3280
				],
				[
					8563,
					-13303
				],
				[
					-23226,
					667
				],
				[
					-2618,
					-13906
				],
				[
					-37974,
					1777
				],
				[
					-15012,
					18151
				],
				[
					-29387,
					4947
				],
				[
					-59607,
					-9089
				],
				[
					-19905,
					-10649
				],
				[
					-36145,
					-5043
				],
				[
					-13874,
					15654
				],
				[
					12910,
					18105
				],
				[
					79882,
					23529
				],
				[
					22897,
					9662
				],
				[
					66673,
					1996
				],
				[
					34537,
					9723
				],
				[
					27407,
					24492
				],
				[
					39644,
					5551
				],
				[
					10558,
					10163
				],
				[
					36286,
					363
				],
				[
					63917,
					-29299
				]
			],
			[
				[
					514645,
					6562874
				],
				[
					7,
					1708
				]
			],
			[
				[
					514642,
					6564279
				],
				[
					2,
					-957
				]
			],
			[
				[
					514653,
					6558973
				],
				[
					-5,
					2311
				]
			],
			[
				[
					221756,
					6742918
				],
				[
					18743,
					-7573
				],
				[
					-22852,
					-19569
				],
				[
					-17927,
					12317
				],
				[
					14045,
					16010
				],
				[
					7991,
					-1185
				]
			],
			[
				[
					222387,
					4419012
				],
				[
					-14120,
					19979
				],
				[
					14537,
					58627
				],
				[
					-402,
					6714
				],
				[
					-71041,
					-4343
				],
				[
					-32989,
					-36628
				],
				[
					-53880,
					29931
				],
				[
					-7818,
					-21179
				],
				[
					-54400,
					21199
				],
				[
					-351,
					427927
				],
				[
					242,
					117828
				],
				[
					-524,
					181183
				],
				[
					-99,
					279755
				],
				[
					649,
					46004
				],
				[
					-1038,
					101148
				],
				[
					558,
					426198
				],
				[
					-1266,
					242389
				],
				[
					82,
					239430
				],
				[
					-527,
					156215
				],
				[
					751,
					34877
				],
				[
					22014,
					-8300
				],
				[
					48413,
					-5804
				],
				[
					56656,
					6169
				],
				[
					36006,
					-17021
				],
				[
					13807,
					1497
				],
				[
					20811,
					-11592
				],
				[
					12676,
					481
				],
				[
					29509,
					-28134
				],
				[
					19408,
					-11279
				],
				[
					14305,
					-22299
				],
				[
					19003,
					-8963
				],
				[
					9080,
					17213
				],
				[
					15839,
					-27161
				],
				[
					29334,
					-18243
				],
				[
					83684,
					-39842
				],
				[
					22409,
					1967
				],
				[
					26292,
					-18881
				],
				[
					21200,
					6582
				],
				[
					13457,
					-4236
				]
			],
			[
				[
					6977432,
					2512028
				],
				[
					10529,
					-8238
				],
				[
					-8715,
					-9191
				],
				[
					776,
					-12317
				],
				[
					-6579,
					-10854
				],
				[
					-21857,
					-158
				],
				[
					-6544,
					-5247
				],
				[
					-3023,
					17518
				],
				[
					19395,
					18183
				],
				[
					16018,
					10304
				]
			],
			[
				[
					7049516,
					2596802
				],
				[
					-10798,
					-9266
				],
				[
					3161,
					9973
				],
				[
					7637,
					-707
				]
			],
			[
				[
					6917870,
					2772239
				],
				[
					6144,
					-1074
				],
				[
					846,
					-20273
				],
				[
					-13679,
					-3954
				],
				[
					882,
					18281
				],
				[
					5807,
					7020
				]
			],
			[
				[
					6749448,
					2782444
				],
				[
					26848,
					-5061
				],
				[
					17452,
					-21942
				],
				[
					1563,
					-9133
				],
				[
					13981,
					-17552
				],
				[
					17375,
					-48648
				],
				[
					141,
					-14580
				],
				[
					-7633,
					-10382
				],
				[
					-35611,
					14022
				],
				[
					-25832,
					20332
				],
				[
					-26293,
					6774
				],
				[
					-27523,
					15660
				],
				[
					-21793,
					8718
				],
				[
					-11289,
					11888
				],
				[
					17970,
					34327
				],
				[
					31810,
					11631
				],
				[
					28834,
					3946
				]
			],
			[
				[
					6903299,
					2823773
				],
				[
					10314,
					-6979
				],
				[
					-5929,
					-8745
				],
				[
					2072,
					-15589
				],
				[
					-8732,
					-7680
				],
				[
					-6687,
					10201
				],
				[
					-2847,
					18912
				],
				[
					11809,
					9880
				]
			],
			[
				[
					7010538,
					3197957
				],
				[
					-2109,
					-6695
				],
				[
					-28805,
					-9900
				],
				[
					-1047,
					-3814
				],
				[
					-33851,
					-9653
				],
				[
					-14062,
					-12642
				],
				[
					11229,
					19706
				],
				[
					24852,
					9619
				],
				[
					43793,
					13379
				]
			],
			[
				[
					7197089,
					3342377
				],
				[
					-8720,
					-13798
				],
				[
					-14657,
					-9607
				],
				[
					23377,
					23405
				]
			],
			[
				[
					7218310,
					3371512
				],
				[
					-4496,
					-13444
				],
				[
					-15340,
					-9721
				],
				[
					19836,
					23165
				]
			],
			[
				[
					7022695,
					3466951
				],
				[
					-12376,
					-45218
				],
				[
					-7148,
					-19358
				],
				[
					12334,
					64252
				],
				[
					7190,
					324
				]
			],
			[
				[
					7270170,
					3496471
				],
				[
					4779,
					-10971
				],
				[
					-8932,
					-7426
				],
				[
					4153,
					18397
				]
			],
			[
				[
					7016839,
					3531615
				],
				[
					-5080,
					-19146
				],
				[
					-2137,
					9559
				],
				[
					7217,
					9587
				]
			],
			[
				[
					7278922,
					3538473
				],
				[
					491,
					-12266
				],
				[
					-9085,
					-3311
				],
				[
					8594,
					15577
				]
			],
			[
				[
					7050927,
					3559678
				],
				[
					4191,
					-6115
				],
				[
					332,
					-34422
				],
				[
					-2445,
					-23932
				],
				[
					-12012,
					-625
				],
				[
					-15351,
					-16649
				],
				[
					1994,
					22652
				],
				[
					10832,
					21423
				],
				[
					-5042,
					14963
				],
				[
					11268,
					20428
				],
				[
					6233,
					2277
				]
			],
			[
				[
					6961321,
					3559651
				],
				[
					-8560,
					-35764
				],
				[
					-9532,
					-7053
				],
				[
					12253,
					39442
				],
				[
					5839,
					3375
				]
			],
			[
				[
					6956082,
					3577037
				],
				[
					-10112,
					-37014
				],
				[
					-11788,
					-17231
				],
				[
					-36402,
					-27725
				],
				[
					-7486,
					7393
				],
				[
					7868,
					23340
				],
				[
					7583,
					6665
				],
				[
					14011,
					-2643
				],
				[
					-2348,
					13803
				],
				[
					16102,
					-5344
				],
				[
					14476,
					18145
				],
				[
					8096,
					20611
				]
			],
			[
				[
					6986650,
					3604514
				],
				[
					-751,
					-16742
				],
				[
					15977,
					-5995
				],
				[
					773,
					-13890
				],
				[
					7033,
					-10524
				],
				[
					14553,
					-124
				],
				[
					4809,
					-29487
				],
				[
					-8852,
					-7800
				],
				[
					-12888,
					-41715
				],
				[
					-11362,
					-48036
				],
				[
					-602,
					8486
				],
				[
					21505,
					72433
				],
				[
					5405,
					37154
				],
				[
					-13174,
					-10993
				],
				[
					-5149,
					-44508
				],
				[
					-5155,
					18628
				],
				[
					-9952,
					-20952
				],
				[
					-5429,
					-22274
				],
				[
					-15497,
					-36818
				],
				[
					-13958,
					-11854
				],
				[
					-7661,
					12994
				],
				[
					-18458,
					-32246
				],
				[
					25275,
					57905
				],
				[
					9899,
					18367
				],
				[
					-9317,
					6449
				],
				[
					-35511,
					-70437
				],
				[
					-6972,
					17126
				],
				[
					-9920,
					5991
				],
				[
					19413,
					24445
				],
				[
					13935,
					32240
				],
				[
					18074,
					20861
				],
				[
					5143,
					14367
				],
				[
					6014,
					34456
				],
				[
					3586,
					-6740
				],
				[
					-11393,
					-53027
				],
				[
					-7505,
					-6917
				],
				[
					-4807,
					-20508
				],
				[
					14241,
					23017
				],
				[
					13294,
					10394
				],
				[
					6923,
					34173
				],
				[
					8461,
					62101
				]
			],
			[
				[
					7286212,
					3623733
				],
				[
					-543,
					-30293
				],
				[
					-5458,
					1847
				],
				[
					6001,
					28446
				]
			],
			[
				[
					6950738,
					3644377
				],
				[
					6680,
					-2888
				],
				[
					3416,
					-22148
				],
				[
					-8108,
					-1057
				],
				[
					-1988,
					26093
				]
			],
			[
				[
					6911508,
					3665444
				],
				[
					9873,
					-6606
				],
				[
					-7780,
					-25509
				],
				[
					-7583,
					8257
				],
				[
					5490,
					23858
				]
			],
			[
				[
					6922736,
					3684925
				],
				[
					5635,
					-10203
				],
				[
					3646,
					-26200
				],
				[
					-4095,
					-4406
				],
				[
					-5631,
					24786
				],
				[
					-10932,
					-2220
				],
				[
					11377,
					18243
				]
			],
			[
				[
					7275548,
					3709078
				],
				[
					6010,
					-10769
				],
				[
					-5975,
					-5323
				],
				[
					-35,
					16092
				]
			],
			[
				[
					7276279,
					3742864
				],
				[
					5666,
					-31401
				],
				[
					-4899,
					-479
				],
				[
					-5765,
					26660
				],
				[
					4998,
					5220
				]
			],
			[
				[
					7089365,
					3775433
				],
				[
					4978,
					-4091
				],
				[
					-13586,
					-9675
				],
				[
					-6528,
					4140
				],
				[
					15136,
					9626
				]
			],
			[
				[
					7261811,
					3795232
				],
				[
					9364,
					-12539
				],
				[
					-1698,
					-20264
				],
				[
					-7666,
					32803
				]
			],
			[
				[
					6925033,
					3819366
				],
				[
					-2856,
					-26531
				],
				[
					-1130,
					20727
				],
				[
					3986,
					5804
				]
			],
			[
				[
					6931198,
					3843001
				],
				[
					4366,
					-14477
				],
				[
					-4771,
					-16372
				],
				[
					-7975,
					7092
				],
				[
					8380,
					23757
				]
			],
			[
				[
					7217528,
					3938965
				],
				[
					-272,
					2050
				]
			],
			[
				[
					7132207,
					4016457
				],
				[
					17725,
					-8214
				],
				[
					-374,
					-5307
				],
				[
					-17351,
					13521
				]
			],
			[
				[
					8311936,
					4028185
				],
				[
					3656,
					-4696
				]
			],
			[
				[
					7103136,
					4042701
				],
				[
					-649,
					4011
				]
			],
			[
				[
					6878373,
					4356432
				],
				[
					6932,
					-4389
				],
				[
					-11396,
					-18245
				],
				[
					-8165,
					4393
				],
				[
					12629,
					18241
				]
			],
			[
				[
					6897847,
					4387806
				],
				[
					12658,
					-7731
				],
				[
					-16519,
					-18513
				],
				[
					-2350,
					9053
				],
				[
					-8627,
					-7632
				],
				[
					6383,
					17506
				],
				[
					8455,
					7317
				]
			],
			[
				[
					8654126,
					4493811
				],
				[
					-20922,
					11243
				],
				[
					-17993,
					17395
				],
				[
					7357,
					15272
				],
				[
					14675,
					-281
				],
				[
					26673,
					-27322
				]
			],
			[
				[
					8245368,
					4562771
				],
				[
					15074,
					-2718
				],
				[
					17669,
					-22629
				],
				[
					1811,
					-8315
				],
				[
					-16451,
					-39992
				],
				[
					-10285,
					1623
				],
				[
					-14285,
					-14901
				],
				[
					-15305,
					-8720
				],
				[
					-10068,
					2873
				],
				[
					-2733,
					13163
				],
				[
					5657,
					26064
				],
				[
					16719,
					50507
				],
				[
					12197,
					3045
				]
			],
			[
				[
					8642159,
					4578790
				],
				[
					-603,
					-12342
				],
				[
					-9245,
					-7152
				],
				[
					9848,
					19494
				]
			],
			[
				[
					7100424,
					4617170
				],
				[
					-4450,
					-9147
				],
				[
					-34095,
					-17745
				],
				[
					-7831,
					-580
				],
				[
					6521,
					16203
				],
				[
					25583,
					10345
				],
				[
					14272,
					924
				]
			],
			[
				[
					8025165,
					4652597
				],
				[
					808,
					-258
				]
			],
			[
				[
					8034818,
					4649510
				],
				[
					-3742,
					10239
				],
				[
					11530,
					7929
				],
				[
					-4413,
					-19256
				]
			],
			[
				[
					7849948,
					4735878
				],
				[
					128,
					-2452
				]
			],
			[
				[
					8598364,
					4827778
				],
				[
					34921,
					-10784
				],
				[
					-8841,
					-7572
				],
				[
					17145,
					-2111
				],
				[
					-11392,
					-26387
				],
				[
					8546,
					2182
				],
				[
					-20957,
					-48434
				],
				[
					-11474,
					8108
				],
				[
					-3495,
					13075
				],
				[
					-28135,
					24721
				],
				[
					-26048,
					18687
				],
				[
					417,
					17191
				],
				[
					27604,
					9321
				],
				[
					21709,
					2003
				]
			],
			[
				[
					8503907,
					4859614
				],
				[
					8955,
					-15407
				],
				[
					-16141,
					5518
				],
				[
					7186,
					9889
				]
			],
			[
				[
					8519467,
					4862026
				],
				[
					4928,
					-21577
				],
				[
					-8986,
					4853
				],
				[
					-2977,
					13554
				],
				[
					7035,
					3170
				]
			],
			[
				[
					8511875,
					4867808
				],
				[
					2656,
					-23367
				],
				[
					-9706,
					16171
				],
				[
					7050,
					7196
				]
			],
			[
				[
					8582620,
					4886563
				],
				[
					13968,
					-6933
				],
				[
					24173,
					-30532
				],
				[
					-3816,
					-14572
				],
				[
					-12194,
					-635
				],
				[
					-20263,
					14975
				],
				[
					-11906,
					21882
				],
				[
					10038,
					15815
				]
			],
			[
				[
					8498655,
					4938353
				],
				[
					9506,
					-12504
				],
				[
					-11887,
					-366
				],
				[
					-8422,
					9401
				],
				[
					10803,
					3469
				]
			],
			[
				[
					7678790,
					4966125
				],
				[
					654,
					-3099
				]
			],
			[
				[
					6957184,
					4995019
				],
				[
					28744,
					-38120
				],
				[
					-9234,
					-44617
				],
				[
					-12042,
					-22240
				],
				[
					919,
					-16156
				],
				[
					-10318,
					-18961
				],
				[
					-6543,
					-25197
				],
				[
					-8253,
					-7054
				],
				[
					-1979,
					-15648
				],
				[
					-19304,
					-7918
				],
				[
					-14575,
					34090
				],
				[
					-11769,
					17372
				],
				[
					-13666,
					53
				],
				[
					-7187,
					30323
				],
				[
					626,
					19907
				],
				[
					13190,
					49817
				],
				[
					9549,
					7979
				],
				[
					11958,
					28819
				],
				[
					40491,
					13787
				],
				[
					9393,
					-6236
				]
			],
			[
				[
					8629222,
					5037178
				],
				[
					7577,
					-13833
				],
				[
					16580,
					13528
				],
				[
					19659,
					-22574
				],
				[
					-13542,
					-8985
				],
				[
					-232,
					-11605
				],
				[
					-15106,
					-5081
				],
				[
					-34973,
					14063
				],
				[
					1155,
					17716
				],
				[
					11219,
					931
				],
				[
					-1587,
					12414
				],
				[
					9250,
					3426
				]
			],
			[
				[
					7129983,
					5042742
				],
				[
					13511,
					701
				],
				[
					-2195,
					-12209
				],
				[
					-23816,
					4416
				],
				[
					12500,
					7092
				]
			],
			[
				[
					7157783,
					5043355
				],
				[
					13004,
					-729
				],
				[
					-13745,
					-12355
				],
				[
					-9041,
					13160
				],
				[
					9782,
					-76
				]
			],
			[
				[
					8613065,
					5048006
				],
				[
					8629,
					-7945
				],
				[
					-18300,
					-11498
				],
				[
					-16704,
					3678
				],
				[
					10494,
					12140
				],
				[
					15881,
					3625
				]
			],
			[
				[
					7524006,
					5079831
				],
				[
					16715,
					-16995
				],
				[
					20828,
					3876
				],
				[
					21817,
					-4654
				],
				[
					1175,
					-16153
				],
				[
					-23960,
					614
				],
				[
					-22318,
					12236
				],
				[
					-14084,
					2215
				],
				[
					-14027,
					10518
				],
				[
					13854,
					8343
				]
			],
			[
				[
					7904320,
					5116862
				],
				[
					37899,
					-14993
				],
				[
					3279,
					2725
				],
				[
					30464,
					-14943
				],
				[
					28033,
					-29550
				],
				[
					10839,
					-19523
				],
				[
					-21954,
					-12945
				],
				[
					-39052,
					6952
				],
				[
					-8314,
					12215
				],
				[
					-7580,
					36957
				],
				[
					13405,
					-1477
				],
				[
					-45640,
					22729
				],
				[
					-1379,
					11853
				]
			],
			[
				[
					7914488,
					5120421
				],
				[
					23077,
					-8350
				],
				[
					2487,
					-6337
				],
				[
					-25564,
					14687
				]
			],
			[
				[
					8425977,
					5124677
				],
				[
					18288,
					-17329
				],
				[
					-15274,
					5780
				],
				[
					-3014,
					11549
				]
			],
			[
				[
					8367235,
					5170146
				],
				[
					17799,
					-13961
				],
				[
					3604,
					-13477
				],
				[
					-21403,
					27438
				]
			],
			[
				[
					8279473,
					5201405
				],
				[
					11702,
					-13174
				],
				[
					-7054,
					-3043
				],
				[
					-4648,
					16217
				]
			],
			[
				[
					8628285,
					5205227
				],
				[
					8263,
					-3485
				],
				[
					-789,
					-12648
				],
				[
					-7474,
					16133
				]
			],
			[
				[
					8236276,
					5212311
				],
				[
					19034,
					-20459
				],
				[
					-12686,
					5329
				],
				[
					-6348,
					15130
				]
			],
			[
				[
					8249772,
					5220196
				],
				[
					24923,
					-30919
				],
				[
					-4598,
					-1896
				],
				[
					-20325,
					32815
				]
			],
			[
				[
					7109082,
					5259811
				],
				[
					44741,
					-8024
				],
				[
					-4494,
					-6651
				],
				[
					21840,
					-6825
				],
				[
					11313,
					-20696
				],
				[
					3984,
					-16782
				],
				[
					-6732,
					-15967
				],
				[
					-36148,
					-20296
				],
				[
					-25123,
					15078
				],
				[
					-14222,
					20623
				],
				[
					-28912,
					33755
				],
				[
					-7147,
					13002
				],
				[
					40900,
					12783
				]
			],
			[
				[
					7077424,
					5267268
				],
				[
					1441,
					-15368
				],
				[
					-13152,
					-989
				],
				[
					11711,
					16357
				]
			],
			[
				[
					8614141,
					5265685
				],
				[
					5548,
					-27185
				],
				[
					-11987,
					5003
				],
				[
					-13763,
					27031
				],
				[
					8767,
					10616
				],
				[
					11435,
					-15465
				]
			],
			[
				[
					8291270,
					5293114
				],
				[
					10413,
					-10327
				],
				[
					-9134,
					-7422
				],
				[
					-1279,
					17749
				]
			],
			[
				[
					7850420,
					5295137
				],
				[
					-6086,
					-13405
				],
				[
					-5134,
					9309
				],
				[
					11220,
					4096
				]
			],
			[
				[
					8694048,
					5296834
				],
				[
					13926,
					-23704
				],
				[
					-10277,
					-5176
				],
				[
					-6899,
					17992
				],
				[
					3250,
					10888
				]
			],
			[
				[
					8716907,
					5297670
				],
				[
					2470,
					-14354
				],
				[
					-12261,
					10705
				],
				[
					9791,
					3649
				]
			],
			[
				[
					8672456,
					5304988
				],
				[
					3067,
					-22261
				],
				[
					9254,
					-15067
				],
				[
					3635,
					-18897
				],
				[
					-6231,
					-245
				],
				[
					20806,
					-23795
				],
				[
					5025,
					-16646
				],
				[
					-27132,
					19172
				],
				[
					-8104,
					12359
				],
				[
					-2621,
					26719
				],
				[
					-12558,
					22212
				],
				[
					14859,
					16449
				]
			],
			[
				[
					7211121,
					5307546
				],
				[
					22181,
					-6383
				],
				[
					6586,
					4094
				],
				[
					27907,
					-17864
				],
				[
					19035,
					-22685
				],
				[
					-8161,
					-11115
				],
				[
					14960,
					-2723
				],
				[
					-12913,
					-5971
				],
				[
					-1756,
					-12701
				],
				[
					-31307,
					6161
				],
				[
					-31606,
					31292
				],
				[
					-19650,
					14494
				],
				[
					-3044,
					11678
				],
				[
					17768,
					11723
				]
			],
			[
				[
					7828899,
					5308325
				],
				[
					7141,
					-9409
				],
				[
					-9767,
					-9916
				],
				[
					2626,
					19325
				]
			],
			[
				[
					7755971,
					5310193
				],
				[
					-23491,
					-6931
				],
				[
					20820,
					10694
				],
				[
					2671,
					-3763
				]
			],
			[
				[
					7732812,
					5324743
				],
				[
					7528,
					-8341
				],
				[
					-13496,
					-3309
				],
				[
					5968,
					11650
				]
			],
			[
				[
					8706267,
					5324634
				],
				[
					-12014,
					-18733
				],
				[
					-5685,
					10401
				],
				[
					17699,
					8332
				]
			],
			[
				[
					8671947,
					5339658
				],
				[
					9000,
					-5997
				],
				[
					4447,
					-15483
				],
				[
					-10588,
					-1369
				],
				[
					-2859,
					22849
				]
			],
			[
				[
					8677011,
					5347356
				],
				[
					18135,
					1404
				],
				[
					-6493,
					-21152
				],
				[
					-15089,
					12988
				],
				[
					3447,
					6760
				]
			],
			[
				[
					8642610,
					5363623
				],
				[
					-376,
					-8748
				],
				[
					13642,
					-6971
				],
				[
					-10803,
					-16281
				],
				[
					13153,
					-12097
				],
				[
					5923,
					12214
				],
				[
					5817,
					-23328
				],
				[
					-10194,
					-5489
				],
				[
					-4404,
					12380
				],
				[
					-17052,
					14949
				],
				[
					-12139,
					-4157
				],
				[
					-15803,
					8349
				],
				[
					1702,
					11577
				],
				[
					30534,
					17602
				]
			],
			[
				[
					7170549,
					5393683
				],
				[
					6994,
					-11086
				],
				[
					-12124,
					-16480
				],
				[
					-27998,
					4244
				],
				[
					-154,
					19332
				],
				[
					33282,
					3990
				]
			],
			[
				[
					8602942,
					5409612
				],
				[
					14424,
					-6895
				],
				[
					-14793,
					-3554
				],
				[
					369,
					10449
				]
			],
			[
				[
					8653863,
					5420134
				],
				[
					14961,
					-7940
				],
				[
					-17629,
					-3660
				],
				[
					2668,
					11600
				]
			],
			[
				[
					7698593,
					5421194
				],
				[
					-3393,
					-15416
				],
				[
					-8914,
					1809
				],
				[
					12307,
					13607
				]
			],
			[
				[
					8579146,
					5436387
				],
				[
					17724,
					-7284
				],
				[
					-9307,
					-10224
				],
				[
					-8417,
					17508
				]
			],
			[
				[
					7296549,
					5441529
				],
				[
					3489,
					-14866
				],
				[
					-9459,
					5026
				],
				[
					5970,
					9840
				]
			],
			[
				[
					8648930,
					5444387
				],
				[
					10871,
					-6139
				],
				[
					-11603,
					-6835
				],
				[
					-8899,
					10009
				],
				[
					9631,
					2965
				]
			],
			[
				[
					7394319,
					5470306
				],
				[
					17646,
					-7882
				],
				[
					-8408,
					-4811
				],
				[
					-9238,
					12693
				]
			],
			[
				[
					8600489,
					5466967
				],
				[
					12271,
					-20590
				],
				[
					-11319,
					-15982
				],
				[
					-11519,
					25342
				],
				[
					10567,
					11230
				]
			],
			[
				[
					7612033,
					5480503
				],
				[
					4287,
					-18951
				],
				[
					-8203,
					-13604
				],
				[
					-3382,
					17871
				],
				[
					7298,
					14684
				]
			],
			[
				[
					8609915,
					5481113
				],
				[
					14462,
					-17849
				],
				[
					-7523,
					-8828
				],
				[
					-11220,
					19017
				],
				[
					4281,
					7660
				]
			],
			[
				[
					7546708,
					5503964
				],
				[
					7361,
					-19560
				],
				[
					-13786,
					1351
				],
				[
					6425,
					18209
				]
			],
			[
				[
					7607772,
					5511075
				],
				[
					11167,
					-16238
				],
				[
					-11930,
					-8224
				],
				[
					763,
					24462
				]
			],
			[
				[
					7545055,
					5518937
				],
				[
					14672,
					-4133
				],
				[
					-3496,
					-14502
				],
				[
					-11176,
					18635
				]
			],
			[
				[
					8587544,
					5527346
				],
				[
					6702,
					-11411
				],
				[
					-18196,
					1318
				],
				[
					11494,
					10093
				]
			],
			[
				[
					8559619,
					5559864
				],
				[
					-5440,
					-23193
				],
				[
					14559,
					23371
				],
				[
					-2461,
					-11914
				],
				[
					10629,
					-14867
				],
				[
					-26019,
					-8048
				],
				[
					10579,
					-4203
				],
				[
					-15466,
					-6143
				],
				[
					1393,
					-7717
				],
				[
					-24368,
					1565
				],
				[
					5433,
					16105
				],
				[
					19851,
					18466
				],
				[
					11310,
					16578
				]
			],
			[
				[
					8471771,
					5610349
				],
				[
					1155,
					-12761
				],
				[
					-12131,
					4713
				],
				[
					10976,
					8048
				]
			],
			[
				[
					8795706,
					5701912
				],
				[
					9027,
					-9865
				],
				[
					-10382,
					-7434
				],
				[
					-5864,
					14489
				],
				[
					7219,
					2810
				]
			],
			[
				[
					8381883,
					5711848
				],
				[
					418,
					-16675
				],
				[
					-11435,
					6138
				],
				[
					11017,
					10537
				]
			],
			[
				[
					8840464,
					5773669
				],
				[
					4160,
					-23565
				],
				[
					-7501,
					12041
				],
				[
					3341,
					11524
				]
			],
			[
				[
					8902755,
					5803790
				],
				[
					19967,
					-17970
				],
				[
					-12355,
					-16434
				],
				[
					-2295,
					15287
				],
				[
					-16205,
					-3775
				],
				[
					-4016,
					22866
				],
				[
					14904,
					26
				]
			],
			[
				[
					8320952,
					5804799
				],
				[
					2284,
					-8526
				],
				[
					-30583,
					266
				],
				[
					28299,
					8260
				]
			],
			[
				[
					8539249,
					5843102
				],
				[
					-216,
					-14858
				],
				[
					-10649,
					-5013
				],
				[
					-1280,
					13996
				],
				[
					12145,
					5875
				]
			],
			[
				[
					8909035,
					5851433
				],
				[
					14971,
					-3188
				],
				[
					-6786,
					-18357
				],
				[
					-8185,
					21545
				]
			],
			[
				[
					8363073,
					5870851
				],
				[
					16332,
					-6463
				],
				[
					2602,
					-10706
				],
				[
					-18934,
					17169
				]
			],
			[
				[
					6482933,
					5922435
				],
				[
					5386,
					-6720
				]
			],
			[
				[
					8920591,
					5918121
				],
				[
					-29564,
					2805
				],
				[
					17484,
					10010
				],
				[
					12080,
					-12815
				]
			],
			[
				[
					6469956,
					5938516
				],
				[
					-338,
					416
				]
			],
			[
				[
					6468205,
					5940669
				],
				[
					11327,
					-5072
				],
				[
					1882,
					-11266
				]
			],
			[
				[
					6534022,
					5953045
				],
				[
					23670,
					-18212
				],
				[
					15238,
					-2621
				],
				[
					-8107,
					-17307
				],
				[
					-32454,
					13322
				],
				[
					1653,
					24818
				]
			],
			[
				[
					8366479,
					5964706
				],
				[
					7749,
					-738
				],
				[
					13338,
					-18172
				],
				[
					-10881,
					1843
				],
				[
					-10206,
					17067
				]
			],
			[
				[
					8381567,
					5967089
				],
				[
					29515,
					-14100
				],
				[
					10731,
					-9235
				],
				[
					-10389,
					-6436
				],
				[
					-20547,
					7432
				],
				[
					4549,
					9247
				],
				[
					-13859,
					13092
				]
			],
			[
				[
					8375339,
					5984259
				],
				[
					12999,
					-8490
				],
				[
					-16717,
					-874
				],
				[
					3718,
					9364
				]
			],
			[
				[
					6341003,
					6093685
				],
				[
					995,
					-1326
				]
			],
			[
				[
					6350970,
					6080626
				],
				[
					-3721,
					4736
				]
			],
			[
				[
					6346931,
					6085786
				],
				[
					-201,
					268
				]
			],
			[
				[
					6343092,
					6090901
				],
				[
					25408,
					5726
				],
				[
					13980,
					-3493
				],
				[
					1450,
					-9005
				],
				[
					-19252,
					-894
				],
				[
					31516,
					-16202
				],
				[
					7919,
					-11683
				],
				[
					14022,
					-2660
				],
				[
					-14330,
					-12439
				],
				[
					33400,
					-8086
				],
				[
					-2882,
					-29676
				],
				[
					29586,
					-28104
				],
				[
					3405,
					-32619
				]
			],
			[
				[
					8895649,
					6105961
				],
				[
					4878,
					-9071
				],
				[
					-11378,
					-4414
				],
				[
					6500,
					13485
				]
			],
			[
				[
					8815075,
					6112736
				],
				[
					11160,
					-8565
				],
				[
					-10974,
					-8186
				],
				[
					-186,
					16751
				]
			],
			[
				[
					8817295,
					6126051
				],
				[
					13449,
					-3841
				],
				[
					4024,
					-15367
				],
				[
					-13731,
					2964
				],
				[
					-3742,
					16244
				]
			],
			[
				[
					8926488,
					6137121
				],
				[
					4596,
					-7433
				],
				[
					-21841,
					-6954
				],
				[
					-5802,
					5169
				],
				[
					23047,
					9218
				]
			],
			[
				[
					8893311,
					6153863
				],
				[
					3277,
					-6850
				],
				[
					-26596,
					-18655
				],
				[
					-17817,
					-21309
				],
				[
					-12282,
					14779
				],
				[
					28050,
					25332
				],
				[
					25368,
					6703
				]
			],
			[
				[
					8759187,
					6194268
				],
				[
					25147,
					-14787
				],
				[
					-6296,
					-6720
				],
				[
					-45458,
					3107
				],
				[
					14144,
					16589
				],
				[
					12463,
					1811
				]
			],
			[
				[
					8719946,
					6262699
				],
				[
					18481,
					-21913
				],
				[
					2269,
					-12978
				],
				[
					-28045,
					-2934
				],
				[
					-5107,
					14102
				],
				[
					12402,
					23723
				]
			],
			[
				[
					8565113,
					6351250
				],
				[
					2212,
					-12861
				],
				[
					-16374,
					1736
				],
				[
					14162,
					11125
				]
			],
			[
				[
					8554997,
					6368589
				],
				[
					246,
					-11493
				],
				[
					-16695,
					7601
				],
				[
					16449,
					3892
				]
			],
			[
				[
					8495633,
					6385001
				],
				[
					6424,
					-14396
				],
				[
					-10284,
					-12811
				],
				[
					3860,
					27207
				]
			],
			[
				[
					8528647,
					6391757
				],
				[
					5757,
					-16529
				],
				[
					-10818,
					-4857
				],
				[
					-3208,
					20096
				],
				[
					8269,
					1290
				]
			],
			[
				[
					7551794,
					6388109
				],
				[
					6415,
					-4886
				],
				[
					-7254,
					-15694
				],
				[
					22463,
					-3071
				],
				[
					31192,
					-16914
				],
				[
					25787,
					6126
				],
				[
					18027,
					-9428
				],
				[
					-696,
					-13365
				],
				[
					8996,
					-20767
				],
				[
					-10696,
					-19439
				],
				[
					-55955,
					6362
				],
				[
					-42181,
					-5370
				],
				[
					-28298,
					10066
				],
				[
					-21871,
					29661
				],
				[
					-4972,
					18409
				],
				[
					5024,
					16939
				],
				[
					28632,
					-2364
				],
				[
					12408,
					14242
				],
				[
					2233,
					14875
				],
				[
					10746,
					-5382
				]
			],
			[
				[
					8405551,
					6399792
				],
				[
					4492,
					-9646
				],
				[
					-14784,
					2861
				],
				[
					10292,
					6785
				]
			],
			[
				[
					7573605,
					6404740
				],
				[
					-442,
					-17355
				],
				[
					-11748,
					15369
				],
				[
					12190,
					1986
				]
			],
			[
				[
					8460722,
					6413232
				],
				[
					-3970,
					-23016
				],
				[
					-10779,
					-4941
				],
				[
					-33878,
					7273
				],
				[
					15837,
					11878
				],
				[
					32790,
					8806
				]
			],
			[
				[
					7066511,
					6415625
				],
				[
					3652,
					-9060
				],
				[
					-15797,
					-4607
				],
				[
					12145,
					13667
				]
			],
			[
				[
					6151834,
					6422213
				],
				[
					21368,
					-15317
				],
				[
					5672,
					-52715
				],
				[
					5827,
					-16107
				],
				[
					-4201,
					-27669
				],
				[
					-17711,
					-26120
				],
				[
					-27898,
					9052
				],
				[
					-17071,
					31890
				],
				[
					13235,
					17447
				],
				[
					-5411,
					14427
				],
				[
					-13388,
					10007
				],
				[
					10142,
					9601
				],
				[
					6535,
					24282
				],
				[
					22901,
					21222
				]
			],
			[
				[
					7372991,
					6430816
				],
				[
					25860,
					-6240
				],
				[
					15408,
					-9916
				],
				[
					32081,
					-5367
				],
				[
					19560,
					-19173
				],
				[
					-2556,
					-31865
				],
				[
					-11069,
					-17405
				],
				[
					10256,
					-36554
				],
				[
					1292,
					-51996
				],
				[
					-14087,
					-34833
				],
				[
					-21032,
					-20586
				],
				[
					-60579,
					-29102
				],
				[
					-37440,
					-219
				],
				[
					-53530,
					-8661
				],
				[
					-33866,
					8168
				],
				[
					-25749,
					50337
				],
				[
					402,
					24322
				],
				[
					-7645,
					41957
				],
				[
					9724,
					29833
				],
				[
					27464,
					57520
				],
				[
					31712,
					39388
				],
				[
					43072,
					19236
				],
				[
					4495,
					-6151
				],
				[
					23213,
					-2236
				],
				[
					10171,
					9818
				],
				[
					12843,
					-275
				]
			],
			[
				[
					7000741,
					6437345
				],
				[
					20231,
					-2179
				],
				[
					16486,
					-19147
				],
				[
					-20814,
					-21527
				],
				[
					-20874,
					7126
				],
				[
					-1526,
					27398
				],
				[
					6497,
					8329
				]
			],
			[
				[
					8389230,
					6439905
				],
				[
					11960,
					-3890
				],
				[
					-9493,
					-7792
				],
				[
					-2467,
					11682
				]
			],
			[
				[
					7546627,
					6462210
				],
				[
					26894,
					-29645
				],
				[
					-8260,
					-19356
				],
				[
					-15336,
					9715
				],
				[
					-14119,
					31875
				],
				[
					10821,
					7411
				]
			],
			[
				[
					8287029,
					6498012
				],
				[
					-9747,
					-6258
				],
				[
					-13873,
					4813
				],
				[
					23620,
					1445
				]
			],
			[
				[
					7033316,
					6510940
				],
				[
					41581,
					-9633
				],
				[
					347,
					-14569
				],
				[
					-21496,
					-1097
				],
				[
					-5761,
					-11110
				],
				[
					10032,
					-5235
				],
				[
					-19904,
					-13384
				],
				[
					-16851,
					8083
				],
				[
					1060,
					11938
				],
				[
					26603,
					8325
				],
				[
					3603,
					8827
				],
				[
					-25471,
					14556
				],
				[
					6257,
					3299
				]
			],
			[
				[
					7497828,
					6512244
				],
				[
					11251,
					-4512
				],
				[
					-2692,
					-11226
				],
				[
					17338,
					-10151
				],
				[
					-35384,
					-337
				],
				[
					-7106,
					10928
				],
				[
					16593,
					15298
				]
			],
			[
				[
					7441955,
					6523493
				],
				[
					29896,
					-16950
				],
				[
					1617,
					-15790
				],
				[
					21306,
					-23069
				],
				[
					-16811,
					-15539
				],
				[
					18540,
					-3484
				],
				[
					-8370,
					-17160
				],
				[
					-19427,
					-231
				],
				[
					-3606,
					13468
				],
				[
					-22990,
					11098
				],
				[
					-20519,
					21422
				],
				[
					1506,
					19465
				],
				[
					11189,
					24332
				],
				[
					7669,
					2438
				]
			],
			[
				[
					6605760,
					6529227
				],
				[
					14138,
					-9062
				],
				[
					-20911,
					2697
				],
				[
					6773,
					6365
				]
			],
			[
				[
					7451547,
					6532017
				],
				[
					12508,
					-5219
				],
				[
					-9696,
					-6851
				],
				[
					-2812,
					12070
				]
			],
			[
				[
					8210592,
					6545712
				],
				[
					33665,
					-6499
				],
				[
					50163,
					-16217
				],
				[
					-17084,
					-2890
				],
				[
					-42751,
					14840
				],
				[
					-23637,
					3455
				],
				[
					-356,
					7311
				]
			],
			[
				[
					8309279,
					6569272
				],
				[
					-20134,
					-7029
				],
				[
					-4511,
					6007
				],
				[
					24645,
					1022
				]
			],
			[
				[
					5883121,
					6650804
				],
				[
					9545,
					-5909
				],
				[
					16919,
					-31648
				],
				[
					61920,
					-41764
				],
				[
					18100,
					-18841
				],
				[
					12282,
					-20223
				],
				[
					4927,
					-47879
				],
				[
					16438,
					-43823
				],
				[
					-7260,
					-32250
				],
				[
					-8756,
					-10383
				],
				[
					-12112,
					8787
				],
				[
					-17300,
					418
				],
				[
					289,
					33145
				],
				[
					-9199,
					-13248
				],
				[
					-35785,
					391
				],
				[
					-12178,
					-6553
				],
				[
					-38344,
					-3680
				]
			],
			[
				[
					7076507,
					6685103
				],
				[
					20631,
					-4016
				],
				[
					7998,
					-19143
				],
				[
					-16074,
					-22037
				],
				[
					-13534,
					5588
				],
				[
					-8007,
					-31784
				],
				[
					-16672,
					-16846
				],
				[
					-3297,
					-13368
				],
				[
					-20982,
					-14710
				],
				[
					-38073,
					-17800
				],
				[
					-14164,
					6350
				],
				[
					-1556,
					15868
				],
				[
					19108,
					39620
				],
				[
					28315,
					3294
				],
				[
					12982,
					11076
				],
				[
					-318,
					13030
				],
				[
					10898,
					15464
				],
				[
					16881,
					-1055
				],
				[
					-13126,
					18680
				],
				[
					28990,
					11789
				]
			],
			[
				[
					6693491,
					6692760
				],
				[
					37246,
					-5403
				],
				[
					5049,
					-14626
				],
				[
					-18114,
					-613
				],
				[
					-20285,
					18103
				],
				[
					5047,
					-16233
				],
				[
					-10607,
					-1191
				],
				[
					1664,
					19963
				]
			],
			[
				[
					7229755,
					6698744
				],
				[
					17252,
					-10803
				],
				[
					29618,
					4141
				],
				[
					1601,
					-23970
				],
				[
					-27245,
					-24647
				],
				[
					3966,
					-13383
				],
				[
					-23634,
					-8574
				],
				[
					-20526,
					6005
				],
				[
					-10535,
					24862
				],
				[
					5294,
					19706
				],
				[
					-3294,
					15156
				],
				[
					27503,
					11507
				]
			],
			[
				[
					6644453,
					6711145
				],
				[
					33857,
					-10749
				],
				[
					2415,
					-7559
				],
				[
					-36272,
					18308
				]
			],
			[
				[
					6718340,
					6713529
				],
				[
					10577,
					-11469
				],
				[
					-23275,
					10270
				],
				[
					12698,
					1199
				]
			],
			[
				[
					6633854,
					6721426
				],
				[
					19477,
					-9685
				],
				[
					-29193,
					3909
				],
				[
					9716,
					5776
				]
			],
			[
				[
					8314707,
					6731904
				],
				[
					22380,
					-4716
				],
				[
					-23642,
					-6799
				],
				[
					3598,
					-6745
				],
				[
					-29513,
					4805
				],
				[
					27177,
					13455
				]
			],
			[
				[
					8280805,
					6752589
				],
				[
					9269,
					-7838
				],
				[
					-12742,
					-7050
				],
				[
					-9113,
					-20595
				],
				[
					-10065,
					312
				],
				[
					-33575,
					14813
				],
				[
					24574,
					18922
				],
				[
					31652,
					1436
				]
			],
			[
				[
					7114119,
					6771309
				],
				[
					17253,
					-11653
				],
				[
					4389,
					-13706
				],
				[
					-14838,
					-14574
				],
				[
					-19099,
					-3746
				],
				[
					-31759,
					-19800
				],
				[
					-13113,
					8119
				],
				[
					-20195,
					-14787
				],
				[
					-4653,
					10571
				],
				[
					36521,
					34090
				],
				[
					15072,
					-464
				],
				[
					2368,
					13875
				],
				[
					18752,
					-5569
				],
				[
					-4679,
					13094
				],
				[
					13981,
					4550
				]
			],
			[
				[
					6585965,
					6786050
				],
				[
					38767,
					-9291
				],
				[
					-4294,
					-14321
				],
				[
					-27500,
					9089
				],
				[
					-6973,
					14523
				]
			],
			[
				[
					6942837,
					6786955
				],
				[
					21291,
					-1900
				],
				[
					14476,
					-23950
				],
				[
					-35147,
					-23250
				],
				[
					-32043,
					-600
				],
				[
					-17406,
					6105
				],
				[
					18690,
					-26959
				],
				[
					-10582,
					-6596
				],
				[
					-25055,
					7494
				],
				[
					2972,
					24520
				],
				[
					-9989,
					-15095
				],
				[
					-22905,
					27316
				],
				[
					-28981,
					-2427
				],
				[
					-7923,
					8020
				],
				[
					12657,
					12762
				],
				[
					28534,
					-8284
				],
				[
					-3258,
					17331
				],
				[
					34816,
					2809
				],
				[
					5281,
					-10813
				],
				[
					18719,
					-8892
				],
				[
					19411,
					7404
				],
				[
					16442,
					15005
				]
			],
			[
				[
					6473575,
					6788958
				],
				[
					29476,
					-9453
				],
				[
					-20888,
					-4141
				],
				[
					8168,
					-11901
				],
				[
					-29603,
					14428
				],
				[
					12847,
					11067
				]
			],
			[
				[
					5882607,
					6417098
				],
				[
					84233,
					10023
				],
				[
					-11695,
					-8203
				],
				[
					12164,
					-32430
				],
				[
					-8009,
					-33288
				],
				[
					-5537,
					-7239
				],
				[
					31832,
					-77135
				],
				[
					18374,
					-10738
				],
				[
					45830,
					-59505
				],
				[
					21710,
					-34848
				],
				[
					-16180,
					-13021
				],
				[
					20512,
					1334
				],
				[
					5655,
					-20807
				],
				[
					2368,
					23039
				],
				[
					28326,
					8847
				],
				[
					359,
					16891
				],
				[
					-10406,
					7379
				],
				[
					26928,
					20695
				],
				[
					10850,
					-2939
				],
				[
					18061,
					-17179
				],
				[
					11115,
					10504
				],
				[
					751,
					43149
				],
				[
					4867,
					10363
				],
				[
					-8520,
					20264
				],
				[
					12252,
					24107
				],
				[
					33790,
					46915
				],
				[
					19221,
					9294
				],
				[
					7013,
					10751
				],
				[
					-1497,
					31007
				],
				[
					17891,
					60617
				],
				[
					732,
					45264
				],
				[
					11874,
					27298
				],
				[
					19810,
					2335
				],
				[
					21499,
					-4430
				],
				[
					7315,
					8248
				],
				[
					46100,
					-6650
				],
				[
					5637,
					6761
				],
				[
					-14655,
					14001
				],
				[
					-16931,
					-4246
				],
				[
					-19838,
					10809
				],
				[
					22035,
					181
				],
				[
					-15579,
					26037
				],
				[
					39512,
					-5401
				],
				[
					-14997,
					17199
				],
				[
					12093,
					6724
				],
				[
					28030,
					-10589
				],
				[
					251,
					8069
				],
				[
					-22410,
					2743
				],
				[
					3045,
					10038
				],
				[
					-22917,
					1239
				],
				[
					-5468,
					14689
				],
				[
					-12820,
					-8635
				],
				[
					4254,
					15421
				],
				[
					-21602,
					626
				],
				[
					-16815,
					8540
				],
				[
					-9934,
					26943
				],
				[
					6516,
					580
				],
				[
					-11337,
					39306
				],
				[
					5779,
					18929
				],
				[
					14079,
					19
				],
				[
					-20331,
					18620
				],
				[
					14807,
					20364
				],
				[
					-11748,
					5610
				],
				[
					18892,
					16383
				],
				[
					-27605,
					-756
				],
				[
					3511,
					10498
				],
				[
					18522,
					-2053
				],
				[
					43344,
					-22254
				],
				[
					-6582,
					6702
				],
				[
					20227,
					16222
				],
				[
					19416,
					-4805
				],
				[
					17230,
					6897
				],
				[
					48769,
					-11336
				],
				[
					7703,
					-13378
				],
				[
					57905,
					-17951
				],
				[
					23923,
					-1737
				],
				[
					12995,
					6542
				],
				[
					27251,
					-4343
				],
				[
					46057,
					861
				],
				[
					29421,
					-16940
				],
				[
					-33356,
					7681
				],
				[
					-6046,
					-5322
				],
				[
					15752,
					-9098
				],
				[
					-6796,
					-5136
				],
				[
					14135,
					-17320
				],
				[
					-69031,
					3058
				],
				[
					48161,
					-8311
				],
				[
					48968,
					-20262
				],
				[
					-15866,
					-3308
				],
				[
					20378,
					-14510
				],
				[
					1227,
					-9247
				],
				[
					-20889,
					-13526
				],
				[
					-49217,
					16785
				],
				[
					-19491,
					-4699
				],
				[
					35143,
					-1599
				],
				[
					17689,
					-12390
				],
				[
					27102,
					5745
				],
				[
					23798,
					-62
				],
				[
					4050,
					7366
				],
				[
					36794,
					-1897
				],
				[
					20181,
					-14581
				],
				[
					19536,
					-2707
				],
				[
					952,
					-22914
				],
				[
					-18923,
					-8173
				],
				[
					-9798,
					-18583
				],
				[
					-12460,
					1629
				],
				[
					-649,
					-11881
				],
				[
					-29091,
					-10186
				],
				[
					35744,
					456
				],
				[
					6262,
					-16639
				],
				[
					17391,
					11096
				],
				[
					12038,
					-7867
				],
				[
					10420,
					-18648
				],
				[
					-4595,
					-4602
				],
				[
					1111,
					-27478
				],
				[
					-39586,
					-29946
				],
				[
					-22124,
					2765
				],
				[
					-102,
					-15296
				],
				[
					-17347,
					-11130
				],
				[
					-11720,
					17868
				],
				[
					-28624,
					19013
				],
				[
					13066,
					716
				],
				[
					-5351,
					14975
				],
				[
					17666,
					-7871
				],
				[
					650,
					11278
				],
				[
					12798,
					-1412
				],
				[
					-9196,
					38551
				],
				[
					-18139,
					5493
				],
				[
					-13300,
					23355
				],
				[
					-3142,
					-15318
				],
				[
					17152,
					-21371
				],
				[
					-21914,
					-20602
				],
				[
					-27689,
					18526
				],
				[
					-6348,
					-16132
				],
				[
					789,
					-20943
				],
				[
					9217,
					-14342
				],
				[
					1408,
					12901
				],
				[
					13026,
					3250
				],
				[
					18863,
					-9429
				],
				[
					14186,
					-19478
				],
				[
					-1659,
					-8776
				],
				[
					-19638,
					967
				],
				[
					-21449,
					12343
				],
				[
					-8786,
					-3861
				],
				[
					16702,
					-13814
				],
				[
					-18364,
					428
				],
				[
					2277,
					-10434
				],
				[
					36673,
					-6799
				],
				[
					12008,
					-6623
				],
				[
					19967,
					384
				],
				[
					-4274,
					-11584
				],
				[
					-9528,
					8589
				],
				[
					-39866,
					-4341
				],
				[
					17538,
					-13831
				],
				[
					13298,
					-271
				],
				[
					-10393,
					-25942
				],
				[
					18358,
					-9225
				],
				[
					14821,
					25726
				],
				[
					6682,
					-5277
				],
				[
					-8390,
					-20833
				],
				[
					-9340,
					-115
				],
				[
					-1705,
					-22486
				],
				[
					5770,
					-26593
				],
				[
					20705,
					-22364
				],
				[
					14576,
					-7089
				],
				[
					22001,
					-31121
				],
				[
					18213,
					-11279
				],
				[
					25395,
					-37445
				],
				[
					-15407,
					-34516
				],
				[
					-2619,
					-33831
				],
				[
					-13008,
					-42042
				],
				[
					-16931,
					1243
				],
				[
					-11623,
					-8116
				],
				[
					-8504,
					7047
				],
				[
					-21579,
					-11391
				],
				[
					-11851,
					-23830
				],
				[
					5600,
					-5428
				],
				[
					-12773,
					-10986
				],
				[
					874,
					-19277
				],
				[
					-20909,
					6166
				],
				[
					-24585,
					-23980
				],
				[
					-3908,
					-16025
				],
				[
					-45744,
					-2540
				],
				[
					-532,
					-16081
				],
				[
					-28006,
					-22839
				],
				[
					-18063,
					-9913
				],
				[
					-16925,
					-2279
				],
				[
					-8348,
					18037
				],
				[
					14030,
					-2174
				],
				[
					-17857,
					27554
				],
				[
					-18189,
					5699
				],
				[
					-4445,
					13697
				],
				[
					-8935,
					-5059
				],
				[
					-7521,
					28146
				],
				[
					16429,
					29630
				],
				[
					-25100,
					-19751
				],
				[
					-4033,
					-8596
				],
				[
					-18493,
					3831
				],
				[
					5266,
					16233
				],
				[
					-22736,
					10503
				],
				[
					8271,
					20646
				],
				[
					-17817,
					7146
				],
				[
					-12044,
					17162
				],
				[
					-25108,
					3490
				],
				[
					-2396,
					-12466
				],
				[
					13319,
					8973
				],
				[
					15533,
					-9734
				],
				[
					-43977,
					-2948
				]
			],
			[
				[
					6601901,
					6803525
				],
				[
					24974,
					-13792
				],
				[
					177,
					-9231
				],
				[
					-28774,
					17380
				],
				[
					3623,
					5643
				]
			],
			[
				[
					6104201,
					6868300
				],
				[
					8249,
					-9027
				],
				[
					22937,
					-6389
				],
				[
					21493,
					6864
				],
				[
					12807,
					-30374
				],
				[
					-30634,
					-4446
				],
				[
					-35262,
					5249
				],
				[
					-23101,
					10327
				],
				[
					-10992,
					14223
				],
				[
					31981,
					6586
				],
				[
					2522,
					6987
				]
			],
			[
				[
					8212486,
					6879328
				],
				[
					-1262,
					-12960
				],
				[
					-10312,
					12098
				],
				[
					11574,
					862
				]
			],
			[
				[
					7822238,
					7084029
				],
				[
					35058,
					-7053
				],
				[
					20203,
					351
				],
				[
					-5249,
					-24187
				],
				[
					-16591,
					-1487
				],
				[
					-63296,
					-23258
				],
				[
					-12646,
					25936
				],
				[
					16137,
					1233
				],
				[
					8950,
					27018
				],
				[
					17434,
					1447
				]
			],
			[
				[
					7893475,
					7089652
				],
				[
					6294,
					15325
				],
				[
					13397,
					1483
				],
				[
					-19691,
					-16808
				]
			],
			[
				[
					7686772,
					7202368
				],
				[
					-11689,
					-28200
				],
				[
					20552,
					25073
				],
				[
					18364,
					-21331
				],
				[
					-24376,
					-8650
				],
				[
					7715,
					-20555
				],
				[
					-32894,
					11658
				],
				[
					1237,
					10770
				],
				[
					-15282,
					26697
				],
				[
					28806,
					11664
				],
				[
					7567,
					-7126
				]
			],
			[
				[
					7722833,
					7232363
				],
				[
					9055,
					-16370
				],
				[
					-7471,
					-13087
				],
				[
					-16354,
					-560
				],
				[
					-16662,
					10654
				],
				[
					10755,
					16216
				],
				[
					20677,
					3147
				]
			],
			[
				[
					7675833,
					7240762
				],
				[
					-17142,
					-30811
				],
				[
					-13425,
					7065
				],
				[
					22534,
					23753
				],
				[
					8033,
					-7
				]
			],
			[
				[
					7502616,
					7370249
				],
				[
					-9275,
					-15324
				],
				[
					-19105,
					1023
				],
				[
					4304,
					8341
				],
				[
					24076,
					5960
				]
			],
			[
				[
					6227807,
					7386876
				],
				[
					13393,
					-1543
				],
				[
					-3610,
					-19249
				],
				[
					-27914,
					17468
				],
				[
					18131,
					3324
				]
			],
			[
				[
					7019877,
					7419782
				],
				[
					24928,
					-17316
				],
				[
					-21927,
					-6380
				],
				[
					-12779,
					4863
				],
				[
					-1812,
					16109
				],
				[
					11590,
					2724
				]
			],
			[
				[
					6951519,
					7425684
				],
				[
					16272,
					-20610
				],
				[
					-12886,
					-7450
				],
				[
					-11968,
					18906
				],
				[
					8582,
					9154
				]
			],
			[
				[
					5014106,
					7485987
				],
				[
					18992,
					10832
				],
				[
					-5665,
					-15224
				]
			],
			[
				[
					4979348,
					7497333
				],
				[
					2261,
					-727
				]
			],
			[
				[
					4966360,
					7501501
				],
				[
					9190,
					-2946
				]
			],
			[
				[
					4959068,
					7503827
				],
				[
					6747,
					-2152
				]
			],
			[
				[
					4983734,
					7495922
				],
				[
					9521,
					24004
				],
				[
					22492,
					11070
				],
				[
					-2133,
					-16414
				],
				[
					10876,
					-10859
				],
				[
					-13034,
					-13927
				],
				[
					-17781,
					2923
				]
			],
			[
				[
					5123160,
					7557507
				],
				[
					3674,
					-21405
				],
				[
					-10248,
					-6335
				],
				[
					-2533,
					20598
				],
				[
					9107,
					7142
				]
			],
			[
				[
					4832531,
					7543108
				],
				[
					22715,
					17831
				],
				[
					29534,
					5238
				],
				[
					27998,
					-5079
				],
				[
					43492,
					-19906
				],
				[
					-7257,
					-16681
				],
				[
					9081,
					-20373
				]
			],
			[
				[
					5124770,
					7590381
				],
				[
					2304,
					-20106
				],
				[
					-17683,
					11245
				],
				[
					15379,
					8861
				]
			],
			[
				[
					5007381,
					7597403
				],
				[
					11863,
					-8065
				],
				[
					11923,
					-25567
				],
				[
					-14836,
					-23449
				],
				[
					-32481,
					-1709
				],
				[
					-13535,
					14410
				],
				[
					-4839,
					24027
				],
				[
					9467,
					14039
				],
				[
					19483,
					9868
				],
				[
					12955,
					-3554
				]
			],
			[
				[
					4984357,
					7621507
				],
				[
					11118,
					-12148
				],
				[
					-27857,
					5628
				],
				[
					16739,
					6520
				]
			],
			[
				[
					4110246,
					7708543
				],
				[
					7081,
					-1144
				]
			],
			[
				[
					4100693,
					7710086
				],
				[
					2246,
					-363
				]
			],
			[
				[
					6846745,
					7740060
				],
				[
					20335,
					-3467
				],
				[
					27216,
					-14529
				],
				[
					2365,
					7222
				],
				[
					51104,
					-13840
				],
				[
					10097,
					-6650
				],
				[
					48026,
					-1294
				],
				[
					17090,
					7277
				],
				[
					89750,
					1729
				],
				[
					26752,
					-12396
				],
				[
					79035,
					-24973
				],
				[
					32184,
					-46437
				],
				[
					24862,
					1126
				],
				[
					-3567,
					-9434
				],
				[
					19211,
					-15634
				],
				[
					-1966,
					-23013
				],
				[
					37511,
					-8236
				],
				[
					-8189,
					-6055
				],
				[
					4095,
					-27422
				],
				[
					25332,
					-4342
				],
				[
					-101,
					-17394
				],
				[
					-20231,
					-9020
				],
				[
					-39052,
					-1325
				],
				[
					-44106,
					4652
				],
				[
					-56305,
					11733
				],
				[
					-84025,
					2991
				],
				[
					-32501,
					-7653
				],
				[
					-69535,
					-27361
				],
				[
					-25995,
					-3997
				],
				[
					-23238,
					3763
				],
				[
					-31590,
					20266
				],
				[
					-17908,
					6254
				],
				[
					-2655,
					15186
				],
				[
					-17966,
					29334
				],
				[
					5685,
					40705
				],
				[
					-8154,
					7646
				],
				[
					-21137,
					-2290
				],
				[
					-43206,
					8776
				],
				[
					-12834,
					15463
				],
				[
					2020,
					32909
				],
				[
					15598,
					1312
				],
				[
					-15992,
					15384
				],
				[
					-3075,
					15335
				],
				[
					13790,
					14127
				],
				[
					-1296,
					20844
				],
				[
					32566,
					2728
				]
			],
			[
				[
					3958065,
					7731992
				],
				[
					39334,
					671
				],
				[
					26692,
					8863
				],
				[
					37069,
					-4028
				],
				[
					38962,
					-27320
				]
			],
			[
				[
					7355096,
					5550348
				],
				[
					25130,
					-28790
				],
				[
					-316,
					-12328
				],
				[
					19753,
					-16210
				],
				[
					-23390,
					6790
				],
				[
					11374,
					-22626
				],
				[
					-10621,
					-4843
				],
				[
					-19694,
					9947
				],
				[
					-9892,
					-11571
				],
				[
					-23507,
					-3167
				],
				[
					12823,
					-8621
				],
				[
					-14597,
					-8685
				],
				[
					-22830,
					-619
				],
				[
					-27194,
					4260
				],
				[
					10427,
					-23213
				],
				[
					-64803,
					21985
				],
				[
					-16603,
					-11251
				],
				[
					-4232,
					20791
				],
				[
					-11340,
					7725
				],
				[
					-41149,
					186
				],
				[
					-3951,
					18808
				],
				[
					-13781,
					-2625
				],
				[
					2145,
					15218
				],
				[
					-21018,
					32678
				],
				[
					928,
					34116
				],
				[
					9747,
					6632
				],
				[
					3219,
					15874
				],
				[
					-9767,
					15713
				],
				[
					21422,
					30946
				],
				[
					22395,
					7520
				],
				[
					19130,
					14787
				],
				[
					11798,
					-3494
				],
				[
					20505,
					16610
				],
				[
					-23171,
					27183
				],
				[
					3759,
					16083
				],
				[
					17712,
					-5641
				],
				[
					3873,
					5181
				],
				[
					-15776,
					20022
				],
				[
					17511,
					3389
				],
				[
					20416,
					-16299
				],
				[
					29946,
					5582
				],
				[
					17955,
					-5684
				],
				[
					57527,
					-27273
				],
				[
					7351,
					-6154
				],
				[
					20338,
					-1310
				],
				[
					18386,
					-10214
				],
				[
					3169,
					-14874
				],
				[
					24702,
					-11050
				],
				[
					-10331,
					17971
				],
				[
					-14034,
					338
				],
				[
					-1944,
					8201
				],
				[
					-20051,
					11062
				],
				[
					838,
					15626
				],
				[
					24929,
					-6630
				],
				[
					5490,
					8660
				],
				[
					8805,
					-17133
				],
				[
					31595,
					-2901
				],
				[
					19206,
					1939
				],
				[
					1930,
					31534
				],
				[
					11921,
					-6042
				],
				[
					21337,
					1536
				],
				[
					6969,
					11275
				],
				[
					10718,
					-7786
				],
				[
					-972,
					-13045
				],
				[
					12711,
					-3394
				],
				[
					19823,
					17981
				],
				[
					7369,
					17755
				],
				[
					26925,
					15003
				],
				[
					6680,
					-8682
				],
				[
					13045,
					9861
				],
				[
					16905,
					-8342
				],
				[
					7820,
					-12755
				],
				[
					8181,
					4980
				],
				[
					13241,
					-7007
				],
				[
					-17274,
					51271
				],
				[
					-12565,
					28578
				],
				[
					-28346,
					13947
				],
				[
					-23579,
					32261
				],
				[
					-23804,
					26810
				],
				[
					-4711,
					20917
				],
				[
					6425,
					9024
				],
				[
					54352,
					34968
				],
				[
					25561,
					27239
				],
				[
					33788,
					26677
				],
				[
					2233,
					13593
				],
				[
					36493,
					23321
				],
				[
					11895,
					34860
				],
				[
					10461,
					14784
				],
				[
					4334,
					20591
				],
				[
					19386,
					15606
				],
				[
					28713,
					2265
				],
				[
					13275,
					16072
				],
				[
					3419,
					22952
				],
				[
					9966,
					5660
				],
				[
					-24215,
					12278
				],
				[
					4158,
					4590
				],
				[
					-16227,
					40257
				],
				[
					7416,
					1487
				],
				[
					-8158,
					25911
				],
				[
					-8931,
					226
				],
				[
					-11244,
					14102
				],
				[
					10527,
					14174
				],
				[
					-17261,
					24408
				],
				[
					-13418,
					897
				],
				[
					-11430,
					20374
				],
				[
					-1618,
					14501
				],
				[
					8338,
					8077
				],
				[
					-10833,
					23036
				],
				[
					-3246,
					29382
				],
				[
					-19016,
					-4936
				],
				[
					-3923,
					13454
				],
				[
					-10471,
					-5038
				],
				[
					-30918,
					6867
				],
				[
					-33226,
					16633
				],
				[
					-8337,
					15785
				],
				[
					8179,
					19129
				],
				[
					16518,
					7330
				],
				[
					-11645,
					11139
				],
				[
					14598,
					11636
				],
				[
					-54,
					9061
				],
				[
					-18414,
					11488
				],
				[
					-37316,
					6664
				],
				[
					33968,
					-41566
				],
				[
					-34093,
					-11726
				],
				[
					-34053,
					19952
				],
				[
					265,
					12841
				],
				[
					-26559,
					21503
				],
				[
					397,
					7595
				],
				[
					24438,
					14149
				],
				[
					-19726,
					4141
				],
				[
					2342,
					-14499
				],
				[
					-14961,
					-1104
				],
				[
					-9584,
					8754
				],
				[
					24171,
					13829
				],
				[
					-1457,
					14594
				],
				[
					-28171,
					-6290
				],
				[
					18427,
					15328
				],
				[
					32294,
					5069
				],
				[
					26467,
					-3141
				],
				[
					462,
					5649
				],
				[
					-39485,
					3574
				],
				[
					-29735,
					-14438
				],
				[
					-22073,
					-3173
				],
				[
					13680,
					14382
				],
				[
					25813,
					7093
				],
				[
					-14000,
					14133
				],
				[
					26553,
					28266
				],
				[
					7958,
					-485
				],
				[
					42410,
					16546
				],
				[
					9501,
					12097
				],
				[
					-56141,
					-26027
				],
				[
					-25946,
					4131
				],
				[
					3457,
					-27563
				],
				[
					-22584,
					-17356
				],
				[
					-22259,
					-39490
				],
				[
					-23486,
					15999
				],
				[
					-13415,
					17868
				],
				[
					-11927,
					-11635
				],
				[
					9377,
					-8639
				],
				[
					-9829,
					-13690
				],
				[
					-40236,
					-15840
				],
				[
					-13753,
					-15074
				],
				[
					-31302,
					-16504
				],
				[
					-30918,
					-2265
				],
				[
					-7041,
					9909
				],
				[
					19562,
					35654
				],
				[
					-12955,
					4367
				],
				[
					-4130,
					13195
				],
				[
					6592,
					22038
				],
				[
					28607,
					6182
				],
				[
					38188,
					-12937
				],
				[
					26664,
					19893
				],
				[
					19804,
					-1806
				],
				[
					131,
					37758
				],
				[
					-19475,
					18753
				],
				[
					-16171,
					5797
				],
				[
					-5878,
					10940
				],
				[
					24138,
					13367
				],
				[
					5122,
					-7670
				],
				[
					9824,
					17687
				],
				[
					22481,
					9426
				],
				[
					2995,
					23443
				],
				[
					-5443,
					10978
				],
				[
					-6209,
					-27062
				],
				[
					-24994,
					2823
				],
				[
					14595,
					-12392
				],
				[
					-16584,
					-3916
				],
				[
					-10391,
					-19329
				],
				[
					-15283,
					-10716
				],
				[
					-26316,
					13586
				],
				[
					-22541,
					-4209
				],
				[
					-2267,
					10858
				],
				[
					-27314,
					21168
				],
				[
					1187,
					13635
				],
				[
					14496,
					12986
				],
				[
					16443,
					79
				],
				[
					15942,
					-9147
				],
				[
					4478,
					12554
				],
				[
					-38010,
					818
				],
				[
					-22225,
					-25971
				],
				[
					-17405,
					5343
				],
				[
					5498,
					11747
				],
				[
					-15655,
					-8311
				],
				[
					-25849,
					10278
				],
				[
					17992,
					16695
				],
				[
					26352,
					2715
				],
				[
					-11250,
					6204
				],
				[
					-1266,
					12847
				],
				[
					-45521,
					8361
				],
				[
					7396,
					12011
				],
				[
					31222,
					12858
				],
				[
					2289,
					31089
				],
				[
					11071,
					14328
				],
				[
					9376,
					-759
				],
				[
					39209,
					31597
				],
				[
					-29339,
					-18359
				],
				[
					-30503,
					-24682
				],
				[
					2159,
					-16150
				],
				[
					-8593,
					-16590
				],
				[
					-19851,
					-9881
				],
				[
					-33914,
					-7558
				],
				[
					4190,
					-15221
				],
				[
					-17547,
					-15429
				],
				[
					-8875,
					19708
				],
				[
					-2008,
					42663
				],
				[
					6052,
					40230
				],
				[
					-14924,
					23140
				],
				[
					11941,
					9432
				],
				[
					36182,
					5721
				],
				[
					22250,
					17236
				],
				[
					-17642,
					-3300
				],
				[
					-3607,
					-11097
				],
				[
					-42731,
					-10815
				],
				[
					-10511,
					-13042
				],
				[
					-8682,
					6263
				],
				[
					-18678,
					-11557
				],
				[
					-7997,
					9955
				],
				[
					-6969,
					-15549
				],
				[
					-10962,
					9008
				],
				[
					-11366,
					-5410
				],
				[
					-18537,
					25171
				],
				[
					18776,
					9879
				],
				[
					-24603,
					2093
				],
				[
					-21358,
					21147
				],
				[
					-31830,
					6253
				],
				[
					2793,
					14539
				],
				[
					19311,
					15521
				],
				[
					12347,
					-6485
				],
				[
					-10478,
					22356
				],
				[
					-5667,
					-11047
				],
				[
					-12848,
					16499
				],
				[
					-15559,
					-18880
				],
				[
					15223,
					5765
				],
				[
					2725,
					-8390
				],
				[
					-18610,
					-23676
				],
				[
					335,
					-19128
				],
				[
					-34602,
					19416
				],
				[
					8005,
					18289
				],
				[
					-9463,
					-2291
				],
				[
					-2530,
					-25341
				],
				[
					-11228,
					-22128
				],
				[
					-11325,
					-2126
				],
				[
					-1741,
					-12916
				],
				[
					14192,
					-23033
				],
				[
					-53951,
					22269
				],
				[
					-15632,
					-5056
				],
				[
					4255,
					-14111
				],
				[
					41996,
					-24781
				],
				[
					4274,
					28457
				],
				[
					22275,
					-1555
				],
				[
					-13228,
					27298
				],
				[
					13269,
					10638
				],
				[
					19812,
					-3487
				],
				[
					17152,
					-15032
				],
				[
					31436,
					3203
				],
				[
					21591,
					-32039
				],
				[
					2187,
					-27140
				],
				[
					8030,
					-6477
				],
				[
					2339,
					-19481
				],
				[
					-16027,
					-21580
				],
				[
					-70208,
					2253
				],
				[
					-19003,
					-8108
				],
				[
					-19751,
					3221
				],
				[
					-16684,
					27027
				],
				[
					-36177,
					8947
				],
				[
					-7331,
					-8445
				],
				[
					-30104,
					15179
				],
				[
					-30673,
					-322
				],
				[
					-40930,
					11125
				],
				[
					-24923,
					25
				],
				[
					-31111,
					7593
				],
				[
					962,
					-12169
				],
				[
					27446,
					-14089
				],
				[
					16010,
					3360
				],
				[
					16808,
					-20813
				],
				[
					40058,
					-36025
				],
				[
					2758,
					-8589
				],
				[
					-19955,
					-10324
				],
				[
					-27547,
					27828
				],
				[
					-23124,
					12824
				],
				[
					-7677,
					10993
				],
				[
					-37097,
					12551
				],
				[
					-35657,
					31093
				],
				[
					-88210,
					36708
				],
				[
					8045,
					-9653
				],
				[
					40771,
					-16123
				],
				[
					41758,
					-22298
				],
				[
					17504,
					-20659
				],
				[
					23008,
					-7863
				],
				[
					-3921,
					-17815
				],
				[
					-22457,
					-5264
				],
				[
					-7810,
					8156
				],
				[
					-11623,
					-23084
				],
				[
					-21530,
					12401
				],
				[
					-36735,
					10410
				],
				[
					-39734,
					25619
				],
				[
					-19203,
					6184
				],
				[
					-22643,
					-8733
				],
				[
					-31821,
					-5738
				],
				[
					-52369,
					7600
				],
				[
					-21447,
					-1041
				],
				[
					-17556,
					5642
				],
				[
					-23543,
					-939
				],
				[
					-30672,
					15284
				],
				[
					-43992,
					9674
				],
				[
					-49052,
					-330
				],
				[
					-11071,
					-14201
				],
				[
					27324,
					7809
				],
				[
					31045,
					-12008
				],
				[
					11137,
					-11026
				],
				[
					-34165,
					7402
				],
				[
					-23998,
					-3621
				],
				[
					-56261,
					26525
				],
				[
					-35788,
					31435
				],
				[
					3348,
					13504
				],
				[
					-7156,
					15750
				],
				[
					8407,
					11384
				],
				[
					25218,
					13614
				],
				[
					-3863,
					3514
				],
				[
					-31877,
					-15561
				],
				[
					-11313,
					-19460
				],
				[
					-17744,
					-2888
				],
				[
					1886,
					12532
				],
				[
					-13102,
					10157
				],
				[
					1933,
					11918
				],
				[
					-16908,
					-4992
				],
				[
					-3587,
					-11999
				],
				[
					18627,
					-8377
				],
				[
					-2202,
					-18619
				],
				[
					-58261,
					10931
				],
				[
					-27762,
					1656
				],
				[
					-6212,
					-7021
				],
				[
					20955,
					-2438
				],
				[
					-14842,
					-12373
				],
				[
					-17841,
					4059
				],
				[
					-34258,
					15655
				],
				[
					7866,
					3709
				],
				[
					28219,
					-10481
				],
				[
					1643,
					6929
				],
				[
					-29450,
					15666
				],
				[
					-59470,
					16522
				],
				[
					-20154,
					14814
				],
				[
					-17707,
					25719
				],
				[
					1706,
					8674
				],
				[
					-37271,
					30695
				],
				[
					-11853,
					28090
				],
				[
					25761,
					7562
				],
				[
					-1868,
					10523
				],
				[
					-15546,
					5578
				],
				[
					-21515,
					19718
				],
				[
					34991,
					-4711
				],
				[
					8763,
					-10413
				],
				[
					45717,
					4712
				],
				[
					31417,
					-3572
				],
				[
					20211,
					-19677
				],
				[
					25377,
					-3570
				],
				[
					28536,
					3460
				],
				[
					52209,
					322
				],
				[
					8036,
					17596
				],
				[
					-11542,
					9824
				],
				[
					-40253,
					16824
				],
				[
					-12984,
					13877
				],
				[
					2815,
					17199
				],
				[
					-36933,
					-8737
				],
				[
					-71959,
					6612
				],
				[
					-39797,
					8948
				],
				[
					-10270,
					-1929
				],
				[
					-46847,
					6010
				],
				[
					-27271,
					11963
				],
				[
					-11885,
					23689
				],
				[
					6034,
					13322
				],
				[
					-9561,
					18429
				],
				[
					19790,
					25236
				],
				[
					4946,
					17439
				],
				[
					-12940,
					21244
				],
				[
					-21493,
					19258
				],
				[
					17112,
					22273
				],
				[
					-4996,
					9916
				],
				[
					49282,
					26712
				],
				[
					-21590,
					-3127
				],
				[
					-14175,
					11074
				],
				[
					-8537,
					31639
				],
				[
					14319,
					13944
				],
				[
					9971,
					51230
				],
				[
					24840,
					4637
				],
				[
					-7247,
					18034
				],
				[
					5745,
					18981
				],
				[
					34218,
					-116
				],
				[
					-20025,
					10690
				],
				[
					11471,
					11819
				],
				[
					-5511,
					29477
				],
				[
					41742,
					68496
				],
				[
					81038,
					70063
				],
				[
					31672,
					19282
				],
				[
					61000,
					26078
				],
				[
					92851,
					21519
				],
				[
					57039,
					1393
				],
				[
					65787,
					-8688
				],
				[
					52830,
					-2953
				],
				[
					26318,
					-16619
				],
				[
					-10202,
					-17475
				],
				[
					-30149,
					-14992
				],
				[
					-42519,
					-27661
				],
				[
					-38602,
					-29934
				],
				[
					-22901,
					-26697
				],
				[
					-34071,
					-67395
				],
				[
					-30653,
					-33583
				],
				[
					-5480,
					-24933
				],
				[
					7771,
					-21399
				],
				[
					34131,
					-29663
				],
				[
					14344,
					-32521
				],
				[
					-17099,
					-19608
				],
				[
					-6378,
					-23094
				],
				[
					5996,
					-46458
				],
				[
					32969,
					-54596
				],
				[
					80450,
					-71340
				],
				[
					55088,
					-17465
				],
				[
					-327,
					-17681
				],
				[
					10256,
					-18236
				],
				[
					-34404,
					7084
				],
				[
					-23180,
					-2583
				],
				[
					7326,
					-10788
				],
				[
					-17161,
					1239
				],
				[
					6687,
					-13151
				],
				[
					-15150,
					-5392
				],
				[
					-22999,
					8029
				],
				[
					-29943,
					-7336
				],
				[
					-30258,
					-28948
				],
				[
					-61354,
					-11760
				],
				[
					4313,
					-7119
				],
				[
					23071,
					-462
				],
				[
					39586,
					10076
				],
				[
					45546,
					28909
				],
				[
					45831,
					9792
				],
				[
					28479,
					-10889
				],
				[
					2630,
					12509
				],
				[
					27650,
					-3890
				],
				[
					-905,
					-23552
				],
				[
					-13675,
					9513
				],
				[
					-7762,
					-5358
				],
				[
					15826,
					-20386
				],
				[
					-5599,
					-15451
				],
				[
					21778,
					-2192
				],
				[
					4052,
					14870
				],
				[
					-7900,
					14412
				],
				[
					-417,
					27580
				],
				[
					13794,
					16010
				],
				[
					-10306,
					7087
				],
				[
					-128,
					22467
				],
				[
					8189,
					19161
				],
				[
					20786,
					5985
				],
				[
					-1832,
					20113
				],
				[
					-12992,
					9545
				],
				[
					5148,
					22581
				],
				[
					-27287,
					-127
				],
				[
					-459,
					-10246
				],
				[
					-51391,
					11462
				],
				[
					-28306,
					27800
				],
				[
					14280,
					2867
				],
				[
					-15214,
					22532
				],
				[
					-43383,
					19845
				],
				[
					-4621,
					11780
				],
				[
					24013,
					-6269
				],
				[
					1898,
					9381
				],
				[
					28505,
					2892
				],
				[
					14065,
					22823
				],
				[
					-13286,
					5849
				],
				[
					13790,
					16907
				],
				[
					17917,
					4283
				],
				[
					29472,
					-4420
				],
				[
					29974,
					-24119
				],
				[
					10662,
					-1885
				],
				[
					40334,
					-29174
				],
				[
					4393,
					-20134
				],
				[
					6833,
					16780
				],
				[
					-40189,
					36024
				],
				[
					-17497,
					5931
				],
				[
					-17753,
					20544
				],
				[
					-14683,
					5356
				],
				[
					17443,
					17295
				],
				[
					32386,
					-1779
				],
				[
					-9400,
					5455
				],
				[
					-31125,
					-1484
				],
				[
					2499,
					19573
				],
				[
					-28329,
					-17775
				],
				[
					-27174,
					7364
				],
				[
					-20982,
					12486
				],
				[
					-8713,
					24600
				],
				[
					13992,
					6324
				],
				[
					-20513,
					4076
				],
				[
					-5718,
					72364
				],
				[
					16184,
					16548
				],
				[
					27160,
					1094
				],
				[
					43314,
					-18624
				],
				[
					35279,
					-6313
				],
				[
					44178,
					-16883
				],
				[
					-32684,
					20648
				],
				[
					-28899,
					8416
				],
				[
					-17297,
					12853
				],
				[
					-25035,
					8419
				],
				[
					-42332,
					3226
				],
				[
					16637,
					28191
				],
				[
					16499,
					-19471
				],
				[
					11265,
					-2856
				],
				[
					-9076,
					24018
				],
				[
					18679,
					-2044
				],
				[
					24480,
					-12448
				],
				[
					66023,
					-8865
				],
				[
					35860,
					-2243
				],
				[
					34772,
					-13502
				],
				[
					-33067,
					17595
				],
				[
					-13875,
					-900
				],
				[
					-46403,
					14289
				],
				[
					-30159,
					4226
				],
				[
					-52359,
					23098
				],
				[
					6106,
					20391
				],
				[
					41133,
					18390
				],
				[
					9336,
					-17297
				],
				[
					39849,
					-22396
				],
				[
					-27298,
					23863
				],
				[
					-7285,
					19583
				],
				[
					56298,
					17911
				],
				[
					43318,
					-12394
				],
				[
					12718,
					-30627
				],
				[
					6230,
					565
				],
				[
					-11357,
					36600
				],
				[
					-37010,
					12701
				],
				[
					87478,
					34005
				],
				[
					22964,
					928
				],
				[
					20636,
					19363
				],
				[
					62004,
					-2844
				],
				[
					79212,
					2473
				],
				[
					18737,
					-11847
				],
				[
					1783,
					-10467
				],
				[
					24526,
					-26316
				],
				[
					6876,
					-34424
				],
				[
					-3949,
					-31165
				],
				[
					67150,
					-24692
				],
				[
					8556,
					-16086
				],
				[
					-13841,
					-21629
				],
				[
					-1052,
					-15330
				],
				[
					16250,
					-24361
				],
				[
					21681,
					-6652
				],
				[
					9508,
					-17550
				],
				[
					-36094,
					-25619
				],
				[
					3738,
					-12657
				],
				[
					-24366,
					-9818
				],
				[
					-28365,
					-22724
				],
				[
					-23334,
					-33910
				],
				[
					-22462,
					-14396
				],
				[
					14217,
					1288
				],
				[
					20359,
					23976
				],
				[
					57385,
					41235
				],
				[
					11417,
					-13303
				],
				[
					-3922,
					-19047
				],
				[
					-17759,
					-8012
				],
				[
					-23684,
					-35781
				],
				[
					-13547,
					294
				],
				[
					49482,
					-25941
				],
				[
					-9690,
					-6142
				],
				[
					-12674,
					9273
				],
				[
					-30365,
					-2977
				],
				[
					-7692,
					-11746
				],
				[
					34670,
					-6039
				],
				[
					-3122,
					-14649
				],
				[
					-18037,
					-18135
				],
				[
					22770,
					10630
				],
				[
					668,
					13037
				],
				[
					23348,
					4581
				],
				[
					25539,
					18747
				],
				[
					-18516,
					24964
				],
				[
					31025,
					2917
				],
				[
					-8431,
					17120
				],
				[
					8559,
					9423
				],
				[
					23133,
					-29164
				],
				[
					25634,
					-10928
				],
				[
					11795,
					1337
				],
				[
					-27759,
					11704
				],
				[
					-27729,
					31943
				],
				[
					17216,
					19124
				],
				[
					17883,
					5995
				],
				[
					1604,
					16483
				],
				[
					18407,
					-7688
				],
				[
					-8416,
					-12043
				],
				[
					18449,
					-16618
				],
				[
					-20321,
					-28132
				],
				[
					21059,
					12280
				],
				[
					12383,
					-7651
				],
				[
					-259,
					19676
				],
				[
					15267,
					18552
				],
				[
					28967,
					-17525
				],
				[
					15360,
					-28740
				],
				[
					-6618,
					-30896
				],
				[
					-23578,
					-27282
				],
				[
					20322,
					-239
				],
				[
					41785,
					-14373
				],
				[
					17709,
					-11750
				],
				[
					-9110,
					16830
				],
				[
					-23083,
					8860
				],
				[
					-14934,
					12249
				],
				[
					8599,
					38341
				],
				[
					43386,
					-21486
				],
				[
					10134,
					-37423
				],
				[
					21549,
					-25480
				],
				[
					35993,
					-14466
				],
				[
					-28110,
					15995
				],
				[
					-20020,
					27838
				],
				[
					18422,
					5730
				],
				[
					21209,
					-32062
				],
				[
					19751,
					-12086
				],
				[
					3352,
					-11670
				],
				[
					8193,
					16537
				],
				[
					-19089,
					6442
				],
				[
					-31171,
					35845
				],
				[
					-22401,
					2242
				],
				[
					-9495,
					26005
				],
				[
					-49963,
					23994
				],
				[
					10249,
					18209
				],
				[
					-8635,
					9492
				],
				[
					24868,
					10801
				],
				[
					8734,
					-3341
				],
				[
					390,
					-28548
				],
				[
					9871,
					23909
				],
				[
					72273,
					-20834
				],
				[
					23787,
					-14615
				],
				[
					9677,
					3038
				],
				[
					-49480,
					25585
				],
				[
					-53639,
					19608
				],
				[
					-16335,
					18469
				],
				[
					14800,
					29449
				],
				[
					52411,
					28202
				],
				[
					20088,
					1572
				],
				[
					18674,
					10982
				],
				[
					74750,
					-620
				],
				[
					24939,
					-6188
				],
				[
					8889,
					-19580
				],
				[
					60733,
					-12741
				],
				[
					6772,
					-10580
				],
				[
					9952,
					9266
				],
				[
					20152,
					700
				],
				[
					73419,
					-23815
				],
				[
					-4146,
					-7288
				],
				[
					15506,
					-31374
				],
				[
					13521,
					-16383
				],
				[
					-10285,
					-16438
				],
				[
					-24810,
					-18971
				],
				[
					-25879,
					8355
				],
				[
					-48487,
					-9755
				],
				[
					-14006,
					-14595
				],
				[
					43704,
					18019
				],
				[
					16456,
					868
				],
				[
					31010,
					-12490
				],
				[
					-6870,
					-8437
				],
				[
					-28279,
					-5779
				],
				[
					-10843,
					-11207
				],
				[
					1181,
					-14199
				],
				[
					-18755,
					-31261
				],
				[
					-1929,
					-14337
				],
				[
					19196,
					26075
				],
				[
					15329,
					40155
				],
				[
					19333,
					1149
				],
				[
					18584,
					9916
				],
				[
					16932,
					20432
				],
				[
					44426,
					-8690
				],
				[
					41892,
					-3329
				],
				[
					13757,
					-28142
				],
				[
					-14536,
					-33203
				],
				[
					-33646,
					-7601
				],
				[
					-40931,
					-22794
				],
				[
					-19144,
					5899
				],
				[
					-33854,
					-11620
				],
				[
					42105,
					5449
				],
				[
					9918,
					-7773
				],
				[
					-29830,
					-15659
				],
				[
					-25118,
					-19434
				],
				[
					23770,
					6147
				],
				[
					59452,
					35760
				],
				[
					4985,
					-11057
				],
				[
					-24853,
					-24319
				],
				[
					-8663,
					-21409
				],
				[
					24216,
					-8861
				],
				[
					189,
					-11589
				],
				[
					-17708,
					-15064
				],
				[
					-20837,
					-31601
				],
				[
					47224,
					45671
				],
				[
					-1254,
					16720
				],
				[
					-11948,
					19953
				],
				[
					15193,
					8073
				],
				[
					8117,
					22418
				],
				[
					23495,
					9259
				],
				[
					3709,
					9411
				],
				[
					22813,
					2718
				],
				[
					-3575,
					-22697
				],
				[
					18057,
					29067
				],
				[
					41995,
					3259
				],
				[
					-1110,
					-10989
				],
				[
					-31016,
					-26930
				],
				[
					-13813,
					-29927
				],
				[
					-34205,
					-22384
				],
				[
					30552,
					10268
				],
				[
					-2628,
					-35321
				],
				[
					10111,
					9033
				],
				[
					2066,
					22498
				],
				[
					11139,
					26324
				],
				[
					20882,
					14039
				],
				[
					11519,
					-10251
				],
				[
					-9841,
					-25973
				],
				[
					9247,
					-13200
				],
				[
					16764,
					11136
				],
				[
					3888,
					-12336
				],
				[
					-33067,
					-31845
				],
				[
					-3637,
					-36028
				],
				[
					21658,
					45878
				],
				[
					19410,
					13359
				],
				[
					33783,
					-14908
				],
				[
					-21331,
					-12373
				],
				[
					26182,
					-625
				],
				[
					8013,
					23502
				],
				[
					-5723,
					18865
				],
				[
					26155,
					6759
				],
				[
					-9264,
					17211
				],
				[
					19346,
					4128
				],
				[
					8769,
					31005
				],
				[
					49653,
					-16727
				],
				[
					24992,
					-3506
				],
				[
					40258,
					-16973
				],
				[
					30211,
					-28564
				],
				[
					17991,
					-31739
				],
				[
					-20506,
					-15917
				],
				[
					-21893,
					-29488
				],
				[
					-40242,
					12694
				],
				[
					-24007,
					-7485
				],
				[
					-9505,
					-27952
				],
				[
					-11017,
					-1112
				],
				[
					-8358,
					-19315
				],
				[
					-50191,
					-17710
				],
				[
					33633,
					5430
				],
				[
					24110,
					8701
				],
				[
					10272,
					-8833
				],
				[
					-23197,
					-35874
				],
				[
					-25073,
					-8895
				],
				[
					4959,
					-7559
				],
				[
					28566,
					15083
				],
				[
					15197,
					24355
				],
				[
					29191,
					3465
				],
				[
					40596,
					19606
				],
				[
					27247,
					4097
				],
				[
					14577,
					31291
				],
				[
					47064,
					24191
				],
				[
					19875,
					-16038
				],
				[
					9769,
					-29401
				],
				[
					-26538,
					-30956
				],
				[
					-8419,
					-17682
				],
				[
					-31929,
					-14922
				],
				[
					-10111,
					-19048
				],
				[
					-29794,
					7162
				],
				[
					-16661,
					-1197
				],
				[
					3028,
					-13266
				],
				[
					-17620,
					-15145
				],
				[
					-7678,
					-47576
				],
				[
					12410,
					12824
				],
				[
					4967,
					30896
				],
				[
					22294,
					25745
				],
				[
					31573,
					-13731
				],
				[
					-16153,
					-54785
				],
				[
					5814,
					-3836
				],
				[
					-24535,
					-46029
				],
				[
					17595,
					11068
				],
				[
					11448,
					41210
				],
				[
					14326,
					35673
				],
				[
					10779,
					41059
				],
				[
					21458,
					5879
				],
				[
					52833,
					31597
				],
				[
					13559,
					1912
				],
				[
					38427,
					20772
				],
				[
					13812,
					-4571
				],
				[
					-25318,
					-33365
				],
				[
					-28896,
					-19318
				],
				[
					-19516,
					-448
				],
				[
					-7432,
					-9018
				],
				[
					7723,
					-23179
				],
				[
					9613,
					-566
				],
				[
					-9281,
					23226
				],
				[
					40996,
					7838
				],
				[
					30577,
					20037
				],
				[
					12271,
					-9290
				],
				[
					2841,
					16190
				],
				[
					22024,
					11380
				],
				[
					24044,
					-1362
				],
				[
					12389,
					-15127
				],
				[
					14804,
					-5161
				],
				[
					-28161,
					-30366
				],
				[
					-24934,
					-14344
				],
				[
					-28440,
					-918
				],
				[
					-5254,
					-9603
				],
				[
					-45973,
					-2055
				],
				[
					-23343,
					-12904
				],
				[
					-28381,
					-25023
				],
				[
					35728,
					23893
				],
				[
					32156,
					11141
				],
				[
					31792,
					-1485
				],
				[
					20400,
					16892
				],
				[
					12028,
					-1212
				],
				[
					27890,
					17086
				],
				[
					25249,
					28433
				],
				[
					58910,
					-22867
				],
				[
					18792,
					-12369
				],
				[
					1406,
					-10810
				],
				[
					-23397,
					-32610
				],
				[
					-9524,
					9727
				],
				[
					958,
					13856
				],
				[
					-12069,
					-12288
				],
				[
					2821,
					-18282
				],
				[
					-29278,
					-12049
				],
				[
					-53393,
					-8781
				],
				[
					-50922,
					-26137
				],
				[
					-7560,
					-15867
				],
				[
					-20787,
					-3388
				],
				[
					20907,
					-5422
				],
				[
					9945,
					-12174
				],
				[
					-36761,
					-6229
				],
				[
					-8279,
					-12445
				],
				[
					-23901,
					-18589
				],
				[
					10260,
					606
				],
				[
					26237,
					25122
				],
				[
					36009,
					2701
				],
				[
					6453,
					8262
				],
				[
					-8162,
					12235
				],
				[
					15659,
					22319
				],
				[
					24986,
					9344
				],
				[
					28725,
					4040
				],
				[
					12591,
					-5786
				],
				[
					17101,
					6731
				],
				[
					27083,
					2423
				],
				[
					4694,
					-10413
				],
				[
					-26921,
					-35717
				],
				[
					-27360,
					-9199
				],
				[
					-24325,
					-22770
				],
				[
					-6775,
					-12806
				],
				[
					-40159,
					1958
				],
				[
					-14891,
					-14856
				],
				[
					-12106,
					-33645
				],
				[
					18942,
					21053
				],
				[
					12075,
					20524
				],
				[
					27044,
					-7889
				],
				[
					18148,
					8656
				],
				[
					7749,
					12928
				],
				[
					20642,
					16146
				],
				[
					16216,
					4391
				],
				[
					23585,
					-4023
				],
				[
					19469,
					22712
				],
				[
					-4561,
					4577
				],
				[
					26924,
					4098
				],
				[
					16399,
					17141
				],
				[
					-10530,
					-410
				],
				[
					-3825,
					22336
				],
				[
					23416,
					22558
				],
				[
					38315,
					-16545
				],
				[
					21827,
					-18707
				],
				[
					21251,
					-24997
				],
				[
					5518,
					-18355
				],
				[
					10903,
					-5499
				],
				[
					11210,
					-52369
				],
				[
					-5186,
					-9382
				],
				[
					-23721,
					-5
				],
				[
					-40851,
					14812
				],
				[
					-36750,
					-3846
				],
				[
					-23040,
					-31310
				],
				[
					-21675,
					-1403
				],
				[
					-22245,
					5425
				],
				[
					-60144,
					-26881
				],
				[
					-14187,
					-1397
				],
				[
					-43630,
					8582
				],
				[
					-29351,
					-13467
				],
				[
					13365,
					-332
				],
				[
					21800,
					9691
				],
				[
					40489,
					-11005
				],
				[
					34651,
					7892
				],
				[
					31309,
					13806
				],
				[
					21710,
					-3025
				],
				[
					62068,
					-28073
				],
				[
					25189,
					5436
				],
				[
					64966,
					-6352
				],
				[
					49652,
					-32265
				],
				[
					11693,
					-21052
				],
				[
					-12611,
					-24390
				],
				[
					-43314,
					13364
				],
				[
					-8551,
					-9744
				],
				[
					-12995,
					9291
				],
				[
					-14474,
					-6690
				],
				[
					-19714,
					1763
				],
				[
					-61810,
					34303
				],
				[
					-26394,
					-4193
				],
				[
					-69054,
					14165
				],
				[
					-20556,
					-13910
				],
				[
					31129,
					9089
				],
				[
					60541,
					-16901
				],
				[
					24790,
					1134
				],
				[
					11841,
					-11186
				],
				[
					-7432,
					-5350
				],
				[
					-47881,
					8254
				],
				[
					-25438,
					-8356
				],
				[
					32961,
					1516
				],
				[
					-19574,
					-13544
				],
				[
					-36182,
					-6536
				],
				[
					8743,
					-5295
				],
				[
					-9827,
					-30738
				],
				[
					7255,
					1826
				],
				[
					8191,
					24935
				],
				[
					50650,
					22669
				],
				[
					24439,
					-6926
				],
				[
					56548,
					-31636
				],
				[
					-32062,
					-5751
				],
				[
					-1509,
					-6510
				],
				[
					-37441,
					11127
				],
				[
					16586,
					-15985
				],
				[
					14330,
					-877
				],
				[
					10608,
					-20815
				],
				[
					-48117,
					11557
				],
				[
					-13597,
					-2589
				],
				[
					36714,
					-8951
				],
				[
					6485,
					-6031
				],
				[
					40929,
					-11981
				],
				[
					-14250,
					-1460
				],
				[
					-60138,
					16053
				],
				[
					-21406,
					1105
				],
				[
					11706,
					-13438
				],
				[
					-46265,
					3267
				],
				[
					-43502,
					16733
				],
				[
					15594,
					-10350
				],
				[
					-16856,
					-4358
				],
				[
					43189,
					-7971
				],
				[
					30599,
					-10726
				],
				[
					32140,
					-1293
				],
				[
					35018,
					-14300
				],
				[
					-3238,
					-9689
				],
				[
					-12442,
					6401
				],
				[
					-17352,
					-7101
				],
				[
					-35634,
					6529
				],
				[
					-25849,
					-12090
				],
				[
					10436,
					-3815
				],
				[
					20495,
					10526
				],
				[
					14278,
					-10444
				],
				[
					-26397,
					-3424
				],
				[
					34235,
					-2048
				],
				[
					1595,
					5750
				],
				[
					32804,
					-4108
				],
				[
					392,
					-10005
				],
				[
					24558,
					2024
				],
				[
					-3482,
					-34106
				],
				[
					7796,
					32138
				],
				[
					21663,
					7879
				],
				[
					17106,
					-3785
				],
				[
					-11490,
					-14606
				],
				[
					3138,
					-26787
				],
				[
					4111,
					26223
				],
				[
					25662,
					3225
				],
				[
					15944,
					-16242
				],
				[
					11375,
					-3417
				],
				[
					2868,
					13835
				],
				[
					12462,
					-9421
				],
				[
					17267,
					8899
				],
				[
					14510,
					-10198
				],
				[
					-27043,
					-3405
				],
				[
					-11907,
					-14763
				],
				[
					-19206,
					8491
				],
				[
					-22827,
					-118
				],
				[
					-25080,
					-11200
				],
				[
					-19880,
					-2887
				],
				[
					24584,
					-3921
				],
				[
					2897,
					-6050
				],
				[
					16851,
					15509
				],
				[
					16472,
					1626
				],
				[
					28807,
					-10029
				],
				[
					-25305,
					-7777
				],
				[
					-11247,
					-11460
				],
				[
					-3526,
					-28794
				],
				[
					8521,
					23765
				],
				[
					17353,
					14051
				],
				[
					16478,
					730
				],
				[
					25873,
					-11786
				],
				[
					-8220,
					-28219
				],
				[
					-15182,
					-12463
				],
				[
					5420,
					-3921
				],
				[
					17450,
					18030
				],
				[
					10186,
					2043
				],
				[
					-5126,
					-38769
				],
				[
					9444,
					15131
				],
				[
					2534,
					23945
				],
				[
					10020,
					2683
				],
				[
					24394,
					-6402
				],
				[
					14205,
					-26328
				],
				[
					-18000,
					-10356
				],
				[
					-5168,
					-24762
				],
				[
					-15776,
					-8464
				],
				[
					14890,
					-388
				],
				[
					5031,
					-15199
				],
				[
					2517,
					32393
				],
				[
					7964,
					14809
				],
				[
					35915,
					15339
				],
				[
					-9058,
					-14814
				],
				[
					10867,
					-23302
				],
				[
					-5050,
					-3011
				],
				[
					-9223,
					-59338
				],
				[
					8922,
					7907
				],
				[
					5574,
					44157
				],
				[
					16884,
					8947
				],
				[
					3121,
					22049
				],
				[
					8306,
					10495
				],
				[
					21188,
					-151
				],
				[
					1380,
					-22791
				],
				[
					-12658,
					-36324
				],
				[
					16686,
					-11906
				],
				[
					7230,
					-26801
				],
				[
					-1909,
					26913
				],
				[
					-19830,
					17610
				],
				[
					13708,
					21175
				],
				[
					2511,
					13029
				],
				[
					21682,
					4631
				],
				[
					15994,
					24721
				],
				[
					17366,
					150
				],
				[
					25589,
					-15405
				],
				[
					-27783,
					-15403
				],
				[
					-14746,
					-22736
				],
				[
					7595,
					-806
				],
				[
					-5063,
					-15885
				],
				[
					-13567,
					-6289
				],
				[
					-965,
					-25186
				],
				[
					7129,
					23236
				],
				[
					24472,
					17685
				],
				[
					10223,
					-6454
				],
				[
					2614,
					-17832
				],
				[
					5283,
					31707
				],
				[
					26586,
					-2061
				],
				[
					35962,
					-34245
				],
				[
					-4529,
					-11651
				],
				[
					18555,
					-4463
				],
				[
					-8118,
					-29540
				],
				[
					-15476,
					-8312
				],
				[
					26201,
					4023
				],
				[
					11124,
					-11601
				],
				[
					1023,
					-17096
				],
				[
					-9893,
					-7512
				],
				[
					-87490,
					10165
				],
				[
					37013,
					-11468
				],
				[
					27608,
					-1186
				],
				[
					-17122,
					-11763
				],
				[
					-23725,
					-4838
				],
				[
					28213,
					-1108
				],
				[
					19114,
					9732
				],
				[
					25458,
					-135
				],
				[
					-2840,
					-9976
				],
				[
					-22377,
					-3128
				],
				[
					-44881,
					-14919
				],
				[
					-12913,
					-12463
				],
				[
					-3078,
					-21955
				],
				[
					8619,
					3963
				],
				[
					7596,
					22845
				],
				[
					32077,
					8073
				],
				[
					13786,
					7358
				],
				[
					20061,
					-2845
				],
				[
					14069,
					15759
				],
				[
					47270,
					-2403
				],
				[
					-8275,
					-29028
				],
				[
					-30720,
					-20766
				],
				[
					30970,
					13035
				],
				[
					13187,
					18068
				],
				[
					268,
					14604
				],
				[
					12317,
					22141
				],
				[
					24131,
					6488
				],
				[
					11593,
					-12644
				],
				[
					-4261,
					-26570
				],
				[
					-31179,
					-13661
				],
				[
					6279,
					-36440
				],
				[
					-29919,
					-8721
				],
				[
					-1022,
					-22350
				],
				[
					8955,
					19186
				],
				[
					4125,
					-25145
				],
				[
					-5499,
					-23597
				],
				[
					6793,
					832
				],
				[
					7949,
					24910
				],
				[
					-1772,
					20070
				],
				[
					10779,
					-1317
				],
				[
					12193,
					13117
				],
				[
					29687,
					-266
				],
				[
					4800,
					-29404
				],
				[
					-6179,
					-20584
				],
				[
					15771,
					9044
				],
				[
					-3844,
					37877
				],
				[
					22372,
					5087
				],
				[
					5702,
					-19845
				],
				[
					11293,
					-11927
				],
				[
					9268,
					-25131
				],
				[
					3820,
					9915
				],
				[
					-11706,
					19246
				],
				[
					-623,
					20375
				],
				[
					18758,
					1001
				],
				[
					-2862,
					27050
				],
				[
					26620,
					3621
				],
				[
					-7017,
					-37369
				],
				[
					14290,
					13354
				],
				[
					27800,
					-5991
				],
				[
					-4602,
					-9780
				],
				[
					-25430,
					-359
				],
				[
					42034,
					-4470
				],
				[
					-8184,
					-16026
				],
				[
					16841,
					1516
				],
				[
					10876,
					-16779
				],
				[
					18074,
					-15860
				],
				[
					-281,
					-13101
				],
				[
					-15937,
					-21646
				],
				[
					-19780,
					3308
				],
				[
					-16278,
					23267
				],
				[
					-26255,
					5233
				],
				[
					-13572,
					-11587
				],
				[
					17595,
					5706
				],
				[
					17701,
					-7700
				],
				[
					25909,
					-35864
				],
				[
					-48436,
					-13387
				],
				[
					47757,
					3260
				],
				[
					11184,
					-11040
				],
				[
					-7856,
					-10298
				],
				[
					-24447,
					-305
				],
				[
					-16709,
					-11852
				],
				[
					-14911,
					10360
				],
				[
					-16693,
					-2957
				],
				[
					-2333,
					23869
				],
				[
					-40482,
					3266
				],
				[
					27117,
					-28701
				],
				[
					-33720,
					-20843
				],
				[
					-16433,
					4143
				],
				[
					-1937,
					17043
				],
				[
					-8215,
					6446
				],
				[
					7706,
					-25708
				],
				[
					17503,
					-8964
				],
				[
					15481,
					8263
				],
				[
					3632,
					-10898
				],
				[
					40691,
					-9318
				],
				[
					-3788,
					-11936
				],
				[
					11159,
					-70
				],
				[
					-12335,
					-12158
				],
				[
					21863,
					305
				],
				[
					-19978,
					-12104
				],
				[
					-6043,
					4350
				],
				[
					-15815,
					-9313
				],
				[
					-18779,
					12175
				],
				[
					-31318,
					1654
				],
				[
					-19134,
					28630
				],
				[
					6428,
					-23402
				],
				[
					13608,
					-10379
				],
				[
					27490,
					-2940
				],
				[
					14563,
					-14992
				],
				[
					-7382,
					-9590
				],
				[
					18350,
					-21273
				],
				[
					-25952,
					-4645
				],
				[
					-19270,
					6187
				],
				[
					-17080,
					19594
				],
				[
					4300,
					-15689
				],
				[
					26080,
					-17605
				],
				[
					-1269,
					-11697
				],
				[
					-29729,
					14500
				],
				[
					9076,
					-13894
				],
				[
					18278,
					-12486
				],
				[
					-15536,
					-16652
				],
				[
					-16134,
					12473
				],
				[
					-9266,
					-13867
				],
				[
					-9325,
					11797
				],
				[
					-17389,
					4808
				],
				[
					-12275,
					15423
				],
				[
					-11109,
					34087
				],
				[
					-12927,
					18553
				],
				[
					-1244,
					-13449
				],
				[
					14461,
					-27300
				],
				[
					5874,
					-24394
				],
				[
					-12203,
					3613
				],
				[
					-27368,
					-5499
				],
				[
					37139,
					-5957
				],
				[
					738,
					-23122
				],
				[
					-12294,
					-2560
				],
				[
					-11649,
					18678
				],
				[
					7766,
					-31814
				],
				[
					4505,
					5195
				],
				[
					18349,
					-10428
				],
				[
					-15201,
					-5435
				],
				[
					-19865,
					8025
				],
				[
					21461,
					-20486
				],
				[
					9870,
					-30396
				],
				[
					-15105,
					488
				],
				[
					17590,
					-13563
				],
				[
					-22668,
					-336
				],
				[
					6807,
					-12762
				],
				[
					12986,
					2738
				],
				[
					-8620,
					-13081
				],
				[
					-46,
					-18774
				],
				[
					-17357,
					-23552
				],
				[
					-9523,
					-584
				],
				[
					-350,
					20962
				],
				[
					-8274,
					-10783
				],
				[
					-12911,
					5296
				],
				[
					8885,
					12114
				],
				[
					-11173,
					-204
				],
				[
					-6362,
					28700
				],
				[
					-256,
					-22247
				],
				[
					-9579,
					-2360
				],
				[
					1273,
					14305
				],
				[
					-8102,
					8674
				],
				[
					-1494,
					-20501
				],
				[
					-18835,
					8941
				],
				[
					1924,
					17227
				],
				[
					18532,
					10215
				],
				[
					-16530,
					-593
				],
				[
					-11860,
					-14473
				],
				[
					-9755,
					25501
				],
				[
					871,
					13121
				],
				[
					16134,
					19066
				],
				[
					-398,
					8933
				],
				[
					-23106,
					-28659
				],
				[
					1857,
					-25765
				],
				[
					-7377,
					-18927
				],
				[
					-13126,
					2010
				],
				[
					-9993,
					35953
				],
				[
					-8150,
					-9623
				],
				[
					-13752,
					16567
				],
				[
					14552,
					11197
				],
				[
					-14267,
					-1346
				],
				[
					26527,
					12761
				],
				[
					8464,
					8500
				],
				[
					17634,
					-2078
				],
				[
					-6042,
					8856
				],
				[
					-20274,
					-7758
				],
				[
					-34692,
					-5249
				],
				[
					-8948,
					-7923
				],
				[
					-11092,
					15423
				],
				[
					533,
					14643
				],
				[
					16860,
					4305
				],
				[
					18601,
					18999
				],
				[
					1869,
					17319
				],
				[
					-19669,
					-27899
				],
				[
					-23966,
					242
				],
				[
					5303,
					11758
				],
				[
					-15484,
					-12852
				],
				[
					841,
					21762
				],
				[
					17626,
					6483
				],
				[
					-24991,
					235
				],
				[
					-11453,
					7096
				],
				[
					8044,
					23604
				],
				[
					-11960,
					-9446
				],
				[
					15697,
					39547
				],
				[
					45068,
					21390
				],
				[
					32028,
					-10263
				],
				[
					-20478,
					14989
				],
				[
					9571,
					15059
				],
				[
					1028,
					23767
				],
				[
					25276,
					26694
				],
				[
					21423,
					8305
				],
				[
					-13036,
					3400
				],
				[
					-25101,
					-14147
				],
				[
					-18076,
					-22810
				],
				[
					1430,
					-21241
				],
				[
					-23340,
					-8570
				],
				[
					-44569,
					-22573
				],
				[
					-35855,
					-951
				],
				[
					-11416,
					-5520
				],
				[
					-11239,
					5803
				],
				[
					-1220,
					17569
				],
				[
					7298,
					12991
				],
				[
					32729,
					19471
				],
				[
					9574,
					13913
				],
				[
					5788,
					36746
				],
				[
					-10212,
					-15262
				],
				[
					-2307,
					-19128
				],
				[
					-13380,
					-15105
				],
				[
					-29605,
					-17322
				],
				[
					-20444,
					5295
				],
				[
					-11198,
					25362
				],
				[
					-22970,
					9904
				],
				[
					10318,
					-14612
				],
				[
					-15032,
					-1485
				],
				[
					-6125,
					7791
				],
				[
					8174,
					16442
				],
				[
					-14439,
					13146
				],
				[
					-19463,
					2005
				],
				[
					6268,
					14110
				],
				[
					-11844,
					5976
				],
				[
					5903,
					10670
				],
				[
					-10528,
					8760
				],
				[
					14665,
					13419
				],
				[
					-14858,
					-5260
				],
				[
					-31325,
					-20846
				],
				[
					-19743,
					19410
				],
				[
					-2360,
					9295
				],
				[
					-11354,
					-6833
				],
				[
					-16270,
					11566
				],
				[
					7380,
					-14382
				],
				[
					17171,
					-3175
				],
				[
					10374,
					-16333
				],
				[
					17041,
					-10064
				],
				[
					618,
					-15439
				],
				[
					-36639,
					15377
				],
				[
					9990,
					-11826
				],
				[
					17836,
					-7818
				],
				[
					8812,
					-11392
				],
				[
					-19563,
					-8765
				],
				[
					-14707,
					4461
				],
				[
					-9339,
					24648
				],
				[
					-36251,
					16692
				],
				[
					-3483,
					11996
				],
				[
					-15773,
					-2016
				],
				[
					13904,
					-13181
				],
				[
					19300,
					-41477
				],
				[
					-5819,
					-6859
				],
				[
					19661,
					-16672
				],
				[
					12106,
					-1593
				],
				[
					8114,
					-12675
				],
				[
					15035,
					-5716
				],
				[
					1407,
					-11668
				],
				[
					10712,
					-2340
				],
				[
					-9550,
					-13546
				],
				[
					7913,
					-18216
				],
				[
					-23690,
					3811
				],
				[
					-8935,
					-8731
				],
				[
					-25463,
					6982
				],
				[
					-10197,
					15926
				],
				[
					4344,
					-23317
				],
				[
					-22656,
					774
				],
				[
					-6940,
					-5495
				],
				[
					13552,
					-6852
				],
				[
					-14067,
					-5859
				],
				[
					1614,
					-9772
				],
				[
					19177,
					11020
				],
				[
					2977,
					-10063
				],
				[
					-14136,
					-6659
				],
				[
					7693,
					-27968
				],
				[
					-17325,
					-36456
				],
				[
					28103,
					35753
				],
				[
					38285,
					10534
				],
				[
					18316,
					-12131
				],
				[
					-919,
					-9625
				],
				[
					-20962,
					-10991
				],
				[
					-1712,
					-8202
				],
				[
					13717,
					-12422
				],
				[
					31704,
					2504
				],
				[
					-5214,
					-25746
				],
				[
					-21617,
					1392
				],
				[
					22616,
					-15023
				],
				[
					-7665,
					-12184
				],
				[
					-14230,
					605
				],
				[
					-18846,
					-9979
				],
				[
					30480,
					6113
				],
				[
					10609,
					9956
				],
				[
					-3701,
					-20105
				],
				[
					18839,
					1947
				],
				[
					-134,
					-24744
				],
				[
					5419,
					-9942
				],
				[
					8146,
					23941
				],
				[
					10709,
					3342
				],
				[
					-7078,
					-29098
				],
				[
					-11440,
					-2149
				],
				[
					19146,
					-8308
				],
				[
					534,
					-43988
				],
				[
					6191,
					-13068
				],
				[
					7149,
					4512
				],
				[
					-6216,
					13854
				],
				[
					5667,
					21310
				],
				[
					-5720,
					24433
				],
				[
					17210,
					-6606
				],
				[
					9940,
					-18827
				],
				[
					35404,
					-15721
				],
				[
					-6267,
					-21738
				],
				[
					2413,
					-20691
				],
				[
					11538,
					34120
				],
				[
					7268,
					-3104
				],
				[
					-5751,
					-20971
				],
				[
					10291,
					8914
				],
				[
					7121,
					-23408
				],
				[
					2966,
					19572
				],
				[
					-9273,
					26869
				],
				[
					3987,
					6369
				],
				[
					25013,
					-11211
				],
				[
					5145,
					-11663
				],
				[
					-8882,
					-9820
				],
				[
					3624,
					-14554
				],
				[
					3421,
					18801
				],
				[
					14005,
					-12405
				],
				[
					-2877,
					-20355
				],
				[
					-14820,
					-11211
				],
				[
					-952,
					-26387
				],
				[
					9192,
					5808
				],
				[
					17667,
					-2613
				],
				[
					16202,
					9800
				],
				[
					95,
					-12184
				],
				[
					12166,
					13053
				],
				[
					1902,
					-10354
				],
				[
					14231,
					-3694
				],
				[
					255,
					-17488
				],
				[
					-15522,
					-7975
				],
				[
					5831,
					-9681
				],
				[
					-16192,
					-11848
				],
				[
					-24542,
					9093
				],
				[
					10402,
					-14015
				],
				[
					-14300,
					-5657
				],
				[
					27939,
					-1098
				],
				[
					6423,
					-15323
				],
				[
					25810,
					-31327
				],
				[
					-16752,
					-5972
				],
				[
					9692,
					-5557
				],
				[
					25624,
					1
				],
				[
					16709,
					6203
				],
				[
					10420,
					-12181
				],
				[
					-20310,
					-12375
				],
				[
					-20881,
					-28416
				],
				[
					51722,
					-28390
				],
				[
					1623,
					-15314
				],
				[
					-9423,
					-3041
				],
				[
					7418,
					-9225
				],
				[
					6568,
					-30829
				],
				[
					-5378,
					-11725
				],
				[
					3433,
					-19675
				],
				[
					-11452,
					-6056
				],
				[
					-3065,
					-14688
				],
				[
					-10238,
					11043
				],
				[
					-7541,
					19066
				],
				[
					-9619,
					46919
				],
				[
					-9743,
					6148
				],
				[
					-3819,
					18012
				],
				[
					-11839,
					10444
				],
				[
					-23440,
					30447
				],
				[
					-2290,
					-5598
				],
				[
					20315,
					-19312
				],
				[
					17894,
					-30120
				],
				[
					-12952,
					-6693
				],
				[
					7360,
					-26523
				],
				[
					-13733,
					-5178
				],
				[
					13969,
					-2610
				],
				[
					-14723,
					-6056
				],
				[
					20392,
					-1590
				],
				[
					8613,
					-26927
				],
				[
					-5348,
					-15397
				],
				[
					-13476,
					-11164
				],
				[
					16874,
					3411
				],
				[
					12729,
					-8671
				],
				[
					4214,
					-17033
				],
				[
					-2148,
					-24616
				],
				[
					18428,
					-16848
				],
				[
					-26048,
					-8381
				],
				[
					-33930,
					24382
				],
				[
					-5635,
					-1089
				],
				[
					2893,
					-23515
				],
				[
					24511,
					-34808
				],
				[
					-986,
					-23365
				],
				[
					-16071,
					-13873
				],
				[
					-12335,
					205
				],
				[
					-13300,
					31366
				],
				[
					-1584,
					43327
				],
				[
					-9196,
					-13714
				],
				[
					-21329,
					3204
				],
				[
					-3283,
					16918
				],
				[
					-14634,
					13028
				],
				[
					-2134,
					-12809
				],
				[
					-17642,
					7241
				],
				[
					13265,
					23754
				],
				[
					-16773,
					-11945
				],
				[
					-9070,
					12013
				],
				[
					-12012,
					824
				],
				[
					13885,
					-11566
				],
				[
					-2472,
					-11087
				],
				[
					-11878,
					2623
				],
				[
					-11020,
					15917
				],
				[
					-9361,
					-5676
				],
				[
					-13479,
					12717
				],
				[
					-9939,
					28262
				],
				[
					-2819,
					-24905
				],
				[
					5980,
					-11930
				],
				[
					-19219,
					8754
				],
				[
					-9704,
					21144
				],
				[
					-8106,
					1308
				],
				[
					-18463,
					26763
				],
				[
					11703,
					6178
				],
				[
					-26314,
					-1100
				],
				[
					-19096,
					27292
				],
				[
					-21625,
					23073
				],
				[
					-1384,
					15964
				],
				[
					-6576,
					-6416
				],
				[
					-3751,
					19738
				],
				[
					-15536,
					6937
				],
				[
					-12098,
					28620
				],
				[
					8788,
					-31244
				],
				[
					-3284,
					-9727
				],
				[
					19664,
					-39489
				],
				[
					-5670,
					-13134
				],
				[
					-14671,
					14299
				],
				[
					-1439,
					9586
				],
				[
					-14914,
					18119
				],
				[
					-13300,
					4694
				],
				[
					-10746,
					13206
				],
				[
					-23646,
					9866
				],
				[
					-1695,
					15799
				],
				[
					-29230,
					10111
				],
				[
					-13022,
					-9676
				],
				[
					-25471,
					8274
				],
				[
					19509,
					-28681
				],
				[
					6138,
					-19902
				],
				[
					32761,
					-30531
				],
				[
					3736,
					-9788
				],
				[
					18799,
					-19889
				],
				[
					18041,
					-29918
				],
				[
					27784,
					-11648
				],
				[
					11433,
					-12781
				],
				[
					16407,
					3327
				],
				[
					3956,
					-8611
				],
				[
					-13300,
					-1620
				],
				[
					-8676,
					-9701
				],
				[
					11005,
					-1177
				],
				[
					15507,
					8175
				],
				[
					7106,
					-10548
				],
				[
					-18678,
					-8345
				],
				[
					8003,
					-4865
				],
				[
					16281,
					9450
				],
				[
					19460,
					-19504
				],
				[
					-8414,
					-11541
				],
				[
					16536,
					2707
				],
				[
					14474,
					-19743
				],
				[
					-4608,
					-5473
				],
				[
					24706,
					-16597
				],
				[
					19578,
					-8089
				],
				[
					-4712,
					-8086
				],
				[
					16987,
					-3553
				],
				[
					17777,
					-28841
				],
				[
					-7126,
					-17747
				],
				[
					10031,
					5319
				],
				[
					12393,
					-12036
				],
				[
					-16113,
					-11995
				],
				[
					17045,
					-17821
				],
				[
					-5999,
					18587
				],
				[
					16456,
					1835
				],
				[
					11517,
					-27493
				],
				[
					11482,
					4842
				],
				[
					12967,
					-13113
				],
				[
					-16550,
					-9654
				],
				[
					2755,
					-26051
				],
				[
					-14477,
					7483
				],
				[
					22228,
					-41445
				],
				[
					-9667,
					-10006
				],
				[
					-31127,
					-786
				],
				[
					-23379,
					10464
				],
				[
					-14039,
					11298
				],
				[
					-7866,
					14156
				],
				[
					-42355,
					5281
				],
				[
					-11428,
					10949
				],
				[
					-12712,
					-3851
				],
				[
					629,
					15064
				],
				[
					-17437,
					1435
				],
				[
					-10745,
					10606
				],
				[
					-17865,
					-6534
				],
				[
					-10681,
					9252
				],
				[
					-21643,
					-130
				],
				[
					-75029,
					21503
				],
				[
					-5273,
					22655
				],
				[
					-3373,
					-12541
				],
				[
					-9186,
					6860
				],
				[
					-18610,
					2485
				],
				[
					-12268,
					12589
				],
				[
					-14372,
					5551
				],
				[
					-15126,
					33211
				],
				[
					-12818,
					14434
				],
				[
					4532,
					-19718
				],
				[
					-20520,
					25259
				],
				[
					14385,
					3778
				],
				[
					3558,
					9832
				],
				[
					-11993,
					-3491
				],
				[
					3977,
					10639
				],
				[
					13283,
					1987
				],
				[
					-36086,
					5326
				],
				[
					-13671,
					13250
				],
				[
					-3830,
					-18049
				],
				[
					-11778,
					12543
				],
				[
					8978,
					24049
				],
				[
					-18531,
					-32035
				],
				[
					-12982,
					-7408
				],
				[
					-18342,
					13039
				],
				[
					-18735,
					19642
				],
				[
					-33920,
					4089
				],
				[
					-1678,
					9206
				],
				[
					-19114,
					12382
				],
				[
					-16378,
					-597
				],
				[
					-1115,
					12085
				],
				[
					13852,
					-2123
				],
				[
					8757,
					9143
				],
				[
					3190,
					16950
				],
				[
					-7390,
					4412
				],
				[
					-2781,
					-21325
				],
				[
					-18564,
					-213
				],
				[
					-9901,
					-8322
				],
				[
					-18861,
					5689
				],
				[
					2676,
					6925
				],
				[
					-28634,
					14171
				],
				[
					-7907,
					30939
				],
				[
					-9671,
					14020
				],
				[
					9834,
					11158
				],
				[
					-40874,
					7233
				],
				[
					-6265,
					9301
				],
				[
					22621,
					1478
				],
				[
					34951,
					-8053
				],
				[
					16844,
					16604
				],
				[
					13028,
					2617
				],
				[
					-1858,
					8006
				],
				[
					14729,
					8385
				],
				[
					-33068,
					5785
				],
				[
					2699,
					8765
				],
				[
					-14979,
					22306
				],
				[
					-21144,
					18708
				],
				[
					-3886,
					-29582
				],
				[
					-18187,
					-4611
				],
				[
					-16895,
					23181
				],
				[
					-2539,
					-17449
				],
				[
					-16238,
					15138
				],
				[
					9260,
					10044
				],
				[
					9081,
					23234
				],
				[
					-7196,
					19316
				],
				[
					-1161,
					-20627
				],
				[
					-6892,
					6430
				],
				[
					-11017,
					-19439
				],
				[
					6138,
					-8845
				],
				[
					-16673,
					-130
				],
				[
					5469,
					12940
				],
				[
					-17297,
					10826
				],
				[
					-3624,
					16513
				],
				[
					6060,
					20123
				],
				[
					-12070,
					2643
				],
				[
					6244,
					-14350
				],
				[
					-8800,
					-4897
				],
				[
					-2948,
					11236
				],
				[
					-25301,
					13820
				],
				[
					10198,
					7007
				],
				[
					-3003,
					21569
				],
				[
					-21012,
					4097
				],
				[
					7549,
					12099
				],
				[
					-33582,
					16404
				],
				[
					5670,
					-13383
				],
				[
					-13918,
					4005
				],
				[
					6051,
					28192
				],
				[
					-10023,
					-6843
				],
				[
					-7902,
					8932
				],
				[
					11856,
					25602
				],
				[
					7306,
					-1883
				],
				[
					17458,
					24079
				],
				[
					-13850,
					-995
				],
				[
					-99,
					16185
				],
				[
					-6809,
					-5028
				],
				[
					8926,
					-23753
				],
				[
					-28938,
					-9709
				],
				[
					1662,
					-18084
				],
				[
					-11245,
					-26919
				],
				[
					-6239,
					4636
				],
				[
					-2161,
					24515
				],
				[
					10992,
					4537
				],
				[
					-11637,
					14093
				],
				[
					6491,
					10591
				],
				[
					17823,
					3319
				],
				[
					1357,
					11199
				],
				[
					-12444,
					-8207
				],
				[
					-5957,
					7754
				],
				[
					-14046,
					-18897
				],
				[
					-20175,
					17406
				],
				[
					8738,
					-24492
				],
				[
					-14960,
					-17899
				],
				[
					5049,
					-9585
				],
				[
					-18590,
					-16155
				],
				[
					-2346,
					13221
				],
				[
					10849,
					11908
				],
				[
					-2862,
					16683
				],
				[
					-9320,
					9761
				],
				[
					17219,
					-474
				],
				[
					-20416,
					8906
				],
				[
					20967,
					683
				],
				[
					-10073,
					9570
				],
				[
					3315,
					25043
				],
				[
					-6578,
					7778
				],
				[
					-192,
					-19137
				],
				[
					-10437,
					-4633
				],
				[
					-4368,
					-21288
				],
				[
					-23257,
					24540
				],
				[
					11078,
					-19522
				],
				[
					-7035,
					-3800
				],
				[
					-33028,
					39506
				],
				[
					15788,
					22977
				],
				[
					628,
					12715
				],
				[
					-12113,
					2282
				],
				[
					-10265,
					-13706
				],
				[
					6839,
					-5875
				],
				[
					-4596,
					-12314
				],
				[
					-9869,
					8679
				],
				[
					-6705,
					-8755
				],
				[
					7140,
					-15029
				],
				[
					16890,
					-7913
				],
				[
					20872,
					-24496
				],
				[
					-7936,
					-8333
				],
				[
					-16497,
					3184
				],
				[
					20936,
					-22429
				],
				[
					-16519,
					-9154
				],
				[
					-2195,
					-9462
				],
				[
					-31409,
					8721
				],
				[
					-27065,
					20685
				],
				[
					1991,
					-10672
				],
				[
					-45130,
					28226
				],
				[
					-4060,
					-6037
				],
				[
					-23824,
					15214
				],
				[
					-21516,
					20504
				]
			],
			[
				[
					4586921,
					7612608
				],
				[
					25064,
					10534
				],
				[
					24443,
					-20358
				],
				[
					29640,
					702
				],
				[
					-34498,
					13901
				],
				[
					-27164,
					31584
				],
				[
					-10128,
					3118
				],
				[
					7487,
					-18900
				],
				[
					-26048,
					-9196
				],
				[
					-24059,
					-2010
				]
			],
			[
				[
					4524120,
					7628955
				],
				[
					-29743,
					13493
				],
				[
					-38112,
					31888
				],
				[
					19466,
					13462
				],
				[
					20720,
					2389
				],
				[
					7514,
					12204
				],
				[
					37451,
					-2421
				],
				[
					22894,
					-31411
				],
				[
					20367,
					-4031
				],
				[
					-14480,
					11062
				],
				[
					8955,
					15127
				],
				[
					-11140,
					8404
				],
				[
					-30210,
					6982
				],
				[
					4441,
					10332
				],
				[
					-23669,
					6249
				],
				[
					-6053,
					10013
				],
				[
					26927,
					22193
				],
				[
					38538,
					9035
				],
				[
					58011,
					-23848
				],
				[
					21268,
					18889
				],
				[
					-34909,
					-3303
				],
				[
					-17101,
					8554
				],
				[
					4408,
					12157
				],
				[
					35086,
					8510
				],
				[
					21146,
					-4003
				],
				[
					5219,
					-19862
				],
				[
					28519,
					-6006
				],
				[
					29829,
					-22082
				],
				[
					46858,
					4657
				],
				[
					52045,
					9864
				],
				[
					45867,
					13352
				],
				[
					20581,
					15122
				],
				[
					-4820,
					-13285
				],
				[
					18735,
					9161
				],
				[
					17385,
					-8848
				],
				[
					31344,
					-777
				],
				[
					30394,
					-38868
				],
				[
					-3432,
					-14727
				],
				[
					-14751,
					-4010
				],
				[
					-12568,
					-14961
				],
				[
					-28115,
					7479
				],
				[
					-707,
					-17207
				],
				[
					-13571,
					5982
				],
				[
					-10772,
					-16441
				],
				[
					27297,
					5433
				],
				[
					29079,
					-11193
				],
				[
					-9518,
					-18883
				],
				[
					-48544,
					-12482
				],
				[
					-18411,
					-12179
				],
				[
					-14607,
					-22394
				],
				[
					-27190,
					-23844
				],
				[
					-29078,
					-12648
				],
				[
					4403,
					-13560
				]
			],
			[
				[
					5775567,
					7811914
				],
				[
					908,
					-16146
				],
				[
					-30811,
					3535
				],
				[
					783,
					9394
				],
				[
					29120,
					3217
				]
			],
			[
				[
					4902117,
					7824423
				],
				[
					7526,
					-9616
				],
				[
					-17740,
					-21576
				],
				[
					-34365,
					-21529
				],
				[
					-34708,
					-11424
				],
				[
					-28148,
					-2690
				],
				[
					-13221,
					9907
				],
				[
					2858,
					-15038
				],
				[
					-14065,
					7405
				],
				[
					-41052,
					336
				],
				[
					-25094,
					15079
				],
				[
					40113,
					11208
				],
				[
					34508,
					18616
				],
				[
					38677,
					2596
				],
				[
					47411,
					15460
				],
				[
					37300,
					1266
				]
			],
			[
				[
					5192616,
					7425906
				],
				[
					-18132,
					16739
				],
				[
					-8722,
					27314
				],
				[
					-21534,
					8734
				],
				[
					-7827,
					12797
				],
				[
					6980,
					12914
				],
				[
					-13557,
					3517
				],
				[
					6854,
					31669
				],
				[
					-10287,
					14381
				],
				[
					8403,
					7613
				],
				[
					-1002,
					25580
				],
				[
					8323,
					6829
				],
				[
					-1848,
					31910
				],
				[
					-10143,
					40153
				],
				[
					12807,
					29769
				],
				[
					-11162,
					20098
				],
				[
					1855,
					17701
				],
				[
					39532,
					9539
				],
				[
					30162,
					-23880
				],
				[
					22453,
					-7722
				],
				[
					25150,
					5352
				],
				[
					-28571,
					2843
				],
				[
					-53684,
					56192
				],
				[
					2559,
					16832
				],
				[
					54887,
					20295
				],
				[
					9037,
					7506
				],
				[
					29295,
					-333
				],
				[
					6128,
					5869
				],
				[
					68701,
					4374
				],
				[
					28044,
					8191
				],
				[
					25771,
					-704
				],
				[
					70007,
					-11841
				],
				[
					48811,
					-20665
				],
				[
					16550,
					-21412
				],
				[
					25784,
					16474
				],
				[
					43574,
					3139
				],
				[
					45922,
					-4004
				],
				[
					56684,
					-13408
				],
				[
					27148,
					-9959
				],
				[
					23271,
					-553
				],
				[
					-5940,
					-15032
				],
				[
					-14866,
					2577
				],
				[
					960,
					-18108
				],
				[
					-17193,
					-24006
				],
				[
					-31904,
					-33198
				],
				[
					-17165,
					-445
				],
				[
					2937,
					-10332
				],
				[
					-41814,
					-60288
				],
				[
					-33845,
					-3248
				],
				[
					26748,
					-6823
				],
				[
					-31073,
					-53293
				],
				[
					-18965,
					-27953
				],
				[
					-25597,
					-26043
				],
				[
					-29402,
					-14961
				],
				[
					-60177,
					9455
				],
				[
					-45513,
					10075
				],
				[
					-6368,
					6930
				],
				[
					-37345,
					-8511
				],
				[
					-56811,
					-3392
				],
				[
					-21173,
					1981
				],
				[
					-3401,
					-11387
				],
				[
					53780,
					-4073
				],
				[
					4659,
					-11641
				],
				[
					33341,
					-28110
				],
				[
					7161,
					-20500
				],
				[
					-11674,
					-8624
				],
				[
					-10575,
					-21364
				],
				[
					-20820,
					-6155
				],
				[
					-5395,
					-13412
				]
			],
			[
				[
					4801733,
					7879124
				],
				[
					8307,
					-7977
				],
				[
					-34130,
					-1175
				],
				[
					25823,
					9152
				]
			],
			[
				[
					4950685,
					7940110
				],
				[
					-12611,
					-19836
				],
				[
					-33763,
					-11966
				],
				[
					-12015,
					5574
				],
				[
					38213,
					34666
				],
				[
					20176,
					-8438
				]
			],
			[
				[
					5140047,
					7952494
				],
				[
					27503,
					-12432
				],
				[
					12572,
					-18582
				],
				[
					-28107,
					-4136
				],
				[
					-34361,
					13708
				],
				[
					10465,
					21122
				],
				[
					11928,
					320
				]
			],
			[
				[
					4164859,
					8144114
				],
				[
					27066,
					-8083
				],
				[
					24439,
					-26314
				],
				[
					-826,
					-15905
				],
				[
					19061,
					-15604
				],
				[
					-29783,
					-25236
				],
				[
					-27482,
					-6244
				],
				[
					-37741,
					-1303
				],
				[
					-54897,
					21704
				],
				[
					13722,
					16691
				],
				[
					9114,
					29606
				],
				[
					22697,
					23745
				],
				[
					34630,
					6943
				]
			],
			[
				[
					4609942,
					8189484
				],
				[
					-7204,
					-8083
				],
				[
					-61931,
					-11666
				],
				[
					-12476,
					4940
				],
				[
					81611,
					14809
				]
			],
			[
				[
					5216579,
					8192053
				],
				[
					65906,
					-11752
				],
				[
					53478,
					-45566
				],
				[
					23207,
					-11079
				],
				[
					16562,
					-19844
				],
				[
					-9406,
					-17832
				],
				[
					12595,
					-15725
				],
				[
					-4731,
					-23407
				],
				[
					10987,
					-17285
				],
				[
					2774,
					-21401
				],
				[
					-10752,
					-49197
				],
				[
					-26758,
					-7844
				],
				[
					-105130,
					-2122
				],
				[
					-21182,
					14022
				],
				[
					-27101,
					-2305
				],
				[
					2647,
					17103
				],
				[
					-33036,
					12713
				],
				[
					-20908,
					-14217
				],
				[
					2998,
					19152
				],
				[
					-24256,
					-1730
				],
				[
					-27415,
					10984
				],
				[
					-19308,
					16596
				],
				[
					-23791,
					-5507
				],
				[
					-2777,
					23443
				],
				[
					-29390,
					-3407
				],
				[
					4023,
					20875
				],
				[
					16969,
					30283
				],
				[
					24840,
					11484
				],
				[
					22958,
					-2741
				],
				[
					-14608,
					13524
				],
				[
					23466,
					21710
				],
				[
					-22774,
					5619
				],
				[
					22224,
					7240
				],
				[
					28067,
					-8051
				],
				[
					-14849,
					11170
				],
				[
					3481,
					11907
				],
				[
					39240,
					16671
				],
				[
					12608,
					-6256
				],
				[
					11793,
					9532
				],
				[
					37349,
					13240
				]
			],
			[
				[
					5059574,
					8194359
				],
				[
					44188,
					-18415
				],
				[
					-24574,
					-26984
				],
				[
					-41911,
					21148
				],
				[
					4022,
					-20579
				],
				[
					-15928,
					-14453
				],
				[
					-27486,
					-11640
				],
				[
					-19637,
					25311
				],
				[
					1012,
					11182
				],
				[
					70011,
					18281
				],
				[
					10303,
					16149
				]
			],
			[
				[
					5009956,
					8192752
				],
				[
					-24115,
					-12718
				],
				[
					2302,
					10097
				],
				[
					21813,
					2621
				]
			],
			[
				[
					5040401,
					8227770
				],
				[
					-26711,
					-11413
				],
				[
					8582,
					13498
				],
				[
					18129,
					-2085
				]
			],
			[
				[
					4252748,
					8251713
				],
				[
					5363,
					-7332
				],
				[
					-38089,
					-4822
				],
				[
					-15371,
					9740
				],
				[
					48097,
					2414
				]
			],
			[
				[
					5264731,
					8274329
				],
				[
					23237,
					-47435
				],
				[
					-2268,
					-6390
				],
				[
					-41307,
					-2280
				],
				[
					-17292,
					11750
				],
				[
					-2973,
					36808
				],
				[
					40603,
					7547
				]
			],
			[
				[
					4398705,
					8278485
				],
				[
					18415,
					-11354
				],
				[
					-52990,
					-18882
				],
				[
					-13032,
					-22617
				],
				[
					-36442,
					-7303
				],
				[
					-52807,
					1190
				],
				[
					3539,
					12876
				],
				[
					20877,
					8373
				],
				[
					6413,
					13774
				],
				[
					59294,
					15757
				],
				[
					46733,
					8186
				]
			],
			[
				[
					4364985,
					8302095
				],
				[
					14105,
					-5397
				],
				[
					-3524,
					-14496
				],
				[
					-116284,
					-25848
				],
				[
					-35309,
					-3496
				],
				[
					-25080,
					3055
				],
				[
					-5983,
					9929
				],
				[
					45143,
					7562
				],
				[
					80594,
					23099
				],
				[
					46338,
					5592
				]
			],
			[
				[
					7026782,
					8307026
				],
				[
					11992,
					-6866
				],
				[
					-12837,
					-14982
				],
				[
					-30334,
					-18723
				],
				[
					18250,
					-16923
				],
				[
					-24628,
					272
				],
				[
					-39545,
					-12993
				],
				[
					2427,
					9339
				],
				[
					-21333,
					4355
				],
				[
					58058,
					35195
				],
				[
					14563,
					21726
				],
				[
					23387,
					-400
				]
			],
			[
				[
					5226365,
					8307269
				],
				[
					-8947,
					-15799
				],
				[
					-13696,
					-915
				],
				[
					-15145,
					17918
				],
				[
					37788,
					-1204
				]
			],
			[
				[
					6762223,
					8323776
				],
				[
					-8030,
					-9946
				],
				[
					-18501,
					3337
				],
				[
					26531,
					6609
				]
			],
			[
				[
					4316638,
					8355875
				],
				[
					13604,
					94
				],
				[
					26052,
					-25490
				],
				[
					-18676,
					-23756
				],
				[
					-40998,
					-11720
				],
				[
					-100698,
					-7195
				],
				[
					6097,
					5267
				],
				[
					-60781,
					8023
				],
				[
					-8624,
					12624
				],
				[
					15655,
					15667
				],
				[
					141348,
					25848
				],
				[
					27021,
					638
				]
			],
			[
				[
					5841227,
					8386512
				],
				[
					-29514,
					439
				],
				[
					11261,
					7702
				],
				[
					18253,
					-8141
				]
			],
			[
				[
					6439905,
					8399746
				],
				[
					21241,
					-8407
				],
				[
					-8611,
					-10777
				],
				[
					-16104,
					6740
				],
				[
					3474,
					12444
				]
			],
			[
				[
					4861322,
					8418136
				],
				[
					27838,
					-7599
				],
				[
					-22656,
					-2746
				],
				[
					-5182,
					10345
				]
			],
			[
				[
					4175662,
					8442465
				],
				[
					20035,
					-5038
				],
				[
					-3904,
					-15828
				],
				[
					24638,
					4725
				],
				[
					21365,
					-21682
				],
				[
					63393,
					-17050
				],
				[
					-22192,
					-21896
				],
				[
					-40101,
					-10166
				],
				[
					-28893,
					-1808
				],
				[
					-61261,
					3897
				],
				[
					-10898,
					42089
				],
				[
					-14758,
					-4141
				],
				[
					-10783,
					28251
				],
				[
					45750,
					18759
				],
				[
					17609,
					-112
				]
			],
			[
				[
					4788848,
					8444592
				],
				[
					33417,
					-5661
				],
				[
					-1811,
					-10370
				],
				[
					30387,
					-8423
				],
				[
					-27219,
					-1741
				],
				[
					19014,
					-8099
				],
				[
					47522,
					-5847
				],
				[
					12910,
					-7162
				],
				[
					2723,
					-18190
				],
				[
					-15364,
					-24899
				],
				[
					32525,
					-26157
				],
				[
					3627,
					-17050
				],
				[
					-14395,
					-16543
				],
				[
					-6239,
					-22263
				],
				[
					11789,
					-24333
				],
				[
					-10950,
					-18234
				],
				[
					-33179,
					-14363
				],
				[
					63479,
					-10342
				],
				[
					-4779,
					-20100
				],
				[
					3821,
					-37842
				],
				[
					11322,
					-15599
				],
				[
					-21212,
					10642
				],
				[
					-1612,
					14101
				],
				[
					-25800,
					19285
				],
				[
					-11653,
					-8265
				],
				[
					3037,
					-20269
				],
				[
					-13471,
					16066
				],
				[
					-3004,
					-12497
				],
				[
					13039,
					-13812
				],
				[
					-23089,
					-22516
				],
				[
					14396,
					-3487
				],
				[
					16969,
					-18483
				],
				[
					-4612,
					-7311
				],
				[
					25071,
					-13009
				],
				[
					-31601,
					-8196
				],
				[
					-32148,
					19420
				],
				[
					-116,
					-9459
				],
				[
					19954,
					-8735
				],
				[
					438,
					-19654
				],
				[
					-42248,
					-1166
				],
				[
					-14958,
					-5924
				],
				[
					-54235,
					1704
				],
				[
					-44422,
					-4848
				],
				[
					-7726,
					11505
				],
				[
					15727,
					17584
				],
				[
					-19064,
					-9111
				],
				[
					-2584,
					-18349
				],
				[
					-11273,
					-5244
				],
				[
					-61837,
					3157
				],
				[
					-31667,
					10760
				],
				[
					-503,
					31049
				],
				[
					-16931,
					10016
				],
				[
					12738,
					6405
				],
				[
					49971,
					3385
				],
				[
					-45682,
					6291
				],
				[
					21870,
					11769
				],
				[
					-37380,
					-5134
				],
				[
					-29742,
					14277
				],
				[
					24629,
					-1197
				],
				[
					14187,
					10135
				],
				[
					-31977,
					9899
				],
				[
					81388,
					5707
				],
				[
					-34008,
					4694
				],
				[
					72401,
					8913
				],
				[
					-42997,
					-1599
				],
				[
					-29632,
					4131
				],
				[
					30772,
					5744
				],
				[
					42834,
					16122
				],
				[
					-23427,
					1412
				],
				[
					14985,
					9031
				],
				[
					31662,
					5631
				],
				[
					64803,
					2018
				],
				[
					-4191,
					5329
				],
				[
					-72562,
					-8933
				],
				[
					-8687,
					4207
				],
				[
					-105445,
					-11112
				],
				[
					-88926,
					-17188
				],
				[
					1070,
					6312
				],
				[
					-74661,
					-12205
				],
				[
					-48162,
					-2288
				],
				[
					-27200,
					-9738
				],
				[
					1075,
					8740
				],
				[
					-23550,
					19746
				],
				[
					21706,
					6151
				],
				[
					10643,
					17074
				],
				[
					36510,
					6755
				],
				[
					12414,
					12021
				],
				[
					-24645,
					-2734
				],
				[
					1624,
					12679
				],
				[
					21846,
					11716
				],
				[
					31879,
					4955
				],
				[
					48367,
					-19402
				],
				[
					-18677,
					24435
				],
				[
					35934,
					21196
				],
				[
					-42527,
					-8526
				],
				[
					-18639,
					10375
				],
				[
					-8652,
					23363
				],
				[
					15679,
					14417
				],
				[
					36501,
					10422
				],
				[
					-76396,
					-397
				],
				[
					8646,
					9802
				],
				[
					-6227,
					20901
				],
				[
					22930,
					24857
				],
				[
					45631,
					-583
				],
				[
					24282,
					-7499
				],
				[
					19346,
					-14937
				],
				[
					-2611,
					-27108
				],
				[
					29654,
					-3826
				],
				[
					30265,
					-21189
				],
				[
					-11697,
					-11483
				],
				[
					45772,
					-7854
				],
				[
					10860,
					-18595
				],
				[
					32768,
					-25135
				],
				[
					23462,
					8989
				],
				[
					11156,
					13333
				],
				[
					-27969,
					4041
				],
				[
					-24650,
					13312
				],
				[
					-3899,
					28632
				],
				[
					47220,
					-4019
				],
				[
					-29240,
					15188
				],
				[
					-23611,
					-3326
				],
				[
					-32064,
					6635
				],
				[
					-7250,
					10306
				],
				[
					20729,
					6406
				],
				[
					53734,
					-1777
				],
				[
					-45995,
					25563
				],
				[
					-52825,
					-1163
				],
				[
					-30479,
					28740
				],
				[
					59712,
					27696
				],
				[
					27370,
					7154
				],
				[
					36131,
					-7890
				],
				[
					38948,
					2763
				],
				[
					55749,
					-55220
				],
				[
					-5468,
					14819
				],
				[
					19555,
					3950
				],
				[
					-13343,
					14826
				],
				[
					7945,
					18271
				],
				[
					57273,
					6261
				],
				[
					-43421,
					8420
				],
				[
					20423,
					3999
				]
			],
			[
				[
					4681442,
					8460836
				],
				[
					27214,
					-11778
				],
				[
					-13218,
					-7690
				],
				[
					-43229,
					14846
				],
				[
					29233,
					4622
				]
			],
			[
				[
					4586599,
					8462521
				],
				[
					22399,
					-6915
				],
				[
					-57742,
					-24196
				],
				[
					-63978,
					-18208
				],
				[
					-39714,
					8639
				],
				[
					75059,
					22923
				],
				[
					4746,
					9072
				],
				[
					27796,
					8007
				],
				[
					31434,
					678
				]
			],
			[
				[
					3527964,
					8166466
				],
				[
					64316,
					-3062
				],
				[
					43593,
					-10006
				],
				[
					-1191,
					27587
				],
				[
					10732,
					4467
				],
				[
					-27205,
					31064
				],
				[
					-70603,
					15812
				],
				[
					4263,
					15940
				],
				[
					-24025,
					-1956
				]
			],
			[
				[
					3527780,
					8262863
				],
				[
					25081,
					5900
				],
				[
					39102,
					23283
				],
				[
					-373,
					11977
				],
				[
					-24479,
					18977
				],
				[
					-28265,
					3628
				],
				[
					-11239,
					11361
				]
			],
			[
				[
					3527512,
					8401123
				],
				[
					14790,
					-264
				],
				[
					-12,
					23420
				],
				[
					11169,
					-5110
				],
				[
					11700,
					28583
				],
				[
					25244,
					25101
				],
				[
					56271,
					7478
				],
				[
					19450,
					-3945
				],
				[
					-10237,
					-11159
				],
				[
					31175,
					-5384
				],
				[
					3869,
					-8764
				],
				[
					-36029,
					-24098
				],
				[
					25537,
					-12648
				],
				[
					-13251,
					-11742
				],
				[
					17519,
					-12202
				],
				[
					-14130,
					-10331
				],
				[
					35697,
					-6726
				],
				[
					22073,
					-38262
				],
				[
					-32852,
					-13571
				],
				[
					-10131,
					-19259
				],
				[
					8048,
					-10213
				],
				[
					64678,
					1740
				],
				[
					18319,
					-20336
				],
				[
					-42463,
					-34830
				],
				[
					14857,
					-8099
				],
				[
					16420,
					21529
				],
				[
					31963,
					6497
				],
				[
					48695,
					-4721
				],
				[
					-9694,
					-11187
				],
				[
					24369,
					-46100
				],
				[
					2916,
					27320
				],
				[
					31350,
					6762
				],
				[
					-33090,
					9394
				],
				[
					-1855,
					23208
				],
				[
					39654,
					32772
				],
				[
					67787,
					-12369
				],
				[
					45345,
					-21867
				],
				[
					14651,
					-19136
				],
				[
					4298,
					-52809
				],
				[
					-8341,
					-16812
				],
				[
					-29201,
					-17437
				],
				[
					13358,
					-12421
				],
				[
					-3093,
					-17028
				],
				[
					-25525,
					-19974
				],
				[
					-8004,
					-14939
				],
				[
					12829,
					-9023
				],
				[
					-31652,
					-19879
				],
				[
					10776,
					-11189
				],
				[
					-26464,
					-8322
				],
				[
					-62389,
					-5586
				],
				[
					-266,
					-8901
				],
				[
					-46168,
					-11631
				],
				[
					-54073,
					15298
				],
				[
					-6245,
					14337
				],
				[
					-30672,
					-8535
				],
				[
					6306,
					-10876
				],
				[
					-52007,
					-8646
				],
				[
					-22123,
					31983
				],
				[
					-22637,
					5488
				],
				[
					-16866,
					-16682
				],
				[
					-41297,
					-11524
				],
				[
					-26095,
					-23616
				],
				[
					-33712,
					3466
				]
			],
			[
				[
					5772657,
					8482003
				],
				[
					31921,
					-24074
				],
				[
					-13514,
					-17440
				],
				[
					-1157,
					-29334
				],
				[
					18247,
					-9721
				],
				[
					-32692,
					-9155
				],
				[
					-27804,
					12995
				],
				[
					-13774,
					23391
				],
				[
					-29497,
					25218
				],
				[
					12476,
					18265
				],
				[
					55794,
					9855
				]
			],
			[
				[
					4959340,
					8486128
				],
				[
					20418,
					-10157
				],
				[
					-9560,
					-5596
				],
				[
					-10858,
					15753
				]
			],
			[
				[
					4952411,
					8529775
				],
				[
					15683,
					-7431
				],
				[
					-36574,
					-8486
				],
				[
					20891,
					15917
				]
			],
			[
				[
					5127591,
					8536722
				],
				[
					30620,
					-2328
				],
				[
					25698,
					-15562
				],
				[
					78403,
					-6412
				],
				[
					22160,
					-18157
				],
				[
					31553,
					1214
				],
				[
					3847,
					8671
				],
				[
					42080,
					-7435
				],
				[
					1582,
					-10445
				],
				[
					34964,
					-26605
				],
				[
					12802,
					-413
				],
				[
					-598,
					-16692
				],
				[
					-13410,
					-31590
				],
				[
					-39680,
					-23398
				],
				[
					28691,
					1777
				],
				[
					33348,
					33738
				],
				[
					24893,
					5953
				],
				[
					20982,
					-6839
				],
				[
					62183,
					5107
				],
				[
					26661,
					13789
				],
				[
					52896,
					4827
				],
				[
					52056,
					-9181
				],
				[
					18584,
					-14626
				],
				[
					28156,
					-7955
				],
				[
					9993,
					-23402
				],
				[
					-40518,
					-1105
				],
				[
					-58075,
					13388
				],
				[
					-6520,
					-11088
				],
				[
					46045,
					-3986
				],
				[
					38036,
					-8413
				],
				[
					7395,
					-6970
				],
				[
					28839,
					2173
				],
				[
					62381,
					-17047
				],
				[
					57699,
					-6576
				],
				[
					11697,
					-13780
				],
				[
					-14237,
					-12039
				],
				[
					-53267,
					-7326
				],
				[
					-124408,
					2698
				],
				[
					-40165,
					11635
				],
				[
					-21730,
					-17421
				],
				[
					22087,
					4080
				],
				[
					65103,
					-11028
				],
				[
					-21981,
					-13528
				],
				[
					42124,
					6883
				],
				[
					33311,
					-7703
				],
				[
					-26586,
					-7296
				],
				[
					-58061,
					-3262
				],
				[
					-15471,
					-5871
				],
				[
					17140,
					-18315
				],
				[
					14022,
					16861
				],
				[
					40472,
					-972
				],
				[
					28534,
					-11321
				],
				[
					15419,
					18850
				],
				[
					43386,
					-29728
				],
				[
					-16335,
					-14525
				],
				[
					13990,
					-6106
				],
				[
					13502,
					13525
				],
				[
					41280,
					-16965
				],
				[
					4665,
					-9928
				],
				[
					-9529,
					-29609
				],
				[
					-31427,
					-4833
				],
				[
					-14810,
					4148
				],
				[
					15824,
					-17742
				],
				[
					9515,
					9377
				],
				[
					23485,
					-330
				],
				[
					12674,
					-25509
				],
				[
					22098,
					-13331
				],
				[
					15510,
					1524
				],
				[
					-14769,
					43643
				],
				[
					17803,
					16883
				],
				[
					61157,
					-35622
				],
				[
					88,
					-11453
				],
				[
					54233,
					20864
				],
				[
					9892,
					-12488
				],
				[
					23855,
					-9593
				],
				[
					-12492,
					18595
				],
				[
					26439,
					14475
				],
				[
					22721,
					-9444
				],
				[
					8089,
					-13448
				],
				[
					22892,
					-10643
				],
				[
					30811,
					-3026
				],
				[
					21737,
					-11239
				],
				[
					-27725,
					-10958
				],
				[
					8113,
					-4037
				],
				[
					51385,
					15081
				],
				[
					31713,
					-442
				],
				[
					-36781,
					15214
				],
				[
					2367,
					8718
				],
				[
					32878,
					5002
				],
				[
					29698,
					14493
				],
				[
					23169,
					-5409
				],
				[
					31958,
					19792
				],
				[
					52805,
					-7896
				],
				[
					-8925,
					16743
				],
				[
					39742,
					1739
				],
				[
					16110,
					14616
				],
				[
					19416,
					709
				],
				[
					6014,
					13359
				],
				[
					25510,
					62
				],
				[
					37334,
					-19440
				],
				[
					52246,
					2294
				],
				[
					32921,
					13954
				],
				[
					34640,
					6100
				],
				[
					50628,
					-7100
				],
				[
					49837,
					-1483
				],
				[
					42207,
					-8543
				],
				[
					-22444,
					-27418
				],
				[
					33445,
					-6304
				],
				[
					54486,
					7238
				],
				[
					30122,
					-6108
				],
				[
					21068,
					-12181
				],
				[
					2649,
					-12929
				],
				[
					-37364,
					-16391
				],
				[
					45393,
					4824
				],
				[
					45082,
					-4613
				],
				[
					-12671,
					-6325
				],
				[
					19277,
					-9727
				],
				[
					-5849,
					-27368
				],
				[
					6065,
					-13375
				],
				[
					-25788,
					-14606
				],
				[
					-8946,
					2395
				],
				[
					-17032,
					-19555
				],
				[
					-34559,
					-7171
				],
				[
					-9220,
					-14247
				],
				[
					30962,
					-12060
				],
				[
					5253,
					11324
				],
				[
					29265,
					6820
				],
				[
					29113,
					-4997
				],
				[
					13704,
					-33305
				],
				[
					-64588,
					-13670
				],
				[
					-34906,
					13883
				],
				[
					-6956,
					16225
				],
				[
					-13054,
					-8458
				],
				[
					35058,
					-20215
				],
				[
					-14417,
					-14191
				],
				[
					12320,
					-10860
				],
				[
					-11144,
					-6334
				],
				[
					-802,
					-25901
				],
				[
					-34656,
					-4440
				],
				[
					-74735,
					3654
				],
				[
					-59154,
					-26442
				],
				[
					-32416,
					3972
				],
				[
					-46325,
					17225
				],
				[
					-12231,
					-9336
				],
				[
					-27242,
					2390
				],
				[
					-33157,
					25894
				],
				[
					-4546,
					46132
				],
				[
					-12628,
					-3188
				],
				[
					-30124,
					21795
				],
				[
					-6170,
					-7643
				],
				[
					28844,
					-27293
				],
				[
					-16435,
					-33296
				],
				[
					-14872,
					-18951
				],
				[
					-29802,
					2607
				],
				[
					-45254,
					-11575
				],
				[
					-44310,
					-827
				],
				[
					-6841,
					6653
				],
				[
					-23545,
					-6719
				],
				[
					-10283,
					35891
				],
				[
					-5966,
					691
				],
				[
					-6755,
					-37280
				],
				[
					-27629,
					-217
				],
				[
					-18049,
					45020
				],
				[
					3703,
					-31441
				],
				[
					-14427,
					-14307
				],
				[
					-58020,
					-3758
				],
				[
					3935,
					19552
				],
				[
					-15158,
					8898
				],
				[
					1671,
					-15008
				],
				[
					-25631,
					-14037
				],
				[
					-21452,
					8758
				],
				[
					-16933,
					17761
				],
				[
					-4608,
					-8151
				],
				[
					21825,
					-21055
				],
				[
					-79782,
					1402
				],
				[
					-13063,
					12293
				],
				[
					-2077,
					-11951
				],
				[
					-30631,
					-3757
				],
				[
					-5313,
					14561
				],
				[
					-12986,
					-11297
				],
				[
					-75321,
					7177
				],
				[
					-1065,
					25484
				],
				[
					17583,
					32527
				],
				[
					-11065,
					10215
				],
				[
					1651,
					15015
				],
				[
					-29206,
					-16494
				],
				[
					-5077,
					-23161
				],
				[
					-10780,
					-6097
				],
				[
					-2733,
					28545
				],
				[
					-21021,
					-14548
				],
				[
					-1481,
					-21485
				],
				[
					-16337,
					-12226
				],
				[
					-21684,
					-5345
				],
				[
					-59498,
					-5374
				],
				[
					-46543,
					18352
				],
				[
					-25067,
					2888
				],
				[
					-24401,
					25735
				],
				[
					-7996,
					-9959
				],
				[
					-13926,
					5673
				],
				[
					30237,
					30995
				],
				[
					1220,
					11906
				],
				[
					-41198,
					-34574
				],
				[
					-13469,
					-2629
				],
				[
					14129,
					-23070
				],
				[
					-21563,
					-1989
				],
				[
					-45434,
					10721
				],
				[
					10271,
					6895
				],
				[
					-48772,
					17959
				],
				[
					-265,
					45062
				],
				[
					-22271,
					16752
				],
				[
					2080,
					10557
				],
				[
					21946,
					4079
				],
				[
					-28231,
					9147
				],
				[
					-25821,
					20796
				],
				[
					12864,
					34890
				],
				[
					-5662,
					13735
				],
				[
					22033,
					28980
				],
				[
					27809,
					12876
				],
				[
					-11323,
					7940
				],
				[
					11327,
					9260
				],
				[
					-12400,
					11729
				],
				[
					283,
					34739
				],
				[
					-48470,
					25886
				],
				[
					-11369,
					17122
				],
				[
					-2413,
					23229
				],
				[
					-16444,
					20643
				],
				[
					-18484,
					6530
				],
				[
					-13614,
					29400
				],
				[
					-28837,
					652
				],
				[
					-26068,
					-16240
				],
				[
					-10104,
					7222
				],
				[
					-13641,
					-9922
				],
				[
					9576,
					-9078
				],
				[
					-49825,
					3331
				],
				[
					-7108,
					4467
				],
				[
					-48731,
					-393
				],
				[
					-5286,
					9315
				],
				[
					-44712,
					-23804
				],
				[
					-37155,
					2483
				],
				[
					-608,
					14823
				],
				[
					33118,
					2917
				],
				[
					2767,
					11270
				],
				[
					-82882,
					10443
				],
				[
					-34754,
					26874
				],
				[
					44335,
					8332
				],
				[
					15506,
					16655
				],
				[
					-31340,
					-12979
				],
				[
					-33122,
					6048
				],
				[
					-26359,
					13034
				],
				[
					-9408,
					13928
				],
				[
					-46090,
					2653
				],
				[
					430,
					28684
				],
				[
					44420,
					-13959
				],
				[
					17784,
					11782
				],
				[
					-52394,
					10780
				],
				[
					-9125,
					13649
				],
				[
					18772,
					11433
				],
				[
					-9503,
					5546
				],
				[
					48526,
					-269
				],
				[
					155,
					11670
				],
				[
					77047,
					8988
				]
			],
			[
				[
					4171718,
					8560593
				],
				[
					18827,
					-9479
				],
				[
					-18152,
					-9758
				],
				[
					-30054,
					600
				],
				[
					10495,
					16230
				],
				[
					18884,
					2407
				]
			],
			[
				[
					5157401,
					8580713
				],
				[
					26321,
					-10999
				],
				[
					-7033,
					-9590
				],
				[
					-22101,
					5007
				],
				[
					-22782,
					14742
				],
				[
					25595,
					840
				]
			],
			[
				[
					5659728,
					8580965
				],
				[
					29798,
					-9602
				],
				[
					-10804,
					-16824
				],
				[
					-22123,
					-1072
				],
				[
					-25381,
					10366
				],
				[
					-4721,
					11595
				],
				[
					33231,
					5537
				]
			],
			[
				[
					6302109,
					8661355
				],
				[
					36438,
					-2085
				],
				[
					20211,
					-18702
				],
				[
					-23518,
					-9398
				],
				[
					-30353,
					17398
				],
				[
					-28041,
					2737
				],
				[
					25263,
					10050
				]
			],
			[
				[
					5681380,
					8676207
				],
				[
					67735,
					-9532
				],
				[
					52571,
					-34261
				],
				[
					8269,
					-37385
				],
				[
					-27101,
					-19194
				],
				[
					-51937,
					-8009
				],
				[
					-5999,
					6107
				],
				[
					-69461,
					22887
				],
				[
					-20157,
					16570
				],
				[
					-410,
					54510
				],
				[
					46490,
					8307
				]
			],
			[
				[
					3977817,
					8705101
				],
				[
					51447,
					-17805
				],
				[
					44648,
					-37365
				],
				[
					-900,
					-31847
				],
				[
					29631,
					3122
				],
				[
					35750,
					-27263
				],
				[
					9920,
					-25546
				],
				[
					-11280,
					-14410
				],
				[
					-33155,
					-6448
				],
				[
					-26463,
					13362
				],
				[
					-34556,
					2386
				],
				[
					-18143,
					19803
				],
				[
					-19244,
					36023
				],
				[
					-17183,
					15231
				],
				[
					12988,
					10466
				],
				[
					-24257,
					6969
				],
				[
					3060,
					18686
				],
				[
					-31335,
					26038
				],
				[
					29072,
					8598
				]
			],
			[
				[
					5157680,
					8710705
				],
				[
					1461,
					-11287
				],
				[
					36871,
					3446
				],
				[
					12060,
					7748
				],
				[
					30309,
					859
				],
				[
					95219,
					-13368
				],
				[
					25295,
					11264
				],
				[
					45000,
					-11263
				],
				[
					18300,
					-18000
				],
				[
					-35076,
					-7988
				],
				[
					-17572,
					-44715
				],
				[
					-67939,
					1138
				],
				[
					-16718,
					5351
				],
				[
					-59065,
					3931
				],
				[
					-49565,
					-6525
				],
				[
					-21019,
					4216
				],
				[
					-45786,
					-2725
				],
				[
					-19616,
					5137
				],
				[
					-30868,
					27027
				],
				[
					3658,
					22039
				],
				[
					24120,
					11477
				],
				[
					70931,
					12238
				]
			],
			[
				[
					7174928,
					8726436
				],
				[
					536,
					-9804
				],
				[
					-28662,
					-10453
				],
				[
					-17616,
					12206
				],
				[
					45742,
					8051
				]
			],
			[
				[
					4443148,
					8739132
				],
				[
					54297,
					-12821
				],
				[
					40884,
					-28856
				],
				[
					-23785,
					-4212
				],
				[
					-43352,
					2914
				],
				[
					-37290,
					-13230
				],
				[
					-27728,
					2294
				],
				[
					-38144,
					14042
				],
				[
					-12653,
					11009
				],
				[
					7940,
					22079
				],
				[
					79831,
					6781
				]
			],
			[
				[
					3527984,
					8788105
				],
				[
					21400,
					-2574
				],
				[
					10525,
					-14217
				],
				[
					-13087,
					-18119
				],
				[
					-18834,
					-6891
				]
			],
			[
				[
					4459834,
					8813835
				],
				[
					-6918,
					-15321
				],
				[
					-21646,
					3650
				],
				[
					13748,
					19769
				],
				[
					14816,
					-8098
				]
			],
			[
				[
					4312517,
					8827608
				],
				[
					12736,
					-16262
				],
				[
					-32634,
					-19831
				],
				[
					-19790,
					612
				],
				[
					-4606,
					12734
				],
				[
					33405,
					22660
				],
				[
					10889,
					87
				]
			],
			[
				[
					5258876,
					8829161
				],
				[
					27748,
					-23104
				],
				[
					-26820,
					-168
				],
				[
					-18720,
					16577
				],
				[
					17792,
					6695
				]
			],
			[
				[
					5978989,
					8849868
				],
				[
					-8781,
					-25875
				],
				[
					-19186,
					7020
				],
				[
					18504,
					34412
				],
				[
					19375,
					6997
				],
				[
					-9912,
					-22554
				]
			],
			[
				[
					3527846,
					8916277
				],
				[
					48751,
					-17743
				],
				[
					20050,
					-22524
				],
				[
					-11740,
					-32398
				],
				[
					-11145,
					-7039
				],
				[
					-45783,
					-2501
				]
			],
			[
				[
					7512030,
					8948714
				],
				[
					55702,
					-12432
				],
				[
					-20606,
					-12514
				],
				[
					-46285,
					15404
				],
				[
					11189,
					9542
				]
			],
			[
				[
					4859618,
					8959260
				],
				[
					62353,
					-4323
				],
				[
					54771,
					-14335
				],
				[
					14023,
					-10127
				],
				[
					41468,
					-4132
				],
				[
					20901,
					-15427
				],
				[
					19191,
					3210
				],
				[
					-14077,
					-24644
				],
				[
					37189,
					-12295
				],
				[
					34943,
					9754
				],
				[
					65747,
					-19413
				],
				[
					28275,
					-21166
				],
				[
					-68204,
					-28439
				],
				[
					21578,
					-3684
				],
				[
					39455,
					-25663
				],
				[
					-24579,
					-39382
				],
				[
					-33047,
					5272
				],
				[
					-60148,
					-20108
				],
				[
					-39743,
					-6684
				],
				[
					-21164,
					11177
				],
				[
					-30337,
					-9705
				],
				[
					-19072,
					-18896
				],
				[
					-24804,
					6290
				],
				[
					14418,
					24178
				],
				[
					-32816,
					8074
				],
				[
					-22436,
					13122
				],
				[
					-33264,
					8334
				],
				[
					7561,
					12199
				],
				[
					87133,
					-3233
				],
				[
					7962,
					14675
				],
				[
					-49924,
					18963
				],
				[
					-29662,
					-3375
				],
				[
					-90980,
					64649
				],
				[
					5419,
					15759
				],
				[
					34668,
					3049
				],
				[
					-36906,
					26625
				],
				[
					-3136,
					28581
				],
				[
					37244,
					11120
				]
			],
			[
				[
					6253095,
					9018983
				],
				[
					54999,
					-3116
				],
				[
					9636,
					-12229
				],
				[
					-61110,
					-16019
				],
				[
					-67086,
					-11359
				],
				[
					-21951,
					1924
				],
				[
					25055,
					28221
				],
				[
					60457,
					12578
				]
			],
			[
				[
					4193142,
					9092466
				],
				[
					25566,
					-2002
				],
				[
					37862,
					-16883
				],
				[
					34020,
					-1947
				],
				[
					22408,
					-27552
				],
				[
					32519,
					-25704
				],
				[
					-19070,
					-27860
				],
				[
					22284,
					-869
				],
				[
					-3654,
					-15396
				],
				[
					26221,
					16245
				],
				[
					1484,
					17965
				],
				[
					42846,
					14965
				],
				[
					43716,
					-5159
				],
				[
					38871,
					-23393
				],
				[
					32011,
					-5872
				],
				[
					-26801,
					-33583
				],
				[
					41911,
					-2398
				],
				[
					55655,
					8408
				],
				[
					10203,
					-13987
				],
				[
					42313,
					-15614
				],
				[
					-18310,
					-14911
				],
				[
					62050,
					-12319
				],
				[
					-16580,
					-27099
				],
				[
					-26672,
					-10785
				],
				[
					14220,
					-7466
				],
				[
					-4770,
					-24078
				],
				[
					34089,
					-4507
				],
				[
					7613,
					-18129
				],
				[
					58189,
					-35749
				],
				[
					-19107,
					-19974
				],
				[
					-7741,
					-29372
				],
				[
					-42792,
					-11262
				],
				[
					-31177,
					2059
				],
				[
					-4873,
					-8337
				],
				[
					-50808,
					7969
				],
				[
					-33862,
					11991
				],
				[
					-27312,
					41204
				],
				[
					9525,
					12524
				],
				[
					-29207,
					13342
				],
				[
					-8655,
					12931
				],
				[
					-24461,
					-5219
				],
				[
					-14425,
					15550
				],
				[
					-60682,
					5873
				],
				[
					-22321,
					6344
				],
				[
					-45413,
					-13578
				],
				[
					-28683,
					13271
				],
				[
					15867,
					20394
				],
				[
					-59823,
					-5159
				],
				[
					-66832,
					-13504
				],
				[
					-13652,
					-12986
				],
				[
					-59473,
					5005
				],
				[
					-41015,
					22402
				],
				[
					-24001,
					35388
				],
				[
					26872,
					18001
				],
				[
					43140,
					-1200
				],
				[
					24881,
					-11172
				],
				[
					73667,
					-5921
				],
				[
					15473,
					27454
				],
				[
					-70696,
					1161
				],
				[
					26237,
					11811
				],
				[
					32089,
					-1664
				],
				[
					22633,
					16760
				],
				[
					-15039,
					12930
				],
				[
					-74574,
					-6853
				],
				[
					-13865,
					8791
				],
				[
					36935,
					18853
				],
				[
					4238,
					10518
				],
				[
					-48919,
					14920
				],
				[
					-20432,
					-9495
				],
				[
					-15128,
					-22389
				],
				[
					-42318,
					-12960
				],
				[
					31360,
					46025
				],
				[
					-1127,
					11806
				],
				[
					-27453,
					5249
				],
				[
					-20071,
					-9289
				],
				[
					-47893,
					614
				],
				[
					-10779,
					35930
				],
				[
					28695,
					29004
				],
				[
					-5545,
					11403
				],
				[
					33663,
					-9057
				],
				[
					134685,
					17593
				]
			],
			[
				[
					4685212,
					9280563
				],
				[
					18137,
					-11078
				],
				[
					37105,
					6685
				],
				[
					33170,
					-14388
				],
				[
					13367,
					-25951
				],
				[
					-6207,
					-10312
				],
				[
					14836,
					-31522
				],
				[
					-23369,
					-29960
				],
				[
					-12540,
					12953
				],
				[
					-45695,
					9655
				],
				[
					8056,
					18318
				],
				[
					-27174,
					12555
				],
				[
					-57050,
					-3652
				],
				[
					-16027,
					4931
				],
				[
					956,
					32327
				],
				[
					14922,
					16025
				],
				[
					47513,
					13414
				]
			],
			[
				[
					5190648,
					9412340
				],
				[
					21643,
					-11428
				],
				[
					-23129,
					-9921
				],
				[
					-53014,
					10704
				],
				[
					-54946,
					4557
				],
				[
					20162,
					5099
				],
				[
					89284,
					989
				]
			],
			[
				[
					5376303,
					9576755
				],
				[
					47034,
					-6770
				],
				[
					91186,
					-22889
				],
				[
					57509,
					-26352
				],
				[
					6760,
					-24327
				],
				[
					32388,
					-33783
				],
				[
					35399,
					-22945
				],
				[
					-2907,
					-9904
				],
				[
					47072,
					-13658
				],
				[
					18653,
					-18747
				],
				[
					-22518,
					-18128
				],
				[
					88195,
					-8178
				],
				[
					44516,
					3934
				],
				[
					39844,
					-4934
				],
				[
					25682,
					-18191
				],
				[
					-27246,
					-12718
				],
				[
					22850,
					-1029
				],
				[
					-19267,
					-22200
				],
				[
					10715,
					-19518
				],
				[
					39241,
					-22504
				],
				[
					38144,
					-6350
				],
				[
					-2935,
					9088
				],
				[
					37818,
					-12196
				],
				[
					-23320,
					29290
				],
				[
					-15364,
					-85
				],
				[
					-24267,
					18013
				],
				[
					6624,
					24892
				],
				[
					25880,
					12476
				],
				[
					87343,
					-7728
				],
				[
					8392,
					-28271
				],
				[
					-2625,
					-26797
				],
				[
					-50720,
					-9845
				],
				[
					5898,
					-15976
				],
				[
					76232,
					3118
				],
				[
					31633,
					-33983
				],
				[
					-25908,
					-5727
				],
				[
					-26445,
					-20554
				],
				[
					59713,
					21320
				],
				[
					-23491,
					-68105
				],
				[
					-33119,
					-17377
				],
				[
					18805,
					-12189
				],
				[
					11562,
					15279
				],
				[
					23857,
					7028
				],
				[
					30770,
					-9277
				],
				[
					-10072,
					16818
				],
				[
					21479,
					5464
				],
				[
					56175,
					-13842
				],
				[
					-3987,
					-17451
				],
				[
					13275,
					-21785
				],
				[
					16517,
					18739
				],
				[
					4765,
					22338
				],
				[
					13535,
					1913
				],
				[
					49618,
					-53241
				],
				[
					38326,
					-19874
				],
				[
					3478,
					-13117
				],
				[
					-32277,
					-7737
				],
				[
					-13570,
					-11639
				],
				[
					-113843,
					-22622
				],
				[
					-21193,
					-7052
				],
				[
					-10630,
					-18881
				],
				[
					-22418,
					-4770
				],
				[
					-21549,
					23490
				],
				[
					42,
					-41700
				],
				[
					-38159,
					-20019
				],
				[
					-24289,
					-34248
				],
				[
					-13135,
					-4458
				],
				[
					-28420,
					14728
				],
				[
					-11797,
					30855
				],
				[
					1058,
					32643
				],
				[
					22233,
					11564
				],
				[
					-41226,
					-4566
				],
				[
					-9100,
					-34383
				],
				[
					15365,
					-41101
				],
				[
					26383,
					-23454
				],
				[
					-17173,
					-25851
				],
				[
					-33532,
					166
				],
				[
					-29557,
					31187
				],
				[
					-25513,
					-8437
				],
				[
					29174,
					-36629
				],
				[
					-14395,
					-23430
				],
				[
					-7980,
					-31798
				],
				[
					-11564,
					-10701
				],
				[
					-36543,
					15456
				],
				[
					-21201,
					27360
				],
				[
					-55586,
					43276
				],
				[
					-1574,
					11053
				],
				[
					-26051,
					12965
				],
				[
					10388,
					-39294
				],
				[
					23024,
					-10531
				],
				[
					37664,
					-54745
				],
				[
					-14040,
					-5315
				],
				[
					-11611,
					15884
				],
				[
					-21635,
					-631
				],
				[
					-16355,
					21622
				],
				[
					-25635,
					8063
				],
				[
					-56598,
					-2079
				],
				[
					27121,
					-12275
				],
				[
					23329,
					-370
				],
				[
					-4737,
					-31837
				],
				[
					-69741,
					-52
				],
				[
					-28204,
					7533
				],
				[
					-47759,
					2940
				],
				[
					-23766,
					12889
				],
				[
					-20104,
					-9059
				],
				[
					-24817,
					30003
				],
				[
					-27852,
					-4194
				],
				[
					-12148,
					11917
				],
				[
					-37537,
					15168
				],
				[
					253,
					17642
				],
				[
					32814,
					-2536
				],
				[
					8597,
					8839
				],
				[
					53878,
					81
				],
				[
					22174,
					5581
				],
				[
					25421,
					-4599
				],
				[
					-229,
					10992
				],
				[
					-62884,
					975
				],
				[
					-40150,
					4733
				],
				[
					-28207,
					9160
				],
				[
					-52456,
					-12128
				],
				[
					-60291,
					45403
				],
				[
					26837,
					4075
				],
				[
					43645,
					-11420
				],
				[
					20477,
					409
				],
				[
					-43655,
					19913
				],
				[
					-51189,
					512
				],
				[
					-50385,
					39116
				],
				[
					65543,
					16424
				],
				[
					38408,
					25871
				],
				[
					24949,
					1013
				],
				[
					38417,
					-8725
				],
				[
					5263,
					8667
				],
				[
					85917,
					-3259
				],
				[
					98973,
					12717
				],
				[
					75566,
					3650
				],
				[
					-76684,
					6211
				],
				[
					-56231,
					-8032
				],
				[
					-70962,
					-1870
				],
				[
					-45171,
					13453
				],
				[
					17605,
					10757
				],
				[
					64675,
					-2479
				],
				[
					27536,
					7287
				],
				[
					57272,
					4477
				],
				[
					6618,
					12196
				],
				[
					-109824,
					-13102
				],
				[
					-54186,
					10345
				],
				[
					42028,
					11283
				],
				[
					-21428,
					7645
				],
				[
					-49916,
					-12546
				],
				[
					-21709,
					17765
				],
				[
					-9581,
					-7449
				],
				[
					18166,
					-14011
				],
				[
					-43795,
					-13798
				],
				[
					13893,
					23809
				],
				[
					-12752,
					2492
				],
				[
					-16790,
					-23501
				],
				[
					-29927,
					-16057
				],
				[
					-29546,
					-6548
				],
				[
					-16543,
					20876
				],
				[
					14945,
					8564
				],
				[
					-36318,
					12556
				],
				[
					-19687,
					-2428
				],
				[
					3009,
					-17982
				],
				[
					-62441,
					-17928
				],
				[
					-27520,
					16812
				],
				[
					7983,
					15583
				],
				[
					-21850,
					-6920
				],
				[
					-37064,
					8321
				],
				[
					10655,
					14061
				],
				[
					-10129,
					16821
				],
				[
					90820,
					11883
				],
				[
					68432,
					20217
				],
				[
					57,
					20873
				],
				[
					-20499,
					-3867
				],
				[
					-28117,
					-18734
				],
				[
					-86815,
					-7719
				],
				[
					-43555,
					4894
				],
				[
					-53695,
					44767
				],
				[
					-27142,
					15126
				],
				[
					50005,
					6298
				],
				[
					-45186,
					8410
				],
				[
					-16171,
					28405
				],
				[
					5701,
					16053
				],
				[
					36765,
					-1244
				],
				[
					39272,
					-15896
				],
				[
					38973,
					-8110
				],
				[
					91834,
					2029
				],
				[
					55953,
					-14590
				],
				[
					-49662,
					22921
				],
				[
					42889,
					20274
				],
				[
					-16435,
					14501
				],
				[
					-19066,
					-17240
				],
				[
					-58406,
					-9838
				],
				[
					-52493,
					12898
				],
				[
					49646,
					8017
				],
				[
					-32788,
					10571
				],
				[
					-38804,
					-12965
				],
				[
					-54462,
					19203
				],
				[
					-14414,
					-741
				],
				[
					-1456,
					21596
				],
				[
					35117,
					-6207
				],
				[
					-2209,
					9238
				],
				[
					61453,
					51
				],
				[
					30477,
					-10579
				],
				[
					3692,
					9598
				],
				[
					-74899,
					28799
				],
				[
					22088,
					4955
				],
				[
					-13114,
					17807
				],
				[
					28767,
					-1555
				],
				[
					86325,
					6390
				],
				[
					24836,
					-10123
				],
				[
					79914,
					-1957
				],
				[
					29698,
					-7196
				],
				[
					-27815,
					16513
				],
				[
					-58066,
					2329
				],
				[
					-9933,
					19707
				],
				[
					50064,
					2500
				],
				[
					-13562,
					12836
				],
				[
					-36914,
					-5652
				],
				[
					-43829,
					11176
				],
				[
					21054,
					10679
				],
				[
					-55132,
					-7954
				],
				[
					-19092,
					11922
				],
				[
					43101,
					10401
				],
				[
					-39953,
					3155
				],
				[
					23909,
					28759
				],
				[
					44715,
					13644
				],
				[
					39010,
					-6369
				],
				[
					16077,
					-17465
				],
				[
					11465,
					11848
				],
				[
					45305,
					5800
				],
				[
					-54478,
					13667
				],
				[
					58392,
					2644
				],
				[
					36127,
					-8614
				],
				[
					44581,
					5393
				],
				[
					12160,
					16424
				],
				[
					-21360,
					13608
				],
				[
					-78545,
					-3318
				],
				[
					-54201,
					11485
				],
				[
					2583,
					11195
				],
				[
					32961,
					16583
				],
				[
					68660,
					-11041
				],
				[
					-6286,
					15094
				]
			],
			[
				[
					5573200,
					9629327
				],
				[
					28478,
					-4164
				],
				[
					-34896,
					-7933
				],
				[
					6418,
					12097
				]
			],
			[
				[
					7111601,
					9956484
				],
				[
					-23855,
					-16770
				],
				[
					-5162,
					16750
				],
				[
					29017,
					20
				]
			],
			[
				[
					8029013,
					9993835
				],
				[
					25555,
					-1755
				],
				[
					19899,
					-28022
				],
				[
					34756,
					8709
				],
				[
					75447,
					-10635
				],
				[
					35082,
					6351
				],
				[
					21443,
					-13098
				],
				[
					60671,
					3289
				],
				[
					53005,
					-7658
				],
				[
					95085,
					-1290
				],
				[
					-55411,
					-27414
				],
				[
					-69666,
					-14657
				],
				[
					-99313,
					-15290
				],
				[
					-31219,
					-15904
				],
				[
					85512,
					8522
				],
				[
					44289,
					-2427
				],
				[
					58169,
					18117
				],
				[
					141085,
					30481
				],
				[
					47891,
					-6521
				],
				[
					1015,
					14537
				],
				[
					65355,
					3880
				],
				[
					-6131,
					-20241
				],
				[
					50098,
					-7096
				],
				[
					30952,
					12076
				],
				[
					49604,
					-518
				],
				[
					14230,
					-17981
				],
				[
					-36292,
					-10254
				],
				[
					59852,
					-18010
				],
				[
					-16772,
					-9411
				],
				[
					49639,
					-6516
				],
				[
					-22147,
					-19731
				],
				[
					97273,
					8469
				],
				[
					8314,
					-9251
				],
				[
					58847,
					-843
				],
				[
					48180,
					-16930
				],
				[
					17861,
					-24416
				],
				[
					-10475,
					-23140
				],
				[
					-51272,
					-16725
				],
				[
					-48277,
					-6454
				],
				[
					22989,
					-5915
				],
				[
					-55209,
					-24137
				],
				[
					-80053,
					-24035
				],
				[
					-65333,
					-11458
				],
				[
					-81509,
					-32937
				],
				[
					-59647,
					8888
				],
				[
					-88183,
					-13295
				],
				[
					36532,
					-6097
				],
				[
					-52947,
					-10451
				],
				[
					-78548,
					-535
				],
				[
					-143379,
					-8443
				],
				[
					-55961,
					-7740
				],
				[
					-79007,
					29330
				],
				[
					-40531,
					8911
				],
				[
					109871,
					-41743
				],
				[
					-23931,
					-8658
				],
				[
					92587,
					10404
				],
				[
					76704,
					2393
				],
				[
					48802,
					-12970
				],
				[
					-191489,
					-45121
				],
				[
					-184912,
					-35929
				],
				[
					35199,
					1876
				],
				[
					-41634,
					-23333
				],
				[
					77427,
					27221
				],
				[
					131736,
					19250
				],
				[
					93432,
					20172
				],
				[
					263777,
					41426
				],
				[
					59466,
					2932
				],
				[
					6204,
					-17838
				],
				[
					-36350,
					-24272
				],
				[
					-94211,
					-31361
				],
				[
					-42839,
					-678
				],
				[
					-58496,
					-30902
				],
				[
					-9174,
					-13078
				],
				[
					-105539,
					-38590
				],
				[
					-36001,
					-17913
				],
				[
					-43321,
					-11650
				],
				[
					-98726,
					-54362
				],
				[
					-22652,
					-28402
				],
				[
					-24302,
					-14040
				],
				[
					-56213,
					-7810
				],
				[
					-30583,
					2057
				],
				[
					9993,
					17432
				],
				[
					-45189,
					26786
				],
				[
					26963,
					-29229
				],
				[
					-14564,
					-14163
				],
				[
					61972,
					-23501
				],
				[
					-23543,
					-15775
				],
				[
					-72788,
					2614
				],
				[
					-97654,
					-22731
				],
				[
					-48015,
					21012
				],
				[
					-37847,
					4081
				],
				[
					62340,
					-24545
				],
				[
					-54901,
					-5970
				],
				[
					31089,
					-6093
				],
				[
					68420,
					2533
				],
				[
					74024,
					14648
				],
				[
					35104,
					-7067
				],
				[
					-19329,
					-25350
				],
				[
					-85509,
					-15477
				],
				[
					-609,
					-10887
				],
				[
					35409,
					7802
				],
				[
					27344,
					-7155
				],
				[
					-25152,
					-23388
				],
				[
					-44917,
					-16077
				],
				[
					-50940,
					-6097
				],
				[
					-37595,
					-11394
				],
				[
					-11256,
					8097
				],
				[
					-33745,
					-3119
				],
				[
					-32988,
					9278
				],
				[
					-13755,
					22684
				],
				[
					-91050,
					5004
				],
				[
					11633,
					8009
				],
				[
					-33690,
					6846
				],
				[
					-64855,
					-8587
				],
				[
					-8681,
					-13786
				],
				[
					78158,
					-222
				],
				[
					69580,
					-8045
				],
				[
					32592,
					-32754
				],
				[
					-9721,
					-25443
				],
				[
					-57829,
					-5619
				],
				[
					-21185,
					13731
				],
				[
					-221,
					-20738
				],
				[
					-15905,
					-6762
				],
				[
					-67629,
					-203
				],
				[
					-23596,
					12735
				],
				[
					-18728,
					-3114
				],
				[
					14826,
					-23685
				],
				[
					-63891,
					2280
				],
				[
					-40433,
					14209
				],
				[
					-12118,
					-7573
				],
				[
					-22277,
					16652
				],
				[
					-62104,
					7860
				],
				[
					-60683,
					2150
				],
				[
					5021,
					-7034
				],
				[
					96379,
					-7301
				],
				[
					16973,
					-16822
				],
				[
					33215,
					-12201
				],
				[
					-32832,
					-2475
				],
				[
					-93101,
					7774
				],
				[
					-15689,
					16683
				],
				[
					-30572,
					2313
				],
				[
					27596,
					-28347
				],
				[
					-103323,
					4928
				],
				[
					52809,
					-8619
				],
				[
					30449,
					-12334
				],
				[
					58260,
					4392
				],
				[
					82801,
					-2927
				],
				[
					12648,
					-9100
				],
				[
					36303,
					2501
				],
				[
					117017,
					-734
				],
				[
					18916,
					-4537
				],
				[
					-39176,
					-8105
				],
				[
					44086,
					-31756
				],
				[
					-30115,
					-9444
				],
				[
					-50484,
					3960
				],
				[
					-73653,
					11134
				],
				[
					-23883,
					26145
				],
				[
					-20055,
					3402
				],
				[
					-95833,
					-4521
				],
				[
					-96851,
					6179
				],
				[
					-45628,
					-9484
				],
				[
					41348,
					2737
				],
				[
					130706,
					-5899
				],
				[
					76699,
					-12544
				],
				[
					-18313,
					-6892
				],
				[
					-45799,
					4322
				],
				[
					-67761,
					-7206
				],
				[
					-31028,
					-9460
				],
				[
					-30679,
					10723
				],
				[
					-60031,
					4307
				],
				[
					-60485,
					-6364
				],
				[
					68264,
					2599
				],
				[
					46452,
					-3763
				],
				[
					16615,
					-8635
				],
				[
					-25868,
					-13190
				],
				[
					-35537,
					-31569
				],
				[
					-5748,
					-14696
				],
				[
					35135,
					30383
				],
				[
					35992,
					19113
				],
				[
					50468,
					3407
				],
				[
					52281,
					9015
				],
				[
					82827,
					-6968
				],
				[
					30564,
					-5968
				],
				[
					-11246,
					-11565
				],
				[
					-43005,
					-9597
				],
				[
					106078,
					695
				],
				[
					58118,
					-15015
				],
				[
					-7813,
					-45407
				],
				[
					27196,
					-12542
				],
				[
					-29555,
					-80
				],
				[
					-12321,
					-11377
				],
				[
					-97519,
					-9391
				],
				[
					-65166,
					10313
				],
				[
					-28896,
					-10118
				],
				[
					52573,
					1510
				],
				[
					14292,
					-11148
				],
				[
					74227,
					-7956
				],
				[
					44019,
					-23800
				],
				[
					-39126,
					-7385
				],
				[
					-15280,
					-21053
				],
				[
					-129419,
					9193
				],
				[
					-25790,
					-14576
				],
				[
					71816,
					-11641
				],
				[
					72600,
					-3197
				],
				[
					-6274,
					-21472
				],
				[
					-30492,
					-19877
				],
				[
					-23839,
					12942
				],
				[
					-42244,
					-6000
				],
				[
					-9407,
					-12450
				],
				[
					-31326,
					-8884
				],
				[
					-50432,
					11500
				],
				[
					-94052,
					2958
				],
				[
					-31835,
					-12633
				],
				[
					30759,
					-12706
				],
				[
					21236,
					-16839
				],
				[
					-15470,
					-26481
				],
				[
					27274,
					-3022
				],
				[
					17006,
					-14690
				],
				[
					-33399,
					-16146
				],
				[
					-3917,
					-16751
				],
				[
					-23587,
					-3704
				],
				[
					-8431,
					-16678
				],
				[
					-58422,
					-17138
				],
				[
					4803,
					19407
				],
				[
					-45506,
					-23561
				],
				[
					-53712,
					6669
				],
				[
					-39684,
					-10446
				],
				[
					-85542,
					13549
				],
				[
					-62804,
					23532
				],
				[
					-1608,
					9360
				],
				[
					-30189,
					12817
				],
				[
					-775,
					17249
				],
				[
					-37520,
					6266
				],
				[
					30436,
					-18403
				],
				[
					-14745,
					-24042
				],
				[
					33685,
					-16053
				],
				[
					33937,
					-2197
				],
				[
					5902,
					-8519
				],
				[
					-76398,
					-11536
				],
				[
					-41499,
					5208
				],
				[
					31706,
					-13824
				],
				[
					12864,
					-21377
				],
				[
					78075,
					31080
				],
				[
					91130,
					-17593
				],
				[
					26488,
					-2833
				],
				[
					-36740,
					-26717
				],
				[
					5304,
					-4632
				],
				[
					47536,
					34008
				],
				[
					30928,
					8025
				],
				[
					41447,
					-5951
				],
				[
					30551,
					-17158
				],
				[
					409,
					-8517
				],
				[
					-43644,
					-46607
				],
				[
					57623,
					1436
				],
				[
					-8481,
					-20573
				],
				[
					25621,
					-2581
				],
				[
					22795,
					28790
				],
				[
					32688,
					16881
				],
				[
					17815,
					-717
				],
				[
					20802,
					-15801
				],
				[
					-133,
					-22961
				],
				[
					11735,
					-15673
				],
				[
					-5224,
					-36684
				],
				[
					-24898,
					-2628
				],
				[
					-10316,
					-21526
				],
				[
					-25862,
					-20130
				],
				[
					-26305,
					10375
				],
				[
					-1195,
					14290
				],
				[
					-20857,
					3080
				],
				[
					-20758,
					-37350
				],
				[
					-19924,
					-1938
				],
				[
					-22643,
					-28158
				],
				[
					-24758,
					4344
				],
				[
					-50965,
					-19361
				],
				[
					-18782,
					3408
				],
				[
					-55263,
					-21444
				],
				[
					-45541,
					13601
				],
				[
					15265,
					14530
				],
				[
					23623,
					35482
				],
				[
					-24739,
					15146
				],
				[
					-31770,
					3367
				],
				[
					4525,
					13097
				],
				[
					-26440,
					-18893
				],
				[
					-34856,
					-827
				],
				[
					-38344,
					11240
				],
				[
					10902,
					16507
				],
				[
					-42216,
					16453
				],
				[
					-25302,
					31810
				],
				[
					-20412,
					9386
				],
				[
					37064,
					-46894
				],
				[
					34595,
					-10126
				],
				[
					-11380,
					-19479
				],
				[
					9938,
					-19448
				],
				[
					-12975,
					-7561
				],
				[
					-34865,
					1786
				],
				[
					-24411,
					-4589
				],
				[
					-38473,
					20625
				],
				[
					9454,
					8273
				],
				[
					-15265,
					28049
				],
				[
					-28298,
					19953
				],
				[
					-10908,
					-5928
				],
				[
					32994,
					-25164
				],
				[
					8094,
					-35716
				],
				[
					-14606,
					-3771
				],
				[
					-45723,
					3854
				],
				[
					-54411,
					45641
				],
				[
					-8620,
					-18518
				],
				[
					6191,
					-21034
				],
				[
					-48675,
					-3814
				],
				[
					-18156,
					8308
				],
				[
					-6552,
					18129
				],
				[
					-20473,
					9623
				],
				[
					-2841,
					-17023
				],
				[
					14792,
					-24734
				],
				[
					55557,
					-18311
				],
				[
					362,
					-8648
				],
				[
					-92612,
					-3834
				],
				[
					-55376,
					16880
				],
				[
					-13241,
					-2489
				],
				[
					-59693,
					10877
				],
				[
					-1133,
					19913
				],
				[
					21890,
					11746
				],
				[
					-43763,
					29718
				],
				[
					-2237,
					-5284
				],
				[
					35083,
					-18822
				],
				[
					-34198,
					-21435
				],
				[
					-9318,
					-26377
				],
				[
					-54491,
					12877
				],
				[
					6835,
					7741
				],
				[
					-37851,
					6672
				],
				[
					6699,
					13591
				],
				[
					-7170,
					17963
				],
				[
					-14203,
					5541
				],
				[
					2940,
					-38180
				],
				[
					13305,
					-7231
				],
				[
					-21477,
					-20344
				],
				[
					-28641,
					6717
				],
				[
					-51613,
					4543
				],
				[
					-563,
					31319
				],
				[
					-19169,
					22353
				],
				[
					4977,
					12461
				],
				[
					-12065,
					27188
				],
				[
					-15889,
					-12792
				],
				[
					15038,
					-20373
				],
				[
					10309,
					-30680
				],
				[
					-12395,
					-25052
				],
				[
					-13273,
					2452
				],
				[
					10056,
					35528
				],
				[
					-13008,
					7429
				],
				[
					-18965,
					-44540
				],
				[
					-15389,
					10698
				],
				[
					-8820,
					-6982
				],
				[
					-62084,
					36153
				],
				[
					29186,
					24796
				],
				[
					-14048,
					41996
				],
				[
					14957,
					10369
				],
				[
					34590,
					9491
				],
				[
					14228,
					14615
				],
				[
					26448,
					1997
				],
				[
					30308,
					24484
				],
				[
					22951,
					7503
				],
				[
					21760,
					-5338
				],
				[
					47414,
					7222
				],
				[
					21939,
					-3401
				],
				[
					11247,
					12910
				],
				[
					51571,
					331
				],
				[
					-26907,
					7382
				],
				[
					21960,
					16080
				],
				[
					-30543,
					-982
				],
				[
					11394,
					23393
				],
				[
					-26432,
					-9283
				],
				[
					-42657,
					7383
				],
				[
					-3404,
					19953
				],
				[
					12714,
					5940
				],
				[
					-6129,
					16168
				],
				[
					-60466,
					29573
				],
				[
					12900,
					38411
				],
				[
					26941,
					2667
				],
				[
					65175,
					16618
				],
				[
					53089,
					-3694
				],
				[
					46723,
					-10720
				],
				[
					25867,
					-10914
				],
				[
					35413,
					-39139
				],
				[
					8888,
					-29722
				],
				[
					-1524,
					-20919
				],
				[
					33282,
					9116
				],
				[
					16106,
					-17166
				],
				[
					47098,
					-1348
				],
				[
					21769,
					-14736
				],
				[
					34703,
					-6519
				],
				[
					-13294,
					12930
				],
				[
					5481,
					13411
				],
				[
					25036,
					-4465
				],
				[
					33179,
					2854
				],
				[
					63246,
					-9776
				],
				[
					-23330,
					8493
				],
				[
					-19895,
					17053
				],
				[
					49078,
					11569
				],
				[
					49137,
					41437
				],
				[
					49842,
					57931
				],
				[
					-5890,
					21973
				],
				[
					22912,
					5409
				],
				[
					-1209,
					11302
				],
				[
					-30832,
					-6511
				],
				[
					-12946,
					-10913
				],
				[
					2381,
					-21887
				],
				[
					-42611,
					-31221
				],
				[
					-5299,
					-17087
				],
				[
					-24068,
					-26282
				],
				[
					-57622,
					-29123
				],
				[
					-58309,
					8690
				],
				[
					-39591,
					-1456
				],
				[
					-10496,
					13902
				],
				[
					38683,
					20929
				],
				[
					-2404,
					4882
				],
				[
					-43291,
					-20578
				],
				[
					-41435,
					17792
				],
				[
					-808,
					16679
				],
				[
					40634,
					25117
				],
				[
					-42499,
					-11632
				],
				[
					-10851,
					9939
				],
				[
					22197,
					11633
				],
				[
					41539,
					3194
				],
				[
					-2680,
					-14692
				],
				[
					33965,
					20896
				],
				[
					-44679,
					-7242
				],
				[
					-55167,
					1874
				],
				[
					-26887,
					6566
				],
				[
					34098,
					17680
				],
				[
					43752,
					13659
				],
				[
					-7861,
					8488
				],
				[
					30477,
					59996
				],
				[
					-6191,
					7189
				],
				[
					10130,
					32944
				],
				[
					-20707,
					-23135
				],
				[
					-402,
					-18010
				],
				[
					-28750,
					-34247
				],
				[
					-26087,
					-22652
				],
				[
					-58747,
					-9682
				],
				[
					-35173,
					1437
				],
				[
					1076,
					22119
				],
				[
					17050,
					1398
				],
				[
					19771,
					16455
				],
				[
					12289,
					22565
				],
				[
					-26235,
					-6778
				],
				[
					-18872,
					-24331
				],
				[
					-29330,
					4270
				],
				[
					-21490,
					-22616
				],
				[
					-55841,
					-4829
				],
				[
					-34843,
					4148
				],
				[
					8810,
					14862
				],
				[
					35656,
					3974
				],
				[
					-50004,
					6960
				],
				[
					-99,
					41919
				],
				[
					23753,
					25101
				],
				[
					53398,
					16631
				],
				[
					-27658,
					1083
				],
				[
					27479,
					39336
				],
				[
					32235,
					13435
				],
				[
					98169,
					11162
				],
				[
					69661,
					18576
				],
				[
					31723,
					-11969
				],
				[
					36375,
					-5323
				],
				[
					71659,
					-1637
				],
				[
					103074,
					-36212
				],
				[
					13033,
					767
				],
				[
					23276,
					-21752
				],
				[
					27354,
					-9650
				],
				[
					16894,
					5225
				],
				[
					-33084,
					16870
				],
				[
					-8260,
					12162
				],
				[
					15714,
					9272
				],
				[
					-42859,
					-3911
				],
				[
					-43891,
					17119
				],
				[
					-4729,
					10684
				],
				[
					31142,
					2831
				],
				[
					59630,
					-5557
				],
				[
					61612,
					7683
				],
				[
					21399,
					-2255
				],
				[
					7676,
					34310
				],
				[
					18298,
					14275
				],
				[
					-41124,
					-10458
				],
				[
					-26206,
					-23850
				],
				[
					-51621,
					-6518
				],
				[
					-39018,
					10475
				],
				[
					-59671,
					-308
				],
				[
					-87921,
					7071
				],
				[
					-57715,
					13720
				],
				[
					-9411,
					12241
				],
				[
					31684,
					19228
				],
				[
					40367,
					-6905
				],
				[
					31953,
					-19731
				],
				[
					40540,
					2206
				],
				[
					-54201,
					22222
				],
				[
					1628,
					20259
				],
				[
					-17586,
					-9606
				],
				[
					-22669,
					2576
				],
				[
					-19216,
					53329
				],
				[
					-41806,
					15215
				],
				[
					-19242,
					33337
				],
				[
					-55228,
					20584
				],
				[
					-35356,
					818
				],
				[
					-51367,
					10531
				],
				[
					-21753,
					16010
				],
				[
					5395,
					34172
				],
				[
					13989,
					4055
				],
				[
					81182,
					-7975
				],
				[
					19840,
					-9095
				],
				[
					18955,
					6532
				],
				[
					-103492,
					18021
				],
				[
					-29000,
					321
				],
				[
					-23218,
					28113
				],
				[
					14476,
					41775
				],
				[
					51195,
					8919
				],
				[
					36650,
					-1960
				],
				[
					44223,
					-13466
				],
				[
					141096,
					-23
				],
				[
					59276,
					-14847
				],
				[
					36306,
					-23745
				],
				[
					129120,
					-61626
				],
				[
					13795,
					-32542
				],
				[
					33684,
					-7459
				],
				[
					-6343,
					-24013
				],
				[
					28298,
					11960
				],
				[
					100351,
					-18662
				],
				[
					-1912,
					9747
				],
				[
					84480,
					11814
				],
				[
					18310,
					13927
				],
				[
					-70371,
					-5358
				],
				[
					-31143,
					-8013
				],
				[
					-38515,
					430
				],
				[
					-15946,
					9466
				],
				[
					-49105,
					5331
				],
				[
					-14320,
					10733
				],
				[
					11728,
					12780
				],
				[
					-13468,
					24545
				],
				[
					25391,
					8864
				],
				[
					-57736,
					8344
				],
				[
					-38472,
					15726
				],
				[
					-102340,
					66659
				],
				[
					227970,
					24527
				],
				[
					60403,
					8608
				],
				[
					36279,
					-294
				],
				[
					11466,
					15621
				],
				[
					192174,
					9599
				],
				[
					48809,
					-1642
				],
				[
					4022,
					8866
				],
				[
					-116420,
					4802
				],
				[
					-57341,
					-5133
				],
				[
					-42037,
					2983
				],
				[
					73883,
					23666
				],
				[
					161411,
					27341
				],
				[
					129574,
					3938
				],
				[
					30518,
					3679
				],
				[
					-9797,
					12339
				],
				[
					101143,
					10594
				],
				[
					60861,
					12656
				],
				[
					-105994,
					-10957
				],
				[
					-68950,
					-15147
				],
				[
					-58540,
					-381
				],
				[
					-70500,
					4943
				],
				[
					-126838,
					-13905
				],
				[
					9365,
					22241
				],
				[
					-11639,
					8576
				],
				[
					54810,
					22736
				],
				[
					58348,
					43641
				],
				[
					120671,
					34160
				],
				[
					5607,
					13873
				],
				[
					-137288,
					-33040
				],
				[
					-64933,
					-30139
				],
				[
					-24531,
					-22274
				],
				[
					-70869,
					21343
				],
				[
					50118,
					-24824
				],
				[
					-38985,
					-24385
				],
				[
					23776,
					-4148
				],
				[
					-25082,
					-10805
				],
				[
					-10571,
					-18105
				],
				[
					-43221,
					-15635
				],
				[
					-122613,
					-31108
				],
				[
					-69462,
					-12021
				],
				[
					-88143,
					-10768
				],
				[
					-86074,
					-4748
				],
				[
					3782,
					25046
				],
				[
					25755,
					8958
				],
				[
					86586,
					13462
				],
				[
					35932,
					17824
				],
				[
					-22009,
					6173
				],
				[
					-66055,
					-22586
				],
				[
					-92106,
					-15304
				],
				[
					-24443,
					14969
				],
				[
					53175,
					17936
				],
				[
					-76986,
					-19717
				],
				[
					12649,
					-26463
				],
				[
					-14637,
					-19615
				],
				[
					-91282,
					-7249
				],
				[
					-63859,
					-965
				],
				[
					-127446,
					9291
				],
				[
					-48823,
					11919
				],
				[
					23827,
					29509
				],
				[
					50504,
					28244
				],
				[
					24837,
					20731
				],
				[
					30201,
					12536
				],
				[
					69963,
					11897
				],
				[
					114944,
					9442
				],
				[
					52050,
					9257
				],
				[
					87736,
					6636
				],
				[
					47025,
					11888
				],
				[
					-57402,
					-1472
				],
				[
					-115991,
					-15688
				],
				[
					-208699,
					-14086
				],
				[
					-51969,
					-18874
				],
				[
					-51524,
					-35508
				],
				[
					-54693,
					-26104
				],
				[
					-19461,
					-21549
				],
				[
					-29629,
					-565
				],
				[
					-72436,
					13950
				],
				[
					-129586,
					41148
				],
				[
					-14828,
					14996
				],
				[
					85666,
					16119
				],
				[
					74542,
					6367
				],
				[
					52537,
					-6886
				],
				[
					94033,
					5079
				],
				[
					89006,
					23865
				],
				[
					67093,
					28330
				],
				[
					71728,
					13991
				],
				[
					-22639,
					9578
				],
				[
					-122033,
					-22522
				],
				[
					-38351,
					-20812
				],
				[
					-119576,
					-16269
				],
				[
					-91740,
					547
				],
				[
					-163695,
					-15129
				],
				[
					-54902,
					10363
				],
				[
					-19563,
					24163
				],
				[
					5038,
					11631
				],
				[
					33884,
					10882
				],
				[
					38742,
					-6480
				],
				[
					46027,
					1653
				],
				[
					-85096,
					24964
				],
				[
					47674,
					7193
				],
				[
					85882,
					35594
				],
				[
					89224,
					7731
				],
				[
					-36366,
					8472
				],
				[
					-48178,
					-5368
				],
				[
					-119724,
					-29182
				],
				[
					-72857,
					-15282
				],
				[
					-11828,
					11343
				],
				[
					-33911,
					5147
				],
				[
					84926,
					31132
				],
				[
					63409,
					16174
				],
				[
					-65173,
					3813
				],
				[
					-15527,
					13897
				],
				[
					-10263,
					-12943
				],
				[
					-31973,
					3332
				],
				[
					-37274,
					-10151
				],
				[
					1438,
					-14565
				],
				[
					-46816,
					-5985
				],
				[
					-12565,
					13527
				],
				[
					-53812,
					10621
				],
				[
					64485,
					33150
				],
				[
					32102,
					-725
				],
				[
					4157,
					13450
				],
				[
					44765,
					2464
				],
				[
					6102,
					10420
				],
				[
					103893,
					3946
				],
				[
					40238,
					-24744
				],
				[
					16774,
					22637
				],
				[
					18833,
					4879
				],
				[
					-6143,
					18878
				],
				[
					57962,
					19082
				],
				[
					55875,
					9596
				],
				[
					73091,
					-7635
				],
				[
					26898,
					-16088
				],
				[
					-8178,
					-13505
				],
				[
					37883,
					11854
				],
				[
					3344,
					13033
				],
				[
					71164,
					-1834
				],
				[
					23315,
					-6461
				],
				[
					80223,
					-37590
				],
				[
					-45546,
					29684
				],
				[
					94451,
					3137
				],
				[
					28927,
					-20955
				],
				[
					-6447,
					20753
				],
				[
					-27065,
					6717
				],
				[
					-86713,
					6081
				],
				[
					-45946,
					11096
				],
				[
					-61612,
					5870
				],
				[
					-24387,
					22074
				],
				[
					141964,
					5163
				],
				[
					31917,
					10522
				],
				[
					-18091,
					9790
				],
				[
					189,
					20650
				],
				[
					-44167,
					5713
				],
				[
					9905,
					7737
				],
				[
					66319,
					5267
				],
				[
					66961,
					-3538
				],
				[
					-32916,
					-9563
				],
				[
					61753,
					-11817
				],
				[
					75973,
					-6575
				],
				[
					39990,
					-19155
				],
				[
					7169,
					-14205
				],
				[
					41195,
					-22626
				],
				[
					-18301,
					-15847
				],
				[
					30937,
					6466
				],
				[
					76187,
					-3401
				],
				[
					67336,
					-18675
				],
				[
					-63163,
					23795
				],
				[
					-62860,
					1681
				],
				[
					-15590,
					21359
				],
				[
					-26126,
					9389
				],
				[
					3175,
					15749
				],
				[
					38603,
					-862
				],
				[
					49682,
					-20455
				],
				[
					175645,
					-47479
				],
				[
					83394,
					-9163
				],
				[
					11761,
					13436
				],
				[
					-83120,
					7181
				],
				[
					-40693,
					11024
				],
				[
					6177,
					15542
				],
				[
					-32923,
					-185
				],
				[
					-80268,
					16636
				],
				[
					-88114,
					30405
				],
				[
					-9586,
					9852
				],
				[
					21338,
					25233
				],
				[
					120174,
					-448
				],
				[
					-70437,
					10925
				],
				[
					-33746,
					15417
				],
				[
					24391,
					15437
				],
				[
					78612,
					-7681
				],
				[
					72594,
					-28424
				],
				[
					33844,
					5607
				],
				[
					-117765,
					60263
				],
				[
					32118,
					6816
				],
				[
					75658,
					-3772
				],
				[
					55943,
					-17557
				],
				[
					11743,
					-16907
				],
				[
					0,
					40782
				],
				[
					-37585,
					8285
				],
				[
					23787,
					14954
				],
				[
					87295,
					11037
				],
				[
					34027,
					-12551
				],
				[
					3260,
					-13420
				],
				[
					36449,
					19097
				],
				[
					24914,
					-5286
				],
				[
					-4969,
					-18411
				],
				[
					80652,
					20032
				],
				[
					83263,
					-18171
				],
				[
					57009,
					-44991
				],
				[
					71722,
					-13841
				],
				[
					15421,
					-13902
				],
				[
					43191,
					16122
				],
				[
					-93741,
					20017
				],
				[
					-2624,
					15523
				],
				[
					-48961,
					29139
				],
				[
					-80800,
					24183
				],
				[
					10963,
					18740
				],
				[
					50701,
					5025
				],
				[
					55820,
					-4707
				],
				[
					62315,
					2180
				],
				[
					66193,
					-11499
				],
				[
					92741,
					-575
				],
				[
					50886,
					-16428
				],
				[
					23008,
					-26435
				],
				[
					59908,
					-20436
				],
				[
					63360,
					-15540
				],
				[
					21116,
					7160
				],
				[
					-69387,
					15804
				],
				[
					-53568,
					35751
				],
				[
					66301,
					28176
				],
				[
					38463,
					7946
				],
				[
					126378,
					1326
				],
				[
					-20927,
					-15814
				],
				[
					26736,
					-20912
				],
				[
					81669,
					-14602
				],
				[
					-67275,
					34247
				],
				[
					9793,
					6311
				],
				[
					102746,
					13569
				],
				[
					36162,
					-13
				]
			],
			[
				[
					7595841,
					9994586
				],
				[
					-23524,
					-12271
				],
				[
					-63323,
					6111
				],
				[
					55079,
					11464
				],
				[
					31768,
					-5304
				]
			]
		],
		"transform": {
			"scale": [
				0.000008839867349386735,
				0.000004145407124440711
			],
			"translate": [
				-141.018073158,
				41.681435425000075
			]
		}
	};

/***/ }
/******/ ])
});
;